#include "sbasn1.h"

zend_class_entry *asn1TagType_ce_ptr = NULL;

void SB_CALLBACK asn1tCallBackFuncRaw(void * _ObjectData, void * Stream, asn1TagTypeRaw TagType, int8_t TagConstrained, void * Tag, int32_t TagSize, int32_t Size, void * Data, int32_t BitRest, int8_t * OutResult)
{
	zval **params[8];
	zval * zStream;
	zval * zTagType;
	zval * zTagConstrained;
	zval * zTag;
	zval * zTagSize;
	zval * zSize;
	zval * zData;
	zval * zBitRest;
	zval * pzOutResult = NULL;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zStream);
	SBInitPointerObject(zStream, Stream TSRMLS_CC);
	MAKE_STD_ZVAL(zTagType);
	ZVAL_LONG(zTagType, (long)TagType);
	MAKE_STD_ZVAL(zTagConstrained);
	ZVAL_BOOL(zTagConstrained, (zend_bool)TagConstrained);
	MAKE_STD_ZVAL(zTag);
	SBInitPointerObject(zTag, Tag TSRMLS_CC);
	MAKE_STD_ZVAL(zTagSize);
	ZVAL_LONG(zTagSize, (long)TagSize);
	MAKE_STD_ZVAL(zSize);
	ZVAL_LONG(zSize, (long)Size);
	MAKE_STD_ZVAL(zData);
	SBInitPointerObject(zData, Data TSRMLS_CC);
	MAKE_STD_ZVAL(zBitRest);
	ZVAL_LONG(zBitRest, (long)BitRest);

	params[0] = &zStream;
	params[1] = &zTagType;
	params[2] = &zTagConstrained;
	params[3] = &zTag;
	params[4] = &zTagSize;
	params[5] = &zSize;
	params[6] = &zData;
	params[7] = &zBitRest;
	SBCallEvent((zval *)_ObjectData, &pzOutResult, 8, params TSRMLS_CC);

	zval_ptr_dtor(&zStream);
	zval_ptr_dtor(&zTagType);
	zval_ptr_dtor(&zTagConstrained);
	zval_ptr_dtor(&zTag);
	zval_ptr_dtor(&zTagSize);
	zval_ptr_dtor(&zSize);
	zval_ptr_dtor(&zData);
	zval_ptr_dtor(&zBitRest);
	if (pzOutResult)
	{
		*OutResult = (int8_t)Z_BVAL_P(pzOutResult);
		zval_ptr_dtor(&pzOutResult);
	}
}

void SB_CALLBACK TSBASN1ReadEventRaw(void * _ObjectData, TObjectHandle Sender, void * Buffer, int32_t * Size)
{
	zval *retval_ptr;
	zval **params[3];
	zval * zSender;
	zval * zBuffer;
	zval * zSize;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zBuffer);
	SBInitPointerObject(zBuffer, Buffer TSRMLS_CC);
	MAKE_STD_ZVAL(zSize);
	ZVAL_LONG(zSize, (long)*Size);

	params[0] = &zSender;
	params[1] = &zBuffer;
	params[2] = &zSize;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 3, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zBuffer);
	*Size = (int32_t)Z_LVAL_P(zSize);
	zval_ptr_dtor(&zSize);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBASN1TagEventRaw(void * _ObjectData, TObjectHandle Sender, asn1TagTypeRaw TagType, int8_t TagConstrained, void * Tag, int32_t TagSize, int64_t Size, void * Data, int32_t BitRest, int8_t * Valid)
{
	zval *retval_ptr;
	zval **params[9];
	zval * zSender;
	zval * zTagType;
	zval * zTagConstrained;
	zval * zTag;
	zval * zTagSize;
	zval * zSize;
	zval * zData;
	zval * zBitRest;
	zval * zValid;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zTagType);
	ZVAL_LONG(zTagType, (long)TagType);
	MAKE_STD_ZVAL(zTagConstrained);
	ZVAL_BOOL(zTagConstrained, (zend_bool)TagConstrained);
	MAKE_STD_ZVAL(zTag);
	SBInitPointerObject(zTag, Tag TSRMLS_CC);
	MAKE_STD_ZVAL(zTagSize);
	ZVAL_LONG(zTagSize, (long)TagSize);
	MAKE_STD_ZVAL(zSize);
	ZVAL_LONG(zSize, (long)Size);
	MAKE_STD_ZVAL(zData);
	SBInitPointerObject(zData, Data TSRMLS_CC);
	MAKE_STD_ZVAL(zBitRest);
	ZVAL_LONG(zBitRest, (long)BitRest);
	MAKE_STD_ZVAL(zValid);
	ZVAL_BOOL(zValid, (zend_bool)*Valid);

	params[0] = &zSender;
	params[1] = &zTagType;
	params[2] = &zTagConstrained;
	params[3] = &zTag;
	params[4] = &zTagSize;
	params[5] = &zSize;
	params[6] = &zData;
	params[7] = &zBitRest;
	params[8] = &zValid;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 9, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zTagType);
	zval_ptr_dtor(&zTagConstrained);
	zval_ptr_dtor(&zTag);
	zval_ptr_dtor(&zTagSize);
	zval_ptr_dtor(&zSize);
	zval_ptr_dtor(&zData);
	zval_ptr_dtor(&zBitRest);
	*Valid = (int8_t)Z_BVAL_P(zValid);
	zval_ptr_dtor(&zValid);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBASN1TagHeaderEventRaw(void * _ObjectData, TObjectHandle Sender, uint8_t TagID, int64_t TagLen, int32_t HeaderLen, int8_t UndefLen)
{
	zval *retval_ptr;
	zval **params[5];
	zval * zSender;
	zval * zTagID;
	zval * zTagLen;
	zval * zHeaderLen;
	zval * zUndefLen;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zTagID);
	ZVAL_LONG(zTagID, (long)TagID);
	MAKE_STD_ZVAL(zTagLen);
	ZVAL_LONG(zTagLen, (long)TagLen);
	MAKE_STD_ZVAL(zHeaderLen);
	ZVAL_LONG(zHeaderLen, (long)HeaderLen);
	MAKE_STD_ZVAL(zUndefLen);
	ZVAL_BOOL(zUndefLen, (zend_bool)UndefLen);

	params[0] = &zSender;
	params[1] = &zTagID;
	params[2] = &zTagLen;
	params[3] = &zHeaderLen;
	params[4] = &zUndefLen;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 5, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zTagID);
	zval_ptr_dtor(&zTagLen);
	zval_ptr_dtor(&zHeaderLen);
	zval_ptr_dtor(&zUndefLen);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBASN1SkipEventRaw(void * _ObjectData, TObjectHandle Sender, int64_t * Count)
{
	zval *retval_ptr;
	zval **params[2];
	zval * zSender;
	zval * zCount;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zCount);
	ZVAL_LONG(zCount, (long)*Count);

	params[0] = &zSender;
	params[1] = &zCount;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 2, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	*Count = (int64_t)Z_LVAL_P(zCount);
	zval_ptr_dtor(&zCount);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

zend_class_entry *TElASN1Parser_ce_ptr = NULL;

SB_PHP_METHOD(TElASN1Parser, Parse)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElASN1Parser_Parse(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElASN1Parser, get_RaiseOnEOC)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElASN1Parser_get_RaiseOnEOC(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElASN1Parser, set_RaiseOnEOC)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElASN1Parser_set_RaiseOnEOC(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElASN1Parser, get_MaxDataLength)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElASN1Parser_get_MaxDataLength(SBGetObjectHandle(getThis() TSRMLS_CC), &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElASN1Parser, set_MaxDataLength)
{
	long l8Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l8Value) == SUCCESS)
	{
		SBCheckError(TElASN1Parser_set_MaxDataLength(SBGetObjectHandle(getThis() TSRMLS_CC), (int64_t)l8Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElASN1Parser, get_MaxSimpleTagLength)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElASN1Parser_get_MaxSimpleTagLength(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElASN1Parser, set_MaxSimpleTagLength)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElASN1Parser_set_MaxSimpleTagLength(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElASN1Parser, get_OnRead)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBASN1ReadEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElASN1Parser_get_OnRead(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElASN1Parser, set_OnRead)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElASN1Parser_set_OnRead(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBASN1ReadEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBASN1ReadEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElASN1Parser, get_OnTag)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBASN1TagEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElASN1Parser_get_OnTag(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElASN1Parser, set_OnTag)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElASN1Parser_set_OnTag(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBASN1TagEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBASN1TagEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElASN1Parser, get_OnTagHeader)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBASN1TagHeaderEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElASN1Parser_get_OnTagHeader(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElASN1Parser, set_OnTagHeader)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElASN1Parser_set_OnTagHeader(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBASN1TagHeaderEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBASN1TagHeaderEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElASN1Parser, get_OnSkip)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBASN1SkipEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElASN1Parser_get_OnSkip(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElASN1Parser, set_OnSkip)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElASN1Parser_set_OnSkip(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBASN1SkipEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBASN1SkipEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElASN1Parser, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElASN1Parser_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASN1Parser_Parse, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASN1Parser_get_RaiseOnEOC, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASN1Parser_set_RaiseOnEOC, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASN1Parser_get_MaxDataLength, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASN1Parser_set_MaxDataLength, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASN1Parser_get_MaxSimpleTagLength, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASN1Parser_set_MaxSimpleTagLength, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASN1Parser_get_OnRead, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASN1Parser_set_OnRead, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASN1Parser_get_OnTag, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASN1Parser_set_OnTag, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASN1Parser_get_OnTagHeader, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASN1Parser_set_OnTagHeader, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASN1Parser_get_OnSkip, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASN1Parser_set_OnSkip, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASN1Parser___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElASN1Parser_methods[] = {
	PHP_ME(TElASN1Parser, Parse, arginfo_TElASN1Parser_Parse, ZEND_ACC_PUBLIC)
	PHP_ME(TElASN1Parser, get_RaiseOnEOC, arginfo_TElASN1Parser_get_RaiseOnEOC, ZEND_ACC_PUBLIC)
	PHP_ME(TElASN1Parser, set_RaiseOnEOC, arginfo_TElASN1Parser_set_RaiseOnEOC, ZEND_ACC_PUBLIC)
	PHP_ME(TElASN1Parser, get_MaxDataLength, arginfo_TElASN1Parser_get_MaxDataLength, ZEND_ACC_PUBLIC)
	PHP_ME(TElASN1Parser, set_MaxDataLength, arginfo_TElASN1Parser_set_MaxDataLength, ZEND_ACC_PUBLIC)
	PHP_ME(TElASN1Parser, get_MaxSimpleTagLength, arginfo_TElASN1Parser_get_MaxSimpleTagLength, ZEND_ACC_PUBLIC)
	PHP_ME(TElASN1Parser, set_MaxSimpleTagLength, arginfo_TElASN1Parser_set_MaxSimpleTagLength, ZEND_ACC_PUBLIC)
	PHP_ME(TElASN1Parser, get_OnRead, arginfo_TElASN1Parser_get_OnRead, ZEND_ACC_PUBLIC)
	PHP_ME(TElASN1Parser, set_OnRead, arginfo_TElASN1Parser_set_OnRead, ZEND_ACC_PUBLIC)
	PHP_ME(TElASN1Parser, get_OnTag, arginfo_TElASN1Parser_get_OnTag, ZEND_ACC_PUBLIC)
	PHP_ME(TElASN1Parser, set_OnTag, arginfo_TElASN1Parser_set_OnTag, ZEND_ACC_PUBLIC)
	PHP_ME(TElASN1Parser, get_OnTagHeader, arginfo_TElASN1Parser_get_OnTagHeader, ZEND_ACC_PUBLIC)
	PHP_ME(TElASN1Parser, set_OnTagHeader, arginfo_TElASN1Parser_set_OnTagHeader, ZEND_ACC_PUBLIC)
	PHP_ME(TElASN1Parser, get_OnSkip, arginfo_TElASN1Parser_get_OnSkip, ZEND_ACC_PUBLIC)
	PHP_ME(TElASN1Parser, set_OnSkip, arginfo_TElASN1Parser_set_OnSkip, ZEND_ACC_PUBLIC)
	PHP_ME(TElASN1Parser, __construct, arginfo_TElASN1Parser___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElASN1Parser(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElASN1Parser_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElASN1Parser", TElASN1Parser_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElASN1Parser_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_FUNCTION(SBASN1, asn1AddTag)
{
	long fTagType;
	long l4BitRest;
	long l4Size;
	long l4TagSize;
	long u1Tag;
	SBArrayZValInfo piData;
	SBArrayZValInfo piStream;
	SBArrayZValInfo piTag;
	zend_bool bRevert;
	zend_bool bTagConstrained;
	zval *zpData;
	zval *zpStream;
	zval *zpTag;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlbzllzbl", &zpStream, &fTagType, &bTagConstrained, &zpTag, &l4TagSize, &l4Size, &zpData, &bRevert, &l4BitRest) == SUCCESS) && ((Z_TYPE_P(zpStream) == IS_STRING) || (Z_TYPE_P(zpStream) == IS_ARRAY) || (Z_TYPE_P(zpStream) == IS_NULL) || ((Z_TYPE_P(zpStream) == IS_OBJECT) && (Z_OBJCE_P(zpStream) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpTag) == IS_STRING) || (Z_TYPE_P(zpTag) == IS_ARRAY) || (Z_TYPE_P(zpTag) == IS_NULL) || ((Z_TYPE_P(zpTag) == IS_OBJECT) && (Z_OBJCE_P(zpTag) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpData) == IS_STRING) || (Z_TYPE_P(zpData) == IS_ARRAY) || (Z_TYPE_P(zpData) == IS_NULL) || ((Z_TYPE_P(zpData) == IS_OBJECT) && (Z_OBJCE_P(zpData) == TSBPointer_ce_ptr))))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpStream, &piStream TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpTag, &piTag TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpData, &piData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBASN1_asn1AddTag(piStream.data, (asn1TagTypeRaw)fTagType, (int8_t)bTagConstrained, piTag.data, (int32_t)l4TagSize, (int32_t)l4Size, piData.data, (int8_t)bRevert, (int32_t)l4BitRest, &bOutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piStream);
		SBFreePointerZValInfo(&piTag);
		SBFreePointerZValInfo(&piData);
		RETURN_BOOL(bOutResultRaw);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlbllzbl", &zpStream, &fTagType, &bTagConstrained, &u1Tag, &l4Size, &zpData, &bRevert, &l4BitRest) == SUCCESS) && ((Z_TYPE_P(zpStream) == IS_STRING) || (Z_TYPE_P(zpStream) == IS_ARRAY) || (Z_TYPE_P(zpStream) == IS_NULL) || ((Z_TYPE_P(zpStream) == IS_OBJECT) && (Z_OBJCE_P(zpStream) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpData) == IS_STRING) || (Z_TYPE_P(zpData) == IS_ARRAY) || (Z_TYPE_P(zpData) == IS_NULL) || ((Z_TYPE_P(zpData) == IS_OBJECT) && (Z_OBJCE_P(zpData) == TSBPointer_ce_ptr))))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpStream, &piStream TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpData, &piData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBASN1_asn1AddTag_1(piStream.data, (asn1TagTypeRaw)fTagType, (int8_t)bTagConstrained, (uint8_t)u1Tag, (int32_t)l4Size, piData.data, (int8_t)bRevert, (int32_t)l4BitRest, &bOutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piStream);
		SBFreePointerZValInfo(&piData);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer, bool, TSBPointer|array of byte|string|NULL, integer, integer, TSBPointer|array of byte|string|NULL, bool, integer) or (TSBPointer|array of byte|string|NULL, integer, bool, integer, integer, TSBPointer|array of byte|string|NULL, bool, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBASN1, asn1ParseStream)
{
	SBArrayZValInfo piStream;
	void *pzCallBack;
	zval *zCallBack;
	zval *zpStream;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zz", &zpStream, &zCallBack) == SUCCESS) && ((Z_TYPE_P(zpStream) == IS_STRING) || (Z_TYPE_P(zpStream) == IS_ARRAY) || (Z_TYPE_P(zpStream) == IS_NULL) || ((Z_TYPE_P(zpStream) == IS_OBJECT) && (Z_OBJCE_P(zpStream) == TSBPointer_ce_ptr))) && ((IS_STRING == Z_TYPE_P(zCallBack)) || (IS_ARRAY == Z_TYPE_P(zCallBack)) || (IS_CALLABLE == Z_TYPE_P(zCallBack)) || (IS_NULL == Z_TYPE_P(zCallBack))))
	{
		if (!SBGetPointerFromZVal(zpStream, &piStream TSRMLS_CC)) RETURN_FALSE;
		pzCallBack = SBSetEventData(zCallBack TSRMLS_CC);
		SBCheckError(SBASN1_asn1ParseStream(piStream.data, pzCallBack ? &asn1tCallBackFuncRaw : NULL, pzCallBack) TSRMLS_CC);
		SBFreePointerZValInfo(&piStream);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, asn1tCallBackFunc|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBASN1, asn1AddInt)
{
	long l4Value;
	SBArrayZValInfo piStream;
	zend_bool bRevert;
	zval *zpStream;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlb", &zpStream, &l4Value, &bRevert) == SUCCESS) && ((Z_TYPE_P(zpStream) == IS_STRING) || (Z_TYPE_P(zpStream) == IS_ARRAY) || (Z_TYPE_P(zpStream) == IS_NULL) || ((Z_TYPE_P(zpStream) == IS_OBJECT) && (Z_OBJCE_P(zpStream) == TSBPointer_ce_ptr))))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpStream, &piStream TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBASN1_asn1AddInt(piStream.data, (int32_t)l4Value, (int8_t)bRevert, &bOutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piStream);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer, bool)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBASN1, asn1AddBool)
{
	SBArrayZValInfo piStream;
	zend_bool bValue;
	zval *zpStream;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zb", &zpStream, &bValue) == SUCCESS) && ((Z_TYPE_P(zpStream) == IS_STRING) || (Z_TYPE_P(zpStream) == IS_ARRAY) || (Z_TYPE_P(zpStream) == IS_NULL) || ((Z_TYPE_P(zpStream) == IS_OBJECT) && (Z_OBJCE_P(zpStream) == TSBPointer_ce_ptr))))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpStream, &piStream TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBASN1_asn1AddBool(piStream.data, (int8_t)bValue, &bOutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piStream);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, bool)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBASN1, asn1AddBuf)
{
	long l4Size;
	SBArrayZValInfo piStream;
	SBArrayZValInfo piValue;
	zval *zpStream;
	zval *zpValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zzl", &zpStream, &zpValue, &l4Size) == SUCCESS) && ((Z_TYPE_P(zpStream) == IS_STRING) || (Z_TYPE_P(zpStream) == IS_ARRAY) || (Z_TYPE_P(zpStream) == IS_NULL) || ((Z_TYPE_P(zpStream) == IS_OBJECT) && (Z_OBJCE_P(zpStream) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpValue) == IS_STRING) || (Z_TYPE_P(zpValue) == IS_ARRAY) || (Z_TYPE_P(zpValue) == IS_NULL) || ((Z_TYPE_P(zpValue) == IS_OBJECT) && (Z_OBJCE_P(zpValue) == TSBPointer_ce_ptr))))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpStream, &piStream TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpValue, &piValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBASN1_asn1AddBuf(piStream.data, piValue.data, (int32_t)l4Size, &bOutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piStream);
		SBFreePointerZValInfo(&piValue);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, TSBPointer|array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBASN1, asn1AddSeq)
{
	SBArrayZValInfo piStream;
	zval *zpStream;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zpStream) == SUCCESS) && ((Z_TYPE_P(zpStream) == IS_STRING) || (Z_TYPE_P(zpStream) == IS_ARRAY) || (Z_TYPE_P(zpStream) == IS_NULL) || ((Z_TYPE_P(zpStream) == IS_OBJECT) && (Z_OBJCE_P(zpStream) == TSBPointer_ce_ptr))))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpStream, &piStream TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBASN1_asn1AddSeq(piStream.data, &bOutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piStream);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBASN1, asn1AddSet)
{
	SBArrayZValInfo piStream;
	zval *zpStream;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zpStream) == SUCCESS) && ((Z_TYPE_P(zpStream) == IS_STRING) || (Z_TYPE_P(zpStream) == IS_ARRAY) || (Z_TYPE_P(zpStream) == IS_NULL) || ((Z_TYPE_P(zpStream) == IS_OBJECT) && (Z_OBJCE_P(zpStream) == TSBPointer_ce_ptr))))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpStream, &piStream TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBASN1_asn1AddSet(piStream.data, &bOutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piStream);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBASN1, asn1AddConstrained)
{
	long fTagType;
	long l4Size;
	long l4TagSize;
	long u1Tag;
	SBArrayZValInfo piStream;
	SBArrayZValInfo piTag;
	zval *zpStream;
	zval *zpTag;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlzll", &zpStream, &fTagType, &zpTag, &l4TagSize, &l4Size) == SUCCESS) && ((Z_TYPE_P(zpStream) == IS_STRING) || (Z_TYPE_P(zpStream) == IS_ARRAY) || (Z_TYPE_P(zpStream) == IS_NULL) || ((Z_TYPE_P(zpStream) == IS_OBJECT) && (Z_OBJCE_P(zpStream) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpTag) == IS_STRING) || (Z_TYPE_P(zpTag) == IS_ARRAY) || (Z_TYPE_P(zpTag) == IS_NULL) || ((Z_TYPE_P(zpTag) == IS_OBJECT) && (Z_OBJCE_P(zpTag) == TSBPointer_ce_ptr))))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpStream, &piStream TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpTag, &piTag TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBASN1_asn1AddConstrained(piStream.data, (asn1TagTypeRaw)fTagType, piTag.data, (int32_t)l4TagSize, (int32_t)l4Size, &bOutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piStream);
		SBFreePointerZValInfo(&piTag);
		RETURN_BOOL(bOutResultRaw);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlll", &zpStream, &fTagType, &u1Tag, &l4Size) == SUCCESS) && ((Z_TYPE_P(zpStream) == IS_STRING) || (Z_TYPE_P(zpStream) == IS_ARRAY) || (Z_TYPE_P(zpStream) == IS_NULL) || ((Z_TYPE_P(zpStream) == IS_OBJECT) && (Z_OBJCE_P(zpStream) == TSBPointer_ce_ptr))))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpStream, &piStream TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBASN1_asn1AddConstrained_1(piStream.data, (asn1TagTypeRaw)fTagType, (uint8_t)u1Tag, (int32_t)l4Size, &bOutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piStream);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer, integer) or (TSBPointer|array of byte|string|NULL, integer, integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBASN1, asn1CloseConstrained)
{
	SBArrayZValInfo piStream;
	zval *zpStream;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zpStream) == SUCCESS) && ((Z_TYPE_P(zpStream) == IS_STRING) || (Z_TYPE_P(zpStream) == IS_ARRAY) || (Z_TYPE_P(zpStream) == IS_NULL) || ((Z_TYPE_P(zpStream) == IS_OBJECT) && (Z_OBJCE_P(zpStream) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpStream, &piStream TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBASN1_asn1CloseConstrained(piStream.data) TSRMLS_CC);
		SBFreePointerZValInfo(&piStream);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBASN1, asn1AddTypeEqu)
{
	long fTagType1;
	long fTagType2;
	long l4TagSize1;
	long l4TagSize2;
	long u1Tag2;
	SBArrayZValInfo piTag1;
	SBArrayZValInfo piTag2;
	zval *zpTag1;
	zval *zpTag2;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lzllzl", &fTagType1, &zpTag1, &l4TagSize1, &fTagType2, &zpTag2, &l4TagSize2) == SUCCESS) && ((Z_TYPE_P(zpTag1) == IS_STRING) || (Z_TYPE_P(zpTag1) == IS_ARRAY) || (Z_TYPE_P(zpTag1) == IS_NULL) || ((Z_TYPE_P(zpTag1) == IS_OBJECT) && (Z_OBJCE_P(zpTag1) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpTag2) == IS_STRING) || (Z_TYPE_P(zpTag2) == IS_ARRAY) || (Z_TYPE_P(zpTag2) == IS_NULL) || ((Z_TYPE_P(zpTag2) == IS_OBJECT) && (Z_OBJCE_P(zpTag2) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpTag1, &piTag1 TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpTag2, &piTag2 TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBASN1_asn1AddTypeEqu((asn1TagTypeRaw)fTagType1, piTag1.data, (int32_t)l4TagSize1, (asn1TagTypeRaw)fTagType2, piTag2.data, (int32_t)l4TagSize2) TSRMLS_CC);
		SBFreePointerZValInfo(&piTag1);
		SBFreePointerZValInfo(&piTag2);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lzll", &fTagType1, &zpTag1, &l4TagSize1, &u1Tag2) == SUCCESS) && ((Z_TYPE_P(zpTag1) == IS_STRING) || (Z_TYPE_P(zpTag1) == IS_ARRAY) || (Z_TYPE_P(zpTag1) == IS_NULL) || ((Z_TYPE_P(zpTag1) == IS_OBJECT) && (Z_OBJCE_P(zpTag1) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpTag1, &piTag1 TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBASN1_asn1AddTypeEqu_1((asn1TagTypeRaw)fTagType1, piTag1.data, (int32_t)l4TagSize1, (uint8_t)u1Tag2) TSRMLS_CC);
		SBFreePointerZValInfo(&piTag1);
	}
	else
	{
		SBErrorExpectsArguments("(integer, TSBPointer|array of byte|string|NULL, integer, integer, TSBPointer|array of byte|string|NULL, integer) or (integer, TSBPointer|array of byte|string|NULL, integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBASN1, WriteListSequence)
{
	uint32_t _err;
	zval *oStrings;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oStrings, TElByteArrayList_ce_ptr) == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = SBASN1_WriteListSequence(SBGetObjectHandle(oStrings TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(1525758728, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(TElByteArrayList)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBASN1, WritePrimitiveListSeq)
{
	long u1Tag;
	uint32_t _err;
	zval *oStrings;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lO!", &u1Tag, &oStrings, TElByteArrayList_ce_ptr) == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = SBASN1_WritePrimitiveListSeq((uint8_t)u1Tag, SBGetObjectHandle(oStrings TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-1046311541, 2, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(integer, TElByteArrayList)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBASN1, WriteExplicit)
{
	SBArrayZValInfo aiData;
	uint32_t _err;
	zval *zaData;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaData) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaData)) || (IS_ARRAY == Z_TYPE_P(zaData)) || (IS_NULL == Z_TYPE_P(zaData))))
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		if (!SBGetByteArrayFromZVal(zaData, &aiData TSRMLS_CC)) RETURN_FALSE;
		_err = SBASN1_WriteExplicit(aiData.data, aiData.len, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(1409445467, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiData);
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBASN1, WriteInteger)
{
	long l4Number;
	long u1TagID;
	SBArrayZValInfo aiData;
	uint32_t _err;
	zval *zaData;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zaData, &u1TagID) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaData)) || (IS_ARRAY == Z_TYPE_P(zaData)) || (IS_NULL == Z_TYPE_P(zaData))))
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		if (!SBGetByteArrayFromZVal(zaData, &aiData TSRMLS_CC)) RETURN_FALSE;
		_err = SBASN1_WriteInteger(aiData.data, aiData.len, (uint8_t)u1TagID, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-1992790702, 2, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiData);
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &l4Number, &u1TagID) == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = SBASN1_WriteInteger_1((int32_t)l4Number, (uint8_t)u1TagID, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-732376845, 2, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, integer) or (integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBASN1, WriteOID)
{
	SBArrayZValInfo aiData;
	uint32_t _err;
	zval *zaData;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaData) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaData)) || (IS_ARRAY == Z_TYPE_P(zaData)) || (IS_NULL == Z_TYPE_P(zaData))))
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		if (!SBGetByteArrayFromZVal(zaData, &aiData TSRMLS_CC)) RETURN_FALSE;
		_err = SBASN1_WriteOID(aiData.data, aiData.len, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(1090962388, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiData);
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBASN1, WritePrintableString)
{
	char *sData;
	int sData_len;
	SBArrayZValInfo aiData;
	uint32_t _err;
	zval *zaData;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sData, &sData_len) == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = SBASN1_WritePrintableString(sData, (int32_t)sData_len, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-973319837, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaData) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaData)) || (IS_ARRAY == Z_TYPE_P(zaData)) || (IS_NULL == Z_TYPE_P(zaData))))
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		if (!SBGetByteArrayFromZVal(zaData, &aiData TSRMLS_CC)) RETURN_FALSE;
		_err = SBASN1_WritePrintableString_1(aiData.data, aiData.len, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-721553012, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiData);
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(string) or (array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBASN1, WriteUTF8String)
{
	char *sData;
	int sData_len;
	SBArrayZValInfo aiData;
	uint32_t _err;
	zval *zaData;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sData, &sData_len) == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = SBASN1_WriteUTF8String(sData, (int32_t)sData_len, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-2016027842, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaData) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaData)) || (IS_ARRAY == Z_TYPE_P(zaData)) || (IS_NULL == Z_TYPE_P(zaData))))
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		if (!SBGetByteArrayFromZVal(zaData, &aiData TSRMLS_CC)) RETURN_FALSE;
		_err = SBASN1_WriteUTF8String_1(aiData.data, aiData.len, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(1341114533, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiData);
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(string) or (array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBASN1, WriteIA5String)
{
	char *sData;
	int sData_len;
	SBArrayZValInfo aiData;
	uint32_t _err;
	zval *zaData;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sData, &sData_len) == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = SBASN1_WriteIA5String(sData, (int32_t)sData_len, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(1880773778, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaData) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaData)) || (IS_ARRAY == Z_TYPE_P(zaData)) || (IS_NULL == Z_TYPE_P(zaData))))
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		if (!SBGetByteArrayFromZVal(zaData, &aiData TSRMLS_CC)) RETURN_FALSE;
		_err = SBASN1_WriteIA5String_1(aiData.data, aiData.len, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-499697359, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiData);
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(string) or (array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBASN1, WriteUTCTime)
{
	char *sData;
	int sData_len;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sData, &sData_len) == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = SBASN1_WriteUTCTime(sData, (int32_t)sData_len, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(1942559608, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBASN1, WriteGeneralizedTime)
{
	uint32_t _err;
	zval *dtT;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &dtT, php_date_get_date_ce()) == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = SBASN1_WriteGeneralizedTime(SBGetDateTime(dtT TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(155410368, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(DateTime)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBASN1, WriteSize)
{
	long u4Size;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u4Size) == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = SBASN1_WriteSize((uint32_t)u4Size, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(520404123, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBASN1, WriteBitString)
{
	SBArrayZValInfo aiData;
	uint32_t _err;
	zval *zaData;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaData) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaData)) || (IS_ARRAY == Z_TYPE_P(zaData)) || (IS_NULL == Z_TYPE_P(zaData))))
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		if (!SBGetByteArrayFromZVal(zaData, &aiData TSRMLS_CC)) RETURN_FALSE;
		_err = SBASN1_WriteBitString(aiData.data, aiData.len, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(517762275, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiData);
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBASN1, WriteOctetString)
{
	char *sData;
	int sData_len;
	SBArrayZValInfo aiData;
	uint32_t _err;
	zval *zaData;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sData, &sData_len) == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = SBASN1_WriteOctetString(sData, (int32_t)sData_len, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(653348048, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaData) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaData)) || (IS_ARRAY == Z_TYPE_P(zaData)) || (IS_NULL == Z_TYPE_P(zaData))))
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		if (!SBGetByteArrayFromZVal(zaData, &aiData TSRMLS_CC)) RETURN_FALSE;
		_err = SBASN1_WriteOctetString_1(aiData.data, aiData.len, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-1158981628, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiData);
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(string) or (array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBASN1, WriteVisibleString)
{
	char *sData;
	int sData_len;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sData, &sData_len) == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = SBASN1_WriteVisibleString(sData, (int32_t)sData_len, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-1518160340, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBASN1, WriteBoolean)
{
	uint32_t _err;
	zend_bool bData;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bData) == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = SBASN1_WriteBoolean((int8_t)bData, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(928009551, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBASN1, WriteNULL)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = SBASN1_WriteNULL(u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(1140307095, 0, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBASN1, WritePrimitive)
{
	long u1Tag;
	SBArrayZValInfo aiData;
	uint32_t _err;
	zval *zaData;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lz", &u1Tag, &zaData) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaData)) || (IS_ARRAY == Z_TYPE_P(zaData)) || (IS_NULL == Z_TYPE_P(zaData))))
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		if (!SBGetByteArrayFromZVal(zaData, &aiData TSRMLS_CC)) RETURN_FALSE;
		_err = SBASN1_WritePrimitive((uint8_t)u1Tag, aiData.data, aiData.len, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(569238472, 2, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiData);
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(integer, array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBASN1, WriteStringPrimitive)
{
	char *sData;
	int sData_len;
	long u1Tag;
	SBArrayZValInfo aiData;
	uint32_t _err;
	zval *zaData;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ls", &u1Tag, &sData, &sData_len) == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = SBASN1_WriteStringPrimitive((uint8_t)u1Tag, sData, (int32_t)sData_len, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-497425069, 2, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lz", &u1Tag, &zaData) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaData)) || (IS_ARRAY == Z_TYPE_P(zaData)) || (IS_NULL == Z_TYPE_P(zaData))))
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		if (!SBGetByteArrayFromZVal(zaData, &aiData TSRMLS_CC)) RETURN_FALSE;
		_err = SBASN1_WriteStringPrimitive_1((uint8_t)u1Tag, aiData.data, aiData.len, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(1929929725, 2, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiData);
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(integer, string) or (integer, array of byte|string|NULL)" TSRMLS_CC);
	}
}

void Register_SBASN1_Constants(int module_number TSRMLS_DC)
{
	SB_REGISTER_LONG_CONSTANT(SBASN1, asn1Boolean, SB_asn1Boolean, SB_asn1Boolean);
	SB_REGISTER_LONG_CONSTANT(SBASN1, asn1Integer, SB_asn1Integer, SB_asn1Integer);
	SB_REGISTER_LONG_CONSTANT(SBASN1, asn1BitStr, SB_asn1BitStr, SB_asn1BitStr);
	SB_REGISTER_LONG_CONSTANT(SBASN1, asn1OctetStr, SB_asn1OctetStr, SB_asn1OctetStr);
	SB_REGISTER_LONG_CONSTANT(SBASN1, asn1NULL, SB_asn1NULL, SB_asn1NULL);
	SB_REGISTER_LONG_CONSTANT(SBASN1, asn1Object, SB_asn1Object, SB_asn1Object);
	SB_REGISTER_LONG_CONSTANT(SBASN1, asn1Real, SB_asn1Real, SB_asn1Real);
	SB_REGISTER_LONG_CONSTANT(SBASN1, asn1Enumerated, SB_asn1Enumerated, SB_asn1Enumerated);
	SB_REGISTER_LONG_CONSTANT(SBASN1, asn1UTF8String, SB_asn1UTF8String, SB_asn1UTF8String);
	SB_REGISTER_LONG_CONSTANT(SBASN1, asn1Sequence, SB_asn1Sequence, SB_asn1Sequence);
	SB_REGISTER_LONG_CONSTANT(SBASN1, asn1Set, SB_asn1Set, SB_asn1Set);
	SB_REGISTER_LONG_CONSTANT(SBASN1, asn1NumericStr, SB_asn1NumericStr, SB_asn1NumericStr);
	SB_REGISTER_LONG_CONSTANT(SBASN1, asn1PrintableStr, SB_asn1PrintableStr, SB_asn1PrintableStr);
	SB_REGISTER_LONG_CONSTANT(SBASN1, asn1T61String, SB_asn1T61String, SB_asn1T61String);
	SB_REGISTER_LONG_CONSTANT(SBASN1, asn1TeletexStr, SB_asn1TeletexStr, SB_asn1TeletexStr);
	SB_REGISTER_LONG_CONSTANT(SBASN1, asn1IA5String, SB_asn1IA5String, SB_asn1IA5String);
	SB_REGISTER_LONG_CONSTANT(SBASN1, asn1UTCTime, SB_asn1UTCTime, SB_asn1UTCTime);
	SB_REGISTER_LONG_CONSTANT(SBASN1, asn1GeneralizedTime, SB_asn1GeneralizedTime, SB_asn1GeneralizedTime);
	SB_REGISTER_LONG_CONSTANT(SBASN1, asn1VisibleStr, SB_asn1VisibleStr, SB_asn1VisibleStr);
	SB_REGISTER_LONG_CONSTANT(SBASN1, asn1GeneralStr, SB_asn1GeneralStr, SB_asn1GeneralStr);
	SB_REGISTER_LONG_CONSTANT(SBASN1, asn1A0, SB_asn1A0, SB_asn1A0);
	SB_REGISTER_LONG_CONSTANT(SBASN1, asn1A1, SB_asn1A1, SB_asn1A1);
	SB_REGISTER_LONG_CONSTANT(SBASN1, asn1A2, SB_asn1A2, SB_asn1A2);
	SB_REGISTER_LONG_CONSTANT(SBASN1, asn1A3, SB_asn1A3, SB_asn1A3);
	SB_REGISTER_LONG_CONSTANT(SBASN1, asn1A4, SB_asn1A4, SB_asn1A4);
	SB_REGISTER_LONG_CONSTANT(SBASN1, asn1A5, SB_asn1A5, SB_asn1A5);
	SB_REGISTER_LONG_CONSTANT(SBASN1, asn1A6, SB_asn1A6, SB_asn1A6);
	SB_REGISTER_LONG_CONSTANT(SBASN1, asn1A7, SB_asn1A7, SB_asn1A7);
	SB_REGISTER_LONG_CONSTANT(SBASN1, asn1A8, SB_asn1A8, SB_asn1A8);
	SB_REGISTER_LONG_CONSTANT(SBASN1, ERROR_FACILITY_ASN1, SB_ERROR_FACILITY_ASN1, SB_ERROR_FACILITY_ASN1);
	SB_REGISTER_LONG_CONSTANT(SBASN1, ERROR_ASN1_INVALID_STRUCTURE, SB_ERROR_ASN1_INVALID_STRUCTURE, SB_ERROR_ASN1_INVALID_STRUCTURE);
	SB_REGISTER_LONG_CONSTANT(SBASN1, ERROR_ASN1_INVALID_LENGTH_VALUE, SB_ERROR_ASN1_INVALID_LENGTH_VALUE, SB_ERROR_ASN1_INVALID_LENGTH_VALUE);
	SB_REGISTER_LONG_CONSTANT(SBASN1, ERROR_ASN1_TAG_DEPTH_OVER_LIMIT, SB_ERROR_ASN1_TAG_DEPTH_OVER_LIMIT, SB_ERROR_ASN1_TAG_DEPTH_OVER_LIMIT);
	SB_REGISTER_LONG_CONSTANT(SBASN1, ERROR_ASN1_INVALID_STREAM_DATA, SB_ERROR_ASN1_INVALID_STREAM_DATA, SB_ERROR_ASN1_INVALID_STREAM_DATA);
	SB_REGISTER_LONG_CONSTANT(SBASN1, ERROR_ASN1_UNEXPECTED_STREAM_END, SB_ERROR_ASN1_UNEXPECTED_STREAM_END, SB_ERROR_ASN1_UNEXPECTED_STREAM_END);
	SB_REGISTER_LONG_CONSTANT(SBASN1, ERROR_ASN1_BUFFER_LENGTH_OVER_LIMIT, SB_ERROR_ASN1_BUFFER_LENGTH_OVER_LIMIT, SB_ERROR_ASN1_BUFFER_LENGTH_OVER_LIMIT);
}

void Register_SBASN1_Enum_Flags(TSRMLS_D)
{
	zend_class_entry ce;
	INIT_CLASS_ENTRY(ce, "asn1TagType", NULL);
	asn1TagType_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	asn1TagType_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(asn1TagType_ce_ptr, "asn1tUniversal", 0)
	SB_DECLARE_CLASS_LONG_CONST(asn1TagType_ce_ptr, "asn1tApplication", 1)
	SB_DECLARE_CLASS_LONG_CONST(asn1TagType_ce_ptr, "asn1tSpecific", 2)
	SB_DECLARE_CLASS_LONG_CONST(asn1TagType_ce_ptr, "asn1tPrivate", 3)
	SB_DECLARE_CLASS_LONG_CONST(asn1TagType_ce_ptr, "asn1tEOC", 4)
}

