#include "sbcertretriever.h"

void SB_CALLBACK TSBCertificateRetrievalEventRaw(void * _ObjectData, TObjectHandle Sender, TElX509CertificateHandle Certificate, TSBGeneralNameRaw NameType, const char * pcLocation, int32_t szLocation, TElX509CertificateHandle * CACertificate)
{
	zval *retval_ptr;
	zval **params[5];
	zval * zSender;
	zval * zCertificate;
	zval * zNameType;
	zval * zLocation;
	zval * zCACertificate;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zCertificate);
	SBInitObject(zCertificate, TElX509Certificate_ce_ptr, Certificate TSRMLS_CC);
	MAKE_STD_ZVAL(zNameType);
	ZVAL_LONG(zNameType, (long)NameType);
	MAKE_STD_ZVAL(zLocation);
	ZVAL_STRINGL(zLocation, pcLocation, szLocation, 1);
	MAKE_STD_ZVAL(zCACertificate);
	SBInitObject(zCACertificate, TElX509Certificate_ce_ptr, *CACertificate TSRMLS_CC);

	params[0] = &zSender;
	params[1] = &zCertificate;
	params[2] = &zNameType;
	params[3] = &zLocation;
	params[4] = &zCACertificate;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 5, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zCertificate);
	zval_ptr_dtor(&zNameType);
	zval_ptr_dtor(&zLocation);
	*CACertificate = SBGetObjectHandleCE(zCACertificate, TElX509Certificate_ce_ptr TSRMLS_CC);
	SBDetachObjectHandleIfUniqueZVal(zCACertificate TSRMLS_CC);
	zval_ptr_dtor(&zCACertificate);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

zend_class_entry *TElCustomCertificateRetriever_ce_ptr = NULL;

SB_PHP_METHOD(TElCustomCertificateRetriever, SupportsLocation)
{
	char *sURI;
	int sURI_len;
	long fNameType;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ls", &fNameType, &sURI, &sURI_len) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElCustomCertificateRetriever_SupportsLocation(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBGeneralNameRaw)fNameType, sURI, (int32_t)sURI_len, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCertificateRetriever, RetrieveCertificate)
{
	char *sURL;
	int sURL_len;
	long fNameType;
	zval *oCertificate;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!ls", &oCertificate, TElX509Certificate_ce_ptr, &fNameType, &sURL, &sURL_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCustomCertificateRetriever_RetrieveCertificate(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oCertificate TSRMLS_CC), (TSBGeneralNameRaw)fNameType, sURL, (int32_t)sURL_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElX509Certificate_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElX509Certificate, integer, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCertificateRetriever, __construct)
{
	zval *oOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCustomCertificateRetriever_Create(SBGetObjectHandle(oOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCertificateRetriever_SupportsLocation, 0, 0, 2)
	ZEND_ARG_INFO(0, NameType)
	ZEND_ARG_INFO(0, URI)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCertificateRetriever_RetrieveCertificate, 0, 0, 3)
	ZEND_ARG_OBJ_INFO(0, Certificate, TElX509Certificate, 1)
	ZEND_ARG_INFO(0, NameType)
	ZEND_ARG_INFO(0, URL)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCertificateRetriever___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Owner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElCustomCertificateRetriever_methods[] = {
	PHP_ME(TElCustomCertificateRetriever, SupportsLocation, arginfo_TElCustomCertificateRetriever_SupportsLocation, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCertificateRetriever, RetrieveCertificate, arginfo_TElCustomCertificateRetriever_RetrieveCertificate, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCertificateRetriever, __construct, arginfo_TElCustomCertificateRetriever___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElCustomCertificateRetriever(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElCustomCertificateRetriever_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElCustomCertificateRetriever", TElCustomCertificateRetriever_methods);
	if (NULL == TComponent_ce_ptr)
		Register_TComponent(TSRMLS_C);
	TElCustomCertificateRetriever_ce_ptr = zend_register_internal_class_ex(&ce, TComponent_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElFileCertificateRetriever_ce_ptr = NULL;

SB_PHP_METHOD(TElFileCertificateRetriever, RetrieveCertificate)
{
	char *sURL;
	int sURL_len;
	long fNameType;
	zval *oCertificate;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!ls", &oCertificate, TElX509Certificate_ce_ptr, &fNameType, &sURL, &sURL_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElFileCertificateRetriever_RetrieveCertificate(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oCertificate TSRMLS_CC), (TSBGeneralNameRaw)fNameType, sURL, (int32_t)sURL_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElX509Certificate_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElX509Certificate, integer, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFileCertificateRetriever, SupportsLocation)
{
	char *sURI;
	int sURI_len;
	long fNameType;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ls", &fNameType, &sURI, &sURI_len) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElFileCertificateRetriever_SupportsLocation(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBGeneralNameRaw)fNameType, sURI, (int32_t)sURI_len, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFileCertificateRetriever, get_OnCertificateNeeded)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBCertificateRetrievalEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElFileCertificateRetriever_get_OnCertificateNeeded(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFileCertificateRetriever, set_OnCertificateNeeded)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElFileCertificateRetriever_set_OnCertificateNeeded(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBCertificateRetrievalEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBCertificateRetrievalEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFileCertificateRetriever, __construct)
{
	zval *oOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElFileCertificateRetriever_Create(SBGetObjectHandle(oOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFileCertificateRetriever_RetrieveCertificate, 0, 0, 3)
	ZEND_ARG_OBJ_INFO(0, Certificate, TElX509Certificate, 1)
	ZEND_ARG_INFO(0, NameType)
	ZEND_ARG_INFO(0, URL)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFileCertificateRetriever_SupportsLocation, 0, 0, 2)
	ZEND_ARG_INFO(0, NameType)
	ZEND_ARG_INFO(0, URI)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFileCertificateRetriever_get_OnCertificateNeeded, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFileCertificateRetriever_set_OnCertificateNeeded, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFileCertificateRetriever___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Owner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElFileCertificateRetriever_methods[] = {
	PHP_ME(TElFileCertificateRetriever, RetrieveCertificate, arginfo_TElFileCertificateRetriever_RetrieveCertificate, ZEND_ACC_PUBLIC)
	PHP_ME(TElFileCertificateRetriever, SupportsLocation, arginfo_TElFileCertificateRetriever_SupportsLocation, ZEND_ACC_PUBLIC)
	PHP_ME(TElFileCertificateRetriever, get_OnCertificateNeeded, arginfo_TElFileCertificateRetriever_get_OnCertificateNeeded, ZEND_ACC_PUBLIC)
	PHP_ME(TElFileCertificateRetriever, set_OnCertificateNeeded, arginfo_TElFileCertificateRetriever_set_OnCertificateNeeded, ZEND_ACC_PUBLIC)
	PHP_ME(TElFileCertificateRetriever, __construct, arginfo_TElFileCertificateRetriever___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElFileCertificateRetriever(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElFileCertificateRetriever_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElFileCertificateRetriever", TElFileCertificateRetriever_methods);
	if (NULL == TElCustomCertificateRetriever_ce_ptr)
		Register_TElCustomCertificateRetriever(TSRMLS_C);
	TElFileCertificateRetriever_ce_ptr = zend_register_internal_class_ex(&ce, TElCustomCertificateRetriever_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElCustomCertificateRetrieverFactory_ce_ptr = NULL;

SB_PHP_METHOD(TElCustomCertificateRetrieverFactory, SupportsLocation)
{
	char *sURI;
	int sURI_len;
	long fNameType;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ls", &fNameType, &sURI, &sURI_len) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElCustomCertificateRetrieverFactory_SupportsLocation(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBGeneralNameRaw)fNameType, sURI, (int32_t)sURI_len, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCertificateRetrieverFactory, GetClientInstance)
{
	zval *oValidator;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValidator, TObject_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCustomCertificateRetrieverFactory_GetClientInstance(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValidator TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomCertificateRetriever_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TObject)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCertificateRetrieverFactory, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCustomCertificateRetrieverFactory_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCertificateRetrieverFactory_SupportsLocation, 0, 0, 2)
	ZEND_ARG_INFO(0, NameType)
	ZEND_ARG_INFO(0, URI)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCertificateRetrieverFactory_GetClientInstance, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Validator, TObject, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCertificateRetrieverFactory___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElCustomCertificateRetrieverFactory_methods[] = {
	PHP_ME(TElCustomCertificateRetrieverFactory, SupportsLocation, arginfo_TElCustomCertificateRetrieverFactory_SupportsLocation, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCertificateRetrieverFactory, GetClientInstance, arginfo_TElCustomCertificateRetrieverFactory_GetClientInstance, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCertificateRetrieverFactory, __construct, arginfo_TElCustomCertificateRetrieverFactory___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElCustomCertificateRetrieverFactory(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElCustomCertificateRetrieverFactory_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElCustomCertificateRetrieverFactory", TElCustomCertificateRetrieverFactory_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElCustomCertificateRetrieverFactory_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElCertificateRetrieverManager_ce_ptr = NULL;

SB_PHP_METHOD(TElCertificateRetrieverManager, FindCertificateRetrieverByLocation)
{
	char *sLocation;
	int sLocation_len;
	long fNameType;
	zval *oValidator;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lsO!", &fNameType, &sLocation, &sLocation_len, &oValidator, TObject_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCertificateRetrieverManager_FindCertificateRetrieverByLocation(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBGeneralNameRaw)fNameType, sLocation, (int32_t)sLocation_len, SBGetObjectHandle(oValidator TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomCertificateRetriever_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, string, TObject)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCertificateRetrieverManager, RegisterCertificateRetrieverFactory)
{
	zval *oFactory;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oFactory, TElCustomCertificateRetrieverFactory_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElCertificateRetrieverManager_RegisterCertificateRetrieverFactory(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oFactory TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCertificateRetrieverFactory)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCertificateRetrieverManager, UnregisterCertificateRetrieverFactory)
{
	zval *oFactory;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oFactory, TElCustomCertificateRetrieverFactory_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElCertificateRetrieverManager_UnregisterCertificateRetrieverFactory(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oFactory TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCertificateRetrieverFactory)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCertificateRetrieverManager, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCertificateRetrieverManager_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCertificateRetrieverManager_FindCertificateRetrieverByLocation, 0, 0, 3)
	ZEND_ARG_INFO(0, NameType)
	ZEND_ARG_INFO(0, Location)
	ZEND_ARG_OBJ_INFO(0, Validator, TObject, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCertificateRetrieverManager_RegisterCertificateRetrieverFactory, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Factory, TElCustomCertificateRetrieverFactory, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCertificateRetrieverManager_UnregisterCertificateRetrieverFactory, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Factory, TElCustomCertificateRetrieverFactory, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCertificateRetrieverManager___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElCertificateRetrieverManager_methods[] = {
	PHP_ME(TElCertificateRetrieverManager, FindCertificateRetrieverByLocation, arginfo_TElCertificateRetrieverManager_FindCertificateRetrieverByLocation, ZEND_ACC_PUBLIC)
	PHP_ME(TElCertificateRetrieverManager, RegisterCertificateRetrieverFactory, arginfo_TElCertificateRetrieverManager_RegisterCertificateRetrieverFactory, ZEND_ACC_PUBLIC)
	PHP_ME(TElCertificateRetrieverManager, UnregisterCertificateRetrieverFactory, arginfo_TElCertificateRetrieverManager_UnregisterCertificateRetrieverFactory, ZEND_ACC_PUBLIC)
	PHP_ME(TElCertificateRetrieverManager, __construct, arginfo_TElCertificateRetrieverManager___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElCertificateRetrieverManager(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElCertificateRetrieverManager_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElCertificateRetrieverManager", TElCertificateRetrieverManager_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElCertificateRetrieverManager_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_FUNCTION(SBCertRetriever, CertificateRetrieverManagerAddRef)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(SBCertRetriever_CertificateRetrieverManagerAddRef(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCertificateRetrieverManager_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBCertRetriever, CertificateRetrieverManagerRelease)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(SBCertRetriever_CertificateRetrieverManagerRelease() TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

void Register_SBCertRetriever_Constants(int module_number TSRMLS_DC)
{
	SB_REGISTER_LONG_CONSTANT(SBCertRetriever, ERROR_FACILITY_CERT_RETRIEVER, SB_ERROR_FACILITY_CERT_RETRIEVER, SB_ERROR_FACILITY_CERT_RETRIEVER);
	SB_REGISTER_LONG_CONSTANT(SBCertRetriever, ERROR_CERT_RETRIEVER_ERROR_FLAG, SB_ERROR_CERT_RETRIEVER_ERROR_FLAG, SB_ERROR_CERT_RETRIEVER_ERROR_FLAG);
	SB_REGISTER_LONG_CONSTANT(SBCertRetriever, SB_CERT_RETRIEVER_ERROR_NO_PARAMETERS, SB_CERT_RETRIEVER_ERROR_NO_PARAMETERS, SB_CERT_RETRIEVER_ERROR_NO_PARAMETERS);
	SB_REGISTER_LONG_CONSTANT(SBCertRetriever, SB_CERT_RETRIEVER_ERROR_NO_REPLY, SB_CERT_RETRIEVER_ERROR_NO_REPLY, SB_CERT_RETRIEVER_ERROR_NO_REPLY);
}

void Register_SBCertRetriever_Aliases(TSRMLS_D)
{
	if (NULL == TElFileCertificateRetriever_ce_ptr)
		Register_TElFileCertificateRetriever(TSRMLS_C);
	zend_register_class_alias("ElFileCertificateRetriever", TElFileCertificateRetriever_ce_ptr);
	if (NULL == TElCustomCertificateRetrieverFactory_ce_ptr)
		Register_TElCustomCertificateRetrieverFactory(TSRMLS_C);
	zend_register_class_alias("ElCustomCertificateRetrieverFactory", TElCustomCertificateRetrieverFactory_ce_ptr);
	if (NULL == TElCertificateRetrieverManager_ce_ptr)
		Register_TElCertificateRetrieverManager(TSRMLS_C);
	zend_register_class_alias("ElCertRetrieverManager", TElCertificateRetrieverManager_ce_ptr);
}

