#include "sbcrlstorage.h"

zend_class_entry *TSBCRLLookupCriterion_ce_ptr = NULL;

zend_class_entry *TSBCRLLookupCriteria_ce_ptr = NULL;

zend_class_entry *TSBCRLLookupOption_ce_ptr = NULL;

zend_class_entry *TSBCRLLookupOptions_ce_ptr = NULL;

zend_class_entry *TElCustomCRLStorage_ce_ptr = NULL;

SB_PHP_METHOD(TElCustomCRLStorage, BeginRead)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElCustomCRLStorage_BeginRead(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCRLStorage, EndRead)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElCustomCRLStorage_EndRead(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCRLStorage, BeginWrite)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElCustomCRLStorage_BeginWrite(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCRLStorage, EndWrite)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElCustomCRLStorage_EndWrite(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCRLStorage, Add)
{
	zval *oCRL;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oCRL, TElCertificateRevocationList_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElCustomCRLStorage_Add(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oCRL TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElCertificateRevocationList)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCRLStorage, FindMatchingCRLs)
{
	zval *oCertificate;
	zval *oDistributionPoint;
	zval *oList;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!O!", &oCertificate, TElX509Certificate_ce_ptr, &oDistributionPoint, TElDistributionPoint_ce_ptr, &oList, TList_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElCustomCRLStorage_FindMatchingCRLs(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oCertificate TSRMLS_CC), SBGetObjectHandle(oDistributionPoint TSRMLS_CC), SBGetObjectHandle(oList TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElX509Certificate, TElDistributionPoint, TList)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCRLStorage, Remove)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		SBCheckError(TElCustomCRLStorage_Remove(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCRLStorage, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElCustomCRLStorage_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCRLStorage, FindFirst)
{
	zval *oLookup;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oLookup, TElCRLLookup_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElCustomCRLStorage_FindFirst(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oLookup TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElCRLLookup)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCRLStorage, FindNext)
{
	zval *oLookup;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oLookup, TElCRLLookup_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElCustomCRLStorage_FindNext(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oLookup TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElCRLLookup)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCRLStorage, ExportTo)
{
	zval *oStorage;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oStorage, TElCustomCRLStorage_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElCustomCRLStorage_ExportTo(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStorage TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCRLStorage)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCRLStorage, IndexOf)
{
	zval *oCrl;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oCrl, TElCertificateRevocationList_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElCustomCRLStorage_IndexOf(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oCrl TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElCertificateRevocationList)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCRLStorage, get_CRLs)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCustomCRLStorage_get_CRLs(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCertificateRevocationList_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCRLStorage, get_Count)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElCustomCRLStorage_get_Count(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCRLStorage, __construct)
{
	zval *oAOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCustomCRLStorage_Create(SBGetObjectHandle(oAOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCRLStorage_BeginRead, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCRLStorage_EndRead, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCRLStorage_BeginWrite, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCRLStorage_EndWrite, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCRLStorage_Add, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, CRL, TElCertificateRevocationList, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCRLStorage_FindMatchingCRLs, 0, 0, 3)
	ZEND_ARG_OBJ_INFO(0, Certificate, TElX509Certificate, 1)
	ZEND_ARG_OBJ_INFO(0, DistributionPoint, TElDistributionPoint, 1)
	ZEND_ARG_OBJ_INFO(0, List, TList, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCRLStorage_Remove, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCRLStorage_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCRLStorage_FindFirst, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Lookup, TElCRLLookup, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCRLStorage_FindNext, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Lookup, TElCRLLookup, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCRLStorage_ExportTo, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Storage, TElCustomCRLStorage, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCRLStorage_IndexOf, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Crl, TElCertificateRevocationList, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCRLStorage_get_CRLs, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCRLStorage_get_Count, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCRLStorage___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AOwner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElCustomCRLStorage_methods[] = {
	PHP_ME(TElCustomCRLStorage, BeginRead, arginfo_TElCustomCRLStorage_BeginRead, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCRLStorage, EndRead, arginfo_TElCustomCRLStorage_EndRead, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCRLStorage, BeginWrite, arginfo_TElCustomCRLStorage_BeginWrite, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCRLStorage, EndWrite, arginfo_TElCustomCRLStorage_EndWrite, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCRLStorage, Add, arginfo_TElCustomCRLStorage_Add, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCRLStorage, FindMatchingCRLs, arginfo_TElCustomCRLStorage_FindMatchingCRLs, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCRLStorage, Remove, arginfo_TElCustomCRLStorage_Remove, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCRLStorage, Clear, arginfo_TElCustomCRLStorage_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCRLStorage, FindFirst, arginfo_TElCustomCRLStorage_FindFirst, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCRLStorage, FindNext, arginfo_TElCustomCRLStorage_FindNext, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCRLStorage, ExportTo, arginfo_TElCustomCRLStorage_ExportTo, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCRLStorage, IndexOf, arginfo_TElCustomCRLStorage_IndexOf, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCRLStorage, get_CRLs, arginfo_TElCustomCRLStorage_get_CRLs, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCRLStorage, get_Count, arginfo_TElCustomCRLStorage_get_Count, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCRLStorage, __construct, arginfo_TElCustomCRLStorage___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElCustomCRLStorage(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElCustomCRLStorage_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElCustomCRLStorage", TElCustomCRLStorage_methods);
	if (NULL == TComponent_ce_ptr)
		Register_TComponent(TSRMLS_C);
	TElCustomCRLStorage_ce_ptr = zend_register_internal_class_ex(&ce, TComponent_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElCRLLookup_ce_ptr = NULL;

SB_PHP_METHOD(TElCRLLookup, get_IssuerRDN)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCRLLookup_get_IssuerRDN(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElRelativeDistinguishedName_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCRLLookup, get_DistributionPoint)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCRLLookup_get_DistributionPoint(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElGeneralName_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCRLLookup, get_Number)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElCRLLookup_get_Number(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-1298585639, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCRLLookup, set_Number)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElCRLLookup_set_Number(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCRLLookup, get_Reasons)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBCRLReasonFlagsRaw fOutResultRaw = 0;
		SBCheckError(TElCRLLookup_get_Reasons(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCRLLookup, set_Reasons)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElCRLLookup_set_Reasons(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBCRLReasonFlagsRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCRLLookup, get_AuthorityKeyIdentifier)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElCRLLookup_get_AuthorityKeyIdentifier(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-441251292, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCRLLookup, set_AuthorityKeyIdentifier)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElCRLLookup_set_AuthorityKeyIdentifier(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCRLLookup, get_BaseCRLNumber)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElCRLLookup_get_BaseCRLNumber(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(1873745431, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCRLLookup, set_BaseCRLNumber)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElCRLLookup_set_BaseCRLNumber(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCRLLookup, get_Criteria)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBCRLLookupCriteriaRaw fOutResultRaw = 0;
		SBCheckError(TElCRLLookup_get_Criteria(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCRLLookup, set_Criteria)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElCRLLookup_set_Criteria(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBCRLLookupCriteriaRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCRLLookup, get_Options)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBCRLLookupOptionsRaw fOutResultRaw = 0;
		SBCheckError(TElCRLLookup_get_Options(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCRLLookup, set_Options)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElCRLLookup_set_Options(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBCRLLookupOptionsRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCRLLookup, __construct)
{
	zval *oAOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCRLLookup_Create(SBGetObjectHandle(oAOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCRLLookup_get_IssuerRDN, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCRLLookup_get_DistributionPoint, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCRLLookup_get_Number, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCRLLookup_set_Number, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCRLLookup_get_Reasons, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCRLLookup_set_Reasons, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCRLLookup_get_AuthorityKeyIdentifier, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCRLLookup_set_AuthorityKeyIdentifier, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCRLLookup_get_BaseCRLNumber, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCRLLookup_set_BaseCRLNumber, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCRLLookup_get_Criteria, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCRLLookup_set_Criteria, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCRLLookup_get_Options, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCRLLookup_set_Options, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCRLLookup___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AOwner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElCRLLookup_methods[] = {
	PHP_ME(TElCRLLookup, get_IssuerRDN, arginfo_TElCRLLookup_get_IssuerRDN, ZEND_ACC_PUBLIC)
	PHP_ME(TElCRLLookup, get_DistributionPoint, arginfo_TElCRLLookup_get_DistributionPoint, ZEND_ACC_PUBLIC)
	PHP_ME(TElCRLLookup, get_Number, arginfo_TElCRLLookup_get_Number, ZEND_ACC_PUBLIC)
	PHP_ME(TElCRLLookup, set_Number, arginfo_TElCRLLookup_set_Number, ZEND_ACC_PUBLIC)
	PHP_ME(TElCRLLookup, get_Reasons, arginfo_TElCRLLookup_get_Reasons, ZEND_ACC_PUBLIC)
	PHP_ME(TElCRLLookup, set_Reasons, arginfo_TElCRLLookup_set_Reasons, ZEND_ACC_PUBLIC)
	PHP_ME(TElCRLLookup, get_AuthorityKeyIdentifier, arginfo_TElCRLLookup_get_AuthorityKeyIdentifier, ZEND_ACC_PUBLIC)
	PHP_ME(TElCRLLookup, set_AuthorityKeyIdentifier, arginfo_TElCRLLookup_set_AuthorityKeyIdentifier, ZEND_ACC_PUBLIC)
	PHP_ME(TElCRLLookup, get_BaseCRLNumber, arginfo_TElCRLLookup_get_BaseCRLNumber, ZEND_ACC_PUBLIC)
	PHP_ME(TElCRLLookup, set_BaseCRLNumber, arginfo_TElCRLLookup_set_BaseCRLNumber, ZEND_ACC_PUBLIC)
	PHP_ME(TElCRLLookup, get_Criteria, arginfo_TElCRLLookup_get_Criteria, ZEND_ACC_PUBLIC)
	PHP_ME(TElCRLLookup, set_Criteria, arginfo_TElCRLLookup_set_Criteria, ZEND_ACC_PUBLIC)
	PHP_ME(TElCRLLookup, get_Options, arginfo_TElCRLLookup_get_Options, ZEND_ACC_PUBLIC)
	PHP_ME(TElCRLLookup, set_Options, arginfo_TElCRLLookup_set_Options, ZEND_ACC_PUBLIC)
	PHP_ME(TElCRLLookup, __construct, arginfo_TElCRLLookup___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElCRLLookup(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElCRLLookup_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElCRLLookup", TElCRLLookup_methods);
	if (NULL == TComponent_ce_ptr)
		Register_TComponent(TSRMLS_C);
	TElCRLLookup_ce_ptr = zend_register_internal_class_ex(&ce, TComponent_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElMemoryCRLStorage_ce_ptr = NULL;

SB_PHP_METHOD(TElMemoryCRLStorage, BeginRead)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElMemoryCRLStorage_BeginRead(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElMemoryCRLStorage, EndRead)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElMemoryCRLStorage_EndRead(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElMemoryCRLStorage, BeginWrite)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElMemoryCRLStorage_BeginWrite(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElMemoryCRLStorage, EndWrite)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElMemoryCRLStorage_EndWrite(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElMemoryCRLStorage, Add)
{
	zval *oCRL;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oCRL, TElCertificateRevocationList_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElMemoryCRLStorage_Add(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oCRL TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElCertificateRevocationList)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElMemoryCRLStorage, Remove)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		SBCheckError(TElMemoryCRLStorage_Remove(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElMemoryCRLStorage, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElMemoryCRLStorage_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElMemoryCRLStorage, IndexOf)
{
	zval *oCrl;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oCrl, TElCertificateRevocationList_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElMemoryCRLStorage_IndexOf(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oCrl TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElCertificateRevocationList)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElMemoryCRLStorage, __construct)
{
	zval *oAOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElMemoryCRLStorage_Create(SBGetObjectHandle(oAOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElMemoryCRLStorage_BeginRead, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElMemoryCRLStorage_EndRead, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElMemoryCRLStorage_BeginWrite, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElMemoryCRLStorage_EndWrite, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElMemoryCRLStorage_Add, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, CRL, TElCertificateRevocationList, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElMemoryCRLStorage_Remove, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElMemoryCRLStorage_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElMemoryCRLStorage_IndexOf, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Crl, TElCertificateRevocationList, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElMemoryCRLStorage___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AOwner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElMemoryCRLStorage_methods[] = {
	PHP_ME(TElMemoryCRLStorage, BeginRead, arginfo_TElMemoryCRLStorage_BeginRead, ZEND_ACC_PUBLIC)
	PHP_ME(TElMemoryCRLStorage, EndRead, arginfo_TElMemoryCRLStorage_EndRead, ZEND_ACC_PUBLIC)
	PHP_ME(TElMemoryCRLStorage, BeginWrite, arginfo_TElMemoryCRLStorage_BeginWrite, ZEND_ACC_PUBLIC)
	PHP_ME(TElMemoryCRLStorage, EndWrite, arginfo_TElMemoryCRLStorage_EndWrite, ZEND_ACC_PUBLIC)
	PHP_ME(TElMemoryCRLStorage, Add, arginfo_TElMemoryCRLStorage_Add, ZEND_ACC_PUBLIC)
	PHP_ME(TElMemoryCRLStorage, Remove, arginfo_TElMemoryCRLStorage_Remove, ZEND_ACC_PUBLIC)
	PHP_ME(TElMemoryCRLStorage, Clear, arginfo_TElMemoryCRLStorage_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElMemoryCRLStorage, IndexOf, arginfo_TElMemoryCRLStorage_IndexOf, ZEND_ACC_PUBLIC)
	PHP_ME(TElMemoryCRLStorage, __construct, arginfo_TElMemoryCRLStorage___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElMemoryCRLStorage(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElMemoryCRLStorage_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElMemoryCRLStorage", TElMemoryCRLStorage_methods);
	if (NULL == TElCustomCRLStorage_ce_ptr)
		Register_TElCustomCRLStorage(TSRMLS_C);
	TElMemoryCRLStorage_ce_ptr = zend_register_internal_class_ex(&ce, TElCustomCRLStorage_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElCRLCacheStorage_ce_ptr = NULL;

SB_PHP_METHOD(TElCRLCacheStorage, Add)
{
	zval *oCRL;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oCRL, TElCertificateRevocationList_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElCRLCacheStorage_Add(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oCRL TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElCertificateRevocationList)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCRLCacheStorage, get_Enabled)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElCRLCacheStorage_get_Enabled(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCRLCacheStorage, set_Enabled)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElCRLCacheStorage_set_Enabled(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCRLCacheStorage, __construct)
{
	zval *oAOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCRLCacheStorage_Create(SBGetObjectHandle(oAOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCRLCacheStorage_Add, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, CRL, TElCertificateRevocationList, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCRLCacheStorage_get_Enabled, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCRLCacheStorage_set_Enabled, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCRLCacheStorage___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AOwner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElCRLCacheStorage_methods[] = {
	PHP_ME(TElCRLCacheStorage, Add, arginfo_TElCRLCacheStorage_Add, ZEND_ACC_PUBLIC)
	PHP_ME(TElCRLCacheStorage, get_Enabled, arginfo_TElCRLCacheStorage_get_Enabled, ZEND_ACC_PUBLIC)
	PHP_ME(TElCRLCacheStorage, set_Enabled, arginfo_TElCRLCacheStorage_set_Enabled, ZEND_ACC_PUBLIC)
	PHP_ME(TElCRLCacheStorage, __construct, arginfo_TElCRLCacheStorage___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElCRLCacheStorage(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElCRLCacheStorage_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElCRLCacheStorage", TElCRLCacheStorage_methods);
	if (NULL == TElMemoryCRLStorage_ce_ptr)
		Register_TElMemoryCRLStorage(TSRMLS_C);
	TElCRLCacheStorage_ce_ptr = zend_register_internal_class_ex(&ce, TElMemoryCRLStorage_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElCustomCRLRetriever_ce_ptr = NULL;

SB_PHP_METHOD(TElCustomCRLRetriever, Supports)
{
	char *sLocation;
	int sLocation_len;
	long fNameType;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ls", &fNameType, &sLocation, &sLocation_len) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElCustomCRLRetriever_Supports(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBGeneralNameRaw)fNameType, sLocation, (int32_t)sLocation_len, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCRLRetriever, GetCRL)
{
	char *sLocation;
	int sLocation_len;
	long fNameType;
	zval *oACertificate;
	zval *oCACertificate;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!ls", &oACertificate, TElX509Certificate_ce_ptr, &oCACertificate, TElX509Certificate_ce_ptr, &fNameType, &sLocation, &sLocation_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCustomCRLRetriever_GetCRL(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oACertificate TSRMLS_CC), SBGetObjectHandle(oCACertificate TSRMLS_CC), (TSBGeneralNameRaw)fNameType, sLocation, (int32_t)sLocation_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCertificateRevocationList_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElX509Certificate, TElX509Certificate, integer, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCRLRetriever, __construct)
{
	zval *oAOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCustomCRLRetriever_Create(SBGetObjectHandle(oAOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCRLRetriever_Supports, 0, 0, 2)
	ZEND_ARG_INFO(0, NameType)
	ZEND_ARG_INFO(0, Location)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCRLRetriever_GetCRL, 0, 0, 4)
	ZEND_ARG_OBJ_INFO(0, ACertificate, TElX509Certificate, 1)
	ZEND_ARG_OBJ_INFO(0, CACertificate, TElX509Certificate, 1)
	ZEND_ARG_INFO(0, NameType)
	ZEND_ARG_INFO(0, Location)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCRLRetriever___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AOwner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElCustomCRLRetriever_methods[] = {
	PHP_ME(TElCustomCRLRetriever, Supports, arginfo_TElCustomCRLRetriever_Supports, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCRLRetriever, GetCRL, arginfo_TElCustomCRLRetriever_GetCRL, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCRLRetriever, __construct, arginfo_TElCustomCRLRetriever___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElCustomCRLRetriever(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElCustomCRLRetriever_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElCustomCRLRetriever", TElCustomCRLRetriever_methods);
	if (NULL == TComponent_ce_ptr)
		Register_TComponent(TSRMLS_C);
	TElCustomCRLRetriever_ce_ptr = zend_register_internal_class_ex(&ce, TComponent_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElCustomCRLRetrieverFactory_ce_ptr = NULL;

SB_PHP_METHOD(TElCustomCRLRetrieverFactory, Supports)
{
	char *sLocation;
	int sLocation_len;
	long fNameType;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ls", &fNameType, &sLocation, &sLocation_len) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElCustomCRLRetrieverFactory_Supports(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBGeneralNameRaw)fNameType, sLocation, (int32_t)sLocation_len, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCRLRetrieverFactory, GetRetrieverInstance)
{
	zval *oValidator;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValidator, TObject_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCustomCRLRetrieverFactory_GetRetrieverInstance(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValidator TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomCRLRetriever_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TObject)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCRLRetrieverFactory, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCustomCRLRetrieverFactory_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCRLRetrieverFactory_Supports, 0, 0, 2)
	ZEND_ARG_INFO(0, NameType)
	ZEND_ARG_INFO(0, Location)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCRLRetrieverFactory_GetRetrieverInstance, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Validator, TObject, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCRLRetrieverFactory___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElCustomCRLRetrieverFactory_methods[] = {
	PHP_ME(TElCustomCRLRetrieverFactory, Supports, arginfo_TElCustomCRLRetrieverFactory_Supports, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCRLRetrieverFactory, GetRetrieverInstance, arginfo_TElCustomCRLRetrieverFactory_GetRetrieverInstance, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCRLRetrieverFactory, __construct, arginfo_TElCustomCRLRetrieverFactory___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElCustomCRLRetrieverFactory(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElCustomCRLRetrieverFactory_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElCustomCRLRetrieverFactory", TElCustomCRLRetrieverFactory_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElCustomCRLRetrieverFactory_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElCRLManager_ce_ptr = NULL;

SB_PHP_METHOD(TElCRLManager, PurgeExpiredCRLs)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElCRLManager_PurgeExpiredCRLs(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCRLManager, RegisterCRLRetrieverFactory)
{
	zval *oFactory;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oFactory, TElCustomCRLRetrieverFactory_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElCRLManager_RegisterCRLRetrieverFactory(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oFactory TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCRLRetrieverFactory)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCRLManager, UnregisterCRLRetrieverFactory)
{
	zval *oFactory;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oFactory, TElCustomCRLRetrieverFactory_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElCRLManager_UnregisterCRLRetrieverFactory(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oFactory TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCRLRetrieverFactory)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCRLManager, FindCRLRetriever)
{
	char *sLocation;
	int sLocation_len;
	long fNameType;
	zval *oValidator;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lsO!", &fNameType, &sLocation, &sLocation_len, &oValidator, TObject_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCRLManager_FindCRLRetriever(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBGeneralNameRaw)fNameType, sLocation, (int32_t)sLocation_len, SBGetObjectHandle(oValidator TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomCRLRetriever_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, string, TObject)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCRLManager, get_CRLCache)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCRLManager_get_CRLCache(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCRLCacheStorage_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCRLManager, get_UseCache)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElCRLManager_get_UseCache(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCRLManager, set_UseCache)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElCRLManager_set_UseCache(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCRLManager, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCRLManager_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCRLManager_PurgeExpiredCRLs, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCRLManager_RegisterCRLRetrieverFactory, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Factory, TElCustomCRLRetrieverFactory, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCRLManager_UnregisterCRLRetrieverFactory, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Factory, TElCustomCRLRetrieverFactory, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCRLManager_FindCRLRetriever, 0, 0, 3)
	ZEND_ARG_INFO(0, NameType)
	ZEND_ARG_INFO(0, Location)
	ZEND_ARG_OBJ_INFO(0, Validator, TObject, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCRLManager_get_CRLCache, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCRLManager_get_UseCache, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCRLManager_set_UseCache, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCRLManager___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElCRLManager_methods[] = {
	PHP_ME(TElCRLManager, PurgeExpiredCRLs, arginfo_TElCRLManager_PurgeExpiredCRLs, ZEND_ACC_PUBLIC)
	PHP_ME(TElCRLManager, RegisterCRLRetrieverFactory, arginfo_TElCRLManager_RegisterCRLRetrieverFactory, ZEND_ACC_PUBLIC)
	PHP_ME(TElCRLManager, UnregisterCRLRetrieverFactory, arginfo_TElCRLManager_UnregisterCRLRetrieverFactory, ZEND_ACC_PUBLIC)
	PHP_ME(TElCRLManager, FindCRLRetriever, arginfo_TElCRLManager_FindCRLRetriever, ZEND_ACC_PUBLIC)
	PHP_ME(TElCRLManager, get_CRLCache, arginfo_TElCRLManager_get_CRLCache, ZEND_ACC_PUBLIC)
	PHP_ME(TElCRLManager, get_UseCache, arginfo_TElCRLManager_get_UseCache, ZEND_ACC_PUBLIC)
	PHP_ME(TElCRLManager, set_UseCache, arginfo_TElCRLManager_set_UseCache, ZEND_ACC_PUBLIC)
	PHP_ME(TElCRLManager, __construct, arginfo_TElCRLManager___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElCRLManager(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElCRLManager_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElCRLManager", TElCRLManager_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElCRLManager_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_FUNCTION(SBCRLStorage, CRLManagerAddRef)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(SBCRLStorage_CRLManagerAddRef(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCRLManager_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBCRLStorage, CRLManagerRelease)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(SBCRLStorage_CRLManagerRelease() TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

void Register_SBCRLStorage_Enum_Flags(TSRMLS_D)
{
	zend_class_entry ce;
	INIT_CLASS_ENTRY(ce, "TSBCRLLookupCriterion", NULL);
	TSBCRLLookupCriterion_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBCRLLookupCriterion_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBCRLLookupCriterion_ce_ptr, "clcIssuer", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBCRLLookupCriterion_ce_ptr, "clcDistributionPoint", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBCRLLookupCriterion_ce_ptr, "clcNumber", 2)
	SB_DECLARE_CLASS_LONG_CONST(TSBCRLLookupCriterion_ce_ptr, "clcReason", 3)
	SB_DECLARE_CLASS_LONG_CONST(TSBCRLLookupCriterion_ce_ptr, "clcAuthorityKeyIdentifier", 4)
	SB_DECLARE_CLASS_LONG_CONST(TSBCRLLookupCriterion_ce_ptr, "clcBaseCRLNumber", 5)
	
	INIT_CLASS_ENTRY(ce, "TSBCRLLookupCriteria", NULL);
	TSBCRLLookupCriteria_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseFlags_ce_ptr, NULL TSRMLS_CC);
	TSBCRLLookupCriteria_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBCRLLookupCriteria_ce_ptr, "clcIssuer", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBCRLLookupCriteria_ce_ptr, "clcDistributionPoint", 2)
	SB_DECLARE_CLASS_LONG_CONST(TSBCRLLookupCriteria_ce_ptr, "clcNumber", 4)
	SB_DECLARE_CLASS_LONG_CONST(TSBCRLLookupCriteria_ce_ptr, "clcReason", 8)
	SB_DECLARE_CLASS_LONG_CONST(TSBCRLLookupCriteria_ce_ptr, "clcAuthorityKeyIdentifier", 16)
	SB_DECLARE_CLASS_LONG_CONST(TSBCRLLookupCriteria_ce_ptr, "clcBaseCRLNumber", 32)
	
	INIT_CLASS_ENTRY(ce, "TSBCRLLookupOption", NULL);
	TSBCRLLookupOption_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBCRLLookupOption_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBCRLLookupOption_ce_ptr, "cloExactMatch", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBCRLLookupOption_ce_ptr, "cloMatchAll", 1)
	
	INIT_CLASS_ENTRY(ce, "TSBCRLLookupOptions", NULL);
	TSBCRLLookupOptions_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseFlags_ce_ptr, NULL TSRMLS_CC);
	TSBCRLLookupOptions_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBCRLLookupOptions_ce_ptr, "cloExactMatch", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBCRLLookupOptions_ce_ptr, "cloMatchAll", 2)
}

void Register_SBCRLStorage_Aliases(TSRMLS_D)
{
	if (NULL == TElCustomCRLStorage_ce_ptr)
		Register_TElCustomCRLStorage(TSRMLS_C);
	zend_register_class_alias("ElCustomCRLStorage", TElCustomCRLStorage_ce_ptr);
	if (NULL == TElCRLLookup_ce_ptr)
		Register_TElCRLLookup(TSRMLS_C);
	zend_register_class_alias("ElCRLLookup", TElCRLLookup_ce_ptr);
	if (NULL == TElMemoryCRLStorage_ce_ptr)
		Register_TElMemoryCRLStorage(TSRMLS_C);
	zend_register_class_alias("ElMemoryCRLStorage", TElMemoryCRLStorage_ce_ptr);
	if (NULL == TElCustomCRLRetriever_ce_ptr)
		Register_TElCustomCRLRetriever(TSRMLS_C);
	zend_register_class_alias("ElCustomCRLRetriever", TElCustomCRLRetriever_ce_ptr);
	if (NULL == TElCRLManager_ce_ptr)
		Register_TElCRLManager(TSRMLS_C);
	zend_register_class_alias("ElCRLManager", TElCRLManager_ce_ptr);
}

