#include "sbcryptoprovbuiltinsym.h"

zend_class_entry *TSBBuiltInSymmetricCryptoMode_ce_ptr = NULL;

zend_class_entry *TSBBuiltInSymmetricCipherPadding_ce_ptr = NULL;

zend_class_entry *TSBBuiltInSymmetricCryptoOperation_ce_ptr = NULL;

void SB_CALLBACK TSBSymmetricCryptoProcessingFunctionRaw(void * _ObjectData, void * Buffer, void * OutBuffer, int32_t Size)
{
	zval *retval_ptr;
	zval **params[3];
	zval * zBuffer;
	zval * zOutBuffer;
	zval * zSize;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zBuffer);
	SBInitPointerObject(zBuffer, Buffer TSRMLS_CC);
	MAKE_STD_ZVAL(zOutBuffer);
	SBInitPointerObject(zOutBuffer, OutBuffer TSRMLS_CC);
	MAKE_STD_ZVAL(zSize);
	ZVAL_LONG(zSize, (long)Size);

	params[0] = &zBuffer;
	params[1] = &zOutBuffer;
	params[2] = &zSize;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 3, params TSRMLS_CC);

	zval_ptr_dtor(&zBuffer);
	zval_ptr_dtor(&zOutBuffer);
	zval_ptr_dtor(&zSize);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

SB_PHP_METHOD(TSBGCMContext, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(TSBGCMContext));
		intern->len = sizeof(TSBGCMContext);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(TSBGCMContext, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(TSBGCMContext));
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBBaseStruct_GetField, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBBaseStruct_SetField, 0, 0, 1)
	ZEND_ARG_INFO(0, value)
ZEND_END_ARG_INFO()

SB_PHP_METHOD(TSBGCMContext, get_IV0)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(TSBGCMContext, set_IV0)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(TSBGCMContext, get_IV1)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 4);
}

SB_PHP_METHOD(TSBGCMContext, set_IV1)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 4);
}

SB_PHP_METHOD(TSBGCMContext, get_IV2)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 8);
}

SB_PHP_METHOD(TSBGCMContext, set_IV2)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 8);
}

SB_PHP_METHOD(TSBGCMContext, get_IV3)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 12);
}

SB_PHP_METHOD(TSBGCMContext, set_IV3)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 12);
}

SB_PHP_METHOD(TSBGCMContext, get_H0)
{
	SBStuctGetFieldInt64(INTERNAL_FUNCTION_PARAM_PASSTHRU, 16);
}

SB_PHP_METHOD(TSBGCMContext, set_H0)
{
	SBStuctSetFieldInt64(INTERNAL_FUNCTION_PARAM_PASSTHRU, 16);
}

SB_PHP_METHOD(TSBGCMContext, get_H1)
{
	SBStuctGetFieldInt64(INTERNAL_FUNCTION_PARAM_PASSTHRU, 24);
}

SB_PHP_METHOD(TSBGCMContext, set_H1)
{
	SBStuctSetFieldInt64(INTERNAL_FUNCTION_PARAM_PASSTHRU, 24);
}

SB_PHP_METHOD(TSBGCMContext, get_Y0)
{
	SBStuctGetFieldInt64(INTERNAL_FUNCTION_PARAM_PASSTHRU, 32);
}

SB_PHP_METHOD(TSBGCMContext, set_Y0)
{
	SBStuctSetFieldInt64(INTERNAL_FUNCTION_PARAM_PASSTHRU, 32);
}

SB_PHP_METHOD(TSBGCMContext, get_Y1)
{
	SBStuctGetFieldInt64(INTERNAL_FUNCTION_PARAM_PASSTHRU, 40);
}

SB_PHP_METHOD(TSBGCMContext, set_Y1)
{
	SBStuctSetFieldInt64(INTERNAL_FUNCTION_PARAM_PASSTHRU, 40);
}

SB_PHP_METHOD(TSBGCMContext, get_Ctr0)
{
	SBStuctGetFieldInt64(INTERNAL_FUNCTION_PARAM_PASSTHRU, 48);
}

SB_PHP_METHOD(TSBGCMContext, set_Ctr0)
{
	SBStuctSetFieldInt64(INTERNAL_FUNCTION_PARAM_PASSTHRU, 48);
}

SB_PHP_METHOD(TSBGCMContext, get_Ctr1)
{
	SBStuctGetFieldInt64(INTERNAL_FUNCTION_PARAM_PASSTHRU, 56);
}

SB_PHP_METHOD(TSBGCMContext, set_Ctr1)
{
	SBStuctSetFieldInt64(INTERNAL_FUNCTION_PARAM_PASSTHRU, 56);
}

SB_PHP_METHOD(TSBGCMContext, get_ASize)
{
	SBStuctGetFieldInt64(INTERNAL_FUNCTION_PARAM_PASSTHRU, 64);
}

SB_PHP_METHOD(TSBGCMContext, set_ASize)
{
	SBStuctSetFieldInt64(INTERNAL_FUNCTION_PARAM_PASSTHRU, 64);
}

SB_PHP_METHOD(TSBGCMContext, get_PSize)
{
	SBStuctGetFieldInt64(INTERNAL_FUNCTION_PARAM_PASSTHRU, 72);
}

SB_PHP_METHOD(TSBGCMContext, set_PSize)
{
	SBStuctSetFieldInt64(INTERNAL_FUNCTION_PARAM_PASSTHRU, 72);
}

zend_class_entry *TSBGCMContext_ce_ptr = NULL;

static zend_function_entry TSBGCMContext_methods[] = {
	PHP_ME(TSBGCMContext, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(TSBGCMContext, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TSBGCMContext, get_IV0, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSBGCMContext, set_IV0, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSBGCMContext, get_IV1, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSBGCMContext, set_IV1, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSBGCMContext, get_IV2, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSBGCMContext, set_IV2, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSBGCMContext, get_IV3, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSBGCMContext, set_IV3, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSBGCMContext, get_H0, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSBGCMContext, set_H0, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSBGCMContext, get_H1, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSBGCMContext, set_H1, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSBGCMContext, get_Y0, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSBGCMContext, set_Y0, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSBGCMContext, get_Y1, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSBGCMContext, set_Y1, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSBGCMContext, get_Ctr0, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSBGCMContext, set_Ctr0, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSBGCMContext, get_Ctr1, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSBGCMContext, set_Ctr1, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSBGCMContext, get_ASize, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSBGCMContext, set_ASize, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSBGCMContext, get_PSize, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSBGCMContext, set_PSize, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TSBGCMContext(TSRMLS_D)
{
	zend_class_entry ce;
	if (TSBGCMContext_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "TSBGCMContext", TSBGCMContext_methods);
	TSBGCMContext_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElBuiltInSymmetricCryptoClass_ce_ptr = NULL;

zend_class_entry *TElBuiltInSymmetricCryptoKey_ce_ptr = NULL;

SB_PHP_METHOD(TElBuiltInSymmetricCryptoKey, Generate)
{
	long l4Bits;
	SBArrayZValInfo piProgressData;
	void *pzProgressFunc;
	zval *oParams;
	zval *zpProgressData;
	zval *zProgressFunc;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lO!zz", &l4Bits, &oParams, TElRelativeDistinguishedName_ce_ptr, &zProgressFunc, &zpProgressData) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zProgressFunc)) || (IS_ARRAY == Z_TYPE_P(zProgressFunc)) || (IS_CALLABLE == Z_TYPE_P(zProgressFunc)) || (IS_NULL == Z_TYPE_P(zProgressFunc))) && ((Z_TYPE_P(zpProgressData) == IS_STRING) || (Z_TYPE_P(zpProgressData) == IS_ARRAY) || (Z_TYPE_P(zpProgressData) == IS_NULL) || ((Z_TYPE_P(zpProgressData) == IS_OBJECT) && (Z_OBJCE_P(zpProgressData) == TSBPointer_ce_ptr))))
	{
		pzProgressFunc = SBSetEventData(zProgressFunc TSRMLS_CC);
		if (!SBGetPointerFromZVal(zpProgressData, &piProgressData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElBuiltInSymmetricCryptoKey_Generate(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Bits, SBGetObjectHandle(oParams TSRMLS_CC), pzProgressFunc ? &TSBProgressFuncRaw : NULL, pzProgressFunc, piProgressData.data) TSRMLS_CC);
		SBFreePointerZValInfo(&piProgressData);
	}
	else
	{
		SBErrorExpectsArguments("(integer, TElRelativeDistinguishedName, TSBProgressFunc|callable|NULL, TSBPointer|array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInSymmetricCryptoKey, GenerateIV)
{
	long l4Bits;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Bits) == SUCCESS)
	{
		SBCheckError(TElBuiltInSymmetricCryptoKey_GenerateIV(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Bits) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInSymmetricCryptoKey, ImportPublic)
{
	long l4Size;
	SBArrayZValInfo piBuffer;
	zval *oParams;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlO!", &zpBuffer, &l4Size, &oParams, TElRelativeDistinguishedName_ce_ptr) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElBuiltInSymmetricCryptoKey_ImportPublic(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, (int32_t)l4Size, SBGetObjectHandle(oParams TSRMLS_CC)) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer, TElRelativeDistinguishedName)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInSymmetricCryptoKey, ImportSecret)
{
	long l4Size;
	SBArrayZValInfo piBuffer;
	zval *oParams;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlO!", &zpBuffer, &l4Size, &oParams, TElRelativeDistinguishedName_ce_ptr) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElBuiltInSymmetricCryptoKey_ImportSecret(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, (int32_t)l4Size, SBGetObjectHandle(oParams TSRMLS_CC)) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer, TElRelativeDistinguishedName)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInSymmetricCryptoKey, ExportPublic)
{
	int32_t l4SizeRaw;
	SBArrayZValInfo piBuffer;
	zval *oParams;
	zval *zl4Size;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zzO!", &zpBuffer, &zl4Size, &oParams, TElRelativeDistinguishedName_ce_ptr) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4Size) && (IS_LONG == Z_TYPE_P(zl4Size)))
	{
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		l4SizeRaw = (int32_t)Z_LVAL_P(zl4Size);
		SBCheckError(TElBuiltInSymmetricCryptoKey_ExportPublic(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, &l4SizeRaw, SBGetObjectHandle(oParams TSRMLS_CC)) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
		ZVAL_LONG(zl4Size, (long)l4SizeRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, &integer, TElRelativeDistinguishedName)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInSymmetricCryptoKey, ExportSecret)
{
	int32_t l4SizeRaw;
	SBArrayZValInfo piBuffer;
	zval *oParams;
	zval *zl4Size;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zzO!", &zpBuffer, &zl4Size, &oParams, TElRelativeDistinguishedName_ce_ptr) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4Size) && (IS_LONG == Z_TYPE_P(zl4Size)))
	{
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		l4SizeRaw = (int32_t)Z_LVAL_P(zl4Size);
		SBCheckError(TElBuiltInSymmetricCryptoKey_ExportSecret(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, &l4SizeRaw, SBGetObjectHandle(oParams TSRMLS_CC)) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
		ZVAL_LONG(zl4Size, (long)l4SizeRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, &integer, TElRelativeDistinguishedName)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInSymmetricCryptoKey, ChangeAlgorithm)
{
	long l4Algorithm;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Algorithm) == SUCCESS)
	{
		SBCheckError(TElBuiltInSymmetricCryptoKey_ChangeAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Algorithm) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInSymmetricCryptoKey, Reset)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElBuiltInSymmetricCryptoKey_Reset(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInSymmetricCryptoKey, Clone)
{
	zval *oParams;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oParams, TElRelativeDistinguishedName_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBuiltInSymmetricCryptoKey_Clone(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oParams TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomCryptoKey_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElRelativeDistinguishedName)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInSymmetricCryptoKey, ClonePublic)
{
	zval *oParams;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oParams, TElRelativeDistinguishedName_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBuiltInSymmetricCryptoKey_ClonePublic(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oParams TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomCryptoKey_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElRelativeDistinguishedName)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInSymmetricCryptoKey, ClearPublic)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElBuiltInSymmetricCryptoKey_ClearPublic(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInSymmetricCryptoKey, ClearSecret)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElBuiltInSymmetricCryptoKey_ClearSecret(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInSymmetricCryptoKey, GetKeyProp)
{
	SBArrayZValInfo aiDefault;
	SBArrayZValInfo aiPropID;
	uint32_t _err;
	zval *zaDefault;
	zval *zaPropID;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zz", &zaPropID, &zaDefault) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaPropID)) || (IS_ARRAY == Z_TYPE_P(zaPropID)) || (IS_NULL == Z_TYPE_P(zaPropID))) && ((IS_STRING == Z_TYPE_P(zaDefault)) || (IS_ARRAY == Z_TYPE_P(zaDefault)) || (IS_NULL == Z_TYPE_P(zaDefault))))
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		if (!SBGetByteArrayFromZVal(zaPropID, &aiPropID TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaDefault, &aiDefault TSRMLS_CC)) RETURN_FALSE;
		_err = TElBuiltInSymmetricCryptoKey_GetKeyProp(SBGetObjectHandle(getThis() TSRMLS_CC), aiPropID.data, aiPropID.len, aiDefault.data, aiDefault.len, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(51928306, 3, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiPropID);
		SBFreeArrayZValInfo(&aiDefault);
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInSymmetricCryptoKey, SetKeyProp)
{
	SBArrayZValInfo aiPropID;
	SBArrayZValInfo aiValue;
	zval *zaPropID;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zz", &zaPropID, &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaPropID)) || (IS_ARRAY == Z_TYPE_P(zaPropID)) || (IS_NULL == Z_TYPE_P(zaPropID))) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaPropID, &aiPropID TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElBuiltInSymmetricCryptoKey_SetKeyProp(SBGetObjectHandle(getThis() TSRMLS_CC), aiPropID.data, aiPropID.len, aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiPropID);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInSymmetricCryptoKey, Equals)
{
	zend_bool bPublicOnly;
	zval *oParams;
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!bO!", &oSource, TElCustomCryptoKey_ce_ptr, &bPublicOnly, &oParams, TElRelativeDistinguishedName_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElBuiltInSymmetricCryptoKey_Equals(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC), (int8_t)bPublicOnly, SBGetObjectHandle(oParams TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCryptoKey, bool, TElRelativeDistinguishedName)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInSymmetricCryptoKey, __construct)
{
	SBArrayZValInfo aiAlgOID;
	SBArrayZValInfo aiAlgParams;
	zval *oCryptoProvider;
	zval *zaAlgOID;
	zval *zaAlgParams;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBuiltInSymmetricCryptoKey_Create(SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!zz", &oCryptoProvider, TElCustomCryptoProvider_ce_ptr, &zaAlgOID, &zaAlgParams) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaAlgOID)) || (IS_ARRAY == Z_TYPE_P(zaAlgOID)) || (IS_NULL == Z_TYPE_P(zaAlgOID))) && ((IS_STRING == Z_TYPE_P(zaAlgParams)) || (IS_ARRAY == Z_TYPE_P(zaAlgParams)) || (IS_NULL == Z_TYPE_P(zaAlgParams))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetByteArrayFromZVal(zaAlgOID, &aiAlgOID TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaAlgParams, &aiAlgParams TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElBuiltInSymmetricCryptoKey_Create_1(SBGetObjectHandle(oCryptoProvider TSRMLS_CC), aiAlgOID.data, aiAlgOID.len, aiAlgParams.data, aiAlgParams.len, &hoOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiAlgOID);
		SBFreeArrayZValInfo(&aiAlgParams);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCryptoProvider) or (TElCustomCryptoProvider, array of byte|string|NULL, array of byte|string|NULL)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInSymmetricCryptoKey_Generate, 0, 0, 4)
	ZEND_ARG_INFO(0, Bits)
	ZEND_ARG_OBJ_INFO(0, Params, TElRelativeDistinguishedName, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressFunc, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressData, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInSymmetricCryptoKey_GenerateIV, 0, 0, 1)
	ZEND_ARG_INFO(0, Bits)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInSymmetricCryptoKey_ImportPublic, 0, 0, 3)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(0, Size)
	ZEND_ARG_OBJ_INFO(0, Params, TElRelativeDistinguishedName, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInSymmetricCryptoKey_ImportSecret, 0, 0, 3)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(0, Size)
	ZEND_ARG_OBJ_INFO(0, Params, TElRelativeDistinguishedName, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInSymmetricCryptoKey_ExportPublic, 0, 0, 3)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(1, Size)
	ZEND_ARG_OBJ_INFO(0, Params, TElRelativeDistinguishedName, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInSymmetricCryptoKey_ExportSecret, 0, 0, 3)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(1, Size)
	ZEND_ARG_OBJ_INFO(0, Params, TElRelativeDistinguishedName, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInSymmetricCryptoKey_ChangeAlgorithm, 0, 0, 1)
	ZEND_ARG_INFO(0, Algorithm)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInSymmetricCryptoKey_Reset, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInSymmetricCryptoKey_Clone, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Params, TElRelativeDistinguishedName, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInSymmetricCryptoKey_ClonePublic, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Params, TElRelativeDistinguishedName, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInSymmetricCryptoKey_ClearPublic, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInSymmetricCryptoKey_ClearSecret, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInSymmetricCryptoKey_GetKeyProp, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, PropID, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Default, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInSymmetricCryptoKey_SetKeyProp, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, PropID, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInSymmetricCryptoKey_Equals, 0, 0, 3)
	ZEND_ARG_OBJ_INFO(0, Source, TElCustomCryptoKey, 1)
	ZEND_ARG_INFO(0, PublicOnly)
	ZEND_ARG_OBJ_INFO(0, Params, TElRelativeDistinguishedName, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInSymmetricCryptoKey___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, CryptoProvider, TElCustomCryptoProvider, 1)
	ZEND_ARG_TYPE_INFO(0, AlgOID, 0, 1)
	ZEND_ARG_TYPE_INFO(0, AlgParams, 0, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElBuiltInSymmetricCryptoKey_methods[] = {
	PHP_ME(TElBuiltInSymmetricCryptoKey, Generate, arginfo_TElBuiltInSymmetricCryptoKey_Generate, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInSymmetricCryptoKey, GenerateIV, arginfo_TElBuiltInSymmetricCryptoKey_GenerateIV, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInSymmetricCryptoKey, ImportPublic, arginfo_TElBuiltInSymmetricCryptoKey_ImportPublic, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInSymmetricCryptoKey, ImportSecret, arginfo_TElBuiltInSymmetricCryptoKey_ImportSecret, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInSymmetricCryptoKey, ExportPublic, arginfo_TElBuiltInSymmetricCryptoKey_ExportPublic, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInSymmetricCryptoKey, ExportSecret, arginfo_TElBuiltInSymmetricCryptoKey_ExportSecret, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInSymmetricCryptoKey, ChangeAlgorithm, arginfo_TElBuiltInSymmetricCryptoKey_ChangeAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInSymmetricCryptoKey, Reset, arginfo_TElBuiltInSymmetricCryptoKey_Reset, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInSymmetricCryptoKey, Clone, arginfo_TElBuiltInSymmetricCryptoKey_Clone, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInSymmetricCryptoKey, ClonePublic, arginfo_TElBuiltInSymmetricCryptoKey_ClonePublic, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInSymmetricCryptoKey, ClearPublic, arginfo_TElBuiltInSymmetricCryptoKey_ClearPublic, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInSymmetricCryptoKey, ClearSecret, arginfo_TElBuiltInSymmetricCryptoKey_ClearSecret, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInSymmetricCryptoKey, GetKeyProp, arginfo_TElBuiltInSymmetricCryptoKey_GetKeyProp, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInSymmetricCryptoKey, SetKeyProp, arginfo_TElBuiltInSymmetricCryptoKey_SetKeyProp, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInSymmetricCryptoKey, Equals, arginfo_TElBuiltInSymmetricCryptoKey_Equals, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInSymmetricCryptoKey, __construct, arginfo_TElBuiltInSymmetricCryptoKey___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElBuiltInSymmetricCryptoKey(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElBuiltInSymmetricCryptoKey_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElBuiltInSymmetricCryptoKey", TElBuiltInSymmetricCryptoKey_methods);
	if (NULL == TElBuiltInCryptoKey_ce_ptr)
		Register_TElBuiltInCryptoKey(TSRMLS_C);
	TElBuiltInSymmetricCryptoKey_ce_ptr = zend_register_internal_class_ex(&ce, TElBuiltInCryptoKey_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElBuiltInSymmetricCrypto_ce_ptr = NULL;

SB_PHP_METHOD(TElBuiltInSymmetricCrypto, InitializeEncryption)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElBuiltInSymmetricCrypto_InitializeEncryption(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInSymmetricCrypto, InitializeDecryption)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElBuiltInSymmetricCrypto_InitializeDecryption(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInSymmetricCrypto, Encrypt)
{
	int32_t l4OutSizeRaw;
	long l4InSize;
	SBArrayZValInfo piInBuffer;
	SBArrayZValInfo piOutBuffer;
	zval *oInStream;
	zval *oOutStream;
	zval *zl4OutSize;
	zval *zpInBuffer;
	zval *zpOutBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlzz", &zpInBuffer, &l4InSize, &zpOutBuffer, &zl4OutSize) == SUCCESS) && ((Z_TYPE_P(zpInBuffer) == IS_STRING) || (Z_TYPE_P(zpInBuffer) == IS_ARRAY) || (Z_TYPE_P(zpInBuffer) == IS_NULL) || ((Z_TYPE_P(zpInBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpInBuffer) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpOutBuffer) == IS_STRING) || (Z_TYPE_P(zpOutBuffer) == IS_ARRAY) || (Z_TYPE_P(zpOutBuffer) == IS_NULL) || ((Z_TYPE_P(zpOutBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpOutBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4OutSize) && (IS_LONG == Z_TYPE_P(zl4OutSize)))
	{
		if (!SBGetPointerFromZVal(zpInBuffer, &piInBuffer TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpOutBuffer, &piOutBuffer TSRMLS_CC)) RETURN_FALSE;
		l4OutSizeRaw = (int32_t)Z_LVAL_P(zl4OutSize);
		SBCheckError(TElBuiltInSymmetricCrypto_Encrypt(SBGetObjectHandle(getThis() TSRMLS_CC), piInBuffer.data, (int32_t)l4InSize, piOutBuffer.data, &l4OutSizeRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piInBuffer);
		SBFreePointerZValInfo(&piOutBuffer);
		ZVAL_LONG(zl4OutSize, (long)l4OutSizeRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oInStream, TStream_ce_ptr, &oOutStream, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElBuiltInSymmetricCrypto_Encrypt_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oInStream TSRMLS_CC), SBGetObjectHandle(oOutStream TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, &integer) or (TStream, TStream)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInSymmetricCrypto, EncryptUpdate)
{
	int32_t l4OutSizeRaw;
	long l4InSize;
	SBArrayZValInfo piInBuffer;
	SBArrayZValInfo piOutBuffer;
	zval *zl4OutSize;
	zval *zpInBuffer;
	zval *zpOutBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlzz", &zpInBuffer, &l4InSize, &zpOutBuffer, &zl4OutSize) == SUCCESS) && ((Z_TYPE_P(zpInBuffer) == IS_STRING) || (Z_TYPE_P(zpInBuffer) == IS_ARRAY) || (Z_TYPE_P(zpInBuffer) == IS_NULL) || ((Z_TYPE_P(zpInBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpInBuffer) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpOutBuffer) == IS_STRING) || (Z_TYPE_P(zpOutBuffer) == IS_ARRAY) || (Z_TYPE_P(zpOutBuffer) == IS_NULL) || ((Z_TYPE_P(zpOutBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpOutBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4OutSize) && (IS_LONG == Z_TYPE_P(zl4OutSize)))
	{
		if (!SBGetPointerFromZVal(zpInBuffer, &piInBuffer TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpOutBuffer, &piOutBuffer TSRMLS_CC)) RETURN_FALSE;
		l4OutSizeRaw = (int32_t)Z_LVAL_P(zl4OutSize);
		SBCheckError(TElBuiltInSymmetricCrypto_EncryptUpdate(SBGetObjectHandle(getThis() TSRMLS_CC), piInBuffer.data, (int32_t)l4InSize, piOutBuffer.data, &l4OutSizeRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piInBuffer);
		SBFreePointerZValInfo(&piOutBuffer);
		ZVAL_LONG(zl4OutSize, (long)l4OutSizeRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, &integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInSymmetricCrypto, FinalizeEncryption)
{
	int32_t l4OutSizeRaw;
	SBArrayZValInfo piOutBuffer;
	zval *zl4OutSize;
	zval *zpOutBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zz", &zpOutBuffer, &zl4OutSize) == SUCCESS) && ((Z_TYPE_P(zpOutBuffer) == IS_STRING) || (Z_TYPE_P(zpOutBuffer) == IS_ARRAY) || (Z_TYPE_P(zpOutBuffer) == IS_NULL) || ((Z_TYPE_P(zpOutBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpOutBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4OutSize) && (IS_LONG == Z_TYPE_P(zl4OutSize)))
	{
		if (!SBGetPointerFromZVal(zpOutBuffer, &piOutBuffer TSRMLS_CC)) RETURN_FALSE;
		l4OutSizeRaw = (int32_t)Z_LVAL_P(zl4OutSize);
		SBCheckError(TElBuiltInSymmetricCrypto_FinalizeEncryption(SBGetObjectHandle(getThis() TSRMLS_CC), piOutBuffer.data, &l4OutSizeRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piOutBuffer);
		ZVAL_LONG(zl4OutSize, (long)l4OutSizeRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, &integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInSymmetricCrypto, Decrypt)
{
	int32_t l4OutSizeRaw;
	long l4InCount;
	long l4InSize;
	SBArrayZValInfo piInBuffer;
	SBArrayZValInfo piOutBuffer;
	zval *oInStream;
	zval *oOutStream;
	zval *zl4OutSize;
	zval *zpInBuffer;
	zval *zpOutBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlzz", &zpInBuffer, &l4InSize, &zpOutBuffer, &zl4OutSize) == SUCCESS) && ((Z_TYPE_P(zpInBuffer) == IS_STRING) || (Z_TYPE_P(zpInBuffer) == IS_ARRAY) || (Z_TYPE_P(zpInBuffer) == IS_NULL) || ((Z_TYPE_P(zpInBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpInBuffer) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpOutBuffer) == IS_STRING) || (Z_TYPE_P(zpOutBuffer) == IS_ARRAY) || (Z_TYPE_P(zpOutBuffer) == IS_NULL) || ((Z_TYPE_P(zpOutBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpOutBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4OutSize) && (IS_LONG == Z_TYPE_P(zl4OutSize)))
	{
		if (!SBGetPointerFromZVal(zpInBuffer, &piInBuffer TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpOutBuffer, &piOutBuffer TSRMLS_CC)) RETURN_FALSE;
		l4OutSizeRaw = (int32_t)Z_LVAL_P(zl4OutSize);
		SBCheckError(TElBuiltInSymmetricCrypto_Decrypt(SBGetObjectHandle(getThis() TSRMLS_CC), piInBuffer.data, (int32_t)l4InSize, piOutBuffer.data, &l4OutSizeRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piInBuffer);
		SBFreePointerZValInfo(&piOutBuffer);
		ZVAL_LONG(zl4OutSize, (long)l4OutSizeRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!l", &oInStream, TStream_ce_ptr, &oOutStream, TStream_ce_ptr, &l4InCount) == SUCCESS)
	{
		SBCheckError(TElBuiltInSymmetricCrypto_Decrypt_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oInStream TSRMLS_CC), SBGetObjectHandle(oOutStream TSRMLS_CC), (int32_t)l4InCount) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, &integer) or (TStream, TStream, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInSymmetricCrypto, DecryptUpdate)
{
	int32_t l4OutSizeRaw;
	long l4InSize;
	SBArrayZValInfo piInBuffer;
	SBArrayZValInfo piOutBuffer;
	zval *zl4OutSize;
	zval *zpInBuffer;
	zval *zpOutBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlzz", &zpInBuffer, &l4InSize, &zpOutBuffer, &zl4OutSize) == SUCCESS) && ((Z_TYPE_P(zpInBuffer) == IS_STRING) || (Z_TYPE_P(zpInBuffer) == IS_ARRAY) || (Z_TYPE_P(zpInBuffer) == IS_NULL) || ((Z_TYPE_P(zpInBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpInBuffer) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpOutBuffer) == IS_STRING) || (Z_TYPE_P(zpOutBuffer) == IS_ARRAY) || (Z_TYPE_P(zpOutBuffer) == IS_NULL) || ((Z_TYPE_P(zpOutBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpOutBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4OutSize) && (IS_LONG == Z_TYPE_P(zl4OutSize)))
	{
		if (!SBGetPointerFromZVal(zpInBuffer, &piInBuffer TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpOutBuffer, &piOutBuffer TSRMLS_CC)) RETURN_FALSE;
		l4OutSizeRaw = (int32_t)Z_LVAL_P(zl4OutSize);
		SBCheckError(TElBuiltInSymmetricCrypto_DecryptUpdate(SBGetObjectHandle(getThis() TSRMLS_CC), piInBuffer.data, (int32_t)l4InSize, piOutBuffer.data, &l4OutSizeRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piInBuffer);
		SBFreePointerZValInfo(&piOutBuffer);
		ZVAL_LONG(zl4OutSize, (long)l4OutSizeRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, &integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInSymmetricCrypto, FinalizeDecryption)
{
	int32_t l4OutSizeRaw;
	SBArrayZValInfo piOutBuffer;
	zval *zl4OutSize;
	zval *zpOutBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zz", &zpOutBuffer, &zl4OutSize) == SUCCESS) && ((Z_TYPE_P(zpOutBuffer) == IS_STRING) || (Z_TYPE_P(zpOutBuffer) == IS_ARRAY) || (Z_TYPE_P(zpOutBuffer) == IS_NULL) || ((Z_TYPE_P(zpOutBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpOutBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4OutSize) && (IS_LONG == Z_TYPE_P(zl4OutSize)))
	{
		if (!SBGetPointerFromZVal(zpOutBuffer, &piOutBuffer TSRMLS_CC)) RETURN_FALSE;
		l4OutSizeRaw = (int32_t)Z_LVAL_P(zl4OutSize);
		SBCheckError(TElBuiltInSymmetricCrypto_FinalizeDecryption(SBGetObjectHandle(getThis() TSRMLS_CC), piOutBuffer.data, &l4OutSizeRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piOutBuffer);
		ZVAL_LONG(zl4OutSize, (long)l4OutSizeRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, &integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInSymmetricCrypto, ClassType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBuiltInSymmetricCrypto_ClassType(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TClass_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInSymmetricCrypto, get_KeyMaterial)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBuiltInSymmetricCrypto_get_KeyMaterial(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomCryptoKey_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInSymmetricCrypto, set_KeyMaterial)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElCustomCryptoKey_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElBuiltInSymmetricCrypto_set_KeyMaterial(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCryptoKey)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInSymmetricCrypto, get_AssociatedData)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElBuiltInSymmetricCrypto_get_AssociatedData(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInSymmetricCrypto, set_AssociatedData)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElBuiltInSymmetricCrypto_set_AssociatedData(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInSymmetricCrypto, get_AssociatedDataSize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElBuiltInSymmetricCrypto_get_AssociatedDataSize(SBGetObjectHandle(getThis() TSRMLS_CC), &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInSymmetricCrypto, set_AssociatedDataSize)
{
	long l8Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l8Value) == SUCCESS)
	{
		SBCheckError(TElBuiltInSymmetricCrypto_set_AssociatedDataSize(SBGetObjectHandle(getThis() TSRMLS_CC), (int64_t)l8Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInSymmetricCrypto, get_PayloadSize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElBuiltInSymmetricCrypto_get_PayloadSize(SBGetObjectHandle(getThis() TSRMLS_CC), &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInSymmetricCrypto, set_PayloadSize)
{
	long l8Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l8Value) == SUCCESS)
	{
		SBCheckError(TElBuiltInSymmetricCrypto_set_PayloadSize(SBGetObjectHandle(getThis() TSRMLS_CC), (int64_t)l8Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInSymmetricCrypto, get_Nonce)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElBuiltInSymmetricCrypto_get_Nonce(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-266579429, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInSymmetricCrypto, set_Nonce)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElBuiltInSymmetricCrypto_set_Nonce(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInSymmetricCrypto, get_TagSize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElBuiltInSymmetricCrypto_get_TagSize(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInSymmetricCrypto, set_TagSize)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElBuiltInSymmetricCrypto_set_TagSize(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInSymmetricCrypto, get_Mode)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBBuiltInSymmetricCryptoModeRaw fOutResultRaw = 0;
		SBCheckError(TElBuiltInSymmetricCrypto_get_Mode(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInSymmetricCrypto, get_BlockSize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElBuiltInSymmetricCrypto_get_BlockSize(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInSymmetricCrypto, get_KeySize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElBuiltInSymmetricCrypto_get_KeySize(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInSymmetricCrypto, get_Padding)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBBuiltInSymmetricCipherPaddingRaw fOutResultRaw = 0;
		SBCheckError(TElBuiltInSymmetricCrypto_get_Padding(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInSymmetricCrypto, set_Padding)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElBuiltInSymmetricCrypto_set_Padding(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBBuiltInSymmetricCipherPaddingRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInSymmetricCrypto, get_CTRLittleEndian)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElBuiltInSymmetricCrypto_get_CTRLittleEndian(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInSymmetricCrypto, set_CTRLittleEndian)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElBuiltInSymmetricCrypto_set_CTRLittleEndian(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInSymmetricCrypto, get_IsStreamCipher)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElBuiltInSymmetricCrypto_get_IsStreamCipher(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInSymmetricCrypto, get_OnProgress)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBProgressEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElBuiltInSymmetricCrypto_get_OnProgress(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInSymmetricCrypto, set_OnProgress)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElBuiltInSymmetricCrypto_set_OnProgress(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBProgressEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBProgressEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInSymmetricCrypto, __construct)
{
	long fMode;
	long l4AlgID;
	SBArrayZValInfo aiAlgOID;
	zval *zaAlgOID;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &l4AlgID, &fMode) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBuiltInSymmetricCrypto_Create((int32_t)l4AlgID, (TSBBuiltInSymmetricCryptoModeRaw)fMode, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zaAlgOID, &fMode) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaAlgOID)) || (IS_ARRAY == Z_TYPE_P(zaAlgOID)) || (IS_NULL == Z_TYPE_P(zaAlgOID))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetByteArrayFromZVal(zaAlgOID, &aiAlgOID TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElBuiltInSymmetricCrypto_Create_1(aiAlgOID.data, aiAlgOID.len, (TSBBuiltInSymmetricCryptoModeRaw)fMode, &hoOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiAlgOID);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fMode) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBuiltInSymmetricCrypto_Create_2((TSBBuiltInSymmetricCryptoModeRaw)fMode, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer) or (array of byte|string|NULL, integer) or (integer)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInSymmetricCrypto_InitializeEncryption, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInSymmetricCrypto_InitializeDecryption, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInSymmetricCrypto_Encrypt, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, InBuffer_or_InStream, 0, 1)
	ZEND_ARG_TYPE_INFO(0, InSize_or_OutStream, 0, 1)
	ZEND_ARG_TYPE_INFO(0, OutBuffer, 0, 1)
	ZEND_ARG_INFO(1, OutSize)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInSymmetricCrypto_EncryptUpdate, 0, 0, 4)
	ZEND_ARG_TYPE_INFO(0, InBuffer, 0, 1)
	ZEND_ARG_INFO(0, InSize)
	ZEND_ARG_TYPE_INFO(0, OutBuffer, 0, 1)
	ZEND_ARG_INFO(1, OutSize)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInSymmetricCrypto_FinalizeEncryption, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, OutBuffer, 0, 1)
	ZEND_ARG_INFO(1, OutSize)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInSymmetricCrypto_Decrypt, 0, 0, 3)
	ZEND_ARG_TYPE_INFO(0, InBuffer_or_InStream, 0, 1)
	ZEND_ARG_TYPE_INFO(0, InSize_or_OutStream, 0, 1)
	ZEND_ARG_TYPE_INFO(0, OutBuffer_or_InCount, 0, 1)
	ZEND_ARG_INFO(1, OutSize)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInSymmetricCrypto_DecryptUpdate, 0, 0, 4)
	ZEND_ARG_TYPE_INFO(0, InBuffer, 0, 1)
	ZEND_ARG_INFO(0, InSize)
	ZEND_ARG_TYPE_INFO(0, OutBuffer, 0, 1)
	ZEND_ARG_INFO(1, OutSize)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInSymmetricCrypto_FinalizeDecryption, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, OutBuffer, 0, 1)
	ZEND_ARG_INFO(1, OutSize)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInSymmetricCrypto_ClassType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInSymmetricCrypto_get_KeyMaterial, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInSymmetricCrypto_set_KeyMaterial, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElCustomCryptoKey, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInSymmetricCrypto_get_AssociatedData, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInSymmetricCrypto_set_AssociatedData, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInSymmetricCrypto_get_AssociatedDataSize, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInSymmetricCrypto_set_AssociatedDataSize, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInSymmetricCrypto_get_PayloadSize, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInSymmetricCrypto_set_PayloadSize, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInSymmetricCrypto_get_Nonce, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInSymmetricCrypto_set_Nonce, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInSymmetricCrypto_get_TagSize, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInSymmetricCrypto_set_TagSize, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInSymmetricCrypto_get_Mode, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInSymmetricCrypto_get_BlockSize, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInSymmetricCrypto_get_KeySize, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInSymmetricCrypto_get_Padding, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInSymmetricCrypto_set_Padding, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInSymmetricCrypto_get_CTRLittleEndian, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInSymmetricCrypto_set_CTRLittleEndian, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInSymmetricCrypto_get_IsStreamCipher, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInSymmetricCrypto_get_OnProgress, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInSymmetricCrypto_set_OnProgress, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInSymmetricCrypto___construct, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, AlgID_or_AlgOID_or_Mode, 0, 1)
	ZEND_ARG_INFO(0, Mode)
ZEND_END_ARG_INFO()

static zend_function_entry TElBuiltInSymmetricCrypto_methods[] = {
	PHP_ME(TElBuiltInSymmetricCrypto, InitializeEncryption, arginfo_TElBuiltInSymmetricCrypto_InitializeEncryption, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInSymmetricCrypto, InitializeDecryption, arginfo_TElBuiltInSymmetricCrypto_InitializeDecryption, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInSymmetricCrypto, Encrypt, arginfo_TElBuiltInSymmetricCrypto_Encrypt, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInSymmetricCrypto, EncryptUpdate, arginfo_TElBuiltInSymmetricCrypto_EncryptUpdate, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInSymmetricCrypto, FinalizeEncryption, arginfo_TElBuiltInSymmetricCrypto_FinalizeEncryption, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInSymmetricCrypto, Decrypt, arginfo_TElBuiltInSymmetricCrypto_Decrypt, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInSymmetricCrypto, DecryptUpdate, arginfo_TElBuiltInSymmetricCrypto_DecryptUpdate, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInSymmetricCrypto, FinalizeDecryption, arginfo_TElBuiltInSymmetricCrypto_FinalizeDecryption, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInSymmetricCrypto, ClassType, arginfo_TElBuiltInSymmetricCrypto_ClassType, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElBuiltInSymmetricCrypto, get_KeyMaterial, arginfo_TElBuiltInSymmetricCrypto_get_KeyMaterial, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInSymmetricCrypto, set_KeyMaterial, arginfo_TElBuiltInSymmetricCrypto_set_KeyMaterial, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInSymmetricCrypto, get_AssociatedData, arginfo_TElBuiltInSymmetricCrypto_get_AssociatedData, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInSymmetricCrypto, set_AssociatedData, arginfo_TElBuiltInSymmetricCrypto_set_AssociatedData, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInSymmetricCrypto, get_AssociatedDataSize, arginfo_TElBuiltInSymmetricCrypto_get_AssociatedDataSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInSymmetricCrypto, set_AssociatedDataSize, arginfo_TElBuiltInSymmetricCrypto_set_AssociatedDataSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInSymmetricCrypto, get_PayloadSize, arginfo_TElBuiltInSymmetricCrypto_get_PayloadSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInSymmetricCrypto, set_PayloadSize, arginfo_TElBuiltInSymmetricCrypto_set_PayloadSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInSymmetricCrypto, get_Nonce, arginfo_TElBuiltInSymmetricCrypto_get_Nonce, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInSymmetricCrypto, set_Nonce, arginfo_TElBuiltInSymmetricCrypto_set_Nonce, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInSymmetricCrypto, get_TagSize, arginfo_TElBuiltInSymmetricCrypto_get_TagSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInSymmetricCrypto, set_TagSize, arginfo_TElBuiltInSymmetricCrypto_set_TagSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInSymmetricCrypto, get_Mode, arginfo_TElBuiltInSymmetricCrypto_get_Mode, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInSymmetricCrypto, get_BlockSize, arginfo_TElBuiltInSymmetricCrypto_get_BlockSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInSymmetricCrypto, get_KeySize, arginfo_TElBuiltInSymmetricCrypto_get_KeySize, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInSymmetricCrypto, get_Padding, arginfo_TElBuiltInSymmetricCrypto_get_Padding, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInSymmetricCrypto, set_Padding, arginfo_TElBuiltInSymmetricCrypto_set_Padding, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInSymmetricCrypto, get_CTRLittleEndian, arginfo_TElBuiltInSymmetricCrypto_get_CTRLittleEndian, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInSymmetricCrypto, set_CTRLittleEndian, arginfo_TElBuiltInSymmetricCrypto_set_CTRLittleEndian, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInSymmetricCrypto, get_IsStreamCipher, arginfo_TElBuiltInSymmetricCrypto_get_IsStreamCipher, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInSymmetricCrypto, get_OnProgress, arginfo_TElBuiltInSymmetricCrypto_get_OnProgress, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInSymmetricCrypto, set_OnProgress, arginfo_TElBuiltInSymmetricCrypto_set_OnProgress, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInSymmetricCrypto, __construct, arginfo_TElBuiltInSymmetricCrypto___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElBuiltInSymmetricCrypto(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElBuiltInSymmetricCrypto_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElBuiltInSymmetricCrypto", TElBuiltInSymmetricCrypto_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElBuiltInSymmetricCrypto_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElBuiltInSymmetricCryptoFactory_ce_ptr = NULL;

SB_PHP_METHOD(TElBuiltInSymmetricCryptoFactory, RegisterClass)
{
	zval *oCls;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oCls, TElBuiltInSymmetricCryptoClass_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElBuiltInSymmetricCryptoFactory_RegisterClass(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oCls TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElBuiltInSymmetricCryptoClass)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInSymmetricCryptoFactory, CreateInstance)
{
	long fMode;
	long l4Alg;
	long l4MacAlg;
	SBArrayZValInfo aiOID;
	zval *zaOID;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zaOID, &fMode) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaOID)) || (IS_ARRAY == Z_TYPE_P(zaOID)) || (IS_NULL == Z_TYPE_P(zaOID))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetByteArrayFromZVal(zaOID, &aiOID TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElBuiltInSymmetricCryptoFactory_CreateInstance(SBGetObjectHandle(getThis() TSRMLS_CC), aiOID.data, aiOID.len, (TSBBuiltInSymmetricCryptoModeRaw)fMode, &hoOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiOID);
		SBInitObject(return_value, TElBuiltInSymmetricCrypto_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &l4Alg, &fMode) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBuiltInSymmetricCryptoFactory_CreateInstance_1(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Alg, (TSBBuiltInSymmetricCryptoModeRaw)fMode, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElBuiltInSymmetricCrypto_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lll", &l4Alg, &l4MacAlg, &fMode) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBuiltInSymmetricCryptoFactory_CreateInstance_2(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Alg, (int32_t)l4MacAlg, (TSBBuiltInSymmetricCryptoModeRaw)fMode, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElBuiltInSymmetricCrypto_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, integer) or (integer, integer) or (integer, integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInSymmetricCryptoFactory, IsAlgorithmSupported)
{
	long l4Alg;
	long l4MacAlg;
	SBArrayZValInfo aiOID;
	zval *zaOID;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaOID) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaOID)) || (IS_ARRAY == Z_TYPE_P(zaOID)) || (IS_NULL == Z_TYPE_P(zaOID))))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaOID, &aiOID TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElBuiltInSymmetricCryptoFactory_IsAlgorithmSupported(SBGetObjectHandle(getThis() TSRMLS_CC), aiOID.data, aiOID.len, &bOutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiOID);
		RETURN_BOOL(bOutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Alg) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElBuiltInSymmetricCryptoFactory_IsAlgorithmSupported_1(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Alg, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &l4Alg, &l4MacAlg) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElBuiltInSymmetricCryptoFactory_IsAlgorithmSupported_2(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Alg, (int32_t)l4MacAlg, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL) or (integer) or (integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInSymmetricCryptoFactory, GetDefaultKeyAndBlockLengths)
{
	int32_t l4BlockLenRaw;
	int32_t l4KeyLenRaw;
	long l4Alg;
	SBArrayZValInfo aiOID;
	zval *zaOID;
	zval *zl4BlockLen;
	zval *zl4KeyLen;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lzz", &l4Alg, &zl4KeyLen, &zl4BlockLen) == SUCCESS) && PZVAL_IS_REF(zl4KeyLen) && (IS_LONG == Z_TYPE_P(zl4KeyLen)) && PZVAL_IS_REF(zl4BlockLen) && (IS_LONG == Z_TYPE_P(zl4BlockLen)))
	{
		int8_t bOutResultRaw = 0;
		l4KeyLenRaw = (int32_t)Z_LVAL_P(zl4KeyLen);
		l4BlockLenRaw = (int32_t)Z_LVAL_P(zl4BlockLen);
		SBCheckError(TElBuiltInSymmetricCryptoFactory_GetDefaultKeyAndBlockLengths(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Alg, &l4KeyLenRaw, &l4BlockLenRaw, &bOutResultRaw) TSRMLS_CC);
		ZVAL_LONG(zl4KeyLen, (long)l4KeyLenRaw);
		ZVAL_LONG(zl4BlockLen, (long)l4BlockLenRaw);
		RETURN_BOOL(bOutResultRaw);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zzz", &zaOID, &zl4KeyLen, &zl4BlockLen) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaOID)) || (IS_ARRAY == Z_TYPE_P(zaOID)) || (IS_NULL == Z_TYPE_P(zaOID))) && PZVAL_IS_REF(zl4KeyLen) && (IS_LONG == Z_TYPE_P(zl4KeyLen)) && PZVAL_IS_REF(zl4BlockLen) && (IS_LONG == Z_TYPE_P(zl4BlockLen)))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaOID, &aiOID TSRMLS_CC)) RETURN_FALSE;
		l4KeyLenRaw = (int32_t)Z_LVAL_P(zl4KeyLen);
		l4BlockLenRaw = (int32_t)Z_LVAL_P(zl4BlockLen);
		SBCheckError(TElBuiltInSymmetricCryptoFactory_GetDefaultKeyAndBlockLengths_1(SBGetObjectHandle(getThis() TSRMLS_CC), aiOID.data, aiOID.len, &l4KeyLenRaw, &l4BlockLenRaw, &bOutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiOID);
		ZVAL_LONG(zl4KeyLen, (long)l4KeyLenRaw);
		ZVAL_LONG(zl4BlockLen, (long)l4BlockLenRaw);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer, &integer, &integer) or (array of byte|string|NULL, &integer, &integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInSymmetricCryptoFactory, get_RegisteredClasses)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBuiltInSymmetricCryptoFactory_get_RegisteredClasses(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElBuiltInSymmetricCryptoClass_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInSymmetricCryptoFactory, get_RegisteredClassCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElBuiltInSymmetricCryptoFactory_get_RegisteredClassCount(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInSymmetricCryptoFactory, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBuiltInSymmetricCryptoFactory_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInSymmetricCryptoFactory_RegisterClass, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Cls, TElBuiltInSymmetricCryptoClass, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInSymmetricCryptoFactory_CreateInstance, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, OID_or_Alg, 0, 1)
	ZEND_ARG_INFO(0, Mode_or_MacAlg)
	ZEND_ARG_INFO(0, Mode)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInSymmetricCryptoFactory_IsAlgorithmSupported, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, OID_or_Alg, 0, 1)
	ZEND_ARG_INFO(0, MacAlg)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInSymmetricCryptoFactory_GetDefaultKeyAndBlockLengths, 0, 0, 3)
	ZEND_ARG_TYPE_INFO(0, Alg_or_OID, 0, 1)
	ZEND_ARG_INFO(1, KeyLen)
	ZEND_ARG_INFO(1, BlockLen)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInSymmetricCryptoFactory_get_RegisteredClasses, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInSymmetricCryptoFactory_get_RegisteredClassCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInSymmetricCryptoFactory___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElBuiltInSymmetricCryptoFactory_methods[] = {
	PHP_ME(TElBuiltInSymmetricCryptoFactory, RegisterClass, arginfo_TElBuiltInSymmetricCryptoFactory_RegisterClass, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInSymmetricCryptoFactory, CreateInstance, arginfo_TElBuiltInSymmetricCryptoFactory_CreateInstance, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInSymmetricCryptoFactory, IsAlgorithmSupported, arginfo_TElBuiltInSymmetricCryptoFactory_IsAlgorithmSupported, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInSymmetricCryptoFactory, GetDefaultKeyAndBlockLengths, arginfo_TElBuiltInSymmetricCryptoFactory_GetDefaultKeyAndBlockLengths, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInSymmetricCryptoFactory, get_RegisteredClasses, arginfo_TElBuiltInSymmetricCryptoFactory_get_RegisteredClasses, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInSymmetricCryptoFactory, get_RegisteredClassCount, arginfo_TElBuiltInSymmetricCryptoFactory_get_RegisteredClassCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInSymmetricCryptoFactory, __construct, arginfo_TElBuiltInSymmetricCryptoFactory___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElBuiltInSymmetricCryptoFactory(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElBuiltInSymmetricCryptoFactory_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElBuiltInSymmetricCryptoFactory", TElBuiltInSymmetricCryptoFactory_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElBuiltInSymmetricCryptoFactory_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElBuiltInIdentitySymmetricCrypto_ce_ptr = NULL;

SB_PHP_METHOD(TElBuiltInIdentitySymmetricCrypto, ClassType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBuiltInIdentitySymmetricCrypto_ClassType(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TClass_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInIdentitySymmetricCrypto, __construct)
{
	long fMode;
	long l4AlgID;
	SBArrayZValInfo aiAlgOID;
	zval *zaAlgOID;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &l4AlgID, &fMode) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBuiltInIdentitySymmetricCrypto_Create((int32_t)l4AlgID, (TSBBuiltInSymmetricCryptoModeRaw)fMode, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zaAlgOID, &fMode) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaAlgOID)) || (IS_ARRAY == Z_TYPE_P(zaAlgOID)) || (IS_NULL == Z_TYPE_P(zaAlgOID))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetByteArrayFromZVal(zaAlgOID, &aiAlgOID TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElBuiltInIdentitySymmetricCrypto_Create_1(aiAlgOID.data, aiAlgOID.len, (TSBBuiltInSymmetricCryptoModeRaw)fMode, &hoOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiAlgOID);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fMode) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBuiltInIdentitySymmetricCrypto_Create_2((TSBBuiltInSymmetricCryptoModeRaw)fMode, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer) or (array of byte|string|NULL, integer) or (integer)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInIdentitySymmetricCrypto_ClassType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInIdentitySymmetricCrypto___construct, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, AlgID_or_AlgOID_or_Mode, 0, 1)
	ZEND_ARG_INFO(0, Mode)
ZEND_END_ARG_INFO()

static zend_function_entry TElBuiltInIdentitySymmetricCrypto_methods[] = {
	PHP_ME(TElBuiltInIdentitySymmetricCrypto, ClassType, arginfo_TElBuiltInIdentitySymmetricCrypto_ClassType, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElBuiltInIdentitySymmetricCrypto, __construct, arginfo_TElBuiltInIdentitySymmetricCrypto___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElBuiltInIdentitySymmetricCrypto(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElBuiltInIdentitySymmetricCrypto_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElBuiltInIdentitySymmetricCrypto", TElBuiltInIdentitySymmetricCrypto_methods);
	if (NULL == TElBuiltInSymmetricCrypto_ce_ptr)
		Register_TElBuiltInSymmetricCrypto(TSRMLS_C);
	TElBuiltInIdentitySymmetricCrypto_ce_ptr = zend_register_internal_class_ex(&ce, TElBuiltInSymmetricCrypto_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElBuiltInRC4SymmetricCrypto_ce_ptr = NULL;

SB_PHP_METHOD(TElBuiltInRC4SymmetricCrypto, InitializeEncryption)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElBuiltInRC4SymmetricCrypto_InitializeEncryption(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInRC4SymmetricCrypto, InitializeDecryption)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElBuiltInRC4SymmetricCrypto_InitializeDecryption(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInRC4SymmetricCrypto, ClassType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBuiltInRC4SymmetricCrypto_ClassType(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TClass_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInRC4SymmetricCrypto, get_SkipKeystreamBytes)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElBuiltInRC4SymmetricCrypto_get_SkipKeystreamBytes(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInRC4SymmetricCrypto, set_SkipKeystreamBytes)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElBuiltInRC4SymmetricCrypto_set_SkipKeystreamBytes(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInRC4SymmetricCrypto, __construct)
{
	long fMode;
	long l4AlgID;
	SBArrayZValInfo aiAlgOID;
	zval *zaAlgOID;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &l4AlgID, &fMode) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBuiltInRC4SymmetricCrypto_Create((int32_t)l4AlgID, (TSBBuiltInSymmetricCryptoModeRaw)fMode, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zaAlgOID, &fMode) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaAlgOID)) || (IS_ARRAY == Z_TYPE_P(zaAlgOID)) || (IS_NULL == Z_TYPE_P(zaAlgOID))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetByteArrayFromZVal(zaAlgOID, &aiAlgOID TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElBuiltInRC4SymmetricCrypto_Create_1(aiAlgOID.data, aiAlgOID.len, (TSBBuiltInSymmetricCryptoModeRaw)fMode, &hoOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiAlgOID);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fMode) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBuiltInRC4SymmetricCrypto_Create_2((TSBBuiltInSymmetricCryptoModeRaw)fMode, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer) or (array of byte|string|NULL, integer) or (integer)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInRC4SymmetricCrypto_InitializeEncryption, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInRC4SymmetricCrypto_InitializeDecryption, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInRC4SymmetricCrypto_ClassType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInRC4SymmetricCrypto_get_SkipKeystreamBytes, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInRC4SymmetricCrypto_set_SkipKeystreamBytes, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInRC4SymmetricCrypto___construct, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, AlgID_or_AlgOID_or_Mode, 0, 1)
	ZEND_ARG_INFO(0, Mode)
ZEND_END_ARG_INFO()

static zend_function_entry TElBuiltInRC4SymmetricCrypto_methods[] = {
	PHP_ME(TElBuiltInRC4SymmetricCrypto, InitializeEncryption, arginfo_TElBuiltInRC4SymmetricCrypto_InitializeEncryption, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInRC4SymmetricCrypto, InitializeDecryption, arginfo_TElBuiltInRC4SymmetricCrypto_InitializeDecryption, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInRC4SymmetricCrypto, ClassType, arginfo_TElBuiltInRC4SymmetricCrypto_ClassType, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElBuiltInRC4SymmetricCrypto, get_SkipKeystreamBytes, arginfo_TElBuiltInRC4SymmetricCrypto_get_SkipKeystreamBytes, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInRC4SymmetricCrypto, set_SkipKeystreamBytes, arginfo_TElBuiltInRC4SymmetricCrypto_set_SkipKeystreamBytes, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInRC4SymmetricCrypto, __construct, arginfo_TElBuiltInRC4SymmetricCrypto___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElBuiltInRC4SymmetricCrypto(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElBuiltInRC4SymmetricCrypto_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElBuiltInRC4SymmetricCrypto", TElBuiltInRC4SymmetricCrypto_methods);
	if (NULL == TElBuiltInSymmetricCrypto_ce_ptr)
		Register_TElBuiltInSymmetricCrypto(TSRMLS_C);
	TElBuiltInRC4SymmetricCrypto_ce_ptr = zend_register_internal_class_ex(&ce, TElBuiltInSymmetricCrypto_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElBuiltInGOST28147SymmetricCrypto_ce_ptr = NULL;

SB_PHP_METHOD(TElBuiltInGOST28147SymmetricCrypto, ClassType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBuiltInGOST28147SymmetricCrypto_ClassType(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TClass_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInGOST28147SymmetricCrypto, set_ParamSet)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElBuiltInGOST28147SymmetricCrypto_set_ParamSet(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInGOST28147SymmetricCrypto, set_SBoxes)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElBuiltInGOST28147SymmetricCrypto_set_SBoxes(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInGOST28147SymmetricCrypto, get_UseKeyMeshing)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElBuiltInGOST28147SymmetricCrypto_get_UseKeyMeshing(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInGOST28147SymmetricCrypto, set_UseKeyMeshing)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElBuiltInGOST28147SymmetricCrypto_set_UseKeyMeshing(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInGOST28147SymmetricCrypto, __construct)
{
	long fMode;
	long l4AlgID;
	SBArrayZValInfo aiAlgOID;
	zval *zaAlgOID;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &l4AlgID, &fMode) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBuiltInGOST28147SymmetricCrypto_Create((int32_t)l4AlgID, (TSBBuiltInSymmetricCryptoModeRaw)fMode, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zaAlgOID, &fMode) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaAlgOID)) || (IS_ARRAY == Z_TYPE_P(zaAlgOID)) || (IS_NULL == Z_TYPE_P(zaAlgOID))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetByteArrayFromZVal(zaAlgOID, &aiAlgOID TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElBuiltInGOST28147SymmetricCrypto_Create_1(aiAlgOID.data, aiAlgOID.len, (TSBBuiltInSymmetricCryptoModeRaw)fMode, &hoOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiAlgOID);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fMode) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBuiltInGOST28147SymmetricCrypto_Create_2((TSBBuiltInSymmetricCryptoModeRaw)fMode, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer) or (array of byte|string|NULL, integer) or (integer)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInGOST28147SymmetricCrypto_ClassType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInGOST28147SymmetricCrypto_set_ParamSet, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInGOST28147SymmetricCrypto_set_SBoxes, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInGOST28147SymmetricCrypto_get_UseKeyMeshing, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInGOST28147SymmetricCrypto_set_UseKeyMeshing, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInGOST28147SymmetricCrypto___construct, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, AlgID_or_AlgOID_or_Mode, 0, 1)
	ZEND_ARG_INFO(0, Mode)
ZEND_END_ARG_INFO()

static zend_function_entry TElBuiltInGOST28147SymmetricCrypto_methods[] = {
	PHP_ME(TElBuiltInGOST28147SymmetricCrypto, ClassType, arginfo_TElBuiltInGOST28147SymmetricCrypto_ClassType, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElBuiltInGOST28147SymmetricCrypto, set_ParamSet, arginfo_TElBuiltInGOST28147SymmetricCrypto_set_ParamSet, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInGOST28147SymmetricCrypto, set_SBoxes, arginfo_TElBuiltInGOST28147SymmetricCrypto_set_SBoxes, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInGOST28147SymmetricCrypto, get_UseKeyMeshing, arginfo_TElBuiltInGOST28147SymmetricCrypto_get_UseKeyMeshing, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInGOST28147SymmetricCrypto, set_UseKeyMeshing, arginfo_TElBuiltInGOST28147SymmetricCrypto_set_UseKeyMeshing, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInGOST28147SymmetricCrypto, __construct, arginfo_TElBuiltInGOST28147SymmetricCrypto___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElBuiltInGOST28147SymmetricCrypto(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElBuiltInGOST28147SymmetricCrypto_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElBuiltInGOST28147SymmetricCrypto", TElBuiltInGOST28147SymmetricCrypto_methods);
	if (NULL == TElBuiltInSymmetricCrypto_ce_ptr)
		Register_TElBuiltInSymmetricCrypto(TSRMLS_C);
	TElBuiltInGOST28147SymmetricCrypto_ce_ptr = zend_register_internal_class_ex(&ce, TElBuiltInSymmetricCrypto_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElBuiltInChaCha20SymmetricCrypto_ce_ptr = NULL;

SB_PHP_METHOD(TElBuiltInChaCha20SymmetricCrypto, ClassType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBuiltInChaCha20SymmetricCrypto_ClassType(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TClass_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInChaCha20SymmetricCrypto, get_Counter)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint32_t u4OutResultRaw = 0;
		SBCheckError(TElBuiltInChaCha20SymmetricCrypto_get_Counter(SBGetObjectHandle(getThis() TSRMLS_CC), &u4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInChaCha20SymmetricCrypto, set_Counter)
{
	long u4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u4Value) == SUCCESS)
	{
		SBCheckError(TElBuiltInChaCha20SymmetricCrypto_set_Counter(SBGetObjectHandle(getThis() TSRMLS_CC), (uint32_t)u4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInChaCha20SymmetricCrypto, __construct)
{
	long fMode;
	long l4AlgID;
	SBArrayZValInfo aiAlgOID;
	zval *zaAlgOID;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &l4AlgID, &fMode) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBuiltInChaCha20SymmetricCrypto_Create((int32_t)l4AlgID, (TSBBuiltInSymmetricCryptoModeRaw)fMode, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zaAlgOID, &fMode) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaAlgOID)) || (IS_ARRAY == Z_TYPE_P(zaAlgOID)) || (IS_NULL == Z_TYPE_P(zaAlgOID))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetByteArrayFromZVal(zaAlgOID, &aiAlgOID TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElBuiltInChaCha20SymmetricCrypto_Create_1(aiAlgOID.data, aiAlgOID.len, (TSBBuiltInSymmetricCryptoModeRaw)fMode, &hoOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiAlgOID);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fMode) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBuiltInChaCha20SymmetricCrypto_Create_2((TSBBuiltInSymmetricCryptoModeRaw)fMode, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer) or (array of byte|string|NULL, integer) or (integer)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInChaCha20SymmetricCrypto_ClassType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInChaCha20SymmetricCrypto_get_Counter, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInChaCha20SymmetricCrypto_set_Counter, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInChaCha20SymmetricCrypto___construct, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, AlgID_or_AlgOID_or_Mode, 0, 1)
	ZEND_ARG_INFO(0, Mode)
ZEND_END_ARG_INFO()

static zend_function_entry TElBuiltInChaCha20SymmetricCrypto_methods[] = {
	PHP_ME(TElBuiltInChaCha20SymmetricCrypto, ClassType, arginfo_TElBuiltInChaCha20SymmetricCrypto_ClassType, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElBuiltInChaCha20SymmetricCrypto, get_Counter, arginfo_TElBuiltInChaCha20SymmetricCrypto_get_Counter, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInChaCha20SymmetricCrypto, set_Counter, arginfo_TElBuiltInChaCha20SymmetricCrypto_set_Counter, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInChaCha20SymmetricCrypto, __construct, arginfo_TElBuiltInChaCha20SymmetricCrypto___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElBuiltInChaCha20SymmetricCrypto(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElBuiltInChaCha20SymmetricCrypto_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElBuiltInChaCha20SymmetricCrypto", TElBuiltInChaCha20SymmetricCrypto_methods);
	if (NULL == TElBuiltInSymmetricCrypto_ce_ptr)
		Register_TElBuiltInSymmetricCrypto(TSRMLS_C);
	TElBuiltInChaCha20SymmetricCrypto_ce_ptr = zend_register_internal_class_ex(&ce, TElBuiltInSymmetricCrypto_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElBuiltInAEADChaCha20Poly1305SymmetricCrypto_ce_ptr = NULL;

SB_PHP_METHOD(TElBuiltInAEADChaCha20Poly1305SymmetricCrypto, ClassType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBuiltInAEADChaCha20Poly1305SymmetricCrypto_ClassType(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TClass_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInAEADChaCha20Poly1305SymmetricCrypto, get_AAD)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElBuiltInAEADChaCha20Poly1305SymmetricCrypto_get_AAD(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(596947906, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInAEADChaCha20Poly1305SymmetricCrypto, set_AAD)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElBuiltInAEADChaCha20Poly1305SymmetricCrypto_set_AAD(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInAEADChaCha20Poly1305SymmetricCrypto, get_Tag)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBPoly1305Tag roOutResult;
		SBCheckError(TElBuiltInAEADChaCha20Poly1305SymmetricCrypto_get_Tag(SBGetObjectHandle(getThis() TSRMLS_CC), &roOutResult) TSRMLS_CC);
		object_init_ex(return_value, TSBPoly1305Tag_ce_ptr);
		SBSetStruct(return_value, &roOutResult, sizeof(TSBPoly1305Tag) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInAEADChaCha20Poly1305SymmetricCrypto, set_Tag)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &oValue, TSBPoly1305Tag_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElBuiltInAEADChaCha20Poly1305SymmetricCrypto_set_Tag(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBPoly1305Tag *)SBGetStructPointer(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPoly1305Tag)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInAEADChaCha20Poly1305SymmetricCrypto, get_Poly1305Mode)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBPoly1305ModeRaw fOutResultRaw = 0;
		SBCheckError(TElBuiltInAEADChaCha20Poly1305SymmetricCrypto_get_Poly1305Mode(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInAEADChaCha20Poly1305SymmetricCrypto, set_Poly1305Mode)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElBuiltInAEADChaCha20Poly1305SymmetricCrypto_set_Poly1305Mode(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBPoly1305ModeRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInAEADChaCha20Poly1305SymmetricCrypto, __construct)
{
	long fMode;
	long l4AlgID;
	SBArrayZValInfo aiAlgOID;
	zval *zaAlgOID;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &l4AlgID, &fMode) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBuiltInAEADChaCha20Poly1305SymmetricCrypto_Create((int32_t)l4AlgID, (TSBBuiltInSymmetricCryptoModeRaw)fMode, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zaAlgOID, &fMode) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaAlgOID)) || (IS_ARRAY == Z_TYPE_P(zaAlgOID)) || (IS_NULL == Z_TYPE_P(zaAlgOID))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetByteArrayFromZVal(zaAlgOID, &aiAlgOID TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElBuiltInAEADChaCha20Poly1305SymmetricCrypto_Create_1(aiAlgOID.data, aiAlgOID.len, (TSBBuiltInSymmetricCryptoModeRaw)fMode, &hoOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiAlgOID);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fMode) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBuiltInAEADChaCha20Poly1305SymmetricCrypto_Create_2((TSBBuiltInSymmetricCryptoModeRaw)fMode, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer) or (array of byte|string|NULL, integer) or (integer)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInAEADChaCha20Poly1305SymmetricCrypto_ClassType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInAEADChaCha20Poly1305SymmetricCrypto_get_AAD, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInAEADChaCha20Poly1305SymmetricCrypto_set_AAD, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInAEADChaCha20Poly1305SymmetricCrypto_get_Tag, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInAEADChaCha20Poly1305SymmetricCrypto_set_Tag, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TSBPoly1305Tag, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInAEADChaCha20Poly1305SymmetricCrypto_get_Poly1305Mode, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInAEADChaCha20Poly1305SymmetricCrypto_set_Poly1305Mode, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInAEADChaCha20Poly1305SymmetricCrypto___construct, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, AlgID_or_AlgOID_or_Mode, 0, 1)
	ZEND_ARG_INFO(0, Mode)
ZEND_END_ARG_INFO()

static zend_function_entry TElBuiltInAEADChaCha20Poly1305SymmetricCrypto_methods[] = {
	PHP_ME(TElBuiltInAEADChaCha20Poly1305SymmetricCrypto, ClassType, arginfo_TElBuiltInAEADChaCha20Poly1305SymmetricCrypto_ClassType, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElBuiltInAEADChaCha20Poly1305SymmetricCrypto, get_AAD, arginfo_TElBuiltInAEADChaCha20Poly1305SymmetricCrypto_get_AAD, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInAEADChaCha20Poly1305SymmetricCrypto, set_AAD, arginfo_TElBuiltInAEADChaCha20Poly1305SymmetricCrypto_set_AAD, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInAEADChaCha20Poly1305SymmetricCrypto, get_Tag, arginfo_TElBuiltInAEADChaCha20Poly1305SymmetricCrypto_get_Tag, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInAEADChaCha20Poly1305SymmetricCrypto, set_Tag, arginfo_TElBuiltInAEADChaCha20Poly1305SymmetricCrypto_set_Tag, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInAEADChaCha20Poly1305SymmetricCrypto, get_Poly1305Mode, arginfo_TElBuiltInAEADChaCha20Poly1305SymmetricCrypto_get_Poly1305Mode, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInAEADChaCha20Poly1305SymmetricCrypto, set_Poly1305Mode, arginfo_TElBuiltInAEADChaCha20Poly1305SymmetricCrypto_set_Poly1305Mode, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInAEADChaCha20Poly1305SymmetricCrypto, __construct, arginfo_TElBuiltInAEADChaCha20Poly1305SymmetricCrypto___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElBuiltInAEADChaCha20Poly1305SymmetricCrypto(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElBuiltInAEADChaCha20Poly1305SymmetricCrypto_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElBuiltInAEADChaCha20Poly1305SymmetricCrypto", TElBuiltInAEADChaCha20Poly1305SymmetricCrypto_methods);
	if (NULL == TElBuiltInSymmetricCrypto_ce_ptr)
		Register_TElBuiltInSymmetricCrypto(TSRMLS_C);
	TElBuiltInAEADChaCha20Poly1305SymmetricCrypto_ce_ptr = zend_register_internal_class_ex(&ce, TElBuiltInSymmetricCrypto_ce_ptr, NULL TSRMLS_CC);
}

void Register_SBCryptoProvBuiltInSym_Constants(int module_number TSRMLS_DC)
{
	SB_REGISTER_LONG_CONSTANT(SBCryptoProvBuiltInSym, SYMMETRIC_BLOCK_SIZE, SB_SYMMETRIC_BLOCK_SIZE, SB_SYMMETRIC_BLOCK_SIZE);
	
}

void Register_SBCryptoProvBuiltInSym_Enum_Flags(TSRMLS_D)
{
	zend_class_entry ce;
	INIT_CLASS_ENTRY(ce, "TSBBuiltInSymmetricCryptoMode", NULL);
	TSBBuiltInSymmetricCryptoMode_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBBuiltInSymmetricCryptoMode_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBBuiltInSymmetricCryptoMode_ce_ptr, "cmDefault", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBBuiltInSymmetricCryptoMode_ce_ptr, "cmECB", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBBuiltInSymmetricCryptoMode_ce_ptr, "cmCBC", 2)
	SB_DECLARE_CLASS_LONG_CONST(TSBBuiltInSymmetricCryptoMode_ce_ptr, "cmCTR", 3)
	SB_DECLARE_CLASS_LONG_CONST(TSBBuiltInSymmetricCryptoMode_ce_ptr, "cmCFB8", 4)
	SB_DECLARE_CLASS_LONG_CONST(TSBBuiltInSymmetricCryptoMode_ce_ptr, "cmCCM", 5)
	SB_DECLARE_CLASS_LONG_CONST(TSBBuiltInSymmetricCryptoMode_ce_ptr, "cmGCM", 6)
	SB_DECLARE_CLASS_LONG_CONST(TSBBuiltInSymmetricCryptoMode_ce_ptr, "cmAEADChaCha20Poly1305", 7)
	
	INIT_CLASS_ENTRY(ce, "TSBBuiltInSymmetricCipherPadding", NULL);
	TSBBuiltInSymmetricCipherPadding_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBBuiltInSymmetricCipherPadding_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBBuiltInSymmetricCipherPadding_ce_ptr, "cpNone", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBBuiltInSymmetricCipherPadding_ce_ptr, "cpPKCS5", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBBuiltInSymmetricCipherPadding_ce_ptr, "cpANSIX923", 2)
	
	INIT_CLASS_ENTRY(ce, "TSBBuiltInSymmetricCryptoOperation", NULL);
	TSBBuiltInSymmetricCryptoOperation_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBBuiltInSymmetricCryptoOperation_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBBuiltInSymmetricCryptoOperation_ce_ptr, "coNone", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBBuiltInSymmetricCryptoOperation_ce_ptr, "coEncryption", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBBuiltInSymmetricCryptoOperation_ce_ptr, "coDecryption", 2)
}

void Register_SBCryptoProvBuiltInSym_Aliases(TSRMLS_D)
{
	TElBuiltInSymmetricCryptoClass_ce_ptr = TObject_ce_ptr;
	zend_register_class_alias("TElBuiltInSymmetricCryptoClass", TElBuiltInSymmetricCryptoClass_ce_ptr);
}

