#include "sbdomainkeys.h"

zend_class_entry *TSBDKPublicKeyType_ce_ptr = NULL;

zend_class_entry *TSBDKCanonicalizationAlgorithm_ce_ptr = NULL;

zend_class_entry *TSBDKDigestAlgorithm_ce_ptr = NULL;

zend_class_entry *TSBDKQueryType_ce_ptr = NULL;

zend_class_entry *TSBDKStatus_ce_ptr = NULL;

zend_class_entry *TSBDomainKeysVerifierState_ce_ptr = NULL;

zend_class_entry *TSBDomainKeysVerifierSignature_ce_ptr = NULL;

zend_class_entry *TSBDomainKeysSignerState_ce_ptr = NULL;

zend_class_entry *TElDKPublicKey_ce_ptr = NULL;

SB_PHP_METHOD(TElDKPublicKey, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElDKPublicKey_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDKPublicKey, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElDKPublicKey_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDKPublicKey, Clone)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDKPublicKey_Clone(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElDKPublicKey_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDKPublicKey, Revoke)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElDKPublicKey_Revoke(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDKPublicKey, Load)
{
	char *sData;
	int sData_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sData, &sData_len) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElDKPublicKey_Load(SBGetObjectHandle(getThis() TSRMLS_CC), sData, (int32_t)sData_len, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDKPublicKey, Save)
{
	char *sData = NULL;
	int32_t sData_len = 0;
	uint32_t _err;
	zval *zsData;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zsData) == SUCCESS) && PZVAL_IS_REF(zsData) && (IS_STRING == Z_TYPE_P(zsData)))
	{
		int8_t bOutResultRaw = 0;
		_err = TElDKPublicKey_Save(SBGetObjectHandle(getThis() TSRMLS_CC), sData, &sData_len, &bOutResultRaw);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sData = emalloc(sData_len + 1);
			SBCheckError(SBGetLastReturnStringA(1391538933, 1, sData, &sData_len) TSRMLS_CC);
			zval_dtor(zsData);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		sData[sData_len] = 0;
		ZVAL_STRINGL(zsData, sData, sData_len, 0);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(&string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDKPublicKey, get_Available)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElDKPublicKey_get_Available(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDKPublicKey, get_KeyType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBDKPublicKeyTypeRaw fOutResultRaw = 0;
		SBCheckError(TElDKPublicKey_get_KeyType(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDKPublicKey, get_Revoked)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElDKPublicKey_get_Revoked(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDKPublicKey, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDKPublicKey_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDKPublicKey_Assign, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Source, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDKPublicKey_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDKPublicKey_Clone, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDKPublicKey_Revoke, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDKPublicKey_Load, 0, 0, 1)
	ZEND_ARG_INFO(0, Data)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDKPublicKey_Save, 0, 0, 1)
	ZEND_ARG_INFO(1, Data)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDKPublicKey_get_Available, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDKPublicKey_get_KeyType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDKPublicKey_get_Revoked, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDKPublicKey___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElDKPublicKey_methods[] = {
	PHP_ME(TElDKPublicKey, Assign, arginfo_TElDKPublicKey_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElDKPublicKey, Clear, arginfo_TElDKPublicKey_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElDKPublicKey, Clone, arginfo_TElDKPublicKey_Clone, ZEND_ACC_PUBLIC)
	PHP_ME(TElDKPublicKey, Revoke, arginfo_TElDKPublicKey_Revoke, ZEND_ACC_PUBLIC)
	PHP_ME(TElDKPublicKey, Load, arginfo_TElDKPublicKey_Load, ZEND_ACC_PUBLIC)
	PHP_ME(TElDKPublicKey, Save, arginfo_TElDKPublicKey_Save, ZEND_ACC_PUBLIC)
	PHP_ME(TElDKPublicKey, get_Available, arginfo_TElDKPublicKey_get_Available, ZEND_ACC_PUBLIC)
	PHP_ME(TElDKPublicKey, get_KeyType, arginfo_TElDKPublicKey_get_KeyType, ZEND_ACC_PUBLIC)
	PHP_ME(TElDKPublicKey, get_Revoked, arginfo_TElDKPublicKey_get_Revoked, ZEND_ACC_PUBLIC)
	PHP_ME(TElDKPublicKey, __construct, arginfo_TElDKPublicKey___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElDKPublicKey(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElDKPublicKey_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElDKPublicKey", TElDKPublicKey_methods);
	if (NULL == TPersistent_ce_ptr)
		Register_TPersistent(TSRMLS_C);
	TElDKPublicKey_ce_ptr = zend_register_internal_class_ex(&ce, TPersistent_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElDKRSAPublicKey_ce_ptr = NULL;

SB_PHP_METHOD(TElDKRSAPublicKey, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElDKRSAPublicKey_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDKRSAPublicKey, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElDKRSAPublicKey_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDKRSAPublicKey, Clone)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDKRSAPublicKey_Clone(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElDKPublicKey_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDKRSAPublicKey, Generate)
{
	long l4Bits;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Bits) == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElDKRSAPublicKey_Generate(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Bits, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(1402597984, 2, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDKRSAPublicKey, Load)
{
	char *sData;
	int sData_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sData, &sData_len) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElDKRSAPublicKey_Load(SBGetObjectHandle(getThis() TSRMLS_CC), sData, (int32_t)sData_len, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDKRSAPublicKey, Save)
{
	char *sData = NULL;
	int32_t sData_len = 0;
	uint32_t _err;
	zval *zsData;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zsData) == SUCCESS) && PZVAL_IS_REF(zsData) && (IS_STRING == Z_TYPE_P(zsData)))
	{
		int8_t bOutResultRaw = 0;
		_err = TElDKRSAPublicKey_Save(SBGetObjectHandle(getThis() TSRMLS_CC), sData, &sData_len, &bOutResultRaw);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sData = emalloc(sData_len + 1);
			SBCheckError(SBGetLastReturnStringA(1412850845, 1, sData, &sData_len) TSRMLS_CC);
			zval_dtor(zsData);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		sData[sData_len] = 0;
		ZVAL_STRINGL(zsData, sData, sData_len, 0);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(&string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDKRSAPublicKey, get_Exponent)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElDKRSAPublicKey_get_Exponent(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(448895909, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDKRSAPublicKey, get_Modulus)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElDKRSAPublicKey_get_Modulus(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-1225291653, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDKRSAPublicKey, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDKRSAPublicKey_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDKRSAPublicKey_Assign, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Source, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDKRSAPublicKey_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDKRSAPublicKey_Clone, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDKRSAPublicKey_Generate, 0, 0, 1)
	ZEND_ARG_INFO(0, Bits)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDKRSAPublicKey_Load, 0, 0, 1)
	ZEND_ARG_INFO(0, Data)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDKRSAPublicKey_Save, 0, 0, 1)
	ZEND_ARG_INFO(1, Data)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDKRSAPublicKey_get_Exponent, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDKRSAPublicKey_get_Modulus, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDKRSAPublicKey___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElDKRSAPublicKey_methods[] = {
	PHP_ME(TElDKRSAPublicKey, Assign, arginfo_TElDKRSAPublicKey_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElDKRSAPublicKey, Clear, arginfo_TElDKRSAPublicKey_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElDKRSAPublicKey, Clone, arginfo_TElDKRSAPublicKey_Clone, ZEND_ACC_PUBLIC)
	PHP_ME(TElDKRSAPublicKey, Generate, arginfo_TElDKRSAPublicKey_Generate, ZEND_ACC_PUBLIC)
	PHP_ME(TElDKRSAPublicKey, Load, arginfo_TElDKRSAPublicKey_Load, ZEND_ACC_PUBLIC)
	PHP_ME(TElDKRSAPublicKey, Save, arginfo_TElDKRSAPublicKey_Save, ZEND_ACC_PUBLIC)
	PHP_ME(TElDKRSAPublicKey, get_Exponent, arginfo_TElDKRSAPublicKey_get_Exponent, ZEND_ACC_PUBLIC)
	PHP_ME(TElDKRSAPublicKey, get_Modulus, arginfo_TElDKRSAPublicKey_get_Modulus, ZEND_ACC_PUBLIC)
	PHP_ME(TElDKRSAPublicKey, __construct, arginfo_TElDKRSAPublicKey___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElDKRSAPublicKey(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElDKRSAPublicKey_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElDKRSAPublicKey", TElDKRSAPublicKey_methods);
	if (NULL == TElDKPublicKey_ce_ptr)
		Register_TElDKPublicKey(TSRMLS_C);
	TElDKRSAPublicKey_ce_ptr = zend_register_internal_class_ex(&ce, TElDKPublicKey_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElDKDNSRecord_ce_ptr = NULL;

SB_PHP_METHOD(TElDKDNSRecord, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElDKDNSRecord_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDKDNSRecord, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElDKDNSRecord_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDKDNSRecord, CreatePublicKey)
{
	long fKeyType;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fKeyType) == SUCCESS)
	{
		SBCheckError(TElDKDNSRecord_CreatePublicKey(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBDKPublicKeyTypeRaw)fKeyType) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDKDNSRecord, Load)
{
	char *sData;
	int sData_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sData, &sData_len) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElDKDNSRecord_Load(SBGetObjectHandle(getThis() TSRMLS_CC), sData, (int32_t)sData_len, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDKDNSRecord, Save)
{
	char *sData = NULL;
	int32_t sData_len = 0;
	uint32_t _err;
	zval *zsData;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zsData) == SUCCESS) && PZVAL_IS_REF(zsData) && (IS_STRING == Z_TYPE_P(zsData)))
	{
		int32_t l4OutResultRaw = 0;
		_err = TElDKDNSRecord_Save(SBGetObjectHandle(getThis() TSRMLS_CC), sData, &sData_len, &l4OutResultRaw);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sData = emalloc(sData_len + 1);
			SBCheckError(SBGetLastReturnStringA(1753240923, 1, sData, &sData_len) TSRMLS_CC);
			zval_dtor(zsData);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		sData[sData_len] = 0;
		ZVAL_STRINGL(zsData, sData, sData_len, 0);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(&string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDKDNSRecord, get_KeyGranularity)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElDKDNSRecord_get_KeyGranularity(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1477654382, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDKDNSRecord, set_KeyGranularity)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElDKDNSRecord_set_KeyGranularity(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDKDNSRecord, get_Notes)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElDKDNSRecord_get_Notes(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1521855507, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDKDNSRecord, set_Notes)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElDKDNSRecord_set_Notes(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDKDNSRecord, get_PublicKey)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDKDNSRecord_get_PublicKey(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElDKPublicKey_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDKDNSRecord, get_TestMode)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElDKDNSRecord_get_TestMode(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDKDNSRecord, set_TestMode)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElDKDNSRecord_set_TestMode(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDKDNSRecord, get_ExactMode)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElDKDNSRecord_get_ExactMode(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDKDNSRecord, set_ExactMode)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElDKDNSRecord_set_ExactMode(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDKDNSRecord, get_ServiceType)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElDKDNSRecord_get_ServiceType(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(480882064, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDKDNSRecord, set_ServiceType)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElDKDNSRecord_set_ServiceType(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDKDNSRecord, get_Version)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElDKDNSRecord_get_Version(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1341405464, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDKDNSRecord, set_Version)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElDKDNSRecord_set_Version(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDKDNSRecord, get_Algorithms)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElDKDNSRecord_get_Algorithms(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-570706960, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDKDNSRecord, set_Algorithms)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElDKDNSRecord_set_Algorithms(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDKDNSRecord, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDKDNSRecord_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDKDNSRecord_Assign, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Source, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDKDNSRecord_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDKDNSRecord_CreatePublicKey, 0, 0, 1)
	ZEND_ARG_INFO(0, KeyType)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDKDNSRecord_Load, 0, 0, 1)
	ZEND_ARG_INFO(0, Data)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDKDNSRecord_Save, 0, 0, 1)
	ZEND_ARG_INFO(1, Data)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDKDNSRecord_get_KeyGranularity, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDKDNSRecord_set_KeyGranularity, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDKDNSRecord_get_Notes, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDKDNSRecord_set_Notes, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDKDNSRecord_get_PublicKey, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDKDNSRecord_get_TestMode, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDKDNSRecord_set_TestMode, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDKDNSRecord_get_ExactMode, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDKDNSRecord_set_ExactMode, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDKDNSRecord_get_ServiceType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDKDNSRecord_set_ServiceType, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDKDNSRecord_get_Version, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDKDNSRecord_set_Version, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDKDNSRecord_get_Algorithms, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDKDNSRecord_set_Algorithms, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDKDNSRecord___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElDKDNSRecord_methods[] = {
	PHP_ME(TElDKDNSRecord, Assign, arginfo_TElDKDNSRecord_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElDKDNSRecord, Clear, arginfo_TElDKDNSRecord_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElDKDNSRecord, CreatePublicKey, arginfo_TElDKDNSRecord_CreatePublicKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElDKDNSRecord, Load, arginfo_TElDKDNSRecord_Load, ZEND_ACC_PUBLIC)
	PHP_ME(TElDKDNSRecord, Save, arginfo_TElDKDNSRecord_Save, ZEND_ACC_PUBLIC)
	PHP_ME(TElDKDNSRecord, get_KeyGranularity, arginfo_TElDKDNSRecord_get_KeyGranularity, ZEND_ACC_PUBLIC)
	PHP_ME(TElDKDNSRecord, set_KeyGranularity, arginfo_TElDKDNSRecord_set_KeyGranularity, ZEND_ACC_PUBLIC)
	PHP_ME(TElDKDNSRecord, get_Notes, arginfo_TElDKDNSRecord_get_Notes, ZEND_ACC_PUBLIC)
	PHP_ME(TElDKDNSRecord, set_Notes, arginfo_TElDKDNSRecord_set_Notes, ZEND_ACC_PUBLIC)
	PHP_ME(TElDKDNSRecord, get_PublicKey, arginfo_TElDKDNSRecord_get_PublicKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElDKDNSRecord, get_TestMode, arginfo_TElDKDNSRecord_get_TestMode, ZEND_ACC_PUBLIC)
	PHP_ME(TElDKDNSRecord, set_TestMode, arginfo_TElDKDNSRecord_set_TestMode, ZEND_ACC_PUBLIC)
	PHP_ME(TElDKDNSRecord, get_ExactMode, arginfo_TElDKDNSRecord_get_ExactMode, ZEND_ACC_PUBLIC)
	PHP_ME(TElDKDNSRecord, set_ExactMode, arginfo_TElDKDNSRecord_set_ExactMode, ZEND_ACC_PUBLIC)
	PHP_ME(TElDKDNSRecord, get_ServiceType, arginfo_TElDKDNSRecord_get_ServiceType, ZEND_ACC_PUBLIC)
	PHP_ME(TElDKDNSRecord, set_ServiceType, arginfo_TElDKDNSRecord_set_ServiceType, ZEND_ACC_PUBLIC)
	PHP_ME(TElDKDNSRecord, get_Version, arginfo_TElDKDNSRecord_get_Version, ZEND_ACC_PUBLIC)
	PHP_ME(TElDKDNSRecord, set_Version, arginfo_TElDKDNSRecord_set_Version, ZEND_ACC_PUBLIC)
	PHP_ME(TElDKDNSRecord, get_Algorithms, arginfo_TElDKDNSRecord_get_Algorithms, ZEND_ACC_PUBLIC)
	PHP_ME(TElDKDNSRecord, set_Algorithms, arginfo_TElDKDNSRecord_set_Algorithms, ZEND_ACC_PUBLIC)
	PHP_ME(TElDKDNSRecord, __construct, arginfo_TElDKDNSRecord___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElDKDNSRecord(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElDKDNSRecord_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElDKDNSRecord", TElDKDNSRecord_methods);
	if (NULL == TPersistent_ce_ptr)
		Register_TPersistent(TSRMLS_C);
	TElDKDNSRecord_ce_ptr = zend_register_internal_class_ex(&ce, TPersistent_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElDomainKeysClass_ce_ptr = NULL;

SB_PHP_METHOD(TElDomainKeysClass, __construct)
{
	zval *oAOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDomainKeysClass_Create(SBGetObjectHandle(oAOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDomainKeysClass___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AOwner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElDomainKeysClass_methods[] = {
	PHP_ME(TElDomainKeysClass, __construct, arginfo_TElDomainKeysClass___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElDomainKeysClass(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElDomainKeysClass_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElDomainKeysClass", TElDomainKeysClass_methods);
	if (NULL == TComponent_ce_ptr)
		Register_TComponent(TSRMLS_C);
	TElDomainKeysClass_ce_ptr = zend_register_internal_class_ex(&ce, TComponent_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElDomainKeysSigner_ce_ptr = NULL;

SB_PHP_METHOD(TElDomainKeysSigner, AddHash)
{
	long l4DataSize;
	SBArrayZValInfo piData;
	zend_bool bBodyHash;
	zval *zpData;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlb", &zpData, &l4DataSize, &bBodyHash) == SUCCESS) && ((Z_TYPE_P(zpData) == IS_STRING) || (Z_TYPE_P(zpData) == IS_ARRAY) || (Z_TYPE_P(zpData) == IS_NULL) || ((Z_TYPE_P(zpData) == IS_OBJECT) && (Z_OBJCE_P(zpData) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpData, &piData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElDomainKeysSigner_AddHash(SBGetObjectHandle(getThis() TSRMLS_CC), piData.data, (int32_t)l4DataSize, (int8_t)bBodyHash) TSRMLS_CC);
		SBFreePointerZValInfo(&piData);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDomainKeysSigner, CanonicalizeBody)
{
	uint32_t _err;
	zval *oBody;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oBody, TStrings_ce_ptr) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElDomainKeysSigner_CanonicalizeBody(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oBody TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1164578877, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(TStrings)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDomainKeysSigner, CanonicalizeHeader)
{
	uint32_t _err;
	zval *oHeader;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oHeader, TStrings_ce_ptr) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElDomainKeysSigner_CanonicalizeHeader(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oHeader TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-950625784, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(TStrings)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDomainKeysSigner, ClearPrivateKey)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElDomainKeysSigner_ClearPrivateKey(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDomainKeysSigner, GetHash)
{
	long fHashAlgorithm;
	SBArrayZValInfo aiHash;
	uint32_t _err;
	zend_bool bBodyHash;
	zval *zaHash;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lbz", &fHashAlgorithm, &bBodyHash, &zaHash) == SUCCESS) && PZVAL_IS_REF(zaHash) && ((IS_STRING == Z_TYPE_P(zaHash)) || (IS_ARRAY == Z_TYPE_P(zaHash))))
	{
		int32_t l4OutResultRaw = 0;
		SBInitArrayZValInfo(&aiHash);
		_err = TElDomainKeysSigner_GetHash(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBDKDigestAlgorithmRaw)fHashAlgorithm, (int8_t)bBodyHash, aiHash.data, &aiHash.len, &l4OutResultRaw);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			SBDetachDataFromZValAndResize(zaHash, &aiHash TSRMLS_CC);
			SBCheckError(SBGetLastReturnBuffer(-555009920, 3, aiHash.data, &aiHash.len) TSRMLS_CC);
			((char *)aiHash.data)[aiHash.len] = 0;
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBFreeArrayZValInfo(&aiHash);
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBSetByteArrayToZVal(&aiHash, zaHash);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer, bool, &array of byte|string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDomainKeysSigner, ProcessHeader)
{
	zval *oHeader;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oHeader, TStrings_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElDomainKeysSigner_ProcessHeader(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oHeader TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TStrings)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDomainKeysSigner, ProcessBodyLine)
{
	char *sS;
	int sS_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sS, &sS_len) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElDomainKeysSigner_ProcessBodyLine(SBGetObjectHandle(getThis() TSRMLS_CC), sS, (int32_t)sS_len, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDomainKeysSigner, ProcessMessage)
{
	char *sMessageText;
	int sMessageText_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sMessageText, &sMessageText_len) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElDomainKeysSigner_ProcessMessage(SBGetObjectHandle(getThis() TSRMLS_CC), sMessageText, (int32_t)sMessageText_len, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDomainKeysSigner, Reset)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElDomainKeysSigner_Reset(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDomainKeysSigner, SetPrivateKey)
{
	long l4BufferSize;
	long l4ExponentSize;
	long l4ModulusSize;
	SBArrayZValInfo piBuffer;
	SBArrayZValInfo piExponent;
	SBArrayZValInfo piModulus;
	zval *zpBuffer;
	zval *zpExponent;
	zval *zpModulus;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlzl", &zpModulus, &l4ModulusSize, &zpExponent, &l4ExponentSize) == SUCCESS) && ((Z_TYPE_P(zpModulus) == IS_STRING) || (Z_TYPE_P(zpModulus) == IS_ARRAY) || (Z_TYPE_P(zpModulus) == IS_NULL) || ((Z_TYPE_P(zpModulus) == IS_OBJECT) && (Z_OBJCE_P(zpModulus) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpExponent) == IS_STRING) || (Z_TYPE_P(zpExponent) == IS_ARRAY) || (Z_TYPE_P(zpExponent) == IS_NULL) || ((Z_TYPE_P(zpExponent) == IS_OBJECT) && (Z_OBJCE_P(zpExponent) == TSBPointer_ce_ptr))))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpModulus, &piModulus TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpExponent, &piExponent TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElDomainKeysSigner_SetPrivateKey(SBGetObjectHandle(getThis() TSRMLS_CC), piModulus.data, (int32_t)l4ModulusSize, piExponent.data, (int32_t)l4ExponentSize, &bOutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piModulus);
		SBFreePointerZValInfo(&piExponent);
		RETURN_BOOL(bOutResultRaw);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zpBuffer, &l4BufferSize) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElDomainKeysSigner_SetPrivateKey_1(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, (int32_t)l4BufferSize, &bOutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer) or (TSBPointer|array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDomainKeysSigner, Sign)
{
	zval *oSignature;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSignature, TStrings_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElDomainKeysSigner_Sign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSignature TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TStrings)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDomainKeysSigner, get_BodyCanonicalization)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBDKCanonicalizationAlgorithmRaw fOutResultRaw = 0;
		SBCheckError(TElDomainKeysSigner_get_BodyCanonicalization(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDomainKeysSigner, set_BodyCanonicalization)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElDomainKeysSigner_set_BodyCanonicalization(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBDKCanonicalizationAlgorithmRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDomainKeysSigner, get_HeaderCanonicalization)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBDKCanonicalizationAlgorithmRaw fOutResultRaw = 0;
		SBCheckError(TElDomainKeysSigner_get_HeaderCanonicalization(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDomainKeysSigner, set_HeaderCanonicalization)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElDomainKeysSigner_set_HeaderCanonicalization(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBDKCanonicalizationAlgorithmRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDomainKeysSigner, get_DigestAlgorithm)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBDKDigestAlgorithmRaw fOutResultRaw = 0;
		SBCheckError(TElDomainKeysSigner_get_DigestAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDomainKeysSigner, set_DigestAlgorithm)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElDomainKeysSigner_set_DigestAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBDKDigestAlgorithmRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDomainKeysSigner, get_Domain)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElDomainKeysSigner_get_Domain(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-819569110, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDomainKeysSigner, get_BodyHashLimit)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElDomainKeysSigner_get_BodyHashLimit(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-540018607, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDomainKeysSigner, set_BodyHashLimit)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElDomainKeysSigner_set_BodyHashLimit(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDomainKeysSigner, get_HeaderFields)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDomainKeysSigner_get_HeaderFields(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
#ifdef SB_WINDOWS
		SBInitObject(return_value, TStringList_ce_ptr, hoOutResult TSRMLS_CC);
#else
		SBInitObject(return_value, TElStringList_ce_ptr, hoOutResult TSRMLS_CC);
#endif
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDomainKeysSigner, set_HeaderFields)
{
	zval *oValue;
#ifdef SB_WINDOWS
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TStringList_ce_ptr) == SUCCESS)
#else
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElStringList_ce_ptr) == SUCCESS)
#endif
	{
		SBCheckError(TElDomainKeysSigner_set_HeaderFields(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
#ifdef SB_WINDOWS
		SBErrorExpectsArguments("(TStringList)" TSRMLS_CC);
#else
		SBErrorExpectsArguments("(TElStringList)" TSRMLS_CC);
#endif
	}
}

SB_PHP_METHOD(TElDomainKeysSigner, get_QueryType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBDKQueryTypeRaw fOutResultRaw = 0;
		SBCheckError(TElDomainKeysSigner_get_QueryType(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDomainKeysSigner, set_QueryType)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElDomainKeysSigner_set_QueryType(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBDKQueryTypeRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDomainKeysSigner, get_Selector)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElDomainKeysSigner_get_Selector(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(755551326, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDomainKeysSigner, set_Selector)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElDomainKeysSigner_set_Selector(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDomainKeysSigner, get_SignatureAlgorithm)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBDKPublicKeyTypeRaw fOutResultRaw = 0;
		SBCheckError(TElDomainKeysSigner_get_SignatureAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDomainKeysSigner, set_SignatureAlgorithm)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElDomainKeysSigner_set_SignatureAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBDKPublicKeyTypeRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDomainKeysSigner, get_SignatureExpiration)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(TElDomainKeysSigner_get_SignatureExpiration(SBGetObjectHandle(getThis() TSRMLS_CC), &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDomainKeysSigner, set_SignatureExpiration)
{
	zval *dtValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &dtValue, php_date_get_date_ce()) == SUCCESS)
	{
		SBCheckError(TElDomainKeysSigner_set_SignatureExpiration(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetDateTime(dtValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(DateTime)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDomainKeysSigner, get_UseCopiedFields)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElDomainKeysSigner_get_UseCopiedFields(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDomainKeysSigner, set_UseCopiedFields)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElDomainKeysSigner_set_UseCopiedFields(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDomainKeysSigner, get_UserIdentity)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElDomainKeysSigner_get_UserIdentity(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1771661161, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDomainKeysSigner, __construct)
{
	zval *oAOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDomainKeysSigner_Create(SBGetObjectHandle(oAOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDomainKeysSigner_AddHash, 0, 0, 3)
	ZEND_ARG_TYPE_INFO(0, Data, 0, 1)
	ZEND_ARG_INFO(0, DataSize)
	ZEND_ARG_INFO(0, BodyHash)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDomainKeysSigner_CanonicalizeBody, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Body, TStrings, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDomainKeysSigner_CanonicalizeHeader, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Header, TStrings, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDomainKeysSigner_ClearPrivateKey, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDomainKeysSigner_GetHash, 0, 0, 3)
	ZEND_ARG_INFO(0, HashAlgorithm)
	ZEND_ARG_INFO(0, BodyHash)
	ZEND_ARG_INFO(1, Hash)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDomainKeysSigner_ProcessHeader, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Header, TStrings, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDomainKeysSigner_ProcessBodyLine, 0, 0, 1)
	ZEND_ARG_INFO(0, S)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDomainKeysSigner_ProcessMessage, 0, 0, 1)
	ZEND_ARG_INFO(0, MessageText)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDomainKeysSigner_Reset, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDomainKeysSigner_SetPrivateKey, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Modulus_or_Buffer, 0, 1)
	ZEND_ARG_INFO(0, ModulusSize_or_BufferSize)
	ZEND_ARG_TYPE_INFO(0, Exponent, 0, 1)
	ZEND_ARG_INFO(0, ExponentSize)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDomainKeysSigner_Sign, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Signature, TStrings, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDomainKeysSigner_get_BodyCanonicalization, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDomainKeysSigner_set_BodyCanonicalization, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDomainKeysSigner_get_HeaderCanonicalization, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDomainKeysSigner_set_HeaderCanonicalization, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDomainKeysSigner_get_DigestAlgorithm, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDomainKeysSigner_set_DigestAlgorithm, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDomainKeysSigner_get_Domain, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDomainKeysSigner_get_BodyHashLimit, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDomainKeysSigner_set_BodyHashLimit, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDomainKeysSigner_get_HeaderFields, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDomainKeysSigner_set_HeaderFields, 0, 0, 1)
#ifdef SB_WINDOWS
	ZEND_ARG_OBJ_INFO(0, Value, TStringList, 1)
#else
	ZEND_ARG_OBJ_INFO(0, Value, TElStringList, 1)
#endif
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDomainKeysSigner_get_QueryType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDomainKeysSigner_set_QueryType, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDomainKeysSigner_get_Selector, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDomainKeysSigner_set_Selector, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDomainKeysSigner_get_SignatureAlgorithm, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDomainKeysSigner_set_SignatureAlgorithm, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDomainKeysSigner_get_SignatureExpiration, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDomainKeysSigner_set_SignatureExpiration, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, DateTime, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDomainKeysSigner_get_UseCopiedFields, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDomainKeysSigner_set_UseCopiedFields, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDomainKeysSigner_get_UserIdentity, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDomainKeysSigner___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AOwner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElDomainKeysSigner_methods[] = {
	PHP_ME(TElDomainKeysSigner, AddHash, arginfo_TElDomainKeysSigner_AddHash, ZEND_ACC_PUBLIC)
	PHP_ME(TElDomainKeysSigner, CanonicalizeBody, arginfo_TElDomainKeysSigner_CanonicalizeBody, ZEND_ACC_PUBLIC)
	PHP_ME(TElDomainKeysSigner, CanonicalizeHeader, arginfo_TElDomainKeysSigner_CanonicalizeHeader, ZEND_ACC_PUBLIC)
	PHP_ME(TElDomainKeysSigner, ClearPrivateKey, arginfo_TElDomainKeysSigner_ClearPrivateKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElDomainKeysSigner, GetHash, arginfo_TElDomainKeysSigner_GetHash, ZEND_ACC_PUBLIC)
	PHP_ME(TElDomainKeysSigner, ProcessHeader, arginfo_TElDomainKeysSigner_ProcessHeader, ZEND_ACC_PUBLIC)
	PHP_ME(TElDomainKeysSigner, ProcessBodyLine, arginfo_TElDomainKeysSigner_ProcessBodyLine, ZEND_ACC_PUBLIC)
	PHP_ME(TElDomainKeysSigner, ProcessMessage, arginfo_TElDomainKeysSigner_ProcessMessage, ZEND_ACC_PUBLIC)
	PHP_ME(TElDomainKeysSigner, Reset, arginfo_TElDomainKeysSigner_Reset, ZEND_ACC_PUBLIC)
	PHP_ME(TElDomainKeysSigner, SetPrivateKey, arginfo_TElDomainKeysSigner_SetPrivateKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElDomainKeysSigner, Sign, arginfo_TElDomainKeysSigner_Sign, ZEND_ACC_PUBLIC)
	PHP_ME(TElDomainKeysSigner, get_BodyCanonicalization, arginfo_TElDomainKeysSigner_get_BodyCanonicalization, ZEND_ACC_PUBLIC)
	PHP_ME(TElDomainKeysSigner, set_BodyCanonicalization, arginfo_TElDomainKeysSigner_set_BodyCanonicalization, ZEND_ACC_PUBLIC)
	PHP_ME(TElDomainKeysSigner, get_HeaderCanonicalization, arginfo_TElDomainKeysSigner_get_HeaderCanonicalization, ZEND_ACC_PUBLIC)
	PHP_ME(TElDomainKeysSigner, set_HeaderCanonicalization, arginfo_TElDomainKeysSigner_set_HeaderCanonicalization, ZEND_ACC_PUBLIC)
	PHP_ME(TElDomainKeysSigner, get_DigestAlgorithm, arginfo_TElDomainKeysSigner_get_DigestAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElDomainKeysSigner, set_DigestAlgorithm, arginfo_TElDomainKeysSigner_set_DigestAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElDomainKeysSigner, get_Domain, arginfo_TElDomainKeysSigner_get_Domain, ZEND_ACC_PUBLIC)
	PHP_ME(TElDomainKeysSigner, get_BodyHashLimit, arginfo_TElDomainKeysSigner_get_BodyHashLimit, ZEND_ACC_PUBLIC)
	PHP_ME(TElDomainKeysSigner, set_BodyHashLimit, arginfo_TElDomainKeysSigner_set_BodyHashLimit, ZEND_ACC_PUBLIC)
	PHP_ME(TElDomainKeysSigner, get_HeaderFields, arginfo_TElDomainKeysSigner_get_HeaderFields, ZEND_ACC_PUBLIC)
	PHP_ME(TElDomainKeysSigner, set_HeaderFields, arginfo_TElDomainKeysSigner_set_HeaderFields, ZEND_ACC_PUBLIC)
	PHP_ME(TElDomainKeysSigner, get_QueryType, arginfo_TElDomainKeysSigner_get_QueryType, ZEND_ACC_PUBLIC)
	PHP_ME(TElDomainKeysSigner, set_QueryType, arginfo_TElDomainKeysSigner_set_QueryType, ZEND_ACC_PUBLIC)
	PHP_ME(TElDomainKeysSigner, get_Selector, arginfo_TElDomainKeysSigner_get_Selector, ZEND_ACC_PUBLIC)
	PHP_ME(TElDomainKeysSigner, set_Selector, arginfo_TElDomainKeysSigner_set_Selector, ZEND_ACC_PUBLIC)
	PHP_ME(TElDomainKeysSigner, get_SignatureAlgorithm, arginfo_TElDomainKeysSigner_get_SignatureAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElDomainKeysSigner, set_SignatureAlgorithm, arginfo_TElDomainKeysSigner_set_SignatureAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElDomainKeysSigner, get_SignatureExpiration, arginfo_TElDomainKeysSigner_get_SignatureExpiration, ZEND_ACC_PUBLIC)
	PHP_ME(TElDomainKeysSigner, set_SignatureExpiration, arginfo_TElDomainKeysSigner_set_SignatureExpiration, ZEND_ACC_PUBLIC)
	PHP_ME(TElDomainKeysSigner, get_UseCopiedFields, arginfo_TElDomainKeysSigner_get_UseCopiedFields, ZEND_ACC_PUBLIC)
	PHP_ME(TElDomainKeysSigner, set_UseCopiedFields, arginfo_TElDomainKeysSigner_set_UseCopiedFields, ZEND_ACC_PUBLIC)
	PHP_ME(TElDomainKeysSigner, get_UserIdentity, arginfo_TElDomainKeysSigner_get_UserIdentity, ZEND_ACC_PUBLIC)
	PHP_ME(TElDomainKeysSigner, __construct, arginfo_TElDomainKeysSigner___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElDomainKeysSigner(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElDomainKeysSigner_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElDomainKeysSigner", TElDomainKeysSigner_methods);
	if (NULL == TElDomainKeysClass_ce_ptr)
		Register_TElDomainKeysClass(TSRMLS_C);
	TElDomainKeysSigner_ce_ptr = zend_register_internal_class_ex(&ce, TElDomainKeysClass_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElDomainKeysVerifier_ce_ptr = NULL;

SB_PHP_METHOD(TElDomainKeysVerifier, ProcessHeader)
{
	char *sSource;
	int sSource_len;
	zval *oHeader;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oHeader, TStrings_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElDomainKeysVerifier_ProcessHeader(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oHeader TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sSource, &sSource_len) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElDomainKeysVerifier_ProcessHeader_1(SBGetObjectHandle(getThis() TSRMLS_CC), sSource, (int32_t)sSource_len, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TStrings) or (string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDomainKeysVerifier, ProcessBodyLine)
{
	char *sS;
	int sS_len;
	long l4SignatureIndex;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sl", &sS, &sS_len, &l4SignatureIndex) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElDomainKeysVerifier_ProcessBodyLine(SBGetObjectHandle(getThis() TSRMLS_CC), sS, (int32_t)sS_len, (int32_t)l4SignatureIndex, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDomainKeysVerifier, ProcessMessage)
{
	zval *oStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oStream, TStream_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElDomainKeysVerifier_ProcessMessage(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TStream)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDomainKeysVerifier, Verify)
{
	long l4SigIndex;
	zval *oDNSRec;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lO!", &l4SigIndex, &oDNSRec, TElDKDNSRecord_ce_ptr) == SUCCESS)
	{
		TSBDKStatusRaw fOutResultRaw = 0;
		SBCheckError(TElDomainKeysVerifier_Verify(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4SigIndex, SBGetObjectHandle(oDNSRec TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer, TElDKDNSRecord)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDomainKeysVerifier, Reset)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElDomainKeysVerifier_Reset(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDomainKeysVerifier, get_Signatures)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDomainKeysVerifier_get_Signatures(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElDKSignature_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDomainKeysVerifier, get_SignaturesCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElDomainKeysVerifier_get_SignaturesCount(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDomainKeysVerifier, __construct)
{
	zval *oAOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDomainKeysVerifier_Create(SBGetObjectHandle(oAOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDomainKeysVerifier_ProcessHeader, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Header_or_Source, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDomainKeysVerifier_ProcessBodyLine, 0, 0, 2)
	ZEND_ARG_INFO(0, S)
	ZEND_ARG_INFO(0, SignatureIndex)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDomainKeysVerifier_ProcessMessage, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Stream, TStream, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDomainKeysVerifier_Verify, 0, 0, 2)
	ZEND_ARG_INFO(0, SigIndex)
	ZEND_ARG_OBJ_INFO(0, DNSRec, TElDKDNSRecord, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDomainKeysVerifier_Reset, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDomainKeysVerifier_get_Signatures, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDomainKeysVerifier_get_SignaturesCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDomainKeysVerifier___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AOwner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElDomainKeysVerifier_methods[] = {
	PHP_ME(TElDomainKeysVerifier, ProcessHeader, arginfo_TElDomainKeysVerifier_ProcessHeader, ZEND_ACC_PUBLIC)
	PHP_ME(TElDomainKeysVerifier, ProcessBodyLine, arginfo_TElDomainKeysVerifier_ProcessBodyLine, ZEND_ACC_PUBLIC)
	PHP_ME(TElDomainKeysVerifier, ProcessMessage, arginfo_TElDomainKeysVerifier_ProcessMessage, ZEND_ACC_PUBLIC)
	PHP_ME(TElDomainKeysVerifier, Verify, arginfo_TElDomainKeysVerifier_Verify, ZEND_ACC_PUBLIC)
	PHP_ME(TElDomainKeysVerifier, Reset, arginfo_TElDomainKeysVerifier_Reset, ZEND_ACC_PUBLIC)
	PHP_ME(TElDomainKeysVerifier, get_Signatures, arginfo_TElDomainKeysVerifier_get_Signatures, ZEND_ACC_PUBLIC)
	PHP_ME(TElDomainKeysVerifier, get_SignaturesCount, arginfo_TElDomainKeysVerifier_get_SignaturesCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElDomainKeysVerifier, __construct, arginfo_TElDomainKeysVerifier___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElDomainKeysVerifier(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElDomainKeysVerifier_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElDomainKeysVerifier", TElDomainKeysVerifier_methods);
	if (NULL == TElDomainKeysClass_ce_ptr)
		Register_TElDomainKeysClass(TSRMLS_C);
	TElDomainKeysVerifier_ce_ptr = zend_register_internal_class_ex(&ce, TElDomainKeysClass_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElDKSignature_ce_ptr = NULL;

SB_PHP_METHOD(TElDKSignature, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElDKSignature_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDKSignature, HashClear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElDKSignature_HashClear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDKSignature, Verify)
{
	zval *oDNS;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDNS, TElDKDNSRecord_ce_ptr) == SUCCESS)
	{
		TSBDKStatusRaw fOutResultRaw = 0;
		SBCheckError(TElDKSignature_Verify(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDNS TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElDKDNSRecord)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDKSignature, get_Available)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElDKSignature_get_Available(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDKSignature, get_HeaderCanonicalization)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBDKCanonicalizationAlgorithmRaw fOutResultRaw = 0;
		SBCheckError(TElDKSignature_get_HeaderCanonicalization(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDKSignature, get_BodyCanonicalization)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBDKCanonicalizationAlgorithmRaw fOutResultRaw = 0;
		SBCheckError(TElDKSignature_get_BodyCanonicalization(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDKSignature, get_DigestAlgorithm)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBDKDigestAlgorithmRaw fOutResultRaw = 0;
		SBCheckError(TElDKSignature_get_DigestAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDKSignature, get_Domain)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElDKSignature_get_Domain(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-766015514, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDKSignature, set_Domain)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElDKSignature_set_Domain(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDKSignature, get_Address)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElDKSignature_get_Address(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(25354320, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDKSignature, get_QueryType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBDKQueryTypeRaw fOutResultRaw = 0;
		SBCheckError(TElDKSignature_get_QueryType(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDKSignature, get_Selector)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElDKSignature_get_Selector(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1253563619, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDKSignature, get_SignatureAlgorithm)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBDKPublicKeyTypeRaw fOutResultRaw = 0;
		SBCheckError(TElDKSignature_get_SignatureAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDKSignature, get_BodyHashLimit)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElDKSignature_get_BodyHashLimit(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-2021521804, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDKSignature, set_BodyHashLimit)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElDKSignature_set_BodyHashLimit(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDKSignature, get_VerifierBodyHashLimit)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElDKSignature_get_VerifierBodyHashLimit(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1478057178, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDKSignature, set_VerifierBodyHashLimit)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElDKSignature_set_VerifierBodyHashLimit(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDKSignature, get_SignatureTime)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(TElDKSignature_get_SignatureTime(SBGetObjectHandle(getThis() TSRMLS_CC), &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDKSignature, set_SignatureTime)
{
	zval *dtValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &dtValue, php_date_get_date_ce()) == SUCCESS)
	{
		SBCheckError(TElDKSignature_set_SignatureTime(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetDateTime(dtValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(DateTime)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDKSignature, get_SignatureExpired)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(TElDKSignature_get_SignatureExpired(SBGetObjectHandle(getThis() TSRMLS_CC), &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDKSignature, set_SignatureExpired)
{
	zval *dtValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &dtValue, php_date_get_date_ce()) == SUCCESS)
	{
		SBCheckError(TElDKSignature_set_SignatureExpired(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetDateTime(dtValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(DateTime)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDKSignature, get_Hashed)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElDKSignature_get_Hashed(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDKSignature, set_Hashed)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElDKSignature_set_Hashed(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDKSignature, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDKSignature_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDKSignature_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDKSignature_HashClear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDKSignature_Verify, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, DNS, TElDKDNSRecord, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDKSignature_get_Available, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDKSignature_get_HeaderCanonicalization, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDKSignature_get_BodyCanonicalization, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDKSignature_get_DigestAlgorithm, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDKSignature_get_Domain, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDKSignature_set_Domain, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDKSignature_get_Address, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDKSignature_get_QueryType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDKSignature_get_Selector, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDKSignature_get_SignatureAlgorithm, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDKSignature_get_BodyHashLimit, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDKSignature_set_BodyHashLimit, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDKSignature_get_VerifierBodyHashLimit, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDKSignature_set_VerifierBodyHashLimit, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDKSignature_get_SignatureTime, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDKSignature_set_SignatureTime, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, DateTime, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDKSignature_get_SignatureExpired, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDKSignature_set_SignatureExpired, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, DateTime, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDKSignature_get_Hashed, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDKSignature_set_Hashed, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDKSignature___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElDKSignature_methods[] = {
	PHP_ME(TElDKSignature, Clear, arginfo_TElDKSignature_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElDKSignature, HashClear, arginfo_TElDKSignature_HashClear, ZEND_ACC_PUBLIC)
	PHP_ME(TElDKSignature, Verify, arginfo_TElDKSignature_Verify, ZEND_ACC_PUBLIC)
	PHP_ME(TElDKSignature, get_Available, arginfo_TElDKSignature_get_Available, ZEND_ACC_PUBLIC)
	PHP_ME(TElDKSignature, get_HeaderCanonicalization, arginfo_TElDKSignature_get_HeaderCanonicalization, ZEND_ACC_PUBLIC)
	PHP_ME(TElDKSignature, get_BodyCanonicalization, arginfo_TElDKSignature_get_BodyCanonicalization, ZEND_ACC_PUBLIC)
	PHP_ME(TElDKSignature, get_DigestAlgorithm, arginfo_TElDKSignature_get_DigestAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElDKSignature, get_Domain, arginfo_TElDKSignature_get_Domain, ZEND_ACC_PUBLIC)
	PHP_ME(TElDKSignature, set_Domain, arginfo_TElDKSignature_set_Domain, ZEND_ACC_PUBLIC)
	PHP_ME(TElDKSignature, get_Address, arginfo_TElDKSignature_get_Address, ZEND_ACC_PUBLIC)
	PHP_ME(TElDKSignature, get_QueryType, arginfo_TElDKSignature_get_QueryType, ZEND_ACC_PUBLIC)
	PHP_ME(TElDKSignature, get_Selector, arginfo_TElDKSignature_get_Selector, ZEND_ACC_PUBLIC)
	PHP_ME(TElDKSignature, get_SignatureAlgorithm, arginfo_TElDKSignature_get_SignatureAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElDKSignature, get_BodyHashLimit, arginfo_TElDKSignature_get_BodyHashLimit, ZEND_ACC_PUBLIC)
	PHP_ME(TElDKSignature, set_BodyHashLimit, arginfo_TElDKSignature_set_BodyHashLimit, ZEND_ACC_PUBLIC)
	PHP_ME(TElDKSignature, get_VerifierBodyHashLimit, arginfo_TElDKSignature_get_VerifierBodyHashLimit, ZEND_ACC_PUBLIC)
	PHP_ME(TElDKSignature, set_VerifierBodyHashLimit, arginfo_TElDKSignature_set_VerifierBodyHashLimit, ZEND_ACC_PUBLIC)
	PHP_ME(TElDKSignature, get_SignatureTime, arginfo_TElDKSignature_get_SignatureTime, ZEND_ACC_PUBLIC)
	PHP_ME(TElDKSignature, set_SignatureTime, arginfo_TElDKSignature_set_SignatureTime, ZEND_ACC_PUBLIC)
	PHP_ME(TElDKSignature, get_SignatureExpired, arginfo_TElDKSignature_get_SignatureExpired, ZEND_ACC_PUBLIC)
	PHP_ME(TElDKSignature, set_SignatureExpired, arginfo_TElDKSignature_set_SignatureExpired, ZEND_ACC_PUBLIC)
	PHP_ME(TElDKSignature, get_Hashed, arginfo_TElDKSignature_get_Hashed, ZEND_ACC_PUBLIC)
	PHP_ME(TElDKSignature, set_Hashed, arginfo_TElDKSignature_set_Hashed, ZEND_ACC_PUBLIC)
	PHP_ME(TElDKSignature, __construct, arginfo_TElDKSignature___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElDKSignature(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElDKSignature_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElDKSignature", TElDKSignature_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElDKSignature_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

void Register_SBDomainKeys_Constants(int module_number TSRMLS_DC)
{
	SB_REGISTER_LONG_CONSTANT(SBDomainKeys, SB_DK_DNS_ERROR_SUCCESS, SB_DK_DNS_ERROR_SUCCESS, SB_DK_DNS_ERROR_SUCCESS);
	SB_REGISTER_LONG_CONSTANT(SBDomainKeys, SB_DK_DNS_ERROR_NODATA, SB_DK_DNS_ERROR_NODATA, SB_DK_DNS_ERROR_NODATA);
	SB_REGISTER_LONG_CONSTANT(SBDomainKeys, SB_DK_DNS_ERROR_NOPARAMS, SB_DK_DNS_ERROR_NOPARAMS, SB_DK_DNS_ERROR_NOPARAMS);
	SB_REGISTER_LONG_CONSTANT(SBDomainKeys, SB_DK_DNS_ERROR_NOKEY, SB_DK_DNS_ERROR_NOKEY, SB_DK_DNS_ERROR_NOKEY);
	SB_REGISTER_LONG_CONSTANT(SBDomainKeys, SB_DK_DNS_ERROR_INVALID_KEYTYPE, SB_DK_DNS_ERROR_INVALID_KEYTYPE, SB_DK_DNS_ERROR_INVALID_KEYTYPE);
	SB_REGISTER_LONG_CONSTANT(SBDomainKeys, SB_DK_DNS_ERROR_INVALID_KEYDATA, SB_DK_DNS_ERROR_INVALID_KEYDATA, SB_DK_DNS_ERROR_INVALID_KEYDATA);
	SB_REGISTER_LONG_CONSTANT(SBDomainKeys, SB_DK_SIGNER_ERROR_SUCCESS, SB_DK_SIGNER_ERROR_SUCCESS, SB_DK_SIGNER_ERROR_SUCCESS);
	SB_REGISTER_LONG_CONSTANT(SBDomainKeys, SB_DK_SIGNER_ERROR_INVALID_STATE, SB_DK_SIGNER_ERROR_INVALID_STATE, SB_DK_SIGNER_ERROR_INVALID_STATE);
	SB_REGISTER_LONG_CONSTANT(SBDomainKeys, SB_DK_SIGNER_ERROR_INVALID_HEADER, SB_DK_SIGNER_ERROR_INVALID_HEADER, SB_DK_SIGNER_ERROR_INVALID_HEADER);
	SB_REGISTER_LONG_CONSTANT(SBDomainKeys, SB_DK_SIGNER_ERROR_EMPTY_HEADER, SB_DK_SIGNER_ERROR_EMPTY_HEADER, SB_DK_SIGNER_ERROR_EMPTY_HEADER);
	SB_REGISTER_LONG_CONSTANT(SBDomainKeys, SB_DK_SIGNER_ERROR_INVALID_SENDER, SB_DK_SIGNER_ERROR_INVALID_SENDER, SB_DK_SIGNER_ERROR_INVALID_SENDER);
	SB_REGISTER_LONG_CONSTANT(SBDomainKeys, SB_DK_SIGNER_ERROR_SEVERAL_SENDERS, SB_DK_SIGNER_ERROR_SEVERAL_SENDERS, SB_DK_SIGNER_ERROR_SEVERAL_SENDERS);
	SB_REGISTER_LONG_CONSTANT(SBDomainKeys, SB_DK_SIGNER_ERROR_NO_DOMAIN, SB_DK_SIGNER_ERROR_NO_DOMAIN, SB_DK_SIGNER_ERROR_NO_DOMAIN);
	SB_REGISTER_LONG_CONSTANT(SBDomainKeys, SB_DK_SIGNER_ERROR_NO_AUTHOR, SB_DK_SIGNER_ERROR_NO_AUTHOR, SB_DK_SIGNER_ERROR_NO_AUTHOR);
	SB_REGISTER_LONG_CONSTANT(SBDomainKeys, SB_DK_SIGNER_ERROR_NO_PRIVATE_KEY, SB_DK_SIGNER_ERROR_NO_PRIVATE_KEY, SB_DK_SIGNER_ERROR_NO_PRIVATE_KEY);
	SB_REGISTER_LONG_CONSTANT(SBDomainKeys, SB_DK_SIGNER_ERROR_NO_SELECTOR, SB_DK_SIGNER_ERROR_NO_SELECTOR, SB_DK_SIGNER_ERROR_NO_SELECTOR);
	SB_REGISTER_LONG_CONSTANT(SBDomainKeys, SB_DK_SIGNER_ERROR_FAILURE, SB_DK_SIGNER_ERROR_FAILURE, SB_DK_SIGNER_ERROR_FAILURE);
	SB_REGISTER_LONG_CONSTANT(SBDomainKeys, SB_DK_VERIFIER_ERROR_SUCCESS, SB_DK_VERIFIER_ERROR_SUCCESS, SB_DK_VERIFIER_ERROR_SUCCESS);
	SB_REGISTER_LONG_CONSTANT(SBDomainKeys, SB_DK_VERIFIER_ERROR_INVALID_STATE, SB_DK_VERIFIER_ERROR_INVALID_STATE, SB_DK_VERIFIER_ERROR_INVALID_STATE);
	SB_REGISTER_LONG_CONSTANT(SBDomainKeys, SB_DK_VERIFIER_ERROR_INVALID_HEADER, SB_DK_VERIFIER_ERROR_INVALID_HEADER, SB_DK_VERIFIER_ERROR_INVALID_HEADER);
	SB_REGISTER_LONG_CONSTANT(SBDomainKeys, SB_DK_VERIFIER_ERROR_NO_ADDRESS, SB_DK_VERIFIER_ERROR_NO_ADDRESS, SB_DK_VERIFIER_ERROR_NO_ADDRESS);
	SB_REGISTER_LONG_CONSTANT(SBDomainKeys, SB_DK_VERIFIER_ERROR_NO_SIGNATURE, SB_DK_VERIFIER_ERROR_NO_SIGNATURE, SB_DK_VERIFIER_ERROR_NO_SIGNATURE);
	SB_REGISTER_LONG_CONSTANT(SBDomainKeys, SB_DK_VERIFIER_ERROR_INVALID_FORMAT, SB_DK_VERIFIER_ERROR_INVALID_FORMAT, SB_DK_VERIFIER_ERROR_INVALID_FORMAT);
	SB_REGISTER_LONG_CONSTANT(SBDomainKeys, SB_DK_VERIFIER_ERROR_UNKNOWN_ALGORITHM, SB_DK_VERIFIER_ERROR_UNKNOWN_ALGORITHM, SB_DK_VERIFIER_ERROR_UNKNOWN_ALGORITHM);
	SB_REGISTER_LONG_CONSTANT(SBDomainKeys, SB_DK_VERIFIER_ERROR_FAILURE, SB_DK_VERIFIER_ERROR_FAILURE, SB_DK_VERIFIER_ERROR_FAILURE);
	SB_REGISTER_LONG_CONSTANT(SBDomainKeys, SB_DK_VERIFIER_ERROR_DOMAIN_MISMATCH, SB_DK_VERIFIER_ERROR_DOMAIN_MISMATCH, SB_DK_VERIFIER_ERROR_DOMAIN_MISMATCH);
	SB_REGISTER_LONG_CONSTANT(SBDomainKeys, SB_DK_VERIFIER_ERROR_INVALID_TIMESTAMP, SB_DK_VERIFIER_ERROR_INVALID_TIMESTAMP, SB_DK_VERIFIER_ERROR_INVALID_TIMESTAMP);
	SB_REGISTER_LONG_CONSTANT(SBDomainKeys, SB_DK_VERIFIER_ERROR_SIGNATURE_EXPIRED, SB_DK_VERIFIER_ERROR_SIGNATURE_EXPIRED, SB_DK_VERIFIER_ERROR_SIGNATURE_EXPIRED);
	SB_REGISTER_STRING_CONSTANT(SBDomainKeys, SDKInvalidPrivateKey, SB_SDKInvalidPrivateKey, SB_SDKInvalidPrivateKey);
	SB_REGISTER_STRING_CONSTANT(SBDomainKeys, SDKInvalidSignerState, SB_SDKInvalidSignerState, SB_SDKInvalidSignerState);
	SB_REGISTER_STRING_CONSTANT(SBDomainKeys, SDKCannotGenerateKey, SB_SDKCannotGenerateKey, SB_SDKCannotGenerateKey);
}

void Register_SBDomainKeys_Enum_Flags(TSRMLS_D)
{
	zend_class_entry ce;
	INIT_CLASS_ENTRY(ce, "TSBDKPublicKeyType", NULL);
	TSBDKPublicKeyType_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBDKPublicKeyType_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBDKPublicKeyType_ce_ptr, "dkRSA", 0)
	
	INIT_CLASS_ENTRY(ce, "TSBDKCanonicalizationAlgorithm", NULL);
	TSBDKCanonicalizationAlgorithm_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBDKCanonicalizationAlgorithm_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBDKCanonicalizationAlgorithm_ce_ptr, "dkSimple", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBDKCanonicalizationAlgorithm_ce_ptr, "dkRelaxed", 1)
	
	INIT_CLASS_ENTRY(ce, "TSBDKDigestAlgorithm", NULL);
	TSBDKDigestAlgorithm_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBDKDigestAlgorithm_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBDKDigestAlgorithm_ce_ptr, "dkSHA1", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBDKDigestAlgorithm_ce_ptr, "dkSHA256", 1)
	
	INIT_CLASS_ENTRY(ce, "TSBDKQueryType", NULL);
	TSBDKQueryType_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBDKQueryType_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBDKQueryType_ce_ptr, "dkDNS", 0)
	
	INIT_CLASS_ENTRY(ce, "TSBDKStatus", NULL);
	TSBDKStatus_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBDKStatus_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBDKStatus_ce_ptr, "dkNone", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBDKStatus_ce_ptr, "dkGood", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBDKStatus_ce_ptr, "dkBad", 2)
	SB_DECLARE_CLASS_LONG_CONST(TSBDKStatus_ce_ptr, "dkNoKey", 3)
	SB_DECLARE_CLASS_LONG_CONST(TSBDKStatus_ce_ptr, "dkRevoked", 4)
	SB_DECLARE_CLASS_LONG_CONST(TSBDKStatus_ce_ptr, "dkNoSignature", 5)
	SB_DECLARE_CLASS_LONG_CONST(TSBDKStatus_ce_ptr, "dkBadFormat", 6)
	SB_DECLARE_CLASS_LONG_CONST(TSBDKStatus_ce_ptr, "dkNonParticipant", 7)
	SB_DECLARE_CLASS_LONG_CONST(TSBDKStatus_ce_ptr, "dkUnknown", 8)
	SB_DECLARE_CLASS_LONG_CONST(TSBDKStatus_ce_ptr, "dkExpired", 9)
	SB_DECLARE_CLASS_LONG_CONST(TSBDKStatus_ce_ptr, "dkNotExact", 10)
	SB_DECLARE_CLASS_LONG_CONST(TSBDKStatus_ce_ptr, "dkBadGranularity", 11)
	
	INIT_CLASS_ENTRY(ce, "TSBDomainKeysVerifierState", NULL);
	TSBDomainKeysVerifierState_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBDomainKeysVerifierState_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBDomainKeysVerifierState_ce_ptr, "dkvHeaders", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBDomainKeysVerifierState_ce_ptr, "dkvBody", 1)
	
	INIT_CLASS_ENTRY(ce, "TSBDomainKeysVerifierSignature", NULL);
	TSBDomainKeysVerifierSignature_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBDomainKeysVerifierSignature_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBDomainKeysVerifierSignature_ce_ptr, "dkvSender", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBDomainKeysVerifierSignature_ce_ptr, "dkvAuthor", 1)
	
	INIT_CLASS_ENTRY(ce, "TSBDomainKeysSignerState", NULL);
	TSBDomainKeysSignerState_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBDomainKeysSignerState_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBDomainKeysSignerState_ce_ptr, "dksHeaders", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBDomainKeysSignerState_ce_ptr, "dksBody", 1)
}

void Register_SBDomainKeys_Aliases(TSRMLS_D)
{
	if (NULL == TElDKPublicKey_ce_ptr)
		Register_TElDKPublicKey(TSRMLS_C);
	zend_register_class_alias("ElDKPublicKey", TElDKPublicKey_ce_ptr);
	if (NULL == TElDKRSAPublicKey_ce_ptr)
		Register_TElDKRSAPublicKey(TSRMLS_C);
	zend_register_class_alias("ElDKRSAPublicKey", TElDKRSAPublicKey_ce_ptr);
	if (NULL == TElDKDNSRecord_ce_ptr)
		Register_TElDKDNSRecord(TSRMLS_C);
	zend_register_class_alias("ElDKDNSRecord", TElDKDNSRecord_ce_ptr);
	if (NULL == TElDomainKeysClass_ce_ptr)
		Register_TElDomainKeysClass(TSRMLS_C);
	zend_register_class_alias("ElDomainKeysClass", TElDomainKeysClass_ce_ptr);
	if (NULL == TElDomainKeysSigner_ce_ptr)
		Register_TElDomainKeysSigner(TSRMLS_C);
	zend_register_class_alias("ElDomainKeysSigner", TElDomainKeysSigner_ce_ptr);
	if (NULL == TElDomainKeysVerifier_ce_ptr)
		Register_TElDomainKeysVerifier(TSRMLS_C);
	zend_register_class_alias("ElDomainKeysVerifier", TElDomainKeysVerifier_ce_ptr);
	if (NULL == TElDKSignature_ce_ptr)
		Register_TElDKSignature(TSRMLS_C);
	zend_register_class_alias("ElDKSignature", TElDKSignature_ce_ptr);
}
