#include "sbdropboxdatastorage.h"

zend_class_entry *TSBDropboxImageSize_ce_ptr = NULL;

void SB_CALLBACK TSBDropboxBeforeRequestSigningEventRaw(void * _ObjectData, TObjectHandle Sender, TElHTTPSClientHandle HttpClient)
{
	zval *retval_ptr;
	zval **params[2];
	zval * zSender;
	zval * zHttpClient;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zHttpClient);
	SBInitObject(zHttpClient, TElHTTPSClient_ce_ptr, HttpClient TSRMLS_CC);

	params[0] = &zSender;
	params[1] = &zHttpClient;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 2, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zHttpClient);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

zend_class_entry *TSBDropboxMetadataLocation_ce_ptr = NULL;

zend_class_entry *TSBDropboxSignatureMethod_ce_ptr = NULL;

zend_class_entry *TElDropboxDataStorage_ce_ptr = NULL;

SB_PHP_METHOD(TElDropboxDataStorage, StartAuthorization)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElDropboxDataStorage_StartAuthorization(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDropboxDataStorage, GetAuthorizationURL)
{
	char *sCallback;
	char *sLocale;
	int sCallback_len;
	int sLocale_len;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElDropboxDataStorage_GetAuthorizationURL(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1804495702, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sCallback, &sCallback_len) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElDropboxDataStorage_GetAuthorizationURL_1(SBGetObjectHandle(getThis() TSRMLS_CC), sCallback, (int32_t)sCallback_len, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-235294303, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &sCallback, &sCallback_len, &sLocale, &sLocale_len) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElDropboxDataStorage_GetAuthorizationURL_2(SBGetObjectHandle(getThis() TSRMLS_CC), sCallback, (int32_t)sCallback_len, sLocale, (int32_t)sLocale_len, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1043002105, 3, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("() or (string) or (string, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDropboxDataStorage, RequestAccessToken)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElDropboxDataStorage_RequestAccessToken(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDropboxDataStorage, StartAuthorization2)
{
	char *sRedirectURL;
	int sRedirectURL_len;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sRedirectURL, &sRedirectURL_len) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElDropboxDataStorage_StartAuthorization2(SBGetObjectHandle(getThis() TSRMLS_CC), sRedirectURL, (int32_t)sRedirectURL_len, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1134967570, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDropboxDataStorage, CompleteAuthorization2)
{
	char *sAuthorizationCode;
	int sAuthorizationCode_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sAuthorizationCode, &sAuthorizationCode_len) == SUCCESS)
	{
		SBCheckError(TElDropboxDataStorage_CompleteAuthorization2(SBGetObjectHandle(getThis() TSRMLS_CC), sAuthorizationCode, (int32_t)sAuthorizationCode_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDropboxDataStorage, CancelAuthorization2)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElDropboxDataStorage_CancelAuthorization2(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDropboxDataStorage, GetAccountInfoStr)
{
	char *sLocale;
	int sLocale_len;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElDropboxDataStorage_GetAccountInfoStr(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1948813338, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sLocale, &sLocale_len) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElDropboxDataStorage_GetAccountInfoStr_1(SBGetObjectHandle(getThis() TSRMLS_CC), sLocale, (int32_t)sLocale_len, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1017424870, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("() or (string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDropboxDataStorage, GetAccountInfo)
{
	char *sLocale;
	int sLocale_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDropboxDataStorage_GetAccountInfo(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElDropboxAccountInfo_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sLocale, &sLocale_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDropboxDataStorage_GetAccountInfo_1(SBGetObjectHandle(getThis() TSRMLS_CC), sLocale, (int32_t)sLocale_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElDropboxAccountInfo_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("() or (string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDropboxDataStorage, AcquireObject)
{
	char *sPath;
	char *sRev;
	int sPath_len;
	int sRev_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sPath, &sPath_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDropboxDataStorage_AcquireObject(SBGetObjectHandle(getThis() TSRMLS_CC), sPath, (int32_t)sPath_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElDropboxDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &sPath, &sPath_len, &sRev, &sRev_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDropboxDataStorage_AcquireObject_1(SBGetObjectHandle(getThis() TSRMLS_CC), sPath, (int32_t)sPath_len, sRev, (int32_t)sRev_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElDropboxDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDropboxDataStorage_AcquireObject_2(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string) or (string, string) or ()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDropboxDataStorage, List)
{
	char *sPath;
	int sPath_len;
	zval *oDir;
	zval *oObjects;
	zval *oObjs;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &sPath, &sPath_len, &oObjects, TElDataStorageObjectList_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElDropboxDataStorage_List(SBGetObjectHandle(getThis() TSRMLS_CC), sPath, (int32_t)sPath_len, SBGetObjectHandle(oObjects TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oDir, TElDropboxDataStorageObject_ce_ptr, &oObjects, TElDataStorageObjectList_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElDropboxDataStorage_List_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDir TSRMLS_CC), SBGetObjectHandle(oObjects TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oObjs, TElDataStorageObjectList_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElDropboxDataStorage_List_2(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObjs TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, TElDataStorageObjectList) or (TElDropboxDataStorageObject, TElDataStorageObjectList) or (TElDataStorageObjectList)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDropboxDataStorage, CreateObject)
{
	char *sPath;
	int sPath_len;
	zval *oHandler;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sPath, &sPath_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDropboxDataStorage_CreateObject(SBGetObjectHandle(getThis() TSRMLS_CC), sPath, (int32_t)sPath_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElDropboxDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &sPath, &sPath_len, &oHandler, TElCustomDataStorageSecurityHandler_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDropboxDataStorage_CreateObject_1(SBGetObjectHandle(getThis() TSRMLS_CC), sPath, (int32_t)sPath_len, SBGetObjectHandle(oHandler TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElDropboxDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string) or (string, TElCustomDataStorageSecurityHandler)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDropboxDataStorage, DeleteObject)
{
	char *sPath;
	int sPath_len;
	TElClassHandle hoObj;
	zval *oObj;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sPath, &sPath_len) == SUCCESS)
	{
		SBCheckError(TElDropboxDataStorage_DeleteObject(SBGetObjectHandle(getThis() TSRMLS_CC), sPath, (int32_t)sPath_len) TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &oObj, TElDropboxDataStorageObject_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oObj) && (IS_OBJECT == Z_TYPE_P(oObj)))
	{
		hoObj = SBGetObjectHandle(oObj TSRMLS_CC);
		SBCheckError(TElDropboxDataStorage_DeleteObject_1(SBGetObjectHandle(getThis() TSRMLS_CC), &hoObj) TSRMLS_CC);
		SBUpdateObjectHandle(oObj, hoObj TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &oObj, TElCustomDataStorageObject_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oObj) && (IS_OBJECT == Z_TYPE_P(oObj)))
	{
		hoObj = SBGetObjectHandle(oObj TSRMLS_CC);
		SBCheckError(TElDropboxDataStorage_DeleteObject_2(SBGetObjectHandle(getThis() TSRMLS_CC), &hoObj) TSRMLS_CC);
		SBUpdateObjectHandle(oObj, hoObj TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string) or (&TElDropboxDataStorageObject) or (&TElCustomDataStorageObject)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDropboxDataStorage, ObjectExists)
{
	char *sPath;
	char *sRev;
	int sPath_len;
	int sRev_len;
	zval *oObj;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sPath, &sPath_len) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElDropboxDataStorage_ObjectExists(SBGetObjectHandle(getThis() TSRMLS_CC), sPath, (int32_t)sPath_len, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &sPath, &sPath_len, &sRev, &sRev_len) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElDropboxDataStorage_ObjectExists_1(SBGetObjectHandle(getThis() TSRMLS_CC), sPath, (int32_t)sPath_len, sRev, (int32_t)sRev_len, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oObj, TElDropboxDataStorageObject_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElDropboxDataStorage_ObjectExists_2(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObj TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string) or (string, string) or (TElDropboxDataStorageObject)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDropboxDataStorage, RefreshObject)
{
	zval *oObj;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oObj, TElDropboxDataStorageObject_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElDropboxDataStorage_RefreshObject(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObj TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElDropboxDataStorageObject)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDropboxDataStorage, WriteObject)
{
	char *sParentRev;
	char *sPath;
	int sParentRev_len;
	int sPath_len;
	zend_bool bOverwrite;
	zval *oData;
	zval *oHandler;
	zval *oObj;
	zval *oStrm;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sbsO!O!", &sPath, &sPath_len, &bOverwrite, &sParentRev, &sParentRev_len, &oData, TStream_ce_ptr, &oHandler, TElCustomDataStorageSecurityHandler_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElDropboxDataStorage_WriteObject(SBGetObjectHandle(getThis() TSRMLS_CC), sPath, (int32_t)sPath_len, (int8_t)bOverwrite, sParentRev, (int32_t)sParentRev_len, SBGetObjectHandle(oData TSRMLS_CC), SBGetObjectHandle(oHandler TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!O!", &sPath, &sPath_len, &oData, TStream_ce_ptr, &oHandler, TElCustomDataStorageSecurityHandler_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElDropboxDataStorage_WriteObject_1(SBGetObjectHandle(getThis() TSRMLS_CC), sPath, (int32_t)sPath_len, SBGetObjectHandle(oData TSRMLS_CC), SBGetObjectHandle(oHandler TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!O!", &oObj, TElDropboxDataStorageObject_ce_ptr, &oData, TStream_ce_ptr, &oHandler, TElCustomDataStorageSecurityHandler_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElDropboxDataStorage_WriteObject_2(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObj TSRMLS_CC), SBGetObjectHandle(oData TSRMLS_CC), SBGetObjectHandle(oHandler TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!O!", &oObj, TElCustomDataStorageObject_ce_ptr, &oStrm, TStream_ce_ptr, &oHandler, TElCustomDataStorageSecurityHandler_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElDropboxDataStorage_WriteObject_3(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObj TSRMLS_CC), SBGetObjectHandle(oStrm TSRMLS_CC), SBGetObjectHandle(oHandler TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, bool, string, TStream, TElCustomDataStorageSecurityHandler) or (string, TStream, TElCustomDataStorageSecurityHandler) or (TElDropboxDataStorageObject, TStream, TElCustomDataStorageSecurityHandler) or (TElCustomDataStorageObject, TStream, TElCustomDataStorageSecurityHandler)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDropboxDataStorage, ReadObject)
{
	char *sPath;
	char *sRev;
	int sPath_len;
	int sRev_len;
	zval *oObj;
	zval *oStrm;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &sPath, &sPath_len, &oStrm, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElDropboxDataStorage_ReadObject(SBGetObjectHandle(getThis() TSRMLS_CC), sPath, (int32_t)sPath_len, SBGetObjectHandle(oStrm TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!", &sPath, &sPath_len, &sRev, &sRev_len, &oStrm, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElDropboxDataStorage_ReadObject_1(SBGetObjectHandle(getThis() TSRMLS_CC), sPath, (int32_t)sPath_len, sRev, (int32_t)sRev_len, SBGetObjectHandle(oStrm TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oObj, TElDropboxDataStorageObject_ce_ptr, &oStrm, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElDropboxDataStorage_ReadObject_2(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObj TSRMLS_CC), SBGetObjectHandle(oStrm TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!sO!", &oObj, TElDropboxDataStorageObject_ce_ptr, &sRev, &sRev_len, &oStrm, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElDropboxDataStorage_ReadObject_3(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObj TSRMLS_CC), sRev, (int32_t)sRev_len, SBGetObjectHandle(oStrm TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oObj, TElCustomDataStorageObject_ce_ptr, &oStrm, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElDropboxDataStorage_ReadObject_4(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObj TSRMLS_CC), SBGetObjectHandle(oStrm TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, TStream) or (string, string, TStream) or (TElDropboxDataStorageObject, TStream) or (TElDropboxDataStorageObject, string, TStream) or (TElCustomDataStorageObject, TStream)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDropboxDataStorage, ReadBlock)
{
	char *sPath;
	char *sRev;
	int sPath_len;
	int sRev_len;
	int64_t l8ReadRaw;
	long l8Offset;
	long l8Size;
	zval *oObj;
	zval *oStrm;
	zval *zl8Read;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!llz", &sPath, &sPath_len, &oStrm, TStream_ce_ptr, &l8Offset, &l8Size, &zl8Read) == SUCCESS) && PZVAL_IS_REF(zl8Read) && (IS_LONG == Z_TYPE_P(zl8Read)))
	{
		l8ReadRaw = (int64_t)Z_LVAL_P(zl8Read);
		SBCheckError(TElDropboxDataStorage_ReadBlock(SBGetObjectHandle(getThis() TSRMLS_CC), sPath, (int32_t)sPath_len, SBGetObjectHandle(oStrm TSRMLS_CC), (int64_t)l8Offset, (int64_t)l8Size, &l8ReadRaw) TSRMLS_CC);
		ZVAL_LONG(zl8Read, (long)l8ReadRaw);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!llzs", &sPath, &sPath_len, &oStrm, TStream_ce_ptr, &l8Offset, &l8Size, &zl8Read, &sRev, &sRev_len) == SUCCESS) && PZVAL_IS_REF(zl8Read) && (IS_LONG == Z_TYPE_P(zl8Read)))
	{
		l8ReadRaw = (int64_t)Z_LVAL_P(zl8Read);
		SBCheckError(TElDropboxDataStorage_ReadBlock_1(SBGetObjectHandle(getThis() TSRMLS_CC), sPath, (int32_t)sPath_len, SBGetObjectHandle(oStrm TSRMLS_CC), (int64_t)l8Offset, (int64_t)l8Size, &l8ReadRaw, sRev, (int32_t)sRev_len) TSRMLS_CC);
		ZVAL_LONG(zl8Read, (long)l8ReadRaw);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!llz", &oObj, TElCustomDataStorageObject_ce_ptr, &oStrm, TStream_ce_ptr, &l8Offset, &l8Size, &zl8Read) == SUCCESS) && PZVAL_IS_REF(zl8Read) && (IS_LONG == Z_TYPE_P(zl8Read)))
	{
		l8ReadRaw = (int64_t)Z_LVAL_P(zl8Read);
		SBCheckError(TElDropboxDataStorage_ReadBlock_2(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObj TSRMLS_CC), SBGetObjectHandle(oStrm TSRMLS_CC), (int64_t)l8Offset, (int64_t)l8Size, &l8ReadRaw) TSRMLS_CC);
		ZVAL_LONG(zl8Read, (long)l8ReadRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string, TStream, integer, integer, &integer) or (string, TStream, integer, integer, &integer, string) or (TElCustomDataStorageObject, TStream, integer, integer, &integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDropboxDataStorage, Search)
{
	char *sPath;
	char *sQuery;
	int sPath_len;
	int sQuery_len;
	zend_bool bIncludeDeleted;
	zval *oObjects;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssbO!", &sPath, &sPath_len, &sQuery, &sQuery_len, &bIncludeDeleted, &oObjects, TElDataStorageObjectList_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElDropboxDataStorage_Search(SBGetObjectHandle(getThis() TSRMLS_CC), sPath, (int32_t)sPath_len, sQuery, (int32_t)sQuery_len, (int8_t)bIncludeDeleted, SBGetObjectHandle(oObjects TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!", &sPath, &sPath_len, &sQuery, &sQuery_len, &oObjects, TElDataStorageObjectList_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElDropboxDataStorage_Search_1(SBGetObjectHandle(getThis() TSRMLS_CC), sPath, (int32_t)sPath_len, sQuery, (int32_t)sQuery_len, SBGetObjectHandle(oObjects TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, string, bool, TElDataStorageObjectList) or (string, string, TElDataStorageObjectList)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDropboxDataStorage, CopyObject)
{
	char *sDestPath;
	char *sSourcePath;
	int sDestPath_len;
	int sSourcePath_len;
	zend_bool bAcquireObject;
	zval *oNewHandler;
	zval *oObj;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!", &sSourcePath, &sSourcePath_len, &sDestPath, &sDestPath_len, &oNewHandler, TElCustomDataStorageSecurityHandler_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDropboxDataStorage_CopyObject(SBGetObjectHandle(getThis() TSRMLS_CC), sSourcePath, (int32_t)sSourcePath_len, sDestPath, (int32_t)sDestPath_len, SBGetObjectHandle(oNewHandler TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!sO!", &oObj, TElDropboxDataStorageObject_ce_ptr, &sDestPath, &sDestPath_len, &oNewHandler, TElCustomDataStorageSecurityHandler_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDropboxDataStorage_CopyObject_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObj TSRMLS_CC), sDestPath, (int32_t)sDestPath_len, SBGetObjectHandle(oNewHandler TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!b", &sSourcePath, &sSourcePath_len, &sDestPath, &sDestPath_len, &oNewHandler, TElCustomDataStorageSecurityHandler_ce_ptr, &bAcquireObject) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDropboxDataStorage_CopyObject_2(SBGetObjectHandle(getThis() TSRMLS_CC), sSourcePath, (int32_t)sSourcePath_len, sDestPath, (int32_t)sDestPath_len, SBGetObjectHandle(oNewHandler TSRMLS_CC), (int8_t)bAcquireObject, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!sO!b", &oObj, TElDropboxDataStorageObject_ce_ptr, &sDestPath, &sDestPath_len, &oNewHandler, TElCustomDataStorageSecurityHandler_ce_ptr, &bAcquireObject) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDropboxDataStorage_CopyObject_3(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObj TSRMLS_CC), sDestPath, (int32_t)sDestPath_len, SBGetObjectHandle(oNewHandler TSRMLS_CC), (int8_t)bAcquireObject, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oObj, TElCustomDataStorageObject_ce_ptr, &oNewHandler, TElCustomDataStorageSecurityHandler_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDropboxDataStorage_CopyObject_4(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObj TSRMLS_CC), SBGetObjectHandle(oNewHandler TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, string, TElCustomDataStorageSecurityHandler) or (TElDropboxDataStorageObject, string, TElCustomDataStorageSecurityHandler) or (string, string, TElCustomDataStorageSecurityHandler, bool) or (TElDropboxDataStorageObject, string, TElCustomDataStorageSecurityHandler, bool) or (TElCustomDataStorageObject, TElCustomDataStorageSecurityHandler)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDropboxDataStorage, CopyObjectFromRef)
{
	char *sCopyRef;
	char *sDestPath;
	int sCopyRef_len;
	int sDestPath_len;
	zend_bool bAcquireObject;
	zval *oNewHandler;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!", &sCopyRef, &sCopyRef_len, &sDestPath, &sDestPath_len, &oNewHandler, TElCustomDataStorageSecurityHandler_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDropboxDataStorage_CopyObjectFromRef(SBGetObjectHandle(getThis() TSRMLS_CC), sCopyRef, (int32_t)sCopyRef_len, sDestPath, (int32_t)sDestPath_len, SBGetObjectHandle(oNewHandler TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!b", &sCopyRef, &sCopyRef_len, &sDestPath, &sDestPath_len, &oNewHandler, TElCustomDataStorageSecurityHandler_ce_ptr, &bAcquireObject) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDropboxDataStorage_CopyObjectFromRef_1(SBGetObjectHandle(getThis() TSRMLS_CC), sCopyRef, (int32_t)sCopyRef_len, sDestPath, (int32_t)sDestPath_len, SBGetObjectHandle(oNewHandler TSRMLS_CC), (int8_t)bAcquireObject, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, string, TElCustomDataStorageSecurityHandler) or (string, string, TElCustomDataStorageSecurityHandler, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDropboxDataStorage, CreateCopyReference)
{
	char *sPath;
	int sPath_len;
	uint32_t _err;
	zval *oObj;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sPath, &sPath_len) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElDropboxDataStorage_CreateCopyReference(SBGetObjectHandle(getThis() TSRMLS_CC), sPath, (int32_t)sPath_len, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1952279600, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oObj, TElDropboxDataStorageObject_ce_ptr) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElDropboxDataStorage_CreateCopyReference_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObj TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1297178625, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(string) or (TElDropboxDataStorageObject)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDropboxDataStorage, GetDirectLink)
{
	char *sPath;
	int sPath_len;
	uint32_t _err;
	zval *oObj;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sPath, &sPath_len) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElDropboxDataStorage_GetDirectLink(SBGetObjectHandle(getThis() TSRMLS_CC), sPath, (int32_t)sPath_len, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(494592404, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oObj, TElDropboxDataStorageObject_ce_ptr) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElDropboxDataStorage_GetDirectLink_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObj TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-692974712, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(string) or (TElDropboxDataStorageObject)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDropboxDataStorage, GetPreviewLink)
{
	char *sPath;
	int sPath_len;
	uint32_t _err;
	zend_bool bShort;
	zval *oObj;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sb", &sPath, &sPath_len, &bShort) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElDropboxDataStorage_GetPreviewLink(SBGetObjectHandle(getThis() TSRMLS_CC), sPath, (int32_t)sPath_len, (int8_t)bShort, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-563713125, 3, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!b", &oObj, TElDropboxDataStorageObject_ce_ptr, &bShort) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElDropboxDataStorage_GetPreviewLink_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObj TSRMLS_CC), (int8_t)bShort, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(820585221, 3, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(string, bool) or (TElDropboxDataStorageObject, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDropboxDataStorage, GetThumbnail)
{
	char *sFormat;
	char *sImageFormat;
	char *sPath;
	int sFormat_len;
	int sImageFormat_len;
	int sPath_len;
	long fSize;
	zval *oObj;
	zval *oStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sslO!", &sPath, &sPath_len, &sImageFormat, &sImageFormat_len, &fSize, &oStream, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElDropboxDataStorage_GetThumbnail(SBGetObjectHandle(getThis() TSRMLS_CC), sPath, (int32_t)sPath_len, sImageFormat, (int32_t)sImageFormat_len, (TSBDropboxImageSizeRaw)fSize, SBGetObjectHandle(oStream TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!slO!", &oObj, TElDropboxDataStorageObject_ce_ptr, &sFormat, &sFormat_len, &fSize, &oStream, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElDropboxDataStorage_GetThumbnail_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObj TSRMLS_CC), sFormat, (int32_t)sFormat_len, (TSBDropboxImageSizeRaw)fSize, SBGetObjectHandle(oStream TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, string, integer, TStream) or (TElDropboxDataStorageObject, string, integer, TStream)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDropboxDataStorage, CreateFolder)
{
	char *sPath;
	int sPath_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sPath, &sPath_len) == SUCCESS)
	{
		SBCheckError(TElDropboxDataStorage_CreateFolder(SBGetObjectHandle(getThis() TSRMLS_CC), sPath, (int32_t)sPath_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDropboxDataStorage, RenameObject)
{
	char *sDestPath;
	char *sSourcePath;
	int sDestPath_len;
	int sSourcePath_len;
	zval *oObj;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &sSourcePath, &sSourcePath_len, &sDestPath, &sDestPath_len) == SUCCESS)
	{
		SBCheckError(TElDropboxDataStorage_RenameObject(SBGetObjectHandle(getThis() TSRMLS_CC), sSourcePath, (int32_t)sSourcePath_len, sDestPath, (int32_t)sDestPath_len) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!s", &oObj, TElDropboxDataStorageObject_ce_ptr, &sDestPath, &sDestPath_len) == SUCCESS)
	{
		SBCheckError(TElDropboxDataStorage_RenameObject_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObj TSRMLS_CC), sDestPath, (int32_t)sDestPath_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, string) or (TElDropboxDataStorageObject, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDropboxDataStorage, RestoreObject)
{
	char *sPath;
	char *sRev;
	int sPath_len;
	int sRev_len;
	zend_bool bAcquireObject;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &sPath, &sPath_len, &sRev, &sRev_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDropboxDataStorage_RestoreObject(SBGetObjectHandle(getThis() TSRMLS_CC), sPath, (int32_t)sPath_len, sRev, (int32_t)sRev_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElDropboxDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssb", &sPath, &sPath_len, &sRev, &sRev_len, &bAcquireObject) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDropboxDataStorage_RestoreObject_1(SBGetObjectHandle(getThis() TSRMLS_CC), sPath, (int32_t)sPath_len, sRev, (int32_t)sRev_len, (int8_t)bAcquireObject, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElDropboxDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, string) or (string, string, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDropboxDataStorage, ListRevisions)
{
	char *sPath;
	int sPath_len;
	zval *oObj;
	zval *oObjects;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &sPath, &sPath_len, &oObjects, TElDataStorageObjectList_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElDropboxDataStorage_ListRevisions(SBGetObjectHandle(getThis() TSRMLS_CC), sPath, (int32_t)sPath_len, SBGetObjectHandle(oObjects TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oObj, TElDropboxDataStorageObject_ce_ptr, &oObjects, TElDataStorageObjectList_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElDropboxDataStorage_ListRevisions_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObj TSRMLS_CC), SBGetObjectHandle(oObjects TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, TElDataStorageObjectList) or (TElDropboxDataStorageObject, TElDataStorageObjectList)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDropboxDataStorage, get_HTTPClient)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDropboxDataStorage_get_HTTPClient(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElHTTPSClient_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDropboxDataStorage, set_HTTPClient)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElHTTPSClient_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElDropboxDataStorage_set_HTTPClient(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElHTTPSClient)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDropboxDataStorage, get_AccessToken)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElDropboxDataStorage_get_AccessToken(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(179022786, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDropboxDataStorage, set_AccessToken)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElDropboxDataStorage_set_AccessToken(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDropboxDataStorage, get_AppKey)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElDropboxDataStorage_get_AppKey(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(171814792, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDropboxDataStorage, set_AppKey)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElDropboxDataStorage_set_AppKey(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDropboxDataStorage, get_AppSecret)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElDropboxDataStorage_get_AppSecret(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1449592817, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDropboxDataStorage, set_AppSecret)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElDropboxDataStorage_set_AppSecret(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDropboxDataStorage, get_AuthToken)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElDropboxDataStorage_get_AuthToken(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1133013533, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDropboxDataStorage, set_AuthToken)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElDropboxDataStorage_set_AuthToken(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDropboxDataStorage, get_AuthTokenSecret)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElDropboxDataStorage_get_AuthTokenSecret(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1498813037, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDropboxDataStorage, set_AuthTokenSecret)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElDropboxDataStorage_set_AuthTokenSecret(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDropboxDataStorage, get_Root)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElDropboxDataStorage_get_Root(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-137355361, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDropboxDataStorage, set_Root)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElDropboxDataStorage_set_Root(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDropboxDataStorage, get_MetadataLocation)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBDropboxMetadataLocationRaw fOutResultRaw = 0;
		SBCheckError(TElDropboxDataStorage_get_MetadataLocation(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDropboxDataStorage, set_MetadataLocation)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElDropboxDataStorage_set_MetadataLocation(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBDropboxMetadataLocationRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDropboxDataStorage, get_MetadataExtension)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElDropboxDataStorage_get_MetadataExtension(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(462771696, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDropboxDataStorage, set_MetadataExtension)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElDropboxDataStorage_set_MetadataExtension(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDropboxDataStorage, get_MetadataDirName)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElDropboxDataStorage_get_MetadataDirName(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-728396742, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDropboxDataStorage, set_MetadataDirName)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElDropboxDataStorage_set_MetadataDirName(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDropboxDataStorage, get_SignatureMethod)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBDropboxSignatureMethodRaw fOutResultRaw = 0;
		SBCheckError(TElDropboxDataStorage_get_SignatureMethod(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDropboxDataStorage, set_SignatureMethod)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElDropboxDataStorage_set_SignatureMethod(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBDropboxSignatureMethodRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDropboxDataStorage, get_ChunkedUploadThreshold)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElDropboxDataStorage_get_ChunkedUploadThreshold(SBGetObjectHandle(getThis() TSRMLS_CC), &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDropboxDataStorage, set_ChunkedUploadThreshold)
{
	long l8Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l8Value) == SUCCESS)
	{
		SBCheckError(TElDropboxDataStorage_set_ChunkedUploadThreshold(SBGetObjectHandle(getThis() TSRMLS_CC), (int64_t)l8Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDropboxDataStorage, get_ChunkedUploadChunkSize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElDropboxDataStorage_get_ChunkedUploadChunkSize(SBGetObjectHandle(getThis() TSRMLS_CC), &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDropboxDataStorage, set_ChunkedUploadChunkSize)
{
	long l8Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l8Value) == SUCCESS)
	{
		SBCheckError(TElDropboxDataStorage_set_ChunkedUploadChunkSize(SBGetObjectHandle(getThis() TSRMLS_CC), (int64_t)l8Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDropboxDataStorage, get_DefaultLocale)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElDropboxDataStorage_get_DefaultLocale(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-2059025256, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDropboxDataStorage, set_DefaultLocale)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElDropboxDataStorage_set_DefaultLocale(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDropboxDataStorage, get_HideMetadataObjects)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElDropboxDataStorage_get_HideMetadataObjects(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDropboxDataStorage, set_HideMetadataObjects)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElDropboxDataStorage_set_HideMetadataObjects(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDropboxDataStorage, get_PickMetadataOnList)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElDropboxDataStorage_get_PickMetadataOnList(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDropboxDataStorage, set_PickMetadataOnList)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElDropboxDataStorage_set_PickMetadataOnList(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDropboxDataStorage, get_Overwrite)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElDropboxDataStorage_get_Overwrite(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDropboxDataStorage, set_Overwrite)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElDropboxDataStorage_set_Overwrite(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDropboxDataStorage, get_PassthroughMode)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElDropboxDataStorage_get_PassthroughMode(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDropboxDataStorage, set_PassthroughMode)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElDropboxDataStorage_set_PassthroughMode(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDropboxDataStorage, get_EmbeddedMetadataMode)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElDropboxDataStorage_get_EmbeddedMetadataMode(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDropboxDataStorage, set_EmbeddedMetadataMode)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElDropboxDataStorage_set_EmbeddedMetadataMode(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDropboxDataStorage, get_OnBeforeRequestSigning)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBDropboxBeforeRequestSigningEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElDropboxDataStorage_get_OnBeforeRequestSigning(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDropboxDataStorage, set_OnBeforeRequestSigning)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElDropboxDataStorage_set_OnBeforeRequestSigning(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBDropboxBeforeRequestSigningEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBDropboxBeforeRequestSigningEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDropboxDataStorage, __construct)
{
	zval *oAOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDropboxDataStorage_Create(SBGetObjectHandle(oAOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDropboxDataStorage_StartAuthorization, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDropboxDataStorage_GetAuthorizationURL, 0, 0, 0)
	ZEND_ARG_INFO(0, Callback)
	ZEND_ARG_INFO(0, Locale)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDropboxDataStorage_RequestAccessToken, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDropboxDataStorage_StartAuthorization2, 0, 0, 1)
	ZEND_ARG_INFO(0, RedirectURL)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDropboxDataStorage_CompleteAuthorization2, 0, 0, 1)
	ZEND_ARG_INFO(0, AuthorizationCode)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDropboxDataStorage_CancelAuthorization2, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDropboxDataStorage_GetAccountInfoStr, 0, 0, 0)
	ZEND_ARG_INFO(0, Locale)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDropboxDataStorage_GetAccountInfo, 0, 0, 0)
	ZEND_ARG_INFO(0, Locale)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDropboxDataStorage_AcquireObject, 0, 0, 0)
	ZEND_ARG_INFO(0, Path)
	ZEND_ARG_INFO(0, Rev)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDropboxDataStorage_List, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Path_or_Dir_or_Objs, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Objects, TElDataStorageObjectList, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDropboxDataStorage_CreateObject, 0, 0, 1)
	ZEND_ARG_INFO(0, Path)
	ZEND_ARG_OBJ_INFO(0, Handler, TElCustomDataStorageSecurityHandler, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDropboxDataStorage_DeleteObject, 0, 0, 1)
	ZEND_ARG_INFO(1, Path_or_Obj)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDropboxDataStorage_ObjectExists, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Path_or_Obj, 0, 1)
	ZEND_ARG_INFO(0, Rev)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDropboxDataStorage_RefreshObject, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Obj, TElDropboxDataStorageObject, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDropboxDataStorage_WriteObject, 0, 0, 3)
	ZEND_ARG_TYPE_INFO(0, Path_or_Obj, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Overwrite_or_Data_or_Strm, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ParentRev_or_Handler, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Data, TStream, 1)
	ZEND_ARG_OBJ_INFO(0, Handler, TElCustomDataStorageSecurityHandler, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDropboxDataStorage_ReadObject, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Path_or_Obj, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Strm_or_Rev, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Strm, TStream, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDropboxDataStorage_ReadBlock, 0, 0, 5)
	ZEND_ARG_TYPE_INFO(0, Path_or_Obj, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Strm, 0, 1)
	ZEND_ARG_INFO(0, Offset)
	ZEND_ARG_INFO(0, Size)
	ZEND_ARG_INFO(1, Read)
	ZEND_ARG_INFO(0, Rev)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDropboxDataStorage_Search, 0, 0, 3)
	ZEND_ARG_INFO(0, Path)
	ZEND_ARG_INFO(0, Query)
	ZEND_ARG_TYPE_INFO(0, IncludeDeleted_or_Objects, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Objects, TElDataStorageObjectList, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDropboxDataStorage_CopyObject, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, SourcePath_or_Obj, 0, 1)
	ZEND_ARG_TYPE_INFO(0, DestPath_or_NewHandler, 0, 1)
	ZEND_ARG_OBJ_INFO(0, NewHandler, TElCustomDataStorageSecurityHandler, 1)
	ZEND_ARG_INFO(0, AcquireObject)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDropboxDataStorage_CopyObjectFromRef, 0, 0, 3)
	ZEND_ARG_INFO(0, CopyRef)
	ZEND_ARG_INFO(0, DestPath)
	ZEND_ARG_OBJ_INFO(0, NewHandler, TElCustomDataStorageSecurityHandler, 1)
	ZEND_ARG_INFO(0, AcquireObject)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDropboxDataStorage_CreateCopyReference, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Path_or_Obj, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDropboxDataStorage_GetDirectLink, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Path_or_Obj, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDropboxDataStorage_GetPreviewLink, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Path_or_Obj, 0, 1)
	ZEND_ARG_INFO(0, Short)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDropboxDataStorage_GetThumbnail, 0, 0, 4)
	ZEND_ARG_TYPE_INFO(0, Path_or_Obj, 0, 1)
	ZEND_ARG_INFO(0, ImageFormat_or_Format)
	ZEND_ARG_INFO(0, Size)
	ZEND_ARG_OBJ_INFO(0, Stream, TStream, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDropboxDataStorage_CreateFolder, 0, 0, 1)
	ZEND_ARG_INFO(0, Path)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDropboxDataStorage_RenameObject, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, SourcePath_or_Obj, 0, 1)
	ZEND_ARG_INFO(0, DestPath)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDropboxDataStorage_RestoreObject, 0, 0, 2)
	ZEND_ARG_INFO(0, Path)
	ZEND_ARG_INFO(0, Rev)
	ZEND_ARG_INFO(0, AcquireObject)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDropboxDataStorage_ListRevisions, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Path_or_Obj, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Objects, TElDataStorageObjectList, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDropboxDataStorage_get_HTTPClient, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDropboxDataStorage_set_HTTPClient, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElHTTPSClient, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDropboxDataStorage_get_AccessToken, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDropboxDataStorage_set_AccessToken, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDropboxDataStorage_get_AppKey, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDropboxDataStorage_set_AppKey, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDropboxDataStorage_get_AppSecret, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDropboxDataStorage_set_AppSecret, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDropboxDataStorage_get_AuthToken, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDropboxDataStorage_set_AuthToken, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDropboxDataStorage_get_AuthTokenSecret, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDropboxDataStorage_set_AuthTokenSecret, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDropboxDataStorage_get_Root, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDropboxDataStorage_set_Root, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDropboxDataStorage_get_MetadataLocation, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDropboxDataStorage_set_MetadataLocation, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDropboxDataStorage_get_MetadataExtension, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDropboxDataStorage_set_MetadataExtension, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDropboxDataStorage_get_MetadataDirName, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDropboxDataStorage_set_MetadataDirName, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDropboxDataStorage_get_SignatureMethod, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDropboxDataStorage_set_SignatureMethod, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDropboxDataStorage_get_ChunkedUploadThreshold, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDropboxDataStorage_set_ChunkedUploadThreshold, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDropboxDataStorage_get_ChunkedUploadChunkSize, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDropboxDataStorage_set_ChunkedUploadChunkSize, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDropboxDataStorage_get_DefaultLocale, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDropboxDataStorage_set_DefaultLocale, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDropboxDataStorage_get_HideMetadataObjects, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDropboxDataStorage_set_HideMetadataObjects, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDropboxDataStorage_get_PickMetadataOnList, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDropboxDataStorage_set_PickMetadataOnList, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDropboxDataStorage_get_Overwrite, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDropboxDataStorage_set_Overwrite, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDropboxDataStorage_get_PassthroughMode, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDropboxDataStorage_set_PassthroughMode, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDropboxDataStorage_get_EmbeddedMetadataMode, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDropboxDataStorage_set_EmbeddedMetadataMode, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDropboxDataStorage_get_OnBeforeRequestSigning, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDropboxDataStorage_set_OnBeforeRequestSigning, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDropboxDataStorage___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AOwner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElDropboxDataStorage_methods[] = {
	PHP_ME(TElDropboxDataStorage, StartAuthorization, arginfo_TElDropboxDataStorage_StartAuthorization, ZEND_ACC_PUBLIC)
	PHP_ME(TElDropboxDataStorage, GetAuthorizationURL, arginfo_TElDropboxDataStorage_GetAuthorizationURL, ZEND_ACC_PUBLIC)
	PHP_ME(TElDropboxDataStorage, RequestAccessToken, arginfo_TElDropboxDataStorage_RequestAccessToken, ZEND_ACC_PUBLIC)
	PHP_ME(TElDropboxDataStorage, StartAuthorization2, arginfo_TElDropboxDataStorage_StartAuthorization2, ZEND_ACC_PUBLIC)
	PHP_ME(TElDropboxDataStorage, CompleteAuthorization2, arginfo_TElDropboxDataStorage_CompleteAuthorization2, ZEND_ACC_PUBLIC)
	PHP_ME(TElDropboxDataStorage, CancelAuthorization2, arginfo_TElDropboxDataStorage_CancelAuthorization2, ZEND_ACC_PUBLIC)
	PHP_ME(TElDropboxDataStorage, GetAccountInfoStr, arginfo_TElDropboxDataStorage_GetAccountInfoStr, ZEND_ACC_PUBLIC)
	PHP_ME(TElDropboxDataStorage, GetAccountInfo, arginfo_TElDropboxDataStorage_GetAccountInfo, ZEND_ACC_PUBLIC)
	PHP_ME(TElDropboxDataStorage, AcquireObject, arginfo_TElDropboxDataStorage_AcquireObject, ZEND_ACC_PUBLIC)
	PHP_ME(TElDropboxDataStorage, List, arginfo_TElDropboxDataStorage_List, ZEND_ACC_PUBLIC)
	PHP_ME(TElDropboxDataStorage, CreateObject, arginfo_TElDropboxDataStorage_CreateObject, ZEND_ACC_PUBLIC)
	PHP_ME(TElDropboxDataStorage, DeleteObject, arginfo_TElDropboxDataStorage_DeleteObject, ZEND_ACC_PUBLIC)
	PHP_ME(TElDropboxDataStorage, ObjectExists, arginfo_TElDropboxDataStorage_ObjectExists, ZEND_ACC_PUBLIC)
	PHP_ME(TElDropboxDataStorage, RefreshObject, arginfo_TElDropboxDataStorage_RefreshObject, ZEND_ACC_PUBLIC)
	PHP_ME(TElDropboxDataStorage, WriteObject, arginfo_TElDropboxDataStorage_WriteObject, ZEND_ACC_PUBLIC)
	PHP_ME(TElDropboxDataStorage, ReadObject, arginfo_TElDropboxDataStorage_ReadObject, ZEND_ACC_PUBLIC)
	PHP_ME(TElDropboxDataStorage, ReadBlock, arginfo_TElDropboxDataStorage_ReadBlock, ZEND_ACC_PUBLIC)
	PHP_ME(TElDropboxDataStorage, Search, arginfo_TElDropboxDataStorage_Search, ZEND_ACC_PUBLIC)
	PHP_ME(TElDropboxDataStorage, CopyObject, arginfo_TElDropboxDataStorage_CopyObject, ZEND_ACC_PUBLIC)
	PHP_ME(TElDropboxDataStorage, CopyObjectFromRef, arginfo_TElDropboxDataStorage_CopyObjectFromRef, ZEND_ACC_PUBLIC)
	PHP_ME(TElDropboxDataStorage, CreateCopyReference, arginfo_TElDropboxDataStorage_CreateCopyReference, ZEND_ACC_PUBLIC)
	PHP_ME(TElDropboxDataStorage, GetDirectLink, arginfo_TElDropboxDataStorage_GetDirectLink, ZEND_ACC_PUBLIC)
	PHP_ME(TElDropboxDataStorage, GetPreviewLink, arginfo_TElDropboxDataStorage_GetPreviewLink, ZEND_ACC_PUBLIC)
	PHP_ME(TElDropboxDataStorage, GetThumbnail, arginfo_TElDropboxDataStorage_GetThumbnail, ZEND_ACC_PUBLIC)
	PHP_ME(TElDropboxDataStorage, CreateFolder, arginfo_TElDropboxDataStorage_CreateFolder, ZEND_ACC_PUBLIC)
	PHP_ME(TElDropboxDataStorage, RenameObject, arginfo_TElDropboxDataStorage_RenameObject, ZEND_ACC_PUBLIC)
	PHP_ME(TElDropboxDataStorage, RestoreObject, arginfo_TElDropboxDataStorage_RestoreObject, ZEND_ACC_PUBLIC)
	PHP_ME(TElDropboxDataStorage, ListRevisions, arginfo_TElDropboxDataStorage_ListRevisions, ZEND_ACC_PUBLIC)
	PHP_ME(TElDropboxDataStorage, get_HTTPClient, arginfo_TElDropboxDataStorage_get_HTTPClient, ZEND_ACC_PUBLIC)
	PHP_ME(TElDropboxDataStorage, set_HTTPClient, arginfo_TElDropboxDataStorage_set_HTTPClient, ZEND_ACC_PUBLIC)
	PHP_ME(TElDropboxDataStorage, get_AccessToken, arginfo_TElDropboxDataStorage_get_AccessToken, ZEND_ACC_PUBLIC)
	PHP_ME(TElDropboxDataStorage, set_AccessToken, arginfo_TElDropboxDataStorage_set_AccessToken, ZEND_ACC_PUBLIC)
	PHP_ME(TElDropboxDataStorage, get_AppKey, arginfo_TElDropboxDataStorage_get_AppKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElDropboxDataStorage, set_AppKey, arginfo_TElDropboxDataStorage_set_AppKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElDropboxDataStorage, get_AppSecret, arginfo_TElDropboxDataStorage_get_AppSecret, ZEND_ACC_PUBLIC)
	PHP_ME(TElDropboxDataStorage, set_AppSecret, arginfo_TElDropboxDataStorage_set_AppSecret, ZEND_ACC_PUBLIC)
	PHP_ME(TElDropboxDataStorage, get_AuthToken, arginfo_TElDropboxDataStorage_get_AuthToken, ZEND_ACC_PUBLIC)
	PHP_ME(TElDropboxDataStorage, set_AuthToken, arginfo_TElDropboxDataStorage_set_AuthToken, ZEND_ACC_PUBLIC)
	PHP_ME(TElDropboxDataStorage, get_AuthTokenSecret, arginfo_TElDropboxDataStorage_get_AuthTokenSecret, ZEND_ACC_PUBLIC)
	PHP_ME(TElDropboxDataStorage, set_AuthTokenSecret, arginfo_TElDropboxDataStorage_set_AuthTokenSecret, ZEND_ACC_PUBLIC)
	PHP_ME(TElDropboxDataStorage, get_Root, arginfo_TElDropboxDataStorage_get_Root, ZEND_ACC_PUBLIC)
	PHP_ME(TElDropboxDataStorage, set_Root, arginfo_TElDropboxDataStorage_set_Root, ZEND_ACC_PUBLIC)
	PHP_ME(TElDropboxDataStorage, get_MetadataLocation, arginfo_TElDropboxDataStorage_get_MetadataLocation, ZEND_ACC_PUBLIC)
	PHP_ME(TElDropboxDataStorage, set_MetadataLocation, arginfo_TElDropboxDataStorage_set_MetadataLocation, ZEND_ACC_PUBLIC)
	PHP_ME(TElDropboxDataStorage, get_MetadataExtension, arginfo_TElDropboxDataStorage_get_MetadataExtension, ZEND_ACC_PUBLIC)
	PHP_ME(TElDropboxDataStorage, set_MetadataExtension, arginfo_TElDropboxDataStorage_set_MetadataExtension, ZEND_ACC_PUBLIC)
	PHP_ME(TElDropboxDataStorage, get_MetadataDirName, arginfo_TElDropboxDataStorage_get_MetadataDirName, ZEND_ACC_PUBLIC)
	PHP_ME(TElDropboxDataStorage, set_MetadataDirName, arginfo_TElDropboxDataStorage_set_MetadataDirName, ZEND_ACC_PUBLIC)
	PHP_ME(TElDropboxDataStorage, get_SignatureMethod, arginfo_TElDropboxDataStorage_get_SignatureMethod, ZEND_ACC_PUBLIC)
	PHP_ME(TElDropboxDataStorage, set_SignatureMethod, arginfo_TElDropboxDataStorage_set_SignatureMethod, ZEND_ACC_PUBLIC)
	PHP_ME(TElDropboxDataStorage, get_ChunkedUploadThreshold, arginfo_TElDropboxDataStorage_get_ChunkedUploadThreshold, ZEND_ACC_PUBLIC)
	PHP_ME(TElDropboxDataStorage, set_ChunkedUploadThreshold, arginfo_TElDropboxDataStorage_set_ChunkedUploadThreshold, ZEND_ACC_PUBLIC)
	PHP_ME(TElDropboxDataStorage, get_ChunkedUploadChunkSize, arginfo_TElDropboxDataStorage_get_ChunkedUploadChunkSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElDropboxDataStorage, set_ChunkedUploadChunkSize, arginfo_TElDropboxDataStorage_set_ChunkedUploadChunkSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElDropboxDataStorage, get_DefaultLocale, arginfo_TElDropboxDataStorage_get_DefaultLocale, ZEND_ACC_PUBLIC)
	PHP_ME(TElDropboxDataStorage, set_DefaultLocale, arginfo_TElDropboxDataStorage_set_DefaultLocale, ZEND_ACC_PUBLIC)
	PHP_ME(TElDropboxDataStorage, get_HideMetadataObjects, arginfo_TElDropboxDataStorage_get_HideMetadataObjects, ZEND_ACC_PUBLIC)
	PHP_ME(TElDropboxDataStorage, set_HideMetadataObjects, arginfo_TElDropboxDataStorage_set_HideMetadataObjects, ZEND_ACC_PUBLIC)
	PHP_ME(TElDropboxDataStorage, get_PickMetadataOnList, arginfo_TElDropboxDataStorage_get_PickMetadataOnList, ZEND_ACC_PUBLIC)
	PHP_ME(TElDropboxDataStorage, set_PickMetadataOnList, arginfo_TElDropboxDataStorage_set_PickMetadataOnList, ZEND_ACC_PUBLIC)
	PHP_ME(TElDropboxDataStorage, get_Overwrite, arginfo_TElDropboxDataStorage_get_Overwrite, ZEND_ACC_PUBLIC)
	PHP_ME(TElDropboxDataStorage, set_Overwrite, arginfo_TElDropboxDataStorage_set_Overwrite, ZEND_ACC_PUBLIC)
	PHP_ME(TElDropboxDataStorage, get_PassthroughMode, arginfo_TElDropboxDataStorage_get_PassthroughMode, ZEND_ACC_PUBLIC)
	PHP_ME(TElDropboxDataStorage, set_PassthroughMode, arginfo_TElDropboxDataStorage_set_PassthroughMode, ZEND_ACC_PUBLIC)
	PHP_ME(TElDropboxDataStorage, get_EmbeddedMetadataMode, arginfo_TElDropboxDataStorage_get_EmbeddedMetadataMode, ZEND_ACC_PUBLIC)
	PHP_ME(TElDropboxDataStorage, set_EmbeddedMetadataMode, arginfo_TElDropboxDataStorage_set_EmbeddedMetadataMode, ZEND_ACC_PUBLIC)
	PHP_ME(TElDropboxDataStorage, get_OnBeforeRequestSigning, arginfo_TElDropboxDataStorage_get_OnBeforeRequestSigning, ZEND_ACC_PUBLIC)
	PHP_ME(TElDropboxDataStorage, set_OnBeforeRequestSigning, arginfo_TElDropboxDataStorage_set_OnBeforeRequestSigning, ZEND_ACC_PUBLIC)
	PHP_ME(TElDropboxDataStorage, __construct, arginfo_TElDropboxDataStorage___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElDropboxDataStorage(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElDropboxDataStorage_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElDropboxDataStorage", TElDropboxDataStorage_methods);
	if (NULL == TElCustomDataStorage_ce_ptr)
		Register_TElCustomDataStorage(TSRMLS_C);
	TElDropboxDataStorage_ce_ptr = zend_register_internal_class_ex(&ce, TElCustomDataStorage_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElDropboxDataStorageObject_ce_ptr = NULL;

SB_PHP_METHOD(TElDropboxDataStorageObject, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TElCustomDataStorageObject_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElDropboxDataStorageObject_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomDataStorageObject)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDropboxDataStorageObject, Clone)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDropboxDataStorageObject_Clone(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDropboxDataStorageObject, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElDropboxDataStorageObject_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDropboxDataStorageObject, IsMetadataObject)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElDropboxDataStorageObject_IsMetadataObject(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDropboxDataStorageObject, IsMetadataDirectory)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElDropboxDataStorageObject_IsMetadataDirectory(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDropboxDataStorageObject, Delete)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElDropboxDataStorageObject_Delete(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDropboxDataStorageObject, Exists)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElDropboxDataStorageObject_Exists(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDropboxDataStorageObject, Refresh)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElDropboxDataStorageObject_Refresh(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDropboxDataStorageObject, Write)
{
	char *sParentRev;
	int sParentRev_len;
	zend_bool bOverwrite;
	zval *oData;
	zval *oHandler;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "bsO!O!", &bOverwrite, &sParentRev, &sParentRev_len, &oData, TStream_ce_ptr, &oHandler, TElCustomDataStorageSecurityHandler_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElDropboxDataStorageObject_Write(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bOverwrite, sParentRev, (int32_t)sParentRev_len, SBGetObjectHandle(oData TSRMLS_CC), SBGetObjectHandle(oHandler TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oData, TStream_ce_ptr, &oHandler, TElCustomDataStorageSecurityHandler_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElDropboxDataStorageObject_Write_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oData TSRMLS_CC), SBGetObjectHandle(oHandler TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool, string, TStream, TElCustomDataStorageSecurityHandler) or (TStream, TElCustomDataStorageSecurityHandler)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDropboxDataStorageObject, Read)
{
	char *sRev;
	int sRev_len;
	zval *oStrm;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oStrm, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElDropboxDataStorageObject_Read(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStrm TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &sRev, &sRev_len, &oStrm, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElDropboxDataStorageObject_Read_1(SBGetObjectHandle(getThis() TSRMLS_CC), sRev, (int32_t)sRev_len, SBGetObjectHandle(oStrm TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream) or (string, TStream)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDropboxDataStorageObject, ReadBlock)
{
	int64_t l8ReadRaw;
	long l8Offset;
	long l8Size;
	zval *oStrm;
	zval *zl8Read;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!llz", &oStrm, TStream_ce_ptr, &l8Offset, &l8Size, &zl8Read) == SUCCESS) && PZVAL_IS_REF(zl8Read) && (IS_LONG == Z_TYPE_P(zl8Read)))
	{
		l8ReadRaw = (int64_t)Z_LVAL_P(zl8Read);
		SBCheckError(TElDropboxDataStorageObject_ReadBlock(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStrm TSRMLS_CC), (int64_t)l8Offset, (int64_t)l8Size, &l8ReadRaw) TSRMLS_CC);
		ZVAL_LONG(zl8Read, (long)l8ReadRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TStream, integer, integer, &integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDropboxDataStorageObject, Copy)
{
	char *sDestPath;
	int sDestPath_len;
	zval *oNewHandler;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &sDestPath, &sDestPath_len, &oNewHandler, TElCustomDataStorageSecurityHandler_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDropboxDataStorageObject_Copy(SBGetObjectHandle(getThis() TSRMLS_CC), sDestPath, (int32_t)sDestPath_len, SBGetObjectHandle(oNewHandler TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, TElCustomDataStorageSecurityHandler)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDropboxDataStorageObject, CreateCopyReference)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElDropboxDataStorageObject_CreateCopyReference(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1034425456, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDropboxDataStorageObject, GetDirectLink)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElDropboxDataStorageObject_GetDirectLink(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1540388836, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDropboxDataStorageObject, GetPreviewLink)
{
	uint32_t _err;
	zend_bool bShort;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bShort) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElDropboxDataStorageObject_GetPreviewLink(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bShort, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1292817116, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDropboxDataStorageObject, GetThumbnail)
{
	char *sFormat;
	int sFormat_len;
	long fSize;
	zval *oStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "slO!", &sFormat, &sFormat_len, &fSize, &oStream, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElDropboxDataStorageObject_GetThumbnail(SBGetObjectHandle(getThis() TSRMLS_CC), sFormat, (int32_t)sFormat_len, (TSBDropboxImageSizeRaw)fSize, SBGetObjectHandle(oStream TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, integer, TStream)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDropboxDataStorageObject, Rename)
{
	char *sDestPath;
	int sDestPath_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sDestPath, &sDestPath_len) == SUCCESS)
	{
		SBCheckError(TElDropboxDataStorageObject_Rename(SBGetObjectHandle(getThis() TSRMLS_CC), sDestPath, (int32_t)sDestPath_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDropboxDataStorageObject, Restore)
{
	char *sRev;
	int sRev_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sRev, &sRev_len) == SUCCESS)
	{
		SBCheckError(TElDropboxDataStorageObject_Restore(SBGetObjectHandle(getThis() TSRMLS_CC), sRev, (int32_t)sRev_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDropboxDataStorageObject, ListRevisions)
{
	zval *oObjects;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oObjects, TElDataStorageObjectList_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElDropboxDataStorageObject_ListRevisions(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObjects TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElDataStorageObjectList)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDropboxDataStorageObject, get_Path)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElDropboxDataStorageObject_get_Path(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1286611438, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDropboxDataStorageObject, get_Locale)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElDropboxDataStorageObject_get_Locale(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1899961304, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDropboxDataStorageObject, get_Rev)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElDropboxDataStorageObject_get_Rev(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1356316687, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDropboxDataStorageObject, get_SizeStr)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElDropboxDataStorageObject_get_SizeStr(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-272524850, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDropboxDataStorageObject, get_ThumbExists)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElDropboxDataStorageObject_get_ThumbExists(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDropboxDataStorageObject, get_Size)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElDropboxDataStorageObject_get_Size(SBGetObjectHandle(getThis() TSRMLS_CC), &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDropboxDataStorageObject, get_Modified)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(TElDropboxDataStorageObject_get_Modified(SBGetObjectHandle(getThis() TSRMLS_CC), &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDropboxDataStorageObject, get_ClientModified)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(TElDropboxDataStorageObject_get_ClientModified(SBGetObjectHandle(getThis() TSRMLS_CC), &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDropboxDataStorageObject, get_Directory)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElDropboxDataStorageObject_get_Directory(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDropboxDataStorageObject, get_Icon)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElDropboxDataStorageObject_get_Icon(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(577798970, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDropboxDataStorageObject, get_Root)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElDropboxDataStorageObject_get_Root(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1360024506, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDropboxDataStorageObject, get_MimeType)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElDropboxDataStorageObject_get_MimeType(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1859099733, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDropboxDataStorageObject, get_Revision)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElDropboxDataStorageObject_get_Revision(SBGetObjectHandle(getThis() TSRMLS_CC), &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDropboxDataStorageObject, get_IsDeleted)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElDropboxDataStorageObject_get_IsDeleted(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDropboxDataStorageObject, get_Hash)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElDropboxDataStorageObject_get_Hash(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1772304295, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDropboxDataStorageObject, get_Listed)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElDropboxDataStorageObject_get_Listed(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDropboxDataStorageObject, get_Objects)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDropboxDataStorageObject_get_Objects(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElDropboxDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDropboxDataStorageObject, get_Count)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElDropboxDataStorageObject_get_Count(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDropboxDataStorageObject, __construct)
{
	zval *oOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oOwner, TElDropboxDataStorage_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDropboxDataStorageObject_Create(SBGetObjectHandle(oOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElDropboxDataStorage)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDropboxDataStorageObject_Assign, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Source, TElCustomDataStorageObject, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDropboxDataStorageObject_Clone, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDropboxDataStorageObject_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDropboxDataStorageObject_IsMetadataObject, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDropboxDataStorageObject_IsMetadataDirectory, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDropboxDataStorageObject_Delete, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDropboxDataStorageObject_Exists, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDropboxDataStorageObject_Refresh, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDropboxDataStorageObject_Write, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Overwrite_or_Data, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ParentRev_or_Handler, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Data, TStream, 1)
	ZEND_ARG_OBJ_INFO(0, Handler, TElCustomDataStorageSecurityHandler, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDropboxDataStorageObject_Read, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Strm_or_Rev, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Strm, TStream, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDropboxDataStorageObject_ReadBlock, 0, 0, 4)
	ZEND_ARG_OBJ_INFO(0, Strm, TStream, 1)
	ZEND_ARG_INFO(0, Offset)
	ZEND_ARG_INFO(0, Size)
	ZEND_ARG_INFO(1, Read)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDropboxDataStorageObject_Copy, 0, 0, 2)
	ZEND_ARG_INFO(0, DestPath)
	ZEND_ARG_OBJ_INFO(0, NewHandler, TElCustomDataStorageSecurityHandler, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDropboxDataStorageObject_CreateCopyReference, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDropboxDataStorageObject_GetDirectLink, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDropboxDataStorageObject_GetPreviewLink, 0, 0, 1)
	ZEND_ARG_INFO(0, Short)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDropboxDataStorageObject_GetThumbnail, 0, 0, 3)
	ZEND_ARG_INFO(0, Format)
	ZEND_ARG_INFO(0, Size)
	ZEND_ARG_OBJ_INFO(0, Stream, TStream, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDropboxDataStorageObject_Rename, 0, 0, 1)
	ZEND_ARG_INFO(0, DestPath)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDropboxDataStorageObject_Restore, 0, 0, 1)
	ZEND_ARG_INFO(0, Rev)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDropboxDataStorageObject_ListRevisions, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Objects, TElDataStorageObjectList, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDropboxDataStorageObject_get_Path, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDropboxDataStorageObject_get_Locale, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDropboxDataStorageObject_get_Rev, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDropboxDataStorageObject_get_SizeStr, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDropboxDataStorageObject_get_ThumbExists, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDropboxDataStorageObject_get_Size, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDropboxDataStorageObject_get_Modified, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDropboxDataStorageObject_get_ClientModified, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDropboxDataStorageObject_get_Directory, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDropboxDataStorageObject_get_Icon, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDropboxDataStorageObject_get_Root, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDropboxDataStorageObject_get_MimeType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDropboxDataStorageObject_get_Revision, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDropboxDataStorageObject_get_IsDeleted, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDropboxDataStorageObject_get_Hash, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDropboxDataStorageObject_get_Listed, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDropboxDataStorageObject_get_Objects, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDropboxDataStorageObject_get_Count, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDropboxDataStorageObject___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Owner, TElDropboxDataStorage, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElDropboxDataStorageObject_methods[] = {
	PHP_ME(TElDropboxDataStorageObject, Assign, arginfo_TElDropboxDataStorageObject_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElDropboxDataStorageObject, Clone, arginfo_TElDropboxDataStorageObject_Clone, ZEND_ACC_PUBLIC)
	PHP_ME(TElDropboxDataStorageObject, Clear, arginfo_TElDropboxDataStorageObject_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElDropboxDataStorageObject, IsMetadataObject, arginfo_TElDropboxDataStorageObject_IsMetadataObject, ZEND_ACC_PUBLIC)
	PHP_ME(TElDropboxDataStorageObject, IsMetadataDirectory, arginfo_TElDropboxDataStorageObject_IsMetadataDirectory, ZEND_ACC_PUBLIC)
	PHP_ME(TElDropboxDataStorageObject, Delete, arginfo_TElDropboxDataStorageObject_Delete, ZEND_ACC_PUBLIC)
	PHP_ME(TElDropboxDataStorageObject, Exists, arginfo_TElDropboxDataStorageObject_Exists, ZEND_ACC_PUBLIC)
	PHP_ME(TElDropboxDataStorageObject, Refresh, arginfo_TElDropboxDataStorageObject_Refresh, ZEND_ACC_PUBLIC)
	PHP_ME(TElDropboxDataStorageObject, Write, arginfo_TElDropboxDataStorageObject_Write, ZEND_ACC_PUBLIC)
	PHP_ME(TElDropboxDataStorageObject, Read, arginfo_TElDropboxDataStorageObject_Read, ZEND_ACC_PUBLIC)
	PHP_ME(TElDropboxDataStorageObject, ReadBlock, arginfo_TElDropboxDataStorageObject_ReadBlock, ZEND_ACC_PUBLIC)
	PHP_ME(TElDropboxDataStorageObject, Copy, arginfo_TElDropboxDataStorageObject_Copy, ZEND_ACC_PUBLIC)
	PHP_ME(TElDropboxDataStorageObject, CreateCopyReference, arginfo_TElDropboxDataStorageObject_CreateCopyReference, ZEND_ACC_PUBLIC)
	PHP_ME(TElDropboxDataStorageObject, GetDirectLink, arginfo_TElDropboxDataStorageObject_GetDirectLink, ZEND_ACC_PUBLIC)
	PHP_ME(TElDropboxDataStorageObject, GetPreviewLink, arginfo_TElDropboxDataStorageObject_GetPreviewLink, ZEND_ACC_PUBLIC)
	PHP_ME(TElDropboxDataStorageObject, GetThumbnail, arginfo_TElDropboxDataStorageObject_GetThumbnail, ZEND_ACC_PUBLIC)
	PHP_ME(TElDropboxDataStorageObject, Rename, arginfo_TElDropboxDataStorageObject_Rename, ZEND_ACC_PUBLIC)
	PHP_ME(TElDropboxDataStorageObject, Restore, arginfo_TElDropboxDataStorageObject_Restore, ZEND_ACC_PUBLIC)
	PHP_ME(TElDropboxDataStorageObject, ListRevisions, arginfo_TElDropboxDataStorageObject_ListRevisions, ZEND_ACC_PUBLIC)
	PHP_ME(TElDropboxDataStorageObject, get_Path, arginfo_TElDropboxDataStorageObject_get_Path, ZEND_ACC_PUBLIC)
	PHP_ME(TElDropboxDataStorageObject, get_Locale, arginfo_TElDropboxDataStorageObject_get_Locale, ZEND_ACC_PUBLIC)
	PHP_ME(TElDropboxDataStorageObject, get_Rev, arginfo_TElDropboxDataStorageObject_get_Rev, ZEND_ACC_PUBLIC)
	PHP_ME(TElDropboxDataStorageObject, get_SizeStr, arginfo_TElDropboxDataStorageObject_get_SizeStr, ZEND_ACC_PUBLIC)
	PHP_ME(TElDropboxDataStorageObject, get_ThumbExists, arginfo_TElDropboxDataStorageObject_get_ThumbExists, ZEND_ACC_PUBLIC)
	PHP_ME(TElDropboxDataStorageObject, get_Size, arginfo_TElDropboxDataStorageObject_get_Size, ZEND_ACC_PUBLIC)
	PHP_ME(TElDropboxDataStorageObject, get_Modified, arginfo_TElDropboxDataStorageObject_get_Modified, ZEND_ACC_PUBLIC)
	PHP_ME(TElDropboxDataStorageObject, get_ClientModified, arginfo_TElDropboxDataStorageObject_get_ClientModified, ZEND_ACC_PUBLIC)
	PHP_ME(TElDropboxDataStorageObject, get_Directory, arginfo_TElDropboxDataStorageObject_get_Directory, ZEND_ACC_PUBLIC)
	PHP_ME(TElDropboxDataStorageObject, get_Icon, arginfo_TElDropboxDataStorageObject_get_Icon, ZEND_ACC_PUBLIC)
	PHP_ME(TElDropboxDataStorageObject, get_Root, arginfo_TElDropboxDataStorageObject_get_Root, ZEND_ACC_PUBLIC)
	PHP_ME(TElDropboxDataStorageObject, get_MimeType, arginfo_TElDropboxDataStorageObject_get_MimeType, ZEND_ACC_PUBLIC)
	PHP_ME(TElDropboxDataStorageObject, get_Revision, arginfo_TElDropboxDataStorageObject_get_Revision, ZEND_ACC_PUBLIC)
	PHP_ME(TElDropboxDataStorageObject, get_IsDeleted, arginfo_TElDropboxDataStorageObject_get_IsDeleted, ZEND_ACC_PUBLIC)
	PHP_ME(TElDropboxDataStorageObject, get_Hash, arginfo_TElDropboxDataStorageObject_get_Hash, ZEND_ACC_PUBLIC)
	PHP_ME(TElDropboxDataStorageObject, get_Listed, arginfo_TElDropboxDataStorageObject_get_Listed, ZEND_ACC_PUBLIC)
	PHP_ME(TElDropboxDataStorageObject, get_Objects, arginfo_TElDropboxDataStorageObject_get_Objects, ZEND_ACC_PUBLIC)
	PHP_ME(TElDropboxDataStorageObject, get_Count, arginfo_TElDropboxDataStorageObject_get_Count, ZEND_ACC_PUBLIC)
	PHP_ME(TElDropboxDataStorageObject, __construct, arginfo_TElDropboxDataStorageObject___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElDropboxDataStorageObject(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElDropboxDataStorageObject_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElDropboxDataStorageObject", TElDropboxDataStorageObject_methods);
	if (NULL == TElCustomDataStorageObject_ce_ptr)
		Register_TElCustomDataStorageObject(TSRMLS_C);
	TElDropboxDataStorageObject_ce_ptr = zend_register_internal_class_ex(&ce, TElCustomDataStorageObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElDropboxAccountInfo_ce_ptr = NULL;

SB_PHP_METHOD(TElDropboxAccountInfo, get_DisplayName)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElDropboxAccountInfo_get_DisplayName(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(605291329, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDropboxAccountInfo, get_UID)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElDropboxAccountInfo_get_UID(SBGetObjectHandle(getThis() TSRMLS_CC), &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDropboxAccountInfo, get_Country)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElDropboxAccountInfo_get_Country(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-41320254, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDropboxAccountInfo, get_ReferralLink)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElDropboxAccountInfo_get_ReferralLink(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-933882448, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDropboxAccountInfo, get_QuotaAvailable)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElDropboxAccountInfo_get_QuotaAvailable(SBGetObjectHandle(getThis() TSRMLS_CC), &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDropboxAccountInfo, get_RegularFiles)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElDropboxAccountInfo_get_RegularFiles(SBGetObjectHandle(getThis() TSRMLS_CC), &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDropboxAccountInfo, get_SharedFiles)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElDropboxAccountInfo_get_SharedFiles(SBGetObjectHandle(getThis() TSRMLS_CC), &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDropboxAccountInfo, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDropboxAccountInfo_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDropboxAccountInfo_get_DisplayName, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDropboxAccountInfo_get_UID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDropboxAccountInfo_get_Country, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDropboxAccountInfo_get_ReferralLink, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDropboxAccountInfo_get_QuotaAvailable, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDropboxAccountInfo_get_RegularFiles, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDropboxAccountInfo_get_SharedFiles, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDropboxAccountInfo___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElDropboxAccountInfo_methods[] = {
	PHP_ME(TElDropboxAccountInfo, get_DisplayName, arginfo_TElDropboxAccountInfo_get_DisplayName, ZEND_ACC_PUBLIC)
	PHP_ME(TElDropboxAccountInfo, get_UID, arginfo_TElDropboxAccountInfo_get_UID, ZEND_ACC_PUBLIC)
	PHP_ME(TElDropboxAccountInfo, get_Country, arginfo_TElDropboxAccountInfo_get_Country, ZEND_ACC_PUBLIC)
	PHP_ME(TElDropboxAccountInfo, get_ReferralLink, arginfo_TElDropboxAccountInfo_get_ReferralLink, ZEND_ACC_PUBLIC)
	PHP_ME(TElDropboxAccountInfo, get_QuotaAvailable, arginfo_TElDropboxAccountInfo_get_QuotaAvailable, ZEND_ACC_PUBLIC)
	PHP_ME(TElDropboxAccountInfo, get_RegularFiles, arginfo_TElDropboxAccountInfo_get_RegularFiles, ZEND_ACC_PUBLIC)
	PHP_ME(TElDropboxAccountInfo, get_SharedFiles, arginfo_TElDropboxAccountInfo_get_SharedFiles, ZEND_ACC_PUBLIC)
	PHP_ME(TElDropboxAccountInfo, __construct, arginfo_TElDropboxAccountInfo___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElDropboxAccountInfo(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElDropboxAccountInfo_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElDropboxAccountInfo", TElDropboxAccountInfo_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElDropboxAccountInfo_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

void Register_SBDropboxDataStorage_Enum_Flags(TSRMLS_D)
{
	zend_class_entry ce;
	INIT_CLASS_ENTRY(ce, "TSBDropboxImageSize", NULL);
	TSBDropboxImageSize_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBDropboxImageSize_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBDropboxImageSize_ce_ptr, "disDefault", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBDropboxImageSize_ce_ptr, "disXS", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBDropboxImageSize_ce_ptr, "disS", 2)
	SB_DECLARE_CLASS_LONG_CONST(TSBDropboxImageSize_ce_ptr, "disM", 3)
	SB_DECLARE_CLASS_LONG_CONST(TSBDropboxImageSize_ce_ptr, "disL", 4)
	SB_DECLARE_CLASS_LONG_CONST(TSBDropboxImageSize_ce_ptr, "disXL", 5)
	
	INIT_CLASS_ENTRY(ce, "TSBDropboxMetadataLocation", NULL);
	TSBDropboxMetadataLocation_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBDropboxMetadataLocation_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBDropboxMetadataLocation_ce_ptr, "dmlColocatedObjects", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBDropboxMetadataLocation_ce_ptr, "dmlMetadataSubdir", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBDropboxMetadataLocation_ce_ptr, "dmlMetadataDir", 2)
	
	INIT_CLASS_ENTRY(ce, "TSBDropboxSignatureMethod", NULL);
	TSBDropboxSignatureMethod_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBDropboxSignatureMethod_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBDropboxSignatureMethod_ce_ptr, "dsmHMACSHA1", 0)
}

