#include "sbgost341194.h"

zend_class_entry *TElGOSTMD_ce_ptr = NULL;

SB_PHP_METHOD(TElGOSTMD, DigestSize_Inst)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElGOSTMD_DigestSize_1(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGOSTMD, DigestSize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElGOSTMD_DigestSize(&l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGOSTMD, Reset)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElGOSTMD_Reset(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGOSTMD, Clone)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TElGOSTBase_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElGOSTMD_Clone(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElGOSTBase)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGOSTMD, Update)
{
	long u4Len;
	long u4StartIndex;
	SBArrayZValInfo aiIn_Buf;
	SBArrayZValInfo piIn_Buf;
	zval *zaIn_Buf;
	zval *zpIn_Buf;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zpIn_Buf, &u4Len) == SUCCESS) && ((Z_TYPE_P(zpIn_Buf) == IS_STRING) || (Z_TYPE_P(zpIn_Buf) == IS_ARRAY) || (Z_TYPE_P(zpIn_Buf) == IS_NULL) || ((Z_TYPE_P(zpIn_Buf) == IS_OBJECT) && (Z_OBJCE_P(zpIn_Buf) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpIn_Buf, &piIn_Buf TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElGOSTMD_Update(SBGetObjectHandle(getThis() TSRMLS_CC), piIn_Buf.data, (uint32_t)u4Len) TSRMLS_CC);
		SBFreePointerZValInfo(&piIn_Buf);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zll", &zaIn_Buf, &u4StartIndex, &u4Len) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaIn_Buf)) || (IS_ARRAY == Z_TYPE_P(zaIn_Buf)) || (IS_NULL == Z_TYPE_P(zaIn_Buf))))
	{
		if (!SBGetByteArrayFromZVal(zaIn_Buf, &aiIn_Buf TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElGOSTMD_Update_1(SBGetObjectHandle(getThis() TSRMLS_CC), aiIn_Buf.data, aiIn_Buf.len, (uint32_t)u4StartIndex, (uint32_t)u4Len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiIn_Buf);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer) or (array of byte|string|NULL, integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGOSTMD, Final)
{
	SBArrayZValInfo aiDigest;
	uint32_t _err;
	zval *zaDigest;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaDigest) == SUCCESS) && PZVAL_IS_REF(zaDigest) && ((IS_STRING == Z_TYPE_P(zaDigest)) || (IS_ARRAY == Z_TYPE_P(zaDigest))))
	{
		SBInitArrayZValInfo(&aiDigest);
		_err = TElGOSTMD_Final(SBGetObjectHandle(getThis() TSRMLS_CC), aiDigest.data, &aiDigest.len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			SBDetachDataFromZValAndResize(zaDigest, &aiDigest TSRMLS_CC);
			SBCheckError(SBGetLastReturnBuffer(-409579556, 1, aiDigest.data, &aiDigest.len) TSRMLS_CC);
			((char *)aiDigest.data)[aiDigest.len] = 0;
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBFreeArrayZValInfo(&aiDigest);
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBSetByteArrayToZVal(&aiDigest, zaDigest);
	}
	else
	{
		SBErrorExpectsArguments("(&array of byte|string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGOSTMD, Calculate)
{
	long u4Count;
	long u4Len;
	long u4StartIndex;
	SBArrayZValInfo aiDigest;
	SBArrayZValInfo aiIn_Buf;
	uint32_t _err;
	zval *oSource;
	zval *zaDigest;
	zval *zaIn_Buf;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zllz", &zaIn_Buf, &u4StartIndex, &u4Len, &zaDigest) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaIn_Buf)) || (IS_ARRAY == Z_TYPE_P(zaIn_Buf)) || (IS_NULL == Z_TYPE_P(zaIn_Buf))) && PZVAL_IS_REF(zaDigest) && ((IS_STRING == Z_TYPE_P(zaDigest)) || (IS_ARRAY == Z_TYPE_P(zaDigest))))
	{
		if (!SBGetByteArrayFromZVal(zaIn_Buf, &aiIn_Buf TSRMLS_CC)) RETURN_FALSE;
		SBInitArrayZValInfo(&aiDigest);
		_err = TElGOSTMD_Calculate(SBGetObjectHandle(getThis() TSRMLS_CC), aiIn_Buf.data, aiIn_Buf.len, (uint32_t)u4StartIndex, (uint32_t)u4Len, aiDigest.data, &aiDigest.len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			SBDetachDataFromZValAndResize(zaDigest, &aiDigest TSRMLS_CC);
			SBCheckError(SBGetLastReturnBuffer(-797096280, 4, aiDigest.data, &aiDigest.len) TSRMLS_CC);
			((char *)aiDigest.data)[aiDigest.len] = 0;
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBFreeArrayZValInfo(&aiDigest);
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiIn_Buf);
		SBSetByteArrayToZVal(&aiDigest, zaDigest);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!lz", &oSource, TStream_ce_ptr, &u4Count, &zaDigest) == SUCCESS) && PZVAL_IS_REF(zaDigest) && ((IS_STRING == Z_TYPE_P(zaDigest)) || (IS_ARRAY == Z_TYPE_P(zaDigest))))
	{
		SBInitArrayZValInfo(&aiDigest);
		_err = TElGOSTMD_Calculate_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC), (uint32_t)u4Count, aiDigest.data, &aiDigest.len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			SBDetachDataFromZValAndResize(zaDigest, &aiDigest TSRMLS_CC);
			SBCheckError(SBGetLastReturnBuffer(408556909, 3, aiDigest.data, &aiDigest.len) TSRMLS_CC);
			((char *)aiDigest.data)[aiDigest.len] = 0;
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBFreeArrayZValInfo(&aiDigest);
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBSetByteArrayToZVal(&aiDigest, zaDigest);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, integer, integer, &array of byte|string) or (TStream, integer, &array of byte|string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGOSTMD, __construct)
{
	zval *oSubstBlock;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElGOSTMD_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &oSubstBlock, TElGostSubstBlock_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElGOSTMD_Create_1((TElGostSubstBlock *)SBGetStructPointer(oSubstBlock TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("() or (TElGostSubstBlock)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOSTMD_DigestSize_Inst, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOSTMD_DigestSize, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOSTMD_Reset, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOSTMD_Clone, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Source, TElGOSTBase, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOSTMD_Update, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, In_Buf, 0, 1)
	ZEND_ARG_INFO(0, Len_or_StartIndex)
	ZEND_ARG_INFO(0, Len)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOSTMD_Final, 0, 0, 1)
	ZEND_ARG_INFO(1, Digest)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOSTMD_Calculate, 0, 0, 3)
	ZEND_ARG_TYPE_INFO(0, In_Buf_or_Source, 0, 1)
	ZEND_ARG_INFO(0, StartIndex_or_Count)
	ZEND_ARG_INFO(1, Len_or_Digest)
	ZEND_ARG_INFO(1, Digest)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOSTMD___construct, 0, 0, 0)
	ZEND_ARG_OBJ_INFO(0, SubstBlock, TElGostSubstBlock, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElGOSTMD_methods[] = {
	PHP_ME(TElGOSTMD, DigestSize_Inst, arginfo_TElGOSTMD_DigestSize_Inst, ZEND_ACC_PUBLIC)
	PHP_ME(TElGOSTMD, DigestSize, arginfo_TElGOSTMD_DigestSize, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElGOSTMD, Reset, arginfo_TElGOSTMD_Reset, ZEND_ACC_PUBLIC)
	PHP_ME(TElGOSTMD, Clone, arginfo_TElGOSTMD_Clone, ZEND_ACC_PUBLIC)
	PHP_ME(TElGOSTMD, Update, arginfo_TElGOSTMD_Update, ZEND_ACC_PUBLIC)
	PHP_ME(TElGOSTMD, Final, arginfo_TElGOSTMD_Final, ZEND_ACC_PUBLIC)
	PHP_ME(TElGOSTMD, Calculate, arginfo_TElGOSTMD_Calculate, ZEND_ACC_PUBLIC)
	PHP_ME(TElGOSTMD, __construct, arginfo_TElGOSTMD___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElGOSTMD(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElGOSTMD_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElGOSTMD", TElGOSTMD_methods);
	if (NULL == TElGOSTBase_ce_ptr)
		Register_TElGOSTBase(TSRMLS_C);
	TElGOSTMD_ce_ptr = zend_register_internal_class_ex(&ce, TElGOSTBase_ce_ptr, NULL TSRMLS_CC);
}

void Register_SBGOST341194_Constants(int module_number TSRMLS_DC)
{
	SB_REGISTER_LONG_CONSTANT(SBGOST341194, c_GOST_DigestSize, SB_c_GOST_DigestSize, SB_c_GOST_DigestSize);
}

