#include "sbgssapibase.h"

SB_PHP_FUNCTION(SBGSSAPIBase, GSS_CALLING_ERROR)
{
	long u4x;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u4x) == SUCCESS)
	{
		uint32_t u4OutResultRaw = 0;
		SBCheckError(SBGSSAPIBase_GSS_CALLING_ERROR((uint32_t)u4x, &u4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBGSSAPIBase, GSS_ROUTINE_ERROR)
{
	long u4x;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u4x) == SUCCESS)
	{
		uint32_t u4OutResultRaw = 0;
		SBCheckError(SBGSSAPIBase_GSS_ROUTINE_ERROR((uint32_t)u4x, &u4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBGSSAPIBase, GSS_SUPPLEMENTARY_INFO)
{
	long u4x;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u4x) == SUCCESS)
	{
		uint32_t u4OutResultRaw = 0;
		SBCheckError(SBGSSAPIBase_GSS_SUPPLEMENTARY_INFO((uint32_t)u4x, &u4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBGSSAPIBase, GSS_ERROR)
{
	long u4x;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u4x) == SUCCESS)
	{
		uint32_t u4OutResultRaw = 0;
		SBCheckError(SBGSSAPIBase_GSS_ERROR((uint32_t)u4x, &u4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBGSSAPIBase, DecodeMechOID)
{
	SBArrayZValInfo aiOID;
	uint32_t _err;
	zval *zaOID;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaOID) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaOID)) || (IS_ARRAY == Z_TYPE_P(zaOID)) || (IS_NULL == Z_TYPE_P(zaOID))))
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		if (!SBGetByteArrayFromZVal(zaOID, &aiOID TSRMLS_CC)) RETURN_FALSE;
		_err = SBGSSAPIBase_DecodeMechOID(aiOID.data, aiOID.len, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-1351336095, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiOID);
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBGSSAPIBase, EncodeMechOID)
{
	SBArrayZValInfo aiOID;
	uint32_t _err;
	zval *zaOID;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaOID) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaOID)) || (IS_ARRAY == Z_TYPE_P(zaOID)) || (IS_NULL == Z_TYPE_P(zaOID))))
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		if (!SBGetByteArrayFromZVal(zaOID, &aiOID TSRMLS_CC)) RETURN_FALSE;
		_err = SBGSSAPIBase_EncodeMechOID(aiOID.data, aiOID.len, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-1282567303, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiOID);
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

void Register_SBGSSAPIBase_Constants(int module_number TSRMLS_DC)
{
	SB_REGISTER_LONG_CONSTANT(SBGSSAPIBase, GSS_C_DELEG_FLAG, SB_GSS_C_DELEG_FLAG, SB_GSS_C_DELEG_FLAG);
	SB_REGISTER_LONG_CONSTANT(SBGSSAPIBase, GSS_C_MUTUAL_FLAG, SB_GSS_C_MUTUAL_FLAG, SB_GSS_C_MUTUAL_FLAG);
	SB_REGISTER_LONG_CONSTANT(SBGSSAPIBase, GSS_C_REPLAY_FLAG, SB_GSS_C_REPLAY_FLAG, SB_GSS_C_REPLAY_FLAG);
	SB_REGISTER_LONG_CONSTANT(SBGSSAPIBase, GSS_C_SEQUENCE_FLAG, SB_GSS_C_SEQUENCE_FLAG, SB_GSS_C_SEQUENCE_FLAG);
	SB_REGISTER_LONG_CONSTANT(SBGSSAPIBase, GSS_C_CONF_FLAG, SB_GSS_C_CONF_FLAG, SB_GSS_C_CONF_FLAG);
	SB_REGISTER_LONG_CONSTANT(SBGSSAPIBase, GSS_C_INTEG_FLAG, SB_GSS_C_INTEG_FLAG, SB_GSS_C_INTEG_FLAG);
	SB_REGISTER_LONG_CONSTANT(SBGSSAPIBase, GSS_C_ANON_FLAG, SB_GSS_C_ANON_FLAG, SB_GSS_C_ANON_FLAG);
	SB_REGISTER_LONG_CONSTANT(SBGSSAPIBase, GSS_C_PROT_READY_FLAG, SB_GSS_C_PROT_READY_FLAG, SB_GSS_C_PROT_READY_FLAG);
	SB_REGISTER_LONG_CONSTANT(SBGSSAPIBase, GSS_C_TRANS_FLAG, SB_GSS_C_TRANS_FLAG, SB_GSS_C_TRANS_FLAG);
	SB_REGISTER_LONG_CONSTANT(SBGSSAPIBase, GSS_C_BOTH, SB_GSS_C_BOTH, SB_GSS_C_BOTH);
	SB_REGISTER_LONG_CONSTANT(SBGSSAPIBase, GSS_C_INITIATE, SB_GSS_C_INITIATE, SB_GSS_C_INITIATE);
	SB_REGISTER_LONG_CONSTANT(SBGSSAPIBase, GSS_C_ACCEPT, SB_GSS_C_ACCEPT, SB_GSS_C_ACCEPT);
	SB_REGISTER_LONG_CONSTANT(SBGSSAPIBase, GSS_C_GSS_CODE, SB_GSS_C_GSS_CODE, SB_GSS_C_GSS_CODE);
	SB_REGISTER_LONG_CONSTANT(SBGSSAPIBase, GSS_C_MECH_CODE, SB_GSS_C_MECH_CODE, SB_GSS_C_MECH_CODE);
	SB_REGISTER_LONG_CONSTANT(SBGSSAPIBase, GSS_C_QOP_DEFAULT, SB_GSS_C_QOP_DEFAULT, SB_GSS_C_QOP_DEFAULT);
	SB_REGISTER_LONG_CONSTANT(SBGSSAPIBase, GSS_C_INDEFINITE, SB_GSS_C_INDEFINITE, SB_GSS_C_INDEFINITE);
	SB_REGISTER_LONG_CONSTANT(SBGSSAPIBase, GSS_C_AF_UNSPEC, SB_GSS_C_AF_UNSPEC, SB_GSS_C_AF_UNSPEC);
	SB_REGISTER_LONG_CONSTANT(SBGSSAPIBase, GSS_C_AF_LOCAL, SB_GSS_C_AF_LOCAL, SB_GSS_C_AF_LOCAL);
	SB_REGISTER_LONG_CONSTANT(SBGSSAPIBase, GSS_C_AF_INET, SB_GSS_C_AF_INET, SB_GSS_C_AF_INET);
	SB_REGISTER_LONG_CONSTANT(SBGSSAPIBase, GSS_C_AF_IMPLINK, SB_GSS_C_AF_IMPLINK, SB_GSS_C_AF_IMPLINK);
	SB_REGISTER_LONG_CONSTANT(SBGSSAPIBase, GSS_C_AF_PUP, SB_GSS_C_AF_PUP, SB_GSS_C_AF_PUP);
	SB_REGISTER_LONG_CONSTANT(SBGSSAPIBase, GSS_C_AF_CHAOS, SB_GSS_C_AF_CHAOS, SB_GSS_C_AF_CHAOS);
	SB_REGISTER_LONG_CONSTANT(SBGSSAPIBase, GSS_C_AF_NS, SB_GSS_C_AF_NS, SB_GSS_C_AF_NS);
	SB_REGISTER_LONG_CONSTANT(SBGSSAPIBase, GSS_C_AF_NBS, SB_GSS_C_AF_NBS, SB_GSS_C_AF_NBS);
	SB_REGISTER_LONG_CONSTANT(SBGSSAPIBase, GSS_C_AF_ECMA, SB_GSS_C_AF_ECMA, SB_GSS_C_AF_ECMA);
	SB_REGISTER_LONG_CONSTANT(SBGSSAPIBase, GSS_C_AF_DATAKIT, SB_GSS_C_AF_DATAKIT, SB_GSS_C_AF_DATAKIT);
	SB_REGISTER_LONG_CONSTANT(SBGSSAPIBase, GSS_C_AF_CCITT, SB_GSS_C_AF_CCITT, SB_GSS_C_AF_CCITT);
	SB_REGISTER_LONG_CONSTANT(SBGSSAPIBase, GSS_C_AF_SNA, SB_GSS_C_AF_SNA, SB_GSS_C_AF_SNA);
	SB_REGISTER_LONG_CONSTANT(SBGSSAPIBase, GSS_C_AF_DECnet, SB_GSS_C_AF_DECnet, SB_GSS_C_AF_DECnet);
	SB_REGISTER_LONG_CONSTANT(SBGSSAPIBase, GSS_C_AF_DLI, SB_GSS_C_AF_DLI, SB_GSS_C_AF_DLI);
	SB_REGISTER_LONG_CONSTANT(SBGSSAPIBase, GSS_C_AF_LAT, SB_GSS_C_AF_LAT, SB_GSS_C_AF_LAT);
	SB_REGISTER_LONG_CONSTANT(SBGSSAPIBase, GSS_C_AF_HYLINK, SB_GSS_C_AF_HYLINK, SB_GSS_C_AF_HYLINK);
	SB_REGISTER_LONG_CONSTANT(SBGSSAPIBase, GSS_C_AF_APPLETALK, SB_GSS_C_AF_APPLETALK, SB_GSS_C_AF_APPLETALK);
	SB_REGISTER_LONG_CONSTANT(SBGSSAPIBase, GSS_C_AF_BSC, SB_GSS_C_AF_BSC, SB_GSS_C_AF_BSC);
	SB_REGISTER_LONG_CONSTANT(SBGSSAPIBase, GSS_C_AF_DSS, SB_GSS_C_AF_DSS, SB_GSS_C_AF_DSS);
	SB_REGISTER_LONG_CONSTANT(SBGSSAPIBase, GSS_C_AF_OSI, SB_GSS_C_AF_OSI, SB_GSS_C_AF_OSI);
	SB_REGISTER_LONG_CONSTANT(SBGSSAPIBase, GSS_C_AF_X25, SB_GSS_C_AF_X25, SB_GSS_C_AF_X25);
	SB_REGISTER_LONG_CONSTANT(SBGSSAPIBase, GSS_C_AF_NULLADDR, SB_GSS_C_AF_NULLADDR, SB_GSS_C_AF_NULLADDR);
	SB_REGISTER_LONG_CONSTANT(SBGSSAPIBase, GSS_C_CALLING_ERROR_OFFSET, SB_GSS_C_CALLING_ERROR_OFFSET, SB_GSS_C_CALLING_ERROR_OFFSET);
	SB_REGISTER_LONG_CONSTANT(SBGSSAPIBase, GSS_C_ROUTINE_ERROR_OFFSET, SB_GSS_C_ROUTINE_ERROR_OFFSET, SB_GSS_C_ROUTINE_ERROR_OFFSET);
	SB_REGISTER_LONG_CONSTANT(SBGSSAPIBase, GSS_C_SUPPLEMENTARY_OFFSET, SB_GSS_C_SUPPLEMENTARY_OFFSET, SB_GSS_C_SUPPLEMENTARY_OFFSET);
	SB_REGISTER_LONG_CONSTANT(SBGSSAPIBase, GSS_C_CALLING_ERROR_MASK, SB_GSS_C_CALLING_ERROR_MASK, SB_GSS_C_CALLING_ERROR_MASK);
	SB_REGISTER_LONG_CONSTANT(SBGSSAPIBase, GSS_C_ROUTINE_ERROR_MASK, SB_GSS_C_ROUTINE_ERROR_MASK, SB_GSS_C_ROUTINE_ERROR_MASK);
	SB_REGISTER_LONG_CONSTANT(SBGSSAPIBase, GSS_C_SUPPLEMENTARY_MASK, SB_GSS_C_SUPPLEMENTARY_MASK, SB_GSS_C_SUPPLEMENTARY_MASK);
	SB_REGISTER_LONG_CONSTANT(SBGSSAPIBase, GSS_S_COMPLETE, SB_GSS_S_COMPLETE, SB_GSS_S_COMPLETE);
	SB_REGISTER_LONG_CONSTANT(SBGSSAPIBase, GSS_S_BAD_MECH, SB_GSS_S_BAD_MECH, SB_GSS_S_BAD_MECH);
	SB_REGISTER_LONG_CONSTANT(SBGSSAPIBase, GSS_S_BAD_NAME, SB_GSS_S_BAD_NAME, SB_GSS_S_BAD_NAME);
	SB_REGISTER_LONG_CONSTANT(SBGSSAPIBase, GSS_S_BAD_NAMETYPE, SB_GSS_S_BAD_NAMETYPE, SB_GSS_S_BAD_NAMETYPE);
	SB_REGISTER_LONG_CONSTANT(SBGSSAPIBase, GSS_S_BAD_BINDINGS, SB_GSS_S_BAD_BINDINGS, SB_GSS_S_BAD_BINDINGS);
	SB_REGISTER_LONG_CONSTANT(SBGSSAPIBase, GSS_S_BAD_STATUS, SB_GSS_S_BAD_STATUS, SB_GSS_S_BAD_STATUS);
	SB_REGISTER_LONG_CONSTANT(SBGSSAPIBase, GSS_S_BAD_SIG, SB_GSS_S_BAD_SIG, SB_GSS_S_BAD_SIG);
	SB_REGISTER_LONG_CONSTANT(SBGSSAPIBase, GSS_S_NO_CRED, SB_GSS_S_NO_CRED, SB_GSS_S_NO_CRED);
	SB_REGISTER_LONG_CONSTANT(SBGSSAPIBase, GSS_S_NO_CONTEXT, SB_GSS_S_NO_CONTEXT, SB_GSS_S_NO_CONTEXT);
	SB_REGISTER_LONG_CONSTANT(SBGSSAPIBase, GSS_S_DEFECTIVE_TOKEN, SB_GSS_S_DEFECTIVE_TOKEN, SB_GSS_S_DEFECTIVE_TOKEN);
	SB_REGISTER_LONG_CONSTANT(SBGSSAPIBase, GSS_S_DEFECTIVE_CREDENTIAL, SB_GSS_S_DEFECTIVE_CREDENTIAL, SB_GSS_S_DEFECTIVE_CREDENTIAL);
	SB_REGISTER_LONG_CONSTANT(SBGSSAPIBase, GSS_S_CREDENTIALS_EXPIRED, SB_GSS_S_CREDENTIALS_EXPIRED, SB_GSS_S_CREDENTIALS_EXPIRED);
	SB_REGISTER_LONG_CONSTANT(SBGSSAPIBase, GSS_S_CONTEXT_EXPIRED, SB_GSS_S_CONTEXT_EXPIRED, SB_GSS_S_CONTEXT_EXPIRED);
	SB_REGISTER_LONG_CONSTANT(SBGSSAPIBase, GSS_S_FAILURE, SB_GSS_S_FAILURE, SB_GSS_S_FAILURE);
	SB_REGISTER_LONG_CONSTANT(SBGSSAPIBase, GSS_S_BAD_QOP, SB_GSS_S_BAD_QOP, SB_GSS_S_BAD_QOP);
	SB_REGISTER_LONG_CONSTANT(SBGSSAPIBase, GSS_S_UNAUTHORIZED, SB_GSS_S_UNAUTHORIZED, SB_GSS_S_UNAUTHORIZED);
	SB_REGISTER_LONG_CONSTANT(SBGSSAPIBase, GSS_S_UNAVAILABLE, SB_GSS_S_UNAVAILABLE, SB_GSS_S_UNAVAILABLE);
	SB_REGISTER_LONG_CONSTANT(SBGSSAPIBase, GSS_S_DUPLICATE_ELEMENT, SB_GSS_S_DUPLICATE_ELEMENT, SB_GSS_S_DUPLICATE_ELEMENT);
	SB_REGISTER_LONG_CONSTANT(SBGSSAPIBase, GSS_S_NAME_NOT_MN, SB_GSS_S_NAME_NOT_MN, SB_GSS_S_NAME_NOT_MN);
	SB_REGISTER_LONG_CONSTANT(SBGSSAPIBase, GSS_S_BAD_MIC, SB_GSS_S_BAD_MIC, SB_GSS_S_BAD_MIC);
	SB_REGISTER_LONG_CONSTANT(SBGSSAPIBase, GSS_S_CRED_UNAVAIL, SB_GSS_S_CRED_UNAVAIL, SB_GSS_S_CRED_UNAVAIL);
	SB_REGISTER_LONG_CONSTANT(SBGSSAPIBase, GSS_S_CONTINUE_NEEDED, SB_GSS_S_CONTINUE_NEEDED, SB_GSS_S_CONTINUE_NEEDED);
	SB_REGISTER_LONG_CONSTANT(SBGSSAPIBase, GSS_S_DUPLICATE_TOKEN, SB_GSS_S_DUPLICATE_TOKEN, SB_GSS_S_DUPLICATE_TOKEN);
	SB_REGISTER_LONG_CONSTANT(SBGSSAPIBase, GSS_S_OLD_TOKEN, SB_GSS_S_OLD_TOKEN, SB_GSS_S_OLD_TOKEN);
	SB_REGISTER_LONG_CONSTANT(SBGSSAPIBase, GSS_S_UNSEQ_TOKEN, SB_GSS_S_UNSEQ_TOKEN, SB_GSS_S_UNSEQ_TOKEN);
	SB_REGISTER_LONG_CONSTANT(SBGSSAPIBase, GSS_S_GAP_TOKEN, SB_GSS_S_GAP_TOKEN, SB_GSS_S_GAP_TOKEN);
	SB_REGISTER_LONG_CONSTANT(SBGSSAPIBase, GSS_S_CALL_INACCESSIBLE_READ, SB_GSS_S_CALL_INACCESSIBLE_READ, SB_GSS_S_CALL_INACCESSIBLE_READ);
	SB_REGISTER_LONG_CONSTANT(SBGSSAPIBase, GSS_S_CALL_INACCESSIBLE_WRITE, SB_GSS_S_CALL_INACCESSIBLE_WRITE, SB_GSS_S_CALL_INACCESSIBLE_WRITE);
	SB_REGISTER_LONG_CONSTANT(SBGSSAPIBase, GSS_S_CALL_BAD_STRUCTURE, SB_GSS_S_CALL_BAD_STRUCTURE, SB_GSS_S_CALL_BAD_STRUCTURE);
}

