#include "sbhttpauth.h"

#ifdef SB_WINDOWS
SB_PHP_METHOD(SBHTTPAuth_CredHandle, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(SBHTTPAuth_CredHandle));
		intern->len = sizeof(SBHTTPAuth_CredHandle);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(SBHTTPAuth_CredHandle, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(SBHTTPAuth_CredHandle));
}

zend_class_entry *SBHTTPAuth_CredHandle_ce_ptr = NULL;

static zend_function_entry SBHTTPAuth_CredHandle_methods[] = {
	PHP_ME(SBHTTPAuth_CredHandle, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(SBHTTPAuth_CredHandle, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_FE_END
};

void Register_SBHTTPAuth_CredHandle(TSRMLS_D)
{
	zend_class_entry ce;
	if (SBHTTPAuth_CredHandle_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "SBHTTPAuth_CredHandle", SBHTTPAuth_CredHandle_methods);
	SBHTTPAuth_CredHandle_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(SBHTTPAuth_SecBuffer, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(SBHTTPAuth_SecBuffer));
		intern->len = sizeof(SBHTTPAuth_SecBuffer);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(SBHTTPAuth_SecBuffer, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(SBHTTPAuth_SecBuffer));
}

#else
SB_PHP_METHOD(AUTH_SEQ, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(AUTH_SEQ));
		intern->len = sizeof(AUTH_SEQ);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(AUTH_SEQ, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(AUTH_SEQ));
}
#endif

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBBaseStruct_GetField, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBBaseStruct_SetField, 0, 0, 1)
	ZEND_ARG_INFO(0, value)
ZEND_END_ARG_INFO()

#ifdef SB_WINDOWS
SB_PHP_METHOD(SBHTTPAuth_SecBuffer, get_cbBuffer)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(SBHTTPAuth_SecBuffer, set_cbBuffer)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(SBHTTPAuth_SecBuffer, get_BufferType)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 4);
}

SB_PHP_METHOD(SBHTTPAuth_SecBuffer, set_BufferType)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 4);
}

zend_class_entry *SBHTTPAuth_SecBuffer_ce_ptr = NULL;

static zend_function_entry SBHTTPAuth_SecBuffer_methods[] = {
	PHP_ME(SBHTTPAuth_SecBuffer, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(SBHTTPAuth_SecBuffer, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(SBHTTPAuth_SecBuffer, get_cbBuffer, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBHTTPAuth_SecBuffer, set_cbBuffer, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBHTTPAuth_SecBuffer, get_BufferType, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBHTTPAuth_SecBuffer, set_BufferType, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_SBHTTPAuth_SecBuffer(TSRMLS_D)
{
	zend_class_entry ce;
	if (SBHTTPAuth_SecBuffer_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "SBHTTPAuth_SecBuffer", SBHTTPAuth_SecBuffer_methods);
	SBHTTPAuth_SecBuffer_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(SBHTTPAuth_SecBufferDesc, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(SBHTTPAuth_SecBufferDesc));
		intern->len = sizeof(SBHTTPAuth_SecBufferDesc);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(SBHTTPAuth_SecBufferDesc, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(SBHTTPAuth_SecBufferDesc));
}

SB_PHP_METHOD(SBHTTPAuth_SecBufferDesc, get_ulVersion)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(SBHTTPAuth_SecBufferDesc, set_ulVersion)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(SBHTTPAuth_SecBufferDesc, get_cBuffers)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 4);
}

SB_PHP_METHOD(SBHTTPAuth_SecBufferDesc, set_cBuffers)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 4);
}

zend_class_entry *SBHTTPAuth_SecBufferDesc_ce_ptr = NULL;

static zend_function_entry SBHTTPAuth_SecBufferDesc_methods[] = {
	PHP_ME(SBHTTPAuth_SecBufferDesc, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(SBHTTPAuth_SecBufferDesc, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(SBHTTPAuth_SecBufferDesc, get_ulVersion, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBHTTPAuth_SecBufferDesc, set_ulVersion, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBHTTPAuth_SecBufferDesc, get_cBuffers, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBHTTPAuth_SecBufferDesc, set_cBuffers, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_SBHTTPAuth_SecBufferDesc(TSRMLS_D)
{
	zend_class_entry ce;
	if (SBHTTPAuth_SecBufferDesc_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "SBHTTPAuth_SecBufferDesc", SBHTTPAuth_SecBufferDesc_methods);
	SBHTTPAuth_SecBufferDesc_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(SecPkgInfo, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(SecPkgInfo));
		intern->len = sizeof(SecPkgInfo);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(SecPkgInfo, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(SecPkgInfo));
}

SB_PHP_METHOD(SecPkgInfo, get_fCapabilities)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(SecPkgInfo, set_fCapabilities)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(SecPkgInfo, get_wVersion)
{
	SBStuctGetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 4);
}

SB_PHP_METHOD(SecPkgInfo, set_wVersion)
{
	SBStuctSetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 4);
}

SB_PHP_METHOD(SecPkgInfo, get_wRPCID)
{
	SBStuctGetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 6);
}

SB_PHP_METHOD(SecPkgInfo, set_wRPCID)
{
	SBStuctSetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 6);
}

SB_PHP_METHOD(SecPkgInfo, get_cbMaxToken)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 8);
}

SB_PHP_METHOD(SecPkgInfo, set_cbMaxToken)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 8);
}

zend_class_entry *SecPkgInfo_ce_ptr = NULL;

static zend_function_entry SecPkgInfo_methods[] = {
	PHP_ME(SecPkgInfo, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(SecPkgInfo, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(SecPkgInfo, get_fCapabilities, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SecPkgInfo, set_fCapabilities, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SecPkgInfo, get_wVersion, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SecPkgInfo, set_wVersion, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SecPkgInfo, get_wRPCID, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SecPkgInfo, set_wRPCID, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SecPkgInfo, get_cbMaxToken, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SecPkgInfo, set_cbMaxToken, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_SecPkgInfo(TSRMLS_D)
{
	zend_class_entry ce;
	if (SecPkgInfo_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "SecPkgInfo", SecPkgInfo_methods);
	SecPkgInfo_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(SBHTTPAuth_SEC_WINNT_AUTH_IDENTITY, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(SBHTTPAuth_SEC_WINNT_AUTH_IDENTITY));
		intern->len = sizeof(SBHTTPAuth_SEC_WINNT_AUTH_IDENTITY);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(SBHTTPAuth_SEC_WINNT_AUTH_IDENTITY, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(SBHTTPAuth_SEC_WINNT_AUTH_IDENTITY));
}

SB_PHP_METHOD(SBHTTPAuth_SEC_WINNT_AUTH_IDENTITY, get_UserLength)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 4);
}

SB_PHP_METHOD(SBHTTPAuth_SEC_WINNT_AUTH_IDENTITY, set_UserLength)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 4);
}

SB_PHP_METHOD(SBHTTPAuth_SEC_WINNT_AUTH_IDENTITY, get_DomainLength)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 12);
}

SB_PHP_METHOD(SBHTTPAuth_SEC_WINNT_AUTH_IDENTITY, set_DomainLength)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 12);
}

SB_PHP_METHOD(SBHTTPAuth_SEC_WINNT_AUTH_IDENTITY, get_PasswordLength)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 20);
}

SB_PHP_METHOD(SBHTTPAuth_SEC_WINNT_AUTH_IDENTITY, set_PasswordLength)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 20);
}

SB_PHP_METHOD(SBHTTPAuth_SEC_WINNT_AUTH_IDENTITY, get_Flags)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 24);
}

SB_PHP_METHOD(SBHTTPAuth_SEC_WINNT_AUTH_IDENTITY, set_Flags)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 24);
}

zend_class_entry *SBHTTPAuth_SEC_WINNT_AUTH_IDENTITY_ce_ptr = NULL;

static zend_function_entry SBHTTPAuth_SEC_WINNT_AUTH_IDENTITY_methods[] = {
	PHP_ME(SBHTTPAuth_SEC_WINNT_AUTH_IDENTITY, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(SBHTTPAuth_SEC_WINNT_AUTH_IDENTITY, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(SBHTTPAuth_SEC_WINNT_AUTH_IDENTITY, get_UserLength, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBHTTPAuth_SEC_WINNT_AUTH_IDENTITY, set_UserLength, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBHTTPAuth_SEC_WINNT_AUTH_IDENTITY, get_DomainLength, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBHTTPAuth_SEC_WINNT_AUTH_IDENTITY, set_DomainLength, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBHTTPAuth_SEC_WINNT_AUTH_IDENTITY, get_PasswordLength, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBHTTPAuth_SEC_WINNT_AUTH_IDENTITY, set_PasswordLength, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBHTTPAuth_SEC_WINNT_AUTH_IDENTITY, get_Flags, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBHTTPAuth_SEC_WINNT_AUTH_IDENTITY, set_Flags, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_SBHTTPAuth_SEC_WINNT_AUTH_IDENTITY(TSRMLS_D)
{
	zend_class_entry ce;
	if (SBHTTPAuth_SEC_WINNT_AUTH_IDENTITY_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "SBHTTPAuth_SEC_WINNT_AUTH_IDENTITY", SBHTTPAuth_SEC_WINNT_AUTH_IDENTITY_methods);
	SBHTTPAuth_SEC_WINNT_AUTH_IDENTITY_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(AUTH_SEQ, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(AUTH_SEQ));
		intern->len = sizeof(AUTH_SEQ);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(AUTH_SEQ, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(AUTH_SEQ));
}

SB_PHP_METHOD(AUTH_SEQ, get_MaxToken)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 16);
}

SB_PHP_METHOD(AUTH_SEQ, set_MaxToken)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 16);
}
#endif

SB_PHP_METHOD(AUTH_SEQ, get_RequestURI)
{
#ifdef SB_WINDOWS
	SBStuctGetFieldStringA(INTERNAL_FUNCTION_PARAM_PASSTHRU, 64);
#else
	SBStuctGetFieldStringA(INTERNAL_FUNCTION_PARAM_PASSTHRU, 4);
#endif
}

SB_PHP_METHOD(AUTH_SEQ, set_RequestURI)
{
#ifdef SB_WINDOWS
	SBStuctSetFieldStringA(INTERNAL_FUNCTION_PARAM_PASSTHRU, 64);
#else
	SBStuctSetFieldStringA(INTERNAL_FUNCTION_PARAM_PASSTHRU, 4);
#endif
}

SB_PHP_METHOD(AUTH_SEQ, get_RequestMethod)
{
#ifdef SB_WINDOWS
	SBStuctGetFieldInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 68);
#else
	SBStuctGetFieldInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 8);
#endif
}

SB_PHP_METHOD(AUTH_SEQ, set_RequestMethod)
{
#ifdef SB_WINDOWS
	SBStuctSetFieldInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 68);
#else
	SBStuctSetFieldInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 8);
#endif
}

SB_PHP_METHOD(AUTH_SEQ, get_sNonce)
{
#ifdef SB_WINDOWS
	SBStuctGetFieldStringA(INTERNAL_FUNCTION_PARAM_PASSTHRU, 72);
#else
	SBStuctGetFieldStringA(INTERNAL_FUNCTION_PARAM_PASSTHRU, 12);
#endif
}

SB_PHP_METHOD(AUTH_SEQ, set_sNonce)
{
#ifdef SB_WINDOWS
	SBStuctSetFieldStringA(INTERNAL_FUNCTION_PARAM_PASSTHRU, 72);
#else
	SBStuctSetFieldStringA(INTERNAL_FUNCTION_PARAM_PASSTHRU, 12);
#endif
}

SB_PHP_METHOD(AUTH_SEQ, get_cNonce)
{
#ifdef SB_WINDOWS
	SBStuctGetFieldStringA(INTERNAL_FUNCTION_PARAM_PASSTHRU, 76);
#else
	SBStuctGetFieldStringA(INTERNAL_FUNCTION_PARAM_PASSTHRU, 16);
#endif
}

SB_PHP_METHOD(AUTH_SEQ, set_cNonce)
{
#ifdef SB_WINDOWS
	SBStuctSetFieldStringA(INTERNAL_FUNCTION_PARAM_PASSTHRU, 76);
#else
	SBStuctSetFieldStringA(INTERNAL_FUNCTION_PARAM_PASSTHRU, 16);
#endif
}

SB_PHP_METHOD(AUTH_SEQ, get_cNonceCount)
{
#ifdef SB_WINDOWS
	SBStuctGetFieldInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 80);
#else
	SBStuctGetFieldInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 20);
#endif
}

SB_PHP_METHOD(AUTH_SEQ, set_cNonceCount)
{
#ifdef SB_WINDOWS
	SBStuctSetFieldInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 80);
#else
	SBStuctSetFieldInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 20);
#endif
}

SB_PHP_METHOD(AUTH_SEQ, get_cRequest)
{
#ifdef SB_WINDOWS
	SBStuctGetFieldStringA(INTERNAL_FUNCTION_PARAM_PASSTHRU, 84);
#else
	SBStuctGetFieldStringA(INTERNAL_FUNCTION_PARAM_PASSTHRU, 24);
#endif
}

SB_PHP_METHOD(AUTH_SEQ, set_cRequest)
{
#ifdef SB_WINDOWS
	SBStuctSetFieldStringA(INTERNAL_FUNCTION_PARAM_PASSTHRU, 84);
#else
	SBStuctSetFieldStringA(INTERNAL_FUNCTION_PARAM_PASSTHRU, 24);
#endif
}

zend_class_entry *AUTH_SEQ_ce_ptr = NULL;

static zend_function_entry AUTH_SEQ_methods[] = {
	PHP_ME(AUTH_SEQ, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(AUTH_SEQ, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
#ifdef SB_WINDOWS
	PHP_ME(AUTH_SEQ, get_MaxToken, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(AUTH_SEQ, set_MaxToken, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
#endif
	PHP_ME(AUTH_SEQ, get_RequestURI, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(AUTH_SEQ, set_RequestURI, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(AUTH_SEQ, get_RequestMethod, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(AUTH_SEQ, set_RequestMethod, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(AUTH_SEQ, get_sNonce, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(AUTH_SEQ, set_sNonce, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(AUTH_SEQ, get_cNonce, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(AUTH_SEQ, set_cNonce, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(AUTH_SEQ, get_cNonceCount, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(AUTH_SEQ, set_cNonceCount, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(AUTH_SEQ, get_cRequest, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(AUTH_SEQ, set_cRequest, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_AUTH_SEQ(TSRMLS_D)
{
	zend_class_entry ce;
	if (AUTH_SEQ_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "AUTH_SEQ", AUTH_SEQ_methods);
	AUTH_SEQ_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

#ifdef SB_WINDOWS
SB_PHP_METHOD(secFuncs, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(secFuncs));
		intern->len = sizeof(secFuncs);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(secFuncs, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(secFuncs));
}

zend_class_entry *secFuncs_ce_ptr = NULL;

static zend_function_entry secFuncs_methods[] = {
	PHP_ME(secFuncs, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(secFuncs, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_FE_END
};

void Register_secFuncs(TSRMLS_D)
{
	zend_class_entry ce;
	if (secFuncs_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "secFuncs", secFuncs_methods);
	secFuncs_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}
#endif

SB_PHP_FUNCTION(SBHTTPAuth, AuthInit)
{
	zval *opAS;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &opAS, AUTH_SEQ_ce_ptr) == SUCCESS)
	{
		SBCheckError(SBHTTPAuth_AuthInit((AUTH_SEQ *)SBGetStructPointer(opAS TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(AUTH_SEQ)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBHTTPAuth, AuthTerm)
{
	zval *opAS;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &opAS, AUTH_SEQ_ce_ptr) == SUCCESS)
	{
		SBCheckError(SBHTTPAuth_AuthTerm((AUTH_SEQ *)SBGetStructPointer(opAS TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(AUTH_SEQ)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBHTTPAuth, AuthConverse)
{
	char *sPackage;
	char *sPassword;
	char *sUser;
	int sPackage_len;
	int sPassword_len;
	int sUser_len;
	int8_t bNeedMoreDataRaw;
	SBArrayZValInfo aiBuffIn;
	SBArrayZValInfo aiBuffOut;
	uint32_t _err;
	zval *opAS;
	zval *zaBuffIn;
	zval *zaBuffOut;
	zval *zbNeedMoreData;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!zzzsss", &opAS, AUTH_SEQ_ce_ptr, &zaBuffIn, &zaBuffOut, &zbNeedMoreData, &sPackage, &sPackage_len, &sUser, &sUser_len, &sPassword, &sPassword_len) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaBuffIn)) || (IS_ARRAY == Z_TYPE_P(zaBuffIn)) || (IS_NULL == Z_TYPE_P(zaBuffIn))) && PZVAL_IS_REF(zaBuffOut) && ((IS_STRING == Z_TYPE_P(zaBuffOut)) || (IS_ARRAY == Z_TYPE_P(zaBuffOut))) && PZVAL_IS_REF(zbNeedMoreData) && (IS_BOOL == Z_TYPE_P(zbNeedMoreData)))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaBuffIn, &aiBuffIn TSRMLS_CC)) RETURN_FALSE;
		SBInitArrayZValInfo(&aiBuffOut);
		bNeedMoreDataRaw = (int8_t)Z_BVAL_P(zbNeedMoreData);
		_err = SBHTTPAuth_AuthConverse((AUTH_SEQ *)SBGetStructPointer(opAS TSRMLS_CC), aiBuffIn.data, aiBuffIn.len, aiBuffOut.data, &aiBuffOut.len, &bNeedMoreDataRaw, sPackage, (int32_t)sPackage_len, sUser, (int32_t)sUser_len, sPassword, (int32_t)sPassword_len, &bOutResultRaw);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			SBDetachDataFromZValAndResize(zaBuffOut, &aiBuffOut TSRMLS_CC);
			SBCheckError(SBGetLastReturnBuffer(-813209678, 2, aiBuffOut.data, &aiBuffOut.len) TSRMLS_CC);
			((char *)aiBuffOut.data)[aiBuffOut.len] = 0;
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBFreeArrayZValInfo(&aiBuffOut);
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiBuffIn);
		SBSetByteArrayToZVal(&aiBuffOut, zaBuffOut);
		ZVAL_BOOL(zbNeedMoreData, (zend_bool)bNeedMoreDataRaw);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(AUTH_SEQ, array of byte|string|NULL, &array of byte|string, &bool, string, string, string)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBHTTPAuth, AddAuthorizationHeader)
{
	char *sAuthData;
	char *sPassword;
	char *sScheme;
	char *sStr;
	char *sUserName;
	int sAuthData_len;
	int sPassword_len;
	int sScheme_len;
	int sUserName_len;
	int32_t sStr_len;
	int8_t bNeedMoreDataRaw;
	uint32_t _err;
	zend_bool bForProxy;
	zval *oaSeq;
	zval *zbNeedMoreData;
	zval *zsStr;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zsssszbO!", &zsStr, &sScheme, &sScheme_len, &sAuthData, &sAuthData_len, &sUserName, &sUserName_len, &sPassword, &sPassword_len, &zbNeedMoreData, &bForProxy, &oaSeq, AUTH_SEQ_ce_ptr) == SUCCESS) && PZVAL_IS_REF(zsStr) && (IS_STRING == Z_TYPE_P(zsStr)) && PZVAL_IS_REF(zbNeedMoreData) && (IS_BOOL == Z_TYPE_P(zbNeedMoreData)))
	{
		int8_t bOutResultRaw = 0;
		sStr = Z_STRVAL_P(zsStr);
		sStr_len = (int32_t)Z_STRLEN_P(zsStr);
		bNeedMoreDataRaw = (int8_t)Z_BVAL_P(zbNeedMoreData);
		_err = SBHTTPAuth_AddAuthorizationHeader(sStr, &sStr_len, sScheme, (int32_t)sScheme_len, sAuthData, (int32_t)sAuthData_len, sUserName, (int32_t)sUserName_len, sPassword, (int32_t)sPassword_len, &bNeedMoreDataRaw, (int8_t)bForProxy, (AUTH_SEQ *)SBGetStructPointer(oaSeq TSRMLS_CC), &bOutResultRaw);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sStr = emalloc(sStr_len + 1);
			SBCheckError(SBGetLastReturnStringA(703882796, 0, sStr, &sStr_len) TSRMLS_CC);
			zval_dtor(zsStr);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		sStr[sStr_len] = 0;
		ZVAL_STRINGL(zsStr, sStr, sStr_len, 0);
		ZVAL_BOOL(zbNeedMoreData, (zend_bool)bNeedMoreDataRaw);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(&string, string, string, string, string, &bool, bool, AUTH_SEQ)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBHTTPAuth, ValidateSecPacks)
{
	zval *ols;
#ifdef SB_WINDOWS
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &ols, TStringList_ce_ptr) == SUCCESS)
#else
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &ols, TElStringList_ce_ptr) == SUCCESS)
#endif
	{
		SBCheckError(SBHTTPAuth_ValidateSecPacks(SBGetObjectHandle(ols TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
#ifdef SB_WINDOWS
		SBErrorExpectsArguments("(TStringList)" TSRMLS_CC);
#else
		SBErrorExpectsArguments("(TElStringList)" TSRMLS_CC);
#endif
	}
}

SB_PHP_FUNCTION(SBHTTPAuth, InitAuthLib)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(SBHTTPAuth_InitAuthLib() TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

void Register_SBHTTPAuth_Constants(int module_number TSRMLS_DC)
{
	SB_REGISTER_LONG_CONSTANT(SBHTTPAuth, SEC_WINNT_AUTH_IDENTITY_ANSI, SB_SEC_WINNT_AUTH_IDENTITY_ANSI, SB_SEC_WINNT_AUTH_IDENTITY_ANSI);
	SB_REGISTER_LONG_CONSTANT(SBHTTPAuth, SEC_WINNT_AUTH_IDENTITY_UNICODE, SB_SEC_WINNT_AUTH_IDENTITY_UNICODE, SB_SEC_WINNT_AUTH_IDENTITY_UNICODE);
	SB_REGISTER_LONG_CONSTANT(SBHTTPAuth, SECPKG_CRED_OUTBOUND, SB_SECPKG_CRED_OUTBOUND, SB_SECPKG_CRED_OUTBOUND);
	SB_REGISTER_LONG_CONSTANT(SBHTTPAuth, SECBUFFER_TOKEN, SB_SECBUFFER_TOKEN, SB_SECBUFFER_TOKEN);
	SB_REGISTER_LONG_CONSTANT(SBHTTPAuth, SECURITY_NATIVE_DREP, SB_SECURITY_NATIVE_DREP, SB_SECURITY_NATIVE_DREP);
	SB_REGISTER_LONG_CONSTANT(SBHTTPAuth, SEC_I_CONTINUE_NEEDED, SB_SEC_I_CONTINUE_NEEDED, SB_SEC_I_CONTINUE_NEEDED);
	SB_REGISTER_LONG_CONSTANT(SBHTTPAuth, SEC_I_COMPLETE_NEEDED, SB_SEC_I_COMPLETE_NEEDED, SB_SEC_I_COMPLETE_NEEDED);
	SB_REGISTER_LONG_CONSTANT(SBHTTPAuth, SEC_I_COMPLETE_AND_CONTINUE, SB_SEC_I_COMPLETE_AND_CONTINUE, SB_SEC_I_COMPLETE_AND_CONTINUE);
#ifdef SB_WINDOWS
}

void Register_SBHTTPAuth_Aliases(TSRMLS_D)
{
	if (NULL == SBHTTPAuth_CredHandle_ce_ptr)
		Register_SBHTTPAuth_CredHandle(TSRMLS_C);
	zend_register_class_alias("SBHTTPAuth_CtxtHandle", SBHTTPAuth_CredHandle_ce_ptr);
#endif
}
