#include "sbldapcertstorage.h"

zend_class_entry *TElLDAPCertStorage_ce_ptr = NULL;

SB_PHP_METHOD(TElLDAPCertStorage, Validate)
{
	TSBCertificateValidityReasonRaw fReasonRaw;
	zend_bool bCheckCACertDates;
	zval *dtValidityMoment;
	zval *oCertificate;
	zval *zfReason;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!zbO", &oCertificate, TElX509Certificate_ce_ptr, &zfReason, &bCheckCACertDates, &dtValidityMoment, php_date_get_date_ce()) == SUCCESS) && PZVAL_IS_REF(zfReason) && (IS_LONG == Z_TYPE_P(zfReason)))
	{
		TSBCertificateValidityRaw fOutResultRaw = 0;
		fReasonRaw = (TSBCertificateValidityReasonRaw)Z_LVAL_P(zfReason);
		SBCheckError(TElLDAPCertStorage_Validate(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oCertificate TSRMLS_CC), &fReasonRaw, (int8_t)bCheckCACertDates, SBGetDateTime(dtValidityMoment TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		ZVAL_LONG(zfReason, (long)fReasonRaw);
		RETURN_LONG((long)fOutResultRaw);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!zO", &oCertificate, TElX509Certificate_ce_ptr, &zfReason, &dtValidityMoment, php_date_get_date_ce()) == SUCCESS) && PZVAL_IS_REF(zfReason) && (IS_LONG == Z_TYPE_P(zfReason)))
	{
		TSBCertificateValidityRaw fOutResultRaw = 0;
		fReasonRaw = (TSBCertificateValidityReasonRaw)Z_LVAL_P(zfReason);
		SBCheckError(TElLDAPCertStorage_Validate_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oCertificate TSRMLS_CC), &fReasonRaw, SBGetDateTime(dtValidityMoment TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		ZVAL_LONG(zfReason, (long)fReasonRaw);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElX509Certificate, &integer, bool, DateTime) or (TElX509Certificate, &integer, DateTime)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElLDAPCertStorage, Add)
{
	zend_bool bCopyPrivateKey;
	zval *oX509Certificate;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!b", &oX509Certificate, TElX509Certificate_ce_ptr, &bCopyPrivateKey) == SUCCESS)
	{
		SBCheckError(TElLDAPCertStorage_Add(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oX509Certificate TSRMLS_CC), (int8_t)bCopyPrivateKey) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElX509Certificate, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElLDAPCertStorage, Remove)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		SBCheckError(TElLDAPCertStorage_Remove(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElLDAPCertStorage, get_LDAPSClient)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElLDAPCertStorage_get_LDAPSClient(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElLDAPSClient_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElLDAPCertStorage, set_LDAPSClient)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElLDAPSClient_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElLDAPCertStorage_set_LDAPSClient(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElLDAPSClient)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElLDAPCertStorage, __construct)
{
	zval *oOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElLDAPCertStorage_Create(SBGetObjectHandle(oOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElLDAPCertStorage_Validate, 0, 0, 3)
	ZEND_ARG_OBJ_INFO(0, Certificate, TElX509Certificate, 1)
	ZEND_ARG_INFO(1, Reason)
	ZEND_ARG_INFO(0, CheckCACertDates_or_ValidityMoment)
	ZEND_ARG_OBJ_INFO(0, ValidityMoment, DateTime, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElLDAPCertStorage_Add, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, X509Certificate, 0, 1)
	ZEND_ARG_INFO(0, CopyPrivateKey)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElLDAPCertStorage_Remove, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElLDAPCertStorage_get_LDAPSClient, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElLDAPCertStorage_set_LDAPSClient, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElLDAPSClient, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElLDAPCertStorage___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Owner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElLDAPCertStorage_methods[] = {
	PHP_ME(TElLDAPCertStorage, Validate, arginfo_TElLDAPCertStorage_Validate, ZEND_ACC_PUBLIC)
	PHP_ME(TElLDAPCertStorage, Add, arginfo_TElLDAPCertStorage_Add, ZEND_ACC_PUBLIC)
	PHP_ME(TElLDAPCertStorage, Remove, arginfo_TElLDAPCertStorage_Remove, ZEND_ACC_PUBLIC)
	PHP_ME(TElLDAPCertStorage, get_LDAPSClient, arginfo_TElLDAPCertStorage_get_LDAPSClient, ZEND_ACC_PUBLIC)
	PHP_ME(TElLDAPCertStorage, set_LDAPSClient, arginfo_TElLDAPCertStorage_set_LDAPSClient, ZEND_ACC_PUBLIC)
	PHP_ME(TElLDAPCertStorage, __construct, arginfo_TElLDAPCertStorage___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElLDAPCertStorage(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElLDAPCertStorage_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElLDAPCertStorage", TElLDAPCertStorage_methods);
	if (NULL == TElCustomCertStorage_ce_ptr)
		Register_TElCustomCertStorage(TSRMLS_C);
	TElLDAPCertStorage_ce_ptr = zend_register_internal_class_ex(&ce, TElCustomCertStorage_ce_ptr, NULL TSRMLS_CC);
}

void Register_SBLDAPCertStorage_Constants(int module_number TSRMLS_DC)
{
	SB_REGISTER_STRING_CONSTANT(SBLDAPCertStorage, SLDAPSClientNotAssigned, SB_SLDAPSClientNotAssigned, SB_SLDAPSClientNotAssigned);
}

void Register_SBLDAPCertStorage_Aliases(TSRMLS_D)
{
	if (NULL == TElLDAPCertStorage_ce_ptr)
		Register_TElLDAPCertStorage(TSRMLS_C);
	zend_register_class_alias("ElLDAPCertStorage", TElLDAPCertStorage_ce_ptr);
}

