#include "sbofficepackage.h"

void SB_CALLBACK TSBOfficeGetDataStreamEventRaw(void * _ObjectData, TObjectHandle Sender, const char * pcPath, int32_t szPath, TStreamHandle * Stream)
{
	zval *retval_ptr;
	zval **params[3];
	zval * zSender;
	zval * zPath;
	zval * zStream;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zPath);
	ZVAL_STRINGL(zPath, pcPath, szPath, 1);
	MAKE_STD_ZVAL(zStream);
	SBInitObject(zStream, TStream_ce_ptr, *Stream TSRMLS_CC);

	params[0] = &zSender;
	params[1] = &zPath;
	params[2] = &zStream;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 3, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zPath);
	*Stream = SBGetObjectHandleCE(zStream, TStream_ce_ptr TSRMLS_CC);
	SBDetachObjectHandleIfUniqueZVal(zStream TSRMLS_CC);
	zval_ptr_dtor(&zStream);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBOfficeCloseDataStreamEventRaw(void * _ObjectData, TObjectHandle Sender, TStreamHandle Stream)
{
	zval *retval_ptr;
	zval **params[2];
	zval * zSender;
	zval * zStream;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zStream);
	SBInitObject(zStream, TStream_ce_ptr, Stream TSRMLS_CC);

	params[0] = &zSender;
	params[1] = &zStream;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 2, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zStream);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

zend_class_entry *TElOfficePackagePart_ce_ptr = NULL;

SB_PHP_METHOD(TElOfficePackagePart, GetStream)
{
	zend_bool bReadOnly;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficePackagePart_GetStream(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TStream_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bReadOnly) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficePackagePart_GetStream_1(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bReadOnly, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TStream_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("() or (bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficePackagePart, CloseStream)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElOfficePackagePart_CloseStream(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficePackagePart, GetRelationshipsStream)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficePackagePart_GetRelationshipsStream(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TStream_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficePackagePart, CloseRelationshipsStream)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElOfficePackagePart_CloseRelationshipsStream(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficePackagePart, get_Package)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficePackagePart_get_Package(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElOfficePackage_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficePackagePart, get_Relationships)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficePackagePart_get_Relationships(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElOfficeOpenXMLRelationships_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficePackagePart, get_ContentType)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElOfficePackagePart_get_ContentType(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1869010986, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficePackagePart, get_URI)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElOfficePackagePart_get_URI(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-2008714719, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficePackagePart, get_IsInterleavedPart)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElOfficePackagePart_get_IsInterleavedPart(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficePackagePart, get_PieceCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElOfficePackagePart_get_PieceCount(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficePackagePart, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficePackagePart_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficePackagePart_GetStream, 0, 0, 0)
	ZEND_ARG_INFO(0, ReadOnly)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficePackagePart_CloseStream, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficePackagePart_GetRelationshipsStream, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficePackagePart_CloseRelationshipsStream, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficePackagePart_get_Package, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficePackagePart_get_Relationships, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficePackagePart_get_ContentType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficePackagePart_get_URI, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficePackagePart_get_IsInterleavedPart, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficePackagePart_get_PieceCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficePackagePart___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElOfficePackagePart_methods[] = {
	PHP_ME(TElOfficePackagePart, GetStream, arginfo_TElOfficePackagePart_GetStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficePackagePart, CloseStream, arginfo_TElOfficePackagePart_CloseStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficePackagePart, GetRelationshipsStream, arginfo_TElOfficePackagePart_GetRelationshipsStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficePackagePart, CloseRelationshipsStream, arginfo_TElOfficePackagePart_CloseRelationshipsStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficePackagePart, get_Package, arginfo_TElOfficePackagePart_get_Package, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficePackagePart, get_Relationships, arginfo_TElOfficePackagePart_get_Relationships, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficePackagePart, get_ContentType, arginfo_TElOfficePackagePart_get_ContentType, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficePackagePart, get_URI, arginfo_TElOfficePackagePart_get_URI, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficePackagePart, get_IsInterleavedPart, arginfo_TElOfficePackagePart_get_IsInterleavedPart, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficePackagePart, get_PieceCount, arginfo_TElOfficePackagePart_get_PieceCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficePackagePart, __construct, arginfo_TElOfficePackagePart___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElOfficePackagePart(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElOfficePackagePart_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElOfficePackagePart", TElOfficePackagePart_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElOfficePackagePart_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElOfficePackage_ce_ptr = NULL;

SB_PHP_METHOD(TElOfficePackage, Close)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElOfficePackage_Close(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficePackage, Flush)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElOfficePackage_Flush(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficePackage, FlushCoreProperties)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElOfficePackage_FlushCoreProperties(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficePackage, CreatePart)
{
	char *sContentType;
	char *sURI;
	int sContentType_len;
	int sURI_len;
	long l8ExpectedStreamSize;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &sURI, &sURI_len, &sContentType, &sContentType_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficePackage_CreatePart(SBGetObjectHandle(getThis() TSRMLS_CC), sURI, (int32_t)sURI_len, sContentType, (int32_t)sContentType_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElOfficePackagePart_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssl", &sURI, &sURI_len, &sContentType, &sContentType_len, &l8ExpectedStreamSize) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficePackage_CreatePart_1(SBGetObjectHandle(getThis() TSRMLS_CC), sURI, (int32_t)sURI_len, sContentType, (int32_t)sContentType_len, (int64_t)l8ExpectedStreamSize, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElOfficePackagePart_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, string) or (string, string, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficePackage, DeletePart)
{
	char *sURI;
	int sURI_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sURI, &sURI_len) == SUCCESS)
	{
		SBCheckError(TElOfficePackage_DeletePart(SBGetObjectHandle(getThis() TSRMLS_CC), sURI, (int32_t)sURI_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficePackage, GetPart)
{
	char *sURI;
	int sURI_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sURI, &sURI_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficePackage_GetPart(SBGetObjectHandle(getThis() TSRMLS_CC), sURI, (int32_t)sURI_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElOfficePackagePart_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficePackage, GetPackageRelatedPartByType)
{
	char *sRelType;
	int sRelType_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sRelType, &sRelType_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficePackage_GetPackageRelatedPartByType(SBGetObjectHandle(getThis() TSRMLS_CC), sRelType, (int32_t)sRelType_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElOfficePackagePart_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficePackage, GetRelatedPartByType)
{
	char *sRelType;
	int sRelType_len;
	zval *oPart;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!s", &oPart, TElOfficePackagePart_ce_ptr, &sRelType, &sRelType_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficePackage_GetRelatedPartByType(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oPart TSRMLS_CC), sRelType, (int32_t)sRelType_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElOfficePackagePart_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElOfficePackagePart, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficePackage, GetZipPackageStream)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficePackage_GetZipPackageStream(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TStream_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficePackage, CloseZipPackageStream)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElOfficePackage_CloseZipPackageStream(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficePackage, GetPackageRelationshipsStream)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficePackage_GetPackageRelationshipsStream(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TStream_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficePackage, ClosePackageRelationshipsStream)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElOfficePackage_ClosePackageRelationshipsStream(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficePackage, get_IsReadOnly)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElOfficePackage_get_IsReadOnly(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficePackage, get_ContentTypes)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficePackage_get_ContentTypes(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElOfficeOpenXMLContentTypes_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficePackage, get_CoreProperties)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficePackage_get_CoreProperties(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElOfficeOpenXMLCoreProperties_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficePackage, get_Relationships)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficePackage_get_Relationships(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElOfficeOpenXMLRelationships_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficePackage, get_PartCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElOfficePackage_get_PartCount(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficePackage, get_Parts)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficePackage_get_Parts(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElOfficePackagePart_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficePackage, get_OnCreateTemporaryStream)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBOfficeCreateTemporaryStreamEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElOfficePackage_get_OnCreateTemporaryStream(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficePackage, set_OnCreateTemporaryStream)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElOfficePackage_set_OnCreateTemporaryStream(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBOfficeCreateTemporaryStreamEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBOfficeCreateTemporaryStreamEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficePackage, get_OnCloseTemporaryStream)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBOfficeCloseTemporaryStreamEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElOfficePackage_get_OnCloseTemporaryStream(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficePackage, set_OnCloseTemporaryStream)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElOfficePackage_set_OnCloseTemporaryStream(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBOfficeCloseTemporaryStreamEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBOfficeCloseTemporaryStreamEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficePackage, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficePackage_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficePackage_Close, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficePackage_Flush, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficePackage_FlushCoreProperties, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficePackage_CreatePart, 0, 0, 2)
	ZEND_ARG_INFO(0, URI)
	ZEND_ARG_INFO(0, ContentType)
	ZEND_ARG_INFO(0, ExpectedStreamSize)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficePackage_DeletePart, 0, 0, 1)
	ZEND_ARG_INFO(0, URI)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficePackage_GetPart, 0, 0, 1)
	ZEND_ARG_INFO(0, URI)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficePackage_GetPackageRelatedPartByType, 0, 0, 1)
	ZEND_ARG_INFO(0, RelType)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficePackage_GetRelatedPartByType, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, Part, TElOfficePackagePart, 1)
	ZEND_ARG_INFO(0, RelType)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficePackage_GetZipPackageStream, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficePackage_CloseZipPackageStream, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficePackage_GetPackageRelationshipsStream, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficePackage_ClosePackageRelationshipsStream, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficePackage_get_IsReadOnly, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficePackage_get_ContentTypes, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficePackage_get_CoreProperties, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficePackage_get_Relationships, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficePackage_get_PartCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficePackage_get_Parts, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficePackage_get_OnCreateTemporaryStream, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficePackage_set_OnCreateTemporaryStream, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficePackage_get_OnCloseTemporaryStream, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficePackage_set_OnCloseTemporaryStream, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficePackage___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElOfficePackage_methods[] = {
	PHP_ME(TElOfficePackage, Close, arginfo_TElOfficePackage_Close, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficePackage, Flush, arginfo_TElOfficePackage_Flush, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficePackage, FlushCoreProperties, arginfo_TElOfficePackage_FlushCoreProperties, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficePackage, CreatePart, arginfo_TElOfficePackage_CreatePart, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficePackage, DeletePart, arginfo_TElOfficePackage_DeletePart, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficePackage, GetPart, arginfo_TElOfficePackage_GetPart, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficePackage, GetPackageRelatedPartByType, arginfo_TElOfficePackage_GetPackageRelatedPartByType, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficePackage, GetRelatedPartByType, arginfo_TElOfficePackage_GetRelatedPartByType, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficePackage, GetZipPackageStream, arginfo_TElOfficePackage_GetZipPackageStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficePackage, CloseZipPackageStream, arginfo_TElOfficePackage_CloseZipPackageStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficePackage, GetPackageRelationshipsStream, arginfo_TElOfficePackage_GetPackageRelationshipsStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficePackage, ClosePackageRelationshipsStream, arginfo_TElOfficePackage_ClosePackageRelationshipsStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficePackage, get_IsReadOnly, arginfo_TElOfficePackage_get_IsReadOnly, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficePackage, get_ContentTypes, arginfo_TElOfficePackage_get_ContentTypes, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficePackage, get_CoreProperties, arginfo_TElOfficePackage_get_CoreProperties, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficePackage, get_Relationships, arginfo_TElOfficePackage_get_Relationships, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficePackage, get_PartCount, arginfo_TElOfficePackage_get_PartCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficePackage, get_Parts, arginfo_TElOfficePackage_get_Parts, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficePackage, get_OnCreateTemporaryStream, arginfo_TElOfficePackage_get_OnCreateTemporaryStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficePackage, set_OnCreateTemporaryStream, arginfo_TElOfficePackage_set_OnCreateTemporaryStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficePackage, get_OnCloseTemporaryStream, arginfo_TElOfficePackage_get_OnCloseTemporaryStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficePackage, set_OnCloseTemporaryStream, arginfo_TElOfficePackage_set_OnCloseTemporaryStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficePackage, __construct, arginfo_TElOfficePackage___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElOfficePackage(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElOfficePackage_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElOfficePackage", TElOfficePackage_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElOfficePackage_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElOfficeZipPackage_ce_ptr = NULL;

SB_PHP_METHOD(TElOfficeZipPackage, Open)
{
	long l8StreamOffset;
	zend_bool bOwnStream;
	zend_bool bReadOnly;
	zval *oStream;
	zval *oZipReader;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oStream, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElOfficeZipPackage_Open(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!b", &oStream, TStream_ce_ptr, &bOwnStream) == SUCCESS)
	{
		SBCheckError(TElOfficeZipPackage_Open_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC), (int8_t)bOwnStream) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!bb", &oStream, TStream_ce_ptr, &bOwnStream, &bReadOnly) == SUCCESS)
	{
		SBCheckError(TElOfficeZipPackage_Open_2(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC), (int8_t)bOwnStream, (int8_t)bReadOnly) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!lbbO!", &oStream, TStream_ce_ptr, &l8StreamOffset, &bOwnStream, &bReadOnly, &oZipReader, TElZipReader_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElOfficeZipPackage_Open_3(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC), (int64_t)l8StreamOffset, (int8_t)bOwnStream, (int8_t)bReadOnly, SBGetObjectHandle(oZipReader TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream) or (TStream, bool) or (TStream, bool, bool) or (TStream, integer, bool, bool, TElZipReader)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeZipPackage, Flush)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElOfficeZipPackage_Flush(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeZipPackage, Close)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElOfficeZipPackage_Close(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeZipPackage, GetZipPackageStream)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeZipPackage_GetZipPackageStream(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TStream_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeZipPackage, CloseZipPackageStream)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElOfficeZipPackage_CloseZipPackageStream(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeZipPackage, get_CompressionLevel)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElOfficeZipPackage_get_CompressionLevel(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeZipPackage, set_CompressionLevel)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElOfficeZipPackage_set_CompressionLevel(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeZipPackage, get_ZipReader)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeZipPackage_get_ZipReader(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElZipReader_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeZipPackage, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeZipPackage_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeZipPackage_Open, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Stream, TStream, 1)
	ZEND_ARG_INFO(0, OwnStream_or_StreamOffset)
	ZEND_ARG_INFO(0, ReadOnly_or_OwnStream)
	ZEND_ARG_INFO(0, ReadOnly)
	ZEND_ARG_OBJ_INFO(0, ZipReader, TElZipReader, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeZipPackage_Flush, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeZipPackage_Close, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeZipPackage_GetZipPackageStream, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeZipPackage_CloseZipPackageStream, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeZipPackage_get_CompressionLevel, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeZipPackage_set_CompressionLevel, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeZipPackage_get_ZipReader, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeZipPackage___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElOfficeZipPackage_methods[] = {
	PHP_ME(TElOfficeZipPackage, Open, arginfo_TElOfficeZipPackage_Open, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeZipPackage, Flush, arginfo_TElOfficeZipPackage_Flush, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeZipPackage, Close, arginfo_TElOfficeZipPackage_Close, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeZipPackage, GetZipPackageStream, arginfo_TElOfficeZipPackage_GetZipPackageStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeZipPackage, CloseZipPackageStream, arginfo_TElOfficeZipPackage_CloseZipPackageStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeZipPackage, get_CompressionLevel, arginfo_TElOfficeZipPackage_get_CompressionLevel, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeZipPackage, set_CompressionLevel, arginfo_TElOfficeZipPackage_set_CompressionLevel, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeZipPackage, get_ZipReader, arginfo_TElOfficeZipPackage_get_ZipReader, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeZipPackage, __construct, arginfo_TElOfficeZipPackage___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElOfficeZipPackage(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElOfficeZipPackage_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElOfficeZipPackage", TElOfficeZipPackage_methods);
	if (NULL == TElOfficePackage_ce_ptr)
		Register_TElOfficePackage(TSRMLS_C);
	TElOfficeZipPackage_ce_ptr = zend_register_internal_class_ex(&ce, TElOfficePackage_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElOpenOfficePackage_ce_ptr = NULL;

SB_PHP_METHOD(TElOpenOfficePackage, CreateNew)
{
	zend_bool bOwnStream;
	zval *oStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!b", &oStream, TStream_ce_ptr, &bOwnStream) == SUCCESS)
	{
		SBCheckError(TElOpenOfficePackage_CreateNew(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC), (int8_t)bOwnStream) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOpenOfficePackage, Open)
{
	long l8StreamOffset;
	zend_bool bOwnStream;
	zend_bool bReadOnly;
	zval *oStream;
	zval *oZipReader;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oStream, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElOpenOfficePackage_Open(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!b", &oStream, TStream_ce_ptr, &bOwnStream) == SUCCESS)
	{
		SBCheckError(TElOpenOfficePackage_Open_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC), (int8_t)bOwnStream) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!bb", &oStream, TStream_ce_ptr, &bOwnStream, &bReadOnly) == SUCCESS)
	{
		SBCheckError(TElOpenOfficePackage_Open_2(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC), (int8_t)bOwnStream, (int8_t)bReadOnly) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!lbbO!", &oStream, TStream_ce_ptr, &l8StreamOffset, &bOwnStream, &bReadOnly, &oZipReader, TElZipReader_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElOpenOfficePackage_Open_3(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC), (int64_t)l8StreamOffset, (int8_t)bOwnStream, (int8_t)bReadOnly, SBGetObjectHandle(oZipReader TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream) or (TStream, bool) or (TStream, bool, bool) or (TStream, integer, bool, bool, TElZipReader)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOpenOfficePackage, Flush)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElOpenOfficePackage_Flush(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOpenOfficePackage, FlushManifest)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElOpenOfficePackage_FlushManifest(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOpenOfficePackage, Close)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElOpenOfficePackage_Close(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOpenOfficePackage, CreateEntry)
{
	char *sPath;
	int sPath_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sPath, &sPath_len) == SUCCESS)
	{
		SBCheckError(TElOpenOfficePackage_CreateEntry(SBGetObjectHandle(getThis() TSRMLS_CC), sPath, (int32_t)sPath_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOpenOfficePackage, CreateStream)
{
	char *sPath;
	int sPath_len;
	long l8ExpectedStreamSize;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sl", &sPath, &sPath_len, &l8ExpectedStreamSize) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOpenOfficePackage_CreateStream(SBGetObjectHandle(getThis() TSRMLS_CC), sPath, (int32_t)sPath_len, (int64_t)l8ExpectedStreamSize, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TStream_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOpenOfficePackage, GetStream)
{
	char *sPath;
	int sPath_len;
	zend_bool bReadOnly;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sPath, &sPath_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOpenOfficePackage_GetStream(SBGetObjectHandle(getThis() TSRMLS_CC), sPath, (int32_t)sPath_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TStream_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sb", &sPath, &sPath_len, &bReadOnly) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOpenOfficePackage_GetStream_1(SBGetObjectHandle(getThis() TSRMLS_CC), sPath, (int32_t)sPath_len, (int8_t)bReadOnly, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TStream_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string) or (string, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOpenOfficePackage, CloseStream)
{
	char *sPath;
	int sPath_len;
	zval *oStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oStream, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElOpenOfficePackage_CloseStream(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sPath, &sPath_len) == SUCCESS)
	{
		SBCheckError(TElOpenOfficePackage_CloseStream_1(SBGetObjectHandle(getThis() TSRMLS_CC), sPath, (int32_t)sPath_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream) or (string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOpenOfficePackage, DeleteStream)
{
	char *sPath;
	int sPath_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sPath, &sPath_len) == SUCCESS)
	{
		SBCheckError(TElOpenOfficePackage_DeleteStream(SBGetObjectHandle(getThis() TSRMLS_CC), sPath, (int32_t)sPath_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOpenOfficePackage, StreamExists)
{
	char *sPath;
	int sPath_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sPath, &sPath_len) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElOpenOfficePackage_StreamExists(SBGetObjectHandle(getThis() TSRMLS_CC), sPath, (int32_t)sPath_len, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOpenOfficePackage, get_IsReadOnly)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElOpenOfficePackage_get_IsReadOnly(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOpenOfficePackage, get_MimeType)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElOpenOfficePackage_get_MimeType(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1846707862, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOpenOfficePackage, set_MimeType)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElOpenOfficePackage_set_MimeType(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOpenOfficePackage, get_Manifest)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOpenOfficePackage_get_Manifest(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElOpenOfficeXMLManifest_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOpenOfficePackage, get_CompressionLevel)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElOpenOfficePackage_get_CompressionLevel(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOpenOfficePackage, set_CompressionLevel)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElOpenOfficePackage_set_CompressionLevel(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOpenOfficePackage, get_ZipReader)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOpenOfficePackage_get_ZipReader(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElZipReader_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOpenOfficePackage, get_OnCreateTemporaryStream)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBOfficeCreateTemporaryStreamEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElOpenOfficePackage_get_OnCreateTemporaryStream(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOpenOfficePackage, set_OnCreateTemporaryStream)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElOpenOfficePackage_set_OnCreateTemporaryStream(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBOfficeCreateTemporaryStreamEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBOfficeCreateTemporaryStreamEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOpenOfficePackage, get_OnCloseTemporaryStream)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBOfficeCloseTemporaryStreamEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElOpenOfficePackage_get_OnCloseTemporaryStream(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOpenOfficePackage, set_OnCloseTemporaryStream)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElOpenOfficePackage_set_OnCloseTemporaryStream(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBOfficeCloseTemporaryStreamEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBOfficeCloseTemporaryStreamEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOpenOfficePackage, get_OnGetDataStream)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBOfficeGetDataStreamEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElOpenOfficePackage_get_OnGetDataStream(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOpenOfficePackage, set_OnGetDataStream)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElOpenOfficePackage_set_OnGetDataStream(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBOfficeGetDataStreamEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBOfficeGetDataStreamEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOpenOfficePackage, get_OnCloseDataStream)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBOfficeCloseDataStreamEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElOpenOfficePackage_get_OnCloseDataStream(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOpenOfficePackage, set_OnCloseDataStream)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElOpenOfficePackage_set_OnCloseDataStream(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBOfficeCloseDataStreamEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBOfficeCloseDataStreamEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOpenOfficePackage, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOpenOfficePackage_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOpenOfficePackage_CreateNew, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, Stream, TStream, 1)
	ZEND_ARG_INFO(0, OwnStream)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOpenOfficePackage_Open, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Stream, TStream, 1)
	ZEND_ARG_INFO(0, OwnStream_or_StreamOffset)
	ZEND_ARG_INFO(0, ReadOnly_or_OwnStream)
	ZEND_ARG_INFO(0, ReadOnly)
	ZEND_ARG_OBJ_INFO(0, ZipReader, TElZipReader, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOpenOfficePackage_Flush, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOpenOfficePackage_FlushManifest, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOpenOfficePackage_Close, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOpenOfficePackage_CreateEntry, 0, 0, 1)
	ZEND_ARG_INFO(0, Path)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOpenOfficePackage_CreateStream, 0, 0, 2)
	ZEND_ARG_INFO(0, Path)
	ZEND_ARG_INFO(0, ExpectedStreamSize)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOpenOfficePackage_GetStream, 0, 0, 1)
	ZEND_ARG_INFO(0, Path)
	ZEND_ARG_INFO(0, ReadOnly)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOpenOfficePackage_CloseStream, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Stream_or_Path, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOpenOfficePackage_DeleteStream, 0, 0, 1)
	ZEND_ARG_INFO(0, Path)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOpenOfficePackage_StreamExists, 0, 0, 1)
	ZEND_ARG_INFO(0, Path)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOpenOfficePackage_get_IsReadOnly, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOpenOfficePackage_get_MimeType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOpenOfficePackage_set_MimeType, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOpenOfficePackage_get_Manifest, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOpenOfficePackage_get_CompressionLevel, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOpenOfficePackage_set_CompressionLevel, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOpenOfficePackage_get_ZipReader, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOpenOfficePackage_get_OnCreateTemporaryStream, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOpenOfficePackage_set_OnCreateTemporaryStream, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOpenOfficePackage_get_OnCloseTemporaryStream, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOpenOfficePackage_set_OnCloseTemporaryStream, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOpenOfficePackage_get_OnGetDataStream, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOpenOfficePackage_set_OnGetDataStream, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOpenOfficePackage_get_OnCloseDataStream, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOpenOfficePackage_set_OnCloseDataStream, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOpenOfficePackage___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElOpenOfficePackage_methods[] = {
	PHP_ME(TElOpenOfficePackage, CreateNew, arginfo_TElOpenOfficePackage_CreateNew, ZEND_ACC_PUBLIC)
	PHP_ME(TElOpenOfficePackage, Open, arginfo_TElOpenOfficePackage_Open, ZEND_ACC_PUBLIC)
	PHP_ME(TElOpenOfficePackage, Flush, arginfo_TElOpenOfficePackage_Flush, ZEND_ACC_PUBLIC)
	PHP_ME(TElOpenOfficePackage, FlushManifest, arginfo_TElOpenOfficePackage_FlushManifest, ZEND_ACC_PUBLIC)
	PHP_ME(TElOpenOfficePackage, Close, arginfo_TElOpenOfficePackage_Close, ZEND_ACC_PUBLIC)
	PHP_ME(TElOpenOfficePackage, CreateEntry, arginfo_TElOpenOfficePackage_CreateEntry, ZEND_ACC_PUBLIC)
	PHP_ME(TElOpenOfficePackage, CreateStream, arginfo_TElOpenOfficePackage_CreateStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElOpenOfficePackage, GetStream, arginfo_TElOpenOfficePackage_GetStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElOpenOfficePackage, CloseStream, arginfo_TElOpenOfficePackage_CloseStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElOpenOfficePackage, DeleteStream, arginfo_TElOpenOfficePackage_DeleteStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElOpenOfficePackage, StreamExists, arginfo_TElOpenOfficePackage_StreamExists, ZEND_ACC_PUBLIC)
	PHP_ME(TElOpenOfficePackage, get_IsReadOnly, arginfo_TElOpenOfficePackage_get_IsReadOnly, ZEND_ACC_PUBLIC)
	PHP_ME(TElOpenOfficePackage, get_MimeType, arginfo_TElOpenOfficePackage_get_MimeType, ZEND_ACC_PUBLIC)
	PHP_ME(TElOpenOfficePackage, set_MimeType, arginfo_TElOpenOfficePackage_set_MimeType, ZEND_ACC_PUBLIC)
	PHP_ME(TElOpenOfficePackage, get_Manifest, arginfo_TElOpenOfficePackage_get_Manifest, ZEND_ACC_PUBLIC)
	PHP_ME(TElOpenOfficePackage, get_CompressionLevel, arginfo_TElOpenOfficePackage_get_CompressionLevel, ZEND_ACC_PUBLIC)
	PHP_ME(TElOpenOfficePackage, set_CompressionLevel, arginfo_TElOpenOfficePackage_set_CompressionLevel, ZEND_ACC_PUBLIC)
	PHP_ME(TElOpenOfficePackage, get_ZipReader, arginfo_TElOpenOfficePackage_get_ZipReader, ZEND_ACC_PUBLIC)
	PHP_ME(TElOpenOfficePackage, get_OnCreateTemporaryStream, arginfo_TElOpenOfficePackage_get_OnCreateTemporaryStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElOpenOfficePackage, set_OnCreateTemporaryStream, arginfo_TElOpenOfficePackage_set_OnCreateTemporaryStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElOpenOfficePackage, get_OnCloseTemporaryStream, arginfo_TElOpenOfficePackage_get_OnCloseTemporaryStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElOpenOfficePackage, set_OnCloseTemporaryStream, arginfo_TElOpenOfficePackage_set_OnCloseTemporaryStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElOpenOfficePackage, get_OnGetDataStream, arginfo_TElOpenOfficePackage_get_OnGetDataStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElOpenOfficePackage, set_OnGetDataStream, arginfo_TElOpenOfficePackage_set_OnGetDataStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElOpenOfficePackage, get_OnCloseDataStream, arginfo_TElOpenOfficePackage_get_OnCloseDataStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElOpenOfficePackage, set_OnCloseDataStream, arginfo_TElOpenOfficePackage_set_OnCloseDataStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElOpenOfficePackage, __construct, arginfo_TElOpenOfficePackage___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElOpenOfficePackage(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElOpenOfficePackage_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElOpenOfficePackage", TElOpenOfficePackage_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElOpenOfficePackage_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

