#include "sbotpserver.h"

zend_class_entry *TElOTPUserClass_ce_ptr = NULL;

zend_class_entry *TElOTPUser_ce_ptr = NULL;

SB_PHP_METHOD(TElOTPUser, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TElOTPUser_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElOTPUser_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElOTPUser)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOTPUser, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElOTPUser_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOTPUser, Clone)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOTPUser_Clone(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElOTPUser_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOTPUser, CreateInstance)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOTPUser_CreateInstance(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElOTPUser_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOTPUser, LoadFromStream)
{
	zval *oStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oStream, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElOTPUser_LoadFromStream(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOTPUser, SaveToStream)
{
	zval *oStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oStream, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElOTPUser_SaveToStream(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOTPUser, ClassType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOTPUser_ClassType(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TClass_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOTPUser, get_UserID)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElOTPUser_get_UserID(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-2041745588, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOTPUser, set_UserID)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElOTPUser_set_UserID(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOTPUser, get_KeySecret)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElOTPUser_get_KeySecret(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(9665658, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOTPUser, set_KeySecret)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElOTPUser_set_KeySecret(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOTPUser, get_PasswordLen)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElOTPUser_get_PasswordLen(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOTPUser, set_PasswordLen)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElOTPUser_set_PasswordLen(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOTPUser, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOTPUser_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOTPUser_Assign, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Source, TElOTPUser, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOTPUser_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOTPUser_Clone, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOTPUser_CreateInstance, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOTPUser_LoadFromStream, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Stream, TStream, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOTPUser_SaveToStream, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Stream, TStream, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOTPUser_ClassType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOTPUser_get_UserID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOTPUser_set_UserID, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOTPUser_get_KeySecret, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOTPUser_set_KeySecret, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOTPUser_get_PasswordLen, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOTPUser_set_PasswordLen, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOTPUser___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElOTPUser_methods[] = {
	PHP_ME(TElOTPUser, Assign, arginfo_TElOTPUser_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElOTPUser, Clear, arginfo_TElOTPUser_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElOTPUser, Clone, arginfo_TElOTPUser_Clone, ZEND_ACC_PUBLIC)
	PHP_ME(TElOTPUser, CreateInstance, arginfo_TElOTPUser_CreateInstance, ZEND_ACC_PUBLIC)
	PHP_ME(TElOTPUser, LoadFromStream, arginfo_TElOTPUser_LoadFromStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElOTPUser, SaveToStream, arginfo_TElOTPUser_SaveToStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElOTPUser, ClassType, arginfo_TElOTPUser_ClassType, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElOTPUser, get_UserID, arginfo_TElOTPUser_get_UserID, ZEND_ACC_PUBLIC)
	PHP_ME(TElOTPUser, set_UserID, arginfo_TElOTPUser_set_UserID, ZEND_ACC_PUBLIC)
	PHP_ME(TElOTPUser, get_KeySecret, arginfo_TElOTPUser_get_KeySecret, ZEND_ACC_PUBLIC)
	PHP_ME(TElOTPUser, set_KeySecret, arginfo_TElOTPUser_set_KeySecret, ZEND_ACC_PUBLIC)
	PHP_ME(TElOTPUser, get_PasswordLen, arginfo_TElOTPUser_get_PasswordLen, ZEND_ACC_PUBLIC)
	PHP_ME(TElOTPUser, set_PasswordLen, arginfo_TElOTPUser_set_PasswordLen, ZEND_ACC_PUBLIC)
	PHP_ME(TElOTPUser, __construct, arginfo_TElOTPUser___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElOTPUser(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElOTPUser_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElOTPUser", TElOTPUser_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElOTPUser_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElHOTPUser_ce_ptr = NULL;

SB_PHP_METHOD(TElHOTPUser, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TElOTPUser_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElHOTPUser_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElOTPUser)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHOTPUser, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElHOTPUser_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHOTPUser, CreateInstance)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElHOTPUser_CreateInstance(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElOTPUser_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHOTPUser, ClassType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElHOTPUser_ClassType(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TClass_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHOTPUser, get_Counter)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElHOTPUser_get_Counter(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHOTPUser, set_Counter)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElHOTPUser_set_Counter(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHOTPUser, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElHOTPUser_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHOTPUser_Assign, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Source, TElOTPUser, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHOTPUser_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHOTPUser_CreateInstance, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHOTPUser_ClassType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHOTPUser_get_Counter, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHOTPUser_set_Counter, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHOTPUser___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElHOTPUser_methods[] = {
	PHP_ME(TElHOTPUser, Assign, arginfo_TElHOTPUser_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElHOTPUser, Clear, arginfo_TElHOTPUser_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElHOTPUser, CreateInstance, arginfo_TElHOTPUser_CreateInstance, ZEND_ACC_PUBLIC)
	PHP_ME(TElHOTPUser, ClassType, arginfo_TElHOTPUser_ClassType, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElHOTPUser, get_Counter, arginfo_TElHOTPUser_get_Counter, ZEND_ACC_PUBLIC)
	PHP_ME(TElHOTPUser, set_Counter, arginfo_TElHOTPUser_set_Counter, ZEND_ACC_PUBLIC)
	PHP_ME(TElHOTPUser, __construct, arginfo_TElHOTPUser___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElHOTPUser(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElHOTPUser_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElHOTPUser", TElHOTPUser_methods);
	if (NULL == TElOTPUser_ce_ptr)
		Register_TElOTPUser(TSRMLS_C);
	TElHOTPUser_ce_ptr = zend_register_internal_class_ex(&ce, TElOTPUser_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElTOTPUser_ce_ptr = NULL;

SB_PHP_METHOD(TElTOTPUser, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TElOTPUser_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElTOTPUser_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElOTPUser)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTOTPUser, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElTOTPUser_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTOTPUser, CreateInstance)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElTOTPUser_CreateInstance(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElOTPUser_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTOTPUser, ClassType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElTOTPUser_ClassType(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TClass_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTOTPUser, get_HashAlgorithm)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElTOTPUser_get_HashAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTOTPUser, set_HashAlgorithm)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElTOTPUser_set_HashAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTOTPUser, get_TimeInterval)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElTOTPUser_get_TimeInterval(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTOTPUser, set_TimeInterval)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElTOTPUser_set_TimeInterval(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTOTPUser, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElTOTPUser_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTOTPUser_Assign, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Source, TElOTPUser, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTOTPUser_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTOTPUser_CreateInstance, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTOTPUser_ClassType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTOTPUser_get_HashAlgorithm, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTOTPUser_set_HashAlgorithm, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTOTPUser_get_TimeInterval, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTOTPUser_set_TimeInterval, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTOTPUser___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElTOTPUser_methods[] = {
	PHP_ME(TElTOTPUser, Assign, arginfo_TElTOTPUser_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElTOTPUser, Clear, arginfo_TElTOTPUser_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElTOTPUser, CreateInstance, arginfo_TElTOTPUser_CreateInstance, ZEND_ACC_PUBLIC)
	PHP_ME(TElTOTPUser, ClassType, arginfo_TElTOTPUser_ClassType, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElTOTPUser, get_HashAlgorithm, arginfo_TElTOTPUser_get_HashAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElTOTPUser, set_HashAlgorithm, arginfo_TElTOTPUser_set_HashAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElTOTPUser, get_TimeInterval, arginfo_TElTOTPUser_get_TimeInterval, ZEND_ACC_PUBLIC)
	PHP_ME(TElTOTPUser, set_TimeInterval, arginfo_TElTOTPUser_set_TimeInterval, ZEND_ACC_PUBLIC)
	PHP_ME(TElTOTPUser, __construct, arginfo_TElTOTPUser___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElTOTPUser(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElTOTPUser_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElTOTPUser", TElTOTPUser_methods);
	if (NULL == TElOTPUser_ce_ptr)
		Register_TElOTPUser(TSRMLS_C);
	TElTOTPUser_ce_ptr = zend_register_internal_class_ex(&ce, TElOTPUser_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElOTPUserFactory_ce_ptr = NULL;

SB_PHP_METHOD(TElOTPUserFactory, RegisterClass)
{
	zval *ocls;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &ocls, TElOTPUserClass_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElOTPUserFactory_RegisterClass(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(ocls TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElOTPUserClass)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOTPUserFactory, CreateInstance)
{
	char *sName;
	int sName_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sName, &sName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOTPUserFactory_CreateInstance(SBGetObjectHandle(getThis() TSRMLS_CC), sName, (int32_t)sName_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElOTPUser_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOTPUserFactory, get_RegisteredClasses)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOTPUserFactory_get_RegisteredClasses(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElOTPUserClass_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOTPUserFactory, get_RegisteredClassCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElOTPUserFactory_get_RegisteredClassCount(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOTPUserFactory, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOTPUserFactory_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOTPUserFactory_RegisterClass, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, cls, TElOTPUserClass, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOTPUserFactory_CreateInstance, 0, 0, 1)
	ZEND_ARG_INFO(0, Name)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOTPUserFactory_get_RegisteredClasses, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOTPUserFactory_get_RegisteredClassCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOTPUserFactory___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElOTPUserFactory_methods[] = {
	PHP_ME(TElOTPUserFactory, RegisterClass, arginfo_TElOTPUserFactory_RegisterClass, ZEND_ACC_PUBLIC)
	PHP_ME(TElOTPUserFactory, CreateInstance, arginfo_TElOTPUserFactory_CreateInstance, ZEND_ACC_PUBLIC)
	PHP_ME(TElOTPUserFactory, get_RegisteredClasses, arginfo_TElOTPUserFactory_get_RegisteredClasses, ZEND_ACC_PUBLIC)
	PHP_ME(TElOTPUserFactory, get_RegisteredClassCount, arginfo_TElOTPUserFactory_get_RegisteredClassCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElOTPUserFactory, __construct, arginfo_TElOTPUserFactory___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElOTPUserFactory(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElOTPUserFactory_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElOTPUserFactory", TElOTPUserFactory_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElOTPUserFactory_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElOTPUserStorage_ce_ptr = NULL;

SB_PHP_METHOD(TElOTPUserStorage, Add)
{
	zval *oUser;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oUser, TElOTPUser_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElOTPUserStorage_Add(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oUser TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElOTPUser)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOTPUserStorage, Remove)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		SBCheckError(TElOTPUserStorage_Remove(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOTPUserStorage, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElOTPUserStorage_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOTPUserStorage, IndexOf)
{
	zval *oUser;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oUser, TElOTPUser_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElOTPUserStorage_IndexOf(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oUser TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElOTPUser)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOTPUserStorage, SaveToStream)
{
	zval *oStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oStream, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElOTPUserStorage_SaveToStream(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOTPUserStorage, LoadFromStream)
{
	zval *oStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oStream, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElOTPUserStorage_LoadFromStream(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOTPUserStorage, get_Users)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOTPUserStorage_get_Users(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElOTPUser_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOTPUserStorage, get_Count)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElOTPUserStorage_get_Count(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOTPUserStorage, __construct)
{
	zval *oAOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOTPUserStorage_Create(SBGetObjectHandle(oAOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOTPUserStorage_Add, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, User, TElOTPUser, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOTPUserStorage_Remove, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOTPUserStorage_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOTPUserStorage_IndexOf, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, User, TElOTPUser, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOTPUserStorage_SaveToStream, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Stream, TStream, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOTPUserStorage_LoadFromStream, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Stream, TStream, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOTPUserStorage_get_Users, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOTPUserStorage_get_Count, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOTPUserStorage___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AOwner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElOTPUserStorage_methods[] = {
	PHP_ME(TElOTPUserStorage, Add, arginfo_TElOTPUserStorage_Add, ZEND_ACC_PUBLIC)
	PHP_ME(TElOTPUserStorage, Remove, arginfo_TElOTPUserStorage_Remove, ZEND_ACC_PUBLIC)
	PHP_ME(TElOTPUserStorage, Clear, arginfo_TElOTPUserStorage_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElOTPUserStorage, IndexOf, arginfo_TElOTPUserStorage_IndexOf, ZEND_ACC_PUBLIC)
	PHP_ME(TElOTPUserStorage, SaveToStream, arginfo_TElOTPUserStorage_SaveToStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElOTPUserStorage, LoadFromStream, arginfo_TElOTPUserStorage_LoadFromStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElOTPUserStorage, get_Users, arginfo_TElOTPUserStorage_get_Users, ZEND_ACC_PUBLIC)
	PHP_ME(TElOTPUserStorage, get_Count, arginfo_TElOTPUserStorage_get_Count, ZEND_ACC_PUBLIC)
	PHP_ME(TElOTPUserStorage, __construct, arginfo_TElOTPUserStorage___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElOTPUserStorage(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElOTPUserStorage_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElOTPUserStorage", TElOTPUserStorage_methods);
	if (NULL == TComponent_ce_ptr)
		Register_TComponent(TSRMLS_C);
	TElOTPUserStorage_ce_ptr = zend_register_internal_class_ex(&ce, TComponent_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElOTPServer_ce_ptr = NULL;

SB_PHP_METHOD(TElOTPServer, get_Delta)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElOTPServer_get_Delta(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOTPServer, set_Delta)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElOTPServer_set_Delta(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOTPServer, get_OTPUserStorage)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOTPServer_get_OTPUserStorage(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElOTPUserStorage_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOTPServer, set_OTPUserStorage)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElOTPUserStorage_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElOTPServer_set_OTPUserStorage(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElOTPUserStorage)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOTPServer, __construct)
{
	zval *oOTPUserStorage;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oOTPUserStorage, TElOTPUserStorage_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOTPServer_Create(SBGetObjectHandle(oOTPUserStorage TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElOTPUserStorage)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOTPServer_get_Delta, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOTPServer_set_Delta, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOTPServer_get_OTPUserStorage, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOTPServer_set_OTPUserStorage, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElOTPUserStorage, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOTPServer___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, OTPUserStorage, TElOTPUserStorage, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElOTPServer_methods[] = {
	PHP_ME(TElOTPServer, get_Delta, arginfo_TElOTPServer_get_Delta, ZEND_ACC_PUBLIC)
	PHP_ME(TElOTPServer, set_Delta, arginfo_TElOTPServer_set_Delta, ZEND_ACC_PUBLIC)
	PHP_ME(TElOTPServer, get_OTPUserStorage, arginfo_TElOTPServer_get_OTPUserStorage, ZEND_ACC_PUBLIC)
	PHP_ME(TElOTPServer, set_OTPUserStorage, arginfo_TElOTPServer_set_OTPUserStorage, ZEND_ACC_PUBLIC)
	PHP_ME(TElOTPServer, __construct, arginfo_TElOTPServer___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElOTPServer(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElOTPServer_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElOTPServer", TElOTPServer_methods);
	if (NULL == TElOTPClass_ce_ptr)
		Register_TElOTPClass(TSRMLS_C);
	TElOTPServer_ce_ptr = zend_register_internal_class_ex(&ce, TElOTPClass_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElHOTPServer_ce_ptr = NULL;

SB_PHP_METHOD(TElHOTPServer, IsPasswordValid)
{
	char *sPassword;
	char *sUserId;
	int sPassword_len;
	int sUserId_len;
	zval *oUser;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &sUserId, &sUserId_len, &sPassword, &sPassword_len) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElHOTPServer_IsPasswordValid(SBGetObjectHandle(getThis() TSRMLS_CC), sUserId, (int32_t)sUserId_len, sPassword, (int32_t)sPassword_len, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!s", &oUser, TElHOTPUser_ce_ptr, &sPassword, &sPassword_len) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElHOTPServer_IsPasswordValid_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oUser TSRMLS_CC), sPassword, (int32_t)sPassword_len, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string, string) or (TElHOTPUser, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHOTPServer, __construct)
{
	zval *oOTPUserStorage;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oOTPUserStorage, TElOTPUserStorage_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElHOTPServer_Create(SBGetObjectHandle(oOTPUserStorage TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElOTPUserStorage)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHOTPServer_IsPasswordValid, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, UserId_or_User, 0, 1)
	ZEND_ARG_INFO(0, Password)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHOTPServer___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, OTPUserStorage, TElOTPUserStorage, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElHOTPServer_methods[] = {
	PHP_ME(TElHOTPServer, IsPasswordValid, arginfo_TElHOTPServer_IsPasswordValid, ZEND_ACC_PUBLIC)
	PHP_ME(TElHOTPServer, __construct, arginfo_TElHOTPServer___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElHOTPServer(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElHOTPServer_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElHOTPServer", TElHOTPServer_methods);
	if (NULL == TElOTPServer_ce_ptr)
		Register_TElOTPServer(TSRMLS_C);
	TElHOTPServer_ce_ptr = zend_register_internal_class_ex(&ce, TElOTPServer_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElTOTPServer_ce_ptr = NULL;

SB_PHP_METHOD(TElTOTPServer, IsPasswordValid)
{
	char *sPassword;
	char *sUserId;
	int sPassword_len;
	int sUserId_len;
	zval *dtTime;
	zval *oUser;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &sUserId, &sUserId_len, &sPassword, &sPassword_len) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElTOTPServer_IsPasswordValid(SBGetObjectHandle(getThis() TSRMLS_CC), sUserId, (int32_t)sUserId_len, sPassword, (int32_t)sPassword_len, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO", &sUserId, &sUserId_len, &sPassword, &sPassword_len, &dtTime, php_date_get_date_ce()) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElTOTPServer_IsPasswordValid_1(SBGetObjectHandle(getThis() TSRMLS_CC), sUserId, (int32_t)sUserId_len, sPassword, (int32_t)sPassword_len, SBGetDateTime(dtTime TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!s", &oUser, TElTOTPUser_ce_ptr, &sPassword, &sPassword_len) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElTOTPServer_IsPasswordValid_2(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oUser TSRMLS_CC), sPassword, (int32_t)sPassword_len, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!sO", &oUser, TElTOTPUser_ce_ptr, &sPassword, &sPassword_len, &dtTime, php_date_get_date_ce()) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElTOTPServer_IsPasswordValid_3(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oUser TSRMLS_CC), sPassword, (int32_t)sPassword_len, SBGetDateTime(dtTime TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string, string) or (string, string, DateTime) or (TElTOTPUser, string) or (TElTOTPUser, string, DateTime)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTOTPServer, __construct)
{
	zval *oOTPUserStorage;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oOTPUserStorage, TElOTPUserStorage_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElTOTPServer_Create(SBGetObjectHandle(oOTPUserStorage TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElOTPUserStorage)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTOTPServer_IsPasswordValid, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, UserId_or_User, 0, 1)
	ZEND_ARG_INFO(0, Password)
	ZEND_ARG_OBJ_INFO(0, Time, DateTime, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTOTPServer___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, OTPUserStorage, TElOTPUserStorage, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElTOTPServer_methods[] = {
	PHP_ME(TElTOTPServer, IsPasswordValid, arginfo_TElTOTPServer_IsPasswordValid, ZEND_ACC_PUBLIC)
	PHP_ME(TElTOTPServer, __construct, arginfo_TElTOTPServer___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElTOTPServer(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElTOTPServer_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElTOTPServer", TElTOTPServer_methods);
	if (NULL == TElOTPServer_ce_ptr)
		Register_TElOTPServer(TSRMLS_C);
	TElTOTPServer_ce_ptr = zend_register_internal_class_ex(&ce, TElOTPServer_ce_ptr, NULL TSRMLS_CC);
}

void Register_SBOTPServer_Constants(int module_number TSRMLS_DC)
{
	SB_REGISTER_STRING_CONSTANT(SBOTPServer, OTPUser, SB_OTPUser, SB_OTPUser);
	SB_REGISTER_STRING_CONSTANT(SBOTPServer, HOTPUser, SB_HOTPUser, SB_HOTPUser);
	SB_REGISTER_STRING_CONSTANT(SBOTPServer, TOTPUser, SB_TOTPUser, SB_TOTPUser);
}

void Register_SBOTPServer_Aliases(TSRMLS_D)
{
	if (NULL == TElOTPUser_ce_ptr)
		Register_TElOTPUser(TSRMLS_C);
	zend_register_class_alias("ElOTPUser", TElOTPUser_ce_ptr);
	if (NULL == TElHOTPUser_ce_ptr)
		Register_TElHOTPUser(TSRMLS_C);
	zend_register_class_alias("ElHOTPUser", TElHOTPUser_ce_ptr);
	if (NULL == TElTOTPUser_ce_ptr)
		Register_TElTOTPUser(TSRMLS_C);
	zend_register_class_alias("ElTOTPUser", TElTOTPUser_ce_ptr);
	if (NULL == TElOTPUserFactory_ce_ptr)
		Register_TElOTPUserFactory(TSRMLS_C);
	zend_register_class_alias("ElOTPUserFactory", TElOTPUserFactory_ce_ptr);
	if (NULL == TElOTPUserStorage_ce_ptr)
		Register_TElOTPUserStorage(TSRMLS_C);
	zend_register_class_alias("ElOTPUserStorage", TElOTPUserStorage_ce_ptr);
	if (NULL == TElOTPServer_ce_ptr)
		Register_TElOTPServer(TSRMLS_C);
	zend_register_class_alias("ElOTPServer", TElOTPServer_ce_ptr);
	if (NULL == TElHOTPServer_ce_ptr)
		Register_TElHOTPServer(TSRMLS_C);
	zend_register_class_alias("ElHOTPServer", TElHOTPServer_ce_ptr);
	if (NULL == TElTOTPServer_ce_ptr)
		Register_TElTOTPServer(TSRMLS_C);
	zend_register_class_alias("ElTOTPServer", TElTOTPServer_ce_ptr);
	TElOTPUserClass_ce_ptr = TObject_ce_ptr;
	zend_register_class_alias("TElOTPUserClass", TElOTPUserClass_ce_ptr);
}

