#include "sbpgp.h"

zend_class_entry *TSBPGPEncryptionType_ce_ptr = NULL;

zend_class_entry *TSBPGPProcessingUnitState_ce_ptr = NULL;

void SB_CALLBACK TSBPGPProgressEventRaw(void * _ObjectData, TObjectHandle Sender, int64_t Processed, int64_t Total, int8_t * Cancel)
{
	zval *retval_ptr;
	zval **params[4];
	zval * zSender;
	zval * zProcessed;
	zval * zTotal;
	zval * zCancel;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zProcessed);
	ZVAL_LONG(zProcessed, (long)Processed);
	MAKE_STD_ZVAL(zTotal);
	ZVAL_LONG(zTotal, (long)Total);
	MAKE_STD_ZVAL(zCancel);
	ZVAL_BOOL(zCancel, (zend_bool)*Cancel);

	params[0] = &zSender;
	params[1] = &zProcessed;
	params[2] = &zTotal;
	params[3] = &zCancel;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 4, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zProcessed);
	zval_ptr_dtor(&zTotal);
	*Cancel = (int8_t)Z_BVAL_P(zCancel);
	zval_ptr_dtor(&zCancel);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

zend_class_entry *TSBPGPSignBufferingMethod_ce_ptr = NULL;

zend_class_entry *TSBPGPMemoryConsumptionStrategy_ce_ptr = NULL;

#ifdef SB_WINDOWS
zend_class_entry *TSBPGPStubSource_ce_ptr = NULL;
#endif

void SB_CALLBACK TSBPGPNewStreamEventRaw(void * _ObjectData, TObjectHandle Sender, TElPGPStreamHandle Stream, int8_t * Atomic)
{
	zval *retval_ptr;
	zval **params[3];
	zval * zSender;
	zval * zStream;
	zval * zAtomic;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zStream);
	SBInitObject(zStream, TElPGPStream_ce_ptr, Stream TSRMLS_CC);
	MAKE_STD_ZVAL(zAtomic);
	ZVAL_BOOL(zAtomic, (zend_bool)*Atomic);

	params[0] = &zSender;
	params[1] = &zStream;
	params[2] = &zAtomic;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 3, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zStream);
	*Atomic = (int8_t)Z_BVAL_P(zAtomic);
	zval_ptr_dtor(&zAtomic);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBPGPSignatureEntityEventRaw(void * _ObjectData, TObjectHandle Sender, TElPGPSignatureEntityHandle Sig)
{
	zval *retval_ptr;
	zval **params[2];
	zval * zSender;
	zval * zSig;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zSig);
	SBInitObject(zSig, TElPGPSignatureEntity_ce_ptr, Sig TSRMLS_CC);

	params[0] = &zSender;
	params[1] = &zSig;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 2, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zSig);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBPGPHashAlgorithmEventRaw(void * _ObjectData, TObjectHandle Sender, int32_t HashAlg, int32_t SigClass)
{
	zval *retval_ptr;
	zval **params[3];
	zval * zSender;
	zval * zHashAlg;
	zval * zSigClass;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zHashAlg);
	ZVAL_LONG(zHashAlg, (long)HashAlg);
	MAKE_STD_ZVAL(zSigClass);
	ZVAL_LONG(zSigClass, (long)SigClass);

	params[0] = &zSender;
	params[1] = &zHashAlg;
	params[2] = &zSigClass;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 3, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zHashAlg);
	zval_ptr_dtor(&zSigClass);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

#ifdef SB_WINDOWS
void SB_CALLBACK TSBPGPGetStubStreamEventRaw(void * _ObjectData, TObjectHandle Sender, TStreamHandle * Stream, int8_t * FreeStub)
{
	zval *retval_ptr;
	zval **params[3];
	zval * zSender;
	zval * zStream;
	zval * zFreeStub;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zStream);
	ZVAL_NULL(zStream);
	MAKE_STD_ZVAL(zFreeStub);
	ZVAL_FALSE(zFreeStub);

	params[0] = &zSender;
	params[1] = &zStream;
	params[2] = &zFreeStub;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 3, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	*Stream = SBGetObjectHandleCE(zStream, TStream_ce_ptr TSRMLS_CC);
	SBDetachObjectHandleIfUniqueZVal(zStream TSRMLS_CC);
	zval_ptr_dtor(&zStream);
	*FreeStub = (int8_t)Z_BVAL_P(zFreeStub);
	zval_ptr_dtor(&zFreeStub);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}
#endif

void SB_CALLBACK TSBPGPMultipleFilesFoundEventRaw(void * _ObjectData, TObjectHandle Sender, const char * pcTarFilename, int32_t szTarFilename, int8_t * ExtractFiles)
{
	zval *retval_ptr;
	zval **params[3];
	zval * zSender;
	zval * zTarFilename;
	zval * zExtractFiles;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zTarFilename);
	ZVAL_STRINGL(zTarFilename, pcTarFilename, szTarFilename, 1);
	MAKE_STD_ZVAL(zExtractFiles);
	ZVAL_BOOL(zExtractFiles, (zend_bool)*ExtractFiles);

	params[0] = &zSender;
	params[1] = &zTarFilename;
	params[2] = &zExtractFiles;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 3, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zTarFilename);
	*ExtractFiles = (int8_t)Z_BVAL_P(zExtractFiles);
	zval_ptr_dtor(&zExtractFiles);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBPGPRequestOutputFileEventRaw(void * _ObjectData, TObjectHandle Sender, const char * pcFilename, int32_t szFilename, int64_t TimeStamp, char * pcPath, int32_t * szPath)
{
	zval *retval_ptr;
	zval **params[4];
	zval * zSender;
	zval * zFilename;
	zval * zTimeStamp;
	zval * zPath;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zFilename);
	ZVAL_STRINGL(zFilename, pcFilename, szFilename, 1);
	MAKE_STD_ZVAL(zTimeStamp);
	object_init_ex(zTimeStamp, php_date_get_date_ce());
	SBSetDateTime(zTimeStamp, TimeStamp TSRMLS_CC);
	MAKE_STD_ZVAL(zPath);
	ZVAL_STRINGL(zPath, pcPath, *szPath, 1);

	params[0] = &zSender;
	params[1] = &zFilename;
	params[2] = &zTimeStamp;
	params[3] = &zPath;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 4, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zFilename);
	zval_ptr_dtor(&zTimeStamp);
	SBCheckError(SBSetEventReturnStringA(4, Z_STRVAL_P(zPath), (int32_t)Z_STRLEN_P(zPath)) TSRMLS_CC);
	zval_ptr_dtor(&zPath);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBPGPCreateOutputStreamEventRaw(void * _ObjectData, TObjectHandle Sender, const char * pcFilename, int32_t szFilename, int64_t TimeStamp, TStreamHandle * Stream, int8_t * FreeOnExit)
{
	zval *retval_ptr;
	zval **params[5];
	zval * zSender;
	zval * zFilename;
	zval * zTimeStamp;
	zval * zStream;
	zval * zFreeOnExit;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zFilename);
	ZVAL_STRINGL(zFilename, pcFilename, szFilename, 1);
	MAKE_STD_ZVAL(zTimeStamp);
	object_init_ex(zTimeStamp, php_date_get_date_ce());
	SBSetDateTime(zTimeStamp, TimeStamp TSRMLS_CC);
	MAKE_STD_ZVAL(zStream);
	SBInitObject(zStream, TStream_ce_ptr, *Stream TSRMLS_CC);
	MAKE_STD_ZVAL(zFreeOnExit);
	ZVAL_BOOL(zFreeOnExit, (zend_bool)*FreeOnExit);

	params[0] = &zSender;
	params[1] = &zFilename;
	params[2] = &zTimeStamp;
	params[3] = &zStream;
	params[4] = &zFreeOnExit;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 5, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zFilename);
	zval_ptr_dtor(&zTimeStamp);
	*Stream = SBGetObjectHandleCE(zStream, TStream_ce_ptr TSRMLS_CC);
	SBDetachObjectHandleIfUniqueZVal(zStream TSRMLS_CC);
	zval_ptr_dtor(&zStream);
	*FreeOnExit = (int8_t)Z_BVAL_P(zFreeOnExit);
	zval_ptr_dtor(&zFreeOnExit);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBPGPFileExtractionStartEventRaw(void * _ObjectData, TObjectHandle Sender, const char * pcFilename, int32_t szFilename, int64_t TimeStamp)
{
	zval *retval_ptr;
	zval **params[3];
	zval * zSender;
	zval * zFilename;
	zval * zTimeStamp;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zFilename);
	ZVAL_STRINGL(zFilename, pcFilename, szFilename, 1);
	MAKE_STD_ZVAL(zTimeStamp);
	object_init_ex(zTimeStamp, php_date_get_date_ce());
	SBSetDateTime(zTimeStamp, TimeStamp TSRMLS_CC);

	params[0] = &zSender;
	params[1] = &zFilename;
	params[2] = &zTimeStamp;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 3, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zFilename);
	zval_ptr_dtor(&zTimeStamp);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBPGPEncryptedEventRaw(void * _ObjectData, TObjectHandle Sender, const uint8_t pKeyIDs[][8], int32_t szKeyIDs, int8_t IntegrityProtected, int8_t PassphraseUsed)
{
	zval *retval_ptr;
	zval **params[4];
	zval * zSender;
	zval * zKeyIDs;
	zval * zIntegrityProtected;
	zval * zPassphraseUsed;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zKeyIDs);
	SBSetStructArrayToZValP((void *)pKeyIDs, szKeyIDs, sizeof(TSBKeyID), TSBKeyID_ce_ptr, zKeyIDs TSRMLS_CC);
	MAKE_STD_ZVAL(zIntegrityProtected);
	ZVAL_BOOL(zIntegrityProtected, (zend_bool)IntegrityProtected);
	MAKE_STD_ZVAL(zPassphraseUsed);
	ZVAL_BOOL(zPassphraseUsed, (zend_bool)PassphraseUsed);

	params[0] = &zSender;
	params[1] = &zKeyIDs;
	params[2] = &zIntegrityProtected;
	params[3] = &zPassphraseUsed;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 4, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zKeyIDs);
	zval_ptr_dtor(&zIntegrityProtected);
	zval_ptr_dtor(&zPassphraseUsed);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBPGPArmoredEventRaw(void * _ObjectData, TObjectHandle Sender, const char * pcBoundary, int32_t szBoundary, TStringListHandle Headers)
{
	zval *retval_ptr;
	zval **params[3];
	zval * zSender;
	zval * zBoundary;
	zval * zHeaders;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zBoundary);
	ZVAL_STRINGL(zBoundary, pcBoundary, szBoundary, 1);
	MAKE_STD_ZVAL(zHeaders);
	SBInitObject(zHeaders, TStringList_ce_ptr, Headers TSRMLS_CC);

	params[0] = &zSender;
	params[1] = &zBoundary;
	params[2] = &zHeaders;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 3, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zBoundary);
	zval_ptr_dtor(&zHeaders);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBPGPSignedEventRaw(void * _ObjectData, TObjectHandle Sender, const uint8_t pKeyIDs[][8], int32_t szKeyIDs, TSBPGPSignatureTypeRaw SignatureType)
{
	zval *retval_ptr;
	zval **params[3];
	zval * zSender;
	zval * zKeyIDs;
	zval * zSignatureType;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zKeyIDs);
	SBSetStructArrayToZValP((void *)pKeyIDs, szKeyIDs, sizeof(TSBKeyID), TSBKeyID_ce_ptr, zKeyIDs TSRMLS_CC);
	MAKE_STD_ZVAL(zSignatureType);
	ZVAL_LONG(zSignatureType, (long)SignatureType);

	params[0] = &zSender;
	params[1] = &zKeyIDs;
	params[2] = &zSignatureType;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 3, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zKeyIDs);
	zval_ptr_dtor(&zSignatureType);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

zend_class_entry *TElPGPWriter_ce_ptr = NULL;

SB_PHP_METHOD(TElPGPWriter, EncryptFile)
{
	char *sADestFile;
	char *sASourceFile;
	int sADestFile_len;
	int sASourceFile_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &sASourceFile, &sASourceFile_len, &sADestFile, &sADestFile_len) == SUCCESS)
	{
		SBCheckError(TElPGPWriter_EncryptFile(SBGetObjectHandle(getThis() TSRMLS_CC), sASourceFile, (int32_t)sASourceFile_len, sADestFile, (int32_t)sADestFile_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPWriter, SignFile)
{
	char *sADestFile;
	char *sASourceFile;
	int sADestFile_len;
	int sASourceFile_len;
	zend_bool bDetached;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssb", &sASourceFile, &sASourceFile_len, &sADestFile, &sADestFile_len, &bDetached) == SUCCESS)
	{
		SBCheckError(TElPGPWriter_SignFile(SBGetObjectHandle(getThis() TSRMLS_CC), sASourceFile, (int32_t)sASourceFile_len, sADestFile, (int32_t)sADestFile_len, (int8_t)bDetached) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, string, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPWriter, EncryptAndSignFile)
{
	char *sADestFile;
	char *sASourceFile;
	int sADestFile_len;
	int sASourceFile_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &sASourceFile, &sASourceFile_len, &sADestFile, &sADestFile_len) == SUCCESS)
	{
		SBCheckError(TElPGPWriter_EncryptAndSignFile(SBGetObjectHandle(getThis() TSRMLS_CC), sASourceFile, (int32_t)sASourceFile_len, sADestFile, (int32_t)sADestFile_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPWriter, ClearTextSignFile)
{
	char *sADestFile;
	char *sASourceFile;
	int sADestFile_len;
	int sASourceFile_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &sASourceFile, &sASourceFile_len, &sADestFile, &sADestFile_len) == SUCCESS)
	{
		SBCheckError(TElPGPWriter_ClearTextSignFile(SBGetObjectHandle(getThis() TSRMLS_CC), sASourceFile, (int32_t)sASourceFile_len, sADestFile, (int32_t)sADestFile_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPWriter, Encrypt)
{
	long l8Count;
	zval *oADestStream;
	zval *oASourceStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!l", &oASourceStream, TStream_ce_ptr, &oADestStream, TStream_ce_ptr, &l8Count) == SUCCESS)
	{
		SBCheckError(TElPGPWriter_Encrypt(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oASourceStream TSRMLS_CC), SBGetObjectHandle(oADestStream TSRMLS_CC), (int64_t)l8Count) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream, TStream, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPWriter, Sign)
{
	long l8Count;
	zend_bool bDetached;
	zval *oADestStream;
	zval *oASourceStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!bl", &oASourceStream, TStream_ce_ptr, &oADestStream, TStream_ce_ptr, &bDetached, &l8Count) == SUCCESS)
	{
		SBCheckError(TElPGPWriter_Sign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oASourceStream TSRMLS_CC), SBGetObjectHandle(oADestStream TSRMLS_CC), (int8_t)bDetached, (int64_t)l8Count) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream, TStream, bool, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPWriter, EncryptAndSign)
{
	long l8Count;
	zval *oADestStream;
	zval *oASourceStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!l", &oASourceStream, TStream_ce_ptr, &oADestStream, TStream_ce_ptr, &l8Count) == SUCCESS)
	{
		SBCheckError(TElPGPWriter_EncryptAndSign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oASourceStream TSRMLS_CC), SBGetObjectHandle(oADestStream TSRMLS_CC), (int64_t)l8Count) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream, TStream, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPWriter, ClearTextSign)
{
	long l8Count;
	zval *oADestStream;
	zval *oASourceStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!l", &oASourceStream, TStream_ce_ptr, &oADestStream, TStream_ce_ptr, &l8Count) == SUCCESS)
	{
		SBCheckError(TElPGPWriter_ClearTextSign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oASourceStream TSRMLS_CC), SBGetObjectHandle(oADestStream TSRMLS_CC), (int64_t)l8Count) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream, TStream, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPWriter, EncryptFiles)
{
	char *sADestFileName;
	int sADestFileName_len;
	zval *oADestStream;
	zval *oSourceFileNames;
	zval *oSourceStreams;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!sO!", &oSourceFileNames, TStringList_ce_ptr, &oSourceStreams, TList_ce_ptr, &sADestFileName, &sADestFileName_len, &oADestStream, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPWriter_EncryptFiles(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSourceFileNames TSRMLS_CC), SBGetObjectHandle(oSourceStreams TSRMLS_CC), sADestFileName, (int32_t)sADestFileName_len, SBGetObjectHandle(oADestStream TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStringList, TList, string, TStream)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPWriter, SignFiles)
{
	char *sADestFileName;
	int sADestFileName_len;
	zval *oADestStream;
	zval *oSourceFileNames;
	zval *oSourceStreams;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!sO!", &oSourceFileNames, TStringList_ce_ptr, &oSourceStreams, TList_ce_ptr, &sADestFileName, &sADestFileName_len, &oADestStream, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPWriter_SignFiles(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSourceFileNames TSRMLS_CC), SBGetObjectHandle(oSourceStreams TSRMLS_CC), sADestFileName, (int32_t)sADestFileName_len, SBGetObjectHandle(oADestStream TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStringList, TList, string, TStream)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPWriter, EncryptAndSignFiles)
{
	char *sADestFileName;
	int sADestFileName_len;
	zval *oADestStream;
	zval *oSourceFileNames;
	zval *oSourceStreams;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!sO!", &oSourceFileNames, TStringList_ce_ptr, &oSourceStreams, TList_ce_ptr, &sADestFileName, &sADestFileName_len, &oADestStream, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPWriter_EncryptAndSignFiles(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSourceFileNames TSRMLS_CC), SBGetObjectHandle(oSourceStreams TSRMLS_CC), sADestFileName, (int32_t)sADestFileName_len, SBGetObjectHandle(oADestStream TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStringList, TList, string, TStream)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPWriter, get_Timestamp)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(TElPGPWriter_get_Timestamp(SBGetObjectHandle(getThis() TSRMLS_CC), &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPWriter, set_Timestamp)
{
	zval *dtValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &dtValue, php_date_get_date_ce()) == SUCCESS)
	{
		SBCheckError(TElPGPWriter_set_Timestamp(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetDateTime(dtValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(DateTime)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPWriter, get_Armor)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPGPWriter_get_Armor(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPWriter, set_Armor)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElPGPWriter_set_Armor(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPWriter, get_EncryptionType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBPGPEncryptionTypeRaw fOutResultRaw = 0;
		SBCheckError(TElPGPWriter_get_EncryptionType(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPWriter, set_EncryptionType)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElPGPWriter_set_EncryptionType(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBPGPEncryptionTypeRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPWriter, get_Compress)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPGPWriter_get_Compress(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPWriter, set_Compress)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElPGPWriter_set_Compress(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPWriter, get_CompressionAlgorithm)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPGPWriter_get_CompressionAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPWriter, set_CompressionAlgorithm)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElPGPWriter_set_CompressionAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPWriter, get_CompressionLevel)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPGPWriter_get_CompressionLevel(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPWriter, set_CompressionLevel)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElPGPWriter_set_CompressionLevel(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPWriter, get_ArmorBoundary)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElPGPWriter_get_ArmorBoundary(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-652794616, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPWriter, set_ArmorBoundary)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElPGPWriter_set_ArmorBoundary(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPWriter, get_ArmorHeaders)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPGPWriter_get_ArmorHeaders(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TStringList_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPWriter, get_Filename)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElPGPWriter_get_Filename(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1791732051, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPWriter, set_Filename)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElPGPWriter_set_Filename(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPWriter, get_SigningKeys)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPGPWriter_get_SigningKeys(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElPGPKeyring_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPWriter, set_SigningKeys)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElPGPKeyring_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPWriter_set_SigningKeys(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElPGPKeyring)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPWriter, get_EncryptingKeys)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPGPWriter_get_EncryptingKeys(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElPGPKeyring_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPWriter, set_EncryptingKeys)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElPGPKeyring_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPWriter_set_EncryptingKeys(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElPGPKeyring)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPWriter, get_HashAlgorithm)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPGPWriter_get_HashAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPWriter, set_HashAlgorithm)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElPGPWriter_set_HashAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPWriter, get_Passphrases)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPGPWriter_get_Passphrases(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TStringList_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPWriter, get_Protection)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBPGPProtectionTypeRaw fOutResultRaw = 0;
		SBCheckError(TElPGPWriter_get_Protection(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPWriter, set_Protection)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElPGPWriter_set_Protection(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBPGPProtectionTypeRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPWriter, get_SymmetricKeyAlgorithm)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPGPWriter_get_SymmetricKeyAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPWriter, set_SymmetricKeyAlgorithm)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElPGPWriter_set_SymmetricKeyAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPWriter, get_SignBufferingMethod)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBPGPSignBufferingMethodRaw fOutResultRaw = 0;
		SBCheckError(TElPGPWriter_get_SignBufferingMethod(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPWriter, set_SignBufferingMethod)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElPGPWriter_set_SignBufferingMethod(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBPGPSignBufferingMethodRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPWriter, get_UseOldPackets)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPGPWriter_get_UseOldPackets(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPWriter, set_UseOldPackets)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElPGPWriter_set_UseOldPackets(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPWriter, get_UseNewFeatures)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPGPWriter_get_UseNewFeatures(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPWriter, set_UseNewFeatures)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElPGPWriter_set_UseNewFeatures(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPWriter, get_InputIsText)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPGPWriter_get_InputIsText(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPWriter, set_InputIsText)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElPGPWriter_set_InputIsText(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPWriter, get_TextCompatibilityMode)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPGPWriter_get_TextCompatibilityMode(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPWriter, set_TextCompatibilityMode)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElPGPWriter_set_TextCompatibilityMode(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPWriter, get_UndefInputLength)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPGPWriter_get_UndefInputLength(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPWriter, set_UndefInputLength)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElPGPWriter_set_UndefInputLength(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

#ifdef SB_WINDOWS
SB_PHP_METHOD(TElPGPWriter, get_SFXCopyright)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElPGPWriter_get_SFXCopyright(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1261277741, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPWriter, set_SFXCopyright)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElPGPWriter_set_SFXCopyright(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPWriter, get_SFXEnabled)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPGPWriter_get_SFXEnabled(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPWriter, set_SFXEnabled)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElPGPWriter_set_SFXEnabled(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPWriter, get_SFXTitle)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElPGPWriter_get_SFXTitle(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(85040249, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPWriter, set_SFXTitle)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElPGPWriter_set_SFXTitle(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPWriter, get_StubName)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElPGPWriter_get_StubName(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1850887023, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPWriter, set_StubName)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElPGPWriter_set_StubName(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPWriter, get_StubSource)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBPGPStubSourceRaw fOutResultRaw = 0;
		SBCheckError(TElPGPWriter_get_StubSource(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPWriter, set_StubSource)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElPGPWriter_set_StubSource(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBPGPStubSourceRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}
#endif

SB_PHP_METHOD(TElPGPWriter, get_PreserveFilePaths)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPGPWriter_get_PreserveFilePaths(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPWriter, set_PreserveFilePaths)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElPGPWriter_set_PreserveFilePaths(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPWriter, get_FileSystemAdapter)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPGPWriter_get_FileSystemAdapter(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomFileSystemAdapter_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPWriter, set_FileSystemAdapter)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElCustomFileSystemAdapter_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPWriter_set_FileSystemAdapter(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomFileSystemAdapter)" TSRMLS_CC);
	}
}

#ifdef SB_WINDOWS
SB_PHP_METHOD(TElPGPWriter, get_OnGetStubStream)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBPGPGetStubStreamEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElPGPWriter_get_OnGetStubStream(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPWriter, set_OnGetStubStream)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElPGPWriter_set_OnGetStubStream(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBPGPGetStubStreamEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPGPGetStubStreamEvent|callable|NULL)" TSRMLS_CC);
	}
}
#endif

SB_PHP_METHOD(TElPGPWriter, get_OnKeyPassphrase)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBPGPKeyPassphraseEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElPGPWriter_get_OnKeyPassphrase(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPWriter, set_OnKeyPassphrase)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElPGPWriter_set_OnKeyPassphrase(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBPGPKeyPassphraseEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPGPKeyPassphraseEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPWriter, get_OnProgress)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBPGPProgressEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElPGPWriter_get_OnProgress(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPWriter, set_OnProgress)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElPGPWriter_set_OnProgress(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBPGPProgressEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPGPProgressEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPWriter, get_OnTemporaryStream)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBPGPTemporaryStreamEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElPGPWriter_get_OnTemporaryStream(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPWriter, set_OnTemporaryStream)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElPGPWriter_set_OnTemporaryStream(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBPGPTemporaryStreamEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPGPTemporaryStreamEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPWriter, __construct)
{
	zval *oAOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPGPWriter_Create(SBGetObjectHandle(oAOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPWriter_EncryptFile, 0, 0, 2)
	ZEND_ARG_INFO(0, ASourceFile)
	ZEND_ARG_INFO(0, ADestFile)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPWriter_SignFile, 0, 0, 3)
	ZEND_ARG_INFO(0, ASourceFile)
	ZEND_ARG_INFO(0, ADestFile)
	ZEND_ARG_INFO(0, Detached)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPWriter_EncryptAndSignFile, 0, 0, 2)
	ZEND_ARG_INFO(0, ASourceFile)
	ZEND_ARG_INFO(0, ADestFile)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPWriter_ClearTextSignFile, 0, 0, 2)
	ZEND_ARG_INFO(0, ASourceFile)
	ZEND_ARG_INFO(0, ADestFile)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPWriter_Encrypt, 0, 0, 3)
	ZEND_ARG_OBJ_INFO(0, ASourceStream, TStream, 1)
	ZEND_ARG_OBJ_INFO(0, ADestStream, TStream, 1)
	ZEND_ARG_INFO(0, Count)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPWriter_Sign, 0, 0, 4)
	ZEND_ARG_OBJ_INFO(0, ASourceStream, TStream, 1)
	ZEND_ARG_OBJ_INFO(0, ADestStream, TStream, 1)
	ZEND_ARG_INFO(0, Detached)
	ZEND_ARG_INFO(0, Count)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPWriter_EncryptAndSign, 0, 0, 3)
	ZEND_ARG_OBJ_INFO(0, ASourceStream, TStream, 1)
	ZEND_ARG_OBJ_INFO(0, ADestStream, TStream, 1)
	ZEND_ARG_INFO(0, Count)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPWriter_ClearTextSign, 0, 0, 3)
	ZEND_ARG_OBJ_INFO(0, ASourceStream, TStream, 1)
	ZEND_ARG_OBJ_INFO(0, ADestStream, TStream, 1)
	ZEND_ARG_INFO(0, Count)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPWriter_EncryptFiles, 0, 0, 4)
	ZEND_ARG_OBJ_INFO(0, SourceFileNames, TStringList, 1)
	ZEND_ARG_OBJ_INFO(0, SourceStreams, TList, 1)
	ZEND_ARG_INFO(0, ADestFileName)
	ZEND_ARG_OBJ_INFO(0, ADestStream, TStream, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPWriter_SignFiles, 0, 0, 4)
	ZEND_ARG_OBJ_INFO(0, SourceFileNames, TStringList, 1)
	ZEND_ARG_OBJ_INFO(0, SourceStreams, TList, 1)
	ZEND_ARG_INFO(0, ADestFileName)
	ZEND_ARG_OBJ_INFO(0, ADestStream, TStream, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPWriter_EncryptAndSignFiles, 0, 0, 4)
	ZEND_ARG_OBJ_INFO(0, SourceFileNames, TStringList, 1)
	ZEND_ARG_OBJ_INFO(0, SourceStreams, TList, 1)
	ZEND_ARG_INFO(0, ADestFileName)
	ZEND_ARG_OBJ_INFO(0, ADestStream, TStream, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPWriter_get_Timestamp, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPWriter_set_Timestamp, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, DateTime, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPWriter_get_Armor, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPWriter_set_Armor, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPWriter_get_EncryptionType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPWriter_set_EncryptionType, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPWriter_get_Compress, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPWriter_set_Compress, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPWriter_get_CompressionAlgorithm, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPWriter_set_CompressionAlgorithm, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPWriter_get_CompressionLevel, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPWriter_set_CompressionLevel, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPWriter_get_ArmorBoundary, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPWriter_set_ArmorBoundary, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPWriter_get_ArmorHeaders, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPWriter_get_Filename, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPWriter_set_Filename, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPWriter_get_SigningKeys, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPWriter_set_SigningKeys, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElPGPKeyring, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPWriter_get_EncryptingKeys, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPWriter_set_EncryptingKeys, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElPGPKeyring, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPWriter_get_HashAlgorithm, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPWriter_set_HashAlgorithm, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPWriter_get_Passphrases, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPWriter_get_Protection, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPWriter_set_Protection, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPWriter_get_SymmetricKeyAlgorithm, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPWriter_set_SymmetricKeyAlgorithm, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPWriter_get_SignBufferingMethod, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPWriter_set_SignBufferingMethod, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPWriter_get_UseOldPackets, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPWriter_set_UseOldPackets, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPWriter_get_UseNewFeatures, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPWriter_set_UseNewFeatures, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPWriter_get_InputIsText, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPWriter_set_InputIsText, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPWriter_get_TextCompatibilityMode, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPWriter_set_TextCompatibilityMode, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPWriter_get_UndefInputLength, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPWriter_set_UndefInputLength, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

#ifdef SB_WINDOWS
ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPWriter_get_SFXCopyright, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPWriter_set_SFXCopyright, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPWriter_get_SFXEnabled, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPWriter_set_SFXEnabled, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPWriter_get_SFXTitle, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPWriter_set_SFXTitle, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPWriter_get_StubName, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPWriter_set_StubName, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPWriter_get_StubSource, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPWriter_set_StubSource, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()
#endif

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPWriter_get_PreserveFilePaths, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPWriter_set_PreserveFilePaths, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPWriter_get_FileSystemAdapter, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPWriter_set_FileSystemAdapter, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElCustomFileSystemAdapter, 1)
ZEND_END_ARG_INFO()

#ifdef SB_WINDOWS
ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPWriter_get_OnGetStubStream, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPWriter_set_OnGetStubStream, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()
#endif

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPWriter_get_OnKeyPassphrase, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPWriter_set_OnKeyPassphrase, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPWriter_get_OnProgress, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPWriter_set_OnProgress, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPWriter_get_OnTemporaryStream, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPWriter_set_OnTemporaryStream, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPWriter___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AOwner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElPGPWriter_methods[] = {
	PHP_ME(TElPGPWriter, EncryptFile, arginfo_TElPGPWriter_EncryptFile, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPWriter, SignFile, arginfo_TElPGPWriter_SignFile, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPWriter, EncryptAndSignFile, arginfo_TElPGPWriter_EncryptAndSignFile, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPWriter, ClearTextSignFile, arginfo_TElPGPWriter_ClearTextSignFile, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPWriter, Encrypt, arginfo_TElPGPWriter_Encrypt, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPWriter, Sign, arginfo_TElPGPWriter_Sign, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPWriter, EncryptAndSign, arginfo_TElPGPWriter_EncryptAndSign, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPWriter, ClearTextSign, arginfo_TElPGPWriter_ClearTextSign, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPWriter, EncryptFiles, arginfo_TElPGPWriter_EncryptFiles, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPWriter, SignFiles, arginfo_TElPGPWriter_SignFiles, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPWriter, EncryptAndSignFiles, arginfo_TElPGPWriter_EncryptAndSignFiles, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPWriter, get_Timestamp, arginfo_TElPGPWriter_get_Timestamp, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPWriter, set_Timestamp, arginfo_TElPGPWriter_set_Timestamp, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPWriter, get_Armor, arginfo_TElPGPWriter_get_Armor, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPWriter, set_Armor, arginfo_TElPGPWriter_set_Armor, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPWriter, get_EncryptionType, arginfo_TElPGPWriter_get_EncryptionType, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPWriter, set_EncryptionType, arginfo_TElPGPWriter_set_EncryptionType, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPWriter, get_Compress, arginfo_TElPGPWriter_get_Compress, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPWriter, set_Compress, arginfo_TElPGPWriter_set_Compress, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPWriter, get_CompressionAlgorithm, arginfo_TElPGPWriter_get_CompressionAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPWriter, set_CompressionAlgorithm, arginfo_TElPGPWriter_set_CompressionAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPWriter, get_CompressionLevel, arginfo_TElPGPWriter_get_CompressionLevel, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPWriter, set_CompressionLevel, arginfo_TElPGPWriter_set_CompressionLevel, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPWriter, get_ArmorBoundary, arginfo_TElPGPWriter_get_ArmorBoundary, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPWriter, set_ArmorBoundary, arginfo_TElPGPWriter_set_ArmorBoundary, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPWriter, get_ArmorHeaders, arginfo_TElPGPWriter_get_ArmorHeaders, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPWriter, get_Filename, arginfo_TElPGPWriter_get_Filename, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPWriter, set_Filename, arginfo_TElPGPWriter_set_Filename, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPWriter, get_SigningKeys, arginfo_TElPGPWriter_get_SigningKeys, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPWriter, set_SigningKeys, arginfo_TElPGPWriter_set_SigningKeys, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPWriter, get_EncryptingKeys, arginfo_TElPGPWriter_get_EncryptingKeys, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPWriter, set_EncryptingKeys, arginfo_TElPGPWriter_set_EncryptingKeys, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPWriter, get_HashAlgorithm, arginfo_TElPGPWriter_get_HashAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPWriter, set_HashAlgorithm, arginfo_TElPGPWriter_set_HashAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPWriter, get_Passphrases, arginfo_TElPGPWriter_get_Passphrases, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPWriter, get_Protection, arginfo_TElPGPWriter_get_Protection, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPWriter, set_Protection, arginfo_TElPGPWriter_set_Protection, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPWriter, get_SymmetricKeyAlgorithm, arginfo_TElPGPWriter_get_SymmetricKeyAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPWriter, set_SymmetricKeyAlgorithm, arginfo_TElPGPWriter_set_SymmetricKeyAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPWriter, get_SignBufferingMethod, arginfo_TElPGPWriter_get_SignBufferingMethod, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPWriter, set_SignBufferingMethod, arginfo_TElPGPWriter_set_SignBufferingMethod, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPWriter, get_UseOldPackets, arginfo_TElPGPWriter_get_UseOldPackets, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPWriter, set_UseOldPackets, arginfo_TElPGPWriter_set_UseOldPackets, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPWriter, get_UseNewFeatures, arginfo_TElPGPWriter_get_UseNewFeatures, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPWriter, set_UseNewFeatures, arginfo_TElPGPWriter_set_UseNewFeatures, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPWriter, get_InputIsText, arginfo_TElPGPWriter_get_InputIsText, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPWriter, set_InputIsText, arginfo_TElPGPWriter_set_InputIsText, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPWriter, get_TextCompatibilityMode, arginfo_TElPGPWriter_get_TextCompatibilityMode, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPWriter, set_TextCompatibilityMode, arginfo_TElPGPWriter_set_TextCompatibilityMode, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPWriter, get_UndefInputLength, arginfo_TElPGPWriter_get_UndefInputLength, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPWriter, set_UndefInputLength, arginfo_TElPGPWriter_set_UndefInputLength, ZEND_ACC_PUBLIC)
#ifdef SB_WINDOWS
	PHP_ME(TElPGPWriter, get_SFXCopyright, arginfo_TElPGPWriter_get_SFXCopyright, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPWriter, set_SFXCopyright, arginfo_TElPGPWriter_set_SFXCopyright, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPWriter, get_SFXEnabled, arginfo_TElPGPWriter_get_SFXEnabled, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPWriter, set_SFXEnabled, arginfo_TElPGPWriter_set_SFXEnabled, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPWriter, get_SFXTitle, arginfo_TElPGPWriter_get_SFXTitle, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPWriter, set_SFXTitle, arginfo_TElPGPWriter_set_SFXTitle, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPWriter, get_StubName, arginfo_TElPGPWriter_get_StubName, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPWriter, set_StubName, arginfo_TElPGPWriter_set_StubName, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPWriter, get_StubSource, arginfo_TElPGPWriter_get_StubSource, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPWriter, set_StubSource, arginfo_TElPGPWriter_set_StubSource, ZEND_ACC_PUBLIC)
#endif
	PHP_ME(TElPGPWriter, get_PreserveFilePaths, arginfo_TElPGPWriter_get_PreserveFilePaths, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPWriter, set_PreserveFilePaths, arginfo_TElPGPWriter_set_PreserveFilePaths, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPWriter, get_FileSystemAdapter, arginfo_TElPGPWriter_get_FileSystemAdapter, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPWriter, set_FileSystemAdapter, arginfo_TElPGPWriter_set_FileSystemAdapter, ZEND_ACC_PUBLIC)
#ifdef SB_WINDOWS
	PHP_ME(TElPGPWriter, get_OnGetStubStream, arginfo_TElPGPWriter_get_OnGetStubStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPWriter, set_OnGetStubStream, arginfo_TElPGPWriter_set_OnGetStubStream, ZEND_ACC_PUBLIC)
#endif
	PHP_ME(TElPGPWriter, get_OnKeyPassphrase, arginfo_TElPGPWriter_get_OnKeyPassphrase, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPWriter, set_OnKeyPassphrase, arginfo_TElPGPWriter_set_OnKeyPassphrase, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPWriter, get_OnProgress, arginfo_TElPGPWriter_get_OnProgress, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPWriter, set_OnProgress, arginfo_TElPGPWriter_set_OnProgress, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPWriter, get_OnTemporaryStream, arginfo_TElPGPWriter_get_OnTemporaryStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPWriter, set_OnTemporaryStream, arginfo_TElPGPWriter_set_OnTemporaryStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPWriter, __construct, arginfo_TElPGPWriter___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElPGPWriter(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElPGPWriter_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElPGPWriter", TElPGPWriter_methods);
	if (NULL == TComponent_ce_ptr)
		Register_TComponent(TSRMLS_C);
	TElPGPWriter_ce_ptr = zend_register_internal_class_ex(&ce, TComponent_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElPGPProcessingUnit_ce_ptr = NULL;

SB_PHP_METHOD(TElPGPProcessingUnit, Read)
{
	long l4Size;
	SBArrayZValInfo piBuffer;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zpBuffer, &l4Size) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPGPProcessingUnit_Read(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, (int32_t)l4Size, &l4OutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPProcessingUnit, Write)
{
	long l4Size;
	SBArrayZValInfo piBuffer;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zpBuffer, &l4Size) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPGPProcessingUnit_Write(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, (int32_t)l4Size) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPProcessingUnit, NFinalize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElPGPProcessingUnit_NFinalize(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPProcessingUnit, get_Atomic)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPGPProcessingUnit_get_Atomic(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPProcessingUnit, get_Finished)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPGPProcessingUnit_get_Finished(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPProcessingUnit, get_Stream)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPGPProcessingUnit_get_Stream(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElPGPStream_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPProcessingUnit, get_Prev)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPGPProcessingUnit_get_Prev(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElPGPProcessingUnit_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPProcessingUnit, get_SkippedLength)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElPGPProcessingUnit_get_SkippedLength(SBGetObjectHandle(getThis() TSRMLS_CC), &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPProcessingUnit, get_ProcessedLength)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElPGPProcessingUnit_get_ProcessedLength(SBGetObjectHandle(getThis() TSRMLS_CC), &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPProcessingUnit, get_InputEncoding)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPGPProcessingUnit_get_InputEncoding(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPProcessingUnit, set_InputEncoding)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElPGPProcessingUnit_set_InputEncoding(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPProcessingUnit, get_IgnoreDataPacketLengths)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPGPProcessingUnit_get_IgnoreDataPacketLengths(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPProcessingUnit, set_IgnoreDataPacketLengths)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElPGPProcessingUnit_set_IgnoreDataPacketLengths(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPProcessingUnit, get_OnNewStream)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBPGPNewStreamEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElPGPProcessingUnit_get_OnNewStream(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPProcessingUnit, set_OnNewStream)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElPGPProcessingUnit_set_OnNewStream(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBPGPNewStreamEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPGPNewStreamEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPProcessingUnit, get_OnFinish)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TNotifyEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElPGPProcessingUnit_get_OnFinish(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPProcessingUnit, set_OnFinish)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElPGPProcessingUnit_set_OnFinish(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TNotifyEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TNotifyEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPProcessingUnit, get_OnSignature)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBPGPSignatureEntityEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElPGPProcessingUnit_get_OnSignature(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPProcessingUnit, set_OnSignature)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElPGPProcessingUnit_set_OnSignature(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBPGPSignatureEntityEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPGPSignatureEntityEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPProcessingUnit, get_OnHashAlgorithm)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBPGPHashAlgorithmEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElPGPProcessingUnit_get_OnHashAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPProcessingUnit, set_OnHashAlgorithm)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElPGPProcessingUnit_set_OnHashAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBPGPHashAlgorithmEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPGPHashAlgorithmEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPProcessingUnit, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPGPProcessingUnit_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPProcessingUnit_Read, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(0, Size)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPProcessingUnit_Write, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(0, Size)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPProcessingUnit_NFinalize, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPProcessingUnit_get_Atomic, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPProcessingUnit_get_Finished, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPProcessingUnit_get_Stream, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPProcessingUnit_get_Prev, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPProcessingUnit_get_SkippedLength, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPProcessingUnit_get_ProcessedLength, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPProcessingUnit_get_InputEncoding, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPProcessingUnit_set_InputEncoding, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPProcessingUnit_get_IgnoreDataPacketLengths, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPProcessingUnit_set_IgnoreDataPacketLengths, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPProcessingUnit_get_OnNewStream, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPProcessingUnit_set_OnNewStream, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPProcessingUnit_get_OnFinish, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPProcessingUnit_set_OnFinish, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPProcessingUnit_get_OnSignature, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPProcessingUnit_set_OnSignature, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPProcessingUnit_get_OnHashAlgorithm, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPProcessingUnit_set_OnHashAlgorithm, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPProcessingUnit___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElPGPProcessingUnit_methods[] = {
	PHP_ME(TElPGPProcessingUnit, Read, arginfo_TElPGPProcessingUnit_Read, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPProcessingUnit, Write, arginfo_TElPGPProcessingUnit_Write, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPProcessingUnit, NFinalize, arginfo_TElPGPProcessingUnit_NFinalize, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPProcessingUnit, get_Atomic, arginfo_TElPGPProcessingUnit_get_Atomic, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPProcessingUnit, get_Finished, arginfo_TElPGPProcessingUnit_get_Finished, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPProcessingUnit, get_Stream, arginfo_TElPGPProcessingUnit_get_Stream, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPProcessingUnit, get_Prev, arginfo_TElPGPProcessingUnit_get_Prev, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPProcessingUnit, get_SkippedLength, arginfo_TElPGPProcessingUnit_get_SkippedLength, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPProcessingUnit, get_ProcessedLength, arginfo_TElPGPProcessingUnit_get_ProcessedLength, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPProcessingUnit, get_InputEncoding, arginfo_TElPGPProcessingUnit_get_InputEncoding, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPProcessingUnit, set_InputEncoding, arginfo_TElPGPProcessingUnit_set_InputEncoding, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPProcessingUnit, get_IgnoreDataPacketLengths, arginfo_TElPGPProcessingUnit_get_IgnoreDataPacketLengths, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPProcessingUnit, set_IgnoreDataPacketLengths, arginfo_TElPGPProcessingUnit_set_IgnoreDataPacketLengths, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPProcessingUnit, get_OnNewStream, arginfo_TElPGPProcessingUnit_get_OnNewStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPProcessingUnit, set_OnNewStream, arginfo_TElPGPProcessingUnit_set_OnNewStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPProcessingUnit, get_OnFinish, arginfo_TElPGPProcessingUnit_get_OnFinish, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPProcessingUnit, set_OnFinish, arginfo_TElPGPProcessingUnit_set_OnFinish, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPProcessingUnit, get_OnSignature, arginfo_TElPGPProcessingUnit_get_OnSignature, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPProcessingUnit, set_OnSignature, arginfo_TElPGPProcessingUnit_set_OnSignature, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPProcessingUnit, get_OnHashAlgorithm, arginfo_TElPGPProcessingUnit_get_OnHashAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPProcessingUnit, set_OnHashAlgorithm, arginfo_TElPGPProcessingUnit_set_OnHashAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPProcessingUnit, __construct, arginfo_TElPGPProcessingUnit___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElPGPProcessingUnit(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElPGPProcessingUnit_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElPGPProcessingUnit", TElPGPProcessingUnit_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElPGPProcessingUnit_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElPGPReader_ce_ptr = NULL;

SB_PHP_METHOD(TElPGPReader, DecryptAndVerifyFile)
{
	char *sASourceFile;
	int sASourceFile_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sASourceFile, &sASourceFile_len) == SUCCESS)
	{
		SBCheckError(TElPGPReader_DecryptAndVerifyFile(SBGetObjectHandle(getThis() TSRMLS_CC), sASourceFile, (int32_t)sASourceFile_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPReader, VerifyDetachedFile)
{
	char *sASignatureFile;
	char *sASourceFile;
	int sASignatureFile_len;
	int sASourceFile_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &sASourceFile, &sASourceFile_len, &sASignatureFile, &sASignatureFile_len) == SUCCESS)
	{
		SBCheckError(TElPGPReader_VerifyDetachedFile(SBGetObjectHandle(getThis() TSRMLS_CC), sASourceFile, (int32_t)sASourceFile_len, sASignatureFile, (int32_t)sASignatureFile_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPReader, DecryptAndVerify)
{
	long l8Count;
	zval *oASourceStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!l", &oASourceStream, TStream_ce_ptr, &l8Count) == SUCCESS)
	{
		SBCheckError(TElPGPReader_DecryptAndVerify(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oASourceStream TSRMLS_CC), (int64_t)l8Count) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPReader, VerifyDetached)
{
	long l8SignatureStreamCount;
	long l8SourceStreamCount;
	zval *oASignatureStream;
	zval *oASourceStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!ll", &oASourceStream, TStream_ce_ptr, &oASignatureStream, TStream_ce_ptr, &l8SourceStreamCount, &l8SignatureStreamCount) == SUCCESS)
	{
		SBCheckError(TElPGPReader_VerifyDetached(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oASourceStream TSRMLS_CC), SBGetObjectHandle(oASignatureStream TSRMLS_CC), (int64_t)l8SourceStreamCount, (int64_t)l8SignatureStreamCount) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream, TStream, integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPReader, get_EncryptionAlgorithm)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPGPReader_get_EncryptionAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPReader, get_CompressionAlgorithm)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPGPReader_get_CompressionAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPReader, get_Protection)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBPGPProtectionTypeRaw fOutResultRaw = 0;
		SBCheckError(TElPGPReader_get_Protection(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPReader, get_ProcessedLength)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElPGPReader_get_ProcessedLength(SBGetObjectHandle(getThis() TSRMLS_CC), &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPReader, get_OutputStream)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPGPReader_get_OutputStream(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TStream_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPReader, set_OutputStream)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPReader_set_OutputStream(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPReader, get_DecryptingKeys)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPGPReader_get_DecryptingKeys(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElPGPKeyring_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPReader, set_DecryptingKeys)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElPGPKeyring_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPReader_set_DecryptingKeys(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElPGPKeyring)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPReader, get_VerifyingKeys)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPGPReader_get_VerifyingKeys(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElPGPKeyring_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPReader, set_VerifyingKeys)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElPGPKeyring_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPReader_set_VerifyingKeys(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElPGPKeyring)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPReader, get_OutputFile)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElPGPReader_get_OutputFile(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1442046346, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPReader, set_OutputFile)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElPGPReader_set_OutputFile(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPReader, get_Passphrase)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElPGPReader_get_Passphrase(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(9101558, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPReader, set_Passphrase)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElPGPReader_set_Passphrase(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPReader, get_KeyPassphrase)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElPGPReader_get_KeyPassphrase(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1428086172, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPReader, set_KeyPassphrase)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElPGPReader_set_KeyPassphrase(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPReader, get_MemoryConsumptionStrategy)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBPGPMemoryConsumptionStrategyRaw fOutResultRaw = 0;
		SBCheckError(TElPGPReader_get_MemoryConsumptionStrategy(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPReader, set_MemoryConsumptionStrategy)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElPGPReader_set_MemoryConsumptionStrategy(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBPGPMemoryConsumptionStrategyRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPReader, get_FileSystemAdapter)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPGPReader_get_FileSystemAdapter(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomFileSystemAdapter_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPReader, set_FileSystemAdapter)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElCustomFileSystemAdapter_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPReader_set_FileSystemAdapter(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomFileSystemAdapter)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPReader, get_IgnoreDataPacketLengths)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPGPReader_get_IgnoreDataPacketLengths(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPReader, set_IgnoreDataPacketLengths)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElPGPReader_set_IgnoreDataPacketLengths(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPReader, get_UndefInputLength)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPGPReader_get_UndefInputLength(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPReader, set_UndefInputLength)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElPGPReader_set_UndefInputLength(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPReader, get_OnArmored)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBPGPArmoredEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElPGPReader_get_OnArmored(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPReader, set_OnArmored)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElPGPReader_set_OnArmored(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBPGPArmoredEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPGPArmoredEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPReader, get_OnCompressed)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TNotifyEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElPGPReader_get_OnCompressed(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPReader, set_OnCompressed)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElPGPReader_set_OnCompressed(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TNotifyEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TNotifyEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPReader, get_OnEncrypted)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBPGPEncryptedEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElPGPReader_get_OnEncrypted(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPReader, set_OnEncrypted)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElPGPReader_set_OnEncrypted(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBPGPEncryptedEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPGPEncryptedEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPReader, get_OnCreateOutputStream)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBPGPCreateOutputStreamEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElPGPReader_get_OnCreateOutputStream(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPReader, set_OnCreateOutputStream)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElPGPReader_set_OnCreateOutputStream(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBPGPCreateOutputStreamEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPGPCreateOutputStreamEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPReader, get_OnRequestOutputFile)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBPGPRequestOutputFileEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElPGPReader_get_OnRequestOutputFile(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPReader, set_OnRequestOutputFile)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElPGPReader_set_OnRequestOutputFile(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBPGPRequestOutputFileEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPGPRequestOutputFileEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPReader, get_OnKeyPassphrase)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBPGPKeyPassphraseEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElPGPReader_get_OnKeyPassphrase(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPReader, set_OnKeyPassphrase)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElPGPReader_set_OnKeyPassphrase(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBPGPKeyPassphraseEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPGPKeyPassphraseEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPReader, get_OnPassphrase)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBPGPPassphraseEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElPGPReader_get_OnPassphrase(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPReader, set_OnPassphrase)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElPGPReader_set_OnPassphrase(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBPGPPassphraseEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPGPPassphraseEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPReader, get_OnProgress)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBPGPProgressEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElPGPReader_get_OnProgress(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPReader, set_OnProgress)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElPGPReader_set_OnProgress(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBPGPProgressEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPGPProgressEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPReader, get_OnSigned)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBPGPSignedEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElPGPReader_get_OnSigned(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPReader, set_OnSigned)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElPGPReader_set_OnSigned(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBPGPSignedEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPGPSignedEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPReader, get_OnSignatures)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBPGPSignaturesEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElPGPReader_get_OnSignatures(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPReader, set_OnSignatures)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElPGPReader_set_OnSignatures(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBPGPSignaturesEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPGPSignaturesEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPReader, get_OnFileExtractionStart)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBPGPFileExtractionStartEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElPGPReader_get_OnFileExtractionStart(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPReader, set_OnFileExtractionStart)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElPGPReader_set_OnFileExtractionStart(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBPGPFileExtractionStartEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPGPFileExtractionStartEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPReader, get_OnMultipleFilesFound)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBPGPMultipleFilesFoundEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElPGPReader_get_OnMultipleFilesFound(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPReader, set_OnMultipleFilesFound)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElPGPReader_set_OnMultipleFilesFound(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBPGPMultipleFilesFoundEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPGPMultipleFilesFoundEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPReader, get_OnTemporaryStream)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBPGPTemporaryStreamEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElPGPReader_get_OnTemporaryStream(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPReader, set_OnTemporaryStream)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElPGPReader_set_OnTemporaryStream(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBPGPTemporaryStreamEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPGPTemporaryStreamEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPReader, __construct)
{
	zval *oAOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPGPReader_Create(SBGetObjectHandle(oAOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPReader_DecryptAndVerifyFile, 0, 0, 1)
	ZEND_ARG_INFO(0, ASourceFile)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPReader_VerifyDetachedFile, 0, 0, 2)
	ZEND_ARG_INFO(0, ASourceFile)
	ZEND_ARG_INFO(0, ASignatureFile)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPReader_DecryptAndVerify, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, ASourceStream, TStream, 1)
	ZEND_ARG_INFO(0, Count)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPReader_VerifyDetached, 0, 0, 4)
	ZEND_ARG_OBJ_INFO(0, ASourceStream, TStream, 1)
	ZEND_ARG_OBJ_INFO(0, ASignatureStream, TStream, 1)
	ZEND_ARG_INFO(0, SourceStreamCount)
	ZEND_ARG_INFO(0, SignatureStreamCount)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPReader_get_EncryptionAlgorithm, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPReader_get_CompressionAlgorithm, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPReader_get_Protection, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPReader_get_ProcessedLength, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPReader_get_OutputStream, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPReader_set_OutputStream, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TStream, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPReader_get_DecryptingKeys, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPReader_set_DecryptingKeys, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElPGPKeyring, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPReader_get_VerifyingKeys, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPReader_set_VerifyingKeys, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElPGPKeyring, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPReader_get_OutputFile, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPReader_set_OutputFile, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPReader_get_Passphrase, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPReader_set_Passphrase, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPReader_get_KeyPassphrase, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPReader_set_KeyPassphrase, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPReader_get_MemoryConsumptionStrategy, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPReader_set_MemoryConsumptionStrategy, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPReader_get_FileSystemAdapter, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPReader_set_FileSystemAdapter, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElCustomFileSystemAdapter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPReader_get_IgnoreDataPacketLengths, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPReader_set_IgnoreDataPacketLengths, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPReader_get_UndefInputLength, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPReader_set_UndefInputLength, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPReader_get_OnArmored, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPReader_set_OnArmored, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPReader_get_OnCompressed, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPReader_set_OnCompressed, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPReader_get_OnEncrypted, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPReader_set_OnEncrypted, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPReader_get_OnCreateOutputStream, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPReader_set_OnCreateOutputStream, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPReader_get_OnRequestOutputFile, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPReader_set_OnRequestOutputFile, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPReader_get_OnKeyPassphrase, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPReader_set_OnKeyPassphrase, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPReader_get_OnPassphrase, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPReader_set_OnPassphrase, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPReader_get_OnProgress, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPReader_set_OnProgress, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPReader_get_OnSigned, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPReader_set_OnSigned, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPReader_get_OnSignatures, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPReader_set_OnSignatures, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPReader_get_OnFileExtractionStart, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPReader_set_OnFileExtractionStart, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPReader_get_OnMultipleFilesFound, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPReader_set_OnMultipleFilesFound, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPReader_get_OnTemporaryStream, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPReader_set_OnTemporaryStream, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPReader___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AOwner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElPGPReader_methods[] = {
	PHP_ME(TElPGPReader, DecryptAndVerifyFile, arginfo_TElPGPReader_DecryptAndVerifyFile, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPReader, VerifyDetachedFile, arginfo_TElPGPReader_VerifyDetachedFile, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPReader, DecryptAndVerify, arginfo_TElPGPReader_DecryptAndVerify, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPReader, VerifyDetached, arginfo_TElPGPReader_VerifyDetached, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPReader, get_EncryptionAlgorithm, arginfo_TElPGPReader_get_EncryptionAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPReader, get_CompressionAlgorithm, arginfo_TElPGPReader_get_CompressionAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPReader, get_Protection, arginfo_TElPGPReader_get_Protection, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPReader, get_ProcessedLength, arginfo_TElPGPReader_get_ProcessedLength, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPReader, get_OutputStream, arginfo_TElPGPReader_get_OutputStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPReader, set_OutputStream, arginfo_TElPGPReader_set_OutputStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPReader, get_DecryptingKeys, arginfo_TElPGPReader_get_DecryptingKeys, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPReader, set_DecryptingKeys, arginfo_TElPGPReader_set_DecryptingKeys, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPReader, get_VerifyingKeys, arginfo_TElPGPReader_get_VerifyingKeys, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPReader, set_VerifyingKeys, arginfo_TElPGPReader_set_VerifyingKeys, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPReader, get_OutputFile, arginfo_TElPGPReader_get_OutputFile, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPReader, set_OutputFile, arginfo_TElPGPReader_set_OutputFile, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPReader, get_Passphrase, arginfo_TElPGPReader_get_Passphrase, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPReader, set_Passphrase, arginfo_TElPGPReader_set_Passphrase, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPReader, get_KeyPassphrase, arginfo_TElPGPReader_get_KeyPassphrase, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPReader, set_KeyPassphrase, arginfo_TElPGPReader_set_KeyPassphrase, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPReader, get_MemoryConsumptionStrategy, arginfo_TElPGPReader_get_MemoryConsumptionStrategy, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPReader, set_MemoryConsumptionStrategy, arginfo_TElPGPReader_set_MemoryConsumptionStrategy, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPReader, get_FileSystemAdapter, arginfo_TElPGPReader_get_FileSystemAdapter, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPReader, set_FileSystemAdapter, arginfo_TElPGPReader_set_FileSystemAdapter, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPReader, get_IgnoreDataPacketLengths, arginfo_TElPGPReader_get_IgnoreDataPacketLengths, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPReader, set_IgnoreDataPacketLengths, arginfo_TElPGPReader_set_IgnoreDataPacketLengths, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPReader, get_UndefInputLength, arginfo_TElPGPReader_get_UndefInputLength, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPReader, set_UndefInputLength, arginfo_TElPGPReader_set_UndefInputLength, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPReader, get_OnArmored, arginfo_TElPGPReader_get_OnArmored, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPReader, set_OnArmored, arginfo_TElPGPReader_set_OnArmored, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPReader, get_OnCompressed, arginfo_TElPGPReader_get_OnCompressed, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPReader, set_OnCompressed, arginfo_TElPGPReader_set_OnCompressed, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPReader, get_OnEncrypted, arginfo_TElPGPReader_get_OnEncrypted, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPReader, set_OnEncrypted, arginfo_TElPGPReader_set_OnEncrypted, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPReader, get_OnCreateOutputStream, arginfo_TElPGPReader_get_OnCreateOutputStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPReader, set_OnCreateOutputStream, arginfo_TElPGPReader_set_OnCreateOutputStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPReader, get_OnRequestOutputFile, arginfo_TElPGPReader_get_OnRequestOutputFile, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPReader, set_OnRequestOutputFile, arginfo_TElPGPReader_set_OnRequestOutputFile, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPReader, get_OnKeyPassphrase, arginfo_TElPGPReader_get_OnKeyPassphrase, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPReader, set_OnKeyPassphrase, arginfo_TElPGPReader_set_OnKeyPassphrase, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPReader, get_OnPassphrase, arginfo_TElPGPReader_get_OnPassphrase, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPReader, set_OnPassphrase, arginfo_TElPGPReader_set_OnPassphrase, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPReader, get_OnProgress, arginfo_TElPGPReader_get_OnProgress, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPReader, set_OnProgress, arginfo_TElPGPReader_set_OnProgress, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPReader, get_OnSigned, arginfo_TElPGPReader_get_OnSigned, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPReader, set_OnSigned, arginfo_TElPGPReader_set_OnSigned, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPReader, get_OnSignatures, arginfo_TElPGPReader_get_OnSignatures, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPReader, set_OnSignatures, arginfo_TElPGPReader_set_OnSignatures, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPReader, get_OnFileExtractionStart, arginfo_TElPGPReader_get_OnFileExtractionStart, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPReader, set_OnFileExtractionStart, arginfo_TElPGPReader_set_OnFileExtractionStart, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPReader, get_OnMultipleFilesFound, arginfo_TElPGPReader_get_OnMultipleFilesFound, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPReader, set_OnMultipleFilesFound, arginfo_TElPGPReader_set_OnMultipleFilesFound, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPReader, get_OnTemporaryStream, arginfo_TElPGPReader_get_OnTemporaryStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPReader, set_OnTemporaryStream, arginfo_TElPGPReader_set_OnTemporaryStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPReader, __construct, arginfo_TElPGPReader___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElPGPReader(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElPGPReader_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElPGPReader", TElPGPReader_methods);
	if (NULL == TComponent_ce_ptr)
		Register_TComponent(TSRMLS_C);
	TElPGPReader_ce_ptr = zend_register_internal_class_ex(&ce, TComponent_ce_ptr, NULL TSRMLS_CC);
}

void Register_SBPGP_Enum_Flags(TSRMLS_D)
{
	zend_class_entry ce;
	INIT_CLASS_ENTRY(ce, "TSBPGPEncryptionType", NULL);
	TSBPGPEncryptionType_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBPGPEncryptionType_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBPGPEncryptionType_ce_ptr, "etPublicKey", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBPGPEncryptionType_ce_ptr, "etPassphrase", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBPGPEncryptionType_ce_ptr, "etBoth", 2)
	
	INIT_CLASS_ENTRY(ce, "TSBPGPProcessingUnitState", NULL);
	TSBPGPProcessingUnitState_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBPGPProcessingUnitState_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBPGPProcessingUnitState_ce_ptr, "usPreSignaturePackets", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBPGPProcessingUnitState_ce_ptr, "usData", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBPGPProcessingUnitState_ce_ptr, "usPostSignaturePackets", 2)
	
	INIT_CLASS_ENTRY(ce, "TSBPGPSignBufferingMethod", NULL);
	TSBPGPSignBufferingMethod_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBPGPSignBufferingMethod_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBPGPSignBufferingMethod_ce_ptr, "sbmTemporaryStream", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBPGPSignBufferingMethod_ce_ptr, "sbmRewind", 1)
	
	INIT_CLASS_ENTRY(ce, "TSBPGPMemoryConsumptionStrategy", NULL);
	TSBPGPMemoryConsumptionStrategy_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBPGPMemoryConsumptionStrategy_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBPGPMemoryConsumptionStrategy_ce_ptr, "mcsDefault", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBPGPMemoryConsumptionStrategy_ce_ptr, "mcsGreedy", 1)
#ifdef SB_WINDOWS
	
	INIT_CLASS_ENTRY(ce, "TSBPGPStubSource", NULL);
	TSBPGPStubSource_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBPGPStubSource_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBPGPStubSource_ce_ptr, "ssStream", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBPGPStubSource_ce_ptr, "ssFile", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBPGPStubSource_ce_ptr, "ssResource", 2)
#endif
}

void Register_SBPGP_Aliases(TSRMLS_D)
{
	if (NULL == TElPGPWriter_ce_ptr)
		Register_TElPGPWriter(TSRMLS_C);
	zend_register_class_alias("ElPGPWriter", TElPGPWriter_ce_ptr);
	if (NULL == TElPGPProcessingUnit_ce_ptr)
		Register_TElPGPProcessingUnit(TSRMLS_C);
	zend_register_class_alias("ElPGPProcessingUnit", TElPGPProcessingUnit_ce_ptr);
	if (NULL == TElPGPReader_ce_ptr)
		Register_TElPGPReader(TSRMLS_C);
	zend_register_class_alias("ElPGPReader", TElPGPReader_ce_ptr);
}
