#include "sbpgpmd.h"

zend_class_entry *TElPGPHashingPool_ce_ptr = NULL;

SB_PHP_METHOD(TElPGPHashingPool, Add)
{
	long l4Algorithm;
	zend_bool bSkipIfExists;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lb", &l4Algorithm, &bSkipIfExists) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPGPHashingPool_Add(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Algorithm, (int8_t)bSkipIfExists, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPHashingPool, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElPGPHashingPool_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPHashingPool, Remove)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		SBCheckError(TElPGPHashingPool_Remove(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPHashingPool, Reset)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElPGPHashingPool_Reset(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPHashingPool, NFinalize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElPGPHashingPool_NFinalize(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPHashingPool, Update)
{
	long l4Count;
	long l4Size;
	SBArrayZValInfo piBuffer;
	zval *oStream;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zpBuffer, &l4Size) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPGPHashingPool_Update(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, (int32_t)l4Size) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!l", &oStream, TStream_ce_ptr, &l4Count) == SUCCESS)
	{
		SBCheckError(TElPGPHashingPool_Update_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC), (int32_t)l4Count) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer) or (TStream, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPHashingPool, GetContextByAlgorithm)
{
	long l4Algorithm;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Algorithm) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPGPHashingPool_GetContextByAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Algorithm, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPHashingPool, get_HashFunctions)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPGPHashingPool_get_HashFunctions(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElHashFunction_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPHashingPool, get_Count)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPGPHashingPool_get_Count(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPHashingPool, get_DataIsText)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPGPHashingPool_get_DataIsText(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPHashingPool, set_DataIsText)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElPGPHashingPool_set_DataIsText(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPHashingPool, get_CompMode)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPGPHashingPool_get_CompMode(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPHashingPool, set_CompMode)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElPGPHashingPool_set_CompMode(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPHashingPool, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPGPHashingPool_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPHashingPool_Add, 0, 0, 2)
	ZEND_ARG_INFO(0, Algorithm)
	ZEND_ARG_INFO(0, SkipIfExists)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPHashingPool_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPHashingPool_Remove, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPHashingPool_Reset, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPHashingPool_NFinalize, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPHashingPool_Update, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Buffer_or_Stream, 0, 1)
	ZEND_ARG_INFO(0, Size_or_Count)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPHashingPool_GetContextByAlgorithm, 0, 0, 1)
	ZEND_ARG_INFO(0, Algorithm)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPHashingPool_get_HashFunctions, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPHashingPool_get_Count, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPHashingPool_get_DataIsText, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPHashingPool_set_DataIsText, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPHashingPool_get_CompMode, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPHashingPool_set_CompMode, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPHashingPool___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElPGPHashingPool_methods[] = {
	PHP_ME(TElPGPHashingPool, Add, arginfo_TElPGPHashingPool_Add, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPHashingPool, Clear, arginfo_TElPGPHashingPool_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPHashingPool, Remove, arginfo_TElPGPHashingPool_Remove, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPHashingPool, Reset, arginfo_TElPGPHashingPool_Reset, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPHashingPool, NFinalize, arginfo_TElPGPHashingPool_NFinalize, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPHashingPool, Update, arginfo_TElPGPHashingPool_Update, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPHashingPool, GetContextByAlgorithm, arginfo_TElPGPHashingPool_GetContextByAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPHashingPool, get_HashFunctions, arginfo_TElPGPHashingPool_get_HashFunctions, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPHashingPool, get_Count, arginfo_TElPGPHashingPool_get_Count, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPHashingPool, get_DataIsText, arginfo_TElPGPHashingPool_get_DataIsText, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPHashingPool, set_DataIsText, arginfo_TElPGPHashingPool_set_DataIsText, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPHashingPool, get_CompMode, arginfo_TElPGPHashingPool_get_CompMode, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPHashingPool, set_CompMode, arginfo_TElPGPHashingPool_set_CompMode, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPHashingPool, __construct, arginfo_TElPGPHashingPool___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElPGPHashingPool(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElPGPHashingPool_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElPGPHashingPool", TElPGPHashingPool_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElPGPHashingPool_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_FUNCTION(SBPGPMD, MDGetDigestSize)
{
	long l4Algorithm;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Algorithm) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(SBPGPMD_MDGetDigestSize((int32_t)l4Algorithm, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBPGPMD, MDInitialize)
{
	long l4Algorithm;
	TElClassHandle hoHashFunction;
	zval *oHashFunction;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "Ol", &oHashFunction, TElHashFunction_ce_ptr, &l4Algorithm) == SUCCESS) && PZVAL_IS_REF(oHashFunction) && (IS_OBJECT == Z_TYPE_P(oHashFunction)))
	{
		hoHashFunction = SBGetObjectHandle(oHashFunction TSRMLS_CC);
		SBCheckError(SBPGPMD_MDInitialize(&hoHashFunction, (int32_t)l4Algorithm) TSRMLS_CC);
		SBUpdateObjectHandle(oHashFunction, hoHashFunction TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(&TElHashFunction, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBPGPMD, MDHash)
{
	long l4Algorithm;
	long l4Size;
	SBArrayZValInfo aiData;
	uint32_t _err;
	zval *zaData;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lzl", &l4Algorithm, &zaData, &l4Size) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaData)) || (IS_ARRAY == Z_TYPE_P(zaData)) || (IS_NULL == Z_TYPE_P(zaData))))
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		if (!SBGetByteArrayFromZVal(zaData, &aiData TSRMLS_CC)) RETURN_FALSE;
		_err = SBPGPMD_MDHash((int32_t)l4Algorithm, aiData.data, aiData.len, (int32_t)l4Size, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(1177040499, 3, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiData);
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(integer, array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBPGPMD, MDFinalize)
{
	TElClassHandle hoHashFunction;
	uint32_t _err;
	zval *oHashFunction;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &oHashFunction, TElHashFunction_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oHashFunction) && (IS_OBJECT == Z_TYPE_P(oHashFunction)))
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		hoHashFunction = SBGetObjectHandle(oHashFunction TSRMLS_CC);
		_err = SBPGPMD_MDFinalize(&hoHashFunction, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-982378395, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBUpdateObjectHandle(oHashFunction, hoHashFunction TSRMLS_CC);
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(&TElHashFunction)" TSRMLS_CC);
	}
}

