#include "sbpkcs8.h"

zend_class_entry *TElPKCS8EncryptedPrivateKeyInfo_ce_ptr = NULL;

SB_PHP_METHOD(TElPKCS8EncryptedPrivateKeyInfo, LoadFromBuffer)
{
	long l4Size;
	SBArrayZValInfo piBuffer;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zpBuffer, &l4Size) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPKCS8EncryptedPrivateKeyInfo_LoadFromBuffer(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, (int32_t)l4Size, &l4OutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS8EncryptedPrivateKeyInfo, SaveToBuffer)
{
	int32_t l4SizeRaw;
	SBArrayZValInfo piBuffer;
	zval *zl4Size;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zz", &zpBuffer, &zl4Size) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4Size) && (IS_LONG == Z_TYPE_P(zl4Size)))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		l4SizeRaw = (int32_t)Z_LVAL_P(zl4Size);
		SBCheckError(TElPKCS8EncryptedPrivateKeyInfo_SaveToBuffer(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, &l4SizeRaw, &bOutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
		ZVAL_LONG(zl4Size, (long)l4SizeRaw);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, &integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS8EncryptedPrivateKeyInfo, LoadFromStream)
{
	long l4Count;
	zval *oStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!l", &oStream, TStream_ce_ptr, &l4Count) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPKCS8EncryptedPrivateKeyInfo_LoadFromStream(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC), (int32_t)l4Count, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TStream, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS8EncryptedPrivateKeyInfo, SaveToStream)
{
	zval *oStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oStream, TStream_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPKCS8EncryptedPrivateKeyInfo_SaveToStream(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TStream)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS8EncryptedPrivateKeyInfo, LoadFromTag)
{
	zval *oTag;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oTag, TElASN1ConstrainedTag_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPKCS8EncryptedPrivateKeyInfo_LoadFromTag(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oTag TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElASN1ConstrainedTag)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS8EncryptedPrivateKeyInfo, SaveToTag)
{
	zval *oTag;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oTag, TElASN1ConstrainedTag_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPKCS8EncryptedPrivateKeyInfo_SaveToTag(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oTag TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElASN1ConstrainedTag)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS8EncryptedPrivateKeyInfo, get_EncryptionAlgorithm)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElPKCS8EncryptedPrivateKeyInfo_get_EncryptionAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(2063076675, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS8EncryptedPrivateKeyInfo, set_EncryptionAlgorithm)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPKCS8EncryptedPrivateKeyInfo_set_EncryptionAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS8EncryptedPrivateKeyInfo, get_EncryptionAlgorithmParams)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElPKCS8EncryptedPrivateKeyInfo_get_EncryptionAlgorithmParams(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(1380500955, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS8EncryptedPrivateKeyInfo, set_EncryptionAlgorithmParams)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPKCS8EncryptedPrivateKeyInfo_set_EncryptionAlgorithmParams(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS8EncryptedPrivateKeyInfo, get_EncryptedData)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElPKCS8EncryptedPrivateKeyInfo_get_EncryptedData(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-1166194524, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS8EncryptedPrivateKeyInfo, set_EncryptedData)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPKCS8EncryptedPrivateKeyInfo_set_EncryptedData(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS8EncryptedPrivateKeyInfo, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPKCS8EncryptedPrivateKeyInfo_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS8EncryptedPrivateKeyInfo_LoadFromBuffer, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(0, Size)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS8EncryptedPrivateKeyInfo_SaveToBuffer, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(1, Size)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS8EncryptedPrivateKeyInfo_LoadFromStream, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, Stream, TStream, 1)
	ZEND_ARG_INFO(0, Count)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS8EncryptedPrivateKeyInfo_SaveToStream, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Stream, TStream, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS8EncryptedPrivateKeyInfo_LoadFromTag, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Tag, TElASN1ConstrainedTag, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS8EncryptedPrivateKeyInfo_SaveToTag, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Tag, TElASN1ConstrainedTag, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS8EncryptedPrivateKeyInfo_get_EncryptionAlgorithm, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS8EncryptedPrivateKeyInfo_set_EncryptionAlgorithm, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS8EncryptedPrivateKeyInfo_get_EncryptionAlgorithmParams, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS8EncryptedPrivateKeyInfo_set_EncryptionAlgorithmParams, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS8EncryptedPrivateKeyInfo_get_EncryptedData, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS8EncryptedPrivateKeyInfo_set_EncryptedData, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS8EncryptedPrivateKeyInfo___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElPKCS8EncryptedPrivateKeyInfo_methods[] = {
	PHP_ME(TElPKCS8EncryptedPrivateKeyInfo, LoadFromBuffer, arginfo_TElPKCS8EncryptedPrivateKeyInfo_LoadFromBuffer, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS8EncryptedPrivateKeyInfo, SaveToBuffer, arginfo_TElPKCS8EncryptedPrivateKeyInfo_SaveToBuffer, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS8EncryptedPrivateKeyInfo, LoadFromStream, arginfo_TElPKCS8EncryptedPrivateKeyInfo_LoadFromStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS8EncryptedPrivateKeyInfo, SaveToStream, arginfo_TElPKCS8EncryptedPrivateKeyInfo_SaveToStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS8EncryptedPrivateKeyInfo, LoadFromTag, arginfo_TElPKCS8EncryptedPrivateKeyInfo_LoadFromTag, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS8EncryptedPrivateKeyInfo, SaveToTag, arginfo_TElPKCS8EncryptedPrivateKeyInfo_SaveToTag, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS8EncryptedPrivateKeyInfo, get_EncryptionAlgorithm, arginfo_TElPKCS8EncryptedPrivateKeyInfo_get_EncryptionAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS8EncryptedPrivateKeyInfo, set_EncryptionAlgorithm, arginfo_TElPKCS8EncryptedPrivateKeyInfo_set_EncryptionAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS8EncryptedPrivateKeyInfo, get_EncryptionAlgorithmParams, arginfo_TElPKCS8EncryptedPrivateKeyInfo_get_EncryptionAlgorithmParams, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS8EncryptedPrivateKeyInfo, set_EncryptionAlgorithmParams, arginfo_TElPKCS8EncryptedPrivateKeyInfo_set_EncryptionAlgorithmParams, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS8EncryptedPrivateKeyInfo, get_EncryptedData, arginfo_TElPKCS8EncryptedPrivateKeyInfo_get_EncryptedData, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS8EncryptedPrivateKeyInfo, set_EncryptedData, arginfo_TElPKCS8EncryptedPrivateKeyInfo_set_EncryptedData, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS8EncryptedPrivateKeyInfo, __construct, arginfo_TElPKCS8EncryptedPrivateKeyInfo___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElPKCS8EncryptedPrivateKeyInfo(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElPKCS8EncryptedPrivateKeyInfo_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElPKCS8EncryptedPrivateKeyInfo", TElPKCS8EncryptedPrivateKeyInfo_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElPKCS8EncryptedPrivateKeyInfo_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElPKCS8PrivateKeyInfo_ce_ptr = NULL;

SB_PHP_METHOD(TElPKCS8PrivateKeyInfo, LoadFromBuffer)
{
	long l4Size;
	SBArrayZValInfo piBuffer;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zpBuffer, &l4Size) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPKCS8PrivateKeyInfo_LoadFromBuffer(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, (int32_t)l4Size, &l4OutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS8PrivateKeyInfo, SaveToBuffer)
{
	int32_t l4SizeRaw;
	SBArrayZValInfo piBuffer;
	zval *zl4Size;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zz", &zpBuffer, &zl4Size) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4Size) && (IS_LONG == Z_TYPE_P(zl4Size)))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		l4SizeRaw = (int32_t)Z_LVAL_P(zl4Size);
		SBCheckError(TElPKCS8PrivateKeyInfo_SaveToBuffer(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, &l4SizeRaw, &bOutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
		ZVAL_LONG(zl4Size, (long)l4SizeRaw);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, &integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS8PrivateKeyInfo, LoadFromStream)
{
	long l4Count;
	zval *oStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!l", &oStream, TStream_ce_ptr, &l4Count) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPKCS8PrivateKeyInfo_LoadFromStream(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC), (int32_t)l4Count, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TStream, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS8PrivateKeyInfo, SaveToStream)
{
	zval *oStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oStream, TStream_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPKCS8PrivateKeyInfo_SaveToStream(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TStream)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS8PrivateKeyInfo, get_PrivateKeyAlgorithm)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElPKCS8PrivateKeyInfo_get_PrivateKeyAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-537502024, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS8PrivateKeyInfo, set_PrivateKeyAlgorithm)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPKCS8PrivateKeyInfo_set_PrivateKeyAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS8PrivateKeyInfo, get_PrivateKeyAlgorithmParams)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElPKCS8PrivateKeyInfo_get_PrivateKeyAlgorithmParams(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(1841459618, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS8PrivateKeyInfo, set_PrivateKeyAlgorithmParams)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPKCS8PrivateKeyInfo_set_PrivateKeyAlgorithmParams(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS8PrivateKeyInfo, get_PrivateKey)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElPKCS8PrivateKeyInfo_get_PrivateKey(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(441459426, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS8PrivateKeyInfo, set_PrivateKey)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPKCS8PrivateKeyInfo_set_PrivateKey(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS8PrivateKeyInfo, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPKCS8PrivateKeyInfo_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS8PrivateKeyInfo_LoadFromBuffer, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(0, Size)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS8PrivateKeyInfo_SaveToBuffer, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(1, Size)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS8PrivateKeyInfo_LoadFromStream, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, Stream, TStream, 1)
	ZEND_ARG_INFO(0, Count)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS8PrivateKeyInfo_SaveToStream, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Stream, TStream, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS8PrivateKeyInfo_get_PrivateKeyAlgorithm, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS8PrivateKeyInfo_set_PrivateKeyAlgorithm, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS8PrivateKeyInfo_get_PrivateKeyAlgorithmParams, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS8PrivateKeyInfo_set_PrivateKeyAlgorithmParams, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS8PrivateKeyInfo_get_PrivateKey, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS8PrivateKeyInfo_set_PrivateKey, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS8PrivateKeyInfo___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElPKCS8PrivateKeyInfo_methods[] = {
	PHP_ME(TElPKCS8PrivateKeyInfo, LoadFromBuffer, arginfo_TElPKCS8PrivateKeyInfo_LoadFromBuffer, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS8PrivateKeyInfo, SaveToBuffer, arginfo_TElPKCS8PrivateKeyInfo_SaveToBuffer, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS8PrivateKeyInfo, LoadFromStream, arginfo_TElPKCS8PrivateKeyInfo_LoadFromStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS8PrivateKeyInfo, SaveToStream, arginfo_TElPKCS8PrivateKeyInfo_SaveToStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS8PrivateKeyInfo, get_PrivateKeyAlgorithm, arginfo_TElPKCS8PrivateKeyInfo_get_PrivateKeyAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS8PrivateKeyInfo, set_PrivateKeyAlgorithm, arginfo_TElPKCS8PrivateKeyInfo_set_PrivateKeyAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS8PrivateKeyInfo, get_PrivateKeyAlgorithmParams, arginfo_TElPKCS8PrivateKeyInfo_get_PrivateKeyAlgorithmParams, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS8PrivateKeyInfo, set_PrivateKeyAlgorithmParams, arginfo_TElPKCS8PrivateKeyInfo_set_PrivateKeyAlgorithmParams, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS8PrivateKeyInfo, get_PrivateKey, arginfo_TElPKCS8PrivateKeyInfo_get_PrivateKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS8PrivateKeyInfo, set_PrivateKey, arginfo_TElPKCS8PrivateKeyInfo_set_PrivateKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS8PrivateKeyInfo, __construct, arginfo_TElPKCS8PrivateKeyInfo___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElPKCS8PrivateKeyInfo(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElPKCS8PrivateKeyInfo_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElPKCS8PrivateKeyInfo", TElPKCS8PrivateKeyInfo_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElPKCS8PrivateKeyInfo_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElPKCS8PrivateKey_ce_ptr = NULL;

SB_PHP_METHOD(TElPKCS8PrivateKey, LoadFromBuffer)
{
	char *sPassphrase;
	int sPassphrase_len;
	long l4Size;
	SBArrayZValInfo piBuffer;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zls", &zpBuffer, &l4Size, &sPassphrase, &sPassphrase_len) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPKCS8PrivateKey_LoadFromBuffer(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, (int32_t)l4Size, sPassphrase, (int32_t)sPassphrase_len, &l4OutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS8PrivateKey, SaveToBuffer)
{
	char *sPassphrase;
	int sPassphrase_len;
	int32_t l4SizeRaw;
	SBArrayZValInfo piBuffer;
	zend_bool bUsePEMEnvelope;
	zval *zl4Size;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zzsb", &zpBuffer, &zl4Size, &sPassphrase, &sPassphrase_len, &bUsePEMEnvelope) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4Size) && (IS_LONG == Z_TYPE_P(zl4Size)))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		l4SizeRaw = (int32_t)Z_LVAL_P(zl4Size);
		SBCheckError(TElPKCS8PrivateKey_SaveToBuffer(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, &l4SizeRaw, sPassphrase, (int32_t)sPassphrase_len, (int8_t)bUsePEMEnvelope, &l4OutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
		ZVAL_LONG(zl4Size, (long)l4SizeRaw);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, &integer, string, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS8PrivateKey, LoadFromStream)
{
	char *sPassphrase;
	int sPassphrase_len;
	long l4Count;
	zval *oStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!sl", &oStream, TStream_ce_ptr, &sPassphrase, &sPassphrase_len, &l4Count) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPKCS8PrivateKey_LoadFromStream(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC), sPassphrase, (int32_t)sPassphrase_len, (int32_t)l4Count, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TStream, string, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS8PrivateKey, SaveToStream)
{
	char *sPassphrase;
	int sPassphrase_len;
	zend_bool bUsePEMEnvelope;
	zval *oStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!sb", &oStream, TStream_ce_ptr, &sPassphrase, &sPassphrase_len, &bUsePEMEnvelope) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPKCS8PrivateKey_SaveToStream(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC), sPassphrase, (int32_t)sPassphrase_len, (int8_t)bUsePEMEnvelope, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TStream, string, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS8PrivateKey, get_SymmetricAlgorithm)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPKCS8PrivateKey_get_SymmetricAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS8PrivateKey, set_SymmetricAlgorithm)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElPKCS8PrivateKey_set_SymmetricAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS8PrivateKey, get_UseNewFeatures)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPKCS8PrivateKey_get_UseNewFeatures(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS8PrivateKey, set_UseNewFeatures)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElPKCS8PrivateKey_set_UseNewFeatures(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS8PrivateKey, get_KeyMaterial)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElPKCS8PrivateKey_get_KeyMaterial(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-335117098, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS8PrivateKey, set_KeyMaterial)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPKCS8PrivateKey_set_KeyMaterial(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS8PrivateKey, get_KeyAlgorithm)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElPKCS8PrivateKey_get_KeyAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-1472033809, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS8PrivateKey, set_KeyAlgorithm)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPKCS8PrivateKey_set_KeyAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS8PrivateKey, get_KeyAlgorithmParams)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElPKCS8PrivateKey_get_KeyAlgorithmParams(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-17686820, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS8PrivateKey, set_KeyAlgorithmParams)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPKCS8PrivateKey_set_KeyAlgorithmParams(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS8PrivateKey, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPKCS8PrivateKey_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS8PrivateKey_LoadFromBuffer, 0, 0, 3)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(0, Size)
	ZEND_ARG_INFO(0, Passphrase)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS8PrivateKey_SaveToBuffer, 0, 0, 4)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(1, Size)
	ZEND_ARG_INFO(0, Passphrase)
	ZEND_ARG_INFO(0, UsePEMEnvelope)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS8PrivateKey_LoadFromStream, 0, 0, 3)
	ZEND_ARG_OBJ_INFO(0, Stream, TStream, 1)
	ZEND_ARG_INFO(0, Passphrase)
	ZEND_ARG_INFO(0, Count)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS8PrivateKey_SaveToStream, 0, 0, 3)
	ZEND_ARG_OBJ_INFO(0, Stream, TStream, 1)
	ZEND_ARG_INFO(0, Passphrase)
	ZEND_ARG_INFO(0, UsePEMEnvelope)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS8PrivateKey_get_SymmetricAlgorithm, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS8PrivateKey_set_SymmetricAlgorithm, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS8PrivateKey_get_UseNewFeatures, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS8PrivateKey_set_UseNewFeatures, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS8PrivateKey_get_KeyMaterial, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS8PrivateKey_set_KeyMaterial, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS8PrivateKey_get_KeyAlgorithm, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS8PrivateKey_set_KeyAlgorithm, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS8PrivateKey_get_KeyAlgorithmParams, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS8PrivateKey_set_KeyAlgorithmParams, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS8PrivateKey___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElPKCS8PrivateKey_methods[] = {
	PHP_ME(TElPKCS8PrivateKey, LoadFromBuffer, arginfo_TElPKCS8PrivateKey_LoadFromBuffer, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS8PrivateKey, SaveToBuffer, arginfo_TElPKCS8PrivateKey_SaveToBuffer, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS8PrivateKey, LoadFromStream, arginfo_TElPKCS8PrivateKey_LoadFromStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS8PrivateKey, SaveToStream, arginfo_TElPKCS8PrivateKey_SaveToStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS8PrivateKey, get_SymmetricAlgorithm, arginfo_TElPKCS8PrivateKey_get_SymmetricAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS8PrivateKey, set_SymmetricAlgorithm, arginfo_TElPKCS8PrivateKey_set_SymmetricAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS8PrivateKey, get_UseNewFeatures, arginfo_TElPKCS8PrivateKey_get_UseNewFeatures, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS8PrivateKey, set_UseNewFeatures, arginfo_TElPKCS8PrivateKey_set_UseNewFeatures, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS8PrivateKey, get_KeyMaterial, arginfo_TElPKCS8PrivateKey_get_KeyMaterial, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS8PrivateKey, set_KeyMaterial, arginfo_TElPKCS8PrivateKey_set_KeyMaterial, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS8PrivateKey, get_KeyAlgorithm, arginfo_TElPKCS8PrivateKey_get_KeyAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS8PrivateKey, set_KeyAlgorithm, arginfo_TElPKCS8PrivateKey_set_KeyAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS8PrivateKey, get_KeyAlgorithmParams, arginfo_TElPKCS8PrivateKey_get_KeyAlgorithmParams, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS8PrivateKey, set_KeyAlgorithmParams, arginfo_TElPKCS8PrivateKey_set_KeyAlgorithmParams, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS8PrivateKey, __construct, arginfo_TElPKCS8PrivateKey___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElPKCS8PrivateKey(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElPKCS8PrivateKey_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElPKCS8PrivateKey", TElPKCS8PrivateKey_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElPKCS8PrivateKey_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_FUNCTION(SBPKCS8, RaisePKCS8Error)
{
	long l4ErrorCode;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4ErrorCode) == SUCCESS)
	{
		SBCheckError(SBPKCS8_RaisePKCS8Error((int32_t)l4ErrorCode) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

void Register_SBPKCS8_Constants(int module_number TSRMLS_DC)
{
	SB_REGISTER_LONG_CONSTANT(SBPKCS8, ERROR_FACILITY_PKCS8, SB_ERROR_FACILITY_PKCS8, SB_ERROR_FACILITY_PKCS8);
	SB_REGISTER_LONG_CONSTANT(SBPKCS8, SB_PKCS8_ERROR_OK, SB_PKCS8_ERROR_OK, SB_PKCS8_ERROR_OK);
	SB_REGISTER_LONG_CONSTANT(SBPKCS8, SB_PKCS8_ERROR_INVALID_ASN_DATA, SB_PKCS8_ERROR_INVALID_ASN_DATA, SB_PKCS8_ERROR_INVALID_ASN_DATA);
	SB_REGISTER_LONG_CONSTANT(SBPKCS8, SB_PKCS8_ERROR_INVALID_FORMAT, SB_PKCS8_ERROR_INVALID_FORMAT, SB_PKCS8_ERROR_INVALID_FORMAT);
	SB_REGISTER_LONG_CONSTANT(SBPKCS8, SB_PKCS8_ERROR_UNSUPPORTED_ALGORITHM, SB_PKCS8_ERROR_UNSUPPORTED_ALGORITHM, SB_PKCS8_ERROR_UNSUPPORTED_ALGORITHM);
	SB_REGISTER_LONG_CONSTANT(SBPKCS8, SB_PKCS8_ERROR_INVALID_PASSWORD, SB_PKCS8_ERROR_INVALID_PASSWORD, SB_PKCS8_ERROR_INVALID_PASSWORD);
	SB_REGISTER_LONG_CONSTANT(SBPKCS8, SB_PKCS8_ERROR_INVALID_VERSION, SB_PKCS8_ERROR_INVALID_VERSION, SB_PKCS8_ERROR_INVALID_VERSION);
	SB_REGISTER_LONG_CONSTANT(SBPKCS8, SB_PKCS8_ERROR_INVALID_PARAMETER, SB_PKCS8_ERROR_INVALID_PARAMETER, SB_PKCS8_ERROR_INVALID_PARAMETER);
	SB_REGISTER_LONG_CONSTANT(SBPKCS8, SB_PKCS8_ERROR_UNKNOWN, SB_PKCS8_ERROR_UNKNOWN, SB_PKCS8_ERROR_UNKNOWN);
	SB_REGISTER_LONG_CONSTANT(SBPKCS8, SB_PKCS8_ERROR_BUFFER_TOO_SMALL, SB_PKCS8_ERROR_BUFFER_TOO_SMALL, SB_PKCS8_ERROR_BUFFER_TOO_SMALL);
	SB_REGISTER_LONG_CONSTANT(SBPKCS8, SB_PKCS8_ERROR_NO_PRIVATE_KEY, SB_PKCS8_ERROR_NO_PRIVATE_KEY, SB_PKCS8_ERROR_NO_PRIVATE_KEY);
}

