#include "sbrandom.h"

zend_class_entry *TElRandom_ce_ptr = NULL;

SB_PHP_METHOD(TElRandom, Randomize)
{
	long l4Count;
	SBArrayZValInfo aiSeed;
	SBArrayZValInfo piBuffer;
#ifdef SB_WINDOWS
	zval *oStream;
#endif
	zval *zaSeed;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaSeed) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaSeed)) || (IS_ARRAY == Z_TYPE_P(zaSeed)) || (IS_NULL == Z_TYPE_P(zaSeed))))
	{
		if (!SBGetByteArrayFromZVal(zaSeed, &aiSeed TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElRandom_Randomize(SBGetObjectHandle(getThis() TSRMLS_CC), aiSeed.data, aiSeed.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiSeed);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!l", &oStream, TStream_ce_ptr, &l4Count) == SUCCESS)
	{
		SBCheckError(TElRandom_Randomize_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC), (int32_t)l4Count) TSRMLS_CC);
	}
#endif
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zpBuffer, &l4Count) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
#ifdef SB_WINDOWS
		SBCheckError(TElRandom_Randomize_2(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, (int32_t)l4Count) TSRMLS_CC);
#else
		SBCheckError(TElRandom_Randomize_1(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, (int32_t)l4Count) TSRMLS_CC);
#endif
		SBFreePointerZValInfo(&piBuffer);
	}
	else
	{
#ifdef SB_WINDOWS
		SBErrorExpectsArguments("(array of byte|string|NULL) or (TStream, integer) or (TSBPointer|array of byte|string|NULL, integer)" TSRMLS_CC);
#else
		SBErrorExpectsArguments("(array of byte|string|NULL) or (TSBPointer|array of byte|string|NULL, integer)" TSRMLS_CC);
#endif
	}
}

SB_PHP_METHOD(TElRandom, Generate)
{
	long l4Count;
	SBArrayZValInfo piBuffer;
	uint32_t _err;
#ifdef SB_WINDOWS
	zval *oStream;
#endif
	zval *zpBuffer;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Count) == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElRandom_Generate(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Count, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-457773418, 2, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zpBuffer, &l4Count) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElRandom_Generate_1(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, (int32_t)l4Count) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!l", &oStream, TStream_ce_ptr, &l4Count) == SUCCESS)
	{
		SBCheckError(TElRandom_Generate_2(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC), (int32_t)l4Count) TSRMLS_CC);
	}
#endif
	else
	{
#ifdef SB_WINDOWS
		SBErrorExpectsArguments("(integer) or (TSBPointer|array of byte|string|NULL, integer) or (TStream, integer)" TSRMLS_CC);
#else
		SBErrorExpectsArguments("(integer) or (TSBPointer|array of byte|string|NULL, integer)" TSRMLS_CC);
#endif
	}
}

SB_PHP_METHOD(TElRandom, Seed)
{
	long l4Count;
	SBArrayZValInfo piBuffer;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zpBuffer, &l4Count) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElRandom_Seed(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, (int32_t)l4Count) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRandom, __construct)
{
	long u4TimeSeed;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElRandom_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u4TimeSeed) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElRandom_Create_1((uint32_t)u4TimeSeed, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("() or (integer)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRandom_Randomize, 0, 0, 1)
#ifdef SB_WINDOWS
	ZEND_ARG_TYPE_INFO(0, Seed_or_Stream_or_Buffer, 0, 1)
#else
	ZEND_ARG_TYPE_INFO(0, Seed_or_Buffer, 0, 1)
#endif
	ZEND_ARG_INFO(0, Count)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRandom_Generate, 0, 0, 1)
#ifdef SB_WINDOWS
	ZEND_ARG_TYPE_INFO(0, Count_or_Buffer_or_Stream, 0, 1)
#else
	ZEND_ARG_TYPE_INFO(0, Count_or_Buffer, 0, 1)
#endif
	ZEND_ARG_INFO(0, Count)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRandom_Seed, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(0, Count)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRandom___construct, 0, 0, 0)
	ZEND_ARG_INFO(0, TimeSeed)
ZEND_END_ARG_INFO()

static zend_function_entry TElRandom_methods[] = {
	PHP_ME(TElRandom, Randomize, arginfo_TElRandom_Randomize, ZEND_ACC_PUBLIC)
	PHP_ME(TElRandom, Generate, arginfo_TElRandom_Generate, ZEND_ACC_PUBLIC)
	PHP_ME(TElRandom, Seed, arginfo_TElRandom_Seed, ZEND_ACC_PUBLIC)
	PHP_ME(TElRandom, __construct, arginfo_TElRandom___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElRandom(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElRandom_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElRandom", TElRandom_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElRandom_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_FUNCTION(SBRandom, SBRndTimeSeed)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(SBRandom_SBRndTimeSeed(&l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBRandom, SBRndInit)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(SBRandom_SBRndInit() TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBRandom, SBRndInitOnDemand)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(SBRandom_SBRndInitOnDemand() TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBRandom, SBRndCreate)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(SBRandom_SBRndCreate() TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBRandom, SBRndDestroy)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(SBRandom_SBRndDestroy() TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBRandom, SBRndSeed)
{
	char *sSalt;
	int sSalt_len;
	long l4Size;
	SBArrayZValInfo piBuffer;
	zval *zpBuffer;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sSalt, &sSalt_len) == SUCCESS)
	{
		SBCheckError(SBRandom_SBRndSeed(sSalt, (int32_t)sSalt_len) TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zpBuffer, &l4Size) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBRandom_SBRndSeed_1(piBuffer.data, (int32_t)l4Size) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
	}
	else
	{
		SBErrorExpectsArguments("(string) or (TSBPointer|array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBRandom, SBRndSeedTime)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(SBRandom_SBRndSeedTime() TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBRandom, SBRndGenerate)
{
	long l4Size;
	long u4UpperBound;
	SBArrayZValInfo piBuffer;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zpBuffer, &l4Size) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBRandom_SBRndGenerate(piBuffer.data, (int32_t)l4Size) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u4UpperBound) == SUCCESS)
	{
		uint32_t u4OutResultRaw = 0;
		SBCheckError(SBRandom_SBRndGenerate_1((uint32_t)u4UpperBound, &u4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer) or (integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBRandom, SBRndGenerateLInt)
{
	long l4Bytes;
	zval *oA;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!l", &oA, TLInt_ce_ptr, &l4Bytes) == SUCCESS)
	{
		SBCheckError(SBRandom_SBRndGenerateLInt((TLInt *)SBGetStructPointer(oA TSRMLS_CC), (int32_t)l4Bytes) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TLInt, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBRandom, SBRndRandomize)
{
	SBArrayZValInfo aiSeed;
	zval *zaSeed;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaSeed) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaSeed)) || (IS_ARRAY == Z_TYPE_P(zaSeed)) || (IS_NULL == Z_TYPE_P(zaSeed))))
	{
		if (!SBGetByteArrayFromZVal(zaSeed, &aiSeed TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBRandom_SBRndRandomize(aiSeed.data, aiSeed.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiSeed);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBRandom, SBRndString)
{
	char *sAlphabet;
	int sAlphabet_len;
	long l4Len;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Len) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBRandom_SBRndString((int32_t)l4Len, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-416397672, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ls", &l4Len, &sAlphabet, &sAlphabet_len) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBRandom_SBRndString_1((int32_t)l4Len, sAlphabet, (int32_t)sAlphabet_len, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1429144796, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(integer) or (integer, string)" TSRMLS_CC);
	}
}

void Register_SBRandom_Aliases(TSRMLS_D)
{
	if (NULL == TElRandom_ce_ptr)
		Register_TElRandom(TSRMLS_C);
	zend_register_class_alias("ElRandom", TElRandom_ce_ptr);
}
