#include "sbsha.h"

SB_PHP_METHOD(TSHA1Context, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(TSHA1Context));
		intern->len = sizeof(TSHA1Context);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(TSHA1Context, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(TSHA1Context));
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBBaseStruct_GetField, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBBaseStruct_SetField, 0, 0, 1)
	ZEND_ARG_INFO(0, value)
ZEND_END_ARG_INFO()

SB_PHP_METHOD(TSHA1Context, get_Size)
{
	SBStuctGetFieldInt64(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(TSHA1Context, set_Size)
{
	SBStuctSetFieldInt64(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(TSHA1Context, get_BufSize)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 392);
}

SB_PHP_METHOD(TSHA1Context, set_BufSize)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 392);
}

SB_PHP_METHOD(TSHA1Context, get_A)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 396);
}

SB_PHP_METHOD(TSHA1Context, set_A)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 396);
}

SB_PHP_METHOD(TSHA1Context, get_B)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 400);
}

SB_PHP_METHOD(TSHA1Context, set_B)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 400);
}

SB_PHP_METHOD(TSHA1Context, get_C)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 404);
}

SB_PHP_METHOD(TSHA1Context, set_C)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 404);
}

SB_PHP_METHOD(TSHA1Context, get_D)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 408);
}

SB_PHP_METHOD(TSHA1Context, set_D)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 408);
}

SB_PHP_METHOD(TSHA1Context, get_E)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 412);
}

SB_PHP_METHOD(TSHA1Context, set_E)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 412);
}

zend_class_entry *TSHA1Context_ce_ptr = NULL;

static zend_function_entry TSHA1Context_methods[] = {
	PHP_ME(TSHA1Context, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(TSHA1Context, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TSHA1Context, get_Size, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSHA1Context, set_Size, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSHA1Context, get_BufSize, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSHA1Context, set_BufSize, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSHA1Context, get_A, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSHA1Context, set_A, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSHA1Context, get_B, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSHA1Context, set_B, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSHA1Context, get_C, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSHA1Context, set_C, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSHA1Context, get_D, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSHA1Context, set_D, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSHA1Context, get_E, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSHA1Context, set_E, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TSHA1Context(TSRMLS_D)
{
	zend_class_entry ce;
	if (TSHA1Context_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "TSHA1Context", TSHA1Context_methods);
	TSHA1Context_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_FUNCTION(SBSHA, InitializeSHA1)
{
	zval *oContext;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &oContext, TSHA1Context_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oContext))
	{
		SBCheckError(SBSHA_InitializeSHA1((TSHA1Context *)SBGetStructPointer(oContext TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(&TSHA1Context)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBSHA, HashSHA1)
{
	long u4Size;
	SBArrayZValInfo aiS;
	SBArrayZValInfo piBuffer;
	SBArrayZValInfo piChunk;
	zval *oContext;
	zval *zaS;
	zval *zpBuffer;
	zval *zpChunk;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaS) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaS)) || (IS_ARRAY == Z_TYPE_P(zaS)) || (IS_NULL == Z_TYPE_P(zaS))))
	{
		TMessageDigest160 roOutResult;
		if (!SBGetByteArrayFromZVal(zaS, &aiS TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBSHA_HashSHA1(aiS.data, aiS.len, &roOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiS);
		object_init_ex(return_value, TMessageDigest160_ce_ptr);
		SBSetStruct(return_value, &roOutResult, sizeof(TMessageDigest160) TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "Ozl", &oContext, TSHA1Context_ce_ptr, &zpChunk, &u4Size) == SUCCESS) && PZVAL_IS_REF(oContext) && ((Z_TYPE_P(zpChunk) == IS_STRING) || (Z_TYPE_P(zpChunk) == IS_ARRAY) || (Z_TYPE_P(zpChunk) == IS_NULL) || ((Z_TYPE_P(zpChunk) == IS_OBJECT) && (Z_OBJCE_P(zpChunk) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpChunk, &piChunk TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBSHA_HashSHA1_1((TSHA1Context *)SBGetStructPointer(oContext TSRMLS_CC), piChunk.data, (uint32_t)u4Size) TSRMLS_CC);
		SBFreePointerZValInfo(&piChunk);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zpBuffer, &u4Size) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		TMessageDigest160 roOutResult;
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBSHA_HashSHA1_2(piBuffer.data, (uint32_t)u4Size, &roOutResult) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
		object_init_ex(return_value, TMessageDigest160_ce_ptr);
		SBSetStruct(return_value, &roOutResult, sizeof(TMessageDigest160) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL) or (&TSHA1Context, TSBPointer|array of byte|string|NULL, integer) or (TSBPointer|array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBSHA, FinalizeSHA1)
{
	zval *oContext;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &oContext, TSHA1Context_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oContext))
	{
		TMessageDigest160 roOutResult;
		SBCheckError(SBSHA_FinalizeSHA1((TSHA1Context *)SBGetStructPointer(oContext TSRMLS_CC), &roOutResult) TSRMLS_CC);
		object_init_ex(return_value, TMessageDigest160_ce_ptr);
		SBSetStruct(return_value, &roOutResult, sizeof(TMessageDigest160) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(&TSHA1Context)" TSRMLS_CC);
	}
}

