#include "sbsshconstants.h"

SB_PHP_FUNCTION(SBSSHConstants, GetSSHPacketNameByCode)
{
	long l4Code;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Code) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBSSHConstants_GetSSHPacketNameByCode((int32_t)l4Code, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-516904072, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

void Register_SBSSHConstants_Constants(int module_number TSRMLS_DC)
{
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, ERROR_SSH_INVALID_IDENTIFICATION_STRING, SB_ERROR_SSH_INVALID_IDENTIFICATION_STRING, SB_ERROR_SSH_INVALID_IDENTIFICATION_STRING);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, ERROR_SSH_INVALID_VERSION, SB_ERROR_SSH_INVALID_VERSION, SB_ERROR_SSH_INVALID_VERSION);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, ERROR_SSH_INVALID_MESSAGE_CODE, SB_ERROR_SSH_INVALID_MESSAGE_CODE, SB_ERROR_SSH_INVALID_MESSAGE_CODE);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, ERROR_SSH_INVALID_CRC, SB_ERROR_SSH_INVALID_CRC, SB_ERROR_SSH_INVALID_CRC);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, ERROR_SSH_INVALID_PACKET_TYPE, SB_ERROR_SSH_INVALID_PACKET_TYPE, SB_ERROR_SSH_INVALID_PACKET_TYPE);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, ERROR_SSH_INVALID_PACKET, SB_ERROR_SSH_INVALID_PACKET, SB_ERROR_SSH_INVALID_PACKET);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, ERROR_SSH_UNSUPPORTED_CIPHER, SB_ERROR_SSH_UNSUPPORTED_CIPHER, SB_ERROR_SSH_UNSUPPORTED_CIPHER);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, ERROR_SSH_UNSUPPORTED_AUTH_TYPE, SB_ERROR_SSH_UNSUPPORTED_AUTH_TYPE, SB_ERROR_SSH_UNSUPPORTED_AUTH_TYPE);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, ERROR_SSH_INVALID_RSA_CHALLENGE, SB_ERROR_SSH_INVALID_RSA_CHALLENGE, SB_ERROR_SSH_INVALID_RSA_CHALLENGE);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, ERROR_SSH_AUTHENTICATION_FAILED, SB_ERROR_SSH_AUTHENTICATION_FAILED, SB_ERROR_SSH_AUTHENTICATION_FAILED);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, ERROR_SSH_INVALID_PACKET_SIZE, SB_ERROR_SSH_INVALID_PACKET_SIZE, SB_ERROR_SSH_INVALID_PACKET_SIZE);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, ERROR_SSH_HOST_NOT_ALLOWED_TO_CONNECT, SB_ERROR_SSH_HOST_NOT_ALLOWED_TO_CONNECT, SB_ERROR_SSH_HOST_NOT_ALLOWED_TO_CONNECT);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, ERROR_SSH_PROTOCOL_ERROR, SB_ERROR_SSH_PROTOCOL_ERROR, SB_ERROR_SSH_PROTOCOL_ERROR);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, ERROR_SSH_KEY_EXCHANGE_FAILED, SB_ERROR_SSH_KEY_EXCHANGE_FAILED, SB_ERROR_SSH_KEY_EXCHANGE_FAILED);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, ERROR_SSH_INVALID_MAC, SB_ERROR_SSH_INVALID_MAC, SB_ERROR_SSH_INVALID_MAC);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, ERROR_SSH_COMPRESSION_ERROR, SB_ERROR_SSH_COMPRESSION_ERROR, SB_ERROR_SSH_COMPRESSION_ERROR);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, ERROR_SSH_SERVICE_NOT_AVAILABLE, SB_ERROR_SSH_SERVICE_NOT_AVAILABLE, SB_ERROR_SSH_SERVICE_NOT_AVAILABLE);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, ERROR_SSH_PROTOCOL_VERSION_NOT_SUPPORTED, SB_ERROR_SSH_PROTOCOL_VERSION_NOT_SUPPORTED, SB_ERROR_SSH_PROTOCOL_VERSION_NOT_SUPPORTED);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, ERROR_SSH_HOST_KEY_NOT_VERIFIABLE, SB_ERROR_SSH_HOST_KEY_NOT_VERIFIABLE, SB_ERROR_SSH_HOST_KEY_NOT_VERIFIABLE);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, ERROR_SSH_CONNECTION_LOST, SB_ERROR_SSH_CONNECTION_LOST, SB_ERROR_SSH_CONNECTION_LOST);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, ERROR_SSH_APPLICATION_CLOSED, SB_ERROR_SSH_APPLICATION_CLOSED, SB_ERROR_SSH_APPLICATION_CLOSED);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, ERROR_SSH_TOO_MANY_CONNECTIONS, SB_ERROR_SSH_TOO_MANY_CONNECTIONS, SB_ERROR_SSH_TOO_MANY_CONNECTIONS);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, ERROR_SSH_AUTH_CANCELLED_BY_USER, SB_ERROR_SSH_AUTH_CANCELLED_BY_USER, SB_ERROR_SSH_AUTH_CANCELLED_BY_USER);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, ERROR_SSH_NO_MORE_AUTH_METHODS_AVAILABLE, SB_ERROR_SSH_NO_MORE_AUTH_METHODS_AVAILABLE, SB_ERROR_SSH_NO_MORE_AUTH_METHODS_AVAILABLE);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, ERROR_SSH_ILLEGAL_USERNAME, SB_ERROR_SSH_ILLEGAL_USERNAME, SB_ERROR_SSH_ILLEGAL_USERNAME);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, ERROR_SSH_INTERNAL_ERROR, SB_ERROR_SSH_INTERNAL_ERROR, SB_ERROR_SSH_INTERNAL_ERROR);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, ERROR_SSH_NOT_CONNECTED, SB_ERROR_SSH_NOT_CONNECTED, SB_ERROR_SSH_NOT_CONNECTED);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, ERROR_SSH_CONNECTION_CANCELLED_BY_USER, SB_ERROR_SSH_CONNECTION_CANCELLED_BY_USER, SB_ERROR_SSH_CONNECTION_CANCELLED_BY_USER);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, ERROR_SSH_FORWARD_DISALLOWED, SB_ERROR_SSH_FORWARD_DISALLOWED, SB_ERROR_SSH_FORWARD_DISALLOWED);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, ERROR_SSH_ONKEYVALIDATE_NOT_ASSIGNED, SB_ERROR_SSH_ONKEYVALIDATE_NOT_ASSIGNED, SB_ERROR_SSH_ONKEYVALIDATE_NOT_ASSIGNED);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, ERROR_SSH_GSSKEX_SERVER_ERROR_MESSAGE, SB_ERROR_SSH_GSSKEX_SERVER_ERROR_MESSAGE, SB_ERROR_SSH_GSSKEX_SERVER_ERROR_MESSAGE);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, ERROR_SSH_GSSAPI_SERVER_ERROR_MESSAGE, SB_ERROR_SSH_GSSAPI_SERVER_ERROR_MESSAGE, SB_ERROR_SSH_GSSAPI_SERVER_ERROR_MESSAGE);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_AUTH_TYPE_RHOSTS, SB_SSH_AUTH_TYPE_RHOSTS, SB_SSH_AUTH_TYPE_RHOSTS);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_AUTH_TYPE_PUBLICKEY, SB_SSH_AUTH_TYPE_PUBLICKEY, SB_SSH_AUTH_TYPE_PUBLICKEY);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_AUTH_TYPE_PASSWORD, SB_SSH_AUTH_TYPE_PASSWORD, SB_SSH_AUTH_TYPE_PASSWORD);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_AUTH_TYPE_HOSTBASED, SB_SSH_AUTH_TYPE_HOSTBASED, SB_SSH_AUTH_TYPE_HOSTBASED);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_AUTH_TYPE_KEYBOARD, SB_SSH_AUTH_TYPE_KEYBOARD, SB_SSH_AUTH_TYPE_KEYBOARD);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_AUTH_TYPE_GSSAPI_WITH_MIC, SB_SSH_AUTH_TYPE_GSSAPI_WITH_MIC, SB_SSH_AUTH_TYPE_GSSAPI_WITH_MIC);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_AUTH_TYPE_GSSAPI_KEYEX, SB_SSH_AUTH_TYPE_GSSAPI_KEYEX, SB_SSH_AUTH_TYPE_GSSAPI_KEYEX);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_AUTH_TYPE_PUBLICKEYAGENT, SB_SSH_AUTH_TYPE_PUBLICKEYAGENT, SB_SSH_AUTH_TYPE_PUBLICKEYAGENT);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_EA_FIRST, SB_SSH_EA_FIRST, SB_SSH_EA_FIRST);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_EA_3DES, SB_SSH_EA_3DES, SB_SSH_EA_3DES);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_EA_BLOWFISH, SB_SSH_EA_BLOWFISH, SB_SSH_EA_BLOWFISH);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_EA_TWOFISH256, SB_SSH_EA_TWOFISH256, SB_SSH_EA_TWOFISH256);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_EA_TWOFISH192, SB_SSH_EA_TWOFISH192, SB_SSH_EA_TWOFISH192);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_EA_TWOFISH128, SB_SSH_EA_TWOFISH128, SB_SSH_EA_TWOFISH128);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_EA_AES256, SB_SSH_EA_AES256, SB_SSH_EA_AES256);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_EA_AES192, SB_SSH_EA_AES192, SB_SSH_EA_AES192);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_EA_AES128, SB_SSH_EA_AES128, SB_SSH_EA_AES128);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_EA_SERPENT256, SB_SSH_EA_SERPENT256, SB_SSH_EA_SERPENT256);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_EA_SERPENT192, SB_SSH_EA_SERPENT192, SB_SSH_EA_SERPENT192);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_EA_SERPENT128, SB_SSH_EA_SERPENT128, SB_SSH_EA_SERPENT128);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_EA_ARCFOUR, SB_SSH_EA_ARCFOUR, SB_SSH_EA_ARCFOUR);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_EA_IDEA, SB_SSH_EA_IDEA, SB_SSH_EA_IDEA);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_EA_CAST128, SB_SSH_EA_CAST128, SB_SSH_EA_CAST128);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_EA_NONE, SB_SSH_EA_NONE, SB_SSH_EA_NONE);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_EA_DES, SB_SSH_EA_DES, SB_SSH_EA_DES);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_EA_AES128_CTR, SB_SSH_EA_AES128_CTR, SB_SSH_EA_AES128_CTR);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_EA_AES192_CTR, SB_SSH_EA_AES192_CTR, SB_SSH_EA_AES192_CTR);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_EA_AES256_CTR, SB_SSH_EA_AES256_CTR, SB_SSH_EA_AES256_CTR);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_EA_3DES_CTR, SB_SSH_EA_3DES_CTR, SB_SSH_EA_3DES_CTR);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_EA_BLOWFISH_CTR, SB_SSH_EA_BLOWFISH_CTR, SB_SSH_EA_BLOWFISH_CTR);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_EA_TWOFISH128_CTR, SB_SSH_EA_TWOFISH128_CTR, SB_SSH_EA_TWOFISH128_CTR);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_EA_TWOFISH192_CTR, SB_SSH_EA_TWOFISH192_CTR, SB_SSH_EA_TWOFISH192_CTR);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_EA_TWOFISH256_CTR, SB_SSH_EA_TWOFISH256_CTR, SB_SSH_EA_TWOFISH256_CTR);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_EA_SERPENT128_CTR, SB_SSH_EA_SERPENT128_CTR, SB_SSH_EA_SERPENT128_CTR);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_EA_SERPENT192_CTR, SB_SSH_EA_SERPENT192_CTR, SB_SSH_EA_SERPENT192_CTR);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_EA_SERPENT256_CTR, SB_SSH_EA_SERPENT256_CTR, SB_SSH_EA_SERPENT256_CTR);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_EA_IDEA_CTR, SB_SSH_EA_IDEA_CTR, SB_SSH_EA_IDEA_CTR);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_EA_CAST128_CTR, SB_SSH_EA_CAST128_CTR, SB_SSH_EA_CAST128_CTR);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_EA_ARCFOUR128, SB_SSH_EA_ARCFOUR128, SB_SSH_EA_ARCFOUR128);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_EA_ARCFOUR256, SB_SSH_EA_ARCFOUR256, SB_SSH_EA_ARCFOUR256);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_EA_AES128_GCM, SB_SSH_EA_AES128_GCM, SB_SSH_EA_AES128_GCM);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_EA_AES256_GCM, SB_SSH_EA_AES256_GCM, SB_SSH_EA_AES256_GCM);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_EA_AES128_GCM_OPENSSH, SB_SSH_EA_AES128_GCM_OPENSSH, SB_SSH_EA_AES128_GCM_OPENSSH);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_EA_AES256_GCM_OPENSSH, SB_SSH_EA_AES256_GCM_OPENSSH, SB_SSH_EA_AES256_GCM_OPENSSH);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_EA_CHACHA20, SB_SSH_EA_CHACHA20, SB_SSH_EA_CHACHA20);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_EA_CHACHA20_OPENSSH, SB_SSH_EA_CHACHA20_OPENSSH, SB_SSH_EA_CHACHA20_OPENSSH);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_EA_LAST, SB_SSH_EA_LAST, SB_SSH_EA_LAST);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_CA_FIRST, SB_SSH_CA_FIRST, SB_SSH_CA_FIRST);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_CA_NONE, SB_SSH_CA_NONE, SB_SSH_CA_NONE);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_CA_ZLIB, SB_SSH_CA_ZLIB, SB_SSH_CA_ZLIB);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_CA_ZLIB_DELAYED, SB_SSH_CA_ZLIB_DELAYED, SB_SSH_CA_ZLIB_DELAYED);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_CA_LAST, SB_SSH_CA_LAST, SB_SSH_CA_LAST);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_MA_FIRST, SB_SSH_MA_FIRST, SB_SSH_MA_FIRST);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_MA_HMAC_SHA1, SB_SSH_MA_HMAC_SHA1, SB_SSH_MA_HMAC_SHA1);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_MA_HMAC_SHA1_96, SB_SSH_MA_HMAC_SHA1_96, SB_SSH_MA_HMAC_SHA1_96);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_MA_HMAC_MD5, SB_SSH_MA_HMAC_MD5, SB_SSH_MA_HMAC_MD5);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_MA_HMAC_MD5_96, SB_SSH_MA_HMAC_MD5_96, SB_SSH_MA_HMAC_MD5_96);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_MA_NONE, SB_SSH_MA_NONE, SB_SSH_MA_NONE);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_MA_HMAC_RIPEMD160, SB_SSH_MA_HMAC_RIPEMD160, SB_SSH_MA_HMAC_RIPEMD160);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_MA_HMAC_RIPEMD, SB_SSH_MA_HMAC_RIPEMD, SB_SSH_MA_HMAC_RIPEMD);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_MA_HMAC_RIPEMD_OPENSSH, SB_SSH_MA_HMAC_RIPEMD_OPENSSH, SB_SSH_MA_HMAC_RIPEMD_OPENSSH);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_MA_HMAC_SHA256, SB_SSH_MA_HMAC_SHA256, SB_SSH_MA_HMAC_SHA256);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_MA_HMAC_SHA256_96, SB_SSH_MA_HMAC_SHA256_96, SB_SSH_MA_HMAC_SHA256_96);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_MA_UMAC32, SB_SSH_MA_UMAC32, SB_SSH_MA_UMAC32);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_MA_UMAC64, SB_SSH_MA_UMAC64, SB_SSH_MA_UMAC64);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_MA_UMAC96, SB_SSH_MA_UMAC96, SB_SSH_MA_UMAC96);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_MA_UMAC128, SB_SSH_MA_UMAC128, SB_SSH_MA_UMAC128);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_MA_HMAC_SHA2_256, SB_SSH_MA_HMAC_SHA2_256, SB_SSH_MA_HMAC_SHA2_256);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_MA_HMAC_SHA2_512, SB_SSH_MA_HMAC_SHA2_512, SB_SSH_MA_HMAC_SHA2_512);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_MA_AES128_GCM, SB_SSH_MA_AES128_GCM, SB_SSH_MA_AES128_GCM);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_MA_AES256_GCM, SB_SSH_MA_AES256_GCM, SB_SSH_MA_AES256_GCM);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_MA_POLY1305, SB_SSH_MA_POLY1305, SB_SSH_MA_POLY1305);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_MA_LAST, SB_SSH_MA_LAST, SB_SSH_MA_LAST);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_EC_FIRST, SB_SSH_EC_FIRST, SB_SSH_EC_FIRST);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_EC_NIST_P256, SB_SSH_EC_NIST_P256, SB_SSH_EC_NIST_P256);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_EC_NIST_P384, SB_SSH_EC_NIST_P384, SB_SSH_EC_NIST_P384);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_EC_NIST_P521, SB_SSH_EC_NIST_P521, SB_SSH_EC_NIST_P521);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_EC_NIST_K163, SB_SSH_EC_NIST_K163, SB_SSH_EC_NIST_K163);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_EC_NIST_P192, SB_SSH_EC_NIST_P192, SB_SSH_EC_NIST_P192);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_EC_NIST_P224, SB_SSH_EC_NIST_P224, SB_SSH_EC_NIST_P224);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_EC_NIST_K233, SB_SSH_EC_NIST_K233, SB_SSH_EC_NIST_K233);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_EC_NIST_B233, SB_SSH_EC_NIST_B233, SB_SSH_EC_NIST_B233);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_EC_NIST_K283, SB_SSH_EC_NIST_K283, SB_SSH_EC_NIST_K283);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_EC_NIST_K409, SB_SSH_EC_NIST_K409, SB_SSH_EC_NIST_K409);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_EC_NIST_B409, SB_SSH_EC_NIST_B409, SB_SSH_EC_NIST_B409);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_EC_NIST_K571, SB_SSH_EC_NIST_K571, SB_SSH_EC_NIST_K571);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_EC_CURVE25519, SB_SSH_EC_CURVE25519, SB_SSH_EC_CURVE25519);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_EC_LAST, SB_SSH_EC_LAST, SB_SSH_EC_LAST);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_KEX_FIRST, SB_SSH_KEX_FIRST, SB_SSH_KEX_FIRST);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_KEX_DH_GROUP, SB_SSH_KEX_DH_GROUP, SB_SSH_KEX_DH_GROUP);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_KEX_DH_GROUP_EXCHANGE, SB_SSH_KEX_DH_GROUP_EXCHANGE, SB_SSH_KEX_DH_GROUP_EXCHANGE);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_KEX_DH_GROUP_14, SB_SSH_KEX_DH_GROUP_14, SB_SSH_KEX_DH_GROUP_14);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_KEX_COMMON_LAST, SB_SSH_KEX_COMMON_LAST, SB_SSH_KEX_COMMON_LAST);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_KEX_DH_GROUP_EXCHANGE256, SB_SSH_KEX_DH_GROUP_EXCHANGE256, SB_SSH_KEX_DH_GROUP_EXCHANGE256);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_KEX_RSA1024_SHA1, SB_SSH_KEX_RSA1024_SHA1, SB_SSH_KEX_RSA1024_SHA1);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_KEX_RSA2048_SHA256, SB_SSH_KEX_RSA2048_SHA256, SB_SSH_KEX_RSA2048_SHA256);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_KEX_ECDH_FIRST, SB_SSH_KEX_ECDH_FIRST, SB_SSH_KEX_ECDH_FIRST);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_KEX_ECDH_NIST_P256, SB_SSH_KEX_ECDH_NIST_P256, SB_SSH_KEX_ECDH_NIST_P256);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_KEX_ECDH_NIST_P384, SB_SSH_KEX_ECDH_NIST_P384, SB_SSH_KEX_ECDH_NIST_P384);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_KEX_ECDH_NIST_P521, SB_SSH_KEX_ECDH_NIST_P521, SB_SSH_KEX_ECDH_NIST_P521);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_KEX_ECDH_NIST_K163, SB_SSH_KEX_ECDH_NIST_K163, SB_SSH_KEX_ECDH_NIST_K163);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_KEX_ECDH_NIST_P192, SB_SSH_KEX_ECDH_NIST_P192, SB_SSH_KEX_ECDH_NIST_P192);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_KEX_ECDH_NIST_P224, SB_SSH_KEX_ECDH_NIST_P224, SB_SSH_KEX_ECDH_NIST_P224);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_KEX_ECDH_NIST_K233, SB_SSH_KEX_ECDH_NIST_K233, SB_SSH_KEX_ECDH_NIST_K233);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_KEX_ECDH_NIST_B233, SB_SSH_KEX_ECDH_NIST_B233, SB_SSH_KEX_ECDH_NIST_B233);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_KEX_ECDH_NIST_K283, SB_SSH_KEX_ECDH_NIST_K283, SB_SSH_KEX_ECDH_NIST_K283);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_KEX_ECDH_NIST_K409, SB_SSH_KEX_ECDH_NIST_K409, SB_SSH_KEX_ECDH_NIST_K409);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_KEX_ECDH_NIST_B409, SB_SSH_KEX_ECDH_NIST_B409, SB_SSH_KEX_ECDH_NIST_B409);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_KEX_ECDH_NIST_K571, SB_SSH_KEX_ECDH_NIST_K571, SB_SSH_KEX_ECDH_NIST_K571);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_KEX_ECDH_CURVE25519, SB_SSH_KEX_ECDH_CURVE25519, SB_SSH_KEX_ECDH_CURVE25519);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_KEX_ECDH_LAST, SB_SSH_KEX_ECDH_LAST, SB_SSH_KEX_ECDH_LAST);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_KEX_CURVE25519, SB_SSH_KEX_CURVE25519, SB_SSH_KEX_CURVE25519);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_KEX_GSS_FIRST, SB_SSH_KEX_GSS_FIRST, SB_SSH_KEX_GSS_FIRST);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_KEX_GSS_GROUP_EXCHANGE, SB_SSH_KEX_GSS_GROUP_EXCHANGE, SB_SSH_KEX_GSS_GROUP_EXCHANGE);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_KEX_GSS_GROUP, SB_SSH_KEX_GSS_GROUP, SB_SSH_KEX_GSS_GROUP);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_KEX_GSS_GROUP_14, SB_SSH_KEX_GSS_GROUP_14, SB_SSH_KEX_GSS_GROUP_14);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_KEX_GSS_LAST, SB_SSH_KEX_GSS_LAST, SB_SSH_KEX_GSS_LAST);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_KEX_LAST, SB_SSH_KEX_LAST, SB_SSH_KEX_LAST);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_PK_FIRST, SB_SSH_PK_FIRST, SB_SSH_PK_FIRST);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_PK_DSS, SB_SSH_PK_DSS, SB_SSH_PK_DSS);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_PK_RSA, SB_SSH_PK_RSA, SB_SSH_PK_RSA);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_PK_X509_SIGN_RSA, SB_SSH_PK_X509_SIGN_RSA, SB_SSH_PK_X509_SIGN_RSA);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_PK_X509_SIGN_DSS, SB_SSH_PK_X509_SIGN_DSS, SB_SSH_PK_X509_SIGN_DSS);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_PK_SPKI_SIGN_RSA, SB_SSH_PK_SPKI_SIGN_RSA, SB_SSH_PK_SPKI_SIGN_RSA);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_PK_SPKI_SIGN_DSS, SB_SSH_PK_SPKI_SIGN_DSS, SB_SSH_PK_SPKI_SIGN_DSS);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_PK_PGP_SIGN_RSA, SB_SSH_PK_PGP_SIGN_RSA, SB_SSH_PK_PGP_SIGN_RSA);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_PK_PGP_SIGN_DSS, SB_SSH_PK_PGP_SIGN_DSS, SB_SSH_PK_PGP_SIGN_DSS);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_PK_ECDSA_FIRST, SB_SSH_PK_ECDSA_FIRST, SB_SSH_PK_ECDSA_FIRST);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_PK_ECDSA_NIST_P256, SB_SSH_PK_ECDSA_NIST_P256, SB_SSH_PK_ECDSA_NIST_P256);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_PK_ECDSA_NIST_P384, SB_SSH_PK_ECDSA_NIST_P384, SB_SSH_PK_ECDSA_NIST_P384);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_PK_ECDSA_NIST_P521, SB_SSH_PK_ECDSA_NIST_P521, SB_SSH_PK_ECDSA_NIST_P521);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_PK_ECDSA_NIST_K163, SB_SSH_PK_ECDSA_NIST_K163, SB_SSH_PK_ECDSA_NIST_K163);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_PK_ECDSA_NIST_P192, SB_SSH_PK_ECDSA_NIST_P192, SB_SSH_PK_ECDSA_NIST_P192);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_PK_ECDSA_NIST_P224, SB_SSH_PK_ECDSA_NIST_P224, SB_SSH_PK_ECDSA_NIST_P224);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_PK_ECDSA_NIST_K233, SB_SSH_PK_ECDSA_NIST_K233, SB_SSH_PK_ECDSA_NIST_K233);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_PK_ECDSA_NIST_B233, SB_SSH_PK_ECDSA_NIST_B233, SB_SSH_PK_ECDSA_NIST_B233);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_PK_ECDSA_NIST_K283, SB_SSH_PK_ECDSA_NIST_K283, SB_SSH_PK_ECDSA_NIST_K283);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_PK_ECDSA_NIST_K409, SB_SSH_PK_ECDSA_NIST_K409, SB_SSH_PK_ECDSA_NIST_K409);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_PK_ECDSA_NIST_B409, SB_SSH_PK_ECDSA_NIST_B409, SB_SSH_PK_ECDSA_NIST_B409);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_PK_ECDSA_NIST_K571, SB_SSH_PK_ECDSA_NIST_K571, SB_SSH_PK_ECDSA_NIST_K571);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_PK_ECDSA_CURVE25519, SB_SSH_PK_ECDSA_CURVE25519, SB_SSH_PK_ECDSA_CURVE25519);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_PK_ECDSA_LAST, SB_SSH_PK_ECDSA_LAST, SB_SSH_PK_ECDSA_LAST);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_PK_LAST, SB_SSH_PK_LAST, SB_SSH_PK_LAST);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_PK_NULL, SB_SSH_PK_NULL, SB_SSH_PK_NULL);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_TUNNEL_ERROR_FORWARD_DISALLOWED, SB_SSH_TUNNEL_ERROR_FORWARD_DISALLOWED, SB_SSH_TUNNEL_ERROR_FORWARD_DISALLOWED);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_TUNNEL_ERROR_SERVER_ERROR, SB_SSH_TUNNEL_ERROR_SERVER_ERROR, SB_SSH_TUNNEL_ERROR_SERVER_ERROR);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_TUNNEL_ERROR_ADMINISTRATIVELY_PROHIBITED, SB_SSH_TUNNEL_ERROR_ADMINISTRATIVELY_PROHIBITED, SB_SSH_TUNNEL_ERROR_ADMINISTRATIVELY_PROHIBITED);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_TUNNEL_ERROR_CONNECT_FAILED, SB_SSH_TUNNEL_ERROR_CONNECT_FAILED, SB_SSH_TUNNEL_ERROR_CONNECT_FAILED);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_TUNNEL_ERROR_UNKNOWN_CHANNEL_TYPE, SB_SSH_TUNNEL_ERROR_UNKNOWN_CHANNEL_TYPE, SB_SSH_TUNNEL_ERROR_UNKNOWN_CHANNEL_TYPE);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_TUNNEL_ERROR_RESOURCE_SHORTAGE, SB_SSH_TUNNEL_ERROR_RESOURCE_SHORTAGE, SB_SSH_TUNNEL_ERROR_RESOURCE_SHORTAGE);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_TUNNEL_ERROR_ALREADY_CONNECTED, SB_SSH_TUNNEL_ERROR_ALREADY_CONNECTED, SB_SSH_TUNNEL_ERROR_ALREADY_CONNECTED);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_TUNNEL_ERROR_NOT_BOUND_TO_SSH_CLASS, SB_SSH_TUNNEL_ERROR_NOT_BOUND_TO_SSH_CLASS, SB_SSH_TUNNEL_ERROR_NOT_BOUND_TO_SSH_CLASS);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_TUNNEL_ERROR_SSH_NOT_CONNECTED, SB_SSH_TUNNEL_ERROR_SSH_NOT_CONNECTED, SB_SSH_TUNNEL_ERROR_SSH_NOT_CONNECTED);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_TUNNEL_ERROR_UNSUPPORTED_BY_SSH_VERSION, SB_SSH_TUNNEL_ERROR_UNSUPPORTED_BY_SSH_VERSION, SB_SSH_TUNNEL_ERROR_UNSUPPORTED_BY_SSH_VERSION);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_TUNNEL_ERROR_UNSUPPORTED_ACTION, SB_SSH_TUNNEL_ERROR_UNSUPPORTED_ACTION, SB_SSH_TUNNEL_ERROR_UNSUPPORTED_ACTION);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_TUNNEL_ERROR_OPEN_FAILED, SB_SSH_TUNNEL_ERROR_OPEN_FAILED, SB_SSH_TUNNEL_ERROR_OPEN_FAILED);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, IN_BUFFER_SIZE, SB_IN_BUFFER_SIZE, SB_IN_BUFFER_SIZE);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, OUT_BUFFER_SIZE, SB_OUT_BUFFER_SIZE, SB_OUT_BUFFER_SIZE);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, COMPR_BUFFER_SIZE, SB_COMPR_BUFFER_SIZE, SB_COMPR_BUFFER_SIZE);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, IDENTIFICATION_STRING_SIZE, SB_IDENTIFICATION_STRING_SIZE, SB_IDENTIFICATION_STRING_SIZE);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH1_MSG_NONE, SB_SSH1_MSG_NONE, SB_SSH1_MSG_NONE);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH1_MSG_DISCONNECT, SB_SSH1_MSG_DISCONNECT, SB_SSH1_MSG_DISCONNECT);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH1_MSG_PUBLIC_KEY, SB_SSH1_MSG_PUBLIC_KEY, SB_SSH1_MSG_PUBLIC_KEY);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH1_MSG_SESSION_KEY, SB_SSH1_MSG_SESSION_KEY, SB_SSH1_MSG_SESSION_KEY);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH1_MSG_USER, SB_SSH1_MSG_USER, SB_SSH1_MSG_USER);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH1_MSG_AUTH_RHOSTS, SB_SSH1_MSG_AUTH_RHOSTS, SB_SSH1_MSG_AUTH_RHOSTS);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH1_MSG_AUTH_RSA, SB_SSH1_MSG_AUTH_RSA, SB_SSH1_MSG_AUTH_RSA);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH1_MSG_AUTH_RSA_CHALLENGE, SB_SSH1_MSG_AUTH_RSA_CHALLENGE, SB_SSH1_MSG_AUTH_RSA_CHALLENGE);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH1_MSG_AUTH_RSA_RESPONSE, SB_SSH1_MSG_AUTH_RSA_RESPONSE, SB_SSH1_MSG_AUTH_RSA_RESPONSE);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH1_MSG_AUTH_PASSWORD, SB_SSH1_MSG_AUTH_PASSWORD, SB_SSH1_MSG_AUTH_PASSWORD);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH1_MSG_REQUEST_PTY, SB_SSH1_MSG_REQUEST_PTY, SB_SSH1_MSG_REQUEST_PTY);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH1_MSG_WINDOW_SIZE, SB_SSH1_MSG_WINDOW_SIZE, SB_SSH1_MSG_WINDOW_SIZE);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH1_MSG_EXEC_SHELL, SB_SSH1_MSG_EXEC_SHELL, SB_SSH1_MSG_EXEC_SHELL);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH1_MSG_EXEC_CMD, SB_SSH1_MSG_EXEC_CMD, SB_SSH1_MSG_EXEC_CMD);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH1_MSG_SUCCESS, SB_SSH1_MSG_SUCCESS, SB_SSH1_MSG_SUCCESS);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH1_MSG_FAILURE, SB_SSH1_MSG_FAILURE, SB_SSH1_MSG_FAILURE);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH1_MSG_STDIN_DATA, SB_SSH1_MSG_STDIN_DATA, SB_SSH1_MSG_STDIN_DATA);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH1_MSG_STDOUT_DATA, SB_SSH1_MSG_STDOUT_DATA, SB_SSH1_MSG_STDOUT_DATA);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH1_MSG_STDERR_DATA, SB_SSH1_MSG_STDERR_DATA, SB_SSH1_MSG_STDERR_DATA);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH1_MSG_EOF, SB_SSH1_MSG_EOF, SB_SSH1_MSG_EOF);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH1_MSG_EXIT_STATUS, SB_SSH1_MSG_EXIT_STATUS, SB_SSH1_MSG_EXIT_STATUS);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH1_MSG_CHANNEL_OPEN_CONFIRMATION, SB_SSH1_MSG_CHANNEL_OPEN_CONFIRMATION, SB_SSH1_MSG_CHANNEL_OPEN_CONFIRMATION);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH1_MSG_CHANNEL_OPEN_FAILURE, SB_SSH1_MSG_CHANNEL_OPEN_FAILURE, SB_SSH1_MSG_CHANNEL_OPEN_FAILURE);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH1_MSG_CHANNEL_DATA, SB_SSH1_MSG_CHANNEL_DATA, SB_SSH1_MSG_CHANNEL_DATA);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH1_MSG_CHANNEL_CLOSE, SB_SSH1_MSG_CHANNEL_CLOSE, SB_SSH1_MSG_CHANNEL_CLOSE);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH1_MSG_CHANNEL_CLOSE_CONFIRMATION, SB_SSH1_MSG_CHANNEL_CLOSE_CONFIRMATION, SB_SSH1_MSG_CHANNEL_CLOSE_CONFIRMATION);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH1_MSG_X11_OPEN, SB_SSH1_MSG_X11_OPEN, SB_SSH1_MSG_X11_OPEN);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH1_MSG_PORT_FORWARD_REQUEST, SB_SSH1_MSG_PORT_FORWARD_REQUEST, SB_SSH1_MSG_PORT_FORWARD_REQUEST);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH1_MSG_PORT_OPEN, SB_SSH1_MSG_PORT_OPEN, SB_SSH1_MSG_PORT_OPEN);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH1_MSG_AGENT_REQUEST_FORWARDING, SB_SSH1_MSG_AGENT_REQUEST_FORWARDING, SB_SSH1_MSG_AGENT_REQUEST_FORWARDING);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH1_MSG_AGENT_OPEN, SB_SSH1_MSG_AGENT_OPEN, SB_SSH1_MSG_AGENT_OPEN);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH1_MSG_IGNORE, SB_SSH1_MSG_IGNORE, SB_SSH1_MSG_IGNORE);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH1_MSG_EXIT_CONFIRMATION, SB_SSH1_MSG_EXIT_CONFIRMATION, SB_SSH1_MSG_EXIT_CONFIRMATION);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH1_MSG_X11_REQUEST_FORWARDING, SB_SSH1_MSG_X11_REQUEST_FORWARDING, SB_SSH1_MSG_X11_REQUEST_FORWARDING);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH1_MSG_AUTH_RHOSTS_RSA, SB_SSH1_MSG_AUTH_RHOSTS_RSA, SB_SSH1_MSG_AUTH_RHOSTS_RSA);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH1_MSG_DEBUG, SB_SSH1_MSG_DEBUG, SB_SSH1_MSG_DEBUG);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH1_MSG_REQUEST_COMPRESSION, SB_SSH1_MSG_REQUEST_COMPRESSION, SB_SSH1_MSG_REQUEST_COMPRESSION);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH1_MSG_AUTH_TIS, SB_SSH1_MSG_AUTH_TIS, SB_SSH1_MSG_AUTH_TIS);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH1_MSG_AUTH_TIS_CHALLENGE, SB_SSH1_MSG_AUTH_TIS_CHALLENGE, SB_SSH1_MSG_AUTH_TIS_CHALLENGE);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH1_MSG_AUTH_TIS_RESPONSE, SB_SSH1_MSG_AUTH_TIS_RESPONSE, SB_SSH1_MSG_AUTH_TIS_RESPONSE);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH1_CIPHER_NONE, SB_SSH1_CIPHER_NONE, SB_SSH1_CIPHER_NONE);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH1_CIPHER_IDEA, SB_SSH1_CIPHER_IDEA, SB_SSH1_CIPHER_IDEA);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH1_CIPHER_DES, SB_SSH1_CIPHER_DES, SB_SSH1_CIPHER_DES);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH1_CIPHER_3DES, SB_SSH1_CIPHER_3DES, SB_SSH1_CIPHER_3DES);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH1_CIPHER_RC4, SB_SSH1_CIPHER_RC4, SB_SSH1_CIPHER_RC4);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH1_CIPHER_BLOWFISH, SB_SSH1_CIPHER_BLOWFISH, SB_SSH1_CIPHER_BLOWFISH);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH1_AUTH_RHOSTS, SB_SSH1_AUTH_RHOSTS, SB_SSH1_AUTH_RHOSTS);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH1_AUTH_RSA, SB_SSH1_AUTH_RSA, SB_SSH1_AUTH_RSA);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH1_AUTH_PASSWORD, SB_SSH1_AUTH_PASSWORD, SB_SSH1_AUTH_PASSWORD);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH1_AUTH_RHOSTS_RSA, SB_SSH1_AUTH_RHOSTS_RSA, SB_SSH1_AUTH_RHOSTS_RSA);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH1_AUTH_TIS, SB_SSH1_AUTH_TIS, SB_SSH1_AUTH_TIS);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH1_AUTH_KERBEROS, SB_SSH1_AUTH_KERBEROS, SB_SSH1_AUTH_KERBEROS);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH2_MSG_DISCONNECT, SB_SSH2_MSG_DISCONNECT, SB_SSH2_MSG_DISCONNECT);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH2_MSG_IGNORE, SB_SSH2_MSG_IGNORE, SB_SSH2_MSG_IGNORE);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH2_MSG_UNIMPLEMENTED, SB_SSH2_MSG_UNIMPLEMENTED, SB_SSH2_MSG_UNIMPLEMENTED);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH2_MSG_DEBUG, SB_SSH2_MSG_DEBUG, SB_SSH2_MSG_DEBUG);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH2_MSG_SERVICE_REQUEST, SB_SSH2_MSG_SERVICE_REQUEST, SB_SSH2_MSG_SERVICE_REQUEST);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH2_MSG_SERVICE_ACCEPT, SB_SSH2_MSG_SERVICE_ACCEPT, SB_SSH2_MSG_SERVICE_ACCEPT);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH2_MSG_KEXINIT, SB_SSH2_MSG_KEXINIT, SB_SSH2_MSG_KEXINIT);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH2_MSG_NEWKEYS, SB_SSH2_MSG_NEWKEYS, SB_SSH2_MSG_NEWKEYS);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH2_MSG_KEXDH_INIT, SB_SSH2_MSG_KEXDH_INIT, SB_SSH2_MSG_KEXDH_INIT);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH2_MSG_KEXDH_REPLY, SB_SSH2_MSG_KEXDH_REPLY, SB_SSH2_MSG_KEXDH_REPLY);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH2_MSG_KEX_DH_GEX_REQUEST, SB_SSH2_MSG_KEX_DH_GEX_REQUEST, SB_SSH2_MSG_KEX_DH_GEX_REQUEST);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH2_MSG_KEX_DH_GEX_GROUP, SB_SSH2_MSG_KEX_DH_GEX_GROUP, SB_SSH2_MSG_KEX_DH_GEX_GROUP);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH2_MSG_KEX_DH_GEX_INIT, SB_SSH2_MSG_KEX_DH_GEX_INIT, SB_SSH2_MSG_KEX_DH_GEX_INIT);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH2_MSG_KEX_DH_GEX_REPLY, SB_SSH2_MSG_KEX_DH_GEX_REPLY, SB_SSH2_MSG_KEX_DH_GEX_REPLY);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH2_MSG_KEXRSA_PUBKEY, SB_SSH2_MSG_KEXRSA_PUBKEY, SB_SSH2_MSG_KEXRSA_PUBKEY);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH2_MSG_KEXRSA_SECRET, SB_SSH2_MSG_KEXRSA_SECRET, SB_SSH2_MSG_KEXRSA_SECRET);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH2_MSG_KEXRSA_DONE, SB_SSH2_MSG_KEXRSA_DONE, SB_SSH2_MSG_KEXRSA_DONE);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH2_MSG_KEX_ECDH_INIT, SB_SSH2_MSG_KEX_ECDH_INIT, SB_SSH2_MSG_KEX_ECDH_INIT);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH2_MSG_KEX_ECDH_REPLY, SB_SSH2_MSG_KEX_ECDH_REPLY, SB_SSH2_MSG_KEX_ECDH_REPLY);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH2_MSG_USERAUTH_REQUEST, SB_SSH2_MSG_USERAUTH_REQUEST, SB_SSH2_MSG_USERAUTH_REQUEST);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH2_MSG_USERAUTH_FAILURE, SB_SSH2_MSG_USERAUTH_FAILURE, SB_SSH2_MSG_USERAUTH_FAILURE);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH2_MSG_USERAUTH_SUCCESS, SB_SSH2_MSG_USERAUTH_SUCCESS, SB_SSH2_MSG_USERAUTH_SUCCESS);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH2_MSG_USERAUTH_BANNER, SB_SSH2_MSG_USERAUTH_BANNER, SB_SSH2_MSG_USERAUTH_BANNER);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH2_MSG_USERAUTH_PK_OK, SB_SSH2_MSG_USERAUTH_PK_OK, SB_SSH2_MSG_USERAUTH_PK_OK);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH2_MSG_USERAUTH_INFO_REQUEST, SB_SSH2_MSG_USERAUTH_INFO_REQUEST, SB_SSH2_MSG_USERAUTH_INFO_REQUEST);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH2_MSG_USERAUTH_PASSWD_CHANGEREQ, SB_SSH2_MSG_USERAUTH_PASSWD_CHANGEREQ, SB_SSH2_MSG_USERAUTH_PASSWD_CHANGEREQ);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH2_MSG_USERAUTH_INFO_RESPONSE, SB_SSH2_MSG_USERAUTH_INFO_RESPONSE, SB_SSH2_MSG_USERAUTH_INFO_RESPONSE);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH2_MSG_GLOBAL_REQUEST, SB_SSH2_MSG_GLOBAL_REQUEST, SB_SSH2_MSG_GLOBAL_REQUEST);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH2_MSG_REQUEST_SUCCESS, SB_SSH2_MSG_REQUEST_SUCCESS, SB_SSH2_MSG_REQUEST_SUCCESS);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH2_MSG_REQUEST_FAILURE, SB_SSH2_MSG_REQUEST_FAILURE, SB_SSH2_MSG_REQUEST_FAILURE);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH2_MSG_CHANNEL_OPEN, SB_SSH2_MSG_CHANNEL_OPEN, SB_SSH2_MSG_CHANNEL_OPEN);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH2_MSG_CHANNEL_OPEN_CONFIRMATION, SB_SSH2_MSG_CHANNEL_OPEN_CONFIRMATION, SB_SSH2_MSG_CHANNEL_OPEN_CONFIRMATION);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH2_MSG_CHANNEL_OPEN_FAILURE, SB_SSH2_MSG_CHANNEL_OPEN_FAILURE, SB_SSH2_MSG_CHANNEL_OPEN_FAILURE);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH2_MSG_CHANNEL_WINDOW_ADJUST, SB_SSH2_MSG_CHANNEL_WINDOW_ADJUST, SB_SSH2_MSG_CHANNEL_WINDOW_ADJUST);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH2_MSG_CHANNEL_DATA, SB_SSH2_MSG_CHANNEL_DATA, SB_SSH2_MSG_CHANNEL_DATA);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH2_MSG_CHANNEL_EXTENDED_DATA, SB_SSH2_MSG_CHANNEL_EXTENDED_DATA, SB_SSH2_MSG_CHANNEL_EXTENDED_DATA);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH2_MSG_CHANNEL_EOF, SB_SSH2_MSG_CHANNEL_EOF, SB_SSH2_MSG_CHANNEL_EOF);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH2_MSG_CHANNEL_CLOSE, SB_SSH2_MSG_CHANNEL_CLOSE, SB_SSH2_MSG_CHANNEL_CLOSE);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH2_MSG_CHANNEL_REQUEST, SB_SSH2_MSG_CHANNEL_REQUEST, SB_SSH2_MSG_CHANNEL_REQUEST);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH2_MSG_CHANNEL_SUCCESS, SB_SSH2_MSG_CHANNEL_SUCCESS, SB_SSH2_MSG_CHANNEL_SUCCESS);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH2_MSG_CHANNEL_FAILURE, SB_SSH2_MSG_CHANNEL_FAILURE, SB_SSH2_MSG_CHANNEL_FAILURE);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_MSG_KEXGSS_INIT, SB_SSH_MSG_KEXGSS_INIT, SB_SSH_MSG_KEXGSS_INIT);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_MSG_KEXGSS_CONTINUE, SB_SSH_MSG_KEXGSS_CONTINUE, SB_SSH_MSG_KEXGSS_CONTINUE);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_MSG_KEXGSS_COMPLETE, SB_SSH_MSG_KEXGSS_COMPLETE, SB_SSH_MSG_KEXGSS_COMPLETE);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_MSG_KEXGSS_HOSTKEY, SB_SSH_MSG_KEXGSS_HOSTKEY, SB_SSH_MSG_KEXGSS_HOSTKEY);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_MSG_KEXGSS_ERROR, SB_SSH_MSG_KEXGSS_ERROR, SB_SSH_MSG_KEXGSS_ERROR);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_MSG_KEXGSS_GROUPREQ, SB_SSH_MSG_KEXGSS_GROUPREQ, SB_SSH_MSG_KEXGSS_GROUPREQ);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_MSG_KEXGSS_GROUP, SB_SSH_MSG_KEXGSS_GROUP, SB_SSH_MSG_KEXGSS_GROUP);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_MSG_USERAUTH_GSSAPI_RESPONSE, SB_SSH_MSG_USERAUTH_GSSAPI_RESPONSE, SB_SSH_MSG_USERAUTH_GSSAPI_RESPONSE);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_MSG_USERAUTH_GSSAPI_TOKEN, SB_SSH_MSG_USERAUTH_GSSAPI_TOKEN, SB_SSH_MSG_USERAUTH_GSSAPI_TOKEN);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_MSG_USERAUTH_GSSAPI_EXCHANGE_COMPLETE, SB_SSH_MSG_USERAUTH_GSSAPI_EXCHANGE_COMPLETE, SB_SSH_MSG_USERAUTH_GSSAPI_EXCHANGE_COMPLETE);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_MSG_USERAUTH_GSSAPI_ERROR, SB_SSH_MSG_USERAUTH_GSSAPI_ERROR, SB_SSH_MSG_USERAUTH_GSSAPI_ERROR);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_MSG_USERAUTH_GSSAPI_ERRTOK, SB_SSH_MSG_USERAUTH_GSSAPI_ERRTOK, SB_SSH_MSG_USERAUTH_GSSAPI_ERRTOK);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_MSG_USERAUTH_GSSAPI_MIC, SB_SSH_MSG_USERAUTH_GSSAPI_MIC, SB_SSH_MSG_USERAUTH_GSSAPI_MIC);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_EXTENDED_DATA_STDERR, SB_SSH_EXTENDED_DATA_STDERR, SB_SSH_EXTENDED_DATA_STDERR);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_DISCONNECT_HOST_NOT_ALLOWED_TO_CONNECT, SB_SSH_DISCONNECT_HOST_NOT_ALLOWED_TO_CONNECT, SB_SSH_DISCONNECT_HOST_NOT_ALLOWED_TO_CONNECT);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_DISCONNECT_PROTOCOL_ERROR, SB_SSH_DISCONNECT_PROTOCOL_ERROR, SB_SSH_DISCONNECT_PROTOCOL_ERROR);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_DISCONNECT_KEY_EXCHANGE_FAILED, SB_SSH_DISCONNECT_KEY_EXCHANGE_FAILED, SB_SSH_DISCONNECT_KEY_EXCHANGE_FAILED);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_DISCONNECT_RESERVED, SB_SSH_DISCONNECT_RESERVED, SB_SSH_DISCONNECT_RESERVED);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_DISCONNECT_MAC_ERROR, SB_SSH_DISCONNECT_MAC_ERROR, SB_SSH_DISCONNECT_MAC_ERROR);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_DISCONNECT_COMPRESSION_ERROR, SB_SSH_DISCONNECT_COMPRESSION_ERROR, SB_SSH_DISCONNECT_COMPRESSION_ERROR);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_DISCONNECT_SERVICE_NOT_AVAILABLE, SB_SSH_DISCONNECT_SERVICE_NOT_AVAILABLE, SB_SSH_DISCONNECT_SERVICE_NOT_AVAILABLE);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_DISCONNECT_PROTOCOL_VERSION_NOT_SUPPORTED, SB_SSH_DISCONNECT_PROTOCOL_VERSION_NOT_SUPPORTED, SB_SSH_DISCONNECT_PROTOCOL_VERSION_NOT_SUPPORTED);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_DISCONNECT_HOST_KEY_NOT_VERIFIABLE, SB_SSH_DISCONNECT_HOST_KEY_NOT_VERIFIABLE, SB_SSH_DISCONNECT_HOST_KEY_NOT_VERIFIABLE);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_DISCONNECT_CONNECTION_LOST, SB_SSH_DISCONNECT_CONNECTION_LOST, SB_SSH_DISCONNECT_CONNECTION_LOST);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_DISCONNECT_BY_APPLICATION, SB_SSH_DISCONNECT_BY_APPLICATION, SB_SSH_DISCONNECT_BY_APPLICATION);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_DISCONNECT_TOO_MANY_CONNECTIONS, SB_SSH_DISCONNECT_TOO_MANY_CONNECTIONS, SB_SSH_DISCONNECT_TOO_MANY_CONNECTIONS);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_DISCONNECT_AUTH_CANCELLED_BY_USER, SB_SSH_DISCONNECT_AUTH_CANCELLED_BY_USER, SB_SSH_DISCONNECT_AUTH_CANCELLED_BY_USER);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_DISCONNECT_NO_MORE_AUTH_METHODS_AVAILABLE, SB_SSH_DISCONNECT_NO_MORE_AUTH_METHODS_AVAILABLE, SB_SSH_DISCONNECT_NO_MORE_AUTH_METHODS_AVAILABLE);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_DISCONNECT_ILLEGAL_USER_NAME, SB_SSH_DISCONNECT_ILLEGAL_USER_NAME, SB_SSH_DISCONNECT_ILLEGAL_USER_NAME);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH2_HASH_ALG_SHA1, SB_SSH2_HASH_ALG_SHA1, SB_SSH2_HASH_ALG_SHA1);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH2_CONN_INTERNAL_TYPE_NONE, SB_SSH2_CONN_INTERNAL_TYPE_NONE, SB_SSH2_CONN_INTERNAL_TYPE_NONE);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH2_CONN_INTERNAL_TYPE_SESSION, SB_SSH2_CONN_INTERNAL_TYPE_SESSION, SB_SSH2_CONN_INTERNAL_TYPE_SESSION);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_CONN_INTERNAL_TYPE_COMMAND, SB_SSH_CONN_INTERNAL_TYPE_COMMAND, SB_SSH_CONN_INTERNAL_TYPE_COMMAND);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH_CONN_INTERNAL_TYPE_SHELL, SB_SSH_CONN_INTERNAL_TYPE_SHELL, SB_SSH_CONN_INTERNAL_TYPE_SHELL);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH2_CONN_INTERNAL_STATE_BEFORE, SB_SSH2_CONN_INTERNAL_STATE_BEFORE, SB_SSH2_CONN_INTERNAL_STATE_BEFORE);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH2_CONN_INTERNAL_STATE_SESSION_OPENED, SB_SSH2_CONN_INTERNAL_STATE_SESSION_OPENED, SB_SSH2_CONN_INTERNAL_STATE_SESSION_OPENED);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH2_CONN_INTERNAL_STATE_PTY_REQUEST_SENT, SB_SSH2_CONN_INTERNAL_STATE_PTY_REQUEST_SENT, SB_SSH2_CONN_INTERNAL_STATE_PTY_REQUEST_SENT);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH2_CONN_INTERNAL_STATE_PTY_ALLOCATED, SB_SSH2_CONN_INTERNAL_STATE_PTY_ALLOCATED, SB_SSH2_CONN_INTERNAL_STATE_PTY_ALLOCATED);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH2_CONN_INTERNAL_STATE_ENVIRONMENT_SENT, SB_SSH2_CONN_INTERNAL_STATE_ENVIRONMENT_SENT, SB_SSH2_CONN_INTERNAL_STATE_ENVIRONMENT_SENT);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH2_CONN_INTERNAL_STATE_ENVIRONMENT_PASSED, SB_SSH2_CONN_INTERNAL_STATE_ENVIRONMENT_PASSED, SB_SSH2_CONN_INTERNAL_STATE_ENVIRONMENT_PASSED);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH2_CONN_INTERNAL_STATE_SHELL_REQUEST_SENT, SB_SSH2_CONN_INTERNAL_STATE_SHELL_REQUEST_SENT, SB_SSH2_CONN_INTERNAL_STATE_SHELL_REQUEST_SENT);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH2_CONN_INTERNAL_STATE_SHELL_STARTED, SB_SSH2_CONN_INTERNAL_STATE_SHELL_STARTED, SB_SSH2_CONN_INTERNAL_STATE_SHELL_STARTED);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH2_CONN_INTERNAL_STATE_EXEC_REQUEST_SENT, SB_SSH2_CONN_INTERNAL_STATE_EXEC_REQUEST_SENT, SB_SSH2_CONN_INTERNAL_STATE_EXEC_REQUEST_SENT);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH2_CONN_INTERNAL_STATE_SUBSYSTEM_REQUEST_SENT, SB_SSH2_CONN_INTERNAL_STATE_SUBSYSTEM_REQUEST_SENT, SB_SSH2_CONN_INTERNAL_STATE_SUBSYSTEM_REQUEST_SENT);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH2_CONN_INTERNAL_STATE_X_REQUEST_SENT, SB_SSH2_CONN_INTERNAL_STATE_X_REQUEST_SENT, SB_SSH2_CONN_INTERNAL_STATE_X_REQUEST_SENT);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH2_CONN_INTERNAL_STATE_BOUND_X_REQUEST_SENT, SB_SSH2_CONN_INTERNAL_STATE_BOUND_X_REQUEST_SENT, SB_SSH2_CONN_INTERNAL_STATE_BOUND_X_REQUEST_SENT);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH1_SESS_TYPE_SHELL, SB_SSH1_SESS_TYPE_SHELL, SB_SSH1_SESS_TYPE_SHELL);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH1_SESS_TYPE_COMMAND, SB_SSH1_SESS_TYPE_COMMAND, SB_SSH1_SESS_TYPE_COMMAND);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH1_SESS_TYPE_NONE, SB_SSH1_SESS_TYPE_NONE, SB_SSH1_SESS_TYPE_NONE);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH2_AUTH_STATE_NONE, SB_SSH2_AUTH_STATE_NONE, SB_SSH2_AUTH_STATE_NONE);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH2_AUTH_STATE_PK, SB_SSH2_AUTH_STATE_PK, SB_SSH2_AUTH_STATE_PK);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH2_AUTH_STATE_HOSTBASED, SB_SSH2_AUTH_STATE_HOSTBASED, SB_SSH2_AUTH_STATE_HOSTBASED);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSH2_AUTH_STATE_PASSWORD, SB_SSH2_AUTH_STATE_PASSWORD, SB_SSH2_AUTH_STATE_PASSWORD);
	SB_REGISTER_LONG_CONSTANT(SBSSHConstants, SSHCOMKEY_ORIG_MAGIC, SB_SSHCOMKEY_ORIG_MAGIC, SB_SSHCOMKEY_ORIG_MAGIC);
	SB_REGISTER_STRING_CONSTANT(SBSSHConstants, SSHKEY_HEADER_SUBJECT, SB_SSHKEY_HEADER_SUBJECT, SB_SSHKEY_HEADER_SUBJECT);
	SB_REGISTER_STRING_CONSTANT(SBSSHConstants, SSHKEY_HEADER_COMMENT, SB_SSHKEY_HEADER_COMMENT, SB_SSHKEY_HEADER_COMMENT);
	SB_REGISTER_STRING_CONSTANT(SBSSHConstants, SInvalidTunnelType, SB_SInvalidTunnelType, SB_SInvalidTunnelType);
	SB_REGISTER_STRING_CONSTANT(SBSSHConstants, SInvalidSize, SB_SInvalidSize, SB_SInvalidSize);
	SB_REGISTER_STRING_CONSTANT(SBSSHConstants, SDisconnectInvalidPacketSize, SB_SDisconnectInvalidPacketSize, SB_SDisconnectInvalidPacketSize);
	SB_REGISTER_STRING_CONSTANT(SBSSHConstants, SDisconnectConnectionClosed, SB_SDisconnectConnectionClosed, SB_SDisconnectConnectionClosed);
	SB_REGISTER_STRING_CONSTANT(SBSSHConstants, SDisconnectInvalidPacket, SB_SDisconnectInvalidPacket, SB_SDisconnectInvalidPacket);
	SB_REGISTER_STRING_CONSTANT(SBSSHConstants, SDisconnectInvalidCRC, SB_SDisconnectInvalidCRC, SB_SDisconnectInvalidCRC);
	SB_REGISTER_STRING_CONSTANT(SBSSHConstants, SDisconnectInvalidPacketType, SB_SDisconnectInvalidPacketType, SB_SDisconnectInvalidPacketType);
	SB_REGISTER_STRING_CONSTANT(SBSSHConstants, SDisconnectUnsupportedCipher, SB_SDisconnectUnsupportedCipher, SB_SDisconnectUnsupportedCipher);
	SB_REGISTER_STRING_CONSTANT(SBSSHConstants, SDisconnectUnsupportedAuthType, SB_SDisconnectUnsupportedAuthType, SB_SDisconnectUnsupportedAuthType);
	SB_REGISTER_STRING_CONSTANT(SBSSHConstants, SDisconnectInvalidRSAChallenge, SB_SDisconnectInvalidRSAChallenge, SB_SDisconnectInvalidRSAChallenge);
	SB_REGISTER_STRING_CONSTANT(SBSSHConstants, SDisconnectAuthenticationFailed, SB_SDisconnectAuthenticationFailed, SB_SDisconnectAuthenticationFailed);
	SB_REGISTER_STRING_CONSTANT(SBSSHConstants, SDisconnectInternalError, SB_SDisconnectInternalError, SB_SDisconnectInternalError);
	SB_REGISTER_STRING_CONSTANT(SBSSHConstants, SDisconnectHostKeyNotVerifiable, SB_SDisconnectHostKeyNotVerifiable, SB_SDisconnectHostKeyNotVerifiable);
	SB_REGISTER_STRING_CONSTANT(SBSSHConstants, SDisconnectInvalidMAC, SB_SDisconnectInvalidMAC, SB_SDisconnectInvalidMAC);
	SB_REGISTER_STRING_CONSTANT(SBSSHConstants, SDisconnectKeyExchangeFailed, SB_SDisconnectKeyExchangeFailed, SB_SDisconnectKeyExchangeFailed);
	SB_REGISTER_STRING_CONSTANT(SBSSHConstants, SDisconnectNoMoreAuthMethodsAvailable, SB_SDisconnectNoMoreAuthMethodsAvailable, SB_SDisconnectNoMoreAuthMethodsAvailable);
	SB_REGISTER_STRING_CONSTANT(SBSSHConstants, SDisconnectInvalidChannelID, SB_SDisconnectInvalidChannelID, SB_SDisconnectInvalidChannelID);
	SB_REGISTER_STRING_CONSTANT(SBSSHConstants, SDisconnectBadService, SB_SDisconnectBadService, SB_SDisconnectBadService);
	SB_REGISTER_STRING_CONSTANT(SBSSHConstants, SInternalUsedException, SB_SInternalUsedException, SB_SInternalUsedException);
	SB_REGISTER_STRING_CONSTANT(SBSSHConstants, SForbidden, SB_SForbidden, SB_SForbidden);
	SB_REGISTER_STRING_CONSTANT(SBSSHConstants, SCertAlgDoesNotMatchSSH, SB_SCertAlgDoesNotMatchSSH, SB_SCertAlgDoesNotMatchSSH);
	SB_REGISTER_STRING_CONSTANT(SBSSHConstants, SBadCertificate, SB_SBadCertificate, SB_SBadCertificate);
	SB_REGISTER_STRING_CONSTANT(SBSSHConstants, SOnKeyValidateNotAssigned, SB_SOnKeyValidateNotAssigned, SB_SOnKeyValidateNotAssigned);
	SB_REGISTER_STRING_CONSTANT(SBSSHConstants, SUnassignedValidationHandler, SB_SUnassignedValidationHandler, SB_SUnassignedValidationHandler);
	SB_REGISTER_STRING_CONSTANT(SBSSHConstants, SNullArgument, SB_SNullArgument, SB_SNullArgument);
	SB_REGISTER_STRING_CONSTANT(SBSSHConstants, SCannotInitializeObfuscation, SB_SCannotInitializeObfuscation, SB_SCannotInitializeObfuscation);
	SB_REGISTER_STRING_CONSTANT(SBSSHConstants, SSH_DSS_ID, SB_SSH_DSS_ID, SB_SSH_DSS_ID);
	SB_REGISTER_STRING_CONSTANT(SBSSHConstants, SSH_RSA_ID, SB_SSH_RSA_ID, SB_SSH_RSA_ID);
	SB_REGISTER_STRING_CONSTANT(SBSSHConstants, SSH_ECDSA_ID, SB_SSH_ECDSA_ID, SB_SSH_ECDSA_ID);
	SB_REGISTER_STRING_CONSTANT(SBSSHConstants, DSS_ID_SPACE, SB_DSS_ID_SPACE, SB_DSS_ID_SPACE);
	SB_REGISTER_STRING_CONSTANT(SBSSHConstants, RSA_ID_SPACE, SB_RSA_ID_SPACE, SB_RSA_ID_SPACE);
	SB_REGISTER_STRING_CONSTANT(SBSSHConstants, BEGIN_MARKER, SB_BEGIN_MARKER, SB_BEGIN_MARKER);
	SB_REGISTER_STRING_CONSTANT(SBSSHConstants, SSH_COM_MARKER, SB_SSH_COM_MARKER, SB_SSH_COM_MARKER);
	SB_REGISTER_STRING_CONSTANT(SBSSHConstants, SSH_NULL, SB_SSH_NULL, SB_SSH_NULL);
	SB_REGISTER_STRING_CONSTANT(SBSSHConstants, SSH_CONST_BUF_SSH_CONNECTION, SB_SSH_CONST_BUF_SSH_CONNECTION, SB_SSH_CONST_BUF_SSH_CONNECTION);
	SB_REGISTER_STRING_CONSTANT(SBSSHConstants, SSH_CONST_BUF_SSH_USERAUTH, SB_SSH_CONST_BUF_SSH_USERAUTH, SB_SSH_CONST_BUF_SSH_USERAUTH);
	SB_REGISTER_STRING_CONSTANT(SBSSHConstants, SSH_CONST_BUF_GSSAPI_KEYEX, SB_SSH_CONST_BUF_GSSAPI_KEYEX, SB_SSH_CONST_BUF_GSSAPI_KEYEX);
	SB_REGISTER_STRING_CONSTANT(SBSSHConstants, SSH_CONST_BUF_GSSAPI_WITH_MIC, SB_SSH_CONST_BUF_GSSAPI_WITH_MIC, SB_SSH_CONST_BUF_GSSAPI_WITH_MIC);
	SB_REGISTER_STRING_CONSTANT(SBSSHConstants, SSH_CONST_BUF_PUBLICKEY, SB_SSH_CONST_BUF_PUBLICKEY, SB_SSH_CONST_BUF_PUBLICKEY);
	SB_REGISTER_STRING_CONSTANT(SBSSHConstants, SSH_CONST_BUF_HOSTBASED, SB_SSH_CONST_BUF_HOSTBASED, SB_SSH_CONST_BUF_HOSTBASED);
	SB_REGISTER_STRING_CONSTANT(SBSSHConstants, SSH_CONST_BUF_PASSWORD, SB_SSH_CONST_BUF_PASSWORD, SB_SSH_CONST_BUF_PASSWORD);
	SB_REGISTER_STRING_CONSTANT(SBSSHConstants, SSH_CONST_BUF_KEYBOARD_INTERACTIVE, SB_SSH_CONST_BUF_KEYBOARD_INTERACTIVE, SB_SSH_CONST_BUF_KEYBOARD_INTERACTIVE);
	SB_REGISTER_STRING_CONSTANT(SBSSHConstants, SSH_CONST_BUF_SESSION, SB_SSH_CONST_BUF_SESSION, SB_SSH_CONST_BUF_SESSION);
	SB_REGISTER_STRING_CONSTANT(SBSSHConstants, SSH_CONST_BUF_DIRECT_TCPIP, SB_SSH_CONST_BUF_DIRECT_TCPIP, SB_SSH_CONST_BUF_DIRECT_TCPIP);
	SB_REGISTER_STRING_CONSTANT(SBSSHConstants, SSH_CONST_BUF_PTY_REQ, SB_SSH_CONST_BUF_PTY_REQ, SB_SSH_CONST_BUF_PTY_REQ);
	SB_REGISTER_STRING_CONSTANT(SBSSHConstants, SSH_CONST_BUF_SHELL, SB_SSH_CONST_BUF_SHELL, SB_SSH_CONST_BUF_SHELL);
	SB_REGISTER_STRING_CONSTANT(SBSSHConstants, SSH_CONST_BUF_EXEC, SB_SSH_CONST_BUF_EXEC, SB_SSH_CONST_BUF_EXEC);
	SB_REGISTER_STRING_CONSTANT(SBSSHConstants, SSH_CONST_BUF_KEEPALIVE, SB_SSH_CONST_BUF_KEEPALIVE, SB_SSH_CONST_BUF_KEEPALIVE);
	SB_REGISTER_STRING_CONSTANT(SBSSHConstants, SSH_CONST_BUF_SUBSYSTEM, SB_SSH_CONST_BUF_SUBSYSTEM, SB_SSH_CONST_BUF_SUBSYSTEM);
	SB_REGISTER_STRING_CONSTANT(SBSSHConstants, SSH_CONST_BUF_X11_REQ, SB_SSH_CONST_BUF_X11_REQ, SB_SSH_CONST_BUF_X11_REQ);
	SB_REGISTER_STRING_CONSTANT(SBSSHConstants, SSH_CONST_BUF_SIGNAL, SB_SSH_CONST_BUF_SIGNAL, SB_SSH_CONST_BUF_SIGNAL);
	SB_REGISTER_STRING_CONSTANT(SBSSHConstants, SSH_CONST_BUF_ENV, SB_SSH_CONST_BUF_ENV, SB_SSH_CONST_BUF_ENV);
	SB_REGISTER_STRING_CONSTANT(SBSSHConstants, SSH_CONST_BUF_WINDOW_CHANGE, SB_SSH_CONST_BUF_WINDOW_CHANGE, SB_SSH_CONST_BUF_WINDOW_CHANGE);
	SB_REGISTER_STRING_CONSTANT(SBSSHConstants, SSH_CONST_BUF_TCPIP_FORWARD, SB_SSH_CONST_BUF_TCPIP_FORWARD, SB_SSH_CONST_BUF_TCPIP_FORWARD);
	SB_REGISTER_STRING_CONSTANT(SBSSHConstants, SSH_CONST_BUF_CANCEL_TCPIP_FORWARD, SB_SSH_CONST_BUF_CANCEL_TCPIP_FORWARD, SB_SSH_CONST_BUF_CANCEL_TCPIP_FORWARD);
	SB_REGISTER_STRING_CONSTANT(SBSSHConstants, SSH_CONST_BUF_FORWARDED_TCPIP, SB_SSH_CONST_BUF_FORWARDED_TCPIP, SB_SSH_CONST_BUF_FORWARDED_TCPIP);
	SB_REGISTER_STRING_CONSTANT(SBSSHConstants, SSH_CONST_BUF_X509V3_SIGN_RSA, SB_SSH_CONST_BUF_X509V3_SIGN_RSA, SB_SSH_CONST_BUF_X509V3_SIGN_RSA);
	SB_REGISTER_STRING_CONSTANT(SBSSHConstants, SSH_CONST_BUF_X509V3_SIGN_DSS, SB_SSH_CONST_BUF_X509V3_SIGN_DSS, SB_SSH_CONST_BUF_X509V3_SIGN_DSS);
	SB_REGISTER_STRING_CONSTANT(SBSSHConstants, SSH_CONST_BUF_NONE, SB_SSH_CONST_BUF_NONE, SB_SSH_CONST_BUF_NONE);
	SB_REGISTER_STRING_CONSTANT(SBSSHConstants, SSH_CONST_BUF_EXIT_STATUS, SB_SSH_CONST_BUF_EXIT_STATUS, SB_SSH_CONST_BUF_EXIT_STATUS);
	SB_REGISTER_STRING_CONSTANT(SBSSHConstants, SSH_CONST_BUF_EXIT_SIGNAL, SB_SSH_CONST_BUF_EXIT_SIGNAL, SB_SSH_CONST_BUF_EXIT_SIGNAL);
	SB_REGISTER_STRING_CONSTANT(SBSSHConstants, SSH_CONST_BUF_VERSION_STR_199, SB_SSH_CONST_BUF_VERSION_STR_199, SB_SSH_CONST_BUF_VERSION_STR_199);
	SB_REGISTER_STRING_CONSTANT(SBSSHConstants, SSH_CONST_BUF_VERSION_STR_150, SB_SSH_CONST_BUF_VERSION_STR_150, SB_SSH_CONST_BUF_VERSION_STR_150);
	SB_REGISTER_STRING_CONSTANT(SBSSHConstants, SSH_CONST_BUF_VERSION_STR_200, SB_SSH_CONST_BUF_VERSION_STR_200, SB_SSH_CONST_BUF_VERSION_STR_200);
	SB_REGISTER_STRING_CONSTANT(SBSSHConstants, SSH_CONST_BUF_OAEP_PREFIX, SB_SSH_CONST_BUF_OAEP_PREFIX, SB_SSH_CONST_BUF_OAEP_PREFIX);
	SB_REGISTER_STRING_CONSTANT(SBSSHConstants, SSH_X509_SIGN_RSA_ID, SB_SSH_X509_SIGN_RSA_ID, SB_SSH_X509_SIGN_RSA_ID);
	SB_REGISTER_STRING_CONSTANT(SBSSHConstants, SSH_X509_SIGN_DSS_ID, SB_SSH_X509_SIGN_DSS_ID, SB_SSH_X509_SIGN_DSS_ID);
	SB_REGISTER_STRING_CONSTANT(SBSSHConstants, SSHCOMKEY_RSA_ID, SB_SSHCOMKEY_RSA_ID, SB_SSHCOMKEY_RSA_ID);
	SB_REGISTER_STRING_CONSTANT(SBSSHConstants, SSHCOMKEY_RSA_ID2, SB_SSHCOMKEY_RSA_ID2, SB_SSHCOMKEY_RSA_ID2);
	SB_REGISTER_STRING_CONSTANT(SBSSHConstants, SSHCOMKEY_DSS_ID, SB_SSHCOMKEY_DSS_ID, SB_SSHCOMKEY_DSS_ID);
	SB_REGISTER_STRING_CONSTANT(SBSSHConstants, SSHCOMKEY_SSHKEY_PREFIX_DSS, SB_SSHCOMKEY_SSHKEY_PREFIX_DSS, SB_SSHCOMKEY_SSHKEY_PREFIX_DSS);
	SB_REGISTER_STRING_CONSTANT(SBSSHConstants, SSHCOMKEY_DESEDE_ID, SB_SSHCOMKEY_DESEDE_ID, SB_SSHCOMKEY_DESEDE_ID);
	SB_REGISTER_STRING_CONSTANT(SBSSHConstants, SSHCOMKEY_NONE_ID, SB_SSHCOMKEY_NONE_ID, SB_SSHCOMKEY_NONE_ID);
	SB_REGISTER_STRING_CONSTANT(SBSSHConstants, PUTTYKEY_ID_V2, SB_PUTTYKEY_ID_V2, SB_PUTTYKEY_ID_V2);
	SB_REGISTER_STRING_CONSTANT(SBSSHConstants, PUTTYKEY_ALG_RSA, SB_PUTTYKEY_ALG_RSA, SB_PUTTYKEY_ALG_RSA);
	SB_REGISTER_STRING_CONSTANT(SBSSHConstants, PUTTYKEY_ALG_DSS, SB_PUTTYKEY_ALG_DSS, SB_PUTTYKEY_ALG_DSS);
	SB_REGISTER_STRING_CONSTANT(SBSSHConstants, PUTTYKEY_ENCRYPTION_AES, SB_PUTTYKEY_ENCRYPTION_AES, SB_PUTTYKEY_ENCRYPTION_AES);
	SB_REGISTER_STRING_CONSTANT(SBSSHConstants, PUTTYKEY_ENCRYPTION_NONE, SB_PUTTYKEY_ENCRYPTION_NONE, SB_PUTTYKEY_ENCRYPTION_NONE);
	SB_REGISTER_STRING_CONSTANT(SBSSHConstants, SSH1KEY_BEGIN, SB_SSH1KEY_BEGIN, SB_SSH1KEY_BEGIN);
	SB_REGISTER_STRING_CONSTANT(SBSSHConstants, PUTTYKEY_FIELD_ENCRYPTION, SB_PUTTYKEY_FIELD_ENCRYPTION, SB_PUTTYKEY_FIELD_ENCRYPTION);
	SB_REGISTER_STRING_CONSTANT(SBSSHConstants, PUTTYKEY_FIELD_COMMENT, SB_PUTTYKEY_FIELD_COMMENT, SB_PUTTYKEY_FIELD_COMMENT);
	SB_REGISTER_STRING_CONSTANT(SBSSHConstants, PUTTYKEY_FIELD_PUBLICLINES, SB_PUTTYKEY_FIELD_PUBLICLINES, SB_PUTTYKEY_FIELD_PUBLICLINES);
	SB_REGISTER_STRING_CONSTANT(SBSSHConstants, PUTTYKEY_FIELD_PRIVATELINES, SB_PUTTYKEY_FIELD_PRIVATELINES, SB_PUTTYKEY_FIELD_PRIVATELINES);
	SB_REGISTER_STRING_CONSTANT(SBSSHConstants, PUTTYKEY_FIELD_PRIVATEMAC, SB_PUTTYKEY_FIELD_PRIVATEMAC, SB_PUTTYKEY_FIELD_PRIVATEMAC);
	SB_REGISTER_STRING_CONSTANT(SBSSHConstants, PUTTYKEY_MAC_BEGIN, SB_PUTTYKEY_MAC_BEGIN, SB_PUTTYKEY_MAC_BEGIN);
	SB_REGISTER_STRING_CONSTANT(SBSSHConstants, SSHKEY_BEGIN_MARKER, SB_SSHKEY_BEGIN_MARKER, SB_SSHKEY_BEGIN_MARKER);
	SB_REGISTER_STRING_CONSTANT(SBSSHConstants, SSHKEY_END_MARKER, SB_SSHKEY_END_MARKER, SB_SSHKEY_END_MARKER);
	SB_REGISTER_STRING_CONSTANT(SBSSHConstants, SSHKEY_PRIVATE_BEGIN_MARKER, SB_SSHKEY_PRIVATE_BEGIN_MARKER, SB_SSHKEY_PRIVATE_BEGIN_MARKER);
	SB_REGISTER_STRING_CONSTANT(SBSSHConstants, SSHKEY_PRIVATE_END_MARKER, SB_SSHKEY_PRIVATE_END_MARKER, SB_SSHKEY_PRIVATE_END_MARKER);
	SB_REGISTER_STRING_CONSTANT(SBSSHConstants, SSHKEY_PREFIX_RSA, SB_SSHKEY_PREFIX_RSA, SB_SSHKEY_PREFIX_RSA);
	SB_REGISTER_STRING_CONSTANT(SBSSHConstants, SSHKEY_PREFIX_DSS, SB_SSHKEY_PREFIX_DSS, SB_SSHKEY_PREFIX_DSS);
	SB_REGISTER_STRING_CONSTANT(SBSSHConstants, SSHKEY_PREFIX_ECDSA, SB_SSHKEY_PREFIX_ECDSA, SB_SSHKEY_PREFIX_ECDSA);
	SB_REGISTER_STRING_CONSTANT(SBSSHConstants, SSHKEY_PREFIX_ECDSA_CURVE25519, SB_SSHKEY_PREFIX_ECDSA_CURVE25519, SB_SSHKEY_PREFIX_ECDSA_CURVE25519);
	SB_REGISTER_STRING_CONSTANT(SBSSHConstants, ASN_SHA1_ID, SB_ASN_SHA1_ID, SB_ASN_SHA1_ID);
	SB_REGISTER_STRING_CONSTANT(SBSSHConstants, SSH_IDENTIFIER, SB_SSH_IDENTIFIER, SB_SSH_IDENTIFIER);
	SB_REGISTER_STRING_CONSTANT(SBSSHConstants, SSH_15_IDENTIFIER, SB_SSH_15_IDENTIFIER, SB_SSH_15_IDENTIFIER);
	SB_REGISTER_STRING_CONSTANT(SBSSHConstants, SSH_20_IDENTIFIER, SB_SSH_20_IDENTIFIER, SB_SSH_20_IDENTIFIER);
}

