#include "sbsshpkcs11keystorage.h"

zend_class_entry *TElSSHPKCS11KeyStorage_ce_ptr = NULL;

SB_PHP_METHOD(TElSSHPKCS11KeyStorage, Open)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElSSHPKCS11KeyStorage_Open(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHPKCS11KeyStorage, Close)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElSSHPKCS11KeyStorage_Close(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHPKCS11KeyStorage, OpenSession)
{
	long l4SlotIndex;
	zend_bool bReadOnly;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lb", &l4SlotIndex, &bReadOnly) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSSHPKCS11KeyStorage_OpenSession(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4SlotIndex, (int8_t)bReadOnly, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElPKCS11SessionInfo_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHPKCS11KeyStorage, CloseSession)
{
	long l4SessionIndex;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4SessionIndex) == SUCCESS)
	{
		SBCheckError(TElSSHPKCS11KeyStorage_CloseSession(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4SessionIndex) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHPKCS11KeyStorage, CloseAllSessions)
{
	zval *oSlot;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSlot, TElPKCS11SlotInfo_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSSHPKCS11KeyStorage_CloseAllSessions(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSlot TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElPKCS11SlotInfo)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHPKCS11KeyStorage, Add)
{
	long l4SessionIndex;
	SBArrayZValInfo aiID;
	SBArrayZValInfo aiKeyLabel;
	zend_bool bCopyPrivateKey;
	zend_bool bExportable;
	zval *oKey;
	zval *zaID;
	zval *zaKeyLabel;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oKey, TElSSHKey_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSSHPKCS11KeyStorage_Add(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oKey TSRMLS_CC)) TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lO!bbzz", &l4SessionIndex, &oKey, TElSSHKey_ce_ptr, &bCopyPrivateKey, &bExportable, &zaID, &zaKeyLabel) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaID)) || (IS_ARRAY == Z_TYPE_P(zaID)) || (IS_NULL == Z_TYPE_P(zaID))) && ((IS_STRING == Z_TYPE_P(zaKeyLabel)) || (IS_ARRAY == Z_TYPE_P(zaKeyLabel)) || (IS_NULL == Z_TYPE_P(zaKeyLabel))))
	{
		if (!SBGetByteArrayFromZVal(zaID, &aiID TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaKeyLabel, &aiKeyLabel TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElSSHPKCS11KeyStorage_Add_1(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4SessionIndex, SBGetObjectHandle(oKey TSRMLS_CC), (int8_t)bCopyPrivateKey, (int8_t)bExportable, aiID.data, aiID.len, aiKeyLabel.data, aiKeyLabel.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiID);
		SBFreeArrayZValInfo(&aiKeyLabel);
	}
	else
	{
		SBErrorExpectsArguments("(TElSSHKey) or (integer, TElSSHKey, bool, bool, array of byte|string|NULL, array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHPKCS11KeyStorage, Remove)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		SBCheckError(TElSSHPKCS11KeyStorage_Remove(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHPKCS11KeyStorage, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElSSHPKCS11KeyStorage_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHPKCS11KeyStorage, IndexOf)
{
	zval *oKey;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oKey, TElSSHKey_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSSHPKCS11KeyStorage_IndexOf(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oKey TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElSSHKey)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHPKCS11KeyStorage, LoadPublic)
{
	char *sFilename;
	int sFilename_len;
	long l4Count;
	zval *oF;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!l", &oF, TStream_ce_ptr, &l4Count) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSSHPKCS11KeyStorage_LoadPublic(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oF TSRMLS_CC), (int32_t)l4Count, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sFilename, &sFilename_len) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSSHPKCS11KeyStorage_LoadPublic_1(SBGetObjectHandle(getThis() TSRMLS_CC), sFilename, (int32_t)sFilename_len, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TStream, integer) or (string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHPKCS11KeyStorage, SavePublic)
{
	char *sFilename;
	int sFilename_len;
	zval *oF;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oF, TStream_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSSHPKCS11KeyStorage_SavePublic(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oF TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sFilename, &sFilename_len) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSSHPKCS11KeyStorage_SavePublic_1(SBGetObjectHandle(getThis() TSRMLS_CC), sFilename, (int32_t)sFilename_len, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TStream) or (string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHPKCS11KeyStorage, get_Module)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSSHPKCS11KeyStorage_get_Module(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElPKCS11Module_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHPKCS11KeyStorage, get_Opened)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSSHPKCS11KeyStorage_get_Opened(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHPKCS11KeyStorage, get_UniqueID)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElSSHPKCS11KeyStorage_get_UniqueID(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-220529685, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHPKCS11KeyStorage, get_DLLName)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSSHPKCS11KeyStorage_get_DLLName(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1936798612, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHPKCS11KeyStorage, set_DLLName)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSSHPKCS11KeyStorage_set_DLLName(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHPKCS11KeyStorage, get_TrySingleThreadedMode)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSSHPKCS11KeyStorage_get_TrySingleThreadedMode(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHPKCS11KeyStorage, set_TrySingleThreadedMode)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSSHPKCS11KeyStorage_set_TrySingleThreadedMode(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHPKCS11KeyStorage, get_MonitorSlotEvents)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSSHPKCS11KeyStorage_get_MonitorSlotEvents(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHPKCS11KeyStorage, set_MonitorSlotEvents)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSSHPKCS11KeyStorage_set_MonitorSlotEvents(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHPKCS11KeyStorage, get_SlotEventMonitoringMode)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBPKCS11SlotEventMonitoringModeRaw fOutResultRaw = 0;
		SBCheckError(TElSSHPKCS11KeyStorage_get_SlotEventMonitoringMode(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHPKCS11KeyStorage, set_SlotEventMonitoringMode)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElSSHPKCS11KeyStorage_set_SlotEventMonitoringMode(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBPKCS11SlotEventMonitoringModeRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHPKCS11KeyStorage, get_SlotEventMonitoringDelay)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSSHPKCS11KeyStorage_get_SlotEventMonitoringDelay(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHPKCS11KeyStorage, set_SlotEventMonitoringDelay)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElSSHPKCS11KeyStorage_set_SlotEventMonitoringDelay(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHPKCS11KeyStorage, get_SynchronizeGUI)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSSHPKCS11KeyStorage_get_SynchronizeGUI(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHPKCS11KeyStorage, set_SynchronizeGUI)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSSHPKCS11KeyStorage_set_SynchronizeGUI(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHPKCS11KeyStorage, get_CryptoProvider)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSSHPKCS11KeyStorage_get_CryptoProvider(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomCryptoProvider_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHPKCS11KeyStorage, set_CryptoProvider)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSSHPKCS11KeyStorage_set_CryptoProvider(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCryptoProvider)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHPKCS11KeyStorage, get_PKCS11Options)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBPKCS11StorageOptionsRaw fOutResultRaw = 0;
		SBCheckError(TElSSHPKCS11KeyStorage_get_PKCS11Options(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHPKCS11KeyStorage, set_PKCS11Options)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElSSHPKCS11KeyStorage_set_PKCS11Options(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBPKCS11StorageOptionsRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHPKCS11KeyStorage, get_TokenAccessMode)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBPKCS11TokenAccessModeRaw fOutResultRaw = 0;
		SBCheckError(TElSSHPKCS11KeyStorage_get_TokenAccessMode(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHPKCS11KeyStorage, set_TokenAccessMode)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElSSHPKCS11KeyStorage_set_TokenAccessMode(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBPKCS11TokenAccessModeRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHPKCS11KeyStorage, get_NSSParams)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSSHPKCS11KeyStorage_get_NSSParams(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElPKCS11NSSParams_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHPKCS11KeyStorage, get_OnSlotEvent)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElPKCSSlotEventEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSSHPKCS11KeyStorage_get_OnSlotEvent(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHPKCS11KeyStorage, set_OnSlotEvent)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSSHPKCS11KeyStorage_set_OnSlotEvent(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TElPKCSSlotEventEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElPKCSSlotEventEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHPKCS11KeyStorage, get_OnNotification)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElPKCSNotifyEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSSHPKCS11KeyStorage_get_OnNotification(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHPKCS11KeyStorage, set_OnNotification)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSSHPKCS11KeyStorage_set_OnNotification(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TElPKCSNotifyEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElPKCSNotifyEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHPKCS11KeyStorage, __construct)
{
	zval *oAOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSSHPKCS11KeyStorage_Create(SBGetObjectHandle(oAOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHPKCS11KeyStorage_Open, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHPKCS11KeyStorage_Close, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHPKCS11KeyStorage_OpenSession, 0, 0, 2)
	ZEND_ARG_INFO(0, SlotIndex)
	ZEND_ARG_INFO(0, ReadOnly)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHPKCS11KeyStorage_CloseSession, 0, 0, 1)
	ZEND_ARG_INFO(0, SessionIndex)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHPKCS11KeyStorage_CloseAllSessions, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Slot, TElPKCS11SlotInfo, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHPKCS11KeyStorage_Add, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Key_or_SessionIndex, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Key, TElSSHKey, 1)
	ZEND_ARG_INFO(0, CopyPrivateKey)
	ZEND_ARG_INFO(0, Exportable)
	ZEND_ARG_TYPE_INFO(0, ID, 0, 1)
	ZEND_ARG_TYPE_INFO(0, KeyLabel, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHPKCS11KeyStorage_Remove, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHPKCS11KeyStorage_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHPKCS11KeyStorage_IndexOf, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Key, TElSSHKey, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHPKCS11KeyStorage_LoadPublic, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, F_or_Filename, 0, 1)
	ZEND_ARG_INFO(0, Count)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHPKCS11KeyStorage_SavePublic, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, F_or_Filename, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHPKCS11KeyStorage_get_Module, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHPKCS11KeyStorage_get_Opened, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHPKCS11KeyStorage_get_UniqueID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHPKCS11KeyStorage_get_DLLName, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHPKCS11KeyStorage_set_DLLName, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHPKCS11KeyStorage_get_TrySingleThreadedMode, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHPKCS11KeyStorage_set_TrySingleThreadedMode, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHPKCS11KeyStorage_get_MonitorSlotEvents, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHPKCS11KeyStorage_set_MonitorSlotEvents, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHPKCS11KeyStorage_get_SlotEventMonitoringMode, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHPKCS11KeyStorage_set_SlotEventMonitoringMode, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHPKCS11KeyStorage_get_SlotEventMonitoringDelay, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHPKCS11KeyStorage_set_SlotEventMonitoringDelay, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHPKCS11KeyStorage_get_SynchronizeGUI, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHPKCS11KeyStorage_set_SynchronizeGUI, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHPKCS11KeyStorage_get_CryptoProvider, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHPKCS11KeyStorage_set_CryptoProvider, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElCustomCryptoProvider, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHPKCS11KeyStorage_get_PKCS11Options, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHPKCS11KeyStorage_set_PKCS11Options, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHPKCS11KeyStorage_get_TokenAccessMode, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHPKCS11KeyStorage_set_TokenAccessMode, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHPKCS11KeyStorage_get_NSSParams, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHPKCS11KeyStorage_get_OnSlotEvent, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHPKCS11KeyStorage_set_OnSlotEvent, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHPKCS11KeyStorage_get_OnNotification, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHPKCS11KeyStorage_set_OnNotification, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHPKCS11KeyStorage___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AOwner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElSSHPKCS11KeyStorage_methods[] = {
	PHP_ME(TElSSHPKCS11KeyStorage, Open, arginfo_TElSSHPKCS11KeyStorage_Open, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHPKCS11KeyStorage, Close, arginfo_TElSSHPKCS11KeyStorage_Close, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHPKCS11KeyStorage, OpenSession, arginfo_TElSSHPKCS11KeyStorage_OpenSession, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHPKCS11KeyStorage, CloseSession, arginfo_TElSSHPKCS11KeyStorage_CloseSession, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHPKCS11KeyStorage, CloseAllSessions, arginfo_TElSSHPKCS11KeyStorage_CloseAllSessions, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHPKCS11KeyStorage, Add, arginfo_TElSSHPKCS11KeyStorage_Add, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHPKCS11KeyStorage, Remove, arginfo_TElSSHPKCS11KeyStorage_Remove, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHPKCS11KeyStorage, Clear, arginfo_TElSSHPKCS11KeyStorage_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHPKCS11KeyStorage, IndexOf, arginfo_TElSSHPKCS11KeyStorage_IndexOf, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHPKCS11KeyStorage, LoadPublic, arginfo_TElSSHPKCS11KeyStorage_LoadPublic, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHPKCS11KeyStorage, SavePublic, arginfo_TElSSHPKCS11KeyStorage_SavePublic, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHPKCS11KeyStorage, get_Module, arginfo_TElSSHPKCS11KeyStorage_get_Module, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHPKCS11KeyStorage, get_Opened, arginfo_TElSSHPKCS11KeyStorage_get_Opened, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHPKCS11KeyStorage, get_UniqueID, arginfo_TElSSHPKCS11KeyStorage_get_UniqueID, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHPKCS11KeyStorage, get_DLLName, arginfo_TElSSHPKCS11KeyStorage_get_DLLName, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHPKCS11KeyStorage, set_DLLName, arginfo_TElSSHPKCS11KeyStorage_set_DLLName, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHPKCS11KeyStorage, get_TrySingleThreadedMode, arginfo_TElSSHPKCS11KeyStorage_get_TrySingleThreadedMode, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHPKCS11KeyStorage, set_TrySingleThreadedMode, arginfo_TElSSHPKCS11KeyStorage_set_TrySingleThreadedMode, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHPKCS11KeyStorage, get_MonitorSlotEvents, arginfo_TElSSHPKCS11KeyStorage_get_MonitorSlotEvents, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHPKCS11KeyStorage, set_MonitorSlotEvents, arginfo_TElSSHPKCS11KeyStorage_set_MonitorSlotEvents, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHPKCS11KeyStorage, get_SlotEventMonitoringMode, arginfo_TElSSHPKCS11KeyStorage_get_SlotEventMonitoringMode, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHPKCS11KeyStorage, set_SlotEventMonitoringMode, arginfo_TElSSHPKCS11KeyStorage_set_SlotEventMonitoringMode, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHPKCS11KeyStorage, get_SlotEventMonitoringDelay, arginfo_TElSSHPKCS11KeyStorage_get_SlotEventMonitoringDelay, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHPKCS11KeyStorage, set_SlotEventMonitoringDelay, arginfo_TElSSHPKCS11KeyStorage_set_SlotEventMonitoringDelay, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHPKCS11KeyStorage, get_SynchronizeGUI, arginfo_TElSSHPKCS11KeyStorage_get_SynchronizeGUI, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHPKCS11KeyStorage, set_SynchronizeGUI, arginfo_TElSSHPKCS11KeyStorage_set_SynchronizeGUI, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHPKCS11KeyStorage, get_CryptoProvider, arginfo_TElSSHPKCS11KeyStorage_get_CryptoProvider, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHPKCS11KeyStorage, set_CryptoProvider, arginfo_TElSSHPKCS11KeyStorage_set_CryptoProvider, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHPKCS11KeyStorage, get_PKCS11Options, arginfo_TElSSHPKCS11KeyStorage_get_PKCS11Options, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHPKCS11KeyStorage, set_PKCS11Options, arginfo_TElSSHPKCS11KeyStorage_set_PKCS11Options, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHPKCS11KeyStorage, get_TokenAccessMode, arginfo_TElSSHPKCS11KeyStorage_get_TokenAccessMode, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHPKCS11KeyStorage, set_TokenAccessMode, arginfo_TElSSHPKCS11KeyStorage_set_TokenAccessMode, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHPKCS11KeyStorage, get_NSSParams, arginfo_TElSSHPKCS11KeyStorage_get_NSSParams, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHPKCS11KeyStorage, get_OnSlotEvent, arginfo_TElSSHPKCS11KeyStorage_get_OnSlotEvent, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHPKCS11KeyStorage, set_OnSlotEvent, arginfo_TElSSHPKCS11KeyStorage_set_OnSlotEvent, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHPKCS11KeyStorage, get_OnNotification, arginfo_TElSSHPKCS11KeyStorage_get_OnNotification, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHPKCS11KeyStorage, set_OnNotification, arginfo_TElSSHPKCS11KeyStorage_set_OnNotification, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHPKCS11KeyStorage, __construct, arginfo_TElSSHPKCS11KeyStorage___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSSHPKCS11KeyStorage(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSSHPKCS11KeyStorage_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSSHPKCS11KeyStorage", TElSSHPKCS11KeyStorage_methods);
	if (NULL == TElSSHCustomKeyStorage_ce_ptr)
		Register_TElSSHCustomKeyStorage(TSRMLS_C);
	TElSSHPKCS11KeyStorage_ce_ptr = zend_register_internal_class_ex(&ce, TElSSHCustomKeyStorage_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElSSHPKCS11ConsumerKeyStorage_ce_ptr = NULL;

SB_PHP_METHOD(TElSSHPKCS11ConsumerKeyStorage, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSSHPKCS11ConsumerKeyStorage_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHPKCS11ConsumerKeyStorage___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElSSHPKCS11ConsumerKeyStorage_methods[] = {
	PHP_ME(TElSSHPKCS11ConsumerKeyStorage, __construct, arginfo_TElSSHPKCS11ConsumerKeyStorage___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSSHPKCS11ConsumerKeyStorage(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSSHPKCS11ConsumerKeyStorage_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSSHPKCS11ConsumerKeyStorage", TElSSHPKCS11ConsumerKeyStorage_methods);
	if (NULL == TElPKCS11Consumer_ce_ptr)
		Register_TElPKCS11Consumer(TSRMLS_C);
	TElSSHPKCS11ConsumerKeyStorage_ce_ptr = zend_register_internal_class_ex(&ce, TElPKCS11Consumer_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElPKCS11SSHKey_ce_ptr = NULL;

SB_PHP_METHOD(TElPKCS11SSHKey, Copy)
{
	TElClassHandle hoDest;
	zval *oDest;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &oDest, TElSSHKey_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oDest) && (IS_OBJECT == Z_TYPE_P(oDest)))
	{
		hoDest = SBGetObjectHandle(oDest TSRMLS_CC);
		SBCheckError(TElPKCS11SSHKey_Copy(SBGetObjectHandle(getThis() TSRMLS_CC), &hoDest) TSRMLS_CC);
		SBUpdateObjectHandle(oDest, hoDest TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(&TElSSHKey)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11SSHKey, Clone)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPKCS11SSHKey_Clone(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElSSHKey_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11SSHKey, CreateObjectInstance)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPKCS11SSHKey_CreateObjectInstance(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElSSHKey_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11SSHKey, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElPKCS11SSHKey_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11SSHKey, get_KeyID)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElPKCS11SSHKey_get_KeyID(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-372121237, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11SSHKey, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPKCS11SSHKey_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11SSHKey_Copy, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(1, Dest, TElSSHKey, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11SSHKey_Clone, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11SSHKey_CreateObjectInstance, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11SSHKey_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11SSHKey_get_KeyID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11SSHKey___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElPKCS11SSHKey_methods[] = {
	PHP_ME(TElPKCS11SSHKey, Copy, arginfo_TElPKCS11SSHKey_Copy, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11SSHKey, Clone, arginfo_TElPKCS11SSHKey_Clone, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11SSHKey, CreateObjectInstance, arginfo_TElPKCS11SSHKey_CreateObjectInstance, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11SSHKey, Clear, arginfo_TElPKCS11SSHKey_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11SSHKey, get_KeyID, arginfo_TElPKCS11SSHKey_get_KeyID, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11SSHKey, __construct, arginfo_TElPKCS11SSHKey___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElPKCS11SSHKey(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElPKCS11SSHKey_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElPKCS11SSHKey", TElPKCS11SSHKey_methods);
	if (NULL == TElSSHKey_ce_ptr)
		Register_TElSSHKey(TSRMLS_C);
	TElPKCS11SSHKey_ce_ptr = zend_register_internal_class_ex(&ce, TElSSHKey_ce_ptr, NULL TSRMLS_CC);
}

