#include "sbsslserver.h"

void SB_CALLBACK TSBServerKeyNeededEventRaw(void * _ObjectData, TObjectHandle Sender, const char * pcIdentity, int32_t szIdentity, uint8_t pKey[], int32_t * szKey)
{
	zval *retval_ptr;
	zval **params[3];
	zval * zSender;
	zval * zIdentity;
	zval * zKey;
	SBArrayZValInfo aiKey;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zIdentity);
	ZVAL_STRINGL(zIdentity, pcIdentity, szIdentity, 1);
	MAKE_STD_ZVAL(zKey);
	ZVAL_STRINGL(zKey, pKey, *szKey, 1);

	params[0] = &zSender;
	params[1] = &zIdentity;
	params[2] = &zKey;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 3, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zIdentity);
	if (SBGetByteArrayFromZVal(zKey, &aiKey TSRMLS_CC))
		SBCheckError(SBSetEventReturnBuffer(3, aiKey.data, aiKey.len) TSRMLS_CC);
	SBFreeArrayZValInfo(&aiKey);
	zval_ptr_dtor(&zKey);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBCertificateURLsEventRaw(void * _ObjectData, TObjectHandle Sender, TElClientCertURLsSSLExtensionHandle URLs, TElMemoryCertStorageHandle Certificates)
{
	zval *retval_ptr;
	zval **params[3];
	zval * zSender;
	zval * zURLs;
	zval * zCertificates;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zURLs);
	SBInitObject(zURLs, TElClientCertURLsSSLExtension_ce_ptr, URLs TSRMLS_CC);
	MAKE_STD_ZVAL(zCertificates);
	SBInitObject(zCertificates, TElMemoryCertStorage_ce_ptr, Certificates TSRMLS_CC);

	params[0] = &zSender;
	params[1] = &zURLs;
	params[2] = &zCertificates;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 3, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zURLs);
	zval_ptr_dtor(&zCertificates);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBServerSrpDbNeededEventRaw(void * _ObjectData, TObjectHandle Sender, const char * pcUserName, int32_t szUserName, uint8_t pN[], int32_t * szN, uint8_t pG[], int32_t * szG, uint8_t pS[], int32_t * szS, uint8_t pV[], int32_t * szV, int8_t * OutResult)
{
	zval **params[6];
	zval * zSender;
	zval * zUserName;
	zval * zN;
	SBArrayZValInfo aiN;
	zval * zG;
	SBArrayZValInfo aiG;
	zval * zS;
	SBArrayZValInfo aiS;
	zval * zV;
	SBArrayZValInfo aiV;
	zval * pzOutResult = NULL;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zUserName);
	ZVAL_STRINGL(zUserName, pcUserName, szUserName, 1);
	MAKE_STD_ZVAL(zN);
	ZVAL_STRINGL(zN, pN, *szN, 1);
	MAKE_STD_ZVAL(zG);
	ZVAL_STRINGL(zG, pG, *szG, 1);
	MAKE_STD_ZVAL(zS);
	ZVAL_STRINGL(zS, pS, *szS, 1);
	MAKE_STD_ZVAL(zV);
	ZVAL_STRINGL(zV, pV, *szV, 1);

	params[0] = &zSender;
	params[1] = &zUserName;
	params[2] = &zN;
	params[3] = &zG;
	params[4] = &zS;
	params[5] = &zV;
	SBCallEvent((zval *)_ObjectData, &pzOutResult, 6, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zUserName);
	if (SBGetByteArrayFromZVal(zN, &aiN TSRMLS_CC))
		SBCheckError(SBSetEventReturnBuffer(3, aiN.data, aiN.len) TSRMLS_CC);
	SBFreeArrayZValInfo(&aiN);
	zval_ptr_dtor(&zN);
	if (SBGetByteArrayFromZVal(zG, &aiG TSRMLS_CC))
		SBCheckError(SBSetEventReturnBuffer(4, aiG.data, aiG.len) TSRMLS_CC);
	SBFreeArrayZValInfo(&aiG);
	zval_ptr_dtor(&zG);
	if (SBGetByteArrayFromZVal(zS, &aiS TSRMLS_CC))
		SBCheckError(SBSetEventReturnBuffer(5, aiS.data, aiS.len) TSRMLS_CC);
	SBFreeArrayZValInfo(&aiS);
	zval_ptr_dtor(&zS);
	if (SBGetByteArrayFromZVal(zV, &aiV TSRMLS_CC))
		SBCheckError(SBSetEventReturnBuffer(6, aiV.data, aiV.len) TSRMLS_CC);
	SBFreeArrayZValInfo(&aiV);
	zval_ptr_dtor(&zV);
	if (pzOutResult)
	{
		*OutResult = (int8_t)Z_BVAL_P(pzOutResult);
		zval_ptr_dtor(&pzOutResult);
	}
}

void SB_CALLBACK TSBServerSessionCreatedEventRaw(void * _ObjectData, TObjectHandle Sender, const uint8_t pSessionID[], int32_t szSessionID, TObjectHandle * SessionInfo, int8_t * FreeOnRelease)
{
	zval *retval_ptr;
	zval **params[4];
	zval * zSender;
	zval * zSessionID;
	zval * zSessionInfo;
	zval * zFreeOnRelease;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zSessionID);
	ZVAL_STRINGL(zSessionID, pSessionID, szSessionID, 1);
	MAKE_STD_ZVAL(zSessionInfo);
	SBInitObject(zSessionInfo, TObject_ce_ptr, *SessionInfo TSRMLS_CC);
	MAKE_STD_ZVAL(zFreeOnRelease);
	ZVAL_BOOL(zFreeOnRelease, (zend_bool)*FreeOnRelease);

	params[0] = &zSender;
	params[1] = &zSessionID;
	params[2] = &zSessionInfo;
	params[3] = &zFreeOnRelease;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 4, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zSessionID);
	*SessionInfo = SBGetObjectHandleCE(zSessionInfo, TObject_ce_ptr TSRMLS_CC);
	SBDetachObjectHandleIfUniqueZVal(zSessionInfo TSRMLS_CC);
	zval_ptr_dtor(&zSessionInfo);
	*FreeOnRelease = (int8_t)Z_BVAL_P(zFreeOnRelease);
	zval_ptr_dtor(&zFreeOnRelease);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBServerSessionReusedEventRaw(void * _ObjectData, TObjectHandle Sender, const uint8_t pSessionID[], int32_t szSessionID, TObjectHandle SessionInfo)
{
	zval *retval_ptr;
	zval **params[3];
	zval * zSender;
	zval * zSessionID;
	zval * zSessionInfo;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zSessionID);
	ZVAL_STRINGL(zSessionID, pSessionID, szSessionID, 1);
	MAKE_STD_ZVAL(zSessionInfo);
	SBInitObject(zSessionInfo, TObject_ce_ptr, SessionInfo TSRMLS_CC);

	params[0] = &zSender;
	params[1] = &zSessionID;
	params[2] = &zSessionInfo;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 3, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zSessionID);
	zval_ptr_dtor(&zSessionInfo);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

zend_class_entry *SBSSLServer_TSBReceiveState_ce_ptr = NULL;

zend_class_entry *TSBServerState_ce_ptr = NULL;

zend_class_entry *TSBEndPoint_ce_ptr = NULL;

SB_PHP_METHOD(TSSLCipherSuite, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(TSSLCipherSuite));
		intern->len = sizeof(TSSLCipherSuite);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(TSSLCipherSuite, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(TSSLCipherSuite));
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBBaseStruct_GetField, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBBaseStruct_SetField, 0, 0, 1)
	ZEND_ARG_INFO(0, value)
ZEND_END_ARG_INFO()

SB_PHP_METHOD(TSSLCipherSuite, get_Index)
{
	SBStuctGetFieldUInt8(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(TSSLCipherSuite, set_Index)
{
	SBStuctSetFieldUInt8(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(TSSLCipherSuite, get_first)
{
	SBStuctGetFieldUInt8(INTERNAL_FUNCTION_PARAM_PASSTHRU, 1);
}

SB_PHP_METHOD(TSSLCipherSuite, set_first)
{
	SBStuctSetFieldUInt8(INTERNAL_FUNCTION_PARAM_PASSTHRU, 1);
}

SB_PHP_METHOD(TSSLCipherSuite, get_second)
{
	SBStuctGetFieldUInt8(INTERNAL_FUNCTION_PARAM_PASSTHRU, 2);
}

SB_PHP_METHOD(TSSLCipherSuite, set_second)
{
	SBStuctSetFieldUInt8(INTERNAL_FUNCTION_PARAM_PASSTHRU, 2);
}

SB_PHP_METHOD(TSSLCipherSuite, get_third)
{
	SBStuctGetFieldUInt8(INTERNAL_FUNCTION_PARAM_PASSTHRU, 3);
}

SB_PHP_METHOD(TSSLCipherSuite, set_third)
{
	SBStuctSetFieldUInt8(INTERNAL_FUNCTION_PARAM_PASSTHRU, 3);
}

SB_PHP_METHOD(TSSLCipherSuite, get_PRFHashAlgorithm)
{
	SBStuctGetFieldInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 12);
}

SB_PHP_METHOD(TSSLCipherSuite, set_PRFHashAlgorithm)
{
	SBStuctSetFieldInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 12);
}

SB_PHP_METHOD(TSSLCipherSuite, get_HashSize)
{
	SBStuctGetFieldUInt8(INTERNAL_FUNCTION_PARAM_PASSTHRU, 16);
}

SB_PHP_METHOD(TSSLCipherSuite, set_HashSize)
{
	SBStuctSetFieldUInt8(INTERNAL_FUNCTION_PARAM_PASSTHRU, 16);
}

SB_PHP_METHOD(TSSLCipherSuite, get_RealHashSize)
{
	SBStuctGetFieldUInt8(INTERNAL_FUNCTION_PARAM_PASSTHRU, 17);
}

SB_PHP_METHOD(TSSLCipherSuite, set_RealHashSize)
{
	SBStuctSetFieldUInt8(INTERNAL_FUNCTION_PARAM_PASSTHRU, 17);
}

SB_PHP_METHOD(TSSLCipherSuite, get_KeySize)
{
	SBStuctGetFieldUInt8(INTERNAL_FUNCTION_PARAM_PASSTHRU, 18);
}

SB_PHP_METHOD(TSSLCipherSuite, set_KeySize)
{
	SBStuctSetFieldUInt8(INTERNAL_FUNCTION_PARAM_PASSTHRU, 18);
}

SB_PHP_METHOD(TSSLCipherSuite, get_IVSize)
{
	SBStuctGetFieldUInt8(INTERNAL_FUNCTION_PARAM_PASSTHRU, 19);
}

SB_PHP_METHOD(TSSLCipherSuite, set_IVSize)
{
	SBStuctSetFieldUInt8(INTERNAL_FUNCTION_PARAM_PASSTHRU, 19);
}

SB_PHP_METHOD(TSSLCipherSuite, get_BlockSize)
{
	SBStuctGetFieldUInt8(INTERNAL_FUNCTION_PARAM_PASSTHRU, 20);
}

SB_PHP_METHOD(TSSLCipherSuite, set_BlockSize)
{
	SBStuctSetFieldUInt8(INTERNAL_FUNCTION_PARAM_PASSTHRU, 20);
}

SB_PHP_METHOD(TSSLCipherSuite, get_PaddingSize)
{
	SBStuctGetFieldUInt8(INTERNAL_FUNCTION_PARAM_PASSTHRU, 21);
}

SB_PHP_METHOD(TSSLCipherSuite, set_PaddingSize)
{
	SBStuctSetFieldUInt8(INTERNAL_FUNCTION_PARAM_PASSTHRU, 21);
}

zend_class_entry *TSSLCipherSuite_ce_ptr = NULL;

static zend_function_entry TSSLCipherSuite_methods[] = {
	PHP_ME(TSSLCipherSuite, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(TSSLCipherSuite, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TSSLCipherSuite, get_Index, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSSLCipherSuite, set_Index, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSSLCipherSuite, get_first, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSSLCipherSuite, set_first, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSSLCipherSuite, get_second, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSSLCipherSuite, set_second, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSSLCipherSuite, get_third, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSSLCipherSuite, set_third, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSSLCipherSuite, get_PRFHashAlgorithm, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSSLCipherSuite, set_PRFHashAlgorithm, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSSLCipherSuite, get_HashSize, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSSLCipherSuite, set_HashSize, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSSLCipherSuite, get_RealHashSize, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSSLCipherSuite, set_RealHashSize, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSSLCipherSuite, get_KeySize, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSSLCipherSuite, set_KeySize, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSSLCipherSuite, get_IVSize, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSSLCipherSuite, set_IVSize, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSSLCipherSuite, get_BlockSize, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSSLCipherSuite, set_BlockSize, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSSLCipherSuite, get_PaddingSize, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSSLCipherSuite, set_PaddingSize, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TSSLCipherSuite(TSRMLS_D)
{
	zend_class_entry ce;
	if (TSSLCipherSuite_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "TSSLCipherSuite", TSSLCipherSuite_methods);
	TSSLCipherSuite_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(TSSL2SecureParams, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(TSSL2SecureParams));
		intern->len = sizeof(TSSL2SecureParams);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(TSSL2SecureParams, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(TSSL2SecureParams));
}

zend_class_entry *TSSL2SecureParams_ce_ptr = NULL;

static zend_function_entry TSSL2SecureParams_methods[] = {
	PHP_ME(TSSL2SecureParams, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(TSSL2SecureParams, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_FE_END
};

void Register_TSSL2SecureParams(TSRMLS_D)
{
	zend_class_entry ce;
	if (TSSL2SecureParams_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "TSSL2SecureParams", TSSL2SecureParams_methods);
	TSSL2SecureParams_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(TSSL3SecureParams, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(TSSL3SecureParams));
		intern->len = sizeof(TSSL3SecureParams);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(TSSL3SecureParams, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(TSSL3SecureParams));
}

zend_class_entry *TSSL3SecureParams_ce_ptr = NULL;

static zend_function_entry TSSL3SecureParams_methods[] = {
	PHP_ME(TSSL3SecureParams, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(TSSL3SecureParams, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_FE_END
};

void Register_TSSL3SecureParams(TSRMLS_D)
{
	zend_class_entry ce;
	if (TSSL3SecureParams_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "TSSL3SecureParams", TSSL3SecureParams_methods);
	TSSL3SecureParams_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TSBAuthenticationLevel_ce_ptr = NULL;

zend_class_entry *TElServerSSLConnectionInfo_ce_ptr = NULL;

SB_PHP_METHOD(TElServerSSLConnectionInfo, Initialize)
{
	long fVersion;
	long u1Ciphersuite;
	SBArrayZValInfo aiSessionID;
	zend_bool bResumedSession;
	zval *oClientChain;
	zval *oServerChain;
	zval *zaSessionID;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "llO!O!zb", &fVersion, &u1Ciphersuite, &oServerChain, TElCustomCertStorage_ce_ptr, &oClientChain, TElCustomCertStorage_ce_ptr, &zaSessionID, &bResumedSession) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaSessionID)) || (IS_ARRAY == Z_TYPE_P(zaSessionID)) || (IS_NULL == Z_TYPE_P(zaSessionID))))
	{
		if (!SBGetByteArrayFromZVal(zaSessionID, &aiSessionID TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElServerSSLConnectionInfo_Initialize(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBVersionRaw)fVersion, (uint8_t)u1Ciphersuite, SBGetObjectHandle(oServerChain TSRMLS_CC), SBGetObjectHandle(oClientChain TSRMLS_CC), aiSessionID.data, aiSessionID.len, (int8_t)bResumedSession) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiSessionID);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer, TElCustomCertStorage, TElCustomCertStorage, array of byte|string|NULL, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElServerSSLConnectionInfo, Initialize2)
{
	long fVersion;
	long l4ECCurve;
	long u1Ciphersuite;
	SBArrayZValInfo aiSessionID;
	zend_bool bResumedSession;
	zval *oClientChain;
	zval *oServerChain;
	zval *zaSessionID;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "llO!O!zbl", &fVersion, &u1Ciphersuite, &oServerChain, TElCustomCertStorage_ce_ptr, &oClientChain, TElCustomCertStorage_ce_ptr, &zaSessionID, &bResumedSession, &l4ECCurve) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaSessionID)) || (IS_ARRAY == Z_TYPE_P(zaSessionID)) || (IS_NULL == Z_TYPE_P(zaSessionID))))
	{
		if (!SBGetByteArrayFromZVal(zaSessionID, &aiSessionID TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElServerSSLConnectionInfo_Initialize2(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBVersionRaw)fVersion, (uint8_t)u1Ciphersuite, SBGetObjectHandle(oServerChain TSRMLS_CC), SBGetObjectHandle(oClientChain TSRMLS_CC), aiSessionID.data, aiSessionID.len, (int8_t)bResumedSession, (int32_t)l4ECCurve) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiSessionID);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer, TElCustomCertStorage, TElCustomCertStorage, array of byte|string|NULL, bool, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElServerSSLConnectionInfo, Reset)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElServerSSLConnectionInfo_Reset(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElServerSSLConnectionInfo, __construct)
{
	zval *oOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oOwner, TElSSLClass_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElServerSSLConnectionInfo_Create(SBGetObjectHandle(oOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSSLClass)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElServerSSLConnectionInfo_Initialize, 0, 0, 6)
	ZEND_ARG_INFO(0, Version)
	ZEND_ARG_INFO(0, Ciphersuite)
	ZEND_ARG_OBJ_INFO(0, ServerChain, TElCustomCertStorage, 1)
	ZEND_ARG_OBJ_INFO(0, ClientChain, TElCustomCertStorage, 1)
	ZEND_ARG_TYPE_INFO(0, SessionID, 0, 1)
	ZEND_ARG_INFO(0, ResumedSession)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElServerSSLConnectionInfo_Initialize2, 0, 0, 7)
	ZEND_ARG_INFO(0, Version)
	ZEND_ARG_INFO(0, Ciphersuite)
	ZEND_ARG_OBJ_INFO(0, ServerChain, TElCustomCertStorage, 1)
	ZEND_ARG_OBJ_INFO(0, ClientChain, TElCustomCertStorage, 1)
	ZEND_ARG_TYPE_INFO(0, SessionID, 0, 1)
	ZEND_ARG_INFO(0, ResumedSession)
	ZEND_ARG_INFO(0, ECCurve)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElServerSSLConnectionInfo_Reset, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElServerSSLConnectionInfo___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Owner, TElSSLClass, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElServerSSLConnectionInfo_methods[] = {
	PHP_ME(TElServerSSLConnectionInfo, Initialize, arginfo_TElServerSSLConnectionInfo_Initialize, ZEND_ACC_PUBLIC)
	PHP_ME(TElServerSSLConnectionInfo, Initialize2, arginfo_TElServerSSLConnectionInfo_Initialize2, ZEND_ACC_PUBLIC)
	PHP_ME(TElServerSSLConnectionInfo, Reset, arginfo_TElServerSSLConnectionInfo_Reset, ZEND_ACC_PUBLIC)
	PHP_ME(TElServerSSLConnectionInfo, __construct, arginfo_TElServerSSLConnectionInfo___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElServerSSLConnectionInfo(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElServerSSLConnectionInfo_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElServerSSLConnectionInfo", TElServerSSLConnectionInfo_methods);
	if (NULL == TElSSLConnectionInfo_ce_ptr)
		Register_TElSSLConnectionInfo(TSRMLS_C);
	TElServerSSLConnectionInfo_ce_ptr = zend_register_internal_class_ex(&ce, TElSSLConnectionInfo_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElSSLServer_ce_ptr = NULL;

SB_PHP_METHOD(TElSSLServer, Open)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElSSLServer_Open(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSLServer, Close)
{
	zend_bool bSilent;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bSilent) == SUCCESS)
	{
		SBCheckError(TElSSLServer_Close(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bSilent) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSLServer, SendData)
{
	long l4Size;
	SBArrayZValInfo piBuffer;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zpBuffer, &l4Size) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElSSLServer_SendData(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, (int32_t)l4Size) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSLServer, SendText)
{
	SBArrayZValInfo aiS;
	zval *zaS;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaS) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaS)) || (IS_ARRAY == Z_TYPE_P(zaS)) || (IS_NULL == Z_TYPE_P(zaS))))
	{
		if (!SBGetByteArrayFromZVal(zaS, &aiS TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElSSLServer_SendText(SBGetObjectHandle(getThis() TSRMLS_CC), aiS.data, aiS.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiS);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSLServer, SendKeepAlive)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSSLServer_SendKeepAlive(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSLServer, DataAvailable)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElSSLServer_DataAvailable(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSLServer, InternalValidate)
{
	TSBCertificateValidityRaw fValidityRaw;
	TSBCertificateValidityReasonRaw fReasonRaw;
	zval *zfReason;
	zval *zfValidity;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zz", &zfValidity, &zfReason) == SUCCESS) && PZVAL_IS_REF(zfValidity) && (IS_LONG == Z_TYPE_P(zfValidity)) && PZVAL_IS_REF(zfReason) && (IS_LONG == Z_TYPE_P(zfReason)))
	{
		fValidityRaw = (TSBCertificateValidityRaw)Z_LVAL_P(zfValidity);
		fReasonRaw = (TSBCertificateValidityReasonRaw)Z_LVAL_P(zfReason);
		SBCheckError(TElSSLServer_InternalValidate(SBGetObjectHandle(getThis() TSRMLS_CC), &fValidityRaw, &fReasonRaw) TSRMLS_CC);
		ZVAL_LONG(zfValidity, (long)fValidityRaw);
		ZVAL_LONG(zfReason, (long)fReasonRaw);
	}
	else
	{
		SBErrorExpectsArguments("(&integer, &integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSLServer, RenegotiateCiphers)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElSSLServer_RenegotiateCiphers(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSLServer, AssignFromTemplate)
{
	zval *oTpl;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oTpl, TElSSLClass_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSSLServer_AssignFromTemplate(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oTpl TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSSLClass)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSLServer, get_CipherSuite)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t u1OutResultRaw = 0;
		SBCheckError(TElSSLServer_get_CipherSuite(SBGetObjectHandle(getThis() TSRMLS_CC), &u1OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u1OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSLServer, get_ECCurves)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSSLServer_get_ECCurves(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSLServer, set_ECCurves)
{
	long l4Index;
	zend_bool bEnabled;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lb", &l4Index, &bEnabled) == SUCCESS)
	{
		SBCheckError(TElSSLServer_set_ECCurves(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, (int8_t)bEnabled) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSLServer, get_ECPoints)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSSLServer_get_ECPoints(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSLServer, set_ECPoints)
{
	long l4Index;
	zend_bool bEnabled;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lb", &l4Index, &bEnabled) == SUCCESS)
	{
		SBCheckError(TElSSLServer_set_ECPoints(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, (int8_t)bEnabled) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSLServer, get_ECCurveType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSSLServer_get_ECCurveType(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSLServer, set_ECCurveType)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElSSLServer_set_ECCurveType(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSLServer, get_SessionID)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElSSLServer_get_SessionID(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-1810079694, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSLServer, get_ServerState)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBServerStateRaw fOutResultRaw = 0;
		SBCheckError(TElSSLServer_get_ServerState(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSLServer, get_Enabled)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSSLServer_get_Enabled(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSLServer, set_Enabled)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSSLServer_set_Enabled(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSLServer, get_ClientAuthentication)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSSLServer_get_ClientAuthentication(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSLServer, set_ClientAuthentication)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSSLServer_set_ClientAuthentication(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSLServer, get_AuthenticationLevel)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBAuthenticationLevelRaw fOutResultRaw = 0;
		SBCheckError(TElSSLServer_get_AuthenticationLevel(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSLServer, set_AuthenticationLevel)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElSSLServer_set_AuthenticationLevel(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBAuthenticationLevelRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSLServer, get_ForceCertificateChain)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSSLServer_get_ForceCertificateChain(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSLServer, set_ForceCertificateChain)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSSLServer_set_ForceCertificateChain(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSLServer, get_CertStorage)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSSLServer_get_CertStorage(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomCertStorage_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSLServer, set_CertStorage)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElCustomCertStorage_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSSLServer_set_CertStorage(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCertStorage)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSLServer, get_KeyStorage)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSSLServer_get_KeyStorage(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElKeyMaterialStorage_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSLServer, set_KeyStorage)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElKeyMaterialStorage_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSSLServer_set_KeyStorage(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElKeyMaterialStorage)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSLServer, get_SessionPool)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSSLServer_get_SessionPool(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElSessionPool_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSLServer, set_SessionPool)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElSessionPool_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSSLServer_set_SessionPool(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSessionPool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSLServer, get_ClientCertStorage)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSSLServer_get_ClientCertStorage(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomCertStorage_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSLServer, set_ClientCertStorage)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElCustomCertStorage_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSSLServer_set_ClientCertStorage(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCertStorage)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSLServer, get_Extensions)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSSLServer_get_Extensions(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElServerSSLExtensions_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSLServer, get_PeerExtensions)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSSLServer_get_PeerExtensions(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElClientSSLExtensions_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSLServer, get_OnlyWithExtendedMasterSecret)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSSLServer_get_OnlyWithExtendedMasterSecret(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSLServer, set_OnlyWithExtendedMasterSecret)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSSLServer_set_OnlyWithExtendedMasterSecret(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSLServer, get_SRPCredentialStore)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSSLServer_get_SRPCredentialStore(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElSRPCredentialStore_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSLServer, set_SRPCredentialStore)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElSRPCredentialStore_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSSLServer_set_SRPCredentialStore(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSRPCredentialStore)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSLServer, get_OnGetSrpDb)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBServerSrpDbNeededEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSSLServer_get_OnGetSrpDb(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSLServer, set_OnGetSrpDb)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSSLServer_set_OnGetSrpDb(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBServerSrpDbNeededEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBServerSrpDbNeededEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSLServer, get_OnKeyNeeded)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBServerKeyNeededEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSSLServer_get_OnKeyNeeded(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSLServer, set_OnKeyNeeded)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSSLServer_set_OnKeyNeeded(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBServerKeyNeededEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBServerKeyNeededEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSLServer, get_OnCloseConnection)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBCloseConnectionEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSSLServer_get_OnCloseConnection(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSLServer, set_OnCloseConnection)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSSLServer_set_OnCloseConnection(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBCloseConnectionEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBCloseConnectionEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSLServer, get_OnRenegotiationStart)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBRenegotiationStartEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSSLServer_get_OnRenegotiationStart(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSLServer, set_OnRenegotiationStart)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSSLServer_set_OnRenegotiationStart(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBRenegotiationStartEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBRenegotiationStartEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSLServer, get_OnCertificateURLs)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBCertificateURLsEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSSLServer_get_OnCertificateURLs(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSLServer, set_OnCertificateURLs)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSSLServer_set_OnCertificateURLs(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBCertificateURLsEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBCertificateURLsEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSLServer, get_OnSessionReused)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBServerSessionReusedEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSSLServer_get_OnSessionReused(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSLServer, set_OnSessionReused)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSSLServer_set_OnSessionReused(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBServerSessionReusedEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBServerSessionReusedEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSLServer, get_OnSessionCreated)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBServerSessionCreatedEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSSLServer_get_OnSessionCreated(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSLServer, set_OnSessionCreated)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSSLServer_set_OnSessionCreated(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBServerSessionCreatedEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBServerSessionCreatedEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSLServer, __construct)
{
	zval *oOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSSLServer_Create(SBGetObjectHandle(oOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSLServer_Open, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSLServer_Close, 0, 0, 1)
	ZEND_ARG_INFO(0, Silent)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSLServer_SendData, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(0, Size)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSLServer_SendText, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, S, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSLServer_SendKeepAlive, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSLServer_DataAvailable, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSLServer_InternalValidate, 0, 0, 2)
	ZEND_ARG_INFO(1, Validity)
	ZEND_ARG_INFO(1, Reason)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSLServer_RenegotiateCiphers, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSLServer_AssignFromTemplate, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Tpl, TElSSLClass, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSLServer_get_CipherSuite, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSLServer_get_ECCurves, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSLServer_set_ECCurves, 0, 0, 2)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_INFO(0, Enabled)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSLServer_get_ECPoints, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSLServer_set_ECPoints, 0, 0, 2)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_INFO(0, Enabled)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSLServer_get_ECCurveType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSLServer_set_ECCurveType, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSLServer_get_SessionID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSLServer_get_ServerState, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSLServer_get_Enabled, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSLServer_set_Enabled, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSLServer_get_ClientAuthentication, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSLServer_set_ClientAuthentication, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSLServer_get_AuthenticationLevel, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSLServer_set_AuthenticationLevel, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSLServer_get_ForceCertificateChain, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSLServer_set_ForceCertificateChain, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSLServer_get_CertStorage, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSLServer_set_CertStorage, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElCustomCertStorage, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSLServer_get_KeyStorage, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSLServer_set_KeyStorage, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElKeyMaterialStorage, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSLServer_get_SessionPool, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSLServer_set_SessionPool, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElSessionPool, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSLServer_get_ClientCertStorage, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSLServer_set_ClientCertStorage, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElCustomCertStorage, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSLServer_get_Extensions, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSLServer_get_PeerExtensions, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSLServer_get_OnlyWithExtendedMasterSecret, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSLServer_set_OnlyWithExtendedMasterSecret, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSLServer_get_SRPCredentialStore, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSLServer_set_SRPCredentialStore, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElSRPCredentialStore, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSLServer_get_OnGetSrpDb, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSLServer_set_OnGetSrpDb, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSLServer_get_OnKeyNeeded, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSLServer_set_OnKeyNeeded, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSLServer_get_OnCloseConnection, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSLServer_set_OnCloseConnection, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSLServer_get_OnRenegotiationStart, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSLServer_set_OnRenegotiationStart, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSLServer_get_OnCertificateURLs, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSLServer_set_OnCertificateURLs, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSLServer_get_OnSessionReused, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSLServer_set_OnSessionReused, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSLServer_get_OnSessionCreated, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSLServer_set_OnSessionCreated, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSLServer___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Owner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElSSLServer_methods[] = {
	PHP_ME(TElSSLServer, Open, arginfo_TElSSLServer_Open, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSLServer, Close, arginfo_TElSSLServer_Close, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSLServer, SendData, arginfo_TElSSLServer_SendData, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSLServer, SendText, arginfo_TElSSLServer_SendText, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSLServer, SendKeepAlive, arginfo_TElSSLServer_SendKeepAlive, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSLServer, DataAvailable, arginfo_TElSSLServer_DataAvailable, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSLServer, InternalValidate, arginfo_TElSSLServer_InternalValidate, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSLServer, RenegotiateCiphers, arginfo_TElSSLServer_RenegotiateCiphers, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSLServer, AssignFromTemplate, arginfo_TElSSLServer_AssignFromTemplate, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSLServer, get_CipherSuite, arginfo_TElSSLServer_get_CipherSuite, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSLServer, get_ECCurves, arginfo_TElSSLServer_get_ECCurves, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSLServer, set_ECCurves, arginfo_TElSSLServer_set_ECCurves, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSLServer, get_ECPoints, arginfo_TElSSLServer_get_ECPoints, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSLServer, set_ECPoints, arginfo_TElSSLServer_set_ECPoints, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSLServer, get_ECCurveType, arginfo_TElSSLServer_get_ECCurveType, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSLServer, set_ECCurveType, arginfo_TElSSLServer_set_ECCurveType, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSLServer, get_SessionID, arginfo_TElSSLServer_get_SessionID, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSLServer, get_ServerState, arginfo_TElSSLServer_get_ServerState, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSLServer, get_Enabled, arginfo_TElSSLServer_get_Enabled, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSLServer, set_Enabled, arginfo_TElSSLServer_set_Enabled, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSLServer, get_ClientAuthentication, arginfo_TElSSLServer_get_ClientAuthentication, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSLServer, set_ClientAuthentication, arginfo_TElSSLServer_set_ClientAuthentication, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSLServer, get_AuthenticationLevel, arginfo_TElSSLServer_get_AuthenticationLevel, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSLServer, set_AuthenticationLevel, arginfo_TElSSLServer_set_AuthenticationLevel, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSLServer, get_ForceCertificateChain, arginfo_TElSSLServer_get_ForceCertificateChain, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSLServer, set_ForceCertificateChain, arginfo_TElSSLServer_set_ForceCertificateChain, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSLServer, get_CertStorage, arginfo_TElSSLServer_get_CertStorage, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSLServer, set_CertStorage, arginfo_TElSSLServer_set_CertStorage, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSLServer, get_KeyStorage, arginfo_TElSSLServer_get_KeyStorage, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSLServer, set_KeyStorage, arginfo_TElSSLServer_set_KeyStorage, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSLServer, get_SessionPool, arginfo_TElSSLServer_get_SessionPool, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSLServer, set_SessionPool, arginfo_TElSSLServer_set_SessionPool, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSLServer, get_ClientCertStorage, arginfo_TElSSLServer_get_ClientCertStorage, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSLServer, set_ClientCertStorage, arginfo_TElSSLServer_set_ClientCertStorage, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSLServer, get_Extensions, arginfo_TElSSLServer_get_Extensions, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSLServer, get_PeerExtensions, arginfo_TElSSLServer_get_PeerExtensions, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSLServer, get_OnlyWithExtendedMasterSecret, arginfo_TElSSLServer_get_OnlyWithExtendedMasterSecret, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSLServer, set_OnlyWithExtendedMasterSecret, arginfo_TElSSLServer_set_OnlyWithExtendedMasterSecret, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSLServer, get_SRPCredentialStore, arginfo_TElSSLServer_get_SRPCredentialStore, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSLServer, set_SRPCredentialStore, arginfo_TElSSLServer_set_SRPCredentialStore, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSLServer, get_OnGetSrpDb, arginfo_TElSSLServer_get_OnGetSrpDb, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSLServer, set_OnGetSrpDb, arginfo_TElSSLServer_set_OnGetSrpDb, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSLServer, get_OnKeyNeeded, arginfo_TElSSLServer_get_OnKeyNeeded, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSLServer, set_OnKeyNeeded, arginfo_TElSSLServer_set_OnKeyNeeded, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSLServer, get_OnCloseConnection, arginfo_TElSSLServer_get_OnCloseConnection, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSLServer, set_OnCloseConnection, arginfo_TElSSLServer_set_OnCloseConnection, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSLServer, get_OnRenegotiationStart, arginfo_TElSSLServer_get_OnRenegotiationStart, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSLServer, set_OnRenegotiationStart, arginfo_TElSSLServer_set_OnRenegotiationStart, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSLServer, get_OnCertificateURLs, arginfo_TElSSLServer_get_OnCertificateURLs, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSLServer, set_OnCertificateURLs, arginfo_TElSSLServer_set_OnCertificateURLs, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSLServer, get_OnSessionReused, arginfo_TElSSLServer_get_OnSessionReused, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSLServer, set_OnSessionReused, arginfo_TElSSLServer_set_OnSessionReused, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSLServer, get_OnSessionCreated, arginfo_TElSSLServer_get_OnSessionCreated, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSLServer, set_OnSessionCreated, arginfo_TElSSLServer_set_OnSessionCreated, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSLServer, __construct, arginfo_TElSSLServer___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSSLServer(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSSLServer_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSSLServer", TElSSLServer_methods);
	if (NULL == TElSSLClass_ce_ptr)
		Register_TElSSLClass(TSRMLS_C);
	TElSSLServer_ce_ptr = zend_register_internal_class_ex(&ce, TElSSLClass_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElSSLServerEnvironment_ce_ptr = NULL;

SB_PHP_METHOD(TElSSLServerEnvironment, RegenerateDH)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSSLServerEnvironment_RegenerateDH(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSLServerEnvironment, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSSLServerEnvironment_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSLServerEnvironment_RegenerateDH, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSLServerEnvironment___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElSSLServerEnvironment_methods[] = {
	PHP_ME(TElSSLServerEnvironment, RegenerateDH, arginfo_TElSSLServerEnvironment_RegenerateDH, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSLServerEnvironment, __construct, arginfo_TElSSLServerEnvironment___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSSLServerEnvironment(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSSLServerEnvironment_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSSLServerEnvironment", TElSSLServerEnvironment_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElSSLServerEnvironment_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_FUNCTION(SBSSLServer, GetTLSCipherSuiteByCode)
{
	long u1B1;
	long u1B2;
	uint8_t u1CipherSuiteRaw;
	zval *zu1CipherSuite;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "llz", &u1B1, &u1B2, &zu1CipherSuite) == SUCCESS) && PZVAL_IS_REF(zu1CipherSuite) && (IS_LONG == Z_TYPE_P(zu1CipherSuite)))
	{
		int8_t bOutResultRaw = 0;
		u1CipherSuiteRaw = (uint8_t)Z_LVAL_P(zu1CipherSuite);
		SBCheckError(SBSSLServer_GetTLSCipherSuiteByCode((uint8_t)u1B1, (uint8_t)u1B2, &u1CipherSuiteRaw, &bOutResultRaw) TSRMLS_CC);
		ZVAL_LONG(zu1CipherSuite, (long)u1CipherSuiteRaw);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer, &integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBSSLServer, PrepareSSLServerEnvironment)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(SBSSLServer_PrepareSSLServerEnvironment() TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBSSLServer, GetSSLDHKeyLength)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(SBSSLServer_GetSSLDHKeyLength(&l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBSSLServer, SetSSLDHKeyLength)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(SBSSLServer_SetSSLDHKeyLength((int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

void Register_SBSSLServer_Constants(int module_number TSRMLS_DC)
{
	SB_REGISTER_LONG_CONSTANT(SBSSLServer, SB_CLOSE_CONNECTION_OK, SB_CLOSE_CONNECTION_OK, SB_CLOSE_CONNECTION_OK);
	SB_REGISTER_LONG_CONSTANT(SBSSLServer, SB_CLOSE_CONNECTION_ERROR, SB_CLOSE_CONNECTION_ERROR, SB_CLOSE_CONNECTION_ERROR);
	SB_REGISTER_LONG_CONSTANT(SBSSLServer, SB_CLOSE_CONNECTION_NEGOTIATION_FAILED, SB_CLOSE_CONNECTION_NEGOTIATION_FAILED, SB_CLOSE_CONNECTION_NEGOTIATION_FAILED);
}

void Register_SBSSLServer_Enum_Flags(TSRMLS_D)
{
	zend_class_entry ce;
	INIT_CLASS_ENTRY(ce, "SBSSLServer_TSBReceiveState", NULL);
	SBSSLServer_TSBReceiveState_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	SBSSLServer_TSBReceiveState_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(SBSSLServer_TSBReceiveState_ce_ptr, "rsRecordHeaderWanted", 0)
	SB_DECLARE_CLASS_LONG_CONST(SBSSLServer_TSBReceiveState_ce_ptr, "rsRecordWanted", 1)
	SB_DECLARE_CLASS_LONG_CONST(SBSSLServer_TSBReceiveState_ce_ptr, "rsOneByteWanted", 2)
	
	INIT_CLASS_ENTRY(ce, "TSBServerState", NULL);
	TSBServerState_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBServerState_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBServerState_ce_ptr, "ssBeforeNegotiation", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBServerState_ce_ptr, "ssClientHelloReceived", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBServerState_ce_ptr, "ssServerHelloSent", 2)
	SB_DECLARE_CLASS_LONG_CONST(TSBServerState_ce_ptr, "ssServerCertificateSent", 3)
	SB_DECLARE_CLASS_LONG_CONST(TSBServerState_ce_ptr, "ssServerKeyExchangeSent", 4)
	SB_DECLARE_CLASS_LONG_CONST(TSBServerState_ce_ptr, "ssServerHelloDoneSent", 5)
	SB_DECLARE_CLASS_LONG_CONST(TSBServerState_ce_ptr, "ssClientKeyExchangeReceived", 6)
	SB_DECLARE_CLASS_LONG_CONST(TSBServerState_ce_ptr, "ssClientChangeCipherSpecReceived", 7)
	SB_DECLARE_CLASS_LONG_CONST(TSBServerState_ce_ptr, "ssClientFinishedReceived", 8)
	SB_DECLARE_CLASS_LONG_CONST(TSBServerState_ce_ptr, "ssApplicationDataTransfer", 9)
	SB_DECLARE_CLASS_LONG_CONST(TSBServerState_ce_ptr, "ssClientMasterKeyReceived", 10)
	
	INIT_CLASS_ENTRY(ce, "TSBEndPoint", NULL);
	TSBEndPoint_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBEndPoint_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBEndPoint_ce_ptr, "epClient", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBEndPoint_ce_ptr, "epServer", 1)
	
	INIT_CLASS_ENTRY(ce, "TSBAuthenticationLevel", NULL);
	TSBAuthenticationLevel_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBAuthenticationLevel_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBAuthenticationLevel_ce_ptr, "alRequestCert", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBAuthenticationLevel_ce_ptr, "alRequireCert", 1)
}

void Register_SBSSLServer_Aliases(TSRMLS_D)
{
	if (NULL == TElSSLServer_ce_ptr)
		Register_TElSSLServer(TSRMLS_C);
	zend_register_class_alias("ElSSLServer", TElSSLServer_ce_ptr);
}

