#include "sbdefs.h"
#ifdef SB_WINDOWS
#include "sbsspi.h"

SB_PHP_METHOD(SecHandle, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(SecHandle));
		intern->len = sizeof(SecHandle);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(SecHandle, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(SecHandle));
}

zend_class_entry *SecHandle_ce_ptr = NULL;

static zend_function_entry SecHandle_methods[] = {
	PHP_ME(SecHandle, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(SecHandle, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_FE_END
};

void Register_SecHandle(TSRMLS_D)
{
	zend_class_entry ce;
	if (SecHandle_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "SecHandle", SecHandle_methods);
	SecHandle_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(SecPkgInfoW, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(SecPkgInfoW));
		intern->len = sizeof(SecPkgInfoW);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(SecPkgInfoW, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(SecPkgInfoW));
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBBaseStruct_GetField, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBBaseStruct_SetField, 0, 0, 1)
	ZEND_ARG_INFO(0, value)
ZEND_END_ARG_INFO()

SB_PHP_METHOD(SecPkgInfoW, get_fCapabilities)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(SecPkgInfoW, set_fCapabilities)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(SecPkgInfoW, get_wVersion)
{
	SBStuctGetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 4);
}

SB_PHP_METHOD(SecPkgInfoW, set_wVersion)
{
	SBStuctSetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 4);
}

SB_PHP_METHOD(SecPkgInfoW, get_wRPCID)
{
	SBStuctGetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 6);
}

SB_PHP_METHOD(SecPkgInfoW, set_wRPCID)
{
	SBStuctSetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 6);
}

SB_PHP_METHOD(SecPkgInfoW, get_cbMaxToken)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 8);
}

SB_PHP_METHOD(SecPkgInfoW, set_cbMaxToken)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 8);
}

zend_class_entry *SecPkgInfoW_ce_ptr = NULL;

static zend_function_entry SecPkgInfoW_methods[] = {
	PHP_ME(SecPkgInfoW, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(SecPkgInfoW, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(SecPkgInfoW, get_fCapabilities, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SecPkgInfoW, set_fCapabilities, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SecPkgInfoW, get_wVersion, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SecPkgInfoW, set_wVersion, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SecPkgInfoW, get_wRPCID, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SecPkgInfoW, set_wRPCID, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SecPkgInfoW, get_cbMaxToken, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SecPkgInfoW, set_cbMaxToken, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_SecPkgInfoW(TSRMLS_D)
{
	zend_class_entry ce;
	if (SecPkgInfoW_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "SecPkgInfoW", SecPkgInfoW_methods);
	SecPkgInfoW_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(SecPkgInfoA, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(SecPkgInfoA));
		intern->len = sizeof(SecPkgInfoA);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(SecPkgInfoA, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(SecPkgInfoA));
}

SB_PHP_METHOD(SecPkgInfoA, get_fCapabilities)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(SecPkgInfoA, set_fCapabilities)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(SecPkgInfoA, get_wVersion)
{
	SBStuctGetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 4);
}

SB_PHP_METHOD(SecPkgInfoA, set_wVersion)
{
	SBStuctSetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 4);
}

SB_PHP_METHOD(SecPkgInfoA, get_wRPCID)
{
	SBStuctGetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 6);
}

SB_PHP_METHOD(SecPkgInfoA, set_wRPCID)
{
	SBStuctSetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 6);
}

SB_PHP_METHOD(SecPkgInfoA, get_cbMaxToken)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 8);
}

SB_PHP_METHOD(SecPkgInfoA, set_cbMaxToken)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 8);
}

zend_class_entry *SecPkgInfoA_ce_ptr = NULL;

static zend_function_entry SecPkgInfoA_methods[] = {
	PHP_ME(SecPkgInfoA, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(SecPkgInfoA, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(SecPkgInfoA, get_fCapabilities, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SecPkgInfoA, set_fCapabilities, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SecPkgInfoA, get_wVersion, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SecPkgInfoA, set_wVersion, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SecPkgInfoA, get_wRPCID, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SecPkgInfoA, set_wRPCID, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SecPkgInfoA, get_cbMaxToken, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SecPkgInfoA, set_cbMaxToken, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_SecPkgInfoA(TSRMLS_D)
{
	zend_class_entry ce;
	if (SecPkgInfoA_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "SecPkgInfoA", SecPkgInfoA_methods);
	SecPkgInfoA_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(SBSSPI_SecBuffer, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(SBSSPI_SecBuffer));
		intern->len = sizeof(SBSSPI_SecBuffer);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(SBSSPI_SecBuffer, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(SBSSPI_SecBuffer));
}

SB_PHP_METHOD(SBSSPI_SecBuffer, get_cbBuffer)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(SBSSPI_SecBuffer, set_cbBuffer)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(SBSSPI_SecBuffer, get_BufferType)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 4);
}

SB_PHP_METHOD(SBSSPI_SecBuffer, set_BufferType)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 4);
}

zend_class_entry *SBSSPI_SecBuffer_ce_ptr = NULL;

static zend_function_entry SBSSPI_SecBuffer_methods[] = {
	PHP_ME(SBSSPI_SecBuffer, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(SBSSPI_SecBuffer, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(SBSSPI_SecBuffer, get_cbBuffer, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBSSPI_SecBuffer, set_cbBuffer, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBSSPI_SecBuffer, get_BufferType, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBSSPI_SecBuffer, set_BufferType, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_SBSSPI_SecBuffer(TSRMLS_D)
{
	zend_class_entry ce;
	if (SBSSPI_SecBuffer_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "SBSSPI_SecBuffer", SBSSPI_SecBuffer_methods);
	SBSSPI_SecBuffer_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(SBSSPI_SecBufferDesc, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(SBSSPI_SecBufferDesc));
		intern->len = sizeof(SBSSPI_SecBufferDesc);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(SBSSPI_SecBufferDesc, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(SBSSPI_SecBufferDesc));
}

SB_PHP_METHOD(SBSSPI_SecBufferDesc, get_ulVersion)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(SBSSPI_SecBufferDesc, set_ulVersion)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(SBSSPI_SecBufferDesc, get_cBuffers)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 4);
}

SB_PHP_METHOD(SBSSPI_SecBufferDesc, set_cBuffers)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 4);
}

zend_class_entry *SBSSPI_SecBufferDesc_ce_ptr = NULL;

static zend_function_entry SBSSPI_SecBufferDesc_methods[] = {
	PHP_ME(SBSSPI_SecBufferDesc, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(SBSSPI_SecBufferDesc, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(SBSSPI_SecBufferDesc, get_ulVersion, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBSSPI_SecBufferDesc, set_ulVersion, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBSSPI_SecBufferDesc, get_cBuffers, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBSSPI_SecBufferDesc, set_cBuffers, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_SBSSPI_SecBufferDesc(TSRMLS_D)
{
	zend_class_entry ce;
	if (SBSSPI_SecBufferDesc_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "SBSSPI_SecBufferDesc", SBSSPI_SecBufferDesc_methods);
	SBSSPI_SecBufferDesc_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(SEC_NEGOTIATION_INFO, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(SEC_NEGOTIATION_INFO));
		intern->len = sizeof(SEC_NEGOTIATION_INFO);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(SEC_NEGOTIATION_INFO, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(SEC_NEGOTIATION_INFO));
}

SB_PHP_METHOD(SEC_NEGOTIATION_INFO, get_Size)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(SEC_NEGOTIATION_INFO, set_Size)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(SEC_NEGOTIATION_INFO, get_NameLength)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 4);
}

SB_PHP_METHOD(SEC_NEGOTIATION_INFO, set_NameLength)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 4);
}

zend_class_entry *SEC_NEGOTIATION_INFO_ce_ptr = NULL;

static zend_function_entry SEC_NEGOTIATION_INFO_methods[] = {
	PHP_ME(SEC_NEGOTIATION_INFO, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(SEC_NEGOTIATION_INFO, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(SEC_NEGOTIATION_INFO, get_Size, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SEC_NEGOTIATION_INFO, set_Size, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SEC_NEGOTIATION_INFO, get_NameLength, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SEC_NEGOTIATION_INFO, set_NameLength, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_SEC_NEGOTIATION_INFO(TSRMLS_D)
{
	zend_class_entry ce;
	if (SEC_NEGOTIATION_INFO_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "SEC_NEGOTIATION_INFO", SEC_NEGOTIATION_INFO_methods);
	SEC_NEGOTIATION_INFO_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(SEC_CHANNEL_BINDINGS, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(SEC_CHANNEL_BINDINGS));
		intern->len = sizeof(SEC_CHANNEL_BINDINGS);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(SEC_CHANNEL_BINDINGS, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(SEC_CHANNEL_BINDINGS));
}

SB_PHP_METHOD(SEC_CHANNEL_BINDINGS, get_dwInitiatorAddrType)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(SEC_CHANNEL_BINDINGS, set_dwInitiatorAddrType)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(SEC_CHANNEL_BINDINGS, get_cbInitiatorLength)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 4);
}

SB_PHP_METHOD(SEC_CHANNEL_BINDINGS, set_cbInitiatorLength)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 4);
}

SB_PHP_METHOD(SEC_CHANNEL_BINDINGS, get_dwInitiatorOffset)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 8);
}

SB_PHP_METHOD(SEC_CHANNEL_BINDINGS, set_dwInitiatorOffset)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 8);
}

SB_PHP_METHOD(SEC_CHANNEL_BINDINGS, get_dwAcceptorAddrType)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 12);
}

SB_PHP_METHOD(SEC_CHANNEL_BINDINGS, set_dwAcceptorAddrType)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 12);
}

SB_PHP_METHOD(SEC_CHANNEL_BINDINGS, get_cbAcceptorLength)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 16);
}

SB_PHP_METHOD(SEC_CHANNEL_BINDINGS, set_cbAcceptorLength)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 16);
}

SB_PHP_METHOD(SEC_CHANNEL_BINDINGS, get_dwAcceptorOffset)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 20);
}

SB_PHP_METHOD(SEC_CHANNEL_BINDINGS, set_dwAcceptorOffset)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 20);
}

SB_PHP_METHOD(SEC_CHANNEL_BINDINGS, get_cbApplicationDataLength)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 24);
}

SB_PHP_METHOD(SEC_CHANNEL_BINDINGS, set_cbApplicationDataLength)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 24);
}

SB_PHP_METHOD(SEC_CHANNEL_BINDINGS, get_dwApplicationDataOffset)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 28);
}

SB_PHP_METHOD(SEC_CHANNEL_BINDINGS, set_dwApplicationDataOffset)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 28);
}

zend_class_entry *SEC_CHANNEL_BINDINGS_ce_ptr = NULL;

static zend_function_entry SEC_CHANNEL_BINDINGS_methods[] = {
	PHP_ME(SEC_CHANNEL_BINDINGS, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(SEC_CHANNEL_BINDINGS, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(SEC_CHANNEL_BINDINGS, get_dwInitiatorAddrType, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SEC_CHANNEL_BINDINGS, set_dwInitiatorAddrType, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SEC_CHANNEL_BINDINGS, get_cbInitiatorLength, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SEC_CHANNEL_BINDINGS, set_cbInitiatorLength, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SEC_CHANNEL_BINDINGS, get_dwInitiatorOffset, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SEC_CHANNEL_BINDINGS, set_dwInitiatorOffset, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SEC_CHANNEL_BINDINGS, get_dwAcceptorAddrType, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SEC_CHANNEL_BINDINGS, set_dwAcceptorAddrType, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SEC_CHANNEL_BINDINGS, get_cbAcceptorLength, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SEC_CHANNEL_BINDINGS, set_cbAcceptorLength, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SEC_CHANNEL_BINDINGS, get_dwAcceptorOffset, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SEC_CHANNEL_BINDINGS, set_dwAcceptorOffset, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SEC_CHANNEL_BINDINGS, get_cbApplicationDataLength, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SEC_CHANNEL_BINDINGS, set_cbApplicationDataLength, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SEC_CHANNEL_BINDINGS, get_dwApplicationDataOffset, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SEC_CHANNEL_BINDINGS, set_dwApplicationDataOffset, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_SEC_CHANNEL_BINDINGS(TSRMLS_D)
{
	zend_class_entry ce;
	if (SEC_CHANNEL_BINDINGS_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "SEC_CHANNEL_BINDINGS", SEC_CHANNEL_BINDINGS_methods);
	SEC_CHANNEL_BINDINGS_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(SecPkgCredentials_NamesW, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(SecPkgCredentials_NamesW));
		intern->len = sizeof(SecPkgCredentials_NamesW);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(SecPkgCredentials_NamesW, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(SecPkgCredentials_NamesW));
}

zend_class_entry *SecPkgCredentials_NamesW_ce_ptr = NULL;

static zend_function_entry SecPkgCredentials_NamesW_methods[] = {
	PHP_ME(SecPkgCredentials_NamesW, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(SecPkgCredentials_NamesW, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_FE_END
};

void Register_SecPkgCredentials_NamesW(TSRMLS_D)
{
	zend_class_entry ce;
	if (SecPkgCredentials_NamesW_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "SecPkgCredentials_NamesW", SecPkgCredentials_NamesW_methods);
	SecPkgCredentials_NamesW_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(SecPkgCredentials_NamesA, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(SecPkgCredentials_NamesA));
		intern->len = sizeof(SecPkgCredentials_NamesA);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(SecPkgCredentials_NamesA, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(SecPkgCredentials_NamesA));
}

zend_class_entry *SecPkgCredentials_NamesA_ce_ptr = NULL;

static zend_function_entry SecPkgCredentials_NamesA_methods[] = {
	PHP_ME(SecPkgCredentials_NamesA, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(SecPkgCredentials_NamesA, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_FE_END
};

void Register_SecPkgCredentials_NamesA(TSRMLS_D)
{
	zend_class_entry ce;
	if (SecPkgCredentials_NamesA_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "SecPkgCredentials_NamesA", SecPkgCredentials_NamesA_methods);
	SecPkgCredentials_NamesA_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(SecPkgCredentials_SSIProviderW, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(SecPkgCredentials_SSIProviderW));
		intern->len = sizeof(SecPkgCredentials_SSIProviderW);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(SecPkgCredentials_SSIProviderW, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(SecPkgCredentials_SSIProviderW));
}

SB_PHP_METHOD(SecPkgCredentials_SSIProviderW, get_ProviderInfoLength)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 4);
}

SB_PHP_METHOD(SecPkgCredentials_SSIProviderW, set_ProviderInfoLength)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 4);
}

zend_class_entry *SecPkgCredentials_SSIProviderW_ce_ptr = NULL;

static zend_function_entry SecPkgCredentials_SSIProviderW_methods[] = {
	PHP_ME(SecPkgCredentials_SSIProviderW, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(SecPkgCredentials_SSIProviderW, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(SecPkgCredentials_SSIProviderW, get_ProviderInfoLength, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SecPkgCredentials_SSIProviderW, set_ProviderInfoLength, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_SecPkgCredentials_SSIProviderW(TSRMLS_D)
{
	zend_class_entry ce;
	if (SecPkgCredentials_SSIProviderW_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "SecPkgCredentials_SSIProviderW", SecPkgCredentials_SSIProviderW_methods);
	SecPkgCredentials_SSIProviderW_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(SecPkgCredentials_SSIProviderA, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(SecPkgCredentials_SSIProviderA));
		intern->len = sizeof(SecPkgCredentials_SSIProviderA);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(SecPkgCredentials_SSIProviderA, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(SecPkgCredentials_SSIProviderA));
}

SB_PHP_METHOD(SecPkgCredentials_SSIProviderA, get_ProviderInfoLength)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 4);
}

SB_PHP_METHOD(SecPkgCredentials_SSIProviderA, set_ProviderInfoLength)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 4);
}

zend_class_entry *SecPkgCredentials_SSIProviderA_ce_ptr = NULL;

static zend_function_entry SecPkgCredentials_SSIProviderA_methods[] = {
	PHP_ME(SecPkgCredentials_SSIProviderA, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(SecPkgCredentials_SSIProviderA, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(SecPkgCredentials_SSIProviderA, get_ProviderInfoLength, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SecPkgCredentials_SSIProviderA, set_ProviderInfoLength, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_SecPkgCredentials_SSIProviderA(TSRMLS_D)
{
	zend_class_entry ce;
	if (SecPkgCredentials_SSIProviderA_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "SecPkgCredentials_SSIProviderA", SecPkgCredentials_SSIProviderA_methods);
	SecPkgCredentials_SSIProviderA_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(SecPkgContext_Sizes, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(SecPkgContext_Sizes));
		intern->len = sizeof(SecPkgContext_Sizes);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(SecPkgContext_Sizes, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(SecPkgContext_Sizes));
}

SB_PHP_METHOD(SecPkgContext_Sizes, get_cbMaxToken)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(SecPkgContext_Sizes, set_cbMaxToken)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(SecPkgContext_Sizes, get_cbMaxSignature)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 4);
}

SB_PHP_METHOD(SecPkgContext_Sizes, set_cbMaxSignature)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 4);
}

SB_PHP_METHOD(SecPkgContext_Sizes, get_cbBlockSize)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 8);
}

SB_PHP_METHOD(SecPkgContext_Sizes, set_cbBlockSize)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 8);
}

SB_PHP_METHOD(SecPkgContext_Sizes, get_cbSecurityTrailer)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 12);
}

SB_PHP_METHOD(SecPkgContext_Sizes, set_cbSecurityTrailer)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 12);
}

zend_class_entry *SecPkgContext_Sizes_ce_ptr = NULL;

static zend_function_entry SecPkgContext_Sizes_methods[] = {
	PHP_ME(SecPkgContext_Sizes, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(SecPkgContext_Sizes, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(SecPkgContext_Sizes, get_cbMaxToken, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SecPkgContext_Sizes, set_cbMaxToken, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SecPkgContext_Sizes, get_cbMaxSignature, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SecPkgContext_Sizes, set_cbMaxSignature, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SecPkgContext_Sizes, get_cbBlockSize, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SecPkgContext_Sizes, set_cbBlockSize, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SecPkgContext_Sizes, get_cbSecurityTrailer, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SecPkgContext_Sizes, set_cbSecurityTrailer, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_SecPkgContext_Sizes(TSRMLS_D)
{
	zend_class_entry ce;
	if (SecPkgContext_Sizes_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "SecPkgContext_Sizes", SecPkgContext_Sizes_methods);
	SecPkgContext_Sizes_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(SecPkgContext_StreamSizes, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(SecPkgContext_StreamSizes));
		intern->len = sizeof(SecPkgContext_StreamSizes);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(SecPkgContext_StreamSizes, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(SecPkgContext_StreamSizes));
}

SB_PHP_METHOD(SecPkgContext_StreamSizes, get_cbHeader)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(SecPkgContext_StreamSizes, set_cbHeader)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(SecPkgContext_StreamSizes, get_cbTrailer)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 4);
}

SB_PHP_METHOD(SecPkgContext_StreamSizes, set_cbTrailer)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 4);
}

SB_PHP_METHOD(SecPkgContext_StreamSizes, get_cbMaximumMessage)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 8);
}

SB_PHP_METHOD(SecPkgContext_StreamSizes, set_cbMaximumMessage)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 8);
}

SB_PHP_METHOD(SecPkgContext_StreamSizes, get_cBuffers)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 12);
}

SB_PHP_METHOD(SecPkgContext_StreamSizes, set_cBuffers)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 12);
}

SB_PHP_METHOD(SecPkgContext_StreamSizes, get_cbBlockSize)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 16);
}

SB_PHP_METHOD(SecPkgContext_StreamSizes, set_cbBlockSize)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 16);
}

zend_class_entry *SecPkgContext_StreamSizes_ce_ptr = NULL;

static zend_function_entry SecPkgContext_StreamSizes_methods[] = {
	PHP_ME(SecPkgContext_StreamSizes, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(SecPkgContext_StreamSizes, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(SecPkgContext_StreamSizes, get_cbHeader, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SecPkgContext_StreamSizes, set_cbHeader, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SecPkgContext_StreamSizes, get_cbTrailer, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SecPkgContext_StreamSizes, set_cbTrailer, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SecPkgContext_StreamSizes, get_cbMaximumMessage, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SecPkgContext_StreamSizes, set_cbMaximumMessage, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SecPkgContext_StreamSizes, get_cBuffers, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SecPkgContext_StreamSizes, set_cBuffers, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SecPkgContext_StreamSizes, get_cbBlockSize, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SecPkgContext_StreamSizes, set_cbBlockSize, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_SecPkgContext_StreamSizes(TSRMLS_D)
{
	zend_class_entry ce;
	if (SecPkgContext_StreamSizes_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "SecPkgContext_StreamSizes", SecPkgContext_StreamSizes_methods);
	SecPkgContext_StreamSizes_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(SecPkgContext_NamesW, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(SecPkgContext_NamesW));
		intern->len = sizeof(SecPkgContext_NamesW);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(SecPkgContext_NamesW, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(SecPkgContext_NamesW));
}

zend_class_entry *SecPkgContext_NamesW_ce_ptr = NULL;

static zend_function_entry SecPkgContext_NamesW_methods[] = {
	PHP_ME(SecPkgContext_NamesW, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(SecPkgContext_NamesW, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_FE_END
};

void Register_SecPkgContext_NamesW(TSRMLS_D)
{
	zend_class_entry ce;
	if (SecPkgContext_NamesW_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "SecPkgContext_NamesW", SecPkgContext_NamesW_methods);
	SecPkgContext_NamesW_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(SecPkgContext_NamesA, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(SecPkgContext_NamesA));
		intern->len = sizeof(SecPkgContext_NamesA);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(SecPkgContext_NamesA, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(SecPkgContext_NamesA));
}

zend_class_entry *SecPkgContext_NamesA_ce_ptr = NULL;

static zend_function_entry SecPkgContext_NamesA_methods[] = {
	PHP_ME(SecPkgContext_NamesA, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(SecPkgContext_NamesA, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_FE_END
};

void Register_SecPkgContext_NamesA(TSRMLS_D)
{
	zend_class_entry ce;
	if (SecPkgContext_NamesA_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "SecPkgContext_NamesA", SecPkgContext_NamesA_methods);
	SecPkgContext_NamesA_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(SecPkgContext_Lifespan, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(SecPkgContext_Lifespan));
		intern->len = sizeof(SecPkgContext_Lifespan);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(SecPkgContext_Lifespan, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(SecPkgContext_Lifespan));
}

zend_class_entry *SecPkgContext_Lifespan_ce_ptr = NULL;

static zend_function_entry SecPkgContext_Lifespan_methods[] = {
	PHP_ME(SecPkgContext_Lifespan, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(SecPkgContext_Lifespan, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_FE_END
};

void Register_SecPkgContext_Lifespan(TSRMLS_D)
{
	zend_class_entry ce;
	if (SecPkgContext_Lifespan_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "SecPkgContext_Lifespan", SecPkgContext_Lifespan_methods);
	SecPkgContext_Lifespan_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(SecPkgContext_DceInfo, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(SecPkgContext_DceInfo));
		intern->len = sizeof(SecPkgContext_DceInfo);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(SecPkgContext_DceInfo, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(SecPkgContext_DceInfo));
}

SB_PHP_METHOD(SecPkgContext_DceInfo, get_AuthzSvc)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(SecPkgContext_DceInfo, set_AuthzSvc)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

zend_class_entry *SecPkgContext_DceInfo_ce_ptr = NULL;

static zend_function_entry SecPkgContext_DceInfo_methods[] = {
	PHP_ME(SecPkgContext_DceInfo, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(SecPkgContext_DceInfo, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(SecPkgContext_DceInfo, get_AuthzSvc, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SecPkgContext_DceInfo, set_AuthzSvc, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_SecPkgContext_DceInfo(TSRMLS_D)
{
	zend_class_entry ce;
	if (SecPkgContext_DceInfo_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "SecPkgContext_DceInfo", SecPkgContext_DceInfo_methods);
	SecPkgContext_DceInfo_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(SecPkgContext_KeyInfoA, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(SecPkgContext_KeyInfoA));
		intern->len = sizeof(SecPkgContext_KeyInfoA);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(SecPkgContext_KeyInfoA, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(SecPkgContext_KeyInfoA));
}

SB_PHP_METHOD(SecPkgContext_KeyInfoA, get_KeySize)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 8);
}

SB_PHP_METHOD(SecPkgContext_KeyInfoA, set_KeySize)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 8);
}

SB_PHP_METHOD(SecPkgContext_KeyInfoA, get_SignatureAlgorithm)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 12);
}

SB_PHP_METHOD(SecPkgContext_KeyInfoA, set_SignatureAlgorithm)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 12);
}

SB_PHP_METHOD(SecPkgContext_KeyInfoA, get_EncryptAlgorithm)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 16);
}

SB_PHP_METHOD(SecPkgContext_KeyInfoA, set_EncryptAlgorithm)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 16);
}

zend_class_entry *SecPkgContext_KeyInfoA_ce_ptr = NULL;

static zend_function_entry SecPkgContext_KeyInfoA_methods[] = {
	PHP_ME(SecPkgContext_KeyInfoA, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(SecPkgContext_KeyInfoA, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(SecPkgContext_KeyInfoA, get_KeySize, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SecPkgContext_KeyInfoA, set_KeySize, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SecPkgContext_KeyInfoA, get_SignatureAlgorithm, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SecPkgContext_KeyInfoA, set_SignatureAlgorithm, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SecPkgContext_KeyInfoA, get_EncryptAlgorithm, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SecPkgContext_KeyInfoA, set_EncryptAlgorithm, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_SecPkgContext_KeyInfoA(TSRMLS_D)
{
	zend_class_entry ce;
	if (SecPkgContext_KeyInfoA_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "SecPkgContext_KeyInfoA", SecPkgContext_KeyInfoA_methods);
	SecPkgContext_KeyInfoA_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(SecPkgContext_KeyInfoW, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(SecPkgContext_KeyInfoW));
		intern->len = sizeof(SecPkgContext_KeyInfoW);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(SecPkgContext_KeyInfoW, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(SecPkgContext_KeyInfoW));
}

SB_PHP_METHOD(SecPkgContext_KeyInfoW, get_KeySize)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 8);
}

SB_PHP_METHOD(SecPkgContext_KeyInfoW, set_KeySize)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 8);
}

SB_PHP_METHOD(SecPkgContext_KeyInfoW, get_SignatureAlgorithm)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 12);
}

SB_PHP_METHOD(SecPkgContext_KeyInfoW, set_SignatureAlgorithm)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 12);
}

SB_PHP_METHOD(SecPkgContext_KeyInfoW, get_EncryptAlgorithm)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 16);
}

SB_PHP_METHOD(SecPkgContext_KeyInfoW, set_EncryptAlgorithm)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 16);
}

zend_class_entry *SecPkgContext_KeyInfoW_ce_ptr = NULL;

static zend_function_entry SecPkgContext_KeyInfoW_methods[] = {
	PHP_ME(SecPkgContext_KeyInfoW, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(SecPkgContext_KeyInfoW, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(SecPkgContext_KeyInfoW, get_KeySize, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SecPkgContext_KeyInfoW, set_KeySize, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SecPkgContext_KeyInfoW, get_SignatureAlgorithm, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SecPkgContext_KeyInfoW, set_SignatureAlgorithm, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SecPkgContext_KeyInfoW, get_EncryptAlgorithm, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SecPkgContext_KeyInfoW, set_EncryptAlgorithm, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_SecPkgContext_KeyInfoW(TSRMLS_D)
{
	zend_class_entry ce;
	if (SecPkgContext_KeyInfoW_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "SecPkgContext_KeyInfoW", SecPkgContext_KeyInfoW_methods);
	SecPkgContext_KeyInfoW_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(SecPkgContext_AuthorityA, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(SecPkgContext_AuthorityA));
		intern->len = sizeof(SecPkgContext_AuthorityA);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(SecPkgContext_AuthorityA, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(SecPkgContext_AuthorityA));
}

zend_class_entry *SecPkgContext_AuthorityA_ce_ptr = NULL;

static zend_function_entry SecPkgContext_AuthorityA_methods[] = {
	PHP_ME(SecPkgContext_AuthorityA, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(SecPkgContext_AuthorityA, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_FE_END
};

void Register_SecPkgContext_AuthorityA(TSRMLS_D)
{
	zend_class_entry ce;
	if (SecPkgContext_AuthorityA_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "SecPkgContext_AuthorityA", SecPkgContext_AuthorityA_methods);
	SecPkgContext_AuthorityA_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(SecPkgContext_AuthorityW, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(SecPkgContext_AuthorityW));
		intern->len = sizeof(SecPkgContext_AuthorityW);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(SecPkgContext_AuthorityW, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(SecPkgContext_AuthorityW));
}

zend_class_entry *SecPkgContext_AuthorityW_ce_ptr = NULL;

static zend_function_entry SecPkgContext_AuthorityW_methods[] = {
	PHP_ME(SecPkgContext_AuthorityW, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(SecPkgContext_AuthorityW, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_FE_END
};

void Register_SecPkgContext_AuthorityW(TSRMLS_D)
{
	zend_class_entry ce;
	if (SecPkgContext_AuthorityW_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "SecPkgContext_AuthorityW", SecPkgContext_AuthorityW_methods);
	SecPkgContext_AuthorityW_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(SecPkgContext_ProtoInfoA, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(SecPkgContext_ProtoInfoA));
		intern->len = sizeof(SecPkgContext_ProtoInfoA);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(SecPkgContext_ProtoInfoA, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(SecPkgContext_ProtoInfoA));
}

SB_PHP_METHOD(SecPkgContext_ProtoInfoA, get_majorVersion)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 4);
}

SB_PHP_METHOD(SecPkgContext_ProtoInfoA, set_majorVersion)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 4);
}

SB_PHP_METHOD(SecPkgContext_ProtoInfoA, get_minorVersion)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 8);
}

SB_PHP_METHOD(SecPkgContext_ProtoInfoA, set_minorVersion)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 8);
}

zend_class_entry *SecPkgContext_ProtoInfoA_ce_ptr = NULL;

static zend_function_entry SecPkgContext_ProtoInfoA_methods[] = {
	PHP_ME(SecPkgContext_ProtoInfoA, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(SecPkgContext_ProtoInfoA, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(SecPkgContext_ProtoInfoA, get_majorVersion, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SecPkgContext_ProtoInfoA, set_majorVersion, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SecPkgContext_ProtoInfoA, get_minorVersion, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SecPkgContext_ProtoInfoA, set_minorVersion, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_SecPkgContext_ProtoInfoA(TSRMLS_D)
{
	zend_class_entry ce;
	if (SecPkgContext_ProtoInfoA_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "SecPkgContext_ProtoInfoA", SecPkgContext_ProtoInfoA_methods);
	SecPkgContext_ProtoInfoA_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(SecPkgContext_ProtoInfoW, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(SecPkgContext_ProtoInfoW));
		intern->len = sizeof(SecPkgContext_ProtoInfoW);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(SecPkgContext_ProtoInfoW, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(SecPkgContext_ProtoInfoW));
}

SB_PHP_METHOD(SecPkgContext_ProtoInfoW, get_majorVersion)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 4);
}

SB_PHP_METHOD(SecPkgContext_ProtoInfoW, set_majorVersion)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 4);
}

SB_PHP_METHOD(SecPkgContext_ProtoInfoW, get_minorVersion)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 8);
}

SB_PHP_METHOD(SecPkgContext_ProtoInfoW, set_minorVersion)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 8);
}

zend_class_entry *SecPkgContext_ProtoInfoW_ce_ptr = NULL;

static zend_function_entry SecPkgContext_ProtoInfoW_methods[] = {
	PHP_ME(SecPkgContext_ProtoInfoW, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(SecPkgContext_ProtoInfoW, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(SecPkgContext_ProtoInfoW, get_majorVersion, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SecPkgContext_ProtoInfoW, set_majorVersion, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SecPkgContext_ProtoInfoW, get_minorVersion, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SecPkgContext_ProtoInfoW, set_minorVersion, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_SecPkgContext_ProtoInfoW(TSRMLS_D)
{
	zend_class_entry ce;
	if (SecPkgContext_ProtoInfoW_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "SecPkgContext_ProtoInfoW", SecPkgContext_ProtoInfoW_methods);
	SecPkgContext_ProtoInfoW_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(SecPkgContext_PasswordExpiry, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(SecPkgContext_PasswordExpiry));
		intern->len = sizeof(SecPkgContext_PasswordExpiry);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(SecPkgContext_PasswordExpiry, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(SecPkgContext_PasswordExpiry));
}

zend_class_entry *SecPkgContext_PasswordExpiry_ce_ptr = NULL;

static zend_function_entry SecPkgContext_PasswordExpiry_methods[] = {
	PHP_ME(SecPkgContext_PasswordExpiry, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(SecPkgContext_PasswordExpiry, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_FE_END
};

void Register_SecPkgContext_PasswordExpiry(TSRMLS_D)
{
	zend_class_entry ce;
	if (SecPkgContext_PasswordExpiry_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "SecPkgContext_PasswordExpiry", SecPkgContext_PasswordExpiry_methods);
	SecPkgContext_PasswordExpiry_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(SecPkgContext_SessionKey, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(SecPkgContext_SessionKey));
		intern->len = sizeof(SecPkgContext_SessionKey);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(SecPkgContext_SessionKey, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(SecPkgContext_SessionKey));
}

SB_PHP_METHOD(SecPkgContext_SessionKey, get_SessionKeyLength)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(SecPkgContext_SessionKey, set_SessionKeyLength)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

zend_class_entry *SecPkgContext_SessionKey_ce_ptr = NULL;

static zend_function_entry SecPkgContext_SessionKey_methods[] = {
	PHP_ME(SecPkgContext_SessionKey, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(SecPkgContext_SessionKey, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(SecPkgContext_SessionKey, get_SessionKeyLength, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SecPkgContext_SessionKey, set_SessionKeyLength, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_SecPkgContext_SessionKey(TSRMLS_D)
{
	zend_class_entry ce;
	if (SecPkgContext_SessionKey_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "SecPkgContext_SessionKey", SecPkgContext_SessionKey_methods);
	SecPkgContext_SessionKey_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(SecPkgContext_PackageInfoW, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(SecPkgContext_PackageInfoW));
		intern->len = sizeof(SecPkgContext_PackageInfoW);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(SecPkgContext_PackageInfoW, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(SecPkgContext_PackageInfoW));
}

zend_class_entry *SecPkgContext_PackageInfoW_ce_ptr = NULL;

static zend_function_entry SecPkgContext_PackageInfoW_methods[] = {
	PHP_ME(SecPkgContext_PackageInfoW, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(SecPkgContext_PackageInfoW, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_FE_END
};

void Register_SecPkgContext_PackageInfoW(TSRMLS_D)
{
	zend_class_entry ce;
	if (SecPkgContext_PackageInfoW_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "SecPkgContext_PackageInfoW", SecPkgContext_PackageInfoW_methods);
	SecPkgContext_PackageInfoW_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(SecPkgContext_PackageInfoA, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(SecPkgContext_PackageInfoA));
		intern->len = sizeof(SecPkgContext_PackageInfoA);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(SecPkgContext_PackageInfoA, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(SecPkgContext_PackageInfoA));
}

zend_class_entry *SecPkgContext_PackageInfoA_ce_ptr = NULL;

static zend_function_entry SecPkgContext_PackageInfoA_methods[] = {
	PHP_ME(SecPkgContext_PackageInfoA, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(SecPkgContext_PackageInfoA, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_FE_END
};

void Register_SecPkgContext_PackageInfoA(TSRMLS_D)
{
	zend_class_entry ce;
	if (SecPkgContext_PackageInfoA_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "SecPkgContext_PackageInfoA", SecPkgContext_PackageInfoA_methods);
	SecPkgContext_PackageInfoA_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(SecPkgContext_UserFlags, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(SecPkgContext_UserFlags));
		intern->len = sizeof(SecPkgContext_UserFlags);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(SecPkgContext_UserFlags, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(SecPkgContext_UserFlags));
}

SB_PHP_METHOD(SecPkgContext_UserFlags, get_UserFlags)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(SecPkgContext_UserFlags, set_UserFlags)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

zend_class_entry *SecPkgContext_UserFlags_ce_ptr = NULL;

static zend_function_entry SecPkgContext_UserFlags_methods[] = {
	PHP_ME(SecPkgContext_UserFlags, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(SecPkgContext_UserFlags, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(SecPkgContext_UserFlags, get_UserFlags, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SecPkgContext_UserFlags, set_UserFlags, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_SecPkgContext_UserFlags(TSRMLS_D)
{
	zend_class_entry ce;
	if (SecPkgContext_UserFlags_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "SecPkgContext_UserFlags", SecPkgContext_UserFlags_methods);
	SecPkgContext_UserFlags_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(SecPkgContext_Flags, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(SecPkgContext_Flags));
		intern->len = sizeof(SecPkgContext_Flags);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(SecPkgContext_Flags, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(SecPkgContext_Flags));
}

SB_PHP_METHOD(SecPkgContext_Flags, get_Flags)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(SecPkgContext_Flags, set_Flags)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

zend_class_entry *SecPkgContext_Flags_ce_ptr = NULL;

static zend_function_entry SecPkgContext_Flags_methods[] = {
	PHP_ME(SecPkgContext_Flags, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(SecPkgContext_Flags, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(SecPkgContext_Flags, get_Flags, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SecPkgContext_Flags, set_Flags, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_SecPkgContext_Flags(TSRMLS_D)
{
	zend_class_entry ce;
	if (SecPkgContext_Flags_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "SecPkgContext_Flags", SecPkgContext_Flags_methods);
	SecPkgContext_Flags_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(SecPkgContext_NegotiationInfoA, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(SecPkgContext_NegotiationInfoA));
		intern->len = sizeof(SecPkgContext_NegotiationInfoA);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(SecPkgContext_NegotiationInfoA, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(SecPkgContext_NegotiationInfoA));
}

SB_PHP_METHOD(SecPkgContext_NegotiationInfoA, get_NegotiationState)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 4);
}

SB_PHP_METHOD(SecPkgContext_NegotiationInfoA, set_NegotiationState)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 4);
}

zend_class_entry *SecPkgContext_NegotiationInfoA_ce_ptr = NULL;

static zend_function_entry SecPkgContext_NegotiationInfoA_methods[] = {
	PHP_ME(SecPkgContext_NegotiationInfoA, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(SecPkgContext_NegotiationInfoA, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(SecPkgContext_NegotiationInfoA, get_NegotiationState, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SecPkgContext_NegotiationInfoA, set_NegotiationState, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_SecPkgContext_NegotiationInfoA(TSRMLS_D)
{
	zend_class_entry ce;
	if (SecPkgContext_NegotiationInfoA_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "SecPkgContext_NegotiationInfoA", SecPkgContext_NegotiationInfoA_methods);
	SecPkgContext_NegotiationInfoA_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(SecPkgContext_NegotiationInfoW, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(SecPkgContext_NegotiationInfoW));
		intern->len = sizeof(SecPkgContext_NegotiationInfoW);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(SecPkgContext_NegotiationInfoW, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(SecPkgContext_NegotiationInfoW));
}

SB_PHP_METHOD(SecPkgContext_NegotiationInfoW, get_NegotiationState)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 4);
}

SB_PHP_METHOD(SecPkgContext_NegotiationInfoW, set_NegotiationState)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 4);
}

zend_class_entry *SecPkgContext_NegotiationInfoW_ce_ptr = NULL;

static zend_function_entry SecPkgContext_NegotiationInfoW_methods[] = {
	PHP_ME(SecPkgContext_NegotiationInfoW, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(SecPkgContext_NegotiationInfoW, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(SecPkgContext_NegotiationInfoW, get_NegotiationState, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SecPkgContext_NegotiationInfoW, set_NegotiationState, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_SecPkgContext_NegotiationInfoW(TSRMLS_D)
{
	zend_class_entry ce;
	if (SecPkgContext_NegotiationInfoW_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "SecPkgContext_NegotiationInfoW", SecPkgContext_NegotiationInfoW_methods);
	SecPkgContext_NegotiationInfoW_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(SecPkgContext_NativeNamesW, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(SecPkgContext_NativeNamesW));
		intern->len = sizeof(SecPkgContext_NativeNamesW);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(SecPkgContext_NativeNamesW, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(SecPkgContext_NativeNamesW));
}

zend_class_entry *SecPkgContext_NativeNamesW_ce_ptr = NULL;

static zend_function_entry SecPkgContext_NativeNamesW_methods[] = {
	PHP_ME(SecPkgContext_NativeNamesW, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(SecPkgContext_NativeNamesW, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_FE_END
};

void Register_SecPkgContext_NativeNamesW(TSRMLS_D)
{
	zend_class_entry ce;
	if (SecPkgContext_NativeNamesW_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "SecPkgContext_NativeNamesW", SecPkgContext_NativeNamesW_methods);
	SecPkgContext_NativeNamesW_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(SecPkgContext_NativeNamesA, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(SecPkgContext_NativeNamesA));
		intern->len = sizeof(SecPkgContext_NativeNamesA);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(SecPkgContext_NativeNamesA, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(SecPkgContext_NativeNamesA));
}

zend_class_entry *SecPkgContext_NativeNamesA_ce_ptr = NULL;

static zend_function_entry SecPkgContext_NativeNamesA_methods[] = {
	PHP_ME(SecPkgContext_NativeNamesA, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(SecPkgContext_NativeNamesA, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_FE_END
};

void Register_SecPkgContext_NativeNamesA(TSRMLS_D)
{
	zend_class_entry ce;
	if (SecPkgContext_NativeNamesA_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "SecPkgContext_NativeNamesA", SecPkgContext_NativeNamesA_methods);
	SecPkgContext_NativeNamesA_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(SecPkgContext_CredentialNameW, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(SecPkgContext_CredentialNameW));
		intern->len = sizeof(SecPkgContext_CredentialNameW);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(SecPkgContext_CredentialNameW, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(SecPkgContext_CredentialNameW));
}

SB_PHP_METHOD(SecPkgContext_CredentialNameW, get_CredentialType)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(SecPkgContext_CredentialNameW, set_CredentialType)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

zend_class_entry *SecPkgContext_CredentialNameW_ce_ptr = NULL;

static zend_function_entry SecPkgContext_CredentialNameW_methods[] = {
	PHP_ME(SecPkgContext_CredentialNameW, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(SecPkgContext_CredentialNameW, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(SecPkgContext_CredentialNameW, get_CredentialType, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SecPkgContext_CredentialNameW, set_CredentialType, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_SecPkgContext_CredentialNameW(TSRMLS_D)
{
	zend_class_entry ce;
	if (SecPkgContext_CredentialNameW_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "SecPkgContext_CredentialNameW", SecPkgContext_CredentialNameW_methods);
	SecPkgContext_CredentialNameW_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(SecPkgContext_CredentialNameA, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(SecPkgContext_CredentialNameA));
		intern->len = sizeof(SecPkgContext_CredentialNameA);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(SecPkgContext_CredentialNameA, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(SecPkgContext_CredentialNameA));
}

SB_PHP_METHOD(SecPkgContext_CredentialNameA, get_CredentialType)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(SecPkgContext_CredentialNameA, set_CredentialType)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

zend_class_entry *SecPkgContext_CredentialNameA_ce_ptr = NULL;

static zend_function_entry SecPkgContext_CredentialNameA_methods[] = {
	PHP_ME(SecPkgContext_CredentialNameA, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(SecPkgContext_CredentialNameA, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(SecPkgContext_CredentialNameA, get_CredentialType, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SecPkgContext_CredentialNameA, set_CredentialType, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_SecPkgContext_CredentialNameA(TSRMLS_D)
{
	zend_class_entry ce;
	if (SecPkgContext_CredentialNameA_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "SecPkgContext_CredentialNameA", SecPkgContext_CredentialNameA_methods);
	SecPkgContext_CredentialNameA_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(SecPkgContext_AccessToken, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(SecPkgContext_AccessToken));
		intern->len = sizeof(SecPkgContext_AccessToken);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(SecPkgContext_AccessToken, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(SecPkgContext_AccessToken));
}

zend_class_entry *SecPkgContext_AccessToken_ce_ptr = NULL;

static zend_function_entry SecPkgContext_AccessToken_methods[] = {
	PHP_ME(SecPkgContext_AccessToken, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(SecPkgContext_AccessToken, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_FE_END
};

void Register_SecPkgContext_AccessToken(TSRMLS_D)
{
	zend_class_entry ce;
	if (SecPkgContext_AccessToken_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "SecPkgContext_AccessToken", SecPkgContext_AccessToken_methods);
	SecPkgContext_AccessToken_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(SecPkgContext_TargetInformation, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(SecPkgContext_TargetInformation));
		intern->len = sizeof(SecPkgContext_TargetInformation);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(SecPkgContext_TargetInformation, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(SecPkgContext_TargetInformation));
}

SB_PHP_METHOD(SecPkgContext_TargetInformation, get_MarshalledTargetInfoLength)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(SecPkgContext_TargetInformation, set_MarshalledTargetInfoLength)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

zend_class_entry *SecPkgContext_TargetInformation_ce_ptr = NULL;

static zend_function_entry SecPkgContext_TargetInformation_methods[] = {
	PHP_ME(SecPkgContext_TargetInformation, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(SecPkgContext_TargetInformation, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(SecPkgContext_TargetInformation, get_MarshalledTargetInfoLength, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SecPkgContext_TargetInformation, set_MarshalledTargetInfoLength, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_SecPkgContext_TargetInformation(TSRMLS_D)
{
	zend_class_entry ce;
	if (SecPkgContext_TargetInformation_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "SecPkgContext_TargetInformation", SecPkgContext_TargetInformation_methods);
	SecPkgContext_TargetInformation_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(SecPkgContext_AuthzID, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(SecPkgContext_AuthzID));
		intern->len = sizeof(SecPkgContext_AuthzID);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(SecPkgContext_AuthzID, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(SecPkgContext_AuthzID));
}

SB_PHP_METHOD(SecPkgContext_AuthzID, get_AuthzIDLength)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(SecPkgContext_AuthzID, set_AuthzIDLength)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

zend_class_entry *SecPkgContext_AuthzID_ce_ptr = NULL;

static zend_function_entry SecPkgContext_AuthzID_methods[] = {
	PHP_ME(SecPkgContext_AuthzID, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(SecPkgContext_AuthzID, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(SecPkgContext_AuthzID, get_AuthzIDLength, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SecPkgContext_AuthzID, set_AuthzIDLength, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_SecPkgContext_AuthzID(TSRMLS_D)
{
	zend_class_entry ce;
	if (SecPkgContext_AuthzID_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "SecPkgContext_AuthzID", SecPkgContext_AuthzID_methods);
	SecPkgContext_AuthzID_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(SecPkgContext_Target, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(SecPkgContext_Target));
		intern->len = sizeof(SecPkgContext_Target);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(SecPkgContext_Target, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(SecPkgContext_Target));
}

SB_PHP_METHOD(SecPkgContext_Target, get_TargetLength)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(SecPkgContext_Target, set_TargetLength)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

zend_class_entry *SecPkgContext_Target_ce_ptr = NULL;

static zend_function_entry SecPkgContext_Target_methods[] = {
	PHP_ME(SecPkgContext_Target, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(SecPkgContext_Target, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(SecPkgContext_Target, get_TargetLength, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SecPkgContext_Target, set_TargetLength, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_SecPkgContext_Target(TSRMLS_D)
{
	zend_class_entry ce;
	if (SecPkgContext_Target_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "SecPkgContext_Target", SecPkgContext_Target_methods);
	SecPkgContext_Target_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *SecDelegationType_ce_ptr = NULL;

SB_PHP_METHOD(SecurityFunctionTableW, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(SecurityFunctionTableW));
		intern->len = sizeof(SecurityFunctionTableW);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(SecurityFunctionTableW, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(SecurityFunctionTableW));
}

SB_PHP_METHOD(SecurityFunctionTableW, get_dwVersion)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(SecurityFunctionTableW, set_dwVersion)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

zend_class_entry *SecurityFunctionTableW_ce_ptr = NULL;

static zend_function_entry SecurityFunctionTableW_methods[] = {
	PHP_ME(SecurityFunctionTableW, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(SecurityFunctionTableW, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(SecurityFunctionTableW, get_dwVersion, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SecurityFunctionTableW, set_dwVersion, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_SecurityFunctionTableW(TSRMLS_D)
{
	zend_class_entry ce;
	if (SecurityFunctionTableW_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "SecurityFunctionTableW", SecurityFunctionTableW_methods);
	SecurityFunctionTableW_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(SecurityFunctionTableA, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(SecurityFunctionTableA));
		intern->len = sizeof(SecurityFunctionTableA);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(SecurityFunctionTableA, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(SecurityFunctionTableA));
}

SB_PHP_METHOD(SecurityFunctionTableA, get_dwVersion)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(SecurityFunctionTableA, set_dwVersion)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

zend_class_entry *SecurityFunctionTableA_ce_ptr = NULL;

static zend_function_entry SecurityFunctionTableA_methods[] = {
	PHP_ME(SecurityFunctionTableA, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(SecurityFunctionTableA, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(SecurityFunctionTableA, get_dwVersion, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SecurityFunctionTableA, set_dwVersion, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_SecurityFunctionTableA(TSRMLS_D)
{
	zend_class_entry ce;
	if (SecurityFunctionTableA_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "SecurityFunctionTableA", SecurityFunctionTableA_methods);
	SecurityFunctionTableA_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(SBSSPI_SEC_WINNT_AUTH_IDENTITY_W, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(SBSSPI_SEC_WINNT_AUTH_IDENTITY_W));
		intern->len = sizeof(SBSSPI_SEC_WINNT_AUTH_IDENTITY_W);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(SBSSPI_SEC_WINNT_AUTH_IDENTITY_W, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(SBSSPI_SEC_WINNT_AUTH_IDENTITY_W));
}

SB_PHP_METHOD(SBSSPI_SEC_WINNT_AUTH_IDENTITY_W, get_UserLength)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 4);
}

SB_PHP_METHOD(SBSSPI_SEC_WINNT_AUTH_IDENTITY_W, set_UserLength)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 4);
}

SB_PHP_METHOD(SBSSPI_SEC_WINNT_AUTH_IDENTITY_W, get_DomainLength)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 12);
}

SB_PHP_METHOD(SBSSPI_SEC_WINNT_AUTH_IDENTITY_W, set_DomainLength)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 12);
}

SB_PHP_METHOD(SBSSPI_SEC_WINNT_AUTH_IDENTITY_W, get_PasswordLength)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 20);
}

SB_PHP_METHOD(SBSSPI_SEC_WINNT_AUTH_IDENTITY_W, set_PasswordLength)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 20);
}

SB_PHP_METHOD(SBSSPI_SEC_WINNT_AUTH_IDENTITY_W, get_Flags)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 24);
}

SB_PHP_METHOD(SBSSPI_SEC_WINNT_AUTH_IDENTITY_W, set_Flags)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 24);
}

zend_class_entry *SBSSPI_SEC_WINNT_AUTH_IDENTITY_W_ce_ptr = NULL;

static zend_function_entry SBSSPI_SEC_WINNT_AUTH_IDENTITY_W_methods[] = {
	PHP_ME(SBSSPI_SEC_WINNT_AUTH_IDENTITY_W, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(SBSSPI_SEC_WINNT_AUTH_IDENTITY_W, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(SBSSPI_SEC_WINNT_AUTH_IDENTITY_W, get_UserLength, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBSSPI_SEC_WINNT_AUTH_IDENTITY_W, set_UserLength, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBSSPI_SEC_WINNT_AUTH_IDENTITY_W, get_DomainLength, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBSSPI_SEC_WINNT_AUTH_IDENTITY_W, set_DomainLength, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBSSPI_SEC_WINNT_AUTH_IDENTITY_W, get_PasswordLength, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBSSPI_SEC_WINNT_AUTH_IDENTITY_W, set_PasswordLength, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBSSPI_SEC_WINNT_AUTH_IDENTITY_W, get_Flags, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBSSPI_SEC_WINNT_AUTH_IDENTITY_W, set_Flags, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_SBSSPI_SEC_WINNT_AUTH_IDENTITY_W(TSRMLS_D)
{
	zend_class_entry ce;
	if (SBSSPI_SEC_WINNT_AUTH_IDENTITY_W_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "SBSSPI_SEC_WINNT_AUTH_IDENTITY_W", SBSSPI_SEC_WINNT_AUTH_IDENTITY_W_methods);
	SBSSPI_SEC_WINNT_AUTH_IDENTITY_W_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(SBSSPI_SEC_WINNT_AUTH_IDENTITY_A, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(SBSSPI_SEC_WINNT_AUTH_IDENTITY_A));
		intern->len = sizeof(SBSSPI_SEC_WINNT_AUTH_IDENTITY_A);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(SBSSPI_SEC_WINNT_AUTH_IDENTITY_A, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(SBSSPI_SEC_WINNT_AUTH_IDENTITY_A));
}

SB_PHP_METHOD(SBSSPI_SEC_WINNT_AUTH_IDENTITY_A, get_UserLength)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 4);
}

SB_PHP_METHOD(SBSSPI_SEC_WINNT_AUTH_IDENTITY_A, set_UserLength)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 4);
}

SB_PHP_METHOD(SBSSPI_SEC_WINNT_AUTH_IDENTITY_A, get_DomainLength)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 12);
}

SB_PHP_METHOD(SBSSPI_SEC_WINNT_AUTH_IDENTITY_A, set_DomainLength)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 12);
}

SB_PHP_METHOD(SBSSPI_SEC_WINNT_AUTH_IDENTITY_A, get_PasswordLength)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 20);
}

SB_PHP_METHOD(SBSSPI_SEC_WINNT_AUTH_IDENTITY_A, set_PasswordLength)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 20);
}

SB_PHP_METHOD(SBSSPI_SEC_WINNT_AUTH_IDENTITY_A, get_Flags)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 24);
}

SB_PHP_METHOD(SBSSPI_SEC_WINNT_AUTH_IDENTITY_A, set_Flags)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 24);
}

zend_class_entry *SBSSPI_SEC_WINNT_AUTH_IDENTITY_A_ce_ptr = NULL;

static zend_function_entry SBSSPI_SEC_WINNT_AUTH_IDENTITY_A_methods[] = {
	PHP_ME(SBSSPI_SEC_WINNT_AUTH_IDENTITY_A, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(SBSSPI_SEC_WINNT_AUTH_IDENTITY_A, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(SBSSPI_SEC_WINNT_AUTH_IDENTITY_A, get_UserLength, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBSSPI_SEC_WINNT_AUTH_IDENTITY_A, set_UserLength, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBSSPI_SEC_WINNT_AUTH_IDENTITY_A, get_DomainLength, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBSSPI_SEC_WINNT_AUTH_IDENTITY_A, set_DomainLength, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBSSPI_SEC_WINNT_AUTH_IDENTITY_A, get_PasswordLength, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBSSPI_SEC_WINNT_AUTH_IDENTITY_A, set_PasswordLength, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBSSPI_SEC_WINNT_AUTH_IDENTITY_A, get_Flags, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBSSPI_SEC_WINNT_AUTH_IDENTITY_A, set_Flags, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_SBSSPI_SEC_WINNT_AUTH_IDENTITY_A(TSRMLS_D)
{
	zend_class_entry ce;
	if (SBSSPI_SEC_WINNT_AUTH_IDENTITY_A_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "SBSSPI_SEC_WINNT_AUTH_IDENTITY_A", SBSSPI_SEC_WINNT_AUTH_IDENTITY_A_methods);
	SBSSPI_SEC_WINNT_AUTH_IDENTITY_A_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(SEC_WINNT_AUTH_IDENTITY_EXW, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(SEC_WINNT_AUTH_IDENTITY_EXW));
		intern->len = sizeof(SEC_WINNT_AUTH_IDENTITY_EXW);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(SEC_WINNT_AUTH_IDENTITY_EXW, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(SEC_WINNT_AUTH_IDENTITY_EXW));
}

SB_PHP_METHOD(SEC_WINNT_AUTH_IDENTITY_EXW, get_Version)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(SEC_WINNT_AUTH_IDENTITY_EXW, set_Version)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(SEC_WINNT_AUTH_IDENTITY_EXW, get_Length)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 4);
}

SB_PHP_METHOD(SEC_WINNT_AUTH_IDENTITY_EXW, set_Length)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 4);
}

SB_PHP_METHOD(SEC_WINNT_AUTH_IDENTITY_EXW, get_UserLength)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 12);
}

SB_PHP_METHOD(SEC_WINNT_AUTH_IDENTITY_EXW, set_UserLength)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 12);
}

SB_PHP_METHOD(SEC_WINNT_AUTH_IDENTITY_EXW, get_DomainLength)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 20);
}

SB_PHP_METHOD(SEC_WINNT_AUTH_IDENTITY_EXW, set_DomainLength)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 20);
}

SB_PHP_METHOD(SEC_WINNT_AUTH_IDENTITY_EXW, get_PasswordLength)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 28);
}

SB_PHP_METHOD(SEC_WINNT_AUTH_IDENTITY_EXW, set_PasswordLength)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 28);
}

SB_PHP_METHOD(SEC_WINNT_AUTH_IDENTITY_EXW, get_Flags)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 32);
}

SB_PHP_METHOD(SEC_WINNT_AUTH_IDENTITY_EXW, set_Flags)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 32);
}

SB_PHP_METHOD(SEC_WINNT_AUTH_IDENTITY_EXW, get_PackageListLength)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 40);
}

SB_PHP_METHOD(SEC_WINNT_AUTH_IDENTITY_EXW, set_PackageListLength)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 40);
}

zend_class_entry *SEC_WINNT_AUTH_IDENTITY_EXW_ce_ptr = NULL;

static zend_function_entry SEC_WINNT_AUTH_IDENTITY_EXW_methods[] = {
	PHP_ME(SEC_WINNT_AUTH_IDENTITY_EXW, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(SEC_WINNT_AUTH_IDENTITY_EXW, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(SEC_WINNT_AUTH_IDENTITY_EXW, get_Version, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SEC_WINNT_AUTH_IDENTITY_EXW, set_Version, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SEC_WINNT_AUTH_IDENTITY_EXW, get_Length, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SEC_WINNT_AUTH_IDENTITY_EXW, set_Length, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SEC_WINNT_AUTH_IDENTITY_EXW, get_UserLength, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SEC_WINNT_AUTH_IDENTITY_EXW, set_UserLength, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SEC_WINNT_AUTH_IDENTITY_EXW, get_DomainLength, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SEC_WINNT_AUTH_IDENTITY_EXW, set_DomainLength, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SEC_WINNT_AUTH_IDENTITY_EXW, get_PasswordLength, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SEC_WINNT_AUTH_IDENTITY_EXW, set_PasswordLength, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SEC_WINNT_AUTH_IDENTITY_EXW, get_Flags, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SEC_WINNT_AUTH_IDENTITY_EXW, set_Flags, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SEC_WINNT_AUTH_IDENTITY_EXW, get_PackageListLength, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SEC_WINNT_AUTH_IDENTITY_EXW, set_PackageListLength, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_SEC_WINNT_AUTH_IDENTITY_EXW(TSRMLS_D)
{
	zend_class_entry ce;
	if (SEC_WINNT_AUTH_IDENTITY_EXW_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "SEC_WINNT_AUTH_IDENTITY_EXW", SEC_WINNT_AUTH_IDENTITY_EXW_methods);
	SEC_WINNT_AUTH_IDENTITY_EXW_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(SEC_WINNT_AUTH_IDENTITY_EXA, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(SEC_WINNT_AUTH_IDENTITY_EXA));
		intern->len = sizeof(SEC_WINNT_AUTH_IDENTITY_EXA);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(SEC_WINNT_AUTH_IDENTITY_EXA, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(SEC_WINNT_AUTH_IDENTITY_EXA));
}

SB_PHP_METHOD(SEC_WINNT_AUTH_IDENTITY_EXA, get_Version)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(SEC_WINNT_AUTH_IDENTITY_EXA, set_Version)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(SEC_WINNT_AUTH_IDENTITY_EXA, get_Length)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 4);
}

SB_PHP_METHOD(SEC_WINNT_AUTH_IDENTITY_EXA, set_Length)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 4);
}

SB_PHP_METHOD(SEC_WINNT_AUTH_IDENTITY_EXA, get_UserLength)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 12);
}

SB_PHP_METHOD(SEC_WINNT_AUTH_IDENTITY_EXA, set_UserLength)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 12);
}

SB_PHP_METHOD(SEC_WINNT_AUTH_IDENTITY_EXA, get_DomainLength)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 20);
}

SB_PHP_METHOD(SEC_WINNT_AUTH_IDENTITY_EXA, set_DomainLength)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 20);
}

SB_PHP_METHOD(SEC_WINNT_AUTH_IDENTITY_EXA, get_PasswordLength)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 28);
}

SB_PHP_METHOD(SEC_WINNT_AUTH_IDENTITY_EXA, set_PasswordLength)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 28);
}

SB_PHP_METHOD(SEC_WINNT_AUTH_IDENTITY_EXA, get_Flags)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 32);
}

SB_PHP_METHOD(SEC_WINNT_AUTH_IDENTITY_EXA, set_Flags)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 32);
}

SB_PHP_METHOD(SEC_WINNT_AUTH_IDENTITY_EXA, get_PackageListLength)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 40);
}

SB_PHP_METHOD(SEC_WINNT_AUTH_IDENTITY_EXA, set_PackageListLength)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 40);
}

zend_class_entry *SEC_WINNT_AUTH_IDENTITY_EXA_ce_ptr = NULL;

static zend_function_entry SEC_WINNT_AUTH_IDENTITY_EXA_methods[] = {
	PHP_ME(SEC_WINNT_AUTH_IDENTITY_EXA, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(SEC_WINNT_AUTH_IDENTITY_EXA, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(SEC_WINNT_AUTH_IDENTITY_EXA, get_Version, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SEC_WINNT_AUTH_IDENTITY_EXA, set_Version, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SEC_WINNT_AUTH_IDENTITY_EXA, get_Length, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SEC_WINNT_AUTH_IDENTITY_EXA, set_Length, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SEC_WINNT_AUTH_IDENTITY_EXA, get_UserLength, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SEC_WINNT_AUTH_IDENTITY_EXA, set_UserLength, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SEC_WINNT_AUTH_IDENTITY_EXA, get_DomainLength, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SEC_WINNT_AUTH_IDENTITY_EXA, set_DomainLength, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SEC_WINNT_AUTH_IDENTITY_EXA, get_PasswordLength, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SEC_WINNT_AUTH_IDENTITY_EXA, set_PasswordLength, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SEC_WINNT_AUTH_IDENTITY_EXA, get_Flags, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SEC_WINNT_AUTH_IDENTITY_EXA, set_Flags, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SEC_WINNT_AUTH_IDENTITY_EXA, get_PackageListLength, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SEC_WINNT_AUTH_IDENTITY_EXA, set_PackageListLength, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_SEC_WINNT_AUTH_IDENTITY_EXA(TSRMLS_D)
{
	zend_class_entry ce;
	if (SEC_WINNT_AUTH_IDENTITY_EXA_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "SEC_WINNT_AUTH_IDENTITY_EXA", SEC_WINNT_AUTH_IDENTITY_EXA_methods);
	SEC_WINNT_AUTH_IDENTITY_EXA_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_FUNCTION(SBSSPI, SEC_SUCCESS)
{
	long l4Status;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Status) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(SBSSPI_SEC_SUCCESS((int32_t)l4Status, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBSSPI, SecInvalidateHandleInt)
{
	zval *ox;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &ox, SecHandle_ce_ptr) == SUCCESS) && PZVAL_IS_REF(ox))
	{
		SBCheckError(SBSSPI_SecInvalidateHandleInt((SecHandle *)SBGetStructPointer(ox TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(&SecHandle)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBSSPI, SecIsValidHandleInt)
{
	zval *ox;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &ox, SecHandle_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(SBSSPI_SecIsValidHandleInt((SecHandle *)SBGetStructPointer(ox TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(SecHandle)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBSSPI, Initialize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(SBSSPI_Initialize() TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBSSPI, FreeAuthLibrary)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(SBSSPI_FreeAuthLibrary() TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

void Register_SBSSPI_Constants(int module_number TSRMLS_DC)
{
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SECPKG_FLAG_INTEGRITY, SB_SECPKG_FLAG_INTEGRITY, SB_SECPKG_FLAG_INTEGRITY);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SECPKG_FLAG_PRIVACY, SB_SECPKG_FLAG_PRIVACY, SB_SECPKG_FLAG_PRIVACY);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SECPKG_FLAG_TOKEN_ONLY, SB_SECPKG_FLAG_TOKEN_ONLY, SB_SECPKG_FLAG_TOKEN_ONLY);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SECPKG_FLAG_DATAGRAM, SB_SECPKG_FLAG_DATAGRAM, SB_SECPKG_FLAG_DATAGRAM);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SECPKG_FLAG_CONNECTION, SB_SECPKG_FLAG_CONNECTION, SB_SECPKG_FLAG_CONNECTION);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SECPKG_FLAG_MULTI_REQUIRED, SB_SECPKG_FLAG_MULTI_REQUIRED, SB_SECPKG_FLAG_MULTI_REQUIRED);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SECPKG_FLAG_CLIENT_ONLY, SB_SECPKG_FLAG_CLIENT_ONLY, SB_SECPKG_FLAG_CLIENT_ONLY);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SECPKG_FLAG_EXTENDED_ERROR, SB_SECPKG_FLAG_EXTENDED_ERROR, SB_SECPKG_FLAG_EXTENDED_ERROR);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SECPKG_FLAG_IMPERSONATION, SB_SECPKG_FLAG_IMPERSONATION, SB_SECPKG_FLAG_IMPERSONATION);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SECPKG_FLAG_ACCEPT_WIN32_NAME, SB_SECPKG_FLAG_ACCEPT_WIN32_NAME, SB_SECPKG_FLAG_ACCEPT_WIN32_NAME);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SECPKG_FLAG_STREAM, SB_SECPKG_FLAG_STREAM, SB_SECPKG_FLAG_STREAM);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SECPKG_FLAG_NEGOTIABLE, SB_SECPKG_FLAG_NEGOTIABLE, SB_SECPKG_FLAG_NEGOTIABLE);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SECPKG_FLAG_GSS_COMPATIBLE, SB_SECPKG_FLAG_GSS_COMPATIBLE, SB_SECPKG_FLAG_GSS_COMPATIBLE);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SECPKG_FLAG_LOGON, SB_SECPKG_FLAG_LOGON, SB_SECPKG_FLAG_LOGON);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SECPKG_FLAG_ASCII_BUFFERS, SB_SECPKG_FLAG_ASCII_BUFFERS, SB_SECPKG_FLAG_ASCII_BUFFERS);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SECPKG_FLAG_FRAGMENT, SB_SECPKG_FLAG_FRAGMENT, SB_SECPKG_FLAG_FRAGMENT);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SECPKG_FLAG_MUTUAL_AUTH, SB_SECPKG_FLAG_MUTUAL_AUTH, SB_SECPKG_FLAG_MUTUAL_AUTH);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SECPKG_FLAG_DELEGATION, SB_SECPKG_FLAG_DELEGATION, SB_SECPKG_FLAG_DELEGATION);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SECPKG_FLAG_READONLY_WITH_CHECKSUM, SB_SECPKG_FLAG_READONLY_WITH_CHECKSUM, SB_SECPKG_FLAG_READONLY_WITH_CHECKSUM);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SECPKG_ID_NONE, SB_SECPKG_ID_NONE, SB_SECPKG_ID_NONE);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SECBUFFER_VERSION, SB_SECBUFFER_VERSION, SB_SECBUFFER_VERSION);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SECBUFFER_EMPTY, SB_SECBUFFER_EMPTY, SB_SECBUFFER_EMPTY);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SECBUFFER_DATA, SB_SECBUFFER_DATA, SB_SECBUFFER_DATA);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SECBUFFER_TOKEN, SB_SECBUFFER_TOKEN, SB_SECBUFFER_TOKEN);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SECBUFFER_PKG_PARAMS, SB_SECBUFFER_PKG_PARAMS, SB_SECBUFFER_PKG_PARAMS);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SECBUFFER_MISSING, SB_SECBUFFER_MISSING, SB_SECBUFFER_MISSING);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SECBUFFER_EXTRA, SB_SECBUFFER_EXTRA, SB_SECBUFFER_EXTRA);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SECBUFFER_STREAM_TRAILER, SB_SECBUFFER_STREAM_TRAILER, SB_SECBUFFER_STREAM_TRAILER);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SECBUFFER_STREAM_HEADER, SB_SECBUFFER_STREAM_HEADER, SB_SECBUFFER_STREAM_HEADER);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SECBUFFER_NEGOTIATION_INFO, SB_SECBUFFER_NEGOTIATION_INFO, SB_SECBUFFER_NEGOTIATION_INFO);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SECBUFFER_PADDING, SB_SECBUFFER_PADDING, SB_SECBUFFER_PADDING);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SECBUFFER_STREAM, SB_SECBUFFER_STREAM, SB_SECBUFFER_STREAM);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SECBUFFER_MECHLIST, SB_SECBUFFER_MECHLIST, SB_SECBUFFER_MECHLIST);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SECBUFFER_MECHLIST_SIGNATURE, SB_SECBUFFER_MECHLIST_SIGNATURE, SB_SECBUFFER_MECHLIST_SIGNATURE);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SECBUFFER_TARGET, SB_SECBUFFER_TARGET, SB_SECBUFFER_TARGET);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SECBUFFER_CHANNEL_BINDINGS, SB_SECBUFFER_CHANNEL_BINDINGS, SB_SECBUFFER_CHANNEL_BINDINGS);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SECBUFFER_ATTRMASK, SB_SECBUFFER_ATTRMASK, SB_SECBUFFER_ATTRMASK);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SECBUFFER_READONLY, SB_SECBUFFER_READONLY, SB_SECBUFFER_READONLY);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SECBUFFER_READONLY_WITH_CHECKSUM, SB_SECBUFFER_READONLY_WITH_CHECKSUM, SB_SECBUFFER_READONLY_WITH_CHECKSUM);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SECBUFFER_RESERVED, SB_SECBUFFER_RESERVED, SB_SECBUFFER_RESERVED);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SECURITY_NATIVE_DREP, SB_SECURITY_NATIVE_DREP, SB_SECURITY_NATIVE_DREP);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SECURITY_NETWORK_DREP, SB_SECURITY_NETWORK_DREP, SB_SECURITY_NETWORK_DREP);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SECPKG_CRED_INBOUND, SB_SECPKG_CRED_INBOUND, SB_SECPKG_CRED_INBOUND);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SECPKG_CRED_OUTBOUND, SB_SECPKG_CRED_OUTBOUND, SB_SECPKG_CRED_OUTBOUND);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SECPKG_CRED_BOTH, SB_SECPKG_CRED_BOTH, SB_SECPKG_CRED_BOTH);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SECPKG_CRED_DEFAULT, SB_SECPKG_CRED_DEFAULT, SB_SECPKG_CRED_DEFAULT);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SECPKG_CRED_RESERVED, SB_SECPKG_CRED_RESERVED, SB_SECPKG_CRED_RESERVED);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, ISC_REQ_DELEGATE, SB_ISC_REQ_DELEGATE, SB_ISC_REQ_DELEGATE);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, ISC_REQ_MUTUAL_AUTH, SB_ISC_REQ_MUTUAL_AUTH, SB_ISC_REQ_MUTUAL_AUTH);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, ISC_REQ_REPLAY_DETECT, SB_ISC_REQ_REPLAY_DETECT, SB_ISC_REQ_REPLAY_DETECT);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, ISC_REQ_SEQUENCE_DETECT, SB_ISC_REQ_SEQUENCE_DETECT, SB_ISC_REQ_SEQUENCE_DETECT);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, ISC_REQ_CONFIDENTIALITY, SB_ISC_REQ_CONFIDENTIALITY, SB_ISC_REQ_CONFIDENTIALITY);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, ISC_REQ_USE_SESSION_KEY, SB_ISC_REQ_USE_SESSION_KEY, SB_ISC_REQ_USE_SESSION_KEY);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, ISC_REQ_PROMPT_FOR_CREDS, SB_ISC_REQ_PROMPT_FOR_CREDS, SB_ISC_REQ_PROMPT_FOR_CREDS);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, ISC_REQ_USE_SUPPLIED_CREDS, SB_ISC_REQ_USE_SUPPLIED_CREDS, SB_ISC_REQ_USE_SUPPLIED_CREDS);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, ISC_REQ_ALLOCATE_MEMORY, SB_ISC_REQ_ALLOCATE_MEMORY, SB_ISC_REQ_ALLOCATE_MEMORY);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, ISC_REQ_USE_DCE_STYLE, SB_ISC_REQ_USE_DCE_STYLE, SB_ISC_REQ_USE_DCE_STYLE);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, ISC_REQ_DATAGRAM, SB_ISC_REQ_DATAGRAM, SB_ISC_REQ_DATAGRAM);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, ISC_REQ_CONNECTION, SB_ISC_REQ_CONNECTION, SB_ISC_REQ_CONNECTION);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, ISC_REQ_CALL_LEVEL, SB_ISC_REQ_CALL_LEVEL, SB_ISC_REQ_CALL_LEVEL);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, ISC_REQ_FRAGMENT_SUPPLIED, SB_ISC_REQ_FRAGMENT_SUPPLIED, SB_ISC_REQ_FRAGMENT_SUPPLIED);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, ISC_REQ_EXTENDED_ERROR, SB_ISC_REQ_EXTENDED_ERROR, SB_ISC_REQ_EXTENDED_ERROR);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, ISC_REQ_STREAM, SB_ISC_REQ_STREAM, SB_ISC_REQ_STREAM);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, ISC_REQ_INTEGRITY, SB_ISC_REQ_INTEGRITY, SB_ISC_REQ_INTEGRITY);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, ISC_REQ_IDENTIFY, SB_ISC_REQ_IDENTIFY, SB_ISC_REQ_IDENTIFY);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, ISC_REQ_NULL_SESSION, SB_ISC_REQ_NULL_SESSION, SB_ISC_REQ_NULL_SESSION);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, ISC_REQ_MANUAL_CRED_VALIDATION, SB_ISC_REQ_MANUAL_CRED_VALIDATION, SB_ISC_REQ_MANUAL_CRED_VALIDATION);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, ISC_REQ_RESERVED1, SB_ISC_REQ_RESERVED1, SB_ISC_REQ_RESERVED1);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, ISC_REQ_FRAGMENT_TO_FIT, SB_ISC_REQ_FRAGMENT_TO_FIT, SB_ISC_REQ_FRAGMENT_TO_FIT);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, ISC_RET_DELEGATE, SB_ISC_RET_DELEGATE, SB_ISC_RET_DELEGATE);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, ISC_RET_MUTUAL_AUTH, SB_ISC_RET_MUTUAL_AUTH, SB_ISC_RET_MUTUAL_AUTH);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, ISC_RET_REPLAY_DETECT, SB_ISC_RET_REPLAY_DETECT, SB_ISC_RET_REPLAY_DETECT);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, ISC_RET_SEQUENCE_DETECT, SB_ISC_RET_SEQUENCE_DETECT, SB_ISC_RET_SEQUENCE_DETECT);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, ISC_RET_CONFIDENTIALITY, SB_ISC_RET_CONFIDENTIALITY, SB_ISC_RET_CONFIDENTIALITY);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, ISC_RET_USE_SESSION_KEY, SB_ISC_RET_USE_SESSION_KEY, SB_ISC_RET_USE_SESSION_KEY);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, ISC_RET_USED_COLLECTED_CREDS, SB_ISC_RET_USED_COLLECTED_CREDS, SB_ISC_RET_USED_COLLECTED_CREDS);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, ISC_RET_USED_SUPPLIED_CREDS, SB_ISC_RET_USED_SUPPLIED_CREDS, SB_ISC_RET_USED_SUPPLIED_CREDS);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, ISC_RET_ALLOCATED_MEMORY, SB_ISC_RET_ALLOCATED_MEMORY, SB_ISC_RET_ALLOCATED_MEMORY);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, ISC_RET_USED_DCE_STYLE, SB_ISC_RET_USED_DCE_STYLE, SB_ISC_RET_USED_DCE_STYLE);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, ISC_RET_DATAGRAM, SB_ISC_RET_DATAGRAM, SB_ISC_RET_DATAGRAM);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, ISC_RET_CONNECTION, SB_ISC_RET_CONNECTION, SB_ISC_RET_CONNECTION);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, ISC_RET_INTERMEDIATE_RETURN, SB_ISC_RET_INTERMEDIATE_RETURN, SB_ISC_RET_INTERMEDIATE_RETURN);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, ISC_RET_CALL_LEVEL, SB_ISC_RET_CALL_LEVEL, SB_ISC_RET_CALL_LEVEL);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, ISC_RET_EXTENDED_ERROR, SB_ISC_RET_EXTENDED_ERROR, SB_ISC_RET_EXTENDED_ERROR);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, ISC_RET_STREAM, SB_ISC_RET_STREAM, SB_ISC_RET_STREAM);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, ISC_RET_INTEGRITY, SB_ISC_RET_INTEGRITY, SB_ISC_RET_INTEGRITY);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, ISC_RET_IDENTIFY, SB_ISC_RET_IDENTIFY, SB_ISC_RET_IDENTIFY);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, ISC_RET_NULL_SESSION, SB_ISC_RET_NULL_SESSION, SB_ISC_RET_NULL_SESSION);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, ISC_RET_MANUAL_CRED_VALIDATION, SB_ISC_RET_MANUAL_CRED_VALIDATION, SB_ISC_RET_MANUAL_CRED_VALIDATION);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, ISC_RET_RESERVED1, SB_ISC_RET_RESERVED1, SB_ISC_RET_RESERVED1);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, ISC_RET_FRAGMENT_ONLY, SB_ISC_RET_FRAGMENT_ONLY, SB_ISC_RET_FRAGMENT_ONLY);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, ASC_REQ_DELEGATE, SB_ASC_REQ_DELEGATE, SB_ASC_REQ_DELEGATE);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, ASC_REQ_MUTUAL_AUTH, SB_ASC_REQ_MUTUAL_AUTH, SB_ASC_REQ_MUTUAL_AUTH);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, ASC_REQ_REPLAY_DETECT, SB_ASC_REQ_REPLAY_DETECT, SB_ASC_REQ_REPLAY_DETECT);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, ASC_REQ_SEQUENCE_DETECT, SB_ASC_REQ_SEQUENCE_DETECT, SB_ASC_REQ_SEQUENCE_DETECT);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, ASC_REQ_CONFIDENTIALITY, SB_ASC_REQ_CONFIDENTIALITY, SB_ASC_REQ_CONFIDENTIALITY);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, ASC_REQ_USE_SESSION_KEY, SB_ASC_REQ_USE_SESSION_KEY, SB_ASC_REQ_USE_SESSION_KEY);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, ASC_REQ_ALLOCATE_MEMORY, SB_ASC_REQ_ALLOCATE_MEMORY, SB_ASC_REQ_ALLOCATE_MEMORY);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, ASC_REQ_USE_DCE_STYLE, SB_ASC_REQ_USE_DCE_STYLE, SB_ASC_REQ_USE_DCE_STYLE);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, ASC_REQ_DATAGRAM, SB_ASC_REQ_DATAGRAM, SB_ASC_REQ_DATAGRAM);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, ASC_REQ_CONNECTION, SB_ASC_REQ_CONNECTION, SB_ASC_REQ_CONNECTION);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, ASC_REQ_CALL_LEVEL, SB_ASC_REQ_CALL_LEVEL, SB_ASC_REQ_CALL_LEVEL);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, ASC_REQ_EXTENDED_ERROR, SB_ASC_REQ_EXTENDED_ERROR, SB_ASC_REQ_EXTENDED_ERROR);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, ASC_REQ_STREAM, SB_ASC_REQ_STREAM, SB_ASC_REQ_STREAM);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, ASC_REQ_INTEGRITY, SB_ASC_REQ_INTEGRITY, SB_ASC_REQ_INTEGRITY);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, ASC_REQ_LICENSING, SB_ASC_REQ_LICENSING, SB_ASC_REQ_LICENSING);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, ASC_REQ_IDENTIFY, SB_ASC_REQ_IDENTIFY, SB_ASC_REQ_IDENTIFY);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, ASC_REQ_ALLOW_NULL_SESSION, SB_ASC_REQ_ALLOW_NULL_SESSION, SB_ASC_REQ_ALLOW_NULL_SESSION);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, ASC_REQ_ALLOW_NON_USER_LOGONS, SB_ASC_REQ_ALLOW_NON_USER_LOGONS, SB_ASC_REQ_ALLOW_NON_USER_LOGONS);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, ASC_REQ_ALLOW_CONTEXT_REPLAY, SB_ASC_REQ_ALLOW_CONTEXT_REPLAY, SB_ASC_REQ_ALLOW_CONTEXT_REPLAY);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, ASC_REQ_FRAGMENT_TO_FIT, SB_ASC_REQ_FRAGMENT_TO_FIT, SB_ASC_REQ_FRAGMENT_TO_FIT);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, ASC_REQ_FRAGMENT_SUPPLIED, SB_ASC_REQ_FRAGMENT_SUPPLIED, SB_ASC_REQ_FRAGMENT_SUPPLIED);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, ASC_REQ_NO_TOKEN, SB_ASC_REQ_NO_TOKEN, SB_ASC_REQ_NO_TOKEN);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, ASC_RET_DELEGATE, SB_ASC_RET_DELEGATE, SB_ASC_RET_DELEGATE);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, ASC_RET_MUTUAL_AUTH, SB_ASC_RET_MUTUAL_AUTH, SB_ASC_RET_MUTUAL_AUTH);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, ASC_RET_REPLAY_DETECT, SB_ASC_RET_REPLAY_DETECT, SB_ASC_RET_REPLAY_DETECT);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, ASC_RET_SEQUENCE_DETECT, SB_ASC_RET_SEQUENCE_DETECT, SB_ASC_RET_SEQUENCE_DETECT);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, ASC_RET_CONFIDENTIALITY, SB_ASC_RET_CONFIDENTIALITY, SB_ASC_RET_CONFIDENTIALITY);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, ASC_RET_USE_SESSION_KEY, SB_ASC_RET_USE_SESSION_KEY, SB_ASC_RET_USE_SESSION_KEY);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, ASC_RET_ALLOCATED_MEMORY, SB_ASC_RET_ALLOCATED_MEMORY, SB_ASC_RET_ALLOCATED_MEMORY);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, ASC_RET_USED_DCE_STYLE, SB_ASC_RET_USED_DCE_STYLE, SB_ASC_RET_USED_DCE_STYLE);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, ASC_RET_DATAGRAM, SB_ASC_RET_DATAGRAM, SB_ASC_RET_DATAGRAM);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, ASC_RET_CONNECTION, SB_ASC_RET_CONNECTION, SB_ASC_RET_CONNECTION);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, ASC_RET_CALL_LEVEL, SB_ASC_RET_CALL_LEVEL, SB_ASC_RET_CALL_LEVEL);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, ASC_RET_THIRD_LEG_FAILED, SB_ASC_RET_THIRD_LEG_FAILED, SB_ASC_RET_THIRD_LEG_FAILED);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, ASC_RET_EXTENDED_ERROR, SB_ASC_RET_EXTENDED_ERROR, SB_ASC_RET_EXTENDED_ERROR);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, ASC_RET_STREAM, SB_ASC_RET_STREAM, SB_ASC_RET_STREAM);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, ASC_RET_INTEGRITY, SB_ASC_RET_INTEGRITY, SB_ASC_RET_INTEGRITY);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, ASC_RET_LICENSING, SB_ASC_RET_LICENSING, SB_ASC_RET_LICENSING);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, ASC_RET_IDENTIFY, SB_ASC_RET_IDENTIFY, SB_ASC_RET_IDENTIFY);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, ASC_RET_NULL_SESSION, SB_ASC_RET_NULL_SESSION, SB_ASC_RET_NULL_SESSION);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, ASC_RET_ALLOW_NON_USER_LOGONS, SB_ASC_RET_ALLOW_NON_USER_LOGONS, SB_ASC_RET_ALLOW_NON_USER_LOGONS);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, ASC_RET_ALLOW_CONTEXT_REPLAY, SB_ASC_RET_ALLOW_CONTEXT_REPLAY, SB_ASC_RET_ALLOW_CONTEXT_REPLAY);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, ASC_RET_FRAGMENT_ONLY, SB_ASC_RET_FRAGMENT_ONLY, SB_ASC_RET_FRAGMENT_ONLY);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, ASC_RET_NO_TOKEN, SB_ASC_RET_NO_TOKEN, SB_ASC_RET_NO_TOKEN);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SECPKG_CRED_ATTR_NAMES, SB_SECPKG_CRED_ATTR_NAMES, SB_SECPKG_CRED_ATTR_NAMES);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SECPKG_CRED_ATTR_SSI_PROVIDER, SB_SECPKG_CRED_ATTR_SSI_PROVIDER, SB_SECPKG_CRED_ATTR_SSI_PROVIDER);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SECPKG_ATTR_SIZES, SB_SECPKG_ATTR_SIZES, SB_SECPKG_ATTR_SIZES);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SECPKG_ATTR_NAMES, SB_SECPKG_ATTR_NAMES, SB_SECPKG_ATTR_NAMES);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SECPKG_ATTR_LIFESPAN, SB_SECPKG_ATTR_LIFESPAN, SB_SECPKG_ATTR_LIFESPAN);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SECPKG_ATTR_DCE_INFO, SB_SECPKG_ATTR_DCE_INFO, SB_SECPKG_ATTR_DCE_INFO);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SECPKG_ATTR_STREAM_SIZES, SB_SECPKG_ATTR_STREAM_SIZES, SB_SECPKG_ATTR_STREAM_SIZES);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SECPKG_ATTR_KEY_INFO, SB_SECPKG_ATTR_KEY_INFO, SB_SECPKG_ATTR_KEY_INFO);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SECPKG_ATTR_AUTHORITY, SB_SECPKG_ATTR_AUTHORITY, SB_SECPKG_ATTR_AUTHORITY);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SECPKG_ATTR_PROTO_INFO, SB_SECPKG_ATTR_PROTO_INFO, SB_SECPKG_ATTR_PROTO_INFO);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SECPKG_ATTR_PASSWORD_EXPIRY, SB_SECPKG_ATTR_PASSWORD_EXPIRY, SB_SECPKG_ATTR_PASSWORD_EXPIRY);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SECPKG_ATTR_SESSION_KEY, SB_SECPKG_ATTR_SESSION_KEY, SB_SECPKG_ATTR_SESSION_KEY);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SECPKG_ATTR_PACKAGE_INFO, SB_SECPKG_ATTR_PACKAGE_INFO, SB_SECPKG_ATTR_PACKAGE_INFO);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SECPKG_ATTR_USER_FLAGS, SB_SECPKG_ATTR_USER_FLAGS, SB_SECPKG_ATTR_USER_FLAGS);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SECPKG_ATTR_NEGOTIATION_INFO, SB_SECPKG_ATTR_NEGOTIATION_INFO, SB_SECPKG_ATTR_NEGOTIATION_INFO);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SECPKG_ATTR_NATIVE_NAMES, SB_SECPKG_ATTR_NATIVE_NAMES, SB_SECPKG_ATTR_NATIVE_NAMES);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SECPKG_ATTR_FLAGS, SB_SECPKG_ATTR_FLAGS, SB_SECPKG_ATTR_FLAGS);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SECPKG_ATTR_USE_VALIDATED, SB_SECPKG_ATTR_USE_VALIDATED, SB_SECPKG_ATTR_USE_VALIDATED);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SECPKG_ATTR_CREDENTIAL_NAME, SB_SECPKG_ATTR_CREDENTIAL_NAME, SB_SECPKG_ATTR_CREDENTIAL_NAME);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SECPKG_ATTR_TARGET_INFORMATION, SB_SECPKG_ATTR_TARGET_INFORMATION, SB_SECPKG_ATTR_TARGET_INFORMATION);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SECPKG_ATTR_ACCESS_TOKEN, SB_SECPKG_ATTR_ACCESS_TOKEN, SB_SECPKG_ATTR_ACCESS_TOKEN);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SECPKG_ATTR_TARGET, SB_SECPKG_ATTR_TARGET, SB_SECPKG_ATTR_TARGET);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SECPKG_ATTR_AUTHENTICATION_ID, SB_SECPKG_ATTR_AUTHENTICATION_ID, SB_SECPKG_ATTR_AUTHENTICATION_ID);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SECPKG_ATTR_LOGOFF_TIME, SB_SECPKG_ATTR_LOGOFF_TIME, SB_SECPKG_ATTR_LOGOFF_TIME);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SECPKG_NEGOTIATION_COMPLETE, SB_SECPKG_NEGOTIATION_COMPLETE, SB_SECPKG_NEGOTIATION_COMPLETE);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SECPKG_NEGOTIATION_OPTIMISTIC, SB_SECPKG_NEGOTIATION_OPTIMISTIC, SB_SECPKG_NEGOTIATION_OPTIMISTIC);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SECPKG_NEGOTIATION_IN_PROGRESS, SB_SECPKG_NEGOTIATION_IN_PROGRESS, SB_SECPKG_NEGOTIATION_IN_PROGRESS);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SECPKG_NEGOTIATION_DIRECT, SB_SECPKG_NEGOTIATION_DIRECT, SB_SECPKG_NEGOTIATION_DIRECT);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SECPKG_NEGOTIATION_TRY_MULTICRED, SB_SECPKG_NEGOTIATION_TRY_MULTICRED, SB_SECPKG_NEGOTIATION_TRY_MULTICRED);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SECPKG_CONTEXT_EXPORT_RESET_NEW, SB_SECPKG_CONTEXT_EXPORT_RESET_NEW, SB_SECPKG_CONTEXT_EXPORT_RESET_NEW);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SECPKG_CONTEXT_EXPORT_DELETE_OLD, SB_SECPKG_CONTEXT_EXPORT_DELETE_OLD, SB_SECPKG_CONTEXT_EXPORT_DELETE_OLD);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SECPKG_CONTEXT_EXPORT_TO_KERNEL, SB_SECPKG_CONTEXT_EXPORT_TO_KERNEL, SB_SECPKG_CONTEXT_EXPORT_TO_KERNEL);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SECQOP_WRAP_NO_ENCRYPT, SB_SECQOP_WRAP_NO_ENCRYPT, SB_SECQOP_WRAP_NO_ENCRYPT);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SECQOP_WRAP_OOB_DATA, SB_SECQOP_WRAP_OOB_DATA, SB_SECQOP_WRAP_OOB_DATA);
	SB_REGISTER_STRING_CONSTANT(SBSSPI, SECURITY_ENTRYPOINT_ANSIW, SB_SECURITY_ENTRYPOINT_ANSIW, SB_SECURITY_ENTRYPOINT_ANSIW);
	SB_REGISTER_STRING_CONSTANT(SBSSPI, SECURITY_ENTRYPOINT_ANSIA, SB_SECURITY_ENTRYPOINT_ANSIA, SB_SECURITY_ENTRYPOINT_ANSIA);
	SB_REGISTER_STRING_CONSTANT(SBSSPI, SECURITY_ENTRYPOINTW, SB_SECURITY_ENTRYPOINTW, SB_SECURITY_ENTRYPOINTW);
	SB_REGISTER_STRING_CONSTANT(SBSSPI, SECURITY_ENTRYPOINTA, SB_SECURITY_ENTRYPOINTA, SB_SECURITY_ENTRYPOINTA);
	SB_REGISTER_STRING_CONSTANT(SBSSPI, SECURITY_ENTRYPOINT16, SB_SECURITY_ENTRYPOINT16, SB_SECURITY_ENTRYPOINT16);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SECURITY_SUPPORT_PROVIDER_INTERFACE_VERSION, SB_SECURITY_SUPPORT_PROVIDER_INTERFACE_VERSION, SB_SECURITY_SUPPORT_PROVIDER_INTERFACE_VERSION);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SECURITY_SUPPORT_PROVIDER_INTERFACE_VERSION_2, SB_SECURITY_SUPPORT_PROVIDER_INTERFACE_VERSION_2, SB_SECURITY_SUPPORT_PROVIDER_INTERFACE_VERSION_2);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SECURITY_SUPPORT_PROVIDER_INTERFACE_VERSION_3, SB_SECURITY_SUPPORT_PROVIDER_INTERFACE_VERSION_3, SB_SECURITY_SUPPORT_PROVIDER_INTERFACE_VERSION_3);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SEC_WINNT_AUTH_IDENTITY_ANSI, SB_SEC_WINNT_AUTH_IDENTITY_ANSI, SB_SEC_WINNT_AUTH_IDENTITY_ANSI);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SEC_WINNT_AUTH_IDENTITY_UNICODE, SB_SEC_WINNT_AUTH_IDENTITY_UNICODE, SB_SEC_WINNT_AUTH_IDENTITY_UNICODE);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SEC_WINNT_AUTH_IDENTITY_VERSION, SB_SEC_WINNT_AUTH_IDENTITY_VERSION, SB_SEC_WINNT_AUTH_IDENTITY_VERSION);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SEC_WINNT_AUTH_IDENTITY_MARSHALLED, SB_SEC_WINNT_AUTH_IDENTITY_MARSHALLED, SB_SEC_WINNT_AUTH_IDENTITY_MARSHALLED);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SEC_WINNT_AUTH_IDENTITY_ONLY, SB_SEC_WINNT_AUTH_IDENTITY_ONLY, SB_SEC_WINNT_AUTH_IDENTITY_ONLY);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SEC_E_OK, SB_SEC_E_OK, SB_SEC_E_OK);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SEC_E_INSUFFICIENT_MEMORY, SB_SEC_E_INSUFFICIENT_MEMORY, SB_SEC_E_INSUFFICIENT_MEMORY);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SEC_E_INVALID_HANDLE, SB_SEC_E_INVALID_HANDLE, SB_SEC_E_INVALID_HANDLE);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SEC_E_UNSUPPORTED_FUNCTION, SB_SEC_E_UNSUPPORTED_FUNCTION, SB_SEC_E_UNSUPPORTED_FUNCTION);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SEC_E_TARGET_UNKNOWN, SB_SEC_E_TARGET_UNKNOWN, SB_SEC_E_TARGET_UNKNOWN);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SEC_E_INTERNAL_ERROR, SB_SEC_E_INTERNAL_ERROR, SB_SEC_E_INTERNAL_ERROR);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SEC_E_SECPKG_NOT_FOUND, SB_SEC_E_SECPKG_NOT_FOUND, SB_SEC_E_SECPKG_NOT_FOUND);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SEC_E_NOT_OWNER, SB_SEC_E_NOT_OWNER, SB_SEC_E_NOT_OWNER);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SEC_E_CANNOT_INSTALL, SB_SEC_E_CANNOT_INSTALL, SB_SEC_E_CANNOT_INSTALL);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SEC_E_INVALID_TOKEN, SB_SEC_E_INVALID_TOKEN, SB_SEC_E_INVALID_TOKEN);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SEC_E_CANNOT_PACK, SB_SEC_E_CANNOT_PACK, SB_SEC_E_CANNOT_PACK);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SEC_E_QOP_NOT_SUPPORTED, SB_SEC_E_QOP_NOT_SUPPORTED, SB_SEC_E_QOP_NOT_SUPPORTED);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SEC_E_NO_IMPERSONATION, SB_SEC_E_NO_IMPERSONATION, SB_SEC_E_NO_IMPERSONATION);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SEC_E_LOGON_DENIED, SB_SEC_E_LOGON_DENIED, SB_SEC_E_LOGON_DENIED);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SEC_E_UNKNOWN_CREDENTIALS, SB_SEC_E_UNKNOWN_CREDENTIALS, SB_SEC_E_UNKNOWN_CREDENTIALS);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SEC_E_NO_CREDENTIALS, SB_SEC_E_NO_CREDENTIALS, SB_SEC_E_NO_CREDENTIALS);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SEC_E_MESSAGE_ALTERED, SB_SEC_E_MESSAGE_ALTERED, SB_SEC_E_MESSAGE_ALTERED);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SEC_E_OUT_OF_SEQUENCE, SB_SEC_E_OUT_OF_SEQUENCE, SB_SEC_E_OUT_OF_SEQUENCE);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SEC_E_NO_AUTHENTICATING_AUTHORITY, SB_SEC_E_NO_AUTHENTICATING_AUTHORITY, SB_SEC_E_NO_AUTHENTICATING_AUTHORITY);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SEC_I_CONTINUE_NEEDED, SB_SEC_I_CONTINUE_NEEDED, SB_SEC_I_CONTINUE_NEEDED);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SEC_I_COMPLETE_NEEDED, SB_SEC_I_COMPLETE_NEEDED, SB_SEC_I_COMPLETE_NEEDED);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SEC_I_COMPLETE_AND_CONTINUE, SB_SEC_I_COMPLETE_AND_CONTINUE, SB_SEC_I_COMPLETE_AND_CONTINUE);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SEC_I_LOCAL_LOGON, SB_SEC_I_LOCAL_LOGON, SB_SEC_I_LOCAL_LOGON);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SEC_E_BAD_PKGID, SB_SEC_E_BAD_PKGID, SB_SEC_E_BAD_PKGID);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SEC_E_CONTEXT_EXPIRED, SB_SEC_E_CONTEXT_EXPIRED, SB_SEC_E_CONTEXT_EXPIRED);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SEC_E_INCOMPLETE_MESSAGE, SB_SEC_E_INCOMPLETE_MESSAGE, SB_SEC_E_INCOMPLETE_MESSAGE);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SEC_E_INCOMPLETE_CREDENTIALS, SB_SEC_E_INCOMPLETE_CREDENTIALS, SB_SEC_E_INCOMPLETE_CREDENTIALS);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SEC_E_BUFFER_TOO_SMALL, SB_SEC_E_BUFFER_TOO_SMALL, SB_SEC_E_BUFFER_TOO_SMALL);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SEC_I_INCOMPLETE_CREDENTIALS, SB_SEC_I_INCOMPLETE_CREDENTIALS, SB_SEC_I_INCOMPLETE_CREDENTIALS);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SEC_I_RENEGOTIATE, SB_SEC_I_RENEGOTIATE, SB_SEC_I_RENEGOTIATE);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SEC_E_WRONG_PRINCIPAL, SB_SEC_E_WRONG_PRINCIPAL, SB_SEC_E_WRONG_PRINCIPAL);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SEC_I_NO_LSA_CONTEXT, SB_SEC_I_NO_LSA_CONTEXT, SB_SEC_I_NO_LSA_CONTEXT);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SEC_E_TIME_SKEW, SB_SEC_E_TIME_SKEW, SB_SEC_E_TIME_SKEW);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SEC_E_UNTRUSTED_ROOT, SB_SEC_E_UNTRUSTED_ROOT, SB_SEC_E_UNTRUSTED_ROOT);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SEC_E_ILLEGAL_MESSAGE, SB_SEC_E_ILLEGAL_MESSAGE, SB_SEC_E_ILLEGAL_MESSAGE);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SEC_E_CERT_UNKNOWN, SB_SEC_E_CERT_UNKNOWN, SB_SEC_E_CERT_UNKNOWN);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SEC_E_CERT_EXPIRED, SB_SEC_E_CERT_EXPIRED, SB_SEC_E_CERT_EXPIRED);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SEC_E_ENCRYPT_FAILURE, SB_SEC_E_ENCRYPT_FAILURE, SB_SEC_E_ENCRYPT_FAILURE);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SEC_E_DECRYPT_FAILURE, SB_SEC_E_DECRYPT_FAILURE, SB_SEC_E_DECRYPT_FAILURE);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SEC_E_ALGORITHM_MISMATCH, SB_SEC_E_ALGORITHM_MISMATCH, SB_SEC_E_ALGORITHM_MISMATCH);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SEC_E_SECURITY_QOS_FAILED, SB_SEC_E_SECURITY_QOS_FAILED, SB_SEC_E_SECURITY_QOS_FAILED);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SEC_E_UNFINISHED_CONTEXT_DELETED, SB_SEC_E_UNFINISHED_CONTEXT_DELETED, SB_SEC_E_UNFINISHED_CONTEXT_DELETED);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SEC_E_NO_TGT_REPLY, SB_SEC_E_NO_TGT_REPLY, SB_SEC_E_NO_TGT_REPLY);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SEC_E_NO_IP_ADDRESSES, SB_SEC_E_NO_IP_ADDRESSES, SB_SEC_E_NO_IP_ADDRESSES);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SEC_E_WRONG_CREDENTIAL_HANDLE, SB_SEC_E_WRONG_CREDENTIAL_HANDLE, SB_SEC_E_WRONG_CREDENTIAL_HANDLE);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SEC_E_CRYPTO_SYSTEM_INVALID, SB_SEC_E_CRYPTO_SYSTEM_INVALID, SB_SEC_E_CRYPTO_SYSTEM_INVALID);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SEC_E_MAX_REFERRALS_EXCEEDED, SB_SEC_E_MAX_REFERRALS_EXCEEDED, SB_SEC_E_MAX_REFERRALS_EXCEEDED);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SEC_E_MUST_BE_KDC, SB_SEC_E_MUST_BE_KDC, SB_SEC_E_MUST_BE_KDC);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SEC_E_STRONG_CRYPTO_NOT_SUPPORTED, SB_SEC_E_STRONG_CRYPTO_NOT_SUPPORTED, SB_SEC_E_STRONG_CRYPTO_NOT_SUPPORTED);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SEC_E_TOO_MANY_PRINCIPALS, SB_SEC_E_TOO_MANY_PRINCIPALS, SB_SEC_E_TOO_MANY_PRINCIPALS);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SEC_E_NO_PA_DATA, SB_SEC_E_NO_PA_DATA, SB_SEC_E_NO_PA_DATA);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SEC_E_PKINIT_NAME_MISMATCH, SB_SEC_E_PKINIT_NAME_MISMATCH, SB_SEC_E_PKINIT_NAME_MISMATCH);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SEC_E_SMARTCARD_LOGON_REQUIRED, SB_SEC_E_SMARTCARD_LOGON_REQUIRED, SB_SEC_E_SMARTCARD_LOGON_REQUIRED);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SEC_E_SHUTDOWN_IN_PROGRESS, SB_SEC_E_SHUTDOWN_IN_PROGRESS, SB_SEC_E_SHUTDOWN_IN_PROGRESS);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SEC_E_KDC_INVALID_REQUEST, SB_SEC_E_KDC_INVALID_REQUEST, SB_SEC_E_KDC_INVALID_REQUEST);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SEC_E_KDC_UNABLE_TO_REFER, SB_SEC_E_KDC_UNABLE_TO_REFER, SB_SEC_E_KDC_UNABLE_TO_REFER);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SEC_E_KDC_UNKNOWN_ETYPE, SB_SEC_E_KDC_UNKNOWN_ETYPE, SB_SEC_E_KDC_UNKNOWN_ETYPE);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SEC_E_UNSUPPORTED_PREAUTH, SB_SEC_E_UNSUPPORTED_PREAUTH, SB_SEC_E_UNSUPPORTED_PREAUTH);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SEC_E_DELEGATION_REQUIRED, SB_SEC_E_DELEGATION_REQUIRED, SB_SEC_E_DELEGATION_REQUIRED);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SEC_E_BAD_BINDINGS, SB_SEC_E_BAD_BINDINGS, SB_SEC_E_BAD_BINDINGS);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SEC_E_MULTIPLE_ACCOUNTS, SB_SEC_E_MULTIPLE_ACCOUNTS, SB_SEC_E_MULTIPLE_ACCOUNTS);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SEC_E_NO_KERB_KEY, SB_SEC_E_NO_KERB_KEY, SB_SEC_E_NO_KERB_KEY);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SEC_E_CERT_WRONG_USAGE, SB_SEC_E_CERT_WRONG_USAGE, SB_SEC_E_CERT_WRONG_USAGE);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SEC_E_DOWNGRADE_DETECTED, SB_SEC_E_DOWNGRADE_DETECTED, SB_SEC_E_DOWNGRADE_DETECTED);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SEC_E_SMARTCARD_CERT_REVOKED, SB_SEC_E_SMARTCARD_CERT_REVOKED, SB_SEC_E_SMARTCARD_CERT_REVOKED);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SEC_E_ISSUING_CA_UNTRUSTED, SB_SEC_E_ISSUING_CA_UNTRUSTED, SB_SEC_E_ISSUING_CA_UNTRUSTED);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SEC_E_REVOCATION_OFFLINE_C, SB_SEC_E_REVOCATION_OFFLINE_C, SB_SEC_E_REVOCATION_OFFLINE_C);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SEC_E_PKINIT_CLIENT_FAILURE, SB_SEC_E_PKINIT_CLIENT_FAILURE, SB_SEC_E_PKINIT_CLIENT_FAILURE);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SEC_E_SMARTCARD_CERT_EXPIRED, SB_SEC_E_SMARTCARD_CERT_EXPIRED, SB_SEC_E_SMARTCARD_CERT_EXPIRED);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SEC_E_NO_S4U_PROT_SUPPORT, SB_SEC_E_NO_S4U_PROT_SUPPORT, SB_SEC_E_NO_S4U_PROT_SUPPORT);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SEC_E_CROSSREALM_DELEGATION_FAILURE, SB_SEC_E_CROSSREALM_DELEGATION_FAILURE, SB_SEC_E_CROSSREALM_DELEGATION_FAILURE);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SEC_E_REVOCATION_OFFLINE_KDC, SB_SEC_E_REVOCATION_OFFLINE_KDC, SB_SEC_E_REVOCATION_OFFLINE_KDC);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SEC_E_ISSUING_CA_UNTRUSTED_KDC, SB_SEC_E_ISSUING_CA_UNTRUSTED_KDC, SB_SEC_E_ISSUING_CA_UNTRUSTED_KDC);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SEC_E_KDC_CERT_EXPIRED, SB_SEC_E_KDC_CERT_EXPIRED, SB_SEC_E_KDC_CERT_EXPIRED);
	SB_REGISTER_LONG_CONSTANT(SBSSPI, SEC_E_KDC_CERT_REVOKED, SB_SEC_E_KDC_CERT_REVOKED, SB_SEC_E_KDC_CERT_REVOKED);
}

void Register_SBSSPI_Enum_Flags(TSRMLS_D)
{
	zend_class_entry ce;
	INIT_CLASS_ENTRY(ce, "SecDelegationType", NULL);
	SecDelegationType_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	SecDelegationType_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(SecDelegationType_ce_ptr, "SecFull", 0)
	SB_DECLARE_CLASS_LONG_CONST(SecDelegationType_ce_ptr, "SecService", 1)
	SB_DECLARE_CLASS_LONG_CONST(SecDelegationType_ce_ptr, "SecTree", 2)
	SB_DECLARE_CLASS_LONG_CONST(SecDelegationType_ce_ptr, "SecDirectory", 3)
	SB_DECLARE_CLASS_LONG_CONST(SecDelegationType_ce_ptr, "SecObject", 4)
}

void Register_SBSSPI_Aliases(TSRMLS_D)
{
	if (NULL == windows_LARGE_INTEGER_ce_ptr)
		Register_windows_LARGE_INTEGER(TSRMLS_C);
	zend_register_class_alias("SECURITY_INTEGER", windows_LARGE_INTEGER_ce_ptr);
	if (NULL == windows_LARGE_INTEGER_ce_ptr)
		Register_windows_LARGE_INTEGER(TSRMLS_C);
	zend_register_class_alias("TimeStamp", windows_LARGE_INTEGER_ce_ptr);
	if (NULL == SecHandle_ce_ptr)
		Register_SecHandle(TSRMLS_C);
	zend_register_class_alias("SBSSPI_CredHandle", SecHandle_ce_ptr);
	if (NULL == SecHandle_ce_ptr)
		Register_SecHandle(TSRMLS_C);
	zend_register_class_alias("SBSSPI_CtxtHandle", SecHandle_ce_ptr);
}
#endif
