#include "sbdefs.h"
#ifdef SB_WINDOWS
#include "sbwincrypt.h"

SB_PHP_METHOD(CRYPTOAPI_BLOB, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(CRYPTOAPI_BLOB));
		intern->len = sizeof(CRYPTOAPI_BLOB);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(CRYPTOAPI_BLOB, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(CRYPTOAPI_BLOB));
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBBaseStruct_GetField, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBBaseStruct_SetField, 0, 0, 1)
	ZEND_ARG_INFO(0, value)
ZEND_END_ARG_INFO()

SB_PHP_METHOD(CRYPTOAPI_BLOB, get_cbData)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(CRYPTOAPI_BLOB, set_cbData)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

zend_class_entry *CRYPTOAPI_BLOB_ce_ptr = NULL;

static zend_function_entry CRYPTOAPI_BLOB_methods[] = {
	PHP_ME(CRYPTOAPI_BLOB, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(CRYPTOAPI_BLOB, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(CRYPTOAPI_BLOB, get_cbData, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(CRYPTOAPI_BLOB, set_cbData, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_CRYPTOAPI_BLOB(TSRMLS_D)
{
	zend_class_entry ce;
	if (CRYPTOAPI_BLOB_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "CRYPTOAPI_BLOB", CRYPTOAPI_BLOB_methods);
	CRYPTOAPI_BLOB_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(CRYPT_BIT_BLOB, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(CRYPT_BIT_BLOB));
		intern->len = sizeof(CRYPT_BIT_BLOB);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(CRYPT_BIT_BLOB, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(CRYPT_BIT_BLOB));
}

SB_PHP_METHOD(CRYPT_BIT_BLOB, get_cbData)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(CRYPT_BIT_BLOB, set_cbData)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(CRYPT_BIT_BLOB, get_cUnusedBits)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 8);
}

SB_PHP_METHOD(CRYPT_BIT_BLOB, set_cUnusedBits)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 8);
}

zend_class_entry *CRYPT_BIT_BLOB_ce_ptr = NULL;

static zend_function_entry CRYPT_BIT_BLOB_methods[] = {
	PHP_ME(CRYPT_BIT_BLOB, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(CRYPT_BIT_BLOB, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(CRYPT_BIT_BLOB, get_cbData, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(CRYPT_BIT_BLOB, set_cbData, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(CRYPT_BIT_BLOB, get_cUnusedBits, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(CRYPT_BIT_BLOB, set_cUnusedBits, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_CRYPT_BIT_BLOB(TSRMLS_D)
{
	zend_class_entry ce;
	if (CRYPT_BIT_BLOB_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "CRYPT_BIT_BLOB", CRYPT_BIT_BLOB_methods);
	CRYPT_BIT_BLOB_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(CRYPT_ALGORITHM_IDENTIFIER, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(CRYPT_ALGORITHM_IDENTIFIER));
		intern->len = sizeof(CRYPT_ALGORITHM_IDENTIFIER);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(CRYPT_ALGORITHM_IDENTIFIER, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(CRYPT_ALGORITHM_IDENTIFIER));
}

zend_class_entry *CRYPT_ALGORITHM_IDENTIFIER_ce_ptr = NULL;

static zend_function_entry CRYPT_ALGORITHM_IDENTIFIER_methods[] = {
	PHP_ME(CRYPT_ALGORITHM_IDENTIFIER, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(CRYPT_ALGORITHM_IDENTIFIER, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_FE_END
};

void Register_CRYPT_ALGORITHM_IDENTIFIER(TSRMLS_D)
{
	zend_class_entry ce;
	if (CRYPT_ALGORITHM_IDENTIFIER_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "CRYPT_ALGORITHM_IDENTIFIER", CRYPT_ALGORITHM_IDENTIFIER_methods);
	CRYPT_ALGORITHM_IDENTIFIER_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(CERT_PUBLIC_KEY_INFO, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(CERT_PUBLIC_KEY_INFO));
		intern->len = sizeof(CERT_PUBLIC_KEY_INFO);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(CERT_PUBLIC_KEY_INFO, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(CERT_PUBLIC_KEY_INFO));
}

zend_class_entry *CERT_PUBLIC_KEY_INFO_ce_ptr = NULL;

static zend_function_entry CERT_PUBLIC_KEY_INFO_methods[] = {
	PHP_ME(CERT_PUBLIC_KEY_INFO, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(CERT_PUBLIC_KEY_INFO, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_FE_END
};

void Register_CERT_PUBLIC_KEY_INFO(TSRMLS_D)
{
	zend_class_entry ce;
	if (CERT_PUBLIC_KEY_INFO_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "CERT_PUBLIC_KEY_INFO", CERT_PUBLIC_KEY_INFO_methods);
	CERT_PUBLIC_KEY_INFO_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(CERT_EXTENSION, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(CERT_EXTENSION));
		intern->len = sizeof(CERT_EXTENSION);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(CERT_EXTENSION, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(CERT_EXTENSION));
}

zend_class_entry *CERT_EXTENSION_ce_ptr = NULL;

static zend_function_entry CERT_EXTENSION_methods[] = {
	PHP_ME(CERT_EXTENSION, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(CERT_EXTENSION, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_FE_END
};

void Register_CERT_EXTENSION(TSRMLS_D)
{
	zend_class_entry ce;
	if (CERT_EXTENSION_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "CERT_EXTENSION", CERT_EXTENSION_methods);
	CERT_EXTENSION_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(CERT_INFO, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(CERT_INFO));
		intern->len = sizeof(CERT_INFO);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(CERT_INFO, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(CERT_INFO));
}

SB_PHP_METHOD(CERT_INFO, get_dwVersion)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(CERT_INFO, set_dwVersion)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(CERT_INFO, get_cExtension)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 104);
}

SB_PHP_METHOD(CERT_INFO, set_cExtension)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 104);
}

zend_class_entry *CERT_INFO_ce_ptr = NULL;

static zend_function_entry CERT_INFO_methods[] = {
	PHP_ME(CERT_INFO, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(CERT_INFO, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(CERT_INFO, get_dwVersion, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(CERT_INFO, set_dwVersion, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(CERT_INFO, get_cExtension, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(CERT_INFO, set_cExtension, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_CERT_INFO(TSRMLS_D)
{
	zend_class_entry ce;
	if (CERT_INFO_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "CERT_INFO", CERT_INFO_methods);
	CERT_INFO_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(CERT_CONTEXT, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(CERT_CONTEXT));
		intern->len = sizeof(CERT_CONTEXT);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(CERT_CONTEXT, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(CERT_CONTEXT));
}

SB_PHP_METHOD(CERT_CONTEXT, get_dwCertEncodingType)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(CERT_CONTEXT, set_dwCertEncodingType)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(CERT_CONTEXT, get_cbCertEncoded)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 8);
}

SB_PHP_METHOD(CERT_CONTEXT, set_cbCertEncoded)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 8);
}

zend_class_entry *CERT_CONTEXT_ce_ptr = NULL;

static zend_function_entry CERT_CONTEXT_methods[] = {
	PHP_ME(CERT_CONTEXT, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(CERT_CONTEXT, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(CERT_CONTEXT, get_dwCertEncodingType, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(CERT_CONTEXT, set_dwCertEncodingType, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(CERT_CONTEXT, get_cbCertEncoded, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(CERT_CONTEXT, set_cbCertEncoded, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_CERT_CONTEXT(TSRMLS_D)
{
	zend_class_entry ce;
	if (CERT_CONTEXT_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "CERT_CONTEXT", CERT_CONTEXT_methods);
	CERT_CONTEXT_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(CRYPTUI_VIEWCERTIFICATE_STRUCT, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(CRYPTUI_VIEWCERTIFICATE_STRUCT));
		intern->len = sizeof(CRYPTUI_VIEWCERTIFICATE_STRUCT);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(CRYPTUI_VIEWCERTIFICATE_STRUCT, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(CRYPTUI_VIEWCERTIFICATE_STRUCT));
}

SB_PHP_METHOD(CRYPTUI_VIEWCERTIFICATE_STRUCT, get_dwSize)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(CRYPTUI_VIEWCERTIFICATE_STRUCT, set_dwSize)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(CRYPTUI_VIEWCERTIFICATE_STRUCT, get_hwndParent)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 4);
}

SB_PHP_METHOD(CRYPTUI_VIEWCERTIFICATE_STRUCT, set_hwndParent)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 4);
}

SB_PHP_METHOD(CRYPTUI_VIEWCERTIFICATE_STRUCT, get_dwFlags)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 8);
}

SB_PHP_METHOD(CRYPTUI_VIEWCERTIFICATE_STRUCT, set_dwFlags)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 8);
}

SB_PHP_METHOD(CRYPTUI_VIEWCERTIFICATE_STRUCT, get_cPurposes)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 24);
}

SB_PHP_METHOD(CRYPTUI_VIEWCERTIFICATE_STRUCT, set_cPurposes)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 24);
}

SB_PHP_METHOD(CRYPTUI_VIEWCERTIFICATE_STRUCT, get_idxSigner)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 36);
}

SB_PHP_METHOD(CRYPTUI_VIEWCERTIFICATE_STRUCT, set_idxSigner)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 36);
}

SB_PHP_METHOD(CRYPTUI_VIEWCERTIFICATE_STRUCT, get_idxCert)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 40);
}

SB_PHP_METHOD(CRYPTUI_VIEWCERTIFICATE_STRUCT, set_idxCert)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 40);
}

SB_PHP_METHOD(CRYPTUI_VIEWCERTIFICATE_STRUCT, get_idxCounterSigner)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 48);
}

SB_PHP_METHOD(CRYPTUI_VIEWCERTIFICATE_STRUCT, set_idxCounterSigner)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 48);
}

SB_PHP_METHOD(CRYPTUI_VIEWCERTIFICATE_STRUCT, get_cStores)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 52);
}

SB_PHP_METHOD(CRYPTUI_VIEWCERTIFICATE_STRUCT, set_cStores)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 52);
}

SB_PHP_METHOD(CRYPTUI_VIEWCERTIFICATE_STRUCT, get_cPropSheetPages)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 60);
}

SB_PHP_METHOD(CRYPTUI_VIEWCERTIFICATE_STRUCT, set_cPropSheetPages)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 60);
}

SB_PHP_METHOD(CRYPTUI_VIEWCERTIFICATE_STRUCT, get_nStartPage)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 68);
}

SB_PHP_METHOD(CRYPTUI_VIEWCERTIFICATE_STRUCT, set_nStartPage)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 68);
}

zend_class_entry *CRYPTUI_VIEWCERTIFICATE_STRUCT_ce_ptr = NULL;

static zend_function_entry CRYPTUI_VIEWCERTIFICATE_STRUCT_methods[] = {
	PHP_ME(CRYPTUI_VIEWCERTIFICATE_STRUCT, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(CRYPTUI_VIEWCERTIFICATE_STRUCT, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(CRYPTUI_VIEWCERTIFICATE_STRUCT, get_dwSize, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(CRYPTUI_VIEWCERTIFICATE_STRUCT, set_dwSize, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(CRYPTUI_VIEWCERTIFICATE_STRUCT, get_hwndParent, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(CRYPTUI_VIEWCERTIFICATE_STRUCT, set_hwndParent, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(CRYPTUI_VIEWCERTIFICATE_STRUCT, get_dwFlags, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(CRYPTUI_VIEWCERTIFICATE_STRUCT, set_dwFlags, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(CRYPTUI_VIEWCERTIFICATE_STRUCT, get_cPurposes, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(CRYPTUI_VIEWCERTIFICATE_STRUCT, set_cPurposes, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(CRYPTUI_VIEWCERTIFICATE_STRUCT, get_idxSigner, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(CRYPTUI_VIEWCERTIFICATE_STRUCT, set_idxSigner, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(CRYPTUI_VIEWCERTIFICATE_STRUCT, get_idxCert, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(CRYPTUI_VIEWCERTIFICATE_STRUCT, set_idxCert, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(CRYPTUI_VIEWCERTIFICATE_STRUCT, get_idxCounterSigner, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(CRYPTUI_VIEWCERTIFICATE_STRUCT, set_idxCounterSigner, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(CRYPTUI_VIEWCERTIFICATE_STRUCT, get_cStores, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(CRYPTUI_VIEWCERTIFICATE_STRUCT, set_cStores, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(CRYPTUI_VIEWCERTIFICATE_STRUCT, get_cPropSheetPages, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(CRYPTUI_VIEWCERTIFICATE_STRUCT, set_cPropSheetPages, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(CRYPTUI_VIEWCERTIFICATE_STRUCT, get_nStartPage, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(CRYPTUI_VIEWCERTIFICATE_STRUCT, set_nStartPage, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_CRYPTUI_VIEWCERTIFICATE_STRUCT(TSRMLS_D)
{
	zend_class_entry ce;
	if (CRYPTUI_VIEWCERTIFICATE_STRUCT_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "CRYPTUI_VIEWCERTIFICATE_STRUCT", CRYPTUI_VIEWCERTIFICATE_STRUCT_methods);
	CRYPTUI_VIEWCERTIFICATE_STRUCT_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(CRYPTUI_SELECTCERTIFICATE_STRUCT, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(CRYPTUI_SELECTCERTIFICATE_STRUCT));
		intern->len = sizeof(CRYPTUI_SELECTCERTIFICATE_STRUCT);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(CRYPTUI_SELECTCERTIFICATE_STRUCT, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(CRYPTUI_SELECTCERTIFICATE_STRUCT));
}

SB_PHP_METHOD(CRYPTUI_SELECTCERTIFICATE_STRUCT, get_dwSize)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(CRYPTUI_SELECTCERTIFICATE_STRUCT, set_dwSize)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(CRYPTUI_SELECTCERTIFICATE_STRUCT, get_hwndParent)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 4);
}

SB_PHP_METHOD(CRYPTUI_SELECTCERTIFICATE_STRUCT, set_hwndParent)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 4);
}

SB_PHP_METHOD(CRYPTUI_SELECTCERTIFICATE_STRUCT, get_dwFlags)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 8);
}

SB_PHP_METHOD(CRYPTUI_SELECTCERTIFICATE_STRUCT, set_dwFlags)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 8);
}

SB_PHP_METHOD(CRYPTUI_SELECTCERTIFICATE_STRUCT, get_dwDontUseColumn)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 16);
}

SB_PHP_METHOD(CRYPTUI_SELECTCERTIFICATE_STRUCT, set_dwDontUseColumn)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 16);
}

SB_PHP_METHOD(CRYPTUI_SELECTCERTIFICATE_STRUCT, get_cDisplayStores)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 36);
}

SB_PHP_METHOD(CRYPTUI_SELECTCERTIFICATE_STRUCT, set_cDisplayStores)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 36);
}

SB_PHP_METHOD(CRYPTUI_SELECTCERTIFICATE_STRUCT, get_cStores)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 44);
}

SB_PHP_METHOD(CRYPTUI_SELECTCERTIFICATE_STRUCT, set_cStores)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 44);
}

SB_PHP_METHOD(CRYPTUI_SELECTCERTIFICATE_STRUCT, get_cPropSheetPages)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 52);
}

SB_PHP_METHOD(CRYPTUI_SELECTCERTIFICATE_STRUCT, set_cPropSheetPages)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 52);
}

zend_class_entry *CRYPTUI_SELECTCERTIFICATE_STRUCT_ce_ptr = NULL;

static zend_function_entry CRYPTUI_SELECTCERTIFICATE_STRUCT_methods[] = {
	PHP_ME(CRYPTUI_SELECTCERTIFICATE_STRUCT, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(CRYPTUI_SELECTCERTIFICATE_STRUCT, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(CRYPTUI_SELECTCERTIFICATE_STRUCT, get_dwSize, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(CRYPTUI_SELECTCERTIFICATE_STRUCT, set_dwSize, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(CRYPTUI_SELECTCERTIFICATE_STRUCT, get_hwndParent, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(CRYPTUI_SELECTCERTIFICATE_STRUCT, set_hwndParent, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(CRYPTUI_SELECTCERTIFICATE_STRUCT, get_dwFlags, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(CRYPTUI_SELECTCERTIFICATE_STRUCT, set_dwFlags, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(CRYPTUI_SELECTCERTIFICATE_STRUCT, get_dwDontUseColumn, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(CRYPTUI_SELECTCERTIFICATE_STRUCT, set_dwDontUseColumn, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(CRYPTUI_SELECTCERTIFICATE_STRUCT, get_cDisplayStores, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(CRYPTUI_SELECTCERTIFICATE_STRUCT, set_cDisplayStores, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(CRYPTUI_SELECTCERTIFICATE_STRUCT, get_cStores, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(CRYPTUI_SELECTCERTIFICATE_STRUCT, set_cStores, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(CRYPTUI_SELECTCERTIFICATE_STRUCT, get_cPropSheetPages, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(CRYPTUI_SELECTCERTIFICATE_STRUCT, set_cPropSheetPages, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_CRYPTUI_SELECTCERTIFICATE_STRUCT(TSRMLS_D)
{
	zend_class_entry ce;
	if (CRYPTUI_SELECTCERTIFICATE_STRUCT_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "CRYPTUI_SELECTCERTIFICATE_STRUCT", CRYPTUI_SELECTCERTIFICATE_STRUCT_methods);
	CRYPTUI_SELECTCERTIFICATE_STRUCT_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(_CERT_SYSTEM_STORE_INFO, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(_CERT_SYSTEM_STORE_INFO));
		intern->len = sizeof(_CERT_SYSTEM_STORE_INFO);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(_CERT_SYSTEM_STORE_INFO, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(_CERT_SYSTEM_STORE_INFO));
}

SB_PHP_METHOD(_CERT_SYSTEM_STORE_INFO, get_cbSize)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(_CERT_SYSTEM_STORE_INFO, set_cbSize)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

zend_class_entry *_CERT_SYSTEM_STORE_INFO_ce_ptr = NULL;

static zend_function_entry _CERT_SYSTEM_STORE_INFO_methods[] = {
	PHP_ME(_CERT_SYSTEM_STORE_INFO, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(_CERT_SYSTEM_STORE_INFO, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(_CERT_SYSTEM_STORE_INFO, get_cbSize, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(_CERT_SYSTEM_STORE_INFO, set_cbSize, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register__CERT_SYSTEM_STORE_INFO(TSRMLS_D)
{
	zend_class_entry ce;
	if (_CERT_SYSTEM_STORE_INFO_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "_CERT_SYSTEM_STORE_INFO", _CERT_SYSTEM_STORE_INFO_methods);
	_CERT_SYSTEM_STORE_INFO_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(_CRYPT_KEY_PROV_INFO, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(_CRYPT_KEY_PROV_INFO));
		intern->len = sizeof(_CRYPT_KEY_PROV_INFO);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(_CRYPT_KEY_PROV_INFO, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(_CRYPT_KEY_PROV_INFO));
}

SB_PHP_METHOD(_CRYPT_KEY_PROV_INFO, get_dwProvType)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 8);
}

SB_PHP_METHOD(_CRYPT_KEY_PROV_INFO, set_dwProvType)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 8);
}

SB_PHP_METHOD(_CRYPT_KEY_PROV_INFO, get_dwFlags)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 12);
}

SB_PHP_METHOD(_CRYPT_KEY_PROV_INFO, set_dwFlags)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 12);
}

SB_PHP_METHOD(_CRYPT_KEY_PROV_INFO, get_cProvParam)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 16);
}

SB_PHP_METHOD(_CRYPT_KEY_PROV_INFO, set_cProvParam)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 16);
}

SB_PHP_METHOD(_CRYPT_KEY_PROV_INFO, get_dwKeySpec)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 24);
}

SB_PHP_METHOD(_CRYPT_KEY_PROV_INFO, set_dwKeySpec)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 24);
}

zend_class_entry *_CRYPT_KEY_PROV_INFO_ce_ptr = NULL;

static zend_function_entry _CRYPT_KEY_PROV_INFO_methods[] = {
	PHP_ME(_CRYPT_KEY_PROV_INFO, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(_CRYPT_KEY_PROV_INFO, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(_CRYPT_KEY_PROV_INFO, get_dwProvType, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(_CRYPT_KEY_PROV_INFO, set_dwProvType, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(_CRYPT_KEY_PROV_INFO, get_dwFlags, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(_CRYPT_KEY_PROV_INFO, set_dwFlags, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(_CRYPT_KEY_PROV_INFO, get_cProvParam, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(_CRYPT_KEY_PROV_INFO, set_cProvParam, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(_CRYPT_KEY_PROV_INFO, get_dwKeySpec, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(_CRYPT_KEY_PROV_INFO, set_dwKeySpec, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register__CRYPT_KEY_PROV_INFO(TSRMLS_D)
{
	zend_class_entry ce;
	if (_CRYPT_KEY_PROV_INFO_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "_CRYPT_KEY_PROV_INFO", _CRYPT_KEY_PROV_INFO_methods);
	_CRYPT_KEY_PROV_INFO_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(_CRYPT_ATTRIBUTE, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(_CRYPT_ATTRIBUTE));
		intern->len = sizeof(_CRYPT_ATTRIBUTE);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(_CRYPT_ATTRIBUTE, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(_CRYPT_ATTRIBUTE));
}

SB_PHP_METHOD(_CRYPT_ATTRIBUTE, get_cValue)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 4);
}

SB_PHP_METHOD(_CRYPT_ATTRIBUTE, set_cValue)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 4);
}

zend_class_entry *_CRYPT_ATTRIBUTE_ce_ptr = NULL;

static zend_function_entry _CRYPT_ATTRIBUTE_methods[] = {
	PHP_ME(_CRYPT_ATTRIBUTE, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(_CRYPT_ATTRIBUTE, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(_CRYPT_ATTRIBUTE, get_cValue, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(_CRYPT_ATTRIBUTE, set_cValue, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register__CRYPT_ATTRIBUTE(TSRMLS_D)
{
	zend_class_entry ce;
	if (_CRYPT_ATTRIBUTE_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "_CRYPT_ATTRIBUTE", _CRYPT_ATTRIBUTE_methods);
	_CRYPT_ATTRIBUTE_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(_CRYPT_SIGN_MESSAGE_PARA, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(_CRYPT_SIGN_MESSAGE_PARA));
		intern->len = sizeof(_CRYPT_SIGN_MESSAGE_PARA);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(_CRYPT_SIGN_MESSAGE_PARA, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(_CRYPT_SIGN_MESSAGE_PARA));
}

SB_PHP_METHOD(_CRYPT_SIGN_MESSAGE_PARA, get_cbSize)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(_CRYPT_SIGN_MESSAGE_PARA, set_cbSize)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(_CRYPT_SIGN_MESSAGE_PARA, get_dwMsgEncodingType)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 4);
}

SB_PHP_METHOD(_CRYPT_SIGN_MESSAGE_PARA, set_dwMsgEncodingType)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 4);
}

SB_PHP_METHOD(_CRYPT_SIGN_MESSAGE_PARA, get_cMsgCert)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 28);
}

SB_PHP_METHOD(_CRYPT_SIGN_MESSAGE_PARA, set_cMsgCert)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 28);
}

SB_PHP_METHOD(_CRYPT_SIGN_MESSAGE_PARA, get_cMsgCrl)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 36);
}

SB_PHP_METHOD(_CRYPT_SIGN_MESSAGE_PARA, set_cMsgCrl)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 36);
}

SB_PHP_METHOD(_CRYPT_SIGN_MESSAGE_PARA, get_cAuthAttr)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 44);
}

SB_PHP_METHOD(_CRYPT_SIGN_MESSAGE_PARA, set_cAuthAttr)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 44);
}

SB_PHP_METHOD(_CRYPT_SIGN_MESSAGE_PARA, get_cUnauthAttr)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 52);
}

SB_PHP_METHOD(_CRYPT_SIGN_MESSAGE_PARA, set_cUnauthAttr)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 52);
}

SB_PHP_METHOD(_CRYPT_SIGN_MESSAGE_PARA, get_dwFlags)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 60);
}

SB_PHP_METHOD(_CRYPT_SIGN_MESSAGE_PARA, set_dwFlags)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 60);
}

SB_PHP_METHOD(_CRYPT_SIGN_MESSAGE_PARA, get_dwInnerContentType)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 64);
}

SB_PHP_METHOD(_CRYPT_SIGN_MESSAGE_PARA, set_dwInnerContentType)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 64);
}

zend_class_entry *_CRYPT_SIGN_MESSAGE_PARA_ce_ptr = NULL;

static zend_function_entry _CRYPT_SIGN_MESSAGE_PARA_methods[] = {
	PHP_ME(_CRYPT_SIGN_MESSAGE_PARA, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(_CRYPT_SIGN_MESSAGE_PARA, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(_CRYPT_SIGN_MESSAGE_PARA, get_cbSize, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(_CRYPT_SIGN_MESSAGE_PARA, set_cbSize, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(_CRYPT_SIGN_MESSAGE_PARA, get_dwMsgEncodingType, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(_CRYPT_SIGN_MESSAGE_PARA, set_dwMsgEncodingType, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(_CRYPT_SIGN_MESSAGE_PARA, get_cMsgCert, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(_CRYPT_SIGN_MESSAGE_PARA, set_cMsgCert, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(_CRYPT_SIGN_MESSAGE_PARA, get_cMsgCrl, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(_CRYPT_SIGN_MESSAGE_PARA, set_cMsgCrl, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(_CRYPT_SIGN_MESSAGE_PARA, get_cAuthAttr, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(_CRYPT_SIGN_MESSAGE_PARA, set_cAuthAttr, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(_CRYPT_SIGN_MESSAGE_PARA, get_cUnauthAttr, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(_CRYPT_SIGN_MESSAGE_PARA, set_cUnauthAttr, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(_CRYPT_SIGN_MESSAGE_PARA, get_dwFlags, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(_CRYPT_SIGN_MESSAGE_PARA, set_dwFlags, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(_CRYPT_SIGN_MESSAGE_PARA, get_dwInnerContentType, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(_CRYPT_SIGN_MESSAGE_PARA, set_dwInnerContentType, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register__CRYPT_SIGN_MESSAGE_PARA(TSRMLS_D)
{
	zend_class_entry ce;
	if (_CRYPT_SIGN_MESSAGE_PARA_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "_CRYPT_SIGN_MESSAGE_PARA", _CRYPT_SIGN_MESSAGE_PARA_methods);
	_CRYPT_SIGN_MESSAGE_PARA_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(_CRYPT_DECRYPT_MESSAGE_PARA, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(_CRYPT_DECRYPT_MESSAGE_PARA));
		intern->len = sizeof(_CRYPT_DECRYPT_MESSAGE_PARA);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(_CRYPT_DECRYPT_MESSAGE_PARA, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(_CRYPT_DECRYPT_MESSAGE_PARA));
}

SB_PHP_METHOD(_CRYPT_DECRYPT_MESSAGE_PARA, get_cbSize)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(_CRYPT_DECRYPT_MESSAGE_PARA, set_cbSize)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(_CRYPT_DECRYPT_MESSAGE_PARA, get_dwMsgAndCertEncodingType)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 4);
}

SB_PHP_METHOD(_CRYPT_DECRYPT_MESSAGE_PARA, set_dwMsgAndCertEncodingType)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 4);
}

SB_PHP_METHOD(_CRYPT_DECRYPT_MESSAGE_PARA, get_cCertStore)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 8);
}

SB_PHP_METHOD(_CRYPT_DECRYPT_MESSAGE_PARA, set_cCertStore)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 8);
}

zend_class_entry *_CRYPT_DECRYPT_MESSAGE_PARA_ce_ptr = NULL;

static zend_function_entry _CRYPT_DECRYPT_MESSAGE_PARA_methods[] = {
	PHP_ME(_CRYPT_DECRYPT_MESSAGE_PARA, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(_CRYPT_DECRYPT_MESSAGE_PARA, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(_CRYPT_DECRYPT_MESSAGE_PARA, get_cbSize, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(_CRYPT_DECRYPT_MESSAGE_PARA, set_cbSize, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(_CRYPT_DECRYPT_MESSAGE_PARA, get_dwMsgAndCertEncodingType, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(_CRYPT_DECRYPT_MESSAGE_PARA, set_dwMsgAndCertEncodingType, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(_CRYPT_DECRYPT_MESSAGE_PARA, get_cCertStore, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(_CRYPT_DECRYPT_MESSAGE_PARA, set_cCertStore, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register__CRYPT_DECRYPT_MESSAGE_PARA(TSRMLS_D)
{
	zend_class_entry ce;
	if (_CRYPT_DECRYPT_MESSAGE_PARA_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "_CRYPT_DECRYPT_MESSAGE_PARA", _CRYPT_DECRYPT_MESSAGE_PARA_methods);
	_CRYPT_DECRYPT_MESSAGE_PARA_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(_PROV_ENUMALGS, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(_PROV_ENUMALGS));
		intern->len = sizeof(_PROV_ENUMALGS);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(_PROV_ENUMALGS, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(_PROV_ENUMALGS));
}

SB_PHP_METHOD(_PROV_ENUMALGS, get_aiAlgId)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(_PROV_ENUMALGS, set_aiAlgId)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(_PROV_ENUMALGS, get_dwBitLen)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 4);
}

SB_PHP_METHOD(_PROV_ENUMALGS, set_dwBitLen)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 4);
}

SB_PHP_METHOD(_PROV_ENUMALGS, get_dwNameLen)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 8);
}

SB_PHP_METHOD(_PROV_ENUMALGS, set_dwNameLen)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 8);
}

zend_class_entry *_PROV_ENUMALGS_ce_ptr = NULL;

static zend_function_entry _PROV_ENUMALGS_methods[] = {
	PHP_ME(_PROV_ENUMALGS, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(_PROV_ENUMALGS, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(_PROV_ENUMALGS, get_aiAlgId, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(_PROV_ENUMALGS, set_aiAlgId, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(_PROV_ENUMALGS, get_dwBitLen, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(_PROV_ENUMALGS, set_dwBitLen, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(_PROV_ENUMALGS, get_dwNameLen, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(_PROV_ENUMALGS, set_dwNameLen, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register__PROV_ENUMALGS(TSRMLS_D)
{
	zend_class_entry ce;
	if (_PROV_ENUMALGS_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "_PROV_ENUMALGS", _PROV_ENUMALGS_methods);
	_PROV_ENUMALGS_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(_CRYPT_OID_FUNC_ENTRY, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(_CRYPT_OID_FUNC_ENTRY));
		intern->len = sizeof(_CRYPT_OID_FUNC_ENTRY);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(_CRYPT_OID_FUNC_ENTRY, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(_CRYPT_OID_FUNC_ENTRY));
}

zend_class_entry *_CRYPT_OID_FUNC_ENTRY_ce_ptr = NULL;

static zend_function_entry _CRYPT_OID_FUNC_ENTRY_methods[] = {
	PHP_ME(_CRYPT_OID_FUNC_ENTRY, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(_CRYPT_OID_FUNC_ENTRY, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_FE_END
};

void Register__CRYPT_OID_FUNC_ENTRY(TSRMLS_D)
{
	zend_class_entry ce;
	if (_CRYPT_OID_FUNC_ENTRY_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "_CRYPT_OID_FUNC_ENTRY", _CRYPT_OID_FUNC_ENTRY_methods);
	_CRYPT_OID_FUNC_ENTRY_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(_CERT_STORE_PROV_INFO, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(_CERT_STORE_PROV_INFO));
		intern->len = sizeof(_CERT_STORE_PROV_INFO);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(_CERT_STORE_PROV_INFO, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(_CERT_STORE_PROV_INFO));
}

SB_PHP_METHOD(_CERT_STORE_PROV_INFO, get_cbSize)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(_CERT_STORE_PROV_INFO, set_cbSize)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(_CERT_STORE_PROV_INFO, get_cStoreProvFunc)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 4);
}

SB_PHP_METHOD(_CERT_STORE_PROV_INFO, set_cStoreProvFunc)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 4);
}

SB_PHP_METHOD(_CERT_STORE_PROV_INFO, get_dwStoreProvFlags)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 16);
}

SB_PHP_METHOD(_CERT_STORE_PROV_INFO, set_dwStoreProvFlags)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 16);
}

zend_class_entry *_CERT_STORE_PROV_INFO_ce_ptr = NULL;

static zend_function_entry _CERT_STORE_PROV_INFO_methods[] = {
	PHP_ME(_CERT_STORE_PROV_INFO, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(_CERT_STORE_PROV_INFO, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(_CERT_STORE_PROV_INFO, get_cbSize, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(_CERT_STORE_PROV_INFO, set_cbSize, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(_CERT_STORE_PROV_INFO, get_cStoreProvFunc, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(_CERT_STORE_PROV_INFO, set_cStoreProvFunc, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(_CERT_STORE_PROV_INFO, get_dwStoreProvFlags, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(_CERT_STORE_PROV_INFO, set_dwStoreProvFlags, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register__CERT_STORE_PROV_INFO(TSRMLS_D)
{
	zend_class_entry ce;
	if (_CERT_STORE_PROV_INFO_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "_CERT_STORE_PROV_INFO", _CERT_STORE_PROV_INFO_methods);
	_CERT_STORE_PROV_INFO_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(CTL_USAGE, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(CTL_USAGE));
		intern->len = sizeof(CTL_USAGE);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(CTL_USAGE, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(CTL_USAGE));
}

SB_PHP_METHOD(CTL_USAGE, get_cUsageIdentifier)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(CTL_USAGE, set_cUsageIdentifier)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

zend_class_entry *CTL_USAGE_ce_ptr = NULL;

static zend_function_entry CTL_USAGE_methods[] = {
	PHP_ME(CTL_USAGE, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(CTL_USAGE, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(CTL_USAGE, get_cUsageIdentifier, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(CTL_USAGE, set_cUsageIdentifier, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_CTL_USAGE(TSRMLS_D)
{
	zend_class_entry ce;
	if (CTL_USAGE_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "CTL_USAGE", CTL_USAGE_methods);
	CTL_USAGE_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(CTL_ENTRY, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(CTL_ENTRY));
		intern->len = sizeof(CTL_ENTRY);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(CTL_ENTRY, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(CTL_ENTRY));
}

SB_PHP_METHOD(CTL_ENTRY, get_cAttribute)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 8);
}

SB_PHP_METHOD(CTL_ENTRY, set_cAttribute)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 8);
}

zend_class_entry *CTL_ENTRY_ce_ptr = NULL;

static zend_function_entry CTL_ENTRY_methods[] = {
	PHP_ME(CTL_ENTRY, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(CTL_ENTRY, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(CTL_ENTRY, get_cAttribute, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(CTL_ENTRY, set_cAttribute, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_CTL_ENTRY(TSRMLS_D)
{
	zend_class_entry ce;
	if (CTL_ENTRY_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "CTL_ENTRY", CTL_ENTRY_methods);
	CTL_ENTRY_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(CRL_ENTRY, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(CRL_ENTRY));
		intern->len = sizeof(CRL_ENTRY);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(CRL_ENTRY, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(CRL_ENTRY));
}

SB_PHP_METHOD(CRL_ENTRY, get_cExtension)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 16);
}

SB_PHP_METHOD(CRL_ENTRY, set_cExtension)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 16);
}

zend_class_entry *CRL_ENTRY_ce_ptr = NULL;

static zend_function_entry CRL_ENTRY_methods[] = {
	PHP_ME(CRL_ENTRY, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(CRL_ENTRY, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(CRL_ENTRY, get_cExtension, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(CRL_ENTRY, set_cExtension, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_CRL_ENTRY(TSRMLS_D)
{
	zend_class_entry ce;
	if (CRL_ENTRY_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "CRL_ENTRY", CRL_ENTRY_methods);
	CRL_ENTRY_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(CTL_INFO, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(CTL_INFO));
		intern->len = sizeof(CTL_INFO);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(CTL_INFO, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(CTL_INFO));
}

SB_PHP_METHOD(CTL_INFO, get_dwVersion)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(CTL_INFO, set_dwVersion)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(CTL_INFO, get_cCTLEntry)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 56);
}

SB_PHP_METHOD(CTL_INFO, set_cCTLEntry)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 56);
}

SB_PHP_METHOD(CTL_INFO, get_cExtension)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 64);
}

SB_PHP_METHOD(CTL_INFO, set_cExtension)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 64);
}

zend_class_entry *CTL_INFO_ce_ptr = NULL;

static zend_function_entry CTL_INFO_methods[] = {
	PHP_ME(CTL_INFO, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(CTL_INFO, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(CTL_INFO, get_dwVersion, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(CTL_INFO, set_dwVersion, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(CTL_INFO, get_cCTLEntry, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(CTL_INFO, set_cCTLEntry, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(CTL_INFO, get_cExtension, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(CTL_INFO, set_cExtension, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_CTL_INFO(TSRMLS_D)
{
	zend_class_entry ce;
	if (CTL_INFO_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "CTL_INFO", CTL_INFO_methods);
	CTL_INFO_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(CRL_INFO, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(CRL_INFO));
		intern->len = sizeof(CRL_INFO);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(CRL_INFO, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(CRL_INFO));
}

SB_PHP_METHOD(CRL_INFO, get_dwVersion)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(CRL_INFO, set_dwVersion)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(CRL_INFO, get_cCRLEntry)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 40);
}

SB_PHP_METHOD(CRL_INFO, set_cCRLEntry)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 40);
}

SB_PHP_METHOD(CRL_INFO, get_cExtension)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 48);
}

SB_PHP_METHOD(CRL_INFO, set_cExtension)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 48);
}

zend_class_entry *CRL_INFO_ce_ptr = NULL;

static zend_function_entry CRL_INFO_methods[] = {
	PHP_ME(CRL_INFO, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(CRL_INFO, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(CRL_INFO, get_dwVersion, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(CRL_INFO, set_dwVersion, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(CRL_INFO, get_cCRLEntry, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(CRL_INFO, set_cCRLEntry, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(CRL_INFO, get_cExtension, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(CRL_INFO, set_cExtension, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_CRL_INFO(TSRMLS_D)
{
	zend_class_entry ce;
	if (CRL_INFO_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "CRL_INFO", CRL_INFO_methods);
	CRL_INFO_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(CRL_CONTEXT, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(CRL_CONTEXT));
		intern->len = sizeof(CRL_CONTEXT);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(CRL_CONTEXT, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(CRL_CONTEXT));
}

SB_PHP_METHOD(CRL_CONTEXT, get_dwCertEncodingType)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(CRL_CONTEXT, set_dwCertEncodingType)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(CRL_CONTEXT, get_cbCrlEncoded)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 8);
}

SB_PHP_METHOD(CRL_CONTEXT, set_cbCrlEncoded)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 8);
}

zend_class_entry *CRL_CONTEXT_ce_ptr = NULL;

static zend_function_entry CRL_CONTEXT_methods[] = {
	PHP_ME(CRL_CONTEXT, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(CRL_CONTEXT, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(CRL_CONTEXT, get_dwCertEncodingType, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(CRL_CONTEXT, set_dwCertEncodingType, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(CRL_CONTEXT, get_cbCrlEncoded, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(CRL_CONTEXT, set_cbCrlEncoded, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_CRL_CONTEXT(TSRMLS_D)
{
	zend_class_entry ce;
	if (CRL_CONTEXT_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "CRL_CONTEXT", CRL_CONTEXT_methods);
	CRL_CONTEXT_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(CTL_CONTEXT, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(CTL_CONTEXT));
		intern->len = sizeof(CTL_CONTEXT);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(CTL_CONTEXT, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(CTL_CONTEXT));
}

SB_PHP_METHOD(CTL_CONTEXT, get_dwMsgAndCertEncodingType)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(CTL_CONTEXT, set_dwMsgAndCertEncodingType)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(CTL_CONTEXT, get_cbCtlEncoded)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 8);
}

SB_PHP_METHOD(CTL_CONTEXT, set_cbCtlEncoded)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 8);
}

SB_PHP_METHOD(CTL_CONTEXT, get_cbCtlContent)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 28);
}

SB_PHP_METHOD(CTL_CONTEXT, set_cbCtlContent)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 28);
}

zend_class_entry *CTL_CONTEXT_ce_ptr = NULL;

static zend_function_entry CTL_CONTEXT_methods[] = {
	PHP_ME(CTL_CONTEXT, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(CTL_CONTEXT, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(CTL_CONTEXT, get_dwMsgAndCertEncodingType, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(CTL_CONTEXT, set_dwMsgAndCertEncodingType, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(CTL_CONTEXT, get_cbCtlEncoded, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(CTL_CONTEXT, set_cbCtlEncoded, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(CTL_CONTEXT, get_cbCtlContent, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(CTL_CONTEXT, set_cbCtlContent, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_CTL_CONTEXT(TSRMLS_D)
{
	zend_class_entry ce;
	if (CTL_CONTEXT_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "CTL_CONTEXT", CTL_CONTEXT_methods);
	CTL_CONTEXT_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(CERT_STORE_PROV_FIND_INFO, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(CERT_STORE_PROV_FIND_INFO));
		intern->len = sizeof(CERT_STORE_PROV_FIND_INFO);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(CERT_STORE_PROV_FIND_INFO, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(CERT_STORE_PROV_FIND_INFO));
}

SB_PHP_METHOD(CERT_STORE_PROV_FIND_INFO, get_cbSize)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(CERT_STORE_PROV_FIND_INFO, set_cbSize)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(CERT_STORE_PROV_FIND_INFO, get_dwMsgAndCertEncodingType)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 4);
}

SB_PHP_METHOD(CERT_STORE_PROV_FIND_INFO, set_dwMsgAndCertEncodingType)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 4);
}

SB_PHP_METHOD(CERT_STORE_PROV_FIND_INFO, get_dwFindFlags)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 8);
}

SB_PHP_METHOD(CERT_STORE_PROV_FIND_INFO, set_dwFindFlags)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 8);
}

SB_PHP_METHOD(CERT_STORE_PROV_FIND_INFO, get_dwFindType)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 12);
}

SB_PHP_METHOD(CERT_STORE_PROV_FIND_INFO, set_dwFindType)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 12);
}

zend_class_entry *CERT_STORE_PROV_FIND_INFO_ce_ptr = NULL;

static zend_function_entry CERT_STORE_PROV_FIND_INFO_methods[] = {
	PHP_ME(CERT_STORE_PROV_FIND_INFO, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(CERT_STORE_PROV_FIND_INFO, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(CERT_STORE_PROV_FIND_INFO, get_cbSize, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(CERT_STORE_PROV_FIND_INFO, set_cbSize, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(CERT_STORE_PROV_FIND_INFO, get_dwMsgAndCertEncodingType, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(CERT_STORE_PROV_FIND_INFO, set_dwMsgAndCertEncodingType, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(CERT_STORE_PROV_FIND_INFO, get_dwFindFlags, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(CERT_STORE_PROV_FIND_INFO, set_dwFindFlags, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(CERT_STORE_PROV_FIND_INFO, get_dwFindType, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(CERT_STORE_PROV_FIND_INFO, set_dwFindType, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_CERT_STORE_PROV_FIND_INFO(TSRMLS_D)
{
	zend_class_entry ce;
	if (CERT_STORE_PROV_FIND_INFO_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "CERT_STORE_PROV_FIND_INFO", CERT_STORE_PROV_FIND_INFO_methods);
	CERT_STORE_PROV_FIND_INFO_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(SBWinCrypt__GUID, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(SBWinCrypt__GUID));
		intern->len = sizeof(SBWinCrypt__GUID);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(SBWinCrypt__GUID, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(SBWinCrypt__GUID));
}

SB_PHP_METHOD(SBWinCrypt__GUID, get_Data1)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(SBWinCrypt__GUID, set_Data1)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(SBWinCrypt__GUID, get_Data2)
{
	SBStuctGetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 4);
}

SB_PHP_METHOD(SBWinCrypt__GUID, set_Data2)
{
	SBStuctSetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 4);
}

SB_PHP_METHOD(SBWinCrypt__GUID, get_Data3)
{
	SBStuctGetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 6);
}

SB_PHP_METHOD(SBWinCrypt__GUID, set_Data3)
{
	SBStuctSetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 6);
}

zend_class_entry *SBWinCrypt__GUID_ce_ptr = NULL;

static zend_function_entry SBWinCrypt__GUID_methods[] = {
	PHP_ME(SBWinCrypt__GUID, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(SBWinCrypt__GUID, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(SBWinCrypt__GUID, get_Data1, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBWinCrypt__GUID, set_Data1, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBWinCrypt__GUID, get_Data2, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBWinCrypt__GUID, set_Data2, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBWinCrypt__GUID, get_Data3, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBWinCrypt__GUID, set_Data3, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_SBWinCrypt__GUID(TSRMLS_D)
{
	zend_class_entry ce;
	if (SBWinCrypt__GUID_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "SBWinCrypt__GUID", SBWinCrypt__GUID_methods);
	SBWinCrypt__GUID_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(HMAC_INFO, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(HMAC_INFO));
		intern->len = sizeof(HMAC_INFO);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(HMAC_INFO, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(HMAC_INFO));
}

SB_PHP_METHOD(HMAC_INFO, get_HashAlgid)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(HMAC_INFO, set_HashAlgid)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(HMAC_INFO, get_cbInnerString)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 8);
}

SB_PHP_METHOD(HMAC_INFO, set_cbInnerString)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 8);
}

SB_PHP_METHOD(HMAC_INFO, get_cbOuterString)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 16);
}

SB_PHP_METHOD(HMAC_INFO, set_cbOuterString)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 16);
}

zend_class_entry *HMAC_INFO_ce_ptr = NULL;

static zend_function_entry HMAC_INFO_methods[] = {
	PHP_ME(HMAC_INFO, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(HMAC_INFO, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(HMAC_INFO, get_HashAlgid, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(HMAC_INFO, set_HashAlgid, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(HMAC_INFO, get_cbInnerString, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(HMAC_INFO, set_cbInnerString, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(HMAC_INFO, get_cbOuterString, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(HMAC_INFO, set_cbOuterString, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_HMAC_INFO(TSRMLS_D)
{
	zend_class_entry ce;
	if (HMAC_INFO_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "HMAC_INFO", HMAC_INFO_methods);
	HMAC_INFO_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(NCryptBuffer, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(NCryptBuffer));
		intern->len = sizeof(NCryptBuffer);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(NCryptBuffer, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(NCryptBuffer));
}

SB_PHP_METHOD(NCryptBuffer, get_cbBuffer)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(NCryptBuffer, set_cbBuffer)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(NCryptBuffer, get_BufferType)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 4);
}

SB_PHP_METHOD(NCryptBuffer, set_BufferType)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 4);
}

zend_class_entry *NCryptBuffer_ce_ptr = NULL;

static zend_function_entry NCryptBuffer_methods[] = {
	PHP_ME(NCryptBuffer, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(NCryptBuffer, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(NCryptBuffer, get_cbBuffer, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(NCryptBuffer, set_cbBuffer, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(NCryptBuffer, get_BufferType, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(NCryptBuffer, set_BufferType, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_NCryptBuffer(TSRMLS_D)
{
	zend_class_entry ce;
	if (NCryptBuffer_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "NCryptBuffer", NCryptBuffer_methods);
	NCryptBuffer_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(NCryptBufferDesc, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(NCryptBufferDesc));
		intern->len = sizeof(NCryptBufferDesc);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(NCryptBufferDesc, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(NCryptBufferDesc));
}

SB_PHP_METHOD(NCryptBufferDesc, get_ulVersion)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(NCryptBufferDesc, set_ulVersion)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(NCryptBufferDesc, get_cBuffers)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 4);
}

SB_PHP_METHOD(NCryptBufferDesc, set_cBuffers)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 4);
}

zend_class_entry *NCryptBufferDesc_ce_ptr = NULL;

static zend_function_entry NCryptBufferDesc_methods[] = {
	PHP_ME(NCryptBufferDesc, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(NCryptBufferDesc, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(NCryptBufferDesc, get_ulVersion, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(NCryptBufferDesc, set_ulVersion, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(NCryptBufferDesc, get_cBuffers, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(NCryptBufferDesc, set_cBuffers, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_NCryptBufferDesc(TSRMLS_D)
{
	zend_class_entry ce;
	if (NCryptBufferDesc_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "NCryptBufferDesc", NCryptBufferDesc_methods);
	NCryptBufferDesc_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(NCryptAlgorithmName, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(NCryptAlgorithmName));
		intern->len = sizeof(NCryptAlgorithmName);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(NCryptAlgorithmName, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(NCryptAlgorithmName));
}

SB_PHP_METHOD(NCryptAlgorithmName, get_dwClass)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 4);
}

SB_PHP_METHOD(NCryptAlgorithmName, set_dwClass)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 4);
}

SB_PHP_METHOD(NCryptAlgorithmName, get_dwAlgOperations)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 8);
}

SB_PHP_METHOD(NCryptAlgorithmName, set_dwAlgOperations)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 8);
}

SB_PHP_METHOD(NCryptAlgorithmName, get_dwFlags)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 12);
}

SB_PHP_METHOD(NCryptAlgorithmName, set_dwFlags)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 12);
}

zend_class_entry *NCryptAlgorithmName_ce_ptr = NULL;

static zend_function_entry NCryptAlgorithmName_methods[] = {
	PHP_ME(NCryptAlgorithmName, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(NCryptAlgorithmName, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(NCryptAlgorithmName, get_dwClass, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(NCryptAlgorithmName, set_dwClass, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(NCryptAlgorithmName, get_dwAlgOperations, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(NCryptAlgorithmName, set_dwAlgOperations, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(NCryptAlgorithmName, get_dwFlags, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(NCryptAlgorithmName, set_dwFlags, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_NCryptAlgorithmName(TSRMLS_D)
{
	zend_class_entry ce;
	if (NCryptAlgorithmName_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "NCryptAlgorithmName", NCryptAlgorithmName_methods);
	NCryptAlgorithmName_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(NCryptKeyName, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(NCryptKeyName));
		intern->len = sizeof(NCryptKeyName);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(NCryptKeyName, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(NCryptKeyName));
}

SB_PHP_METHOD(NCryptKeyName, get_dwLegacyKeySpec)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 8);
}

SB_PHP_METHOD(NCryptKeyName, set_dwLegacyKeySpec)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 8);
}

SB_PHP_METHOD(NCryptKeyName, get_dwFlags)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 12);
}

SB_PHP_METHOD(NCryptKeyName, set_dwFlags)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 12);
}

zend_class_entry *NCryptKeyName_ce_ptr = NULL;

static zend_function_entry NCryptKeyName_methods[] = {
	PHP_ME(NCryptKeyName, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(NCryptKeyName, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(NCryptKeyName, get_dwLegacyKeySpec, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(NCryptKeyName, set_dwLegacyKeySpec, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(NCryptKeyName, get_dwFlags, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(NCryptKeyName, set_dwFlags, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_NCryptKeyName(TSRMLS_D)
{
	zend_class_entry ce;
	if (NCryptKeyName_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "NCryptKeyName", NCryptKeyName_methods);
	NCryptKeyName_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(NCryptProviderName, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(NCryptProviderName));
		intern->len = sizeof(NCryptProviderName);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(NCryptProviderName, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(NCryptProviderName));
}

zend_class_entry *NCryptProviderName_ce_ptr = NULL;

static zend_function_entry NCryptProviderName_methods[] = {
	PHP_ME(NCryptProviderName, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(NCryptProviderName, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_FE_END
};

void Register_NCryptProviderName(TSRMLS_D)
{
	zend_class_entry ce;
	if (NCryptProviderName_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "NCryptProviderName", NCryptProviderName_methods);
	NCryptProviderName_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(BCRYPT_PKCS1_PADDING_INFO, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(BCRYPT_PKCS1_PADDING_INFO));
		intern->len = sizeof(BCRYPT_PKCS1_PADDING_INFO);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(BCRYPT_PKCS1_PADDING_INFO, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(BCRYPT_PKCS1_PADDING_INFO));
}

zend_class_entry *BCRYPT_PKCS1_PADDING_INFO_ce_ptr = NULL;

static zend_function_entry BCRYPT_PKCS1_PADDING_INFO_methods[] = {
	PHP_ME(BCRYPT_PKCS1_PADDING_INFO, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(BCRYPT_PKCS1_PADDING_INFO, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_FE_END
};

void Register_BCRYPT_PKCS1_PADDING_INFO(TSRMLS_D)
{
	zend_class_entry ce;
	if (BCRYPT_PKCS1_PADDING_INFO_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "BCRYPT_PKCS1_PADDING_INFO", BCRYPT_PKCS1_PADDING_INFO_methods);
	BCRYPT_PKCS1_PADDING_INFO_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

void Register_SBWinCrypt_Constants(int module_number TSRMLS_DC)
{
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CERT_STORE_ADD_NEW, SB_CERT_STORE_ADD_NEW, SB_CERT_STORE_ADD_NEW);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CERT_STORE_ADD_REPLACE_EXISTING, SB_CERT_STORE_ADD_REPLACE_EXISTING, SB_CERT_STORE_ADD_REPLACE_EXISTING);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CERT_STORE_ADD_ALWAYS, SB_CERT_STORE_ADD_ALWAYS, SB_CERT_STORE_ADD_ALWAYS);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CERT_STORE_READONLY_FLAG, SB_CERT_STORE_READONLY_FLAG, SB_CERT_STORE_READONLY_FLAG);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CRYPT_ASN_ENCODING, SB_CRYPT_ASN_ENCODING, SB_CRYPT_ASN_ENCODING);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CRYPT_NDR_ENCODING, SB_CRYPT_NDR_ENCODING, SB_CRYPT_NDR_ENCODING);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CRYPT_E_UNKNOWN_ALGO, SB_CRYPT_E_UNKNOWN_ALGO, SB_CRYPT_E_UNKNOWN_ALGO);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CRYPT_E_EXISTS, SB_CRYPT_E_EXISTS, SB_CRYPT_E_EXISTS);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, X509_ASN_ENCODING, SB_X509_ASN_ENCODING, SB_X509_ASN_ENCODING);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, X509_NDR_ENCODING, SB_X509_NDR_ENCODING, SB_X509_NDR_ENCODING);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, PKCS_7_ASN_ENCODING, SB_PKCS_7_ASN_ENCODING, SB_PKCS_7_ASN_ENCODING);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, PKCS_7_NDR_ENCODING, SB_PKCS_7_NDR_ENCODING, SB_PKCS_7_NDR_ENCODING);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CERT_INFO_VERSION_FLAG, SB_CERT_INFO_VERSION_FLAG, SB_CERT_INFO_VERSION_FLAG);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CERT_INFO_SERIAL_NUMBER_FLAG, SB_CERT_INFO_SERIAL_NUMBER_FLAG, SB_CERT_INFO_SERIAL_NUMBER_FLAG);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CERT_INFO_SIGNATURE_ALGORITHM_FLAG, SB_CERT_INFO_SIGNATURE_ALGORITHM_FLAG, SB_CERT_INFO_SIGNATURE_ALGORITHM_FLAG);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CERT_INFO_ISSUER_FLAG, SB_CERT_INFO_ISSUER_FLAG, SB_CERT_INFO_ISSUER_FLAG);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CERT_INFO_NOT_BEFORE_FLAG, SB_CERT_INFO_NOT_BEFORE_FLAG, SB_CERT_INFO_NOT_BEFORE_FLAG);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CERT_INFO_NOT_AFTER_FLAG, SB_CERT_INFO_NOT_AFTER_FLAG, SB_CERT_INFO_NOT_AFTER_FLAG);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CERT_INFO_SUBJECT_FLAG, SB_CERT_INFO_SUBJECT_FLAG, SB_CERT_INFO_SUBJECT_FLAG);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CERT_INFO_SUBJECT_PUBLIC_KEY_INFO_FLAG, SB_CERT_INFO_SUBJECT_PUBLIC_KEY_INFO_FLAG, SB_CERT_INFO_SUBJECT_PUBLIC_KEY_INFO_FLAG);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CERT_INFO_ISSUER_UNIQUE_ID_FLAG, SB_CERT_INFO_ISSUER_UNIQUE_ID_FLAG, SB_CERT_INFO_ISSUER_UNIQUE_ID_FLAG);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CERT_INFO_SUBJECT_UNIQUE_ID_FLAG, SB_CERT_INFO_SUBJECT_UNIQUE_ID_FLAG, SB_CERT_INFO_SUBJECT_UNIQUE_ID_FLAG);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CERT_INFO_EXTENSION_FLAG, SB_CERT_INFO_EXTENSION_FLAG, SB_CERT_INFO_EXTENSION_FLAG);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CERT_COMPARE_SHIFT, SB_CERT_COMPARE_SHIFT, SB_CERT_COMPARE_SHIFT);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CERT_COMPARE_ANY, SB_CERT_COMPARE_ANY, SB_CERT_COMPARE_ANY);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CERT_COMPARE_SHA1_HASH, SB_CERT_COMPARE_SHA1_HASH, SB_CERT_COMPARE_SHA1_HASH);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CERT_COMPARE_NAME, SB_CERT_COMPARE_NAME, SB_CERT_COMPARE_NAME);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CERT_COMPARE_ATTR, SB_CERT_COMPARE_ATTR, SB_CERT_COMPARE_ATTR);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CERT_COMPARE_MD5_HASH, SB_CERT_COMPARE_MD5_HASH, SB_CERT_COMPARE_MD5_HASH);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CERT_COMPARE_PROPERTY, SB_CERT_COMPARE_PROPERTY, SB_CERT_COMPARE_PROPERTY);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CERT_COMPARE_PUBLIC_KEY, SB_CERT_COMPARE_PUBLIC_KEY, SB_CERT_COMPARE_PUBLIC_KEY);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CERT_COMPARE_HASH, SB_CERT_COMPARE_HASH, SB_CERT_COMPARE_HASH);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CERT_COMPARE_NAME_STR_A, SB_CERT_COMPARE_NAME_STR_A, SB_CERT_COMPARE_NAME_STR_A);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CERT_COMPARE_NAME_STR_W, SB_CERT_COMPARE_NAME_STR_W, SB_CERT_COMPARE_NAME_STR_W);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CERT_COMPARE_KEY_SPEC, SB_CERT_COMPARE_KEY_SPEC, SB_CERT_COMPARE_KEY_SPEC);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CERT_COMPARE_ENHKEY_USAGE, SB_CERT_COMPARE_ENHKEY_USAGE, SB_CERT_COMPARE_ENHKEY_USAGE);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CERT_COMPARE_CTL_USAGE, SB_CERT_COMPARE_CTL_USAGE, SB_CERT_COMPARE_CTL_USAGE);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CERT_FIND_ANY, SB_CERT_FIND_ANY, SB_CERT_FIND_ANY);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CERT_FIND_SHA1_HASH, SB_CERT_FIND_SHA1_HASH, SB_CERT_FIND_SHA1_HASH);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CERT_FIND_MD5_HASH, SB_CERT_FIND_MD5_HASH, SB_CERT_FIND_MD5_HASH);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CERT_FIND_HASH, SB_CERT_FIND_HASH, SB_CERT_FIND_HASH);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CERT_FIND_PROPERTY, SB_CERT_FIND_PROPERTY, SB_CERT_FIND_PROPERTY);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CERT_FIND_PUBLIC_KEY, SB_CERT_FIND_PUBLIC_KEY, SB_CERT_FIND_PUBLIC_KEY);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CERT_FIND_SUBJECT_NAME, SB_CERT_FIND_SUBJECT_NAME, SB_CERT_FIND_SUBJECT_NAME);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CERT_FIND_SUBJECT_ATTR, SB_CERT_FIND_SUBJECT_ATTR, SB_CERT_FIND_SUBJECT_ATTR);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CERT_FIND_ISSUER_NAME, SB_CERT_FIND_ISSUER_NAME, SB_CERT_FIND_ISSUER_NAME);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CERT_FIND_ISSUER_ATTR, SB_CERT_FIND_ISSUER_ATTR, SB_CERT_FIND_ISSUER_ATTR);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CERT_FIND_SUBJECT_STR_A, SB_CERT_FIND_SUBJECT_STR_A, SB_CERT_FIND_SUBJECT_STR_A);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CERT_FIND_SUBJECT_STR_W, SB_CERT_FIND_SUBJECT_STR_W, SB_CERT_FIND_SUBJECT_STR_W);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CERT_FIND_SUBJECT_STR, SB_CERT_FIND_SUBJECT_STR, SB_CERT_FIND_SUBJECT_STR);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CERT_FIND_ISSUER_STR_A, SB_CERT_FIND_ISSUER_STR_A, SB_CERT_FIND_ISSUER_STR_A);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CERT_FIND_ISSUER_STR_W, SB_CERT_FIND_ISSUER_STR_W, SB_CERT_FIND_ISSUER_STR_W);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CERT_FIND_ISSUER_STR, SB_CERT_FIND_ISSUER_STR, SB_CERT_FIND_ISSUER_STR);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CERT_FIND_KEY_SPEC, SB_CERT_FIND_KEY_SPEC, SB_CERT_FIND_KEY_SPEC);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CERT_FIND_ENHKEY_USAGE, SB_CERT_FIND_ENHKEY_USAGE, SB_CERT_FIND_ENHKEY_USAGE);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CERT_FIND_CTL_USAGE, SB_CERT_FIND_CTL_USAGE, SB_CERT_FIND_CTL_USAGE);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CERT_SYSTEM_STORE_LOCATION_MASK, SB_CERT_SYSTEM_STORE_LOCATION_MASK, SB_CERT_SYSTEM_STORE_LOCATION_MASK);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CERT_SYSTEM_STORE_LOCATION_SHIFT, SB_CERT_SYSTEM_STORE_LOCATION_SHIFT, SB_CERT_SYSTEM_STORE_LOCATION_SHIFT);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CERT_SYSTEM_STORE_CURRENT_USER_ID, SB_CERT_SYSTEM_STORE_CURRENT_USER_ID, SB_CERT_SYSTEM_STORE_CURRENT_USER_ID);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CERT_SYSTEM_STORE_LOCAL_MACHINE_ID, SB_CERT_SYSTEM_STORE_LOCAL_MACHINE_ID, SB_CERT_SYSTEM_STORE_LOCAL_MACHINE_ID);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CERT_SYSTEM_STORE_CURRENT_SERVICE_ID, SB_CERT_SYSTEM_STORE_CURRENT_SERVICE_ID, SB_CERT_SYSTEM_STORE_CURRENT_SERVICE_ID);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CERT_SYSTEM_STORE_SERVICES_ID, SB_CERT_SYSTEM_STORE_SERVICES_ID, SB_CERT_SYSTEM_STORE_SERVICES_ID);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CERT_SYSTEM_STORE_USERS_ID, SB_CERT_SYSTEM_STORE_USERS_ID, SB_CERT_SYSTEM_STORE_USERS_ID);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CERT_SYSTEM_STORE_CURRENT_USER_GROUP_POLICY_ID, SB_CERT_SYSTEM_STORE_CURRENT_USER_GROUP_POLICY_ID, SB_CERT_SYSTEM_STORE_CURRENT_USER_GROUP_POLICY_ID);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CERT_SYSTEM_STORE_LOCAL_MACHINE_GROUP_POLICY_ID, SB_CERT_SYSTEM_STORE_LOCAL_MACHINE_GROUP_POLICY_ID, SB_CERT_SYSTEM_STORE_LOCAL_MACHINE_GROUP_POLICY_ID);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CERT_SYSTEM_STORE_LOCAL_MACHINE_ENTERPRISE_ID, SB_CERT_SYSTEM_STORE_LOCAL_MACHINE_ENTERPRISE_ID, SB_CERT_SYSTEM_STORE_LOCAL_MACHINE_ENTERPRISE_ID);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CERT_SYSTEM_STORE_CURRENT_USER, SB_CERT_SYSTEM_STORE_CURRENT_USER, SB_CERT_SYSTEM_STORE_CURRENT_USER);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CERT_SYSTEM_STORE_LOCAL_MACHINE, SB_CERT_SYSTEM_STORE_LOCAL_MACHINE, SB_CERT_SYSTEM_STORE_LOCAL_MACHINE);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CERT_SYSTEM_STORE_CURRENT_SERVICE, SB_CERT_SYSTEM_STORE_CURRENT_SERVICE, SB_CERT_SYSTEM_STORE_CURRENT_SERVICE);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CERT_SYSTEM_STORE_SERVICES, SB_CERT_SYSTEM_STORE_SERVICES, SB_CERT_SYSTEM_STORE_SERVICES);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CERT_SYSTEM_STORE_USERS, SB_CERT_SYSTEM_STORE_USERS, SB_CERT_SYSTEM_STORE_USERS);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CERT_SYSTEM_STORE_CURRENT_USER_GROUP_POLICY, SB_CERT_SYSTEM_STORE_CURRENT_USER_GROUP_POLICY, SB_CERT_SYSTEM_STORE_CURRENT_USER_GROUP_POLICY);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CERT_SYSTEM_STORE_LOCAL_MACHINE_ENTERPRISE, SB_CERT_SYSTEM_STORE_LOCAL_MACHINE_ENTERPRISE, SB_CERT_SYSTEM_STORE_LOCAL_MACHINE_ENTERPRISE);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CERT_SYSTEM_STORE_LOCAL_MACHINE_GROUP_POLICY, SB_CERT_SYSTEM_STORE_LOCAL_MACHINE_GROUP_POLICY, SB_CERT_SYSTEM_STORE_LOCAL_MACHINE_GROUP_POLICY);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CERT_STORE_OPEN_EXISTING_FLAG, SB_CERT_STORE_OPEN_EXISTING_FLAG, SB_CERT_STORE_OPEN_EXISTING_FLAG);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CERT_STORE_CREATE_NEW_FLAG, SB_CERT_STORE_CREATE_NEW_FLAG, SB_CERT_STORE_CREATE_NEW_FLAG);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CERT_STORE_DELETE_FLAG, SB_CERT_STORE_DELETE_FLAG, SB_CERT_STORE_DELETE_FLAG);
	SB_REGISTER_STRING_CONSTANT(SBWinCrypt, CRYPT_OID_OPEN_STORE_PROV_FUNC, SB_CRYPT_OID_OPEN_STORE_PROV_FUNC, SB_CRYPT_OID_OPEN_STORE_PROV_FUNC);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CERT_STORE_PROV_PHYSICAL, SB_CERT_STORE_PROV_PHYSICAL, SB_CERT_STORE_PROV_PHYSICAL);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CERT_KEY_PROV_INFO_PROP_ID, SB_CERT_KEY_PROV_INFO_PROP_ID, SB_CERT_KEY_PROV_INFO_PROP_ID);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CERT_KEY_CONTEXT_PROP_ID, SB_CERT_KEY_CONTEXT_PROP_ID, SB_CERT_KEY_CONTEXT_PROP_ID);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CERT_KEY_SPEC_PROP_ID, SB_CERT_KEY_SPEC_PROP_ID, SB_CERT_KEY_SPEC_PROP_ID);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CERT_FRIENDLY_NAME_PROP_ID, SB_CERT_FRIENDLY_NAME_PROP_ID, SB_CERT_FRIENDLY_NAME_PROP_ID);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CERT_NCRYPT_KEY_HANDLE_TRANSFER_PROP_ID, SB_CERT_NCRYPT_KEY_HANDLE_TRANSFER_PROP_ID, SB_CERT_NCRYPT_KEY_HANDLE_TRANSFER_PROP_ID);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, AT_KEYEXCHANGE, SB_AT_KEYEXCHANGE, SB_AT_KEYEXCHANGE);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, AT_SIGNATURE, SB_AT_SIGNATURE, SB_AT_SIGNATURE);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, PUBLICKEYBLOB, SB_PUBLICKEYBLOB, SB_PUBLICKEYBLOB);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, PRIVATEKEYBLOB, SB_PRIVATEKEYBLOB, SB_PRIVATEKEYBLOB);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, PLAINTEXTKEYBLOB, SB_PLAINTEXTKEYBLOB, SB_PLAINTEXTKEYBLOB);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CRYPT_SILENT, SB_CRYPT_SILENT, SB_CRYPT_SILENT);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CRYPT_MESSAGE_SILENT_KEYSET_FLAG, SB_CRYPT_MESSAGE_SILENT_KEYSET_FLAG, SB_CRYPT_MESSAGE_SILENT_KEYSET_FLAG);
	SB_REGISTER_STRING_CONSTANT(SBWinCrypt, szOID_RSA_MD5, SB_szOID_RSA_MD5, SB_szOID_RSA_MD5);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CRYPT_MODE_CBC, SB_CRYPT_MODE_CBC, SB_CRYPT_MODE_CBC);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CRYPT_MODE_ECB, SB_CRYPT_MODE_ECB, SB_CRYPT_MODE_ECB);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CRYPT_MODE_OFB, SB_CRYPT_MODE_OFB, SB_CRYPT_MODE_OFB);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CRYPT_MODE_CFB, SB_CRYPT_MODE_CFB, SB_CRYPT_MODE_CFB);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CRYPT_MODE_CTS, SB_CRYPT_MODE_CTS, SB_CRYPT_MODE_CTS);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, ALG_CLASS_HASH, SB_ALG_CLASS_HASH, SB_ALG_CLASS_HASH);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, ALG_CLASS_KEY_EXCHANGE, SB_ALG_CLASS_KEY_EXCHANGE, SB_ALG_CLASS_KEY_EXCHANGE);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, ALG_CLASS_SIGNATURE, SB_ALG_CLASS_SIGNATURE, SB_ALG_CLASS_SIGNATURE);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, ALG_CLASS_MSG_ENCRYPT, SB_ALG_CLASS_MSG_ENCRYPT, SB_ALG_CLASS_MSG_ENCRYPT);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, ALG_TYPE_ANY, SB_ALG_TYPE_ANY, SB_ALG_TYPE_ANY);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, ALG_TYPE_DH, SB_ALG_TYPE_DH, SB_ALG_TYPE_DH);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, ALG_TYPE_DSS, SB_ALG_TYPE_DSS, SB_ALG_TYPE_DSS);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, ALG_TYPE_RSA, SB_ALG_TYPE_RSA, SB_ALG_TYPE_RSA);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, ALG_TYPE_SECURECHANNEL, SB_ALG_TYPE_SECURECHANNEL, SB_ALG_TYPE_SECURECHANNEL);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, ALG_TYPE_GR3410, SB_ALG_TYPE_GR3410, SB_ALG_TYPE_GR3410);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, ALG_SID_SSL3SHAMD5, SB_ALG_SID_SSL3SHAMD5, SB_ALG_SID_SSL3SHAMD5);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, ALG_SID_SHA1, SB_ALG_SID_SHA1, SB_ALG_SID_SHA1);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, ALG_SID_MD2, SB_ALG_SID_MD2, SB_ALG_SID_MD2);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, ALG_SID_MD4, SB_ALG_SID_MD4, SB_ALG_SID_MD4);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, ALG_SID_MD5, SB_ALG_SID_MD5, SB_ALG_SID_MD5);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, ALG_SID_MAC, SB_ALG_SID_MAC, SB_ALG_SID_MAC);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CALG_SSL3_SHAMD5, SB_CALG_SSL3_SHAMD5, SB_CALG_SSL3_SHAMD5);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CALG_SHA1, SB_CALG_SHA1, SB_CALG_SHA1);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CALG_MAC, SB_CALG_MAC, SB_CALG_MAC);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CALG_MD2, SB_CALG_MD2, SB_CALG_MD2);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CALG_MD4, SB_CALG_MD4, SB_CALG_MD4);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CALG_MD5, SB_CALG_MD5, SB_CALG_MD5);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, ALG_SID_AES, SB_ALG_SID_AES, SB_ALG_SID_AES);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, ALG_SID_AES_128, SB_ALG_SID_AES_128, SB_ALG_SID_AES_128);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, ALG_SID_AES_192, SB_ALG_SID_AES_192, SB_ALG_SID_AES_192);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, ALG_SID_AES_256, SB_ALG_SID_AES_256, SB_ALG_SID_AES_256);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, ALG_SID_SHA_256, SB_ALG_SID_SHA_256, SB_ALG_SID_SHA_256);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, ALG_SID_SHA_384, SB_ALG_SID_SHA_384, SB_ALG_SID_SHA_384);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, ALG_SID_SHA_512, SB_ALG_SID_SHA_512, SB_ALG_SID_SHA_512);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, ALG_SID_DH_EPHEM, SB_ALG_SID_DH_EPHEM, SB_ALG_SID_DH_EPHEM);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, ALG_SID_DSS_ANY, SB_ALG_SID_DSS_ANY, SB_ALG_SID_DSS_ANY);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, ALG_SID_RSA_ANY, SB_ALG_SID_RSA_ANY, SB_ALG_SID_RSA_ANY);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, ALG_SID_SHA, SB_ALG_SID_SHA, SB_ALG_SID_SHA);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, ALG_SID_ANY, SB_ALG_SID_ANY, SB_ALG_SID_ANY);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, ALG_SID_3DES_112, SB_ALG_SID_3DES_112, SB_ALG_SID_3DES_112);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, ALG_SID_DESX, SB_ALG_SID_DESX, SB_ALG_SID_DESX);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, ALG_SID_SEAL, SB_ALG_SID_SEAL, SB_ALG_SID_SEAL);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, ALG_SID_DH_SANDF, SB_ALG_SID_DH_SANDF, SB_ALG_SID_DH_SANDF);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, ALG_SID_AGREED_KEY_ANY, SB_ALG_SID_AGREED_KEY_ANY, SB_ALG_SID_AGREED_KEY_ANY);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, ALG_SID_KEA, SB_ALG_SID_KEA, SB_ALG_SID_KEA);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, ALG_SID_SKIPJACK, SB_ALG_SID_SKIPJACK, SB_ALG_SID_SKIPJACK);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, ALG_SID_TEK, SB_ALG_SID_TEK, SB_ALG_SID_TEK);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, ALG_SID_CYLINK_MEK, SB_ALG_SID_CYLINK_MEK, SB_ALG_SID_CYLINK_MEK);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, ALG_SID_SSL3_MASTER, SB_ALG_SID_SSL3_MASTER, SB_ALG_SID_SSL3_MASTER);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, ALG_SID_SCHANNEL_MASTER_HASH, SB_ALG_SID_SCHANNEL_MASTER_HASH, SB_ALG_SID_SCHANNEL_MASTER_HASH);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, ALG_SID_SCHANNEL_MAC_KEY, SB_ALG_SID_SCHANNEL_MAC_KEY, SB_ALG_SID_SCHANNEL_MAC_KEY);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, ALG_SID_SCHANNEL_ENC_KEY, SB_ALG_SID_SCHANNEL_ENC_KEY, SB_ALG_SID_SCHANNEL_ENC_KEY);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, ALG_SID_PCT1_MASTER, SB_ALG_SID_PCT1_MASTER, SB_ALG_SID_PCT1_MASTER);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, ALG_SID_SSL2_MASTER, SB_ALG_SID_SSL2_MASTER, SB_ALG_SID_SSL2_MASTER);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, ALG_SID_TLS1_MASTER, SB_ALG_SID_TLS1_MASTER, SB_ALG_SID_TLS1_MASTER);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, ALG_SID_RC5, SB_ALG_SID_RC5, SB_ALG_SID_RC5);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, ALG_SID_HMAC, SB_ALG_SID_HMAC, SB_ALG_SID_HMAC);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, ALG_SID_TLS1PRF, SB_ALG_SID_TLS1PRF, SB_ALG_SID_TLS1PRF);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, ALG_SID_HASH_REPLACE_OWF, SB_ALG_SID_HASH_REPLACE_OWF, SB_ALG_SID_HASH_REPLACE_OWF);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, ALG_SID_GR3411, SB_ALG_SID_GR3411, SB_ALG_SID_GR3411);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, ALG_SID_GR3410, SB_ALG_SID_GR3410, SB_ALG_SID_GR3410);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, ALG_SID_GR3410EL, SB_ALG_SID_GR3410EL, SB_ALG_SID_GR3410EL);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, ALG_SID_G28147, SB_ALG_SID_G28147, SB_ALG_SID_G28147);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, ALG_SID_PRODIVERS, SB_ALG_SID_PRODIVERS, SB_ALG_SID_PRODIVERS);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, ALG_SID_PRO_EXP, SB_ALG_SID_PRO_EXP, SB_ALG_SID_PRO_EXP);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CALG_3DES, SB_CALG_3DES, SB_CALG_3DES);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CALG_AES, SB_CALG_AES, SB_CALG_AES);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CALG_AES_128, SB_CALG_AES_128, SB_CALG_AES_128);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CALG_AES_192, SB_CALG_AES_192, SB_CALG_AES_192);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CALG_AES_256, SB_CALG_AES_256, SB_CALG_AES_256);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CALG_SHA_256, SB_CALG_SHA_256, SB_CALG_SHA_256);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CALG_SHA_384, SB_CALG_SHA_384, SB_CALG_SHA_384);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CALG_SHA_512, SB_CALG_SHA_512, SB_CALG_SHA_512);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CALG_DH_EPHEM, SB_CALG_DH_EPHEM, SB_CALG_DH_EPHEM);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CALG_DSS_SIGN, SB_CALG_DSS_SIGN, SB_CALG_DSS_SIGN);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CALG_RSA_KEYX, SB_CALG_RSA_KEYX, SB_CALG_RSA_KEYX);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CALG_RSA_SIGN, SB_CALG_RSA_SIGN, SB_CALG_RSA_SIGN);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CALG_SHA, SB_CALG_SHA, SB_CALG_SHA);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CALG_NO_SIGN, SB_CALG_NO_SIGN, SB_CALG_NO_SIGN);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CALG_3DES_112, SB_CALG_3DES_112, SB_CALG_3DES_112);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CALG_DESX, SB_CALG_DESX, SB_CALG_DESX);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CALG_SEAL, SB_CALG_SEAL, SB_CALG_SEAL);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CALG_DH_SF, SB_CALG_DH_SF, SB_CALG_DH_SF);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CALG_AGREEDKEY_ANY, SB_CALG_AGREEDKEY_ANY, SB_CALG_AGREEDKEY_ANY);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CALG_KEA_KEYX, SB_CALG_KEA_KEYX, SB_CALG_KEA_KEYX);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CALG_HUGHES_MD5, SB_CALG_HUGHES_MD5, SB_CALG_HUGHES_MD5);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CALG_SKIPJACK, SB_CALG_SKIPJACK, SB_CALG_SKIPJACK);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CALG_TEK, SB_CALG_TEK, SB_CALG_TEK);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CALG_CYLINK_MEK, SB_CALG_CYLINK_MEK, SB_CALG_CYLINK_MEK);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CALG_SSL3_MASTER, SB_CALG_SSL3_MASTER, SB_CALG_SSL3_MASTER);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CALG_SCHANNEL_MASTER_HASH, SB_CALG_SCHANNEL_MASTER_HASH, SB_CALG_SCHANNEL_MASTER_HASH);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CALG_SCHANNEL_MAC_KEY, SB_CALG_SCHANNEL_MAC_KEY, SB_CALG_SCHANNEL_MAC_KEY);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CALG_SCHANNEL_ENC_KEY, SB_CALG_SCHANNEL_ENC_KEY, SB_CALG_SCHANNEL_ENC_KEY);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CALG_PCT1_MASTER, SB_CALG_PCT1_MASTER, SB_CALG_PCT1_MASTER);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CALG_SSL2_MASTER, SB_CALG_SSL2_MASTER, SB_CALG_SSL2_MASTER);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CALG_TLS1_MASTER, SB_CALG_TLS1_MASTER, SB_CALG_TLS1_MASTER);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CALG_RC5, SB_CALG_RC5, SB_CALG_RC5);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CALG_HMAC, SB_CALG_HMAC, SB_CALG_HMAC);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CALG_TLS1PRF, SB_CALG_TLS1PRF, SB_CALG_TLS1PRF);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CALG_HASH_REPLACE_OWF, SB_CALG_HASH_REPLACE_OWF, SB_CALG_HASH_REPLACE_OWF);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CALG_ECDH, SB_CALG_ECDH, SB_CALG_ECDH);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CALG_ECDSA, SB_CALG_ECDSA, SB_CALG_ECDSA);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CALG_GR3411, SB_CALG_GR3411, SB_CALG_GR3411);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CALG_GR3410, SB_CALG_GR3410, SB_CALG_GR3410);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CALG_GR3410EL, SB_CALG_GR3410EL, SB_CALG_GR3410EL);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CALG_G28147, SB_CALG_G28147, SB_CALG_G28147);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CALG_PRO_DIVERS, SB_CALG_PRO_DIVERS, SB_CALG_PRO_DIVERS);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CALG_PRO_EXPORT, SB_CALG_PRO_EXPORT, SB_CALG_PRO_EXPORT);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, HP_HASHSIZE, SB_HP_HASHSIZE, SB_HP_HASHSIZE);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, HP_HASHVAL, SB_HP_HASHVAL, SB_HP_HASHVAL);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, HP_HMAC_INFO, SB_HP_HMAC_INFO, SB_HP_HMAC_INFO);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, KP_KEYLEN, SB_KP_KEYLEN, SB_KP_KEYLEN);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, KP_ALGID, SB_KP_ALGID, SB_KP_ALGID);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, KP_BLOCKLEN, SB_KP_BLOCKLEN, SB_KP_BLOCKLEN);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, KP_PERMISSIONS, SB_KP_PERMISSIONS, SB_KP_PERMISSIONS);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, KP_CERTIFICATE, SB_KP_CERTIFICATE, SB_KP_CERTIFICATE);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CRYPT_E_UNEXPECTED_MSG_TYPE, SB_CRYPT_E_UNEXPECTED_MSG_TYPE, SB_CRYPT_E_UNEXPECTED_MSG_TYPE);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, _NTE_BAD_ALGID, SB__NTE_BAD_ALGID, SB__NTE_BAD_ALGID);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CRYPT_E_NO_DECRYPT_CERT, SB_CRYPT_E_NO_DECRYPT_CERT, SB_CRYPT_E_NO_DECRYPT_CERT);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CRYPT_IPSEC_HMAC_KEY, SB_CRYPT_IPSEC_HMAC_KEY, SB_CRYPT_IPSEC_HMAC_KEY);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, NTE_BAD_SIGNATURE, SB_NTE_BAD_SIGNATURE, SB_NTE_BAD_SIGNATURE);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, NTE_INVALID_HANDLE, SB_NTE_INVALID_HANDLE, SB_NTE_INVALID_HANDLE);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, PP_ENUMALGS, SB_PP_ENUMALGS, SB_PP_ENUMALGS);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, PP_ENUMCONTAINERS, SB_PP_ENUMCONTAINERS, SB_PP_ENUMCONTAINERS);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, PP_KEYEXCHANGE_PIN, SB_PP_KEYEXCHANGE_PIN, SB_PP_KEYEXCHANGE_PIN);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, PP_SIGNATURE_PIN, SB_PP_SIGNATURE_PIN, SB_PP_SIGNATURE_PIN);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CRYPT_FIRST, SB_CRYPT_FIRST, SB_CRYPT_FIRST);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CRYPT_NEXT, SB_CRYPT_NEXT, SB_CRYPT_NEXT);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CRYPT_EXPORTABLE, SB_CRYPT_EXPORTABLE, SB_CRYPT_EXPORTABLE);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CRYPT_USER_PROTECTED, SB_CRYPT_USER_PROTECTED, SB_CRYPT_USER_PROTECTED);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CRYPT_NO_SALT, SB_CRYPT_NO_SALT, SB_CRYPT_NO_SALT);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CRYPT_VERIFYCONTEXT, SB_CRYPT_VERIFYCONTEXT, SB_CRYPT_VERIFYCONTEXT);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, PROV_RSA, SB_PROV_RSA, SB_PROV_RSA);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, PROV_DSS, SB_PROV_DSS, SB_PROV_DSS);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, PROV_SSL, SB_PROV_SSL, SB_PROV_SSL);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, PROV_RSA_SCHANNEL, SB_PROV_RSA_SCHANNEL, SB_PROV_RSA_SCHANNEL);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, PROV_RSA_SIG, SB_PROV_RSA_SIG, SB_PROV_RSA_SIG);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, PROV_DSS_DH, SB_PROV_DSS_DH, SB_PROV_DSS_DH);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, PROV_DH_SCHANNEL, SB_PROV_DH_SCHANNEL, SB_PROV_DH_SCHANNEL);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, PROV_RSA_AES, SB_PROV_RSA_AES, SB_PROV_RSA_AES);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, PROV_RSA_FULL, SB_PROV_RSA_FULL, SB_PROV_RSA_FULL);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, PROV_EC_ECDSA_SIG, SB_PROV_EC_ECDSA_SIG, SB_PROV_EC_ECDSA_SIG);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, PROV_EC_ECNRA_SIG, SB_PROV_EC_ECNRA_SIG, SB_PROV_EC_ECNRA_SIG);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, PROV_EC_ECDSA_FULL, SB_PROV_EC_ECDSA_FULL, SB_PROV_EC_ECDSA_FULL);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, PROV_EC_ECNRA_FULL, SB_PROV_EC_ECNRA_FULL, SB_PROV_EC_ECNRA_FULL);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, PROV_GOST_94_DH, SB_PROV_GOST_94_DH, SB_PROV_GOST_94_DH);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, PROV_GOST_2001_DH, SB_PROV_GOST_2001_DH, SB_PROV_GOST_2001_DH);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CRYPT_NEWKEYSET, SB_CRYPT_NEWKEYSET, SB_CRYPT_NEWKEYSET);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CRYPT_MACHINE_KEYSET, SB_CRYPT_MACHINE_KEYSET, SB_CRYPT_MACHINE_KEYSET);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CRYPT_DELETEKEYSET, SB_CRYPT_DELETEKEYSET, SB_CRYPT_DELETEKEYSET);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CERT_KEY_PROV_HANDLE_PROP_ID, SB_CERT_KEY_PROV_HANDLE_PROP_ID, SB_CERT_KEY_PROV_HANDLE_PROP_ID);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CERT_STORE_PROV_MSG, SB_CERT_STORE_PROV_MSG, SB_CERT_STORE_PROV_MSG);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CERT_STORE_PROV_MEMORY, SB_CERT_STORE_PROV_MEMORY, SB_CERT_STORE_PROV_MEMORY);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CERT_STORE_PROV_FILE, SB_CERT_STORE_PROV_FILE, SB_CERT_STORE_PROV_FILE);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CERT_STORE_PROV_REG, SB_CERT_STORE_PROV_REG, SB_CERT_STORE_PROV_REG);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CERT_STORE_PROV_PKCS7, SB_CERT_STORE_PROV_PKCS7, SB_CERT_STORE_PROV_PKCS7);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CERT_STORE_PROV_SERIALIZED, SB_CERT_STORE_PROV_SERIALIZED, SB_CERT_STORE_PROV_SERIALIZED);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CERT_STORE_PROV_FILENAME_A, SB_CERT_STORE_PROV_FILENAME_A, SB_CERT_STORE_PROV_FILENAME_A);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CERT_STORE_PROV_FILENAME_W, SB_CERT_STORE_PROV_FILENAME_W, SB_CERT_STORE_PROV_FILENAME_W);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CERT_STORE_PROV_FILENAME, SB_CERT_STORE_PROV_FILENAME, SB_CERT_STORE_PROV_FILENAME);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CERT_STORE_PROV_SYSTEM_A, SB_CERT_STORE_PROV_SYSTEM_A, SB_CERT_STORE_PROV_SYSTEM_A);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CERT_STORE_PROV_SYSTEM_W, SB_CERT_STORE_PROV_SYSTEM_W, SB_CERT_STORE_PROV_SYSTEM_W);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CERT_STORE_PROV_SYSTEM, SB_CERT_STORE_PROV_SYSTEM, SB_CERT_STORE_PROV_SYSTEM);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CERT_STORE_PROV_LDAP_W, SB_CERT_STORE_PROV_LDAP_W, SB_CERT_STORE_PROV_LDAP_W);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CERT_STORE_PROV_LDAP, SB_CERT_STORE_PROV_LDAP, SB_CERT_STORE_PROV_LDAP);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CRYPT_MACHINE_DEFAULT, SB_CRYPT_MACHINE_DEFAULT, SB_CRYPT_MACHINE_DEFAULT);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, CRYPT_USER_DEFAULT, SB_CRYPT_USER_DEFAULT, SB_CRYPT_USER_DEFAULT);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, PP_NAME, SB_PP_NAME, SB_PP_NAME);
	SB_REGISTER_STRING_CONSTANT(SBWinCrypt, MS_DEF_PROV, SB_MS_DEF_PROV, SB_MS_DEF_PROV);
	SB_REGISTER_STRING_CONSTANT(SBWinCrypt, MS_ENHANCED_PROV, SB_MS_ENHANCED_PROV, SB_MS_ENHANCED_PROV);
	SB_REGISTER_STRING_CONSTANT(SBWinCrypt, MS_ENH_DSS_DH_PROV, SB_MS_ENH_DSS_DH_PROV, SB_MS_ENH_DSS_DH_PROV);
	SB_REGISTER_STRING_CONSTANT(SBWinCrypt, MS_DEF_RSA_SIG_PROV, SB_MS_DEF_RSA_SIG_PROV, SB_MS_DEF_RSA_SIG_PROV);
	SB_REGISTER_STRING_CONSTANT(SBWinCrypt, MS_DEF_RSA_SCHANNEL_PROV, SB_MS_DEF_RSA_SCHANNEL_PROV, SB_MS_DEF_RSA_SCHANNEL_PROV);
	SB_REGISTER_STRING_CONSTANT(SBWinCrypt, MS_ENHANCED_RSA_SCHANNEL_PROV, SB_MS_ENHANCED_RSA_SCHANNEL_PROV, SB_MS_ENHANCED_RSA_SCHANNEL_PROV);
	SB_REGISTER_STRING_CONSTANT(SBWinCrypt, MS_DEF_DSS_PROV, SB_MS_DEF_DSS_PROV, SB_MS_DEF_DSS_PROV);
	SB_REGISTER_STRING_CONSTANT(SBWinCrypt, MS_DEF_DSS_DH_PROV, SB_MS_DEF_DSS_DH_PROV, SB_MS_DEF_DSS_DH_PROV);
	SB_REGISTER_STRING_CONSTANT(SBWinCrypt, MS_ENH_RSA_AES_PROV, SB_MS_ENH_RSA_AES_PROV, SB_MS_ENH_RSA_AES_PROV);
	SB_REGISTER_STRING_CONSTANT(SBWinCrypt, MS_ENH_RSA_AES_PROV_XP, SB_MS_ENH_RSA_AES_PROV_XP, SB_MS_ENH_RSA_AES_PROV_XP);
	SB_REGISTER_STRING_CONSTANT(SBWinCrypt, MS_SCARD_PROV, SB_MS_SCARD_PROV, SB_MS_SCARD_PROV);
	SB_REGISTER_STRING_CONSTANT(SBWinCrypt, MS_STRONG_PROV, SB_MS_STRONG_PROV, SB_MS_STRONG_PROV);
	SB_REGISTER_STRING_CONSTANT(SBWinCrypt, MS_DEF_DH_SCHANNEL_PROV, SB_MS_DEF_DH_SCHANNEL_PROV, SB_MS_DEF_DH_SCHANNEL_PROV);
	SB_REGISTER_STRING_CONSTANT(SBWinCrypt, CP_GR3410_94_PROV, SB_CP_GR3410_94_PROV, SB_CP_GR3410_94_PROV);
	SB_REGISTER_STRING_CONSTANT(SBWinCrypt, CP_GR3410_2001_PROV, SB_CP_GR3410_2001_PROV, SB_CP_GR3410_2001_PROV);
	SB_REGISTER_STRING_CONSTANT(SBWinCrypt, BCRYPT_SHA1_ALGORITHM, SB_BCRYPT_SHA1_ALGORITHM, SB_BCRYPT_SHA1_ALGORITHM);
	SB_REGISTER_STRING_CONSTANT(SBWinCrypt, BCRYPT_SHA256_ALGORITHM, SB_BCRYPT_SHA256_ALGORITHM, SB_BCRYPT_SHA256_ALGORITHM);
	SB_REGISTER_STRING_CONSTANT(SBWinCrypt, BCRYPT_SHA384_ALGORITHM, SB_BCRYPT_SHA384_ALGORITHM, SB_BCRYPT_SHA384_ALGORITHM);
	SB_REGISTER_STRING_CONSTANT(SBWinCrypt, BCRYPT_SHA512_ALGORITHM, SB_BCRYPT_SHA512_ALGORITHM, SB_BCRYPT_SHA512_ALGORITHM);
	SB_REGISTER_STRING_CONSTANT(SBWinCrypt, BCRYPT_MD2_ALGORITHM, SB_BCRYPT_MD2_ALGORITHM, SB_BCRYPT_MD2_ALGORITHM);
	SB_REGISTER_STRING_CONSTANT(SBWinCrypt, BCRYPT_MD5_ALGORITHM, SB_BCRYPT_MD5_ALGORITHM, SB_BCRYPT_MD5_ALGORITHM);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, BCRYPT_ECDSA_PUBLIC_P256_MAGIC, SB_BCRYPT_ECDSA_PUBLIC_P256_MAGIC, SB_BCRYPT_ECDSA_PUBLIC_P256_MAGIC);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, BCRYPT_ECDSA_PUBLIC_P384_MAGIC, SB_BCRYPT_ECDSA_PUBLIC_P384_MAGIC, SB_BCRYPT_ECDSA_PUBLIC_P384_MAGIC);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, BCRYPT_ECDSA_PUBLIC_P521_MAGIC, SB_BCRYPT_ECDSA_PUBLIC_P521_MAGIC, SB_BCRYPT_ECDSA_PUBLIC_P521_MAGIC);
	SB_REGISTER_STRING_CONSTANT(SBWinCrypt, BCRYPT_ECCPUBLIC_BLOB, SB_BCRYPT_ECCPUBLIC_BLOB, SB_BCRYPT_ECCPUBLIC_BLOB);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, BCRYPT_PAD_NONE, SB_BCRYPT_PAD_NONE, SB_BCRYPT_PAD_NONE);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, BCRYPT_PAD_PKCS1, SB_BCRYPT_PAD_PKCS1, SB_BCRYPT_PAD_PKCS1);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, BCRYPT_PAD_OAEP, SB_BCRYPT_PAD_OAEP, SB_BCRYPT_PAD_OAEP);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, BCRYPT_PAD_PSS, SB_BCRYPT_PAD_PSS, SB_BCRYPT_PAD_PSS);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, NCRYPT_PAD_PKCS1_FLAG, SB_NCRYPT_PAD_PKCS1_FLAG, SB_NCRYPT_PAD_PKCS1_FLAG);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, NCRYPT_ALLOW_DECRYPT_FLAG, SB_NCRYPT_ALLOW_DECRYPT_FLAG, SB_NCRYPT_ALLOW_DECRYPT_FLAG);
	SB_REGISTER_LONG_CONSTANT(SBWinCrypt, NCRYPT_ALLOW_SIGNING_FLAG, SB_NCRYPT_ALLOW_SIGNING_FLAG, SB_NCRYPT_ALLOW_SIGNING_FLAG);
}

void Register_SBWinCrypt_Aliases(TSRMLS_D)
{
	if (NULL == CRYPTOAPI_BLOB_ce_ptr)
		Register_CRYPTOAPI_BLOB(TSRMLS_C);
	zend_register_class_alias("CRYPT_INTEGER_BLOB", CRYPTOAPI_BLOB_ce_ptr);
	if (NULL == CRYPTOAPI_BLOB_ce_ptr)
		Register_CRYPTOAPI_BLOB(TSRMLS_C);
	zend_register_class_alias("CRYPT_UINT_BLOB", CRYPTOAPI_BLOB_ce_ptr);
	if (NULL == CRYPTOAPI_BLOB_ce_ptr)
		Register_CRYPTOAPI_BLOB(TSRMLS_C);
	zend_register_class_alias("CRYPT_OBJID_BLOB", CRYPTOAPI_BLOB_ce_ptr);
	if (NULL == CRYPTOAPI_BLOB_ce_ptr)
		Register_CRYPTOAPI_BLOB(TSRMLS_C);
	zend_register_class_alias("CERT_NAME_BLOB", CRYPTOAPI_BLOB_ce_ptr);
	if (NULL == CRYPTOAPI_BLOB_ce_ptr)
		Register_CRYPTOAPI_BLOB(TSRMLS_C);
	zend_register_class_alias("CERT_RDN_VALUE_BLOB", CRYPTOAPI_BLOB_ce_ptr);
	if (NULL == CRYPTOAPI_BLOB_ce_ptr)
		Register_CRYPTOAPI_BLOB(TSRMLS_C);
	zend_register_class_alias("CERT_BLOB", CRYPTOAPI_BLOB_ce_ptr);
	if (NULL == CRYPTOAPI_BLOB_ce_ptr)
		Register_CRYPTOAPI_BLOB(TSRMLS_C);
	zend_register_class_alias("CRL_BLOB", CRYPTOAPI_BLOB_ce_ptr);
	if (NULL == CRYPTOAPI_BLOB_ce_ptr)
		Register_CRYPTOAPI_BLOB(TSRMLS_C);
	zend_register_class_alias("DATA_BLOB", CRYPTOAPI_BLOB_ce_ptr);
	if (NULL == CRYPTOAPI_BLOB_ce_ptr)
		Register_CRYPTOAPI_BLOB(TSRMLS_C);
	zend_register_class_alias("CRYPT_DATA_BLOB", CRYPTOAPI_BLOB_ce_ptr);
	if (NULL == CRYPTOAPI_BLOB_ce_ptr)
		Register_CRYPTOAPI_BLOB(TSRMLS_C);
	zend_register_class_alias("CRYPT_HASH_BLOB", CRYPTOAPI_BLOB_ce_ptr);
	if (NULL == CRYPTOAPI_BLOB_ce_ptr)
		Register_CRYPTOAPI_BLOB(TSRMLS_C);
	zend_register_class_alias("CRYPT_DIGEST_BLOB", CRYPTOAPI_BLOB_ce_ptr);
	if (NULL == CRYPTOAPI_BLOB_ce_ptr)
		Register_CRYPTOAPI_BLOB(TSRMLS_C);
	zend_register_class_alias("CRYPT_DER_BLOB", CRYPTOAPI_BLOB_ce_ptr);
	if (NULL == CRYPTOAPI_BLOB_ce_ptr)
		Register_CRYPTOAPI_BLOB(TSRMLS_C);
	zend_register_class_alias("CRYPT_ATTR_BLOB", CRYPTOAPI_BLOB_ce_ptr);
	if (NULL == _CERT_SYSTEM_STORE_INFO_ce_ptr)
		Register__CERT_SYSTEM_STORE_INFO(TSRMLS_C);
	zend_register_class_alias("CERT_SYSTEM_STORE_INFO", _CERT_SYSTEM_STORE_INFO_ce_ptr);
	if (NULL == _CERT_SYSTEM_STORE_INFO_ce_ptr)
		Register__CERT_SYSTEM_STORE_INFO(TSRMLS_C);
	zend_register_class_alias("TCertSystemStoreInfo", _CERT_SYSTEM_STORE_INFO_ce_ptr);
	if (NULL == _CRYPT_KEY_PROV_INFO_ce_ptr)
		Register__CRYPT_KEY_PROV_INFO(TSRMLS_C);
	zend_register_class_alias("CRYPT_KEY_PROV_INFO", _CRYPT_KEY_PROV_INFO_ce_ptr);
	if (NULL == _CRYPT_ATTRIBUTE_ce_ptr)
		Register__CRYPT_ATTRIBUTE(TSRMLS_C);
	zend_register_class_alias("CRYPT_ATTRIBUTE", _CRYPT_ATTRIBUTE_ce_ptr);
	if (NULL == _CRYPT_SIGN_MESSAGE_PARA_ce_ptr)
		Register__CRYPT_SIGN_MESSAGE_PARA(TSRMLS_C);
	zend_register_class_alias("CRYPT_SIGN_MESSAGE_PARA", _CRYPT_SIGN_MESSAGE_PARA_ce_ptr);
	if (NULL == _CRYPT_DECRYPT_MESSAGE_PARA_ce_ptr)
		Register__CRYPT_DECRYPT_MESSAGE_PARA(TSRMLS_C);
	zend_register_class_alias("CRYPT_DECRYPT_MESSAGE_PARA", _CRYPT_DECRYPT_MESSAGE_PARA_ce_ptr);
	if (NULL == _PROV_ENUMALGS_ce_ptr)
		Register__PROV_ENUMALGS(TSRMLS_C);
	zend_register_class_alias("PROV_ENUMALGS", _PROV_ENUMALGS_ce_ptr);
	if (NULL == _CRYPT_OID_FUNC_ENTRY_ce_ptr)
		Register__CRYPT_OID_FUNC_ENTRY(TSRMLS_C);
	zend_register_class_alias("CRYPT_OID_FUNC_ENTRY", _CRYPT_OID_FUNC_ENTRY_ce_ptr);
	if (NULL == _CERT_STORE_PROV_INFO_ce_ptr)
		Register__CERT_STORE_PROV_INFO(TSRMLS_C);
	zend_register_class_alias("CERT_STORE_PROV_INFO", _CERT_STORE_PROV_INFO_ce_ptr);
	if (NULL == CERT_STORE_PROV_FIND_INFO_ce_ptr)
		Register_CERT_STORE_PROV_FIND_INFO(TSRMLS_C);
	zend_register_class_alias("CCERT_STORE_PROV_FIND_INFO", CERT_STORE_PROV_FIND_INFO_ce_ptr);
	if (NULL == SBWinCrypt__GUID_ce_ptr)
		Register_SBWinCrypt__GUID(TSRMLS_C);
	zend_register_class_alias("SBWinCrypt_GUID", SBWinCrypt__GUID_ce_ptr);
}
#endif
