#include "sbxmlcharsets.h"

zend_class_entry *TElXMLBufferingStream_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLBufferingStream, Read)
{
	long l4Count;
	SBPointerZValInfo piBuffer;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zpBuffer, &l4Count) == SUCCESS) && ((PZVAL_IS_REF(zpBuffer) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY))) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElXMLBufferingStream_Read(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, (int32_t)l4Count, &l4OutResultRaw) TSRMLS_CC);
		SBSetPointerToZVal(&piBuffer, zpBuffer);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLBufferingStream, Write)
{
	long l4Count;
	SBPointerZValInfo piBuffer;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zpBuffer, &l4Count) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElXMLBufferingStream_Write(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, (int32_t)l4Count, &l4OutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLBufferingStream, Seek)
{
	long fOrigin;
	long l4Offset;
	long l8Offset;
	long u2Origin;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &l4Offset, &u2Origin) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXMLBufferingStream_Seek(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Offset, (uint16_t)u2Origin, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &l8Offset, &fOrigin) == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElXMLBufferingStream_Seek_1(SBGetObjectHandle(getThis() TSRMLS_CC), (int64_t)l8Offset, (TSeekOriginRaw)fOrigin, &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer) or (integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLBufferingStream, Flush)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElXMLBufferingStream_Flush(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLBufferingStream, get_Stream)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLBufferingStream_get_Stream(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TStream_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLBufferingStream, set_Stream)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLBufferingStream_set_Stream(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLBufferingStream, get_EndOfFile)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElXMLBufferingStream_get_EndOfFile(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLBufferingStream, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLBufferingStream_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLBufferingStream_Read, 0, 0, 2)
	ZEND_ARG_INFO(1, Buffer)
	ZEND_ARG_INFO(0, Count)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLBufferingStream_Write, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(0, Count)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLBufferingStream_Seek, 0, 0, 2)
	ZEND_ARG_INFO(0, Offset)
	ZEND_ARG_INFO(0, Origin)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLBufferingStream_Flush, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLBufferingStream_get_Stream, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLBufferingStream_set_Stream, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TStream, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLBufferingStream_get_EndOfFile, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLBufferingStream___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLBufferingStream_methods[] = {
	PHP_ME(TElXMLBufferingStream, Read, arginfo_TElXMLBufferingStream_Read, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLBufferingStream, Write, arginfo_TElXMLBufferingStream_Write, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLBufferingStream, Seek, arginfo_TElXMLBufferingStream_Seek, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLBufferingStream, Flush, arginfo_TElXMLBufferingStream_Flush, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLBufferingStream, get_Stream, arginfo_TElXMLBufferingStream_get_Stream, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLBufferingStream, set_Stream, arginfo_TElXMLBufferingStream_set_Stream, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLBufferingStream, get_EndOfFile, arginfo_TElXMLBufferingStream_get_EndOfFile, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLBufferingStream, __construct, arginfo_TElXMLBufferingStream___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLBufferingStream(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLBufferingStream_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLBufferingStream", TElXMLBufferingStream_methods);
	if (NULL == TStream_ce_ptr)
		Register_TStream(TSRMLS_C);
	TElXMLBufferingStream_ce_ptr = zend_register_internal_class_ex(&ce, TStream_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLCodec_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLCodec, MigrateTo)
{
	zval *oCodec;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oCodec, TElXMLCodec_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLCodec_MigrateTo(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oCodec TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLCodec)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCodec, Flush)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElXMLCodec_Flush(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCodec, NextChar)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLCodec_NextChar(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1049573703, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCodec, WriteChar)
{
	char *sc;
	int sc_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sc, &sc_len) == SUCCESS)
	{
		SBCheckError(TElXMLCodec_WriteChar(SBGetObjectHandle(getThis() TSRMLS_CC), sc, (int32_t)sc_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCodec, WriteStartup)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElXMLCodec_WriteStartup(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCodec, Detect_Inst)
{
	char *sDefaultEncoding;
	int sDefaultEncoding_len;
	zval *oaStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sDefaultEncoding, &sDefaultEncoding_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLCodec_Detect(SBGetObjectHandle(getThis() TSRMLS_CC), sDefaultEncoding, (int32_t)sDefaultEncoding_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLCodec_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!s", &oaStream, TStream_ce_ptr, &sDefaultEncoding, &sDefaultEncoding_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLCodec_Detect_2(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oaStream TSRMLS_CC), sDefaultEncoding, (int32_t)sDefaultEncoding_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLCodec_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string) or (TStream, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCodec, Detect)
{
	char *sDefaultEncoding;
	int sDefaultEncoding_len;
	zval *oaStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!s", &oaStream, TStream_ce_ptr, &sDefaultEncoding, &sDefaultEncoding_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLCodec_Detect_1(SBGetObjectHandle(oaStream TSRMLS_CC), sDefaultEncoding, (int32_t)sDefaultEncoding_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLCodec_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCodec, GetCodec_Inst)
{
	char *saEnc;
	int saEnc_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &saEnc, &saEnc_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLCodec_GetCodec_1(SBGetObjectHandle(getThis() TSRMLS_CC), saEnc, (int32_t)saEnc_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLCodec_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCodec, GetCodec)
{
	char *saEnc;
	int saEnc_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &saEnc, &saEnc_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLCodec_GetCodec(saEnc, (int32_t)saEnc_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLCodec_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCodec, get_Stream)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLCodec_get_Stream(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TStream_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCodec, set_Stream)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLCodec_set_Stream(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCodec, get_sEOF)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElXMLCodec_get_sEOF(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCodec, get_sPos)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElXMLCodec_get_sPos(SBGetObjectHandle(getThis() TSRMLS_CC), &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCodec, set_sPos)
{
	long l8Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l8Value) == SUCCESS)
	{
		SBCheckError(TElXMLCodec_set_sPos(SBGetObjectHandle(getThis() TSRMLS_CC), (int64_t)l8Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCodec, get_sSize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElXMLCodec_get_sSize(SBGetObjectHandle(getThis() TSRMLS_CC), &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCodec, set_sSize)
{
	long l8Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l8Value) == SUCCESS)
	{
		SBCheckError(TElXMLCodec_set_sSize(SBGetObjectHandle(getThis() TSRMLS_CC), (int64_t)l8Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCodec, get_Name)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLCodec_get_Name(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1027338626, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCodec, get_WriteBOM)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElXMLCodec_get_WriteBOM(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCodec, set_WriteBOM)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElXMLCodec_set_WriteBOM(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCodec, __construct)
{
	zval *oaStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLCodec_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oaStream, TStream_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLCodec_Create_1(SBGetObjectHandle(oaStream TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("() or (TStream)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCodec_MigrateTo, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Codec, TElXMLCodec, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCodec_Flush, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCodec_NextChar, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCodec_WriteChar, 0, 0, 1)
	ZEND_ARG_INFO(0, c)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCodec_WriteStartup, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCodec_Detect_Inst, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, DefaultEncoding_or_aStream, 0, 1)
	ZEND_ARG_INFO(0, DefaultEncoding)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCodec_Detect, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, aStream, TStream, 1)
	ZEND_ARG_INFO(0, DefaultEncoding)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCodec_GetCodec_Inst, 0, 0, 1)
	ZEND_ARG_INFO(0, aEnc)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCodec_GetCodec, 0, 0, 1)
	ZEND_ARG_INFO(0, aEnc)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCodec_get_Stream, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCodec_set_Stream, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TStream, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCodec_get_sEOF, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCodec_get_sPos, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCodec_set_sPos, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCodec_get_sSize, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCodec_set_sSize, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCodec_get_Name, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCodec_get_WriteBOM, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCodec_set_WriteBOM, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCodec___construct, 0, 0, 0)
	ZEND_ARG_OBJ_INFO(0, aStream, TStream, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLCodec_methods[] = {
	PHP_ME(TElXMLCodec, MigrateTo, arginfo_TElXMLCodec_MigrateTo, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCodec, Flush, arginfo_TElXMLCodec_Flush, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCodec, NextChar, arginfo_TElXMLCodec_NextChar, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCodec, WriteChar, arginfo_TElXMLCodec_WriteChar, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCodec, WriteStartup, arginfo_TElXMLCodec_WriteStartup, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCodec, Detect_Inst, arginfo_TElXMLCodec_Detect_Inst, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCodec, Detect, arginfo_TElXMLCodec_Detect, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElXMLCodec, GetCodec_Inst, arginfo_TElXMLCodec_GetCodec_Inst, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCodec, GetCodec, arginfo_TElXMLCodec_GetCodec, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElXMLCodec, get_Stream, arginfo_TElXMLCodec_get_Stream, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCodec, set_Stream, arginfo_TElXMLCodec_set_Stream, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCodec, get_sEOF, arginfo_TElXMLCodec_get_sEOF, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCodec, get_sPos, arginfo_TElXMLCodec_get_sPos, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCodec, set_sPos, arginfo_TElXMLCodec_set_sPos, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCodec, get_sSize, arginfo_TElXMLCodec_get_sSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCodec, set_sSize, arginfo_TElXMLCodec_set_sSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCodec, get_Name, arginfo_TElXMLCodec_get_Name, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCodec, get_WriteBOM, arginfo_TElXMLCodec_get_WriteBOM, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCodec, set_WriteBOM, arginfo_TElXMLCodec_set_WriteBOM, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCodec, __construct, arginfo_TElXMLCodec___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLCodec(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLCodec_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLCodec", TElXMLCodec_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElXMLCodec_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXML8BitCodec_ce_ptr = NULL;

SB_PHP_METHOD(TElXML8BitCodec, get_Charset)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXML8BitCodec_get_Charset(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-36465395, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXML8BitCodec, set_Charset)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElXML8BitCodec_set_Charset(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXML8BitCodec, __construct)
{
	char *saEncoding;
	int saEncoding_len;
	zval *oaStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXML8BitCodec_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &saEncoding, &saEncoding_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXML8BitCodec_Create_1(saEncoding, (int32_t)saEncoding_len, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oaStream, TStream_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXML8BitCodec_Create_2(SBGetObjectHandle(oaStream TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("() or (string) or (TStream)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXML8BitCodec_get_Charset, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXML8BitCodec_set_Charset, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXML8BitCodec___construct, 0, 0, 0)
	ZEND_ARG_TYPE_INFO(0, aEncoding_or_aStream, 0, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElXML8BitCodec_methods[] = {
	PHP_ME(TElXML8BitCodec, get_Charset, arginfo_TElXML8BitCodec_get_Charset, ZEND_ACC_PUBLIC)
	PHP_ME(TElXML8BitCodec, set_Charset, arginfo_TElXML8BitCodec_set_Charset, ZEND_ACC_PUBLIC)
	PHP_ME(TElXML8BitCodec, __construct, arginfo_TElXML8BitCodec___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXML8BitCodec(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXML8BitCodec_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXML8BitCodec", TElXML8BitCodec_methods);
	if (NULL == TElXMLCodec_ce_ptr)
		Register_TElXMLCodec(TSRMLS_C);
	TElXML8BitCodec_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLCodec_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLUTF8Codec_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLUTF8Codec, __construct)
{
	zval *oaStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLUTF8Codec_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oaStream, TStream_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLUTF8Codec_Create_1(SBGetObjectHandle(oaStream TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("() or (TStream)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLUTF8Codec___construct, 0, 0, 0)
	ZEND_ARG_OBJ_INFO(0, aStream, TStream, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLUTF8Codec_methods[] = {
	PHP_ME(TElXMLUTF8Codec, __construct, arginfo_TElXMLUTF8Codec___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLUTF8Codec(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLUTF8Codec_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLUTF8Codec", TElXMLUTF8Codec_methods);
	if (NULL == TElXMLCodec_ce_ptr)
		Register_TElXMLCodec(TSRMLS_C);
	TElXMLUTF8Codec_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLCodec_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLUnicodeCodec_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLUnicodeCodec, get_BigEndian)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElXMLUnicodeCodec_get_BigEndian(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLUnicodeCodec, set_BigEndian)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElXMLUnicodeCodec_set_BigEndian(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLUnicodeCodec, __construct)
{
	zval *oaStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLUnicodeCodec_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oaStream, TStream_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLUnicodeCodec_Create_1(SBGetObjectHandle(oaStream TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("() or (TStream)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLUnicodeCodec_get_BigEndian, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLUnicodeCodec_set_BigEndian, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLUnicodeCodec___construct, 0, 0, 0)
	ZEND_ARG_OBJ_INFO(0, aStream, TStream, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLUnicodeCodec_methods[] = {
	PHP_ME(TElXMLUnicodeCodec, get_BigEndian, arginfo_TElXMLUnicodeCodec_get_BigEndian, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLUnicodeCodec, set_BigEndian, arginfo_TElXMLUnicodeCodec_set_BigEndian, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLUnicodeCodec, __construct, arginfo_TElXMLUnicodeCodec___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLUnicodeCodec(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLUnicodeCodec_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLUnicodeCodec", TElXMLUnicodeCodec_methods);
	if (NULL == TElXMLCodec_ce_ptr)
		Register_TElXMLCodec(TSRMLS_C);
	TElXMLUnicodeCodec_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLCodec_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLStringCodec_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLStringCodec, NextChar)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLStringCodec_NextChar(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1646818503, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLStringCodec, WriteChar)
{
	char *sc;
	int sc_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sc, &sc_len) == SUCCESS)
	{
		SBCheckError(TElXMLStringCodec_WriteChar(SBGetObjectHandle(getThis() TSRMLS_CC), sc, (int32_t)sc_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLStringCodec, WriteStartup)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElXMLStringCodec_WriteStartup(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLStringCodec, get_Data)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLStringCodec_get_Data(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1890962346, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLStringCodec, set_Data)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElXMLStringCodec_set_Data(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLStringCodec, __construct)
{
	zval *oaStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLStringCodec_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oaStream, TStream_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLStringCodec_Create_1(SBGetObjectHandle(oaStream TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("() or (TStream)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLStringCodec_NextChar, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLStringCodec_WriteChar, 0, 0, 1)
	ZEND_ARG_INFO(0, c)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLStringCodec_WriteStartup, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLStringCodec_get_Data, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLStringCodec_set_Data, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLStringCodec___construct, 0, 0, 0)
	ZEND_ARG_OBJ_INFO(0, aStream, TStream, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLStringCodec_methods[] = {
	PHP_ME(TElXMLStringCodec, NextChar, arginfo_TElXMLStringCodec_NextChar, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLStringCodec, WriteChar, arginfo_TElXMLStringCodec_WriteChar, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLStringCodec, WriteStartup, arginfo_TElXMLStringCodec_WriteStartup, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLStringCodec, get_Data, arginfo_TElXMLStringCodec_get_Data, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLStringCodec, set_Data, arginfo_TElXMLStringCodec_set_Data, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLStringCodec, __construct, arginfo_TElXMLStringCodec___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLStringCodec(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLStringCodec_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLStringCodec", TElXMLStringCodec_methods);
	if (NULL == TElXMLCodec_ce_ptr)
		Register_TElXMLCodec(TSRMLS_C);
	TElXMLStringCodec_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLCodec_ce_ptr, NULL TSRMLS_CC);
}

void Register_SBXMLCharsets_Aliases(TSRMLS_D)
{
	if (NULL == TElXMLCodec_ce_ptr)
		Register_TElXMLCodec(TSRMLS_C);
	zend_register_class_alias("ElXMLCodec", TElXMLCodec_ce_ptr);
	if (NULL == TElXML8BitCodec_ce_ptr)
		Register_TElXML8BitCodec(TSRMLS_C);
	zend_register_class_alias("ElXML8BitCodec", TElXML8BitCodec_ce_ptr);
	if (NULL == TElXMLUTF8Codec_ce_ptr)
		Register_TElXMLUTF8Codec(TSRMLS_C);
	zend_register_class_alias("ElXMLUTF8Codec", TElXMLUTF8Codec_ce_ptr);
	if (NULL == TElXMLUnicodeCodec_ce_ptr)
		Register_TElXMLUnicodeCodec(TSRMLS_C);
	zend_register_class_alias("ElXMLUnicodeCodec", TElXMLUnicodeCodec_ce_ptr);
	if (NULL == TElXMLStringCodec_ce_ptr)
		Register_TElXMLStringCodec(TSRMLS_C);
	zend_register_class_alias("ElXMLStringCodec", TElXMLStringCodec_ce_ptr);
}

