#include "sbxmlsamlbind.h"

zend_class_entry *TSBSAMLBindingType_ce_ptr = NULL;

zend_class_entry *TSBSAMLBindingTypes_ce_ptr = NULL;

zend_class_entry *TSBSAMLDataType_ce_ptr = NULL;

void SB_CALLBACK TSBSAMLBeforeSOAPEnvelopeRaw(void * _ObjectData, TObjectHandle Sender, TElXMLSOAPMessageHandle Msg)
{
	zval *retval_ptr;
	zval **params[2];
	zval * zSender;
	zval * zMsg;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zMsg);
	SBInitObject(zMsg, TElXMLSOAPMessage_ce_ptr, Msg TSRMLS_CC);

	params[0] = &zSender;
	params[1] = &zMsg;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 2, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zMsg);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBSAMLRedirectBinderSignRaw(void * _ObjectData, TObjectHandle Sender, const char * pcURL, int32_t szURL, const char * pcSignatureAlg, int32_t szSignatureAlg, uint8_t pOutResult[], int32_t * szOutResult)
{
	zval **params[3];
	zval * zSender;
	zval * zURL;
	zval * zSignatureAlg;
	zval * pzOutResult = NULL;
	SBArrayZValInfo aiOutResult;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zURL);
	ZVAL_STRINGL(zURL, pcURL, szURL, 1);
	MAKE_STD_ZVAL(zSignatureAlg);
	ZVAL_STRINGL(zSignatureAlg, pcSignatureAlg, szSignatureAlg, 1);

	params[0] = &zSender;
	params[1] = &zURL;
	params[2] = &zSignatureAlg;
	SBCallEvent((zval *)_ObjectData, &pzOutResult, 3, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zURL);
	zval_ptr_dtor(&zSignatureAlg);
	if (pzOutResult)
	{
		if (SBGetByteArrayFromZVal(pzOutResult, &aiOutResult TSRMLS_CC))
			SBCheckError(SBSetEventReturnBuffer(4, aiOutResult.data, aiOutResult.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiOutResult);
		zval_ptr_dtor(&pzOutResult);
	}
}

void SB_CALLBACK TSBSAMLRedirectBinderVerifyRaw(void * _ObjectData, TObjectHandle Sender, const char * pcURL, int32_t szURL, const char * pcSignatureAlg, int32_t szSignatureAlg, const uint8_t pSignature[], int32_t szSignature, int8_t * OutResult)
{
	zval **params[4];
	zval * zSender;
	zval * zURL;
	zval * zSignatureAlg;
	zval * zSignature;
	zval * pzOutResult = NULL;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zURL);
	ZVAL_STRINGL(zURL, pcURL, szURL, 1);
	MAKE_STD_ZVAL(zSignatureAlg);
	ZVAL_STRINGL(zSignatureAlg, pcSignatureAlg, szSignatureAlg, 1);
	MAKE_STD_ZVAL(zSignature);
	ZVAL_STRINGL(zSignature, pSignature, szSignature, 1);

	params[0] = &zSender;
	params[1] = &zURL;
	params[2] = &zSignatureAlg;
	params[3] = &zSignature;
	SBCallEvent((zval *)_ObjectData, &pzOutResult, 4, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zURL);
	zval_ptr_dtor(&zSignatureAlg);
	zval_ptr_dtor(&zSignature);
	if (pzOutResult)
	{
		*OutResult = (int8_t)Z_BVAL_P(pzOutResult);
		zval_ptr_dtor(&pzOutResult);
	}
}

void SB_CALLBACK TSBSAMLBindingXMLPreparedEventRaw(void * _ObjectData, TObjectHandle Sender, const char * pcXML, int32_t szXML)
{
	zval *retval_ptr;
	zval **params[2];
	zval * zSender;
	zval * zXML;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zXML);
	ZVAL_STRINGL(zXML, pcXML, szXML, 1);

	params[0] = &zSender;
	params[1] = &zXML;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 2, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zXML);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

zend_class_entry *TSAMLGZHeaderSkipped_ce_ptr = NULL;

zend_class_entry *TSBSAMLPOSTBindingMode_ce_ptr = NULL;

void SB_CALLBACK TSBSAMLPOSTBindingParseFormRaw(void * _ObjectData, TObjectHandle Sender, const char * pcHtml, int32_t szHtml, const char * pcBodyName, int32_t szBodyName, char * pcURL, int32_t * szURL, char * pcBody, int32_t * szBody, char * pcRelayState, int32_t * szRelayState)
{
	zval *retval_ptr;
	zval **params[6];
	zval * zSender;
	zval * zHtml;
	zval * zBodyName;
	zval * zURL;
	zval * zBody;
	zval * zRelayState;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zHtml);
	ZVAL_STRINGL(zHtml, pcHtml, szHtml, 1);
	MAKE_STD_ZVAL(zBodyName);
	ZVAL_STRINGL(zBodyName, pcBodyName, szBodyName, 1);
	MAKE_STD_ZVAL(zURL);
	ZVAL_STRINGL(zURL, pcURL, *szURL, 1);
	MAKE_STD_ZVAL(zBody);
	ZVAL_STRINGL(zBody, pcBody, *szBody, 1);
	MAKE_STD_ZVAL(zRelayState);
	ZVAL_STRINGL(zRelayState, pcRelayState, *szRelayState, 1);

	params[0] = &zSender;
	params[1] = &zHtml;
	params[2] = &zBodyName;
	params[3] = &zURL;
	params[4] = &zBody;
	params[5] = &zRelayState;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 6, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zHtml);
	zval_ptr_dtor(&zBodyName);
	SBCheckError(SBSetEventReturnStringA(4, Z_STRVAL_P(zURL), (int32_t)Z_STRLEN_P(zURL)) TSRMLS_CC);
	zval_ptr_dtor(&zURL);
	SBCheckError(SBSetEventReturnStringA(5, Z_STRVAL_P(zBody), (int32_t)Z_STRLEN_P(zBody)) TSRMLS_CC);
	zval_ptr_dtor(&zBody);
	SBCheckError(SBSetEventReturnStringA(6, Z_STRVAL_P(zRelayState), (int32_t)Z_STRLEN_P(zRelayState)) TSRMLS_CC);
	zval_ptr_dtor(&zRelayState);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

zend_class_entry *TElSAMLBinding_ce_ptr = NULL;

SB_PHP_METHOD(TElSAMLBinding, GetName)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSAMLBinding_GetName(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1104305105, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLBinding, StrToBinding_Inst)
{
	char *sS;
	int sS_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sS, &sS_len) == SUCCESS)
	{
		TSBSAMLBindingTypeRaw fOutResultRaw = 0;
		SBCheckError(TElSAMLBinding_StrToBinding_1(SBGetObjectHandle(getThis() TSRMLS_CC), sS, (int32_t)sS_len, &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLBinding, StrToBinding)
{
	char *sS;
	int sS_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sS, &sS_len) == SUCCESS)
	{
		TSBSAMLBindingTypeRaw fOutResultRaw = 0;
		SBCheckError(TElSAMLBinding_StrToBinding(sS, (int32_t)sS_len, &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLBinding, BindingToStr_Inst)
{
	long fV;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fV) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSAMLBinding_BindingToStr_1(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBSAMLBindingTypeRaw)fV, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1083446915, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLBinding, BindingToStr)
{
	long fV;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fV) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSAMLBinding_BindingToStr((TSBSAMLBindingTypeRaw)fV, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1083446915, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLBinding, SaveRequest)
{
	uint32_t _err;
	zval *oDoc;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDoc, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSAMLBinding_SaveRequest(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDoc TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1570792837, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLBinding, SaveResponse)
{
	uint32_t _err;
	zval *oDoc;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDoc, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSAMLBinding_SaveResponse(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDoc TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-2116410461, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLBinding, SaveArtifact)
{
	SBArrayZValInfo aiArtifact;
	uint32_t _err;
	zval *zaArtifact;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaArtifact) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaArtifact)) || (IS_ARRAY == Z_TYPE_P(zaArtifact)) || (IS_NULL == Z_TYPE_P(zaArtifact))))
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		if (!SBGetByteArrayFromZVal(zaArtifact, &aiArtifact TSRMLS_CC)) RETURN_FALSE;
		_err = TElSAMLBinding_SaveArtifact(SBGetObjectHandle(getThis() TSRMLS_CC), aiArtifact.data, aiArtifact.len, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(527490829, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiArtifact);
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLBinding, LoadRequest)
{
	char *sRequest;
	int sRequest_len;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sRequest, &sRequest_len) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSAMLBinding_LoadRequest(SBGetObjectHandle(getThis() TSRMLS_CC), sRequest, (int32_t)sRequest_len, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-546517470, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLBinding, LoadResponse)
{
	char *sResponse;
	int sResponse_len;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sResponse, &sResponse_len) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSAMLBinding_LoadResponse(SBGetObjectHandle(getThis() TSRMLS_CC), sResponse, (int32_t)sResponse_len, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1445840230, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLBinding, LoadArtifact)
{
	char *sArtifact;
	int sArtifact_len;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sArtifact, &sArtifact_len) == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElSAMLBinding_LoadArtifact(SBGetObjectHandle(getThis() TSRMLS_CC), sArtifact, (int32_t)sArtifact_len, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-450806483, 2, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLBinding, get_OnXMLPrepared)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBSAMLBindingXMLPreparedEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSAMLBinding_get_OnXMLPrepared(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLBinding, set_OnXMLPrepared)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSAMLBinding_set_OnXMLPrepared(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBSAMLBindingXMLPreparedEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBSAMLBindingXMLPreparedEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLBinding, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLBinding_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLBinding_GetName, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLBinding_StrToBinding_Inst, 0, 0, 1)
	ZEND_ARG_INFO(0, S)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLBinding_StrToBinding, 0, 0, 1)
	ZEND_ARG_INFO(0, S)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLBinding_BindingToStr_Inst, 0, 0, 1)
	ZEND_ARG_INFO(0, V)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLBinding_BindingToStr, 0, 0, 1)
	ZEND_ARG_INFO(0, V)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLBinding_SaveRequest, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Doc, TElXMLDOMDocument, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLBinding_SaveResponse, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Doc, TElXMLDOMDocument, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLBinding_SaveArtifact, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Artifact, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLBinding_LoadRequest, 0, 0, 1)
	ZEND_ARG_INFO(0, Request)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLBinding_LoadResponse, 0, 0, 1)
	ZEND_ARG_INFO(0, Response)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLBinding_LoadArtifact, 0, 0, 1)
	ZEND_ARG_INFO(0, Artifact)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLBinding_get_OnXMLPrepared, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLBinding_set_OnXMLPrepared, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLBinding___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElSAMLBinding_methods[] = {
	PHP_ME(TElSAMLBinding, GetName, arginfo_TElSAMLBinding_GetName, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLBinding, StrToBinding_Inst, arginfo_TElSAMLBinding_StrToBinding_Inst, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLBinding, StrToBinding, arginfo_TElSAMLBinding_StrToBinding, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElSAMLBinding, BindingToStr_Inst, arginfo_TElSAMLBinding_BindingToStr_Inst, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLBinding, BindingToStr, arginfo_TElSAMLBinding_BindingToStr, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElSAMLBinding, SaveRequest, arginfo_TElSAMLBinding_SaveRequest, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLBinding, SaveResponse, arginfo_TElSAMLBinding_SaveResponse, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLBinding, SaveArtifact, arginfo_TElSAMLBinding_SaveArtifact, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLBinding, LoadRequest, arginfo_TElSAMLBinding_LoadRequest, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLBinding, LoadResponse, arginfo_TElSAMLBinding_LoadResponse, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLBinding, LoadArtifact, arginfo_TElSAMLBinding_LoadArtifact, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLBinding, get_OnXMLPrepared, arginfo_TElSAMLBinding_get_OnXMLPrepared, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLBinding, set_OnXMLPrepared, arginfo_TElSAMLBinding_set_OnXMLPrepared, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLBinding, __construct, arginfo_TElSAMLBinding___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSAMLBinding(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSAMLBinding_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSAMLBinding", TElSAMLBinding_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElSAMLBinding_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElSAMLSOAPBinding_ce_ptr = NULL;

SB_PHP_METHOD(TElSAMLSOAPBinding, GetName)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSAMLSOAPBinding_GetName(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1110683299, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLSOAPBinding, Detect_Inst)
{
	char *sBuf;
	char *sProto = NULL;
	int sBuf_len;
	int32_t sProto_len = 0;
	uint32_t _err;
	zval *zsProto;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sz", &sBuf, &sBuf_len, &zsProto) == SUCCESS) && PZVAL_IS_REF(zsProto) && (IS_STRING == Z_TYPE_P(zsProto)))
	{
		TSBSAMLDataTypeRaw fOutResultRaw = 0;
		_err = TElSAMLSOAPBinding_Detect_1(SBGetObjectHandle(getThis() TSRMLS_CC), sBuf, (int32_t)sBuf_len, sProto, &sProto_len, &fOutResultRaw);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sProto = emalloc(sProto_len + 1);
			SBCheckError(SBGetLastReturnStringA(231619823, 2, sProto, &sProto_len) TSRMLS_CC);
			zval_dtor(zsProto);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		sProto[sProto_len] = 0;
		ZVAL_STRINGL(zsProto, sProto, sProto_len, 0);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string, &string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLSOAPBinding, Detect)
{
	char *sBuf;
	char *sProto = NULL;
	int sBuf_len;
	int32_t sProto_len = 0;
	uint32_t _err;
	zval *zsProto;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sz", &sBuf, &sBuf_len, &zsProto) == SUCCESS) && PZVAL_IS_REF(zsProto) && (IS_STRING == Z_TYPE_P(zsProto)))
	{
		TSBSAMLDataTypeRaw fOutResultRaw = 0;
		_err = TElSAMLSOAPBinding_Detect(sBuf, (int32_t)sBuf_len, sProto, &sProto_len, &fOutResultRaw);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sProto = emalloc(sProto_len + 1);
			SBCheckError(SBGetLastReturnStringA(231619823, 1, sProto, &sProto_len) TSRMLS_CC);
			zval_dtor(zsProto);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		sProto[sProto_len] = 0;
		ZVAL_STRINGL(zsProto, sProto, sProto_len, 0);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string, &string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLSOAPBinding, SaveRequest)
{
	uint32_t _err;
	zval *oDoc;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDoc, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSAMLSOAPBinding_SaveRequest(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDoc TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(780124036, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLSOAPBinding, SaveResponse)
{
	uint32_t _err;
	zval *oDoc;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDoc, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSAMLSOAPBinding_SaveResponse(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDoc TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1786079610, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLSOAPBinding, LoadRequest)
{
	char *sRequest;
	int sRequest_len;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sRequest, &sRequest_len) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSAMLSOAPBinding_LoadRequest(SBGetObjectHandle(getThis() TSRMLS_CC), sRequest, (int32_t)sRequest_len, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1840551457, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLSOAPBinding, LoadResponse)
{
	char *sResponse;
	int sResponse_len;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sResponse, &sResponse_len) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSAMLSOAPBinding_LoadResponse(SBGetObjectHandle(getThis() TSRMLS_CC), sResponse, (int32_t)sResponse_len, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(580573702, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLSOAPBinding, get_Version)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBXMLSOAPVersionRaw fOutResultRaw = 0;
		SBCheckError(TElSAMLSOAPBinding_get_Version(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLSOAPBinding, set_Version)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElSAMLSOAPBinding_set_Version(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBXMLSOAPVersionRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLSOAPBinding, get_OnBeforeEnvelope)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBSAMLBeforeSOAPEnvelope pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSAMLSOAPBinding_get_OnBeforeEnvelope(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLSOAPBinding, set_OnBeforeEnvelope)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSAMLSOAPBinding_set_OnBeforeEnvelope(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBSAMLBeforeSOAPEnvelopeRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBSAMLBeforeSOAPEnvelope|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLSOAPBinding, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLSOAPBinding_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLSOAPBinding_GetName, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLSOAPBinding_Detect_Inst, 0, 0, 2)
	ZEND_ARG_INFO(0, Buf)
	ZEND_ARG_INFO(1, Proto)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLSOAPBinding_Detect, 0, 0, 2)
	ZEND_ARG_INFO(0, Buf)
	ZEND_ARG_INFO(1, Proto)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLSOAPBinding_SaveRequest, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Doc, TElXMLDOMDocument, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLSOAPBinding_SaveResponse, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Doc, TElXMLDOMDocument, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLSOAPBinding_LoadRequest, 0, 0, 1)
	ZEND_ARG_INFO(0, Request)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLSOAPBinding_LoadResponse, 0, 0, 1)
	ZEND_ARG_INFO(0, Response)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLSOAPBinding_get_Version, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLSOAPBinding_set_Version, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLSOAPBinding_get_OnBeforeEnvelope, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLSOAPBinding_set_OnBeforeEnvelope, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLSOAPBinding___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElSAMLSOAPBinding_methods[] = {
	PHP_ME(TElSAMLSOAPBinding, GetName, arginfo_TElSAMLSOAPBinding_GetName, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLSOAPBinding, Detect_Inst, arginfo_TElSAMLSOAPBinding_Detect_Inst, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLSOAPBinding, Detect, arginfo_TElSAMLSOAPBinding_Detect, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElSAMLSOAPBinding, SaveRequest, arginfo_TElSAMLSOAPBinding_SaveRequest, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLSOAPBinding, SaveResponse, arginfo_TElSAMLSOAPBinding_SaveResponse, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLSOAPBinding, LoadRequest, arginfo_TElSAMLSOAPBinding_LoadRequest, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLSOAPBinding, LoadResponse, arginfo_TElSAMLSOAPBinding_LoadResponse, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLSOAPBinding, get_Version, arginfo_TElSAMLSOAPBinding_get_Version, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLSOAPBinding, set_Version, arginfo_TElSAMLSOAPBinding_set_Version, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLSOAPBinding, get_OnBeforeEnvelope, arginfo_TElSAMLSOAPBinding_get_OnBeforeEnvelope, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLSOAPBinding, set_OnBeforeEnvelope, arginfo_TElSAMLSOAPBinding_set_OnBeforeEnvelope, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLSOAPBinding, __construct, arginfo_TElSAMLSOAPBinding___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSAMLSOAPBinding(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSAMLSOAPBinding_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSAMLSOAPBinding", TElSAMLSOAPBinding_methods);
	if (NULL == TElSAMLBinding_ce_ptr)
		Register_TElSAMLBinding(TSRMLS_C);
	TElSAMLSOAPBinding_ce_ptr = zend_register_internal_class_ex(&ce, TElSAMLBinding_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElSAMLCompressedProcessor_ce_ptr = NULL;

SB_PHP_METHOD(TElSAMLCompressedProcessor, Initialize)
{
	zend_bool bAsEncoder;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bAsEncoder) == SUCCESS)
	{
		SBCheckError(TElSAMLCompressedProcessor_Initialize(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bAsEncoder) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLCompressedProcessor, Reset)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElSAMLCompressedProcessor_Reset(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLCompressedProcessor, DecodeData)
{
	int32_t l4ProcessedRaw;
	int8_t bEndReachedRaw;
	long l4Position;
	long l4Size;
	SBArrayZValInfo aiBuffer;
	uint32_t _err;
	zval *zaBuffer;
	zval *zbEndReached;
	zval *zl4Processed;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zllzz", &zaBuffer, &l4Position, &l4Size, &zl4Processed, &zbEndReached) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaBuffer)) || (IS_ARRAY == Z_TYPE_P(zaBuffer)) || (IS_NULL == Z_TYPE_P(zaBuffer))) && PZVAL_IS_REF(zl4Processed) && (IS_LONG == Z_TYPE_P(zl4Processed)) && PZVAL_IS_REF(zbEndReached) && (IS_BOOL == Z_TYPE_P(zbEndReached)))
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		if (!SBGetByteArrayFromZVal(zaBuffer, &aiBuffer TSRMLS_CC)) RETURN_FALSE;
		l4ProcessedRaw = (int32_t)Z_LVAL_P(zl4Processed);
		bEndReachedRaw = (int8_t)Z_BVAL_P(zbEndReached);
		_err = TElSAMLCompressedProcessor_DecodeData(SBGetObjectHandle(getThis() TSRMLS_CC), aiBuffer.data, aiBuffer.len, (int32_t)l4Position, (int32_t)l4Size, &l4ProcessedRaw, &bEndReachedRaw, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(183638031, 6, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiBuffer);
		ZVAL_LONG(zl4Processed, (long)l4ProcessedRaw);
		ZVAL_BOOL(zbEndReached, (zend_bool)bEndReachedRaw);
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, integer, integer, &integer, &bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLCompressedProcessor, EncodeData)
{
	long l4Position;
	long l4Size;
	SBArrayZValInfo aiBuffer;
	uint32_t _err;
	zval *zaBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zll", &zaBuffer, &l4Position, &l4Size) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaBuffer)) || (IS_ARRAY == Z_TYPE_P(zaBuffer)) || (IS_NULL == Z_TYPE_P(zaBuffer))))
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		if (!SBGetByteArrayFromZVal(zaBuffer, &aiBuffer TSRMLS_CC)) RETURN_FALSE;
		_err = TElSAMLCompressedProcessor_EncodeData(SBGetObjectHandle(getThis() TSRMLS_CC), aiBuffer.data, aiBuffer.len, (int32_t)l4Position, (int32_t)l4Size, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-669979419, 4, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiBuffer);
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLCompressedProcessor, get_BytesEncoded)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElSAMLCompressedProcessor_get_BytesEncoded(SBGetObjectHandle(getThis() TSRMLS_CC), &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLCompressedProcessor, get_Deflated)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSAMLCompressedProcessor_get_Deflated(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLCompressedProcessor, set_Deflated)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSAMLCompressedProcessor_set_Deflated(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLCompressedProcessor, get_Gzipped)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSAMLCompressedProcessor_get_Gzipped(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLCompressedProcessor, set_Gzipped)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSAMLCompressedProcessor_set_Gzipped(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLCompressedProcessor, get_CompressionLevel)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSAMLCompressedProcessor_get_CompressionLevel(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLCompressedProcessor, set_CompressionLevel)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElSAMLCompressedProcessor_set_CompressionLevel(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLCompressedProcessor, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLCompressedProcessor_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLCompressedProcessor_Initialize, 0, 0, 1)
	ZEND_ARG_INFO(0, AsEncoder)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLCompressedProcessor_Reset, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLCompressedProcessor_DecodeData, 0, 0, 5)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(0, Position)
	ZEND_ARG_INFO(0, Size)
	ZEND_ARG_INFO(1, Processed)
	ZEND_ARG_INFO(1, EndReached)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLCompressedProcessor_EncodeData, 0, 0, 3)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(0, Position)
	ZEND_ARG_INFO(0, Size)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLCompressedProcessor_get_BytesEncoded, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLCompressedProcessor_get_Deflated, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLCompressedProcessor_set_Deflated, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLCompressedProcessor_get_Gzipped, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLCompressedProcessor_set_Gzipped, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLCompressedProcessor_get_CompressionLevel, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLCompressedProcessor_set_CompressionLevel, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLCompressedProcessor___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElSAMLCompressedProcessor_methods[] = {
	PHP_ME(TElSAMLCompressedProcessor, Initialize, arginfo_TElSAMLCompressedProcessor_Initialize, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLCompressedProcessor, Reset, arginfo_TElSAMLCompressedProcessor_Reset, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLCompressedProcessor, DecodeData, arginfo_TElSAMLCompressedProcessor_DecodeData, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLCompressedProcessor, EncodeData, arginfo_TElSAMLCompressedProcessor_EncodeData, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLCompressedProcessor, get_BytesEncoded, arginfo_TElSAMLCompressedProcessor_get_BytesEncoded, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLCompressedProcessor, get_Deflated, arginfo_TElSAMLCompressedProcessor_get_Deflated, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLCompressedProcessor, set_Deflated, arginfo_TElSAMLCompressedProcessor_set_Deflated, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLCompressedProcessor, get_Gzipped, arginfo_TElSAMLCompressedProcessor_get_Gzipped, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLCompressedProcessor, set_Gzipped, arginfo_TElSAMLCompressedProcessor_set_Gzipped, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLCompressedProcessor, get_CompressionLevel, arginfo_TElSAMLCompressedProcessor_get_CompressionLevel, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLCompressedProcessor, set_CompressionLevel, arginfo_TElSAMLCompressedProcessor_set_CompressionLevel, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLCompressedProcessor, __construct, arginfo_TElSAMLCompressedProcessor___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSAMLCompressedProcessor(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSAMLCompressedProcessor_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSAMLCompressedProcessor", TElSAMLCompressedProcessor_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElSAMLCompressedProcessor_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElSAMLRedirectBinding_ce_ptr = NULL;

SB_PHP_METHOD(TElSAMLRedirectBinding, Detect_Inst)
{
	char *sBuf;
	char *sProto = NULL;
	int sBuf_len;
	int32_t sProto_len = 0;
	uint32_t _err;
	zval *zsProto;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sz", &sBuf, &sBuf_len, &zsProto) == SUCCESS) && PZVAL_IS_REF(zsProto) && (IS_STRING == Z_TYPE_P(zsProto)))
	{
		TSBSAMLDataTypeRaw fOutResultRaw = 0;
		_err = TElSAMLRedirectBinding_Detect_1(SBGetObjectHandle(getThis() TSRMLS_CC), sBuf, (int32_t)sBuf_len, sProto, &sProto_len, &fOutResultRaw);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sProto = emalloc(sProto_len + 1);
			SBCheckError(SBGetLastReturnStringA(144278676, 2, sProto, &sProto_len) TSRMLS_CC);
			zval_dtor(zsProto);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		sProto[sProto_len] = 0;
		ZVAL_STRINGL(zsProto, sProto, sProto_len, 0);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string, &string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLRedirectBinding, Detect)
{
	char *sBuf;
	char *sProto = NULL;
	int sBuf_len;
	int32_t sProto_len = 0;
	uint32_t _err;
	zval *zsProto;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sz", &sBuf, &sBuf_len, &zsProto) == SUCCESS) && PZVAL_IS_REF(zsProto) && (IS_STRING == Z_TYPE_P(zsProto)))
	{
		TSBSAMLDataTypeRaw fOutResultRaw = 0;
		_err = TElSAMLRedirectBinding_Detect(sBuf, (int32_t)sBuf_len, sProto, &sProto_len, &fOutResultRaw);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sProto = emalloc(sProto_len + 1);
			SBCheckError(SBGetLastReturnStringA(144278676, 1, sProto, &sProto_len) TSRMLS_CC);
			zval_dtor(zsProto);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		sProto[sProto_len] = 0;
		ZVAL_STRINGL(zsProto, sProto, sProto_len, 0);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string, &string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLRedirectBinding, GetName)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSAMLRedirectBinding_GetName(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-59453703, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLRedirectBinding, SaveRequest)
{
	uint32_t _err;
	zval *oDoc;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDoc, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSAMLRedirectBinding_SaveRequest(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDoc TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1628884802, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLRedirectBinding, SaveResponse)
{
	uint32_t _err;
	zval *oDoc;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDoc, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSAMLRedirectBinding_SaveResponse(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDoc TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-464079914, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLRedirectBinding, SaveArtifact)
{
	SBArrayZValInfo aiArtifact;
	uint32_t _err;
	zval *zaArtifact;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaArtifact) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaArtifact)) || (IS_ARRAY == Z_TYPE_P(zaArtifact)) || (IS_NULL == Z_TYPE_P(zaArtifact))))
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		if (!SBGetByteArrayFromZVal(zaArtifact, &aiArtifact TSRMLS_CC)) RETURN_FALSE;
		_err = TElSAMLRedirectBinding_SaveArtifact(SBGetObjectHandle(getThis() TSRMLS_CC), aiArtifact.data, aiArtifact.len, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-164022155, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiArtifact);
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLRedirectBinding, LoadRequest)
{
	char *sRequest;
	int sRequest_len;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sRequest, &sRequest_len) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSAMLRedirectBinding_LoadRequest(SBGetObjectHandle(getThis() TSRMLS_CC), sRequest, (int32_t)sRequest_len, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(117426539, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLRedirectBinding, LoadResponse)
{
	char *sResponse;
	int sResponse_len;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sResponse, &sResponse_len) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSAMLRedirectBinding_LoadResponse(SBGetObjectHandle(getThis() TSRMLS_CC), sResponse, (int32_t)sResponse_len, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-263867009, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLRedirectBinding, LoadArtifact)
{
	char *sArtifact;
	int sArtifact_len;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sArtifact, &sArtifact_len) == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElSAMLRedirectBinding_LoadArtifact(SBGetObjectHandle(getThis() TSRMLS_CC), sArtifact, (int32_t)sArtifact_len, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-116898055, 2, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLRedirectBinding, get_URL)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSAMLRedirectBinding_get_URL(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1332028142, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLRedirectBinding, set_URL)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSAMLRedirectBinding_set_URL(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLRedirectBinding, get_Encoding)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSAMLRedirectBinding_get_Encoding(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-2128031919, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLRedirectBinding, set_Encoding)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSAMLRedirectBinding_set_Encoding(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLRedirectBinding, get_RelayState)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSAMLRedirectBinding_get_RelayState(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(2134379695, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLRedirectBinding, set_RelayState)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSAMLRedirectBinding_set_RelayState(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLRedirectBinding, get_SignatureAlg)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSAMLRedirectBinding_get_SignatureAlg(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(317219926, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLRedirectBinding, set_SignatureAlg)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSAMLRedirectBinding_set_SignatureAlg(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLRedirectBinding, get_ForceSign)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSAMLRedirectBinding_get_ForceSign(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLRedirectBinding, set_ForceSign)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSAMLRedirectBinding_set_ForceSign(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLRedirectBinding, get_KeyMaterial)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLRedirectBinding_get_KeyMaterial(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElPublicKeyMaterial_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLRedirectBinding, set_KeyMaterial)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElPublicKeyMaterial_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSAMLRedirectBinding_set_KeyMaterial(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElPublicKeyMaterial)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLRedirectBinding, get_VerifySignatures)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSAMLRedirectBinding_get_VerifySignatures(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLRedirectBinding, set_VerifySignatures)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSAMLRedirectBinding_set_VerifySignatures(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLRedirectBinding, get_OnRedirectBinderSign)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBSAMLRedirectBinderSign pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSAMLRedirectBinding_get_OnRedirectBinderSign(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLRedirectBinding, set_OnRedirectBinderSign)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSAMLRedirectBinding_set_OnRedirectBinderSign(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBSAMLRedirectBinderSignRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBSAMLRedirectBinderSign|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLRedirectBinding, get_OnRedirectBinderVerify)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBSAMLRedirectBinderVerify pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSAMLRedirectBinding_get_OnRedirectBinderVerify(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLRedirectBinding, set_OnRedirectBinderVerify)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSAMLRedirectBinding_set_OnRedirectBinderVerify(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBSAMLRedirectBinderVerifyRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBSAMLRedirectBinderVerify|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLRedirectBinding, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLRedirectBinding_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLRedirectBinding_Detect_Inst, 0, 0, 2)
	ZEND_ARG_INFO(0, Buf)
	ZEND_ARG_INFO(1, Proto)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLRedirectBinding_Detect, 0, 0, 2)
	ZEND_ARG_INFO(0, Buf)
	ZEND_ARG_INFO(1, Proto)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLRedirectBinding_GetName, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLRedirectBinding_SaveRequest, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Doc, TElXMLDOMDocument, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLRedirectBinding_SaveResponse, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Doc, TElXMLDOMDocument, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLRedirectBinding_SaveArtifact, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Artifact, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLRedirectBinding_LoadRequest, 0, 0, 1)
	ZEND_ARG_INFO(0, Request)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLRedirectBinding_LoadResponse, 0, 0, 1)
	ZEND_ARG_INFO(0, Response)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLRedirectBinding_LoadArtifact, 0, 0, 1)
	ZEND_ARG_INFO(0, Artifact)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLRedirectBinding_get_URL, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLRedirectBinding_set_URL, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLRedirectBinding_get_Encoding, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLRedirectBinding_set_Encoding, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLRedirectBinding_get_RelayState, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLRedirectBinding_set_RelayState, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLRedirectBinding_get_SignatureAlg, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLRedirectBinding_set_SignatureAlg, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLRedirectBinding_get_ForceSign, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLRedirectBinding_set_ForceSign, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLRedirectBinding_get_KeyMaterial, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLRedirectBinding_set_KeyMaterial, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElPublicKeyMaterial, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLRedirectBinding_get_VerifySignatures, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLRedirectBinding_set_VerifySignatures, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLRedirectBinding_get_OnRedirectBinderSign, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLRedirectBinding_set_OnRedirectBinderSign, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLRedirectBinding_get_OnRedirectBinderVerify, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLRedirectBinding_set_OnRedirectBinderVerify, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLRedirectBinding___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElSAMLRedirectBinding_methods[] = {
	PHP_ME(TElSAMLRedirectBinding, Detect_Inst, arginfo_TElSAMLRedirectBinding_Detect_Inst, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLRedirectBinding, Detect, arginfo_TElSAMLRedirectBinding_Detect, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElSAMLRedirectBinding, GetName, arginfo_TElSAMLRedirectBinding_GetName, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLRedirectBinding, SaveRequest, arginfo_TElSAMLRedirectBinding_SaveRequest, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLRedirectBinding, SaveResponse, arginfo_TElSAMLRedirectBinding_SaveResponse, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLRedirectBinding, SaveArtifact, arginfo_TElSAMLRedirectBinding_SaveArtifact, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLRedirectBinding, LoadRequest, arginfo_TElSAMLRedirectBinding_LoadRequest, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLRedirectBinding, LoadResponse, arginfo_TElSAMLRedirectBinding_LoadResponse, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLRedirectBinding, LoadArtifact, arginfo_TElSAMLRedirectBinding_LoadArtifact, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLRedirectBinding, get_URL, arginfo_TElSAMLRedirectBinding_get_URL, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLRedirectBinding, set_URL, arginfo_TElSAMLRedirectBinding_set_URL, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLRedirectBinding, get_Encoding, arginfo_TElSAMLRedirectBinding_get_Encoding, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLRedirectBinding, set_Encoding, arginfo_TElSAMLRedirectBinding_set_Encoding, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLRedirectBinding, get_RelayState, arginfo_TElSAMLRedirectBinding_get_RelayState, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLRedirectBinding, set_RelayState, arginfo_TElSAMLRedirectBinding_set_RelayState, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLRedirectBinding, get_SignatureAlg, arginfo_TElSAMLRedirectBinding_get_SignatureAlg, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLRedirectBinding, set_SignatureAlg, arginfo_TElSAMLRedirectBinding_set_SignatureAlg, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLRedirectBinding, get_ForceSign, arginfo_TElSAMLRedirectBinding_get_ForceSign, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLRedirectBinding, set_ForceSign, arginfo_TElSAMLRedirectBinding_set_ForceSign, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLRedirectBinding, get_KeyMaterial, arginfo_TElSAMLRedirectBinding_get_KeyMaterial, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLRedirectBinding, set_KeyMaterial, arginfo_TElSAMLRedirectBinding_set_KeyMaterial, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLRedirectBinding, get_VerifySignatures, arginfo_TElSAMLRedirectBinding_get_VerifySignatures, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLRedirectBinding, set_VerifySignatures, arginfo_TElSAMLRedirectBinding_set_VerifySignatures, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLRedirectBinding, get_OnRedirectBinderSign, arginfo_TElSAMLRedirectBinding_get_OnRedirectBinderSign, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLRedirectBinding, set_OnRedirectBinderSign, arginfo_TElSAMLRedirectBinding_set_OnRedirectBinderSign, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLRedirectBinding, get_OnRedirectBinderVerify, arginfo_TElSAMLRedirectBinding_get_OnRedirectBinderVerify, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLRedirectBinding, set_OnRedirectBinderVerify, arginfo_TElSAMLRedirectBinding_set_OnRedirectBinderVerify, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLRedirectBinding, __construct, arginfo_TElSAMLRedirectBinding___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSAMLRedirectBinding(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSAMLRedirectBinding_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSAMLRedirectBinding", TElSAMLRedirectBinding_methods);
	if (NULL == TElSAMLBinding_ce_ptr)
		Register_TElSAMLBinding(TSRMLS_C);
	TElSAMLRedirectBinding_ce_ptr = zend_register_internal_class_ex(&ce, TElSAMLBinding_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElSAMLPOSTBinding_ce_ptr = NULL;

SB_PHP_METHOD(TElSAMLPOSTBinding, Detect_Inst)
{
	char *sProto = NULL;
	int32_t sProto_len = 0;
	SBArrayZValInfo aiBuf;
	uint32_t _err;
	zval *zaBuf;
	zval *zsProto;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zz", &zaBuf, &zsProto) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaBuf)) || (IS_ARRAY == Z_TYPE_P(zaBuf)) || (IS_NULL == Z_TYPE_P(zaBuf))) && PZVAL_IS_REF(zsProto) && (IS_STRING == Z_TYPE_P(zsProto)))
	{
		TSBSAMLDataTypeRaw fOutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaBuf, &aiBuf TSRMLS_CC)) RETURN_FALSE;
		_err = TElSAMLPOSTBinding_Detect_1(SBGetObjectHandle(getThis() TSRMLS_CC), aiBuf.data, aiBuf.len, sProto, &sProto_len, &fOutResultRaw);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sProto = emalloc(sProto_len + 1);
			SBCheckError(SBGetLastReturnStringA(2113827569, 2, sProto, &sProto_len) TSRMLS_CC);
			zval_dtor(zsProto);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiBuf);
		sProto[sProto_len] = 0;
		ZVAL_STRINGL(zsProto, sProto, sProto_len, 0);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, &string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLPOSTBinding, Detect)
{
	char *sProto = NULL;
	int32_t sProto_len = 0;
	SBArrayZValInfo aiBuf;
	uint32_t _err;
	zval *zaBuf;
	zval *zsProto;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zz", &zaBuf, &zsProto) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaBuf)) || (IS_ARRAY == Z_TYPE_P(zaBuf)) || (IS_NULL == Z_TYPE_P(zaBuf))) && PZVAL_IS_REF(zsProto) && (IS_STRING == Z_TYPE_P(zsProto)))
	{
		TSBSAMLDataTypeRaw fOutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaBuf, &aiBuf TSRMLS_CC)) RETURN_FALSE;
		_err = TElSAMLPOSTBinding_Detect(aiBuf.data, aiBuf.len, sProto, &sProto_len, &fOutResultRaw);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sProto = emalloc(sProto_len + 1);
			SBCheckError(SBGetLastReturnStringA(2113827569, 1, sProto, &sProto_len) TSRMLS_CC);
			zval_dtor(zsProto);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiBuf);
		sProto[sProto_len] = 0;
		ZVAL_STRINGL(zsProto, sProto, sProto_len, 0);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, &string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLPOSTBinding, GetName)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSAMLPOSTBinding_GetName(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(624063246, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLPOSTBinding, SaveRequest)
{
	uint32_t _err;
	zval *oDoc;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDoc, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSAMLPOSTBinding_SaveRequest(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDoc TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1447537896, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLPOSTBinding, SaveResponse)
{
	uint32_t _err;
	zval *oDoc;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDoc, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSAMLPOSTBinding_SaveResponse(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDoc TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1272222839, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLPOSTBinding, LoadRequest)
{
	char *sRequest;
	int sRequest_len;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sRequest, &sRequest_len) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSAMLPOSTBinding_LoadRequest(SBGetObjectHandle(getThis() TSRMLS_CC), sRequest, (int32_t)sRequest_len, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1608275339, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLPOSTBinding, LoadResponse)
{
	char *sResponse;
	int sResponse_len;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sResponse, &sResponse_len) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSAMLPOSTBinding_LoadResponse(SBGetObjectHandle(getThis() TSRMLS_CC), sResponse, (int32_t)sResponse_len, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1040951894, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLPOSTBinding, get_URL)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSAMLPOSTBinding_get_URL(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-100508425, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLPOSTBinding, set_URL)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSAMLPOSTBinding_set_URL(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLPOSTBinding, get_RelayState)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSAMLPOSTBinding_get_RelayState(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1108824842, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLPOSTBinding, set_RelayState)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSAMLPOSTBinding_set_RelayState(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLPOSTBinding, get_FormTemplate)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSAMLPOSTBinding_get_FormTemplate(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1680724897, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLPOSTBinding, set_FormTemplate)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSAMLPOSTBinding_set_FormTemplate(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLPOSTBinding, get_Body)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSAMLPOSTBinding_get_Body(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1227220172, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLPOSTBinding, set_Body)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSAMLPOSTBinding_set_Body(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLPOSTBinding, get_Mode)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBSAMLPOSTBindingModeRaw fOutResultRaw = 0;
		SBCheckError(TElSAMLPOSTBinding_get_Mode(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLPOSTBinding, set_Mode)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElSAMLPOSTBinding_set_Mode(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBSAMLPOSTBindingModeRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLPOSTBinding, get_OnParseForm)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBSAMLPOSTBindingParseForm pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSAMLPOSTBinding_get_OnParseForm(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLPOSTBinding, set_OnParseForm)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSAMLPOSTBinding_set_OnParseForm(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBSAMLPOSTBindingParseFormRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBSAMLPOSTBindingParseForm|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLPOSTBinding, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLPOSTBinding_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLPOSTBinding_Detect_Inst, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Buf, 0, 1)
	ZEND_ARG_INFO(1, Proto)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLPOSTBinding_Detect, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Buf, 0, 1)
	ZEND_ARG_INFO(1, Proto)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLPOSTBinding_GetName, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLPOSTBinding_SaveRequest, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Doc, TElXMLDOMDocument, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLPOSTBinding_SaveResponse, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Doc, TElXMLDOMDocument, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLPOSTBinding_LoadRequest, 0, 0, 1)
	ZEND_ARG_INFO(0, Request)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLPOSTBinding_LoadResponse, 0, 0, 1)
	ZEND_ARG_INFO(0, Response)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLPOSTBinding_get_URL, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLPOSTBinding_set_URL, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLPOSTBinding_get_RelayState, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLPOSTBinding_set_RelayState, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLPOSTBinding_get_FormTemplate, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLPOSTBinding_set_FormTemplate, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLPOSTBinding_get_Body, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLPOSTBinding_set_Body, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLPOSTBinding_get_Mode, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLPOSTBinding_set_Mode, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLPOSTBinding_get_OnParseForm, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLPOSTBinding_set_OnParseForm, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLPOSTBinding___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElSAMLPOSTBinding_methods[] = {
	PHP_ME(TElSAMLPOSTBinding, Detect_Inst, arginfo_TElSAMLPOSTBinding_Detect_Inst, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLPOSTBinding, Detect, arginfo_TElSAMLPOSTBinding_Detect, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElSAMLPOSTBinding, GetName, arginfo_TElSAMLPOSTBinding_GetName, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLPOSTBinding, SaveRequest, arginfo_TElSAMLPOSTBinding_SaveRequest, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLPOSTBinding, SaveResponse, arginfo_TElSAMLPOSTBinding_SaveResponse, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLPOSTBinding, LoadRequest, arginfo_TElSAMLPOSTBinding_LoadRequest, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLPOSTBinding, LoadResponse, arginfo_TElSAMLPOSTBinding_LoadResponse, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLPOSTBinding, get_URL, arginfo_TElSAMLPOSTBinding_get_URL, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLPOSTBinding, set_URL, arginfo_TElSAMLPOSTBinding_set_URL, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLPOSTBinding, get_RelayState, arginfo_TElSAMLPOSTBinding_get_RelayState, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLPOSTBinding, set_RelayState, arginfo_TElSAMLPOSTBinding_set_RelayState, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLPOSTBinding, get_FormTemplate, arginfo_TElSAMLPOSTBinding_get_FormTemplate, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLPOSTBinding, set_FormTemplate, arginfo_TElSAMLPOSTBinding_set_FormTemplate, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLPOSTBinding, get_Body, arginfo_TElSAMLPOSTBinding_get_Body, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLPOSTBinding, set_Body, arginfo_TElSAMLPOSTBinding_set_Body, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLPOSTBinding, get_Mode, arginfo_TElSAMLPOSTBinding_get_Mode, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLPOSTBinding, set_Mode, arginfo_TElSAMLPOSTBinding_set_Mode, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLPOSTBinding, get_OnParseForm, arginfo_TElSAMLPOSTBinding_get_OnParseForm, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLPOSTBinding, set_OnParseForm, arginfo_TElSAMLPOSTBinding_set_OnParseForm, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLPOSTBinding, __construct, arginfo_TElSAMLPOSTBinding___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSAMLPOSTBinding(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSAMLPOSTBinding_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSAMLPOSTBinding", TElSAMLPOSTBinding_methods);
	if (NULL == TElSAMLBinding_ce_ptr)
		Register_TElSAMLBinding(TSRMLS_C);
	TElSAMLPOSTBinding_ce_ptr = zend_register_internal_class_ex(&ce, TElSAMLBinding_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElSAMLArtifact_ce_ptr = NULL;

SB_PHP_METHOD(TElSAMLArtifact, SaveToBuffer)
{
	int32_t l4SizeRaw;
	SBArrayZValInfo aiBuf;
	uint32_t _err;
	zval *zaBuf;
	zval *zl4Size;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zz", &zaBuf, &zl4Size) == SUCCESS) && PZVAL_IS_REF(zaBuf) && ((IS_STRING == Z_TYPE_P(zaBuf)) || (IS_ARRAY == Z_TYPE_P(zaBuf))) && PZVAL_IS_REF(zl4Size) && (IS_LONG == Z_TYPE_P(zl4Size)))
	{
		if (!SBGetByteArrayFromZVal(zaBuf, &aiBuf TSRMLS_CC)) RETURN_FALSE;
		l4SizeRaw = (int32_t)Z_LVAL_P(zl4Size);
		_err = TElSAMLArtifact_SaveToBuffer(SBGetObjectHandle(getThis() TSRMLS_CC), aiBuf.data, &aiBuf.len, &l4SizeRaw);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			SBDetachDataFromZValAndResize(zaBuf, &aiBuf TSRMLS_CC);
			SBCheckError(SBGetLastReturnBuffer(777458146, 1, aiBuf.data, &aiBuf.len) TSRMLS_CC);
			((char *)aiBuf.data)[aiBuf.len] = 0;
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBFreeArrayZValInfo(&aiBuf);
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBSetByteArrayToZVal(&aiBuf, zaBuf);
		ZVAL_LONG(zl4Size, (long)l4SizeRaw);
	}
	else
	{
		SBErrorExpectsArguments("(&array of byte|string, &integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLArtifact, LoadFromBuffer)
{
	SBArrayZValInfo aiBuffer;
	zval *zaBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaBuffer) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaBuffer)) || (IS_ARRAY == Z_TYPE_P(zaBuffer)) || (IS_NULL == Z_TYPE_P(zaBuffer))))
	{
		if (!SBGetByteArrayFromZVal(zaBuffer, &aiBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElSAMLArtifact_LoadFromBuffer(SBGetObjectHandle(getThis() TSRMLS_CC), aiBuffer.data, aiBuffer.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiBuffer);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLArtifact, Initialize)
{
	char *sURI;
	int sURI_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sURI, &sURI_len) == SUCCESS)
	{
		SBCheckError(TElSAMLArtifact_Initialize(SBGetObjectHandle(getThis() TSRMLS_CC), sURI, (int32_t)sURI_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLArtifact, get_TypeCode)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint16_t u2OutResultRaw = 0;
		SBCheckError(TElSAMLArtifact_get_TypeCode(SBGetObjectHandle(getThis() TSRMLS_CC), &u2OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u2OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLArtifact, get_EndPointIndex)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint16_t u2OutResultRaw = 0;
		SBCheckError(TElSAMLArtifact_get_EndPointIndex(SBGetObjectHandle(getThis() TSRMLS_CC), &u2OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u2OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLArtifact, set_EndPointIndex)
{
	long u2Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u2Value) == SUCCESS)
	{
		SBCheckError(TElSAMLArtifact_set_EndPointIndex(SBGetObjectHandle(getThis() TSRMLS_CC), (uint16_t)u2Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLArtifact, get_RamainingArtifact)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElSAMLArtifact_get_RamainingArtifact(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-1114650305, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLArtifact, get_SourceID)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElSAMLArtifact_get_SourceID(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(466442972, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLArtifact, set_SourceID)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElSAMLArtifact_set_SourceID(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLArtifact, get_MessageHandle)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElSAMLArtifact_get_MessageHandle(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-1396907964, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLArtifact, set_MessageHandle)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElSAMLArtifact_set_MessageHandle(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLArtifact, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLArtifact_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLArtifact_SaveToBuffer, 0, 0, 2)
	ZEND_ARG_INFO(1, Buf)
	ZEND_ARG_INFO(1, Size)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLArtifact_LoadFromBuffer, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLArtifact_Initialize, 0, 0, 1)
	ZEND_ARG_INFO(0, URI)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLArtifact_get_TypeCode, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLArtifact_get_EndPointIndex, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLArtifact_set_EndPointIndex, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLArtifact_get_RamainingArtifact, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLArtifact_get_SourceID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLArtifact_set_SourceID, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLArtifact_get_MessageHandle, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLArtifact_set_MessageHandle, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLArtifact___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElSAMLArtifact_methods[] = {
	PHP_ME(TElSAMLArtifact, SaveToBuffer, arginfo_TElSAMLArtifact_SaveToBuffer, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLArtifact, LoadFromBuffer, arginfo_TElSAMLArtifact_LoadFromBuffer, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLArtifact, Initialize, arginfo_TElSAMLArtifact_Initialize, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLArtifact, get_TypeCode, arginfo_TElSAMLArtifact_get_TypeCode, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLArtifact, get_EndPointIndex, arginfo_TElSAMLArtifact_get_EndPointIndex, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLArtifact, set_EndPointIndex, arginfo_TElSAMLArtifact_set_EndPointIndex, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLArtifact, get_RamainingArtifact, arginfo_TElSAMLArtifact_get_RamainingArtifact, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLArtifact, get_SourceID, arginfo_TElSAMLArtifact_get_SourceID, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLArtifact, set_SourceID, arginfo_TElSAMLArtifact_set_SourceID, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLArtifact, get_MessageHandle, arginfo_TElSAMLArtifact_get_MessageHandle, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLArtifact, set_MessageHandle, arginfo_TElSAMLArtifact_set_MessageHandle, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLArtifact, __construct, arginfo_TElSAMLArtifact___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSAMLArtifact(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSAMLArtifact_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSAMLArtifact", TElSAMLArtifact_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElSAMLArtifact_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_FUNCTION(SBXMLSAMLBind, ParseHTTPParameters)
{
	char *sS;
	int sS_len;
	zval *oOutput;
#ifdef SB_WINDOWS
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &sS, &sS_len, &oOutput, TStringList_ce_ptr) == SUCCESS)
#else
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &sS, &sS_len, &oOutput, TElStringList_ce_ptr) == SUCCESS)
#endif
	{
		SBCheckError(SBXMLSAMLBind_ParseHTTPParameters(sS, (int32_t)sS_len, SBGetObjectHandle(oOutput TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
#ifdef SB_WINDOWS
		SBErrorExpectsArguments("(string, TStringList)" TSRMLS_CC);
#else
		SBErrorExpectsArguments("(string, TElStringList)" TSRMLS_CC);
#endif
	}
}

void Register_SBXMLSAMLBind_Constants(int module_number TSRMLS_DC)
{
	SB_REGISTER_STRING_CONSTANT(SBXMLSAMLBind, samlBindingSOAP, SB_samlBindingSOAP, SB_samlBindingSOAP);
	SB_REGISTER_STRING_CONSTANT(SBXMLSAMLBind, samlBindingPAOS, SB_samlBindingPAOS, SB_samlBindingPAOS);
	SB_REGISTER_STRING_CONSTANT(SBXMLSAMLBind, samlBindingRedirect, SB_samlBindingRedirect, SB_samlBindingRedirect);
	SB_REGISTER_STRING_CONSTANT(SBXMLSAMLBind, samlBindingPOST, SB_samlBindingPOST, SB_samlBindingPOST);
	SB_REGISTER_STRING_CONSTANT(SBXMLSAMLBind, samlBindingHTTPArtifact, SB_samlBindingHTTPArtifact, SB_samlBindingHTTPArtifact);
	SB_REGISTER_STRING_CONSTANT(SBXMLSAMLBind, samlRedirectBindingEncodingDeflate, SB_samlRedirectBindingEncodingDeflate, SB_samlRedirectBindingEncodingDeflate);
	SB_REGISTER_STRING_CONSTANT(SBXMLSAMLBind, SCannotParseGZHeader, SB_SCannotParseGZHeader, SB_SCannotParseGZHeader);
	SB_REGISTER_STRING_CONSTANT(SBXMLSAMLBind, SCannotInflateCompressedData, SB_SCannotInflateCompressedData, SB_SCannotInflateCompressedData);
}

void Register_SBXMLSAMLBind_Enum_Flags(TSRMLS_D)
{
	zend_class_entry ce;
	INIT_CLASS_ENTRY(ce, "TSBSAMLBindingType", NULL);
	TSBSAMLBindingType_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBSAMLBindingType_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBSAMLBindingType_ce_ptr, "sbtNone", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBSAMLBindingType_ce_ptr, "sbtSOAP", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBSAMLBindingType_ce_ptr, "sbtPAOS", 2)
	SB_DECLARE_CLASS_LONG_CONST(TSBSAMLBindingType_ce_ptr, "sbtRedirect", 3)
	SB_DECLARE_CLASS_LONG_CONST(TSBSAMLBindingType_ce_ptr, "sbtPOST", 4)
	SB_DECLARE_CLASS_LONG_CONST(TSBSAMLBindingType_ce_ptr, "sbtArtifact", 5)
	
	INIT_CLASS_ENTRY(ce, "TSBSAMLBindingTypes", NULL);
	TSBSAMLBindingTypes_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseFlags_ce_ptr, NULL TSRMLS_CC);
	TSBSAMLBindingTypes_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBSAMLBindingTypes_ce_ptr, "sbtNone", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBSAMLBindingTypes_ce_ptr, "sbtSOAP", 2)
	SB_DECLARE_CLASS_LONG_CONST(TSBSAMLBindingTypes_ce_ptr, "sbtPAOS", 4)
	SB_DECLARE_CLASS_LONG_CONST(TSBSAMLBindingTypes_ce_ptr, "sbtRedirect", 8)
	SB_DECLARE_CLASS_LONG_CONST(TSBSAMLBindingTypes_ce_ptr, "sbtPOST", 16)
	SB_DECLARE_CLASS_LONG_CONST(TSBSAMLBindingTypes_ce_ptr, "sbtArtifact", 32)
	
	INIT_CLASS_ENTRY(ce, "TSBSAMLDataType", NULL);
	TSBSAMLDataType_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBSAMLDataType_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBSAMLDataType_ce_ptr, "sdtNone", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBSAMLDataType_ce_ptr, "sdtRequest", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBSAMLDataType_ce_ptr, "sdtResponse", 2)
	SB_DECLARE_CLASS_LONG_CONST(TSBSAMLDataType_ce_ptr, "sdtArtifact", 3)
	
	INIT_CLASS_ENTRY(ce, "TSAMLGZHeaderSkipped", NULL);
	TSAMLGZHeaderSkipped_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSAMLGZHeaderSkipped_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSAMLGZHeaderSkipped_ce_ptr, "gzNone", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSAMLGZHeaderSkipped_ce_ptr, "gzMagic", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSAMLGZHeaderSkipped_ce_ptr, "gzMethod", 2)
	SB_DECLARE_CLASS_LONG_CONST(TSAMLGZHeaderSkipped_ce_ptr, "gzFlags", 3)
	SB_DECLARE_CLASS_LONG_CONST(TSAMLGZHeaderSkipped_ce_ptr, "gzTimeXFlagsOSCode", 4)
	SB_DECLARE_CLASS_LONG_CONST(TSAMLGZHeaderSkipped_ce_ptr, "gzExtra", 5)
	SB_DECLARE_CLASS_LONG_CONST(TSAMLGZHeaderSkipped_ce_ptr, "gzFileName", 6)
	SB_DECLARE_CLASS_LONG_CONST(TSAMLGZHeaderSkipped_ce_ptr, "gzFileComment", 7)
	SB_DECLARE_CLASS_LONG_CONST(TSAMLGZHeaderSkipped_ce_ptr, "gzCRC", 8)
	SB_DECLARE_CLASS_LONG_CONST(TSAMLGZHeaderSkipped_ce_ptr, "gzAll", 9)
	
	INIT_CLASS_ENTRY(ce, "TSBSAMLPOSTBindingMode", NULL);
	TSBSAMLPOSTBindingMode_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBSAMLPOSTBindingMode_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBSAMLPOSTBindingMode_ce_ptr, "spmClient", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBSAMLPOSTBindingMode_ce_ptr, "spmServer", 1)
}
