#include "sbxmlsamlcommon.h"

zend_class_entry *TSBSAMLClientProfile_ce_ptr = NULL;

zend_class_entry *TSBSAMLClientProfiles_ce_ptr = NULL;

zend_class_entry *TSBSAMLClientState_ce_ptr = NULL;

void SB_CALLBACK TSBSAMLResourceOpenEventRaw(void * _ObjectData, TObjectHandle Sender, const char * pcURL, int32_t szURL, void * (* Handle))
{
	zval *retval_ptr;
	zval **params[3];
	zval * zSender;
	zval * zURL;
	zval * zHandle;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zURL);
	ZVAL_STRINGL(zURL, pcURL, szURL, 1);
	MAKE_STD_ZVAL(zHandle);
	SBInitPointerObject(zHandle, Handle TSRMLS_CC);

	params[0] = &zSender;
	params[1] = &zURL;
	params[2] = &zHandle;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 3, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zURL);
	Handle = SBGetPointerValue(zHandle TSRMLS_CC);
	zval_ptr_dtor(&zHandle);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBSAMLResourceReadEventRaw(void * _ObjectData, TObjectHandle Sender, void * Handle, uint8_t pBuf[], int32_t * szBuf, int32_t * Size)
{
	zval *retval_ptr;
	zval **params[4];
	zval * zSender;
	zval * zHandle;
	zval * zBuf;
	SBArrayZValInfo aiBuf;
	zval * zSize;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zHandle);
	SBInitPointerObject(zHandle, Handle TSRMLS_CC);
	MAKE_STD_ZVAL(zBuf);
	ZVAL_STRINGL(zBuf, pBuf, *szBuf, 1);
	MAKE_STD_ZVAL(zSize);
	ZVAL_LONG(zSize, (long)*Size);

	params[0] = &zSender;
	params[1] = &zHandle;
	params[2] = &zBuf;
	params[3] = &zSize;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 4, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zHandle);
	if (SBGetByteArrayFromZVal(zBuf, &aiBuf TSRMLS_CC))
		SBCheckError(SBSetEventReturnBuffer(3, aiBuf.data, aiBuf.len) TSRMLS_CC);
	SBFreeArrayZValInfo(&aiBuf);
	zval_ptr_dtor(&zBuf);
	*Size = (int32_t)Z_LVAL_P(zSize);
	zval_ptr_dtor(&zSize);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBSAMLResourceCloseEventRaw(void * _ObjectData, TObjectHandle Sender, void * Handle)
{
	zval *retval_ptr;
	zval **params[2];
	zval * zSender;
	zval * zHandle;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zHandle);
	SBInitPointerObject(zHandle, Handle TSRMLS_CC);

	params[0] = &zSender;
	params[1] = &zHandle;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 2, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zHandle);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBSAMLMetadataPreparedEventRaw(void * _ObjectData, TObjectHandle Sender, TElSAMLMetadataHandle Metadata)
{
	zval *retval_ptr;
	zval **params[2];
	zval * zSender;
	zval * zMetadata;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zMetadata);
	SBInitObject(zMetadata, TElSAMLMetadata_ce_ptr, Metadata TSRMLS_CC);

	params[0] = &zSender;
	params[1] = &zMetadata;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 2, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zMetadata);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBSAMLBeforeBindingUseEventRaw(void * _ObjectData, TObjectHandle Sender, TElSAMLBindingHandle Binding)
{
	zval *retval_ptr;
	zval **params[2];
	zval * zSender;
	zval * zBinding;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zBinding);
	SBInitObject(zBinding, TElSAMLBinding_ce_ptr, Binding TSRMLS_CC);

	params[0] = &zSender;
	params[1] = &zBinding;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 2, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zBinding);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK SBXMLSAMLCommon_TSBSAMLBeforeHTTPSServerUseEventRaw(void * _ObjectData, TObjectHandle Sender, TObjectHandle HTTPSServer)
{
	zval *retval_ptr;
	zval **params[2];
	zval * zSender;
	zval * zHTTPSServer;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zHTTPSServer);
	SBInitObject(zHTTPSServer, TObject_ce_ptr, HTTPSServer TSRMLS_CC);

	params[0] = &zSender;
	params[1] = &zHTTPSServer;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 2, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zHTTPSServer);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBSAMLBeforeHTTPSClientUseEventRaw(void * _ObjectData, TObjectHandle Sender, TObjectHandle HTTPSClient)
{
	zval *retval_ptr;
	zval **params[2];
	zval * zSender;
	zval * zHTTPSClient;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zHTTPSClient);
	SBInitObject(zHTTPSClient, TObject_ce_ptr, HTTPSClient TSRMLS_CC);

	params[0] = &zSender;
	params[1] = &zHTTPSClient;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 2, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zHTTPSClient);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBSAMLResponderErrorEventRaw(void * _ObjectData, TObjectHandle Sender, TElSAMLStatusElementHandle Status, int32_t * StatusCode, char * pcRedirectLocation, int32_t * szRedirectLocation)
{
	zval *retval_ptr;
	zval **params[4];
	zval * zSender;
	zval * zStatus;
	zval * zStatusCode;
	zval * zRedirectLocation;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zStatus);
	SBInitObject(zStatus, TElSAMLStatusElement_ce_ptr, Status TSRMLS_CC);
	MAKE_STD_ZVAL(zStatusCode);
	ZVAL_LONG(zStatusCode, (long)*StatusCode);
	MAKE_STD_ZVAL(zRedirectLocation);
	ZVAL_STRINGL(zRedirectLocation, pcRedirectLocation, *szRedirectLocation, 1);

	params[0] = &zSender;
	params[1] = &zStatus;
	params[2] = &zStatusCode;
	params[3] = &zRedirectLocation;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 4, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zStatus);
	*StatusCode = (int32_t)Z_LVAL_P(zStatusCode);
	zval_ptr_dtor(&zStatusCode);
	SBCheckError(SBSetEventReturnStringA(4, Z_STRVAL_P(zRedirectLocation), (int32_t)Z_STRLEN_P(zRedirectLocation)) TSRMLS_CC);
	zval_ptr_dtor(&zRedirectLocation);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBSAMLResponseStatusCodeEventRaw(void * _ObjectData, TObjectHandle Sender, int32_t * StatusCode, char * pcErrorMessage, int32_t * szErrorMessage, int8_t * DestroySession)
{
	zval *retval_ptr;
	zval **params[4];
	zval * zSender;
	zval * zStatusCode;
	zval * zErrorMessage;
	zval * zDestroySession;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zStatusCode);
	ZVAL_LONG(zStatusCode, (long)*StatusCode);
	MAKE_STD_ZVAL(zErrorMessage);
	ZVAL_STRINGL(zErrorMessage, pcErrorMessage, *szErrorMessage, 1);
	MAKE_STD_ZVAL(zDestroySession);
	ZVAL_BOOL(zDestroySession, (zend_bool)*DestroySession);

	params[0] = &zSender;
	params[1] = &zStatusCode;
	params[2] = &zErrorMessage;
	params[3] = &zDestroySession;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 4, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	*StatusCode = (int32_t)Z_LVAL_P(zStatusCode);
	zval_ptr_dtor(&zStatusCode);
	SBCheckError(SBSetEventReturnStringA(3, Z_STRVAL_P(zErrorMessage), (int32_t)Z_STRLEN_P(zErrorMessage)) TSRMLS_CC);
	zval_ptr_dtor(&zErrorMessage);
	*DestroySession = (int8_t)Z_BVAL_P(zDestroySession);
	zval_ptr_dtor(&zDestroySession);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBSAMLRequestPreparedEventRaw(void * _ObjectData, TObjectHandle Sender, TElSAMLRequestAbstractTypeHandle Request)
{
	zval *retval_ptr;
	zval **params[2];
	zval * zSender;
	zval * zRequest;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zRequest);
	SBInitObject(zRequest, TElSAMLRequestAbstractType_ce_ptr, Request TSRMLS_CC);

	params[0] = &zSender;
	params[1] = &zRequest;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 2, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zRequest);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBSAMLResponsePreparedEventRaw(void * _ObjectData, TObjectHandle Sender, TElSAMLStatusResponseTypeHandle Request)
{
	zval *retval_ptr;
	zval **params[2];
	zval * zSender;
	zval * zRequest;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zRequest);
	SBInitObject(zRequest, TElSAMLStatusResponseType_ce_ptr, Request TSRMLS_CC);

	params[0] = &zSender;
	params[1] = &zRequest;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 2, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zRequest);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBSAMLResponseReceivedEventRaw(void * _ObjectData, TObjectHandle Sender, TElSAMLStatusResponseTypeHandle Response, int8_t * Accept)
{
	zval *retval_ptr;
	zval **params[3];
	zval * zSender;
	zval * zResponse;
	zval * zAccept;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zResponse);
	SBInitObject(zResponse, TElSAMLStatusResponseType_ce_ptr, Response TSRMLS_CC);
	MAKE_STD_ZVAL(zAccept);
	ZVAL_BOOL(zAccept, (zend_bool)*Accept);

	params[0] = &zSender;
	params[1] = &zResponse;
	params[2] = &zAccept;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 3, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zResponse);
	*Accept = (int8_t)Z_BVAL_P(zAccept);
	zval_ptr_dtor(&zAccept);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBSAMLRequestReceivedEventRaw(void * _ObjectData, TObjectHandle Sender, TElSAMLRequestAbstractTypeHandle Request, int8_t * Accept)
{
	zval *retval_ptr;
	zval **params[3];
	zval * zSender;
	zval * zRequest;
	zval * zAccept;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zRequest);
	SBInitObject(zRequest, TElSAMLRequestAbstractType_ce_ptr, Request TSRMLS_CC);
	MAKE_STD_ZVAL(zAccept);
	ZVAL_BOOL(zAccept, (zend_bool)*Accept);

	params[0] = &zSender;
	params[1] = &zRequest;
	params[2] = &zAccept;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 3, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zRequest);
	*Accept = (int8_t)Z_BVAL_P(zAccept);
	zval_ptr_dtor(&zAccept);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBHTTPSAMLStateChangedRaw(void * _ObjectData, TObjectHandle Sender, TSBSAMLClientStateRaw State)
{
	zval *retval_ptr;
	zval **params[2];
	zval * zSender;
	zval * zState;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zState);
	ZVAL_LONG(zState, (long)State);

	params[0] = &zSender;
	params[1] = &zState;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 2, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zState);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

#ifdef SB_WINDOWS
void SB_CALLBACK TSBHTTPSAMLCredentialsChallengeRaw(void * _ObjectData, TObjectHandle Sender, const char * pcURL, int32_t szURL, const uint8_t pBody[], int32_t szBody, char * pcTargetURL, int32_t * szTargetURL, TStringListHandle Fields)
#else
void SB_CALLBACK TSBHTTPSAMLCredentialsChallengeRaw(void * _ObjectData, TObjectHandle Sender, const char * pcURL, int32_t szURL, const uint8_t pBody[], int32_t szBody, char * pcTargetURL, int32_t * szTargetURL, TElStringListHandle Fields)
#endif
{
	zval *retval_ptr;
	zval **params[5];
	zval * zSender;
	zval * zURL;
	zval * zBody;
	zval * zTargetURL;
	zval * zFields;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zURL);
	ZVAL_STRINGL(zURL, pcURL, szURL, 1);
	MAKE_STD_ZVAL(zBody);
	ZVAL_STRINGL(zBody, pBody, szBody, 1);
	MAKE_STD_ZVAL(zTargetURL);
	ZVAL_STRINGL(zTargetURL, pcTargetURL, *szTargetURL, 1);
	MAKE_STD_ZVAL(zFields);
#ifdef SB_WINDOWS
	SBInitObject(zFields, TStringList_ce_ptr, Fields TSRMLS_CC);
#else
	SBInitObject(zFields, TElStringList_ce_ptr, Fields TSRMLS_CC);
#endif

	params[0] = &zSender;
	params[1] = &zURL;
	params[2] = &zBody;
	params[3] = &zTargetURL;
	params[4] = &zFields;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 5, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zURL);
	zval_ptr_dtor(&zBody);
	SBCheckError(SBSetEventReturnStringA(4, Z_STRVAL_P(zTargetURL), (int32_t)Z_STRLEN_P(zTargetURL)) TSRMLS_CC);
	zval_ptr_dtor(&zTargetURL);
	zval_ptr_dtor(&zFields);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

zend_class_entry *TElSAMLClientSettings_ce_ptr = NULL;

SB_PHP_METHOD(TElSAMLClientSettings, Reset)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElSAMLClientSettings_Reset(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLClientSettings, get_Enabled)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSAMLClientSettings_get_Enabled(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLClientSettings, set_Enabled)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSAMLClientSettings_set_Enabled(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLClientSettings, get_Profiles)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBSAMLClientProfilesRaw fOutResultRaw = 0;
		SBCheckError(TElSAMLClientSettings_get_Profiles(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLClientSettings, set_Profiles)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElSAMLClientSettings_set_Profiles(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBSAMLClientProfilesRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLClientSettings, get_State)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBSAMLClientStateRaw fOutResultRaw = 0;
		SBCheckError(TElSAMLClientSettings_get_State(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLClientSettings, set_State)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElSAMLClientSettings_set_State(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBSAMLClientStateRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLClientSettings, get_Proto)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSAMLClientSettings_get_Proto(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1204872647, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLClientSettings, set_Proto)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSAMLClientSettings_set_Proto(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLClientSettings, get_IdPURL)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSAMLClientSettings_get_IdPURL(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(276895558, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLClientSettings, set_IdPURL)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSAMLClientSettings_set_IdPURL(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLClientSettings, get_WebSSOEnabled)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSAMLClientSettings_get_WebSSOEnabled(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLClientSettings, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLClientSettings_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLClientSettings_Reset, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLClientSettings_get_Enabled, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLClientSettings_set_Enabled, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLClientSettings_get_Profiles, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLClientSettings_set_Profiles, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLClientSettings_get_State, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLClientSettings_set_State, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLClientSettings_get_Proto, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLClientSettings_set_Proto, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLClientSettings_get_IdPURL, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLClientSettings_set_IdPURL, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLClientSettings_get_WebSSOEnabled, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLClientSettings___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElSAMLClientSettings_methods[] = {
	PHP_ME(TElSAMLClientSettings, Reset, arginfo_TElSAMLClientSettings_Reset, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLClientSettings, get_Enabled, arginfo_TElSAMLClientSettings_get_Enabled, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLClientSettings, set_Enabled, arginfo_TElSAMLClientSettings_set_Enabled, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLClientSettings, get_Profiles, arginfo_TElSAMLClientSettings_get_Profiles, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLClientSettings, set_Profiles, arginfo_TElSAMLClientSettings_set_Profiles, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLClientSettings, get_State, arginfo_TElSAMLClientSettings_get_State, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLClientSettings, set_State, arginfo_TElSAMLClientSettings_set_State, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLClientSettings, get_Proto, arginfo_TElSAMLClientSettings_get_Proto, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLClientSettings, set_Proto, arginfo_TElSAMLClientSettings_set_Proto, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLClientSettings, get_IdPURL, arginfo_TElSAMLClientSettings_get_IdPURL, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLClientSettings, set_IdPURL, arginfo_TElSAMLClientSettings_set_IdPURL, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLClientSettings, get_WebSSOEnabled, arginfo_TElSAMLClientSettings_get_WebSSOEnabled, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLClientSettings, __construct, arginfo_TElSAMLClientSettings___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSAMLClientSettings(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSAMLClientSettings_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSAMLClientSettings", TElSAMLClientSettings_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElSAMLClientSettings_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElSAMLSession_ce_ptr = NULL;

SB_PHP_METHOD(TElSAMLSession, Generate)
{
	long l4TTL;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4TTL) == SUCCESS)
	{
		SBCheckError(TElSAMLSession_Generate(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4TTL) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLSession, get_URL)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSAMLSession_get_URL(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-60097589, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLSession, set_URL)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSAMLSession_set_URL(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLSession, get_Session)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSAMLSession_get_Session(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(486089150, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLSession, set_Session)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSAMLSession_set_Session(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLSession, get_CookieSet)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSAMLSession_get_CookieSet(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLSession, set_CookieSet)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSAMLSession_set_CookieSet(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLSession, get_RelayState)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSAMLSession_get_RelayState(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1511727574, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLSession, set_RelayState)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSAMLSession_set_RelayState(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLSession, get_Request)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLSession_get_Request(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElSAMLRequestAbstractType_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLSession, set_Request)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElSAMLRequestAbstractType_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSAMLSession_set_Request(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSAMLRequestAbstractType)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLSession, get_Expires)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(TElSAMLSession_get_Expires(SBGetObjectHandle(getThis() TSRMLS_CC), &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLSession, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLSession_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLSession_Generate, 0, 0, 1)
	ZEND_ARG_INFO(0, TTL)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLSession_get_URL, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLSession_set_URL, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLSession_get_Session, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLSession_set_Session, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLSession_get_CookieSet, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLSession_set_CookieSet, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLSession_get_RelayState, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLSession_set_RelayState, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLSession_get_Request, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLSession_set_Request, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElSAMLRequestAbstractType, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLSession_get_Expires, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLSession___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElSAMLSession_methods[] = {
	PHP_ME(TElSAMLSession, Generate, arginfo_TElSAMLSession_Generate, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLSession, get_URL, arginfo_TElSAMLSession_get_URL, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLSession, set_URL, arginfo_TElSAMLSession_set_URL, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLSession, get_Session, arginfo_TElSAMLSession_get_Session, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLSession, set_Session, arginfo_TElSAMLSession_set_Session, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLSession, get_CookieSet, arginfo_TElSAMLSession_get_CookieSet, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLSession, set_CookieSet, arginfo_TElSAMLSession_set_CookieSet, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLSession, get_RelayState, arginfo_TElSAMLSession_get_RelayState, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLSession, set_RelayState, arginfo_TElSAMLSession_set_RelayState, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLSession, get_Request, arginfo_TElSAMLSession_get_Request, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLSession, set_Request, arginfo_TElSAMLSession_set_Request, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLSession, get_Expires, arginfo_TElSAMLSession_get_Expires, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLSession, __construct, arginfo_TElSAMLSession___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSAMLSession(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSAMLSession_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSAMLSession", TElSAMLSession_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElSAMLSession_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElCustomSessionManager_ce_ptr = NULL;

SB_PHP_METHOD(TElCustomSessionManager, Lock)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElCustomSessionManager_Lock(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomSessionManager, Unlock)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElCustomSessionManager_Unlock(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomSessionManager, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElCustomSessionManager_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomSessionManager, Add)
{
	zval *oSession;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSession, TElSAMLSession_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElCustomSessionManager_Add(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSession TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElSAMLSession)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomSessionManager, Remove)
{
	char *sSession;
	int sSession_len;
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCustomSessionManager_Remove(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElSAMLSession_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sSession, &sSession_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCustomSessionManager_Remove_1(SBGetObjectHandle(getThis() TSRMLS_CC), sSession, (int32_t)sSession_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElSAMLSession_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer) or (string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomSessionManager, Find)
{
	char *sSession;
	int sSession_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sSession, &sSession_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCustomSessionManager_Find(SBGetObjectHandle(getThis() TSRMLS_CC), sSession, (int32_t)sSession_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElSAMLSession_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomSessionManager, get_Count)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElCustomSessionManager_get_Count(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomSessionManager, get_Sessions)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCustomSessionManager_get_Sessions(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElSAMLSession_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomSessionManager, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCustomSessionManager_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomSessionManager_Lock, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomSessionManager_Unlock, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomSessionManager_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomSessionManager_Add, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Session, TElSAMLSession, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomSessionManager_Remove, 0, 0, 1)
	ZEND_ARG_INFO(0, Index_or_Session)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomSessionManager_Find, 0, 0, 1)
	ZEND_ARG_INFO(0, Session)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomSessionManager_get_Count, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomSessionManager_get_Sessions, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomSessionManager___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElCustomSessionManager_methods[] = {
	PHP_ME(TElCustomSessionManager, Lock, arginfo_TElCustomSessionManager_Lock, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomSessionManager, Unlock, arginfo_TElCustomSessionManager_Unlock, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomSessionManager, Clear, arginfo_TElCustomSessionManager_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomSessionManager, Add, arginfo_TElCustomSessionManager_Add, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomSessionManager, Remove, arginfo_TElCustomSessionManager_Remove, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomSessionManager, Find, arginfo_TElCustomSessionManager_Find, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomSessionManager, get_Count, arginfo_TElCustomSessionManager_get_Count, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomSessionManager, get_Sessions, arginfo_TElCustomSessionManager_get_Sessions, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomSessionManager, __construct, arginfo_TElCustomSessionManager___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElCustomSessionManager(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElCustomSessionManager_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElCustomSessionManager", TElCustomSessionManager_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElCustomSessionManager_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElMemorySessionManager_ce_ptr = NULL;

SB_PHP_METHOD(TElMemorySessionManager, Lock)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElMemorySessionManager_Lock(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElMemorySessionManager, Unlock)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElMemorySessionManager_Unlock(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElMemorySessionManager, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElMemorySessionManager_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElMemorySessionManager, Add)
{
	zval *oSession;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSession, TElSAMLSession_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElMemorySessionManager_Add(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSession TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElSAMLSession)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElMemorySessionManager, Remove)
{
	char *sSession;
	int sSession_len;
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElMemorySessionManager_Remove(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElSAMLSession_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sSession, &sSession_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElMemorySessionManager_Remove_1(SBGetObjectHandle(getThis() TSRMLS_CC), sSession, (int32_t)sSession_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElSAMLSession_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer) or (string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElMemorySessionManager, Find)
{
	char *sSession;
	int sSession_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sSession, &sSession_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElMemorySessionManager_Find(SBGetObjectHandle(getThis() TSRMLS_CC), sSession, (int32_t)sSession_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElSAMLSession_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElMemorySessionManager, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElMemorySessionManager_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElMemorySessionManager_Lock, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElMemorySessionManager_Unlock, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElMemorySessionManager_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElMemorySessionManager_Add, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Session, TElSAMLSession, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElMemorySessionManager_Remove, 0, 0, 1)
	ZEND_ARG_INFO(0, Index_or_Session)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElMemorySessionManager_Find, 0, 0, 1)
	ZEND_ARG_INFO(0, Session)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElMemorySessionManager___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElMemorySessionManager_methods[] = {
	PHP_ME(TElMemorySessionManager, Lock, arginfo_TElMemorySessionManager_Lock, ZEND_ACC_PUBLIC)
	PHP_ME(TElMemorySessionManager, Unlock, arginfo_TElMemorySessionManager_Unlock, ZEND_ACC_PUBLIC)
	PHP_ME(TElMemorySessionManager, Clear, arginfo_TElMemorySessionManager_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElMemorySessionManager, Add, arginfo_TElMemorySessionManager_Add, ZEND_ACC_PUBLIC)
	PHP_ME(TElMemorySessionManager, Remove, arginfo_TElMemorySessionManager_Remove, ZEND_ACC_PUBLIC)
	PHP_ME(TElMemorySessionManager, Find, arginfo_TElMemorySessionManager_Find, ZEND_ACC_PUBLIC)
	PHP_ME(TElMemorySessionManager, __construct, arginfo_TElMemorySessionManager___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElMemorySessionManager(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElMemorySessionManager_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElMemorySessionManager", TElMemorySessionManager_methods);
	if (NULL == TElCustomSessionManager_ce_ptr)
		Register_TElCustomSessionManager(TSRMLS_C);
	TElMemorySessionManager_ce_ptr = zend_register_internal_class_ex(&ce, TElCustomSessionManager_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *SBXMLSAMLCommon_TElStringValue_ce_ptr = NULL;

SB_PHP_METHOD(SBXMLSAMLCommon_TElStringValue, get_Value)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBXMLSAMLCommon_TElStringValue_get_Value(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1501239362, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(SBXMLSAMLCommon_TElStringValue, set_Value)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(SBXMLSAMLCommon_TElStringValue_set_Value(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(SBXMLSAMLCommon_TElStringValue, __construct)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(SBXMLSAMLCommon_TElStringValue_Create(sValue, (int32_t)sValue_len, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_SBXMLSAMLCommon_TElStringValue_get_Value, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_SBXMLSAMLCommon_TElStringValue_set_Value, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_SBXMLSAMLCommon_TElStringValue___construct, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

static zend_function_entry SBXMLSAMLCommon_TElStringValue_methods[] = {
	PHP_ME(SBXMLSAMLCommon_TElStringValue, get_Value, arginfo_SBXMLSAMLCommon_TElStringValue_get_Value, ZEND_ACC_PUBLIC)
	PHP_ME(SBXMLSAMLCommon_TElStringValue, set_Value, arginfo_SBXMLSAMLCommon_TElStringValue_set_Value, ZEND_ACC_PUBLIC)
	PHP_ME(SBXMLSAMLCommon_TElStringValue, __construct, arginfo_SBXMLSAMLCommon_TElStringValue___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_SBXMLSAMLCommon_TElStringValue(TSRMLS_D)
{
	zend_class_entry ce;
	if (SBXMLSAMLCommon_TElStringValue_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "SBXMLSAMLCommon_TElStringValue", SBXMLSAMLCommon_TElStringValue_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	SBXMLSAMLCommon_TElStringValue_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElCustomArtifactStorage_ce_ptr = NULL;

SB_PHP_METHOD(TElCustomArtifactStorage, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElCustomArtifactStorage_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomArtifactStorage, Add)
{
	char *sBody;
	int sBody_len;
	SBArrayZValInfo aiHandle;
	zval *zaHandle;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zs", &zaHandle, &sBody, &sBody_len) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaHandle)) || (IS_ARRAY == Z_TYPE_P(zaHandle)) || (IS_NULL == Z_TYPE_P(zaHandle))))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaHandle, &aiHandle TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElCustomArtifactStorage_Add(SBGetObjectHandle(getThis() TSRMLS_CC), aiHandle.data, aiHandle.len, sBody, (int32_t)sBody_len, &bOutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiHandle);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomArtifactStorage, Get)
{
	SBArrayZValInfo aiHandle;
	uint32_t _err;
	zval *zaHandle;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaHandle) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaHandle)) || (IS_ARRAY == Z_TYPE_P(zaHandle)) || (IS_NULL == Z_TYPE_P(zaHandle))))
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		if (!SBGetByteArrayFromZVal(zaHandle, &aiHandle TSRMLS_CC)) RETURN_FALSE;
		_err = TElCustomArtifactStorage_Get(SBGetObjectHandle(getThis() TSRMLS_CC), aiHandle.data, aiHandle.len, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1008268664, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiHandle);
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomArtifactStorage, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCustomArtifactStorage_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomArtifactStorage_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomArtifactStorage_Add, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Handle, 0, 1)
	ZEND_ARG_INFO(0, Body)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomArtifactStorage_Get, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Handle, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomArtifactStorage___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElCustomArtifactStorage_methods[] = {
	PHP_ME(TElCustomArtifactStorage, Clear, arginfo_TElCustomArtifactStorage_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomArtifactStorage, Add, arginfo_TElCustomArtifactStorage_Add, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomArtifactStorage, Get, arginfo_TElCustomArtifactStorage_Get, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomArtifactStorage, __construct, arginfo_TElCustomArtifactStorage___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElCustomArtifactStorage(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElCustomArtifactStorage_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElCustomArtifactStorage", TElCustomArtifactStorage_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElCustomArtifactStorage_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElMemoryArtifactStorage_ce_ptr = NULL;

SB_PHP_METHOD(TElMemoryArtifactStorage, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElMemoryArtifactStorage_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElMemoryArtifactStorage, Add)
{
	char *sBody;
	int sBody_len;
	SBArrayZValInfo aiHandle;
	zval *zaHandle;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zs", &zaHandle, &sBody, &sBody_len) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaHandle)) || (IS_ARRAY == Z_TYPE_P(zaHandle)) || (IS_NULL == Z_TYPE_P(zaHandle))))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaHandle, &aiHandle TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElMemoryArtifactStorage_Add(SBGetObjectHandle(getThis() TSRMLS_CC), aiHandle.data, aiHandle.len, sBody, (int32_t)sBody_len, &bOutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiHandle);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElMemoryArtifactStorage, Get)
{
	SBArrayZValInfo aiHandle;
	uint32_t _err;
	zval *zaHandle;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaHandle) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaHandle)) || (IS_ARRAY == Z_TYPE_P(zaHandle)) || (IS_NULL == Z_TYPE_P(zaHandle))))
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		if (!SBGetByteArrayFromZVal(zaHandle, &aiHandle TSRMLS_CC)) RETURN_FALSE;
		_err = TElMemoryArtifactStorage_Get(SBGetObjectHandle(getThis() TSRMLS_CC), aiHandle.data, aiHandle.len, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1536298407, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiHandle);
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElMemoryArtifactStorage, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElMemoryArtifactStorage_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElMemoryArtifactStorage_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElMemoryArtifactStorage_Add, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Handle, 0, 1)
	ZEND_ARG_INFO(0, Body)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElMemoryArtifactStorage_Get, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Handle, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElMemoryArtifactStorage___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElMemoryArtifactStorage_methods[] = {
	PHP_ME(TElMemoryArtifactStorage, Clear, arginfo_TElMemoryArtifactStorage_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElMemoryArtifactStorage, Add, arginfo_TElMemoryArtifactStorage_Add, ZEND_ACC_PUBLIC)
	PHP_ME(TElMemoryArtifactStorage, Get, arginfo_TElMemoryArtifactStorage_Get, ZEND_ACC_PUBLIC)
	PHP_ME(TElMemoryArtifactStorage, __construct, arginfo_TElMemoryArtifactStorage___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElMemoryArtifactStorage(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElMemoryArtifactStorage_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElMemoryArtifactStorage", TElMemoryArtifactStorage_methods);
	if (NULL == TElCustomArtifactStorage_ce_ptr)
		Register_TElCustomArtifactStorage(TSRMLS_C);
	TElMemoryArtifactStorage_ce_ptr = zend_register_internal_class_ex(&ce, TElCustomArtifactStorage_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElSAMLAdapter_ce_ptr = NULL;

SB_PHP_METHOD(TElSAMLAdapter, HandleDocumentEnd)
{
	zval *oParam;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oParam, TElHTTPSClientParams_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSAMLAdapter_HandleDocumentEnd(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oParam TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElHTTPSClientParams)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAdapter, Reset)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElSAMLAdapter_Reset(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAdapter, HandlePerformExchange)
{
	zval *oParam;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oParam, TElHTTPSClientParams_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSAMLAdapter_HandlePerformExchange(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oParam TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElHTTPSClientParams)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAdapter, HandleRedirection)
{
	zval *oParam;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oParam, TElHTTPSClientParams_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSAMLAdapter_HandleRedirection(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oParam TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElHTTPSClientParams)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAdapter, HandleReadyData)
{
	SBArrayZValInfo aiBuf;
	zval *zaBuf;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaBuf) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaBuf)) || (IS_ARRAY == Z_TYPE_P(zaBuf)) || (IS_NULL == Z_TYPE_P(zaBuf))))
	{
		if (!SBGetByteArrayFromZVal(zaBuf, &aiBuf TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElSAMLAdapter_HandleReadyData(SBGetObjectHandle(getThis() TSRMLS_CC), aiBuf.data, aiBuf.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiBuf);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAdapter, get_SAMLSettings)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLAdapter_get_SAMLSettings(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElSAMLClientSettings_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAdapter, get_OnSAMLStateChanged)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBHTTPSAMLStateChanged pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSAMLAdapter_get_OnSAMLStateChanged(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAdapter, set_OnSAMLStateChanged)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSAMLAdapter_set_OnSAMLStateChanged(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBHTTPSAMLStateChangedRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBHTTPSAMLStateChanged|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAdapter, get_OnSAMLParseForm)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBSAMLPOSTBindingParseForm pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSAMLAdapter_get_OnSAMLParseForm(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAdapter, set_OnSAMLParseForm)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSAMLAdapter_set_OnSAMLParseForm(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBSAMLPOSTBindingParseFormRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBSAMLPOSTBindingParseForm|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAdapter, get_OnSAMLCredentialsChallenge)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBHTTPSAMLCredentialsChallenge pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSAMLAdapter_get_OnSAMLCredentialsChallenge(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAdapter, set_OnSAMLCredentialsChallenge)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSAMLAdapter_set_OnSAMLCredentialsChallenge(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBHTTPSAMLCredentialsChallengeRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBHTTPSAMLCredentialsChallenge|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAdapter, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLAdapter_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAdapter_HandleDocumentEnd, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Param, TElHTTPSClientParams, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAdapter_Reset, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAdapter_HandlePerformExchange, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Param, TElHTTPSClientParams, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAdapter_HandleRedirection, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Param, TElHTTPSClientParams, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAdapter_HandleReadyData, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Buf, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAdapter_get_SAMLSettings, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAdapter_get_OnSAMLStateChanged, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAdapter_set_OnSAMLStateChanged, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAdapter_get_OnSAMLParseForm, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAdapter_set_OnSAMLParseForm, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAdapter_get_OnSAMLCredentialsChallenge, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAdapter_set_OnSAMLCredentialsChallenge, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAdapter___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElSAMLAdapter_methods[] = {
	PHP_ME(TElSAMLAdapter, HandleDocumentEnd, arginfo_TElSAMLAdapter_HandleDocumentEnd, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAdapter, Reset, arginfo_TElSAMLAdapter_Reset, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAdapter, HandlePerformExchange, arginfo_TElSAMLAdapter_HandlePerformExchange, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAdapter, HandleRedirection, arginfo_TElSAMLAdapter_HandleRedirection, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAdapter, HandleReadyData, arginfo_TElSAMLAdapter_HandleReadyData, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAdapter, get_SAMLSettings, arginfo_TElSAMLAdapter_get_SAMLSettings, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAdapter, get_OnSAMLStateChanged, arginfo_TElSAMLAdapter_get_OnSAMLStateChanged, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAdapter, set_OnSAMLStateChanged, arginfo_TElSAMLAdapter_set_OnSAMLStateChanged, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAdapter, get_OnSAMLParseForm, arginfo_TElSAMLAdapter_get_OnSAMLParseForm, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAdapter, set_OnSAMLParseForm, arginfo_TElSAMLAdapter_set_OnSAMLParseForm, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAdapter, get_OnSAMLCredentialsChallenge, arginfo_TElSAMLAdapter_get_OnSAMLCredentialsChallenge, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAdapter, set_OnSAMLCredentialsChallenge, arginfo_TElSAMLAdapter_set_OnSAMLCredentialsChallenge, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAdapter, __construct, arginfo_TElSAMLAdapter___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSAMLAdapter(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSAMLAdapter_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSAMLAdapter", TElSAMLAdapter_methods);
	if (NULL == TElCustomSAMLAdapter_ce_ptr)
		Register_TElCustomSAMLAdapter(TSRMLS_C);
	TElSAMLAdapter_ce_ptr = zend_register_internal_class_ex(&ce, TElCustomSAMLAdapter_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_FUNCTION(SBXMLSAMLCommon, XMLDocToStr)
{
	uint32_t _err;
	zval *oDoc;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDoc, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBXMLSAMLCommon_XMLDocToStr(SBGetObjectHandle(oDoc TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-483283538, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument)" TSRMLS_CC);
	}
}

void Register_SBXMLSAMLCommon_Constants(int module_number TSRMLS_DC)
{
	SB_REGISTER_STRING_CONSTANT(SBXMLSAMLCommon, SFailedToDownloadMetadata, SB_SFailedToDownloadMetadata, SB_SFailedToDownloadMetadata);
	SB_REGISTER_STRING_CONSTANT(SBXMLSAMLCommon, SWrongEntityID, SB_SWrongEntityID, SB_SWrongEntityID);
	SB_REGISTER_STRING_CONSTANT(SBXMLSAMLCommon, SWrongKeyDescriptor, SB_SWrongKeyDescriptor, SB_SWrongKeyDescriptor);
	SB_REGISTER_STRING_CONSTANT(SBXMLSAMLCommon, SMetadataIncomplete, SB_SMetadataIncomplete, SB_SMetadataIncomplete);
	SB_REGISTER_STRING_CONSTANT(SBXMLSAMLCommon, SMetadataExpired, SB_SMetadataExpired, SB_SMetadataExpired);
	SB_REGISTER_STRING_CONSTANT(SBXMLSAMLCommon, SMetadataMultipleDescriptorsAvailable, SB_SMetadataMultipleDescriptorsAvailable, SB_SMetadataMultipleDescriptorsAvailable);
}

void Register_SBXMLSAMLCommon_Enum_Flags(TSRMLS_D)
{
	zend_class_entry ce;
	INIT_CLASS_ENTRY(ce, "TSBSAMLClientProfile", NULL);
	TSBSAMLClientProfile_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBSAMLClientProfile_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBSAMLClientProfile_ce_ptr, "scpWebSSO", 0)
	
	INIT_CLASS_ENTRY(ce, "TSBSAMLClientProfiles", NULL);
	TSBSAMLClientProfiles_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseFlags_ce_ptr, NULL TSRMLS_CC);
	TSBSAMLClientProfiles_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBSAMLClientProfiles_ce_ptr, "scpWebSSO", 1)
	
	INIT_CLASS_ENTRY(ce, "TSBSAMLClientState", NULL);
	TSBSAMLClientState_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBSAMLClientState_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBSAMLClientState_ce_ptr, "scsStart", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBSAMLClientState_ce_ptr, "scsSAMLRequestRecv", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBSAMLClientState_ce_ptr, "scsSAMLRequestSent", 2)
	SB_DECLARE_CLASS_LONG_CONST(TSBSAMLClientState_ce_ptr, "scsIdentRecv", 3)
	SB_DECLARE_CLASS_LONG_CONST(TSBSAMLClientState_ce_ptr, "scsIdentSent", 4)
	SB_DECLARE_CLASS_LONG_CONST(TSBSAMLClientState_ce_ptr, "scsResponseRecv", 5)
	SB_DECLARE_CLASS_LONG_CONST(TSBSAMLClientState_ce_ptr, "scsResponseSent", 6)
}
