#include "sbxmlsoap.h"

zend_class_entry *TElXMLSOAPSignatureHandlerClass_ce_ptr = NULL;

zend_class_entry *TSBXMLSOAPSignatureValidationStatus_ce_ptr = NULL;

void SB_CALLBACK TSBXMLSOAPSignEventRaw(void * _ObjectData, TObjectHandle Sender, TElXMLSignerHandle Signer)
{
	zval *retval_ptr;
	zval **params[2];
	zval * zSender;
	zval * zSigner;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zSigner);
	SBInitObject(zSigner, TElXMLSigner_ce_ptr, Signer TSRMLS_CC);

	params[0] = &zSender;
	params[1] = &zSigner;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 2, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zSigner);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

zend_class_entry *TElXMLSOAPMessage_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLSOAPMessage, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElXMLSOAPMessage_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPMessage, CreateEnvelope)
{
	char *sSOAPPrefix;
	int sSOAPPrefix_len;
	long fVersion;
	zval *oDocument;
	zval *oParentElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!l", &oDocument, TElXMLDOMDocument_ce_ptr, &fVersion) == SUCCESS)
	{
		SBCheckError(TElXMLSOAPMessage_CreateEnvelope(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), (TSBXMLSOAPVersionRaw)fVersion) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!ls", &oDocument, TElXMLDOMDocument_ce_ptr, &fVersion, &sSOAPPrefix, &sSOAPPrefix_len) == SUCCESS)
	{
		SBCheckError(TElXMLSOAPMessage_CreateEnvelope_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), (TSBXMLSOAPVersionRaw)fVersion, sSOAPPrefix, (int32_t)sSOAPPrefix_len) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!l", &oParentElement, TElXMLDOMElement_ce_ptr, &fVersion) == SUCCESS)
	{
		SBCheckError(TElXMLSOAPMessage_CreateEnvelope_2(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oParentElement TSRMLS_CC), (TSBXMLSOAPVersionRaw)fVersion) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!ls", &oParentElement, TElXMLDOMElement_ce_ptr, &fVersion, &sSOAPPrefix, &sSOAPPrefix_len) == SUCCESS)
	{
		SBCheckError(TElXMLSOAPMessage_CreateEnvelope_3(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oParentElement TSRMLS_CC), (TSBXMLSOAPVersionRaw)fVersion, sSOAPPrefix, (int32_t)sSOAPPrefix_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument, integer) or (TElXMLDOMDocument, integer, string) or (TElXMLDOMElement, integer) or (TElXMLDOMElement, integer, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPMessage, LoadFromXML)
{
	zval *oDocument;
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLSOAPMessage_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDocument, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLSOAPMessage_LoadFromXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement) or (TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPMessage, CompleteAsyncSign)
{
	zval *oHandler;
	zval *oState;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oHandler, TElXMLSOAPCustomSignatureHandler_ce_ptr, &oState, TElDCAsyncState_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLSOAPMessage_CompleteAsyncSign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oHandler TSRMLS_CC), SBGetObjectHandle(oState TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLSOAPCustomSignatureHandler, TElDCAsyncState)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPMessage, AddSignature)
{
	zend_bool bOwnHandler;
	zval *oHandler;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oHandler, TElXMLSOAPCustomSignatureHandler_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXMLSOAPMessage_AddSignature(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oHandler TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!b", &oHandler, TElXMLSOAPCustomSignatureHandler_ce_ptr, &bOwnHandler) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXMLSOAPMessage_AddSignature_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oHandler TSRMLS_CC), (int8_t)bOwnHandler, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLSOAPCustomSignatureHandler) or (TElXMLSOAPCustomSignatureHandler, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPMessage, RemoveSignature)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		SBCheckError(TElXMLSOAPMessage_RemoveSignature(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPMessage, AddSecurityHeader)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXMLSOAPMessage_AddSecurityHeader(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPMessage, RemoveSecurityHeader)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		SBCheckError(TElXMLSOAPMessage_RemoveSecurityHeader(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPMessage, get_Envelope)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPMessage_get_Envelope(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLSOAPEnvelope_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPMessage, get_SOAPVersion)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBXMLSOAPVersionRaw fOutResultRaw = 0;
		SBCheckError(TElXMLSOAPMessage_get_SOAPVersion(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPMessage, get_IsSigned)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElXMLSOAPMessage_get_IsSigned(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPMessage, get_SignatureHandlerCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXMLSOAPMessage_get_SignatureHandlerCount(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPMessage, get_SecurityHeaderCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXMLSOAPMessage_get_SecurityHeaderCount(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPMessage, get_SignatureHandlers)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPMessage_get_SignatureHandlers(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLSOAPCustomSignatureHandler_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPMessage, get_SecurityHeaders)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPMessage_get_SecurityHeaders(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLWSSESecurity_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPMessage, __construct)
{
	zval *oAOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPMessage_Create(SBGetObjectHandle(oAOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPMessage_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPMessage_CreateEnvelope, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Document_or_ParentElement, 0, 1)
	ZEND_ARG_INFO(0, Version)
	ZEND_ARG_INFO(0, SOAPPrefix)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPMessage_LoadFromXML, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Element_or_Document, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPMessage_CompleteAsyncSign, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, Handler, TElXMLSOAPCustomSignatureHandler, 1)
	ZEND_ARG_OBJ_INFO(0, State, TElDCAsyncState, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPMessage_AddSignature, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Handler, TElXMLSOAPCustomSignatureHandler, 1)
	ZEND_ARG_INFO(0, OwnHandler)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPMessage_RemoveSignature, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPMessage_AddSecurityHeader, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPMessage_RemoveSecurityHeader, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPMessage_get_Envelope, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPMessage_get_SOAPVersion, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPMessage_get_IsSigned, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPMessage_get_SignatureHandlerCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPMessage_get_SecurityHeaderCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPMessage_get_SignatureHandlers, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPMessage_get_SecurityHeaders, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPMessage___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AOwner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLSOAPMessage_methods[] = {
	PHP_ME(TElXMLSOAPMessage, Clear, arginfo_TElXMLSOAPMessage_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPMessage, CreateEnvelope, arginfo_TElXMLSOAPMessage_CreateEnvelope, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPMessage, LoadFromXML, arginfo_TElXMLSOAPMessage_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPMessage, CompleteAsyncSign, arginfo_TElXMLSOAPMessage_CompleteAsyncSign, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPMessage, AddSignature, arginfo_TElXMLSOAPMessage_AddSignature, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPMessage, RemoveSignature, arginfo_TElXMLSOAPMessage_RemoveSignature, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPMessage, AddSecurityHeader, arginfo_TElXMLSOAPMessage_AddSecurityHeader, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPMessage, RemoveSecurityHeader, arginfo_TElXMLSOAPMessage_RemoveSecurityHeader, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPMessage, get_Envelope, arginfo_TElXMLSOAPMessage_get_Envelope, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPMessage, get_SOAPVersion, arginfo_TElXMLSOAPMessage_get_SOAPVersion, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPMessage, get_IsSigned, arginfo_TElXMLSOAPMessage_get_IsSigned, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPMessage, get_SignatureHandlerCount, arginfo_TElXMLSOAPMessage_get_SignatureHandlerCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPMessage, get_SecurityHeaderCount, arginfo_TElXMLSOAPMessage_get_SecurityHeaderCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPMessage, get_SignatureHandlers, arginfo_TElXMLSOAPMessage_get_SignatureHandlers, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPMessage, get_SecurityHeaders, arginfo_TElXMLSOAPMessage_get_SecurityHeaders, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPMessage, __construct, arginfo_TElXMLSOAPMessage___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLSOAPMessage(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLSOAPMessage_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLSOAPMessage", TElXMLSOAPMessage_methods);
	if (NULL == TComponent_ce_ptr)
		Register_TComponent(TSRMLS_C);
	TElXMLSOAPMessage_ce_ptr = zend_register_internal_class_ex(&ce, TComponent_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLSOAPCustomSignatureHandler_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLSOAPCustomSignatureHandler, GetName_Inst)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLSOAPCustomSignatureHandler_GetName_1(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(823898468, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPCustomSignatureHandler, GetName)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLSOAPCustomSignatureHandler_GetName(sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(823898468, 0, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPCustomSignatureHandler, LoadFromXML)
{
	zval *oMsg;
	zval *oSignatureElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oSignatureElement, TElXMLDOMElement_ce_ptr, &oMsg, TElXMLSOAPMessage_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLSOAPCustomSignatureHandler_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSignatureElement TSRMLS_CC), SBGetObjectHandle(oMsg TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement, TElXMLSOAPMessage)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPCustomSignatureHandler, Reset)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElXMLSOAPCustomSignatureHandler_Reset(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPCustomSignatureHandler, CompleteAsyncSign)
{
	zval *oState;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oState, TElDCAsyncState_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLSOAPCustomSignatureHandler_CompleteAsyncSign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oState TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElDCAsyncState)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPCustomSignatureHandler, ClassType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPCustomSignatureHandler_ClassType(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TClass_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPCustomSignatureHandler, get_SOAPMessage)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPCustomSignatureHandler_get_SOAPMessage(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLSOAPMessage_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPCustomSignatureHandler, get_XMLElement)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPCustomSignatureHandler_get_XMLElement(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPCustomSignatureHandler, get_CryptoProviderManager)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPCustomSignatureHandler_get_CryptoProviderManager(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomCryptoProviderManager_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPCustomSignatureHandler, set_CryptoProviderManager)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElCustomCryptoProviderManager_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLSOAPCustomSignatureHandler_set_CryptoProviderManager(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCryptoProviderManager)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPCustomSignatureHandler, get_IsCalculated)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElXMLSOAPCustomSignatureHandler_get_IsCalculated(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPCustomSignatureHandler, __construct)
{
	zval *oOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPCustomSignatureHandler_Create(SBGetObjectHandle(oOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPCustomSignatureHandler_GetName_Inst, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPCustomSignatureHandler_GetName, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPCustomSignatureHandler_LoadFromXML, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, SignatureElement, TElXMLDOMElement, 1)
	ZEND_ARG_OBJ_INFO(0, Msg, TElXMLSOAPMessage, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPCustomSignatureHandler_Reset, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPCustomSignatureHandler_CompleteAsyncSign, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, State, TElDCAsyncState, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPCustomSignatureHandler_ClassType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPCustomSignatureHandler_get_SOAPMessage, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPCustomSignatureHandler_get_XMLElement, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPCustomSignatureHandler_get_CryptoProviderManager, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPCustomSignatureHandler_set_CryptoProviderManager, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElCustomCryptoProviderManager, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPCustomSignatureHandler_get_IsCalculated, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPCustomSignatureHandler___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Owner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLSOAPCustomSignatureHandler_methods[] = {
	PHP_ME(TElXMLSOAPCustomSignatureHandler, GetName_Inst, arginfo_TElXMLSOAPCustomSignatureHandler_GetName_Inst, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPCustomSignatureHandler, GetName, arginfo_TElXMLSOAPCustomSignatureHandler_GetName, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElXMLSOAPCustomSignatureHandler, LoadFromXML, arginfo_TElXMLSOAPCustomSignatureHandler_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPCustomSignatureHandler, Reset, arginfo_TElXMLSOAPCustomSignatureHandler_Reset, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPCustomSignatureHandler, CompleteAsyncSign, arginfo_TElXMLSOAPCustomSignatureHandler_CompleteAsyncSign, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPCustomSignatureHandler, ClassType, arginfo_TElXMLSOAPCustomSignatureHandler_ClassType, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElXMLSOAPCustomSignatureHandler, get_SOAPMessage, arginfo_TElXMLSOAPCustomSignatureHandler_get_SOAPMessage, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPCustomSignatureHandler, get_XMLElement, arginfo_TElXMLSOAPCustomSignatureHandler_get_XMLElement, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPCustomSignatureHandler, get_CryptoProviderManager, arginfo_TElXMLSOAPCustomSignatureHandler_get_CryptoProviderManager, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPCustomSignatureHandler, set_CryptoProviderManager, arginfo_TElXMLSOAPCustomSignatureHandler_set_CryptoProviderManager, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPCustomSignatureHandler, get_IsCalculated, arginfo_TElXMLSOAPCustomSignatureHandler_get_IsCalculated, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPCustomSignatureHandler, __construct, arginfo_TElXMLSOAPCustomSignatureHandler___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLSOAPCustomSignatureHandler(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLSOAPCustomSignatureHandler_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLSOAPCustomSignatureHandler", TElXMLSOAPCustomSignatureHandler_methods);
	if (NULL == TComponent_ce_ptr)
		Register_TComponent(TSRMLS_C);
	TElXMLSOAPCustomSignatureHandler_ce_ptr = zend_register_internal_class_ex(&ce, TComponent_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLSOAPBaseSignatureHandler_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLSOAPBaseSignatureHandler, GetName_Inst)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLSOAPBaseSignatureHandler_GetName_1(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1770850445, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPBaseSignatureHandler, GetName)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLSOAPBaseSignatureHandler_GetName(sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1770850445, 0, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPBaseSignatureHandler, LoadFromXML)
{
	zval *oMsg;
	zval *oSignatureElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oSignatureElement, TElXMLDOMElement_ce_ptr, &oMsg, TElXMLSOAPMessage_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLSOAPBaseSignatureHandler_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSignatureElement TSRMLS_CC), SBGetObjectHandle(oMsg TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement, TElXMLSOAPMessage)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPBaseSignatureHandler, Reset)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElXMLSOAPBaseSignatureHandler_Reset(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPBaseSignatureHandler, InitiateAsyncSign)
{
	long fIncludeDataParams;
	long fSignatureMethod;
	zend_bool bIncludeKey;
	zend_bool bIncludeKeyValue;
	zval *oCertificate;
	zval *oCertStorage;
	zval *oKeyData;
	zval *oParentElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oParentElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPBaseSignatureHandler_InitiateAsyncSign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oParentElement TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElDCAsyncState_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oParentElement, TElXMLDOMElement_ce_ptr, &oCertificate, TElX509Certificate_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPBaseSignatureHandler_InitiateAsyncSign_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oParentElement TSRMLS_CC), SBGetObjectHandle(oCertificate TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElDCAsyncState_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!b", &oParentElement, TElXMLDOMElement_ce_ptr, &oCertificate, TElX509Certificate_ce_ptr, &bIncludeKey) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPBaseSignatureHandler_InitiateAsyncSign_2(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oParentElement TSRMLS_CC), SBGetObjectHandle(oCertificate TSRMLS_CC), (int8_t)bIncludeKey, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElDCAsyncState_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!bbl", &oParentElement, TElXMLDOMElement_ce_ptr, &oCertificate, TElX509Certificate_ce_ptr, &bIncludeKey, &bIncludeKeyValue, &fIncludeDataParams) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPBaseSignatureHandler_InitiateAsyncSign_3(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oParentElement TSRMLS_CC), SBGetObjectHandle(oCertificate TSRMLS_CC), (int8_t)bIncludeKey, (int8_t)bIncludeKeyValue, (TElXMLKeyInfoX509DataParamsRaw)fIncludeDataParams, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElDCAsyncState_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oParentElement, TElXMLDOMElement_ce_ptr, &oCertStorage, TElCustomCertStorage_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPBaseSignatureHandler_InitiateAsyncSign_4(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oParentElement TSRMLS_CC), SBGetObjectHandle(oCertStorage TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElDCAsyncState_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!b", &oParentElement, TElXMLDOMElement_ce_ptr, &oCertStorage, TElCustomCertStorage_ce_ptr, &bIncludeKey) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPBaseSignatureHandler_InitiateAsyncSign_5(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oParentElement TSRMLS_CC), SBGetObjectHandle(oCertStorage TSRMLS_CC), (int8_t)bIncludeKey, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElDCAsyncState_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!bbl", &oParentElement, TElXMLDOMElement_ce_ptr, &oCertStorage, TElCustomCertStorage_ce_ptr, &bIncludeKey, &bIncludeKeyValue, &fIncludeDataParams) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPBaseSignatureHandler_InitiateAsyncSign_6(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oParentElement TSRMLS_CC), SBGetObjectHandle(oCertStorage TSRMLS_CC), (int8_t)bIncludeKey, (int8_t)bIncludeKeyValue, (TElXMLKeyInfoX509DataParamsRaw)fIncludeDataParams, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElDCAsyncState_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!lb", &oParentElement, TElXMLDOMElement_ce_ptr, &oKeyData, TElXMLKeyInfoData_ce_ptr, &fSignatureMethod, &bIncludeKey) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPBaseSignatureHandler_InitiateAsyncSign_7(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oParentElement TSRMLS_CC), SBGetObjectHandle(oKeyData TSRMLS_CC), (TElXMLSignatureMethodRaw)fSignatureMethod, (int8_t)bIncludeKey, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElDCAsyncState_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement) or (TElXMLDOMElement, TElX509Certificate) or (TElXMLDOMElement, TElX509Certificate, bool) or (TElXMLDOMElement, TElX509Certificate, bool, bool, integer) or (TElXMLDOMElement, TElCustomCertStorage) or (TElXMLDOMElement, TElCustomCertStorage, bool) or (TElXMLDOMElement, TElCustomCertStorage, bool, bool, integer) or (TElXMLDOMElement, TElXMLKeyInfoData, integer, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPBaseSignatureHandler, CompleteAsyncSign)
{
	zval *oState;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oState, TElDCAsyncState_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLSOAPBaseSignatureHandler_CompleteAsyncSign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oState TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElDCAsyncState)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPBaseSignatureHandler, Sign)
{
	long fIncludeDataParams;
	long fSignatureMethod;
	zend_bool bIncludeKey;
	zend_bool bIncludeKeyValue;
	zval *oCertificate;
	zval *oCertStorage;
	zval *oKeyData;
	zval *oParentElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oParentElement, TElXMLDOMElement_ce_ptr, &oCertificate, TElX509Certificate_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLSOAPBaseSignatureHandler_Sign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oParentElement TSRMLS_CC), SBGetObjectHandle(oCertificate TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!b", &oParentElement, TElXMLDOMElement_ce_ptr, &oCertificate, TElX509Certificate_ce_ptr, &bIncludeKey) == SUCCESS)
	{
		SBCheckError(TElXMLSOAPBaseSignatureHandler_Sign_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oParentElement TSRMLS_CC), SBGetObjectHandle(oCertificate TSRMLS_CC), (int8_t)bIncludeKey) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!bbl", &oParentElement, TElXMLDOMElement_ce_ptr, &oCertificate, TElX509Certificate_ce_ptr, &bIncludeKey, &bIncludeKeyValue, &fIncludeDataParams) == SUCCESS)
	{
		SBCheckError(TElXMLSOAPBaseSignatureHandler_Sign_2(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oParentElement TSRMLS_CC), SBGetObjectHandle(oCertificate TSRMLS_CC), (int8_t)bIncludeKey, (int8_t)bIncludeKeyValue, (TElXMLKeyInfoX509DataParamsRaw)fIncludeDataParams) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oParentElement, TElXMLDOMElement_ce_ptr, &oCertStorage, TElCustomCertStorage_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLSOAPBaseSignatureHandler_Sign_3(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oParentElement TSRMLS_CC), SBGetObjectHandle(oCertStorage TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!b", &oParentElement, TElXMLDOMElement_ce_ptr, &oCertStorage, TElCustomCertStorage_ce_ptr, &bIncludeKey) == SUCCESS)
	{
		SBCheckError(TElXMLSOAPBaseSignatureHandler_Sign_4(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oParentElement TSRMLS_CC), SBGetObjectHandle(oCertStorage TSRMLS_CC), (int8_t)bIncludeKey) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!bbl", &oParentElement, TElXMLDOMElement_ce_ptr, &oCertStorage, TElCustomCertStorage_ce_ptr, &bIncludeKey, &bIncludeKeyValue, &fIncludeDataParams) == SUCCESS)
	{
		SBCheckError(TElXMLSOAPBaseSignatureHandler_Sign_5(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oParentElement TSRMLS_CC), SBGetObjectHandle(oCertStorage TSRMLS_CC), (int8_t)bIncludeKey, (int8_t)bIncludeKeyValue, (TElXMLKeyInfoX509DataParamsRaw)fIncludeDataParams) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!lb", &oParentElement, TElXMLDOMElement_ce_ptr, &oKeyData, TElXMLKeyInfoData_ce_ptr, &fSignatureMethod, &bIncludeKey) == SUCCESS)
	{
		SBCheckError(TElXMLSOAPBaseSignatureHandler_Sign_6(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oParentElement TSRMLS_CC), SBGetObjectHandle(oKeyData TSRMLS_CC), (TElXMLSignatureMethodRaw)fSignatureMethod, (int8_t)bIncludeKey) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement, TElX509Certificate) or (TElXMLDOMElement, TElX509Certificate, bool) or (TElXMLDOMElement, TElX509Certificate, bool, bool, integer) or (TElXMLDOMElement, TElCustomCertStorage) or (TElXMLDOMElement, TElCustomCertStorage, bool) or (TElXMLDOMElement, TElCustomCertStorage, bool, bool, integer) or (TElXMLDOMElement, TElXMLKeyInfoData, integer, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPBaseSignatureHandler, Validate)
{
	zval *oCertificate;
	zval *oKeyData;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBXMLSOAPSignatureValidationStatusRaw fOutResultRaw = 0;
		SBCheckError(TElXMLSOAPBaseSignatureHandler_Validate(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oCertificate, TElX509Certificate_ce_ptr) == SUCCESS)
	{
		TSBXMLSOAPSignatureValidationStatusRaw fOutResultRaw = 0;
		SBCheckError(TElXMLSOAPBaseSignatureHandler_Validate_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oCertificate TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oKeyData, TElXMLKeyInfoData_ce_ptr) == SUCCESS)
	{
		TSBXMLSOAPSignatureValidationStatusRaw fOutResultRaw = 0;
		SBCheckError(TElXMLSOAPBaseSignatureHandler_Validate_2(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oKeyData TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("() or (TElX509Certificate) or (TElXMLKeyInfoData)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPBaseSignatureHandler, AddReference)
{
	char *sCustomId;
	char *sFileNameURI;
	int sCustomId_len;
	int sFileNameURI_len;
	zend_bool bAutoGenerateId;
	zval *oElement;
	zval *oStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXMLSOAPBaseSignatureHandler_AddReference(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!b", &oElement, TElXMLDOMElement_ce_ptr, &bAutoGenerateId) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXMLSOAPBaseSignatureHandler_AddReference_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC), (int8_t)bAutoGenerateId, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!s", &oElement, TElXMLDOMElement_ce_ptr, &sCustomId, &sCustomId_len) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXMLSOAPBaseSignatureHandler_AddReference_2(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC), sCustomId, (int32_t)sCustomId_len, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLCustomElement_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXMLSOAPBaseSignatureHandler_AddReference_3(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!b", &oElement, TElXMLCustomElement_ce_ptr, &bAutoGenerateId) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXMLSOAPBaseSignatureHandler_AddReference_4(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC), (int8_t)bAutoGenerateId, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!s", &oElement, TElXMLCustomElement_ce_ptr, &sCustomId, &sCustomId_len) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXMLSOAPBaseSignatureHandler_AddReference_5(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC), sCustomId, (int32_t)sCustomId_len, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!s", &oStream, TStream_ce_ptr, &sFileNameURI, &sFileNameURI_len) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXMLSOAPBaseSignatureHandler_AddReference_6(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC), sFileNameURI, (int32_t)sFileNameURI_len, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement) or (TElXMLDOMElement, bool) or (TElXMLDOMElement, string) or (TElXMLCustomElement) or (TElXMLCustomElement, bool) or (TElXMLCustomElement, string) or (TStream, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPBaseSignatureHandler, ClassType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPBaseSignatureHandler_ClassType(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TClass_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPBaseSignatureHandler, get_Verifier)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPBaseSignatureHandler_get_Verifier(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLVerifier_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPBaseSignatureHandler, get_References)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPBaseSignatureHandler_get_References(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLReferenceList_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPBaseSignatureHandler, get_Certificates)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPBaseSignatureHandler_get_Certificates(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomCertStorage_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPBaseSignatureHandler, get_KeyName)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLSOAPBaseSignatureHandler_get_KeyName(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-230914508, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPBaseSignatureHandler, set_KeyName)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElXMLSOAPBaseSignatureHandler_set_KeyName(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPBaseSignatureHandler, get_SignerCertificate)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPBaseSignatureHandler_get_SignerCertificate(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElX509Certificate_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPBaseSignatureHandler, get_SignerKeyData)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPBaseSignatureHandler_get_SignerKeyData(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLKeyInfoData_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPBaseSignatureHandler, get_ReferencesDigestMethod)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElXMLDigestMethodRaw fOutResultRaw = 0;
		SBCheckError(TElXMLSOAPBaseSignatureHandler_get_ReferencesDigestMethod(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPBaseSignatureHandler, set_ReferencesDigestMethod)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElXMLSOAPBaseSignatureHandler_set_ReferencesDigestMethod(SBGetObjectHandle(getThis() TSRMLS_CC), (TElXMLDigestMethodRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPBaseSignatureHandler, get_XAdESProcessor)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPBaseSignatureHandler_get_XAdESProcessor(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXAdESProcessor_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPBaseSignatureHandler, set_XAdESProcessor)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElXAdESProcessor_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLSOAPBaseSignatureHandler_set_XAdESProcessor(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXAdESProcessor)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPBaseSignatureHandler, get_OwnXAdESProcessor)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElXMLSOAPBaseSignatureHandler_get_OwnXAdESProcessor(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPBaseSignatureHandler, set_OwnXAdESProcessor)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElXMLSOAPBaseSignatureHandler_set_OwnXAdESProcessor(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPBaseSignatureHandler, get_OnPrepareSignature)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBXMLSOAPSignEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElXMLSOAPBaseSignatureHandler_get_OnPrepareSignature(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPBaseSignatureHandler, set_OnPrepareSignature)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElXMLSOAPBaseSignatureHandler_set_OnPrepareSignature(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBXMLSOAPSignEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBXMLSOAPSignEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPBaseSignatureHandler, get_OnBeforeSign)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBXMLSOAPSignEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElXMLSOAPBaseSignatureHandler_get_OnBeforeSign(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPBaseSignatureHandler, set_OnBeforeSign)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElXMLSOAPBaseSignatureHandler_set_OnBeforeSign(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBXMLSOAPSignEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBXMLSOAPSignEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPBaseSignatureHandler, get_OnAfterSign)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBXMLSOAPSignEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElXMLSOAPBaseSignatureHandler_get_OnAfterSign(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPBaseSignatureHandler, set_OnAfterSign)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElXMLSOAPBaseSignatureHandler_set_OnAfterSign(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBXMLSOAPSignEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBXMLSOAPSignEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPBaseSignatureHandler, __construct)
{
	zval *oOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPBaseSignatureHandler_Create(SBGetObjectHandle(oOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPBaseSignatureHandler_GetName_Inst, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPBaseSignatureHandler_GetName, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPBaseSignatureHandler_LoadFromXML, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, SignatureElement, TElXMLDOMElement, 1)
	ZEND_ARG_OBJ_INFO(0, Msg, TElXMLSOAPMessage, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPBaseSignatureHandler_Reset, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPBaseSignatureHandler_InitiateAsyncSign, 0, 0, 0)
	ZEND_ARG_TYPE_INFO(0, ParentElement, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Certificate_or_CertStorage_or_KeyData, 0, 1)
	ZEND_ARG_INFO(0, IncludeKey_or_SignatureMethod)
	ZEND_ARG_INFO(0, IncludeKeyValue_or_IncludeKey)
	ZEND_ARG_INFO(0, IncludeDataParams)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPBaseSignatureHandler_CompleteAsyncSign, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, State, TElDCAsyncState, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPBaseSignatureHandler_Sign, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ParentElement, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Certificate_or_CertStorage_or_KeyData, 0, 1)
	ZEND_ARG_INFO(0, IncludeKey_or_SignatureMethod)
	ZEND_ARG_INFO(0, IncludeKeyValue_or_IncludeKey)
	ZEND_ARG_INFO(0, IncludeDataParams)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPBaseSignatureHandler_Validate, 0, 0, 0)
	ZEND_ARG_TYPE_INFO(0, Certificate_or_KeyData, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPBaseSignatureHandler_AddReference, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Element_or_Stream, 0, 1)
	ZEND_ARG_INFO(0, AutoGenerateId_or_CustomId_or_FileNameURI)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPBaseSignatureHandler_ClassType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPBaseSignatureHandler_get_Verifier, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPBaseSignatureHandler_get_References, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPBaseSignatureHandler_get_Certificates, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPBaseSignatureHandler_get_KeyName, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPBaseSignatureHandler_set_KeyName, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPBaseSignatureHandler_get_SignerCertificate, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPBaseSignatureHandler_get_SignerKeyData, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPBaseSignatureHandler_get_ReferencesDigestMethod, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPBaseSignatureHandler_set_ReferencesDigestMethod, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPBaseSignatureHandler_get_XAdESProcessor, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPBaseSignatureHandler_set_XAdESProcessor, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElXAdESProcessor, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPBaseSignatureHandler_get_OwnXAdESProcessor, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPBaseSignatureHandler_set_OwnXAdESProcessor, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPBaseSignatureHandler_get_OnPrepareSignature, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPBaseSignatureHandler_set_OnPrepareSignature, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPBaseSignatureHandler_get_OnBeforeSign, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPBaseSignatureHandler_set_OnBeforeSign, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPBaseSignatureHandler_get_OnAfterSign, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPBaseSignatureHandler_set_OnAfterSign, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPBaseSignatureHandler___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Owner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLSOAPBaseSignatureHandler_methods[] = {
	PHP_ME(TElXMLSOAPBaseSignatureHandler, GetName_Inst, arginfo_TElXMLSOAPBaseSignatureHandler_GetName_Inst, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPBaseSignatureHandler, GetName, arginfo_TElXMLSOAPBaseSignatureHandler_GetName, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElXMLSOAPBaseSignatureHandler, LoadFromXML, arginfo_TElXMLSOAPBaseSignatureHandler_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPBaseSignatureHandler, Reset, arginfo_TElXMLSOAPBaseSignatureHandler_Reset, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPBaseSignatureHandler, InitiateAsyncSign, arginfo_TElXMLSOAPBaseSignatureHandler_InitiateAsyncSign, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPBaseSignatureHandler, CompleteAsyncSign, arginfo_TElXMLSOAPBaseSignatureHandler_CompleteAsyncSign, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPBaseSignatureHandler, Sign, arginfo_TElXMLSOAPBaseSignatureHandler_Sign, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPBaseSignatureHandler, Validate, arginfo_TElXMLSOAPBaseSignatureHandler_Validate, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPBaseSignatureHandler, AddReference, arginfo_TElXMLSOAPBaseSignatureHandler_AddReference, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPBaseSignatureHandler, ClassType, arginfo_TElXMLSOAPBaseSignatureHandler_ClassType, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElXMLSOAPBaseSignatureHandler, get_Verifier, arginfo_TElXMLSOAPBaseSignatureHandler_get_Verifier, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPBaseSignatureHandler, get_References, arginfo_TElXMLSOAPBaseSignatureHandler_get_References, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPBaseSignatureHandler, get_Certificates, arginfo_TElXMLSOAPBaseSignatureHandler_get_Certificates, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPBaseSignatureHandler, get_KeyName, arginfo_TElXMLSOAPBaseSignatureHandler_get_KeyName, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPBaseSignatureHandler, set_KeyName, arginfo_TElXMLSOAPBaseSignatureHandler_set_KeyName, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPBaseSignatureHandler, get_SignerCertificate, arginfo_TElXMLSOAPBaseSignatureHandler_get_SignerCertificate, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPBaseSignatureHandler, get_SignerKeyData, arginfo_TElXMLSOAPBaseSignatureHandler_get_SignerKeyData, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPBaseSignatureHandler, get_ReferencesDigestMethod, arginfo_TElXMLSOAPBaseSignatureHandler_get_ReferencesDigestMethod, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPBaseSignatureHandler, set_ReferencesDigestMethod, arginfo_TElXMLSOAPBaseSignatureHandler_set_ReferencesDigestMethod, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPBaseSignatureHandler, get_XAdESProcessor, arginfo_TElXMLSOAPBaseSignatureHandler_get_XAdESProcessor, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPBaseSignatureHandler, set_XAdESProcessor, arginfo_TElXMLSOAPBaseSignatureHandler_set_XAdESProcessor, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPBaseSignatureHandler, get_OwnXAdESProcessor, arginfo_TElXMLSOAPBaseSignatureHandler_get_OwnXAdESProcessor, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPBaseSignatureHandler, set_OwnXAdESProcessor, arginfo_TElXMLSOAPBaseSignatureHandler_set_OwnXAdESProcessor, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPBaseSignatureHandler, get_OnPrepareSignature, arginfo_TElXMLSOAPBaseSignatureHandler_get_OnPrepareSignature, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPBaseSignatureHandler, set_OnPrepareSignature, arginfo_TElXMLSOAPBaseSignatureHandler_set_OnPrepareSignature, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPBaseSignatureHandler, get_OnBeforeSign, arginfo_TElXMLSOAPBaseSignatureHandler_get_OnBeforeSign, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPBaseSignatureHandler, set_OnBeforeSign, arginfo_TElXMLSOAPBaseSignatureHandler_set_OnBeforeSign, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPBaseSignatureHandler, get_OnAfterSign, arginfo_TElXMLSOAPBaseSignatureHandler_get_OnAfterSign, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPBaseSignatureHandler, set_OnAfterSign, arginfo_TElXMLSOAPBaseSignatureHandler_set_OnAfterSign, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPBaseSignatureHandler, __construct, arginfo_TElXMLSOAPBaseSignatureHandler___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLSOAPBaseSignatureHandler(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLSOAPBaseSignatureHandler_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLSOAPBaseSignatureHandler", TElXMLSOAPBaseSignatureHandler_methods);
	if (NULL == TElXMLSOAPCustomSignatureHandler_ce_ptr)
		Register_TElXMLSOAPCustomSignatureHandler(TSRMLS_C);
	TElXMLSOAPBaseSignatureHandler_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLSOAPCustomSignatureHandler_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_FUNCTION(SBXMLSOAP, RegisterSecurityHandler)
{
	zval *oHandlerClass;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oHandlerClass, TElXMLSOAPSignatureHandlerClass_ce_ptr) == SUCCESS)
	{
		SBCheckError(SBXMLSOAP_RegisterSecurityHandler(SBGetObjectHandle(oHandlerClass TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLSOAPSignatureHandlerClass)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBXMLSOAP, UnregisterSecurityHandler)
{
	zval *oHandlerClass;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oHandlerClass, TElXMLSOAPSignatureHandlerClass_ce_ptr) == SUCCESS)
	{
		SBCheckError(SBXMLSOAP_UnregisterSecurityHandler(SBGetObjectHandle(oHandlerClass TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLSOAPSignatureHandlerClass)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBXMLSOAP, Initialize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(SBXMLSOAP_Initialize() TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

void Register_SBXMLSOAP_Constants(int module_number TSRMLS_DC)
{
	SB_REGISTER_STRING_CONSTANT(SBXMLSOAP, SSOAPMessageNotLoaded, SB_SSOAPMessageNotLoaded, SB_SSOAPMessageNotLoaded);
	SB_REGISTER_STRING_CONSTANT(SBXMLSOAP, SSOAPSecurityHandlerAlreadyRegistered, SB_SSOAPSecurityHandlerAlreadyRegistered, SB_SSOAPSecurityHandlerAlreadyRegistered);
	SB_REGISTER_STRING_CONSTANT(SBXMLSOAP, SSOAPNoCertificate, SB_SSOAPNoCertificate, SB_SSOAPNoCertificate);
	SB_REGISTER_STRING_CONSTANT(SBXMLSOAP, SSOAPNoKeyData, SB_SSOAPNoKeyData, SB_SSOAPNoKeyData);
	SB_REGISTER_STRING_CONSTANT(SBXMLSOAP, SSOAPCannotValidateSignatureNotCalculated, SB_SSOAPCannotValidateSignatureNotCalculated, SB_SSOAPCannotValidateSignatureNotCalculated);
	SB_REGISTER_STRING_CONSTANT(SBXMLSOAP, SSOAPCannotSignSignatureCalculated, SB_SSOAPCannotSignSignatureCalculated, SB_SSOAPCannotSignSignatureCalculated);
	SB_REGISTER_STRING_CONSTANT(SBXMLSOAP, SSOAPSignatureHandlerNotAttached, SB_SSOAPSignatureHandlerNotAttached, SB_SSOAPSignatureHandlerNotAttached);
	SB_REGISTER_STRING_CONSTANT(SBXMLSOAP, SSOAPNothingToSign, SB_SSOAPNothingToSign, SB_SSOAPNothingToSign);
	SB_REGISTER_STRING_CONSTANT(SBXMLSOAP, SSOAPUnsupportedCertificatePublicKeyAlg, SB_SSOAPUnsupportedCertificatePublicKeyAlg, SB_SSOAPUnsupportedCertificatePublicKeyAlg);
	SB_REGISTER_STRING_CONSTANT(SBXMLSOAP, SSOAPCannotCompleteAsyncSignNoSignature, SB_SSOAPCannotCompleteAsyncSignNoSignature, SB_SSOAPCannotCompleteAsyncSignNoSignature);
	SB_REGISTER_STRING_CONSTANT(SBXMLSOAP, SSOAPNotImplemented, SB_SSOAPNotImplemented, SB_SSOAPNotImplemented);
	SB_REGISTER_STRING_CONSTANT(SBXMLSOAP, SSOAPTargetElementHasNoId, SB_SSOAPTargetElementHasNoId, SB_SSOAPTargetElementHasNoId);
}

void Register_SBXMLSOAP_Enum_Flags(TSRMLS_D)
{
	zend_class_entry ce;
	INIT_CLASS_ENTRY(ce, "TSBXMLSOAPSignatureValidationStatus", NULL);
	TSBXMLSOAPSignatureValidationStatus_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBXMLSOAPSignatureValidationStatus_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBXMLSOAPSignatureValidationStatus_ce_ptr, "ssvsUnknown", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBXMLSOAPSignatureValidationStatus_ce_ptr, "ssvsValid", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBXMLSOAPSignatureValidationStatus_ce_ptr, "ssvsInvalidSignature", 2)
	SB_DECLARE_CLASS_LONG_CONST(TSBXMLSOAPSignatureValidationStatus_ce_ptr, "ssvsInvalidReferenceDigest", 3)
	SB_DECLARE_CLASS_LONG_CONST(TSBXMLSOAPSignatureValidationStatus_ce_ptr, "ssvsNoKey", 4)
}

void Register_SBXMLSOAP_Aliases(TSRMLS_D)
{
	TElXMLSOAPSignatureHandlerClass_ce_ptr = TObject_ce_ptr;
	zend_register_class_alias("TElXMLSOAPSignatureHandlerClass", TElXMLSOAPSignatureHandlerClass_ce_ptr);
}

