#include "sbxmlutils.h"

zend_class_entry *TSBXMLDateTimeFormat_ce_ptr = NULL;

SB_PHP_FUNCTION(SBXMLUtils, ParseElementFromXMLString)
{
	char *sData;
	int sData_len;
	zval *oDocument;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &sData, &sData_len, &oDocument, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(SBXMLUtils_ParseElementFromXMLString(sData, (int32_t)sData_len, SBGetObjectHandle(oDocument TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBXMLUtils, ParseNodeListFromXMLString)
{
	char *sData;
	int sData_len;
	zval *oDocument;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &sData, &sData_len, &oDocument, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(SBXMLUtils_ParseNodeListFromXMLString(sData, (int32_t)sData_len, SBGetObjectHandle(oDocument TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMNodeList_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBXMLUtils, ConvertToBase64String)
{
	SBArrayZValInfo aiBuf;
	uint32_t _err;
	zval *zaBuf;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaBuf) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaBuf)) || (IS_ARRAY == Z_TYPE_P(zaBuf)) || (IS_NULL == Z_TYPE_P(zaBuf))))
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		if (!SBGetByteArrayFromZVal(zaBuf, &aiBuf TSRMLS_CC)) RETURN_FALSE;
		_err = SBXMLUtils_ConvertToBase64String(aiBuf.data, aiBuf.len, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1873312742, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiBuf);
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBXMLUtils, ConvertFromBase64String)
{
	char *sS;
	int sS_len;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sS, &sS_len) == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = SBXMLUtils_ConvertFromBase64String(sS, (int32_t)sS_len, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(1194684313, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBXMLUtils, ConvertBinaryToBigInt)
{
	SBArrayZValInfo aiBuf;
	uint32_t _err;
	zend_bool bAllowNegativeNumbers;
	zval *zaBuf;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zb", &zaBuf, &bAllowNegativeNumbers) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaBuf)) || (IS_ARRAY == Z_TYPE_P(zaBuf)) || (IS_NULL == Z_TYPE_P(zaBuf))))
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		if (!SBGetByteArrayFromZVal(zaBuf, &aiBuf TSRMLS_CC)) RETURN_FALSE;
		_err = SBXMLUtils_ConvertBinaryToBigInt(aiBuf.data, aiBuf.len, (int8_t)bAllowNegativeNumbers, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-864556250, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiBuf);
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, bool)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBXMLUtils, ConvertBigIntToBinary)
{
	char *sValue;
	int sValue_len;
	uint32_t _err;
	zend_bool bAllowHexNumbers;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sb", &sValue, &sValue_len, &bAllowHexNumbers) == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = SBXMLUtils_ConvertBigIntToBinary(sValue, (int32_t)sValue_len, (int8_t)bAllowHexNumbers, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(556697992, 2, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(string, bool)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBXMLUtils, ConvertHexToBinary)
{
	char *sValue;
	int sValue_len;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = SBXMLUtils_ConvertHexToBinary(sValue, (int32_t)sValue_len, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(377863171, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBXMLUtils, AddTextToXMLElement)
{
	char *sText;
	int sText_len;
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &sText, &sText_len, &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(SBXMLUtils_AddTextToXMLElement(sText, (int32_t)sText_len, SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBXMLUtils, InsertTextBeforeXMLElement)
{
	char *sText;
	int sText_len;
	zval *oElement;
	zval *oRef;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!O!", &sText, &sText_len, &oElement, TElXMLDOMElement_ce_ptr, &oRef, TElXMLDOMNode_ce_ptr) == SUCCESS)
	{
		SBCheckError(SBXMLUtils_InsertTextBeforeXMLElement(sText, (int32_t)sText_len, SBGetObjectHandle(oElement TSRMLS_CC), SBGetObjectHandle(oRef TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, TElXMLDOMElement, TElXMLDOMNode)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBXMLUtils, GetTextFromXMLElement)
{
	uint32_t _err;
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBXMLUtils_GetTextFromXMLElement(SBGetObjectHandle(oElement TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-64638431, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBXMLUtils, GetStrictTextFromXMLElement)
{
	uint32_t _err;
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBXMLUtils_GetStrictTextFromXMLElement(SBGetObjectHandle(oElement TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1322068759, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBXMLUtils, FindChildElementByLocalName)
{
	char *sLocalName;
	int sLocalName_len;
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!s", &oElement, TElXMLDOMElement_ce_ptr, &sLocalName, &sLocalName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(SBXMLUtils_FindChildElementByLocalName(SBGetObjectHandle(oElement TSRMLS_CC), sLocalName, (int32_t)sLocalName_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement, string)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBXMLUtils, FindChildElement)
{
	char *sDefaultPrefix;
	char *sName;
	char *sNamespaceURI;
	int sDefaultPrefix_len;
	int sName_len;
	int sNamespaceURI_len;
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!sss", &oElement, TElXMLDOMElement_ce_ptr, &sName, &sName_len, &sNamespaceURI, &sNamespaceURI_len, &sDefaultPrefix, &sDefaultPrefix_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(SBXMLUtils_FindChildElement(SBGetObjectHandle(oElement TSRMLS_CC), sName, (int32_t)sName_len, sNamespaceURI, (int32_t)sNamespaceURI_len, sDefaultPrefix, (int32_t)sDefaultPrefix_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement, string, string, string)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBXMLUtils, FindElementById)
{
	char *sID;
	char *sNamespaceURI;
	int sID_len;
	int sNamespaceURI_len;
	zval *oRootElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!s", &oRootElement, TElXMLDOMElement_ce_ptr, &sID, &sID_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(SBXMLUtils_FindElementById(SBGetObjectHandle(oRootElement TSRMLS_CC), sID, (int32_t)sID_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!ss", &oRootElement, TElXMLDOMElement_ce_ptr, &sID, &sID_len, &sNamespaceURI, &sNamespaceURI_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(SBXMLUtils_FindElementById_1(SBGetObjectHandle(oRootElement TSRMLS_CC), sID, (int32_t)sID_len, sNamespaceURI, (int32_t)sNamespaceURI_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement, string) or (TElXMLDOMElement, string, string)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBXMLUtils, FindElementByName)
{
	char *sName;
	char *sNamespaceURI;
	int sName_len;
	int sNamespaceURI_len;
	zval *oRootElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!ss", &oRootElement, TElXMLDOMElement_ce_ptr, &sName, &sName_len, &sNamespaceURI, &sNamespaceURI_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(SBXMLUtils_FindElementByName(SBGetObjectHandle(oRootElement TSRMLS_CC), sName, (int32_t)sName_len, sNamespaceURI, (int32_t)sNamespaceURI_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement, string, string)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBXMLUtils, ExtractIdFromLocalURI)
{
	char *sId = NULL;
	char *sURI;
	int sURI_len;
	int32_t sId_len = 0;
	uint32_t _err;
	zval *zsId;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sURI, &sURI_len) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBXMLUtils_ExtractIdFromLocalURI(sURI, (int32_t)sURI_len, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-535855577, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sz", &sURI, &sURI_len, &zsId) == SUCCESS) && PZVAL_IS_REF(zsId) && (IS_STRING == Z_TYPE_P(zsId)))
	{
		int8_t bOutResultRaw = 0;
		_err = SBXMLUtils_ExtractIdFromLocalURI_1(sURI, (int32_t)sURI_len, sId, &sId_len, &bOutResultRaw);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sId = emalloc(sId_len + 1);
			SBCheckError(SBGetLastReturnStringA(-343439292, 1, sId, &sId_len) TSRMLS_CC);
			zval_dtor(zsId);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		sId[sId_len] = 0;
		ZVAL_STRINGL(zsId, sId, sId_len, 0);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string) or (string, &string)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBXMLUtils, GetElementId)
{
	uint32_t _err;
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBXMLUtils_GetElementId(SBGetObjectHandle(oElement TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-673475204, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBXMLUtils, SetElementId)
{
	char *sValue;
	int sValue_len;
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!s", &oElement, TElXMLDOMElement_ce_ptr, &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(SBXMLUtils_SetElementId(SBGetObjectHandle(oElement TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement, string)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBXMLUtils, CanonicalizationMethodToURI)
{
	long fACanonicalizationMethod;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fACanonicalizationMethod) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBXMLUtils_CanonicalizationMethodToURI((TElXMLCanonicalizationMethodRaw)fACanonicalizationMethod, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-2117021519, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBXMLUtils, URIToCanonicalizationMethod)
{
	char *sAURI;
	int sAURI_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sAURI, &sAURI_len) == SUCCESS)
	{
		TElXMLCanonicalizationMethodRaw fOutResultRaw = 0;
		SBCheckError(SBXMLUtils_URIToCanonicalizationMethod(sAURI, (int32_t)sAURI_len, &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBXMLUtils, AddPrefixes)
{
	char *sNamespaceURI;
	char *sPrefixes;
	int sNamespaceURI_len;
	int sPrefixes_len;
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!ss", &oElement, TElXMLDOMElement_ce_ptr, &sPrefixes, &sPrefixes_len, &sNamespaceURI, &sNamespaceURI_len) == SUCCESS)
	{
		SBCheckError(SBXMLUtils_AddPrefixes(SBGetObjectHandle(oElement TSRMLS_CC), sPrefixes, (int32_t)sPrefixes_len, sNamespaceURI, (int32_t)sNamespaceURI_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement, string, string)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBXMLUtils, DateTimeToXMLString)
{
	long fFormat;
	long l4TimeZoneOffset;
	uint32_t _err;
	zval *dtValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &dtValue, php_date_get_date_ce()) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBXMLUtils_DateTimeToXMLString(SBGetDateTime(dtValue TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-2048501415, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "Ol", &dtValue, php_date_get_date_ce(), &fFormat) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBXMLUtils_DateTimeToXMLString_1(SBGetDateTime(dtValue TSRMLS_CC), (TSBXMLDateTimeFormatRaw)fFormat, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-189295739, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "Oll", &dtValue, php_date_get_date_ce(), &fFormat, &l4TimeZoneOffset) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBXMLUtils_DateTimeToXMLString_2(SBGetDateTime(dtValue TSRMLS_CC), (TSBXMLDateTimeFormatRaw)fFormat, (int32_t)l4TimeZoneOffset, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-98225005, 3, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(DateTime) or (DateTime, integer) or (DateTime, integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBXMLUtils, XMLStringToDateTime)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(SBXMLUtils_XMLStringToDateTime(sValue, (int32_t)sValue_len, &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBXMLUtils, DateTimeFormatToString)
{
	long fFormat;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fFormat) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBXMLUtils_DateTimeFormatToString((TSBXMLDateTimeFormatRaw)fFormat, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1097333036, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

void Register_SBXMLUtils_Constants(int module_number TSRMLS_DC)
{
	SB_REGISTER_LONG_CONSTANT(SBXMLUtils, SB_XML_DATETIME_SKIP_TIMEZONE, SB_XML_DATETIME_SKIP_TIMEZONE, SB_XML_DATETIME_SKIP_TIMEZONE);
}

void Register_SBXMLUtils_Enum_Flags(TSRMLS_D)
{
	zend_class_entry ce;
	INIT_CLASS_ENTRY(ce, "TSBXMLDateTimeFormat", NULL);
	TSBXMLDateTimeFormat_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBXMLDateTimeFormat_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBXMLDateTimeFormat_ce_ptr, "xdfYear", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBXMLDateTimeFormat_ce_ptr, "xdfYearMonth", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBXMLDateTimeFormat_ce_ptr, "xdfFullDate", 2)
	SB_DECLARE_CLASS_LONG_CONST(TSBXMLDateTimeFormat_ce_ptr, "xdfDateHoursMinutes", 3)
	SB_DECLARE_CLASS_LONG_CONST(TSBXMLDateTimeFormat_ce_ptr, "xdfDateTimeWithSeconds", 4)
	SB_DECLARE_CLASS_LONG_CONST(TSBXMLDateTimeFormat_ce_ptr, "xdfDateTimeWithSecondFraction", 5)
	SB_DECLARE_CLASS_LONG_CONST(TSBXMLDateTimeFormat_ce_ptr, "xdfFullDateTime", 6)
}

