#include "sbxmlwsscore.h"

zend_class_entry *TElXMLWSSESecurityTokenReferenceType_ce_ptr = NULL;

zend_class_entry *TSBXMLWSSETokenType_ce_ptr = NULL;

zend_class_entry *TElXMLWSSEElement_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLWSSEElement, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLWSSEElement_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLWSSEElement, SaveToXML)
{
	zval *oDocument;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oDocument, TElXMLDOMDocument_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLWSSEElement_SaveToXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDocument, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLWSSEElement_SaveToXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument, TElXMLCustomFormatter) or (TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLWSSEElement, __construct)
{
	char *sAName;
	int sAName_len;
	zval *oParentElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLWSSEElement_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sAName, &sAName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLWSSEElement_Create_1(sAName, (int32_t)sAName_len, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oParentElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLWSSEElement_Create_2(SBGetObjectHandle(oParentElement TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!s", &oParentElement, TElXMLDOMElement_ce_ptr, &sAName, &sAName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLWSSEElement_Create_3(SBGetObjectHandle(oParentElement TSRMLS_CC), sAName, (int32_t)sAName_len, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("() or (string) or (TElXMLDOMElement) or (TElXMLDOMElement, string)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLWSSEElement_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLWSSEElement_SaveToXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLWSSEElement___construct, 0, 0, 0)
	ZEND_ARG_TYPE_INFO(0, AName_or_ParentElement, 0, 1)
	ZEND_ARG_INFO(0, AName)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLWSSEElement_methods[] = {
	PHP_ME(TElXMLWSSEElement, LoadFromXML, arginfo_TElXMLWSSEElement_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLWSSEElement, SaveToXML, arginfo_TElXMLWSSEElement_SaveToXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLWSSEElement, __construct, arginfo_TElXMLWSSEElement___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLWSSEElement(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLWSSEElement_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLWSSEElement", TElXMLWSSEElement_methods);
	if (NULL == TElXMLCustomElement_ce_ptr)
		Register_TElXMLCustomElement(TSRMLS_C);
	TElXMLWSSEElement_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLCustomElement_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLWSSEBaseToken_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLWSSEBaseToken, get_ID)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLWSSEBaseToken_get_ID(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1576179498, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLWSSEBaseToken, set_ID)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElXMLWSSEBaseToken_set_ID(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLWSSEBaseToken, __construct)
{
	char *sAName;
	int sAName_len;
	zval *oParentElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLWSSEBaseToken_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sAName, &sAName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLWSSEBaseToken_Create_1(sAName, (int32_t)sAName_len, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oParentElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLWSSEBaseToken_Create_2(SBGetObjectHandle(oParentElement TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!s", &oParentElement, TElXMLDOMElement_ce_ptr, &sAName, &sAName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLWSSEBaseToken_Create_3(SBGetObjectHandle(oParentElement TSRMLS_CC), sAName, (int32_t)sAName_len, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("() or (string) or (TElXMLDOMElement) or (TElXMLDOMElement, string)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLWSSEBaseToken_get_ID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLWSSEBaseToken_set_ID, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLWSSEBaseToken___construct, 0, 0, 0)
	ZEND_ARG_TYPE_INFO(0, AName_or_ParentElement, 0, 1)
	ZEND_ARG_INFO(0, AName)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLWSSEBaseToken_methods[] = {
	PHP_ME(TElXMLWSSEBaseToken, get_ID, arginfo_TElXMLWSSEBaseToken_get_ID, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLWSSEBaseToken, set_ID, arginfo_TElXMLWSSEBaseToken_set_ID, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLWSSEBaseToken, __construct, arginfo_TElXMLWSSEBaseToken___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLWSSEBaseToken(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLWSSEBaseToken_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLWSSEBaseToken", TElXMLWSSEBaseToken_methods);
	if (NULL == TElXMLWSSEElement_ce_ptr)
		Register_TElXMLWSSEElement(TSRMLS_C);
	TElXMLWSSEBaseToken_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLWSSEElement_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLWSSETextElement_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLWSSETextElement, get_Data)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLWSSETextElement_get_Data(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1434943960, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLWSSETextElement, set_Data)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElXMLWSSETextElement_set_Data(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLWSSETextElement, __construct)
{
	char *sAName;
	int sAName_len;
	zval *oParentElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLWSSETextElement_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sAName, &sAName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLWSSETextElement_Create_1(sAName, (int32_t)sAName_len, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oParentElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLWSSETextElement_Create_2(SBGetObjectHandle(oParentElement TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!s", &oParentElement, TElXMLDOMElement_ce_ptr, &sAName, &sAName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLWSSETextElement_Create_3(SBGetObjectHandle(oParentElement TSRMLS_CC), sAName, (int32_t)sAName_len, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("() or (string) or (TElXMLDOMElement) or (TElXMLDOMElement, string)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLWSSETextElement_get_Data, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLWSSETextElement_set_Data, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLWSSETextElement___construct, 0, 0, 0)
	ZEND_ARG_TYPE_INFO(0, AName_or_ParentElement, 0, 1)
	ZEND_ARG_INFO(0, AName)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLWSSETextElement_methods[] = {
	PHP_ME(TElXMLWSSETextElement, get_Data, arginfo_TElXMLWSSETextElement_get_Data, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLWSSETextElement, set_Data, arginfo_TElXMLWSSETextElement_set_Data, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLWSSETextElement, __construct, arginfo_TElXMLWSSETextElement___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLWSSETextElement(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLWSSETextElement_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLWSSETextElement", TElXMLWSSETextElement_methods);
	if (NULL == TElXMLWSSEElement_ce_ptr)
		Register_TElXMLWSSEElement(TSRMLS_C);
	TElXMLWSSETextElement_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLWSSEElement_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLWSSEPassword_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLWSSEPassword, get_PasswordType)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLWSSEPassword_get_PasswordType(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-730032111, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLWSSEPassword, set_PasswordType)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElXMLWSSEPassword_set_PasswordType(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLWSSEPassword, __construct)
{
	char *sAName;
	int sAName_len;
	zval *oParentElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLWSSEPassword_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sAName, &sAName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLWSSEPassword_Create_1(sAName, (int32_t)sAName_len, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oParentElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLWSSEPassword_Create_2(SBGetObjectHandle(oParentElement TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!s", &oParentElement, TElXMLDOMElement_ce_ptr, &sAName, &sAName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLWSSEPassword_Create_3(SBGetObjectHandle(oParentElement TSRMLS_CC), sAName, (int32_t)sAName_len, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("() or (string) or (TElXMLDOMElement) or (TElXMLDOMElement, string)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLWSSEPassword_get_PasswordType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLWSSEPassword_set_PasswordType, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLWSSEPassword___construct, 0, 0, 0)
	ZEND_ARG_TYPE_INFO(0, AName_or_ParentElement, 0, 1)
	ZEND_ARG_INFO(0, AName)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLWSSEPassword_methods[] = {
	PHP_ME(TElXMLWSSEPassword, get_PasswordType, arginfo_TElXMLWSSEPassword_get_PasswordType, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLWSSEPassword, set_PasswordType, arginfo_TElXMLWSSEPassword_set_PasswordType, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLWSSEPassword, __construct, arginfo_TElXMLWSSEPassword___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLWSSEPassword(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLWSSEPassword_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLWSSEPassword", TElXMLWSSEPassword_methods);
	if (NULL == TElXMLWSSETextElement_ce_ptr)
		Register_TElXMLWSSETextElement(TSRMLS_C);
	TElXMLWSSEPassword_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLWSSETextElement_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLWSSENonce_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLWSSENonce, get_EncodingType)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLWSSENonce_get_EncodingType(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1853011137, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLWSSENonce, set_EncodingType)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElXMLWSSENonce_set_EncodingType(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLWSSENonce, __construct)
{
	char *sAName;
	int sAName_len;
	zval *oParentElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLWSSENonce_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sAName, &sAName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLWSSENonce_Create_1(sAName, (int32_t)sAName_len, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oParentElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLWSSENonce_Create_2(SBGetObjectHandle(oParentElement TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!s", &oParentElement, TElXMLDOMElement_ce_ptr, &sAName, &sAName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLWSSENonce_Create_3(SBGetObjectHandle(oParentElement TSRMLS_CC), sAName, (int32_t)sAName_len, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("() or (string) or (TElXMLDOMElement) or (TElXMLDOMElement, string)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLWSSENonce_get_EncodingType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLWSSENonce_set_EncodingType, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLWSSENonce___construct, 0, 0, 0)
	ZEND_ARG_TYPE_INFO(0, AName_or_ParentElement, 0, 1)
	ZEND_ARG_INFO(0, AName)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLWSSENonce_methods[] = {
	PHP_ME(TElXMLWSSENonce, get_EncodingType, arginfo_TElXMLWSSENonce_get_EncodingType, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLWSSENonce, set_EncodingType, arginfo_TElXMLWSSENonce_set_EncodingType, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLWSSENonce, __construct, arginfo_TElXMLWSSENonce___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLWSSENonce(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLWSSENonce_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLWSSENonce", TElXMLWSSENonce_methods);
	if (NULL == TElXMLWSSETextElement_ce_ptr)
		Register_TElXMLWSSETextElement(TSRMLS_C);
	TElXMLWSSENonce_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLWSSETextElement_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLWSUDateTime_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLWSUDateTime, get_Value)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLWSUDateTime_get_Value(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1907181709, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLWSUDateTime, set_Value)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElXMLWSUDateTime_set_Value(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLWSUDateTime, get_ValueType)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLWSUDateTime_get_ValueType(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1354307227, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLWSUDateTime, set_ValueType)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElXMLWSUDateTime_set_ValueType(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLWSUDateTime, get_ValueUTC)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(TElXMLWSUDateTime_get_ValueUTC(SBGetObjectHandle(getThis() TSRMLS_CC), &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLWSUDateTime, set_ValueUTC)
{
	zval *dtValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &dtValue, php_date_get_date_ce()) == SUCCESS)
	{
		SBCheckError(TElXMLWSUDateTime_set_ValueUTC(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetDateTime(dtValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(DateTime)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLWSUDateTime, __construct)
{
	char *sAName;
	int sAName_len;
	zval *oParentElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLWSUDateTime_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sAName, &sAName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLWSUDateTime_Create_1(sAName, (int32_t)sAName_len, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oParentElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLWSUDateTime_Create_2(SBGetObjectHandle(oParentElement TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!s", &oParentElement, TElXMLDOMElement_ce_ptr, &sAName, &sAName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLWSUDateTime_Create_3(SBGetObjectHandle(oParentElement TSRMLS_CC), sAName, (int32_t)sAName_len, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("() or (string) or (TElXMLDOMElement) or (TElXMLDOMElement, string)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLWSUDateTime_get_Value, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLWSUDateTime_set_Value, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLWSUDateTime_get_ValueType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLWSUDateTime_set_ValueType, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLWSUDateTime_get_ValueUTC, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLWSUDateTime_set_ValueUTC, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, DateTime, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLWSUDateTime___construct, 0, 0, 0)
	ZEND_ARG_TYPE_INFO(0, AName_or_ParentElement, 0, 1)
	ZEND_ARG_INFO(0, AName)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLWSUDateTime_methods[] = {
	PHP_ME(TElXMLWSUDateTime, get_Value, arginfo_TElXMLWSUDateTime_get_Value, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLWSUDateTime, set_Value, arginfo_TElXMLWSUDateTime_set_Value, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLWSUDateTime, get_ValueType, arginfo_TElXMLWSUDateTime_get_ValueType, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLWSUDateTime, set_ValueType, arginfo_TElXMLWSUDateTime_set_ValueType, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLWSUDateTime, get_ValueUTC, arginfo_TElXMLWSUDateTime_get_ValueUTC, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLWSUDateTime, set_ValueUTC, arginfo_TElXMLWSUDateTime_set_ValueUTC, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLWSUDateTime, __construct, arginfo_TElXMLWSUDateTime___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLWSUDateTime(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLWSUDateTime_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLWSUDateTime", TElXMLWSUDateTime_methods);
	if (NULL == TElXMLWSSEElement_ce_ptr)
		Register_TElXMLWSSEElement(TSRMLS_C);
	TElXMLWSUDateTime_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLWSSEElement_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLWSSEUsernameToken_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLWSSEUsernameToken, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElXMLWSSEUsernameToken_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLWSSEUsernameToken, CreateUsername)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElXMLWSSEUsernameToken_CreateUsername(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLWSSEUsernameToken, CreatePassword)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElXMLWSSEUsernameToken_CreatePassword(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLWSSEUsernameToken, CreateNonce)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElXMLWSSEUsernameToken_CreateNonce(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLWSSEUsernameToken, CreateCreated)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElXMLWSSEUsernameToken_CreateCreated(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLWSSEUsernameToken, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLWSSEUsernameToken_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLWSSEUsernameToken, get_Username)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLWSSEUsernameToken_get_Username(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLWSSETextElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLWSSEUsernameToken, get_Password)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLWSSEUsernameToken_get_Password(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLWSSEPassword_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLWSSEUsernameToken, get_Nonce)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLWSSEUsernameToken_get_Nonce(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLWSSENonce_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLWSSEUsernameToken, get_Created)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLWSSEUsernameToken_get_Created(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLWSUDateTime_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLWSSEUsernameToken, get_CreatedUTC)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(TElXMLWSSEUsernameToken_get_CreatedUTC(SBGetObjectHandle(getThis() TSRMLS_CC), &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLWSSEUsernameToken, set_CreatedUTC)
{
	zval *dtValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &dtValue, php_date_get_date_ce()) == SUCCESS)
	{
		SBCheckError(TElXMLWSSEUsernameToken_set_CreatedUTC(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetDateTime(dtValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(DateTime)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLWSSEUsernameToken, __construct)
{
	char *sAName;
	int sAName_len;
	zval *oParentElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLWSSEUsernameToken_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sAName, &sAName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLWSSEUsernameToken_Create_1(sAName, (int32_t)sAName_len, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oParentElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLWSSEUsernameToken_Create_2(SBGetObjectHandle(oParentElement TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!s", &oParentElement, TElXMLDOMElement_ce_ptr, &sAName, &sAName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLWSSEUsernameToken_Create_3(SBGetObjectHandle(oParentElement TSRMLS_CC), sAName, (int32_t)sAName_len, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("() or (string) or (TElXMLDOMElement) or (TElXMLDOMElement, string)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLWSSEUsernameToken_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLWSSEUsernameToken_CreateUsername, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLWSSEUsernameToken_CreatePassword, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLWSSEUsernameToken_CreateNonce, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLWSSEUsernameToken_CreateCreated, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLWSSEUsernameToken_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLWSSEUsernameToken_get_Username, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLWSSEUsernameToken_get_Password, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLWSSEUsernameToken_get_Nonce, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLWSSEUsernameToken_get_Created, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLWSSEUsernameToken_get_CreatedUTC, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLWSSEUsernameToken_set_CreatedUTC, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, DateTime, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLWSSEUsernameToken___construct, 0, 0, 0)
	ZEND_ARG_TYPE_INFO(0, AName_or_ParentElement, 0, 1)
	ZEND_ARG_INFO(0, AName)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLWSSEUsernameToken_methods[] = {
	PHP_ME(TElXMLWSSEUsernameToken, Clear, arginfo_TElXMLWSSEUsernameToken_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLWSSEUsernameToken, CreateUsername, arginfo_TElXMLWSSEUsernameToken_CreateUsername, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLWSSEUsernameToken, CreatePassword, arginfo_TElXMLWSSEUsernameToken_CreatePassword, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLWSSEUsernameToken, CreateNonce, arginfo_TElXMLWSSEUsernameToken_CreateNonce, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLWSSEUsernameToken, CreateCreated, arginfo_TElXMLWSSEUsernameToken_CreateCreated, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLWSSEUsernameToken, LoadFromXML, arginfo_TElXMLWSSEUsernameToken_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLWSSEUsernameToken, get_Username, arginfo_TElXMLWSSEUsernameToken_get_Username, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLWSSEUsernameToken, get_Password, arginfo_TElXMLWSSEUsernameToken_get_Password, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLWSSEUsernameToken, get_Nonce, arginfo_TElXMLWSSEUsernameToken_get_Nonce, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLWSSEUsernameToken, get_Created, arginfo_TElXMLWSSEUsernameToken_get_Created, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLWSSEUsernameToken, get_CreatedUTC, arginfo_TElXMLWSSEUsernameToken_get_CreatedUTC, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLWSSEUsernameToken, set_CreatedUTC, arginfo_TElXMLWSSEUsernameToken_set_CreatedUTC, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLWSSEUsernameToken, __construct, arginfo_TElXMLWSSEUsernameToken___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLWSSEUsernameToken(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLWSSEUsernameToken_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLWSSEUsernameToken", TElXMLWSSEUsernameToken_methods);
	if (NULL == TElXMLWSSEBaseToken_ce_ptr)
		Register_TElXMLWSSEBaseToken(TSRMLS_C);
	TElXMLWSSEUsernameToken_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLWSSEBaseToken_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLWSUTimestamp_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLWSUTimestamp, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElXMLWSUTimestamp_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLWSUTimestamp, CreateCreated)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElXMLWSUTimestamp_CreateCreated(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLWSUTimestamp, CreateExpires)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElXMLWSUTimestamp_CreateExpires(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLWSUTimestamp, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLWSUTimestamp_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLWSUTimestamp, get_Created)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLWSUTimestamp_get_Created(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLWSUDateTime_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLWSUTimestamp, get_CreatedUTC)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(TElXMLWSUTimestamp_get_CreatedUTC(SBGetObjectHandle(getThis() TSRMLS_CC), &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLWSUTimestamp, set_CreatedUTC)
{
	zval *dtValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &dtValue, php_date_get_date_ce()) == SUCCESS)
	{
		SBCheckError(TElXMLWSUTimestamp_set_CreatedUTC(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetDateTime(dtValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(DateTime)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLWSUTimestamp, get_Expires)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLWSUTimestamp_get_Expires(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLWSUDateTime_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLWSUTimestamp, get_ExpiresUTC)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(TElXMLWSUTimestamp_get_ExpiresUTC(SBGetObjectHandle(getThis() TSRMLS_CC), &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLWSUTimestamp, set_ExpiresUTC)
{
	zval *dtValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &dtValue, php_date_get_date_ce()) == SUCCESS)
	{
		SBCheckError(TElXMLWSUTimestamp_set_ExpiresUTC(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetDateTime(dtValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(DateTime)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLWSUTimestamp, __construct)
{
	char *sAName;
	int sAName_len;
	zval *oParentElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLWSUTimestamp_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sAName, &sAName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLWSUTimestamp_Create_1(sAName, (int32_t)sAName_len, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oParentElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLWSUTimestamp_Create_2(SBGetObjectHandle(oParentElement TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!s", &oParentElement, TElXMLDOMElement_ce_ptr, &sAName, &sAName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLWSUTimestamp_Create_3(SBGetObjectHandle(oParentElement TSRMLS_CC), sAName, (int32_t)sAName_len, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("() or (string) or (TElXMLDOMElement) or (TElXMLDOMElement, string)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLWSUTimestamp_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLWSUTimestamp_CreateCreated, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLWSUTimestamp_CreateExpires, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLWSUTimestamp_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLWSUTimestamp_get_Created, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLWSUTimestamp_get_CreatedUTC, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLWSUTimestamp_set_CreatedUTC, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, DateTime, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLWSUTimestamp_get_Expires, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLWSUTimestamp_get_ExpiresUTC, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLWSUTimestamp_set_ExpiresUTC, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, DateTime, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLWSUTimestamp___construct, 0, 0, 0)
	ZEND_ARG_TYPE_INFO(0, AName_or_ParentElement, 0, 1)
	ZEND_ARG_INFO(0, AName)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLWSUTimestamp_methods[] = {
	PHP_ME(TElXMLWSUTimestamp, Clear, arginfo_TElXMLWSUTimestamp_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLWSUTimestamp, CreateCreated, arginfo_TElXMLWSUTimestamp_CreateCreated, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLWSUTimestamp, CreateExpires, arginfo_TElXMLWSUTimestamp_CreateExpires, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLWSUTimestamp, LoadFromXML, arginfo_TElXMLWSUTimestamp_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLWSUTimestamp, get_Created, arginfo_TElXMLWSUTimestamp_get_Created, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLWSUTimestamp, get_CreatedUTC, arginfo_TElXMLWSUTimestamp_get_CreatedUTC, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLWSUTimestamp, set_CreatedUTC, arginfo_TElXMLWSUTimestamp_set_CreatedUTC, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLWSUTimestamp, get_Expires, arginfo_TElXMLWSUTimestamp_get_Expires, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLWSUTimestamp, get_ExpiresUTC, arginfo_TElXMLWSUTimestamp_get_ExpiresUTC, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLWSUTimestamp, set_ExpiresUTC, arginfo_TElXMLWSUTimestamp_set_ExpiresUTC, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLWSUTimestamp, __construct, arginfo_TElXMLWSUTimestamp___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLWSUTimestamp(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLWSUTimestamp_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLWSUTimestamp", TElXMLWSUTimestamp_methods);
	if (NULL == TElXMLWSSEBaseToken_ce_ptr)
		Register_TElXMLWSSEBaseToken(TSRMLS_C);
	TElXMLWSUTimestamp_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLWSSEBaseToken_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLWSSEBinarySecurityToken_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLWSSEBinarySecurityToken, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElXMLWSSEBinarySecurityToken_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLWSSEBinarySecurityToken, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLWSSEBinarySecurityToken_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLWSSEBinarySecurityToken, ExtractCertificates)
{
	zval *oCertStorage;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oCertStorage, TElCustomCertStorage_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLWSSEBinarySecurityToken_ExtractCertificates(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oCertStorage TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCertStorage)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLWSSEBinarySecurityToken, SetCertificate)
{
	long fTokenType;
	zval *oCert;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oCert, TElX509Certificate_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLWSSEBinarySecurityToken_SetCertificate(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oCert TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!l", &oCert, TElX509Certificate_ce_ptr, &fTokenType) == SUCCESS)
	{
		SBCheckError(TElXMLWSSEBinarySecurityToken_SetCertificate_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oCert TSRMLS_CC), (TSBXMLWSSETokenTypeRaw)fTokenType) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElX509Certificate) or (TElX509Certificate, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLWSSEBinarySecurityToken, SetCertificates)
{
	long fTokenType;
	zval *oCertStorage;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oCertStorage, TElCustomCertStorage_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLWSSEBinarySecurityToken_SetCertificates(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oCertStorage TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!l", &oCertStorage, TElCustomCertStorage_ce_ptr, &fTokenType) == SUCCESS)
	{
		SBCheckError(TElXMLWSSEBinarySecurityToken_SetCertificates_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oCertStorage TSRMLS_CC), (TSBXMLWSSETokenTypeRaw)fTokenType) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCertStorage) or (TElCustomCertStorage, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLWSSEBinarySecurityToken, get_Data)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLWSSEBinarySecurityToken_get_Data(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1654049237, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLWSSEBinarySecurityToken, set_Data)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElXMLWSSEBinarySecurityToken_set_Data(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLWSSEBinarySecurityToken, get_EncodingType)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLWSSEBinarySecurityToken_get_EncodingType(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(853864442, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLWSSEBinarySecurityToken, set_EncodingType)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElXMLWSSEBinarySecurityToken_set_EncodingType(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLWSSEBinarySecurityToken, get_ValueType)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLWSSEBinarySecurityToken_get_ValueType(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-226321803, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLWSSEBinarySecurityToken, set_ValueType)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElXMLWSSEBinarySecurityToken_set_ValueType(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLWSSEBinarySecurityToken, get_TokenType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBXMLWSSETokenTypeRaw fOutResultRaw = 0;
		SBCheckError(TElXMLWSSEBinarySecurityToken_get_TokenType(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLWSSEBinarySecurityToken, __construct)
{
	char *sAName;
	int sAName_len;
	zval *oParentElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLWSSEBinarySecurityToken_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sAName, &sAName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLWSSEBinarySecurityToken_Create_1(sAName, (int32_t)sAName_len, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oParentElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLWSSEBinarySecurityToken_Create_2(SBGetObjectHandle(oParentElement TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!s", &oParentElement, TElXMLDOMElement_ce_ptr, &sAName, &sAName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLWSSEBinarySecurityToken_Create_3(SBGetObjectHandle(oParentElement TSRMLS_CC), sAName, (int32_t)sAName_len, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("() or (string) or (TElXMLDOMElement) or (TElXMLDOMElement, string)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLWSSEBinarySecurityToken_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLWSSEBinarySecurityToken_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLWSSEBinarySecurityToken_ExtractCertificates, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, CertStorage, TElCustomCertStorage, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLWSSEBinarySecurityToken_SetCertificate, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Cert, TElX509Certificate, 1)
	ZEND_ARG_INFO(0, TokenType)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLWSSEBinarySecurityToken_SetCertificates, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, CertStorage, TElCustomCertStorage, 1)
	ZEND_ARG_INFO(0, TokenType)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLWSSEBinarySecurityToken_get_Data, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLWSSEBinarySecurityToken_set_Data, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLWSSEBinarySecurityToken_get_EncodingType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLWSSEBinarySecurityToken_set_EncodingType, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLWSSEBinarySecurityToken_get_ValueType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLWSSEBinarySecurityToken_set_ValueType, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLWSSEBinarySecurityToken_get_TokenType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLWSSEBinarySecurityToken___construct, 0, 0, 0)
	ZEND_ARG_TYPE_INFO(0, AName_or_ParentElement, 0, 1)
	ZEND_ARG_INFO(0, AName)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLWSSEBinarySecurityToken_methods[] = {
	PHP_ME(TElXMLWSSEBinarySecurityToken, Clear, arginfo_TElXMLWSSEBinarySecurityToken_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLWSSEBinarySecurityToken, LoadFromXML, arginfo_TElXMLWSSEBinarySecurityToken_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLWSSEBinarySecurityToken, ExtractCertificates, arginfo_TElXMLWSSEBinarySecurityToken_ExtractCertificates, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLWSSEBinarySecurityToken, SetCertificate, arginfo_TElXMLWSSEBinarySecurityToken_SetCertificate, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLWSSEBinarySecurityToken, SetCertificates, arginfo_TElXMLWSSEBinarySecurityToken_SetCertificates, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLWSSEBinarySecurityToken, get_Data, arginfo_TElXMLWSSEBinarySecurityToken_get_Data, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLWSSEBinarySecurityToken, set_Data, arginfo_TElXMLWSSEBinarySecurityToken_set_Data, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLWSSEBinarySecurityToken, get_EncodingType, arginfo_TElXMLWSSEBinarySecurityToken_get_EncodingType, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLWSSEBinarySecurityToken, set_EncodingType, arginfo_TElXMLWSSEBinarySecurityToken_set_EncodingType, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLWSSEBinarySecurityToken, get_ValueType, arginfo_TElXMLWSSEBinarySecurityToken_get_ValueType, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLWSSEBinarySecurityToken, set_ValueType, arginfo_TElXMLWSSEBinarySecurityToken_set_ValueType, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLWSSEBinarySecurityToken, get_TokenType, arginfo_TElXMLWSSEBinarySecurityToken_get_TokenType, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLWSSEBinarySecurityToken, __construct, arginfo_TElXMLWSSEBinarySecurityToken___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLWSSEBinarySecurityToken(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLWSSEBinarySecurityToken_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLWSSEBinarySecurityToken", TElXMLWSSEBinarySecurityToken_methods);
	if (NULL == TElXMLWSSEBaseToken_ce_ptr)
		Register_TElXMLWSSEBaseToken(TSRMLS_C);
	TElXMLWSSEBinarySecurityToken_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLWSSEBaseToken_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLWSSESecurity_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLWSSESecurity, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElXMLWSSESecurity_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLWSSESecurity, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLWSSESecurity_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLWSSESecurity, LoadFromHeaderBlock)
{
	zval *oAHeaderBlock;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAHeaderBlock, TElXMLSOAPHeaderBlock_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLWSSESecurity_LoadFromHeaderBlock(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oAHeaderBlock TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLSOAPHeaderBlock)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLWSSESecurity, AddToken)
{
	zval *oAToken;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAToken, TElXMLWSSEBaseToken_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXMLWSSESecurity_AddToken(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oAToken TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLWSSEBaseToken)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLWSSESecurity, get_HeaderBlock)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLWSSESecurity_get_HeaderBlock(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLSOAPHeaderBlock_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLWSSESecurity, set_HeaderBlock)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElXMLSOAPHeaderBlock_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLWSSESecurity_set_HeaderBlock(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLSOAPHeaderBlock)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLWSSESecurity, get_TokenCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXMLWSSESecurity_get_TokenCount(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLWSSESecurity, get_Tokens)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLWSSESecurity_get_Tokens(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLWSSEBaseToken_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLWSSESecurity, __construct)
{
	char *sAName;
	int sAName_len;
	zval *oParentElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLWSSESecurity_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sAName, &sAName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLWSSESecurity_Create_1(sAName, (int32_t)sAName_len, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oParentElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLWSSESecurity_Create_2(SBGetObjectHandle(oParentElement TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!s", &oParentElement, TElXMLDOMElement_ce_ptr, &sAName, &sAName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLWSSESecurity_Create_3(SBGetObjectHandle(oParentElement TSRMLS_CC), sAName, (int32_t)sAName_len, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("() or (string) or (TElXMLDOMElement) or (TElXMLDOMElement, string)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLWSSESecurity_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLWSSESecurity_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLWSSESecurity_LoadFromHeaderBlock, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AHeaderBlock, TElXMLSOAPHeaderBlock, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLWSSESecurity_AddToken, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AToken, TElXMLWSSEBaseToken, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLWSSESecurity_get_HeaderBlock, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLWSSESecurity_set_HeaderBlock, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElXMLSOAPHeaderBlock, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLWSSESecurity_get_TokenCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLWSSESecurity_get_Tokens, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLWSSESecurity___construct, 0, 0, 0)
	ZEND_ARG_TYPE_INFO(0, AName_or_ParentElement, 0, 1)
	ZEND_ARG_INFO(0, AName)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLWSSESecurity_methods[] = {
	PHP_ME(TElXMLWSSESecurity, Clear, arginfo_TElXMLWSSESecurity_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLWSSESecurity, LoadFromXML, arginfo_TElXMLWSSESecurity_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLWSSESecurity, LoadFromHeaderBlock, arginfo_TElXMLWSSESecurity_LoadFromHeaderBlock, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLWSSESecurity, AddToken, arginfo_TElXMLWSSESecurity_AddToken, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLWSSESecurity, get_HeaderBlock, arginfo_TElXMLWSSESecurity_get_HeaderBlock, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLWSSESecurity, set_HeaderBlock, arginfo_TElXMLWSSESecurity_set_HeaderBlock, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLWSSESecurity, get_TokenCount, arginfo_TElXMLWSSESecurity_get_TokenCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLWSSESecurity, get_Tokens, arginfo_TElXMLWSSESecurity_get_Tokens, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLWSSESecurity, __construct, arginfo_TElXMLWSSESecurity___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLWSSESecurity(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLWSSESecurity_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLWSSESecurity", TElXMLWSSESecurity_methods);
	if (NULL == TElXMLWSSEElement_ce_ptr)
		Register_TElXMLWSSEElement(TSRMLS_C);
	TElXMLWSSESecurity_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLWSSEElement_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLWSSEReference_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLWSSEReference, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElXMLWSSEReference_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLWSSEReference, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLWSSEReference_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLWSSEReference, SaveToXML)
{
	zval *oDocument;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oDocument, TElXMLDOMDocument_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLWSSEReference_SaveToXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDocument, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLWSSEReference_SaveToXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument, TElXMLCustomFormatter) or (TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLWSSEReference, get_URI)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLWSSEReference_get_URI(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-628906287, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLWSSEReference, set_URI)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElXMLWSSEReference_set_URI(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLWSSEReference, get_ValueType)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLWSSEReference_get_ValueType(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-249024085, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLWSSEReference, set_ValueType)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElXMLWSSEReference_set_ValueType(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLWSSEReference, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLWSSEReference_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLWSSEReference_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLWSSEReference_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLWSSEReference_SaveToXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLWSSEReference_get_URI, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLWSSEReference_set_URI, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLWSSEReference_get_ValueType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLWSSEReference_set_ValueType, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLWSSEReference___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLWSSEReference_methods[] = {
	PHP_ME(TElXMLWSSEReference, Clear, arginfo_TElXMLWSSEReference_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLWSSEReference, LoadFromXML, arginfo_TElXMLWSSEReference_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLWSSEReference, SaveToXML, arginfo_TElXMLWSSEReference_SaveToXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLWSSEReference, get_URI, arginfo_TElXMLWSSEReference_get_URI, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLWSSEReference, set_URI, arginfo_TElXMLWSSEReference_set_URI, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLWSSEReference, get_ValueType, arginfo_TElXMLWSSEReference_get_ValueType, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLWSSEReference, set_ValueType, arginfo_TElXMLWSSEReference_set_ValueType, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLWSSEReference, __construct, arginfo_TElXMLWSSEReference___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLWSSEReference(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLWSSEReference_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLWSSEReference", TElXMLWSSEReference_methods);
	if (NULL == TElXMLCustomElement_ce_ptr)
		Register_TElXMLCustomElement(TSRMLS_C);
	TElXMLWSSEReference_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLCustomElement_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLWSSEKeyIdentifier_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLWSSEKeyIdentifier, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElXMLWSSEKeyIdentifier_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLWSSEKeyIdentifier, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLWSSEKeyIdentifier_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLWSSEKeyIdentifier, SaveToXML)
{
	zval *oDocument;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oDocument, TElXMLDOMDocument_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLWSSEKeyIdentifier_SaveToXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDocument, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLWSSEKeyIdentifier_SaveToXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument, TElXMLCustomFormatter) or (TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLWSSEKeyIdentifier, get_Data)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElXMLWSSEKeyIdentifier_get_Data(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-1400374638, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLWSSEKeyIdentifier, set_Data)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElXMLWSSEKeyIdentifier_set_Data(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLWSSEKeyIdentifier, get_ID)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLWSSEKeyIdentifier_get_ID(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1822939042, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLWSSEKeyIdentifier, set_ID)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElXMLWSSEKeyIdentifier_set_ID(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLWSSEKeyIdentifier, get_ValueType)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLWSSEKeyIdentifier_get_ValueType(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1225827402, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLWSSEKeyIdentifier, set_ValueType)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElXMLWSSEKeyIdentifier_set_ValueType(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLWSSEKeyIdentifier, get_EncodingType)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLWSSEKeyIdentifier_get_EncodingType(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1089420365, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLWSSEKeyIdentifier, set_EncodingType)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElXMLWSSEKeyIdentifier_set_EncodingType(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLWSSEKeyIdentifier, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLWSSEKeyIdentifier_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLWSSEKeyIdentifier_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLWSSEKeyIdentifier_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLWSSEKeyIdentifier_SaveToXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLWSSEKeyIdentifier_get_Data, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLWSSEKeyIdentifier_set_Data, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLWSSEKeyIdentifier_get_ID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLWSSEKeyIdentifier_set_ID, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLWSSEKeyIdentifier_get_ValueType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLWSSEKeyIdentifier_set_ValueType, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLWSSEKeyIdentifier_get_EncodingType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLWSSEKeyIdentifier_set_EncodingType, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLWSSEKeyIdentifier___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLWSSEKeyIdentifier_methods[] = {
	PHP_ME(TElXMLWSSEKeyIdentifier, Clear, arginfo_TElXMLWSSEKeyIdentifier_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLWSSEKeyIdentifier, LoadFromXML, arginfo_TElXMLWSSEKeyIdentifier_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLWSSEKeyIdentifier, SaveToXML, arginfo_TElXMLWSSEKeyIdentifier_SaveToXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLWSSEKeyIdentifier, get_Data, arginfo_TElXMLWSSEKeyIdentifier_get_Data, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLWSSEKeyIdentifier, set_Data, arginfo_TElXMLWSSEKeyIdentifier_set_Data, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLWSSEKeyIdentifier, get_ID, arginfo_TElXMLWSSEKeyIdentifier_get_ID, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLWSSEKeyIdentifier, set_ID, arginfo_TElXMLWSSEKeyIdentifier_set_ID, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLWSSEKeyIdentifier, get_ValueType, arginfo_TElXMLWSSEKeyIdentifier_get_ValueType, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLWSSEKeyIdentifier, set_ValueType, arginfo_TElXMLWSSEKeyIdentifier_set_ValueType, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLWSSEKeyIdentifier, get_EncodingType, arginfo_TElXMLWSSEKeyIdentifier_get_EncodingType, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLWSSEKeyIdentifier, set_EncodingType, arginfo_TElXMLWSSEKeyIdentifier_set_EncodingType, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLWSSEKeyIdentifier, __construct, arginfo_TElXMLWSSEKeyIdentifier___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLWSSEKeyIdentifier(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLWSSEKeyIdentifier_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLWSSEKeyIdentifier", TElXMLWSSEKeyIdentifier_methods);
	if (NULL == TElXMLCustomElement_ce_ptr)
		Register_TElXMLCustomElement(TSRMLS_C);
	TElXMLWSSEKeyIdentifier_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLCustomElement_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLWSSESecurityTokenReference_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLWSSESecurityTokenReference, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElXMLWSSESecurityTokenReference_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLWSSESecurityTokenReference, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMNode_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLWSSESecurityTokenReference_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMNode)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLWSSESecurityTokenReference, SaveToXML)
{
	zval *oDocument;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oDocument, TElXMLDOMDocument_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLWSSESecurityTokenReference_SaveToXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMNode_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument, TElXMLCustomFormatter)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLWSSESecurityTokenReference, get_ID)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLWSSESecurityTokenReference_get_ID(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1505650505, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLWSSESecurityTokenReference, set_ID)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElXMLWSSESecurityTokenReference_set_ID(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLWSSESecurityTokenReference, get_TokenType)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLWSSESecurityTokenReference_get_TokenType(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(449143255, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLWSSESecurityTokenReference, set_TokenType)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElXMLWSSESecurityTokenReference_set_TokenType(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLWSSESecurityTokenReference, get_Usage)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLWSSESecurityTokenReference_get_Usage(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-288364004, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLWSSESecurityTokenReference, set_Usage)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElXMLWSSESecurityTokenReference_set_Usage(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLWSSESecurityTokenReference, get_ReferenceType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElXMLWSSESecurityTokenReferenceTypeRaw fOutResultRaw = 0;
		SBCheckError(TElXMLWSSESecurityTokenReference_get_ReferenceType(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLWSSESecurityTokenReference, set_ReferenceType)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElXMLWSSESecurityTokenReference_set_ReferenceType(SBGetObjectHandle(getThis() TSRMLS_CC), (TElXMLWSSESecurityTokenReferenceTypeRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLWSSESecurityTokenReference, get_Reference)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLWSSESecurityTokenReference_get_Reference(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLWSSEReference_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLWSSESecurityTokenReference, get_KeyIdentifier)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLWSSESecurityTokenReference_get_KeyIdentifier(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLWSSEKeyIdentifier_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLWSSESecurityTokenReference, get_EmbeddedNode)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLWSSESecurityTokenReference_get_EmbeddedNode(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMNode_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLWSSESecurityTokenReference, set_EmbeddedNode)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElXMLDOMNode_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLWSSESecurityTokenReference_set_EmbeddedNode(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMNode)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLWSSESecurityTokenReference, __construct)
{
	zend_bool bAOwnResources;
	zend_bool bOwnResources;
	zval *oManager;
	zval *oProv;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bOwnResources) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLWSSESecurityTokenReference_Create((int8_t)bOwnResources, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "bO!O!", &bAOwnResources, &oManager, TElCustomCryptoProviderManager_ce_ptr, &oProv, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLWSSESecurityTokenReference_Create_1((int8_t)bAOwnResources, SBGetObjectHandle(oManager TSRMLS_CC), SBGetObjectHandle(oProv TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool) or (bool, TElCustomCryptoProviderManager, TElCustomCryptoProvider)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLWSSESecurityTokenReference_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLWSSESecurityTokenReference_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMNode, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLWSSESecurityTokenReference_SaveToXML, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLWSSESecurityTokenReference_get_ID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLWSSESecurityTokenReference_set_ID, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLWSSESecurityTokenReference_get_TokenType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLWSSESecurityTokenReference_set_TokenType, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLWSSESecurityTokenReference_get_Usage, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLWSSESecurityTokenReference_set_Usage, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLWSSESecurityTokenReference_get_ReferenceType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLWSSESecurityTokenReference_set_ReferenceType, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLWSSESecurityTokenReference_get_Reference, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLWSSESecurityTokenReference_get_KeyIdentifier, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLWSSESecurityTokenReference_get_EmbeddedNode, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLWSSESecurityTokenReference_set_EmbeddedNode, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElXMLDOMNode, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLWSSESecurityTokenReference___construct, 0, 0, 1)
	ZEND_ARG_INFO(0, OwnResources_or_AOwnResources)
	ZEND_ARG_OBJ_INFO(0, Manager, TElCustomCryptoProviderManager, 1)
	ZEND_ARG_OBJ_INFO(0, Prov, TElCustomCryptoProvider, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLWSSESecurityTokenReference_methods[] = {
	PHP_ME(TElXMLWSSESecurityTokenReference, Clear, arginfo_TElXMLWSSESecurityTokenReference_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLWSSESecurityTokenReference, LoadFromXML, arginfo_TElXMLWSSESecurityTokenReference_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLWSSESecurityTokenReference, SaveToXML, arginfo_TElXMLWSSESecurityTokenReference_SaveToXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLWSSESecurityTokenReference, get_ID, arginfo_TElXMLWSSESecurityTokenReference_get_ID, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLWSSESecurityTokenReference, set_ID, arginfo_TElXMLWSSESecurityTokenReference_set_ID, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLWSSESecurityTokenReference, get_TokenType, arginfo_TElXMLWSSESecurityTokenReference_get_TokenType, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLWSSESecurityTokenReference, set_TokenType, arginfo_TElXMLWSSESecurityTokenReference_set_TokenType, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLWSSESecurityTokenReference, get_Usage, arginfo_TElXMLWSSESecurityTokenReference_get_Usage, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLWSSESecurityTokenReference, set_Usage, arginfo_TElXMLWSSESecurityTokenReference_set_Usage, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLWSSESecurityTokenReference, get_ReferenceType, arginfo_TElXMLWSSESecurityTokenReference_get_ReferenceType, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLWSSESecurityTokenReference, set_ReferenceType, arginfo_TElXMLWSSESecurityTokenReference_set_ReferenceType, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLWSSESecurityTokenReference, get_Reference, arginfo_TElXMLWSSESecurityTokenReference_get_Reference, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLWSSESecurityTokenReference, get_KeyIdentifier, arginfo_TElXMLWSSESecurityTokenReference_get_KeyIdentifier, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLWSSESecurityTokenReference, get_EmbeddedNode, arginfo_TElXMLWSSESecurityTokenReference_get_EmbeddedNode, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLWSSESecurityTokenReference, set_EmbeddedNode, arginfo_TElXMLWSSESecurityTokenReference_set_EmbeddedNode, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLWSSESecurityTokenReference, __construct, arginfo_TElXMLWSSESecurityTokenReference___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLWSSESecurityTokenReference(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLWSSESecurityTokenReference_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLWSSESecurityTokenReference", TElXMLWSSESecurityTokenReference_methods);
	if (NULL == TElXMLKeyInfoData_ce_ptr)
		Register_TElXMLKeyInfoData(TSRMLS_C);
	TElXMLWSSESecurityTokenReference_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLKeyInfoData_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_FUNCTION(SBXMLWSSCore, WSUGetElementId)
{
	uint32_t _err;
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBXMLWSSCore_WSUGetElementId(SBGetObjectHandle(oElement TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(2080141626, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBXMLWSSCore, WSUSetElementId)
{
	char *sValue;
	int sValue_len;
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!s", &oElement, TElXMLDOMElement_ce_ptr, &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(SBXMLWSSCore_WSUSetElementId(SBGetObjectHandle(oElement TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement, string)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBXMLWSSCore, WSSETokenTypeToURI)
{
	long fTokenType;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fTokenType) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBXMLWSSCore_WSSETokenTypeToURI((TSBXMLWSSETokenTypeRaw)fTokenType, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1189291544, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

void Register_SBXMLWSSCore_Enum_Flags(TSRMLS_D)
{
	zend_class_entry ce;
	INIT_CLASS_ENTRY(ce, "TElXMLWSSESecurityTokenReferenceType", NULL);
	TElXMLWSSESecurityTokenReferenceType_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TElXMLWSSESecurityTokenReferenceType_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TElXMLWSSESecurityTokenReferenceType_ce_ptr, "wsrtNone", 0)
	SB_DECLARE_CLASS_LONG_CONST(TElXMLWSSESecurityTokenReferenceType_ce_ptr, "wsrtReference", 1)
	SB_DECLARE_CLASS_LONG_CONST(TElXMLWSSESecurityTokenReferenceType_ce_ptr, "wsrtKeyIdentifier", 2)
	SB_DECLARE_CLASS_LONG_CONST(TElXMLWSSESecurityTokenReferenceType_ce_ptr, "wsrtEmbeddedReference", 3)
	
	INIT_CLASS_ENTRY(ce, "TSBXMLWSSETokenType", NULL);
	TSBXMLWSSETokenType_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBXMLWSSETokenType_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBXMLWSSETokenType_ce_ptr, "wttX509v3", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBXMLWSSETokenType_ce_ptr, "wttPKCS7", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBXMLWSSETokenType_ce_ptr, "wttX509PKIPathv1", 2)
	SB_DECLARE_CLASS_LONG_CONST(TSBXMLWSSETokenType_ce_ptr, "wttUnknown", 3)
}

