#include "sbziputils.h"

SB_PHP_METHOD(TSBZIPEncryptionContext, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(TSBZIPEncryptionContext));
		intern->len = sizeof(TSBZIPEncryptionContext);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(TSBZIPEncryptionContext, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(TSBZIPEncryptionContext));
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBBaseStruct_GetField, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBBaseStruct_SetField, 0, 0, 1)
	ZEND_ARG_INFO(0, value)
ZEND_END_ARG_INFO()

SB_PHP_METHOD(TSBZIPEncryptionContext, get_K0)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(TSBZIPEncryptionContext, set_K0)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(TSBZIPEncryptionContext, get_K1)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 4);
}

SB_PHP_METHOD(TSBZIPEncryptionContext, set_K1)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 4);
}

SB_PHP_METHOD(TSBZIPEncryptionContext, get_K2)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 8);
}

SB_PHP_METHOD(TSBZIPEncryptionContext, set_K2)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 8);
}

zend_class_entry *TSBZIPEncryptionContext_ce_ptr = NULL;

static zend_function_entry TSBZIPEncryptionContext_methods[] = {
	PHP_ME(TSBZIPEncryptionContext, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(TSBZIPEncryptionContext, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TSBZIPEncryptionContext, get_K0, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSBZIPEncryptionContext, set_K0, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSBZIPEncryptionContext, get_K1, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSBZIPEncryptionContext, set_K1, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSBZIPEncryptionContext, get_K2, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSBZIPEncryptionContext, set_K2, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TSBZIPEncryptionContext(TSRMLS_D)
{
	zend_class_entry ce;
	if (TSBZIPEncryptionContext_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "TSBZIPEncryptionContext", TSBZIPEncryptionContext_methods);
	TSBZIPEncryptionContext_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_FUNCTION(SBZipUtils, BufferToUINT16)
{
	long l4Index;
	SBArrayZValInfo aiBuffer;
	zval *zaBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zaBuffer, &l4Index) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaBuffer)) || (IS_ARRAY == Z_TYPE_P(zaBuffer)) || (IS_NULL == Z_TYPE_P(zaBuffer))))
	{
		uint32_t u4OutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaBuffer, &aiBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBZipUtils_BufferToUINT16(aiBuffer.data, aiBuffer.len, (int32_t)l4Index, &u4OutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiBuffer);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBZipUtils, UINT16ToBuffer)
{
	long l4Index;
	long u4Value;
	SBArrayZValInfo aiBuffer;
	uint32_t _err;
	zval *zaBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zll", &zaBuffer, &l4Index, &u4Value) == SUCCESS) && PZVAL_IS_REF(zaBuffer) && ((IS_STRING == Z_TYPE_P(zaBuffer)) || (IS_ARRAY == Z_TYPE_P(zaBuffer))))
	{
		if (!SBGetByteArrayFromZVal(zaBuffer, &aiBuffer TSRMLS_CC)) RETURN_FALSE;
		_err = SBZipUtils_UINT16ToBuffer(aiBuffer.data, &aiBuffer.len, (int32_t)l4Index, (uint32_t)u4Value);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			SBDetachDataFromZValAndResize(zaBuffer, &aiBuffer TSRMLS_CC);
			SBCheckError(SBGetLastReturnBuffer(-502955716, 0, aiBuffer.data, &aiBuffer.len) TSRMLS_CC);
			((char *)aiBuffer.data)[aiBuffer.len] = 0;
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBFreeArrayZValInfo(&aiBuffer);
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBSetByteArrayToZVal(&aiBuffer, zaBuffer);
	}
	else
	{
		SBErrorExpectsArguments("(&array of byte|string, integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBZipUtils, BufferToUINT32)
{
	long l4Index;
	SBArrayZValInfo aiBuffer;
	zval *zaBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zaBuffer, &l4Index) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaBuffer)) || (IS_ARRAY == Z_TYPE_P(zaBuffer)) || (IS_NULL == Z_TYPE_P(zaBuffer))))
	{
		uint32_t u4OutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaBuffer, &aiBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBZipUtils_BufferToUINT32(aiBuffer.data, aiBuffer.len, (int32_t)l4Index, &u4OutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiBuffer);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBZipUtils, UINT32ToBuffer)
{
	long l4Index;
	long u4Value;
	SBArrayZValInfo aiBuffer;
	uint32_t _err;
	zval *zaBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zll", &zaBuffer, &l4Index, &u4Value) == SUCCESS) && PZVAL_IS_REF(zaBuffer) && ((IS_STRING == Z_TYPE_P(zaBuffer)) || (IS_ARRAY == Z_TYPE_P(zaBuffer))))
	{
		if (!SBGetByteArrayFromZVal(zaBuffer, &aiBuffer TSRMLS_CC)) RETURN_FALSE;
		_err = SBZipUtils_UINT32ToBuffer(aiBuffer.data, &aiBuffer.len, (int32_t)l4Index, (uint32_t)u4Value);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			SBDetachDataFromZValAndResize(zaBuffer, &aiBuffer TSRMLS_CC);
			SBCheckError(SBGetLastReturnBuffer(12906964, 0, aiBuffer.data, &aiBuffer.len) TSRMLS_CC);
			((char *)aiBuffer.data)[aiBuffer.len] = 0;
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBFreeArrayZValInfo(&aiBuffer);
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBSetByteArrayToZVal(&aiBuffer, zaBuffer);
	}
	else
	{
		SBErrorExpectsArguments("(&array of byte|string, integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBZipUtils, BufferToUINT64)
{
	long l4Index;
	SBArrayZValInfo aiBuffer;
	zval *zaBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zaBuffer, &l4Index) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaBuffer)) || (IS_ARRAY == Z_TYPE_P(zaBuffer)) || (IS_NULL == Z_TYPE_P(zaBuffer))))
	{
		int64_t l8OutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaBuffer, &aiBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBZipUtils_BufferToUINT64(aiBuffer.data, aiBuffer.len, (int32_t)l4Index, &l8OutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiBuffer);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBZipUtils, UINT64ToBuffer)
{
	long l4Index;
	long l8Value;
	SBArrayZValInfo aiBuffer;
	uint32_t _err;
	zval *zaBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zll", &zaBuffer, &l4Index, &l8Value) == SUCCESS) && PZVAL_IS_REF(zaBuffer) && ((IS_STRING == Z_TYPE_P(zaBuffer)) || (IS_ARRAY == Z_TYPE_P(zaBuffer))))
	{
		if (!SBGetByteArrayFromZVal(zaBuffer, &aiBuffer TSRMLS_CC)) RETURN_FALSE;
		_err = SBZipUtils_UINT64ToBuffer(aiBuffer.data, &aiBuffer.len, (int32_t)l4Index, (int64_t)l8Value);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			SBDetachDataFromZValAndResize(zaBuffer, &aiBuffer TSRMLS_CC);
			SBCheckError(SBGetLastReturnBuffer(-118474735, 0, aiBuffer.data, &aiBuffer.len) TSRMLS_CC);
			((char *)aiBuffer.data)[aiBuffer.len] = 0;
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBFreeArrayZValInfo(&aiBuffer);
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBSetByteArrayToZVal(&aiBuffer, zaBuffer);
	}
	else
	{
		SBErrorExpectsArguments("(&array of byte|string, integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBZipUtils, ReverseBuffer)
{
	SBArrayZValInfo aiBuffer;
	uint32_t _err;
	zval *zaBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaBuffer) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaBuffer)) || (IS_ARRAY == Z_TYPE_P(zaBuffer)) || (IS_NULL == Z_TYPE_P(zaBuffer))))
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		if (!SBGetByteArrayFromZVal(zaBuffer, &aiBuffer TSRMLS_CC)) RETURN_FALSE;
		_err = SBZipUtils_ReverseBuffer(aiBuffer.data, aiBuffer.len, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-108175947, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiBuffer);
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBZipUtils, ZipInitializeEncryption)
{
	zval *oContext;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &oContext, TSBZIPEncryptionContext_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oContext))
	{
		SBCheckError(SBZipUtils_ZipInitializeEncryption((TSBZIPEncryptionContext *)SBGetStructPointer(oContext TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(&TSBZIPEncryptionContext)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBZipUtils, ZipUpdateKeys)
{
	long l4Index;
	long l4Size;
	SBArrayZValInfo aiBuffer;
	zval *oContext;
	zval *zaBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "Ozll", &oContext, TSBZIPEncryptionContext_ce_ptr, &zaBuffer, &l4Index, &l4Size) == SUCCESS) && PZVAL_IS_REF(oContext) && ((IS_STRING == Z_TYPE_P(zaBuffer)) || (IS_ARRAY == Z_TYPE_P(zaBuffer)) || (IS_NULL == Z_TYPE_P(zaBuffer))))
	{
		if (!SBGetByteArrayFromZVal(zaBuffer, &aiBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBZipUtils_ZipUpdateKeys((TSBZIPEncryptionContext *)SBGetStructPointer(oContext TSRMLS_CC), aiBuffer.data, aiBuffer.len, (int32_t)l4Index, (int32_t)l4Size) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiBuffer);
	}
	else
	{
		SBErrorExpectsArguments("(&TSBZIPEncryptionContext, array of byte|string|NULL, integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBZipUtils, ZipEncrypt)
{
	long l4Index;
	long l4OutIndex;
	long l4Size;
	SBArrayZValInfo aiBuffer;
	SBArrayZValInfo aiOutBuffer;
	uint32_t _err;
	zval *oContext;
	zval *zaBuffer;
	zval *zaOutBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "Ozllzl", &oContext, TSBZIPEncryptionContext_ce_ptr, &zaBuffer, &l4Index, &l4Size, &zaOutBuffer, &l4OutIndex) == SUCCESS) && PZVAL_IS_REF(oContext) && ((IS_STRING == Z_TYPE_P(zaBuffer)) || (IS_ARRAY == Z_TYPE_P(zaBuffer)) || (IS_NULL == Z_TYPE_P(zaBuffer))) && PZVAL_IS_REF(zaOutBuffer) && ((IS_STRING == Z_TYPE_P(zaOutBuffer)) || (IS_ARRAY == Z_TYPE_P(zaOutBuffer))))
	{
		if (!SBGetByteArrayFromZVal(zaBuffer, &aiBuffer TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaOutBuffer, &aiOutBuffer TSRMLS_CC)) RETURN_FALSE;
		_err = SBZipUtils_ZipEncrypt((TSBZIPEncryptionContext *)SBGetStructPointer(oContext TSRMLS_CC), aiBuffer.data, aiBuffer.len, (int32_t)l4Index, (int32_t)l4Size, aiOutBuffer.data, &aiOutBuffer.len, (int32_t)l4OutIndex);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			SBDetachDataFromZValAndResize(zaOutBuffer, &aiOutBuffer TSRMLS_CC);
			SBCheckError(SBGetLastReturnBuffer(1326814311, 4, aiOutBuffer.data, &aiOutBuffer.len) TSRMLS_CC);
			((char *)aiOutBuffer.data)[aiOutBuffer.len] = 0;
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBFreeArrayZValInfo(&aiOutBuffer);
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiBuffer);
		SBSetByteArrayToZVal(&aiOutBuffer, zaOutBuffer);
	}
	else
	{
		SBErrorExpectsArguments("(&TSBZIPEncryptionContext, array of byte|string|NULL, integer, integer, &array of byte|string, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBZipUtils, ZipDecrypt)
{
	long l4Index;
	long l4OutIndex;
	long l4Size;
	SBArrayZValInfo aiBuffer;
	SBArrayZValInfo aiOutBuffer;
	uint32_t _err;
	zval *oContext;
	zval *zaBuffer;
	zval *zaOutBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "Ozllzl", &oContext, TSBZIPEncryptionContext_ce_ptr, &zaBuffer, &l4Index, &l4Size, &zaOutBuffer, &l4OutIndex) == SUCCESS) && PZVAL_IS_REF(oContext) && ((IS_STRING == Z_TYPE_P(zaBuffer)) || (IS_ARRAY == Z_TYPE_P(zaBuffer)) || (IS_NULL == Z_TYPE_P(zaBuffer))) && PZVAL_IS_REF(zaOutBuffer) && ((IS_STRING == Z_TYPE_P(zaOutBuffer)) || (IS_ARRAY == Z_TYPE_P(zaOutBuffer))))
	{
		if (!SBGetByteArrayFromZVal(zaBuffer, &aiBuffer TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaOutBuffer, &aiOutBuffer TSRMLS_CC)) RETURN_FALSE;
		_err = SBZipUtils_ZipDecrypt((TSBZIPEncryptionContext *)SBGetStructPointer(oContext TSRMLS_CC), aiBuffer.data, aiBuffer.len, (int32_t)l4Index, (int32_t)l4Size, aiOutBuffer.data, &aiOutBuffer.len, (int32_t)l4OutIndex);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			SBDetachDataFromZValAndResize(zaOutBuffer, &aiOutBuffer TSRMLS_CC);
			SBCheckError(SBGetLastReturnBuffer(374433162, 4, aiOutBuffer.data, &aiOutBuffer.len) TSRMLS_CC);
			((char *)aiOutBuffer.data)[aiOutBuffer.len] = 0;
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBFreeArrayZValInfo(&aiOutBuffer);
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiBuffer);
		SBSetByteArrayToZVal(&aiOutBuffer, zaOutBuffer);
	}
	else
	{
		SBErrorExpectsArguments("(&TSBZIPEncryptionContext, array of byte|string|NULL, integer, integer, &array of byte|string, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBZipUtils, ZipHashAlgorithmToSBB)
{
	long l4Algorithm;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Algorithm) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(SBZipUtils_ZipHashAlgorithmToSBB((int32_t)l4Algorithm, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBZipUtils, SBBHashAlgorithmToZip)
{
	long l4Algorithm;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Algorithm) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(SBZipUtils_SBBHashAlgorithmToZip((int32_t)l4Algorithm, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBZipUtils, ZipSymmetricAlgorithmToSBB)
{
	long l4Algorithm;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Algorithm) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(SBZipUtils_ZipSymmetricAlgorithmToSBB((int32_t)l4Algorithm, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBZipUtils, ZipCipherDefaultKeySize)
{
	long l4Algorithm;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Algorithm) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(SBZipUtils_ZipCipherDefaultKeySize((int32_t)l4Algorithm, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBZipUtils, ZipCipherIVSize)
{
	long l4Algorithm;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Algorithm) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(SBZipUtils_ZipCipherIVSize((int32_t)l4Algorithm, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBZipUtils, ZipCompressionMethodName)
{
	long u4CompressionMethod;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u4CompressionMethod) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBZipUtils_ZipCompressionMethodName((uint32_t)u4CompressionMethod, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(503592161, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBZipUtils, ZipEncryptionAlgorithmName)
{
	long u4EncryptionAlgorithm;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u4EncryptionAlgorithm) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBZipUtils_ZipEncryptionAlgorithmName((uint32_t)u4EncryptionAlgorithm, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1432719622, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBZipUtils, ZipVersionStr)
{
	long u4Version;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u4Version) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBZipUtils_ZipVersionStr((uint32_t)u4Version, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1411239658, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBZipUtils, OEMEncodingName)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBZipUtils_OEMEncodingName(sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1478486678, 0, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBZipUtils, ANSIEncodingName)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBZipUtils_ANSIEncodingName(sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-184804594, 0, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBZipUtils, CopyStreamPart)
{
	long l8DestPosition;
	long l8Size;
	long l8SourcePosition;
	zval *oDest;
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!lO!ll", &oSource, TStream_ce_ptr, &l8SourcePosition, &oDest, TStream_ce_ptr, &l8DestPosition, &l8Size) == SUCCESS)
	{
		SBCheckError(SBZipUtils_CopyStreamPart(SBGetObjectHandle(oSource TSRMLS_CC), (int64_t)l8SourcePosition, SBGetObjectHandle(oDest TSRMLS_CC), (int64_t)l8DestPosition, (int64_t)l8Size) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream, integer, TStream, integer, integer)" TSRMLS_CC);
	}
}

void Register_SBZipUtils_Constants(int module_number TSRMLS_DC)
{
	SB_REGISTER_LONG_CONSTANT(SBZipUtils, ZIP_COMPRESSION_STORED, SB_ZIP_COMPRESSION_STORED, SB_ZIP_COMPRESSION_STORED);
	SB_REGISTER_LONG_CONSTANT(SBZipUtils, ZIP_COMPRESSION_SHRUNK, SB_ZIP_COMPRESSION_SHRUNK, SB_ZIP_COMPRESSION_SHRUNK);
	SB_REGISTER_LONG_CONSTANT(SBZipUtils, ZIP_COMPRESSION_REDUCE_1, SB_ZIP_COMPRESSION_REDUCE_1, SB_ZIP_COMPRESSION_REDUCE_1);
	SB_REGISTER_LONG_CONSTANT(SBZipUtils, ZIP_COMPRESSION_REDUCE_2, SB_ZIP_COMPRESSION_REDUCE_2, SB_ZIP_COMPRESSION_REDUCE_2);
	SB_REGISTER_LONG_CONSTANT(SBZipUtils, ZIP_COMPRESSION_REDUCE_3, SB_ZIP_COMPRESSION_REDUCE_3, SB_ZIP_COMPRESSION_REDUCE_3);
	SB_REGISTER_LONG_CONSTANT(SBZipUtils, ZIP_COMPRESSION_REDUCE_4, SB_ZIP_COMPRESSION_REDUCE_4, SB_ZIP_COMPRESSION_REDUCE_4);
	SB_REGISTER_LONG_CONSTANT(SBZipUtils, ZIP_COMPRESSION_IMPLODE, SB_ZIP_COMPRESSION_IMPLODE, SB_ZIP_COMPRESSION_IMPLODE);
	SB_REGISTER_LONG_CONSTANT(SBZipUtils, ZIP_COMPRESSION_TOKENIZING, SB_ZIP_COMPRESSION_TOKENIZING, SB_ZIP_COMPRESSION_TOKENIZING);
	SB_REGISTER_LONG_CONSTANT(SBZipUtils, ZIP_COMPRESSION_DEFLATE, SB_ZIP_COMPRESSION_DEFLATE, SB_ZIP_COMPRESSION_DEFLATE);
	SB_REGISTER_LONG_CONSTANT(SBZipUtils, ZIP_COMPRESSION_DEFLATE64, SB_ZIP_COMPRESSION_DEFLATE64, SB_ZIP_COMPRESSION_DEFLATE64);
	SB_REGISTER_LONG_CONSTANT(SBZipUtils, ZIP_COMPRESSION_TERSE_OLD, SB_ZIP_COMPRESSION_TERSE_OLD, SB_ZIP_COMPRESSION_TERSE_OLD);
	SB_REGISTER_LONG_CONSTANT(SBZipUtils, ZIP_COMPRESSION_BZIP2, SB_ZIP_COMPRESSION_BZIP2, SB_ZIP_COMPRESSION_BZIP2);
	SB_REGISTER_LONG_CONSTANT(SBZipUtils, ZIP_COMPRESSION_LZMA, SB_ZIP_COMPRESSION_LZMA, SB_ZIP_COMPRESSION_LZMA);
	SB_REGISTER_LONG_CONSTANT(SBZipUtils, ZIP_COMPRESSION_TERSE_NEW, SB_ZIP_COMPRESSION_TERSE_NEW, SB_ZIP_COMPRESSION_TERSE_NEW);
	SB_REGISTER_LONG_CONSTANT(SBZipUtils, ZIP_COMPRESSION_LZ77, SB_ZIP_COMPRESSION_LZ77, SB_ZIP_COMPRESSION_LZ77);
	SB_REGISTER_LONG_CONSTANT(SBZipUtils, ZIP_COMPRESSION_WAVPACK, SB_ZIP_COMPRESSION_WAVPACK, SB_ZIP_COMPRESSION_WAVPACK);
	SB_REGISTER_LONG_CONSTANT(SBZipUtils, ZIP_COMPRESSION_PPMD_V1, SB_ZIP_COMPRESSION_PPMD_V1, SB_ZIP_COMPRESSION_PPMD_V1);
	SB_REGISTER_LONG_CONSTANT(SBZipUtils, ZIP_COMPRESSION_WINZIP_AES, SB_ZIP_COMPRESSION_WINZIP_AES, SB_ZIP_COMPRESSION_WINZIP_AES);
	SB_REGISTER_LONG_CONSTANT(SBZipUtils, ZIP_COMPRESSION_UNKNOWN, SB_ZIP_COMPRESSION_UNKNOWN, SB_ZIP_COMPRESSION_UNKNOWN);
	SB_REGISTER_LONG_CONSTANT(SBZipUtils, ZIP_FILEATTR_MSDOS, SB_ZIP_FILEATTR_MSDOS, SB_ZIP_FILEATTR_MSDOS);
	SB_REGISTER_LONG_CONSTANT(SBZipUtils, ZIP_FILEATTR_AMIGA, SB_ZIP_FILEATTR_AMIGA, SB_ZIP_FILEATTR_AMIGA);
	SB_REGISTER_LONG_CONSTANT(SBZipUtils, ZIP_FILEATTR_OpenVMS, SB_ZIP_FILEATTR_OpenVMS, SB_ZIP_FILEATTR_OpenVMS);
	SB_REGISTER_LONG_CONSTANT(SBZipUtils, ZIP_FILEATTR_UNIX, SB_ZIP_FILEATTR_UNIX, SB_ZIP_FILEATTR_UNIX);
	SB_REGISTER_LONG_CONSTANT(SBZipUtils, ZIP_FILEATTR_VM_CMS, SB_ZIP_FILEATTR_VM_CMS, SB_ZIP_FILEATTR_VM_CMS);
	SB_REGISTER_LONG_CONSTANT(SBZipUtils, ZIP_FILEATTR_ATARI_ST, SB_ZIP_FILEATTR_ATARI_ST, SB_ZIP_FILEATTR_ATARI_ST);
	SB_REGISTER_LONG_CONSTANT(SBZipUtils, ZIP_FILEATTR_OS2_HPFS, SB_ZIP_FILEATTR_OS2_HPFS, SB_ZIP_FILEATTR_OS2_HPFS);
	SB_REGISTER_LONG_CONSTANT(SBZipUtils, ZIP_FILEATTR_MACINTOSH, SB_ZIP_FILEATTR_MACINTOSH, SB_ZIP_FILEATTR_MACINTOSH);
	SB_REGISTER_LONG_CONSTANT(SBZipUtils, ZIP_FILEATTR_ZSYSTEM, SB_ZIP_FILEATTR_ZSYSTEM, SB_ZIP_FILEATTR_ZSYSTEM);
	SB_REGISTER_LONG_CONSTANT(SBZipUtils, ZIP_FILEATTR_CP_M, SB_ZIP_FILEATTR_CP_M, SB_ZIP_FILEATTR_CP_M);
	SB_REGISTER_LONG_CONSTANT(SBZipUtils, ZIP_FILEATTR_WIN_NTFS, SB_ZIP_FILEATTR_WIN_NTFS, SB_ZIP_FILEATTR_WIN_NTFS);
	SB_REGISTER_LONG_CONSTANT(SBZipUtils, ZIP_FILEATTR_MVS, SB_ZIP_FILEATTR_MVS, SB_ZIP_FILEATTR_MVS);
	SB_REGISTER_LONG_CONSTANT(SBZipUtils, ZIP_FILEATTR_VSE, SB_ZIP_FILEATTR_VSE, SB_ZIP_FILEATTR_VSE);
	SB_REGISTER_LONG_CONSTANT(SBZipUtils, ZIP_FILEATTR_ACORN_RISC, SB_ZIP_FILEATTR_ACORN_RISC, SB_ZIP_FILEATTR_ACORN_RISC);
	SB_REGISTER_LONG_CONSTANT(SBZipUtils, ZIP_FILEATTR_VFAT, SB_ZIP_FILEATTR_VFAT, SB_ZIP_FILEATTR_VFAT);
	SB_REGISTER_LONG_CONSTANT(SBZipUtils, ZIP_FILEATTR_ALT_MVS, SB_ZIP_FILEATTR_ALT_MVS, SB_ZIP_FILEATTR_ALT_MVS);
	SB_REGISTER_LONG_CONSTANT(SBZipUtils, ZIP_FILEATTR_BEOS, SB_ZIP_FILEATTR_BEOS, SB_ZIP_FILEATTR_BEOS);
	SB_REGISTER_LONG_CONSTANT(SBZipUtils, ZIP_FILEATTR_TANDEM, SB_ZIP_FILEATTR_TANDEM, SB_ZIP_FILEATTR_TANDEM);
	SB_REGISTER_LONG_CONSTANT(SBZipUtils, ZIP_FILEATTR_OS400, SB_ZIP_FILEATTR_OS400, SB_ZIP_FILEATTR_OS400);
	SB_REGISTER_LONG_CONSTANT(SBZipUtils, ZIP_FILEATTR_OSX, SB_ZIP_FILEATTR_OSX, SB_ZIP_FILEATTR_OSX);
	SB_REGISTER_LONG_CONSTANT(SBZipUtils, ZIP_VERSION_1_0, SB_ZIP_VERSION_1_0, SB_ZIP_VERSION_1_0);
	SB_REGISTER_LONG_CONSTANT(SBZipUtils, ZIP_VERSION_1_1, SB_ZIP_VERSION_1_1, SB_ZIP_VERSION_1_1);
	SB_REGISTER_LONG_CONSTANT(SBZipUtils, ZIP_VERSION_2_0, SB_ZIP_VERSION_2_0, SB_ZIP_VERSION_2_0);
	SB_REGISTER_LONG_CONSTANT(SBZipUtils, ZIP_VERSION_2_1, SB_ZIP_VERSION_2_1, SB_ZIP_VERSION_2_1);
	SB_REGISTER_LONG_CONSTANT(SBZipUtils, ZIP_VERSION_2_5, SB_ZIP_VERSION_2_5, SB_ZIP_VERSION_2_5);
	SB_REGISTER_LONG_CONSTANT(SBZipUtils, ZIP_VERSION_2_7, SB_ZIP_VERSION_2_7, SB_ZIP_VERSION_2_7);
	SB_REGISTER_LONG_CONSTANT(SBZipUtils, ZIP_VERSION_4_5, SB_ZIP_VERSION_4_5, SB_ZIP_VERSION_4_5);
	SB_REGISTER_LONG_CONSTANT(SBZipUtils, ZIP_VERSION_4_6, SB_ZIP_VERSION_4_6, SB_ZIP_VERSION_4_6);
	SB_REGISTER_LONG_CONSTANT(SBZipUtils, ZIP_VERSION_5_0, SB_ZIP_VERSION_5_0, SB_ZIP_VERSION_5_0);
	SB_REGISTER_LONG_CONSTANT(SBZipUtils, ZIP_VERSION_5_1, SB_ZIP_VERSION_5_1, SB_ZIP_VERSION_5_1);
	SB_REGISTER_LONG_CONSTANT(SBZipUtils, ZIP_VERSION_5_2, SB_ZIP_VERSION_5_2, SB_ZIP_VERSION_5_2);
	SB_REGISTER_LONG_CONSTANT(SBZipUtils, ZIP_VERSION_6_1, SB_ZIP_VERSION_6_1, SB_ZIP_VERSION_6_1);
	SB_REGISTER_LONG_CONSTANT(SBZipUtils, ZIP_VERSION_6_2, SB_ZIP_VERSION_6_2, SB_ZIP_VERSION_6_2);
	SB_REGISTER_LONG_CONSTANT(SBZipUtils, ZIP_VERSION_6_3, SB_ZIP_VERSION_6_3, SB_ZIP_VERSION_6_3);
	SB_REGISTER_LONG_CONSTANT(SBZipUtils, ZIP_EXTENSION_ZIP64, SB_ZIP_EXTENSION_ZIP64, SB_ZIP_EXTENSION_ZIP64);
	SB_REGISTER_LONG_CONSTANT(SBZipUtils, ZIP_EXTENSION_AV_INFO, SB_ZIP_EXTENSION_AV_INFO, SB_ZIP_EXTENSION_AV_INFO);
	SB_REGISTER_LONG_CONSTANT(SBZipUtils, ZIP_EXTENSION_PFS, SB_ZIP_EXTENSION_PFS, SB_ZIP_EXTENSION_PFS);
	SB_REGISTER_LONG_CONSTANT(SBZipUtils, ZIP_EXTENSION_OS2, SB_ZIP_EXTENSION_OS2, SB_ZIP_EXTENSION_OS2);
	SB_REGISTER_LONG_CONSTANT(SBZipUtils, ZIP_EXTENSION_NTFS, SB_ZIP_EXTENSION_NTFS, SB_ZIP_EXTENSION_NTFS);
	SB_REGISTER_LONG_CONSTANT(SBZipUtils, ZIP_EXTENSION_OPENVMS, SB_ZIP_EXTENSION_OPENVMS, SB_ZIP_EXTENSION_OPENVMS);
	SB_REGISTER_LONG_CONSTANT(SBZipUtils, ZIP_EXTENSION_UNIX, SB_ZIP_EXTENSION_UNIX, SB_ZIP_EXTENSION_UNIX);
	SB_REGISTER_LONG_CONSTANT(SBZipUtils, ZIP_EXTENSION_DESCRIPTORS, SB_ZIP_EXTENSION_DESCRIPTORS, SB_ZIP_EXTENSION_DESCRIPTORS);
	SB_REGISTER_LONG_CONSTANT(SBZipUtils, ZIP_EXTENSION_PATCH, SB_ZIP_EXTENSION_PATCH, SB_ZIP_EXTENSION_PATCH);
	SB_REGISTER_LONG_CONSTANT(SBZipUtils, ZIP_EXTENSION_PKCS7_STORE, SB_ZIP_EXTENSION_PKCS7_STORE, SB_ZIP_EXTENSION_PKCS7_STORE);
	SB_REGISTER_LONG_CONSTANT(SBZipUtils, ZIP_EXTENSION_FILE_SIGNATURE, SB_ZIP_EXTENSION_FILE_SIGNATURE, SB_ZIP_EXTENSION_FILE_SIGNATURE);
	SB_REGISTER_LONG_CONSTANT(SBZipUtils, ZIP_EXTENSION_CDIR_SIGNATURE, SB_ZIP_EXTENSION_CDIR_SIGNATURE, SB_ZIP_EXTENSION_CDIR_SIGNATURE);
	SB_REGISTER_LONG_CONSTANT(SBZipUtils, ZIP_EXTENSION_STRONG_ENCRYPTION, SB_ZIP_EXTENSION_STRONG_ENCRYPTION, SB_ZIP_EXTENSION_STRONG_ENCRYPTION);
	SB_REGISTER_LONG_CONSTANT(SBZipUtils, ZIP_EXTENSION_RECORD_MANAGEMENT, SB_ZIP_EXTENSION_RECORD_MANAGEMENT, SB_ZIP_EXTENSION_RECORD_MANAGEMENT);
	SB_REGISTER_LONG_CONSTANT(SBZipUtils, ZIP_EXTENSION_PKCS7_RECIPIENTS, SB_ZIP_EXTENSION_PKCS7_RECIPIENTS, SB_ZIP_EXTENSION_PKCS7_RECIPIENTS);
	SB_REGISTER_LONG_CONSTANT(SBZipUtils, ZIP_EXTENSION_IBM_ATTRIBUTES, SB_ZIP_EXTENSION_IBM_ATTRIBUTES, SB_ZIP_EXTENSION_IBM_ATTRIBUTES);
	SB_REGISTER_LONG_CONSTANT(SBZipUtils, ZIP_EXTENSION_IBM_ATTRIBUTES_CMP, SB_ZIP_EXTENSION_IBM_ATTRIBUTES_CMP, SB_ZIP_EXTENSION_IBM_ATTRIBUTES_CMP);
	SB_REGISTER_LONG_CONSTANT(SBZipUtils, ZIP_EXTENSION_POSZIP_4690, SB_ZIP_EXTENSION_POSZIP_4690, SB_ZIP_EXTENSION_POSZIP_4690);
	SB_REGISTER_LONG_CONSTANT(SBZipUtils, ZIP_EXTENSION_EXTENDED_TIMESTAMP, SB_ZIP_EXTENSION_EXTENDED_TIMESTAMP, SB_ZIP_EXTENSION_EXTENDED_TIMESTAMP);
	SB_REGISTER_LONG_CONSTANT(SBZipUtils, ZIP_EXTENSION_UNIX1, SB_ZIP_EXTENSION_UNIX1, SB_ZIP_EXTENSION_UNIX1);
	SB_REGISTER_LONG_CONSTANT(SBZipUtils, ZIP_EXTENSION_UNIX2, SB_ZIP_EXTENSION_UNIX2, SB_ZIP_EXTENSION_UNIX2);
	SB_REGISTER_LONG_CONSTANT(SBZipUtils, ZIP_EXTENSION_UID_GID, SB_ZIP_EXTENSION_UID_GID, SB_ZIP_EXTENSION_UID_GID);
	SB_REGISTER_LONG_CONSTANT(SBZipUtils, ZIP_EXTENSION_WINZIP_AES, SB_ZIP_EXTENSION_WINZIP_AES, SB_ZIP_EXTENSION_WINZIP_AES);
	SB_REGISTER_LONG_CONSTANT(SBZipUtils, ZIP_HASH_NONE, SB_ZIP_HASH_NONE, SB_ZIP_HASH_NONE);
	SB_REGISTER_LONG_CONSTANT(SBZipUtils, ZIP_HASH_CRC32, SB_ZIP_HASH_CRC32, SB_ZIP_HASH_CRC32);
	SB_REGISTER_LONG_CONSTANT(SBZipUtils, ZIP_HASH_MD5, SB_ZIP_HASH_MD5, SB_ZIP_HASH_MD5);
	SB_REGISTER_LONG_CONSTANT(SBZipUtils, ZIP_HASH_SHA1, SB_ZIP_HASH_SHA1, SB_ZIP_HASH_SHA1);
	SB_REGISTER_LONG_CONSTANT(SBZipUtils, ZIP_HASH_RIPEMD160, SB_ZIP_HASH_RIPEMD160, SB_ZIP_HASH_RIPEMD160);
	SB_REGISTER_LONG_CONSTANT(SBZipUtils, ZIP_HASH_SHA256, SB_ZIP_HASH_SHA256, SB_ZIP_HASH_SHA256);
	SB_REGISTER_LONG_CONSTANT(SBZipUtils, ZIP_HASH_SHA384, SB_ZIP_HASH_SHA384, SB_ZIP_HASH_SHA384);
	SB_REGISTER_LONG_CONSTANT(SBZipUtils, ZIP_HASH_SHA512, SB_ZIP_HASH_SHA512, SB_ZIP_HASH_SHA512);
	SB_REGISTER_LONG_CONSTANT(SBZipUtils, ZIP_ENCRYPTION_NONE, SB_ZIP_ENCRYPTION_NONE, SB_ZIP_ENCRYPTION_NONE);
	SB_REGISTER_LONG_CONSTANT(SBZipUtils, ZIP_ENCRYPTION_DES, SB_ZIP_ENCRYPTION_DES, SB_ZIP_ENCRYPTION_DES);
	SB_REGISTER_LONG_CONSTANT(SBZipUtils, ZIP_ENCRYPTION_RC2_OLD, SB_ZIP_ENCRYPTION_RC2_OLD, SB_ZIP_ENCRYPTION_RC2_OLD);
	SB_REGISTER_LONG_CONSTANT(SBZipUtils, ZIP_ENCRYPTION_3DES168, SB_ZIP_ENCRYPTION_3DES168, SB_ZIP_ENCRYPTION_3DES168);
	SB_REGISTER_LONG_CONSTANT(SBZipUtils, ZIP_ENCRYPTION_3DES112, SB_ZIP_ENCRYPTION_3DES112, SB_ZIP_ENCRYPTION_3DES112);
	SB_REGISTER_LONG_CONSTANT(SBZipUtils, ZIP_ENCRYPTION_AES128, SB_ZIP_ENCRYPTION_AES128, SB_ZIP_ENCRYPTION_AES128);
	SB_REGISTER_LONG_CONSTANT(SBZipUtils, ZIP_ENCRYPTION_AES192, SB_ZIP_ENCRYPTION_AES192, SB_ZIP_ENCRYPTION_AES192);
	SB_REGISTER_LONG_CONSTANT(SBZipUtils, ZIP_ENCRYPTION_AES256, SB_ZIP_ENCRYPTION_AES256, SB_ZIP_ENCRYPTION_AES256);
	SB_REGISTER_LONG_CONSTANT(SBZipUtils, ZIP_ENCRYPTION_RC2_NEW, SB_ZIP_ENCRYPTION_RC2_NEW, SB_ZIP_ENCRYPTION_RC2_NEW);
	SB_REGISTER_LONG_CONSTANT(SBZipUtils, ZIP_ENCRYPTION_BLOWFISH, SB_ZIP_ENCRYPTION_BLOWFISH, SB_ZIP_ENCRYPTION_BLOWFISH);
	SB_REGISTER_LONG_CONSTANT(SBZipUtils, ZIP_ENCRYPTION_TWOFISH, SB_ZIP_ENCRYPTION_TWOFISH, SB_ZIP_ENCRYPTION_TWOFISH);
	SB_REGISTER_LONG_CONSTANT(SBZipUtils, ZIP_ENCRYPTION_RC4, SB_ZIP_ENCRYPTION_RC4, SB_ZIP_ENCRYPTION_RC4);
	SB_REGISTER_LONG_CONSTANT(SBZipUtils, ZIP_ENCRYPTION_UNKNOWN, SB_ZIP_ENCRYPTION_UNKNOWN, SB_ZIP_ENCRYPTION_UNKNOWN);
	SB_REGISTER_LONG_CONSTANT(SBZipUtils, ZIP_STRONG_ENCR_PASSWORD_NEEDED, SB_ZIP_STRONG_ENCR_PASSWORD_NEEDED, SB_ZIP_STRONG_ENCR_PASSWORD_NEEDED);
	SB_REGISTER_LONG_CONSTANT(SBZipUtils, ZIP_STRONG_ENCR_CERTIFICATE_NEEDED, SB_ZIP_STRONG_ENCR_CERTIFICATE_NEEDED, SB_ZIP_STRONG_ENCR_CERTIFICATE_NEEDED);
	SB_REGISTER_LONG_CONSTANT(SBZipUtils, ZIP_STRONG_ENCR_NO_OAEP, SB_ZIP_STRONG_ENCR_NO_OAEP, SB_ZIP_STRONG_ENCR_NO_OAEP);
	SB_REGISTER_LONG_CONSTANT(SBZipUtils, ZIP_STRONG_ENCR_USE_3DES, SB_ZIP_STRONG_ENCR_USE_3DES, SB_ZIP_STRONG_ENCR_USE_3DES);
}

