#ifndef __INC_SBARCBASE
#define __INC_SBARCBASE

#if _MSC_VER > 1000
#  pragma once
#endif // _MSC_VER > 1000

#include "sbdefs.h"
#include "sbphpcore.h"
#include "sbsystem.h"
#include "sbstreams.h"
#include "sbtypes.h"
#include "sbutils.h"
#include "sbconstants.h"

#pragma pack(push, 1)

#ifdef __cplusplus
namespace SecureBlackbox {
#endif

#ifdef __cplusplus
extern "C" {
#endif
typedef TElClassHandle TElBaseArchiveHandle;

typedef TElClassHandle TElArchiveDirectoryEntryHandle;

typedef TElClassHandle TElArcProcessingUnitHandle;

typedef uint8_t TSBArcReplaceModeRaw;

typedef enum
{
	armAlways = 0,
	armNever = 1,
	armNewer = 2,
	armReportError = 3
} TSBArcReplaceMode;

typedef void (SB_CALLBACK *TSBArcReadEvent)(void * _ObjectData, TObjectHandle Sender, uint8_t pBuffer[], int32_t * szBuffer, int32_t Index, int32_t * Written, int8_t * Last);

typedef void (SB_CALLBACK *TSBArcWriteEvent)(void * _ObjectData, TObjectHandle Sender, const uint8_t pBuffer[], int32_t szBuffer, int32_t Index, int32_t Size);

#ifdef SB_USE_CLASS_TELBASEARCHIVE
SB_IMPORT uint32_t SB_APIENTRY TElBaseArchive_Open(TElBaseArchiveHandle _Handle, const char * pcFileName, int32_t szFileName, int8_t ReadOnly);
SB_IMPORT uint32_t SB_APIENTRY TElBaseArchive_Open_1(TElBaseArchiveHandle _Handle, TStreamHandle Stream);
SB_IMPORT uint32_t SB_APIENTRY TElBaseArchive_Close(TElBaseArchiveHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElBaseArchive_get_Opened(TElBaseArchiveHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElBaseArchive_get_IsReadOnly(TElBaseArchiveHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElBaseArchive_get_OnProgress(TElBaseArchiveHandle _Handle, TSBProgressEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElBaseArchive_set_OnProgress(TElBaseArchiveHandle _Handle, TSBProgressEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElBaseArchive_Create(TComponentHandle AOwner, TElBaseArchiveHandle * OutResult);
#endif /* SB_USE_CLASS_TELBASEARCHIVE */

#ifdef SB_USE_CLASS_TELARCHIVEDIRECTORYENTRY
SB_IMPORT uint32_t SB_APIENTRY TElArchiveDirectoryEntry_get_FileName(TElArchiveDirectoryEntryHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElArchiveDirectoryEntry_set_FileName(TElArchiveDirectoryEntryHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElArchiveDirectoryEntry_get_FileSize(TElArchiveDirectoryEntryHandle _Handle, int64_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElArchiveDirectoryEntry_set_FileSize(TElArchiveDirectoryEntryHandle _Handle, int64_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElArchiveDirectoryEntry_get_FileDateCreated(TElArchiveDirectoryEntryHandle _Handle, int64_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElArchiveDirectoryEntry_set_FileDateCreated(TElArchiveDirectoryEntryHandle _Handle, int64_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElArchiveDirectoryEntry_get_FileDateModified(TElArchiveDirectoryEntryHandle _Handle, int64_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElArchiveDirectoryEntry_set_FileDateModified(TElArchiveDirectoryEntryHandle _Handle, int64_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElArchiveDirectoryEntry_get_FileDateAccessed(TElArchiveDirectoryEntryHandle _Handle, int64_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElArchiveDirectoryEntry_set_FileDateAccessed(TElArchiveDirectoryEntryHandle _Handle, int64_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElArchiveDirectoryEntry_get_CompressedSize(TElArchiveDirectoryEntryHandle _Handle, int64_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElArchiveDirectoryEntry_set_CompressedSize(TElArchiveDirectoryEntryHandle _Handle, int64_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElArchiveDirectoryEntry_get_IsDirectory(TElArchiveDirectoryEntryHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElArchiveDirectoryEntry_set_IsDirectory(TElArchiveDirectoryEntryHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElArchiveDirectoryEntry_get_EntriesCount(TElArchiveDirectoryEntryHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElArchiveDirectoryEntry_Create(TElArchiveDirectoryEntryHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElArchiveDirectoryEntry_Create_1(TElBaseArchiveHandle Owner, TElArchiveDirectoryEntryHandle * OutResult);
#endif /* SB_USE_CLASS_TELARCHIVEDIRECTORYENTRY */

#ifdef SB_USE_CLASS_TELARCPROCESSINGUNIT
SB_IMPORT uint32_t SB_APIENTRY TElArcProcessingUnit_InitializeProcessing(TElArcProcessingUnitHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElArcProcessingUnit_ProcessBlock(TElArcProcessingUnitHandle _Handle, const uint8_t pBuffer[], int32_t szBuffer, int32_t Index, int32_t Size);
SB_IMPORT uint32_t SB_APIENTRY TElArcProcessingUnit_FinalizeProcessing(TElArcProcessingUnitHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElArcProcessingUnit_get_OutputStream(TElArcProcessingUnitHandle _Handle, TStreamHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElArcProcessingUnit_set_OutputStream(TElArcProcessingUnitHandle _Handle, TStreamHandle Value);
SB_IMPORT uint32_t SB_APIENTRY TElArcProcessingUnit_get_OutputProcessingUnit(TElArcProcessingUnitHandle _Handle, TElArcProcessingUnitHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElArcProcessingUnit_set_OutputProcessingUnit(TElArcProcessingUnitHandle _Handle, TElArcProcessingUnitHandle Value);
SB_IMPORT uint32_t SB_APIENTRY TElArcProcessingUnit_get_ProcessedData(TElArcProcessingUnitHandle _Handle, int64_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElArcProcessingUnit_set_ProcessedData(TElArcProcessingUnitHandle _Handle, int64_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElArcProcessingUnit_get_WrittenData(TElArcProcessingUnitHandle _Handle, int64_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElArcProcessingUnit_set_WrittenData(TElArcProcessingUnitHandle _Handle, int64_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElArcProcessingUnit_get_OutputEvent(TElArcProcessingUnitHandle _Handle, TSBArcWriteEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElArcProcessingUnit_set_OutputEvent(TElArcProcessingUnitHandle _Handle, TSBArcWriteEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElArcProcessingUnit_Create(TElArcProcessingUnitHandle * OutResult);
#endif /* SB_USE_CLASS_TELARCPROCESSINGUNIT */

#ifdef __cplusplus
};	/* extern "C" */
#endif

extern zend_class_entry *TElBaseArchive_ce_ptr;
extern zend_class_entry *TElArchiveDirectoryEntry_ce_ptr;
extern zend_class_entry *TElArcProcessingUnit_ce_ptr;

void SB_CALLBACK TSBArcReadEventRaw(void * _ObjectData, TObjectHandle Sender, uint8_t pBuffer[], int32_t * szBuffer, int32_t Index, int32_t * Written, int8_t * Last);
void SB_CALLBACK TSBArcWriteEventRaw(void * _ObjectData, TObjectHandle Sender, const uint8_t pBuffer[], int32_t szBuffer, int32_t Index, int32_t Size);
void Register_TElBaseArchive(TSRMLS_D);
void Register_TElArchiveDirectoryEntry(TSRMLS_D);
void Register_TElArcProcessingUnit(TSRMLS_D);
void Register_SBArcBase_Enum_Flags(TSRMLS_D);

#ifdef __cplusplus
};	/* namespace SecureBlackbox */
#endif

#pragma pack(pop)

#endif  /* __INC_SBARCBASE */

