#ifndef __INC_SBBZIP2UTILS
#define __INC_SBBZIP2UTILS

#if _MSC_VER > 1000
#  pragma once
#endif // _MSC_VER > 1000

#include "sbdefs.h"
#include "sbphpcore.h"
#include "sbsystem.h"
#include "sbtypes.h"
#include "sbutils.h"
#include "sbbzip2basetypes.h"

#pragma pack(push, 1)

#ifdef __cplusplus
namespace SecureBlackbox {
#endif

#ifdef __cplusplus
extern "C" {
#endif
typedef TElClassHandle TSBDataArrayHandle;

typedef TElClassHandle TSBByteDataArrayHandle;

typedef TElClassHandle TSBByteArrayHandle;

typedef TElClassHandle TSBInt16ArrayHandle;

typedef TElClassHandle TSBUInt16ArrayHandle;

typedef TElClassHandle TSBInt32ArrayHandle;

typedef TElClassHandle TSBUInt32ArrayHandle;

typedef TElClassHandle TSBUInt16onByteArrayHandle;

typedef TElClassHandle TSBByteonUInt32ArrayHandle;

typedef TElClassHandle TSBUInt16onUInt32ArrayHandle;

typedef TElClassHandle TSBArrayPointerHandle;

typedef TElClassHandle TSBInt32ArrayPointerHandle;

typedef TElClassHandle TSBUInt32ArrayPointerHandle;

typedef TElClassHandle TSBByteArrayPointerHandle;

#ifdef SB_USE_CLASS_TSBDATAARRAY
SB_IMPORT uint32_t SB_APIENTRY TSBDataArray_GetArrayData(TSBDataArrayHandle _Handle, int32_t Index, int64_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TSBDataArray_SetArrayData(TSBDataArrayHandle _Handle, int64_t Data, int32_t Index);
SB_IMPORT uint32_t SB_APIENTRY TSBDataArray_Create(int32_t Len, TSBDataArrayHandle * OutResult);
#endif /* SB_USE_CLASS_TSBDATAARRAY */

#ifdef SB_USE_CLASS_TSBBYTEDATAARRAY
SB_IMPORT uint32_t SB_APIENTRY TSBByteDataArray_GetArrayData(TSBByteDataArrayHandle _Handle, int32_t Index, uint8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TSBByteDataArray_SetArrayData(TSBByteDataArrayHandle _Handle, uint8_t Data, int32_t Index);
SB_IMPORT uint32_t SB_APIENTRY TSBByteDataArray_Create(int32_t Len, TSBByteDataArrayHandle * OutResult);
#endif /* SB_USE_CLASS_TSBBYTEDATAARRAY */

#ifdef SB_USE_CLASS_TSBBYTEARRAY
SB_IMPORT uint32_t SB_APIENTRY TSBByteArray_GetData(TSBByteArrayHandle _Handle, int32_t Index, uint8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TSBByteArray_SetData(TSBByteArrayHandle _Handle, uint8_t Data, int32_t Index);
SB_IMPORT uint32_t SB_APIENTRY TSBByteArray_Create(int32_t Len, TSBDataArrayHandle * OutResult);
#endif /* SB_USE_CLASS_TSBBYTEARRAY */

#ifdef SB_USE_CLASS_TSBINT16ARRAY
SB_IMPORT uint32_t SB_APIENTRY TSBInt16Array_GetData(TSBInt16ArrayHandle _Handle, int32_t Index, int16_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TSBInt16Array_SetData(TSBInt16ArrayHandle _Handle, int16_t Data, int32_t Index);
SB_IMPORT uint32_t SB_APIENTRY TSBInt16Array_Create(int32_t Len, TSBDataArrayHandle * OutResult);
#endif /* SB_USE_CLASS_TSBINT16ARRAY */

#ifdef SB_USE_CLASS_TSBUINT16ARRAY
SB_IMPORT uint32_t SB_APIENTRY TSBUInt16Array_GetData(TSBUInt16ArrayHandle _Handle, int32_t Index, uint16_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TSBUInt16Array_SetData(TSBUInt16ArrayHandle _Handle, uint16_t Data, int32_t Index);
SB_IMPORT uint32_t SB_APIENTRY TSBUInt16Array_Create(int32_t Len, TSBDataArrayHandle * OutResult);
#endif /* SB_USE_CLASS_TSBUINT16ARRAY */

#ifdef SB_USE_CLASS_TSBINT32ARRAY
SB_IMPORT uint32_t SB_APIENTRY TSBInt32Array_GetData(TSBInt32ArrayHandle _Handle, int32_t Index, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TSBInt32Array_SetData(TSBInt32ArrayHandle _Handle, int32_t Data, int32_t Index);
SB_IMPORT uint32_t SB_APIENTRY TSBInt32Array_Create(int32_t Len, TSBDataArrayHandle * OutResult);
#endif /* SB_USE_CLASS_TSBINT32ARRAY */

#ifdef SB_USE_CLASS_TSBUINT32ARRAY
SB_IMPORT uint32_t SB_APIENTRY TSBUInt32Array_GetData(TSBUInt32ArrayHandle _Handle, int32_t Index, uint32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TSBUInt32Array_SetData(TSBUInt32ArrayHandle _Handle, uint32_t Data, int32_t Index);
SB_IMPORT uint32_t SB_APIENTRY TSBUInt32Array_Create(int32_t Len, TSBDataArrayHandle * OutResult);
#endif /* SB_USE_CLASS_TSBUINT32ARRAY */

#ifdef SB_USE_CLASS_TSBUINT16ONBYTEARRAY
SB_IMPORT uint32_t SB_APIENTRY TSBUInt16onByteArray_GetData(TSBUInt16onByteArrayHandle _Handle, int32_t Index, uint16_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TSBUInt16onByteArray_SetData(TSBUInt16onByteArrayHandle _Handle, uint16_t Data, int32_t Index);
SB_IMPORT uint32_t SB_APIENTRY TSBUInt16onByteArray_Create(TSBByteArrayHandle Base, const char * pcParentName, int32_t szParentName, TSBUInt16onByteArrayHandle * OutResult);
#endif /* SB_USE_CLASS_TSBUINT16ONBYTEARRAY */

#ifdef SB_USE_CLASS_TSBBYTEONUINT32ARRAY
SB_IMPORT uint32_t SB_APIENTRY TSBByteonUInt32Array_GetData(TSBByteonUInt32ArrayHandle _Handle, int32_t Index, uint8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TSBByteonUInt32Array_SetData(TSBByteonUInt32ArrayHandle _Handle, uint8_t Data, int32_t Index);
SB_IMPORT uint32_t SB_APIENTRY TSBByteonUInt32Array_Create(TSBUInt32ArrayHandle Base, const char * pcParentName, int32_t szParentName, TSBByteonUInt32ArrayHandle * OutResult);
#endif /* SB_USE_CLASS_TSBBYTEONUINT32ARRAY */

#ifdef SB_USE_CLASS_TSBUINT16ONUINT32ARRAY
SB_IMPORT uint32_t SB_APIENTRY TSBUInt16onUInt32Array_GetData(TSBUInt16onUInt32ArrayHandle _Handle, int32_t Index, uint16_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TSBUInt16onUInt32Array_SetData(TSBUInt16onUInt32ArrayHandle _Handle, uint16_t Data, int32_t Index);
SB_IMPORT uint32_t SB_APIENTRY TSBUInt16onUInt32Array_Create(TSBUInt32ArrayHandle Base, const char * pcParentName, int32_t szParentName, TSBUInt16onUInt32ArrayHandle * OutResult);
#endif /* SB_USE_CLASS_TSBUINT16ONUINT32ARRAY */

#ifdef SB_USE_CLASS_TSBARRAYPOINTER
SB_IMPORT uint32_t SB_APIENTRY TSBArrayPointer_SetData(TSBArrayPointerHandle _Handle, int64_t Data, int32_t Index);
SB_IMPORT uint32_t SB_APIENTRY TSBArrayPointer_IncOffset(TSBArrayPointerHandle _Handle, int32_t Index);
SB_IMPORT uint32_t SB_APIENTRY TSBArrayPointer_SetOffset(TSBArrayPointerHandle _Handle, int32_t Index);
SB_IMPORT uint32_t SB_APIENTRY TSBArrayPointer_GetData(TSBArrayPointerHandle _Handle, int32_t Index, int64_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TSBArrayPointer_GetAtPtr(TSBArrayPointerHandle _Handle, int64_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TSBArrayPointer_SetAtPtr(TSBArrayPointerHandle _Handle, int64_t Data);
SB_IMPORT uint32_t SB_APIENTRY TSBArrayPointer_Create(TSBDataArrayHandle Base, const char * pcParentName, int32_t szParentName, TSBArrayPointerHandle * OutResult);
#endif /* SB_USE_CLASS_TSBARRAYPOINTER */

#ifdef SB_USE_CLASS_TSBINT32ARRAYPOINTER
SB_IMPORT uint32_t SB_APIENTRY TSBInt32ArrayPointer_SetData(TSBInt32ArrayPointerHandle _Handle, int32_t Data, int32_t Index);
SB_IMPORT uint32_t SB_APIENTRY TSBInt32ArrayPointer_SetData_1(TSBArrayPointerHandle _Handle, int64_t Data, int32_t Index);
SB_IMPORT uint32_t SB_APIENTRY TSBInt32ArrayPointer_GetData(TSBInt32ArrayPointerHandle _Handle, int32_t Index, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TSBInt32ArrayPointer_GetAtPtr(TSBInt32ArrayPointerHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TSBInt32ArrayPointer_SetAtPtr(TSBInt32ArrayPointerHandle _Handle, int32_t Data);
SB_IMPORT uint32_t SB_APIENTRY TSBInt32ArrayPointer_SetAtPtr_1(TSBArrayPointerHandle _Handle, int64_t Data);
SB_IMPORT uint32_t SB_APIENTRY TSBInt32ArrayPointer_Create(TSBDataArrayHandle Base, const char * pcParentName, int32_t szParentName, TSBArrayPointerHandle * OutResult);
#endif /* SB_USE_CLASS_TSBINT32ARRAYPOINTER */

#ifdef SB_USE_CLASS_TSBUINT32ARRAYPOINTER
SB_IMPORT uint32_t SB_APIENTRY TSBUInt32ArrayPointer_SetData(TSBUInt32ArrayPointerHandle _Handle, uint32_t Data, int32_t Index);
SB_IMPORT uint32_t SB_APIENTRY TSBUInt32ArrayPointer_SetData_1(TSBArrayPointerHandle _Handle, int64_t Data, int32_t Index);
SB_IMPORT uint32_t SB_APIENTRY TSBUInt32ArrayPointer_GetData(TSBUInt32ArrayPointerHandle _Handle, int32_t Index, uint32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TSBUInt32ArrayPointer_GetAtPtr(TSBUInt32ArrayPointerHandle _Handle, uint32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TSBUInt32ArrayPointer_SetAtPtr(TSBUInt32ArrayPointerHandle _Handle, uint32_t Data);
SB_IMPORT uint32_t SB_APIENTRY TSBUInt32ArrayPointer_SetAtPtr_1(TSBArrayPointerHandle _Handle, int64_t Data);
SB_IMPORT uint32_t SB_APIENTRY TSBUInt32ArrayPointer_Create(TSBDataArrayHandle Base, const char * pcParentName, int32_t szParentName, TSBArrayPointerHandle * OutResult);
#endif /* SB_USE_CLASS_TSBUINT32ARRAYPOINTER */

#ifdef SB_USE_CLASS_TSBBYTEARRAYPOINTER
SB_IMPORT uint32_t SB_APIENTRY TSBByteArrayPointer_SetData(TSBByteArrayPointerHandle _Handle, uint8_t Data, int32_t Index);
SB_IMPORT uint32_t SB_APIENTRY TSBByteArrayPointer_SetData_1(TSBArrayPointerHandle _Handle, int64_t Data, int32_t Index);
SB_IMPORT uint32_t SB_APIENTRY TSBByteArrayPointer_GetData(TSBByteArrayPointerHandle _Handle, int32_t Index, uint8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TSBByteArrayPointer_GetAtPtr(TSBByteArrayPointerHandle _Handle, uint8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TSBByteArrayPointer_Create(TSBDataArrayHandle Base, const char * pcParentName, int32_t szParentName, TSBArrayPointerHandle * OutResult);
#endif /* SB_USE_CLASS_TSBBYTEARRAYPOINTER */

#ifdef __cplusplus
};	/* extern "C" */
#endif

extern zend_class_entry *TSBDataArray_ce_ptr;
extern zend_class_entry *TSBByteDataArray_ce_ptr;
extern zend_class_entry *TSBByteArray_ce_ptr;
extern zend_class_entry *TSBInt16Array_ce_ptr;
extern zend_class_entry *TSBUInt16Array_ce_ptr;
extern zend_class_entry *TSBInt32Array_ce_ptr;
extern zend_class_entry *TSBUInt32Array_ce_ptr;
extern zend_class_entry *TSBUInt16onByteArray_ce_ptr;
extern zend_class_entry *TSBByteonUInt32Array_ce_ptr;
extern zend_class_entry *TSBUInt16onUInt32Array_ce_ptr;
extern zend_class_entry *TSBArrayPointer_ce_ptr;
extern zend_class_entry *TSBInt32ArrayPointer_ce_ptr;
extern zend_class_entry *TSBUInt32ArrayPointer_ce_ptr;
extern zend_class_entry *TSBByteArrayPointer_ce_ptr;

void Register_TSBDataArray(TSRMLS_D);
void Register_TSBByteDataArray(TSRMLS_D);
void Register_TSBByteArray(TSRMLS_D);
void Register_TSBInt16Array(TSRMLS_D);
void Register_TSBUInt16Array(TSRMLS_D);
void Register_TSBInt32Array(TSRMLS_D);
void Register_TSBUInt32Array(TSRMLS_D);
void Register_TSBUInt16onByteArray(TSRMLS_D);
void Register_TSBByteonUInt32Array(TSRMLS_D);
void Register_TSBUInt16onUInt32Array(TSRMLS_D);
void Register_TSBArrayPointer(TSRMLS_D);
void Register_TSBInt32ArrayPointer(TSRMLS_D);
void Register_TSBUInt32ArrayPointer(TSRMLS_D);
void Register_TSBByteArrayPointer(TSRMLS_D);
SB_PHP_FUNCTION(SBBzip2Utils, IfThenInt);
SB_PHP_FUNCTION(SBBzip2Utils, IfThenInt64);
SB_PHP_FUNCTION(SBBzip2Utils, IfThenDouble);
SB_PHP_FUNCTION(SBBzip2Utils, IfThenUInt32);

#ifdef __cplusplus
extern "C" {
#endif

#ifdef SB_USE_GLOBAL_PROCS_BZIP2UTILS
SB_IMPORT uint32_t SB_APIENTRY SBBzip2Utils_IfThenInt(int8_t AValue, int32_t ATrue, int32_t AFalse, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY SBBzip2Utils_IfThenInt64(int8_t AValue, int64_t ATrue, int64_t AFalse, int64_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY SBBzip2Utils_IfThenDouble(int8_t AValue, double ATrue, double AFalse, double * OutResult);
SB_IMPORT uint32_t SB_APIENTRY SBBzip2Utils_IfThenUInt32(int8_t AValue, uint32_t ATrue, uint32_t AFalse, uint32_t * OutResult);
#endif /* SB_USE_GLOBAL_PROCS_BZIP2UTILS */

#ifdef __cplusplus
};	/* extern "C" */
#endif

#ifdef __cplusplus
};	/* namespace SecureBlackbox */
#endif

#pragma pack(pop)

#endif  /* __INC_SBBZIP2UTILS */

