#ifndef __INC_SBECMATH
#define __INC_SBECMATH

#if _MSC_VER > 1000
#  pragma once
#endif // _MSC_VER > 1000

#include "sbdefs.h"
#include "sbphpcore.h"
#include "sbsystem.h"
#include "sbconstants.h"
#include "sbmath.h"
#include "sbtypes.h"
#include "sbutils.h"

#pragma pack(push, 1)

#ifdef __cplusplus
namespace SecureBlackbox {
#endif

#ifdef __cplusplus
extern "C" {
#endif
#ifdef __cplusplus
};	/* extern "C" */
#endif

SB_PHP_FUNCTION(SBECMath, GetFieldByP);
SB_PHP_FUNCTION(SBECMath, GetBinaryFieldK);
SB_PHP_FUNCTION(SBECMath, SetBinaryFieldK);
SB_PHP_FUNCTION(SBECMath, ECPFpDecompress);
SB_PHP_FUNCTION(SBECMath, ECPF2mPDecompress);
SB_PHP_FUNCTION(SBECMath, ECPF2mPGetYpBit);
SB_PHP_FUNCTION(SBECMath, FpZero);
SB_PHP_FUNCTION(SBECMath, FpOne);
SB_PHP_FUNCTION(SBECMath, FpInt);
SB_PHP_FUNCTION(SBECMath, FpCmp);
SB_PHP_FUNCTION(SBECMath, FpAdd);
SB_PHP_FUNCTION(SBECMath, FpSub);
SB_PHP_FUNCTION(SBECMath, FpIsOne);
SB_PHP_FUNCTION(SBECMath, FpIsZero);
SB_PHP_FUNCTION(SBECMath, FpReduce);
SB_PHP_FUNCTION(SBECMath, FpMul);
SB_PHP_FUNCTION(SBECMath, FpSqr);
SB_PHP_FUNCTION(SBECMath, FpDiv2);
SB_PHP_FUNCTION(SBECMath, FpInv);
SB_PHP_FUNCTION(SBECMath, FpDiv);
SB_PHP_FUNCTION(SBECMath, F2mPZero);
SB_PHP_FUNCTION(SBECMath, F2mPOne);
SB_PHP_FUNCTION(SBECMath, F2mPIsZero);
SB_PHP_FUNCTION(SBECMath, F2mPIsOne);
SB_PHP_FUNCTION(SBECMath, F2mPCmp);
SB_PHP_FUNCTION(SBECMath, F2mPAdd);
SB_PHP_FUNCTION(SBECMath, F2mPReduce);
SB_PHP_FUNCTION(SBECMath, F2mPMul);
SB_PHP_FUNCTION(SBECMath, F2mPSqr);
SB_PHP_FUNCTION(SBECMath, F2mPDivX);
SB_PHP_FUNCTION(SBECMath, F2mPDiv);
SB_PHP_FUNCTION(SBECMath, F2mPInv);
SB_PHP_FUNCTION(SBECMath, ECPFpDouble);
SB_PHP_FUNCTION(SBECMath, ECPFpAdd);
SB_PHP_FUNCTION(SBECMath, ECPFpJDouble);
SB_PHP_FUNCTION(SBECMath, ECPFpJAAdd);
SB_PHP_FUNCTION(SBECMath, ECPFpExpJA);
SB_PHP_FUNCTION(SBECMath, ECPFpExp);
SB_PHP_FUNCTION(SBECMath, ECPFpJ2A);
SB_PHP_FUNCTION(SBECMath, ECPFpPointOnCurve);
SB_PHP_FUNCTION(SBECMath, ECPF2mPDouble);
SB_PHP_FUNCTION(SBECMath, ECPF2mPAdd);
SB_PHP_FUNCTION(SBECMath, ECPF2mPLDDouble);
SB_PHP_FUNCTION(SBECMath, ECPF2mPLDAAdd);
SB_PHP_FUNCTION(SBECMath, ECPF2mPExpLDA);
SB_PHP_FUNCTION(SBECMath, ECPF2mPExp);
SB_PHP_FUNCTION(SBECMath, ECPF2mPLD2A);
SB_PHP_FUNCTION(SBECMath, ECPF2mPPointOnCurve);
SB_PHP_FUNCTION(SBECMath, CryptoScalarMult);

#ifdef __cplusplus
extern "C" {
#endif

#ifdef SB_USE_GLOBAL_PROCS_ECMATH
SB_IMPORT uint32_t SB_APIENTRY SBECMath_GetFieldByP(PLInt * P, int32_t * Field, int32_t * FldType);
SB_IMPORT uint32_t SB_APIENTRY SBECMath_GetBinaryFieldK(PLInt P, int32_t * M, int32_t * K1, int32_t * K2, int32_t * K3);
SB_IMPORT uint32_t SB_APIENTRY SBECMath_SetBinaryFieldK(PLInt * P, int32_t M, int32_t K1, int32_t K2, int32_t K3);
SB_IMPORT uint32_t SB_APIENTRY SBECMath_ECPFpDecompress(int32_t yp, PLInt X, PLInt A, PLInt B, PLInt P, PLInt * Y, int32_t Field, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY SBECMath_ECPF2mPDecompress(int32_t yp, PLInt X, PLInt A, PLInt B, PLInt P, PLInt * Y, int32_t Field, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY SBECMath_ECPF2mPGetYpBit(PLInt X, PLInt Y, PLInt P, int32_t Field, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY SBECMath_FpZero(PLInt * A, PLInt P);
SB_IMPORT uint32_t SB_APIENTRY SBECMath_FpOne(PLInt * A, PLInt P);
SB_IMPORT uint32_t SB_APIENTRY SBECMath_FpInt(PLInt * A, PLInt P, uint32_t C);
SB_IMPORT uint32_t SB_APIENTRY SBECMath_FpCmp(PLInt A, PLInt B, PLInt P, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY SBECMath_FpAdd(PLInt A, PLInt B, PLInt P, PLInt * C);
SB_IMPORT uint32_t SB_APIENTRY SBECMath_FpSub(PLInt A, PLInt B, PLInt P, PLInt * C);
SB_IMPORT uint32_t SB_APIENTRY SBECMath_FpIsOne(PLInt A, PLInt P, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY SBECMath_FpIsZero(PLInt A, PLInt P, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY SBECMath_FpReduce(PLInt * A, PLInt P, PLInt T1, PLInt T2, int32_t Field);
SB_IMPORT uint32_t SB_APIENTRY SBECMath_FpMul(PLInt A, PLInt B, PLInt P, PLInt T1, PLInt T2, PLInt * C, int32_t Field);
SB_IMPORT uint32_t SB_APIENTRY SBECMath_FpSqr(PLInt A, PLInt P, PLInt T1, PLInt T2, PLInt * C, int32_t Field);
SB_IMPORT uint32_t SB_APIENTRY SBECMath_FpDiv2(PLInt A, PLInt P, PLInt * C);
SB_IMPORT uint32_t SB_APIENTRY SBECMath_FpInv(PLInt A, PLInt P, PLInt * C, int32_t Field);
SB_IMPORT uint32_t SB_APIENTRY SBECMath_FpDiv(PLInt A, PLInt B, PLInt P, PLInt * C, int32_t Field);
SB_IMPORT uint32_t SB_APIENTRY SBECMath_F2mPZero(PLInt * A, PLInt P);
SB_IMPORT uint32_t SB_APIENTRY SBECMath_F2mPOne(PLInt * A, PLInt P);
SB_IMPORT uint32_t SB_APIENTRY SBECMath_F2mPIsZero(PLInt A, PLInt P, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY SBECMath_F2mPIsOne(PLInt A, PLInt P, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY SBECMath_F2mPCmp(PLInt A, PLInt B, PLInt P, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY SBECMath_F2mPAdd(PLInt A, PLInt B, PLInt P, PLInt * C);
SB_IMPORT uint32_t SB_APIENTRY SBECMath_F2mPReduce(PLInt * A, PLInt P, int32_t Field);
SB_IMPORT uint32_t SB_APIENTRY SBECMath_F2mPMul(PLInt A, PLInt B, PLInt P, PLInt * T1, PLInt * C, int32_t Field);
SB_IMPORT uint32_t SB_APIENTRY SBECMath_F2mPSqr(PLInt A, PLInt P, PLInt * C, int32_t Field);
SB_IMPORT uint32_t SB_APIENTRY SBECMath_F2mPDivX(PLInt A, PLInt P, PLInt * C);
SB_IMPORT uint32_t SB_APIENTRY SBECMath_F2mPDiv(PLInt A, PLInt B, PLInt P, PLInt * C);
SB_IMPORT uint32_t SB_APIENTRY SBECMath_F2mPInv(PLInt A, PLInt P, PLInt * C);
SB_IMPORT uint32_t SB_APIENTRY SBECMath_ECPFpDouble(PLInt x1, PLInt y1, PLInt P, PLInt A, PLInt * x3, PLInt * y3, int32_t Field);
SB_IMPORT uint32_t SB_APIENTRY SBECMath_ECPFpAdd(PLInt x1, PLInt y1, PLInt x2, PLInt y2, PLInt P, PLInt A, PLInt * x3, PLInt * y3, int32_t Field);
SB_IMPORT uint32_t SB_APIENTRY SBECMath_ECPFpJDouble(PLInt X1, PLInt Y1, PLInt Z1, PLInt P, PLInt * X3, PLInt * Y3, PLInt * Z3, int32_t Field);
SB_IMPORT uint32_t SB_APIENTRY SBECMath_ECPFpJDouble_1(PLInt X1, PLInt Y1, PLInt Z1, PLInt P, PLInt A, PLInt * X3, PLInt * Y3, PLInt * Z3, int32_t Field);
SB_IMPORT uint32_t SB_APIENTRY SBECMath_ECPFpJAAdd(PLInt X1, PLInt Y1, PLInt Z1, PLInt x2, PLInt y2, PLInt P, PLInt * X3, PLInt * Y3, PLInt * Z3, int32_t Field);
SB_IMPORT uint32_t SB_APIENTRY SBECMath_ECPFpExpJA(PLInt x1, PLInt y1, PLInt P, PLInt A, PLInt n, PLInt * xr, PLInt * yr, int32_t Field);
SB_IMPORT uint32_t SB_APIENTRY SBECMath_ECPFpExp(PLInt x1, PLInt y1, PLInt P, PLInt A, PLInt n, PLInt * xr, PLInt * yr, int32_t Field);
SB_IMPORT uint32_t SB_APIENTRY SBECMath_ECPFpJ2A(PLInt X, PLInt Y, PLInt Z, PLInt P, PLInt * xr, PLInt * yr, int32_t Field);
SB_IMPORT uint32_t SB_APIENTRY SBECMath_ECPFpPointOnCurve(PLInt X, PLInt Y, PLInt A, PLInt B, PLInt P, int32_t Field, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY SBECMath_ECPF2mPDouble(PLInt x1, PLInt y1, PLInt a, PLInt b, PLInt P, PLInt * x3, PLInt * y3, int32_t Field);
SB_IMPORT uint32_t SB_APIENTRY SBECMath_ECPF2mPAdd(PLInt x1, PLInt y1, PLInt x2, PLInt y2, PLInt a, PLInt b, PLInt P, PLInt * x3, PLInt * y3, int32_t Field);
SB_IMPORT uint32_t SB_APIENTRY SBECMath_ECPF2mPLDDouble(PLInt X1, PLInt Y1, PLInt Z1, PLInt a, PLInt b, PLInt P, PLInt * X3, PLInt * Y3, PLInt * Z3, int32_t Field);
SB_IMPORT uint32_t SB_APIENTRY SBECMath_ECPF2mPLDAAdd(PLInt X1, PLInt Y1, PLInt Z1, PLInt x2, PLInt y2, PLInt a, PLInt b, PLInt P, PLInt * X3, PLInt * Y3, PLInt * Z3, int32_t Field);
SB_IMPORT uint32_t SB_APIENTRY SBECMath_ECPF2mPExpLDA(PLInt x1, PLInt y1, PLInt a, PLInt b, PLInt P, PLInt n, PLInt * xr, PLInt * yr, int32_t Field);
SB_IMPORT uint32_t SB_APIENTRY SBECMath_ECPF2mPExp(PLInt x1, PLInt y1, PLInt a, PLInt b, PLInt P, PLInt n, PLInt * xr, PLInt * yr, int32_t Field);
SB_IMPORT uint32_t SB_APIENTRY SBECMath_ECPF2mPLD2A(PLInt X, PLInt Y, PLInt Z, PLInt P, PLInt * xr, PLInt * yr, int32_t Field);
SB_IMPORT uint32_t SB_APIENTRY SBECMath_ECPF2mPPointOnCurve(PLInt X, PLInt Y, PLInt A, PLInt B, PLInt P, int32_t Field, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY SBECMath_CryptoScalarMult(const uint8_t pN[], int32_t szN, const uint8_t pP[], int32_t szP, const uint8_t pQ[], int32_t szQ);
#endif /* SB_USE_GLOBAL_PROCS_ECMATH */

#ifdef __cplusplus
};	/* extern "C" */
#endif

#ifdef __cplusplus
};	/* namespace SecureBlackbox */
#endif

#pragma pack(pop)

#endif  /* __INC_SBECMATH */

