#ifndef __INC_SBHTTPSSERVER
#define __INC_SBHTTPSSERVER

#if _MSC_VER > 1000
#  pragma once
#endif // _MSC_VER > 1000

#include "sbdefs.h"
#include "sbphpcore.h"
#include "sbsystem.h"
#include "sbcustomcertstorage.h"
#include "sbtypes.h"
#include "sbutils.h"
#include "sbstrutils.h"
#include "sbrandom.h"
#include "sbencoding.h"
#include "sbx509.h"
#include "sbstringlist.h"
#include "sbconstants.h"
#include "sbsslcommon.h"
#include "sbsslserver.h"
#include "sbsessionpool.h"
#include "sbsslconstants.h"
#include "sbstreams.h"
#ifdef SB_WINDOWS
#include "sbhttpauth.h"
#endif
#include "sbwebsocketcommon.h"
#include "sbwebsocketserver.h"
#include "sbsrp.h"
#include "sbhttpsconstants.h"
#include "sbhashfunction.h"
#include "sbhttpscommon.h"

#pragma pack(push, 1)

#ifdef __cplusplus
namespace SecureBlackbox {
#endif

#ifdef __cplusplus
extern "C" {
#endif
typedef TElClassHandle TElHTTPServerRequestParamsHandle;

typedef TElHTTPServerRequestParamsHandle ElHTTPServerRequestParamsHandle;

typedef TElClassHandle TElHTTPServerResponseParamsHandle;

typedef TElHTTPServerResponseParamsHandle ElHTTPServerResponseParamsHandle;

typedef TElClassHandle TElMultipartFormDataHandle;

typedef TElMultipartFormDataHandle ElMultipartFormDataHandle;

typedef TElClassHandle TElMultipartFormListHandle;

typedef TElMultipartFormListHandle ElMultipartFormListHandle;

typedef TElClassHandle TElHTTPSServerHandle;

typedef TElHTTPSServerHandle ElHTTPSServerHandle;

typedef TElClassHandle TElDigestAuthHandle;

typedef uint8_t TSBHTTPServerConnStageRaw;

typedef enum
{
	csHeader = 0,
	csBody = 1,
	csTunnel = 2
} TSBHTTPServerConnStage;

typedef void (SB_CALLBACK *TSBHTTPRequestHeadersEvent)(void * _ObjectData, TObjectHandle Sender, TElHTTPServerRequestParamsHandle RequestInfo, int8_t * Accepted);

typedef void (SB_CALLBACK *TSBHTTPAfterAuthorizationEvent)(void * _ObjectData, TObjectHandle Sender, TElHTTPServerRequestParamsHandle RequestInfo, int8_t * Accepted);

typedef void (SB_CALLBACK *TSBHTTPRequestBodyEvent)(void * _ObjectData, TObjectHandle Sender, TElHTTPServerRequestParamsHandle RequestInfo);

typedef void (SB_CALLBACK *TSBHTTPBeforeWebSocketServerUsedEvent)(void * _ObjectData, TObjectHandle Sender, TElWebSocketServerHandle WSServer);

typedef void (SB_CALLBACK *SBHTTPSServer_TSBHTTPWebSocketConnectionEstablishedEvent)(void * _ObjectData, TObjectHandle Sender, TElWebSocketServerHandle WSServer);

typedef void (SB_CALLBACK *TSBOnGetUserPasswordEvent)(void * _ObjectData, TObjectHandle Sender, TElHTTPServerRequestParamsHandle ReqParams, char * pcPassword, int32_t * szPassword, int8_t * Accept);

#ifdef SB_USE_CLASS_TELHTTPSERVERREQUESTPARAMS
SB_IMPORT uint32_t SB_APIENTRY TElHTTPServerRequestParams_Assign(TElHTTPServerRequestParamsHandle _Handle, TPersistentHandle Source);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPServerRequestParams_Clone(TElHTTPServerRequestParamsHandle _Handle, TObjectHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPServerRequestParams_get_CustomMethod(TElHTTPServerRequestParamsHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPServerRequestParams_set_CustomMethod(TElHTTPServerRequestParamsHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPServerRequestParams_get_Expects100Continue(TElHTTPServerRequestParamsHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPServerRequestParams_set_Expects100Continue(TElHTTPServerRequestParamsHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPServerRequestParams_get_HTTPVersion(TElHTTPServerRequestParamsHandle _Handle, TSBHTTPVersionRaw * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPServerRequestParams_set_HTTPVersion(TElHTTPServerRequestParamsHandle _Handle, TSBHTTPVersionRaw Value);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPServerRequestParams_get_KeepAlive(TElHTTPServerRequestParamsHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPServerRequestParams_set_KeepAlive(TElHTTPServerRequestParamsHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPServerRequestParams_get_Method(TElHTTPServerRequestParamsHandle _Handle, TSBHTTPMethodRaw * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPServerRequestParams_set_Method(TElHTTPServerRequestParamsHandle _Handle, TSBHTTPMethodRaw Value);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPServerRequestParams_get_URL(TElHTTPServerRequestParamsHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPServerRequestParams_set_URL(TElHTTPServerRequestParamsHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPServerRequestParams_get_Chunked(TElHTTPServerRequestParamsHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPServerRequestParams_get_PreferGzip(TElHTTPServerRequestParamsHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPServerRequestParams_get_AcceptGZip(TElHTTPServerRequestParamsHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPServerRequestParams_get_AcceptDeflate(TElHTTPServerRequestParamsHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPServerRequestParams_get_AcceptChunked(TElHTTPServerRequestParamsHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPServerRequestParams_get_AcceptIdentity(TElHTTPServerRequestParamsHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPServerRequestParams_get_AuthMethod(TElHTTPServerRequestParamsHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPServerRequestParams_get_RequireAuth(TElHTTPServerRequestParamsHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPServerRequestParams_set_RequireAuth(TElHTTPServerRequestParamsHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPServerRequestParams_get_WebSocketRequest(TElHTTPServerRequestParamsHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPServerRequestParams_Create(TElHTTPServerRequestParamsHandle * OutResult);
#endif /* SB_USE_CLASS_TELHTTPSERVERREQUESTPARAMS */

#ifdef SB_USE_CLASS_TELHTTPSERVERRESPONSEPARAMS
SB_IMPORT uint32_t SB_APIENTRY TElHTTPServerResponseParams_Assign(TElHTTPServerResponseParamsHandle _Handle, TPersistentHandle Source);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPServerResponseParams_Clone(TElHTTPServerResponseParamsHandle _Handle, TObjectHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPServerResponseParams_get_AcceptRanges(TElHTTPServerResponseParamsHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPServerResponseParams_set_AcceptRanges(TElHTTPServerResponseParamsHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPServerResponseParams_get_Location(TElHTTPServerResponseParamsHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPServerResponseParams_set_Location(TElHTTPServerResponseParamsHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPServerResponseParams_get_StatusCode(TElHTTPServerResponseParamsHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPServerResponseParams_set_StatusCode(TElHTTPServerResponseParamsHandle _Handle, int32_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPServerResponseParams_get_Expires(TElHTTPServerResponseParamsHandle _Handle, int64_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPServerResponseParams_set_Expires(TElHTTPServerResponseParamsHandle _Handle, int64_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPServerResponseParams_get_LastModified(TElHTTPServerResponseParamsHandle _Handle, int64_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPServerResponseParams_set_LastModified(TElHTTPServerResponseParamsHandle _Handle, int64_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPServerResponseParams_get_ReasonPhrase(TElHTTPServerResponseParamsHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPServerResponseParams_set_ReasonPhrase(TElHTTPServerResponseParamsHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPServerResponseParams_get_Server(TElHTTPServerResponseParamsHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPServerResponseParams_set_Server(TElHTTPServerResponseParamsHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPServerResponseParams_get_UseChunkedTransfer(TElHTTPServerResponseParamsHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPServerResponseParams_set_UseChunkedTransfer(TElHTTPServerResponseParamsHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPServerResponseParams_get_UseCompression(TElHTTPServerResponseParamsHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPServerResponseParams_set_UseCompression(TElHTTPServerResponseParamsHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPServerResponseParams_get_CompressionLevel(TElHTTPServerResponseParamsHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPServerResponseParams_set_CompressionLevel(TElHTTPServerResponseParamsHandle _Handle, int32_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPServerResponseParams_get_UseKeepAlive(TElHTTPServerResponseParamsHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPServerResponseParams_set_UseKeepAlive(TElHTTPServerResponseParamsHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPServerResponseParams_get_WebSocketResponse(TElHTTPServerResponseParamsHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPServerResponseParams_set_WebSocketResponse(TElHTTPServerResponseParamsHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPServerResponseParams_Create(TElHTTPServerResponseParamsHandle * OutResult);
#endif /* SB_USE_CLASS_TELHTTPSERVERRESPONSEPARAMS */

#ifdef SB_USE_CLASS_TELMULTIPARTFORMDATA
SB_IMPORT uint32_t SB_APIENTRY TElMultipartFormData_Parse(TElMultipartFormDataHandle _Handle, const uint8_t pBuffer[], int32_t szBuffer, int32_t Index, int32_t Size);
SB_IMPORT uint32_t SB_APIENTRY TElMultipartFormData_ParseStream(TElMultipartFormDataHandle _Handle, TStreamHandle Stream, const char * pcBoundary, int32_t szBoundary);
#ifdef SB_WINDOWS
SB_IMPORT uint32_t SB_APIENTRY TElMultipartFormData_get_Headers(TElMultipartFormDataHandle _Handle, TStringListHandle * OutResult);
#else
SB_IMPORT uint32_t SB_APIENTRY TElMultipartFormData_get_Headers(TElMultipartFormDataHandle _Handle, TElStringListHandle * OutResult);
#endif
SB_IMPORT uint32_t SB_APIENTRY TElMultipartFormData_get_Content(TElMultipartFormDataHandle _Handle, uint8_t pOutResult[], int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMultipartFormData_get_ContentStartPos(TElMultipartFormDataHandle _Handle, int64_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMultipartFormData_get_ContentSize(TElMultipartFormDataHandle _Handle, int64_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMultipartFormData_get_IsMultipart(TElMultipartFormDataHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMultipartFormData_get_Name(TElMultipartFormDataHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMultipartFormData_get_FileName(TElMultipartFormDataHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMultipartFormData_Create(TElMultipartFormDataHandle * OutResult);
#endif /* SB_USE_CLASS_TELMULTIPARTFORMDATA */

#ifdef SB_USE_CLASS_TELMULTIPARTFORMLIST
SB_IMPORT uint32_t SB_APIENTRY TElMultipartFormList_Assign(TElMultipartFormListHandle _Handle, TElMultipartFormDataHandle Src);
SB_IMPORT uint32_t SB_APIENTRY TElMultipartFormList_Parse(TElMultipartFormListHandle _Handle, TElHTTPServerRequestParamsHandle RequestInfo, const uint8_t pBuffer[], int32_t szBuffer, int32_t Index, int32_t Size);
SB_IMPORT uint32_t SB_APIENTRY TElMultipartFormList_Parse_1(TElMultipartFormDataHandle _Handle, const uint8_t pBuffer[], int32_t szBuffer, int32_t Index, int32_t Size);
SB_IMPORT uint32_t SB_APIENTRY TElMultipartFormList_ParseStream(TElMultipartFormListHandle _Handle, TElHTTPServerRequestParamsHandle RequestInfo, TStreamHandle Stream);
SB_IMPORT uint32_t SB_APIENTRY TElMultipartFormList_ParseStream_1(TElMultipartFormDataHandle _Handle, TStreamHandle Stream, const char * pcBoundary, int32_t szBoundary);
SB_IMPORT uint32_t SB_APIENTRY TElMultipartFormList_get_ValuesByName(TElMultipartFormListHandle _Handle, const char * pcName, int32_t szName, TElMultipartFormDataHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMultipartFormList_get_ValuesByFileName(TElMultipartFormListHandle _Handle, const char * pcName, int32_t szName, TElMultipartFormDataHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMultipartFormList_get_ValuesByIndex(TElMultipartFormListHandle _Handle, int32_t Idx, TElMultipartFormDataHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMultipartFormList_get_Count(TElMultipartFormListHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMultipartFormList_Create(TElMultipartFormListHandle * OutResult);
#endif /* SB_USE_CLASS_TELMULTIPARTFORMLIST */

#ifdef SB_USE_CLASS_TELHTTPSSERVER
SB_IMPORT uint32_t SB_APIENTRY TElHTTPSServer_Open(TElHTTPSServerHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPSServer_DataAvailable(TElHTTPSServerHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPSServer_Send100Continue(TElHTTPSServerHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPSServer_SendResponseHeaders(TElHTTPSServerHandle _Handle, TElHTTPServerRequestParamsHandle RequestParameters, TElHTTPServerResponseParamsHandle ResponseParameters);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPSServer_SendResponseData(TElHTTPSServerHandle _Handle, const uint8_t pBuffer[], int32_t szBuffer);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPSServer_SendResponseData_1(TElHTTPSServerHandle _Handle, const uint8_t pBuffer[], int32_t szBuffer, int32_t StartIndex, int32_t Count);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPSServer_SendResponseData_2(TElHTTPSServerHandle _Handle, void * Buffer, int32_t Size);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPSServer_SendResponseData_3(TElHTTPSServerHandle _Handle, TStreamHandle Strm);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPSServer_ResponseComplete(TElHTTPSServerHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPSServer_Close(TElHTTPSServerHandle _Handle, int8_t Silent);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPSServer_ParseMultipartFormData(TElHTTPSServerHandle _Handle, TElHTTPServerRequestParamsHandle RequestParameters, const uint8_t pBuffer[], int32_t szBuffer, TElMultipartFormListHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPSServer_ParseMultipartFormData_1(TElHTTPSServerHandle _Handle, TElHTTPServerRequestParamsHandle RequestParameters, TStreamHandle Strm, TElMultipartFormListHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPSServer_ParseMultipartFormData_2(TElHTTPSServerHandle _Handle, TElHTTPServerRequestParamsHandle RequestParameters, TStreamHandle Strm, int8_t LoadData, TElMultipartFormListHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPSServer_GetControl(TElHTTPSServerHandle _Handle, TElSSLClassHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPSServer_AddCertTypeHandler(TElHTTPSServerHandle _Handle, TElSSLCertificateTypeHandlerHandle Handler);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPSServer_RemoveCertTypeHandler(TElHTTPSServerHandle _Handle, TElSSLCertificateTypeHandlerHandle Handler);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPSServer_GetCertTypeHandler(TElHTTPSServerHandle _Handle, TElSSLCertificateTypeRaw CertType, TElSSLCertificateTypeHandlerHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPSServer_get_SSLCipherSuite(TElHTTPSServerHandle _Handle, uint8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPSServer_get_SSLCipherSuites(TElHTTPSServerHandle _Handle, uint8_t Index, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPSServer_set_SSLCipherSuites(TElHTTPSServerHandle _Handle, uint8_t Index, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPSServer_get_SSLCipherSuitePriorities(TElHTTPSServerHandle _Handle, uint8_t Index, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPSServer_set_SSLCipherSuitePriorities(TElHTTPSServerHandle _Handle, uint8_t Index, int32_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPSServer_get_SSLCompressionAlgorithms(TElHTTPSServerHandle _Handle, uint8_t Index, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPSServer_set_SSLCompressionAlgorithms(TElHTTPSServerHandle _Handle, uint8_t Index, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPSServer_get_SSLVersion(TElHTTPSServerHandle _Handle, TSBVersionRaw * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPSServer_get_SSLCompressionAlgorithm(TElHTTPSServerHandle _Handle, uint8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPSServer_get_SSLConnectionInfo(TElHTTPSServerHandle _Handle, TElSSLConnectionInfoHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPSServer_get_Active(TElHTTPSServerHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPSServer_get_AllowKeepAlive(TElHTTPSServerHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPSServer_set_AllowKeepAlive(TElHTTPSServerHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPSServer_get_AuthRealm(TElHTTPSServerHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPSServer_set_AuthRealm(TElHTTPSServerHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPSServer_get_AuthBasic(TElHTTPSServerHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPSServer_set_AuthBasic(TElHTTPSServerHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPSServer_get_AuthDigest(TElHTTPSServerHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPSServer_set_AuthDigest(TElHTTPSServerHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPSServer_get_AuthDigestExpire(TElHTTPSServerHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPSServer_set_AuthDigestExpire(TElHTTPSServerHandle _Handle, int32_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPSServer_get_CloseConnectionOnUnauthorizedData(TElHTTPSServerHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPSServer_set_CloseConnectionOnUnauthorizedData(TElHTTPSServerHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPSServer_get_SendForbiddenAuto(TElHTTPSServerHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPSServer_set_SendForbiddenAuto(TElHTTPSServerHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPSServer_get_SSLMode(TElHTTPSServerHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPSServer_set_SSLMode(TElHTTPSServerHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPSServer_get_SSLClientAuthentication(TElHTTPSServerHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPSServer_set_SSLClientAuthentication(TElHTTPSServerHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPSServer_get_SSLAuthenticationLevel(TElHTTPSServerHandle _Handle, TSBAuthenticationLevelRaw * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPSServer_set_SSLAuthenticationLevel(TElHTTPSServerHandle _Handle, TSBAuthenticationLevelRaw Value);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPSServer_get_SSLForceCertificateChain(TElHTTPSServerHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPSServer_set_SSLForceCertificateChain(TElHTTPSServerHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPSServer_get_CertStorage(TElHTTPSServerHandle _Handle, TElCustomCertStorageHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPSServer_set_CertStorage(TElHTTPSServerHandle _Handle, TElCustomCertStorageHandle Value);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPSServer_get_SSLSessionPool(TElHTTPSServerHandle _Handle, TElSessionPoolHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPSServer_set_SSLSessionPool(TElHTTPSServerHandle _Handle, TElSessionPoolHandle Value);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPSServer_get_ClientCertStorage(TElHTTPSServerHandle _Handle, TElCustomCertStorageHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPSServer_set_ClientCertStorage(TElHTTPSServerHandle _Handle, TElCustomCertStorageHandle Value);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPSServer_get_SSLVersions(TElHTTPSServerHandle _Handle, TSBVersionsRaw * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPSServer_set_SSLVersions(TElHTTPSServerHandle _Handle, TSBVersionsRaw Value);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPSServer_get_SSLExtensions(TElHTTPSServerHandle _Handle, TElServerSSLExtensionsHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPSServer_get_SSLPeerExtensions(TElHTTPSServerHandle _Handle, TElCustomSSLExtensionsHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPSServer_get_SSLOptions(TElHTTPSServerHandle _Handle, TSBSSLOptionsRaw * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPSServer_set_SSLOptions(TElHTTPSServerHandle _Handle, TSBSSLOptionsRaw Value);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPSServer_get_RenegotiationAttackPreventionMode(TElHTTPSServerHandle _Handle, TSBRenegotiationAttackPreventionModeRaw * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPSServer_set_RenegotiationAttackPreventionMode(TElHTTPSServerHandle _Handle, TSBRenegotiationAttackPreventionModeRaw Value);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPSServer_get_SRPCredentialStore(TElHTTPSServerHandle _Handle, TElSRPCredentialStoreHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPSServer_set_SRPCredentialStore(TElHTTPSServerHandle _Handle, TElSRPCredentialStoreHandle Value);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPSServer_get_OnGetSrpDb(TElHTTPSServerHandle _Handle, TSBServerSrpDbNeededEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPSServer_set_OnGetSrpDb(TElHTTPSServerHandle _Handle, TSBServerSrpDbNeededEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPSServer_get_OnSend(TElHTTPSServerHandle _Handle, TSBSendEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPSServer_set_OnSend(TElHTTPSServerHandle _Handle, TSBSendEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPSServer_get_OnReceive(TElHTTPSServerHandle _Handle, TSBReceiveEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPSServer_set_OnReceive(TElHTTPSServerHandle _Handle, TSBReceiveEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPSServer_get_OnData(TElHTTPSServerHandle _Handle, TSBDataEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPSServer_set_OnData(TElHTTPSServerHandle _Handle, TSBDataEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPSServer_get_OnOpenConnection(TElHTTPSServerHandle _Handle, TSBOpenConnectionEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPSServer_set_OnOpenConnection(TElHTTPSServerHandle _Handle, TSBOpenConnectionEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPSServer_get_OnCertificateValidate(TElHTTPSServerHandle _Handle, TSBCertificateValidateEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPSServer_set_OnCertificateValidate(TElHTTPSServerHandle _Handle, TSBCertificateValidateEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPSServer_get_OnCiphersNegotiated(TElHTTPSServerHandle _Handle, TNotifyEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPSServer_set_OnCiphersNegotiated(TElHTTPSServerHandle _Handle, TNotifyEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPSServer_get_OnSSLError(TElHTTPSServerHandle _Handle, TSBErrorEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPSServer_set_OnSSLError(TElHTTPSServerHandle _Handle, TSBErrorEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPSServer_get_OnExtensionsReceived(TElHTTPSServerHandle _Handle, TSBExtensionsReceivedEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPSServer_set_OnExtensionsReceived(TElHTTPSServerHandle _Handle, TSBExtensionsReceivedEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPSServer_get_OnExtensionsPrepared(TElHTTPSServerHandle _Handle, TSBExtensionsPreparedEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPSServer_set_OnExtensionsPrepared(TElHTTPSServerHandle _Handle, TSBExtensionsPreparedEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPSServer_get_OnKeyNeeded(TElHTTPSServerHandle _Handle, TSBServerKeyNeededEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPSServer_set_OnKeyNeeded(TElHTTPSServerHandle _Handle, TSBServerKeyNeededEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPSServer_get_OnCloseConnection(TElHTTPSServerHandle _Handle, TSBCloseConnectionEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPSServer_set_OnCloseConnection(TElHTTPSServerHandle _Handle, TSBCloseConnectionEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPSServer_get_OnRenegotiationStart(TElHTTPSServerHandle _Handle, TSBRenegotiationStartEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPSServer_set_OnRenegotiationStart(TElHTTPSServerHandle _Handle, TSBRenegotiationStartEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPSServer_get_OnCertificateURLs(TElHTTPSServerHandle _Handle, TSBCertificateURLsEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPSServer_set_OnCertificateURLs(TElHTTPSServerHandle _Handle, TSBCertificateURLsEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPSServer_get_OnPreparedHeaders(TElHTTPSServerHandle _Handle, TSBHTTPHeadersEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPSServer_set_OnPreparedHeaders(TElHTTPSServerHandle _Handle, TSBHTTPHeadersEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPSServer_get_OnRequestHeadersReceived(TElHTTPSServerHandle _Handle, TSBHTTPRequestHeadersEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPSServer_set_OnRequestHeadersReceived(TElHTTPSServerHandle _Handle, TSBHTTPRequestHeadersEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPSServer_get_OnAfterAuthorization(TElHTTPSServerHandle _Handle, TSBHTTPAfterAuthorizationEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPSServer_set_OnAfterAuthorization(TElHTTPSServerHandle _Handle, TSBHTTPAfterAuthorizationEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPSServer_get_OnRequestBodyReceived(TElHTTPSServerHandle _Handle, TSBHTTPRequestBodyEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPSServer_set_OnRequestBodyReceived(TElHTTPSServerHandle _Handle, TSBHTTPRequestBodyEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPSServer_get_OnGetUserPassword(TElHTTPSServerHandle _Handle, TSBOnGetUserPasswordEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPSServer_set_OnGetUserPassword(TElHTTPSServerHandle _Handle, TSBOnGetUserPasswordEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPSServer_get_OnBeforeWebSocketServerUsed(TElHTTPSServerHandle _Handle, TSBHTTPBeforeWebSocketServerUsedEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPSServer_set_OnBeforeWebSocketServerUsed(TElHTTPSServerHandle _Handle, TSBHTTPBeforeWebSocketServerUsedEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPSServer_get_OnWebSocketConnectionEstablished(TElHTTPSServerHandle _Handle, SBHTTPSServer_TSBHTTPWebSocketConnectionEstablishedEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPSServer_set_OnWebSocketConnectionEstablished(TElHTTPSServerHandle _Handle, SBHTTPSServer_TSBHTTPWebSocketConnectionEstablishedEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElHTTPSServer_Create(TComponentHandle AOwner, TElHTTPSServerHandle * OutResult);
#endif /* SB_USE_CLASS_TELHTTPSSERVER */

#ifdef SB_USE_CLASS_TELDIGESTAUTH
SB_IMPORT uint32_t SB_APIENTRY TElDigestAuth_Init(TElDigestAuthHandle _Handle, const char * pcUserParams, int32_t szUserParams);
SB_IMPORT uint32_t SB_APIENTRY TElDigestAuth_CalcHash(TElDigestAuthHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElDigestAuth_get_Nonce(TElDigestAuthHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElDigestAuth_set_Nonce(TElDigestAuthHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElDigestAuth_get_Password(TElDigestAuthHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElDigestAuth_set_Password(TElDigestAuthHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElDigestAuth_get_RequestMethod(TElDigestAuthHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElDigestAuth_set_RequestMethod(TElDigestAuthHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElDigestAuth_get_RequestURI(TElDigestAuthHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElDigestAuth_set_RequestURI(TElDigestAuthHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElDigestAuth_get_Response(TElDigestAuthHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElDigestAuth_set_Response(TElDigestAuthHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElDigestAuth_get_UserName(TElDigestAuthHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElDigestAuth_set_UserName(TElDigestAuthHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElDigestAuth_Create(TObjectHandle * OutResult);
#endif /* SB_USE_CLASS_TELDIGESTAUTH */

#ifdef __cplusplus
};	/* extern "C" */
#endif

extern zend_class_entry *TElHTTPServerRequestParams_ce_ptr;
extern zend_class_entry *TElHTTPServerResponseParams_ce_ptr;
extern zend_class_entry *TElMultipartFormData_ce_ptr;
extern zend_class_entry *TElMultipartFormList_ce_ptr;
extern zend_class_entry *TElHTTPSServer_ce_ptr;
extern zend_class_entry *TElDigestAuth_ce_ptr;

void SB_CALLBACK TSBHTTPRequestHeadersEventRaw(void * _ObjectData, TObjectHandle Sender, TElHTTPServerRequestParamsHandle RequestInfo, int8_t * Accepted);
void SB_CALLBACK TSBHTTPAfterAuthorizationEventRaw(void * _ObjectData, TObjectHandle Sender, TElHTTPServerRequestParamsHandle RequestInfo, int8_t * Accepted);
void SB_CALLBACK TSBHTTPRequestBodyEventRaw(void * _ObjectData, TObjectHandle Sender, TElHTTPServerRequestParamsHandle RequestInfo);
void SB_CALLBACK TSBHTTPBeforeWebSocketServerUsedEventRaw(void * _ObjectData, TObjectHandle Sender, TElWebSocketServerHandle WSServer);
void SB_CALLBACK SBHTTPSServer_TSBHTTPWebSocketConnectionEstablishedEventRaw(void * _ObjectData, TObjectHandle Sender, TElWebSocketServerHandle WSServer);
void SB_CALLBACK TSBOnGetUserPasswordEventRaw(void * _ObjectData, TObjectHandle Sender, TElHTTPServerRequestParamsHandle ReqParams, char * pcPassword, int32_t * szPassword, int8_t * Accept);
void Register_TElHTTPServerRequestParams(TSRMLS_D);
void Register_TElHTTPServerResponseParams(TSRMLS_D);
void Register_TElMultipartFormData(TSRMLS_D);
void Register_TElMultipartFormList(TSRMLS_D);
void Register_TElHTTPSServer(TSRMLS_D);
void Register_TElDigestAuth(TSRMLS_D);
SB_PHP_FUNCTION(SBHTTPSServer, GetDefaultReasonPhrase);
void Register_SBHTTPSServer_Enum_Flags(TSRMLS_D);
void Register_SBHTTPSServer_Aliases(TSRMLS_D);

#ifdef __cplusplus
extern "C" {
#endif

#ifdef SB_USE_GLOBAL_PROCS_HTTPSSERVER
SB_IMPORT uint32_t SB_APIENTRY SBHTTPSServer_GetDefaultReasonPhrase(int32_t ResponseCode, char * pcOutResult, int32_t * szOutResult);
#endif /* SB_USE_GLOBAL_PROCS_HTTPSSERVER */

#ifdef __cplusplus
};	/* extern "C" */
#endif

#ifdef __cplusplus
};	/* namespace SecureBlackbox */
#endif

#pragma pack(pop)

#endif  /* __INC_SBHTTPSSERVER */
