#ifndef __INC_SBONEDRIVEDATASTORAGE
#define __INC_SBONEDRIVEDATASTORAGE

#if _MSC_VER > 1000
#  pragma once
#endif // _MSC_VER > 1000

#include "sbdefs.h"
#include "sbphpcore.h"
#include "sbsystem.h"
#include "sbconstants.h"
#include "sbtypes.h"
#include "sbutils.h"
#include "sbstreams.h"
#include "sbencoding.h"
#include "sbstringlist.h"
#include "sbdatastorage.h"
#include "sbdatastorageutils.h"
#include "sbstrutils.h"
#include "sbjson.h"
#include "sboauth2.h"
#include "sbhttpsconstants.h"
#include "sbhttpscommon.h"
#include "sbhttpsclient.h"

#pragma pack(push, 1)

#ifdef __cplusplus
namespace SecureBlackbox {
#endif

#ifdef __cplusplus
extern "C" {
#endif
typedef TElClassHandle TElOneDriveDataStorageHandle;

typedef TElClassHandle TElOneDriveDataStorageObjectHandle;

typedef TElClassHandle TElOneDriveFolderHandle;

typedef TElClassHandle TElOneDriveCommentsHandle;

typedef TElClassHandle TElOneDriveTagsHandle;

typedef TElClassHandle TElOneDriveTaggedObjectHandle;

typedef TElClassHandle TElOneDriveFriendHandle;

typedef TElClassHandle TElOneDriveCommentHandle;

typedef TElClassHandle TElOneDriveFileHandle;

typedef TElClassHandle TElOneDriveTagHandle;

typedef TElClassHandle TElOneDriveNotebookHandle;

typedef TElClassHandle TElOneDriveAudioHandle;

typedef TElClassHandle TElOneDrivePhotoHandle;

typedef TElClassHandle TElOneDrivePhotoImageHandle;

typedef TElClassHandle TElOneDrivePhotoImagesHandle;

typedef TElClassHandle TElOneDriveVideoHandle;

typedef TElClassHandle TElOneDriveAlbumHandle;

typedef TElClassHandle TElOneDriveUserInfoHandle;

#ifdef SB_USE_CLASS_TELONEDRIVEDATASTORAGE
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveDataStorage_StartAuthorization(TElOneDriveDataStorageHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveDataStorage_CompleteAuthorization(TElOneDriveDataStorageHandle _Handle, const char * pcAuthorizationCode, int32_t szAuthorizationCode);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveDataStorage_AcquireObject(TElOneDriveDataStorageHandle _Handle, const char * pcObjectID, int32_t szObjectID, TElOneDriveDataStorageObjectHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveDataStorage_AcquireObject_1(TElCustomDataStorageHandle _Handle, TElCustomDataStorageObjectHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveDataStorage_CloseSession(TElOneDriveDataStorageHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveDataStorage_CopyObject(TElOneDriveDataStorageHandle _Handle, TElOneDriveDataStorageObjectHandle Obj, TElOneDriveFolderHandle Destination, TElOneDriveDataStorageObjectHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveDataStorage_CopyObject_1(TElCustomDataStorageHandle _Handle, TElCustomDataStorageObjectHandle Obj, TElCustomDataStorageSecurityHandlerHandle NewHandler, TElCustomDataStorageObjectHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveDataStorage_CreateFolder(TElOneDriveDataStorageHandle _Handle, TElOneDriveFolderHandle Parent, const char * pcName, int32_t szName, const char * pcDescription, int32_t szDescription, TElOneDriveFolderHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveDataStorage_CreateObject(TElOneDriveDataStorageHandle _Handle, TElOneDriveFolderHandle Parent, const char * pcName, int32_t szName, int8_t OverwriteIfExists, TElOneDriveFileHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveDataStorage_CreateObject_1(TElOneDriveDataStorageHandle _Handle, TElOneDriveFolderHandle Parent, const char * pcName, int32_t szName, int8_t OverwriteIfExists, TElCustomDataStorageSecurityHandlerHandle Handler, TElOneDriveFileHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveDataStorage_GetQuota(TElOneDriveDataStorageHandle _Handle, int64_t * Total, int64_t * Free);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveDataStorage_GetUserInfo(TElOneDriveDataStorageHandle _Handle, TElOneDriveUserInfoHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveDataStorage_GetUserInfo_1(TElOneDriveDataStorageHandle _Handle, const char * pcUserID, int32_t szUserID, TElOneDriveUserInfoHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveDataStorage_List(TElOneDriveDataStorageHandle _Handle, TElOneDriveFolderHandle Dir, TElDataStorageObjectListHandle Objects);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveDataStorage_List_1(TElCustomDataStorageHandle _Handle, TElDataStorageObjectListHandle Objs);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveDataStorage_ListFriendly(TElOneDriveDataStorageHandle _Handle, const char * pcFriendlyName, int32_t szFriendlyName, TElDataStorageObjectListHandle Objects);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveDataStorage_ListRecent(TElOneDriveDataStorageHandle _Handle, TElDataStorageObjectListHandle Objects);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveDataStorage_ListShared(TElOneDriveDataStorageHandle _Handle, TElDataStorageObjectListHandle Objects);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveDataStorage_MoveObject(TElOneDriveDataStorageHandle _Handle, TElOneDriveDataStorageObjectHandle Obj, TElOneDriveFolderHandle Destination);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveDataStorage_RefreshObject(TElOneDriveDataStorageHandle _Handle, TElOneDriveDataStorageObjectHandle Obj);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveDataStorage_RenameObject(TElOneDriveDataStorageHandle _Handle, TElOneDriveDataStorageObjectHandle Obj, const char * pcNewName, int32_t szNewName);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveDataStorage_Search(TElOneDriveDataStorageHandle _Handle, const char * pcQuery, int32_t szQuery, TElDataStorageObjectListHandle Objects);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveDataStorage_get_AccessToken(TElOneDriveDataStorageHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveDataStorage_get_ClientID(TElOneDriveDataStorageHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveDataStorage_set_ClientID(TElOneDriveDataStorageHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveDataStorage_get_ClientSecret(TElOneDriveDataStorageHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveDataStorage_set_ClientSecret(TElOneDriveDataStorageHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveDataStorage_get_HTTPClient(TElOneDriveDataStorageHandle _Handle, TElHTTPSClientHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveDataStorage_set_HTTPClient(TElOneDriveDataStorageHandle _Handle, TElHTTPSClientHandle Value);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveDataStorage_get_Locale(TElOneDriveDataStorageHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveDataStorage_set_Locale(TElOneDriveDataStorageHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveDataStorage_get_Overwrite(TElOneDriveDataStorageHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveDataStorage_set_Overwrite(TElOneDriveDataStorageHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveDataStorage_get_PassthroughMode(TElOneDriveDataStorageHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveDataStorage_set_PassthroughMode(TElOneDriveDataStorageHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveDataStorage_get_ReadOnly(TElOneDriveDataStorageHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveDataStorage_set_ReadOnly(TElOneDriveDataStorageHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveDataStorage_get_RefreshToken(TElOneDriveDataStorageHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveDataStorage_set_RefreshToken(TElOneDriveDataStorageHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveDataStorage_get_ChunkedUploadChunkSize(TElOneDriveDataStorageHandle _Handle, int64_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveDataStorage_set_ChunkedUploadChunkSize(TElOneDriveDataStorageHandle _Handle, int64_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveDataStorage_get_ChunkedUploadThreshold(TElOneDriveDataStorageHandle _Handle, int64_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveDataStorage_set_ChunkedUploadThreshold(TElOneDriveDataStorageHandle _Handle, int64_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveDataStorage_Create(TComponentHandle AOwner, TElOneDriveDataStorageHandle * OutResult);
#endif /* SB_USE_CLASS_TELONEDRIVEDATASTORAGE */

#ifdef SB_USE_CLASS_TELONEDRIVEDATASTORAGEOBJECT
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveDataStorageObject_Assign(TElOneDriveDataStorageObjectHandle _Handle, TElCustomDataStorageObjectHandle Source);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveDataStorageObject_Clear(TElOneDriveDataStorageObjectHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveDataStorageObject_Clone(TElOneDriveDataStorageObjectHandle _Handle, TElCustomDataStorageObjectHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveDataStorageObject_Copy(TElOneDriveDataStorageObjectHandle _Handle, TElOneDriveFolderHandle Destination, TElOneDriveDataStorageObjectHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveDataStorageObject_Delete(TElOneDriveDataStorageObjectHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveDataStorageObject_Move(TElOneDriveDataStorageObjectHandle _Handle, TElOneDriveFolderHandle Destination);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveDataStorageObject_Refresh(TElOneDriveDataStorageObjectHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveDataStorageObject_Rename(TElOneDriveDataStorageObjectHandle _Handle, const char * pcNewName, int32_t szNewName);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveDataStorageObject_get_ClientUpdatedTime(TElOneDriveDataStorageObjectHandle _Handle, int64_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveDataStorageObject_get_Comments(TElOneDriveDataStorageObjectHandle _Handle, TElOneDriveCommentsHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveDataStorageObject_get_CreatedTime(TElOneDriveDataStorageObjectHandle _Handle, int64_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveDataStorageObject_get_Description(TElOneDriveDataStorageObjectHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveDataStorageObject_set_Description(TElOneDriveDataStorageObjectHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveDataStorageObject_get_From(TElOneDriveDataStorageObjectHandle _Handle, TElOneDriveFriendHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveDataStorageObject_get_ID(TElOneDriveDataStorageObjectHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveDataStorageObject_get_IsEmbeddable(TElOneDriveDataStorageObjectHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveDataStorageObject_get_Link(TElOneDriveDataStorageObjectHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveDataStorageObject_get_ObjectType(TElOneDriveDataStorageObjectHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveDataStorageObject_get_ParentID(TElOneDriveDataStorageObjectHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveDataStorageObject_get_SharedWith(TElOneDriveDataStorageObjectHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveDataStorageObject_get_Size(TElOneDriveDataStorageObjectHandle _Handle, int64_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveDataStorageObject_get_Storage(TElOneDriveDataStorageObjectHandle _Handle, TElOneDriveDataStorageHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveDataStorageObject_get_UpdatedTime(TElOneDriveDataStorageObjectHandle _Handle, int64_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveDataStorageObject_get_UploadLocation(TElOneDriveDataStorageObjectHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveDataStorageObject_Create(TElOneDriveDataStorageHandle AStorage, TElOneDriveDataStorageObjectHandle * OutResult);
#endif /* SB_USE_CLASS_TELONEDRIVEDATASTORAGEOBJECT */

#ifdef SB_USE_CLASS_TELONEDRIVEFOLDER
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveFolder_Assign(TElOneDriveFolderHandle _Handle, TElCustomDataStorageObjectHandle Source);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveFolder_Clear(TElOneDriveFolderHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveFolder_Clone(TElOneDriveFolderHandle _Handle, TElCustomDataStorageObjectHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveFolder_CreateFolder(TElOneDriveFolderHandle _Handle, const char * pcName, int32_t szName, const char * pcDescription, int32_t szDescription, TElOneDriveFolderHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveFolder_CreateObject(TElOneDriveFolderHandle _Handle, const char * pcName, int32_t szName, int8_t OverwriteIfExists, TElOneDriveFileHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveFolder_CreateObject_1(TElOneDriveFolderHandle _Handle, const char * pcName, int32_t szName, int8_t OverwriteIfExists, TElCustomDataStorageSecurityHandlerHandle Handler, TElOneDriveFileHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveFolder_List(TElOneDriveFolderHandle _Handle, TElDataStorageObjectListHandle Objects);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveFolder_ListFolders(TElOneDriveFolderHandle _Handle, TElDataStorageObjectListHandle Objects);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveFolder_get_Count(TElOneDriveFolderHandle _Handle, uint32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveFolder_Create(TElOneDriveDataStorageHandle Storage, TElOneDriveFolderHandle * OutResult);
#endif /* SB_USE_CLASS_TELONEDRIVEFOLDER */

#ifdef SB_USE_CLASS_TELONEDRIVECOMMENTS
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveComments_Add(TElOneDriveCommentsHandle _Handle, const char * pcMessage, int32_t szMessage, TElOneDriveCommentHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveComments_Assign(TElOneDriveCommentsHandle _Handle, TElOneDriveCommentsHandle Source);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveComments_Clear(TElOneDriveCommentsHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveComments_Refresh(TElOneDriveCommentsHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveComments_get_Count(TElOneDriveCommentsHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveComments_get_Enabled(TElOneDriveCommentsHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveComments_get_Items(TElOneDriveCommentsHandle _Handle, int32_t Index, TElOneDriveCommentHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveComments_get_Owner(TElOneDriveCommentsHandle _Handle, TElOneDriveDataStorageObjectHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveComments_Create(TElOneDriveDataStorageObjectHandle AOwner, TElOneDriveCommentsHandle * OutResult);
#endif /* SB_USE_CLASS_TELONEDRIVECOMMENTS */

#ifdef SB_USE_CLASS_TELONEDRIVETAGS
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveTags_Assign(TElOneDriveTagsHandle _Handle, TElOneDriveTagsHandle Source);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveTags_Clear(TElOneDriveTagsHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveTags_Refresh(TElOneDriveTagsHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveTags_get_Count(TElOneDriveTagsHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveTags_get_Enabled(TElOneDriveTagsHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveTags_get_Items(TElOneDriveTagsHandle _Handle, int32_t Index, TElOneDriveTagHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveTags_get_Owner(TElOneDriveTagsHandle _Handle, TElOneDriveTaggedObjectHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveTags_Create(TElOneDriveTaggedObjectHandle AOwner, TElOneDriveTagsHandle * OutResult);
#endif /* SB_USE_CLASS_TELONEDRIVETAGS */

#ifdef SB_USE_CLASS_TELONEDRIVEFILE
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveFile_Assign(TElOneDriveFileHandle _Handle, TElCustomDataStorageObjectHandle Source);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveFile_CancelUpload(TElOneDriveFileHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveFile_Clear(TElOneDriveFileHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveFile_Clone(TElOneDriveFileHandle _Handle, TElCustomDataStorageObjectHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveFile_Read(TElOneDriveFileHandle _Handle, TStreamHandle Target);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveFile_Write(TElOneDriveFileHandle _Handle, TStreamHandle Source);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveFile_Write_1(TElOneDriveFileHandle _Handle, TStreamHandle Source, TElCustomDataStorageSecurityHandlerHandle Handler);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveFile_get_Source(TElOneDriveFileHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveFile_Create(TElOneDriveDataStorageHandle AStorage, TElOneDriveFileHandle * OutResult);
#endif /* SB_USE_CLASS_TELONEDRIVEFILE */

#ifdef SB_USE_CLASS_TELONEDRIVEFRIEND
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveFriend_Assign(TElOneDriveFriendHandle _Handle, TElOneDriveFriendHandle Source);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveFriend_Clear(TElOneDriveFriendHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveFriend_Clone(TElOneDriveFriendHandle _Handle, TElOneDriveFriendHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveFriend_get_ID(TElOneDriveFriendHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveFriend_get_Name(TElOneDriveFriendHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveFriend_Create(TElOneDriveFriendHandle * OutResult);
#endif /* SB_USE_CLASS_TELONEDRIVEFRIEND */

#ifdef SB_USE_CLASS_TELONEDRIVECOMMENT
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveComment_Clone(TElOneDriveCommentHandle _Handle, TElOneDriveCommentHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveComment_Delete(TElOneDriveCommentHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveComment_get_CreatedTime(TElOneDriveCommentHandle _Handle, int64_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveComment_get_From(TElOneDriveCommentHandle _Handle, TElOneDriveFriendHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveComment_get_ID(TElOneDriveCommentHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveComment_get_Message(TElOneDriveCommentHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveComment_Create(TElOneDriveCommentsHandle AOwner, TElOneDriveCommentHandle * OutResult);
#endif /* SB_USE_CLASS_TELONEDRIVECOMMENT */

#ifdef SB_USE_CLASS_TELONEDRIVETAGGEDOBJECT
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveTaggedObject_Assign(TElOneDriveTaggedObjectHandle _Handle, TElCustomDataStorageObjectHandle Source);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveTaggedObject_Clear(TElOneDriveTaggedObjectHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveTaggedObject_get_Tags(TElOneDriveTaggedObjectHandle _Handle, TElOneDriveTagsHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveTaggedObject_Create(TElOneDriveDataStorageHandle AStorage, TElOneDriveTaggedObjectHandle * OutResult);
#endif /* SB_USE_CLASS_TELONEDRIVETAGGEDOBJECT */

#ifdef SB_USE_CLASS_TELONEDRIVETAG
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveTag_Clone(TElOneDriveTagHandle _Handle, TElOneDriveTagHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveTag_get_CreatedTime(TElOneDriveTagHandle _Handle, int64_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveTag_get_ID(TElOneDriveTagHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveTag_get_User(TElOneDriveTagHandle _Handle, TElOneDriveFriendHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveTag_get_X(TElOneDriveTagHandle _Handle, double * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveTag_get_Y(TElOneDriveTagHandle _Handle, double * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveTag_Create(TElOneDriveTagsHandle AOwner, TElOneDriveTagHandle * OutResult);
#endif /* SB_USE_CLASS_TELONEDRIVETAG */

#ifdef SB_USE_CLASS_TELONEDRIVENOTEBOOK
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveNotebook_Create(TElOneDriveDataStorageHandle AStorage, TElOneDriveFileHandle * OutResult);
#endif /* SB_USE_CLASS_TELONEDRIVENOTEBOOK */

#ifdef SB_USE_CLASS_TELONEDRIVEAUDIO
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveAudio_Assign(TElOneDriveAudioHandle _Handle, TElCustomDataStorageObjectHandle Source);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveAudio_Clear(TElOneDriveAudioHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveAudio_Clone(TElOneDriveAudioHandle _Handle, TElCustomDataStorageObjectHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveAudio_get_Album(TElOneDriveAudioHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveAudio_set_Album(TElOneDriveAudioHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveAudio_get_AlbumArtist(TElOneDriveAudioHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveAudio_set_AlbumArtist(TElOneDriveAudioHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveAudio_get_Artist(TElOneDriveAudioHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveAudio_set_Artist(TElOneDriveAudioHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveAudio_get_Duration(TElOneDriveAudioHandle _Handle, int64_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveAudio_get_Genre(TElOneDriveAudioHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveAudio_set_Genre(TElOneDriveAudioHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveAudio_get_Picture(TElOneDriveAudioHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveAudio_get_Title(TElOneDriveAudioHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveAudio_set_Title(TElOneDriveAudioHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveAudio_Create(TElOneDriveDataStorageHandle AStorage, TElOneDriveAudioHandle * OutResult);
#endif /* SB_USE_CLASS_TELONEDRIVEAUDIO */

#ifdef SB_USE_CLASS_TELONEDRIVEPHOTO
SB_IMPORT uint32_t SB_APIENTRY TElOneDrivePhoto_Assign(TElOneDrivePhotoHandle _Handle, TElCustomDataStorageObjectHandle Source);
SB_IMPORT uint32_t SB_APIENTRY TElOneDrivePhoto_Clear(TElOneDrivePhotoHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElOneDrivePhoto_Clone(TElOneDrivePhotoHandle _Handle, TElCustomDataStorageObjectHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOneDrivePhoto_get_Altitude(TElOneDrivePhotoHandle _Handle, double * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOneDrivePhoto_get_CameraMaker(TElOneDrivePhotoHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOneDrivePhoto_get_CameraModel(TElOneDrivePhotoHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOneDrivePhoto_get_ExposureDenominator(TElOneDrivePhotoHandle _Handle, double * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOneDrivePhoto_get_ExposureNumerator(TElOneDrivePhotoHandle _Handle, double * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOneDrivePhoto_get_FocalLength(TElOneDrivePhotoHandle _Handle, double * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOneDrivePhoto_get_FocalRatio(TElOneDrivePhotoHandle _Handle, double * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOneDrivePhoto_get_Height(TElOneDrivePhotoHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOneDrivePhoto_get_Images(TElOneDrivePhotoHandle _Handle, TElOneDrivePhotoImagesHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOneDrivePhoto_get_Latitude(TElOneDrivePhotoHandle _Handle, double * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOneDrivePhoto_get_Longitude(TElOneDrivePhotoHandle _Handle, double * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOneDrivePhoto_get_Picture(TElOneDrivePhotoHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOneDrivePhoto_get_WhenTaken(TElOneDrivePhotoHandle _Handle, int64_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOneDrivePhoto_get_Width(TElOneDrivePhotoHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOneDrivePhoto_Create(TElOneDriveDataStorageHandle Storage, TElOneDrivePhotoHandle * OutResult);
#endif /* SB_USE_CLASS_TELONEDRIVEPHOTO */

#ifdef SB_USE_CLASS_TELONEDRIVEPHOTOIMAGE
SB_IMPORT uint32_t SB_APIENTRY TElOneDrivePhotoImage_Clear(TElOneDrivePhotoImageHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElOneDrivePhotoImage_Clone(TElOneDrivePhotoImageHandle _Handle, TElOneDrivePhotoImageHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOneDrivePhotoImage_get_Height(TElOneDrivePhotoImageHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOneDrivePhotoImage_get_ImageType(TElOneDrivePhotoImageHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOneDrivePhotoImage_get_Source(TElOneDrivePhotoImageHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOneDrivePhotoImage_get_Width(TElOneDrivePhotoImageHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOneDrivePhotoImage_Create(TElOneDrivePhotoImageHandle * OutResult);
#endif /* SB_USE_CLASS_TELONEDRIVEPHOTOIMAGE */

#ifdef SB_USE_CLASS_TELONEDRIVEPHOTOIMAGES
SB_IMPORT uint32_t SB_APIENTRY TElOneDrivePhotoImages_Assign(TElOneDrivePhotoImagesHandle _Handle, TElOneDrivePhotoImagesHandle Source);
SB_IMPORT uint32_t SB_APIENTRY TElOneDrivePhotoImages_Clear(TElOneDrivePhotoImagesHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElOneDrivePhotoImages_get_Album(TElOneDrivePhotoImagesHandle _Handle, TElOneDrivePhotoImageHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOneDrivePhotoImages_get_Count(TElOneDrivePhotoImagesHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOneDrivePhotoImages_get_Full(TElOneDrivePhotoImagesHandle _Handle, TElOneDrivePhotoImageHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOneDrivePhotoImages_get_Items(TElOneDrivePhotoImagesHandle _Handle, int32_t Index, TElOneDrivePhotoImageHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOneDrivePhotoImages_get_Normal(TElOneDrivePhotoImagesHandle _Handle, TElOneDrivePhotoImageHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOneDrivePhotoImages_get_Small(TElOneDrivePhotoImagesHandle _Handle, TElOneDrivePhotoImageHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOneDrivePhotoImages_Create(TElOneDrivePhotoImagesHandle * OutResult);
#endif /* SB_USE_CLASS_TELONEDRIVEPHOTOIMAGES */

#ifdef SB_USE_CLASS_TELONEDRIVEVIDEO
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveVideo_Assign(TElOneDriveVideoHandle _Handle, TElCustomDataStorageObjectHandle Source);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveVideo_Clear(TElOneDriveVideoHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveVideo_Clone(TElOneDriveVideoHandle _Handle, TElCustomDataStorageObjectHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveVideo_get_Bitrate(TElOneDriveVideoHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveVideo_get_Duration(TElOneDriveVideoHandle _Handle, int64_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveVideo_get_Height(TElOneDriveVideoHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveVideo_get_Picture(TElOneDriveVideoHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveVideo_get_Width(TElOneDriveVideoHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveVideo_Create(TElOneDriveDataStorageHandle Storage, TElOneDriveVideoHandle * OutResult);
#endif /* SB_USE_CLASS_TELONEDRIVEVIDEO */

#ifdef SB_USE_CLASS_TELONEDRIVEALBUM
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveAlbum_Clone(TElOneDriveAlbumHandle _Handle, TElCustomDataStorageObjectHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveAlbum_Create(TElOneDriveDataStorageHandle Storage, TElOneDriveFolderHandle * OutResult);
#endif /* SB_USE_CLASS_TELONEDRIVEALBUM */

#ifdef SB_USE_CLASS_TELONEDRIVEUSERINFO
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveUserInfo_Assign(TElOneDriveUserInfoHandle _Handle, TElOneDriveUserInfoHandle Source);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveUserInfo_Clear(TElOneDriveUserInfoHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveUserInfo_Clone(TElOneDriveUserInfoHandle _Handle, TElOneDriveUserInfoHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveUserInfo_Refresh(TElOneDriveUserInfoHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveUserInfo_get_FirstName(TElOneDriveUserInfoHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveUserInfo_set_FirstName(TElOneDriveUserInfoHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveUserInfo_get_Gender(TElOneDriveUserInfoHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveUserInfo_set_Gender(TElOneDriveUserInfoHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveUserInfo_get_ID(TElOneDriveUserInfoHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveUserInfo_set_ID(TElOneDriveUserInfoHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveUserInfo_get_LastName(TElOneDriveUserInfoHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveUserInfo_set_LastName(TElOneDriveUserInfoHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveUserInfo_get_Link(TElOneDriveUserInfoHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveUserInfo_set_Link(TElOneDriveUserInfoHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveUserInfo_get_Locale(TElOneDriveUserInfoHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveUserInfo_set_Locale(TElOneDriveUserInfoHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveUserInfo_get_Name(TElOneDriveUserInfoHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveUserInfo_set_Name(TElOneDriveUserInfoHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveUserInfo_get_UpdatedTime(TElOneDriveUserInfoHandle _Handle, int64_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveUserInfo_set_UpdatedTime(TElOneDriveUserInfoHandle _Handle, int64_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElOneDriveUserInfo_Create(TElOneDriveDataStorageHandle AStorage, TElOneDriveUserInfoHandle * OutResult);
#endif /* SB_USE_CLASS_TELONEDRIVEUSERINFO */

#ifdef __cplusplus
};	/* extern "C" */
#endif

extern zend_class_entry *TElOneDriveDataStorage_ce_ptr;
extern zend_class_entry *TElOneDriveDataStorageObject_ce_ptr;
extern zend_class_entry *TElOneDriveFolder_ce_ptr;
extern zend_class_entry *TElOneDriveComments_ce_ptr;
extern zend_class_entry *TElOneDriveTags_ce_ptr;
extern zend_class_entry *TElOneDriveFile_ce_ptr;
extern zend_class_entry *TElOneDriveFriend_ce_ptr;
extern zend_class_entry *TElOneDriveComment_ce_ptr;
extern zend_class_entry *TElOneDriveTaggedObject_ce_ptr;
extern zend_class_entry *TElOneDriveTag_ce_ptr;
extern zend_class_entry *TElOneDriveNotebook_ce_ptr;
extern zend_class_entry *TElOneDriveAudio_ce_ptr;
extern zend_class_entry *TElOneDrivePhoto_ce_ptr;
extern zend_class_entry *TElOneDrivePhotoImage_ce_ptr;
extern zend_class_entry *TElOneDrivePhotoImages_ce_ptr;
extern zend_class_entry *TElOneDriveVideo_ce_ptr;
extern zend_class_entry *TElOneDriveAlbum_ce_ptr;
extern zend_class_entry *TElOneDriveUserInfo_ce_ptr;

void Register_TElOneDriveDataStorage(TSRMLS_D);
void Register_TElOneDriveDataStorageObject(TSRMLS_D);
void Register_TElOneDriveFolder(TSRMLS_D);
void Register_TElOneDriveComments(TSRMLS_D);
void Register_TElOneDriveTags(TSRMLS_D);
void Register_TElOneDriveFile(TSRMLS_D);
void Register_TElOneDriveFriend(TSRMLS_D);
void Register_TElOneDriveComment(TSRMLS_D);
void Register_TElOneDriveTaggedObject(TSRMLS_D);
void Register_TElOneDriveTag(TSRMLS_D);
void Register_TElOneDriveNotebook(TSRMLS_D);
void Register_TElOneDriveAudio(TSRMLS_D);
void Register_TElOneDrivePhoto(TSRMLS_D);
void Register_TElOneDrivePhotoImage(TSRMLS_D);
void Register_TElOneDrivePhotoImages(TSRMLS_D);
void Register_TElOneDriveVideo(TSRMLS_D);
void Register_TElOneDriveAlbum(TSRMLS_D);
void Register_TElOneDriveUserInfo(TSRMLS_D);

#ifdef __cplusplus
};	/* namespace SecureBlackbox */
#endif

#pragma pack(pop)

#endif  /* __INC_SBONEDRIVEDATASTORAGE */

