#ifndef __INC_SBOTPSERVER
#define __INC_SBOTPSERVER

#if _MSC_VER > 1000
#  pragma once
#endif // _MSC_VER > 1000

#include "sbdefs.h"
#include "sbphpcore.h"
#include "sbsystem.h"
#include "sbtypes.h"
#include "sbutils.h"
#include "sbstrutils.h"
#include "sbxmlcore.h"
#include "sbconstants.h"
#include "sbotpcommon.h"

#pragma pack(push, 1)

#ifdef __cplusplus
namespace SecureBlackbox {
#endif

#ifdef __cplusplus
extern "C" {
#endif
#define SB_OTPUser 	"OTPUser"
#define SB_HOTPUser 	"HOTPUser"
#define SB_TOTPUser 	"TOTPUser"

typedef TElClassHandle TElOTPUserHandle;

typedef TElOTPUserHandle ElOTPUserHandle;

typedef TElClassHandle TElHOTPUserHandle;

typedef TElHOTPUserHandle ElHOTPUserHandle;

typedef TElClassHandle TElTOTPUserHandle;

typedef TElTOTPUserHandle ElTOTPUserHandle;

typedef TElClassHandle TElOTPUserFactoryHandle;

typedef TElOTPUserFactoryHandle ElOTPUserFactoryHandle;

typedef TElClassHandle TElOTPUserStorageHandle;

typedef TElOTPUserStorageHandle ElOTPUserStorageHandle;

typedef TElClassHandle TElOTPServerHandle;

typedef TElOTPServerHandle ElOTPServerHandle;

typedef TElClassHandle TElHOTPServerHandle;

typedef TElHOTPServerHandle ElHOTPServerHandle;

typedef TElClassHandle TElTOTPServerHandle;

typedef TElTOTPServerHandle ElTOTPServerHandle;

typedef TElClassHandle TElOTPUserClassHandle;

#ifdef SB_USE_CLASS_TELOTPUSER
SB_IMPORT uint32_t SB_APIENTRY TElOTPUser_Assign(TElOTPUserHandle _Handle, TElOTPUserHandle Source);
SB_IMPORT uint32_t SB_APIENTRY TElOTPUser_Clear(TElOTPUserHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElOTPUser_Clone(TElOTPUserHandle _Handle, TElOTPUserHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOTPUser_CreateInstance(TElOTPUserHandle _Handle, TElOTPUserHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOTPUser_LoadFromStream(TElOTPUserHandle _Handle, TStreamHandle Stream);
SB_IMPORT uint32_t SB_APIENTRY TElOTPUser_SaveToStream(TElOTPUserHandle _Handle, TStreamHandle Stream);
SB_IMPORT uint32_t SB_APIENTRY TElOTPUser_ClassType(TClassHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOTPUser_get_UserID(TElOTPUserHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOTPUser_set_UserID(TElOTPUserHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElOTPUser_get_KeySecret(TElOTPUserHandle _Handle, uint8_t pOutResult[], int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOTPUser_set_KeySecret(TElOTPUserHandle _Handle, const uint8_t pValue[], int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElOTPUser_get_PasswordLen(TElOTPUserHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOTPUser_set_PasswordLen(TElOTPUserHandle _Handle, int32_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElOTPUser_Create(TElOTPUserHandle * OutResult);
#endif /* SB_USE_CLASS_TELOTPUSER */

#ifdef SB_USE_CLASS_TELHOTPUSER
SB_IMPORT uint32_t SB_APIENTRY TElHOTPUser_Assign(TElHOTPUserHandle _Handle, TElOTPUserHandle Source);
SB_IMPORT uint32_t SB_APIENTRY TElHOTPUser_Clear(TElHOTPUserHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElHOTPUser_CreateInstance(TElHOTPUserHandle _Handle, TElOTPUserHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElHOTPUser_ClassType(TClassHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElHOTPUser_get_Counter(TElHOTPUserHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElHOTPUser_set_Counter(TElHOTPUserHandle _Handle, int32_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElHOTPUser_Create(TElHOTPUserHandle * OutResult);
#endif /* SB_USE_CLASS_TELHOTPUSER */

#ifdef SB_USE_CLASS_TELTOTPUSER
SB_IMPORT uint32_t SB_APIENTRY TElTOTPUser_Assign(TElTOTPUserHandle _Handle, TElOTPUserHandle Source);
SB_IMPORT uint32_t SB_APIENTRY TElTOTPUser_Clear(TElTOTPUserHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElTOTPUser_CreateInstance(TElTOTPUserHandle _Handle, TElOTPUserHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElTOTPUser_ClassType(TClassHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElTOTPUser_get_HashAlgorithm(TElTOTPUserHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElTOTPUser_set_HashAlgorithm(TElTOTPUserHandle _Handle, int32_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElTOTPUser_get_TimeInterval(TElTOTPUserHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElTOTPUser_set_TimeInterval(TElTOTPUserHandle _Handle, int32_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElTOTPUser_Create(TElTOTPUserHandle * OutResult);
#endif /* SB_USE_CLASS_TELTOTPUSER */

#ifdef SB_USE_CLASS_TELOTPUSERFACTORY
SB_IMPORT uint32_t SB_APIENTRY TElOTPUserFactory_RegisterClass(TElOTPUserFactoryHandle _Handle, TElOTPUserClassHandle cls);
SB_IMPORT uint32_t SB_APIENTRY TElOTPUserFactory_CreateInstance(TElOTPUserFactoryHandle _Handle, const char * pcName, int32_t szName, TElOTPUserHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOTPUserFactory_get_RegisteredClasses(TElOTPUserFactoryHandle _Handle, int32_t Index, TElOTPUserClassHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOTPUserFactory_get_RegisteredClassCount(TElOTPUserFactoryHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOTPUserFactory_Create(TElOTPUserFactoryHandle * OutResult);
#endif /* SB_USE_CLASS_TELOTPUSERFACTORY */

#ifdef SB_USE_CLASS_TELOTPUSERSTORAGE
SB_IMPORT uint32_t SB_APIENTRY TElOTPUserStorage_Add(TElOTPUserStorageHandle _Handle, TElOTPUserHandle User);
SB_IMPORT uint32_t SB_APIENTRY TElOTPUserStorage_Remove(TElOTPUserStorageHandle _Handle, int32_t Index);
SB_IMPORT uint32_t SB_APIENTRY TElOTPUserStorage_Clear(TElOTPUserStorageHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElOTPUserStorage_IndexOf(TElOTPUserStorageHandle _Handle, TElOTPUserHandle User, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOTPUserStorage_SaveToStream(TElOTPUserStorageHandle _Handle, TStreamHandle Stream);
SB_IMPORT uint32_t SB_APIENTRY TElOTPUserStorage_LoadFromStream(TElOTPUserStorageHandle _Handle, TStreamHandle Stream);
SB_IMPORT uint32_t SB_APIENTRY TElOTPUserStorage_get_Users(TElOTPUserStorageHandle _Handle, int32_t Index, TElOTPUserHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOTPUserStorage_get_Count(TElOTPUserStorageHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOTPUserStorage_Create(TComponentHandle AOwner, TElOTPUserStorageHandle * OutResult);
#endif /* SB_USE_CLASS_TELOTPUSERSTORAGE */

#ifdef SB_USE_CLASS_TELOTPSERVER
SB_IMPORT uint32_t SB_APIENTRY TElOTPServer_get_Delta(TElOTPServerHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOTPServer_set_Delta(TElOTPServerHandle _Handle, int32_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElOTPServer_get_OTPUserStorage(TElOTPServerHandle _Handle, TElOTPUserStorageHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOTPServer_set_OTPUserStorage(TElOTPServerHandle _Handle, TElOTPUserStorageHandle Value);
SB_IMPORT uint32_t SB_APIENTRY TElOTPServer_Create(TElOTPUserStorageHandle OTPUserStorage, TElOTPServerHandle * OutResult);
#endif /* SB_USE_CLASS_TELOTPSERVER */

#ifdef SB_USE_CLASS_TELHOTPSERVER
SB_IMPORT uint32_t SB_APIENTRY TElHOTPServer_IsPasswordValid(TElHOTPServerHandle _Handle, const char * pcUserId, int32_t szUserId, const char * pcPassword, int32_t szPassword, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElHOTPServer_IsPasswordValid_1(TElHOTPServerHandle _Handle, TElHOTPUserHandle User, const char * pcPassword, int32_t szPassword, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElHOTPServer_Create(TElOTPUserStorageHandle OTPUserStorage, TElHOTPServerHandle * OutResult);
#endif /* SB_USE_CLASS_TELHOTPSERVER */

#ifdef SB_USE_CLASS_TELTOTPSERVER
SB_IMPORT uint32_t SB_APIENTRY TElTOTPServer_IsPasswordValid(TElTOTPServerHandle _Handle, const char * pcUserId, int32_t szUserId, const char * pcPassword, int32_t szPassword, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElTOTPServer_IsPasswordValid_1(TElTOTPServerHandle _Handle, const char * pcUserId, int32_t szUserId, const char * pcPassword, int32_t szPassword, int64_t Time, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElTOTPServer_IsPasswordValid_2(TElTOTPServerHandle _Handle, TElTOTPUserHandle User, const char * pcPassword, int32_t szPassword, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElTOTPServer_IsPasswordValid_3(TElTOTPServerHandle _Handle, TElTOTPUserHandle User, const char * pcPassword, int32_t szPassword, int64_t Time, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElTOTPServer_Create(TElOTPUserStorageHandle OTPUserStorage, TElTOTPServerHandle * OutResult);
#endif /* SB_USE_CLASS_TELTOTPSERVER */

#ifdef __cplusplus
};	/* extern "C" */
#endif

extern zend_class_entry *TElOTPUserClass_ce_ptr;
extern zend_class_entry *TElOTPUser_ce_ptr;
extern zend_class_entry *TElHOTPUser_ce_ptr;
extern zend_class_entry *TElTOTPUser_ce_ptr;
extern zend_class_entry *TElOTPUserFactory_ce_ptr;
extern zend_class_entry *TElOTPUserStorage_ce_ptr;
extern zend_class_entry *TElOTPServer_ce_ptr;
extern zend_class_entry *TElHOTPServer_ce_ptr;
extern zend_class_entry *TElTOTPServer_ce_ptr;

void Register_TElOTPUser(TSRMLS_D);
void Register_TElHOTPUser(TSRMLS_D);
void Register_TElTOTPUser(TSRMLS_D);
void Register_TElOTPUserFactory(TSRMLS_D);
void Register_TElOTPUserStorage(TSRMLS_D);
void Register_TElOTPServer(TSRMLS_D);
void Register_TElHOTPServer(TSRMLS_D);
void Register_TElTOTPServer(TSRMLS_D);
void Register_SBOTPServer_Constants(int module_number TSRMLS_DC);
void Register_SBOTPServer_Aliases(TSRMLS_D);

#ifdef __cplusplus
};	/* namespace SecureBlackbox */
#endif

#pragma pack(pop)

#endif  /* __INC_SBOTPSERVER */

