#ifndef __INC_SBTARENTITIES
#define __INC_SBTARENTITIES

#if _MSC_VER > 1000
#  pragma once
#endif // _MSC_VER > 1000

#include "sbdefs.h"
#include "sbphpcore.h"
#include "sbsystem.h"
#include "sbconstants.h"
#include "sbtypes.h"
#include "sbutils.h"
#include "sbstrutils.h"
#include "sbtarutils.h"
#include "sbstreams.h"

#pragma pack(push, 1)

#ifdef __cplusplus
namespace SecureBlackbox {
#endif

#ifdef __cplusplus
extern "C" {
#endif
typedef TElClassHandle TElTarFileHeaderHandle;

typedef TElClassHandle TElBaseTarHeaderHandle;

typedef TElClassHandle TElUStarTarHeaderHandle;

typedef TElClassHandle TElTarProcessorHandle;

typedef void (SB_CALLBACK *TSBTarFileHeaderLoadedEvent)(void * _ObjectData, TObjectHandle Sender, TElTarFileHeaderHandle Header);

typedef void (SB_CALLBACK *TSBTarArchiveErrorEvent)(void * _ObjectData, TObjectHandle Sender, int32_t ErrorCode, const char * pcErrorMessage, int32_t szErrorMessage, int8_t * TryContinue);

#ifdef SB_USE_CLASS_TELTARFILEHEADER
SB_IMPORT uint32_t SB_APIENTRY TElTarFileHeader_Assign(TElTarFileHeaderHandle _Handle, TElTarFileHeaderHandle Source);
SB_IMPORT uint32_t SB_APIENTRY TElTarFileHeader_AssignTo(TElTarFileHeaderHandle _Handle, TElTarFileHeaderHandle Dest);
SB_IMPORT uint32_t SB_APIENTRY TElTarFileHeader_CalculateCheckSum(TElTarFileHeaderHandle _Handle, int64_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElTarFileHeader_get_Base(TElTarFileHeaderHandle _Handle, TElBaseTarHeaderHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElTarFileHeader_set_Base(TElTarFileHeaderHandle _Handle, TElBaseTarHeaderHandle Value);
SB_IMPORT uint32_t SB_APIENTRY TElTarFileHeader_get_HasUStar(TElTarFileHeaderHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElTarFileHeader_set_HasUStar(TElTarFileHeaderHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElTarFileHeader_get_UStar(TElTarFileHeaderHandle _Handle, TElUStarTarHeaderHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElTarFileHeader_set_UStar(TElTarFileHeaderHandle _Handle, TElUStarTarHeaderHandle Value);
SB_IMPORT uint32_t SB_APIENTRY TElTarFileHeader_get_LocalHeaderOffset(TElTarFileHeaderHandle _Handle, int64_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElTarFileHeader_set_LocalHeaderOffset(TElTarFileHeaderHandle _Handle, int64_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElTarFileHeader_get_FileSize(TElTarFileHeaderHandle _Handle, int64_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElTarFileHeader_set_FileSize(TElTarFileHeaderHandle _Handle, int64_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElTarFileHeader_Create(TElTarFileHeaderHandle * OutResult);
#endif /* SB_USE_CLASS_TELTARFILEHEADER */

#ifdef SB_USE_CLASS_TELBASETARHEADER
SB_IMPORT uint32_t SB_APIENTRY TElBaseTarHeader_Assign(TElBaseTarHeaderHandle _Handle, TElBaseTarHeaderHandle Source);
SB_IMPORT uint32_t SB_APIENTRY TElBaseTarHeader_AssignTo(TElBaseTarHeaderHandle _Handle, TElBaseTarHeaderHandle Dest);
SB_IMPORT uint32_t SB_APIENTRY TElBaseTarHeader_LoadFromBuffer(TElBaseTarHeaderHandle _Handle, const uint8_t pBuf[], int32_t szBuf);
SB_IMPORT uint32_t SB_APIENTRY TElBaseTarHeader_SaveToBuffer(TElBaseTarHeaderHandle _Handle, uint8_t pOutResult[], int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElBaseTarHeader_get_Name(TElBaseTarHeaderHandle _Handle, uint8_t pOutResult[], int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElBaseTarHeader_set_Name(TElBaseTarHeaderHandle _Handle, const uint8_t pValue[], int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElBaseTarHeader_get_Mode(TElBaseTarHeaderHandle _Handle, uint8_t pOutResult[], int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElBaseTarHeader_set_Mode(TElBaseTarHeaderHandle _Handle, const uint8_t pValue[], int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElBaseTarHeader_get_UID(TElBaseTarHeaderHandle _Handle, uint8_t pOutResult[], int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElBaseTarHeader_set_UID(TElBaseTarHeaderHandle _Handle, const uint8_t pValue[], int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElBaseTarHeader_get_GID(TElBaseTarHeaderHandle _Handle, uint8_t pOutResult[], int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElBaseTarHeader_set_GID(TElBaseTarHeaderHandle _Handle, const uint8_t pValue[], int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElBaseTarHeader_get_Size(TElBaseTarHeaderHandle _Handle, uint8_t pOutResult[], int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElBaseTarHeader_set_Size(TElBaseTarHeaderHandle _Handle, const uint8_t pValue[], int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElBaseTarHeader_get_MTime(TElBaseTarHeaderHandle _Handle, uint8_t pOutResult[], int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElBaseTarHeader_set_MTime(TElBaseTarHeaderHandle _Handle, const uint8_t pValue[], int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElBaseTarHeader_get_CheckSum(TElBaseTarHeaderHandle _Handle, uint8_t pOutResult[], int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElBaseTarHeader_set_CheckSum(TElBaseTarHeaderHandle _Handle, const uint8_t pValue[], int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElBaseTarHeader_get_TypeFlag(TElBaseTarHeaderHandle _Handle, uint8_t pOutResult[], int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElBaseTarHeader_set_TypeFlag(TElBaseTarHeaderHandle _Handle, const uint8_t pValue[], int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElBaseTarHeader_get_LinkName(TElBaseTarHeaderHandle _Handle, uint8_t pOutResult[], int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElBaseTarHeader_set_LinkName(TElBaseTarHeaderHandle _Handle, const uint8_t pValue[], int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElBaseTarHeader_Create(TElBaseTarHeaderHandle * OutResult);
#endif /* SB_USE_CLASS_TELBASETARHEADER */

#ifdef SB_USE_CLASS_TELUSTARTARHEADER
SB_IMPORT uint32_t SB_APIENTRY TElUStarTarHeader_Assign(TElUStarTarHeaderHandle _Handle, TElUStarTarHeaderHandle Source);
SB_IMPORT uint32_t SB_APIENTRY TElUStarTarHeader_AssignTo(TElUStarTarHeaderHandle _Handle, TElUStarTarHeaderHandle Dest);
SB_IMPORT uint32_t SB_APIENTRY TElUStarTarHeader_LoadFromBuffer(TElUStarTarHeaderHandle _Handle, const uint8_t pB[], int32_t szB);
SB_IMPORT uint32_t SB_APIENTRY TElUStarTarHeader_SaveToBuffer(TElUStarTarHeaderHandle _Handle, uint8_t pOutResult[], int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElUStarTarHeader_get_Magic(TElUStarTarHeaderHandle _Handle, uint8_t pOutResult[], int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElUStarTarHeader_set_Magic(TElUStarTarHeaderHandle _Handle, const uint8_t pValue[], int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElUStarTarHeader_get_UName(TElUStarTarHeaderHandle _Handle, uint8_t pOutResult[], int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElUStarTarHeader_set_UName(TElUStarTarHeaderHandle _Handle, const uint8_t pValue[], int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElUStarTarHeader_get_GName(TElUStarTarHeaderHandle _Handle, uint8_t pOutResult[], int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElUStarTarHeader_set_GName(TElUStarTarHeaderHandle _Handle, const uint8_t pValue[], int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElUStarTarHeader_get_DevMajor(TElUStarTarHeaderHandle _Handle, uint8_t pOutResult[], int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElUStarTarHeader_set_DevMajor(TElUStarTarHeaderHandle _Handle, const uint8_t pValue[], int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElUStarTarHeader_get_DevMinor(TElUStarTarHeaderHandle _Handle, uint8_t pOutResult[], int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElUStarTarHeader_set_DevMinor(TElUStarTarHeaderHandle _Handle, const uint8_t pValue[], int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElUStarTarHeader_get_Prefix(TElUStarTarHeaderHandle _Handle, uint8_t pOutResult[], int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElUStarTarHeader_set_Prefix(TElUStarTarHeaderHandle _Handle, const uint8_t pValue[], int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElUStarTarHeader_Create(TElUStarTarHeaderHandle * OutResult);
#endif /* SB_USE_CLASS_TELUSTARTARHEADER */

#ifdef SB_USE_CLASS_TELTARPROCESSOR
SB_IMPORT uint32_t SB_APIENTRY TElTarProcessor_Process(TElTarProcessorHandle _Handle, TStreamHandle Stream);
SB_IMPORT uint32_t SB_APIENTRY TElTarProcessor_DataAvailable(TElTarProcessorHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElTarProcessor_get_Processed(TElTarProcessorHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElTarProcessor_get_OnTarFileHeaderLoaded(TElTarProcessorHandle _Handle, TSBTarFileHeaderLoadedEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElTarProcessor_set_OnTarFileHeaderLoaded(TElTarProcessorHandle _Handle, TSBTarFileHeaderLoadedEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElTarProcessor_get_OnArchiveError(TElTarProcessorHandle _Handle, TSBTarArchiveErrorEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElTarProcessor_set_OnArchiveError(TElTarProcessorHandle _Handle, TSBTarArchiveErrorEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElTarProcessor_Create(TElTarProcessorHandle * OutResult);
#endif /* SB_USE_CLASS_TELTARPROCESSOR */

#ifdef __cplusplus
};	/* extern "C" */
#endif

extern zend_class_entry *TElTarFileHeader_ce_ptr;
extern zend_class_entry *TElBaseTarHeader_ce_ptr;
extern zend_class_entry *TElUStarTarHeader_ce_ptr;
extern zend_class_entry *TElTarProcessor_ce_ptr;

void SB_CALLBACK TSBTarFileHeaderLoadedEventRaw(void * _ObjectData, TObjectHandle Sender, TElTarFileHeaderHandle Header);
void SB_CALLBACK TSBTarArchiveErrorEventRaw(void * _ObjectData, TObjectHandle Sender, int32_t ErrorCode, const char * pcErrorMessage, int32_t szErrorMessage, int8_t * TryContinue);
void Register_TElTarFileHeader(TSRMLS_D);
void Register_TElBaseTarHeader(TSRMLS_D);
void Register_TElUStarTarHeader(TSRMLS_D);
void Register_TElTarProcessor(TSRMLS_D);

#ifdef __cplusplus
};	/* namespace SecureBlackbox */
#endif

#pragma pack(pop)

#endif  /* __INC_SBTARENTITIES */

