<?php 
    date_default_timezone_set("UTC");

    function DoCertificateValidate($Sender, $X509Certificate, &$Validate)
    {
        $Validate = true;
    }

    if (isset($_POST["receive"])) 
    {
        if (!extension_loaded("sbb") && !function_exists('SBUtils\SetLicenseKey')) 
        {
            print "SecureBlackbox extension is not available, please check that you've set it up correctly"; 
            die;
        }

        $aname = $_POST["aname"];
        $akey = $_POST["akey"];
        $devmode = (isset($_POST['devmode']) && $_POST['devmode'] == 'yes');

        if ((strlen($aname) > 0) and (strlen($akey) > 0))
        {
            $storage = new TElWinAzureDataStorage(NULL);
            $https = new TElHTTPSClient(NULL);
            $https->OnCertificateValidate = "DoCertificateValidate";
            $storage->HTTPClient = $https;
            $storage->AccountName = $aname;
            $storage->AccountKey = $akey;
            $storage->DevMode = $devmode;

            $conts = new TStringList();

            try
            {
                $storage->ListContainers($conts);

                if ($conts->Count > 0)
                {
                    $eprocess = "";

                    for ($i = 0; $i <= $conts->Count - 1; $i++)
                    {
                        $cont = $conts->get_Strings($i);
                        $eprocess = $eprocess . "&nbsp;&nbsp;&nbsp;" . $cont . " :  <br/>";

                        $objs = new TElDataStorageObjectList();
                        $storage->List($cont, $objs);

                        for ($j = 0; $j <= $objs->Count - 1; $j++)
                        {
                            $obj = new TElWinAzureDataStorageObject($storage);
                            $obj->Assign($objs->get_Objects($j));
                            $eprocess = $eprocess . "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;File name : " . $obj->Name . "<br/>" .
                                        "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Size : ". $obj->Size . "<br/>";
                            if ($obj->Secured)
                            {
                                $eprocess = $eprocess . "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Secured : yes<br/>";
                            }
                            else
                            {
                                $eprocess = $eprocess . "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Secured : no<br/>";
                            }

                            $eprocess = $eprocess . "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;----------------------------<br/>";
                        }

                        $eprocess = $eprocess . "------------------------------------<br/>";
                    }

                    print "All Containers: <br/><br/>" . $eprocess;
                }
                else
                {
                    print "Zero files in storage";
                }
            }
            catch(SBException $e) 
            {
                print "Failed to connect Azure storage : " . $e->getMessage() ." <br/>";
                return;
            }
        }
        else
        {
            $error_details = "";

            if (strlen($aname) == 0)
            {
                $error_details = $error_details . "Account name is not provided<br/>";
            }
            if (strlen($akey) == 0)
            {
                $error_details = $error_details . "Account key is not provided<br/>";
            }

            print "Parameters missing: <br/><br/>" . $error_details;
        }
    }
?>

<html>
<head>
  <title>EldoS WinAzure demo</title>
  <style type="text/css">
  .textheader {
    font-family: Arial;
    font-size: 16;
    font-weight: bold;
  }
  .textnormal {
    font-family: Arial;
    font-size: 12;
  }
  </style>
</head>
<body>
  <div align="center">
  <table border="0" cellspacing="0" cellpadding="0" width="600" height="100%">
    <tr height="*"></tr>
    <tr height="400">
      <td width="600" valign="top">
        <table border="0" cellspacing="0" cellpadding="10" width="100%" height="100%" style="border: 1px solid #bbbbbb;" bgcolor="#f6f6f6">
          <tr height="50">
            <td width="100%" valign="center" bgcolor="#e6e6e6">
              <div align="center" class="textheader">EldoS SecureBlackbox WinAzure demo</div>
            </td>
          </tr>
          <tr height="70">
            <td width="100%" height="*" align="center" valign="center" class="textnormal">
              <div align="center"> This sample illustrates the use of SecureBlackbox WinAzure components for receiving list of files in storage. <br/>
              Please provide your WinAzure account name, key and click the 'List of all files' button to receive list of files in storage. </div>
            </td>
          </tr>
          <tr height="*">
            <td width="100%" height="*">            
              <form action="" method="post" enctype="multipart/form-data">
                <table border="0" cellspacing="0" cellpadding="0" width="100%" height="100%" class="textnormal">
                  <tr height="30">
                    <td width="20%" align="right"> Account name: </td>
                    <td width="10"></td>
                    <td width="*" align="left"> <input type="text" name="aname" value="" size="30" /> <td>
                  </tr>
                  <tr height="30">
                    <td width="20%" align="right"> Account key: </td>
                    <td width="10"></td>
                    <td width="*" align="left"> <input type="text" name="akey" value="" size="60" /> </td>
                  </tr>
                  <tr height="40">
                    <td width="20%" align="right"> </td>
                    <td width="10"></td>  
                    <td width="*" align="left"> <input type="checkbox" name="devmode" value="yes" size="60" /> <span class="mtx4">Development mode (local server)</span> </td>
                 </tr>
                  <tr height="45" valign="center">
                    <td colspan="3" align="center"> <input type="submit" name="receive" value="List of all files"/> </td>
                  </tr>
                  <tr height="30" valign="bottom">
                    <td colspan="3" align="center"> Please inspect the source code of this script for more details. </td>
                  </tr>
                </table>
              </form>
            </td>
          </tr>
          <tr height="20">
            <td width="100%" valign="center" bgcolor="#e6e6e6">
              <div align="center" class="textnormal">Copyright &copy; EldoS Corporation <a href="http://www.eldos.com/">www.eldos.com</a></div>
            </td>
          </tr>
        </table>
      </td>
    </tr>
    <tr height="*"></tr>
  </table>
  </div>  
</body>
</html>