<?php 
    date_default_timezone_set("UTC");

    $logfile = "";
  
    function DoError($Sender, $ErrorCode, $Fatal, $Remote)
    {
        if ($Fatal)
        {
            $GLOBALS["logfile"] = $GLOBALS["logfile"] . "Fatal ";
        }

        if ($Remote)
        {
            $GLOBALS["logfile"] = $GLOBALS["logfile"] . "Remote ";
        }
        else
        {
            $GLOBALS["logfile"] = $GLOBALS["logfile"] . "Local ";
        }

        $GLOBALS["logfile"] = $GLOBALS["logfile"] . "error " . $ErrorCode . " <br/>";

        $GLOBALS["logfile"] = $GLOBALS["logfile"] . "Note: error 75778 (0x12802) may be an indicator of component misconfiguration. Please contacts us for the details.<br/>";
    }
  
    if (isset($_POST["upload"])) 
    {
        if (!extension_loaded("sbb") && !function_exists('SBUtils\SetLicenseKey')) 
        {
            print "SecureBlackbox extension is not available, please check that you've set it up correctly"; 
            die;
        }

        $address = $_POST["address"];
        $port = $_POST["port"];
        $username = $_POST["username"];
        $password = $_POST["password"];
        $targetname = $_FILES["filename"]["name"];
        $filename = $_FILES["filename"]["tmp_name"];

        if ((strlen($address) > 0) and (strlen($port) > 0) and (strlen($username) > 0) and (strlen($filename) > 0))
        {
            $client = new TElSimpleFtpsClient(NULL);
            $client->Address = $address;
            $client->Port = $port;
            $client->Username = $username;
            $client->Password = $password;
            $client->UseSSL = false;
            $client->PassiveMode = true;
            $client->OnSSLError = "DoError";

            try
            {
                $GLOBALS["logfile"] = $GLOBALS["logfile"] . "Connecting to " . $client->Address . "<br/>";
                $client->Open();
                $GLOBALS["logfile"] = $GLOBALS["logfile"] . "FTPS connection established <br/>";

                $GLOBALS["logfile"] = $GLOBALS["logfile"] . "Logging in to " . $client->Address . "<br/>";
                $client->Login();
                $GLOBALS["logfile"] = $GLOBALS["logfile"] . "Authorisation completed<br/>";

                $client->UploadFile($filename ,$targetname);
                print "File \"" . $targetname . "\" successfully uploaded";
        
                $client->Close(false);

                return;
            }
            catch(SBException $e) 
            {
                $client->Close(false);
                print "FTPS connection failed with message [ " . $e->getMessage() ." ]<br/>";
                print "Connection log: <br/>" . $GLOBALS["logfile"] . "<br/><br/>";
                print "If you have ensured that all connection parameters are correct and you still can't connect,<br/>";
                print "please contact EldoS support as described on http://www.eldos.com/sbb/support.php<br/>";
                print "Remember to provide as many details about the error as possible.<br/>";
            }
        }
        else
        {
            $error_details = "";

            if (strlen($address) == 0)
            {
                $error_details = $error_details . "Address is empty <br/>";
            }
            if (strlen($port) == 0)
            {
                $error_details = $error_details . "Port is empty <br/>";
            }
            if (strlen($username) == 0)
            {
                $error_details = $error_details . "Username is empty <br/>";
            }
            if (strlen($filename) == 0)
            {
                $error_details = $error_details . "File to upload is not selected <br/>";
            }
            print "Parameters missing: <br/><br/>" . $error_details;
        }
    }
?>

<html>
<head>
  <title>EldoS FTPS upload demo</title>
  <style type="text/css">
  .textheader {
    font-family: Arial;
    font-size: 16;
    font-weight: bold;
  }
  .textnormal {
    font-family: Arial;
    font-size: 12;
  }
  </style>
</head>
<body>
  <div align="center">
  <table border="0" cellspacing="0" cellpadding="0" width="600" height="100%">
    <tr height="*"></tr>
    <tr height="400">
      <td width="600" valign="top">
        <table border="0" cellspacing="0" cellpadding="10" width="100%" height="100%" style="border: 1px solid #bbbbbb;" bgcolor="#f6f6f6">
          <tr height="50">
            <td width="100%" valign="center" bgcolor="#e6e6e6">
              <div align="center" class="textheader">EldoS SecureBlackbox FTPS upload demo</div>
            </td>
          </tr>
          <tr height="70">
            <td width="100%" height="*" align="center" valign="center" class="textnormal">
              <div align="center">This sample illustrates the use of SecureBlackbox FTPS components for uploading files to FTPS (FTP over SSL) servers.<br/>
              Please provide the connection parameters below and click the 'Upload' button to upload the file to the server. </div>
            </td>
          </tr>
          <tr height="*">
            <td width="100%" height="*">            
              <form action="" method="post" enctype="multipart/form-data">
                <table border="0" cellspacing="0" cellpadding="0" width="100%" height="100%" class="textnormal">
                  <tr height="30">
                    <td width="40%" align="right"> Address: </td>
                    <td width="10"></td>
                    <td width="*" align="left"> <input width="20" type="text" name="address" value="127.0.0.1" size="20" /> <td>
                  </tr>
                  <tr height="30">
                    <td width="40%" align="right"> Port: </td>
                    <td width="10"></td>
                    <td width="*" align="left"> <input type="text" name="port" value="21" size="5" /> </td>
                  </tr>
                  <tr height="30">
                    <td width="40%" align="right"> Username: </td>
                    <td width="10"></td>
                    <td width="*" align="left"> <input type="text" name="username" value="anonymous" size="30" /> </td>
                  </tr>
                  <tr height="30">
                    <td width="40%" align="right"> Password: </td>
                    <td width="10"></td>
                    <td width="*" align="left"> <input type="password" name="password" value="" size="30" /> </td>
                  </tr>
                  <tr height="30">
                    <td width="40%" align="right"> File to upload: </td>
                    <td width="10"></td>
                    <td width="*" align="left"> <input type="file" name="filename" value="" size="30" /> </td>
                  </tr>
                  <tr height="45" valign="center">
                    <td colspan="3" align="center"> <input type="submit" name="upload" value="Upload"/> </td>
                  </tr>
                  <tr height="30" valign="bottom">
                    <td colspan="3" align="center"> Please inspect the source code of this script for more details. </td>
                  </tr>
                </table>
              </form>
            </td>
          </tr>
          <tr height="20">
            <td width="100%" valign="center" bgcolor="#e6e6e6">
              <div align="center" class="textnormal">Copyright &copy; EldoS Corporation <a href="http://www.eldos.com/">www.eldos.com</a></div>
            </td>
          </tr>
        </table>
      </td>
    </tr>
    <tr height="*"></tr>
  </table>
  </div>  
</body>
</html>