<?php
    error_reporting(E_ALL);
    date_default_timezone_set("UTC");
    
    $callbacksStr = " <br/>";
    $count = 0;
    $clientCert = null;
    $client = null;
    
    function OnDocumentBegin($Sender)
    {
        global $callbacksStr;
        $callbacksStr .= "<br/> -- Document started -- <br/>";
    }

    function OnDocumentEnd($Sender)
    {
        global $callbacksStr;
        $callbacksStr .= "<br/> -- Document finished -- <br/>";
    }

    function OnData($Sender, $Buffer, $Size)
    {
        global $callbacksStr;
        $str = "";
        if (!$Buffer->isNULL()) {
            $str = SBStrUtils\UTF8ToWideStr($Buffer, $Size);
        } else {
            $str = "Buffer is null";
        }
        $callbacksStr .= "<br/> " .$str . " <br/>";
    }

    function DoSAMLCredentialsChallenge($Sender, $URL, $Body, &$TargetURL, $Fields)
    {
        // We've hardcoded the values, but you can parse incoming form
        // to extract the URL and parameter names
        $TargetURL = 'http://idp.test.org/idp/SingleSignOnService/login';
        $Fields->Add('login=user');
        $Fields->Add('password=1234');
    }

    if (isset($_POST["get"])) {
        if (!extension_loaded("sbb") && !function_exists('SBUtils\SetLicenseKey')) {
            print "SecureBlackbox extension NOT available";
            die;
        }

        $url = $_POST["url"];
        
        if (strlen($url) > 0) {
            $error_happened = false;
            $error_details = "";

            $client = new TElHTTPSClient(null);
            $client->HTTPVersion = TSBHTTPVersion::hvHTTP11;
            // see the full list of HTTP versions at https://www.eldos.com/documentation/sbb/documentation/ref_cl_httpsclient_prp_httpversion.html
            $versions = (TSBVersions::sbTLS1 | TSBVersions::sbTLS11 | TSBVersions::sbTLS12);
            // see the full list of SSL/TLS versions at https://www.eldos.com/documentation/sbb/documentation/ref_cl_httpsclient_prp_httpversion.html
            $client->Versions = $versions;
            $client->KeepAlivePolicy = TSBHTTPKeepAlivePolicy::kapStandardDefined;
            $client->OnDocumentBegin = "OnDocumentBegin";
            $client->OnDocumentEnd = "OnDocumentEnd";
            $client->OnData = "OnData";

            $saml = new TElSAMLAdapter();
            $saml->SAMLSettings->Enabled = true;
            $saml->OnSAMLCredentialsChallenge = 'DoSAMLCredentialsChallenge';
            $client->set_SAMLAdapter($saml);

            try 
            {
                $client->Get($url);
                $client->Close(true);
            }
            catch(SBException $e) 
            {
                $error_happened = true;
                $error_details = "HTTPS GET request failed with message: " . $e->getErrorMessage();
            }
            
            if (!$error_happened) {
                print $callbacksStr;
            } else {
                print "Error happened: <br/>" . $error_details . " <br/><br/>" . $callbacksStr;
            }
            
            return;
        }
        else
        {
            $error_details = "";
            if (strlen($url) == 0)
            {
                $error_details .= "URL is empty <br/>";
            }
            print "Error happened: <br/><br/>" . $error_details;
        }
    }
?>

<html>
<head>
  <title>EldoS SAML Client demo</title>
  <style type="text/css">
  .textheader {
    font-family: Arial;
    font-size: 16;
    font-weight: bold;
  }
  .textnormal {
    font-family: Arial;
    font-size: 12;
  }
  </style>
</head>
<body>
  <div align="center">
  <table border="0" cellspacing="0" cellpadding="0" width="600" height="100%">
    <tr height="*"></tr>
    <tr height="400">
      <td width="600" valign="top">
        <table border="0" cellspacing="0" cellpadding="10" width="100%" height="100%" style="border: 1px solid #bbbbbb;" bgcolor="#f6f6f6">
          <tr height="50">
            <td width="100%" valign="center" bgcolor="#e6e6e6">
              <div align="center" class="textheader">EldoS SecureBlackbox SAML Client demo</div>
            </td>
          </tr>
          <tr height="70">
            <td width="100%" height="*" align="center" valign="center" class="textnormal">
              <div align="center"> This sample illustrates the use of SecureBlackbox SAML components for retrieving a remote resource. <br/>
              Please provide the full URL of the resource and  click the 'Get' button to have the resource retrieved. </div>
            </td>
          </tr>
          <tr height="*">
            <td width="100%" height="*">
              <form action="" method="post" enctype="multipart/form-data">
                <table border="0" cellspacing="0" cellpadding="0" width="100%" height="100%" class="textnormal">
                  <tr height="30">
                    <td width="25%" align="right"> URL: </td>
                    <td width="10"></td>
                    <td width="*" align="left"> <input width="20" type="text" name="url" value="http://sp.test.org:9999/index.html" size="40" /> <td>
                  </tr>
                  <tr height="45" valign="center">
                    <td colspan="3" align="center"> <input type="submit" name="get" value="Get"/> </td>
                  </tr>
                  <tr height="30" valign="bottom">
                    <td colspan="3" align="center"> Please inspect the source code of this script for more details. </td>
                  </tr>
                </table>
              </form>
            </td>
          </tr>
          <tr height="20">
            <td width="100%" valign="center" bgcolor="#e6e6e6">
              <div align="center" class="textnormal">Copyright &copy; EldoS Corporation <a href="http://www.eldos.com/">www.eldos.com</a></div>
            </td>
          </tr>
        </table>
      </td>
    </tr>
    <tr height="*"></tr>
  </table>
  </div>
</body>
</html>