<?php 
    date_default_timezone_set("UTC");

    if (isset($_POST["encrypt"])) 
    {
        if (!extension_loaded("sbb") && !function_exists('SBUtils\SetLicenseKey')) 
        {
            print "SecureBlackbox extension is not available, please check that you've set it up correctly";
            die;
        }

        $inputfile = $_FILES["inputfile"]["tmp_name"];
        $filename = $_FILES["inputfile"]["name"];
        $keyname = $_POST['keyname'];
        $keyfile = $_FILES["keyfile"]["tmp_name"];
        $enckey = (isset($_POST['enckey']) && $_POST['enckey'] == 'yes');
        $datatype = $_POST['datatype'];
        $encmethod = $_POST['encmethod'];
        if (isset($_POST['mime'])) {$mime = $_POST['mime'];}
        if (isset($_FILES['extfile'])) {$extfile = $_FILES["extfile"]["tmp_name"];}
        if (isset($_POST['kektype'])) {$kektype = $_POST['kektype'];}
        if (isset($_POST['keytransport'])) {$keytransport = $_POST['keytransport'];}
        if (isset($_POST['keywrap'])) {$keywrap = $_POST['keywrap'];}
        if (isset($_POST['password'])) {$password = $_POST['password'];}

        if ((strlen($inputfile) > 0) and (strlen($keyfile) > 0))
        {
            $in = new TMemoryStream;
            $in->LoadFromFile($inputfile);

            $xmldoc = new TElXMLDOMDocument();
            try
            {
                $xmldoc->LoadFromStream($in);
            }
            catch(SBException $e) 
            {
                print $e->getMessage();
                return;
            }

            $node = $xmldoc->get_FirstChild();
            while (!empty($node))
            {
                if ($node->ClassName_Inst() == 'TElXMLDOMElement') {break;}

                $node = $node->get_NextSibling();
            }

            $encryptor = new TElXMLEncryptor(NULL);

            try
            {
                $encryptor->set_EncryptKey($enckey);
                $encryptor->set_KeyName($keyname);
                switch ($encmethod)
                {
                    case 1 : $encryptor->set_EncryptionMethod(TElXMLEncryptionMethod::xemAES); break;
                    case 2 : $encryptor->set_EncryptionMethod(TElXMLEncryptionMethod::xemCamellia); break;
                    case 3 : $encryptor->set_EncryptionMethod(TElXMLEncryptionMethod::xemDES); break;
                    case 4 : $encryptor->set_EncryptionMethod(TElXMLEncryptionMethod::xemRC4); break;
                    case 5 : $encryptor->set_EncryptionMethod(TElXMLEncryptionMethod::xemSEED); break;
                    case 6 : $encryptor->set_EncryptionMethod(TElXMLEncryptionMethod::xemAES_GCM); break;
                    default : $encryptor->set_EncryptionMethod(TElXMLEncryptionMethod::xem3DES);
                }
                switch ($datatype)
                {
                    case 1 : $encryptor->set_EncryptedDataType(TElXMLEncryptedDataType::xedtContent); break;
                    case 2 : $encryptor->set_EncryptedDataType(TElXMLEncryptedDataType::xedtExternal); break;
                    default : $encryptor->set_EncryptedDataType(TElXMLEncryptedDataType::xedtElement);
                }

                $symkeydata = new TElXMLKeyInfoSymmetricData(true);

                if ($enckey)
                {
                    if ($kektype == 1)
                    {
                        $encryptor->set_KeyEncryptionType(TElXMLKeyEncryptionType::xetKeyWrap);

                        switch ($keywrap)
                        {
                            case 1 : $encryptor->set_KeyWrapMethod(TElXMLKeyWrapMethod::xwmAES128); break;
                            case 2 : $encryptor->set_KeyWrapMethod(TElXMLKeyWrapMethod::xwmAES192); break;
                            case 3 : $encryptor->set_KeyWrapMethod(TElXMLKeyWrapMethod::xwmAES256); break;
                            case 4 : $encryptor->set_KeyWrapMethod(TElXMLKeyWrapMethod::xwmCamellia128); break;
                            case 5 : $encryptor->set_KeyWrapMethod(TElXMLKeyWrapMethod::xwmCamellia192); break;
                            case 6 : $encryptor->set_KeyWrapMethod(TElXMLKeyWrapMethod::xwmCamellia256); break;
                            case 7 : $encryptor->set_KeyWrapMethod(TElXMLKeyWrapMethod::xwmSEED); break;
                            default : $encryptor->set_KeyWrapMethod(TElXMLKeyWrapMethod::xwm3DES);
                        }
                    }
                    else
                    {
                        $encryptor->set_KeyEncryptionType(TElXMLKeyEncryptionType::xetKeyTransport);

                        switch ($keytransport)
                        {
                            case 0 : $encryptor->set_KeyTransportMethod(TElXMLKeyTransportMethod::xktRSA15); break;
                            default : $encryptor->set_KeyTransportMethod(TElXMLKeyTransportMethod::xktRSAOAEP);
                        }
                    }

                    switch ($encryptor->get_EncryptionMethod())
                    {
                        case TElXMLEncryptionMethod::xem3DES :
                            $symkeydata->get_Key()->Generate(SBDES\T3DESKeySize * 8);
                            $symkeydata->get_Key()->GenerateIV(8 * 8);
                            break;
                        case TElXMLEncryptionMethod::xemAES :
                            $symkeydata->get_Key()->Generate(32 * 8);
                            $symkeydata->get_Key()->GenerateIV(16 * 8);
                            break;
                        case TElXMLEncryptionMethod::xemAES_GCM :
                            $symkeydata->get_Key()->Generate(32 * 8);
                            break;
                        case TElXMLEncryptionMethod::xemCamellia :
                            $symkeydata->get_Key()->Generate(32 * 8);
                            $symkeydata->get_Key()->GenerateIV(16 * 8);
                            break;
                        case TElXMLEncryptionMethod::xemRC4 :
                            $symkeydata->get_Key()->Generate(16 * 8);
                            break;
                    }

                    $encryptor->set_KeyData($symkeydata);

                    if ($encryptor->get_KeyEncryptionType() == TElXMLKeyEncryptionType::xetKeyWrap)
                    {
                        $syskekdata = new TElXMLKeyInfoSymmetricData(true);

                        $keystream = new TMemoryStream;
                        $keystream->LoadFromFile($keyfile);

                        $syskekdata->get_Key()->Load($keystream, $keystream->Size);

                        $encryptor->set_KeyEncryptionKeyData($syskekdata);
                    }
                    else
                    {
                        $rsakeydata = new TElXMLKeyInfoRSAData(true);
                        $rsakeydata->get_RSAKeyMaterial()->set_Passphrase($password);
                        $x509keydata = new TElXMLKeyInfoX509Data(true);

                        $keystream = new TMemoryStream;
                        $keystream->LoadFromFile($keyfile);

                        try
                        {
                            $rsakeydata->get_RSAKeyMaterial()->LoadPublic($keystream, $keystream->Size);
                        }
                        catch(SBException $e) {}

                        if (!($rsakeydata->get_RSAKeyMaterial()->get_PublicKey()))
                        {
                            $keystream->set_Position(0);
                            try
                            {
                                $rsakeydata->get_RSAKeyMaterial()->LoadSecret($keystream, $keystream->Size);
                            }
                            catch(SBException $e) {}
                        }

                        if (!($rsakeydata->get_RSAKeyMaterial()->get_PublicKey()))
                        {
                            $cert = new TElX509Certificate(NULL);
                            $r = $cert->LoadFromFileAuto($keyfile, $password);
                            if ($r == 0)
                            {
                                $x509keydata->set_Certificate($cert);
                            }
                        }

                        if ($rsakeydata->get_RSAKeyMaterial()->get_PublicKey())
                        {
                            $encryptor->set_KeyEncryptionKeyData($rsakeydata);
                        }
                        else
                        if (!empty($x509keydata->get_Certificate()))
                        {
                            $encryptor->set_KeyEncryptionKeyData($x509keydata);
                        }
                        else
                        {
                            print "Key not loaded";
                            return;
                        }
                    }
                }
                else
                {
                    $keystream = new TMemoryStream;
                    $keystream->LoadFromFile($keyfile);
                    $keystream->set_Position(0);

                    $symkeydata->get_Key()->Load($keystream, $keystream->get_Size());

                    if (($encryptor->get_EncryptionMethod() == TElXMLEncryptionMethod::xem3DES) or
                        ($encryptor->get_EncryptionMethod() == TElXMLEncryptionMethod::xemDES))
                    {
                        $symkeydata->get_Key()->GenerateIV(8 * 8);
                    }
                    else
                    {
                        $symkeydata->get_Key()->GenerateIV(16 * 8);
                    }

                    $encryptor->set_KeyData($symkeydata);
                }


                if ($encryptor->get_EncryptedDataType() == TElXMLEncryptedDataType::xedtExternal) 
                {
                    $encryptor->set_MimeType($mime);

                    $data = file_get_contents($extfile);

                    $encryptor->Encrypt($data);

                    $xmldoc = new TElXMLDOMDocument();
                    $encnode = new TElXMLDOMNode();
                    try
                    {
                        $encnode = $encryptor->Save($xmldoc);
                    }
                    catch(SBException $e)
                    {
                        print 'Encrypted data saving failed. (' . $e->getMessage() . ')';
                        return;
                    }

                    $xmldoc->AppendChild($encnode);

                    $out = new TMemoryStream;
                    $xmldoc->SaveToStream($out);

                    $yourfile = basename($filename) . ".tmp";
                    $tempname = tempnam(sys_get_temp_dir(), $yourfile);

                    $out->SaveToFile($tempname);

                    if (ob_get_level()) 
                    {
                        ob_end_clean();
                    }

                    header('Content-Description: File Transfer');
                    header('Content-Type: application/octet-stream');
                    header("Content-Disposition: attachment; filename=$filename");
                    header('Content-Transfer-Encoding: binary');
                    header('Expires: 0');
                    header('Cache-Control: must-revalidate');
                    header('Pragma: public');
                    header('Content-Length: ' . filesize($tempname));
                    readfile($tempname);
                }
                else
                {
                    $encryptor->Encrypt($node);

                    $encnode = new TElXMLDOMNode();
                    try
                    {
                        $encnode = $encryptor->Save($xmldoc);
                    }
                    catch(SBException $e)
                    {
                        print 'Encrypted data saving failed. (' . $e->getMessage() . ')';
                        return;
                    }

                    if ($encryptor->get_EncryptedDataType() == TElXMLEncryptedDataType::xedtElement)
                    {
                        $node->get_ParentNode()->ReplaceChild($encnode, $node);
                    }
                    else // xedtContent
                    {
                        while (!empty($node->get_LastChild()))
                        {
                            $node->RemoveChild($node->get_LastChild());
                        }

                        $node->AppendChild($encnode);
                    }

                    $out = new TMemoryStream;
                    $xmldoc->SaveToStream($out);

                    $yourfile = basename($filename) . ".tmp";
                    $tempname = tempnam(sys_get_temp_dir(), $yourfile);

                    $out->SaveToFile($tempname);

                    if (ob_get_level()) 
                    {
                        ob_end_clean();
                    }

                    header('Content-Description: File Transfer');
                    header('Content-Type: application/octet-stream');
                    header("Content-Disposition: attachment; filename=$filename");
                    header('Content-Transfer-Encoding: binary');
                    header('Expires: 0');
                    header('Cache-Control: must-revalidate');
                    header('Pragma: public');
                    header('Content-Length: ' . filesize($tempname));
                    readfile($tempname);

                    unlink($tempname);
                }

                //print "Ok";
                return;
            }
            catch(SBException $e) 
            {
                print $e->getMessage();
            }
        }
        else
        {
            $error_details = "";

            if (strlen($inputfile) == 0)
            {
                $error_details = $error_details . "XML file is not provided<br/>";
            }
            if (strlen($keyfile) == 0)
            {
                $error_details = $error_details . "Key file is not provided <br/>";
            }

            print "Parameters missing: <br/><br/>" . $error_details;
        }
    }
?>

<html>
<head>
  <title>EldoS XML demo</title>
  <style type="text/css">
  .textheader {
    font-family: Arial;
    font-size: 16;
    font-weight: bold;
  }
  .textnormal {
    font-family: Arial;
    font-size: 12;
  }
  </style>
</head>
<body>
  <div align="center">
  <table border="0" cellspacing="0" cellpadding="0" width="600" height="100%">
    <tr height="*"></tr>
    <tr height="400">
      <td width="600" valign="top">
        <table border="0" cellspacing="0" cellpadding="10" width="100%" height="100%" style="border: 1px solid #bbbbbb;" bgcolor="#f6f6f6">
          <tr height="50">
            <td width="100%" valign="center" bgcolor="#e6e6e6">
              <div align="center" class="textheader">EldoS SecureBlackbox XML demo</div>
            </td>
          </tr>
          <tr height="70">
            <td width="100%" height="*" align="center" valign="center" class="textnormal">
              <div align="center"> This sample illustrates the use of SecureBlackbox XML components for encrypting xml files. <br/>
              Please provide file, encrypt options and click the 'Encrypt' button to encrypt xml file. </div>
            </td>
          </tr>
          <tr height="*">
            <td width="100%" height="*">
              <form method="post" enctype="multipart/form-data">
                <table border="0" cellspacing="0" cellpadding="0" width="100%" height="100%" class="textnormal">
                  <tr height="40">
                    <td width="40%" align="right"> XML file: </td>
                    <td width="10"></td>
                    <td width="*" align="left"> <input type="file" name="inputfile" value="" accept="application/xml" size="30" /> </td>
                  </tr>
                  <tr height="30">
                    <td colspan="3" align="left">
                      <fieldset>
                        <legend> Encryption options </legend>
                        <table border="0" cellspacing="0" cellpadding="0" width="100%" height="100%" class="textnormal">
                          <tr height="30">
                            <td width="*">
                              <fieldset>
                                <legend> General  </legend>
                                <table border="0" cellspacing="0" cellpadding="0" width="100%" height="100%" class="textnormal">
                                  <tr height="30">
                                    <td colspan=2 align="right"> Encrypted data type </td>
                                    <td width="10" > &nbsp;&nbsp; </td>
                                    <td colspan=2 align="left">
                                      <select name="datatype" size="1" onchange="this.form.mime.disabled=!(this.form.datatype.value == 2);this.form.extfile.disabled=!(this.form.datatype.value == 2)">
                                        <option value=0 selected>Element</option>
                                        <option value=1>Content</option>
                                        <option value=2>External file</option>
                                      </select>
                                    </td>
                                  </tr>
                                  <tr height="30">
                                    <td colspan=2 align="right"> Encryption method </td>
                                    <td width="10" > </td>
                                    <td colspan=2 align="left">
                                      <select name="encmethod" size="1">
                                        <option value=0 selected>3DES</option>
                                        <option value=1>AES</option>
                                        <option value=2>Camellia</option>
                                        <option value=3>DES</option>
                                        <option value=4>RC4</option>
                                        <option value=5>SEED</option>
                                        <option value=6>AES-GCM</option>
                                      </select>
                                    </td>
                                  </tr>
                                  <tr height="30">
                                    <td width="20%" align="left"> Mime type </td>
                                    <td width="*" align="left"> <input type="text" name="mime" value="" size="25" disabled/> </td>
                                    <td width="10" > </td>
                                    <td width="20%" align="left"> External file </td>
                                    <td width="*" align="left"> <input type="file" name="extfile" value="" size="25" disabled/> </td>
                                  </tr>
                                </table>
                              </fieldset>
                            </td>
                          </tr>
                          <tr height="30">
                            <td width="*">
                              <fieldset>
                                <legend> <label> <input type="checkbox" name="enckey" value="yes" onchange="this.form.kektype[0].disabled=!this.form.enckey.checked;this.form.kektype[1].disabled=!this.form.enckey.checked;this.form.keytransport.disabled=(!this.form.enckey.checked||!this.form.kektype[0].checked);this.form.keywrap.disabled=(!this.form.enckey.checked||!this.form.kektype[1].checked);this.form.password.disabled=(!this.form.enckey.checked||!this.form.kektype[0].checked)"/> Encrypt key </label> </legend>
                                <table border="0" cellspacing="0" cellpadding="0" width="100%" height="100%" class="textnormal">
                                  <tr height="30">
                                    <td width="40%" align="left"> <label> <input type="radio" name="kektype" value="0" disabled checked onchange="this.form.keytransport.disabled=!this.form.kektype[0].checked;this.form.keywrap.disabled=!this.form.kektype[1].checked;this.form.password.disabled=!this.form.kektype[0].checked"> Key Transport </label> </td>
                                    <td width="10"></td>
                                    <td width="*" align="left">
                                      <select name="keytransport" size="1" disabled>
                                        <option value=0 selected>RSA v1.5</option>
                                        <option value=1>RSA-OAEP</option>
                                      </select>
                                    </td>
                                  </tr>
                                  <tr height="30">
                                    <td width="40%" align="left"> <label> <input type="radio" name="kektype" value="1" disabled onchange="this.form.keytransport.disabled=!this.form.kektype[0].checked;this.form.keywrap.disabled=!this.form.kektype[1].checked;this.form.password.disabled=!this.form.kektype[0].checked"> Key Wrap </label> </td>
                                    <td width="10"></td>
                                    <td width="*" align="left">
                                      <select name="keywrap" size="1" disabled>
                                        <option value=0 selected>3DES</option>
                                        <option value=1>AES 128 bit</option>
                                        <option value=2>AES 192 bit</option>
                                        <option value=3>AES 256 bit</option>
                                        <option value=4>Camellia 128 bit</option>
                                        <option value=5>Camellia 192 bit</option>
                                        <option value=6>Camellia 256 bit</option>
                                        <option value=7>SEED 128 bit</option>
                                      </select>
                                    </td>
                                  </tr>
                                </table>
                              </fieldset>
                            </td>
                          </tr>
                          <tr height="30">
                            <td width="*">
                              <fieldset>
                                <legend> Key Info </label> </legend>
                                <table border="0" cellspacing="0" cellpadding="0" width="100%" height="100%" class="textnormal">
                                  <tr height="30">
                                    <td width="20%" align="left"> Key name </td>
                                    <td width="*" align="left"> <input type="text" name="keyname" value="" size="25"/> </td>
                                    <td width="10" > &nbsp;&nbsp; </td>
                                    <td width="20%" align="left"> Key file </td>
                                    <td width="*" align="left"> <input type="file" name="keyfile" value="" size="25"/> </td>
                                  </tr>
                                  <tr height="30">
                                    <td width="20%" align="left"> Passphrase </td>
                                    <td colspan=4 align="left"> <input type="password" name="password" value="" size="25" disabled/> </td>
                                  </tr>
                                </table>
                              </fieldset>
                            </td>
                          </tr>
                        </table>
                      </fieldset>
                    </td>
                  </tr>
                  <tr height="45" valign="center">
                    <td colspan="3" align="center"> <input type="submit" name="encrypt" value="Encrypt"/> </td>
                  </tr>
                  <tr height="30" valign="bottom">
                    <td colspan="3" align="center"> Please inspect the source code of this script for more details. </td>
                  </tr>
                </table>
              </form>
            </td>
          </tr>
          <tr height="20">
            <td width="100%" valign="center" bgcolor="#e6e6e6">
              <div align="center" class="textnormal">Copyright &copy; EldoS Corporation <a href="http://www.eldos.com/">www.eldos.com</a></div>
            </td>
          </tr>
        </table>
      </td>
    </tr>
    <tr height="*"></tr>
  </table>
  </div>  
</body>
</html>