<?php 
    date_default_timezone_set("UTC");

    $verifier = new TElXMLVerifier(NULL);
    $inputfile = "";
    $filename = "";
    $tempname = "";

    function ShowForm()
    {
        global $verifier;
        global $filename;
        global $tempname;

        echo '<html>';
        echo '<head>';
        echo '  <title>EldoS XML demo</title>';
        echo '  <style type="text/css">';
        echo '  .textheader {';
        echo '    font-family: Arial;';
        echo '    font-size: 16;';
        echo '    font-weight: bold;';
        echo '  }';
        echo '  .textnormal {';
        echo '    font-family: Arial;';
        echo '    font-size: 12;';
        echo '  }';
        echo '  </style>';
        echo '</head>';
        echo '<body>';
        echo '  <div align="center">';
        echo '  <table border="0" cellspacing="0" cellpadding="0" width="600" height="100%">';
        echo '    <tr height="*"></tr>';
        echo '    <tr height="400">';
        echo '      <td width="600" valign="top">';
        echo '        <table border="0" cellspacing="0" cellpadding="10" width="100%" height="100%" style="border: 1px solid #bbbbbb;" bgcolor="#f6f6f6">';
        echo '          <tr height="50">';
        echo '            <td width="100%" valign="center" bgcolor="#e6e6e6">';
        echo '              <div align="center" class="textheader">EldoS SecureBlackbox XML demo</div>';
        echo '            </td>';
        echo '          </tr>';
        echo '          <tr height="70">';
        echo '            <td width="100%" height="*" align="center" valign="center" class="textnormal">';
        echo '              <div align="center"> This sample illustrates the use of SecureBlackbox XML components for verifying xml files. <br/>';
        echo '              Please provide key file and click the "Verify" button to verify xml file. </div>';
        echo '            </td>';
        echo '          </tr>';
        echo '          <tr height="*">';
        echo '            <td width="100%" height="*">';
        echo '              <form action="XML_Verify.php" method="post" enctype="multipart/form-data">';
        echo '                <table border="0" cellspacing="0" cellpadding="0" width="100%" height="100%" class="textnormal">';
        echo '                  <tr height="0">';
        echo '                    <td colspan="3"> <input type="hidden" name="inputfile" value="' . $tempname . '" size="30" /> </td>';
        echo '                  </tr>';
        echo '                  <tr height="0">';
        echo '                    <td colspan="3"> <input type="hidden" name="filename" value="' . $filename . '" size="30" /> </td>';
        echo '                  </tr>';
        echo '                  <tr height="30">';
        echo '                    <td colspan="3" align="left">';
        echo '                      <fieldset>';
        echo '                        <legend> Signature options </legend>';
        echo '                        <table border="0" cellspacing="0" cellpadding="0" width="100%" height="100%" class="textnormal">';
        echo '                          <tr height="30">';
        echo '                            <td width="*">';
        echo '                              <fieldset>';
        echo '                                <legend> General  </legend>';
        echo '                                <table border="0" cellspacing="0" cellpadding="0" width="100%" height="100%" class="textnormal">';
        echo '                                  <tr height="30">';
        echo '                                    <td width="40%" align="right"> Canonicalization method </td>';
        echo '                                    <td width="10" > &nbsp;&nbsp; </td>';

        $s = "";
        switch ($verifier->get_CanonicalizationMethod())
        {
            case TElXMLCanonicalizationMethod::xcmCanon : $s = "Canonical"; break;
            case TElXMLCanonicalizationMethod::xcmCanonComment : $s = "Canonical with comments"; break;
            case TElXMLCanonicalizationMethod::xcmCanon_v1_1 : $s = "Canonical v1.1"; break;
            case TElXMLCanonicalizationMethod::xcmCanonComment_v1_1 : $s = "Canonical with comments v1.1"; break;
            case TElXMLCanonicalizationMethod::xcmExclCanon : $s = "Exclusive canonical"; break;
            case TElXMLCanonicalizationMethod::xcmExclCanonComment : $s = "Exclusive canonical with comments"; break;
            case TElXMLCanonicalizationMethod::xcmMinCanon : $s = "Minimal canonical"; break;
        }

        echo '                                    <td width="*" align="left"> <input type="text" name="canmethod" value="' . $s . '" size="25" disabled/> </td>';
        echo '                                  </tr>';
        echo '                                  <tr height="30">';
        echo '                                    <td width="40%" align="right"> Signature method type </td>';
        echo '                                    <td width="10" > </td>';

        $s = "";
        if ($verifier->get_SignatureMethodType() == TElXMLSigMethodType::xmtSig)
        {
            $s = "Signature method : ";

            switch ($verifier->get_SignatureMethod())
            {
                case TElXMLSignatureMethod::xsmDSS : $s = "DSS"; break;
                case TElXMLSignatureMethod::xsmRSA_SHA1 : $s = "RSA SHA1"; break;
                case TElXMLSignatureMethod::xsmRSA_MD5 : $s = "RSA MD5"; break;
                case TElXMLSignatureMethod::xsmRSA_SHA256 : $s = "RSA SHA256"; break;
                case TElXMLSignatureMethod::xsmRSA_SHA384 : $s = "RSA SHA384"; break;
                case TElXMLSignatureMethod::xsmRSA_SHA512 : $s = "RSA SHA512"; break;
                case TElXMLSignatureMethod::xsmRSA_RIPEMD160 : $s = "RSA RIPEMD160"; break;
            }
        }
        else
        {
            $s = "HMAC method : ";

            switch ($verifier->get_MACMethod())
            {
                case TElXMLMACMethod::xmmHMAC_MD5 : $s = "MD5"; break;
                case TElXMLMACMethod::xmmHMAC_SHA1 : $s = "SHA1"; break;
                case TElXMLMACMethod::xmmHMAC_SHA224 : $s = "SHA224"; break;
                case TElXMLMACMethod::xmmHMAC_SHA256 : $s = "SHA256"; break;
                case TElXMLMACMethod::xmmHMAC_SHA384 : $s = "SHA384"; break;
                case TElXMLMACMethod::xmmHMAC_SHA512 : $s = "SHA512"; break;
                case TElXMLMACMethod::xmmHMAC_RIPEMD160 : $s = "RIPEMD160"; break;
            }
        }

        echo '                                    <td width="*" align="left"> <input type="text" name="signmethod" value="' . $s . '" size="25" disabled/> </td>';
        echo '                                  </tr>';
        echo '                                </table>';
        echo '                              </fieldset>';
        echo '                            </td>';
        echo '                          </tr>';
        echo '                          <tr height="30">';
        echo '                            <td width="*">';
        echo '                              <fieldset>';
        echo '                                <legend> Key Info </label> </legend>';
        echo '                                <table border="0" cellspacing="0" cellpadding="0" width="100%" height="100%" class="textnormal">';
        echo '                                  <tr height="30">';
        echo '                                    <td width="20%" align="left"> Key name </td>';
        echo '                                    <td width="*" align="left"> <input type="text" name="keyname" value="' . $verifier->get_KeyName() . '" size="25" disabled/> </td>';
        echo '                                    <td width="10" > &nbsp;&nbsp; </td>';
        echo '                                    <td width="20%" align="left"> Key file </td>';
        echo '                                    <td width="*" align="left"> <input type="file" name="keyfile" value="" size="25"/> </td>';
        echo '                                  </tr>';

        if ($verifier->get_SignatureMethodType() == TElXMLSigMethodType::xmtSig)
        {
            echo '                                  <tr height="30">';
            echo '                                    <td width="20%" align="left"> Passphrase </td>';
            echo '                                    <td colspan=4 align="left"> <input type="password" name="password" value="" size="25"/> </td>';
            echo '                                  </tr>';
        }

        echo '                                </table>';
        echo '                              </fieldset>';
        echo '                            </td>';
        echo '                          </tr>';
        echo '                        </table>';
        echo '                      </fieldset>';
        echo '                    </td>';
        echo '                  </tr>';
        echo '                  <tr height="45" valign="center">';
        echo '                    <td colspan="3" align="center"> <input type="submit" name="dopverify" value="Verify"/> </td>';
        echo '                  </tr>';
        echo '                  <tr height="30" valign="bottom">';
        echo '                    <td colspan="3" align="center"> Please inspect the source code of this script for more details. </td>';
        echo '                  </tr>';
        echo '                </table>';
        echo '              </form>';
        echo '            </td>';
        echo '          </tr>';
        echo '          <tr height="20">';
        echo '            <td width="100%" valign="center" bgcolor="#e6e6e6">';
        echo '              <div align="center" class="textnormal">Copyright &copy; EldoS Corporation <a href="http://www.eldos.com/">www.eldos.com</a></div>';
        echo '            </td>';
        echo '          </tr>';
        echo '        </table>';
        echo '      </td>';
        echo '    </tr>';
        echo '    <tr height="*"></tr>';
        echo '  </table>';
        echo '  </div>  ';
        echo '</body>';
        echo '</html>';
    }

    if (isset($_POST["dopverify"])) 
    {
        $inputfile = $_POST["inputfile"];
        $filename = $_POST["filename"];
        $keyfile = $_FILES["keyfile"]["tmp_name"];
        if (isset($_POST['password'])) {$password = $_POST['password'];}

        if ((strlen($inputfile) > 0) and (strlen($keyfile) > 0))
        {
            $in = new TMemoryStream;
            $in->LoadFromFile($inputfile);

            $xmldoc = new TElXMLDOMDocument();
            try
            {
                $xmldoc->LoadFromStream($in);
            }
            catch(SBException $e) 
            {
                print $e->getMessage();
                return;
            }

            $node = $xmldoc->get_DocumentElement();

            $SigningTime = new DateTime('now'); // knot known at the moment
            $SigOK = true;

            $HMACKeyData = NULL;
            $RSAKeyData = NULL;
            $X509KeyData = NULL;
            $PGPKeyData = NULL;

            try
            {
                $verifier->Load($node->CastTo());
            }
            catch(SBException $e)
            {
                print 'Signature data loading failed. (' . $e->getMessage() . ')';
                return;
            }

            if ($verifier->get_SignatureMethodType() == TElXMLSigMethodType::xmtMAC)
            {
                $HMACKeyData = new TElXMLKeyInfoHMACData(True);

                $data = file_get_contents($keyfile);
 
                $HMACKeyData->get_Key()->set_Key_ByteArray($data);
                $verifier->set_HMACKey($HMACKeyData);
            }
            else
            {
                $RSAKeyData = new TElXMLKeyInfoRSAData(True);
                $RSAKeyData->get_RSAKeyMaterial()->set_Passphrase($password);
                $X509KeyData = new TElXMLKeyInfoX509Data(True);
                $PGPKeyData = new TElXMLKeyInfoPGPData(True);

                $keystream = new TMemoryStream;
                $keystream->LoadFromFile($keyfile);
                $keystream->set_Position(0);

                try
                {
                    // trying to load file as RSA key material
                    $RSAKeyData->get_RSAKeyMaterial()->LoadPublic($keystream, $keystream->Size);
                }
                catch(SBException $e) {}

                if (!$RSAKeyData->get_RSAKeyMaterial()->get_PublicKey())
                {
                    $keystream->set_Position(0);
                    try
                    {
                        $RSAKeyData->get_RSAKeyMaterial()->LoadSecret($keystream, $keystream->Size);
                    }
                    catch(SBException $e) {}
                }

                if (!$RSAKeyData->get_RSAKeyMaterial()->get_PublicKey())
                {
                    // trying to load file as Certificate
                    $cert = new TElX509Certificate(NULL);
                    $r = $cert->LoadFromFileAuto($keyfile, $password);
                    if ($r == 0)
                    {
                        $X509KeyData->set_Certificate($cert);
                    }
                }

                if (!$RSAKeyData->get_RSAKeyMaterial()->get_PublicKey() and
                    empty($X509KeyData->get_Certificate()))
                {
                    // trying to load file as PGP key
                    $keystream->set_Position(0);
                    $PGPkey = new TElPGPPublicKey();
                    $PGPKeyData->set_PublicKey($PGPkey);
                    try
                    {
                        $PGPKeyData->get_PublicKey()->CastTo()->LoadFromStream($keystream);
                    }
                    catch(SBException $e)
                    {
                        $PGPKeyData->set_PublicKey(NULL);
                        $PGPkey = NULL;
                    }

                    if (empty($PGPKeyData->get_PublicKey()))
                    {
                        // trying to load file as PGP key
                        $keystream->set_Position(0);
                        $PGPkey = new TElPGPSecretKey();
                        $PGPKeyData->set_SecretKey($PGPkey);
                        try
                        {
                            $PGPKeyData->get_SecretKey()->CastTo()->LoadFromStream($keystream);
                            $PGPKeyData->get_SecretKey()->set_Passphrase($password);
                        }
                        catch(SBException $e)
                        {
                            $PGPKeyData->set_SecretKey(NULL);
                        }
                    }
                }

                if ($RSAKeyData->get_RSAKeyMaterial()->get_PublicKey())
                {
                    $verifier->set_KeyData($RSAKeyData);
                }
                else
                if (!empty($X509KeyData->get_Certificate()))
                {
                    $verifier->set_KeyData($X509KeyData);
                }
                else
                if (!empty($PGPKeyData->get_PublicKey()) or !empty($PGPKeyData->get_SecretKey()))
                {
                    $verifier->set_KeyData($PGPKeyData);
                }
                else
                {
                    print "No Key loaded.";
                    return;
                }

                $RSAKeyData->detachHandle();
                $X509KeyData->detachHandle();
                $PGPKeyData->detachHandle();
            }

            if (!$verifier->ValidateSignature())
            {
                $SigOK = false;
                print 'Signature is invalid <br/>';return;
            }
            else
            if (!empty($verifier->get_KeyData()))
            {
                if (($verifier->get_KeyData()->ClassName_Inst() == 'TElXMLKeyInfoX509Data') and
                    ($verifier->get_KeyData()->CastTo()->get_Certificate() != NULL))
                {
                    $CertificateValidator = new TElX509CertificateValidator(NULL);
                    $CertificateValidator->Validate($verifier->get_KeyData()->CastTo()->get_Certificate(), $verifier->get_KeyData()->CastTo()->get_CertStorage(), false, $SigningTime, $Validity, $Reason);

                    if ($Validity == cvSelfSigned)
                    {
                        print 'The selected signature is signed by self-signed certificate which was not previously trusted. <br/>';
                    }
                    else
                    if ($Validity != cvOk)
                    {
                        //$SigOK = false;
                        if ($Validity == cvChainUnvalidated)
                        {
                            print 'Signing certificate chain could not be validated completely. <br/>';
                        }
                        else
                        {
                            print 'Signing certificate is not valid. <br/>';
                        }
                    }
                }
            }


            if ($SigOK)
            {
                if ($verifier->ValidateReferences())
                {
                    print 'Signature and references validated successfully. <br/>';
                }
                else
                {
                    print 'Signature validated successfully. <br/>';
                }
            }

            unlink($inputfile);
            return;
        }
        else
        {
            $error_details = "";

            if (strlen($inputfile) == 0)
            {
                $error_details = $error_details . "XML file is not provided<br/>";
            }
            if (strlen($keyfile) == 0)
            {
                $error_details = $error_details . "Key file is not provided <br/>";
            }

            print "Parameters missing: <br/><br/>" . $error_details;
        }
    }

    if (isset($_POST["verify"])) 
    {
        if (!extension_loaded("sbb") && !function_exists('SBUtils\SetLicenseKey')) 
        {
            print "SecureBlackbox extension is not available, please check that you've set it up correctly";
            die;
        }

        $inputfile = $_FILES["inputfile"]["tmp_name"];
        $filename = $_FILES["inputfile"]["name"];

        if (strlen($inputfile) > 0)
        {
            $in = new TMemoryStream;
            $in->LoadFromFile($inputfile);

            $xmldoc = new TElXMLDOMDocument();
            try
            {
                $xmldoc->LoadFromStream($in);
            }
            catch(SBException $e) 
            {
                print $e->getMessage();
                return;
            }

            $SigningTime = new DateTime('now'); // knot known at the moment

            $node = $xmldoc->get_DocumentElement();

            if (!($node->ClassName_Inst() == 'TElXMLDOMElement') or
                (($node->CastTo()->get_LocalName() != 'Signature') and
                 ($node->CastTo()->get_LocalName() != 'AuthSignature') and
                 empty(SBXMLUtils\FindElementByName($node->CastTo(), 'Signature', SBXMLDefs\xmlSignatureNamespace))))
            {
                print 'Document is not signing.';
                return;
            }

            $SigOK = true;

            try
            {
                $verifier->Load($node->CastTo());
            }
            catch(SBException $e)
            {
                print 'Signature data loading failed. (' . $e->getMessage() . ')';
                return;
            }

            if (!$verifier->ValidateSignature())
            {
                // KeyInfo doesn't contain correct public key for the signature or data corrupted
                $tempname = tempnam(sys_get_temp_dir(), $filename);

                if (!copy($inputfile, $tempname)) 
                {
                    print "Can not copy $inputfile...\n";
                    die;
                }

                ShowForm();
            }
            else
            {
                // signature is valid
                // validate a certificate used for signature validation
                if ($verifier->get_SignerCertificate() != NULL)
                {
                    $CertificateValidator = new TElX509CertificateValidator(NULL);
                    $CertificateValidator->Validate($verifier->get_SignerCertificate(), $verifier->get_SignerKeyData()->CastTo()->get_CertStorage(), false, $SigningTime, $Validity, $Reason);

                    if ($Validity == cvSelfSigned)
                    {
                        print 'The selected signature is signed by self-signed certificate which was not previously trusted. <br/>';
                    }
                    else 
                    if ($Validity != cvOk)
                    {
                        //$SigOK = false;
                        if ($Validity == cvChainUnvalidated)
                        {
                            print 'Signing certificate chain could not be validated completely. <br/>';
                        }
                        else
                        {
                            print 'Signing certificate is not valid. <br/>';
                        }
                    }
                }
            }

            if ($SigOK)
            {
                if ($verifier->ValidateReferences())
                {
                    print 'Signature and references validated successfully. <br/>';
                }
                else
                {
                    print 'Signature validated successfully. <br/>';
                }
            }

            return;
        }
        else
        {
            print "XML file is not provided";
        }
    }
?>