#include "sbcms.h"

zend_class_entry *TSBASN1DirectoryStringEncoding_ce_ptr = NULL;

zend_class_entry *TSBCMSRevocationRefsWriteMode_ce_ptr = NULL;

zend_class_entry *TSBCMSSignerIdentifierType_ce_ptr = NULL;

zend_class_entry *TSBSigPolicyQualifierType_ce_ptr = NULL;

zend_class_entry *TSBCMSSigningCertificateType_ce_ptr = NULL;

zend_class_entry *TSBCMSSignerAttributesVersion_ce_ptr = NULL;

zend_class_entry *TSBCMSSignaturePolicyStoreType_ce_ptr = NULL;

zend_class_entry *TSBCMSTimestampType_ce_ptr = NULL;

zend_class_entry *TSBCMSItemType_ce_ptr = NULL;

void SB_CALLBACK TSBCMSBeforeSignEventRaw(void * _ObjectData, TObjectHandle Sender, TElPublicKeyCryptoHandle Crypto)
{
	zval *retval_ptr;
	zval **params[2];
	zval * zSender;
	zval * zCrypto;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zCrypto);
	SBInitObject(zCrypto, TElPublicKeyCrypto_ce_ptr, Crypto TSRMLS_CC);

	params[0] = &zSender;
	params[1] = &zCrypto;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 2, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zCrypto);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBCMSBeforeVerifyEventRaw(void * _ObjectData, TObjectHandle Sender, TElPublicKeyCryptoHandle Crypto)
{
	zval *retval_ptr;
	zval **params[2];
	zval * zSender;
	zval * zCrypto;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zCrypto);
	SBInitObject(zCrypto, TElPublicKeyCrypto_ce_ptr, Crypto TSRMLS_CC);

	params[0] = &zSender;
	params[1] = &zCrypto;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 2, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zCrypto);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBCMSCertificateTrustedEventRaw(void * _ObjectData, TObjectHandle Sender, TElX509CertificateHandle Cert, int8_t * Trusted)
{
	zval *retval_ptr;
	zval **params[3];
	zval * zSender;
	zval * zCert;
	zval * zTrusted;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zCert);
	SBInitObject(zCert, TElX509Certificate_ce_ptr, Cert TSRMLS_CC);
	MAKE_STD_ZVAL(zTrusted);
	ZVAL_BOOL(zTrusted, (zend_bool)*Trusted);

	params[0] = &zSender;
	params[1] = &zCert;
	params[2] = &zTrusted;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 3, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zCert);
	*Trusted = (int8_t)Z_BVAL_P(zTrusted);
	zval_ptr_dtor(&zTrusted);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBCMSItemValidatedEventRaw(void * _ObjectData, TObjectHandle Sender, TSBCMSItemTypeRaw ItemType, TObjectHandle Item, int8_t * Valid)
{
	zval *retval_ptr;
	zval **params[4];
	zval * zSender;
	zval * zItemType;
	zval * zItem;
	zval * zValid;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zItemType);
	ZVAL_LONG(zItemType, (long)ItemType);
	MAKE_STD_ZVAL(zItem);
	SBInitObject(zItem, TObject_ce_ptr, Item TSRMLS_CC);
	MAKE_STD_ZVAL(zValid);
	ZVAL_BOOL(zValid, (zend_bool)*Valid);

	params[0] = &zSender;
	params[1] = &zItemType;
	params[2] = &zItem;
	params[3] = &zValid;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 4, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zItemType);
	zval_ptr_dtor(&zItem);
	*Valid = (int8_t)Z_BVAL_P(zValid);
	zval_ptr_dtor(&zValid);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBCMSCRLNeededEventRaw(void * _ObjectData, TObjectHandle Sender, TElCMSCRLValidatedIDHandle ID, TElX509CertificateHandle Cert, TElCertificateRevocationListHandle * Crl)
{
	zval *retval_ptr;
	zval **params[4];
	zval * zSender;
	zval * zID;
	zval * zCert;
	zval * zCrl;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zID);
	SBInitObject(zID, TElCMSCRLValidatedID_ce_ptr, ID TSRMLS_CC);
	MAKE_STD_ZVAL(zCert);
	SBInitObject(zCert, TElX509Certificate_ce_ptr, Cert TSRMLS_CC);
	MAKE_STD_ZVAL(zCrl);
	SBInitObject(zCrl, TElCertificateRevocationList_ce_ptr, *Crl TSRMLS_CC);

	params[0] = &zSender;
	params[1] = &zID;
	params[2] = &zCert;
	params[3] = &zCrl;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 4, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zID);
	zval_ptr_dtor(&zCert);
	*Crl = SBGetObjectHandleCE(zCrl, TElCertificateRevocationList_ce_ptr TSRMLS_CC);
	SBDetachObjectHandleIfUniqueZVal(zCrl TSRMLS_CC);
	zval_ptr_dtor(&zCrl);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBCMSOCSPResponseNeededEventRaw(void * _ObjectData, TObjectHandle Sender, TElCMSOCSPResponsesIDHandle ID, TElX509CertificateHandle Cert, TElOCSPResponseHandle * Ocsp)
{
	zval *retval_ptr;
	zval **params[4];
	zval * zSender;
	zval * zID;
	zval * zCert;
	zval * zOcsp;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zID);
	SBInitObject(zID, TElCMSOCSPResponsesID_ce_ptr, ID TSRMLS_CC);
	MAKE_STD_ZVAL(zCert);
	SBInitObject(zCert, TElX509Certificate_ce_ptr, Cert TSRMLS_CC);
	MAKE_STD_ZVAL(zOcsp);
	SBInitObject(zOcsp, TElOCSPResponse_ce_ptr, *Ocsp TSRMLS_CC);

	params[0] = &zSender;
	params[1] = &zID;
	params[2] = &zCert;
	params[3] = &zOcsp;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 4, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zID);
	zval_ptr_dtor(&zCert);
	*Ocsp = SBGetObjectHandleCE(zOcsp, TElOCSPResponse_ce_ptr TSRMLS_CC);
	SBDetachObjectHandleIfUniqueZVal(zOcsp TSRMLS_CC);
	zval_ptr_dtor(&zOcsp);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

zend_class_entry *TSBCMSSigningOption_ce_ptr = NULL;

zend_class_entry *TSBCMSSigningOptions_ce_ptr = NULL;

void SB_CALLBACK TSBCMSRemoteSignCallbackRaw(void * _ObjectData, TObjectHandle Sender, TObjectHandle Param, const uint8_t pHash[], int32_t szHash, uint8_t pSignedHash[], int32_t * szSignedHash, int8_t * OutResult)
{
	zval **params[4];
	zval * zSender;
	zval * zParam;
	zval * zHash;
	zval * zSignedHash;
	SBArrayZValInfo aiSignedHash;
	zval * pzOutResult = NULL;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zParam);
	SBInitObject(zParam, TObject_ce_ptr, Param TSRMLS_CC);
	MAKE_STD_ZVAL(zHash);
	ZVAL_STRINGL(zHash, pHash, szHash, 1);
	MAKE_STD_ZVAL(zSignedHash);
	ZVAL_STRINGL(zSignedHash, pSignedHash, *szSignedHash, 1);

	params[0] = &zSender;
	params[1] = &zParam;
	params[2] = &zHash;
	params[3] = &zSignedHash;
	SBCallEvent((zval *)_ObjectData, &pzOutResult, 4, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zParam);
	zval_ptr_dtor(&zHash);
	if (SBGetByteArrayFromZVal(zSignedHash, &aiSignedHash TSRMLS_CC))
		SBCheckError(SBSetEventReturnBuffer(4, aiSignedHash.data, aiSignedHash.len) TSRMLS_CC);
	SBFreeArrayZValInfo(&aiSignedHash);
	zval_ptr_dtor(&zSignedHash);
	if (pzOutResult)
	{
		*OutResult = (int8_t)Z_BVAL_P(pzOutResult);
		zval_ptr_dtor(&pzOutResult);
	}
}

zend_class_entry *TSBCMSSignatureState_ce_ptr = NULL;

zend_class_entry *TElASN1DirectoryString_ce_ptr = NULL;

SB_PHP_METHOD(TElASN1DirectoryString, get_Value)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElASN1DirectoryString_get_Value(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-56606743, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElASN1DirectoryString, set_Value)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElASN1DirectoryString_set_Value(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElASN1DirectoryString, get_Encoding)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBASN1DirectoryStringEncodingRaw fOutResultRaw = 0;
		SBCheckError(TElASN1DirectoryString_get_Encoding(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElASN1DirectoryString, set_Encoding)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElASN1DirectoryString_set_Encoding(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBASN1DirectoryStringEncodingRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElASN1DirectoryString, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElASN1DirectoryString_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASN1DirectoryString_get_Value, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASN1DirectoryString_set_Value, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASN1DirectoryString_get_Encoding, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASN1DirectoryString_set_Encoding, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASN1DirectoryString___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElASN1DirectoryString_methods[] = {
	PHP_ME(TElASN1DirectoryString, get_Value, arginfo_TElASN1DirectoryString_get_Value, ZEND_ACC_PUBLIC)
	PHP_ME(TElASN1DirectoryString, set_Value, arginfo_TElASN1DirectoryString_set_Value, ZEND_ACC_PUBLIC)
	PHP_ME(TElASN1DirectoryString, get_Encoding, arginfo_TElASN1DirectoryString_get_Encoding, ZEND_ACC_PUBLIC)
	PHP_ME(TElASN1DirectoryString, set_Encoding, arginfo_TElASN1DirectoryString_set_Encoding, ZEND_ACC_PUBLIC)
	PHP_ME(TElASN1DirectoryString, __construct, arginfo_TElASN1DirectoryString___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElASN1DirectoryString(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElASN1DirectoryString_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElASN1DirectoryString", TElASN1DirectoryString_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElASN1DirectoryString_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElCMSProperty_ce_ptr = NULL;

SB_PHP_METHOD(TElCMSProperty, get_Included)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElCMSProperty_get_Included(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSProperty, set_Included)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElCMSProperty_set_Included(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSProperty, get_Signed)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElCMSProperty_get_Signed(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSProperty, set_Signed)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElCMSProperty_set_Signed(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSProperty, get_RecalculateValue)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElCMSProperty_get_RecalculateValue(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSProperty, set_RecalculateValue)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElCMSProperty_set_RecalculateValue(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSProperty, get_RawValue)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElCMSProperty_get_RawValue(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(1781252699, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSProperty, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCMSProperty_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSProperty_get_Included, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSProperty_set_Included, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSProperty_get_Signed, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSProperty_set_Signed, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSProperty_get_RecalculateValue, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSProperty_set_RecalculateValue, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSProperty_get_RawValue, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSProperty___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElCMSProperty_methods[] = {
	PHP_ME(TElCMSProperty, get_Included, arginfo_TElCMSProperty_get_Included, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSProperty, set_Included, arginfo_TElCMSProperty_set_Included, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSProperty, get_Signed, arginfo_TElCMSProperty_get_Signed, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSProperty, set_Signed, arginfo_TElCMSProperty_set_Signed, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSProperty, get_RecalculateValue, arginfo_TElCMSProperty_get_RecalculateValue, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSProperty, set_RecalculateValue, arginfo_TElCMSProperty_set_RecalculateValue, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSProperty, get_RawValue, arginfo_TElCMSProperty_get_RawValue, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSProperty, __construct, arginfo_TElCMSProperty___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElCMSProperty(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElCMSProperty_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElCMSProperty", TElCMSProperty_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElCMSProperty_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElCMSHash_ce_ptr = NULL;

SB_PHP_METHOD(TElCMSHash, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElCMSHash_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSHash, get_HashAlgorithm)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElCMSHash_get_HashAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSHash, set_HashAlgorithm)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElCMSHash_set_HashAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSHash, get_HashAlgorithmParams)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElCMSHash_get_HashAlgorithmParams(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(1552069653, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSHash, set_HashAlgorithmParams)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElCMSHash_set_HashAlgorithmParams(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSHash, get_HashValue)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElCMSHash_get_HashValue(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-1272502510, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSHash, set_HashValue)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElCMSHash_set_HashValue(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSHash, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCMSHash_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSHash_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSHash_get_HashAlgorithm, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSHash_set_HashAlgorithm, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSHash_get_HashAlgorithmParams, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSHash_set_HashAlgorithmParams, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSHash_get_HashValue, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSHash_set_HashValue, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSHash___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElCMSHash_methods[] = {
	PHP_ME(TElCMSHash, Clear, arginfo_TElCMSHash_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSHash, get_HashAlgorithm, arginfo_TElCMSHash_get_HashAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSHash, set_HashAlgorithm, arginfo_TElCMSHash_set_HashAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSHash, get_HashAlgorithmParams, arginfo_TElCMSHash_get_HashAlgorithmParams, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSHash, set_HashAlgorithmParams, arginfo_TElCMSHash_set_HashAlgorithmParams, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSHash, get_HashValue, arginfo_TElCMSHash_get_HashValue, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSHash, set_HashValue, arginfo_TElCMSHash_set_HashValue, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSHash, __construct, arginfo_TElCMSHash___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElCMSHash(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElCMSHash_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElCMSHash", TElCMSHash_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElCMSHash_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElCMSSignerIdentifier_ce_ptr = NULL;

SB_PHP_METHOD(TElCMSSignerIdentifier, Import)
{
	long l4HashAlgorithm;
	zval *oCert;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!l", &oCert, TElX509Certificate_ce_ptr, &l4HashAlgorithm) == SUCCESS)
	{
		SBCheckError(TElCMSSignerIdentifier_Import(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oCert TSRMLS_CC), (int32_t)l4HashAlgorithm) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElX509Certificate, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSignerIdentifier, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElCMSSignerIdentifier_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSignerIdentifier, Corresponds)
{
	zval *oCert;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oCert, TElX509Certificate_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElCMSSignerIdentifier_Corresponds(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oCert TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElX509Certificate)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSignerIdentifier, get_Hash)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCMSSignerIdentifier_get_Hash(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCMSHash_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSignerIdentifier, get_Issuer)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCMSSignerIdentifier_get_Issuer(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElGeneralNames_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSignerIdentifier, get_SerialNumber)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElCMSSignerIdentifier_get_SerialNumber(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-2122149540, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSignerIdentifier, get_SignerIdentifierType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBCMSSignerIdentifierTypeRaw fOutResultRaw = 0;
		SBCheckError(TElCMSSignerIdentifier_get_SignerIdentifierType(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSignerIdentifier, set_SignerIdentifierType)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElCMSSignerIdentifier_set_SignerIdentifierType(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBCMSSignerIdentifierTypeRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSignerIdentifier, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCMSSignerIdentifier_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignerIdentifier_Import, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, Cert, TElX509Certificate, 1)
	ZEND_ARG_INFO(0, HashAlgorithm)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignerIdentifier_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignerIdentifier_Corresponds, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Cert, TElX509Certificate, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignerIdentifier_get_Hash, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignerIdentifier_get_Issuer, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignerIdentifier_get_SerialNumber, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignerIdentifier_get_SignerIdentifierType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignerIdentifier_set_SignerIdentifierType, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignerIdentifier___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElCMSSignerIdentifier_methods[] = {
	PHP_ME(TElCMSSignerIdentifier, Import, arginfo_TElCMSSignerIdentifier_Import, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSignerIdentifier, Clear, arginfo_TElCMSSignerIdentifier_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSignerIdentifier, Corresponds, arginfo_TElCMSSignerIdentifier_Corresponds, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSignerIdentifier, get_Hash, arginfo_TElCMSSignerIdentifier_get_Hash, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSignerIdentifier, get_Issuer, arginfo_TElCMSSignerIdentifier_get_Issuer, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSignerIdentifier, get_SerialNumber, arginfo_TElCMSSignerIdentifier_get_SerialNumber, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSignerIdentifier, get_SignerIdentifierType, arginfo_TElCMSSignerIdentifier_get_SignerIdentifierType, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSignerIdentifier, set_SignerIdentifierType, arginfo_TElCMSSignerIdentifier_set_SignerIdentifierType, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSignerIdentifier, __construct, arginfo_TElCMSSignerIdentifier___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElCMSSignerIdentifier(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElCMSSignerIdentifier_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElCMSSignerIdentifier", TElCMSSignerIdentifier_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElCMSSignerIdentifier_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElCMSCertificateRefs_ce_ptr = NULL;

SB_PHP_METHOD(TElCMSCertificateRefs, Add)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElCMSCertificateRefs_Add(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSCertificateRefs, Remove)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		SBCheckError(TElCMSCertificateRefs_Remove(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSCertificateRefs, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElCMSCertificateRefs_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSCertificateRefs, get_CertIDs)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCMSCertificateRefs_get_CertIDs(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCMSSignerIdentifier_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSCertificateRefs, get_CertIDCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElCMSCertificateRefs_get_CertIDCount(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSCertificateRefs, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCMSCertificateRefs_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSCertificateRefs_Add, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSCertificateRefs_Remove, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSCertificateRefs_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSCertificateRefs_get_CertIDs, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSCertificateRefs_get_CertIDCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSCertificateRefs___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElCMSCertificateRefs_methods[] = {
	PHP_ME(TElCMSCertificateRefs, Add, arginfo_TElCMSCertificateRefs_Add, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSCertificateRefs, Remove, arginfo_TElCMSCertificateRefs_Remove, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSCertificateRefs, Clear, arginfo_TElCMSCertificateRefs_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSCertificateRefs, get_CertIDs, arginfo_TElCMSCertificateRefs_get_CertIDs, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSCertificateRefs, get_CertIDCount, arginfo_TElCMSCertificateRefs_get_CertIDCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSCertificateRefs, __construct, arginfo_TElCMSCertificateRefs___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElCMSCertificateRefs(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElCMSCertificateRefs_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElCMSCertificateRefs", TElCMSCertificateRefs_methods);
	if (NULL == TElCMSProperty_ce_ptr)
		Register_TElCMSProperty(TSRMLS_C);
	TElCMSCertificateRefs_ce_ptr = zend_register_internal_class_ex(&ce, TElCMSProperty_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElCMSCRLIdentifier_ce_ptr = NULL;

SB_PHP_METHOD(TElCMSCRLIdentifier, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElCMSCRLIdentifier_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSCRLIdentifier, get_Issuer)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCMSCRLIdentifier_get_Issuer(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElRelativeDistinguishedName_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSCRLIdentifier, get_Time)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(TElCMSCRLIdentifier_get_Time(SBGetObjectHandle(getThis() TSRMLS_CC), &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSCRLIdentifier, set_Time)
{
	zval *dtValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &dtValue, php_date_get_date_ce()) == SUCCESS)
	{
		SBCheckError(TElCMSCRLIdentifier_set_Time(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetDateTime(dtValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(DateTime)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSCRLIdentifier, get_Number)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElCMSCRLIdentifier_get_Number(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSCRLIdentifier, set_Number)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElCMSCRLIdentifier_set_Number(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSCRLIdentifier, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCMSCRLIdentifier_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSCRLIdentifier_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSCRLIdentifier_get_Issuer, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSCRLIdentifier_get_Time, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSCRLIdentifier_set_Time, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, DateTime, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSCRLIdentifier_get_Number, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSCRLIdentifier_set_Number, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSCRLIdentifier___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElCMSCRLIdentifier_methods[] = {
	PHP_ME(TElCMSCRLIdentifier, Clear, arginfo_TElCMSCRLIdentifier_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSCRLIdentifier, get_Issuer, arginfo_TElCMSCRLIdentifier_get_Issuer, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSCRLIdentifier, get_Time, arginfo_TElCMSCRLIdentifier_get_Time, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSCRLIdentifier, set_Time, arginfo_TElCMSCRLIdentifier_set_Time, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSCRLIdentifier, get_Number, arginfo_TElCMSCRLIdentifier_get_Number, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSCRLIdentifier, set_Number, arginfo_TElCMSCRLIdentifier_set_Number, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSCRLIdentifier, __construct, arginfo_TElCMSCRLIdentifier___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElCMSCRLIdentifier(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElCMSCRLIdentifier_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElCMSCRLIdentifier", TElCMSCRLIdentifier_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElCMSCRLIdentifier_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElCMSCRLValidatedID_ce_ptr = NULL;

SB_PHP_METHOD(TElCMSCRLValidatedID, Import)
{
	long l4HashAlgorithm;
	zval *oCRL;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!l", &oCRL, TElCertificateRevocationList_ce_ptr, &l4HashAlgorithm) == SUCCESS)
	{
		SBCheckError(TElCMSCRLValidatedID_Import(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oCRL TSRMLS_CC), (int32_t)l4HashAlgorithm) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCertificateRevocationList, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSCRLValidatedID, CRLMatches)
{
	zval *oCRL;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oCRL, TElCertificateRevocationList_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElCMSCRLValidatedID_CRLMatches(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oCRL TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElCertificateRevocationList)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSCRLValidatedID, get_CRLHash)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCMSCRLValidatedID_get_CRLHash(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCMSHash_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSCRLValidatedID, get_CRLIdentifier)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCMSCRLValidatedID_get_CRLIdentifier(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCMSCRLIdentifier_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSCRLValidatedID, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCMSCRLValidatedID_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSCRLValidatedID_Import, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, CRL, TElCertificateRevocationList, 1)
	ZEND_ARG_INFO(0, HashAlgorithm)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSCRLValidatedID_CRLMatches, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, CRL, TElCertificateRevocationList, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSCRLValidatedID_get_CRLHash, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSCRLValidatedID_get_CRLIdentifier, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSCRLValidatedID___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElCMSCRLValidatedID_methods[] = {
	PHP_ME(TElCMSCRLValidatedID, Import, arginfo_TElCMSCRLValidatedID_Import, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSCRLValidatedID, CRLMatches, arginfo_TElCMSCRLValidatedID_CRLMatches, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSCRLValidatedID, get_CRLHash, arginfo_TElCMSCRLValidatedID_get_CRLHash, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSCRLValidatedID, get_CRLIdentifier, arginfo_TElCMSCRLValidatedID_get_CRLIdentifier, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSCRLValidatedID, __construct, arginfo_TElCMSCRLValidatedID___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElCMSCRLValidatedID(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElCMSCRLValidatedID_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElCMSCRLValidatedID", TElCMSCRLValidatedID_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElCMSCRLValidatedID_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElCMSOCSPIdentifier_ce_ptr = NULL;

SB_PHP_METHOD(TElCMSOCSPIdentifier, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TElCMSOCSPIdentifier_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElCMSOCSPIdentifier_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCMSOCSPIdentifier)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSOCSPIdentifier, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElCMSOCSPIdentifier_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSOCSPIdentifier, get_ResponderID)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCMSOCSPIdentifier_get_ResponderID(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElOCSPResponderID_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSOCSPIdentifier, get_Time)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(TElCMSOCSPIdentifier_get_Time(SBGetObjectHandle(getThis() TSRMLS_CC), &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSOCSPIdentifier, set_Time)
{
	zval *dtValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &dtValue, php_date_get_date_ce()) == SUCCESS)
	{
		SBCheckError(TElCMSOCSPIdentifier_set_Time(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetDateTime(dtValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(DateTime)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSOCSPIdentifier, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCMSOCSPIdentifier_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSOCSPIdentifier_Assign, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Source, TElCMSOCSPIdentifier, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSOCSPIdentifier_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSOCSPIdentifier_get_ResponderID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSOCSPIdentifier_get_Time, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSOCSPIdentifier_set_Time, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, DateTime, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSOCSPIdentifier___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElCMSOCSPIdentifier_methods[] = {
	PHP_ME(TElCMSOCSPIdentifier, Assign, arginfo_TElCMSOCSPIdentifier_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSOCSPIdentifier, Clear, arginfo_TElCMSOCSPIdentifier_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSOCSPIdentifier, get_ResponderID, arginfo_TElCMSOCSPIdentifier_get_ResponderID, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSOCSPIdentifier, get_Time, arginfo_TElCMSOCSPIdentifier_get_Time, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSOCSPIdentifier, set_Time, arginfo_TElCMSOCSPIdentifier_set_Time, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSOCSPIdentifier, __construct, arginfo_TElCMSOCSPIdentifier___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElCMSOCSPIdentifier(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElCMSOCSPIdentifier_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElCMSOCSPIdentifier", TElCMSOCSPIdentifier_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElCMSOCSPIdentifier_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElCMSOCSPResponsesID_ce_ptr = NULL;

SB_PHP_METHOD(TElCMSOCSPResponsesID, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElCMSOCSPResponsesID_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSOCSPResponsesID, Import)
{
	long l4HashAlgorithm;
	zval *oResponse;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!l", &oResponse, TElOCSPResponse_ce_ptr, &l4HashAlgorithm) == SUCCESS)
	{
		SBCheckError(TElCMSOCSPResponsesID_Import(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oResponse TSRMLS_CC), (int32_t)l4HashAlgorithm) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElOCSPResponse, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSOCSPResponsesID, OCSPResponseMatches)
{
	zval *oResponse;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oResponse, TElOCSPResponse_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElCMSOCSPResponsesID_OCSPResponseMatches(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oResponse TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElOCSPResponse)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSOCSPResponsesID, get_OCSPIdentifier)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCMSOCSPResponsesID_get_OCSPIdentifier(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCMSOCSPIdentifier_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSOCSPResponsesID, get_OCSPHash)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCMSOCSPResponsesID_get_OCSPHash(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCMSHash_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSOCSPResponsesID, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCMSOCSPResponsesID_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSOCSPResponsesID_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSOCSPResponsesID_Import, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, Response, TElOCSPResponse, 1)
	ZEND_ARG_INFO(0, HashAlgorithm)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSOCSPResponsesID_OCSPResponseMatches, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Response, TElOCSPResponse, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSOCSPResponsesID_get_OCSPIdentifier, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSOCSPResponsesID_get_OCSPHash, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSOCSPResponsesID___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElCMSOCSPResponsesID_methods[] = {
	PHP_ME(TElCMSOCSPResponsesID, Clear, arginfo_TElCMSOCSPResponsesID_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSOCSPResponsesID, Import, arginfo_TElCMSOCSPResponsesID_Import, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSOCSPResponsesID, OCSPResponseMatches, arginfo_TElCMSOCSPResponsesID_OCSPResponseMatches, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSOCSPResponsesID, get_OCSPIdentifier, arginfo_TElCMSOCSPResponsesID_get_OCSPIdentifier, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSOCSPResponsesID, get_OCSPHash, arginfo_TElCMSOCSPResponsesID_get_OCSPHash, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSOCSPResponsesID, __construct, arginfo_TElCMSOCSPResponsesID___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElCMSOCSPResponsesID(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElCMSOCSPResponsesID_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElCMSOCSPResponsesID", TElCMSOCSPResponsesID_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElCMSOCSPResponsesID_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElCMSRevocationRef_ce_ptr = NULL;

SB_PHP_METHOD(TElCMSRevocationRef, AddCRLID)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElCMSRevocationRef_AddCRLID(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSRevocationRef, AddOCSPID)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElCMSRevocationRef_AddOCSPID(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSRevocationRef, RemoveCRLID)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		SBCheckError(TElCMSRevocationRef_RemoveCRLID(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSRevocationRef, RemoveOCSPID)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		SBCheckError(TElCMSRevocationRef_RemoveOCSPID(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSRevocationRef, ClearCRLIDs)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElCMSRevocationRef_ClearCRLIDs(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSRevocationRef, ClearOCSPIDs)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElCMSRevocationRef_ClearOCSPIDs(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSRevocationRef, Import)
{
	zval *oCRLList;
	zval *oOCSPList;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oCRLList, TList_ce_ptr, &oOCSPList, TList_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElCMSRevocationRef_Import(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oCRLList TSRMLS_CC), SBGetObjectHandle(oOCSPList TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TList, TList)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSRevocationRef, Import2)
{
	zval *oCRLs;
	zval *oOCSPList;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oCRLs, TElMemoryCRLStorage_ce_ptr, &oOCSPList, TList_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElCMSRevocationRef_Import2(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oCRLs TSRMLS_CC), SBGetObjectHandle(oOCSPList TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElMemoryCRLStorage, TList)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSRevocationRef, get_CRLIDs)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCMSRevocationRef_get_CRLIDs(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCMSCRLValidatedID_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSRevocationRef, get_OCSPIDs)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCMSRevocationRef_get_OCSPIDs(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCMSOCSPResponsesID_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSRevocationRef, get_CRLIDCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElCMSRevocationRef_get_CRLIDCount(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSRevocationRef, get_OCSPIDCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElCMSRevocationRef_get_OCSPIDCount(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSRevocationRef, get_OtherRevType)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElCMSRevocationRef_get_OtherRevType(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(841193973, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSRevocationRef, set_OtherRevType)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElCMSRevocationRef_set_OtherRevType(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSRevocationRef, get_OtherRevRefs)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElCMSRevocationRef_get_OtherRevRefs(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-365388613, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSRevocationRef, set_OtherRevRefs)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElCMSRevocationRef_set_OtherRevRefs(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSRevocationRef, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCMSRevocationRef_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSRevocationRef_AddCRLID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSRevocationRef_AddOCSPID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSRevocationRef_RemoveCRLID, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSRevocationRef_RemoveOCSPID, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSRevocationRef_ClearCRLIDs, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSRevocationRef_ClearOCSPIDs, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSRevocationRef_Import, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, CRLList, TList, 1)
	ZEND_ARG_OBJ_INFO(0, OCSPList, TList, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSRevocationRef_Import2, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, CRLs, TElMemoryCRLStorage, 1)
	ZEND_ARG_OBJ_INFO(0, OCSPList, TList, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSRevocationRef_get_CRLIDs, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSRevocationRef_get_OCSPIDs, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSRevocationRef_get_CRLIDCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSRevocationRef_get_OCSPIDCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSRevocationRef_get_OtherRevType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSRevocationRef_set_OtherRevType, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSRevocationRef_get_OtherRevRefs, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSRevocationRef_set_OtherRevRefs, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSRevocationRef___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElCMSRevocationRef_methods[] = {
	PHP_ME(TElCMSRevocationRef, AddCRLID, arginfo_TElCMSRevocationRef_AddCRLID, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSRevocationRef, AddOCSPID, arginfo_TElCMSRevocationRef_AddOCSPID, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSRevocationRef, RemoveCRLID, arginfo_TElCMSRevocationRef_RemoveCRLID, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSRevocationRef, RemoveOCSPID, arginfo_TElCMSRevocationRef_RemoveOCSPID, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSRevocationRef, ClearCRLIDs, arginfo_TElCMSRevocationRef_ClearCRLIDs, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSRevocationRef, ClearOCSPIDs, arginfo_TElCMSRevocationRef_ClearOCSPIDs, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSRevocationRef, Import, arginfo_TElCMSRevocationRef_Import, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSRevocationRef, Import2, arginfo_TElCMSRevocationRef_Import2, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSRevocationRef, get_CRLIDs, arginfo_TElCMSRevocationRef_get_CRLIDs, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSRevocationRef, get_OCSPIDs, arginfo_TElCMSRevocationRef_get_OCSPIDs, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSRevocationRef, get_CRLIDCount, arginfo_TElCMSRevocationRef_get_CRLIDCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSRevocationRef, get_OCSPIDCount, arginfo_TElCMSRevocationRef_get_OCSPIDCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSRevocationRef, get_OtherRevType, arginfo_TElCMSRevocationRef_get_OtherRevType, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSRevocationRef, set_OtherRevType, arginfo_TElCMSRevocationRef_set_OtherRevType, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSRevocationRef, get_OtherRevRefs, arginfo_TElCMSRevocationRef_get_OtherRevRefs, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSRevocationRef, set_OtherRevRefs, arginfo_TElCMSRevocationRef_set_OtherRevRefs, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSRevocationRef, __construct, arginfo_TElCMSRevocationRef___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElCMSRevocationRef(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElCMSRevocationRef_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElCMSRevocationRef", TElCMSRevocationRef_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElCMSRevocationRef_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElCMSRevocationRefs_ce_ptr = NULL;

SB_PHP_METHOD(TElCMSRevocationRefs, Add)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElCMSRevocationRefs_Add(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSRevocationRefs, Remove)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		SBCheckError(TElCMSRevocationRefs_Remove(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSRevocationRefs, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElCMSRevocationRefs_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSRevocationRefs, get_Refs)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCMSRevocationRefs_get_Refs(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCMSRevocationRef_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSRevocationRefs, get_RefCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElCMSRevocationRefs_get_RefCount(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSRevocationRefs, get_AddASN1ExplicitTagsForEmptyRecords)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElCMSRevocationRefs_get_AddASN1ExplicitTagsForEmptyRecords(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSRevocationRefs, set_AddASN1ExplicitTagsForEmptyRecords)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElCMSRevocationRefs_set_AddASN1ExplicitTagsForEmptyRecords(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSRevocationRefs, get_WriteMode)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBCMSRevocationRefsWriteModeRaw fOutResultRaw = 0;
		SBCheckError(TElCMSRevocationRefs_get_WriteMode(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSRevocationRefs, set_WriteMode)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElCMSRevocationRefs_set_WriteMode(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBCMSRevocationRefsWriteModeRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSRevocationRefs, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCMSRevocationRefs_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSRevocationRefs_Add, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSRevocationRefs_Remove, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSRevocationRefs_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSRevocationRefs_get_Refs, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSRevocationRefs_get_RefCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSRevocationRefs_get_AddASN1ExplicitTagsForEmptyRecords, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSRevocationRefs_set_AddASN1ExplicitTagsForEmptyRecords, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSRevocationRefs_get_WriteMode, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSRevocationRefs_set_WriteMode, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSRevocationRefs___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElCMSRevocationRefs_methods[] = {
	PHP_ME(TElCMSRevocationRefs, Add, arginfo_TElCMSRevocationRefs_Add, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSRevocationRefs, Remove, arginfo_TElCMSRevocationRefs_Remove, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSRevocationRefs, Clear, arginfo_TElCMSRevocationRefs_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSRevocationRefs, get_Refs, arginfo_TElCMSRevocationRefs_get_Refs, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSRevocationRefs, get_RefCount, arginfo_TElCMSRevocationRefs_get_RefCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSRevocationRefs, get_AddASN1ExplicitTagsForEmptyRecords, arginfo_TElCMSRevocationRefs_get_AddASN1ExplicitTagsForEmptyRecords, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSRevocationRefs, set_AddASN1ExplicitTagsForEmptyRecords, arginfo_TElCMSRevocationRefs_set_AddASN1ExplicitTagsForEmptyRecords, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSRevocationRefs, get_WriteMode, arginfo_TElCMSRevocationRefs_get_WriteMode, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSRevocationRefs, set_WriteMode, arginfo_TElCMSRevocationRefs_set_WriteMode, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSRevocationRefs, __construct, arginfo_TElCMSRevocationRefs___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElCMSRevocationRefs(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElCMSRevocationRefs_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElCMSRevocationRefs", TElCMSRevocationRefs_methods);
	if (NULL == TElCMSProperty_ce_ptr)
		Register_TElCMSProperty(TSRMLS_C);
	TElCMSRevocationRefs_ce_ptr = zend_register_internal_class_ex(&ce, TElCMSProperty_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElCMSRevocationValues_ce_ptr = NULL;

SB_PHP_METHOD(TElCMSRevocationValues, AddCRL)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElCMSRevocationValues_AddCRL(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSRevocationValues, AddOCSPResponse)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElCMSRevocationValues_AddOCSPResponse(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSRevocationValues, RemoveCRL)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		SBCheckError(TElCMSRevocationValues_RemoveCRL(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSRevocationValues, RemoveOCSPResponse)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		SBCheckError(TElCMSRevocationValues_RemoveOCSPResponse(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSRevocationValues, ClearCRLs)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElCMSRevocationValues_ClearCRLs(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSRevocationValues, ClearOCSPResponses)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElCMSRevocationValues_ClearOCSPResponses(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSRevocationValues, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElCMSRevocationValues_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSRevocationValues, get_CRLs)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCMSRevocationValues_get_CRLs(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCertificateRevocationList_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSRevocationValues, get_OCSPResponses)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCMSRevocationValues_get_OCSPResponses(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElOCSPResponse_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSRevocationValues, get_CRLCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElCMSRevocationValues_get_CRLCount(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSRevocationValues, get_OCSPResponseCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElCMSRevocationValues_get_OCSPResponseCount(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSRevocationValues, get_OtherRevType)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElCMSRevocationValues_get_OtherRevType(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-2012533883, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSRevocationValues, set_OtherRevType)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElCMSRevocationValues_set_OtherRevType(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSRevocationValues, get_OtherRevValues)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElCMSRevocationValues_get_OtherRevValues(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(545231934, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSRevocationValues, set_OtherRevValues)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElCMSRevocationValues_set_OtherRevValues(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSRevocationValues, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCMSRevocationValues_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSRevocationValues_AddCRL, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSRevocationValues_AddOCSPResponse, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSRevocationValues_RemoveCRL, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSRevocationValues_RemoveOCSPResponse, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSRevocationValues_ClearCRLs, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSRevocationValues_ClearOCSPResponses, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSRevocationValues_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSRevocationValues_get_CRLs, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSRevocationValues_get_OCSPResponses, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSRevocationValues_get_CRLCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSRevocationValues_get_OCSPResponseCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSRevocationValues_get_OtherRevType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSRevocationValues_set_OtherRevType, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSRevocationValues_get_OtherRevValues, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSRevocationValues_set_OtherRevValues, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSRevocationValues___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElCMSRevocationValues_methods[] = {
	PHP_ME(TElCMSRevocationValues, AddCRL, arginfo_TElCMSRevocationValues_AddCRL, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSRevocationValues, AddOCSPResponse, arginfo_TElCMSRevocationValues_AddOCSPResponse, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSRevocationValues, RemoveCRL, arginfo_TElCMSRevocationValues_RemoveCRL, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSRevocationValues, RemoveOCSPResponse, arginfo_TElCMSRevocationValues_RemoveOCSPResponse, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSRevocationValues, ClearCRLs, arginfo_TElCMSRevocationValues_ClearCRLs, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSRevocationValues, ClearOCSPResponses, arginfo_TElCMSRevocationValues_ClearOCSPResponses, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSRevocationValues, Clear, arginfo_TElCMSRevocationValues_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSRevocationValues, get_CRLs, arginfo_TElCMSRevocationValues_get_CRLs, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSRevocationValues, get_OCSPResponses, arginfo_TElCMSRevocationValues_get_OCSPResponses, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSRevocationValues, get_CRLCount, arginfo_TElCMSRevocationValues_get_CRLCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSRevocationValues, get_OCSPResponseCount, arginfo_TElCMSRevocationValues_get_OCSPResponseCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSRevocationValues, get_OtherRevType, arginfo_TElCMSRevocationValues_get_OtherRevType, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSRevocationValues, set_OtherRevType, arginfo_TElCMSRevocationValues_set_OtherRevType, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSRevocationValues, get_OtherRevValues, arginfo_TElCMSRevocationValues_get_OtherRevValues, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSRevocationValues, set_OtherRevValues, arginfo_TElCMSRevocationValues_set_OtherRevValues, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSRevocationValues, __construct, arginfo_TElCMSRevocationValues___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElCMSRevocationValues(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElCMSRevocationValues_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElCMSRevocationValues", TElCMSRevocationValues_methods);
	if (NULL == TElCMSProperty_ce_ptr)
		Register_TElCMSProperty(TSRMLS_C);
	TElCMSRevocationValues_ce_ptr = zend_register_internal_class_ex(&ce, TElCMSProperty_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElCMSContent_ce_ptr = NULL;

SB_PHP_METHOD(TElCMSContent, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElCMSContent_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSContent, Init)
{
	long l4Size;
	long l8Offset;
	long l8Size;
	SBArrayZValInfo piBuffer;
	zval *oStream;
	zval *zpBuffer;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!ll", &oStream, TStream_ce_ptr, &l8Offset, &l8Size) == SUCCESS)
	{
		SBCheckError(TElCMSContent_Init(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC), (int64_t)l8Offset, (int64_t)l8Size) TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zpBuffer, &l4Size) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElCMSContent_Init_1(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, (int32_t)l4Size) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
	}
	else
	{
		SBErrorExpectsArguments("(TStream, integer, integer) or (TSBPointer|array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSContent, Read)
{
	long l4Size;
	long l8Offset;
	SBArrayZValInfo piBuffer;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zll", &zpBuffer, &l4Size, &l8Offset) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElCMSContent_Read(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, (int32_t)l4Size, (int64_t)l8Offset, &l4OutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSContent, AddKnownHash)
{
	long l4AlgID;
	SBArrayZValInfo aiHash;
	SBArrayZValInfo aiHashAlgParams;
	zval *zaHash;
	zval *zaHashAlgParams;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElCMSContent_AddKnownHash(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lzz", &l4AlgID, &zaHashAlgParams, &zaHash) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaHashAlgParams)) || (IS_ARRAY == Z_TYPE_P(zaHashAlgParams)) || (IS_NULL == Z_TYPE_P(zaHashAlgParams))) && ((IS_STRING == Z_TYPE_P(zaHash)) || (IS_ARRAY == Z_TYPE_P(zaHash)) || (IS_NULL == Z_TYPE_P(zaHash))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaHashAlgParams, &aiHashAlgParams TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaHash, &aiHash TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElCMSContent_AddKnownHash_1(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4AlgID, aiHashAlgParams.data, aiHashAlgParams.len, aiHash.data, aiHash.len, &l4OutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiHashAlgParams);
		SBFreeArrayZValInfo(&aiHash);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("() or (integer, array of byte|string|NULL, array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSContent, RemoveKnownHash)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		SBCheckError(TElCMSContent_RemoveKnownHash(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSContent, ClearKnownHashes)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElCMSContent_ClearKnownHashes(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSContent, get_Size)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElCMSContent_get_Size(SBGetObjectHandle(getThis() TSRMLS_CC), &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSContent, get_ContentIsHash)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElCMSContent_get_ContentIsHash(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSContent, set_ContentIsHash)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElCMSContent_set_ContentIsHash(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSContent, get_RawContent)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElCMSContent_get_RawContent(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-1316200630, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSContent, get_KnownHashes)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCMSContent_get_KnownHashes(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCMSHash_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSContent, get_KnownHashCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElCMSContent_get_KnownHashCount(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSContent, __construct)
{
	zval *oData;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCMSContent_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oData, TElPKCS7SignedData_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCMSContent_Create_1(SBGetObjectHandle(oData TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oData, TElPKCS7SignedAndEnvelopedData_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCMSContent_Create_2(SBGetObjectHandle(oData TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("() or (TElPKCS7SignedData) or (TElPKCS7SignedAndEnvelopedData)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSContent_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSContent_Init, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Stream_or_Buffer, 0, 1)
	ZEND_ARG_INFO(0, Offset_or_Size)
	ZEND_ARG_INFO(0, Size)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSContent_Read, 0, 0, 3)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(0, Size)
	ZEND_ARG_INFO(0, Offset)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSContent_AddKnownHash, 0, 0, 0)
	ZEND_ARG_INFO(0, AlgID)
	ZEND_ARG_TYPE_INFO(0, HashAlgParams, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Hash, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSContent_RemoveKnownHash, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSContent_ClearKnownHashes, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSContent_get_Size, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSContent_get_ContentIsHash, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSContent_set_ContentIsHash, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSContent_get_RawContent, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSContent_get_KnownHashes, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSContent_get_KnownHashCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSContent___construct, 0, 0, 0)
	ZEND_ARG_TYPE_INFO(0, Data, 0, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElCMSContent_methods[] = {
	PHP_ME(TElCMSContent, Clear, arginfo_TElCMSContent_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSContent, Init, arginfo_TElCMSContent_Init, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSContent, Read, arginfo_TElCMSContent_Read, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSContent, AddKnownHash, arginfo_TElCMSContent_AddKnownHash, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSContent, RemoveKnownHash, arginfo_TElCMSContent_RemoveKnownHash, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSContent, ClearKnownHashes, arginfo_TElCMSContent_ClearKnownHashes, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSContent, get_Size, arginfo_TElCMSContent_get_Size, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSContent, get_ContentIsHash, arginfo_TElCMSContent_get_ContentIsHash, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSContent, set_ContentIsHash, arginfo_TElCMSContent_set_ContentIsHash, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSContent, get_RawContent, arginfo_TElCMSContent_get_RawContent, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSContent, get_KnownHashes, arginfo_TElCMSContent_get_KnownHashes, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSContent, get_KnownHashCount, arginfo_TElCMSContent_get_KnownHashCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSContent, __construct, arginfo_TElCMSContent___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElCMSContent(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElCMSContent_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElCMSContent", TElCMSContent_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElCMSContent_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElCMSSigPolicyQualifier_ce_ptr = NULL;

SB_PHP_METHOD(TElCMSSigPolicyQualifier, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElCMSSigPolicyQualifier_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSigPolicyQualifier, AddNoticeNumber)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElCMSSigPolicyQualifier_AddNoticeNumber(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSigPolicyQualifier, RemoveNoticeNumber)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		SBCheckError(TElCMSSigPolicyQualifier_RemoveNoticeNumber(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSigPolicyQualifier, ClearNoticeNumbers)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElCMSSigPolicyQualifier_ClearNoticeNumbers(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSigPolicyQualifier, get_ID)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElCMSSigPolicyQualifier_get_ID(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(928652400, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSigPolicyQualifier, set_ID)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElCMSSigPolicyQualifier_set_ID(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSigPolicyQualifier, get_QualifierType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBSigPolicyQualifierTypeRaw fOutResultRaw = 0;
		SBCheckError(TElCMSSigPolicyQualifier_get_QualifierType(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSigPolicyQualifier, set_QualifierType)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElCMSSigPolicyQualifier_set_QualifierType(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBSigPolicyQualifierTypeRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSigPolicyQualifier, get_URI)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElCMSSigPolicyQualifier_get_URI(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1452686807, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSigPolicyQualifier, set_URI)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElCMSSigPolicyQualifier_set_URI(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSigPolicyQualifier, get_ExplicitText)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElCMSSigPolicyQualifier_get_ExplicitText(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1839922739, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSigPolicyQualifier, set_ExplicitText)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElCMSSigPolicyQualifier_set_ExplicitText(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSigPolicyQualifier, get_Organization)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElCMSSigPolicyQualifier_get_Organization(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(2093930952, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSigPolicyQualifier, set_Organization)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElCMSSigPolicyQualifier_set_Organization(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSigPolicyQualifier, get_CustomData)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElCMSSigPolicyQualifier_get_CustomData(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(305103628, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSigPolicyQualifier, set_CustomData)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElCMSSigPolicyQualifier_set_CustomData(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSigPolicyQualifier, get_NoticeNumbers)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElCMSSigPolicyQualifier_get_NoticeNumbers(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSigPolicyQualifier, set_NoticeNumbers)
{
	long l4Index;
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &l4Index, &l4Value) == SUCCESS)
	{
		SBCheckError(TElCMSSigPolicyQualifier_set_NoticeNumbers(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSigPolicyQualifier, get_NoticeNumberCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElCMSSigPolicyQualifier_get_NoticeNumberCount(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSigPolicyQualifier, get_UseUTF8)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElCMSSigPolicyQualifier_get_UseUTF8(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSigPolicyQualifier, set_UseUTF8)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElCMSSigPolicyQualifier_set_UseUTF8(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSigPolicyQualifier, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCMSSigPolicyQualifier_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSigPolicyQualifier_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSigPolicyQualifier_AddNoticeNumber, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSigPolicyQualifier_RemoveNoticeNumber, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSigPolicyQualifier_ClearNoticeNumbers, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSigPolicyQualifier_get_ID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSigPolicyQualifier_set_ID, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSigPolicyQualifier_get_QualifierType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSigPolicyQualifier_set_QualifierType, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSigPolicyQualifier_get_URI, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSigPolicyQualifier_set_URI, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSigPolicyQualifier_get_ExplicitText, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSigPolicyQualifier_set_ExplicitText, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSigPolicyQualifier_get_Organization, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSigPolicyQualifier_set_Organization, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSigPolicyQualifier_get_CustomData, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSigPolicyQualifier_set_CustomData, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSigPolicyQualifier_get_NoticeNumbers, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSigPolicyQualifier_set_NoticeNumbers, 0, 0, 2)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSigPolicyQualifier_get_NoticeNumberCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSigPolicyQualifier_get_UseUTF8, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSigPolicyQualifier_set_UseUTF8, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSigPolicyQualifier___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElCMSSigPolicyQualifier_methods[] = {
	PHP_ME(TElCMSSigPolicyQualifier, Clear, arginfo_TElCMSSigPolicyQualifier_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSigPolicyQualifier, AddNoticeNumber, arginfo_TElCMSSigPolicyQualifier_AddNoticeNumber, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSigPolicyQualifier, RemoveNoticeNumber, arginfo_TElCMSSigPolicyQualifier_RemoveNoticeNumber, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSigPolicyQualifier, ClearNoticeNumbers, arginfo_TElCMSSigPolicyQualifier_ClearNoticeNumbers, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSigPolicyQualifier, get_ID, arginfo_TElCMSSigPolicyQualifier_get_ID, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSigPolicyQualifier, set_ID, arginfo_TElCMSSigPolicyQualifier_set_ID, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSigPolicyQualifier, get_QualifierType, arginfo_TElCMSSigPolicyQualifier_get_QualifierType, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSigPolicyQualifier, set_QualifierType, arginfo_TElCMSSigPolicyQualifier_set_QualifierType, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSigPolicyQualifier, get_URI, arginfo_TElCMSSigPolicyQualifier_get_URI, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSigPolicyQualifier, set_URI, arginfo_TElCMSSigPolicyQualifier_set_URI, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSigPolicyQualifier, get_ExplicitText, arginfo_TElCMSSigPolicyQualifier_get_ExplicitText, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSigPolicyQualifier, set_ExplicitText, arginfo_TElCMSSigPolicyQualifier_set_ExplicitText, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSigPolicyQualifier, get_Organization, arginfo_TElCMSSigPolicyQualifier_get_Organization, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSigPolicyQualifier, set_Organization, arginfo_TElCMSSigPolicyQualifier_set_Organization, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSigPolicyQualifier, get_CustomData, arginfo_TElCMSSigPolicyQualifier_get_CustomData, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSigPolicyQualifier, set_CustomData, arginfo_TElCMSSigPolicyQualifier_set_CustomData, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSigPolicyQualifier, get_NoticeNumbers, arginfo_TElCMSSigPolicyQualifier_get_NoticeNumbers, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSigPolicyQualifier, set_NoticeNumbers, arginfo_TElCMSSigPolicyQualifier_set_NoticeNumbers, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSigPolicyQualifier, get_NoticeNumberCount, arginfo_TElCMSSigPolicyQualifier_get_NoticeNumberCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSigPolicyQualifier, get_UseUTF8, arginfo_TElCMSSigPolicyQualifier_get_UseUTF8, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSigPolicyQualifier, set_UseUTF8, arginfo_TElCMSSigPolicyQualifier_set_UseUTF8, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSigPolicyQualifier, __construct, arginfo_TElCMSSigPolicyQualifier___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElCMSSigPolicyQualifier(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElCMSSigPolicyQualifier_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElCMSSigPolicyQualifier", TElCMSSigPolicyQualifier_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElCMSSigPolicyQualifier_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElCMSSignaturePolicy_ce_ptr = NULL;

SB_PHP_METHOD(TElCMSSignaturePolicy, AddQualifier)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElCMSSignaturePolicy_AddQualifier(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSignaturePolicy, RemoveQualifier)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		SBCheckError(TElCMSSignaturePolicy_RemoveQualifier(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSignaturePolicy, ClearQualifiers)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElCMSSignaturePolicy_ClearQualifiers(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSignaturePolicy, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElCMSSignaturePolicy_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSignaturePolicy, get_PolicyIdentifier)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElCMSSignaturePolicy_get_PolicyIdentifier(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(703919943, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSignaturePolicy, set_PolicyIdentifier)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElCMSSignaturePolicy_set_PolicyIdentifier(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSignaturePolicy, get_PolicyHash)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCMSSignaturePolicy_get_PolicyHash(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCMSHash_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSignaturePolicy, get_Qualifiers)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCMSSignaturePolicy_get_Qualifiers(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCMSSigPolicyQualifier_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSignaturePolicy, get_QualifierCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElCMSSignaturePolicy_get_QualifierCount(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSignaturePolicy, get_Implied)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElCMSSignaturePolicy_get_Implied(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSignaturePolicy, set_Implied)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElCMSSignaturePolicy_set_Implied(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSignaturePolicy, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCMSSignaturePolicy_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignaturePolicy_AddQualifier, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignaturePolicy_RemoveQualifier, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignaturePolicy_ClearQualifiers, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignaturePolicy_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignaturePolicy_get_PolicyIdentifier, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignaturePolicy_set_PolicyIdentifier, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignaturePolicy_get_PolicyHash, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignaturePolicy_get_Qualifiers, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignaturePolicy_get_QualifierCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignaturePolicy_get_Implied, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignaturePolicy_set_Implied, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignaturePolicy___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElCMSSignaturePolicy_methods[] = {
	PHP_ME(TElCMSSignaturePolicy, AddQualifier, arginfo_TElCMSSignaturePolicy_AddQualifier, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSignaturePolicy, RemoveQualifier, arginfo_TElCMSSignaturePolicy_RemoveQualifier, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSignaturePolicy, ClearQualifiers, arginfo_TElCMSSignaturePolicy_ClearQualifiers, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSignaturePolicy, Clear, arginfo_TElCMSSignaturePolicy_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSignaturePolicy, get_PolicyIdentifier, arginfo_TElCMSSignaturePolicy_get_PolicyIdentifier, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSignaturePolicy, set_PolicyIdentifier, arginfo_TElCMSSignaturePolicy_set_PolicyIdentifier, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSignaturePolicy, get_PolicyHash, arginfo_TElCMSSignaturePolicy_get_PolicyHash, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSignaturePolicy, get_Qualifiers, arginfo_TElCMSSignaturePolicy_get_Qualifiers, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSignaturePolicy, get_QualifierCount, arginfo_TElCMSSignaturePolicy_get_QualifierCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSignaturePolicy, get_Implied, arginfo_TElCMSSignaturePolicy_get_Implied, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSignaturePolicy, set_Implied, arginfo_TElCMSSignaturePolicy_set_Implied, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSignaturePolicy, __construct, arginfo_TElCMSSignaturePolicy___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElCMSSignaturePolicy(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElCMSSignaturePolicy_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElCMSSignaturePolicy", TElCMSSignaturePolicy_methods);
	if (NULL == TElCMSProperty_ce_ptr)
		Register_TElCMSProperty(TSRMLS_C);
	TElCMSSignaturePolicy_ce_ptr = zend_register_internal_class_ex(&ce, TElCMSProperty_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElCMSContentHints_ce_ptr = NULL;

SB_PHP_METHOD(TElCMSContentHints, get_ContentDescription)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElCMSContentHints_get_ContentDescription(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1069309002, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSContentHints, set_ContentDescription)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElCMSContentHints_set_ContentDescription(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSContentHints, get_ContentType)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElCMSContentHints_get_ContentType(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(1454836111, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSContentHints, set_ContentType)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElCMSContentHints_set_ContentType(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSContentHints, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCMSContentHints_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSContentHints_get_ContentDescription, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSContentHints_set_ContentDescription, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSContentHints_get_ContentType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSContentHints_set_ContentType, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSContentHints___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElCMSContentHints_methods[] = {
	PHP_ME(TElCMSContentHints, get_ContentDescription, arginfo_TElCMSContentHints_get_ContentDescription, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSContentHints, set_ContentDescription, arginfo_TElCMSContentHints_set_ContentDescription, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSContentHints, get_ContentType, arginfo_TElCMSContentHints_get_ContentType, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSContentHints, set_ContentType, arginfo_TElCMSContentHints_set_ContentType, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSContentHints, __construct, arginfo_TElCMSContentHints___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElCMSContentHints(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElCMSContentHints_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElCMSContentHints", TElCMSContentHints_methods);
	if (NULL == TElCMSProperty_ce_ptr)
		Register_TElCMSProperty(TSRMLS_C);
	TElCMSContentHints_ce_ptr = zend_register_internal_class_ex(&ce, TElCMSProperty_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElCMSContentReference_ce_ptr = NULL;

SB_PHP_METHOD(TElCMSContentReference, get_ContentType)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElCMSContentReference_get_ContentType(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(1684689815, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSContentReference, set_ContentType)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElCMSContentReference_set_ContentType(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSContentReference, get_ContentIdentifier)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElCMSContentReference_get_ContentIdentifier(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(642625241, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSContentReference, set_ContentIdentifier)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElCMSContentReference_set_ContentIdentifier(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSContentReference, get_OriginatorSignatureValue)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElCMSContentReference_get_OriginatorSignatureValue(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-601461775, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSContentReference, set_OriginatorSignatureValue)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElCMSContentReference_set_OriginatorSignatureValue(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSContentReference, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCMSContentReference_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSContentReference_get_ContentType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSContentReference_set_ContentType, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSContentReference_get_ContentIdentifier, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSContentReference_set_ContentIdentifier, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSContentReference_get_OriginatorSignatureValue, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSContentReference_set_OriginatorSignatureValue, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSContentReference___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElCMSContentReference_methods[] = {
	PHP_ME(TElCMSContentReference, get_ContentType, arginfo_TElCMSContentReference_get_ContentType, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSContentReference, set_ContentType, arginfo_TElCMSContentReference_set_ContentType, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSContentReference, get_ContentIdentifier, arginfo_TElCMSContentReference_get_ContentIdentifier, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSContentReference, set_ContentIdentifier, arginfo_TElCMSContentReference_set_ContentIdentifier, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSContentReference, get_OriginatorSignatureValue, arginfo_TElCMSContentReference_get_OriginatorSignatureValue, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSContentReference, set_OriginatorSignatureValue, arginfo_TElCMSContentReference_set_OriginatorSignatureValue, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSContentReference, __construct, arginfo_TElCMSContentReference___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElCMSContentReference(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElCMSContentReference_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElCMSContentReference", TElCMSContentReference_methods);
	if (NULL == TElCMSProperty_ce_ptr)
		Register_TElCMSProperty(TSRMLS_C);
	TElCMSContentReference_ce_ptr = zend_register_internal_class_ex(&ce, TElCMSProperty_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElCMSCommitmentTypeIndication_ce_ptr = NULL;

SB_PHP_METHOD(TElCMSCommitmentTypeIndication, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElCMSCommitmentTypeIndication_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSCommitmentTypeIndication, get_ProofOfOrigin)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElCMSCommitmentTypeIndication_get_ProofOfOrigin(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSCommitmentTypeIndication, set_ProofOfOrigin)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElCMSCommitmentTypeIndication_set_ProofOfOrigin(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSCommitmentTypeIndication, get_ProofOfReceipt)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElCMSCommitmentTypeIndication_get_ProofOfReceipt(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSCommitmentTypeIndication, set_ProofOfReceipt)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElCMSCommitmentTypeIndication_set_ProofOfReceipt(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSCommitmentTypeIndication, get_ProofOfDelivery)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElCMSCommitmentTypeIndication_get_ProofOfDelivery(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSCommitmentTypeIndication, set_ProofOfDelivery)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElCMSCommitmentTypeIndication_set_ProofOfDelivery(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSCommitmentTypeIndication, get_ProofOfSender)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElCMSCommitmentTypeIndication_get_ProofOfSender(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSCommitmentTypeIndication, set_ProofOfSender)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElCMSCommitmentTypeIndication_set_ProofOfSender(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSCommitmentTypeIndication, get_ProofOfApproval)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElCMSCommitmentTypeIndication_get_ProofOfApproval(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSCommitmentTypeIndication, set_ProofOfApproval)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElCMSCommitmentTypeIndication_set_ProofOfApproval(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSCommitmentTypeIndication, get_ProofOfCreation)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElCMSCommitmentTypeIndication_get_ProofOfCreation(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSCommitmentTypeIndication, set_ProofOfCreation)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElCMSCommitmentTypeIndication_set_ProofOfCreation(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSCommitmentTypeIndication, get_CustomIdentifiers)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCMSCommitmentTypeIndication_get_CustomIdentifiers(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElByteArrayList_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSCommitmentTypeIndication, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCMSCommitmentTypeIndication_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSCommitmentTypeIndication_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSCommitmentTypeIndication_get_ProofOfOrigin, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSCommitmentTypeIndication_set_ProofOfOrigin, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSCommitmentTypeIndication_get_ProofOfReceipt, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSCommitmentTypeIndication_set_ProofOfReceipt, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSCommitmentTypeIndication_get_ProofOfDelivery, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSCommitmentTypeIndication_set_ProofOfDelivery, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSCommitmentTypeIndication_get_ProofOfSender, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSCommitmentTypeIndication_set_ProofOfSender, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSCommitmentTypeIndication_get_ProofOfApproval, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSCommitmentTypeIndication_set_ProofOfApproval, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSCommitmentTypeIndication_get_ProofOfCreation, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSCommitmentTypeIndication_set_ProofOfCreation, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSCommitmentTypeIndication_get_CustomIdentifiers, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSCommitmentTypeIndication___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElCMSCommitmentTypeIndication_methods[] = {
	PHP_ME(TElCMSCommitmentTypeIndication, Clear, arginfo_TElCMSCommitmentTypeIndication_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSCommitmentTypeIndication, get_ProofOfOrigin, arginfo_TElCMSCommitmentTypeIndication_get_ProofOfOrigin, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSCommitmentTypeIndication, set_ProofOfOrigin, arginfo_TElCMSCommitmentTypeIndication_set_ProofOfOrigin, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSCommitmentTypeIndication, get_ProofOfReceipt, arginfo_TElCMSCommitmentTypeIndication_get_ProofOfReceipt, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSCommitmentTypeIndication, set_ProofOfReceipt, arginfo_TElCMSCommitmentTypeIndication_set_ProofOfReceipt, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSCommitmentTypeIndication, get_ProofOfDelivery, arginfo_TElCMSCommitmentTypeIndication_get_ProofOfDelivery, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSCommitmentTypeIndication, set_ProofOfDelivery, arginfo_TElCMSCommitmentTypeIndication_set_ProofOfDelivery, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSCommitmentTypeIndication, get_ProofOfSender, arginfo_TElCMSCommitmentTypeIndication_get_ProofOfSender, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSCommitmentTypeIndication, set_ProofOfSender, arginfo_TElCMSCommitmentTypeIndication_set_ProofOfSender, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSCommitmentTypeIndication, get_ProofOfApproval, arginfo_TElCMSCommitmentTypeIndication_get_ProofOfApproval, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSCommitmentTypeIndication, set_ProofOfApproval, arginfo_TElCMSCommitmentTypeIndication_set_ProofOfApproval, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSCommitmentTypeIndication, get_ProofOfCreation, arginfo_TElCMSCommitmentTypeIndication_get_ProofOfCreation, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSCommitmentTypeIndication, set_ProofOfCreation, arginfo_TElCMSCommitmentTypeIndication_set_ProofOfCreation, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSCommitmentTypeIndication, get_CustomIdentifiers, arginfo_TElCMSCommitmentTypeIndication_get_CustomIdentifiers, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSCommitmentTypeIndication, __construct, arginfo_TElCMSCommitmentTypeIndication___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElCMSCommitmentTypeIndication(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElCMSCommitmentTypeIndication_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElCMSCommitmentTypeIndication", TElCMSCommitmentTypeIndication_methods);
	if (NULL == TElCMSProperty_ce_ptr)
		Register_TElCMSProperty(TSRMLS_C);
	TElCMSCommitmentTypeIndication_ce_ptr = zend_register_internal_class_ex(&ce, TElCMSProperty_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElCMSSignerLocation_ce_ptr = NULL;

SB_PHP_METHOD(TElCMSSignerLocation, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElCMSSignerLocation_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSignerLocation, AddPostalAddressLine)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElCMSSignerLocation_AddPostalAddressLine(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSignerLocation, RemovePostalAddressLine)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		SBCheckError(TElCMSSignerLocation_RemovePostalAddressLine(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSignerLocation, ClearPostalAddressLines)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElCMSSignerLocation_ClearPostalAddressLines(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSignerLocation, get_CountryName)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCMSSignerLocation_get_CountryName(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElASN1DirectoryString_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSignerLocation, get_LocalityName)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCMSSignerLocation_get_LocalityName(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElASN1DirectoryString_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSignerLocation, get_PostalAddressLines)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCMSSignerLocation_get_PostalAddressLines(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElASN1DirectoryString_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSignerLocation, get_PostalAddressLineCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElCMSSignerLocation_get_PostalAddressLineCount(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSignerLocation, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCMSSignerLocation_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignerLocation_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignerLocation_AddPostalAddressLine, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignerLocation_RemovePostalAddressLine, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignerLocation_ClearPostalAddressLines, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignerLocation_get_CountryName, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignerLocation_get_LocalityName, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignerLocation_get_PostalAddressLines, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignerLocation_get_PostalAddressLineCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignerLocation___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElCMSSignerLocation_methods[] = {
	PHP_ME(TElCMSSignerLocation, Clear, arginfo_TElCMSSignerLocation_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSignerLocation, AddPostalAddressLine, arginfo_TElCMSSignerLocation_AddPostalAddressLine, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSignerLocation, RemovePostalAddressLine, arginfo_TElCMSSignerLocation_RemovePostalAddressLine, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSignerLocation, ClearPostalAddressLines, arginfo_TElCMSSignerLocation_ClearPostalAddressLines, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSignerLocation, get_CountryName, arginfo_TElCMSSignerLocation_get_CountryName, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSignerLocation, get_LocalityName, arginfo_TElCMSSignerLocation_get_LocalityName, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSignerLocation, get_PostalAddressLines, arginfo_TElCMSSignerLocation_get_PostalAddressLines, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSignerLocation, get_PostalAddressLineCount, arginfo_TElCMSSignerLocation_get_PostalAddressLineCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSignerLocation, __construct, arginfo_TElCMSSignerLocation___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElCMSSignerLocation(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElCMSSignerLocation_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElCMSSignerLocation", TElCMSSignerLocation_methods);
	if (NULL == TElCMSProperty_ce_ptr)
		Register_TElCMSProperty(TSRMLS_C);
	TElCMSSignerLocation_ce_ptr = zend_register_internal_class_ex(&ce, TElCMSProperty_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElCMSSigningCertificate_ce_ptr = NULL;

SB_PHP_METHOD(TElCMSSigningCertificate, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElCMSSigningCertificate_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSigningCertificate, AddCertID)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElCMSSigningCertificate_AddCertID(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSigningCertificate, RemoveCertID)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		SBCheckError(TElCMSSigningCertificate_RemoveCertID(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSigningCertificate, ClearCertIDs)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElCMSSigningCertificate_ClearCertIDs(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSigningCertificate, Corresponds)
{
	zval *oCert;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oCert, TElX509Certificate_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElCMSSigningCertificate_Corresponds(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oCert TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElX509Certificate)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSigningCertificate, get_CertIDs)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCMSSigningCertificate_get_CertIDs(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCMSSignerIdentifier_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSigningCertificate, get_CertIDCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElCMSSigningCertificate_get_CertIDCount(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSigningCertificate, get_SigningCertificateType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBCMSSigningCertificateTypeRaw fOutResultRaw = 0;
		SBCheckError(TElCMSSigningCertificate_get_SigningCertificateType(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSigningCertificate, set_SigningCertificateType)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElCMSSigningCertificate_set_SigningCertificateType(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBCMSSigningCertificateTypeRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSigningCertificate, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCMSSigningCertificate_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSigningCertificate_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSigningCertificate_AddCertID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSigningCertificate_RemoveCertID, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSigningCertificate_ClearCertIDs, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSigningCertificate_Corresponds, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Cert, TElX509Certificate, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSigningCertificate_get_CertIDs, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSigningCertificate_get_CertIDCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSigningCertificate_get_SigningCertificateType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSigningCertificate_set_SigningCertificateType, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSigningCertificate___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElCMSSigningCertificate_methods[] = {
	PHP_ME(TElCMSSigningCertificate, Clear, arginfo_TElCMSSigningCertificate_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSigningCertificate, AddCertID, arginfo_TElCMSSigningCertificate_AddCertID, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSigningCertificate, RemoveCertID, arginfo_TElCMSSigningCertificate_RemoveCertID, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSigningCertificate, ClearCertIDs, arginfo_TElCMSSigningCertificate_ClearCertIDs, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSigningCertificate, Corresponds, arginfo_TElCMSSigningCertificate_Corresponds, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSigningCertificate, get_CertIDs, arginfo_TElCMSSigningCertificate_get_CertIDs, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSigningCertificate, get_CertIDCount, arginfo_TElCMSSigningCertificate_get_CertIDCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSigningCertificate, get_SigningCertificateType, arginfo_TElCMSSigningCertificate_get_SigningCertificateType, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSigningCertificate, set_SigningCertificateType, arginfo_TElCMSSigningCertificate_set_SigningCertificateType, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSigningCertificate, __construct, arginfo_TElCMSSigningCertificate___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElCMSSigningCertificate(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElCMSSigningCertificate_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElCMSSigningCertificate", TElCMSSigningCertificate_methods);
	if (NULL == TElCMSProperty_ce_ptr)
		Register_TElCMSProperty(TSRMLS_C);
	TElCMSSigningCertificate_ce_ptr = zend_register_internal_class_ex(&ce, TElCMSProperty_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElCMSSignerAttributes_ce_ptr = NULL;

SB_PHP_METHOD(TElCMSSignerAttributes, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElCMSSignerAttributes_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSignerAttributes, get_ClaimedAttributes)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCMSSignerAttributes_get_ClaimedAttributes(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElPKCS7Attributes_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSignerAttributes, get_CertifiedAttributesBinary)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElCMSSignerAttributes_get_CertifiedAttributesBinary(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(112136034, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSignerAttributes, set_CertifiedAttributesBinary)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElCMSSignerAttributes_set_CertifiedAttributesBinary(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSignerAttributes, get_SignedAssertions)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCMSSignerAttributes_get_SignedAssertions(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElPKCS7Attributes_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSignerAttributes, get_Version)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBCMSSignerAttributesVersionRaw fOutResultRaw = 0;
		SBCheckError(TElCMSSignerAttributes_get_Version(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSignerAttributes, set_Version)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElCMSSignerAttributes_set_Version(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBCMSSignerAttributesVersionRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSignerAttributes, get_AttributeCertificateType)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElCMSSignerAttributes_get_AttributeCertificateType(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(1139442376, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSignerAttributes, set_AttributeCertificateType)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElCMSSignerAttributes_set_AttributeCertificateType(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSignerAttributes, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCMSSignerAttributes_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignerAttributes_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignerAttributes_get_ClaimedAttributes, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignerAttributes_get_CertifiedAttributesBinary, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignerAttributes_set_CertifiedAttributesBinary, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignerAttributes_get_SignedAssertions, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignerAttributes_get_Version, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignerAttributes_set_Version, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignerAttributes_get_AttributeCertificateType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignerAttributes_set_AttributeCertificateType, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignerAttributes___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElCMSSignerAttributes_methods[] = {
	PHP_ME(TElCMSSignerAttributes, Clear, arginfo_TElCMSSignerAttributes_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSignerAttributes, get_ClaimedAttributes, arginfo_TElCMSSignerAttributes_get_ClaimedAttributes, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSignerAttributes, get_CertifiedAttributesBinary, arginfo_TElCMSSignerAttributes_get_CertifiedAttributesBinary, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSignerAttributes, set_CertifiedAttributesBinary, arginfo_TElCMSSignerAttributes_set_CertifiedAttributesBinary, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSignerAttributes, get_SignedAssertions, arginfo_TElCMSSignerAttributes_get_SignedAssertions, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSignerAttributes, get_Version, arginfo_TElCMSSignerAttributes_get_Version, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSignerAttributes, set_Version, arginfo_TElCMSSignerAttributes_set_Version, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSignerAttributes, get_AttributeCertificateType, arginfo_TElCMSSignerAttributes_get_AttributeCertificateType, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSignerAttributes, set_AttributeCertificateType, arginfo_TElCMSSignerAttributes_set_AttributeCertificateType, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSignerAttributes, __construct, arginfo_TElCMSSignerAttributes___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElCMSSignerAttributes(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElCMSSignerAttributes_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElCMSSignerAttributes", TElCMSSignerAttributes_methods);
	if (NULL == TElCMSProperty_ce_ptr)
		Register_TElCMSProperty(TSRMLS_C);
	TElCMSSignerAttributes_ce_ptr = zend_register_internal_class_ex(&ce, TElCMSProperty_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElCMSSignaturePolicyStore_ce_ptr = NULL;

SB_PHP_METHOD(TElCMSSignaturePolicyStore, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElCMSSignaturePolicyStore_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSignaturePolicyStore, get_DocSpecOID)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElCMSSignaturePolicyStore_get_DocSpecOID(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-209236411, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSignaturePolicyStore, set_DocSpecOID)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElCMSSignaturePolicyStore_set_DocSpecOID(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSignaturePolicyStore, get_DocSpecURI)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElCMSSignaturePolicyStore_get_DocSpecURI(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(900849604, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSignaturePolicyStore, set_DocSpecURI)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElCMSSignaturePolicyStore_set_DocSpecURI(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSignaturePolicyStore, get_EncodedPolicyDocument)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElCMSSignaturePolicyStore_get_EncodedPolicyDocument(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(179407998, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSignaturePolicyStore, set_EncodedPolicyDocument)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElCMSSignaturePolicyStore_set_EncodedPolicyDocument(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSignaturePolicyStore, get_PolicyLocalURI)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElCMSSignaturePolicyStore_get_PolicyLocalURI(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(460176575, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSignaturePolicyStore, set_PolicyLocalURI)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElCMSSignaturePolicyStore_set_PolicyLocalURI(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSignaturePolicyStore, get_PolicyStoreType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBCMSSignaturePolicyStoreTypeRaw fOutResultRaw = 0;
		SBCheckError(TElCMSSignaturePolicyStore_get_PolicyStoreType(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSignaturePolicyStore, set_PolicyStoreType)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElCMSSignaturePolicyStore_set_PolicyStoreType(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBCMSSignaturePolicyStoreTypeRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSignaturePolicyStore, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCMSSignaturePolicyStore_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignaturePolicyStore_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignaturePolicyStore_get_DocSpecOID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignaturePolicyStore_set_DocSpecOID, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignaturePolicyStore_get_DocSpecURI, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignaturePolicyStore_set_DocSpecURI, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignaturePolicyStore_get_EncodedPolicyDocument, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignaturePolicyStore_set_EncodedPolicyDocument, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignaturePolicyStore_get_PolicyLocalURI, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignaturePolicyStore_set_PolicyLocalURI, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignaturePolicyStore_get_PolicyStoreType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignaturePolicyStore_set_PolicyStoreType, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignaturePolicyStore___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElCMSSignaturePolicyStore_methods[] = {
	PHP_ME(TElCMSSignaturePolicyStore, Clear, arginfo_TElCMSSignaturePolicyStore_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSignaturePolicyStore, get_DocSpecOID, arginfo_TElCMSSignaturePolicyStore_get_DocSpecOID, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSignaturePolicyStore, set_DocSpecOID, arginfo_TElCMSSignaturePolicyStore_set_DocSpecOID, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSignaturePolicyStore, get_DocSpecURI, arginfo_TElCMSSignaturePolicyStore_get_DocSpecURI, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSignaturePolicyStore, set_DocSpecURI, arginfo_TElCMSSignaturePolicyStore_set_DocSpecURI, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSignaturePolicyStore, get_EncodedPolicyDocument, arginfo_TElCMSSignaturePolicyStore_get_EncodedPolicyDocument, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSignaturePolicyStore, set_EncodedPolicyDocument, arginfo_TElCMSSignaturePolicyStore_set_EncodedPolicyDocument, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSignaturePolicyStore, get_PolicyLocalURI, arginfo_TElCMSSignaturePolicyStore_get_PolicyLocalURI, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSignaturePolicyStore, set_PolicyLocalURI, arginfo_TElCMSSignaturePolicyStore_set_PolicyLocalURI, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSignaturePolicyStore, get_PolicyStoreType, arginfo_TElCMSSignaturePolicyStore_get_PolicyStoreType, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSignaturePolicyStore, set_PolicyStoreType, arginfo_TElCMSSignaturePolicyStore_set_PolicyStoreType, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSignaturePolicyStore, __construct, arginfo_TElCMSSignaturePolicyStore___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElCMSSignaturePolicyStore(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElCMSSignaturePolicyStore_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElCMSSignaturePolicyStore", TElCMSSignaturePolicyStore_methods);
	if (NULL == TElCMSProperty_ce_ptr)
		Register_TElCMSProperty(TSRMLS_C);
	TElCMSSignaturePolicyStore_ce_ptr = zend_register_internal_class_ex(&ce, TElCMSProperty_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElCMSSignature_ce_ptr = NULL;

SB_PHP_METHOD(TElCMSSignature, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TElCMSSignature_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElCMSSignature_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCMSSignature)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSignature, AddCountersignature)
{
	SBArrayZValInfo aiSignature;
	zval *zaSignature;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElCMSSignature_AddCountersignature(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaSignature) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaSignature)) || (IS_ARRAY == Z_TYPE_P(zaSignature)) || (IS_NULL == Z_TYPE_P(zaSignature))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaSignature, &aiSignature TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElCMSSignature_AddCountersignature_1(SBGetObjectHandle(getThis() TSRMLS_CC), aiSignature.data, aiSignature.len, &l4OutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiSignature);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("() or (array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSignature, AddTimestamp)
{
	SBArrayZValInfo aiTimestamp;
	zval *oTSPClient;
	zval *zaTimestamp;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oTSPClient, TElCustomTSPClient_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElCMSSignature_AddTimestamp(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oTSPClient TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaTimestamp) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaTimestamp)) || (IS_ARRAY == Z_TYPE_P(zaTimestamp)) || (IS_NULL == Z_TYPE_P(zaTimestamp))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaTimestamp, &aiTimestamp TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElCMSSignature_AddTimestamp_1(SBGetObjectHandle(getThis() TSRMLS_CC), aiTimestamp.data, aiTimestamp.len, &l4OutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiTimestamp);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomTSPClient) or (array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSignature, AddContentTimestamp)
{
	SBArrayZValInfo aiTimestamp;
	zval *oTSPClient;
	zval *zaTimestamp;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oTSPClient, TElCustomTSPClient_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElCMSSignature_AddContentTimestamp(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oTSPClient TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaTimestamp) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaTimestamp)) || (IS_ARRAY == Z_TYPE_P(zaTimestamp)) || (IS_NULL == Z_TYPE_P(zaTimestamp))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaTimestamp, &aiTimestamp TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElCMSSignature_AddContentTimestamp_1(SBGetObjectHandle(getThis() TSRMLS_CC), aiTimestamp.data, aiTimestamp.len, &l4OutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiTimestamp);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomTSPClient) or (array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSignature, AddValidationTimestamp)
{
	long fTimestampType;
	zval *oTSPClient;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!l", &oTSPClient, TElCustomTSPClient_ce_ptr, &fTimestampType) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElCMSSignature_AddValidationTimestamp(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oTSPClient TSRMLS_CC), (TSBCMSTimestampTypeRaw)fTimestampType, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomTSPClient, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSignature, AddCompleteValidationData)
{
	zend_bool bReferencesOnly;
	zval *oChain;
	zval *oCRLs;
	zval *oOCSPResponses;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!O!b", &oChain, TElCustomCertStorage_ce_ptr, &oCRLs, TElMemoryCRLStorage_ce_ptr, &oOCSPResponses, TList_ce_ptr, &bReferencesOnly) == SUCCESS)
	{
		SBCheckError(TElCMSSignature_AddCompleteValidationData(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oChain TSRMLS_CC), SBGetObjectHandle(oCRLs TSRMLS_CC), SBGetObjectHandle(oOCSPResponses TSRMLS_CC), (int8_t)bReferencesOnly) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCertStorage, TElMemoryCRLStorage, TList, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSignature, AddCompleteValidationDataItem)
{
	zend_bool bReferencesOnly;
	zval *oCert;
	zval *oCRLs;
	zval *oOCSPResponses;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!O!b", &oCert, TElX509Certificate_ce_ptr, &oCRLs, TElMemoryCRLStorage_ce_ptr, &oOCSPResponses, TList_ce_ptr, &bReferencesOnly) == SUCCESS)
	{
		SBCheckError(TElCMSSignature_AddCompleteValidationDataItem(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oCert TSRMLS_CC), SBGetObjectHandle(oCRLs TSRMLS_CC), SBGetObjectHandle(oOCSPResponses TSRMLS_CC), (int8_t)bReferencesOnly) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElX509Certificate, TElMemoryCRLStorage, TList, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSignature, RemoveCountersignature)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		SBCheckError(TElCMSSignature_RemoveCountersignature(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSignature, RemoveTimestamp)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		SBCheckError(TElCMSSignature_RemoveTimestamp(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSignature, RemoveContentTimestamp)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		SBCheckError(TElCMSSignature_RemoveContentTimestamp(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSignature, RemoveValidationTimestamp)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		SBCheckError(TElCMSSignature_RemoveValidationTimestamp(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSignature, ClearCountersignatures)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElCMSSignature_ClearCountersignatures(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSignature, ClearTimestamps)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElCMSSignature_ClearTimestamps(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSignature, ClearContentTimestamps)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElCMSSignature_ClearContentTimestamps(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSignature, ClearValidationTimestamps)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElCMSSignature_ClearValidationTimestamps(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSignature, Sign)
{
	zval *oCert;
	zval *oChain;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oCert, TElX509Certificate_ce_ptr, &oChain, TElCustomCertStorage_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElCMSSignature_Sign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oCert TSRMLS_CC), SBGetObjectHandle(oChain TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElX509Certificate, TElCustomCertStorage)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSignature, SignRemote)
{
	SBArrayZValInfo piParam;
	void *pzSignCallback;
	zend_bool bExternalHashCalculation;
	zval *oCert;
	zval *oChain;
	zval *zpParam;
	zval *zSignCallback;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!zzO!", &oCert, TElX509Certificate_ce_ptr, &zSignCallback, &zpParam, &oChain, TElCustomCertStorage_ce_ptr) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zSignCallback)) || (IS_ARRAY == Z_TYPE_P(zSignCallback)) || (IS_CALLABLE == Z_TYPE_P(zSignCallback)) || (IS_NULL == Z_TYPE_P(zSignCallback))) && ((Z_TYPE_P(zpParam) == IS_STRING) || (Z_TYPE_P(zpParam) == IS_ARRAY) || (Z_TYPE_P(zpParam) == IS_NULL) || ((Z_TYPE_P(zpParam) == IS_OBJECT) && (Z_OBJCE_P(zpParam) == TSBPointer_ce_ptr))))
	{
		pzSignCallback = SBSetEventData(zSignCallback TSRMLS_CC);
		if (!SBGetPointerFromZVal(zpParam, &piParam TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElCMSSignature_SignRemote(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oCert TSRMLS_CC), pzSignCallback ? &TSBCMSRemoteSignCallbackRaw : NULL, pzSignCallback, piParam.data, SBGetObjectHandle(oChain TSRMLS_CC)) TSRMLS_CC);
		SBFreePointerZValInfo(&piParam);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!zbzO!", &oCert, TElX509Certificate_ce_ptr, &zSignCallback, &bExternalHashCalculation, &zpParam, &oChain, TElCustomCertStorage_ce_ptr) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zSignCallback)) || (IS_ARRAY == Z_TYPE_P(zSignCallback)) || (IS_CALLABLE == Z_TYPE_P(zSignCallback)) || (IS_NULL == Z_TYPE_P(zSignCallback))) && ((Z_TYPE_P(zpParam) == IS_STRING) || (Z_TYPE_P(zpParam) == IS_ARRAY) || (Z_TYPE_P(zpParam) == IS_NULL) || ((Z_TYPE_P(zpParam) == IS_OBJECT) && (Z_OBJCE_P(zpParam) == TSBPointer_ce_ptr))))
	{
		pzSignCallback = SBSetEventData(zSignCallback TSRMLS_CC);
		if (!SBGetPointerFromZVal(zpParam, &piParam TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElCMSSignature_SignRemote_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oCert TSRMLS_CC), pzSignCallback ? &TSBCMSRemoteSignCallbackRaw : NULL, pzSignCallback, (int8_t)bExternalHashCalculation, piParam.data, SBGetObjectHandle(oChain TSRMLS_CC)) TSRMLS_CC);
		SBFreePointerZValInfo(&piParam);
	}
	else
	{
		SBErrorExpectsArguments("(TElX509Certificate, TSBCMSRemoteSignCallback|callable|NULL, TSBPointer|array of byte|string|NULL, TElCustomCertStorage) or (TElX509Certificate, TSBCMSRemoteSignCallback|callable|NULL, bool, TSBPointer|array of byte|string|NULL, TElCustomCertStorage)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSignature, Validate)
{
	long fOptions;
	zval *oValidator;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBCMSSignatureValidityRaw fOutResultRaw = 0;
		SBCheckError(TElCMSSignature_Validate(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fOptions) == SUCCESS)
	{
		TSBCMSAdvancedSignatureValidityRaw fOutResultRaw = 0;
		SBCheckError(TElCMSSignature_Validate_1(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBCMSValidationOptionsRaw)fOptions, &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!l", &oValidator, TElX509CertificateValidator_ce_ptr, &fOptions) == SUCCESS)
	{
		TSBCMSAdvancedSignatureValidityRaw fOutResultRaw = 0;
		SBCheckError(TElCMSSignature_Validate_2(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValidator TSRMLS_CC), (TSBCMSValidationOptionsRaw)fOptions, &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("() or (integer) or (TElX509CertificateValidator, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSignature, GetSignedCMSMessage)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCMSSignature_GetSignedCMSMessage(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElSignedCMSMessage_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSignature, InitiateAsyncSign)
{
	long fAsyncSignMethod;
	TElClassHandle hoState;
	zval *oCert;
	zval *oChain;
	zval *oState;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!O", &oCert, TElX509Certificate_ce_ptr, &oChain, TElCustomCertStorage_ce_ptr, &oState, TElDCAsyncState_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oState) && (IS_OBJECT == Z_TYPE_P(oState)))
	{
		hoState = SBGetObjectHandle(oState TSRMLS_CC);
		SBCheckError(TElCMSSignature_InitiateAsyncSign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oCert TSRMLS_CC), SBGetObjectHandle(oChain TSRMLS_CC), &hoState) TSRMLS_CC);
		SBUpdateObjectHandle(oState, hoState TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &oState, TElDCAsyncState_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oState) && (IS_OBJECT == Z_TYPE_P(oState)))
	{
		hoState = SBGetObjectHandle(oState TSRMLS_CC);
		SBCheckError(TElCMSSignature_InitiateAsyncSign_1(SBGetObjectHandle(getThis() TSRMLS_CC), &hoState) TSRMLS_CC);
		SBUpdateObjectHandle(oState, hoState TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lO", &fAsyncSignMethod, &oState, TElDCAsyncState_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oState) && (IS_OBJECT == Z_TYPE_P(oState)))
	{
		hoState = SBGetObjectHandle(oState TSRMLS_CC);
		SBCheckError(TElCMSSignature_InitiateAsyncSign_2(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBDCAsyncSignMethodRaw)fAsyncSignMethod, &hoState) TSRMLS_CC);
		SBUpdateObjectHandle(oState, hoState TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElX509Certificate, TElCustomCertStorage, &TElDCAsyncState) or (&TElDCAsyncState) or (integer, &TElDCAsyncState)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSignature, CompleteAsyncSign)
{
	zval *oAsyncState;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAsyncState, TElDCAsyncState_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElCMSSignature_CompleteAsyncSign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oAsyncState TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElDCAsyncState)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSignature, UpdateCMS)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElCMSSignature_UpdateCMS(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSignature, get_Content)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElCMSSignature_get_Content(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(1522358336, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSignature, get_Signer)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCMSSignature_get_Signer(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElPKCS7Issuer_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSignature, get_DigestAlgorithm)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElCMSSignature_get_DigestAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSignature, set_DigestAlgorithm)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElCMSSignature_set_DigestAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSignature, get_EncryptedDigest)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElCMSSignature_get_EncryptedDigest(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(1001482175, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSignature, get_PublicKeyAlgorithm)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElCMSSignature_get_PublicKeyAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSignature, set_PublicKeyAlgorithm)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElCMSSignature_set_PublicKeyAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSignature, get_FingerprintAlgorithm)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElCMSSignature_get_FingerprintAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSignature, set_FingerprintAlgorithm)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElCMSSignature_set_FingerprintAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSignature, get_CustomSignedAttributes)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCMSSignature_get_CustomSignedAttributes(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElPKCS7Attributes_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSignature, get_CustomUnsignedAttributes)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCMSSignature_get_CustomUnsignedAttributes(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElPKCS7Attributes_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSignature, get_SignedAttributesPresent)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElCMSSignature_get_SignedAttributesPresent(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSignature, get_SignatureAlgorithm)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElCMSSignature_get_SignatureAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSignature, get_Countersignatures)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCMSSignature_get_Countersignatures(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCMSSignature_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSignature, get_Timestamps)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCMSSignature_get_Timestamps(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCMSTimestamp_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSignature, get_ContentTimestamps)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCMSSignature_get_ContentTimestamps(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCMSTimestamp_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSignature, get_ValidationTimestamps)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCMSSignature_get_ValidationTimestamps(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCMSTimestamp_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSignature, get_CountersignatureCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElCMSSignature_get_CountersignatureCount(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSignature, get_TimestampCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElCMSSignature_get_TimestampCount(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSignature, get_ContentTimestampCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElCMSSignature_get_ContentTimestampCount(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSignature, get_LastValidationResult)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBCMSAdvancedSignatureValidityRaw fOutResultRaw = 0;
		SBCheckError(TElCMSSignature_get_LastValidationResult(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSignature, get_LastValidatorValidity)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBCertificateValidityRaw fOutResultRaw = 0;
		SBCheckError(TElCMSSignature_get_LastValidatorValidity(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSignature, get_LastValidatorReason)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBCertificateValidityReasonRaw fOutResultRaw = 0;
		SBCheckError(TElCMSSignature_get_LastValidatorReason(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSignature, get_ContentType)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElCMSSignature_get_ContentType(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(784754721, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSignature, set_ContentType)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElCMSSignature_set_ContentType(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSignature, get_SigningTime)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(TElCMSSignature_get_SigningTime(SBGetObjectHandle(getThis() TSRMLS_CC), &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSignature, set_SigningTime)
{
	zval *dtValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &dtValue, php_date_get_date_ce()) == SUCCESS)
	{
		SBCheckError(TElCMSSignature_set_SigningTime(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetDateTime(dtValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(DateTime)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSignature, get_SignaturePolicy)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCMSSignature_get_SignaturePolicy(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCMSSignaturePolicy_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSignature, get_ContentHints)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCMSSignature_get_ContentHints(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCMSContentHints_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSignature, get_ContentIdentifier)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElCMSSignature_get_ContentIdentifier(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(1184856461, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSignature, set_ContentIdentifier)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElCMSSignature_set_ContentIdentifier(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSignature, get_ContentReference)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCMSSignature_get_ContentReference(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCMSContentReference_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSignature, get_CommitmentTypeIndication)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCMSSignature_get_CommitmentTypeIndication(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCMSCommitmentTypeIndication_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSignature, set_CommitmentTypeIndication)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElCMSCommitmentTypeIndication_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElCMSSignature_set_CommitmentTypeIndication(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCMSCommitmentTypeIndication)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSignature, get_SignerLocation)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCMSSignature_get_SignerLocation(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCMSSignerLocation_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSignature, get_SigningCertificate)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCMSSignature_get_SigningCertificate(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCMSSigningCertificate_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSignature, get_MessageDigest)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElCMSSignature_get_MessageDigest(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(638655577, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSignature, get_MimeType)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElCMSSignature_get_MimeType(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-746426946, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSignature, set_MimeType)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElCMSSignature_set_MimeType(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSignature, get_CertificateRefs)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCMSSignature_get_CertificateRefs(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCMSCertificateRefs_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSignature, get_CertificateValues)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCMSSignature_get_CertificateValues(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomCertStorage_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSignature, get_RevocationRefs)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCMSSignature_get_RevocationRefs(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCMSRevocationRefs_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSignature, get_RevocationValues)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCMSSignature_get_RevocationValues(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCMSRevocationValues_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSignature, get_SignerAttributes)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCMSSignature_get_SignerAttributes(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCMSSignerAttributes_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSignature, get_SignaturePolicyStore)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCMSSignature_get_SignaturePolicyStore(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCMSSignaturePolicyStore_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSignature, get_ValidationTimestampCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElCMSSignature_get_ValidationTimestampCount(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSignature, get_State)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBCMSSignatureStateRaw fOutResultRaw = 0;
		SBCheckError(TElCMSSignature_get_State(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSignature, get_SigningOptions)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBCMSSigningOptionsRaw fOutResultRaw = 0;
		SBCheckError(TElCMSSignature_get_SigningOptions(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSignature, set_SigningOptions)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElCMSSignature_set_SigningOptions(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBCMSSigningOptionsRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSignature, get_UsePSS)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElCMSSignature_get_UsePSS(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSignature, set_UsePSS)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElCMSSignature_set_UsePSS(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSignature, get_UseCachedDigests)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElCMSSignature_get_UseCachedDigests(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSignature, set_UseCachedDigests)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElCMSSignature_set_UseCachedDigests(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSignature, get_LiberalMode)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElCMSSignature_get_LiberalMode(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSignature, set_LiberalMode)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElCMSSignature_set_LiberalMode(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSignature, get_AuthenticodeMode)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElCMSSignature_get_AuthenticodeMode(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSignature, set_AuthenticodeMode)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElCMSSignature_set_AuthenticodeMode(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSignature, get_OnBeforeSign)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBCMSBeforeSignEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElCMSSignature_get_OnBeforeSign(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSignature, set_OnBeforeSign)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElCMSSignature_set_OnBeforeSign(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBCMSBeforeSignEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBCMSBeforeSignEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSignature, get_OnBeforeVerify)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBCMSBeforeVerifyEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElCMSSignature_get_OnBeforeVerify(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSignature, set_OnBeforeVerify)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElCMSSignature_set_OnBeforeVerify(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBCMSBeforeVerifyEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBCMSBeforeVerifyEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSignature, get_OnCertificateNeeded)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBCMSCertificateNeededEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElCMSSignature_get_OnCertificateNeeded(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSignature, set_OnCertificateNeeded)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElCMSSignature_set_OnCertificateNeeded(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBCMSCertificateNeededEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBCMSCertificateNeededEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSignature, get_OnIsCertificateTrusted)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBCMSCertificateTrustedEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElCMSSignature_get_OnIsCertificateTrusted(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSignature, set_OnIsCertificateTrusted)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElCMSSignature_set_OnIsCertificateTrusted(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBCMSCertificateTrustedEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBCMSCertificateTrustedEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSignature, get_OnCRLNeeded)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBCMSCRLNeededEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElCMSSignature_get_OnCRLNeeded(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSignature, set_OnCRLNeeded)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElCMSSignature_set_OnCRLNeeded(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBCMSCRLNeededEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBCMSCRLNeededEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSignature, get_OnOCSPResponseNeeded)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBCMSOCSPResponseNeededEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElCMSSignature_get_OnOCSPResponseNeeded(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSignature, set_OnOCSPResponseNeeded)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElCMSSignature_set_OnOCSPResponseNeeded(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBCMSOCSPResponseNeededEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBCMSOCSPResponseNeededEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSignature, get_OnItemValidated)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBCMSItemValidatedEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElCMSSignature_get_OnItemValidated(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSignature, set_OnItemValidated)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElCMSSignature_set_OnItemValidated(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBCMSItemValidatedEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBCMSItemValidatedEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSignature, get_OnProgress)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBProgressEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElCMSSignature_get_OnProgress(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSignature, set_OnProgress)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElCMSSignature_set_OnProgress(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBProgressEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBProgressEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSSignature, __construct)
{
	SBArrayZValInfo aiData;
	zval *oPKCS7Signer;
	zval *oSubject;
	zval *zaData;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSubject, TObject_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCMSSignature_Create(SBGetObjectHandle(oSubject TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oSubject, TObject_ce_ptr, &oPKCS7Signer, TElPKCS7Signer_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCMSSignature_Create_1(SBGetObjectHandle(oSubject TSRMLS_CC), SBGetObjectHandle(oPKCS7Signer TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!z", &oSubject, TObject_ce_ptr, &zaData) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaData)) || (IS_ARRAY == Z_TYPE_P(zaData)) || (IS_NULL == Z_TYPE_P(zaData))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetByteArrayFromZVal(zaData, &aiData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElCMSSignature_Create_2(SBGetObjectHandle(oSubject TSRMLS_CC), aiData.data, aiData.len, &hoOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiData);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TObject) or (TObject, TElPKCS7Signer) or (TObject, array of byte|string|NULL)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignature_Assign, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Source, TElCMSSignature, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignature_AddCountersignature, 0, 0, 0)
	ZEND_ARG_TYPE_INFO(0, Signature, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignature_AddTimestamp, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, TSPClient_or_Timestamp, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignature_AddContentTimestamp, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, TSPClient_or_Timestamp, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignature_AddValidationTimestamp, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, TSPClient, TElCustomTSPClient, 1)
	ZEND_ARG_INFO(0, TimestampType)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignature_AddCompleteValidationData, 0, 0, 4)
	ZEND_ARG_OBJ_INFO(0, Chain, TElCustomCertStorage, 1)
	ZEND_ARG_OBJ_INFO(0, CRLs, TElMemoryCRLStorage, 1)
	ZEND_ARG_OBJ_INFO(0, OCSPResponses, TList, 1)
	ZEND_ARG_INFO(0, ReferencesOnly)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignature_AddCompleteValidationDataItem, 0, 0, 4)
	ZEND_ARG_OBJ_INFO(0, Cert, TElX509Certificate, 1)
	ZEND_ARG_OBJ_INFO(0, CRLs, TElMemoryCRLStorage, 1)
	ZEND_ARG_OBJ_INFO(0, OCSPResponses, TList, 1)
	ZEND_ARG_INFO(0, ReferencesOnly)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignature_RemoveCountersignature, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignature_RemoveTimestamp, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignature_RemoveContentTimestamp, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignature_RemoveValidationTimestamp, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignature_ClearCountersignatures, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignature_ClearTimestamps, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignature_ClearContentTimestamps, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignature_ClearValidationTimestamps, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignature_Sign, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, Cert, TElX509Certificate, 1)
	ZEND_ARG_OBJ_INFO(0, Chain, TElCustomCertStorage, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignature_SignRemote, 0, 0, 4)
	ZEND_ARG_OBJ_INFO(0, Cert, TElX509Certificate, 1)
	ZEND_ARG_TYPE_INFO(0, SignCallback, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Param_or_ExternalHashCalculation, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Chain_or_Param, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Chain, TElCustomCertStorage, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignature_Validate, 0, 0, 0)
	ZEND_ARG_TYPE_INFO(0, Options_or_Validator, 0, 1)
	ZEND_ARG_INFO(0, Options)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignature_GetSignedCMSMessage, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignature_InitiateAsyncSign, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(1, Cert_or_State_or_AsyncSignMethod, 0, 1)
	ZEND_ARG_TYPE_INFO(1, Chain_or_State, 0, 1)
	ZEND_ARG_OBJ_INFO(1, State, TElDCAsyncState, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignature_CompleteAsyncSign, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AsyncState, TElDCAsyncState, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignature_UpdateCMS, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignature_get_Content, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignature_get_Signer, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignature_get_DigestAlgorithm, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignature_set_DigestAlgorithm, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignature_get_EncryptedDigest, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignature_get_PublicKeyAlgorithm, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignature_set_PublicKeyAlgorithm, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignature_get_FingerprintAlgorithm, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignature_set_FingerprintAlgorithm, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignature_get_CustomSignedAttributes, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignature_get_CustomUnsignedAttributes, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignature_get_SignedAttributesPresent, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignature_get_SignatureAlgorithm, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignature_get_Countersignatures, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignature_get_Timestamps, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignature_get_ContentTimestamps, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignature_get_ValidationTimestamps, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignature_get_CountersignatureCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignature_get_TimestampCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignature_get_ContentTimestampCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignature_get_LastValidationResult, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignature_get_LastValidatorValidity, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignature_get_LastValidatorReason, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignature_get_ContentType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignature_set_ContentType, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignature_get_SigningTime, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignature_set_SigningTime, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, DateTime, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignature_get_SignaturePolicy, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignature_get_ContentHints, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignature_get_ContentIdentifier, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignature_set_ContentIdentifier, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignature_get_ContentReference, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignature_get_CommitmentTypeIndication, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignature_set_CommitmentTypeIndication, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElCMSCommitmentTypeIndication, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignature_get_SignerLocation, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignature_get_SigningCertificate, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignature_get_MessageDigest, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignature_get_MimeType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignature_set_MimeType, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignature_get_CertificateRefs, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignature_get_CertificateValues, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignature_get_RevocationRefs, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignature_get_RevocationValues, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignature_get_SignerAttributes, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignature_get_SignaturePolicyStore, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignature_get_ValidationTimestampCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignature_get_State, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignature_get_SigningOptions, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignature_set_SigningOptions, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignature_get_UsePSS, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignature_set_UsePSS, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignature_get_UseCachedDigests, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignature_set_UseCachedDigests, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignature_get_LiberalMode, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignature_set_LiberalMode, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignature_get_AuthenticodeMode, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignature_set_AuthenticodeMode, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignature_get_OnBeforeSign, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignature_set_OnBeforeSign, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignature_get_OnBeforeVerify, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignature_set_OnBeforeVerify, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignature_get_OnCertificateNeeded, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignature_set_OnCertificateNeeded, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignature_get_OnIsCertificateTrusted, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignature_set_OnIsCertificateTrusted, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignature_get_OnCRLNeeded, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignature_set_OnCRLNeeded, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignature_get_OnOCSPResponseNeeded, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignature_set_OnOCSPResponseNeeded, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignature_get_OnItemValidated, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignature_set_OnItemValidated, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignature_get_OnProgress, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignature_set_OnProgress, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSSignature___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Subject, TObject, 1)
	ZEND_ARG_TYPE_INFO(0, PKCS7Signer_or_Data, 0, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElCMSSignature_methods[] = {
	PHP_ME(TElCMSSignature, Assign, arginfo_TElCMSSignature_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSignature, AddCountersignature, arginfo_TElCMSSignature_AddCountersignature, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSignature, AddTimestamp, arginfo_TElCMSSignature_AddTimestamp, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSignature, AddContentTimestamp, arginfo_TElCMSSignature_AddContentTimestamp, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSignature, AddValidationTimestamp, arginfo_TElCMSSignature_AddValidationTimestamp, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSignature, AddCompleteValidationData, arginfo_TElCMSSignature_AddCompleteValidationData, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSignature, AddCompleteValidationDataItem, arginfo_TElCMSSignature_AddCompleteValidationDataItem, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSignature, RemoveCountersignature, arginfo_TElCMSSignature_RemoveCountersignature, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSignature, RemoveTimestamp, arginfo_TElCMSSignature_RemoveTimestamp, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSignature, RemoveContentTimestamp, arginfo_TElCMSSignature_RemoveContentTimestamp, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSignature, RemoveValidationTimestamp, arginfo_TElCMSSignature_RemoveValidationTimestamp, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSignature, ClearCountersignatures, arginfo_TElCMSSignature_ClearCountersignatures, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSignature, ClearTimestamps, arginfo_TElCMSSignature_ClearTimestamps, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSignature, ClearContentTimestamps, arginfo_TElCMSSignature_ClearContentTimestamps, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSignature, ClearValidationTimestamps, arginfo_TElCMSSignature_ClearValidationTimestamps, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSignature, Sign, arginfo_TElCMSSignature_Sign, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSignature, SignRemote, arginfo_TElCMSSignature_SignRemote, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSignature, Validate, arginfo_TElCMSSignature_Validate, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSignature, GetSignedCMSMessage, arginfo_TElCMSSignature_GetSignedCMSMessage, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSignature, InitiateAsyncSign, arginfo_TElCMSSignature_InitiateAsyncSign, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSignature, CompleteAsyncSign, arginfo_TElCMSSignature_CompleteAsyncSign, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSignature, UpdateCMS, arginfo_TElCMSSignature_UpdateCMS, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSignature, get_Content, arginfo_TElCMSSignature_get_Content, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSignature, get_Signer, arginfo_TElCMSSignature_get_Signer, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSignature, get_DigestAlgorithm, arginfo_TElCMSSignature_get_DigestAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSignature, set_DigestAlgorithm, arginfo_TElCMSSignature_set_DigestAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSignature, get_EncryptedDigest, arginfo_TElCMSSignature_get_EncryptedDigest, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSignature, get_PublicKeyAlgorithm, arginfo_TElCMSSignature_get_PublicKeyAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSignature, set_PublicKeyAlgorithm, arginfo_TElCMSSignature_set_PublicKeyAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSignature, get_FingerprintAlgorithm, arginfo_TElCMSSignature_get_FingerprintAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSignature, set_FingerprintAlgorithm, arginfo_TElCMSSignature_set_FingerprintAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSignature, get_CustomSignedAttributes, arginfo_TElCMSSignature_get_CustomSignedAttributes, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSignature, get_CustomUnsignedAttributes, arginfo_TElCMSSignature_get_CustomUnsignedAttributes, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSignature, get_SignedAttributesPresent, arginfo_TElCMSSignature_get_SignedAttributesPresent, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSignature, get_SignatureAlgorithm, arginfo_TElCMSSignature_get_SignatureAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSignature, get_Countersignatures, arginfo_TElCMSSignature_get_Countersignatures, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSignature, get_Timestamps, arginfo_TElCMSSignature_get_Timestamps, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSignature, get_ContentTimestamps, arginfo_TElCMSSignature_get_ContentTimestamps, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSignature, get_ValidationTimestamps, arginfo_TElCMSSignature_get_ValidationTimestamps, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSignature, get_CountersignatureCount, arginfo_TElCMSSignature_get_CountersignatureCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSignature, get_TimestampCount, arginfo_TElCMSSignature_get_TimestampCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSignature, get_ContentTimestampCount, arginfo_TElCMSSignature_get_ContentTimestampCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSignature, get_LastValidationResult, arginfo_TElCMSSignature_get_LastValidationResult, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSignature, get_LastValidatorValidity, arginfo_TElCMSSignature_get_LastValidatorValidity, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSignature, get_LastValidatorReason, arginfo_TElCMSSignature_get_LastValidatorReason, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSignature, get_ContentType, arginfo_TElCMSSignature_get_ContentType, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSignature, set_ContentType, arginfo_TElCMSSignature_set_ContentType, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSignature, get_SigningTime, arginfo_TElCMSSignature_get_SigningTime, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSignature, set_SigningTime, arginfo_TElCMSSignature_set_SigningTime, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSignature, get_SignaturePolicy, arginfo_TElCMSSignature_get_SignaturePolicy, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSignature, get_ContentHints, arginfo_TElCMSSignature_get_ContentHints, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSignature, get_ContentIdentifier, arginfo_TElCMSSignature_get_ContentIdentifier, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSignature, set_ContentIdentifier, arginfo_TElCMSSignature_set_ContentIdentifier, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSignature, get_ContentReference, arginfo_TElCMSSignature_get_ContentReference, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSignature, get_CommitmentTypeIndication, arginfo_TElCMSSignature_get_CommitmentTypeIndication, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSignature, set_CommitmentTypeIndication, arginfo_TElCMSSignature_set_CommitmentTypeIndication, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSignature, get_SignerLocation, arginfo_TElCMSSignature_get_SignerLocation, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSignature, get_SigningCertificate, arginfo_TElCMSSignature_get_SigningCertificate, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSignature, get_MessageDigest, arginfo_TElCMSSignature_get_MessageDigest, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSignature, get_MimeType, arginfo_TElCMSSignature_get_MimeType, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSignature, set_MimeType, arginfo_TElCMSSignature_set_MimeType, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSignature, get_CertificateRefs, arginfo_TElCMSSignature_get_CertificateRefs, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSignature, get_CertificateValues, arginfo_TElCMSSignature_get_CertificateValues, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSignature, get_RevocationRefs, arginfo_TElCMSSignature_get_RevocationRefs, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSignature, get_RevocationValues, arginfo_TElCMSSignature_get_RevocationValues, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSignature, get_SignerAttributes, arginfo_TElCMSSignature_get_SignerAttributes, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSignature, get_SignaturePolicyStore, arginfo_TElCMSSignature_get_SignaturePolicyStore, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSignature, get_ValidationTimestampCount, arginfo_TElCMSSignature_get_ValidationTimestampCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSignature, get_State, arginfo_TElCMSSignature_get_State, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSignature, get_SigningOptions, arginfo_TElCMSSignature_get_SigningOptions, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSignature, set_SigningOptions, arginfo_TElCMSSignature_set_SigningOptions, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSignature, get_UsePSS, arginfo_TElCMSSignature_get_UsePSS, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSignature, set_UsePSS, arginfo_TElCMSSignature_set_UsePSS, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSignature, get_UseCachedDigests, arginfo_TElCMSSignature_get_UseCachedDigests, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSignature, set_UseCachedDigests, arginfo_TElCMSSignature_set_UseCachedDigests, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSignature, get_LiberalMode, arginfo_TElCMSSignature_get_LiberalMode, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSignature, set_LiberalMode, arginfo_TElCMSSignature_set_LiberalMode, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSignature, get_AuthenticodeMode, arginfo_TElCMSSignature_get_AuthenticodeMode, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSignature, set_AuthenticodeMode, arginfo_TElCMSSignature_set_AuthenticodeMode, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSignature, get_OnBeforeSign, arginfo_TElCMSSignature_get_OnBeforeSign, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSignature, set_OnBeforeSign, arginfo_TElCMSSignature_set_OnBeforeSign, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSignature, get_OnBeforeVerify, arginfo_TElCMSSignature_get_OnBeforeVerify, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSignature, set_OnBeforeVerify, arginfo_TElCMSSignature_set_OnBeforeVerify, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSignature, get_OnCertificateNeeded, arginfo_TElCMSSignature_get_OnCertificateNeeded, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSignature, set_OnCertificateNeeded, arginfo_TElCMSSignature_set_OnCertificateNeeded, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSignature, get_OnIsCertificateTrusted, arginfo_TElCMSSignature_get_OnIsCertificateTrusted, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSignature, set_OnIsCertificateTrusted, arginfo_TElCMSSignature_set_OnIsCertificateTrusted, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSignature, get_OnCRLNeeded, arginfo_TElCMSSignature_get_OnCRLNeeded, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSignature, set_OnCRLNeeded, arginfo_TElCMSSignature_set_OnCRLNeeded, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSignature, get_OnOCSPResponseNeeded, arginfo_TElCMSSignature_get_OnOCSPResponseNeeded, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSignature, set_OnOCSPResponseNeeded, arginfo_TElCMSSignature_set_OnOCSPResponseNeeded, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSignature, get_OnItemValidated, arginfo_TElCMSSignature_get_OnItemValidated, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSignature, set_OnItemValidated, arginfo_TElCMSSignature_set_OnItemValidated, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSignature, get_OnProgress, arginfo_TElCMSSignature_get_OnProgress, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSignature, set_OnProgress, arginfo_TElCMSSignature_set_OnProgress, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSSignature, __construct, arginfo_TElCMSSignature___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElCMSSignature(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElCMSSignature_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElCMSSignature", TElCMSSignature_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElCMSSignature_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElCMSTimestamp_ce_ptr = NULL;

SB_PHP_METHOD(TElCMSTimestamp, Validate)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElCMSTimestamp_Validate(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSTimestamp, UpdateCMS)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElCMSTimestamp_UpdateCMS(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSTimestamp, get_Certificates)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCMSTimestamp_get_Certificates(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomCertStorage_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSTimestamp, get_CRLs)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCMSTimestamp_get_CRLs(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElMemoryCRLStorage_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSTimestamp, get_OCSPResponses)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCMSTimestamp_get_OCSPResponses(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElOCSPResponseStorage_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSTimestamp, get_Signatures)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCMSTimestamp_get_Signatures(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCMSSignature_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSTimestamp, get_SignatureCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElCMSTimestamp_get_SignatureCount(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSTimestamp, get_Info)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCMSTimestamp_get_Info(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElClientTSPInfo_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSTimestamp, get_TimestampType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBCMSTimestampTypeRaw fOutResultRaw = 0;
		SBCheckError(TElCMSTimestamp_get_TimestampType(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSTimestamp, get_UseCachedDigests)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElCMSTimestamp_get_UseCachedDigests(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSTimestamp, set_UseCachedDigests)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElCMSTimestamp_set_UseCachedDigests(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSTimestamp, get_DigestCalcType)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElCMSTimestamp_get_DigestCalcType(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(6583594, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSTimestamp, get_CMS)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElCMSTimestamp_get_CMS(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-575010221, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSTimestamp, __construct)
{
	SBArrayZValInfo aiData;
	zval *oSubject;
	zval *zaData;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSubject, TObject_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCMSTimestamp_Create(SBGetObjectHandle(oSubject TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!z", &oSubject, TObject_ce_ptr, &zaData) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaData)) || (IS_ARRAY == Z_TYPE_P(zaData)) || (IS_NULL == Z_TYPE_P(zaData))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetByteArrayFromZVal(zaData, &aiData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElCMSTimestamp_Create_1(SBGetObjectHandle(oSubject TSRMLS_CC), aiData.data, aiData.len, &hoOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiData);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TObject) or (TObject, array of byte|string|NULL)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSTimestamp_Validate, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSTimestamp_UpdateCMS, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSTimestamp_get_Certificates, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSTimestamp_get_CRLs, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSTimestamp_get_OCSPResponses, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSTimestamp_get_Signatures, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSTimestamp_get_SignatureCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSTimestamp_get_Info, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSTimestamp_get_TimestampType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSTimestamp_get_UseCachedDigests, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSTimestamp_set_UseCachedDigests, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSTimestamp_get_DigestCalcType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSTimestamp_get_CMS, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSTimestamp___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Subject, TObject, 1)
	ZEND_ARG_TYPE_INFO(0, Data, 0, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElCMSTimestamp_methods[] = {
	PHP_ME(TElCMSTimestamp, Validate, arginfo_TElCMSTimestamp_Validate, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSTimestamp, UpdateCMS, arginfo_TElCMSTimestamp_UpdateCMS, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSTimestamp, get_Certificates, arginfo_TElCMSTimestamp_get_Certificates, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSTimestamp, get_CRLs, arginfo_TElCMSTimestamp_get_CRLs, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSTimestamp, get_OCSPResponses, arginfo_TElCMSTimestamp_get_OCSPResponses, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSTimestamp, get_Signatures, arginfo_TElCMSTimestamp_get_Signatures, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSTimestamp, get_SignatureCount, arginfo_TElCMSTimestamp_get_SignatureCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSTimestamp, get_Info, arginfo_TElCMSTimestamp_get_Info, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSTimestamp, get_TimestampType, arginfo_TElCMSTimestamp_get_TimestampType, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSTimestamp, get_UseCachedDigests, arginfo_TElCMSTimestamp_get_UseCachedDigests, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSTimestamp, set_UseCachedDigests, arginfo_TElCMSTimestamp_set_UseCachedDigests, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSTimestamp, get_DigestCalcType, arginfo_TElCMSTimestamp_get_DigestCalcType, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSTimestamp, get_CMS, arginfo_TElCMSTimestamp_get_CMS, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSTimestamp, __construct, arginfo_TElCMSTimestamp___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElCMSTimestamp(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElCMSTimestamp_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElCMSTimestamp", TElCMSTimestamp_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElCMSTimestamp_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElATSHashIndexProcessor_ce_ptr = NULL;

SB_PHP_METHOD(TElATSHashIndexProcessor, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElATSHashIndexProcessor_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElATSHashIndexProcessor, Load)
{
	long l4Count;
	long l4StartIndex;
	SBArrayZValInfo aiBuffer;
	zval *zaBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zll", &zaBuffer, &l4StartIndex, &l4Count) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaBuffer)) || (IS_ARRAY == Z_TYPE_P(zaBuffer)) || (IS_NULL == Z_TYPE_P(zaBuffer))))
	{
		if (!SBGetByteArrayFromZVal(zaBuffer, &aiBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElATSHashIndexProcessor_Load(SBGetObjectHandle(getThis() TSRMLS_CC), aiBuffer.data, aiBuffer.len, (int32_t)l4StartIndex, (int32_t)l4Count) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiBuffer);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElATSHashIndexProcessor, CertPresent)
{
	zval *oCert;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oCert, TElX509Certificate_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElATSHashIndexProcessor_CertPresent(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oCert TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElX509Certificate)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElATSHashIndexProcessor, CRLPresent)
{
	zval *oCrl;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oCrl, TElCertificateRevocationList_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElATSHashIndexProcessor_CRLPresent(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oCrl TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElCertificateRevocationList)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElATSHashIndexProcessor, OCSPResponsePresent)
{
	zval *oOcspResponse;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oOcspResponse, TElOCSPResponse_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElATSHashIndexProcessor_OCSPResponsePresent(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oOcspResponse TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElOCSPResponse)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElATSHashIndexProcessor, get_CertHashes)
{
	long l4Index;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElATSHashIndexProcessor_get_CertHashes(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-1017755210, 2, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElATSHashIndexProcessor, get_CertHashesCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElATSHashIndexProcessor_get_CertHashesCount(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElATSHashIndexProcessor, get_RevInfoHashes)
{
	long l4Index;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElATSHashIndexProcessor_get_RevInfoHashes(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-815929982, 2, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElATSHashIndexProcessor, get_RevInfoHashesCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElATSHashIndexProcessor_get_RevInfoHashesCount(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElATSHashIndexProcessor, get_AttributeHashes)
{
	long l4Index;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElATSHashIndexProcessor_get_AttributeHashes(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-2097616764, 2, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElATSHashIndexProcessor, get_AttributeHashesCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElATSHashIndexProcessor_get_AttributeHashesCount(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElATSHashIndexProcessor, get_HashAlgorithm)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElATSHashIndexProcessor_get_HashAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElATSHashIndexProcessor, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElATSHashIndexProcessor_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElATSHashIndexProcessor_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElATSHashIndexProcessor_Load, 0, 0, 3)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(0, StartIndex)
	ZEND_ARG_INFO(0, Count)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElATSHashIndexProcessor_CertPresent, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Cert, TElX509Certificate, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElATSHashIndexProcessor_CRLPresent, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Crl, TElCertificateRevocationList, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElATSHashIndexProcessor_OCSPResponsePresent, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, OcspResponse, TElOCSPResponse, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElATSHashIndexProcessor_get_CertHashes, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElATSHashIndexProcessor_get_CertHashesCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElATSHashIndexProcessor_get_RevInfoHashes, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElATSHashIndexProcessor_get_RevInfoHashesCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElATSHashIndexProcessor_get_AttributeHashes, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElATSHashIndexProcessor_get_AttributeHashesCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElATSHashIndexProcessor_get_HashAlgorithm, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElATSHashIndexProcessor___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElATSHashIndexProcessor_methods[] = {
	PHP_ME(TElATSHashIndexProcessor, Clear, arginfo_TElATSHashIndexProcessor_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElATSHashIndexProcessor, Load, arginfo_TElATSHashIndexProcessor_Load, ZEND_ACC_PUBLIC)
	PHP_ME(TElATSHashIndexProcessor, CertPresent, arginfo_TElATSHashIndexProcessor_CertPresent, ZEND_ACC_PUBLIC)
	PHP_ME(TElATSHashIndexProcessor, CRLPresent, arginfo_TElATSHashIndexProcessor_CRLPresent, ZEND_ACC_PUBLIC)
	PHP_ME(TElATSHashIndexProcessor, OCSPResponsePresent, arginfo_TElATSHashIndexProcessor_OCSPResponsePresent, ZEND_ACC_PUBLIC)
	PHP_ME(TElATSHashIndexProcessor, get_CertHashes, arginfo_TElATSHashIndexProcessor_get_CertHashes, ZEND_ACC_PUBLIC)
	PHP_ME(TElATSHashIndexProcessor, get_CertHashesCount, arginfo_TElATSHashIndexProcessor_get_CertHashesCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElATSHashIndexProcessor, get_RevInfoHashes, arginfo_TElATSHashIndexProcessor_get_RevInfoHashes, ZEND_ACC_PUBLIC)
	PHP_ME(TElATSHashIndexProcessor, get_RevInfoHashesCount, arginfo_TElATSHashIndexProcessor_get_RevInfoHashesCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElATSHashIndexProcessor, get_AttributeHashes, arginfo_TElATSHashIndexProcessor_get_AttributeHashes, ZEND_ACC_PUBLIC)
	PHP_ME(TElATSHashIndexProcessor, get_AttributeHashesCount, arginfo_TElATSHashIndexProcessor_get_AttributeHashesCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElATSHashIndexProcessor, get_HashAlgorithm, arginfo_TElATSHashIndexProcessor_get_HashAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElATSHashIndexProcessor, __construct, arginfo_TElATSHashIndexProcessor___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElATSHashIndexProcessor(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElATSHashIndexProcessor_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElATSHashIndexProcessor", TElATSHashIndexProcessor_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElATSHashIndexProcessor_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElCMSMessage_ce_ptr = NULL;

SB_PHP_METHOD(TElCMSMessage, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElCMSMessage_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSMessage, CreateNew)
{
	long l4Size;
	long l8Offset;
	long l8Size;
	SBArrayZValInfo piBuffer;
	zval *oDataStream;
	zval *zpBuffer;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!ll", &oDataStream, TStream_ce_ptr, &l8Offset, &l8Size) == SUCCESS)
	{
		SBCheckError(TElCMSMessage_CreateNew(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDataStream TSRMLS_CC), (int64_t)l8Offset, (int64_t)l8Size) TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zpBuffer, &l4Size) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElCMSMessage_CreateNew_1(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, (int32_t)l4Size) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
	}
	else
	{
		SBErrorExpectsArguments("(TStream, integer, integer) or (TSBPointer|array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSMessage, Open)
{
	long l8CMSCount;
	long l8DataCount;
	zval *oCMSStream;
	zval *oDataStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!ll", &oCMSStream, TStream_ce_ptr, &oDataStream, TStream_ce_ptr, &l8CMSCount, &l8DataCount) == SUCCESS)
	{
		SBCheckError(TElCMSMessage_Open(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oCMSStream TSRMLS_CC), SBGetObjectHandle(oDataStream TSRMLS_CC), (int64_t)l8CMSCount, (int64_t)l8DataCount) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream, TStream, integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSMessage, Save)
{
	zval *oDestStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDestStream, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElCMSMessage_Save(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDestStream TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSMessage, Close)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElCMSMessage_Close(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSMessage, get_Content)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCMSMessage_get_Content(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCMSContent_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSMessage, get_Detached)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElCMSMessage_get_Detached(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSMessage, set_Detached)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElCMSMessage_set_Detached(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSMessage, get_UseUndefSize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElCMSMessage_get_UseUndefSize(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSMessage, set_UseUndefSize)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElCMSMessage_set_UseUndefSize(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSMessage, __construct)
{
	zval *oAOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCMSMessage_Create(SBGetObjectHandle(oAOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSMessage_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSMessage_CreateNew, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, DataStream_or_Buffer, 0, 1)
	ZEND_ARG_INFO(0, Offset_or_Size)
	ZEND_ARG_INFO(0, Size)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSMessage_Open, 0, 0, 4)
	ZEND_ARG_OBJ_INFO(0, CMSStream, TStream, 1)
	ZEND_ARG_OBJ_INFO(0, DataStream, TStream, 1)
	ZEND_ARG_INFO(0, CMSCount)
	ZEND_ARG_INFO(0, DataCount)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSMessage_Save, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, DestStream, TStream, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSMessage_Close, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSMessage_get_Content, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSMessage_get_Detached, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSMessage_set_Detached, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSMessage_get_UseUndefSize, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSMessage_set_UseUndefSize, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSMessage___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AOwner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElCMSMessage_methods[] = {
	PHP_ME(TElCMSMessage, Clear, arginfo_TElCMSMessage_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSMessage, CreateNew, arginfo_TElCMSMessage_CreateNew, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSMessage, Open, arginfo_TElCMSMessage_Open, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSMessage, Save, arginfo_TElCMSMessage_Save, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSMessage, Close, arginfo_TElCMSMessage_Close, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSMessage, get_Content, arginfo_TElCMSMessage_get_Content, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSMessage, get_Detached, arginfo_TElCMSMessage_get_Detached, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSMessage, set_Detached, arginfo_TElCMSMessage_set_Detached, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSMessage, get_UseUndefSize, arginfo_TElCMSMessage_get_UseUndefSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSMessage, set_UseUndefSize, arginfo_TElCMSMessage_set_UseUndefSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSMessage, __construct, arginfo_TElCMSMessage___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElCMSMessage(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElCMSMessage_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElCMSMessage", TElCMSMessage_methods);
	if (NULL == TComponent_ce_ptr)
		Register_TComponent(TSRMLS_C);
	TElCMSMessage_ce_ptr = zend_register_internal_class_ex(&ce, TComponent_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElCMSContentHash_ce_ptr = NULL;

SB_PHP_METHOD(TElCMSContentHash, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElCMSContentHash_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSContentHash, GetHash)
{
	long l4Alg;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Alg) == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElCMSContentHash_GetHash(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Alg, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(92069767, 2, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSContentHash, SetHash)
{
	long l4Alg;
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lz", &l4Alg, &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElCMSContentHash_SetHash(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Alg, aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(integer, array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCMSContentHash, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCMSContentHash_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSContentHash_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSContentHash_GetHash, 0, 0, 1)
	ZEND_ARG_INFO(0, Alg)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSContentHash_SetHash, 0, 0, 2)
	ZEND_ARG_INFO(0, Alg)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCMSContentHash___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElCMSContentHash_methods[] = {
	PHP_ME(TElCMSContentHash, Clear, arginfo_TElCMSContentHash_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSContentHash, GetHash, arginfo_TElCMSContentHash_GetHash, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSContentHash, SetHash, arginfo_TElCMSContentHash_SetHash, ZEND_ACC_PUBLIC)
	PHP_ME(TElCMSContentHash, __construct, arginfo_TElCMSContentHash___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElCMSContentHash(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElCMSContentHash_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElCMSContentHash", TElCMSContentHash_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElCMSContentHash_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElSignedCMSMessage_ce_ptr = NULL;

SB_PHP_METHOD(TElSignedCMSMessage, AddSignature)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSignedCMSMessage_AddSignature(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSignedCMSMessage, RemoveSignature)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		SBCheckError(TElSignedCMSMessage_RemoveSignature(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSignedCMSMessage, ClearSignatures)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElSignedCMSMessage_ClearSignatures(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSignedCMSMessage, ExtractAllCertificates)
{
	zval *oStorage;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oStorage, TElCustomCertStorage_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSignedCMSMessage_ExtractAllCertificates(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStorage TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCertStorage)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSignedCMSMessage, ExtractAllValidationElements)
{
	zval *oCrls;
	zval *oOcsps;
	zval *oStorage;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!O!", &oStorage, TElCustomCertStorage_ce_ptr, &oCrls, TElMemoryCRLStorage_ce_ptr, &oOcsps, TList_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSignedCMSMessage_ExtractAllValidationElements(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStorage TSRMLS_CC), SBGetObjectHandle(oCrls TSRMLS_CC), SBGetObjectHandle(oOcsps TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCertStorage, TElMemoryCRLStorage, TList)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSignedCMSMessage, get_ContentType)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElSignedCMSMessage_get_ContentType(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(1146624711, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSignedCMSMessage, set_ContentType)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElSignedCMSMessage_set_ContentType(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSignedCMSMessage, get_ContentVersion)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSignedCMSMessage_get_ContentVersion(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSignedCMSMessage, set_ContentVersion)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElSignedCMSMessage_set_ContentVersion(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSignedCMSMessage, get_Certificates)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSignedCMSMessage_get_Certificates(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomCertStorage_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSignedCMSMessage, get_CRLs)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSignedCMSMessage_get_CRLs(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElMemoryCRLStorage_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSignedCMSMessage, get_OCSPResponses)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSignedCMSMessage_get_OCSPResponses(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElOCSPResponseStorage_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSignedCMSMessage, get_Signatures)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSignedCMSMessage_get_Signatures(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCMSSignature_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSignedCMSMessage, get_SignatureCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSignedCMSMessage_get_SignatureCount(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSignedCMSMessage, get_UseImplicitContent)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSignedCMSMessage_get_UseImplicitContent(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSignedCMSMessage, set_UseImplicitContent)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSignedCMSMessage_set_UseImplicitContent(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSignedCMSMessage, get_SerializeContentOnUpdate)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSignedCMSMessage_get_SerializeContentOnUpdate(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSignedCMSMessage, set_SerializeContentOnUpdate)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSignedCMSMessage_set_SerializeContentOnUpdate(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSignedCMSMessage, get_CertStorage)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSignedCMSMessage_get_CertStorage(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomCertStorage_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSignedCMSMessage, set_CertStorage)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElCustomCertStorage_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSignedCMSMessage_set_CertStorage(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCertStorage)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSignedCMSMessage, __construct)
{
	zval *oAOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSignedCMSMessage_Create(SBGetObjectHandle(oAOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSignedCMSMessage_AddSignature, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSignedCMSMessage_RemoveSignature, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSignedCMSMessage_ClearSignatures, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSignedCMSMessage_ExtractAllCertificates, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Storage, TElCustomCertStorage, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSignedCMSMessage_ExtractAllValidationElements, 0, 0, 3)
	ZEND_ARG_OBJ_INFO(0, Storage, TElCustomCertStorage, 1)
	ZEND_ARG_OBJ_INFO(0, Crls, TElMemoryCRLStorage, 1)
	ZEND_ARG_OBJ_INFO(0, Ocsps, TList, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSignedCMSMessage_get_ContentType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSignedCMSMessage_set_ContentType, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSignedCMSMessage_get_ContentVersion, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSignedCMSMessage_set_ContentVersion, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSignedCMSMessage_get_Certificates, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSignedCMSMessage_get_CRLs, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSignedCMSMessage_get_OCSPResponses, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSignedCMSMessage_get_Signatures, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSignedCMSMessage_get_SignatureCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSignedCMSMessage_get_UseImplicitContent, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSignedCMSMessage_set_UseImplicitContent, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSignedCMSMessage_get_SerializeContentOnUpdate, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSignedCMSMessage_set_SerializeContentOnUpdate, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSignedCMSMessage_get_CertStorage, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSignedCMSMessage_set_CertStorage, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElCustomCertStorage, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSignedCMSMessage___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AOwner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElSignedCMSMessage_methods[] = {
	PHP_ME(TElSignedCMSMessage, AddSignature, arginfo_TElSignedCMSMessage_AddSignature, ZEND_ACC_PUBLIC)
	PHP_ME(TElSignedCMSMessage, RemoveSignature, arginfo_TElSignedCMSMessage_RemoveSignature, ZEND_ACC_PUBLIC)
	PHP_ME(TElSignedCMSMessage, ClearSignatures, arginfo_TElSignedCMSMessage_ClearSignatures, ZEND_ACC_PUBLIC)
	PHP_ME(TElSignedCMSMessage, ExtractAllCertificates, arginfo_TElSignedCMSMessage_ExtractAllCertificates, ZEND_ACC_PUBLIC)
	PHP_ME(TElSignedCMSMessage, ExtractAllValidationElements, arginfo_TElSignedCMSMessage_ExtractAllValidationElements, ZEND_ACC_PUBLIC)
	PHP_ME(TElSignedCMSMessage, get_ContentType, arginfo_TElSignedCMSMessage_get_ContentType, ZEND_ACC_PUBLIC)
	PHP_ME(TElSignedCMSMessage, set_ContentType, arginfo_TElSignedCMSMessage_set_ContentType, ZEND_ACC_PUBLIC)
	PHP_ME(TElSignedCMSMessage, get_ContentVersion, arginfo_TElSignedCMSMessage_get_ContentVersion, ZEND_ACC_PUBLIC)
	PHP_ME(TElSignedCMSMessage, set_ContentVersion, arginfo_TElSignedCMSMessage_set_ContentVersion, ZEND_ACC_PUBLIC)
	PHP_ME(TElSignedCMSMessage, get_Certificates, arginfo_TElSignedCMSMessage_get_Certificates, ZEND_ACC_PUBLIC)
	PHP_ME(TElSignedCMSMessage, get_CRLs, arginfo_TElSignedCMSMessage_get_CRLs, ZEND_ACC_PUBLIC)
	PHP_ME(TElSignedCMSMessage, get_OCSPResponses, arginfo_TElSignedCMSMessage_get_OCSPResponses, ZEND_ACC_PUBLIC)
	PHP_ME(TElSignedCMSMessage, get_Signatures, arginfo_TElSignedCMSMessage_get_Signatures, ZEND_ACC_PUBLIC)
	PHP_ME(TElSignedCMSMessage, get_SignatureCount, arginfo_TElSignedCMSMessage_get_SignatureCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElSignedCMSMessage, get_UseImplicitContent, arginfo_TElSignedCMSMessage_get_UseImplicitContent, ZEND_ACC_PUBLIC)
	PHP_ME(TElSignedCMSMessage, set_UseImplicitContent, arginfo_TElSignedCMSMessage_set_UseImplicitContent, ZEND_ACC_PUBLIC)
	PHP_ME(TElSignedCMSMessage, get_SerializeContentOnUpdate, arginfo_TElSignedCMSMessage_get_SerializeContentOnUpdate, ZEND_ACC_PUBLIC)
	PHP_ME(TElSignedCMSMessage, set_SerializeContentOnUpdate, arginfo_TElSignedCMSMessage_set_SerializeContentOnUpdate, ZEND_ACC_PUBLIC)
	PHP_ME(TElSignedCMSMessage, get_CertStorage, arginfo_TElSignedCMSMessage_get_CertStorage, ZEND_ACC_PUBLIC)
	PHP_ME(TElSignedCMSMessage, set_CertStorage, arginfo_TElSignedCMSMessage_set_CertStorage, ZEND_ACC_PUBLIC)
	PHP_ME(TElSignedCMSMessage, __construct, arginfo_TElSignedCMSMessage___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSignedCMSMessage(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSignedCMSMessage_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSignedCMSMessage", TElSignedCMSMessage_methods);
	if (NULL == TElCMSMessage_ce_ptr)
		Register_TElCMSMessage(TSRMLS_C);
	TElSignedCMSMessage_ce_ptr = zend_register_internal_class_ex(&ce, TElCMSMessage_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElSignedAndEnvelopedCMSMessage_ce_ptr = NULL;

SB_PHP_METHOD(TElSignedAndEnvelopedCMSMessage, get_CryptoProviderManager)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSignedAndEnvelopedCMSMessage_get_CryptoProviderManager(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomCryptoProviderManager_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSignedAndEnvelopedCMSMessage, set_CryptoProviderManager)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElCustomCryptoProviderManager_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSignedAndEnvelopedCMSMessage_set_CryptoProviderManager(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCryptoProviderManager)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSignedAndEnvelopedCMSMessage, get_Recipients)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSignedAndEnvelopedCMSMessage_get_Recipients(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomCertStorage_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSignedAndEnvelopedCMSMessage, set_Recipients)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElCustomCertStorage_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSignedAndEnvelopedCMSMessage_set_Recipients(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCertStorage)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSignedAndEnvelopedCMSMessage, get_Algorithm)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSignedAndEnvelopedCMSMessage_get_Algorithm(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSignedAndEnvelopedCMSMessage, set_Algorithm)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElSignedAndEnvelopedCMSMessage_set_Algorithm(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSignedAndEnvelopedCMSMessage, get_BitsInKey)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSignedAndEnvelopedCMSMessage_get_BitsInKey(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSignedAndEnvelopedCMSMessage, set_BitsInKey)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElSignedAndEnvelopedCMSMessage_set_BitsInKey(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSignedAndEnvelopedCMSMessage, get_UseImplicitContentEncoding)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSignedAndEnvelopedCMSMessage_get_UseImplicitContentEncoding(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSignedAndEnvelopedCMSMessage, set_UseImplicitContentEncoding)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSignedAndEnvelopedCMSMessage_set_UseImplicitContentEncoding(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSignedAndEnvelopedCMSMessage, get_UseOAEP)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSignedAndEnvelopedCMSMessage_get_UseOAEP(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSignedAndEnvelopedCMSMessage, set_UseOAEP)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSignedAndEnvelopedCMSMessage_set_UseOAEP(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSignedAndEnvelopedCMSMessage, get_AlignEncryptedKey)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSignedAndEnvelopedCMSMessage_get_AlignEncryptedKey(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSignedAndEnvelopedCMSMessage, set_AlignEncryptedKey)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSignedAndEnvelopedCMSMessage_set_AlignEncryptedKey(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSignedAndEnvelopedCMSMessage, __construct)
{
	zval *oAOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSignedAndEnvelopedCMSMessage_Create(SBGetObjectHandle(oAOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSignedAndEnvelopedCMSMessage_get_CryptoProviderManager, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSignedAndEnvelopedCMSMessage_set_CryptoProviderManager, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElCustomCryptoProviderManager, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSignedAndEnvelopedCMSMessage_get_Recipients, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSignedAndEnvelopedCMSMessage_set_Recipients, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElCustomCertStorage, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSignedAndEnvelopedCMSMessage_get_Algorithm, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSignedAndEnvelopedCMSMessage_set_Algorithm, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSignedAndEnvelopedCMSMessage_get_BitsInKey, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSignedAndEnvelopedCMSMessage_set_BitsInKey, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSignedAndEnvelopedCMSMessage_get_UseImplicitContentEncoding, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSignedAndEnvelopedCMSMessage_set_UseImplicitContentEncoding, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSignedAndEnvelopedCMSMessage_get_UseOAEP, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSignedAndEnvelopedCMSMessage_set_UseOAEP, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSignedAndEnvelopedCMSMessage_get_AlignEncryptedKey, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSignedAndEnvelopedCMSMessage_set_AlignEncryptedKey, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSignedAndEnvelopedCMSMessage___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AOwner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElSignedAndEnvelopedCMSMessage_methods[] = {
	PHP_ME(TElSignedAndEnvelopedCMSMessage, get_CryptoProviderManager, arginfo_TElSignedAndEnvelopedCMSMessage_get_CryptoProviderManager, ZEND_ACC_PUBLIC)
	PHP_ME(TElSignedAndEnvelopedCMSMessage, set_CryptoProviderManager, arginfo_TElSignedAndEnvelopedCMSMessage_set_CryptoProviderManager, ZEND_ACC_PUBLIC)
	PHP_ME(TElSignedAndEnvelopedCMSMessage, get_Recipients, arginfo_TElSignedAndEnvelopedCMSMessage_get_Recipients, ZEND_ACC_PUBLIC)
	PHP_ME(TElSignedAndEnvelopedCMSMessage, set_Recipients, arginfo_TElSignedAndEnvelopedCMSMessage_set_Recipients, ZEND_ACC_PUBLIC)
	PHP_ME(TElSignedAndEnvelopedCMSMessage, get_Algorithm, arginfo_TElSignedAndEnvelopedCMSMessage_get_Algorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElSignedAndEnvelopedCMSMessage, set_Algorithm, arginfo_TElSignedAndEnvelopedCMSMessage_set_Algorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElSignedAndEnvelopedCMSMessage, get_BitsInKey, arginfo_TElSignedAndEnvelopedCMSMessage_get_BitsInKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElSignedAndEnvelopedCMSMessage, set_BitsInKey, arginfo_TElSignedAndEnvelopedCMSMessage_set_BitsInKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElSignedAndEnvelopedCMSMessage, get_UseImplicitContentEncoding, arginfo_TElSignedAndEnvelopedCMSMessage_get_UseImplicitContentEncoding, ZEND_ACC_PUBLIC)
	PHP_ME(TElSignedAndEnvelopedCMSMessage, set_UseImplicitContentEncoding, arginfo_TElSignedAndEnvelopedCMSMessage_set_UseImplicitContentEncoding, ZEND_ACC_PUBLIC)
	PHP_ME(TElSignedAndEnvelopedCMSMessage, get_UseOAEP, arginfo_TElSignedAndEnvelopedCMSMessage_get_UseOAEP, ZEND_ACC_PUBLIC)
	PHP_ME(TElSignedAndEnvelopedCMSMessage, set_UseOAEP, arginfo_TElSignedAndEnvelopedCMSMessage_set_UseOAEP, ZEND_ACC_PUBLIC)
	PHP_ME(TElSignedAndEnvelopedCMSMessage, get_AlignEncryptedKey, arginfo_TElSignedAndEnvelopedCMSMessage_get_AlignEncryptedKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElSignedAndEnvelopedCMSMessage, set_AlignEncryptedKey, arginfo_TElSignedAndEnvelopedCMSMessage_set_AlignEncryptedKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElSignedAndEnvelopedCMSMessage, __construct, arginfo_TElSignedAndEnvelopedCMSMessage___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSignedAndEnvelopedCMSMessage(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSignedAndEnvelopedCMSMessage_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSignedAndEnvelopedCMSMessage", TElSignedAndEnvelopedCMSMessage_methods);
	if (NULL == TElSignedCMSMessage_ce_ptr)
		Register_TElSignedCMSMessage(TSRMLS_C);
	TElSignedAndEnvelopedCMSMessage_ce_ptr = zend_register_internal_class_ex(&ce, TElSignedCMSMessage_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_FUNCTION(SBCMS, GetTimestampTypeOID)
{
	long fTimestampType;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fTimestampType) == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = SBCMS_GetTimestampTypeOID((TSBCMSTimestampTypeRaw)fTimestampType, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(870254217, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

void Register_SBCMS_Constants(int module_number TSRMLS_DC)
{
	SB_REGISTER_LONG_CONSTANT(SBCMS, ERROR_FACILITY_CMS, SB_ERROR_FACILITY_CMS, SB_ERROR_FACILITY_CMS);
	SB_REGISTER_LONG_CONSTANT(SBCMS, SB_CMS_ERROR_INVALID_CERT_REFS, SB_CMS_ERROR_INVALID_CERT_REFS, SB_CMS_ERROR_INVALID_CERT_REFS);
	SB_REGISTER_LONG_CONSTANT(SBCMS, SB_CMS_ERROR_INVALID_REVOC_REFS, SB_CMS_ERROR_INVALID_REVOC_REFS, SB_CMS_ERROR_INVALID_REVOC_REFS);
	SB_REGISTER_LONG_CONSTANT(SBCMS, SB_CMS_ERROR_INVALID_REVOC_VALS, SB_CMS_ERROR_INVALID_REVOC_VALS, SB_CMS_ERROR_INVALID_REVOC_VALS);
	SB_REGISTER_LONG_CONSTANT(SBCMS, SB_CMS_ERROR_INVALID_CRL_ID, SB_CMS_ERROR_INVALID_CRL_ID, SB_CMS_ERROR_INVALID_CRL_ID);
	SB_REGISTER_LONG_CONSTANT(SBCMS, SB_CMS_ERROR_INVALID_OCSP_ID, SB_CMS_ERROR_INVALID_OCSP_ID, SB_CMS_ERROR_INVALID_OCSP_ID);
	SB_REGISTER_LONG_CONSTANT(SBCMS, SB_CMS_ERROR_INVALID_SIGNER_ID, SB_CMS_ERROR_INVALID_SIGNER_ID, SB_CMS_ERROR_INVALID_SIGNER_ID);
	SB_REGISTER_LONG_CONSTANT(SBCMS, SB_CMS_ERROR_INVALID_ALG_ID, SB_CMS_ERROR_INVALID_ALG_ID, SB_CMS_ERROR_INVALID_ALG_ID);
	SB_REGISTER_LONG_CONSTANT(SBCMS, SB_CMS_ERROR_INVALID_PARAMETERS, SB_CMS_ERROR_INVALID_PARAMETERS, SB_CMS_ERROR_INVALID_PARAMETERS);
	SB_REGISTER_LONG_CONSTANT(SBCMS, SB_CMS_ERROR_INVALID_HASH, SB_CMS_ERROR_INVALID_HASH, SB_CMS_ERROR_INVALID_HASH);
	SB_REGISTER_LONG_CONSTANT(SBCMS, SB_CMS_ERROR_INVALID_SIGN_STRUCT, SB_CMS_ERROR_INVALID_SIGN_STRUCT, SB_CMS_ERROR_INVALID_SIGN_STRUCT);
	SB_REGISTER_LONG_CONSTANT(SBCMS, SB_CMS_ERROR_INVALID_COUNTERSIGN, SB_CMS_ERROR_INVALID_COUNTERSIGN, SB_CMS_ERROR_INVALID_COUNTERSIGN);
	SB_REGISTER_LONG_CONSTANT(SBCMS, SB_CMS_ERROR_INVALID_TIMESTAMP_TYPE, SB_CMS_ERROR_INVALID_TIMESTAMP_TYPE, SB_CMS_ERROR_INVALID_TIMESTAMP_TYPE);
	SB_REGISTER_LONG_CONSTANT(SBCMS, SB_CMS_ERROR_INVALID_TIMESTAMP, SB_CMS_ERROR_INVALID_TIMESTAMP, SB_CMS_ERROR_INVALID_TIMESTAMP);
	SB_REGISTER_LONG_CONSTANT(SBCMS, SB_CMS_ERROR_INVALID_TIMESTAMP_CMS, SB_CMS_ERROR_INVALID_TIMESTAMP_CMS, SB_CMS_ERROR_INVALID_TIMESTAMP_CMS);
	SB_REGISTER_LONG_CONSTANT(SBCMS, SB_CMS_ERROR_INVALID_TIMESTAMP_ASN1, SB_CMS_ERROR_INVALID_TIMESTAMP_ASN1, SB_CMS_ERROR_INVALID_TIMESTAMP_ASN1);
	SB_REGISTER_LONG_CONSTANT(SBCMS, SB_CMS_ERROR_INVALID_PKCS7_IN_DATA, SB_CMS_ERROR_INVALID_PKCS7_IN_DATA, SB_CMS_ERROR_INVALID_PKCS7_IN_DATA);
	SB_REGISTER_LONG_CONSTANT(SBCMS, SB_CMS_ERROR_INVALID_KEY_PARAMS, SB_CMS_ERROR_INVALID_KEY_PARAMS, SB_CMS_ERROR_INVALID_KEY_PARAMS);
	SB_REGISTER_LONG_CONSTANT(SBCMS, SB_CMS_ERROR_INVALID_POLICY_QUAL, SB_CMS_ERROR_INVALID_POLICY_QUAL, SB_CMS_ERROR_INVALID_POLICY_QUAL);
	SB_REGISTER_LONG_CONSTANT(SBCMS, SB_CMS_ERROR_INVALID_SIG_POLICY, SB_CMS_ERROR_INVALID_SIG_POLICY, SB_CMS_ERROR_INVALID_SIG_POLICY);
	SB_REGISTER_LONG_CONSTANT(SBCMS, SB_CMS_ERROR_INVALID_CONTENT_HINTS, SB_CMS_ERROR_INVALID_CONTENT_HINTS, SB_CMS_ERROR_INVALID_CONTENT_HINTS);
	SB_REGISTER_LONG_CONSTANT(SBCMS, SB_CMS_ERROR_INVALID_CONTENT_REFS, SB_CMS_ERROR_INVALID_CONTENT_REFS, SB_CMS_ERROR_INVALID_CONTENT_REFS);
	SB_REGISTER_LONG_CONSTANT(SBCMS, SB_CMS_ERROR_INVALID_SIGNER_LOCATION, SB_CMS_ERROR_INVALID_SIGNER_LOCATION, SB_CMS_ERROR_INVALID_SIGNER_LOCATION);
	SB_REGISTER_LONG_CONSTANT(SBCMS, SB_CMS_ERROR_INVALID_SIGNING_CERT, SB_CMS_ERROR_INVALID_SIGNING_CERT, SB_CMS_ERROR_INVALID_SIGNING_CERT);
	SB_REGISTER_LONG_CONSTANT(SBCMS, SB_CMS_ERROR_INVALID_SIGNER_ATTRS, SB_CMS_ERROR_INVALID_SIGNER_ATTRS, SB_CMS_ERROR_INVALID_SIGNER_ATTRS);
	SB_REGISTER_LONG_CONSTANT(SBCMS, SB_CMS_ERROR_INVALID_ATS_HASH_INDEX, SB_CMS_ERROR_INVALID_ATS_HASH_INDEX, SB_CMS_ERROR_INVALID_ATS_HASH_INDEX);
	SB_REGISTER_LONG_CONSTANT(SBCMS, SB_CMS_ERROR_UNSUPPORTED_ALGORITHM, SB_CMS_ERROR_UNSUPPORTED_ALGORITHM, SB_CMS_ERROR_UNSUPPORTED_ALGORITHM);
	SB_REGISTER_LONG_CONSTANT(SBCMS, SB_CMS_ERROR_NO_PRIVATE_KEY, SB_CMS_ERROR_NO_PRIVATE_KEY, SB_CMS_ERROR_NO_PRIVATE_KEY);
	SB_REGISTER_LONG_CONSTANT(SBCMS, SB_CMS_ERROR_NO_DECRYPTION_KEY, SB_CMS_ERROR_NO_DECRYPTION_KEY, SB_CMS_ERROR_NO_DECRYPTION_KEY);
	SB_REGISTER_LONG_CONSTANT(SBCMS, SB_CMS_ERROR_NO_SIGNED_DATA, SB_CMS_ERROR_NO_SIGNED_DATA, SB_CMS_ERROR_NO_SIGNED_DATA);
	SB_REGISTER_LONG_CONSTANT(SBCMS, SB_CMS_ERROR_NO_SIGNING_CERT, SB_CMS_ERROR_NO_SIGNING_CERT, SB_CMS_ERROR_NO_SIGNING_CERT);
	SB_REGISTER_LONG_CONSTANT(SBCMS, SB_CMS_ERROR_NO_RECIPIENT_CERT, SB_CMS_ERROR_NO_RECIPIENT_CERT, SB_CMS_ERROR_NO_RECIPIENT_CERT);
	SB_REGISTER_LONG_CONSTANT(SBCMS, SB_CMS_ERROR_WRONG_CONTENT_TYPE, SB_CMS_ERROR_WRONG_CONTENT_TYPE, SB_CMS_ERROR_WRONG_CONTENT_TYPE);
	SB_REGISTER_LONG_CONSTANT(SBCMS, SB_CMS_ERROR_TIMESTAMPING_FAILED, SB_CMS_ERROR_TIMESTAMPING_FAILED, SB_CMS_ERROR_TIMESTAMPING_FAILED);
	SB_REGISTER_LONG_CONSTANT(SBCMS, SB_CMS_ERROR_REMOTE_SIGN_FAILED, SB_CMS_ERROR_REMOTE_SIGN_FAILED, SB_CMS_ERROR_REMOTE_SIGN_FAILED);
	SB_REGISTER_LONG_CONSTANT(SBCMS, SB_CMS_ERROR_DECRYPTION_FAILED, SB_CMS_ERROR_DECRYPTION_FAILED, SB_CMS_ERROR_DECRYPTION_FAILED);
	SB_REGISTER_LONG_CONSTANT(SBCMS, SB_CMS_ERROR_UNEXPECTED_END_OF_DATA, SB_CMS_ERROR_UNEXPECTED_END_OF_DATA, SB_CMS_ERROR_UNEXPECTED_END_OF_DATA);
	SB_REGISTER_LONG_CONSTANT(SBCMS, SB_CMS_ERROR_UNEXPECTED_ELEMENT_IN_CHAIN, SB_CMS_ERROR_UNEXPECTED_ELEMENT_IN_CHAIN, SB_CMS_ERROR_UNEXPECTED_ELEMENT_IN_CHAIN);
	SB_REGISTER_LONG_CONSTANT(SBCMS, SB_CMS_ERROR_DUPLICATE_ELEMENT_IN_CHAIN, SB_CMS_ERROR_DUPLICATE_ELEMENT_IN_CHAIN, SB_CMS_ERROR_DUPLICATE_ELEMENT_IN_CHAIN);
	SB_REGISTER_LONG_CONSTANT(SBCMS, SB_CMS_ERROR_CHAIN_INCOMPLETE, SB_CMS_ERROR_CHAIN_INCOMPLETE, SB_CMS_ERROR_CHAIN_INCOMPLETE);
	SB_REGISTER_LONG_CONSTANT(SBCMS, SB_CMS_ERROR_INCONSISTENT_TIMESTAMP_STATE, SB_CMS_ERROR_INCONSISTENT_TIMESTAMP_STATE, SB_CMS_ERROR_INCONSISTENT_TIMESTAMP_STATE);
	SB_REGISTER_LONG_CONSTANT(SBCMS, SB_CMS_ERROR_ASN1_SERIALIZATION_FAILED, SB_CMS_ERROR_ASN1_SERIALIZATION_FAILED, SB_CMS_ERROR_ASN1_SERIALIZATION_FAILED);
	SB_REGISTER_LONG_CONSTANT(SBCMS, SB_CMS_ERROR_CANT_SAVE_TO_SOURCE, SB_CMS_ERROR_CANT_SAVE_TO_SOURCE, SB_CMS_ERROR_CANT_SAVE_TO_SOURCE);
	SB_REGISTER_LONG_CONSTANT(SBCMS, SB_CMS_ERROR_BUFFER_TOO_SMALL, SB_CMS_ERROR_BUFFER_TOO_SMALL, SB_CMS_ERROR_BUFFER_TOO_SMALL);
	SB_REGISTER_LONG_CONSTANT(SBCMS, SB_CMS_ERROR_BAD_TEMPLATE, SB_CMS_ERROR_BAD_TEMPLATE, SB_CMS_ERROR_BAD_TEMPLATE);
	SB_REGISTER_LONG_CONSTANT(SBCMS, SB_CMS_ERROR_INVALID_SIGNATURE_POLICY_STORE, SB_CMS_ERROR_INVALID_SIGNATURE_POLICY_STORE, SB_CMS_ERROR_INVALID_SIGNATURE_POLICY_STORE);
	SB_REGISTER_LONG_CONSTANT(SBCMS, SB_CMS_ERROR_UNSUPPORTED_SIGNING_MODE, SB_CMS_ERROR_UNSUPPORTED_SIGNING_MODE, SB_CMS_ERROR_UNSUPPORTED_SIGNING_MODE);
}

void Register_SBCMS_Enum_Flags(TSRMLS_D)
{
	zend_class_entry ce;
	INIT_CLASS_ENTRY(ce, "TSBASN1DirectoryStringEncoding", NULL);
	TSBASN1DirectoryStringEncoding_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBASN1DirectoryStringEncoding_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBASN1DirectoryStringEncoding_ce_ptr, "dseTeletexString", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBASN1DirectoryStringEncoding_ce_ptr, "dsePrintableString", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBASN1DirectoryStringEncoding_ce_ptr, "dseUniversalString", 2)
	SB_DECLARE_CLASS_LONG_CONST(TSBASN1DirectoryStringEncoding_ce_ptr, "dseUTF8String", 3)
	SB_DECLARE_CLASS_LONG_CONST(TSBASN1DirectoryStringEncoding_ce_ptr, "dseBMPString", 4)
	
	INIT_CLASS_ENTRY(ce, "TSBCMSRevocationRefsWriteMode", NULL);
	TSBCMSRevocationRefsWriteMode_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBCMSRevocationRefsWriteMode_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBCMSRevocationRefsWriteMode_ce_ptr, "rrwmWriteAll", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBCMSRevocationRefsWriteMode_ce_ptr, "rrwmWriteCRLIfPresent", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBCMSRevocationRefsWriteMode_ce_ptr, "rrwmWriteOCSPIfPresent", 2)
	
	INIT_CLASS_ENTRY(ce, "TSBCMSSignerIdentifierType", NULL);
	TSBCMSSignerIdentifierType_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBCMSSignerIdentifierType_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBCMSSignerIdentifierType_ce_ptr, "sitESSCertID", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBCMSSignerIdentifierType_ce_ptr, "sitOtherCertID", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBCMSSignerIdentifierType_ce_ptr, "sitESSCertIDV2", 2)
	
	INIT_CLASS_ENTRY(ce, "TSBSigPolicyQualifierType", NULL);
	TSBSigPolicyQualifierType_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBSigPolicyQualifierType_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBSigPolicyQualifierType_ce_ptr, "spqtURI", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBSigPolicyQualifierType_ce_ptr, "spqtUserNotice", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBSigPolicyQualifierType_ce_ptr, "spqtCustom", 2)
	
	INIT_CLASS_ENTRY(ce, "TSBCMSSigningCertificateType", NULL);
	TSBCMSSigningCertificateType_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBCMSSigningCertificateType_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBCMSSigningCertificateType_ce_ptr, "sctESSSigningCertificate", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBCMSSigningCertificateType_ce_ptr, "sctOtherSigningCertificate", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBCMSSigningCertificateType_ce_ptr, "sctESSSigningCertificateV2", 2)
	
	INIT_CLASS_ENTRY(ce, "TSBCMSSignerAttributesVersion", NULL);
	TSBCMSSignerAttributesVersion_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBCMSSignerAttributesVersion_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBCMSSignerAttributesVersion_ce_ptr, "saVersion1", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBCMSSignerAttributesVersion_ce_ptr, "saVersion2", 1)
	
	INIT_CLASS_ENTRY(ce, "TSBCMSSignaturePolicyStoreType", NULL);
	TSBCMSSignaturePolicyStoreType_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBCMSSignaturePolicyStoreType_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBCMSSignaturePolicyStoreType_ce_ptr, "pstDocument", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBCMSSignaturePolicyStoreType_ce_ptr, "pstURI", 1)
	
	INIT_CLASS_ENTRY(ce, "TSBCMSTimestampType", NULL);
	TSBCMSTimestampType_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBCMSTimestampType_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBCMSTimestampType_ce_ptr, "cvtGeneric", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBCMSTimestampType_ce_ptr, "cvtESC", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBCMSTimestampType_ce_ptr, "cvtCertsAndCRLs", 2)
	SB_DECLARE_CLASS_LONG_CONST(TSBCMSTimestampType_ce_ptr, "cvtArchive", 3)
	SB_DECLARE_CLASS_LONG_CONST(TSBCMSTimestampType_ce_ptr, "cvtArchive2", 4)
	SB_DECLARE_CLASS_LONG_CONST(TSBCMSTimestampType_ce_ptr, "cvtArchive3", 5)
	SB_DECLARE_CLASS_LONG_CONST(TSBCMSTimestampType_ce_ptr, "cvtContent", 6)
	
	INIT_CLASS_ENTRY(ce, "TSBCMSItemType", NULL);
	TSBCMSItemType_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBCMSItemType_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBCMSItemType_ce_ptr, "citCertificate", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBCMSItemType_ce_ptr, "citCRL", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBCMSItemType_ce_ptr, "citOCSPResponse", 2)
	SB_DECLARE_CLASS_LONG_CONST(TSBCMSItemType_ce_ptr, "citTimestamp", 3)
	
	INIT_CLASS_ENTRY(ce, "TSBCMSSigningOption", NULL);
	TSBCMSSigningOption_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBCMSSigningOption_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBCMSSigningOption_ce_ptr, "csoInsertMessageDigests", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBCMSSigningOption_ce_ptr, "csoInsertSigningTime", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBCMSSigningOption_ce_ptr, "csoInsertContentType", 2)
	SB_DECLARE_CLASS_LONG_CONST(TSBCMSSigningOption_ce_ptr, "csoUseGeneralizedTimeFormat", 3)
	SB_DECLARE_CLASS_LONG_CONST(TSBCMSSigningOption_ce_ptr, "csoIncludeCertToMessage", 4)
	SB_DECLARE_CLASS_LONG_CONST(TSBCMSSigningOption_ce_ptr, "csoIncludeCertToAttributes", 5)
	SB_DECLARE_CLASS_LONG_CONST(TSBCMSSigningOption_ce_ptr, "csoImzagerMIMCompatibility", 6)
	SB_DECLARE_CLASS_LONG_CONST(TSBCMSSigningOption_ce_ptr, "csoForceSigningCertificateV2Usage", 7)
	SB_DECLARE_CLASS_LONG_CONST(TSBCMSSigningOption_ce_ptr, "csoAnnexKArchiveTimestampV2Mode", 8)
	SB_DECLARE_CLASS_LONG_CONST(TSBCMSSigningOption_ce_ptr, "csoDigitPADSSCompatibility", 9)
	SB_DECLARE_CLASS_LONG_CONST(TSBCMSSigningOption_ce_ptr, "csoCompareRDNAsStrings", 10)
	SB_DECLARE_CLASS_LONG_CONST(TSBCMSSigningOption_ce_ptr, "csoIgnoreDERReqInArchiveTimestamps", 11)
	SB_DECLARE_CLASS_LONG_CONST(TSBCMSSigningOption_ce_ptr, "csoSkipEnvContentInfoOnSigArchival", 12)
	SB_DECLARE_CLASS_LONG_CONST(TSBCMSSigningOption_ce_ptr, "csoUseGenericSigAlgorithmOIDs", 13)
	SB_DECLARE_CLASS_LONG_CONST(TSBCMSSigningOption_ce_ptr, "csoUsePlainContentForTimestampHashes", 14)
	SB_DECLARE_CLASS_LONG_CONST(TSBCMSSigningOption_ce_ptr, "csoUseATSHashIndexV1", 15)
	SB_DECLARE_CLASS_LONG_CONST(TSBCMSSigningOption_ce_ptr, "csoCheckATSHashIndexElements", 16)
	
	INIT_CLASS_ENTRY(ce, "TSBCMSSigningOptions", NULL);
	TSBCMSSigningOptions_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseFlags_ce_ptr, NULL TSRMLS_CC);
	TSBCMSSigningOptions_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBCMSSigningOptions_ce_ptr, "csoInsertMessageDigests", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBCMSSigningOptions_ce_ptr, "csoInsertSigningTime", 2)
	SB_DECLARE_CLASS_LONG_CONST(TSBCMSSigningOptions_ce_ptr, "csoInsertContentType", 4)
	SB_DECLARE_CLASS_LONG_CONST(TSBCMSSigningOptions_ce_ptr, "csoUseGeneralizedTimeFormat", 8)
	SB_DECLARE_CLASS_LONG_CONST(TSBCMSSigningOptions_ce_ptr, "csoIncludeCertToMessage", 16)
	SB_DECLARE_CLASS_LONG_CONST(TSBCMSSigningOptions_ce_ptr, "csoIncludeCertToAttributes", 32)
	SB_DECLARE_CLASS_LONG_CONST(TSBCMSSigningOptions_ce_ptr, "csoImzagerMIMCompatibility", 64)
	SB_DECLARE_CLASS_LONG_CONST(TSBCMSSigningOptions_ce_ptr, "csoForceSigningCertificateV2Usage", 128)
	SB_DECLARE_CLASS_LONG_CONST(TSBCMSSigningOptions_ce_ptr, "csoAnnexKArchiveTimestampV2Mode", 256)
	SB_DECLARE_CLASS_LONG_CONST(TSBCMSSigningOptions_ce_ptr, "csoDigitPADSSCompatibility", 512)
	SB_DECLARE_CLASS_LONG_CONST(TSBCMSSigningOptions_ce_ptr, "csoCompareRDNAsStrings", 1024)
	SB_DECLARE_CLASS_LONG_CONST(TSBCMSSigningOptions_ce_ptr, "csoIgnoreDERReqInArchiveTimestamps", 2048)
	SB_DECLARE_CLASS_LONG_CONST(TSBCMSSigningOptions_ce_ptr, "csoSkipEnvContentInfoOnSigArchival", 4096)
	SB_DECLARE_CLASS_LONG_CONST(TSBCMSSigningOptions_ce_ptr, "csoUseGenericSigAlgorithmOIDs", 8192)
	SB_DECLARE_CLASS_LONG_CONST(TSBCMSSigningOptions_ce_ptr, "csoUsePlainContentForTimestampHashes", 16384)
	SB_DECLARE_CLASS_LONG_CONST(TSBCMSSigningOptions_ce_ptr, "csoUseATSHashIndexV1", 32768)
	SB_DECLARE_CLASS_LONG_CONST(TSBCMSSigningOptions_ce_ptr, "csoCheckATSHashIndexElements", 65536)
	
	INIT_CLASS_ENTRY(ce, "TSBCMSSignatureState", NULL);
	TSBCMSSignatureState_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBCMSSignatureState_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBCMSSignatureState_ce_ptr, "cssSigned", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBCMSSignatureState_ce_ptr, "cssUnsigned", 1)
}

