#include "sbcryptoprov.h"

void SB_CALLBACK TSBCryptoProviderObjectEventRaw(void * _ObjectData, TObjectHandle Sender, TObjectHandle Obj)
{
	zval *retval_ptr;
	zval **params[2];
	zval * zSender;
	zval * zObj;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zObj);
	SBInitObject(zObj, TObject_ce_ptr, Obj TSRMLS_CC);

	params[0] = &zSender;
	params[1] = &zObj;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 2, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zObj);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

zend_class_entry *TElCustomCryptoProviderClass_ce_ptr = NULL;

zend_class_entry *TElCustomCryptoProvider_ce_ptr = NULL;

SB_PHP_METHOD(TElCustomCryptoProvider, Init)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElCustomCryptoProvider_Init(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCryptoProvider, Deinit)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElCustomCryptoProvider_Deinit(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCryptoProvider, SetAsDefault_Inst)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElCustomCryptoProvider_SetAsDefault_1(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCryptoProvider, SetAsDefault)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElCustomCryptoProvider_SetAsDefault() TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCryptoProvider, GetDefaultInstance)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCustomCryptoProvider_GetDefaultInstance(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomCryptoProvider_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCryptoProvider, Clone)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCustomCryptoProvider_Clone(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomCryptoProvider_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCryptoProvider, IsAlgorithmSupported)
{
	long l4Algorithm;
	long l4Mode;
	SBArrayZValInfo aiAlgOID;
	SBArrayZValInfo aiAlgParams;
	zval *zaAlgOID;
	zval *zaAlgParams;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &l4Algorithm, &l4Mode) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElCustomCryptoProvider_IsAlgorithmSupported(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Algorithm, (int32_t)l4Mode, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zzl", &zaAlgOID, &zaAlgParams, &l4Mode) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaAlgOID)) || (IS_ARRAY == Z_TYPE_P(zaAlgOID)) || (IS_NULL == Z_TYPE_P(zaAlgOID))) && ((IS_STRING == Z_TYPE_P(zaAlgParams)) || (IS_ARRAY == Z_TYPE_P(zaAlgParams)) || (IS_NULL == Z_TYPE_P(zaAlgParams))))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaAlgOID, &aiAlgOID TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaAlgParams, &aiAlgParams TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElCustomCryptoProvider_IsAlgorithmSupported_1(SBGetObjectHandle(getThis() TSRMLS_CC), aiAlgOID.data, aiAlgOID.len, aiAlgParams.data, aiAlgParams.len, (int32_t)l4Mode, &bOutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiAlgOID);
		SBFreeArrayZValInfo(&aiAlgParams);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer) or (array of byte|string|NULL, array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCryptoProvider, IsOperationSupported)
{
	long l4Algorithm;
	long l4Mode;
	long l4Operation;
	SBArrayZValInfo aiAlgOID;
	SBArrayZValInfo aiAlgParams;
	zval *oKey;
	zval *oParams;
	zval *zaAlgOID;
	zval *zaAlgParams;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lllO!O!", &l4Operation, &l4Algorithm, &l4Mode, &oKey, TElCustomCryptoKey_ce_ptr, &oParams, TElRelativeDistinguishedName_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElCustomCryptoProvider_IsOperationSupported(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Operation, (int32_t)l4Algorithm, (int32_t)l4Mode, SBGetObjectHandle(oKey TSRMLS_CC), SBGetObjectHandle(oParams TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lzzlO!O!", &l4Operation, &zaAlgOID, &zaAlgParams, &l4Mode, &oKey, TElCustomCryptoKey_ce_ptr, &oParams, TElRelativeDistinguishedName_ce_ptr) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaAlgOID)) || (IS_ARRAY == Z_TYPE_P(zaAlgOID)) || (IS_NULL == Z_TYPE_P(zaAlgOID))) && ((IS_STRING == Z_TYPE_P(zaAlgParams)) || (IS_ARRAY == Z_TYPE_P(zaAlgParams)) || (IS_NULL == Z_TYPE_P(zaAlgParams))))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaAlgOID, &aiAlgOID TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaAlgParams, &aiAlgParams TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElCustomCryptoProvider_IsOperationSupported_1(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Operation, aiAlgOID.data, aiAlgOID.len, aiAlgParams.data, aiAlgParams.len, (int32_t)l4Mode, SBGetObjectHandle(oKey TSRMLS_CC), SBGetObjectHandle(oParams TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiAlgOID);
		SBFreeArrayZValInfo(&aiAlgParams);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer, integer, TElCustomCryptoKey, TElRelativeDistinguishedName) or (integer, array of byte|string|NULL, array of byte|string|NULL, integer, TElCustomCryptoKey, TElRelativeDistinguishedName)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCryptoProvider, GetAlgorithmProperty)
{
	long l4Algorithm;
	long l4Mode;
	SBArrayZValInfo aiAlgOID;
	SBArrayZValInfo aiAlgParams;
	SBArrayZValInfo aiPropID;
	uint32_t _err;
	zval *zaAlgOID;
	zval *zaAlgParams;
	zval *zaPropID;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "llz", &l4Algorithm, &l4Mode, &zaPropID) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaPropID)) || (IS_ARRAY == Z_TYPE_P(zaPropID)) || (IS_NULL == Z_TYPE_P(zaPropID))))
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		if (!SBGetByteArrayFromZVal(zaPropID, &aiPropID TSRMLS_CC)) RETURN_FALSE;
		_err = TElCustomCryptoProvider_GetAlgorithmProperty(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Algorithm, (int32_t)l4Mode, aiPropID.data, aiPropID.len, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(1810233091, 4, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiPropID);
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zzlz", &zaAlgOID, &zaAlgParams, &l4Mode, &zaPropID) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaAlgOID)) || (IS_ARRAY == Z_TYPE_P(zaAlgOID)) || (IS_NULL == Z_TYPE_P(zaAlgOID))) && ((IS_STRING == Z_TYPE_P(zaAlgParams)) || (IS_ARRAY == Z_TYPE_P(zaAlgParams)) || (IS_NULL == Z_TYPE_P(zaAlgParams))) && ((IS_STRING == Z_TYPE_P(zaPropID)) || (IS_ARRAY == Z_TYPE_P(zaPropID)) || (IS_NULL == Z_TYPE_P(zaPropID))))
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		if (!SBGetByteArrayFromZVal(zaAlgOID, &aiAlgOID TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaAlgParams, &aiAlgParams TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaPropID, &aiPropID TSRMLS_CC)) RETURN_FALSE;
		_err = TElCustomCryptoProvider_GetAlgorithmProperty_1(SBGetObjectHandle(getThis() TSRMLS_CC), aiAlgOID.data, aiAlgOID.len, aiAlgParams.data, aiAlgParams.len, (int32_t)l4Mode, aiPropID.data, aiPropID.len, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(1581093443, 5, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiAlgOID);
		SBFreeArrayZValInfo(&aiAlgParams);
		SBFreeArrayZValInfo(&aiPropID);
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer, array of byte|string|NULL) or (array of byte|string|NULL, array of byte|string|NULL, integer, array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCryptoProvider, GetAlgorithmClass)
{
	long l4Algorithm;
	SBArrayZValInfo aiAlgOID;
	SBArrayZValInfo aiAlgParams;
	zval *zaAlgOID;
	zval *zaAlgParams;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Algorithm) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElCustomCryptoProvider_GetAlgorithmClass(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Algorithm, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zz", &zaAlgOID, &zaAlgParams) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaAlgOID)) || (IS_ARRAY == Z_TYPE_P(zaAlgOID)) || (IS_NULL == Z_TYPE_P(zaAlgOID))) && ((IS_STRING == Z_TYPE_P(zaAlgParams)) || (IS_ARRAY == Z_TYPE_P(zaAlgParams)) || (IS_NULL == Z_TYPE_P(zaAlgParams))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaAlgOID, &aiAlgOID TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaAlgParams, &aiAlgParams TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElCustomCryptoProvider_GetAlgorithmClass_1(SBGetObjectHandle(getThis() TSRMLS_CC), aiAlgOID.data, aiAlgOID.len, aiAlgParams.data, aiAlgParams.len, &l4OutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiAlgOID);
		SBFreeArrayZValInfo(&aiAlgParams);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer) or (array of byte|string|NULL, array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCryptoProvider, GetProviderProp)
{
	SBArrayZValInfo aiDefault;
	SBArrayZValInfo aiPropID;
	uint32_t _err;
	zval *zaDefault;
	zval *zaPropID;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zz", &zaPropID, &zaDefault) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaPropID)) || (IS_ARRAY == Z_TYPE_P(zaPropID)) || (IS_NULL == Z_TYPE_P(zaPropID))) && ((IS_STRING == Z_TYPE_P(zaDefault)) || (IS_ARRAY == Z_TYPE_P(zaDefault)) || (IS_NULL == Z_TYPE_P(zaDefault))))
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		if (!SBGetByteArrayFromZVal(zaPropID, &aiPropID TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaDefault, &aiDefault TSRMLS_CC)) RETURN_FALSE;
		_err = TElCustomCryptoProvider_GetProviderProp(SBGetObjectHandle(getThis() TSRMLS_CC), aiPropID.data, aiPropID.len, aiDefault.data, aiDefault.len, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-129298666, 3, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiPropID);
		SBFreeArrayZValInfo(&aiDefault);
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCryptoProvider, SetProviderProp)
{
	SBArrayZValInfo aiPropID;
	SBArrayZValInfo aiValue;
	zval *zaPropID;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zz", &zaPropID, &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaPropID)) || (IS_ARRAY == Z_TYPE_P(zaPropID)) || (IS_NULL == Z_TYPE_P(zaPropID))) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaPropID, &aiPropID TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElCustomCryptoProvider_SetProviderProp(SBGetObjectHandle(getThis() TSRMLS_CC), aiPropID.data, aiPropID.len, aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiPropID);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCryptoProvider, CreateKey)
{
	long l4Algorithm;
	long l4Mode;
	SBArrayZValInfo aiAlgOID;
	SBArrayZValInfo aiAlgParams;
	zval *oParams;
	zval *zaAlgOID;
	zval *zaAlgParams;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "llO!", &l4Algorithm, &l4Mode, &oParams, TElRelativeDistinguishedName_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCustomCryptoProvider_CreateKey(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Algorithm, (int32_t)l4Mode, SBGetObjectHandle(oParams TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomCryptoKey_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zzO!", &zaAlgOID, &zaAlgParams, &oParams, TElRelativeDistinguishedName_ce_ptr) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaAlgOID)) || (IS_ARRAY == Z_TYPE_P(zaAlgOID)) || (IS_NULL == Z_TYPE_P(zaAlgOID))) && ((IS_STRING == Z_TYPE_P(zaAlgParams)) || (IS_ARRAY == Z_TYPE_P(zaAlgParams)) || (IS_NULL == Z_TYPE_P(zaAlgParams))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetByteArrayFromZVal(zaAlgOID, &aiAlgOID TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaAlgParams, &aiAlgParams TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElCustomCryptoProvider_CreateKey_1(SBGetObjectHandle(getThis() TSRMLS_CC), aiAlgOID.data, aiAlgOID.len, aiAlgParams.data, aiAlgParams.len, SBGetObjectHandle(oParams TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiAlgOID);
		SBFreeArrayZValInfo(&aiAlgParams);
		SBInitObject(return_value, TElCustomCryptoKey_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer, TElRelativeDistinguishedName) or (array of byte|string|NULL, array of byte|string|NULL, TElRelativeDistinguishedName)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCryptoProvider, CloneKey)
{
	zval *oKey;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oKey, TElCustomCryptoKey_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCustomCryptoProvider_CloneKey(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oKey TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomCryptoKey_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCryptoKey)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCryptoProvider, ReleaseKey)
{
	TElClassHandle hoKey;
	zval *oKey;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &oKey, TElCustomCryptoKey_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oKey) && (IS_OBJECT == Z_TYPE_P(oKey)))
	{
		hoKey = SBGetObjectHandle(oKey TSRMLS_CC);
		SBCheckError(TElCustomCryptoProvider_ReleaseKey(SBGetObjectHandle(getThis() TSRMLS_CC), &hoKey) TSRMLS_CC);
		SBUpdateObjectHandle(oKey, hoKey TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(&TElCustomCryptoKey)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCryptoProvider, DeleteKey)
{
	TElClassHandle hoKey;
	zval *oKey;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &oKey, TElCustomCryptoKey_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oKey) && (IS_OBJECT == Z_TYPE_P(oKey)))
	{
		hoKey = SBGetObjectHandle(oKey TSRMLS_CC);
		SBCheckError(TElCustomCryptoProvider_DeleteKey(SBGetObjectHandle(getThis() TSRMLS_CC), &hoKey) TSRMLS_CC);
		SBUpdateObjectHandle(oKey, hoKey TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(&TElCustomCryptoKey)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCryptoProvider, DecryptKey)
{
	long l4EncKeySize;
	SBArrayZValInfo aiEncKeyAlgOID;
	SBArrayZValInfo aiEncKeyAlgParams;
	SBArrayZValInfo aiKeyAlgOID;
	SBArrayZValInfo aiKeyAlgParams;
	SBArrayZValInfo piEncKey;
	SBArrayZValInfo piProgressData;
	void *pzProgressFunc;
	zval *oKey;
	zval *oParams;
	zval *zaEncKeyAlgOID;
	zval *zaEncKeyAlgParams;
	zval *zaKeyAlgOID;
	zval *zaKeyAlgParams;
	zval *zpEncKey;
	zval *zpProgressData;
	zval *zProgressFunc;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlzzO!zzO!zz", &zpEncKey, &l4EncKeySize, &zaEncKeyAlgOID, &zaEncKeyAlgParams, &oKey, TElCustomCryptoKey_ce_ptr, &zaKeyAlgOID, &zaKeyAlgParams, &oParams, TElRelativeDistinguishedName_ce_ptr, &zProgressFunc, &zpProgressData) == SUCCESS) && ((Z_TYPE_P(zpEncKey) == IS_STRING) || (Z_TYPE_P(zpEncKey) == IS_ARRAY) || (Z_TYPE_P(zpEncKey) == IS_NULL) || ((Z_TYPE_P(zpEncKey) == IS_OBJECT) && (Z_OBJCE_P(zpEncKey) == TSBPointer_ce_ptr))) && ((IS_STRING == Z_TYPE_P(zaEncKeyAlgOID)) || (IS_ARRAY == Z_TYPE_P(zaEncKeyAlgOID)) || (IS_NULL == Z_TYPE_P(zaEncKeyAlgOID))) && ((IS_STRING == Z_TYPE_P(zaEncKeyAlgParams)) || (IS_ARRAY == Z_TYPE_P(zaEncKeyAlgParams)) || (IS_NULL == Z_TYPE_P(zaEncKeyAlgParams))) && ((IS_STRING == Z_TYPE_P(zaKeyAlgOID)) || (IS_ARRAY == Z_TYPE_P(zaKeyAlgOID)) || (IS_NULL == Z_TYPE_P(zaKeyAlgOID))) && ((IS_STRING == Z_TYPE_P(zaKeyAlgParams)) || (IS_ARRAY == Z_TYPE_P(zaKeyAlgParams)) || (IS_NULL == Z_TYPE_P(zaKeyAlgParams))) && ((IS_STRING == Z_TYPE_P(zProgressFunc)) || (IS_ARRAY == Z_TYPE_P(zProgressFunc)) || (IS_CALLABLE == Z_TYPE_P(zProgressFunc)) || (IS_NULL == Z_TYPE_P(zProgressFunc))) && ((Z_TYPE_P(zpProgressData) == IS_STRING) || (Z_TYPE_P(zpProgressData) == IS_ARRAY) || (Z_TYPE_P(zpProgressData) == IS_NULL) || ((Z_TYPE_P(zpProgressData) == IS_OBJECT) && (Z_OBJCE_P(zpProgressData) == TSBPointer_ce_ptr))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetPointerFromZVal(zpEncKey, &piEncKey TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaEncKeyAlgOID, &aiEncKeyAlgOID TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaEncKeyAlgParams, &aiEncKeyAlgParams TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaKeyAlgOID, &aiKeyAlgOID TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaKeyAlgParams, &aiKeyAlgParams TSRMLS_CC)) RETURN_FALSE;
		pzProgressFunc = SBSetEventData(zProgressFunc TSRMLS_CC);
		if (!SBGetPointerFromZVal(zpProgressData, &piProgressData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElCustomCryptoProvider_DecryptKey(SBGetObjectHandle(getThis() TSRMLS_CC), piEncKey.data, (int32_t)l4EncKeySize, aiEncKeyAlgOID.data, aiEncKeyAlgOID.len, aiEncKeyAlgParams.data, aiEncKeyAlgParams.len, SBGetObjectHandle(oKey TSRMLS_CC), aiKeyAlgOID.data, aiKeyAlgOID.len, aiKeyAlgParams.data, aiKeyAlgParams.len, SBGetObjectHandle(oParams TSRMLS_CC), pzProgressFunc ? &TSBProgressFuncRaw : NULL, pzProgressFunc, piProgressData.data, &hoOutResult) TSRMLS_CC);
		SBFreePointerZValInfo(&piEncKey);
		SBFreeArrayZValInfo(&aiEncKeyAlgOID);
		SBFreeArrayZValInfo(&aiEncKeyAlgParams);
		SBFreeArrayZValInfo(&aiKeyAlgOID);
		SBFreeArrayZValInfo(&aiKeyAlgParams);
		SBFreePointerZValInfo(&piProgressData);
		SBInitObject(return_value, TElCustomCryptoKey_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer, array of byte|string|NULL, array of byte|string|NULL, TElCustomCryptoKey, array of byte|string|NULL, array of byte|string|NULL, TElRelativeDistinguishedName, TSBProgressFunc|callable|NULL, TSBPointer|array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCryptoProvider, CreateKeyStorage)
{
	zend_bool bPersistent;
	zval *oParams;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "bO!", &bPersistent, &oParams, TElRelativeDistinguishedName_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCustomCryptoProvider_CreateKeyStorage(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bPersistent, SBGetObjectHandle(oParams TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomCryptoKeyStorage_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool, TElRelativeDistinguishedName)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCryptoProvider, ReleaseKeyStorage)
{
	TElClassHandle hoKeyStorage;
	zval *oKeyStorage;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &oKeyStorage, TElCustomCryptoKeyStorage_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oKeyStorage) && (IS_OBJECT == Z_TYPE_P(oKeyStorage)))
	{
		hoKeyStorage = SBGetObjectHandle(oKeyStorage TSRMLS_CC);
		SBCheckError(TElCustomCryptoProvider_ReleaseKeyStorage(SBGetObjectHandle(getThis() TSRMLS_CC), &hoKeyStorage) TSRMLS_CC);
		SBUpdateObjectHandle(oKeyStorage, hoKeyStorage TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(&TElCustomCryptoKeyStorage)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCryptoProvider, DeleteKeyStorage)
{
	TElClassHandle hoKeyStorage;
	zval *oKeyStorage;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &oKeyStorage, TElCustomCryptoKeyStorage_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oKeyStorage) && (IS_OBJECT == Z_TYPE_P(oKeyStorage)))
	{
		hoKeyStorage = SBGetObjectHandle(oKeyStorage TSRMLS_CC);
		SBCheckError(TElCustomCryptoProvider_DeleteKeyStorage(SBGetObjectHandle(getThis() TSRMLS_CC), &hoKeyStorage) TSRMLS_CC);
		SBUpdateObjectHandle(oKeyStorage, hoKeyStorage TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(&TElCustomCryptoKeyStorage)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCryptoProvider, EncryptInit)
{
	long l4Algorithm;
	long l4Mode;
	SBArrayZValInfo aiAlgOID;
	SBArrayZValInfo aiAlgParams;
	SBArrayZValInfo piProgressData;
	void *pzProgressFunc;
	zval *oKey;
	zval *oParams;
	zval *zaAlgOID;
	zval *zaAlgParams;
	zval *zpProgressData;
	zval *zProgressFunc;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "llO!O!zz", &l4Algorithm, &l4Mode, &oKey, TElCustomCryptoKey_ce_ptr, &oParams, TElRelativeDistinguishedName_ce_ptr, &zProgressFunc, &zpProgressData) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zProgressFunc)) || (IS_ARRAY == Z_TYPE_P(zProgressFunc)) || (IS_CALLABLE == Z_TYPE_P(zProgressFunc)) || (IS_NULL == Z_TYPE_P(zProgressFunc))) && ((Z_TYPE_P(zpProgressData) == IS_STRING) || (Z_TYPE_P(zpProgressData) == IS_ARRAY) || (Z_TYPE_P(zpProgressData) == IS_NULL) || ((Z_TYPE_P(zpProgressData) == IS_OBJECT) && (Z_OBJCE_P(zpProgressData) == TSBPointer_ce_ptr))))
	{
		TElClassHandle hoOutResult = NULL;
		pzProgressFunc = SBSetEventData(zProgressFunc TSRMLS_CC);
		if (!SBGetPointerFromZVal(zpProgressData, &piProgressData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElCustomCryptoProvider_EncryptInit(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Algorithm, (int32_t)l4Mode, SBGetObjectHandle(oKey TSRMLS_CC), SBGetObjectHandle(oParams TSRMLS_CC), pzProgressFunc ? &TSBProgressFuncRaw : NULL, pzProgressFunc, piProgressData.data, &hoOutResult) TSRMLS_CC);
		SBFreePointerZValInfo(&piProgressData);
		SBInitObject(return_value, TElCustomCryptoContext_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zzlO!O!zz", &zaAlgOID, &zaAlgParams, &l4Mode, &oKey, TElCustomCryptoKey_ce_ptr, &oParams, TElRelativeDistinguishedName_ce_ptr, &zProgressFunc, &zpProgressData) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaAlgOID)) || (IS_ARRAY == Z_TYPE_P(zaAlgOID)) || (IS_NULL == Z_TYPE_P(zaAlgOID))) && ((IS_STRING == Z_TYPE_P(zaAlgParams)) || (IS_ARRAY == Z_TYPE_P(zaAlgParams)) || (IS_NULL == Z_TYPE_P(zaAlgParams))) && ((IS_STRING == Z_TYPE_P(zProgressFunc)) || (IS_ARRAY == Z_TYPE_P(zProgressFunc)) || (IS_CALLABLE == Z_TYPE_P(zProgressFunc)) || (IS_NULL == Z_TYPE_P(zProgressFunc))) && ((Z_TYPE_P(zpProgressData) == IS_STRING) || (Z_TYPE_P(zpProgressData) == IS_ARRAY) || (Z_TYPE_P(zpProgressData) == IS_NULL) || ((Z_TYPE_P(zpProgressData) == IS_OBJECT) && (Z_OBJCE_P(zpProgressData) == TSBPointer_ce_ptr))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetByteArrayFromZVal(zaAlgOID, &aiAlgOID TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaAlgParams, &aiAlgParams TSRMLS_CC)) RETURN_FALSE;
		pzProgressFunc = SBSetEventData(zProgressFunc TSRMLS_CC);
		if (!SBGetPointerFromZVal(zpProgressData, &piProgressData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElCustomCryptoProvider_EncryptInit_1(SBGetObjectHandle(getThis() TSRMLS_CC), aiAlgOID.data, aiAlgOID.len, aiAlgParams.data, aiAlgParams.len, (int32_t)l4Mode, SBGetObjectHandle(oKey TSRMLS_CC), SBGetObjectHandle(oParams TSRMLS_CC), pzProgressFunc ? &TSBProgressFuncRaw : NULL, pzProgressFunc, piProgressData.data, &hoOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiAlgOID);
		SBFreeArrayZValInfo(&aiAlgParams);
		SBFreePointerZValInfo(&piProgressData);
		SBInitObject(return_value, TElCustomCryptoContext_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer, TElCustomCryptoKey, TElRelativeDistinguishedName, TSBProgressFunc|callable|NULL, TSBPointer|array of byte|string|NULL) or (array of byte|string|NULL, array of byte|string|NULL, integer, TElCustomCryptoKey, TElRelativeDistinguishedName, TSBProgressFunc|callable|NULL, TSBPointer|array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCryptoProvider, DecryptInit)
{
	long l4Algorithm;
	long l4Mode;
	SBArrayZValInfo aiAlgOID;
	SBArrayZValInfo aiAlgParams;
	SBArrayZValInfo piProgressData;
	void *pzProgressFunc;
	zval *oKey;
	zval *oParams;
	zval *zaAlgOID;
	zval *zaAlgParams;
	zval *zpProgressData;
	zval *zProgressFunc;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "llO!O!zz", &l4Algorithm, &l4Mode, &oKey, TElCustomCryptoKey_ce_ptr, &oParams, TElRelativeDistinguishedName_ce_ptr, &zProgressFunc, &zpProgressData) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zProgressFunc)) || (IS_ARRAY == Z_TYPE_P(zProgressFunc)) || (IS_CALLABLE == Z_TYPE_P(zProgressFunc)) || (IS_NULL == Z_TYPE_P(zProgressFunc))) && ((Z_TYPE_P(zpProgressData) == IS_STRING) || (Z_TYPE_P(zpProgressData) == IS_ARRAY) || (Z_TYPE_P(zpProgressData) == IS_NULL) || ((Z_TYPE_P(zpProgressData) == IS_OBJECT) && (Z_OBJCE_P(zpProgressData) == TSBPointer_ce_ptr))))
	{
		TElClassHandle hoOutResult = NULL;
		pzProgressFunc = SBSetEventData(zProgressFunc TSRMLS_CC);
		if (!SBGetPointerFromZVal(zpProgressData, &piProgressData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElCustomCryptoProvider_DecryptInit(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Algorithm, (int32_t)l4Mode, SBGetObjectHandle(oKey TSRMLS_CC), SBGetObjectHandle(oParams TSRMLS_CC), pzProgressFunc ? &TSBProgressFuncRaw : NULL, pzProgressFunc, piProgressData.data, &hoOutResult) TSRMLS_CC);
		SBFreePointerZValInfo(&piProgressData);
		SBInitObject(return_value, TElCustomCryptoContext_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zzlO!O!zz", &zaAlgOID, &zaAlgParams, &l4Mode, &oKey, TElCustomCryptoKey_ce_ptr, &oParams, TElRelativeDistinguishedName_ce_ptr, &zProgressFunc, &zpProgressData) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaAlgOID)) || (IS_ARRAY == Z_TYPE_P(zaAlgOID)) || (IS_NULL == Z_TYPE_P(zaAlgOID))) && ((IS_STRING == Z_TYPE_P(zaAlgParams)) || (IS_ARRAY == Z_TYPE_P(zaAlgParams)) || (IS_NULL == Z_TYPE_P(zaAlgParams))) && ((IS_STRING == Z_TYPE_P(zProgressFunc)) || (IS_ARRAY == Z_TYPE_P(zProgressFunc)) || (IS_CALLABLE == Z_TYPE_P(zProgressFunc)) || (IS_NULL == Z_TYPE_P(zProgressFunc))) && ((Z_TYPE_P(zpProgressData) == IS_STRING) || (Z_TYPE_P(zpProgressData) == IS_ARRAY) || (Z_TYPE_P(zpProgressData) == IS_NULL) || ((Z_TYPE_P(zpProgressData) == IS_OBJECT) && (Z_OBJCE_P(zpProgressData) == TSBPointer_ce_ptr))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetByteArrayFromZVal(zaAlgOID, &aiAlgOID TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaAlgParams, &aiAlgParams TSRMLS_CC)) RETURN_FALSE;
		pzProgressFunc = SBSetEventData(zProgressFunc TSRMLS_CC);
		if (!SBGetPointerFromZVal(zpProgressData, &piProgressData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElCustomCryptoProvider_DecryptInit_1(SBGetObjectHandle(getThis() TSRMLS_CC), aiAlgOID.data, aiAlgOID.len, aiAlgParams.data, aiAlgParams.len, (int32_t)l4Mode, SBGetObjectHandle(oKey TSRMLS_CC), SBGetObjectHandle(oParams TSRMLS_CC), pzProgressFunc ? &TSBProgressFuncRaw : NULL, pzProgressFunc, piProgressData.data, &hoOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiAlgOID);
		SBFreeArrayZValInfo(&aiAlgParams);
		SBFreePointerZValInfo(&piProgressData);
		SBInitObject(return_value, TElCustomCryptoContext_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer, TElCustomCryptoKey, TElRelativeDistinguishedName, TSBProgressFunc|callable|NULL, TSBPointer|array of byte|string|NULL) or (array of byte|string|NULL, array of byte|string|NULL, integer, TElCustomCryptoKey, TElRelativeDistinguishedName, TSBProgressFunc|callable|NULL, TSBPointer|array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCryptoProvider, SignInit)
{
	long l4Algorithm;
	SBArrayZValInfo aiAlgOID;
	SBArrayZValInfo aiAlgParams;
	SBArrayZValInfo piProgressData;
	void *pzProgressFunc;
	zend_bool bDetached;
	zval *oKey;
	zval *oParams;
	zval *zaAlgOID;
	zval *zaAlgParams;
	zval *zpProgressData;
	zval *zProgressFunc;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lO!bO!zz", &l4Algorithm, &oKey, TElCustomCryptoKey_ce_ptr, &bDetached, &oParams, TElRelativeDistinguishedName_ce_ptr, &zProgressFunc, &zpProgressData) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zProgressFunc)) || (IS_ARRAY == Z_TYPE_P(zProgressFunc)) || (IS_CALLABLE == Z_TYPE_P(zProgressFunc)) || (IS_NULL == Z_TYPE_P(zProgressFunc))) && ((Z_TYPE_P(zpProgressData) == IS_STRING) || (Z_TYPE_P(zpProgressData) == IS_ARRAY) || (Z_TYPE_P(zpProgressData) == IS_NULL) || ((Z_TYPE_P(zpProgressData) == IS_OBJECT) && (Z_OBJCE_P(zpProgressData) == TSBPointer_ce_ptr))))
	{
		TElClassHandle hoOutResult = NULL;
		pzProgressFunc = SBSetEventData(zProgressFunc TSRMLS_CC);
		if (!SBGetPointerFromZVal(zpProgressData, &piProgressData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElCustomCryptoProvider_SignInit(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Algorithm, SBGetObjectHandle(oKey TSRMLS_CC), (int8_t)bDetached, SBGetObjectHandle(oParams TSRMLS_CC), pzProgressFunc ? &TSBProgressFuncRaw : NULL, pzProgressFunc, piProgressData.data, &hoOutResult) TSRMLS_CC);
		SBFreePointerZValInfo(&piProgressData);
		SBInitObject(return_value, TElCustomCryptoContext_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zzO!bO!zz", &zaAlgOID, &zaAlgParams, &oKey, TElCustomCryptoKey_ce_ptr, &bDetached, &oParams, TElRelativeDistinguishedName_ce_ptr, &zProgressFunc, &zpProgressData) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaAlgOID)) || (IS_ARRAY == Z_TYPE_P(zaAlgOID)) || (IS_NULL == Z_TYPE_P(zaAlgOID))) && ((IS_STRING == Z_TYPE_P(zaAlgParams)) || (IS_ARRAY == Z_TYPE_P(zaAlgParams)) || (IS_NULL == Z_TYPE_P(zaAlgParams))) && ((IS_STRING == Z_TYPE_P(zProgressFunc)) || (IS_ARRAY == Z_TYPE_P(zProgressFunc)) || (IS_CALLABLE == Z_TYPE_P(zProgressFunc)) || (IS_NULL == Z_TYPE_P(zProgressFunc))) && ((Z_TYPE_P(zpProgressData) == IS_STRING) || (Z_TYPE_P(zpProgressData) == IS_ARRAY) || (Z_TYPE_P(zpProgressData) == IS_NULL) || ((Z_TYPE_P(zpProgressData) == IS_OBJECT) && (Z_OBJCE_P(zpProgressData) == TSBPointer_ce_ptr))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetByteArrayFromZVal(zaAlgOID, &aiAlgOID TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaAlgParams, &aiAlgParams TSRMLS_CC)) RETURN_FALSE;
		pzProgressFunc = SBSetEventData(zProgressFunc TSRMLS_CC);
		if (!SBGetPointerFromZVal(zpProgressData, &piProgressData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElCustomCryptoProvider_SignInit_1(SBGetObjectHandle(getThis() TSRMLS_CC), aiAlgOID.data, aiAlgOID.len, aiAlgParams.data, aiAlgParams.len, SBGetObjectHandle(oKey TSRMLS_CC), (int8_t)bDetached, SBGetObjectHandle(oParams TSRMLS_CC), pzProgressFunc ? &TSBProgressFuncRaw : NULL, pzProgressFunc, piProgressData.data, &hoOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiAlgOID);
		SBFreeArrayZValInfo(&aiAlgParams);
		SBFreePointerZValInfo(&piProgressData);
		SBInitObject(return_value, TElCustomCryptoContext_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, TElCustomCryptoKey, bool, TElRelativeDistinguishedName, TSBProgressFunc|callable|NULL, TSBPointer|array of byte|string|NULL) or (array of byte|string|NULL, array of byte|string|NULL, TElCustomCryptoKey, bool, TElRelativeDistinguishedName, TSBProgressFunc|callable|NULL, TSBPointer|array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCryptoProvider, VerifyInit)
{
	long l4Algorithm;
	long l4SigSize;
	SBArrayZValInfo aiAlgOID;
	SBArrayZValInfo aiAlgParams;
	SBArrayZValInfo piProgressData;
	SBArrayZValInfo piSigBuffer;
	void *pzProgressFunc;
	zval *oKey;
	zval *oParams;
	zval *zaAlgOID;
	zval *zaAlgParams;
	zval *zpProgressData;
	zval *zProgressFunc;
	zval *zpSigBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lO!zlO!zz", &l4Algorithm, &oKey, TElCustomCryptoKey_ce_ptr, &zpSigBuffer, &l4SigSize, &oParams, TElRelativeDistinguishedName_ce_ptr, &zProgressFunc, &zpProgressData) == SUCCESS) && ((Z_TYPE_P(zpSigBuffer) == IS_STRING) || (Z_TYPE_P(zpSigBuffer) == IS_ARRAY) || (Z_TYPE_P(zpSigBuffer) == IS_NULL) || ((Z_TYPE_P(zpSigBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpSigBuffer) == TSBPointer_ce_ptr))) && ((IS_STRING == Z_TYPE_P(zProgressFunc)) || (IS_ARRAY == Z_TYPE_P(zProgressFunc)) || (IS_CALLABLE == Z_TYPE_P(zProgressFunc)) || (IS_NULL == Z_TYPE_P(zProgressFunc))) && ((Z_TYPE_P(zpProgressData) == IS_STRING) || (Z_TYPE_P(zpProgressData) == IS_ARRAY) || (Z_TYPE_P(zpProgressData) == IS_NULL) || ((Z_TYPE_P(zpProgressData) == IS_OBJECT) && (Z_OBJCE_P(zpProgressData) == TSBPointer_ce_ptr))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetPointerFromZVal(zpSigBuffer, &piSigBuffer TSRMLS_CC)) RETURN_FALSE;
		pzProgressFunc = SBSetEventData(zProgressFunc TSRMLS_CC);
		if (!SBGetPointerFromZVal(zpProgressData, &piProgressData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElCustomCryptoProvider_VerifyInit(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Algorithm, SBGetObjectHandle(oKey TSRMLS_CC), piSigBuffer.data, (int32_t)l4SigSize, SBGetObjectHandle(oParams TSRMLS_CC), pzProgressFunc ? &TSBProgressFuncRaw : NULL, pzProgressFunc, piProgressData.data, &hoOutResult) TSRMLS_CC);
		SBFreePointerZValInfo(&piSigBuffer);
		SBFreePointerZValInfo(&piProgressData);
		SBInitObject(return_value, TElCustomCryptoContext_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zzO!zlO!zz", &zaAlgOID, &zaAlgParams, &oKey, TElCustomCryptoKey_ce_ptr, &zpSigBuffer, &l4SigSize, &oParams, TElRelativeDistinguishedName_ce_ptr, &zProgressFunc, &zpProgressData) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaAlgOID)) || (IS_ARRAY == Z_TYPE_P(zaAlgOID)) || (IS_NULL == Z_TYPE_P(zaAlgOID))) && ((IS_STRING == Z_TYPE_P(zaAlgParams)) || (IS_ARRAY == Z_TYPE_P(zaAlgParams)) || (IS_NULL == Z_TYPE_P(zaAlgParams))) && ((Z_TYPE_P(zpSigBuffer) == IS_STRING) || (Z_TYPE_P(zpSigBuffer) == IS_ARRAY) || (Z_TYPE_P(zpSigBuffer) == IS_NULL) || ((Z_TYPE_P(zpSigBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpSigBuffer) == TSBPointer_ce_ptr))) && ((IS_STRING == Z_TYPE_P(zProgressFunc)) || (IS_ARRAY == Z_TYPE_P(zProgressFunc)) || (IS_CALLABLE == Z_TYPE_P(zProgressFunc)) || (IS_NULL == Z_TYPE_P(zProgressFunc))) && ((Z_TYPE_P(zpProgressData) == IS_STRING) || (Z_TYPE_P(zpProgressData) == IS_ARRAY) || (Z_TYPE_P(zpProgressData) == IS_NULL) || ((Z_TYPE_P(zpProgressData) == IS_OBJECT) && (Z_OBJCE_P(zpProgressData) == TSBPointer_ce_ptr))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetByteArrayFromZVal(zaAlgOID, &aiAlgOID TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaAlgParams, &aiAlgParams TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpSigBuffer, &piSigBuffer TSRMLS_CC)) RETURN_FALSE;
		pzProgressFunc = SBSetEventData(zProgressFunc TSRMLS_CC);
		if (!SBGetPointerFromZVal(zpProgressData, &piProgressData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElCustomCryptoProvider_VerifyInit_1(SBGetObjectHandle(getThis() TSRMLS_CC), aiAlgOID.data, aiAlgOID.len, aiAlgParams.data, aiAlgParams.len, SBGetObjectHandle(oKey TSRMLS_CC), piSigBuffer.data, (int32_t)l4SigSize, SBGetObjectHandle(oParams TSRMLS_CC), pzProgressFunc ? &TSBProgressFuncRaw : NULL, pzProgressFunc, piProgressData.data, &hoOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiAlgOID);
		SBFreeArrayZValInfo(&aiAlgParams);
		SBFreePointerZValInfo(&piSigBuffer);
		SBFreePointerZValInfo(&piProgressData);
		SBInitObject(return_value, TElCustomCryptoContext_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, TElCustomCryptoKey, TSBPointer|array of byte|string|NULL, integer, TElRelativeDistinguishedName, TSBProgressFunc|callable|NULL, TSBPointer|array of byte|string|NULL) or (array of byte|string|NULL, array of byte|string|NULL, TElCustomCryptoKey, TSBPointer|array of byte|string|NULL, integer, TElRelativeDistinguishedName, TSBProgressFunc|callable|NULL, TSBPointer|array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCryptoProvider, EncryptUpdate)
{
	int32_t l4OutSizeRaw;
	long l4InSize;
	SBArrayZValInfo piInBuffer;
	SBArrayZValInfo piOutBuffer;
	SBArrayZValInfo piProgressData;
	void *pzProgressFunc;
	zval *oContext;
	zval *oParams;
	zval *zl4OutSize;
	zval *zpInBuffer;
	zval *zpOutBuffer;
	zval *zpProgressData;
	zval *zProgressFunc;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!zlzzO!zz", &oContext, TElCustomCryptoContext_ce_ptr, &zpInBuffer, &l4InSize, &zpOutBuffer, &zl4OutSize, &oParams, TElRelativeDistinguishedName_ce_ptr, &zProgressFunc, &zpProgressData) == SUCCESS) && ((Z_TYPE_P(zpInBuffer) == IS_STRING) || (Z_TYPE_P(zpInBuffer) == IS_ARRAY) || (Z_TYPE_P(zpInBuffer) == IS_NULL) || ((Z_TYPE_P(zpInBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpInBuffer) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpOutBuffer) == IS_STRING) || (Z_TYPE_P(zpOutBuffer) == IS_ARRAY) || (Z_TYPE_P(zpOutBuffer) == IS_NULL) || ((Z_TYPE_P(zpOutBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpOutBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4OutSize) && (IS_LONG == Z_TYPE_P(zl4OutSize)) && ((IS_STRING == Z_TYPE_P(zProgressFunc)) || (IS_ARRAY == Z_TYPE_P(zProgressFunc)) || (IS_CALLABLE == Z_TYPE_P(zProgressFunc)) || (IS_NULL == Z_TYPE_P(zProgressFunc))) && ((Z_TYPE_P(zpProgressData) == IS_STRING) || (Z_TYPE_P(zpProgressData) == IS_ARRAY) || (Z_TYPE_P(zpProgressData) == IS_NULL) || ((Z_TYPE_P(zpProgressData) == IS_OBJECT) && (Z_OBJCE_P(zpProgressData) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpInBuffer, &piInBuffer TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpOutBuffer, &piOutBuffer TSRMLS_CC)) RETURN_FALSE;
		l4OutSizeRaw = (int32_t)Z_LVAL_P(zl4OutSize);
		pzProgressFunc = SBSetEventData(zProgressFunc TSRMLS_CC);
		if (!SBGetPointerFromZVal(zpProgressData, &piProgressData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElCustomCryptoProvider_EncryptUpdate(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oContext TSRMLS_CC), piInBuffer.data, (int32_t)l4InSize, piOutBuffer.data, &l4OutSizeRaw, SBGetObjectHandle(oParams TSRMLS_CC), pzProgressFunc ? &TSBProgressFuncRaw : NULL, pzProgressFunc, piProgressData.data) TSRMLS_CC);
		SBFreePointerZValInfo(&piInBuffer);
		SBFreePointerZValInfo(&piOutBuffer);
		ZVAL_LONG(zl4OutSize, (long)l4OutSizeRaw);
		SBFreePointerZValInfo(&piProgressData);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCryptoContext, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, &integer, TElRelativeDistinguishedName, TSBProgressFunc|callable|NULL, TSBPointer|array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCryptoProvider, DecryptUpdate)
{
	int32_t l4OutSizeRaw;
	long l4InSize;
	SBArrayZValInfo piInBuffer;
	SBArrayZValInfo piOutBuffer;
	SBArrayZValInfo piProgressData;
	void *pzProgressFunc;
	zval *oContext;
	zval *oParams;
	zval *zl4OutSize;
	zval *zpInBuffer;
	zval *zpOutBuffer;
	zval *zpProgressData;
	zval *zProgressFunc;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!zlzzO!zz", &oContext, TElCustomCryptoContext_ce_ptr, &zpInBuffer, &l4InSize, &zpOutBuffer, &zl4OutSize, &oParams, TElRelativeDistinguishedName_ce_ptr, &zProgressFunc, &zpProgressData) == SUCCESS) && ((Z_TYPE_P(zpInBuffer) == IS_STRING) || (Z_TYPE_P(zpInBuffer) == IS_ARRAY) || (Z_TYPE_P(zpInBuffer) == IS_NULL) || ((Z_TYPE_P(zpInBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpInBuffer) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpOutBuffer) == IS_STRING) || (Z_TYPE_P(zpOutBuffer) == IS_ARRAY) || (Z_TYPE_P(zpOutBuffer) == IS_NULL) || ((Z_TYPE_P(zpOutBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpOutBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4OutSize) && (IS_LONG == Z_TYPE_P(zl4OutSize)) && ((IS_STRING == Z_TYPE_P(zProgressFunc)) || (IS_ARRAY == Z_TYPE_P(zProgressFunc)) || (IS_CALLABLE == Z_TYPE_P(zProgressFunc)) || (IS_NULL == Z_TYPE_P(zProgressFunc))) && ((Z_TYPE_P(zpProgressData) == IS_STRING) || (Z_TYPE_P(zpProgressData) == IS_ARRAY) || (Z_TYPE_P(zpProgressData) == IS_NULL) || ((Z_TYPE_P(zpProgressData) == IS_OBJECT) && (Z_OBJCE_P(zpProgressData) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpInBuffer, &piInBuffer TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpOutBuffer, &piOutBuffer TSRMLS_CC)) RETURN_FALSE;
		l4OutSizeRaw = (int32_t)Z_LVAL_P(zl4OutSize);
		pzProgressFunc = SBSetEventData(zProgressFunc TSRMLS_CC);
		if (!SBGetPointerFromZVal(zpProgressData, &piProgressData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElCustomCryptoProvider_DecryptUpdate(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oContext TSRMLS_CC), piInBuffer.data, (int32_t)l4InSize, piOutBuffer.data, &l4OutSizeRaw, SBGetObjectHandle(oParams TSRMLS_CC), pzProgressFunc ? &TSBProgressFuncRaw : NULL, pzProgressFunc, piProgressData.data) TSRMLS_CC);
		SBFreePointerZValInfo(&piInBuffer);
		SBFreePointerZValInfo(&piOutBuffer);
		ZVAL_LONG(zl4OutSize, (long)l4OutSizeRaw);
		SBFreePointerZValInfo(&piProgressData);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCryptoContext, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, &integer, TElRelativeDistinguishedName, TSBProgressFunc|callable|NULL, TSBPointer|array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCryptoProvider, SignUpdate)
{
	int32_t l4OutSizeRaw;
	long l4InSize;
	SBArrayZValInfo piInBuffer;
	SBArrayZValInfo piOutBuffer;
	SBArrayZValInfo piProgressData;
	void *pzProgressFunc;
	zval *oContext;
	zval *oParams;
	zval *zl4OutSize;
	zval *zpInBuffer;
	zval *zpOutBuffer;
	zval *zpProgressData;
	zval *zProgressFunc;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!zlzzO!zz", &oContext, TElCustomCryptoContext_ce_ptr, &zpInBuffer, &l4InSize, &zpOutBuffer, &zl4OutSize, &oParams, TElRelativeDistinguishedName_ce_ptr, &zProgressFunc, &zpProgressData) == SUCCESS) && ((Z_TYPE_P(zpInBuffer) == IS_STRING) || (Z_TYPE_P(zpInBuffer) == IS_ARRAY) || (Z_TYPE_P(zpInBuffer) == IS_NULL) || ((Z_TYPE_P(zpInBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpInBuffer) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpOutBuffer) == IS_STRING) || (Z_TYPE_P(zpOutBuffer) == IS_ARRAY) || (Z_TYPE_P(zpOutBuffer) == IS_NULL) || ((Z_TYPE_P(zpOutBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpOutBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4OutSize) && (IS_LONG == Z_TYPE_P(zl4OutSize)) && ((IS_STRING == Z_TYPE_P(zProgressFunc)) || (IS_ARRAY == Z_TYPE_P(zProgressFunc)) || (IS_CALLABLE == Z_TYPE_P(zProgressFunc)) || (IS_NULL == Z_TYPE_P(zProgressFunc))) && ((Z_TYPE_P(zpProgressData) == IS_STRING) || (Z_TYPE_P(zpProgressData) == IS_ARRAY) || (Z_TYPE_P(zpProgressData) == IS_NULL) || ((Z_TYPE_P(zpProgressData) == IS_OBJECT) && (Z_OBJCE_P(zpProgressData) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpInBuffer, &piInBuffer TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpOutBuffer, &piOutBuffer TSRMLS_CC)) RETURN_FALSE;
		l4OutSizeRaw = (int32_t)Z_LVAL_P(zl4OutSize);
		pzProgressFunc = SBSetEventData(zProgressFunc TSRMLS_CC);
		if (!SBGetPointerFromZVal(zpProgressData, &piProgressData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElCustomCryptoProvider_SignUpdate(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oContext TSRMLS_CC), piInBuffer.data, (int32_t)l4InSize, piOutBuffer.data, &l4OutSizeRaw, SBGetObjectHandle(oParams TSRMLS_CC), pzProgressFunc ? &TSBProgressFuncRaw : NULL, pzProgressFunc, piProgressData.data) TSRMLS_CC);
		SBFreePointerZValInfo(&piInBuffer);
		SBFreePointerZValInfo(&piOutBuffer);
		ZVAL_LONG(zl4OutSize, (long)l4OutSizeRaw);
		SBFreePointerZValInfo(&piProgressData);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCryptoContext, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, &integer, TElRelativeDistinguishedName, TSBProgressFunc|callable|NULL, TSBPointer|array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCryptoProvider, VerifyUpdate)
{
	int32_t l4OutSizeRaw;
	long l4InSize;
	SBArrayZValInfo piInBuffer;
	SBArrayZValInfo piOutBuffer;
	SBArrayZValInfo piProgressData;
	void *pzProgressFunc;
	zval *oContext;
	zval *oParams;
	zval *zl4OutSize;
	zval *zpInBuffer;
	zval *zpOutBuffer;
	zval *zpProgressData;
	zval *zProgressFunc;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!zlzzO!zz", &oContext, TElCustomCryptoContext_ce_ptr, &zpInBuffer, &l4InSize, &zpOutBuffer, &zl4OutSize, &oParams, TElRelativeDistinguishedName_ce_ptr, &zProgressFunc, &zpProgressData) == SUCCESS) && ((Z_TYPE_P(zpInBuffer) == IS_STRING) || (Z_TYPE_P(zpInBuffer) == IS_ARRAY) || (Z_TYPE_P(zpInBuffer) == IS_NULL) || ((Z_TYPE_P(zpInBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpInBuffer) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpOutBuffer) == IS_STRING) || (Z_TYPE_P(zpOutBuffer) == IS_ARRAY) || (Z_TYPE_P(zpOutBuffer) == IS_NULL) || ((Z_TYPE_P(zpOutBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpOutBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4OutSize) && (IS_LONG == Z_TYPE_P(zl4OutSize)) && ((IS_STRING == Z_TYPE_P(zProgressFunc)) || (IS_ARRAY == Z_TYPE_P(zProgressFunc)) || (IS_CALLABLE == Z_TYPE_P(zProgressFunc)) || (IS_NULL == Z_TYPE_P(zProgressFunc))) && ((Z_TYPE_P(zpProgressData) == IS_STRING) || (Z_TYPE_P(zpProgressData) == IS_ARRAY) || (Z_TYPE_P(zpProgressData) == IS_NULL) || ((Z_TYPE_P(zpProgressData) == IS_OBJECT) && (Z_OBJCE_P(zpProgressData) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpInBuffer, &piInBuffer TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpOutBuffer, &piOutBuffer TSRMLS_CC)) RETURN_FALSE;
		l4OutSizeRaw = (int32_t)Z_LVAL_P(zl4OutSize);
		pzProgressFunc = SBSetEventData(zProgressFunc TSRMLS_CC);
		if (!SBGetPointerFromZVal(zpProgressData, &piProgressData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElCustomCryptoProvider_VerifyUpdate(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oContext TSRMLS_CC), piInBuffer.data, (int32_t)l4InSize, piOutBuffer.data, &l4OutSizeRaw, SBGetObjectHandle(oParams TSRMLS_CC), pzProgressFunc ? &TSBProgressFuncRaw : NULL, pzProgressFunc, piProgressData.data) TSRMLS_CC);
		SBFreePointerZValInfo(&piInBuffer);
		SBFreePointerZValInfo(&piOutBuffer);
		ZVAL_LONG(zl4OutSize, (long)l4OutSizeRaw);
		SBFreePointerZValInfo(&piProgressData);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCryptoContext, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, &integer, TElRelativeDistinguishedName, TSBProgressFunc|callable|NULL, TSBPointer|array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCryptoProvider, EncryptFinal)
{
	int32_t l4SizeRaw;
	SBArrayZValInfo piBuffer;
	SBArrayZValInfo piProgressData;
	void *pzProgressFunc;
	zval *oContext;
	zval *oParams;
	zval *zl4Size;
	zval *zpBuffer;
	zval *zpProgressData;
	zval *zProgressFunc;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!zzO!zz", &oContext, TElCustomCryptoContext_ce_ptr, &zpBuffer, &zl4Size, &oParams, TElRelativeDistinguishedName_ce_ptr, &zProgressFunc, &zpProgressData) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4Size) && (IS_LONG == Z_TYPE_P(zl4Size)) && ((IS_STRING == Z_TYPE_P(zProgressFunc)) || (IS_ARRAY == Z_TYPE_P(zProgressFunc)) || (IS_CALLABLE == Z_TYPE_P(zProgressFunc)) || (IS_NULL == Z_TYPE_P(zProgressFunc))) && ((Z_TYPE_P(zpProgressData) == IS_STRING) || (Z_TYPE_P(zpProgressData) == IS_ARRAY) || (Z_TYPE_P(zpProgressData) == IS_NULL) || ((Z_TYPE_P(zpProgressData) == IS_OBJECT) && (Z_OBJCE_P(zpProgressData) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		l4SizeRaw = (int32_t)Z_LVAL_P(zl4Size);
		pzProgressFunc = SBSetEventData(zProgressFunc TSRMLS_CC);
		if (!SBGetPointerFromZVal(zpProgressData, &piProgressData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElCustomCryptoProvider_EncryptFinal(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oContext TSRMLS_CC), piBuffer.data, &l4SizeRaw, SBGetObjectHandle(oParams TSRMLS_CC), pzProgressFunc ? &TSBProgressFuncRaw : NULL, pzProgressFunc, piProgressData.data) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
		ZVAL_LONG(zl4Size, (long)l4SizeRaw);
		SBFreePointerZValInfo(&piProgressData);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCryptoContext, TSBPointer|array of byte|string|NULL, &integer, TElRelativeDistinguishedName, TSBProgressFunc|callable|NULL, TSBPointer|array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCryptoProvider, DecryptFinal)
{
	int32_t l4SizeRaw;
	SBArrayZValInfo piBuffer;
	SBArrayZValInfo piProgressData;
	void *pzProgressFunc;
	zval *oContext;
	zval *oParams;
	zval *zl4Size;
	zval *zpBuffer;
	zval *zpProgressData;
	zval *zProgressFunc;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!zzO!zz", &oContext, TElCustomCryptoContext_ce_ptr, &zpBuffer, &zl4Size, &oParams, TElRelativeDistinguishedName_ce_ptr, &zProgressFunc, &zpProgressData) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4Size) && (IS_LONG == Z_TYPE_P(zl4Size)) && ((IS_STRING == Z_TYPE_P(zProgressFunc)) || (IS_ARRAY == Z_TYPE_P(zProgressFunc)) || (IS_CALLABLE == Z_TYPE_P(zProgressFunc)) || (IS_NULL == Z_TYPE_P(zProgressFunc))) && ((Z_TYPE_P(zpProgressData) == IS_STRING) || (Z_TYPE_P(zpProgressData) == IS_ARRAY) || (Z_TYPE_P(zpProgressData) == IS_NULL) || ((Z_TYPE_P(zpProgressData) == IS_OBJECT) && (Z_OBJCE_P(zpProgressData) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		l4SizeRaw = (int32_t)Z_LVAL_P(zl4Size);
		pzProgressFunc = SBSetEventData(zProgressFunc TSRMLS_CC);
		if (!SBGetPointerFromZVal(zpProgressData, &piProgressData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElCustomCryptoProvider_DecryptFinal(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oContext TSRMLS_CC), piBuffer.data, &l4SizeRaw, SBGetObjectHandle(oParams TSRMLS_CC), pzProgressFunc ? &TSBProgressFuncRaw : NULL, pzProgressFunc, piProgressData.data) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
		ZVAL_LONG(zl4Size, (long)l4SizeRaw);
		SBFreePointerZValInfo(&piProgressData);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCryptoContext, TSBPointer|array of byte|string|NULL, &integer, TElRelativeDistinguishedName, TSBProgressFunc|callable|NULL, TSBPointer|array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCryptoProvider, SignFinal)
{
	int32_t l4SizeRaw;
	SBArrayZValInfo piBuffer;
	SBArrayZValInfo piProgressData;
	void *pzProgressFunc;
	zval *oContext;
	zval *oParams;
	zval *zl4Size;
	zval *zpBuffer;
	zval *zpProgressData;
	zval *zProgressFunc;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!zzO!zz", &oContext, TElCustomCryptoContext_ce_ptr, &zpBuffer, &zl4Size, &oParams, TElRelativeDistinguishedName_ce_ptr, &zProgressFunc, &zpProgressData) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4Size) && (IS_LONG == Z_TYPE_P(zl4Size)) && ((IS_STRING == Z_TYPE_P(zProgressFunc)) || (IS_ARRAY == Z_TYPE_P(zProgressFunc)) || (IS_CALLABLE == Z_TYPE_P(zProgressFunc)) || (IS_NULL == Z_TYPE_P(zProgressFunc))) && ((Z_TYPE_P(zpProgressData) == IS_STRING) || (Z_TYPE_P(zpProgressData) == IS_ARRAY) || (Z_TYPE_P(zpProgressData) == IS_NULL) || ((Z_TYPE_P(zpProgressData) == IS_OBJECT) && (Z_OBJCE_P(zpProgressData) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		l4SizeRaw = (int32_t)Z_LVAL_P(zl4Size);
		pzProgressFunc = SBSetEventData(zProgressFunc TSRMLS_CC);
		if (!SBGetPointerFromZVal(zpProgressData, &piProgressData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElCustomCryptoProvider_SignFinal(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oContext TSRMLS_CC), piBuffer.data, &l4SizeRaw, SBGetObjectHandle(oParams TSRMLS_CC), pzProgressFunc ? &TSBProgressFuncRaw : NULL, pzProgressFunc, piProgressData.data) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
		ZVAL_LONG(zl4Size, (long)l4SizeRaw);
		SBFreePointerZValInfo(&piProgressData);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCryptoContext, TSBPointer|array of byte|string|NULL, &integer, TElRelativeDistinguishedName, TSBProgressFunc|callable|NULL, TSBPointer|array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCryptoProvider, VerifyFinal)
{
	int32_t l4SizeRaw;
	SBArrayZValInfo piBuffer;
	SBArrayZValInfo piProgressData;
	void *pzProgressFunc;
	zval *oContext;
	zval *oParams;
	zval *zl4Size;
	zval *zpBuffer;
	zval *zpProgressData;
	zval *zProgressFunc;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!zzO!zz", &oContext, TElCustomCryptoContext_ce_ptr, &zpBuffer, &zl4Size, &oParams, TElRelativeDistinguishedName_ce_ptr, &zProgressFunc, &zpProgressData) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4Size) && (IS_LONG == Z_TYPE_P(zl4Size)) && ((IS_STRING == Z_TYPE_P(zProgressFunc)) || (IS_ARRAY == Z_TYPE_P(zProgressFunc)) || (IS_CALLABLE == Z_TYPE_P(zProgressFunc)) || (IS_NULL == Z_TYPE_P(zProgressFunc))) && ((Z_TYPE_P(zpProgressData) == IS_STRING) || (Z_TYPE_P(zpProgressData) == IS_ARRAY) || (Z_TYPE_P(zpProgressData) == IS_NULL) || ((Z_TYPE_P(zpProgressData) == IS_OBJECT) && (Z_OBJCE_P(zpProgressData) == TSBPointer_ce_ptr))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		l4SizeRaw = (int32_t)Z_LVAL_P(zl4Size);
		pzProgressFunc = SBSetEventData(zProgressFunc TSRMLS_CC);
		if (!SBGetPointerFromZVal(zpProgressData, &piProgressData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElCustomCryptoProvider_VerifyFinal(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oContext TSRMLS_CC), piBuffer.data, &l4SizeRaw, SBGetObjectHandle(oParams TSRMLS_CC), pzProgressFunc ? &TSBProgressFuncRaw : NULL, pzProgressFunc, piProgressData.data, &l4OutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
		ZVAL_LONG(zl4Size, (long)l4SizeRaw);
		SBFreePointerZValInfo(&piProgressData);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCryptoContext, TSBPointer|array of byte|string|NULL, &integer, TElRelativeDistinguishedName, TSBProgressFunc|callable|NULL, TSBPointer|array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCryptoProvider, Encrypt)
{
	int32_t l4OutSizeRaw;
	long l4Algorithm;
	long l4InSize;
	long l4Mode;
	SBArrayZValInfo aiAlgOID;
	SBArrayZValInfo aiAlgParams;
	SBArrayZValInfo piInBuffer;
	SBArrayZValInfo piOutBuffer;
	SBArrayZValInfo piProgressData;
	void *pzProgressFunc;
	zval *oKey;
	zval *oParams;
	zval *zaAlgOID;
	zval *zaAlgParams;
	zval *zl4OutSize;
	zval *zpInBuffer;
	zval *zpOutBuffer;
	zval *zpProgressData;
	zval *zProgressFunc;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "llO!zlzzO!zz", &l4Algorithm, &l4Mode, &oKey, TElCustomCryptoKey_ce_ptr, &zpInBuffer, &l4InSize, &zpOutBuffer, &zl4OutSize, &oParams, TElRelativeDistinguishedName_ce_ptr, &zProgressFunc, &zpProgressData) == SUCCESS) && ((Z_TYPE_P(zpInBuffer) == IS_STRING) || (Z_TYPE_P(zpInBuffer) == IS_ARRAY) || (Z_TYPE_P(zpInBuffer) == IS_NULL) || ((Z_TYPE_P(zpInBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpInBuffer) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpOutBuffer) == IS_STRING) || (Z_TYPE_P(zpOutBuffer) == IS_ARRAY) || (Z_TYPE_P(zpOutBuffer) == IS_NULL) || ((Z_TYPE_P(zpOutBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpOutBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4OutSize) && (IS_LONG == Z_TYPE_P(zl4OutSize)) && ((IS_STRING == Z_TYPE_P(zProgressFunc)) || (IS_ARRAY == Z_TYPE_P(zProgressFunc)) || (IS_CALLABLE == Z_TYPE_P(zProgressFunc)) || (IS_NULL == Z_TYPE_P(zProgressFunc))) && ((Z_TYPE_P(zpProgressData) == IS_STRING) || (Z_TYPE_P(zpProgressData) == IS_ARRAY) || (Z_TYPE_P(zpProgressData) == IS_NULL) || ((Z_TYPE_P(zpProgressData) == IS_OBJECT) && (Z_OBJCE_P(zpProgressData) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpInBuffer, &piInBuffer TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpOutBuffer, &piOutBuffer TSRMLS_CC)) RETURN_FALSE;
		l4OutSizeRaw = (int32_t)Z_LVAL_P(zl4OutSize);
		pzProgressFunc = SBSetEventData(zProgressFunc TSRMLS_CC);
		if (!SBGetPointerFromZVal(zpProgressData, &piProgressData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElCustomCryptoProvider_Encrypt(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Algorithm, (int32_t)l4Mode, SBGetObjectHandle(oKey TSRMLS_CC), piInBuffer.data, (int32_t)l4InSize, piOutBuffer.data, &l4OutSizeRaw, SBGetObjectHandle(oParams TSRMLS_CC), pzProgressFunc ? &TSBProgressFuncRaw : NULL, pzProgressFunc, piProgressData.data) TSRMLS_CC);
		SBFreePointerZValInfo(&piInBuffer);
		SBFreePointerZValInfo(&piOutBuffer);
		ZVAL_LONG(zl4OutSize, (long)l4OutSizeRaw);
		SBFreePointerZValInfo(&piProgressData);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zzlO!zlzzO!zz", &zaAlgOID, &zaAlgParams, &l4Mode, &oKey, TElCustomCryptoKey_ce_ptr, &zpInBuffer, &l4InSize, &zpOutBuffer, &zl4OutSize, &oParams, TElRelativeDistinguishedName_ce_ptr, &zProgressFunc, &zpProgressData) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaAlgOID)) || (IS_ARRAY == Z_TYPE_P(zaAlgOID)) || (IS_NULL == Z_TYPE_P(zaAlgOID))) && ((IS_STRING == Z_TYPE_P(zaAlgParams)) || (IS_ARRAY == Z_TYPE_P(zaAlgParams)) || (IS_NULL == Z_TYPE_P(zaAlgParams))) && ((Z_TYPE_P(zpInBuffer) == IS_STRING) || (Z_TYPE_P(zpInBuffer) == IS_ARRAY) || (Z_TYPE_P(zpInBuffer) == IS_NULL) || ((Z_TYPE_P(zpInBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpInBuffer) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpOutBuffer) == IS_STRING) || (Z_TYPE_P(zpOutBuffer) == IS_ARRAY) || (Z_TYPE_P(zpOutBuffer) == IS_NULL) || ((Z_TYPE_P(zpOutBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpOutBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4OutSize) && (IS_LONG == Z_TYPE_P(zl4OutSize)) && ((IS_STRING == Z_TYPE_P(zProgressFunc)) || (IS_ARRAY == Z_TYPE_P(zProgressFunc)) || (IS_CALLABLE == Z_TYPE_P(zProgressFunc)) || (IS_NULL == Z_TYPE_P(zProgressFunc))) && ((Z_TYPE_P(zpProgressData) == IS_STRING) || (Z_TYPE_P(zpProgressData) == IS_ARRAY) || (Z_TYPE_P(zpProgressData) == IS_NULL) || ((Z_TYPE_P(zpProgressData) == IS_OBJECT) && (Z_OBJCE_P(zpProgressData) == TSBPointer_ce_ptr))))
	{
		if (!SBGetByteArrayFromZVal(zaAlgOID, &aiAlgOID TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaAlgParams, &aiAlgParams TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpInBuffer, &piInBuffer TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpOutBuffer, &piOutBuffer TSRMLS_CC)) RETURN_FALSE;
		l4OutSizeRaw = (int32_t)Z_LVAL_P(zl4OutSize);
		pzProgressFunc = SBSetEventData(zProgressFunc TSRMLS_CC);
		if (!SBGetPointerFromZVal(zpProgressData, &piProgressData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElCustomCryptoProvider_Encrypt_1(SBGetObjectHandle(getThis() TSRMLS_CC), aiAlgOID.data, aiAlgOID.len, aiAlgParams.data, aiAlgParams.len, (int32_t)l4Mode, SBGetObjectHandle(oKey TSRMLS_CC), piInBuffer.data, (int32_t)l4InSize, piOutBuffer.data, &l4OutSizeRaw, SBGetObjectHandle(oParams TSRMLS_CC), pzProgressFunc ? &TSBProgressFuncRaw : NULL, pzProgressFunc, piProgressData.data) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiAlgOID);
		SBFreeArrayZValInfo(&aiAlgParams);
		SBFreePointerZValInfo(&piInBuffer);
		SBFreePointerZValInfo(&piOutBuffer);
		ZVAL_LONG(zl4OutSize, (long)l4OutSizeRaw);
		SBFreePointerZValInfo(&piProgressData);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer, TElCustomCryptoKey, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, &integer, TElRelativeDistinguishedName, TSBProgressFunc|callable|NULL, TSBPointer|array of byte|string|NULL) or (array of byte|string|NULL, array of byte|string|NULL, integer, TElCustomCryptoKey, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, &integer, TElRelativeDistinguishedName, TSBProgressFunc|callable|NULL, TSBPointer|array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCryptoProvider, Decrypt)
{
	int32_t l4OutSizeRaw;
	long l4Algorithm;
	long l4InSize;
	long l4Mode;
	SBArrayZValInfo aiAlgOID;
	SBArrayZValInfo aiAlgParams;
	SBArrayZValInfo piInBuffer;
	SBArrayZValInfo piOutBuffer;
	SBArrayZValInfo piProgressData;
	void *pzProgressFunc;
	zval *oKey;
	zval *oParams;
	zval *zaAlgOID;
	zval *zaAlgParams;
	zval *zl4OutSize;
	zval *zpInBuffer;
	zval *zpOutBuffer;
	zval *zpProgressData;
	zval *zProgressFunc;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "llO!zlzzO!zz", &l4Algorithm, &l4Mode, &oKey, TElCustomCryptoKey_ce_ptr, &zpInBuffer, &l4InSize, &zpOutBuffer, &zl4OutSize, &oParams, TElRelativeDistinguishedName_ce_ptr, &zProgressFunc, &zpProgressData) == SUCCESS) && ((Z_TYPE_P(zpInBuffer) == IS_STRING) || (Z_TYPE_P(zpInBuffer) == IS_ARRAY) || (Z_TYPE_P(zpInBuffer) == IS_NULL) || ((Z_TYPE_P(zpInBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpInBuffer) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpOutBuffer) == IS_STRING) || (Z_TYPE_P(zpOutBuffer) == IS_ARRAY) || (Z_TYPE_P(zpOutBuffer) == IS_NULL) || ((Z_TYPE_P(zpOutBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpOutBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4OutSize) && (IS_LONG == Z_TYPE_P(zl4OutSize)) && ((IS_STRING == Z_TYPE_P(zProgressFunc)) || (IS_ARRAY == Z_TYPE_P(zProgressFunc)) || (IS_CALLABLE == Z_TYPE_P(zProgressFunc)) || (IS_NULL == Z_TYPE_P(zProgressFunc))) && ((Z_TYPE_P(zpProgressData) == IS_STRING) || (Z_TYPE_P(zpProgressData) == IS_ARRAY) || (Z_TYPE_P(zpProgressData) == IS_NULL) || ((Z_TYPE_P(zpProgressData) == IS_OBJECT) && (Z_OBJCE_P(zpProgressData) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpInBuffer, &piInBuffer TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpOutBuffer, &piOutBuffer TSRMLS_CC)) RETURN_FALSE;
		l4OutSizeRaw = (int32_t)Z_LVAL_P(zl4OutSize);
		pzProgressFunc = SBSetEventData(zProgressFunc TSRMLS_CC);
		if (!SBGetPointerFromZVal(zpProgressData, &piProgressData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElCustomCryptoProvider_Decrypt(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Algorithm, (int32_t)l4Mode, SBGetObjectHandle(oKey TSRMLS_CC), piInBuffer.data, (int32_t)l4InSize, piOutBuffer.data, &l4OutSizeRaw, SBGetObjectHandle(oParams TSRMLS_CC), pzProgressFunc ? &TSBProgressFuncRaw : NULL, pzProgressFunc, piProgressData.data) TSRMLS_CC);
		SBFreePointerZValInfo(&piInBuffer);
		SBFreePointerZValInfo(&piOutBuffer);
		ZVAL_LONG(zl4OutSize, (long)l4OutSizeRaw);
		SBFreePointerZValInfo(&piProgressData);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zzlO!zlzzO!zz", &zaAlgOID, &zaAlgParams, &l4Mode, &oKey, TElCustomCryptoKey_ce_ptr, &zpInBuffer, &l4InSize, &zpOutBuffer, &zl4OutSize, &oParams, TElRelativeDistinguishedName_ce_ptr, &zProgressFunc, &zpProgressData) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaAlgOID)) || (IS_ARRAY == Z_TYPE_P(zaAlgOID)) || (IS_NULL == Z_TYPE_P(zaAlgOID))) && ((IS_STRING == Z_TYPE_P(zaAlgParams)) || (IS_ARRAY == Z_TYPE_P(zaAlgParams)) || (IS_NULL == Z_TYPE_P(zaAlgParams))) && ((Z_TYPE_P(zpInBuffer) == IS_STRING) || (Z_TYPE_P(zpInBuffer) == IS_ARRAY) || (Z_TYPE_P(zpInBuffer) == IS_NULL) || ((Z_TYPE_P(zpInBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpInBuffer) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpOutBuffer) == IS_STRING) || (Z_TYPE_P(zpOutBuffer) == IS_ARRAY) || (Z_TYPE_P(zpOutBuffer) == IS_NULL) || ((Z_TYPE_P(zpOutBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpOutBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4OutSize) && (IS_LONG == Z_TYPE_P(zl4OutSize)) && ((IS_STRING == Z_TYPE_P(zProgressFunc)) || (IS_ARRAY == Z_TYPE_P(zProgressFunc)) || (IS_CALLABLE == Z_TYPE_P(zProgressFunc)) || (IS_NULL == Z_TYPE_P(zProgressFunc))) && ((Z_TYPE_P(zpProgressData) == IS_STRING) || (Z_TYPE_P(zpProgressData) == IS_ARRAY) || (Z_TYPE_P(zpProgressData) == IS_NULL) || ((Z_TYPE_P(zpProgressData) == IS_OBJECT) && (Z_OBJCE_P(zpProgressData) == TSBPointer_ce_ptr))))
	{
		if (!SBGetByteArrayFromZVal(zaAlgOID, &aiAlgOID TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaAlgParams, &aiAlgParams TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpInBuffer, &piInBuffer TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpOutBuffer, &piOutBuffer TSRMLS_CC)) RETURN_FALSE;
		l4OutSizeRaw = (int32_t)Z_LVAL_P(zl4OutSize);
		pzProgressFunc = SBSetEventData(zProgressFunc TSRMLS_CC);
		if (!SBGetPointerFromZVal(zpProgressData, &piProgressData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElCustomCryptoProvider_Decrypt_1(SBGetObjectHandle(getThis() TSRMLS_CC), aiAlgOID.data, aiAlgOID.len, aiAlgParams.data, aiAlgParams.len, (int32_t)l4Mode, SBGetObjectHandle(oKey TSRMLS_CC), piInBuffer.data, (int32_t)l4InSize, piOutBuffer.data, &l4OutSizeRaw, SBGetObjectHandle(oParams TSRMLS_CC), pzProgressFunc ? &TSBProgressFuncRaw : NULL, pzProgressFunc, piProgressData.data) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiAlgOID);
		SBFreeArrayZValInfo(&aiAlgParams);
		SBFreePointerZValInfo(&piInBuffer);
		SBFreePointerZValInfo(&piOutBuffer);
		ZVAL_LONG(zl4OutSize, (long)l4OutSizeRaw);
		SBFreePointerZValInfo(&piProgressData);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer, TElCustomCryptoKey, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, &integer, TElRelativeDistinguishedName, TSBProgressFunc|callable|NULL, TSBPointer|array of byte|string|NULL) or (array of byte|string|NULL, array of byte|string|NULL, integer, TElCustomCryptoKey, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, &integer, TElRelativeDistinguishedName, TSBProgressFunc|callable|NULL, TSBPointer|array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCryptoProvider, Sign)
{
	int32_t l4OutSizeRaw;
	long l4Algorithm;
	long l4InSize;
	SBArrayZValInfo aiAlgOID;
	SBArrayZValInfo aiAlgParams;
	SBArrayZValInfo piInBuffer;
	SBArrayZValInfo piOutBuffer;
	SBArrayZValInfo piProgressData;
	void *pzProgressFunc;
	zend_bool bDetached;
	zval *oKey;
	zval *oParams;
	zval *zaAlgOID;
	zval *zaAlgParams;
	zval *zl4OutSize;
	zval *zpInBuffer;
	zval *zpOutBuffer;
	zval *zpProgressData;
	zval *zProgressFunc;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lO!bzlzzO!zz", &l4Algorithm, &oKey, TElCustomCryptoKey_ce_ptr, &bDetached, &zpInBuffer, &l4InSize, &zpOutBuffer, &zl4OutSize, &oParams, TElRelativeDistinguishedName_ce_ptr, &zProgressFunc, &zpProgressData) == SUCCESS) && ((Z_TYPE_P(zpInBuffer) == IS_STRING) || (Z_TYPE_P(zpInBuffer) == IS_ARRAY) || (Z_TYPE_P(zpInBuffer) == IS_NULL) || ((Z_TYPE_P(zpInBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpInBuffer) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpOutBuffer) == IS_STRING) || (Z_TYPE_P(zpOutBuffer) == IS_ARRAY) || (Z_TYPE_P(zpOutBuffer) == IS_NULL) || ((Z_TYPE_P(zpOutBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpOutBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4OutSize) && (IS_LONG == Z_TYPE_P(zl4OutSize)) && ((IS_STRING == Z_TYPE_P(zProgressFunc)) || (IS_ARRAY == Z_TYPE_P(zProgressFunc)) || (IS_CALLABLE == Z_TYPE_P(zProgressFunc)) || (IS_NULL == Z_TYPE_P(zProgressFunc))) && ((Z_TYPE_P(zpProgressData) == IS_STRING) || (Z_TYPE_P(zpProgressData) == IS_ARRAY) || (Z_TYPE_P(zpProgressData) == IS_NULL) || ((Z_TYPE_P(zpProgressData) == IS_OBJECT) && (Z_OBJCE_P(zpProgressData) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpInBuffer, &piInBuffer TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpOutBuffer, &piOutBuffer TSRMLS_CC)) RETURN_FALSE;
		l4OutSizeRaw = (int32_t)Z_LVAL_P(zl4OutSize);
		pzProgressFunc = SBSetEventData(zProgressFunc TSRMLS_CC);
		if (!SBGetPointerFromZVal(zpProgressData, &piProgressData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElCustomCryptoProvider_Sign(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Algorithm, SBGetObjectHandle(oKey TSRMLS_CC), (int8_t)bDetached, piInBuffer.data, (int32_t)l4InSize, piOutBuffer.data, &l4OutSizeRaw, SBGetObjectHandle(oParams TSRMLS_CC), pzProgressFunc ? &TSBProgressFuncRaw : NULL, pzProgressFunc, piProgressData.data) TSRMLS_CC);
		SBFreePointerZValInfo(&piInBuffer);
		SBFreePointerZValInfo(&piOutBuffer);
		ZVAL_LONG(zl4OutSize, (long)l4OutSizeRaw);
		SBFreePointerZValInfo(&piProgressData);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zzO!bzlzzO!zz", &zaAlgOID, &zaAlgParams, &oKey, TElCustomCryptoKey_ce_ptr, &bDetached, &zpInBuffer, &l4InSize, &zpOutBuffer, &zl4OutSize, &oParams, TElRelativeDistinguishedName_ce_ptr, &zProgressFunc, &zpProgressData) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaAlgOID)) || (IS_ARRAY == Z_TYPE_P(zaAlgOID)) || (IS_NULL == Z_TYPE_P(zaAlgOID))) && ((IS_STRING == Z_TYPE_P(zaAlgParams)) || (IS_ARRAY == Z_TYPE_P(zaAlgParams)) || (IS_NULL == Z_TYPE_P(zaAlgParams))) && ((Z_TYPE_P(zpInBuffer) == IS_STRING) || (Z_TYPE_P(zpInBuffer) == IS_ARRAY) || (Z_TYPE_P(zpInBuffer) == IS_NULL) || ((Z_TYPE_P(zpInBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpInBuffer) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpOutBuffer) == IS_STRING) || (Z_TYPE_P(zpOutBuffer) == IS_ARRAY) || (Z_TYPE_P(zpOutBuffer) == IS_NULL) || ((Z_TYPE_P(zpOutBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpOutBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4OutSize) && (IS_LONG == Z_TYPE_P(zl4OutSize)) && ((IS_STRING == Z_TYPE_P(zProgressFunc)) || (IS_ARRAY == Z_TYPE_P(zProgressFunc)) || (IS_CALLABLE == Z_TYPE_P(zProgressFunc)) || (IS_NULL == Z_TYPE_P(zProgressFunc))) && ((Z_TYPE_P(zpProgressData) == IS_STRING) || (Z_TYPE_P(zpProgressData) == IS_ARRAY) || (Z_TYPE_P(zpProgressData) == IS_NULL) || ((Z_TYPE_P(zpProgressData) == IS_OBJECT) && (Z_OBJCE_P(zpProgressData) == TSBPointer_ce_ptr))))
	{
		if (!SBGetByteArrayFromZVal(zaAlgOID, &aiAlgOID TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaAlgParams, &aiAlgParams TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpInBuffer, &piInBuffer TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpOutBuffer, &piOutBuffer TSRMLS_CC)) RETURN_FALSE;
		l4OutSizeRaw = (int32_t)Z_LVAL_P(zl4OutSize);
		pzProgressFunc = SBSetEventData(zProgressFunc TSRMLS_CC);
		if (!SBGetPointerFromZVal(zpProgressData, &piProgressData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElCustomCryptoProvider_Sign_1(SBGetObjectHandle(getThis() TSRMLS_CC), aiAlgOID.data, aiAlgOID.len, aiAlgParams.data, aiAlgParams.len, SBGetObjectHandle(oKey TSRMLS_CC), (int8_t)bDetached, piInBuffer.data, (int32_t)l4InSize, piOutBuffer.data, &l4OutSizeRaw, SBGetObjectHandle(oParams TSRMLS_CC), pzProgressFunc ? &TSBProgressFuncRaw : NULL, pzProgressFunc, piProgressData.data) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiAlgOID);
		SBFreeArrayZValInfo(&aiAlgParams);
		SBFreePointerZValInfo(&piInBuffer);
		SBFreePointerZValInfo(&piOutBuffer);
		ZVAL_LONG(zl4OutSize, (long)l4OutSizeRaw);
		SBFreePointerZValInfo(&piProgressData);
	}
	else
	{
		SBErrorExpectsArguments("(integer, TElCustomCryptoKey, bool, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, &integer, TElRelativeDistinguishedName, TSBProgressFunc|callable|NULL, TSBPointer|array of byte|string|NULL) or (array of byte|string|NULL, array of byte|string|NULL, TElCustomCryptoKey, bool, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, &integer, TElRelativeDistinguishedName, TSBProgressFunc|callable|NULL, TSBPointer|array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCryptoProvider, Verify)
{
	int32_t l4OutSizeRaw;
	long l4Algorithm;
	long l4InSize;
	SBArrayZValInfo aiAlgOID;
	SBArrayZValInfo aiAlgParams;
	SBArrayZValInfo piInBuffer;
	SBArrayZValInfo piOutBuffer;
	SBArrayZValInfo piProgressData;
	void *pzProgressFunc;
	zval *oKey;
	zval *oParams;
	zval *zaAlgOID;
	zval *zaAlgParams;
	zval *zl4OutSize;
	zval *zpInBuffer;
	zval *zpOutBuffer;
	zval *zpProgressData;
	zval *zProgressFunc;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lO!zlzzO!zz", &l4Algorithm, &oKey, TElCustomCryptoKey_ce_ptr, &zpInBuffer, &l4InSize, &zpOutBuffer, &zl4OutSize, &oParams, TElRelativeDistinguishedName_ce_ptr, &zProgressFunc, &zpProgressData) == SUCCESS) && ((Z_TYPE_P(zpInBuffer) == IS_STRING) || (Z_TYPE_P(zpInBuffer) == IS_ARRAY) || (Z_TYPE_P(zpInBuffer) == IS_NULL) || ((Z_TYPE_P(zpInBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpInBuffer) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpOutBuffer) == IS_STRING) || (Z_TYPE_P(zpOutBuffer) == IS_ARRAY) || (Z_TYPE_P(zpOutBuffer) == IS_NULL) || ((Z_TYPE_P(zpOutBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpOutBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4OutSize) && (IS_LONG == Z_TYPE_P(zl4OutSize)) && ((IS_STRING == Z_TYPE_P(zProgressFunc)) || (IS_ARRAY == Z_TYPE_P(zProgressFunc)) || (IS_CALLABLE == Z_TYPE_P(zProgressFunc)) || (IS_NULL == Z_TYPE_P(zProgressFunc))) && ((Z_TYPE_P(zpProgressData) == IS_STRING) || (Z_TYPE_P(zpProgressData) == IS_ARRAY) || (Z_TYPE_P(zpProgressData) == IS_NULL) || ((Z_TYPE_P(zpProgressData) == IS_OBJECT) && (Z_OBJCE_P(zpProgressData) == TSBPointer_ce_ptr))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpInBuffer, &piInBuffer TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpOutBuffer, &piOutBuffer TSRMLS_CC)) RETURN_FALSE;
		l4OutSizeRaw = (int32_t)Z_LVAL_P(zl4OutSize);
		pzProgressFunc = SBSetEventData(zProgressFunc TSRMLS_CC);
		if (!SBGetPointerFromZVal(zpProgressData, &piProgressData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElCustomCryptoProvider_Verify(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Algorithm, SBGetObjectHandle(oKey TSRMLS_CC), piInBuffer.data, (int32_t)l4InSize, piOutBuffer.data, &l4OutSizeRaw, SBGetObjectHandle(oParams TSRMLS_CC), pzProgressFunc ? &TSBProgressFuncRaw : NULL, pzProgressFunc, piProgressData.data, &l4OutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piInBuffer);
		SBFreePointerZValInfo(&piOutBuffer);
		ZVAL_LONG(zl4OutSize, (long)l4OutSizeRaw);
		SBFreePointerZValInfo(&piProgressData);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zzO!zlzzO!zz", &zaAlgOID, &zaAlgParams, &oKey, TElCustomCryptoKey_ce_ptr, &zpInBuffer, &l4InSize, &zpOutBuffer, &zl4OutSize, &oParams, TElRelativeDistinguishedName_ce_ptr, &zProgressFunc, &zpProgressData) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaAlgOID)) || (IS_ARRAY == Z_TYPE_P(zaAlgOID)) || (IS_NULL == Z_TYPE_P(zaAlgOID))) && ((IS_STRING == Z_TYPE_P(zaAlgParams)) || (IS_ARRAY == Z_TYPE_P(zaAlgParams)) || (IS_NULL == Z_TYPE_P(zaAlgParams))) && ((Z_TYPE_P(zpInBuffer) == IS_STRING) || (Z_TYPE_P(zpInBuffer) == IS_ARRAY) || (Z_TYPE_P(zpInBuffer) == IS_NULL) || ((Z_TYPE_P(zpInBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpInBuffer) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpOutBuffer) == IS_STRING) || (Z_TYPE_P(zpOutBuffer) == IS_ARRAY) || (Z_TYPE_P(zpOutBuffer) == IS_NULL) || ((Z_TYPE_P(zpOutBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpOutBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4OutSize) && (IS_LONG == Z_TYPE_P(zl4OutSize)) && ((IS_STRING == Z_TYPE_P(zProgressFunc)) || (IS_ARRAY == Z_TYPE_P(zProgressFunc)) || (IS_CALLABLE == Z_TYPE_P(zProgressFunc)) || (IS_NULL == Z_TYPE_P(zProgressFunc))) && ((Z_TYPE_P(zpProgressData) == IS_STRING) || (Z_TYPE_P(zpProgressData) == IS_ARRAY) || (Z_TYPE_P(zpProgressData) == IS_NULL) || ((Z_TYPE_P(zpProgressData) == IS_OBJECT) && (Z_OBJCE_P(zpProgressData) == TSBPointer_ce_ptr))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaAlgOID, &aiAlgOID TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaAlgParams, &aiAlgParams TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpInBuffer, &piInBuffer TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpOutBuffer, &piOutBuffer TSRMLS_CC)) RETURN_FALSE;
		l4OutSizeRaw = (int32_t)Z_LVAL_P(zl4OutSize);
		pzProgressFunc = SBSetEventData(zProgressFunc TSRMLS_CC);
		if (!SBGetPointerFromZVal(zpProgressData, &piProgressData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElCustomCryptoProvider_Verify_1(SBGetObjectHandle(getThis() TSRMLS_CC), aiAlgOID.data, aiAlgOID.len, aiAlgParams.data, aiAlgParams.len, SBGetObjectHandle(oKey TSRMLS_CC), piInBuffer.data, (int32_t)l4InSize, piOutBuffer.data, &l4OutSizeRaw, SBGetObjectHandle(oParams TSRMLS_CC), pzProgressFunc ? &TSBProgressFuncRaw : NULL, pzProgressFunc, piProgressData.data, &l4OutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiAlgOID);
		SBFreeArrayZValInfo(&aiAlgParams);
		SBFreePointerZValInfo(&piInBuffer);
		SBFreePointerZValInfo(&piOutBuffer);
		ZVAL_LONG(zl4OutSize, (long)l4OutSizeRaw);
		SBFreePointerZValInfo(&piProgressData);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer, TElCustomCryptoKey, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, &integer, TElRelativeDistinguishedName, TSBProgressFunc|callable|NULL, TSBPointer|array of byte|string|NULL) or (array of byte|string|NULL, array of byte|string|NULL, TElCustomCryptoKey, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, &integer, TElRelativeDistinguishedName, TSBProgressFunc|callable|NULL, TSBPointer|array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCryptoProvider, VerifyDetached)
{
	long l4Algorithm;
	long l4InSize;
	long l4SigSize;
	SBArrayZValInfo aiAlgOID;
	SBArrayZValInfo aiAlgParams;
	SBArrayZValInfo piInBuffer;
	SBArrayZValInfo piProgressData;
	SBArrayZValInfo piSigBuffer;
	void *pzProgressFunc;
	zval *oKey;
	zval *oParams;
	zval *zaAlgOID;
	zval *zaAlgParams;
	zval *zpInBuffer;
	zval *zpProgressData;
	zval *zProgressFunc;
	zval *zpSigBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lO!zlzlO!zz", &l4Algorithm, &oKey, TElCustomCryptoKey_ce_ptr, &zpInBuffer, &l4InSize, &zpSigBuffer, &l4SigSize, &oParams, TElRelativeDistinguishedName_ce_ptr, &zProgressFunc, &zpProgressData) == SUCCESS) && ((Z_TYPE_P(zpInBuffer) == IS_STRING) || (Z_TYPE_P(zpInBuffer) == IS_ARRAY) || (Z_TYPE_P(zpInBuffer) == IS_NULL) || ((Z_TYPE_P(zpInBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpInBuffer) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpSigBuffer) == IS_STRING) || (Z_TYPE_P(zpSigBuffer) == IS_ARRAY) || (Z_TYPE_P(zpSigBuffer) == IS_NULL) || ((Z_TYPE_P(zpSigBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpSigBuffer) == TSBPointer_ce_ptr))) && ((IS_STRING == Z_TYPE_P(zProgressFunc)) || (IS_ARRAY == Z_TYPE_P(zProgressFunc)) || (IS_CALLABLE == Z_TYPE_P(zProgressFunc)) || (IS_NULL == Z_TYPE_P(zProgressFunc))) && ((Z_TYPE_P(zpProgressData) == IS_STRING) || (Z_TYPE_P(zpProgressData) == IS_ARRAY) || (Z_TYPE_P(zpProgressData) == IS_NULL) || ((Z_TYPE_P(zpProgressData) == IS_OBJECT) && (Z_OBJCE_P(zpProgressData) == TSBPointer_ce_ptr))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpInBuffer, &piInBuffer TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpSigBuffer, &piSigBuffer TSRMLS_CC)) RETURN_FALSE;
		pzProgressFunc = SBSetEventData(zProgressFunc TSRMLS_CC);
		if (!SBGetPointerFromZVal(zpProgressData, &piProgressData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElCustomCryptoProvider_VerifyDetached(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Algorithm, SBGetObjectHandle(oKey TSRMLS_CC), piInBuffer.data, (int32_t)l4InSize, piSigBuffer.data, (int32_t)l4SigSize, SBGetObjectHandle(oParams TSRMLS_CC), pzProgressFunc ? &TSBProgressFuncRaw : NULL, pzProgressFunc, piProgressData.data, &l4OutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piInBuffer);
		SBFreePointerZValInfo(&piSigBuffer);
		SBFreePointerZValInfo(&piProgressData);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zzO!zlzlO!zz", &zaAlgOID, &zaAlgParams, &oKey, TElCustomCryptoKey_ce_ptr, &zpInBuffer, &l4InSize, &zpSigBuffer, &l4SigSize, &oParams, TElRelativeDistinguishedName_ce_ptr, &zProgressFunc, &zpProgressData) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaAlgOID)) || (IS_ARRAY == Z_TYPE_P(zaAlgOID)) || (IS_NULL == Z_TYPE_P(zaAlgOID))) && ((IS_STRING == Z_TYPE_P(zaAlgParams)) || (IS_ARRAY == Z_TYPE_P(zaAlgParams)) || (IS_NULL == Z_TYPE_P(zaAlgParams))) && ((Z_TYPE_P(zpInBuffer) == IS_STRING) || (Z_TYPE_P(zpInBuffer) == IS_ARRAY) || (Z_TYPE_P(zpInBuffer) == IS_NULL) || ((Z_TYPE_P(zpInBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpInBuffer) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpSigBuffer) == IS_STRING) || (Z_TYPE_P(zpSigBuffer) == IS_ARRAY) || (Z_TYPE_P(zpSigBuffer) == IS_NULL) || ((Z_TYPE_P(zpSigBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpSigBuffer) == TSBPointer_ce_ptr))) && ((IS_STRING == Z_TYPE_P(zProgressFunc)) || (IS_ARRAY == Z_TYPE_P(zProgressFunc)) || (IS_CALLABLE == Z_TYPE_P(zProgressFunc)) || (IS_NULL == Z_TYPE_P(zProgressFunc))) && ((Z_TYPE_P(zpProgressData) == IS_STRING) || (Z_TYPE_P(zpProgressData) == IS_ARRAY) || (Z_TYPE_P(zpProgressData) == IS_NULL) || ((Z_TYPE_P(zpProgressData) == IS_OBJECT) && (Z_OBJCE_P(zpProgressData) == TSBPointer_ce_ptr))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaAlgOID, &aiAlgOID TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaAlgParams, &aiAlgParams TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpInBuffer, &piInBuffer TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpSigBuffer, &piSigBuffer TSRMLS_CC)) RETURN_FALSE;
		pzProgressFunc = SBSetEventData(zProgressFunc TSRMLS_CC);
		if (!SBGetPointerFromZVal(zpProgressData, &piProgressData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElCustomCryptoProvider_VerifyDetached_1(SBGetObjectHandle(getThis() TSRMLS_CC), aiAlgOID.data, aiAlgOID.len, aiAlgParams.data, aiAlgParams.len, SBGetObjectHandle(oKey TSRMLS_CC), piInBuffer.data, (int32_t)l4InSize, piSigBuffer.data, (int32_t)l4SigSize, SBGetObjectHandle(oParams TSRMLS_CC), pzProgressFunc ? &TSBProgressFuncRaw : NULL, pzProgressFunc, piProgressData.data, &l4OutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiAlgOID);
		SBFreeArrayZValInfo(&aiAlgParams);
		SBFreePointerZValInfo(&piInBuffer);
		SBFreePointerZValInfo(&piSigBuffer);
		SBFreePointerZValInfo(&piProgressData);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer, TElCustomCryptoKey, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer, TElRelativeDistinguishedName, TSBProgressFunc|callable|NULL, TSBPointer|array of byte|string|NULL) or (array of byte|string|NULL, array of byte|string|NULL, TElCustomCryptoKey, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer, TElRelativeDistinguishedName, TSBProgressFunc|callable|NULL, TSBPointer|array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCryptoProvider, HashInit)
{
	long l4Algorithm;
	SBArrayZValInfo aiAlgOID;
	SBArrayZValInfo aiAlgParams;
	SBArrayZValInfo piProgressData;
	void *pzProgressFunc;
	zval *oKey;
	zval *oParams;
	zval *zaAlgOID;
	zval *zaAlgParams;
	zval *zpProgressData;
	zval *zProgressFunc;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lO!O!zz", &l4Algorithm, &oKey, TElCustomCryptoKey_ce_ptr, &oParams, TElRelativeDistinguishedName_ce_ptr, &zProgressFunc, &zpProgressData) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zProgressFunc)) || (IS_ARRAY == Z_TYPE_P(zProgressFunc)) || (IS_CALLABLE == Z_TYPE_P(zProgressFunc)) || (IS_NULL == Z_TYPE_P(zProgressFunc))) && ((Z_TYPE_P(zpProgressData) == IS_STRING) || (Z_TYPE_P(zpProgressData) == IS_ARRAY) || (Z_TYPE_P(zpProgressData) == IS_NULL) || ((Z_TYPE_P(zpProgressData) == IS_OBJECT) && (Z_OBJCE_P(zpProgressData) == TSBPointer_ce_ptr))))
	{
		TElClassHandle hoOutResult = NULL;
		pzProgressFunc = SBSetEventData(zProgressFunc TSRMLS_CC);
		if (!SBGetPointerFromZVal(zpProgressData, &piProgressData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElCustomCryptoProvider_HashInit(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Algorithm, SBGetObjectHandle(oKey TSRMLS_CC), SBGetObjectHandle(oParams TSRMLS_CC), pzProgressFunc ? &TSBProgressFuncRaw : NULL, pzProgressFunc, piProgressData.data, &hoOutResult) TSRMLS_CC);
		SBFreePointerZValInfo(&piProgressData);
		SBInitObject(return_value, TElCustomCryptoContext_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zzO!O!zz", &zaAlgOID, &zaAlgParams, &oKey, TElCustomCryptoKey_ce_ptr, &oParams, TElRelativeDistinguishedName_ce_ptr, &zProgressFunc, &zpProgressData) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaAlgOID)) || (IS_ARRAY == Z_TYPE_P(zaAlgOID)) || (IS_NULL == Z_TYPE_P(zaAlgOID))) && ((IS_STRING == Z_TYPE_P(zaAlgParams)) || (IS_ARRAY == Z_TYPE_P(zaAlgParams)) || (IS_NULL == Z_TYPE_P(zaAlgParams))) && ((IS_STRING == Z_TYPE_P(zProgressFunc)) || (IS_ARRAY == Z_TYPE_P(zProgressFunc)) || (IS_CALLABLE == Z_TYPE_P(zProgressFunc)) || (IS_NULL == Z_TYPE_P(zProgressFunc))) && ((Z_TYPE_P(zpProgressData) == IS_STRING) || (Z_TYPE_P(zpProgressData) == IS_ARRAY) || (Z_TYPE_P(zpProgressData) == IS_NULL) || ((Z_TYPE_P(zpProgressData) == IS_OBJECT) && (Z_OBJCE_P(zpProgressData) == TSBPointer_ce_ptr))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetByteArrayFromZVal(zaAlgOID, &aiAlgOID TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaAlgParams, &aiAlgParams TSRMLS_CC)) RETURN_FALSE;
		pzProgressFunc = SBSetEventData(zProgressFunc TSRMLS_CC);
		if (!SBGetPointerFromZVal(zpProgressData, &piProgressData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElCustomCryptoProvider_HashInit_1(SBGetObjectHandle(getThis() TSRMLS_CC), aiAlgOID.data, aiAlgOID.len, aiAlgParams.data, aiAlgParams.len, SBGetObjectHandle(oKey TSRMLS_CC), SBGetObjectHandle(oParams TSRMLS_CC), pzProgressFunc ? &TSBProgressFuncRaw : NULL, pzProgressFunc, piProgressData.data, &hoOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiAlgOID);
		SBFreeArrayZValInfo(&aiAlgParams);
		SBFreePointerZValInfo(&piProgressData);
		SBInitObject(return_value, TElCustomCryptoContext_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, TElCustomCryptoKey, TElRelativeDistinguishedName, TSBProgressFunc|callable|NULL, TSBPointer|array of byte|string|NULL) or (array of byte|string|NULL, array of byte|string|NULL, TElCustomCryptoKey, TElRelativeDistinguishedName, TSBProgressFunc|callable|NULL, TSBPointer|array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCryptoProvider, HashFinal)
{
	SBArrayZValInfo piProgressData;
	uint32_t _err;
	void *pzProgressFunc;
	zval *oContext;
	zval *oParams;
	zval *zpProgressData;
	zval *zProgressFunc;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!zz", &oContext, TElCustomCryptoContext_ce_ptr, &oParams, TElRelativeDistinguishedName_ce_ptr, &zProgressFunc, &zpProgressData) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zProgressFunc)) || (IS_ARRAY == Z_TYPE_P(zProgressFunc)) || (IS_CALLABLE == Z_TYPE_P(zProgressFunc)) || (IS_NULL == Z_TYPE_P(zProgressFunc))) && ((Z_TYPE_P(zpProgressData) == IS_STRING) || (Z_TYPE_P(zpProgressData) == IS_ARRAY) || (Z_TYPE_P(zpProgressData) == IS_NULL) || ((Z_TYPE_P(zpProgressData) == IS_OBJECT) && (Z_OBJCE_P(zpProgressData) == TSBPointer_ce_ptr))))
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		pzProgressFunc = SBSetEventData(zProgressFunc TSRMLS_CC);
		if (!SBGetPointerFromZVal(zpProgressData, &piProgressData TSRMLS_CC)) RETURN_FALSE;
		_err = TElCustomCryptoProvider_HashFinal(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oContext TSRMLS_CC), SBGetObjectHandle(oParams TSRMLS_CC), pzProgressFunc ? &TSBProgressFuncRaw : NULL, pzProgressFunc, piProgressData.data, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(732132555, 5, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreePointerZValInfo(&piProgressData);
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCryptoContext, TElRelativeDistinguishedName, TSBProgressFunc|callable|NULL, TSBPointer|array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCryptoProvider, HashUpdate)
{
	long l4Size;
	SBArrayZValInfo piBuffer;
	SBArrayZValInfo piProgressData;
	void *pzProgressFunc;
	zval *oContext;
	zval *oParams;
	zval *zpBuffer;
	zval *zpProgressData;
	zval *zProgressFunc;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!zlO!zz", &oContext, TElCustomCryptoContext_ce_ptr, &zpBuffer, &l4Size, &oParams, TElRelativeDistinguishedName_ce_ptr, &zProgressFunc, &zpProgressData) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))) && ((IS_STRING == Z_TYPE_P(zProgressFunc)) || (IS_ARRAY == Z_TYPE_P(zProgressFunc)) || (IS_CALLABLE == Z_TYPE_P(zProgressFunc)) || (IS_NULL == Z_TYPE_P(zProgressFunc))) && ((Z_TYPE_P(zpProgressData) == IS_STRING) || (Z_TYPE_P(zpProgressData) == IS_ARRAY) || (Z_TYPE_P(zpProgressData) == IS_NULL) || ((Z_TYPE_P(zpProgressData) == IS_OBJECT) && (Z_OBJCE_P(zpProgressData) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		pzProgressFunc = SBSetEventData(zProgressFunc TSRMLS_CC);
		if (!SBGetPointerFromZVal(zpProgressData, &piProgressData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElCustomCryptoProvider_HashUpdate(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oContext TSRMLS_CC), piBuffer.data, (int32_t)l4Size, SBGetObjectHandle(oParams TSRMLS_CC), pzProgressFunc ? &TSBProgressFuncRaw : NULL, pzProgressFunc, piProgressData.data) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
		SBFreePointerZValInfo(&piProgressData);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCryptoContext, TSBPointer|array of byte|string|NULL, integer, TElRelativeDistinguishedName, TSBProgressFunc|callable|NULL, TSBPointer|array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCryptoProvider, Hash)
{
	long l4Algorithm;
	long l4Size;
	SBArrayZValInfo aiAlgOID;
	SBArrayZValInfo aiAlgParams;
	SBArrayZValInfo piBuffer;
	SBArrayZValInfo piProgressData;
	uint32_t _err;
	void *pzProgressFunc;
	zval *oKey;
	zval *oParams;
	zval *zaAlgOID;
	zval *zaAlgParams;
	zval *zpBuffer;
	zval *zpProgressData;
	zval *zProgressFunc;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lO!zlO!zz", &l4Algorithm, &oKey, TElCustomCryptoKey_ce_ptr, &zpBuffer, &l4Size, &oParams, TElRelativeDistinguishedName_ce_ptr, &zProgressFunc, &zpProgressData) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))) && ((IS_STRING == Z_TYPE_P(zProgressFunc)) || (IS_ARRAY == Z_TYPE_P(zProgressFunc)) || (IS_CALLABLE == Z_TYPE_P(zProgressFunc)) || (IS_NULL == Z_TYPE_P(zProgressFunc))) && ((Z_TYPE_P(zpProgressData) == IS_STRING) || (Z_TYPE_P(zpProgressData) == IS_ARRAY) || (Z_TYPE_P(zpProgressData) == IS_NULL) || ((Z_TYPE_P(zpProgressData) == IS_OBJECT) && (Z_OBJCE_P(zpProgressData) == TSBPointer_ce_ptr))))
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		pzProgressFunc = SBSetEventData(zProgressFunc TSRMLS_CC);
		if (!SBGetPointerFromZVal(zpProgressData, &piProgressData TSRMLS_CC)) RETURN_FALSE;
		_err = TElCustomCryptoProvider_Hash(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Algorithm, SBGetObjectHandle(oKey TSRMLS_CC), piBuffer.data, (int32_t)l4Size, SBGetObjectHandle(oParams TSRMLS_CC), pzProgressFunc ? &TSBProgressFuncRaw : NULL, pzProgressFunc, piProgressData.data, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-1837494766, 8, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreePointerZValInfo(&piBuffer);
		SBFreePointerZValInfo(&piProgressData);
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zzO!zlO!zz", &zaAlgOID, &zaAlgParams, &oKey, TElCustomCryptoKey_ce_ptr, &zpBuffer, &l4Size, &oParams, TElRelativeDistinguishedName_ce_ptr, &zProgressFunc, &zpProgressData) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaAlgOID)) || (IS_ARRAY == Z_TYPE_P(zaAlgOID)) || (IS_NULL == Z_TYPE_P(zaAlgOID))) && ((IS_STRING == Z_TYPE_P(zaAlgParams)) || (IS_ARRAY == Z_TYPE_P(zaAlgParams)) || (IS_NULL == Z_TYPE_P(zaAlgParams))) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))) && ((IS_STRING == Z_TYPE_P(zProgressFunc)) || (IS_ARRAY == Z_TYPE_P(zProgressFunc)) || (IS_CALLABLE == Z_TYPE_P(zProgressFunc)) || (IS_NULL == Z_TYPE_P(zProgressFunc))) && ((Z_TYPE_P(zpProgressData) == IS_STRING) || (Z_TYPE_P(zpProgressData) == IS_ARRAY) || (Z_TYPE_P(zpProgressData) == IS_NULL) || ((Z_TYPE_P(zpProgressData) == IS_OBJECT) && (Z_OBJCE_P(zpProgressData) == TSBPointer_ce_ptr))))
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		if (!SBGetByteArrayFromZVal(zaAlgOID, &aiAlgOID TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaAlgParams, &aiAlgParams TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		pzProgressFunc = SBSetEventData(zProgressFunc TSRMLS_CC);
		if (!SBGetPointerFromZVal(zpProgressData, &piProgressData TSRMLS_CC)) RETURN_FALSE;
		_err = TElCustomCryptoProvider_Hash_1(SBGetObjectHandle(getThis() TSRMLS_CC), aiAlgOID.data, aiAlgOID.len, aiAlgParams.data, aiAlgParams.len, SBGetObjectHandle(oKey TSRMLS_CC), piBuffer.data, (int32_t)l4Size, SBGetObjectHandle(oParams TSRMLS_CC), pzProgressFunc ? &TSBProgressFuncRaw : NULL, pzProgressFunc, piProgressData.data, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(842125541, 9, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiAlgOID);
		SBFreeArrayZValInfo(&aiAlgParams);
		SBFreePointerZValInfo(&piBuffer);
		SBFreePointerZValInfo(&piProgressData);
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(integer, TElCustomCryptoKey, TSBPointer|array of byte|string|NULL, integer, TElRelativeDistinguishedName, TSBProgressFunc|callable|NULL, TSBPointer|array of byte|string|NULL) or (array of byte|string|NULL, array of byte|string|NULL, TElCustomCryptoKey, TSBPointer|array of byte|string|NULL, integer, TElRelativeDistinguishedName, TSBProgressFunc|callable|NULL, TSBPointer|array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCryptoProvider, ReleaseCryptoContext)
{
	TElClassHandle hoContext;
	zval *oContext;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &oContext, TElCustomCryptoContext_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oContext) && (IS_OBJECT == Z_TYPE_P(oContext)))
	{
		hoContext = SBGetObjectHandle(oContext TSRMLS_CC);
		SBCheckError(TElCustomCryptoProvider_ReleaseCryptoContext(SBGetObjectHandle(getThis() TSRMLS_CC), &hoContext) TSRMLS_CC);
		SBUpdateObjectHandle(oContext, hoContext TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(&TElCustomCryptoContext)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCryptoProvider, RandomInit)
{
	long l4BaseDataSize;
	SBArrayZValInfo piBaseData;
	zval *oParams;
	zval *zpBaseData;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlO!", &zpBaseData, &l4BaseDataSize, &oParams, TElRelativeDistinguishedName_ce_ptr) == SUCCESS) && ((Z_TYPE_P(zpBaseData) == IS_STRING) || (Z_TYPE_P(zpBaseData) == IS_ARRAY) || (Z_TYPE_P(zpBaseData) == IS_NULL) || ((Z_TYPE_P(zpBaseData) == IS_OBJECT) && (Z_OBJCE_P(zpBaseData) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpBaseData, &piBaseData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElCustomCryptoProvider_RandomInit(SBGetObjectHandle(getThis() TSRMLS_CC), piBaseData.data, (int32_t)l4BaseDataSize, SBGetObjectHandle(oParams TSRMLS_CC)) TSRMLS_CC);
		SBFreePointerZValInfo(&piBaseData);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer, TElRelativeDistinguishedName)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCryptoProvider, RandomSeed)
{
	long l4DataSize;
	SBArrayZValInfo piData;
	zval *zpData;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zpData, &l4DataSize) == SUCCESS) && ((Z_TYPE_P(zpData) == IS_STRING) || (Z_TYPE_P(zpData) == IS_ARRAY) || (Z_TYPE_P(zpData) == IS_NULL) || ((Z_TYPE_P(zpData) == IS_OBJECT) && (Z_OBJCE_P(zpData) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpData, &piData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElCustomCryptoProvider_RandomSeed(SBGetObjectHandle(getThis() TSRMLS_CC), piData.data, (int32_t)l4DataSize) TSRMLS_CC);
		SBFreePointerZValInfo(&piData);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCryptoProvider, RandomGenerate)
{
	long l4MaxValue;
	long l4Size;
	SBArrayZValInfo piBuffer;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zpBuffer, &l4Size) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElCustomCryptoProvider_RandomGenerate(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, (int32_t)l4Size) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4MaxValue) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElCustomCryptoProvider_RandomGenerate_1(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4MaxValue, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer) or (integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCryptoProvider, OwnsObject)
{
	zval *oObj;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oObj, TObject_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElCustomCryptoProvider_OwnsObject(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObj TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TObject)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCryptoProvider, ClassType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCustomCryptoProvider_ClassType(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TClass_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCryptoProvider, get_Options)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCustomCryptoProvider_get_Options(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomCryptoProviderOptions_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCryptoProvider, get_Enabled)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElCustomCryptoProvider_get_Enabled(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCryptoProvider, set_Enabled)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElCustomCryptoProvider_set_Enabled(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCryptoProvider, get_CryptoProviderManager)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCustomCryptoProvider_get_CryptoProviderManager(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomCryptoProviderManager_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCryptoProvider, set_CryptoProviderManager)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElCustomCryptoProviderManager_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElCustomCryptoProvider_set_CryptoProviderManager(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCryptoProviderManager)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCryptoProvider, get_OnCreateObject)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBCryptoProviderObjectEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElCustomCryptoProvider_get_OnCreateObject(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCryptoProvider, set_OnCreateObject)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElCustomCryptoProvider_set_OnCreateObject(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBCryptoProviderObjectEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBCryptoProviderObjectEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCryptoProvider, get_OnDestroyObject)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBCryptoProviderObjectEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElCustomCryptoProvider_get_OnDestroyObject(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCryptoProvider, set_OnDestroyObject)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElCustomCryptoProvider_set_OnDestroyObject(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBCryptoProviderObjectEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBCryptoProviderObjectEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCryptoProvider, __construct)
{
	zval *oAOwner;
	zval *oOptions;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCustomCryptoProvider_Create(SBGetObjectHandle(oAOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oOptions, TElCustomCryptoProviderOptions_ce_ptr, &oAOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCustomCryptoProvider_Create_1(SBGetObjectHandle(oOptions TSRMLS_CC), SBGetObjectHandle(oAOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent) or (TElCustomCryptoProviderOptions, TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCryptoProvider_Init, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCryptoProvider_Deinit, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCryptoProvider_SetAsDefault_Inst, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCryptoProvider_SetAsDefault, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCryptoProvider_GetDefaultInstance, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCryptoProvider_Clone, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCryptoProvider_IsAlgorithmSupported, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Algorithm_or_AlgOID, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Mode_or_AlgParams, 0, 1)
	ZEND_ARG_INFO(0, Mode)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCryptoProvider_IsOperationSupported, 0, 0, 5)
	ZEND_ARG_INFO(0, Operation)
	ZEND_ARG_TYPE_INFO(0, Algorithm_or_AlgOID, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Mode_or_AlgParams, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Key_or_Mode, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Params_or_Key, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Params, TElRelativeDistinguishedName, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCryptoProvider_GetAlgorithmProperty, 0, 0, 3)
	ZEND_ARG_TYPE_INFO(0, Algorithm_or_AlgOID, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Mode_or_AlgParams, 0, 1)
	ZEND_ARG_TYPE_INFO(0, PropID_or_Mode, 0, 1)
	ZEND_ARG_TYPE_INFO(0, PropID, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCryptoProvider_GetAlgorithmClass, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Algorithm_or_AlgOID, 0, 1)
	ZEND_ARG_TYPE_INFO(0, AlgParams, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCryptoProvider_GetProviderProp, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, PropID, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Default, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCryptoProvider_SetProviderProp, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, PropID, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCryptoProvider_CreateKey, 0, 0, 3)
	ZEND_ARG_TYPE_INFO(0, Algorithm_or_AlgOID, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Mode_or_AlgParams, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Params, TElRelativeDistinguishedName, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCryptoProvider_CloneKey, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Key, TElCustomCryptoKey, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCryptoProvider_ReleaseKey, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(1, Key, TElCustomCryptoKey, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCryptoProvider_DeleteKey, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(1, Key, TElCustomCryptoKey, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCryptoProvider_DecryptKey, 0, 0, 10)
	ZEND_ARG_TYPE_INFO(0, EncKey, 0, 1)
	ZEND_ARG_INFO(0, EncKeySize)
	ZEND_ARG_TYPE_INFO(0, EncKeyAlgOID, 0, 1)
	ZEND_ARG_TYPE_INFO(0, EncKeyAlgParams, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Key, TElCustomCryptoKey, 1)
	ZEND_ARG_TYPE_INFO(0, KeyAlgOID, 0, 1)
	ZEND_ARG_TYPE_INFO(0, KeyAlgParams, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Params, TElRelativeDistinguishedName, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressFunc, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressData, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCryptoProvider_CreateKeyStorage, 0, 0, 2)
	ZEND_ARG_INFO(0, Persistent)
	ZEND_ARG_OBJ_INFO(0, Params, TElRelativeDistinguishedName, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCryptoProvider_ReleaseKeyStorage, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(1, KeyStorage, TElCustomCryptoKeyStorage, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCryptoProvider_DeleteKeyStorage, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(1, KeyStorage, TElCustomCryptoKeyStorage, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCryptoProvider_EncryptInit, 0, 0, 6)
	ZEND_ARG_TYPE_INFO(0, Algorithm_or_AlgOID, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Mode_or_AlgParams, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Key_or_Mode, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Params_or_Key, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressFunc_or_Params, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressData_or_ProgressFunc, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressData, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCryptoProvider_DecryptInit, 0, 0, 6)
	ZEND_ARG_TYPE_INFO(0, Algorithm_or_AlgOID, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Mode_or_AlgParams, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Key_or_Mode, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Params_or_Key, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressFunc_or_Params, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressData_or_ProgressFunc, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressData, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCryptoProvider_SignInit, 0, 0, 6)
	ZEND_ARG_TYPE_INFO(0, Algorithm_or_AlgOID, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Key_or_AlgParams, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Detached_or_Key, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Params_or_Detached, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressFunc_or_Params, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressData_or_ProgressFunc, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressData, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCryptoProvider_VerifyInit, 0, 0, 7)
	ZEND_ARG_TYPE_INFO(0, Algorithm_or_AlgOID, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Key_or_AlgParams, 0, 1)
	ZEND_ARG_TYPE_INFO(0, SigBuffer_or_Key, 0, 1)
	ZEND_ARG_TYPE_INFO(0, SigSize_or_SigBuffer, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Params_or_SigSize, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressFunc_or_Params, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressData_or_ProgressFunc, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressData, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCryptoProvider_EncryptUpdate, 0, 0, 8)
	ZEND_ARG_OBJ_INFO(0, Context, TElCustomCryptoContext, 1)
	ZEND_ARG_TYPE_INFO(0, InBuffer, 0, 1)
	ZEND_ARG_INFO(0, InSize)
	ZEND_ARG_TYPE_INFO(0, OutBuffer, 0, 1)
	ZEND_ARG_INFO(1, OutSize)
	ZEND_ARG_OBJ_INFO(0, Params, TElRelativeDistinguishedName, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressFunc, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressData, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCryptoProvider_DecryptUpdate, 0, 0, 8)
	ZEND_ARG_OBJ_INFO(0, Context, TElCustomCryptoContext, 1)
	ZEND_ARG_TYPE_INFO(0, InBuffer, 0, 1)
	ZEND_ARG_INFO(0, InSize)
	ZEND_ARG_TYPE_INFO(0, OutBuffer, 0, 1)
	ZEND_ARG_INFO(1, OutSize)
	ZEND_ARG_OBJ_INFO(0, Params, TElRelativeDistinguishedName, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressFunc, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressData, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCryptoProvider_SignUpdate, 0, 0, 8)
	ZEND_ARG_OBJ_INFO(0, Context, TElCustomCryptoContext, 1)
	ZEND_ARG_TYPE_INFO(0, InBuffer, 0, 1)
	ZEND_ARG_INFO(0, InSize)
	ZEND_ARG_TYPE_INFO(0, OutBuffer, 0, 1)
	ZEND_ARG_INFO(1, OutSize)
	ZEND_ARG_OBJ_INFO(0, Params, TElRelativeDistinguishedName, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressFunc, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressData, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCryptoProvider_VerifyUpdate, 0, 0, 8)
	ZEND_ARG_OBJ_INFO(0, Context, TElCustomCryptoContext, 1)
	ZEND_ARG_TYPE_INFO(0, InBuffer, 0, 1)
	ZEND_ARG_INFO(0, InSize)
	ZEND_ARG_TYPE_INFO(0, OutBuffer, 0, 1)
	ZEND_ARG_INFO(1, OutSize)
	ZEND_ARG_OBJ_INFO(0, Params, TElRelativeDistinguishedName, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressFunc, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressData, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCryptoProvider_EncryptFinal, 0, 0, 6)
	ZEND_ARG_OBJ_INFO(0, Context, TElCustomCryptoContext, 1)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(1, Size)
	ZEND_ARG_OBJ_INFO(0, Params, TElRelativeDistinguishedName, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressFunc, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressData, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCryptoProvider_DecryptFinal, 0, 0, 6)
	ZEND_ARG_OBJ_INFO(0, Context, TElCustomCryptoContext, 1)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(1, Size)
	ZEND_ARG_OBJ_INFO(0, Params, TElRelativeDistinguishedName, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressFunc, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressData, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCryptoProvider_SignFinal, 0, 0, 6)
	ZEND_ARG_OBJ_INFO(0, Context, TElCustomCryptoContext, 1)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(1, Size)
	ZEND_ARG_OBJ_INFO(0, Params, TElRelativeDistinguishedName, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressFunc, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressData, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCryptoProvider_VerifyFinal, 0, 0, 6)
	ZEND_ARG_OBJ_INFO(0, Context, TElCustomCryptoContext, 1)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(1, Size)
	ZEND_ARG_OBJ_INFO(0, Params, TElRelativeDistinguishedName, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressFunc, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressData, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCryptoProvider_Encrypt, 0, 0, 10)
	ZEND_ARG_TYPE_INFO(0, Algorithm_or_AlgOID, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Mode_or_AlgParams, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Key_or_Mode, 0, 1)
	ZEND_ARG_TYPE_INFO(0, InBuffer_or_Key, 0, 1)
	ZEND_ARG_TYPE_INFO(0, InSize_or_InBuffer, 0, 1)
	ZEND_ARG_TYPE_INFO(0, OutBuffer_or_InSize, 0, 1)
	ZEND_ARG_TYPE_INFO(1, OutSize_or_OutBuffer, 0, 1)
	ZEND_ARG_TYPE_INFO(1, Params_or_OutSize, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressFunc_or_Params, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressData_or_ProgressFunc, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressData, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCryptoProvider_Decrypt, 0, 0, 10)
	ZEND_ARG_TYPE_INFO(0, Algorithm_or_AlgOID, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Mode_or_AlgParams, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Key_or_Mode, 0, 1)
	ZEND_ARG_TYPE_INFO(0, InBuffer_or_Key, 0, 1)
	ZEND_ARG_TYPE_INFO(0, InSize_or_InBuffer, 0, 1)
	ZEND_ARG_TYPE_INFO(0, OutBuffer_or_InSize, 0, 1)
	ZEND_ARG_TYPE_INFO(1, OutSize_or_OutBuffer, 0, 1)
	ZEND_ARG_TYPE_INFO(1, Params_or_OutSize, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressFunc_or_Params, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressData_or_ProgressFunc, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressData, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCryptoProvider_Sign, 0, 0, 10)
	ZEND_ARG_TYPE_INFO(0, Algorithm_or_AlgOID, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Key_or_AlgParams, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Detached_or_Key, 0, 1)
	ZEND_ARG_TYPE_INFO(0, InBuffer_or_Detached, 0, 1)
	ZEND_ARG_TYPE_INFO(0, InSize_or_InBuffer, 0, 1)
	ZEND_ARG_TYPE_INFO(0, OutBuffer_or_InSize, 0, 1)
	ZEND_ARG_TYPE_INFO(1, OutSize_or_OutBuffer, 0, 1)
	ZEND_ARG_TYPE_INFO(1, Params_or_OutSize, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressFunc_or_Params, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressData_or_ProgressFunc, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressData, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCryptoProvider_Verify, 0, 0, 9)
	ZEND_ARG_TYPE_INFO(0, Algorithm_or_AlgOID, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Key_or_AlgParams, 0, 1)
	ZEND_ARG_TYPE_INFO(0, InBuffer_or_Key, 0, 1)
	ZEND_ARG_TYPE_INFO(0, InSize_or_InBuffer, 0, 1)
	ZEND_ARG_TYPE_INFO(0, OutBuffer_or_InSize, 0, 1)
	ZEND_ARG_TYPE_INFO(1, OutSize_or_OutBuffer, 0, 1)
	ZEND_ARG_TYPE_INFO(1, Params_or_OutSize, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressFunc_or_Params, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressData_or_ProgressFunc, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressData, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCryptoProvider_VerifyDetached, 0, 0, 9)
	ZEND_ARG_TYPE_INFO(0, Algorithm_or_AlgOID, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Key_or_AlgParams, 0, 1)
	ZEND_ARG_TYPE_INFO(0, InBuffer_or_Key, 0, 1)
	ZEND_ARG_TYPE_INFO(0, InSize_or_InBuffer, 0, 1)
	ZEND_ARG_TYPE_INFO(0, SigBuffer_or_InSize, 0, 1)
	ZEND_ARG_TYPE_INFO(0, SigSize_or_SigBuffer, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Params_or_SigSize, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressFunc_or_Params, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressData_or_ProgressFunc, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressData, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCryptoProvider_HashInit, 0, 0, 5)
	ZEND_ARG_TYPE_INFO(0, Algorithm_or_AlgOID, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Key_or_AlgParams, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Params_or_Key, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressFunc_or_Params, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressData_or_ProgressFunc, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressData, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCryptoProvider_HashFinal, 0, 0, 4)
	ZEND_ARG_OBJ_INFO(0, Context, TElCustomCryptoContext, 1)
	ZEND_ARG_OBJ_INFO(0, Params, TElRelativeDistinguishedName, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressFunc, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressData, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCryptoProvider_HashUpdate, 0, 0, 6)
	ZEND_ARG_OBJ_INFO(0, Context, TElCustomCryptoContext, 1)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(0, Size)
	ZEND_ARG_OBJ_INFO(0, Params, TElRelativeDistinguishedName, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressFunc, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressData, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCryptoProvider_Hash, 0, 0, 7)
	ZEND_ARG_TYPE_INFO(0, Algorithm_or_AlgOID, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Key_or_AlgParams, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Buffer_or_Key, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Size_or_Buffer, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Params_or_Size, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressFunc_or_Params, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressData_or_ProgressFunc, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressData, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCryptoProvider_ReleaseCryptoContext, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(1, Context, TElCustomCryptoContext, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCryptoProvider_RandomInit, 0, 0, 3)
	ZEND_ARG_TYPE_INFO(0, BaseData, 0, 1)
	ZEND_ARG_INFO(0, BaseDataSize)
	ZEND_ARG_OBJ_INFO(0, Params, TElRelativeDistinguishedName, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCryptoProvider_RandomSeed, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Data, 0, 1)
	ZEND_ARG_INFO(0, DataSize)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCryptoProvider_RandomGenerate, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Buffer_or_MaxValue, 0, 1)
	ZEND_ARG_INFO(0, Size)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCryptoProvider_OwnsObject, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Obj, TObject, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCryptoProvider_ClassType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCryptoProvider_get_Options, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCryptoProvider_get_Enabled, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCryptoProvider_set_Enabled, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCryptoProvider_get_CryptoProviderManager, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCryptoProvider_set_CryptoProviderManager, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElCustomCryptoProviderManager, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCryptoProvider_get_OnCreateObject, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCryptoProvider_set_OnCreateObject, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCryptoProvider_get_OnDestroyObject, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCryptoProvider_set_OnDestroyObject, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCryptoProvider___construct, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, AOwner_or_Options, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AOwner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElCustomCryptoProvider_methods[] = {
	PHP_ME(TElCustomCryptoProvider, Init, arginfo_TElCustomCryptoProvider_Init, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCryptoProvider, Deinit, arginfo_TElCustomCryptoProvider_Deinit, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCryptoProvider, SetAsDefault_Inst, arginfo_TElCustomCryptoProvider_SetAsDefault_Inst, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCryptoProvider, SetAsDefault, arginfo_TElCustomCryptoProvider_SetAsDefault, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElCustomCryptoProvider, GetDefaultInstance, arginfo_TElCustomCryptoProvider_GetDefaultInstance, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCryptoProvider, Clone, arginfo_TElCustomCryptoProvider_Clone, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCryptoProvider, IsAlgorithmSupported, arginfo_TElCustomCryptoProvider_IsAlgorithmSupported, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCryptoProvider, IsOperationSupported, arginfo_TElCustomCryptoProvider_IsOperationSupported, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCryptoProvider, GetAlgorithmProperty, arginfo_TElCustomCryptoProvider_GetAlgorithmProperty, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCryptoProvider, GetAlgorithmClass, arginfo_TElCustomCryptoProvider_GetAlgorithmClass, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCryptoProvider, GetProviderProp, arginfo_TElCustomCryptoProvider_GetProviderProp, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCryptoProvider, SetProviderProp, arginfo_TElCustomCryptoProvider_SetProviderProp, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCryptoProvider, CreateKey, arginfo_TElCustomCryptoProvider_CreateKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCryptoProvider, CloneKey, arginfo_TElCustomCryptoProvider_CloneKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCryptoProvider, ReleaseKey, arginfo_TElCustomCryptoProvider_ReleaseKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCryptoProvider, DeleteKey, arginfo_TElCustomCryptoProvider_DeleteKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCryptoProvider, DecryptKey, arginfo_TElCustomCryptoProvider_DecryptKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCryptoProvider, CreateKeyStorage, arginfo_TElCustomCryptoProvider_CreateKeyStorage, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCryptoProvider, ReleaseKeyStorage, arginfo_TElCustomCryptoProvider_ReleaseKeyStorage, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCryptoProvider, DeleteKeyStorage, arginfo_TElCustomCryptoProvider_DeleteKeyStorage, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCryptoProvider, EncryptInit, arginfo_TElCustomCryptoProvider_EncryptInit, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCryptoProvider, DecryptInit, arginfo_TElCustomCryptoProvider_DecryptInit, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCryptoProvider, SignInit, arginfo_TElCustomCryptoProvider_SignInit, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCryptoProvider, VerifyInit, arginfo_TElCustomCryptoProvider_VerifyInit, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCryptoProvider, EncryptUpdate, arginfo_TElCustomCryptoProvider_EncryptUpdate, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCryptoProvider, DecryptUpdate, arginfo_TElCustomCryptoProvider_DecryptUpdate, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCryptoProvider, SignUpdate, arginfo_TElCustomCryptoProvider_SignUpdate, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCryptoProvider, VerifyUpdate, arginfo_TElCustomCryptoProvider_VerifyUpdate, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCryptoProvider, EncryptFinal, arginfo_TElCustomCryptoProvider_EncryptFinal, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCryptoProvider, DecryptFinal, arginfo_TElCustomCryptoProvider_DecryptFinal, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCryptoProvider, SignFinal, arginfo_TElCustomCryptoProvider_SignFinal, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCryptoProvider, VerifyFinal, arginfo_TElCustomCryptoProvider_VerifyFinal, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCryptoProvider, Encrypt, arginfo_TElCustomCryptoProvider_Encrypt, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCryptoProvider, Decrypt, arginfo_TElCustomCryptoProvider_Decrypt, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCryptoProvider, Sign, arginfo_TElCustomCryptoProvider_Sign, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCryptoProvider, Verify, arginfo_TElCustomCryptoProvider_Verify, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCryptoProvider, VerifyDetached, arginfo_TElCustomCryptoProvider_VerifyDetached, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCryptoProvider, HashInit, arginfo_TElCustomCryptoProvider_HashInit, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCryptoProvider, HashFinal, arginfo_TElCustomCryptoProvider_HashFinal, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCryptoProvider, HashUpdate, arginfo_TElCustomCryptoProvider_HashUpdate, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCryptoProvider, Hash, arginfo_TElCustomCryptoProvider_Hash, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCryptoProvider, ReleaseCryptoContext, arginfo_TElCustomCryptoProvider_ReleaseCryptoContext, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCryptoProvider, RandomInit, arginfo_TElCustomCryptoProvider_RandomInit, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCryptoProvider, RandomSeed, arginfo_TElCustomCryptoProvider_RandomSeed, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCryptoProvider, RandomGenerate, arginfo_TElCustomCryptoProvider_RandomGenerate, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCryptoProvider, OwnsObject, arginfo_TElCustomCryptoProvider_OwnsObject, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCryptoProvider, ClassType, arginfo_TElCustomCryptoProvider_ClassType, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElCustomCryptoProvider, get_Options, arginfo_TElCustomCryptoProvider_get_Options, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCryptoProvider, get_Enabled, arginfo_TElCustomCryptoProvider_get_Enabled, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCryptoProvider, set_Enabled, arginfo_TElCustomCryptoProvider_set_Enabled, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCryptoProvider, get_CryptoProviderManager, arginfo_TElCustomCryptoProvider_get_CryptoProviderManager, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCryptoProvider, set_CryptoProviderManager, arginfo_TElCustomCryptoProvider_set_CryptoProviderManager, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCryptoProvider, get_OnCreateObject, arginfo_TElCustomCryptoProvider_get_OnCreateObject, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCryptoProvider, set_OnCreateObject, arginfo_TElCustomCryptoProvider_set_OnCreateObject, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCryptoProvider, get_OnDestroyObject, arginfo_TElCustomCryptoProvider_get_OnDestroyObject, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCryptoProvider, set_OnDestroyObject, arginfo_TElCustomCryptoProvider_set_OnDestroyObject, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCryptoProvider, __construct, arginfo_TElCustomCryptoProvider___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElCustomCryptoProvider(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElCustomCryptoProvider_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElCustomCryptoProvider", TElCustomCryptoProvider_methods);
	if (NULL == TComponent_ce_ptr)
		Register_TComponent(TSRMLS_C);
	TElCustomCryptoProvider_ce_ptr = zend_register_internal_class_ex(&ce, TComponent_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElCustomCryptoProviderManager_ce_ptr = NULL;

SB_PHP_METHOD(TElCustomCryptoProviderManager, Init)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElCustomCryptoProviderManager_Init(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCryptoProviderManager, Deinit)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElCustomCryptoProviderManager_Deinit(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCryptoProviderManager, RegisterCryptoProvider)
{
	zval *oProv;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oProv, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElCustomCryptoProviderManager_RegisterCryptoProvider(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oProv TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCryptoProvider)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCryptoProviderManager, UnregisterCryptoProvider)
{
	long l4Index;
	zval *oProv;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oProv, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElCustomCryptoProviderManager_UnregisterCryptoProvider(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oProv TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		SBCheckError(TElCustomCryptoProviderManager_UnregisterCryptoProvider_1(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCryptoProvider) or (integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCryptoProviderManager, SetDefaultCryptoProvider)
{
	long l4Index;
	zval *oProv;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oProv, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElCustomCryptoProviderManager_SetDefaultCryptoProvider(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oProv TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		SBCheckError(TElCustomCryptoProviderManager_SetDefaultCryptoProvider_1(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCryptoProvider) or (integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCryptoProviderManager, SetDefaultCryptoProviderType)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElCustomCryptoProviderClass_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElCustomCryptoProviderManager_SetDefaultCryptoProviderType(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCryptoProviderClass)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCryptoProviderManager, GetSuitableProvider)
{
	long l4Algorithm;
	long l4Mode;
	long l4Operation;
	SBArrayZValInfo aiAlgOID;
	SBArrayZValInfo aiAlgParams;
	zval *oKey;
	zval *oParams;
	zval *zaAlgOID;
	zval *zaAlgParams;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lllO!O!", &l4Operation, &l4Algorithm, &l4Mode, &oKey, TElCustomCryptoKey_ce_ptr, &oParams, TElRelativeDistinguishedName_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCustomCryptoProviderManager_GetSuitableProvider(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Operation, (int32_t)l4Algorithm, (int32_t)l4Mode, SBGetObjectHandle(oKey TSRMLS_CC), SBGetObjectHandle(oParams TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomCryptoProvider_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lzzlO!O!", &l4Operation, &zaAlgOID, &zaAlgParams, &l4Mode, &oKey, TElCustomCryptoKey_ce_ptr, &oParams, TElRelativeDistinguishedName_ce_ptr) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaAlgOID)) || (IS_ARRAY == Z_TYPE_P(zaAlgOID)) || (IS_NULL == Z_TYPE_P(zaAlgOID))) && ((IS_STRING == Z_TYPE_P(zaAlgParams)) || (IS_ARRAY == Z_TYPE_P(zaAlgParams)) || (IS_NULL == Z_TYPE_P(zaAlgParams))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetByteArrayFromZVal(zaAlgOID, &aiAlgOID TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaAlgParams, &aiAlgParams TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElCustomCryptoProviderManager_GetSuitableProvider_1(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Operation, aiAlgOID.data, aiAlgOID.len, aiAlgParams.data, aiAlgParams.len, (int32_t)l4Mode, SBGetObjectHandle(oKey TSRMLS_CC), SBGetObjectHandle(oParams TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiAlgOID);
		SBFreeArrayZValInfo(&aiAlgParams);
		SBInitObject(return_value, TElCustomCryptoProvider_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &l4Algorithm, &l4Mode) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCustomCryptoProviderManager_GetSuitableProvider_2(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Algorithm, (int32_t)l4Mode, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomCryptoProvider_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zzl", &zaAlgOID, &zaAlgParams, &l4Mode) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaAlgOID)) || (IS_ARRAY == Z_TYPE_P(zaAlgOID)) || (IS_NULL == Z_TYPE_P(zaAlgOID))) && ((IS_STRING == Z_TYPE_P(zaAlgParams)) || (IS_ARRAY == Z_TYPE_P(zaAlgParams)) || (IS_NULL == Z_TYPE_P(zaAlgParams))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetByteArrayFromZVal(zaAlgOID, &aiAlgOID TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaAlgParams, &aiAlgParams TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElCustomCryptoProviderManager_GetSuitableProvider_3(SBGetObjectHandle(getThis() TSRMLS_CC), aiAlgOID.data, aiAlgOID.len, aiAlgParams.data, aiAlgParams.len, (int32_t)l4Mode, &hoOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiAlgOID);
		SBFreeArrayZValInfo(&aiAlgParams);
		SBInitObject(return_value, TElCustomCryptoProvider_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer, integer, TElCustomCryptoKey, TElRelativeDistinguishedName) or (integer, array of byte|string|NULL, array of byte|string|NULL, integer, TElCustomCryptoKey, TElRelativeDistinguishedName) or (integer, integer) or (array of byte|string|NULL, array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCryptoProviderManager, IsOperationSupported)
{
	long l4Algorithm;
	long l4Mode;
	long l4Operation;
	SBArrayZValInfo aiAlgOID;
	SBArrayZValInfo aiAlgParams;
	zval *oKey;
	zval *oParams;
	zval *zaAlgOID;
	zval *zaAlgParams;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lllO!O!", &l4Operation, &l4Algorithm, &l4Mode, &oKey, TElCustomCryptoKey_ce_ptr, &oParams, TElRelativeDistinguishedName_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElCustomCryptoProviderManager_IsOperationSupported(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Operation, (int32_t)l4Algorithm, (int32_t)l4Mode, SBGetObjectHandle(oKey TSRMLS_CC), SBGetObjectHandle(oParams TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lzzlO!O!", &l4Operation, &zaAlgOID, &zaAlgParams, &l4Mode, &oKey, TElCustomCryptoKey_ce_ptr, &oParams, TElRelativeDistinguishedName_ce_ptr) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaAlgOID)) || (IS_ARRAY == Z_TYPE_P(zaAlgOID)) || (IS_NULL == Z_TYPE_P(zaAlgOID))) && ((IS_STRING == Z_TYPE_P(zaAlgParams)) || (IS_ARRAY == Z_TYPE_P(zaAlgParams)) || (IS_NULL == Z_TYPE_P(zaAlgParams))))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaAlgOID, &aiAlgOID TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaAlgParams, &aiAlgParams TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElCustomCryptoProviderManager_IsOperationSupported_1(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Operation, aiAlgOID.data, aiAlgOID.len, aiAlgParams.data, aiAlgParams.len, (int32_t)l4Mode, SBGetObjectHandle(oKey TSRMLS_CC), SBGetObjectHandle(oParams TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiAlgOID);
		SBFreeArrayZValInfo(&aiAlgParams);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer, integer, TElCustomCryptoKey, TElRelativeDistinguishedName) or (integer, array of byte|string|NULL, array of byte|string|NULL, integer, TElCustomCryptoKey, TElRelativeDistinguishedName)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCryptoProviderManager, IsAlgorithmSupported)
{
	long l4Algorithm;
	long l4Mode;
	SBArrayZValInfo aiAlgOID;
	SBArrayZValInfo aiAlgParams;
	zval *zaAlgOID;
	zval *zaAlgParams;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &l4Algorithm, &l4Mode) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElCustomCryptoProviderManager_IsAlgorithmSupported(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Algorithm, (int32_t)l4Mode, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zzl", &zaAlgOID, &zaAlgParams, &l4Mode) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaAlgOID)) || (IS_ARRAY == Z_TYPE_P(zaAlgOID)) || (IS_NULL == Z_TYPE_P(zaAlgOID))) && ((IS_STRING == Z_TYPE_P(zaAlgParams)) || (IS_ARRAY == Z_TYPE_P(zaAlgParams)) || (IS_NULL == Z_TYPE_P(zaAlgParams))))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaAlgOID, &aiAlgOID TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaAlgParams, &aiAlgParams TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElCustomCryptoProviderManager_IsAlgorithmSupported_1(SBGetObjectHandle(getThis() TSRMLS_CC), aiAlgOID.data, aiAlgOID.len, aiAlgParams.data, aiAlgParams.len, (int32_t)l4Mode, &bOutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiAlgOID);
		SBFreeArrayZValInfo(&aiAlgParams);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer) or (array of byte|string|NULL, array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCryptoProviderManager, IsProviderAllowed)
{
	zval *oProv;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oProv, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElCustomCryptoProviderManager_IsProviderAllowed(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oProv TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCryptoProvider)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCryptoProviderManager, GetAlgorithmProperty)
{
	long l4Algorithm;
	long l4Mode;
	SBArrayZValInfo aiAlgOID;
	SBArrayZValInfo aiAlgParams;
	SBArrayZValInfo aiPropID;
	uint32_t _err;
	zval *zaAlgOID;
	zval *zaAlgParams;
	zval *zaPropID;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "llz", &l4Algorithm, &l4Mode, &zaPropID) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaPropID)) || (IS_ARRAY == Z_TYPE_P(zaPropID)) || (IS_NULL == Z_TYPE_P(zaPropID))))
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		if (!SBGetByteArrayFromZVal(zaPropID, &aiPropID TSRMLS_CC)) RETURN_FALSE;
		_err = TElCustomCryptoProviderManager_GetAlgorithmProperty(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Algorithm, (int32_t)l4Mode, aiPropID.data, aiPropID.len, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-419240698, 4, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiPropID);
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zzlz", &zaAlgOID, &zaAlgParams, &l4Mode, &zaPropID) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaAlgOID)) || (IS_ARRAY == Z_TYPE_P(zaAlgOID)) || (IS_NULL == Z_TYPE_P(zaAlgOID))) && ((IS_STRING == Z_TYPE_P(zaAlgParams)) || (IS_ARRAY == Z_TYPE_P(zaAlgParams)) || (IS_NULL == Z_TYPE_P(zaAlgParams))) && ((IS_STRING == Z_TYPE_P(zaPropID)) || (IS_ARRAY == Z_TYPE_P(zaPropID)) || (IS_NULL == Z_TYPE_P(zaPropID))))
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		if (!SBGetByteArrayFromZVal(zaAlgOID, &aiAlgOID TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaAlgParams, &aiAlgParams TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaPropID, &aiPropID TSRMLS_CC)) RETURN_FALSE;
		_err = TElCustomCryptoProviderManager_GetAlgorithmProperty_1(SBGetObjectHandle(getThis() TSRMLS_CC), aiAlgOID.data, aiAlgOID.len, aiAlgParams.data, aiAlgParams.len, (int32_t)l4Mode, aiPropID.data, aiPropID.len, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(1700494602, 5, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiAlgOID);
		SBFreeArrayZValInfo(&aiAlgParams);
		SBFreeArrayZValInfo(&aiPropID);
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer, array of byte|string|NULL) or (array of byte|string|NULL, array of byte|string|NULL, integer, array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCryptoProviderManager, GetAlgorithmClass)
{
	long l4Algorithm;
	SBArrayZValInfo aiAlgOID;
	SBArrayZValInfo aiAlgParams;
	zval *zaAlgOID;
	zval *zaAlgParams;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Algorithm) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElCustomCryptoProviderManager_GetAlgorithmClass(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Algorithm, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zz", &zaAlgOID, &zaAlgParams) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaAlgOID)) || (IS_ARRAY == Z_TYPE_P(zaAlgOID)) || (IS_NULL == Z_TYPE_P(zaAlgOID))) && ((IS_STRING == Z_TYPE_P(zaAlgParams)) || (IS_ARRAY == Z_TYPE_P(zaAlgParams)) || (IS_NULL == Z_TYPE_P(zaAlgParams))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaAlgOID, &aiAlgOID TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaAlgParams, &aiAlgParams TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElCustomCryptoProviderManager_GetAlgorithmClass_1(SBGetObjectHandle(getThis() TSRMLS_CC), aiAlgOID.data, aiAlgOID.len, aiAlgParams.data, aiAlgParams.len, &l4OutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiAlgOID);
		SBFreeArrayZValInfo(&aiAlgParams);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer) or (array of byte|string|NULL, array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCryptoProviderManager, get_CryptoProviders)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCustomCryptoProviderManager_get_CryptoProviders(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomCryptoProvider_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCryptoProviderManager, get_Count)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElCustomCryptoProviderManager_get_Count(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCryptoProviderManager, get_DefaultCryptoProvider)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCustomCryptoProviderManager_get_DefaultCryptoProvider(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomCryptoProvider_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCryptoProviderManager, __construct)
{
	zval *oAOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCustomCryptoProviderManager_Create(SBGetObjectHandle(oAOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCryptoProviderManager_Init, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCryptoProviderManager_Deinit, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCryptoProviderManager_RegisterCryptoProvider, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Prov, TElCustomCryptoProvider, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCryptoProviderManager_UnregisterCryptoProvider, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Prov_or_Index, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCryptoProviderManager_SetDefaultCryptoProvider, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Prov_or_Index, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCryptoProviderManager_SetDefaultCryptoProviderType, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElCustomCryptoProviderClass, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCryptoProviderManager_GetSuitableProvider, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Operation_or_Algorithm_or_AlgOID, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Algorithm_or_AlgOID_or_Mode_or_AlgParams, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Mode_or_AlgParams, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Key_or_Mode, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Params_or_Key, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Params, TElRelativeDistinguishedName, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCryptoProviderManager_IsOperationSupported, 0, 0, 5)
	ZEND_ARG_INFO(0, Operation)
	ZEND_ARG_TYPE_INFO(0, Algorithm_or_AlgOID, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Mode_or_AlgParams, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Key_or_Mode, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Params_or_Key, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Params, TElRelativeDistinguishedName, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCryptoProviderManager_IsAlgorithmSupported, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Algorithm_or_AlgOID, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Mode_or_AlgParams, 0, 1)
	ZEND_ARG_INFO(0, Mode)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCryptoProviderManager_IsProviderAllowed, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Prov, TElCustomCryptoProvider, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCryptoProviderManager_GetAlgorithmProperty, 0, 0, 3)
	ZEND_ARG_TYPE_INFO(0, Algorithm_or_AlgOID, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Mode_or_AlgParams, 0, 1)
	ZEND_ARG_TYPE_INFO(0, PropID_or_Mode, 0, 1)
	ZEND_ARG_TYPE_INFO(0, PropID, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCryptoProviderManager_GetAlgorithmClass, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Algorithm_or_AlgOID, 0, 1)
	ZEND_ARG_TYPE_INFO(0, AlgParams, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCryptoProviderManager_get_CryptoProviders, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCryptoProviderManager_get_Count, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCryptoProviderManager_get_DefaultCryptoProvider, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCryptoProviderManager___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AOwner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElCustomCryptoProviderManager_methods[] = {
	PHP_ME(TElCustomCryptoProviderManager, Init, arginfo_TElCustomCryptoProviderManager_Init, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCryptoProviderManager, Deinit, arginfo_TElCustomCryptoProviderManager_Deinit, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCryptoProviderManager, RegisterCryptoProvider, arginfo_TElCustomCryptoProviderManager_RegisterCryptoProvider, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCryptoProviderManager, UnregisterCryptoProvider, arginfo_TElCustomCryptoProviderManager_UnregisterCryptoProvider, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCryptoProviderManager, SetDefaultCryptoProvider, arginfo_TElCustomCryptoProviderManager_SetDefaultCryptoProvider, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCryptoProviderManager, SetDefaultCryptoProviderType, arginfo_TElCustomCryptoProviderManager_SetDefaultCryptoProviderType, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCryptoProviderManager, GetSuitableProvider, arginfo_TElCustomCryptoProviderManager_GetSuitableProvider, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCryptoProviderManager, IsOperationSupported, arginfo_TElCustomCryptoProviderManager_IsOperationSupported, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCryptoProviderManager, IsAlgorithmSupported, arginfo_TElCustomCryptoProviderManager_IsAlgorithmSupported, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCryptoProviderManager, IsProviderAllowed, arginfo_TElCustomCryptoProviderManager_IsProviderAllowed, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCryptoProviderManager, GetAlgorithmProperty, arginfo_TElCustomCryptoProviderManager_GetAlgorithmProperty, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCryptoProviderManager, GetAlgorithmClass, arginfo_TElCustomCryptoProviderManager_GetAlgorithmClass, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCryptoProviderManager, get_CryptoProviders, arginfo_TElCustomCryptoProviderManager_get_CryptoProviders, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCryptoProviderManager, get_Count, arginfo_TElCustomCryptoProviderManager_get_Count, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCryptoProviderManager, get_DefaultCryptoProvider, arginfo_TElCustomCryptoProviderManager_get_DefaultCryptoProvider, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCryptoProviderManager, __construct, arginfo_TElCustomCryptoProviderManager___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElCustomCryptoProviderManager(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElCustomCryptoProviderManager_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElCustomCryptoProviderManager", TElCustomCryptoProviderManager_methods);
	if (NULL == TComponent_ce_ptr)
		Register_TComponent(TSRMLS_C);
	TElCustomCryptoProviderManager_ce_ptr = zend_register_internal_class_ex(&ce, TComponent_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElCustomCryptoKeyStorage_ce_ptr = NULL;

SB_PHP_METHOD(TElCustomCryptoKeyStorage, AddKey)
{
	zval *oKey;
	zval *oParams;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oKey, TElCustomCryptoKey_ce_ptr, &oParams, TElRelativeDistinguishedName_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElCustomCryptoKeyStorage_AddKey(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oKey TSRMLS_CC), SBGetObjectHandle(oParams TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCryptoKey, TElRelativeDistinguishedName)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCryptoKeyStorage, RemoveKey)
{
	long l4Index;
	zval *oKey;
	zval *oParams;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lO!", &l4Index, &oParams, TElRelativeDistinguishedName_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElCustomCryptoKeyStorage_RemoveKey(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, SBGetObjectHandle(oParams TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oKey, TElCustomCryptoKey_ce_ptr, &oParams, TElRelativeDistinguishedName_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElCustomCryptoKeyStorage_RemoveKey_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oKey TSRMLS_CC), SBGetObjectHandle(oParams TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, TElRelativeDistinguishedName) or (TElCustomCryptoKey, TElRelativeDistinguishedName)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCryptoKeyStorage, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElCustomCryptoKeyStorage_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCryptoKeyStorage, Clone)
{
	zval *oParams;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oParams, TElRelativeDistinguishedName_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCustomCryptoKeyStorage_Clone(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oParams TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomCryptoKeyStorage_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElRelativeDistinguishedName)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCryptoKeyStorage, Lock)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElCustomCryptoKeyStorage_Lock(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCryptoKeyStorage, Unlock)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElCustomCryptoKeyStorage_Unlock(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCryptoKeyStorage, GetStorageProp)
{
	SBArrayZValInfo aiDefault;
	SBArrayZValInfo aiPropID;
	uint32_t _err;
	zval *zaDefault;
	zval *zaPropID;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zz", &zaPropID, &zaDefault) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaPropID)) || (IS_ARRAY == Z_TYPE_P(zaPropID)) || (IS_NULL == Z_TYPE_P(zaPropID))) && ((IS_STRING == Z_TYPE_P(zaDefault)) || (IS_ARRAY == Z_TYPE_P(zaDefault)) || (IS_NULL == Z_TYPE_P(zaDefault))))
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		if (!SBGetByteArrayFromZVal(zaPropID, &aiPropID TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaDefault, &aiDefault TSRMLS_CC)) RETURN_FALSE;
		_err = TElCustomCryptoKeyStorage_GetStorageProp(SBGetObjectHandle(getThis() TSRMLS_CC), aiPropID.data, aiPropID.len, aiDefault.data, aiDefault.len, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-731852618, 3, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiPropID);
		SBFreeArrayZValInfo(&aiDefault);
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCryptoKeyStorage, SetStorageProp)
{
	SBArrayZValInfo aiPropID;
	SBArrayZValInfo aiValue;
	zval *zaPropID;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zz", &zaPropID, &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaPropID)) || (IS_ARRAY == Z_TYPE_P(zaPropID)) || (IS_NULL == Z_TYPE_P(zaPropID))) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaPropID, &aiPropID TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElCustomCryptoKeyStorage_SetStorageProp(SBGetObjectHandle(getThis() TSRMLS_CC), aiPropID.data, aiPropID.len, aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiPropID);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCryptoKeyStorage, get_Keys)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCustomCryptoKeyStorage_get_Keys(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomCryptoKey_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCryptoKeyStorage, get_Count)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElCustomCryptoKeyStorage_get_Count(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCryptoKeyStorage, get_IsPersistent)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElCustomCryptoKeyStorage_get_IsPersistent(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCryptoKeyStorage, get_CryptoProvider)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCustomCryptoKeyStorage_get_CryptoProvider(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomCryptoProvider_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCryptoKeyStorage, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCustomCryptoKeyStorage_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCryptoKeyStorage_AddKey, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, Key, TElCustomCryptoKey, 1)
	ZEND_ARG_OBJ_INFO(0, Params, TElRelativeDistinguishedName, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCryptoKeyStorage_RemoveKey, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Index_or_Key, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Params, TElRelativeDistinguishedName, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCryptoKeyStorage_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCryptoKeyStorage_Clone, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Params, TElRelativeDistinguishedName, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCryptoKeyStorage_Lock, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCryptoKeyStorage_Unlock, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCryptoKeyStorage_GetStorageProp, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, PropID, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Default, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCryptoKeyStorage_SetStorageProp, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, PropID, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCryptoKeyStorage_get_Keys, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCryptoKeyStorage_get_Count, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCryptoKeyStorage_get_IsPersistent, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCryptoKeyStorage_get_CryptoProvider, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCryptoKeyStorage___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElCustomCryptoKeyStorage_methods[] = {
	PHP_ME(TElCustomCryptoKeyStorage, AddKey, arginfo_TElCustomCryptoKeyStorage_AddKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCryptoKeyStorage, RemoveKey, arginfo_TElCustomCryptoKeyStorage_RemoveKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCryptoKeyStorage, Clear, arginfo_TElCustomCryptoKeyStorage_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCryptoKeyStorage, Clone, arginfo_TElCustomCryptoKeyStorage_Clone, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCryptoKeyStorage, Lock, arginfo_TElCustomCryptoKeyStorage_Lock, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCryptoKeyStorage, Unlock, arginfo_TElCustomCryptoKeyStorage_Unlock, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCryptoKeyStorage, GetStorageProp, arginfo_TElCustomCryptoKeyStorage_GetStorageProp, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCryptoKeyStorage, SetStorageProp, arginfo_TElCustomCryptoKeyStorage_SetStorageProp, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCryptoKeyStorage, get_Keys, arginfo_TElCustomCryptoKeyStorage_get_Keys, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCryptoKeyStorage, get_Count, arginfo_TElCustomCryptoKeyStorage_get_Count, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCryptoKeyStorage, get_IsPersistent, arginfo_TElCustomCryptoKeyStorage_get_IsPersistent, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCryptoKeyStorage, get_CryptoProvider, arginfo_TElCustomCryptoKeyStorage_get_CryptoProvider, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCryptoKeyStorage, __construct, arginfo_TElCustomCryptoKeyStorage___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElCustomCryptoKeyStorage(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElCustomCryptoKeyStorage_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElCustomCryptoKeyStorage", TElCustomCryptoKeyStorage_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElCustomCryptoKeyStorage_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElCustomCryptoKey_ce_ptr = NULL;

SB_PHP_METHOD(TElCustomCryptoKey, Reset)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElCustomCryptoKey_Reset(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCryptoKey, Generate)
{
	long l4Bits;
	SBArrayZValInfo piProgressData;
	void *pzProgressFunc;
	zval *oParams;
	zval *zpProgressData;
	zval *zProgressFunc;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lO!zz", &l4Bits, &oParams, TElRelativeDistinguishedName_ce_ptr, &zProgressFunc, &zpProgressData) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zProgressFunc)) || (IS_ARRAY == Z_TYPE_P(zProgressFunc)) || (IS_CALLABLE == Z_TYPE_P(zProgressFunc)) || (IS_NULL == Z_TYPE_P(zProgressFunc))) && ((Z_TYPE_P(zpProgressData) == IS_STRING) || (Z_TYPE_P(zpProgressData) == IS_ARRAY) || (Z_TYPE_P(zpProgressData) == IS_NULL) || ((Z_TYPE_P(zpProgressData) == IS_OBJECT) && (Z_OBJCE_P(zpProgressData) == TSBPointer_ce_ptr))))
	{
		pzProgressFunc = SBSetEventData(zProgressFunc TSRMLS_CC);
		if (!SBGetPointerFromZVal(zpProgressData, &piProgressData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElCustomCryptoKey_Generate(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Bits, SBGetObjectHandle(oParams TSRMLS_CC), pzProgressFunc ? &TSBProgressFuncRaw : NULL, pzProgressFunc, piProgressData.data) TSRMLS_CC);
		SBFreePointerZValInfo(&piProgressData);
	}
	else
	{
		SBErrorExpectsArguments("(integer, TElRelativeDistinguishedName, TSBProgressFunc|callable|NULL, TSBPointer|array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCryptoKey, ImportPublic)
{
	long l4Size;
	SBArrayZValInfo piBuffer;
	zval *oParams;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlO!", &zpBuffer, &l4Size, &oParams, TElRelativeDistinguishedName_ce_ptr) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElCustomCryptoKey_ImportPublic(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, (int32_t)l4Size, SBGetObjectHandle(oParams TSRMLS_CC)) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer, TElRelativeDistinguishedName)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCryptoKey, ImportSecret)
{
	long l4Size;
	SBArrayZValInfo piBuffer;
	zval *oParams;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlO!", &zpBuffer, &l4Size, &oParams, TElRelativeDistinguishedName_ce_ptr) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElCustomCryptoKey_ImportSecret(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, (int32_t)l4Size, SBGetObjectHandle(oParams TSRMLS_CC)) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer, TElRelativeDistinguishedName)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCryptoKey, ExportPublic)
{
	int32_t l4SizeRaw;
	SBArrayZValInfo piBuffer;
	zval *oParams;
	zval *zl4Size;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zzO!", &zpBuffer, &zl4Size, &oParams, TElRelativeDistinguishedName_ce_ptr) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4Size) && (IS_LONG == Z_TYPE_P(zl4Size)))
	{
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		l4SizeRaw = (int32_t)Z_LVAL_P(zl4Size);
		SBCheckError(TElCustomCryptoKey_ExportPublic(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, &l4SizeRaw, SBGetObjectHandle(oParams TSRMLS_CC)) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
		ZVAL_LONG(zl4Size, (long)l4SizeRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, &integer, TElRelativeDistinguishedName)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCryptoKey, ExportSecret)
{
	int32_t l4SizeRaw;
	SBArrayZValInfo piBuffer;
	zval *oParams;
	zval *zl4Size;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zzO!", &zpBuffer, &zl4Size, &oParams, TElRelativeDistinguishedName_ce_ptr) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4Size) && (IS_LONG == Z_TYPE_P(zl4Size)))
	{
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		l4SizeRaw = (int32_t)Z_LVAL_P(zl4Size);
		SBCheckError(TElCustomCryptoKey_ExportSecret(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, &l4SizeRaw, SBGetObjectHandle(oParams TSRMLS_CC)) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
		ZVAL_LONG(zl4Size, (long)l4SizeRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, &integer, TElRelativeDistinguishedName)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCryptoKey, Clone)
{
	zval *oParams;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oParams, TElRelativeDistinguishedName_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCustomCryptoKey_Clone(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oParams TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomCryptoKey_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElRelativeDistinguishedName)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCryptoKey, ClonePublic)
{
	zval *oParams;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oParams, TElRelativeDistinguishedName_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCustomCryptoKey_ClonePublic(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oParams TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomCryptoKey_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElRelativeDistinguishedName)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCryptoKey, ClearPublic)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElCustomCryptoKey_ClearPublic(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCryptoKey, ClearSecret)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElCustomCryptoKey_ClearSecret(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCryptoKey, GetKeyProp)
{
	SBArrayZValInfo aiDefault;
	SBArrayZValInfo aiPropID;
	uint32_t _err;
	zval *zaDefault;
	zval *zaPropID;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zz", &zaPropID, &zaDefault) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaPropID)) || (IS_ARRAY == Z_TYPE_P(zaPropID)) || (IS_NULL == Z_TYPE_P(zaPropID))) && ((IS_STRING == Z_TYPE_P(zaDefault)) || (IS_ARRAY == Z_TYPE_P(zaDefault)) || (IS_NULL == Z_TYPE_P(zaDefault))))
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		if (!SBGetByteArrayFromZVal(zaPropID, &aiPropID TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaDefault, &aiDefault TSRMLS_CC)) RETURN_FALSE;
		_err = TElCustomCryptoKey_GetKeyProp(SBGetObjectHandle(getThis() TSRMLS_CC), aiPropID.data, aiPropID.len, aiDefault.data, aiDefault.len, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(357823112, 3, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiPropID);
		SBFreeArrayZValInfo(&aiDefault);
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCryptoKey, SetKeyProp)
{
	SBArrayZValInfo aiPropID;
	SBArrayZValInfo aiValue;
	zval *zaPropID;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zz", &zaPropID, &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaPropID)) || (IS_ARRAY == Z_TYPE_P(zaPropID)) || (IS_NULL == Z_TYPE_P(zaPropID))) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaPropID, &aiPropID TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElCustomCryptoKey_SetKeyProp(SBGetObjectHandle(getThis() TSRMLS_CC), aiPropID.data, aiPropID.len, aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiPropID);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCryptoKey, GetKeyObjectProp)
{
	SBArrayZValInfo aiPropID;
	zval *oDefault;
	zval *zaPropID;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zO!", &zaPropID, &oDefault, TObject_ce_ptr) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaPropID)) || (IS_ARRAY == Z_TYPE_P(zaPropID)) || (IS_NULL == Z_TYPE_P(zaPropID))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetByteArrayFromZVal(zaPropID, &aiPropID TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElCustomCryptoKey_GetKeyObjectProp(SBGetObjectHandle(getThis() TSRMLS_CC), aiPropID.data, aiPropID.len, SBGetObjectHandle(oDefault TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiPropID);
		SBInitObject(return_value, TObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, TObject)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCryptoKey, SetKeyObjectProp)
{
	SBArrayZValInfo aiPropID;
	zval *oValue;
	zval *zaPropID;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zO!", &zaPropID, &oValue, TObject_ce_ptr) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaPropID)) || (IS_ARRAY == Z_TYPE_P(zaPropID)) || (IS_NULL == Z_TYPE_P(zaPropID))))
	{
		if (!SBGetByteArrayFromZVal(zaPropID, &aiPropID TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElCustomCryptoKey_SetKeyObjectProp(SBGetObjectHandle(getThis() TSRMLS_CC), aiPropID.data, aiPropID.len, SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiPropID);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, TObject)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCryptoKey, ChangeAlgorithm)
{
	long l4Algorithm;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Algorithm) == SUCCESS)
	{
		SBCheckError(TElCustomCryptoKey_ChangeAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Algorithm) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCryptoKey, PrepareForEncryption)
{
	zend_bool bMultiUse;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bMultiUse) == SUCCESS)
	{
		SBCheckError(TElCustomCryptoKey_PrepareForEncryption(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bMultiUse) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCryptoKey, PrepareForSigning)
{
	zend_bool bMultiUse;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bMultiUse) == SUCCESS)
	{
		SBCheckError(TElCustomCryptoKey_PrepareForSigning(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bMultiUse) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCryptoKey, CancelPreparation)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElCustomCryptoKey_CancelPreparation(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCryptoKey, AsyncOperationFinished)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElCustomCryptoKey_AsyncOperationFinished(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCryptoKey, Equals)
{
	zend_bool bPublicOnly;
	zval *oKey;
	zval *oParams;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!bO!", &oKey, TElCustomCryptoKey_ce_ptr, &bPublicOnly, &oParams, TElRelativeDistinguishedName_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElCustomCryptoKey_Equals(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oKey TSRMLS_CC), (int8_t)bPublicOnly, SBGetObjectHandle(oParams TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCryptoKey, bool, TElRelativeDistinguishedName)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCryptoKey, Persistentiate)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElCustomCryptoKey_Persistentiate(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCryptoKey, get_IsPublic)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElCustomCryptoKey_get_IsPublic(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCryptoKey, get_IsSecret)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElCustomCryptoKey_get_IsSecret(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCryptoKey, get_IsExportable)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElCustomCryptoKey_get_IsExportable(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCryptoKey, get_IsPersistent)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElCustomCryptoKey_get_IsPersistent(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCryptoKey, get_IsValid)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElCustomCryptoKey_get_IsValid(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCryptoKey, get_Bits)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElCustomCryptoKey_get_Bits(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCryptoKey, get_Algorithm)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElCustomCryptoKey_get_Algorithm(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCryptoKey, get_Value)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElCustomCryptoKey_get_Value(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-1018985884, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCryptoKey, set_Value)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElCustomCryptoKey_set_Value(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCryptoKey, get_IV)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElCustomCryptoKey_get_IV(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-1797683558, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCryptoKey, set_IV)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElCustomCryptoKey_set_IV(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCryptoKey, get_Mode)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElCustomCryptoKey_get_Mode(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCryptoKey, set_Mode)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElCustomCryptoKey_set_Mode(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCryptoKey, get_CryptoProvider)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCustomCryptoKey_get_CryptoProvider(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomCryptoProvider_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCryptoKey, get_KeyStorage)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCustomCryptoKey_get_KeyStorage(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomCryptoKeyStorage_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCryptoKey, __construct)
{
	zval *oCryptoProvider;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCustomCryptoKey_Create(SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCryptoProvider)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCryptoKey_Reset, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCryptoKey_Generate, 0, 0, 4)
	ZEND_ARG_INFO(0, Bits)
	ZEND_ARG_OBJ_INFO(0, Params, TElRelativeDistinguishedName, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressFunc, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressData, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCryptoKey_ImportPublic, 0, 0, 3)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(0, Size)
	ZEND_ARG_OBJ_INFO(0, Params, TElRelativeDistinguishedName, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCryptoKey_ImportSecret, 0, 0, 3)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(0, Size)
	ZEND_ARG_OBJ_INFO(0, Params, TElRelativeDistinguishedName, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCryptoKey_ExportPublic, 0, 0, 3)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(1, Size)
	ZEND_ARG_OBJ_INFO(0, Params, TElRelativeDistinguishedName, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCryptoKey_ExportSecret, 0, 0, 3)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(1, Size)
	ZEND_ARG_OBJ_INFO(0, Params, TElRelativeDistinguishedName, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCryptoKey_Clone, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Params, TElRelativeDistinguishedName, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCryptoKey_ClonePublic, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Params, TElRelativeDistinguishedName, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCryptoKey_ClearPublic, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCryptoKey_ClearSecret, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCryptoKey_GetKeyProp, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, PropID, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Default, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCryptoKey_SetKeyProp, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, PropID, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCryptoKey_GetKeyObjectProp, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, PropID, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Default, TObject, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCryptoKey_SetKeyObjectProp, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, PropID, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TObject, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCryptoKey_ChangeAlgorithm, 0, 0, 1)
	ZEND_ARG_INFO(0, Algorithm)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCryptoKey_PrepareForEncryption, 0, 0, 1)
	ZEND_ARG_INFO(0, MultiUse)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCryptoKey_PrepareForSigning, 0, 0, 1)
	ZEND_ARG_INFO(0, MultiUse)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCryptoKey_CancelPreparation, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCryptoKey_AsyncOperationFinished, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCryptoKey_Equals, 0, 0, 3)
	ZEND_ARG_OBJ_INFO(0, Key, TElCustomCryptoKey, 1)
	ZEND_ARG_INFO(0, PublicOnly)
	ZEND_ARG_OBJ_INFO(0, Params, TElRelativeDistinguishedName, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCryptoKey_Persistentiate, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCryptoKey_get_IsPublic, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCryptoKey_get_IsSecret, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCryptoKey_get_IsExportable, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCryptoKey_get_IsPersistent, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCryptoKey_get_IsValid, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCryptoKey_get_Bits, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCryptoKey_get_Algorithm, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCryptoKey_get_Value, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCryptoKey_set_Value, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCryptoKey_get_IV, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCryptoKey_set_IV, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCryptoKey_get_Mode, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCryptoKey_set_Mode, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCryptoKey_get_CryptoProvider, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCryptoKey_get_KeyStorage, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCryptoKey___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, CryptoProvider, TElCustomCryptoProvider, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElCustomCryptoKey_methods[] = {
	PHP_ME(TElCustomCryptoKey, Reset, arginfo_TElCustomCryptoKey_Reset, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCryptoKey, Generate, arginfo_TElCustomCryptoKey_Generate, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCryptoKey, ImportPublic, arginfo_TElCustomCryptoKey_ImportPublic, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCryptoKey, ImportSecret, arginfo_TElCustomCryptoKey_ImportSecret, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCryptoKey, ExportPublic, arginfo_TElCustomCryptoKey_ExportPublic, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCryptoKey, ExportSecret, arginfo_TElCustomCryptoKey_ExportSecret, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCryptoKey, Clone, arginfo_TElCustomCryptoKey_Clone, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCryptoKey, ClonePublic, arginfo_TElCustomCryptoKey_ClonePublic, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCryptoKey, ClearPublic, arginfo_TElCustomCryptoKey_ClearPublic, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCryptoKey, ClearSecret, arginfo_TElCustomCryptoKey_ClearSecret, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCryptoKey, GetKeyProp, arginfo_TElCustomCryptoKey_GetKeyProp, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCryptoKey, SetKeyProp, arginfo_TElCustomCryptoKey_SetKeyProp, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCryptoKey, GetKeyObjectProp, arginfo_TElCustomCryptoKey_GetKeyObjectProp, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCryptoKey, SetKeyObjectProp, arginfo_TElCustomCryptoKey_SetKeyObjectProp, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCryptoKey, ChangeAlgorithm, arginfo_TElCustomCryptoKey_ChangeAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCryptoKey, PrepareForEncryption, arginfo_TElCustomCryptoKey_PrepareForEncryption, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCryptoKey, PrepareForSigning, arginfo_TElCustomCryptoKey_PrepareForSigning, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCryptoKey, CancelPreparation, arginfo_TElCustomCryptoKey_CancelPreparation, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCryptoKey, AsyncOperationFinished, arginfo_TElCustomCryptoKey_AsyncOperationFinished, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCryptoKey, Equals, arginfo_TElCustomCryptoKey_Equals, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCryptoKey, Persistentiate, arginfo_TElCustomCryptoKey_Persistentiate, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCryptoKey, get_IsPublic, arginfo_TElCustomCryptoKey_get_IsPublic, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCryptoKey, get_IsSecret, arginfo_TElCustomCryptoKey_get_IsSecret, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCryptoKey, get_IsExportable, arginfo_TElCustomCryptoKey_get_IsExportable, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCryptoKey, get_IsPersistent, arginfo_TElCustomCryptoKey_get_IsPersistent, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCryptoKey, get_IsValid, arginfo_TElCustomCryptoKey_get_IsValid, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCryptoKey, get_Bits, arginfo_TElCustomCryptoKey_get_Bits, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCryptoKey, get_Algorithm, arginfo_TElCustomCryptoKey_get_Algorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCryptoKey, get_Value, arginfo_TElCustomCryptoKey_get_Value, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCryptoKey, set_Value, arginfo_TElCustomCryptoKey_set_Value, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCryptoKey, get_IV, arginfo_TElCustomCryptoKey_get_IV, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCryptoKey, set_IV, arginfo_TElCustomCryptoKey_set_IV, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCryptoKey, get_Mode, arginfo_TElCustomCryptoKey_get_Mode, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCryptoKey, set_Mode, arginfo_TElCustomCryptoKey_set_Mode, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCryptoKey, get_CryptoProvider, arginfo_TElCustomCryptoKey_get_CryptoProvider, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCryptoKey, get_KeyStorage, arginfo_TElCustomCryptoKey_get_KeyStorage, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCryptoKey, __construct, arginfo_TElCustomCryptoKey___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElCustomCryptoKey(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElCustomCryptoKey_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElCustomCryptoKey", TElCustomCryptoKey_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElCustomCryptoKey_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElCustomCryptoContext_ce_ptr = NULL;

SB_PHP_METHOD(TElCustomCryptoContext, GetContextProp)
{
	SBArrayZValInfo aiDefault;
	SBArrayZValInfo aiPropID;
	uint32_t _err;
	zval *zaDefault;
	zval *zaPropID;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zz", &zaPropID, &zaDefault) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaPropID)) || (IS_ARRAY == Z_TYPE_P(zaPropID)) || (IS_NULL == Z_TYPE_P(zaPropID))) && ((IS_STRING == Z_TYPE_P(zaDefault)) || (IS_ARRAY == Z_TYPE_P(zaDefault)) || (IS_NULL == Z_TYPE_P(zaDefault))))
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		if (!SBGetByteArrayFromZVal(zaPropID, &aiPropID TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaDefault, &aiDefault TSRMLS_CC)) RETURN_FALSE;
		_err = TElCustomCryptoContext_GetContextProp(SBGetObjectHandle(getThis() TSRMLS_CC), aiPropID.data, aiPropID.len, aiDefault.data, aiDefault.len, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-243842912, 3, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiPropID);
		SBFreeArrayZValInfo(&aiDefault);
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCryptoContext, SetContextProp)
{
	SBArrayZValInfo aiPropID;
	SBArrayZValInfo aiValue;
	zval *zaPropID;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zz", &zaPropID, &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaPropID)) || (IS_ARRAY == Z_TYPE_P(zaPropID)) || (IS_NULL == Z_TYPE_P(zaPropID))) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaPropID, &aiPropID TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElCustomCryptoContext_SetContextProp(SBGetObjectHandle(getThis() TSRMLS_CC), aiPropID.data, aiPropID.len, aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiPropID);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCryptoContext, Clone)
{
	zval *oParams;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oParams, TElRelativeDistinguishedName_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCustomCryptoContext_Clone(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oParams TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomCryptoContext_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElRelativeDistinguishedName)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCryptoContext, EstimateOutputSize)
{
	long l8InSize;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l8InSize) == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElCustomCryptoContext_EstimateOutputSize(SBGetObjectHandle(getThis() TSRMLS_CC), (int64_t)l8InSize, &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCryptoContext, get_Algorithm)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElCustomCryptoContext_get_Algorithm(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCryptoContext, get_CryptoProvider)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCustomCryptoContext_get_CryptoProvider(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomCryptoProvider_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCryptoContext, get_KeySize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElCustomCryptoContext_get_KeySize(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCryptoContext, set_KeySize)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElCustomCryptoContext_set_KeySize(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCryptoContext, get_BlockSize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElCustomCryptoContext_get_BlockSize(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCryptoContext, set_BlockSize)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElCustomCryptoContext_set_BlockSize(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCryptoContext, get_DigestSize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElCustomCryptoContext_get_DigestSize(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCryptoContext, set_DigestSize)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElCustomCryptoContext_set_DigestSize(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCryptoContext, get_Mode)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElCustomCryptoContext_get_Mode(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCryptoContext, set_Mode)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElCustomCryptoContext_set_Mode(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCryptoContext, get_Padding)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElCustomCryptoContext_get_Padding(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCryptoContext, set_Padding)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElCustomCryptoContext_set_Padding(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCryptoContext, get_AlgorithmClass)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElCustomCryptoContext_get_AlgorithmClass(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCryptoContext, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCustomCryptoContext_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCryptoContext_GetContextProp, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, PropID, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Default, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCryptoContext_SetContextProp, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, PropID, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCryptoContext_Clone, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Params, TElRelativeDistinguishedName, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCryptoContext_EstimateOutputSize, 0, 0, 1)
	ZEND_ARG_INFO(0, InSize)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCryptoContext_get_Algorithm, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCryptoContext_get_CryptoProvider, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCryptoContext_get_KeySize, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCryptoContext_set_KeySize, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCryptoContext_get_BlockSize, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCryptoContext_set_BlockSize, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCryptoContext_get_DigestSize, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCryptoContext_set_DigestSize, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCryptoContext_get_Mode, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCryptoContext_set_Mode, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCryptoContext_get_Padding, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCryptoContext_set_Padding, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCryptoContext_get_AlgorithmClass, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCryptoContext___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElCustomCryptoContext_methods[] = {
	PHP_ME(TElCustomCryptoContext, GetContextProp, arginfo_TElCustomCryptoContext_GetContextProp, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCryptoContext, SetContextProp, arginfo_TElCustomCryptoContext_SetContextProp, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCryptoContext, Clone, arginfo_TElCustomCryptoContext_Clone, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCryptoContext, EstimateOutputSize, arginfo_TElCustomCryptoContext_EstimateOutputSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCryptoContext, get_Algorithm, arginfo_TElCustomCryptoContext_get_Algorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCryptoContext, get_CryptoProvider, arginfo_TElCustomCryptoContext_get_CryptoProvider, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCryptoContext, get_KeySize, arginfo_TElCustomCryptoContext_get_KeySize, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCryptoContext, set_KeySize, arginfo_TElCustomCryptoContext_set_KeySize, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCryptoContext, get_BlockSize, arginfo_TElCustomCryptoContext_get_BlockSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCryptoContext, set_BlockSize, arginfo_TElCustomCryptoContext_set_BlockSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCryptoContext, get_DigestSize, arginfo_TElCustomCryptoContext_get_DigestSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCryptoContext, set_DigestSize, arginfo_TElCustomCryptoContext_set_DigestSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCryptoContext, get_Mode, arginfo_TElCustomCryptoContext_get_Mode, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCryptoContext, set_Mode, arginfo_TElCustomCryptoContext_set_Mode, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCryptoContext, get_Padding, arginfo_TElCustomCryptoContext_get_Padding, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCryptoContext, set_Padding, arginfo_TElCustomCryptoContext_set_Padding, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCryptoContext, get_AlgorithmClass, arginfo_TElCustomCryptoContext_get_AlgorithmClass, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCryptoContext, __construct, arginfo_TElCustomCryptoContext___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElCustomCryptoContext(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElCustomCryptoContext_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElCustomCryptoContext", TElCustomCryptoContext_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElCustomCryptoContext_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElCustomCryptoProviderOptions_ce_ptr = NULL;

SB_PHP_METHOD(TElCustomCryptoProviderOptions, Assign)
{
	zval *oOptions;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oOptions, TElCustomCryptoProviderOptions_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElCustomCryptoProviderOptions_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oOptions TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCryptoProviderOptions)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCryptoProviderOptions, get_MaxPublicKeySize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElCustomCryptoProviderOptions_get_MaxPublicKeySize(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCryptoProviderOptions, set_MaxPublicKeySize)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElCustomCryptoProviderOptions_set_MaxPublicKeySize(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCryptoProviderOptions, get_StoreKeys)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElCustomCryptoProviderOptions_get_StoreKeys(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCryptoProviderOptions, set_StoreKeys)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElCustomCryptoProviderOptions_set_StoreKeys(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCryptoProviderOptions, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCustomCryptoProviderOptions_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCryptoProviderOptions_Assign, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Options, TElCustomCryptoProviderOptions, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCryptoProviderOptions_get_MaxPublicKeySize, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCryptoProviderOptions_set_MaxPublicKeySize, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCryptoProviderOptions_get_StoreKeys, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCryptoProviderOptions_set_StoreKeys, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCryptoProviderOptions___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElCustomCryptoProviderOptions_methods[] = {
	PHP_ME(TElCustomCryptoProviderOptions, Assign, arginfo_TElCustomCryptoProviderOptions_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCryptoProviderOptions, get_MaxPublicKeySize, arginfo_TElCustomCryptoProviderOptions_get_MaxPublicKeySize, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCryptoProviderOptions, set_MaxPublicKeySize, arginfo_TElCustomCryptoProviderOptions_set_MaxPublicKeySize, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCryptoProviderOptions, get_StoreKeys, arginfo_TElCustomCryptoProviderOptions_get_StoreKeys, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCryptoProviderOptions, set_StoreKeys, arginfo_TElCustomCryptoProviderOptions_set_StoreKeys, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCryptoProviderOptions, __construct, arginfo_TElCustomCryptoProviderOptions___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElCustomCryptoProviderOptions(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElCustomCryptoProviderOptions_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElCustomCryptoProviderOptions", TElCustomCryptoProviderOptions_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElCustomCryptoProviderOptions_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElBlackboxCryptoProvider_ce_ptr = NULL;

SB_PHP_METHOD(TElBlackboxCryptoProvider, ClassType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBlackboxCryptoProvider_ClassType(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TClass_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBlackboxCryptoProvider, __construct)
{
	zval *oAOwner;
	zval *oOptions;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBlackboxCryptoProvider_Create(SBGetObjectHandle(oAOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oOptions, TElCustomCryptoProviderOptions_ce_ptr, &oAOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBlackboxCryptoProvider_Create_1(SBGetObjectHandle(oOptions TSRMLS_CC), SBGetObjectHandle(oAOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent) or (TElCustomCryptoProviderOptions, TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBlackboxCryptoProvider_ClassType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBlackboxCryptoProvider___construct, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, AOwner_or_Options, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AOwner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElBlackboxCryptoProvider_methods[] = {
	PHP_ME(TElBlackboxCryptoProvider, ClassType, arginfo_TElBlackboxCryptoProvider_ClassType, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElBlackboxCryptoProvider, __construct, arginfo_TElBlackboxCryptoProvider___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElBlackboxCryptoProvider(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElBlackboxCryptoProvider_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElBlackboxCryptoProvider", TElBlackboxCryptoProvider_methods);
	if (NULL == TElCustomCryptoProvider_ce_ptr)
		Register_TElCustomCryptoProvider(TSRMLS_C);
	TElBlackboxCryptoProvider_ce_ptr = zend_register_internal_class_ex(&ce, TElCustomCryptoProvider_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElExternalCryptoProvider_ce_ptr = NULL;

SB_PHP_METHOD(TElExternalCryptoProvider, ClassType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElExternalCryptoProvider_ClassType(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TClass_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElExternalCryptoProvider, __construct)
{
	zval *oAOwner;
	zval *oOptions;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElExternalCryptoProvider_Create(SBGetObjectHandle(oAOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oOptions, TElCustomCryptoProviderOptions_ce_ptr, &oAOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElExternalCryptoProvider_Create_1(SBGetObjectHandle(oOptions TSRMLS_CC), SBGetObjectHandle(oAOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent) or (TElCustomCryptoProviderOptions, TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElExternalCryptoProvider_ClassType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElExternalCryptoProvider___construct, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, AOwner_or_Options, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AOwner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElExternalCryptoProvider_methods[] = {
	PHP_ME(TElExternalCryptoProvider, ClassType, arginfo_TElExternalCryptoProvider_ClassType, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElExternalCryptoProvider, __construct, arginfo_TElExternalCryptoProvider___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElExternalCryptoProvider(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElExternalCryptoProvider_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElExternalCryptoProvider", TElExternalCryptoProvider_methods);
	if (NULL == TElBlackboxCryptoProvider_ce_ptr)
		Register_TElBlackboxCryptoProvider(TSRMLS_C);
	TElExternalCryptoProvider_ce_ptr = zend_register_internal_class_ex(&ce, TElBlackboxCryptoProvider_ce_ptr, NULL TSRMLS_CC);
}

void Register_SBCryptoProv_Constants(int module_number TSRMLS_DC)
{
	SB_REGISTER_LONG_CONSTANT(SBCryptoProv, SB_ALGCLASS_NONE, SB_ALGCLASS_NONE, SB_ALGCLASS_NONE);
	SB_REGISTER_LONG_CONSTANT(SBCryptoProv, SB_ALGCLASS_BLOCK, SB_ALGCLASS_BLOCK, SB_ALGCLASS_BLOCK);
	SB_REGISTER_LONG_CONSTANT(SBCryptoProv, SB_ALGCLASS_STREAM, SB_ALGCLASS_STREAM, SB_ALGCLASS_STREAM);
	SB_REGISTER_LONG_CONSTANT(SBCryptoProv, SB_ALGCLASS_PUBLICKEY, SB_ALGCLASS_PUBLICKEY, SB_ALGCLASS_PUBLICKEY);
	SB_REGISTER_LONG_CONSTANT(SBCryptoProv, SB_ALGCLASS_HASH, SB_ALGCLASS_HASH, SB_ALGCLASS_HASH);
	SB_REGISTER_LONG_CONSTANT(SBCryptoProv, SB_SYMENC_MODE_DEFAULT, SB_SYMENC_MODE_DEFAULT, SB_SYMENC_MODE_DEFAULT);
	SB_REGISTER_LONG_CONSTANT(SBCryptoProv, SB_SYMENC_MODE_BLOCK, SB_SYMENC_MODE_BLOCK, SB_SYMENC_MODE_BLOCK);
	SB_REGISTER_LONG_CONSTANT(SBCryptoProv, SB_SYMENC_MODE_CBC, SB_SYMENC_MODE_CBC, SB_SYMENC_MODE_CBC);
	SB_REGISTER_LONG_CONSTANT(SBCryptoProv, SB_SYMENC_MODE_CFB8, SB_SYMENC_MODE_CFB8, SB_SYMENC_MODE_CFB8);
	SB_REGISTER_LONG_CONSTANT(SBCryptoProv, SB_SYMENC_MODE_CTR, SB_SYMENC_MODE_CTR, SB_SYMENC_MODE_CTR);
	SB_REGISTER_LONG_CONSTANT(SBCryptoProv, SB_SYMENC_MODE_ECB, SB_SYMENC_MODE_ECB, SB_SYMENC_MODE_ECB);
	SB_REGISTER_LONG_CONSTANT(SBCryptoProv, SB_SYMENC_MODE_CCM, SB_SYMENC_MODE_CCM, SB_SYMENC_MODE_CCM);
	SB_REGISTER_LONG_CONSTANT(SBCryptoProv, SB_SYMENC_MODE_GCM, SB_SYMENC_MODE_GCM, SB_SYMENC_MODE_GCM);
	SB_REGISTER_LONG_CONSTANT(SBCryptoProv, SB_SYMENC_MODE_AEADCHACHA20POLY1305, SB_SYMENC_MODE_AEADCHACHA20POLY1305, SB_SYMENC_MODE_AEADCHACHA20POLY1305);
	SB_REGISTER_LONG_CONSTANT(SBCryptoProv, SB_SYMENC_PADDING_NONE, SB_SYMENC_PADDING_NONE, SB_SYMENC_PADDING_NONE);
	SB_REGISTER_LONG_CONSTANT(SBCryptoProv, SB_SYMENC_PADDING_PKCS5, SB_SYMENC_PADDING_PKCS5, SB_SYMENC_PADDING_PKCS5);
	SB_REGISTER_LONG_CONSTANT(SBCryptoProv, SB_SYMENC_PADDING_ANSIX923, SB_SYMENC_PADDING_ANSIX923, SB_SYMENC_PADDING_ANSIX923);
	SB_REGISTER_LONG_CONSTANT(SBCryptoProv, SB_VR_SUCCESS, SB_VR_SUCCESS, SB_VR_SUCCESS);
	SB_REGISTER_LONG_CONSTANT(SBCryptoProv, SB_VR_INVALID_SIGNATURE, SB_VR_INVALID_SIGNATURE, SB_VR_INVALID_SIGNATURE);
	SB_REGISTER_LONG_CONSTANT(SBCryptoProv, SB_VR_KEY_NOT_FOUND, SB_VR_KEY_NOT_FOUND, SB_VR_KEY_NOT_FOUND);
	SB_REGISTER_LONG_CONSTANT(SBCryptoProv, SB_VR_FAILURE, SB_VR_FAILURE, SB_VR_FAILURE);
	SB_REGISTER_LONG_CONSTANT(SBCryptoProv, SB_OPTYPE_NONE, SB_OPTYPE_NONE, SB_OPTYPE_NONE);
	SB_REGISTER_LONG_CONSTANT(SBCryptoProv, SB_OPTYPE_ENCRYPT, SB_OPTYPE_ENCRYPT, SB_OPTYPE_ENCRYPT);
	SB_REGISTER_LONG_CONSTANT(SBCryptoProv, SB_OPTYPE_DECRYPT, SB_OPTYPE_DECRYPT, SB_OPTYPE_DECRYPT);
	SB_REGISTER_LONG_CONSTANT(SBCryptoProv, SB_OPTYPE_SIGN, SB_OPTYPE_SIGN, SB_OPTYPE_SIGN);
	SB_REGISTER_LONG_CONSTANT(SBCryptoProv, SB_OPTYPE_SIGN_DETACHED, SB_OPTYPE_SIGN_DETACHED, SB_OPTYPE_SIGN_DETACHED);
	SB_REGISTER_LONG_CONSTANT(SBCryptoProv, SB_OPTYPE_VERIFY, SB_OPTYPE_VERIFY, SB_OPTYPE_VERIFY);
	SB_REGISTER_LONG_CONSTANT(SBCryptoProv, SB_OPTYPE_VERIFY_DETACHED, SB_OPTYPE_VERIFY_DETACHED, SB_OPTYPE_VERIFY_DETACHED);
	SB_REGISTER_LONG_CONSTANT(SBCryptoProv, SB_OPTYPE_HASH, SB_OPTYPE_HASH, SB_OPTYPE_HASH);
	SB_REGISTER_LONG_CONSTANT(SBCryptoProv, SB_OPTYPE_KEY_GENERATE, SB_OPTYPE_KEY_GENERATE, SB_OPTYPE_KEY_GENERATE);
	SB_REGISTER_LONG_CONSTANT(SBCryptoProv, SB_OPTYPE_KEY_DECRYPT, SB_OPTYPE_KEY_DECRYPT, SB_OPTYPE_KEY_DECRYPT);
	SB_REGISTER_LONG_CONSTANT(SBCryptoProv, SB_OPTYPE_RANDOM, SB_OPTYPE_RANDOM, SB_OPTYPE_RANDOM);
	SB_REGISTER_LONG_CONSTANT(SBCryptoProv, SB_OPTYPE_KEY_CREATE, SB_OPTYPE_KEY_CREATE, SB_OPTYPE_KEY_CREATE);
	SB_REGISTER_LONG_CONSTANT(SBCryptoProv, SB_OPTYPE_KEYSTORAGE_CREATE, SB_OPTYPE_KEYSTORAGE_CREATE, SB_OPTYPE_KEYSTORAGE_CREATE);
	SB_REGISTER_LONG_CONSTANT(SBCryptoProv, ERROR_FACILITY_CRYPTOPROV, SB_ERROR_FACILITY_CRYPTOPROV, SB_ERROR_FACILITY_CRYPTOPROV);
	SB_REGISTER_LONG_CONSTANT(SBCryptoProv, ERROR_CRYPTOPROV_ERROR_FLAG, SB_ERROR_CRYPTOPROV_ERROR_FLAG, SB_ERROR_CRYPTOPROV_ERROR_FLAG);
	SB_REGISTER_LONG_CONSTANT(SBCryptoProv, ERROR_CP_NOT_INITIALIZED, SB_ERROR_CP_NOT_INITIALIZED, SB_ERROR_CP_NOT_INITIALIZED);
	SB_REGISTER_LONG_CONSTANT(SBCryptoProv, ERROR_CP_FEATURE_NOT_SUPPORTED, SB_ERROR_CP_FEATURE_NOT_SUPPORTED, SB_ERROR_CP_FEATURE_NOT_SUPPORTED);
	SB_REGISTER_LONG_CONSTANT(SBCryptoProv, ERROR_CP_OPERATION_NOT_SUPPORTED, SB_ERROR_CP_OPERATION_NOT_SUPPORTED, SB_ERROR_CP_OPERATION_NOT_SUPPORTED);
	SB_REGISTER_LONG_CONSTANT(SBCryptoProv, ERROR_CP_METHOD_NOT_IMPLEMENTED, SB_ERROR_CP_METHOD_NOT_IMPLEMENTED, SB_ERROR_CP_METHOD_NOT_IMPLEMENTED);
	SB_REGISTER_LONG_CONSTANT(SBCryptoProv, ERROR_CP_INVALID_KEY_PROP, SB_ERROR_CP_INVALID_KEY_PROP, SB_ERROR_CP_INVALID_KEY_PROP);
	SB_REGISTER_LONG_CONSTANT(SBCryptoProv, ERROR_CP_INVALID_KEY_MATERIAL, SB_ERROR_CP_INVALID_KEY_MATERIAL, SB_ERROR_CP_INVALID_KEY_MATERIAL);
	SB_REGISTER_LONG_CONSTANT(SBCryptoProv, ERROR_CP_INVALID_KEY_SIZE, SB_ERROR_CP_INVALID_KEY_SIZE, SB_ERROR_CP_INVALID_KEY_SIZE);
	SB_REGISTER_LONG_CONSTANT(SBCryptoProv, ERROR_CP_INVALID_IV_SIZE, SB_ERROR_CP_INVALID_IV_SIZE, SB_ERROR_CP_INVALID_IV_SIZE);
	SB_REGISTER_LONG_CONSTANT(SBCryptoProv, ERROR_CP_INVALID_ALG, SB_ERROR_CP_INVALID_ALG, SB_ERROR_CP_INVALID_ALG);
	SB_REGISTER_LONG_CONSTANT(SBCryptoProv, ERROR_CP_INVALID_CONTEXT, SB_ERROR_CP_INVALID_CONTEXT, SB_ERROR_CP_INVALID_CONTEXT);
	SB_REGISTER_LONG_CONSTANT(SBCryptoProv, ERROR_CP_INVALID_CRYPTOPROV, SB_ERROR_CP_INVALID_CRYPTOPROV, SB_ERROR_CP_INVALID_CRYPTOPROV);
	SB_REGISTER_LONG_CONSTANT(SBCryptoProv, ERROR_CP_INVALID_MODE, SB_ERROR_CP_INVALID_MODE, SB_ERROR_CP_INVALID_MODE);
	SB_REGISTER_LONG_CONSTANT(SBCryptoProv, ERROR_CP_INVALID_PROP_VALUE, SB_ERROR_CP_INVALID_PROP_VALUE, SB_ERROR_CP_INVALID_PROP_VALUE);
	SB_REGISTER_LONG_CONSTANT(SBCryptoProv, ERROR_CP_INVALID_PADDING, SB_ERROR_CP_INVALID_PADDING, SB_ERROR_CP_INVALID_PADDING);
	SB_REGISTER_LONG_CONSTANT(SBCryptoProv, ERROR_CP_INVALID_OPERATION, SB_ERROR_CP_INVALID_OPERATION, SB_ERROR_CP_INVALID_OPERATION);
	SB_REGISTER_LONG_CONSTANT(SBCryptoProv, ERROR_CP_BUFFER_TOO_SMALL, SB_ERROR_CP_BUFFER_TOO_SMALL, SB_ERROR_CP_BUFFER_TOO_SMALL);
	SB_REGISTER_LONG_CONSTANT(SBCryptoProv, ERROR_CP_UNSUPPORTED_ALGORITHM, SB_ERROR_CP_UNSUPPORTED_ALGORITHM, SB_ERROR_CP_UNSUPPORTED_ALGORITHM);
	SB_REGISTER_LONG_CONSTANT(SBCryptoProv, ERROR_CP_UNSUPPORTED_PROPERTY, SB_ERROR_CP_UNSUPPORTED_PROPERTY, SB_ERROR_CP_UNSUPPORTED_PROPERTY);
	SB_REGISTER_LONG_CONSTANT(SBCryptoProv, ERROR_CP_UNSUPPORTED_PROP_VALUE, SB_ERROR_CP_UNSUPPORTED_PROP_VALUE, SB_ERROR_CP_UNSUPPORTED_PROP_VALUE);
	SB_REGISTER_LONG_CONSTANT(SBCryptoProv, ERROR_CP_UNSUPPORTED_PROVIDER, SB_ERROR_CP_UNSUPPORTED_PROVIDER, SB_ERROR_CP_UNSUPPORTED_PROVIDER);
	SB_REGISTER_LONG_CONSTANT(SBCryptoProv, ERROR_CP_UNSUPPORTED_KEY_FORMAT, SB_ERROR_CP_UNSUPPORTED_KEY_FORMAT, SB_ERROR_CP_UNSUPPORTED_KEY_FORMAT);
	SB_REGISTER_LONG_CONSTANT(SBCryptoProv, ERROR_CP_INSTANTIATION_FAILED, SB_ERROR_CP_INSTANTIATION_FAILED, SB_ERROR_CP_INSTANTIATION_FAILED);
	SB_REGISTER_LONG_CONSTANT(SBCryptoProv, ERROR_CP_CANT_UNREG_DEFAULT, SB_ERROR_CP_CANT_UNREG_DEFAULT, SB_ERROR_CP_CANT_UNREG_DEFAULT);
	SB_REGISTER_LONG_CONSTANT(SBCryptoProv, ERROR_CP_NO_SUITABLE_PROV, SB_ERROR_CP_NO_SUITABLE_PROV, SB_ERROR_CP_NO_SUITABLE_PROV);
	SB_REGISTER_LONG_CONSTANT(SBCryptoProv, ERROR_CP_CANT_CHANGE_ALG, SB_ERROR_CP_CANT_CHANGE_ALG, SB_ERROR_CP_CANT_CHANGE_ALG);
	SB_REGISTER_LONG_CONSTANT(SBCryptoProv, ERROR_CP_UNKNOWN_ALG_PROP, SB_ERROR_CP_UNKNOWN_ALG_PROP, SB_ERROR_CP_UNKNOWN_ALG_PROP);
	SB_REGISTER_LONG_CONSTANT(SBCryptoProv, ERROR_CP_CANT_CHANGE_RO_PROP, SB_ERROR_CP_CANT_CHANGE_RO_PROP, SB_ERROR_CP_CANT_CHANGE_RO_PROP);
	SB_REGISTER_LONG_CONSTANT(SBCryptoProv, ERROR_CP_WRONG_CONTEXT_TYPE, SB_ERROR_CP_WRONG_CONTEXT_TYPE, SB_ERROR_CP_WRONG_CONTEXT_TYPE);
	SB_REGISTER_LONG_CONSTANT(SBCryptoProv, ERROR_CP_CANT_CLONE_CONTEXT, SB_ERROR_CP_CANT_CLONE_CONTEXT, SB_ERROR_CP_CANT_CLONE_CONTEXT);
	SB_REGISTER_LONG_CONSTANT(SBCryptoProv, ERROR_CP_PRIMITIVE_OP_FAILED, SB_ERROR_CP_PRIMITIVE_OP_FAILED, SB_ERROR_CP_PRIMITIVE_OP_FAILED);
	SB_REGISTER_LONG_CONSTANT(SBCryptoProv, ERROR_CP_KEY_GENERATION_FAILED, SB_ERROR_CP_KEY_GENERATION_FAILED, SB_ERROR_CP_KEY_GENERATION_FAILED);
	SB_REGISTER_LONG_CONSTANT(SBCryptoProv, ERROR_CP_KEY_ALREADY_PREPARED, SB_ERROR_CP_KEY_ALREADY_PREPARED, SB_ERROR_CP_KEY_ALREADY_PREPARED);
	SB_REGISTER_LONG_CONSTANT(SBCryptoProv, ERROR_CP_KEY_NOT_PREPARED, SB_ERROR_CP_KEY_NOT_PREPARED, SB_ERROR_CP_KEY_NOT_PREPARED);
	SB_REGISTER_LONG_CONSTANT(SBCryptoProv, ERROR_CP_KEY_NOT_FOUND, SB_ERROR_CP_KEY_NOT_FOUND, SB_ERROR_CP_KEY_NOT_FOUND);
	SB_REGISTER_LONG_CONSTANT(SBCryptoProv, ERROR_CP_IV_NOT_FOUND, SB_ERROR_CP_IV_NOT_FOUND, SB_ERROR_CP_IV_NOT_FOUND);
	SB_REGISTER_LONG_CONSTANT(SBCryptoProv, ERROR_CP_WRONG_INPUT_SIZE, SB_ERROR_CP_WRONG_INPUT_SIZE, SB_ERROR_CP_WRONG_INPUT_SIZE);
	SB_REGISTER_LONG_CONSTANT(SBCryptoProv, ERROR_CP_INTERRUPTED_BY_USER, SB_ERROR_CP_INTERRUPTED_BY_USER, SB_ERROR_CP_INTERRUPTED_BY_USER);
	SB_REGISTER_LONG_CONSTANT(SBCryptoProv, ERROR_CP_WRONG_OBJECT_TYPE, SB_ERROR_CP_WRONG_OBJECT_TYPE, SB_ERROR_CP_WRONG_OBJECT_TYPE);
	SB_REGISTER_LONG_CONSTANT(SBCryptoProv, ERROR_CP_WRONG_KEY_TYPE, SB_ERROR_CP_WRONG_KEY_TYPE, SB_ERROR_CP_WRONG_KEY_TYPE);
	SB_REGISTER_LONG_CONSTANT(SBCryptoProv, ERROR_CP_NO_SESSION, SB_ERROR_CP_NO_SESSION, SB_ERROR_CP_NO_SESSION);
	SB_REGISTER_LONG_CONSTANT(SBCryptoProv, ERROR_CP_NO_MODULE, SB_ERROR_CP_NO_MODULE, SB_ERROR_CP_NO_MODULE);
	SB_REGISTER_LONG_CONSTANT(SBCryptoProv, ERROR_CP_NO_DRIVER, SB_ERROR_CP_NO_DRIVER, SB_ERROR_CP_NO_DRIVER);
	SB_REGISTER_LONG_CONSTANT(SBCryptoProv, ERROR_CP_KEY_NOT_EXPORTABLE, SB_ERROR_CP_KEY_NOT_EXPORTABLE, SB_ERROR_CP_KEY_NOT_EXPORTABLE);
	SB_REGISTER_LONG_CONSTANT(SBCryptoProv, ERROR_CP_OBJECT_ACQUIRED, SB_ERROR_CP_OBJECT_ACQUIRED, SB_ERROR_CP_OBJECT_ACQUIRED);
	SB_REGISTER_LONG_CONSTANT(SBCryptoProv, ERROR_CP_OBJECT_PERSISTENT, SB_ERROR_CP_OBJECT_PERSISTENT, SB_ERROR_CP_OBJECT_PERSISTENT);
	SB_REGISTER_LONG_CONSTANT(SBCryptoProv, ERROR_CP_BAD_DATA_FORMAT, SB_ERROR_CP_BAD_DATA_FORMAT, SB_ERROR_CP_BAD_DATA_FORMAT);
	SB_REGISTER_LONG_CONSTANT(SBCryptoProv, ERROR_CP_DATA_TOO_LARGE, SB_ERROR_CP_DATA_TOO_LARGE, SB_ERROR_CP_DATA_TOO_LARGE);
	SB_REGISTER_LONG_CONSTANT(SBCryptoProv, ERROR_CP_DECRYPTION_FAILED, SB_ERROR_CP_DECRYPTION_FAILED, SB_ERROR_CP_DECRYPTION_FAILED);
	SB_REGISTER_LONG_CONSTANT(SBCryptoProv, ERROR_CP_SIGNING_FAILED, SB_ERROR_CP_SIGNING_FAILED, SB_ERROR_CP_SIGNING_FAILED);
	SB_REGISTER_LONG_CONSTANT(SBCryptoProv, ERROR_CP_ELEVATION_NEEDED, SB_ERROR_CP_ELEVATION_NEEDED, SB_ERROR_CP_ELEVATION_NEEDED);
	SB_REGISTER_LONG_CONSTANT(SBCryptoProv, ERROR_CP_BACKEND_ERROR, SB_ERROR_CP_BACKEND_ERROR, SB_ERROR_CP_BACKEND_ERROR);
	SB_REGISTER_LONG_CONSTANT(SBCryptoProv, ERROR_CP_CONTEXT_NOT_ACQUIRED, SB_ERROR_CP_CONTEXT_NOT_ACQUIRED, SB_ERROR_CP_CONTEXT_NOT_ACQUIRED);
	SB_REGISTER_LONG_CONSTANT(SBCryptoProv, SB_CRYPTOPROV_GENERAL_ERROR, SB_CRYPTOPROV_GENERAL_ERROR, SB_CRYPTOPROV_GENERAL_ERROR);
}

void Register_SBCryptoProv_Aliases(TSRMLS_D)
{
	if (NULL == TElRelativeDistinguishedName_ce_ptr)
		Register_TElRelativeDistinguishedName(TSRMLS_C);
	zend_register_class_alias("TElCPParameters", TElRelativeDistinguishedName_ce_ptr);
	TElCustomCryptoProviderClass_ce_ptr = TObject_ce_ptr;
	zend_register_class_alias("TElCustomCryptoProviderClass", TElCustomCryptoProviderClass_ce_ptr);
}

