#include "sbonedrivedatastorage.h"

zend_class_entry *TElOneDriveDataStorage_ce_ptr = NULL;

SB_PHP_METHOD(TElOneDriveDataStorage, StartAuthorization)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElOneDriveDataStorage_StartAuthorization(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-20432854, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveDataStorage, CompleteAuthorization)
{
	char *sAuthorizationCode;
	int sAuthorizationCode_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sAuthorizationCode, &sAuthorizationCode_len) == SUCCESS)
	{
		SBCheckError(TElOneDriveDataStorage_CompleteAuthorization(SBGetObjectHandle(getThis() TSRMLS_CC), sAuthorizationCode, (int32_t)sAuthorizationCode_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveDataStorage, AcquireObject)
{
	char *sObjectID;
	int sObjectID_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sObjectID, &sObjectID_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOneDriveDataStorage_AcquireObject(SBGetObjectHandle(getThis() TSRMLS_CC), sObjectID, (int32_t)sObjectID_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElOneDriveDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOneDriveDataStorage_AcquireObject_1(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string) or ()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveDataStorage, CloseSession)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElOneDriveDataStorage_CloseSession(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveDataStorage, CopyObject)
{
	zval *oDestination;
	zval *oNewHandler;
	zval *oObj;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oObj, TElOneDriveDataStorageObject_ce_ptr, &oDestination, TElOneDriveFolder_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOneDriveDataStorage_CopyObject(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObj TSRMLS_CC), SBGetObjectHandle(oDestination TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElOneDriveDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oObj, TElCustomDataStorageObject_ce_ptr, &oNewHandler, TElCustomDataStorageSecurityHandler_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOneDriveDataStorage_CopyObject_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObj TSRMLS_CC), SBGetObjectHandle(oNewHandler TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElOneDriveDataStorageObject, TElOneDriveFolder) or (TElCustomDataStorageObject, TElCustomDataStorageSecurityHandler)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveDataStorage, CreateFolder)
{
	char *sDescription;
	char *sName;
	int sDescription_len;
	int sName_len;
	zval *oParent;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!ss", &oParent, TElOneDriveFolder_ce_ptr, &sName, &sName_len, &sDescription, &sDescription_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOneDriveDataStorage_CreateFolder(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oParent TSRMLS_CC), sName, (int32_t)sName_len, sDescription, (int32_t)sDescription_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElOneDriveFolder_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElOneDriveFolder, string, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveDataStorage, CreateObject)
{
	char *sName;
	int sName_len;
	zend_bool bOverwriteIfExists;
	zval *oHandler;
	zval *oParent;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!sb", &oParent, TElOneDriveFolder_ce_ptr, &sName, &sName_len, &bOverwriteIfExists) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOneDriveDataStorage_CreateObject(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oParent TSRMLS_CC), sName, (int32_t)sName_len, (int8_t)bOverwriteIfExists, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElOneDriveFile_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!sbO!", &oParent, TElOneDriveFolder_ce_ptr, &sName, &sName_len, &bOverwriteIfExists, &oHandler, TElCustomDataStorageSecurityHandler_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOneDriveDataStorage_CreateObject_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oParent TSRMLS_CC), sName, (int32_t)sName_len, (int8_t)bOverwriteIfExists, SBGetObjectHandle(oHandler TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElOneDriveFile_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElOneDriveFolder, string, bool) or (TElOneDriveFolder, string, bool, TElCustomDataStorageSecurityHandler)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveDataStorage, GetQuota)
{
	int64_t l8FreeRaw = 0;
	int64_t l8TotalRaw = 0;
	zval *zl8Free;
	zval *zl8Total;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zz", &zl8Total, &zl8Free) == SUCCESS) && PZVAL_IS_REF(zl8Total) && (IS_LONG == Z_TYPE_P(zl8Total)) && PZVAL_IS_REF(zl8Free) && (IS_LONG == Z_TYPE_P(zl8Free)))
	{
		SBCheckError(TElOneDriveDataStorage_GetQuota(SBGetObjectHandle(getThis() TSRMLS_CC), &l8TotalRaw, &l8FreeRaw) TSRMLS_CC);
		ZVAL_LONG(zl8Total, (long)l8TotalRaw);
		ZVAL_LONG(zl8Free, (long)l8FreeRaw);
	}
	else
	{
		SBErrorExpectsArguments("(&integer, &integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveDataStorage, GetUserInfo)
{
	char *sUserID;
	int sUserID_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOneDriveDataStorage_GetUserInfo(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElOneDriveUserInfo_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sUserID, &sUserID_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOneDriveDataStorage_GetUserInfo_1(SBGetObjectHandle(getThis() TSRMLS_CC), sUserID, (int32_t)sUserID_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElOneDriveUserInfo_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("() or (string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveDataStorage, List)
{
	zval *oDir;
	zval *oObjects;
	zval *oObjs;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oDir, TElOneDriveFolder_ce_ptr, &oObjects, TElDataStorageObjectList_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElOneDriveDataStorage_List(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDir TSRMLS_CC), SBGetObjectHandle(oObjects TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oObjs, TElDataStorageObjectList_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElOneDriveDataStorage_List_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObjs TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElOneDriveFolder, TElDataStorageObjectList) or (TElDataStorageObjectList)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveDataStorage, ListFriendly)
{
	char *sFriendlyName;
	int sFriendlyName_len;
	zval *oObjects;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &sFriendlyName, &sFriendlyName_len, &oObjects, TElDataStorageObjectList_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElOneDriveDataStorage_ListFriendly(SBGetObjectHandle(getThis() TSRMLS_CC), sFriendlyName, (int32_t)sFriendlyName_len, SBGetObjectHandle(oObjects TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, TElDataStorageObjectList)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveDataStorage, ListRecent)
{
	zval *oObjects;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oObjects, TElDataStorageObjectList_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElOneDriveDataStorage_ListRecent(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObjects TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElDataStorageObjectList)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveDataStorage, ListShared)
{
	zval *oObjects;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oObjects, TElDataStorageObjectList_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElOneDriveDataStorage_ListShared(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObjects TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElDataStorageObjectList)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveDataStorage, MoveObject)
{
	zval *oDestination;
	zval *oObj;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oObj, TElOneDriveDataStorageObject_ce_ptr, &oDestination, TElOneDriveFolder_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElOneDriveDataStorage_MoveObject(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObj TSRMLS_CC), SBGetObjectHandle(oDestination TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElOneDriveDataStorageObject, TElOneDriveFolder)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveDataStorage, RefreshObject)
{
	zval *oObj;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oObj, TElOneDriveDataStorageObject_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElOneDriveDataStorage_RefreshObject(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObj TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElOneDriveDataStorageObject)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveDataStorage, RenameObject)
{
	char *sNewName;
	int sNewName_len;
	zval *oObj;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!s", &oObj, TElOneDriveDataStorageObject_ce_ptr, &sNewName, &sNewName_len) == SUCCESS)
	{
		SBCheckError(TElOneDriveDataStorage_RenameObject(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObj TSRMLS_CC), sNewName, (int32_t)sNewName_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElOneDriveDataStorageObject, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveDataStorage, Search)
{
	char *sQuery;
	int sQuery_len;
	zval *oObjects;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &sQuery, &sQuery_len, &oObjects, TElDataStorageObjectList_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElOneDriveDataStorage_Search(SBGetObjectHandle(getThis() TSRMLS_CC), sQuery, (int32_t)sQuery_len, SBGetObjectHandle(oObjects TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, TElDataStorageObjectList)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveDataStorage, get_AccessToken)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElOneDriveDataStorage_get_AccessToken(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1641233852, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveDataStorage, get_ClientID)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElOneDriveDataStorage_get_ClientID(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-444164145, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveDataStorage, set_ClientID)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElOneDriveDataStorage_set_ClientID(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveDataStorage, get_ClientSecret)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElOneDriveDataStorage_get_ClientSecret(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(69439554, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveDataStorage, set_ClientSecret)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElOneDriveDataStorage_set_ClientSecret(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveDataStorage, get_HTTPClient)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOneDriveDataStorage_get_HTTPClient(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElHTTPSClient_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveDataStorage, set_HTTPClient)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElHTTPSClient_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElOneDriveDataStorage_set_HTTPClient(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElHTTPSClient)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveDataStorage, get_Locale)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElOneDriveDataStorage_get_Locale(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(479558518, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveDataStorage, set_Locale)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElOneDriveDataStorage_set_Locale(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveDataStorage, get_Overwrite)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElOneDriveDataStorage_get_Overwrite(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveDataStorage, set_Overwrite)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElOneDriveDataStorage_set_Overwrite(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveDataStorage, get_PassthroughMode)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElOneDriveDataStorage_get_PassthroughMode(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveDataStorage, set_PassthroughMode)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElOneDriveDataStorage_set_PassthroughMode(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveDataStorage, get_ReadOnly)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElOneDriveDataStorage_get_ReadOnly(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveDataStorage, set_ReadOnly)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElOneDriveDataStorage_set_ReadOnly(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveDataStorage, get_RefreshToken)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElOneDriveDataStorage_get_RefreshToken(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(520872412, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveDataStorage, set_RefreshToken)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElOneDriveDataStorage_set_RefreshToken(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveDataStorage, get_ChunkedUploadChunkSize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElOneDriveDataStorage_get_ChunkedUploadChunkSize(SBGetObjectHandle(getThis() TSRMLS_CC), &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveDataStorage, set_ChunkedUploadChunkSize)
{
	long l8Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l8Value) == SUCCESS)
	{
		SBCheckError(TElOneDriveDataStorage_set_ChunkedUploadChunkSize(SBGetObjectHandle(getThis() TSRMLS_CC), (int64_t)l8Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveDataStorage, get_ChunkedUploadThreshold)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElOneDriveDataStorage_get_ChunkedUploadThreshold(SBGetObjectHandle(getThis() TSRMLS_CC), &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveDataStorage, set_ChunkedUploadThreshold)
{
	long l8Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l8Value) == SUCCESS)
	{
		SBCheckError(TElOneDriveDataStorage_set_ChunkedUploadThreshold(SBGetObjectHandle(getThis() TSRMLS_CC), (int64_t)l8Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveDataStorage, __construct)
{
	zval *oAOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOneDriveDataStorage_Create(SBGetObjectHandle(oAOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveDataStorage_StartAuthorization, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveDataStorage_CompleteAuthorization, 0, 0, 1)
	ZEND_ARG_INFO(0, AuthorizationCode)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveDataStorage_AcquireObject, 0, 0, 0)
	ZEND_ARG_INFO(0, ObjectID)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveDataStorage_CloseSession, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveDataStorage_CopyObject, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Obj, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Destination_or_NewHandler, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveDataStorage_CreateFolder, 0, 0, 3)
	ZEND_ARG_OBJ_INFO(0, Parent, TElOneDriveFolder, 1)
	ZEND_ARG_INFO(0, Name)
	ZEND_ARG_INFO(0, Description)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveDataStorage_CreateObject, 0, 0, 3)
	ZEND_ARG_OBJ_INFO(0, Parent, TElOneDriveFolder, 1)
	ZEND_ARG_INFO(0, Name)
	ZEND_ARG_INFO(0, OverwriteIfExists)
	ZEND_ARG_OBJ_INFO(0, Handler, TElCustomDataStorageSecurityHandler, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveDataStorage_GetQuota, 0, 0, 2)
	ZEND_ARG_INFO(1, Total)
	ZEND_ARG_INFO(1, Free)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveDataStorage_GetUserInfo, 0, 0, 0)
	ZEND_ARG_INFO(0, UserID)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveDataStorage_List, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Dir_or_Objs, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Objects, TElDataStorageObjectList, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveDataStorage_ListFriendly, 0, 0, 2)
	ZEND_ARG_INFO(0, FriendlyName)
	ZEND_ARG_OBJ_INFO(0, Objects, TElDataStorageObjectList, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveDataStorage_ListRecent, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Objects, TElDataStorageObjectList, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveDataStorage_ListShared, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Objects, TElDataStorageObjectList, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveDataStorage_MoveObject, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, Obj, TElOneDriveDataStorageObject, 1)
	ZEND_ARG_OBJ_INFO(0, Destination, TElOneDriveFolder, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveDataStorage_RefreshObject, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Obj, TElOneDriveDataStorageObject, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveDataStorage_RenameObject, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, Obj, TElOneDriveDataStorageObject, 1)
	ZEND_ARG_INFO(0, NewName)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveDataStorage_Search, 0, 0, 2)
	ZEND_ARG_INFO(0, Query)
	ZEND_ARG_OBJ_INFO(0, Objects, TElDataStorageObjectList, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveDataStorage_get_AccessToken, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveDataStorage_get_ClientID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveDataStorage_set_ClientID, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveDataStorage_get_ClientSecret, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveDataStorage_set_ClientSecret, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveDataStorage_get_HTTPClient, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveDataStorage_set_HTTPClient, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElHTTPSClient, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveDataStorage_get_Locale, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveDataStorage_set_Locale, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveDataStorage_get_Overwrite, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveDataStorage_set_Overwrite, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveDataStorage_get_PassthroughMode, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveDataStorage_set_PassthroughMode, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveDataStorage_get_ReadOnly, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveDataStorage_set_ReadOnly, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveDataStorage_get_RefreshToken, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveDataStorage_set_RefreshToken, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveDataStorage_get_ChunkedUploadChunkSize, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveDataStorage_set_ChunkedUploadChunkSize, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveDataStorage_get_ChunkedUploadThreshold, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveDataStorage_set_ChunkedUploadThreshold, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveDataStorage___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AOwner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElOneDriveDataStorage_methods[] = {
	PHP_ME(TElOneDriveDataStorage, StartAuthorization, arginfo_TElOneDriveDataStorage_StartAuthorization, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveDataStorage, CompleteAuthorization, arginfo_TElOneDriveDataStorage_CompleteAuthorization, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveDataStorage, AcquireObject, arginfo_TElOneDriveDataStorage_AcquireObject, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveDataStorage, CloseSession, arginfo_TElOneDriveDataStorage_CloseSession, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveDataStorage, CopyObject, arginfo_TElOneDriveDataStorage_CopyObject, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveDataStorage, CreateFolder, arginfo_TElOneDriveDataStorage_CreateFolder, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveDataStorage, CreateObject, arginfo_TElOneDriveDataStorage_CreateObject, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveDataStorage, GetQuota, arginfo_TElOneDriveDataStorage_GetQuota, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveDataStorage, GetUserInfo, arginfo_TElOneDriveDataStorage_GetUserInfo, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveDataStorage, List, arginfo_TElOneDriveDataStorage_List, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveDataStorage, ListFriendly, arginfo_TElOneDriveDataStorage_ListFriendly, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveDataStorage, ListRecent, arginfo_TElOneDriveDataStorage_ListRecent, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveDataStorage, ListShared, arginfo_TElOneDriveDataStorage_ListShared, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveDataStorage, MoveObject, arginfo_TElOneDriveDataStorage_MoveObject, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveDataStorage, RefreshObject, arginfo_TElOneDriveDataStorage_RefreshObject, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveDataStorage, RenameObject, arginfo_TElOneDriveDataStorage_RenameObject, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveDataStorage, Search, arginfo_TElOneDriveDataStorage_Search, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveDataStorage, get_AccessToken, arginfo_TElOneDriveDataStorage_get_AccessToken, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveDataStorage, get_ClientID, arginfo_TElOneDriveDataStorage_get_ClientID, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveDataStorage, set_ClientID, arginfo_TElOneDriveDataStorage_set_ClientID, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveDataStorage, get_ClientSecret, arginfo_TElOneDriveDataStorage_get_ClientSecret, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveDataStorage, set_ClientSecret, arginfo_TElOneDriveDataStorage_set_ClientSecret, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveDataStorage, get_HTTPClient, arginfo_TElOneDriveDataStorage_get_HTTPClient, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveDataStorage, set_HTTPClient, arginfo_TElOneDriveDataStorage_set_HTTPClient, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveDataStorage, get_Locale, arginfo_TElOneDriveDataStorage_get_Locale, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveDataStorage, set_Locale, arginfo_TElOneDriveDataStorage_set_Locale, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveDataStorage, get_Overwrite, arginfo_TElOneDriveDataStorage_get_Overwrite, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveDataStorage, set_Overwrite, arginfo_TElOneDriveDataStorage_set_Overwrite, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveDataStorage, get_PassthroughMode, arginfo_TElOneDriveDataStorage_get_PassthroughMode, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveDataStorage, set_PassthroughMode, arginfo_TElOneDriveDataStorage_set_PassthroughMode, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveDataStorage, get_ReadOnly, arginfo_TElOneDriveDataStorage_get_ReadOnly, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveDataStorage, set_ReadOnly, arginfo_TElOneDriveDataStorage_set_ReadOnly, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveDataStorage, get_RefreshToken, arginfo_TElOneDriveDataStorage_get_RefreshToken, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveDataStorage, set_RefreshToken, arginfo_TElOneDriveDataStorage_set_RefreshToken, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveDataStorage, get_ChunkedUploadChunkSize, arginfo_TElOneDriveDataStorage_get_ChunkedUploadChunkSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveDataStorage, set_ChunkedUploadChunkSize, arginfo_TElOneDriveDataStorage_set_ChunkedUploadChunkSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveDataStorage, get_ChunkedUploadThreshold, arginfo_TElOneDriveDataStorage_get_ChunkedUploadThreshold, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveDataStorage, set_ChunkedUploadThreshold, arginfo_TElOneDriveDataStorage_set_ChunkedUploadThreshold, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveDataStorage, __construct, arginfo_TElOneDriveDataStorage___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElOneDriveDataStorage(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElOneDriveDataStorage_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElOneDriveDataStorage", TElOneDriveDataStorage_methods);
	if (NULL == TElCustomDataStorage_ce_ptr)
		Register_TElCustomDataStorage(TSRMLS_C);
	TElOneDriveDataStorage_ce_ptr = zend_register_internal_class_ex(&ce, TElCustomDataStorage_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElOneDriveDataStorageObject_ce_ptr = NULL;

SB_PHP_METHOD(TElOneDriveDataStorageObject, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TElCustomDataStorageObject_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElOneDriveDataStorageObject_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomDataStorageObject)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveDataStorageObject, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElOneDriveDataStorageObject_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveDataStorageObject, Clone)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOneDriveDataStorageObject_Clone(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveDataStorageObject, Copy)
{
	zval *oDestination;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDestination, TElOneDriveFolder_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOneDriveDataStorageObject_Copy(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDestination TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElOneDriveDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElOneDriveFolder)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveDataStorageObject, Delete)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElOneDriveDataStorageObject_Delete(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveDataStorageObject, Move)
{
	zval *oDestination;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDestination, TElOneDriveFolder_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElOneDriveDataStorageObject_Move(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDestination TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElOneDriveFolder)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveDataStorageObject, Refresh)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElOneDriveDataStorageObject_Refresh(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveDataStorageObject, Rename)
{
	char *sNewName;
	int sNewName_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sNewName, &sNewName_len) == SUCCESS)
	{
		SBCheckError(TElOneDriveDataStorageObject_Rename(SBGetObjectHandle(getThis() TSRMLS_CC), sNewName, (int32_t)sNewName_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveDataStorageObject, get_ClientUpdatedTime)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(TElOneDriveDataStorageObject_get_ClientUpdatedTime(SBGetObjectHandle(getThis() TSRMLS_CC), &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveDataStorageObject, get_Comments)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOneDriveDataStorageObject_get_Comments(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElOneDriveComments_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveDataStorageObject, get_CreatedTime)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(TElOneDriveDataStorageObject_get_CreatedTime(SBGetObjectHandle(getThis() TSRMLS_CC), &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveDataStorageObject, get_Description)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElOneDriveDataStorageObject_get_Description(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-535790145, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveDataStorageObject, set_Description)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElOneDriveDataStorageObject_set_Description(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveDataStorageObject, get_From)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOneDriveDataStorageObject_get_From(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElOneDriveFriend_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveDataStorageObject, get_ID)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElOneDriveDataStorageObject_get_ID(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1358663532, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveDataStorageObject, get_IsEmbeddable)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElOneDriveDataStorageObject_get_IsEmbeddable(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveDataStorageObject, get_Link)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElOneDriveDataStorageObject_get_Link(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1843777127, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveDataStorageObject, get_ObjectType)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElOneDriveDataStorageObject_get_ObjectType(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1435910481, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveDataStorageObject, get_ParentID)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElOneDriveDataStorageObject_get_ParentID(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1075384001, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveDataStorageObject, get_SharedWith)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElOneDriveDataStorageObject_get_SharedWith(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1597057785, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveDataStorageObject, get_Size)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElOneDriveDataStorageObject_get_Size(SBGetObjectHandle(getThis() TSRMLS_CC), &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveDataStorageObject, get_Storage)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOneDriveDataStorageObject_get_Storage(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElOneDriveDataStorage_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveDataStorageObject, get_UpdatedTime)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(TElOneDriveDataStorageObject_get_UpdatedTime(SBGetObjectHandle(getThis() TSRMLS_CC), &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveDataStorageObject, get_UploadLocation)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElOneDriveDataStorageObject_get_UploadLocation(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-886295467, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveDataStorageObject, __construct)
{
	zval *oAStorage;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAStorage, TElOneDriveDataStorage_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOneDriveDataStorageObject_Create(SBGetObjectHandle(oAStorage TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElOneDriveDataStorage)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveDataStorageObject_Assign, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Source, TElCustomDataStorageObject, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveDataStorageObject_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveDataStorageObject_Clone, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveDataStorageObject_Copy, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Destination, TElOneDriveFolder, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveDataStorageObject_Delete, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveDataStorageObject_Move, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Destination, TElOneDriveFolder, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveDataStorageObject_Refresh, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveDataStorageObject_Rename, 0, 0, 1)
	ZEND_ARG_INFO(0, NewName)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveDataStorageObject_get_ClientUpdatedTime, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveDataStorageObject_get_Comments, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveDataStorageObject_get_CreatedTime, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveDataStorageObject_get_Description, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveDataStorageObject_set_Description, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveDataStorageObject_get_From, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveDataStorageObject_get_ID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveDataStorageObject_get_IsEmbeddable, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveDataStorageObject_get_Link, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveDataStorageObject_get_ObjectType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveDataStorageObject_get_ParentID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveDataStorageObject_get_SharedWith, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveDataStorageObject_get_Size, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveDataStorageObject_get_Storage, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveDataStorageObject_get_UpdatedTime, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveDataStorageObject_get_UploadLocation, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveDataStorageObject___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AStorage, TElOneDriveDataStorage, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElOneDriveDataStorageObject_methods[] = {
	PHP_ME(TElOneDriveDataStorageObject, Assign, arginfo_TElOneDriveDataStorageObject_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveDataStorageObject, Clear, arginfo_TElOneDriveDataStorageObject_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveDataStorageObject, Clone, arginfo_TElOneDriveDataStorageObject_Clone, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveDataStorageObject, Copy, arginfo_TElOneDriveDataStorageObject_Copy, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveDataStorageObject, Delete, arginfo_TElOneDriveDataStorageObject_Delete, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveDataStorageObject, Move, arginfo_TElOneDriveDataStorageObject_Move, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveDataStorageObject, Refresh, arginfo_TElOneDriveDataStorageObject_Refresh, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveDataStorageObject, Rename, arginfo_TElOneDriveDataStorageObject_Rename, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveDataStorageObject, get_ClientUpdatedTime, arginfo_TElOneDriveDataStorageObject_get_ClientUpdatedTime, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveDataStorageObject, get_Comments, arginfo_TElOneDriveDataStorageObject_get_Comments, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveDataStorageObject, get_CreatedTime, arginfo_TElOneDriveDataStorageObject_get_CreatedTime, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveDataStorageObject, get_Description, arginfo_TElOneDriveDataStorageObject_get_Description, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveDataStorageObject, set_Description, arginfo_TElOneDriveDataStorageObject_set_Description, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveDataStorageObject, get_From, arginfo_TElOneDriveDataStorageObject_get_From, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveDataStorageObject, get_ID, arginfo_TElOneDriveDataStorageObject_get_ID, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveDataStorageObject, get_IsEmbeddable, arginfo_TElOneDriveDataStorageObject_get_IsEmbeddable, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveDataStorageObject, get_Link, arginfo_TElOneDriveDataStorageObject_get_Link, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveDataStorageObject, get_ObjectType, arginfo_TElOneDriveDataStorageObject_get_ObjectType, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveDataStorageObject, get_ParentID, arginfo_TElOneDriveDataStorageObject_get_ParentID, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveDataStorageObject, get_SharedWith, arginfo_TElOneDriveDataStorageObject_get_SharedWith, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveDataStorageObject, get_Size, arginfo_TElOneDriveDataStorageObject_get_Size, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveDataStorageObject, get_Storage, arginfo_TElOneDriveDataStorageObject_get_Storage, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveDataStorageObject, get_UpdatedTime, arginfo_TElOneDriveDataStorageObject_get_UpdatedTime, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveDataStorageObject, get_UploadLocation, arginfo_TElOneDriveDataStorageObject_get_UploadLocation, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveDataStorageObject, __construct, arginfo_TElOneDriveDataStorageObject___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElOneDriveDataStorageObject(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElOneDriveDataStorageObject_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElOneDriveDataStorageObject", TElOneDriveDataStorageObject_methods);
	if (NULL == TElCustomDataStorageObject_ce_ptr)
		Register_TElCustomDataStorageObject(TSRMLS_C);
	TElOneDriveDataStorageObject_ce_ptr = zend_register_internal_class_ex(&ce, TElCustomDataStorageObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElOneDriveFolder_ce_ptr = NULL;

SB_PHP_METHOD(TElOneDriveFolder, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TElCustomDataStorageObject_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElOneDriveFolder_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomDataStorageObject)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveFolder, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElOneDriveFolder_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveFolder, Clone)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOneDriveFolder_Clone(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveFolder, CreateFolder)
{
	char *sDescription;
	char *sName;
	int sDescription_len;
	int sName_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &sName, &sName_len, &sDescription, &sDescription_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOneDriveFolder_CreateFolder(SBGetObjectHandle(getThis() TSRMLS_CC), sName, (int32_t)sName_len, sDescription, (int32_t)sDescription_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElOneDriveFolder_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveFolder, CreateObject)
{
	char *sName;
	int sName_len;
	zend_bool bOverwriteIfExists;
	zval *oHandler;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sb", &sName, &sName_len, &bOverwriteIfExists) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOneDriveFolder_CreateObject(SBGetObjectHandle(getThis() TSRMLS_CC), sName, (int32_t)sName_len, (int8_t)bOverwriteIfExists, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElOneDriveFile_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sbO!", &sName, &sName_len, &bOverwriteIfExists, &oHandler, TElCustomDataStorageSecurityHandler_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOneDriveFolder_CreateObject_1(SBGetObjectHandle(getThis() TSRMLS_CC), sName, (int32_t)sName_len, (int8_t)bOverwriteIfExists, SBGetObjectHandle(oHandler TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElOneDriveFile_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, bool) or (string, bool, TElCustomDataStorageSecurityHandler)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveFolder, List)
{
	zval *oObjects;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oObjects, TElDataStorageObjectList_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElOneDriveFolder_List(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObjects TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElDataStorageObjectList)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveFolder, ListFolders)
{
	zval *oObjects;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oObjects, TElDataStorageObjectList_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElOneDriveFolder_ListFolders(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObjects TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElDataStorageObjectList)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveFolder, get_Count)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint32_t u4OutResultRaw = 0;
		SBCheckError(TElOneDriveFolder_get_Count(SBGetObjectHandle(getThis() TSRMLS_CC), &u4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveFolder, __construct)
{
	zval *oStorage;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oStorage, TElOneDriveDataStorage_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOneDriveFolder_Create(SBGetObjectHandle(oStorage TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElOneDriveDataStorage)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveFolder_Assign, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Source, TElCustomDataStorageObject, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveFolder_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveFolder_Clone, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveFolder_CreateFolder, 0, 0, 2)
	ZEND_ARG_INFO(0, Name)
	ZEND_ARG_INFO(0, Description)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveFolder_CreateObject, 0, 0, 2)
	ZEND_ARG_INFO(0, Name)
	ZEND_ARG_INFO(0, OverwriteIfExists)
	ZEND_ARG_OBJ_INFO(0, Handler, TElCustomDataStorageSecurityHandler, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveFolder_List, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Objects, TElDataStorageObjectList, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveFolder_ListFolders, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Objects, TElDataStorageObjectList, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveFolder_get_Count, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveFolder___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Storage, TElOneDriveDataStorage, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElOneDriveFolder_methods[] = {
	PHP_ME(TElOneDriveFolder, Assign, arginfo_TElOneDriveFolder_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveFolder, Clear, arginfo_TElOneDriveFolder_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveFolder, Clone, arginfo_TElOneDriveFolder_Clone, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveFolder, CreateFolder, arginfo_TElOneDriveFolder_CreateFolder, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveFolder, CreateObject, arginfo_TElOneDriveFolder_CreateObject, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveFolder, List, arginfo_TElOneDriveFolder_List, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveFolder, ListFolders, arginfo_TElOneDriveFolder_ListFolders, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveFolder, get_Count, arginfo_TElOneDriveFolder_get_Count, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveFolder, __construct, arginfo_TElOneDriveFolder___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElOneDriveFolder(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElOneDriveFolder_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElOneDriveFolder", TElOneDriveFolder_methods);
	if (NULL == TElOneDriveDataStorageObject_ce_ptr)
		Register_TElOneDriveDataStorageObject(TSRMLS_C);
	TElOneDriveFolder_ce_ptr = zend_register_internal_class_ex(&ce, TElOneDriveDataStorageObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElOneDriveComments_ce_ptr = NULL;

SB_PHP_METHOD(TElOneDriveComments, Add)
{
	char *sMessage;
	int sMessage_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sMessage, &sMessage_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOneDriveComments_Add(SBGetObjectHandle(getThis() TSRMLS_CC), sMessage, (int32_t)sMessage_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElOneDriveComment_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveComments, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TElOneDriveComments_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElOneDriveComments_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElOneDriveComments)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveComments, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElOneDriveComments_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveComments, Refresh)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElOneDriveComments_Refresh(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveComments, get_Count)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElOneDriveComments_get_Count(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveComments, get_Enabled)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElOneDriveComments_get_Enabled(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveComments, get_Items)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOneDriveComments_get_Items(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElOneDriveComment_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveComments, get_Owner)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOneDriveComments_get_Owner(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElOneDriveDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveComments, __construct)
{
	zval *oAOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAOwner, TElOneDriveDataStorageObject_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOneDriveComments_Create(SBGetObjectHandle(oAOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElOneDriveDataStorageObject)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveComments_Add, 0, 0, 1)
	ZEND_ARG_INFO(0, Message)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveComments_Assign, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Source, TElOneDriveComments, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveComments_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveComments_Refresh, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveComments_get_Count, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveComments_get_Enabled, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveComments_get_Items, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveComments_get_Owner, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveComments___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AOwner, TElOneDriveDataStorageObject, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElOneDriveComments_methods[] = {
	PHP_ME(TElOneDriveComments, Add, arginfo_TElOneDriveComments_Add, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveComments, Assign, arginfo_TElOneDriveComments_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveComments, Clear, arginfo_TElOneDriveComments_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveComments, Refresh, arginfo_TElOneDriveComments_Refresh, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveComments, get_Count, arginfo_TElOneDriveComments_get_Count, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveComments, get_Enabled, arginfo_TElOneDriveComments_get_Enabled, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveComments, get_Items, arginfo_TElOneDriveComments_get_Items, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveComments, get_Owner, arginfo_TElOneDriveComments_get_Owner, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveComments, __construct, arginfo_TElOneDriveComments___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElOneDriveComments(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElOneDriveComments_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElOneDriveComments", TElOneDriveComments_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElOneDriveComments_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElOneDriveTags_ce_ptr = NULL;

SB_PHP_METHOD(TElOneDriveTags, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TElOneDriveTags_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElOneDriveTags_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElOneDriveTags)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveTags, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElOneDriveTags_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveTags, Refresh)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElOneDriveTags_Refresh(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveTags, get_Count)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElOneDriveTags_get_Count(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveTags, get_Enabled)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElOneDriveTags_get_Enabled(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveTags, get_Items)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOneDriveTags_get_Items(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElOneDriveTag_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveTags, get_Owner)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOneDriveTags_get_Owner(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElOneDriveTaggedObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveTags, __construct)
{
	zval *oAOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAOwner, TElOneDriveTaggedObject_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOneDriveTags_Create(SBGetObjectHandle(oAOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElOneDriveTaggedObject)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveTags_Assign, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Source, TElOneDriveTags, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveTags_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveTags_Refresh, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveTags_get_Count, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveTags_get_Enabled, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveTags_get_Items, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveTags_get_Owner, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveTags___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AOwner, TElOneDriveTaggedObject, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElOneDriveTags_methods[] = {
	PHP_ME(TElOneDriveTags, Assign, arginfo_TElOneDriveTags_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveTags, Clear, arginfo_TElOneDriveTags_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveTags, Refresh, arginfo_TElOneDriveTags_Refresh, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveTags, get_Count, arginfo_TElOneDriveTags_get_Count, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveTags, get_Enabled, arginfo_TElOneDriveTags_get_Enabled, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveTags, get_Items, arginfo_TElOneDriveTags_get_Items, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveTags, get_Owner, arginfo_TElOneDriveTags_get_Owner, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveTags, __construct, arginfo_TElOneDriveTags___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElOneDriveTags(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElOneDriveTags_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElOneDriveTags", TElOneDriveTags_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElOneDriveTags_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElOneDriveFile_ce_ptr = NULL;

SB_PHP_METHOD(TElOneDriveFile, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TElCustomDataStorageObject_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElOneDriveFile_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomDataStorageObject)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveFile, CancelUpload)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElOneDriveFile_CancelUpload(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveFile, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElOneDriveFile_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveFile, Clone)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOneDriveFile_Clone(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveFile, Read)
{
	zval *oTarget;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oTarget, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElOneDriveFile_Read(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oTarget TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveFile, Write)
{
	zval *oHandler;
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElOneDriveFile_Write(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oSource, TStream_ce_ptr, &oHandler, TElCustomDataStorageSecurityHandler_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElOneDriveFile_Write_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC), SBGetObjectHandle(oHandler TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream) or (TStream, TElCustomDataStorageSecurityHandler)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveFile, get_Source)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElOneDriveFile_get_Source(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1141081693, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveFile, __construct)
{
	zval *oAStorage;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAStorage, TElOneDriveDataStorage_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOneDriveFile_Create(SBGetObjectHandle(oAStorage TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElOneDriveDataStorage)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveFile_Assign, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Source, TElCustomDataStorageObject, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveFile_CancelUpload, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveFile_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveFile_Clone, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveFile_Read, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Target, TStream, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveFile_Write, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Source, TStream, 1)
	ZEND_ARG_OBJ_INFO(0, Handler, TElCustomDataStorageSecurityHandler, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveFile_get_Source, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveFile___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AStorage, TElOneDriveDataStorage, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElOneDriveFile_methods[] = {
	PHP_ME(TElOneDriveFile, Assign, arginfo_TElOneDriveFile_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveFile, CancelUpload, arginfo_TElOneDriveFile_CancelUpload, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveFile, Clear, arginfo_TElOneDriveFile_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveFile, Clone, arginfo_TElOneDriveFile_Clone, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveFile, Read, arginfo_TElOneDriveFile_Read, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveFile, Write, arginfo_TElOneDriveFile_Write, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveFile, get_Source, arginfo_TElOneDriveFile_get_Source, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveFile, __construct, arginfo_TElOneDriveFile___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElOneDriveFile(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElOneDriveFile_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElOneDriveFile", TElOneDriveFile_methods);
	if (NULL == TElOneDriveDataStorageObject_ce_ptr)
		Register_TElOneDriveDataStorageObject(TSRMLS_C);
	TElOneDriveFile_ce_ptr = zend_register_internal_class_ex(&ce, TElOneDriveDataStorageObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElOneDriveFriend_ce_ptr = NULL;

SB_PHP_METHOD(TElOneDriveFriend, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TElOneDriveFriend_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElOneDriveFriend_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElOneDriveFriend)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveFriend, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElOneDriveFriend_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveFriend, Clone)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOneDriveFriend_Clone(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElOneDriveFriend_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveFriend, get_ID)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElOneDriveFriend_get_ID(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1926298813, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveFriend, get_Name)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElOneDriveFriend_get_Name(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(210238684, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveFriend, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOneDriveFriend_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveFriend_Assign, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Source, TElOneDriveFriend, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveFriend_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveFriend_Clone, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveFriend_get_ID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveFriend_get_Name, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveFriend___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElOneDriveFriend_methods[] = {
	PHP_ME(TElOneDriveFriend, Assign, arginfo_TElOneDriveFriend_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveFriend, Clear, arginfo_TElOneDriveFriend_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveFriend, Clone, arginfo_TElOneDriveFriend_Clone, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveFriend, get_ID, arginfo_TElOneDriveFriend_get_ID, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveFriend, get_Name, arginfo_TElOneDriveFriend_get_Name, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveFriend, __construct, arginfo_TElOneDriveFriend___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElOneDriveFriend(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElOneDriveFriend_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElOneDriveFriend", TElOneDriveFriend_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElOneDriveFriend_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElOneDriveComment_ce_ptr = NULL;

SB_PHP_METHOD(TElOneDriveComment, Clone)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOneDriveComment_Clone(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElOneDriveComment_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveComment, Delete)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElOneDriveComment_Delete(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveComment, get_CreatedTime)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(TElOneDriveComment_get_CreatedTime(SBGetObjectHandle(getThis() TSRMLS_CC), &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveComment, get_From)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOneDriveComment_get_From(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElOneDriveFriend_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveComment, get_ID)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElOneDriveComment_get_ID(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-496898025, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveComment, get_Message)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElOneDriveComment_get_Message(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-791821567, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveComment, __construct)
{
	zval *oAOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAOwner, TElOneDriveComments_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOneDriveComment_Create(SBGetObjectHandle(oAOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElOneDriveComments)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveComment_Clone, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveComment_Delete, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveComment_get_CreatedTime, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveComment_get_From, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveComment_get_ID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveComment_get_Message, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveComment___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AOwner, TElOneDriveComments, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElOneDriveComment_methods[] = {
	PHP_ME(TElOneDriveComment, Clone, arginfo_TElOneDriveComment_Clone, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveComment, Delete, arginfo_TElOneDriveComment_Delete, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveComment, get_CreatedTime, arginfo_TElOneDriveComment_get_CreatedTime, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveComment, get_From, arginfo_TElOneDriveComment_get_From, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveComment, get_ID, arginfo_TElOneDriveComment_get_ID, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveComment, get_Message, arginfo_TElOneDriveComment_get_Message, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveComment, __construct, arginfo_TElOneDriveComment___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElOneDriveComment(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElOneDriveComment_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElOneDriveComment", TElOneDriveComment_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElOneDriveComment_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElOneDriveTaggedObject_ce_ptr = NULL;

SB_PHP_METHOD(TElOneDriveTaggedObject, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TElCustomDataStorageObject_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElOneDriveTaggedObject_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomDataStorageObject)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveTaggedObject, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElOneDriveTaggedObject_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveTaggedObject, get_Tags)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOneDriveTaggedObject_get_Tags(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElOneDriveTags_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveTaggedObject, __construct)
{
	zval *oAStorage;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAStorage, TElOneDriveDataStorage_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOneDriveTaggedObject_Create(SBGetObjectHandle(oAStorage TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElOneDriveDataStorage)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveTaggedObject_Assign, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Source, TElCustomDataStorageObject, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveTaggedObject_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveTaggedObject_get_Tags, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveTaggedObject___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AStorage, TElOneDriveDataStorage, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElOneDriveTaggedObject_methods[] = {
	PHP_ME(TElOneDriveTaggedObject, Assign, arginfo_TElOneDriveTaggedObject_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveTaggedObject, Clear, arginfo_TElOneDriveTaggedObject_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveTaggedObject, get_Tags, arginfo_TElOneDriveTaggedObject_get_Tags, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveTaggedObject, __construct, arginfo_TElOneDriveTaggedObject___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElOneDriveTaggedObject(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElOneDriveTaggedObject_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElOneDriveTaggedObject", TElOneDriveTaggedObject_methods);
	if (NULL == TElOneDriveFile_ce_ptr)
		Register_TElOneDriveFile(TSRMLS_C);
	TElOneDriveTaggedObject_ce_ptr = zend_register_internal_class_ex(&ce, TElOneDriveFile_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElOneDriveTag_ce_ptr = NULL;

SB_PHP_METHOD(TElOneDriveTag, Clone)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOneDriveTag_Clone(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElOneDriveTag_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveTag, get_CreatedTime)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(TElOneDriveTag_get_CreatedTime(SBGetObjectHandle(getThis() TSRMLS_CC), &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveTag, get_ID)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElOneDriveTag_get_ID(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(792028368, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveTag, get_User)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOneDriveTag_get_User(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElOneDriveFriend_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveTag, get_X)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		double dOutResult = 0.0;
		SBCheckError(TElOneDriveTag_get_X(SBGetObjectHandle(getThis() TSRMLS_CC), &dOutResult) TSRMLS_CC);
		RETURN_DOUBLE(dOutResult);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveTag, get_Y)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		double dOutResult = 0.0;
		SBCheckError(TElOneDriveTag_get_Y(SBGetObjectHandle(getThis() TSRMLS_CC), &dOutResult) TSRMLS_CC);
		RETURN_DOUBLE(dOutResult);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveTag, __construct)
{
	zval *oAOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAOwner, TElOneDriveTags_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOneDriveTag_Create(SBGetObjectHandle(oAOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElOneDriveTags)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveTag_Clone, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveTag_get_CreatedTime, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveTag_get_ID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveTag_get_User, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveTag_get_X, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveTag_get_Y, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveTag___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AOwner, TElOneDriveTags, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElOneDriveTag_methods[] = {
	PHP_ME(TElOneDriveTag, Clone, arginfo_TElOneDriveTag_Clone, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveTag, get_CreatedTime, arginfo_TElOneDriveTag_get_CreatedTime, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveTag, get_ID, arginfo_TElOneDriveTag_get_ID, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveTag, get_User, arginfo_TElOneDriveTag_get_User, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveTag, get_X, arginfo_TElOneDriveTag_get_X, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveTag, get_Y, arginfo_TElOneDriveTag_get_Y, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveTag, __construct, arginfo_TElOneDriveTag___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElOneDriveTag(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElOneDriveTag_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElOneDriveTag", TElOneDriveTag_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElOneDriveTag_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElOneDriveNotebook_ce_ptr = NULL;

SB_PHP_METHOD(TElOneDriveNotebook, __construct)
{
	zval *oAStorage;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAStorage, TElOneDriveDataStorage_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOneDriveNotebook_Create(SBGetObjectHandle(oAStorage TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElOneDriveDataStorage)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveNotebook___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AStorage, TElOneDriveDataStorage, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElOneDriveNotebook_methods[] = {
	PHP_ME(TElOneDriveNotebook, __construct, arginfo_TElOneDriveNotebook___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElOneDriveNotebook(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElOneDriveNotebook_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElOneDriveNotebook", TElOneDriveNotebook_methods);
	if (NULL == TElOneDriveFile_ce_ptr)
		Register_TElOneDriveFile(TSRMLS_C);
	TElOneDriveNotebook_ce_ptr = zend_register_internal_class_ex(&ce, TElOneDriveFile_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElOneDriveAudio_ce_ptr = NULL;

SB_PHP_METHOD(TElOneDriveAudio, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TElCustomDataStorageObject_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElOneDriveAudio_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomDataStorageObject)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveAudio, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElOneDriveAudio_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveAudio, Clone)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOneDriveAudio_Clone(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveAudio, get_Album)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElOneDriveAudio_get_Album(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1069550746, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveAudio, set_Album)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElOneDriveAudio_set_Album(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveAudio, get_AlbumArtist)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElOneDriveAudio_get_AlbumArtist(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1757370723, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveAudio, set_AlbumArtist)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElOneDriveAudio_set_AlbumArtist(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveAudio, get_Artist)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElOneDriveAudio_get_Artist(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(743590680, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveAudio, set_Artist)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElOneDriveAudio_set_Artist(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveAudio, get_Duration)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElOneDriveAudio_get_Duration(SBGetObjectHandle(getThis() TSRMLS_CC), &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveAudio, get_Genre)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElOneDriveAudio_get_Genre(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-2063052511, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveAudio, set_Genre)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElOneDriveAudio_set_Genre(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveAudio, get_Picture)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElOneDriveAudio_get_Picture(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1539037940, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveAudio, get_Title)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElOneDriveAudio_get_Title(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(762190514, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveAudio, set_Title)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElOneDriveAudio_set_Title(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveAudio, __construct)
{
	zval *oAStorage;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAStorage, TElOneDriveDataStorage_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOneDriveAudio_Create(SBGetObjectHandle(oAStorage TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElOneDriveDataStorage)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveAudio_Assign, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Source, TElCustomDataStorageObject, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveAudio_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveAudio_Clone, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveAudio_get_Album, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveAudio_set_Album, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveAudio_get_AlbumArtist, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveAudio_set_AlbumArtist, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveAudio_get_Artist, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveAudio_set_Artist, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveAudio_get_Duration, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveAudio_get_Genre, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveAudio_set_Genre, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveAudio_get_Picture, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveAudio_get_Title, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveAudio_set_Title, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveAudio___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AStorage, TElOneDriveDataStorage, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElOneDriveAudio_methods[] = {
	PHP_ME(TElOneDriveAudio, Assign, arginfo_TElOneDriveAudio_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveAudio, Clear, arginfo_TElOneDriveAudio_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveAudio, Clone, arginfo_TElOneDriveAudio_Clone, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveAudio, get_Album, arginfo_TElOneDriveAudio_get_Album, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveAudio, set_Album, arginfo_TElOneDriveAudio_set_Album, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveAudio, get_AlbumArtist, arginfo_TElOneDriveAudio_get_AlbumArtist, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveAudio, set_AlbumArtist, arginfo_TElOneDriveAudio_set_AlbumArtist, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveAudio, get_Artist, arginfo_TElOneDriveAudio_get_Artist, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveAudio, set_Artist, arginfo_TElOneDriveAudio_set_Artist, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveAudio, get_Duration, arginfo_TElOneDriveAudio_get_Duration, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveAudio, get_Genre, arginfo_TElOneDriveAudio_get_Genre, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveAudio, set_Genre, arginfo_TElOneDriveAudio_set_Genre, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveAudio, get_Picture, arginfo_TElOneDriveAudio_get_Picture, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveAudio, get_Title, arginfo_TElOneDriveAudio_get_Title, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveAudio, set_Title, arginfo_TElOneDriveAudio_set_Title, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveAudio, __construct, arginfo_TElOneDriveAudio___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElOneDriveAudio(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElOneDriveAudio_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElOneDriveAudio", TElOneDriveAudio_methods);
	if (NULL == TElOneDriveFile_ce_ptr)
		Register_TElOneDriveFile(TSRMLS_C);
	TElOneDriveAudio_ce_ptr = zend_register_internal_class_ex(&ce, TElOneDriveFile_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElOneDrivePhoto_ce_ptr = NULL;

SB_PHP_METHOD(TElOneDrivePhoto, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TElCustomDataStorageObject_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElOneDrivePhoto_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomDataStorageObject)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDrivePhoto, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElOneDrivePhoto_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDrivePhoto, Clone)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOneDrivePhoto_Clone(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDrivePhoto, get_Altitude)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		double dOutResult = 0.0;
		SBCheckError(TElOneDrivePhoto_get_Altitude(SBGetObjectHandle(getThis() TSRMLS_CC), &dOutResult) TSRMLS_CC);
		RETURN_DOUBLE(dOutResult);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDrivePhoto, get_CameraMaker)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElOneDrivePhoto_get_CameraMaker(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1215691604, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDrivePhoto, get_CameraModel)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElOneDrivePhoto_get_CameraModel(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1509553721, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDrivePhoto, get_ExposureDenominator)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		double dOutResult = 0.0;
		SBCheckError(TElOneDrivePhoto_get_ExposureDenominator(SBGetObjectHandle(getThis() TSRMLS_CC), &dOutResult) TSRMLS_CC);
		RETURN_DOUBLE(dOutResult);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDrivePhoto, get_ExposureNumerator)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		double dOutResult = 0.0;
		SBCheckError(TElOneDrivePhoto_get_ExposureNumerator(SBGetObjectHandle(getThis() TSRMLS_CC), &dOutResult) TSRMLS_CC);
		RETURN_DOUBLE(dOutResult);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDrivePhoto, get_FocalLength)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		double dOutResult = 0.0;
		SBCheckError(TElOneDrivePhoto_get_FocalLength(SBGetObjectHandle(getThis() TSRMLS_CC), &dOutResult) TSRMLS_CC);
		RETURN_DOUBLE(dOutResult);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDrivePhoto, get_FocalRatio)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		double dOutResult = 0.0;
		SBCheckError(TElOneDrivePhoto_get_FocalRatio(SBGetObjectHandle(getThis() TSRMLS_CC), &dOutResult) TSRMLS_CC);
		RETURN_DOUBLE(dOutResult);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDrivePhoto, get_Height)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElOneDrivePhoto_get_Height(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDrivePhoto, get_Images)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOneDrivePhoto_get_Images(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElOneDrivePhotoImages_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDrivePhoto, get_Latitude)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		double dOutResult = 0.0;
		SBCheckError(TElOneDrivePhoto_get_Latitude(SBGetObjectHandle(getThis() TSRMLS_CC), &dOutResult) TSRMLS_CC);
		RETURN_DOUBLE(dOutResult);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDrivePhoto, get_Longitude)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		double dOutResult = 0.0;
		SBCheckError(TElOneDrivePhoto_get_Longitude(SBGetObjectHandle(getThis() TSRMLS_CC), &dOutResult) TSRMLS_CC);
		RETURN_DOUBLE(dOutResult);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDrivePhoto, get_Picture)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElOneDrivePhoto_get_Picture(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-731717316, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDrivePhoto, get_WhenTaken)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(TElOneDrivePhoto_get_WhenTaken(SBGetObjectHandle(getThis() TSRMLS_CC), &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDrivePhoto, get_Width)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElOneDrivePhoto_get_Width(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDrivePhoto, __construct)
{
	zval *oStorage;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oStorage, TElOneDriveDataStorage_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOneDrivePhoto_Create(SBGetObjectHandle(oStorage TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElOneDriveDataStorage)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDrivePhoto_Assign, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Source, TElCustomDataStorageObject, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDrivePhoto_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDrivePhoto_Clone, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDrivePhoto_get_Altitude, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDrivePhoto_get_CameraMaker, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDrivePhoto_get_CameraModel, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDrivePhoto_get_ExposureDenominator, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDrivePhoto_get_ExposureNumerator, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDrivePhoto_get_FocalLength, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDrivePhoto_get_FocalRatio, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDrivePhoto_get_Height, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDrivePhoto_get_Images, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDrivePhoto_get_Latitude, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDrivePhoto_get_Longitude, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDrivePhoto_get_Picture, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDrivePhoto_get_WhenTaken, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDrivePhoto_get_Width, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDrivePhoto___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Storage, TElOneDriveDataStorage, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElOneDrivePhoto_methods[] = {
	PHP_ME(TElOneDrivePhoto, Assign, arginfo_TElOneDrivePhoto_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDrivePhoto, Clear, arginfo_TElOneDrivePhoto_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDrivePhoto, Clone, arginfo_TElOneDrivePhoto_Clone, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDrivePhoto, get_Altitude, arginfo_TElOneDrivePhoto_get_Altitude, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDrivePhoto, get_CameraMaker, arginfo_TElOneDrivePhoto_get_CameraMaker, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDrivePhoto, get_CameraModel, arginfo_TElOneDrivePhoto_get_CameraModel, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDrivePhoto, get_ExposureDenominator, arginfo_TElOneDrivePhoto_get_ExposureDenominator, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDrivePhoto, get_ExposureNumerator, arginfo_TElOneDrivePhoto_get_ExposureNumerator, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDrivePhoto, get_FocalLength, arginfo_TElOneDrivePhoto_get_FocalLength, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDrivePhoto, get_FocalRatio, arginfo_TElOneDrivePhoto_get_FocalRatio, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDrivePhoto, get_Height, arginfo_TElOneDrivePhoto_get_Height, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDrivePhoto, get_Images, arginfo_TElOneDrivePhoto_get_Images, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDrivePhoto, get_Latitude, arginfo_TElOneDrivePhoto_get_Latitude, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDrivePhoto, get_Longitude, arginfo_TElOneDrivePhoto_get_Longitude, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDrivePhoto, get_Picture, arginfo_TElOneDrivePhoto_get_Picture, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDrivePhoto, get_WhenTaken, arginfo_TElOneDrivePhoto_get_WhenTaken, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDrivePhoto, get_Width, arginfo_TElOneDrivePhoto_get_Width, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDrivePhoto, __construct, arginfo_TElOneDrivePhoto___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElOneDrivePhoto(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElOneDrivePhoto_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElOneDrivePhoto", TElOneDrivePhoto_methods);
	if (NULL == TElOneDriveTaggedObject_ce_ptr)
		Register_TElOneDriveTaggedObject(TSRMLS_C);
	TElOneDrivePhoto_ce_ptr = zend_register_internal_class_ex(&ce, TElOneDriveTaggedObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElOneDrivePhotoImage_ce_ptr = NULL;

SB_PHP_METHOD(TElOneDrivePhotoImage, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElOneDrivePhotoImage_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDrivePhotoImage, Clone)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOneDrivePhotoImage_Clone(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElOneDrivePhotoImage_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDrivePhotoImage, get_Height)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElOneDrivePhotoImage_get_Height(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDrivePhotoImage, get_ImageType)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElOneDrivePhotoImage_get_ImageType(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1409509683, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDrivePhotoImage, get_Source)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElOneDrivePhotoImage_get_Source(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-571037465, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDrivePhotoImage, get_Width)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElOneDrivePhotoImage_get_Width(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDrivePhotoImage, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOneDrivePhotoImage_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDrivePhotoImage_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDrivePhotoImage_Clone, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDrivePhotoImage_get_Height, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDrivePhotoImage_get_ImageType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDrivePhotoImage_get_Source, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDrivePhotoImage_get_Width, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDrivePhotoImage___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElOneDrivePhotoImage_methods[] = {
	PHP_ME(TElOneDrivePhotoImage, Clear, arginfo_TElOneDrivePhotoImage_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDrivePhotoImage, Clone, arginfo_TElOneDrivePhotoImage_Clone, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDrivePhotoImage, get_Height, arginfo_TElOneDrivePhotoImage_get_Height, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDrivePhotoImage, get_ImageType, arginfo_TElOneDrivePhotoImage_get_ImageType, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDrivePhotoImage, get_Source, arginfo_TElOneDrivePhotoImage_get_Source, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDrivePhotoImage, get_Width, arginfo_TElOneDrivePhotoImage_get_Width, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDrivePhotoImage, __construct, arginfo_TElOneDrivePhotoImage___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElOneDrivePhotoImage(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElOneDrivePhotoImage_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElOneDrivePhotoImage", TElOneDrivePhotoImage_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElOneDrivePhotoImage_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElOneDrivePhotoImages_ce_ptr = NULL;

SB_PHP_METHOD(TElOneDrivePhotoImages, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TElOneDrivePhotoImages_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElOneDrivePhotoImages_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElOneDrivePhotoImages)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDrivePhotoImages, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElOneDrivePhotoImages_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDrivePhotoImages, get_Album)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOneDrivePhotoImages_get_Album(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElOneDrivePhotoImage_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDrivePhotoImages, get_Count)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElOneDrivePhotoImages_get_Count(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDrivePhotoImages, get_Full)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOneDrivePhotoImages_get_Full(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElOneDrivePhotoImage_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDrivePhotoImages, get_Items)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOneDrivePhotoImages_get_Items(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElOneDrivePhotoImage_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDrivePhotoImages, get_Normal)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOneDrivePhotoImages_get_Normal(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElOneDrivePhotoImage_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDrivePhotoImages, get_Small)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOneDrivePhotoImages_get_Small(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElOneDrivePhotoImage_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDrivePhotoImages, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOneDrivePhotoImages_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDrivePhotoImages_Assign, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Source, TElOneDrivePhotoImages, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDrivePhotoImages_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDrivePhotoImages_get_Album, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDrivePhotoImages_get_Count, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDrivePhotoImages_get_Full, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDrivePhotoImages_get_Items, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDrivePhotoImages_get_Normal, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDrivePhotoImages_get_Small, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDrivePhotoImages___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElOneDrivePhotoImages_methods[] = {
	PHP_ME(TElOneDrivePhotoImages, Assign, arginfo_TElOneDrivePhotoImages_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDrivePhotoImages, Clear, arginfo_TElOneDrivePhotoImages_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDrivePhotoImages, get_Album, arginfo_TElOneDrivePhotoImages_get_Album, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDrivePhotoImages, get_Count, arginfo_TElOneDrivePhotoImages_get_Count, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDrivePhotoImages, get_Full, arginfo_TElOneDrivePhotoImages_get_Full, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDrivePhotoImages, get_Items, arginfo_TElOneDrivePhotoImages_get_Items, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDrivePhotoImages, get_Normal, arginfo_TElOneDrivePhotoImages_get_Normal, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDrivePhotoImages, get_Small, arginfo_TElOneDrivePhotoImages_get_Small, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDrivePhotoImages, __construct, arginfo_TElOneDrivePhotoImages___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElOneDrivePhotoImages(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElOneDrivePhotoImages_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElOneDrivePhotoImages", TElOneDrivePhotoImages_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElOneDrivePhotoImages_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElOneDriveVideo_ce_ptr = NULL;

SB_PHP_METHOD(TElOneDriveVideo, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TElCustomDataStorageObject_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElOneDriveVideo_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomDataStorageObject)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveVideo, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElOneDriveVideo_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveVideo, Clone)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOneDriveVideo_Clone(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveVideo, get_Bitrate)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElOneDriveVideo_get_Bitrate(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveVideo, get_Duration)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElOneDriveVideo_get_Duration(SBGetObjectHandle(getThis() TSRMLS_CC), &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveVideo, get_Height)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElOneDriveVideo_get_Height(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveVideo, get_Picture)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElOneDriveVideo_get_Picture(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-126370751, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveVideo, get_Width)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElOneDriveVideo_get_Width(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveVideo, __construct)
{
	zval *oStorage;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oStorage, TElOneDriveDataStorage_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOneDriveVideo_Create(SBGetObjectHandle(oStorage TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElOneDriveDataStorage)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveVideo_Assign, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Source, TElCustomDataStorageObject, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveVideo_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveVideo_Clone, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveVideo_get_Bitrate, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveVideo_get_Duration, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveVideo_get_Height, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveVideo_get_Picture, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveVideo_get_Width, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveVideo___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Storage, TElOneDriveDataStorage, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElOneDriveVideo_methods[] = {
	PHP_ME(TElOneDriveVideo, Assign, arginfo_TElOneDriveVideo_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveVideo, Clear, arginfo_TElOneDriveVideo_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveVideo, Clone, arginfo_TElOneDriveVideo_Clone, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveVideo, get_Bitrate, arginfo_TElOneDriveVideo_get_Bitrate, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveVideo, get_Duration, arginfo_TElOneDriveVideo_get_Duration, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveVideo, get_Height, arginfo_TElOneDriveVideo_get_Height, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveVideo, get_Picture, arginfo_TElOneDriveVideo_get_Picture, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveVideo, get_Width, arginfo_TElOneDriveVideo_get_Width, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveVideo, __construct, arginfo_TElOneDriveVideo___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElOneDriveVideo(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElOneDriveVideo_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElOneDriveVideo", TElOneDriveVideo_methods);
	if (NULL == TElOneDriveTaggedObject_ce_ptr)
		Register_TElOneDriveTaggedObject(TSRMLS_C);
	TElOneDriveVideo_ce_ptr = zend_register_internal_class_ex(&ce, TElOneDriveTaggedObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElOneDriveAlbum_ce_ptr = NULL;

SB_PHP_METHOD(TElOneDriveAlbum, Clone)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOneDriveAlbum_Clone(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveAlbum, __construct)
{
	zval *oStorage;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oStorage, TElOneDriveDataStorage_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOneDriveAlbum_Create(SBGetObjectHandle(oStorage TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElOneDriveDataStorage)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveAlbum_Clone, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveAlbum___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Storage, TElOneDriveDataStorage, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElOneDriveAlbum_methods[] = {
	PHP_ME(TElOneDriveAlbum, Clone, arginfo_TElOneDriveAlbum_Clone, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveAlbum, __construct, arginfo_TElOneDriveAlbum___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElOneDriveAlbum(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElOneDriveAlbum_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElOneDriveAlbum", TElOneDriveAlbum_methods);
	if (NULL == TElOneDriveFolder_ce_ptr)
		Register_TElOneDriveFolder(TSRMLS_C);
	TElOneDriveAlbum_ce_ptr = zend_register_internal_class_ex(&ce, TElOneDriveFolder_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElOneDriveUserInfo_ce_ptr = NULL;

SB_PHP_METHOD(TElOneDriveUserInfo, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TElOneDriveUserInfo_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElOneDriveUserInfo_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElOneDriveUserInfo)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveUserInfo, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElOneDriveUserInfo_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveUserInfo, Clone)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOneDriveUserInfo_Clone(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElOneDriveUserInfo_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveUserInfo, Refresh)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElOneDriveUserInfo_Refresh(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveUserInfo, get_FirstName)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElOneDriveUserInfo_get_FirstName(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-377699222, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveUserInfo, set_FirstName)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElOneDriveUserInfo_set_FirstName(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveUserInfo, get_Gender)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElOneDriveUserInfo_get_Gender(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1493794507, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveUserInfo, set_Gender)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElOneDriveUserInfo_set_Gender(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveUserInfo, get_ID)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElOneDriveUserInfo_get_ID(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(213529877, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveUserInfo, set_ID)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElOneDriveUserInfo_set_ID(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveUserInfo, get_LastName)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElOneDriveUserInfo_get_LastName(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-891560865, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveUserInfo, set_LastName)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElOneDriveUserInfo_set_LastName(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveUserInfo, get_Link)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElOneDriveUserInfo_get_Link(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1196684789, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveUserInfo, set_Link)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElOneDriveUserInfo_set_Link(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveUserInfo, get_Locale)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElOneDriveUserInfo_get_Locale(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(540102127, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveUserInfo, set_Locale)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElOneDriveUserInfo_set_Locale(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveUserInfo, get_Name)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElOneDriveUserInfo_get_Name(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(802951682, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveUserInfo, set_Name)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElOneDriveUserInfo_set_Name(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveUserInfo, get_UpdatedTime)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(TElOneDriveUserInfo_get_UpdatedTime(SBGetObjectHandle(getThis() TSRMLS_CC), &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveUserInfo, set_UpdatedTime)
{
	zval *dtValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &dtValue, php_date_get_date_ce()) == SUCCESS)
	{
		SBCheckError(TElOneDriveUserInfo_set_UpdatedTime(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetDateTime(dtValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(DateTime)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOneDriveUserInfo, __construct)
{
	zval *oAStorage;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAStorage, TElOneDriveDataStorage_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOneDriveUserInfo_Create(SBGetObjectHandle(oAStorage TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElOneDriveDataStorage)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveUserInfo_Assign, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Source, TElOneDriveUserInfo, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveUserInfo_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveUserInfo_Clone, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveUserInfo_Refresh, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveUserInfo_get_FirstName, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveUserInfo_set_FirstName, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveUserInfo_get_Gender, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveUserInfo_set_Gender, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveUserInfo_get_ID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveUserInfo_set_ID, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveUserInfo_get_LastName, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveUserInfo_set_LastName, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveUserInfo_get_Link, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveUserInfo_set_Link, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveUserInfo_get_Locale, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveUserInfo_set_Locale, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveUserInfo_get_Name, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveUserInfo_set_Name, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveUserInfo_get_UpdatedTime, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveUserInfo_set_UpdatedTime, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, DateTime, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOneDriveUserInfo___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AStorage, TElOneDriveDataStorage, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElOneDriveUserInfo_methods[] = {
	PHP_ME(TElOneDriveUserInfo, Assign, arginfo_TElOneDriveUserInfo_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveUserInfo, Clear, arginfo_TElOneDriveUserInfo_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveUserInfo, Clone, arginfo_TElOneDriveUserInfo_Clone, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveUserInfo, Refresh, arginfo_TElOneDriveUserInfo_Refresh, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveUserInfo, get_FirstName, arginfo_TElOneDriveUserInfo_get_FirstName, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveUserInfo, set_FirstName, arginfo_TElOneDriveUserInfo_set_FirstName, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveUserInfo, get_Gender, arginfo_TElOneDriveUserInfo_get_Gender, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveUserInfo, set_Gender, arginfo_TElOneDriveUserInfo_set_Gender, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveUserInfo, get_ID, arginfo_TElOneDriveUserInfo_get_ID, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveUserInfo, set_ID, arginfo_TElOneDriveUserInfo_set_ID, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveUserInfo, get_LastName, arginfo_TElOneDriveUserInfo_get_LastName, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveUserInfo, set_LastName, arginfo_TElOneDriveUserInfo_set_LastName, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveUserInfo, get_Link, arginfo_TElOneDriveUserInfo_get_Link, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveUserInfo, set_Link, arginfo_TElOneDriveUserInfo_set_Link, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveUserInfo, get_Locale, arginfo_TElOneDriveUserInfo_get_Locale, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveUserInfo, set_Locale, arginfo_TElOneDriveUserInfo_set_Locale, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveUserInfo, get_Name, arginfo_TElOneDriveUserInfo_get_Name, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveUserInfo, set_Name, arginfo_TElOneDriveUserInfo_set_Name, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveUserInfo, get_UpdatedTime, arginfo_TElOneDriveUserInfo_get_UpdatedTime, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveUserInfo, set_UpdatedTime, arginfo_TElOneDriveUserInfo_set_UpdatedTime, ZEND_ACC_PUBLIC)
	PHP_ME(TElOneDriveUserInfo, __construct, arginfo_TElOneDriveUserInfo___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElOneDriveUserInfo(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElOneDriveUserInfo_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElOneDriveUserInfo", TElOneDriveUserInfo_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElOneDriveUserInfo_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

