#include "sbpkcs11base.h"

zend_class_entry *TElPKCS11CertificateType_ce_ptr = NULL;

zend_class_entry *TElPKCS11CertificateCategory_ce_ptr = NULL;

zend_class_entry *TElPKCS11NotificationFlag_ce_ptr = NULL;

zend_class_entry *TElPKCS11UserType_ce_ptr = NULL;

zend_class_entry *TElPKCS11KeyType_ce_ptr = NULL;

zend_class_entry *TElPKCS11SessionState_ce_ptr = NULL;

zend_class_entry *TSBPKCS11StorageOption_ce_ptr = NULL;

zend_class_entry *TSBPKCS11StorageOptions_ce_ptr = NULL;

void SB_CALLBACK TElPKCSNotifyEventRaw(void * _ObjectData, TObjectHandle Sender, TElPKCS11SessionInfoHandle SessionInfo, TElPKCS11NotificationFlagRaw NotificationFlag, int8_t * AbortOperation)
{
	zval *retval_ptr;
	zval **params[4];
	zval * zSender;
	zval * zSessionInfo;
	zval * zNotificationFlag;
	zval * zAbortOperation;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zSessionInfo);
	SBInitObject(zSessionInfo, TElPKCS11SessionInfo_ce_ptr, SessionInfo TSRMLS_CC);
	MAKE_STD_ZVAL(zNotificationFlag);
	ZVAL_LONG(zNotificationFlag, (long)NotificationFlag);
	MAKE_STD_ZVAL(zAbortOperation);
	ZVAL_BOOL(zAbortOperation, (zend_bool)*AbortOperation);

	params[0] = &zSender;
	params[1] = &zSessionInfo;
	params[2] = &zNotificationFlag;
	params[3] = &zAbortOperation;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 4, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zSessionInfo);
	zval_ptr_dtor(&zNotificationFlag);
	*AbortOperation = (int8_t)Z_BVAL_P(zAbortOperation);
	zval_ptr_dtor(&zAbortOperation);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TElPKCSSlotEventEventRaw(void * _ObjectData, TObjectHandle Sender, TElPKCS11SlotInfoHandle Slot)
{
	zval *retval_ptr;
	zval **params[2];
	zval * zSender;
	zval * zSlot;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zSlot);
	SBInitObject(zSlot, TElPKCS11SlotInfo_ce_ptr, Slot TSRMLS_CC);

	params[0] = &zSender;
	params[1] = &zSlot;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 2, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zSlot);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

zend_class_entry *TSBPKCS11SlotEventMonitoringMode_ce_ptr = NULL;

zend_class_entry *TSBPKCS11ObjectType_ce_ptr = NULL;

zend_class_entry *TElPKCS11ObjectClass_ce_ptr = NULL;

zend_class_entry *TSBPKCS11CertCategory_ce_ptr = NULL;

zend_class_entry *TSBPKCS11CertType_ce_ptr = NULL;

zend_class_entry *TSBPKCS11MIDPSecurityDomain_ce_ptr = NULL;

zend_class_entry *TSBPKCS11TokenAccessMode_ce_ptr = NULL;

void SB_CALLBACK TElSlotEventMonitoringThreadEventRaw(void * _ObjectData, TObjectHandle Sender, uint32_t SlotID)
{
	zval *retval_ptr;
	zval **params[2];
	zval * zSender;
	zval * zSlotID;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zSlotID);
	ZVAL_LONG(zSlotID, (long)SlotID);

	params[0] = &zSender;
	params[1] = &zSlotID;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 2, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zSlotID);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

zend_class_entry *TElPKCS11Module_ce_ptr = NULL;

SB_PHP_METHOD(TElPKCS11Module, CloseSession)
{
	zval *oSessionInfo;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSessionInfo, TElPKCS11SessionInfo_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPKCS11Module_CloseSession(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSessionInfo TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElPKCS11SessionInfo)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11Module, GetFunctionList)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPKCS11Module_GetFunctionList(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11Module, OpenSession)
{
	long l4SlotIndex;
	zend_bool bReadOnly;
	zval *oConsumer;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lbO!", &l4SlotIndex, &bReadOnly, &oConsumer, TElPKCS11Consumer_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPKCS11Module_OpenSession(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4SlotIndex, (int8_t)bReadOnly, SBGetObjectHandle(oConsumer TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElPKCS11SessionInfo_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, bool, TElPKCS11Consumer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11Module, OpenSessionEx)
{
	long l4SlotIndex;
	zend_bool bReadOnly;
	zend_bool bRequestNotifications;
	zval *oConsumer;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lbO!b", &l4SlotIndex, &bReadOnly, &oConsumer, TElPKCS11Consumer_ce_ptr, &bRequestNotifications) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPKCS11Module_OpenSessionEx(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4SlotIndex, (int8_t)bReadOnly, SBGetObjectHandle(oConsumer TSRMLS_CC), (int8_t)bRequestNotifications, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElPKCS11SessionInfo_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, bool, TElPKCS11Consumer, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11Module, GetSessionByHandle)
{
#ifdef SB_NOT_CPU64_OR_WINDOWS
	long u4Handle;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u4Handle) == SUCCESS)
#else
	long l8Handle;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l8Handle) == SUCCESS)
#endif
	{
		TElClassHandle hoOutResult = NULL;
#ifdef SB_NOT_CPU64_OR_WINDOWS
		SBCheckError(TElPKCS11Module_GetSessionByHandle(SBGetObjectHandle(getThis() TSRMLS_CC), (uint32_t)u4Handle, &hoOutResult) TSRMLS_CC);
#else
		SBCheckError(TElPKCS11Module_GetSessionByHandle(SBGetObjectHandle(getThis() TSRMLS_CC), (int64_t)l8Handle, &hoOutResult) TSRMLS_CC);
#endif
		SBInitObject(return_value, TElPKCS11SessionInfo_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11Module, InitToken)
{
	char *sPin;
	char *sTokenLabel;
	int sPin_len;
	int sTokenLabel_len;
	long l4SlotIndex;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lss", &l4SlotIndex, &sPin, &sPin_len, &sTokenLabel, &sTokenLabel_len) == SUCCESS)
	{
		SBCheckError(TElPKCS11Module_InitToken(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4SlotIndex, sPin, (int32_t)sPin_len, sTokenLabel, (int32_t)sTokenLabel_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, string, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11Module, get_ProviderDescription)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElPKCS11Module_get_ProviderDescription(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(322616071, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11Module, set_ProviderDescription)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElPKCS11Module_set_ProviderDescription(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11Module, get_Session)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPKCS11Module_get_Session(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElPKCS11SessionInfo_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11Module, get_SessionCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPKCS11Module_get_SessionCount(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11Module, get_Slot)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPKCS11Module_get_Slot(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElPKCS11SlotInfo_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11Module, get_SlotCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPKCS11Module_get_SlotCount(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11Module, get_UniqueID)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElPKCS11Module_get_UniqueID(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(236493488, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11Module, get_HLib)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
#ifndef CPU64
		uint32_t u4OutResultRaw = 0;
		SBCheckError(TElPKCS11Module_get_HLib(SBGetObjectHandle(getThis() TSRMLS_CC), &u4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
#else
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElPKCS11Module_get_HLib(SBGetObjectHandle(getThis() TSRMLS_CC), &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
#endif
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11Module, get_UseGetFunctionList)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPKCS11Module_get_UseGetFunctionList(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11Module, set_UseGetFunctionList)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElPKCS11Module_set_UseGetFunctionList(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11Module, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPKCS11Module_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11Module_CloseSession, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, SessionInfo, TElPKCS11SessionInfo, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11Module_GetFunctionList, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11Module_OpenSession, 0, 0, 3)
	ZEND_ARG_INFO(0, SlotIndex)
	ZEND_ARG_INFO(0, ReadOnly)
	ZEND_ARG_OBJ_INFO(0, Consumer, TElPKCS11Consumer, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11Module_OpenSessionEx, 0, 0, 4)
	ZEND_ARG_INFO(0, SlotIndex)
	ZEND_ARG_INFO(0, ReadOnly)
	ZEND_ARG_OBJ_INFO(0, Consumer, TElPKCS11Consumer, 1)
	ZEND_ARG_INFO(0, RequestNotifications)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11Module_GetSessionByHandle, 0, 0, 1)
	ZEND_ARG_INFO(0, Handle)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11Module_InitToken, 0, 0, 3)
	ZEND_ARG_INFO(0, SlotIndex)
	ZEND_ARG_INFO(0, Pin)
	ZEND_ARG_INFO(0, TokenLabel)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11Module_get_ProviderDescription, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11Module_set_ProviderDescription, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11Module_get_Session, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11Module_get_SessionCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11Module_get_Slot, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11Module_get_SlotCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11Module_get_UniqueID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11Module_get_HLib, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11Module_get_UseGetFunctionList, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11Module_set_UseGetFunctionList, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11Module___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElPKCS11Module_methods[] = {
	PHP_ME(TElPKCS11Module, CloseSession, arginfo_TElPKCS11Module_CloseSession, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11Module, GetFunctionList, arginfo_TElPKCS11Module_GetFunctionList, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11Module, OpenSession, arginfo_TElPKCS11Module_OpenSession, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11Module, OpenSessionEx, arginfo_TElPKCS11Module_OpenSessionEx, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11Module, GetSessionByHandle, arginfo_TElPKCS11Module_GetSessionByHandle, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11Module, InitToken, arginfo_TElPKCS11Module_InitToken, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11Module, get_ProviderDescription, arginfo_TElPKCS11Module_get_ProviderDescription, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11Module, set_ProviderDescription, arginfo_TElPKCS11Module_set_ProviderDescription, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11Module, get_Session, arginfo_TElPKCS11Module_get_Session, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11Module, get_SessionCount, arginfo_TElPKCS11Module_get_SessionCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11Module, get_Slot, arginfo_TElPKCS11Module_get_Slot, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11Module, get_SlotCount, arginfo_TElPKCS11Module_get_SlotCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11Module, get_UniqueID, arginfo_TElPKCS11Module_get_UniqueID, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11Module, get_HLib, arginfo_TElPKCS11Module_get_HLib, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11Module, get_UseGetFunctionList, arginfo_TElPKCS11Module_get_UseGetFunctionList, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11Module, set_UseGetFunctionList, arginfo_TElPKCS11Module_set_UseGetFunctionList, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11Module, __construct, arginfo_TElPKCS11Module___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElPKCS11Module(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElPKCS11Module_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElPKCS11Module", TElPKCS11Module_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElPKCS11Module_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElPKCS11SlotInfo_ce_ptr = NULL;

SB_PHP_METHOD(TElPKCS11SlotInfo, AddConsumer)
{
	zval *oConsumer;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oConsumer, TElPKCS11Consumer_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPKCS11SlotInfo_AddConsumer(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oConsumer TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElPKCS11Consumer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11SlotInfo, PinNeeded)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPKCS11SlotInfo_PinNeeded(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11SlotInfo, Refresh)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElPKCS11SlotInfo_Refresh(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11SlotInfo, RefreshSlot)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElPKCS11SlotInfo_RefreshSlot(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11SlotInfo, RefreshSupportedAlgorithms)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElPKCS11SlotInfo_RefreshSupportedAlgorithms(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11SlotInfo, RemoveConsumer)
{
	zval *oConsumer;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oConsumer, TElPKCS11Consumer_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPKCS11SlotInfo_RemoveConsumer(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oConsumer TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElPKCS11Consumer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11SlotInfo, get_ConsumerCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPKCS11SlotInfo_get_ConsumerCount(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11SlotInfo, get_LoggedIn)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPKCS11SlotInfo_get_LoggedIn(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11SlotInfo, get_ReadOnly)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPKCS11SlotInfo_get_ReadOnly(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11SlotInfo, get_SlotManufacturerID)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElPKCS11SlotInfo_get_SlotManufacturerID(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(4214827, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11SlotInfo, get_SlotDescription)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElPKCS11SlotInfo_get_SlotDescription(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-180262983, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11SlotInfo, get_SlotHardwareVersionHi)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t u1OutResultRaw = 0;
		SBCheckError(TElPKCS11SlotInfo_get_SlotHardwareVersionHi(SBGetObjectHandle(getThis() TSRMLS_CC), &u1OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u1OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11SlotInfo, get_SlotFirmwareVersionHi)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t u1OutResultRaw = 0;
		SBCheckError(TElPKCS11SlotInfo_get_SlotFirmwareVersionHi(SBGetObjectHandle(getThis() TSRMLS_CC), &u1OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u1OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11SlotInfo, get_SlotHardwareVersionLo)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t u1OutResultRaw = 0;
		SBCheckError(TElPKCS11SlotInfo_get_SlotHardwareVersionLo(SBGetObjectHandle(getThis() TSRMLS_CC), &u1OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u1OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11SlotInfo, get_SlotFirmwareVersionLo)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t u1OutResultRaw = 0;
		SBCheckError(TElPKCS11SlotInfo_get_SlotFirmwareVersionLo(SBGetObjectHandle(getThis() TSRMLS_CC), &u1OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u1OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11SlotInfo, get_TokenPresent)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPKCS11SlotInfo_get_TokenPresent(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11SlotInfo, get_TokenHardwareVersionHi)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t u1OutResultRaw = 0;
		SBCheckError(TElPKCS11SlotInfo_get_TokenHardwareVersionHi(SBGetObjectHandle(getThis() TSRMLS_CC), &u1OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u1OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11SlotInfo, get_TokenFirmwareVersionHi)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t u1OutResultRaw = 0;
		SBCheckError(TElPKCS11SlotInfo_get_TokenFirmwareVersionHi(SBGetObjectHandle(getThis() TSRMLS_CC), &u1OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u1OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11SlotInfo, get_TokenHardwareVersionLo)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t u1OutResultRaw = 0;
		SBCheckError(TElPKCS11SlotInfo_get_TokenHardwareVersionLo(SBGetObjectHandle(getThis() TSRMLS_CC), &u1OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u1OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11SlotInfo, get_TokenFirmwareVersionLo)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t u1OutResultRaw = 0;
		SBCheckError(TElPKCS11SlotInfo_get_TokenFirmwareVersionLo(SBGetObjectHandle(getThis() TSRMLS_CC), &u1OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u1OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11SlotInfo, get_TokenManufacturerID)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElPKCS11SlotInfo_get_TokenManufacturerID(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-695402202, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11SlotInfo, get_TokenLabel)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElPKCS11SlotInfo_get_TokenLabel(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1007807862, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11SlotInfo, get_TokenModel)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElPKCS11SlotInfo_get_TokenModel(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-450638009, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11SlotInfo, get_TokenSerial)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElPKCS11SlotInfo_get_TokenSerial(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(385035951, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11SlotInfo, get_TokenFlags)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint32_t u4OutResultRaw = 0;
		SBCheckError(TElPKCS11SlotInfo_get_TokenFlags(SBGetObjectHandle(getThis() TSRMLS_CC), &u4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11SlotInfo, get_Module)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPKCS11SlotInfo_get_Module(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElPKCS11Module_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11SlotInfo, get_Consumers)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPKCS11SlotInfo_get_Consumers(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElPKCS11Consumer_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11SlotInfo, get_SupportedPKCS11Mechanisms)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
#ifdef SB_NOT_CPU64_OR_WINDOWS
		uint32_t u4OutResultRaw = 0;
		SBCheckError(TElPKCS11SlotInfo_get_SupportedPKCS11Mechanisms(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &u4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
#else
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElPKCS11SlotInfo_get_SupportedPKCS11Mechanisms(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
#endif
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11SlotInfo, get_SlotID)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
#ifdef SB_NOT_CPU64_OR_WINDOWS
		uint32_t u4OutResultRaw = 0;
		SBCheckError(TElPKCS11SlotInfo_get_SlotID(SBGetObjectHandle(getThis() TSRMLS_CC), &u4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
#else
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElPKCS11SlotInfo_get_SlotID(SBGetObjectHandle(getThis() TSRMLS_CC), &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
#endif
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11SlotInfo, get_SupportedPKCS11MechanismCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPKCS11SlotInfo_get_SupportedPKCS11MechanismCount(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11SlotInfo, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPKCS11SlotInfo_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11SlotInfo_AddConsumer, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Consumer, TElPKCS11Consumer, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11SlotInfo_PinNeeded, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11SlotInfo_Refresh, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11SlotInfo_RefreshSlot, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11SlotInfo_RefreshSupportedAlgorithms, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11SlotInfo_RemoveConsumer, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Consumer, TElPKCS11Consumer, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11SlotInfo_get_ConsumerCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11SlotInfo_get_LoggedIn, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11SlotInfo_get_ReadOnly, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11SlotInfo_get_SlotManufacturerID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11SlotInfo_get_SlotDescription, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11SlotInfo_get_SlotHardwareVersionHi, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11SlotInfo_get_SlotFirmwareVersionHi, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11SlotInfo_get_SlotHardwareVersionLo, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11SlotInfo_get_SlotFirmwareVersionLo, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11SlotInfo_get_TokenPresent, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11SlotInfo_get_TokenHardwareVersionHi, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11SlotInfo_get_TokenFirmwareVersionHi, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11SlotInfo_get_TokenHardwareVersionLo, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11SlotInfo_get_TokenFirmwareVersionLo, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11SlotInfo_get_TokenManufacturerID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11SlotInfo_get_TokenLabel, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11SlotInfo_get_TokenModel, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11SlotInfo_get_TokenSerial, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11SlotInfo_get_TokenFlags, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11SlotInfo_get_Module, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11SlotInfo_get_Consumers, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11SlotInfo_get_SupportedPKCS11Mechanisms, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11SlotInfo_get_SlotID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11SlotInfo_get_SupportedPKCS11MechanismCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11SlotInfo___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElPKCS11SlotInfo_methods[] = {
	PHP_ME(TElPKCS11SlotInfo, AddConsumer, arginfo_TElPKCS11SlotInfo_AddConsumer, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11SlotInfo, PinNeeded, arginfo_TElPKCS11SlotInfo_PinNeeded, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11SlotInfo, Refresh, arginfo_TElPKCS11SlotInfo_Refresh, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11SlotInfo, RefreshSlot, arginfo_TElPKCS11SlotInfo_RefreshSlot, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11SlotInfo, RefreshSupportedAlgorithms, arginfo_TElPKCS11SlotInfo_RefreshSupportedAlgorithms, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11SlotInfo, RemoveConsumer, arginfo_TElPKCS11SlotInfo_RemoveConsumer, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11SlotInfo, get_ConsumerCount, arginfo_TElPKCS11SlotInfo_get_ConsumerCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11SlotInfo, get_LoggedIn, arginfo_TElPKCS11SlotInfo_get_LoggedIn, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11SlotInfo, get_ReadOnly, arginfo_TElPKCS11SlotInfo_get_ReadOnly, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11SlotInfo, get_SlotManufacturerID, arginfo_TElPKCS11SlotInfo_get_SlotManufacturerID, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11SlotInfo, get_SlotDescription, arginfo_TElPKCS11SlotInfo_get_SlotDescription, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11SlotInfo, get_SlotHardwareVersionHi, arginfo_TElPKCS11SlotInfo_get_SlotHardwareVersionHi, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11SlotInfo, get_SlotFirmwareVersionHi, arginfo_TElPKCS11SlotInfo_get_SlotFirmwareVersionHi, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11SlotInfo, get_SlotHardwareVersionLo, arginfo_TElPKCS11SlotInfo_get_SlotHardwareVersionLo, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11SlotInfo, get_SlotFirmwareVersionLo, arginfo_TElPKCS11SlotInfo_get_SlotFirmwareVersionLo, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11SlotInfo, get_TokenPresent, arginfo_TElPKCS11SlotInfo_get_TokenPresent, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11SlotInfo, get_TokenHardwareVersionHi, arginfo_TElPKCS11SlotInfo_get_TokenHardwareVersionHi, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11SlotInfo, get_TokenFirmwareVersionHi, arginfo_TElPKCS11SlotInfo_get_TokenFirmwareVersionHi, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11SlotInfo, get_TokenHardwareVersionLo, arginfo_TElPKCS11SlotInfo_get_TokenHardwareVersionLo, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11SlotInfo, get_TokenFirmwareVersionLo, arginfo_TElPKCS11SlotInfo_get_TokenFirmwareVersionLo, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11SlotInfo, get_TokenManufacturerID, arginfo_TElPKCS11SlotInfo_get_TokenManufacturerID, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11SlotInfo, get_TokenLabel, arginfo_TElPKCS11SlotInfo_get_TokenLabel, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11SlotInfo, get_TokenModel, arginfo_TElPKCS11SlotInfo_get_TokenModel, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11SlotInfo, get_TokenSerial, arginfo_TElPKCS11SlotInfo_get_TokenSerial, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11SlotInfo, get_TokenFlags, arginfo_TElPKCS11SlotInfo_get_TokenFlags, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11SlotInfo, get_Module, arginfo_TElPKCS11SlotInfo_get_Module, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11SlotInfo, get_Consumers, arginfo_TElPKCS11SlotInfo_get_Consumers, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11SlotInfo, get_SupportedPKCS11Mechanisms, arginfo_TElPKCS11SlotInfo_get_SupportedPKCS11Mechanisms, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11SlotInfo, get_SlotID, arginfo_TElPKCS11SlotInfo_get_SlotID, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11SlotInfo, get_SupportedPKCS11MechanismCount, arginfo_TElPKCS11SlotInfo_get_SupportedPKCS11MechanismCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11SlotInfo, __construct, arginfo_TElPKCS11SlotInfo___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElPKCS11SlotInfo(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElPKCS11SlotInfo_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElPKCS11SlotInfo", TElPKCS11SlotInfo_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElPKCS11SlotInfo_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElPKCS11SessionInfo_ce_ptr = NULL;

SB_PHP_METHOD(TElPKCS11SessionInfo, AddObject)
{
	long fObjectType;
	zend_bool bModifiable;
	zend_bool bPrivate;
	zend_bool bToken;
	zval *oAttributes;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lbbbO!", &fObjectType, &bToken, &bPrivate, &bModifiable, &oAttributes, TElPKCS11AttributeList_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPKCS11SessionInfo_AddObject(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBPKCS11ObjectTypeRaw)fObjectType, (int8_t)bToken, (int8_t)bPrivate, (int8_t)bModifiable, SBGetObjectHandle(oAttributes TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lbO!", &fObjectType, &bToken, &oAttributes, TElPKCS11AttributeList_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPKCS11SessionInfo_AddObject_1(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBPKCS11ObjectTypeRaw)fObjectType, (int8_t)bToken, SBGetObjectHandle(oAttributes TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer, bool, bool, bool, TElPKCS11AttributeList) or (integer, bool, TElPKCS11AttributeList)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11SessionInfo, AddGeneratedObject)
{
#ifdef SB_NOT_CPU64_OR_WINDOWS
	long u4Handle;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u4Handle) == SUCCESS)
#else
	long l8Handle;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l8Handle) == SUCCESS)
#endif
	{
		int32_t l4OutResultRaw = 0;
#ifdef SB_NOT_CPU64_OR_WINDOWS
		SBCheckError(TElPKCS11SessionInfo_AddGeneratedObject(SBGetObjectHandle(getThis() TSRMLS_CC), (uint32_t)u4Handle, &l4OutResultRaw) TSRMLS_CC);
#else
		SBCheckError(TElPKCS11SessionInfo_AddGeneratedObject(SBGetObjectHandle(getThis() TSRMLS_CC), (int64_t)l8Handle, &l4OutResultRaw) TSRMLS_CC);
#endif
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11SessionInfo, RemoveObject)
{
	long l4Index;
	zval *oObj;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		SBCheckError(TElPKCS11SessionInfo_RemoveObject(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oObj, TElPKCS11Object_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPKCS11SessionInfo_RemoveObject_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObj TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer) or (TElPKCS11Object)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11SessionInfo, RemoveObjectByHandle)
{
#ifdef SB_NOT_CPU64_OR_WINDOWS
	long u4Handle;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u4Handle) == SUCCESS)
#else
	long l8Handle;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l8Handle) == SUCCESS)
#endif
	{
#ifdef SB_NOT_CPU64_OR_WINDOWS
		SBCheckError(TElPKCS11SessionInfo_RemoveObjectByHandle(SBGetObjectHandle(getThis() TSRMLS_CC), (uint32_t)u4Handle) TSRMLS_CC);
#else
		SBCheckError(TElPKCS11SessionInfo_RemoveObjectByHandle(SBGetObjectHandle(getThis() TSRMLS_CC), (int64_t)l8Handle) TSRMLS_CC);
#endif
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11SessionInfo, ClearObjects)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElPKCS11SessionInfo_ClearObjects(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11SessionInfo, CopyObject)
{
	long l4Index;
	zend_bool bModifiable;
	zend_bool bPrivate;
	zend_bool bToken;
	zval *oAttributes;
	zval *oObj;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lbbbO!", &l4Index, &bToken, &bPrivate, &bModifiable, &oAttributes, TElPKCS11AttributeList_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPKCS11SessionInfo_CopyObject(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, (int8_t)bToken, (int8_t)bPrivate, (int8_t)bModifiable, SBGetObjectHandle(oAttributes TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!bbbO!", &oObj, TElPKCS11Object_ce_ptr, &bToken, &bPrivate, &bModifiable, &oAttributes, TElPKCS11AttributeList_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPKCS11SessionInfo_CopyObject_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObj TSRMLS_CC), (int8_t)bToken, (int8_t)bPrivate, (int8_t)bModifiable, SBGetObjectHandle(oAttributes TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer, bool, bool, bool, TElPKCS11AttributeList) or (TElPKCS11Object, bool, bool, bool, TElPKCS11AttributeList)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11SessionInfo, GetObjectByHandle)
{
#ifdef SB_NOT_CPU64_OR_WINDOWS
	long u4Handle;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u4Handle) == SUCCESS)
#else
	long l8Handle;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l8Handle) == SUCCESS)
#endif
	{
		TElClassHandle hoOutResult = NULL;
#ifdef SB_NOT_CPU64_OR_WINDOWS
		SBCheckError(TElPKCS11SessionInfo_GetObjectByHandle(SBGetObjectHandle(getThis() TSRMLS_CC), (uint32_t)u4Handle, &hoOutResult) TSRMLS_CC);
#else
		SBCheckError(TElPKCS11SessionInfo_GetObjectByHandle(SBGetObjectHandle(getThis() TSRMLS_CC), (int64_t)l8Handle, &hoOutResult) TSRMLS_CC);
#endif
		SBInitObject(return_value, TElPKCS11Object_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11SessionInfo, GetObjectBySubjectOrID)
{
	long fObjectType;
	SBArrayZValInfo aiID;
	SBArrayZValInfo aiSubject;
	zend_bool bIDMustMatch;
	zend_bool bSubjectMustMatch;
	zval *zaID;
	zval *zaSubject;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lzz", &fObjectType, &zaSubject, &zaID) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaSubject)) || (IS_ARRAY == Z_TYPE_P(zaSubject)) || (IS_NULL == Z_TYPE_P(zaSubject))) && ((IS_STRING == Z_TYPE_P(zaID)) || (IS_ARRAY == Z_TYPE_P(zaID)) || (IS_NULL == Z_TYPE_P(zaID))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetByteArrayFromZVal(zaSubject, &aiSubject TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaID, &aiID TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPKCS11SessionInfo_GetObjectBySubjectOrID(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBPKCS11ObjectTypeRaw)fObjectType, aiSubject.data, aiSubject.len, aiID.data, aiID.len, &hoOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiSubject);
		SBFreeArrayZValInfo(&aiID);
		SBInitObject(return_value, TElPKCS11Object_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lzzbb", &fObjectType, &zaSubject, &zaID, &bSubjectMustMatch, &bIDMustMatch) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaSubject)) || (IS_ARRAY == Z_TYPE_P(zaSubject)) || (IS_NULL == Z_TYPE_P(zaSubject))) && ((IS_STRING == Z_TYPE_P(zaID)) || (IS_ARRAY == Z_TYPE_P(zaID)) || (IS_NULL == Z_TYPE_P(zaID))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetByteArrayFromZVal(zaSubject, &aiSubject TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaID, &aiID TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPKCS11SessionInfo_GetObjectBySubjectOrID_1(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBPKCS11ObjectTypeRaw)fObjectType, aiSubject.data, aiSubject.len, aiID.data, aiID.len, (int8_t)bSubjectMustMatch, (int8_t)bIDMustMatch, &hoOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiSubject);
		SBFreeArrayZValInfo(&aiID);
		SBInitObject(return_value, TElPKCS11Object_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, array of byte|string|NULL, array of byte|string|NULL) or (integer, array of byte|string|NULL, array of byte|string|NULL, bool, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11SessionInfo, Close)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPKCS11SessionInfo_Close(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11SessionInfo, Login)
{
	char *sPIN;
	int sPIN_len;
	long fUserType;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ls", &fUserType, &sPIN, &sPIN_len) == SUCCESS)
	{
		SBCheckError(TElPKCS11SessionInfo_Login(SBGetObjectHandle(getThis() TSRMLS_CC), (TElPKCS11UserTypeRaw)fUserType, sPIN, (int32_t)sPIN_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11SessionInfo, Logout)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElPKCS11SessionInfo_Logout(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11SessionInfo, ClearObjectInstances)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElPKCS11SessionInfo_ClearObjectInstances(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11SessionInfo, RefreshObjectList)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElPKCS11SessionInfo_RefreshObjectList(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11SessionInfo, UpdateObjectList)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElPKCS11SessionInfo_UpdateObjectList(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11SessionInfo, AcquireSession)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElPKCS11SessionInfo_AcquireSession(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11SessionInfo, ReleaseSession)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElPKCS11SessionInfo_ReleaseSession(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11SessionInfo, InitPIN)
{
	char *sPin;
	int sPin_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sPin, &sPin_len) == SUCCESS)
	{
		SBCheckError(TElPKCS11SessionInfo_InitPIN(SBGetObjectHandle(getThis() TSRMLS_CC), sPin, (int32_t)sPin_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11SessionInfo, SetPIN)
{
	char *sNewPin;
	char *sOldPin;
	int sNewPin_len;
	int sOldPin_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &sOldPin, &sOldPin_len, &sNewPin, &sNewPin_len) == SUCCESS)
	{
		SBCheckError(TElPKCS11SessionInfo_SetPIN(SBGetObjectHandle(getThis() TSRMLS_CC), sOldPin, (int32_t)sOldPin_len, sNewPin, (int32_t)sNewPin_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11SessionInfo, get_Consumer)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPKCS11SessionInfo_get_Consumer(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElPKCS11Consumer_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11SessionInfo, get_Slot)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPKCS11SessionInfo_get_Slot(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElPKCS11SlotInfo_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11SessionInfo, get_Handle)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
#ifdef SB_NOT_CPU64_OR_WINDOWS
		uint32_t u4OutResultRaw = 0;
		SBCheckError(TElPKCS11SessionInfo_get_Handle(SBGetObjectHandle(getThis() TSRMLS_CC), &u4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
#else
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElPKCS11SessionInfo_get_Handle(SBGetObjectHandle(getThis() TSRMLS_CC), &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
#endif
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11SessionInfo, get_CryptoProvider)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPKCS11SessionInfo_get_CryptoProvider(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomCryptoProvider_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11SessionInfo, set_CryptoProvider)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPKCS11SessionInfo_set_CryptoProvider(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCryptoProvider)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11SessionInfo, get_ObjectCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPKCS11SessionInfo_get_ObjectCount(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11SessionInfo, get_TokenAccessMode)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBPKCS11TokenAccessModeRaw fOutResultRaw = 0;
		SBCheckError(TElPKCS11SessionInfo_get_TokenAccessMode(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11SessionInfo, set_TokenAccessMode)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElPKCS11SessionInfo_set_TokenAccessMode(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBPKCS11TokenAccessModeRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11SessionInfo, get_IsOnDemandSession)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPKCS11SessionInfo_get_IsOnDemandSession(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11SessionInfo, get_Objects)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPKCS11SessionInfo_get_Objects(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElPKCS11Object_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11SessionInfo, get_TokenProps)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPKCS11SessionInfo_get_TokenProps(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11SessionInfo, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPKCS11SessionInfo_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11SessionInfo_AddObject, 0, 0, 3)
	ZEND_ARG_INFO(0, ObjectType)
	ZEND_ARG_INFO(0, Token)
	ZEND_ARG_TYPE_INFO(0, Private_or_Attributes, 0, 1)
	ZEND_ARG_INFO(0, Modifiable)
	ZEND_ARG_OBJ_INFO(0, Attributes, TElPKCS11AttributeList, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11SessionInfo_AddGeneratedObject, 0, 0, 1)
	ZEND_ARG_INFO(0, Handle)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11SessionInfo_RemoveObject, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Index_or_Obj, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11SessionInfo_RemoveObjectByHandle, 0, 0, 1)
	ZEND_ARG_INFO(0, Handle)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11SessionInfo_ClearObjects, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11SessionInfo_CopyObject, 0, 0, 5)
	ZEND_ARG_TYPE_INFO(0, Index_or_Obj, 0, 1)
	ZEND_ARG_INFO(0, Token)
	ZEND_ARG_INFO(0, Private)
	ZEND_ARG_INFO(0, Modifiable)
	ZEND_ARG_OBJ_INFO(0, Attributes, TElPKCS11AttributeList, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11SessionInfo_GetObjectByHandle, 0, 0, 1)
	ZEND_ARG_INFO(0, Handle)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11SessionInfo_GetObjectBySubjectOrID, 0, 0, 3)
	ZEND_ARG_INFO(0, ObjectType)
	ZEND_ARG_TYPE_INFO(0, Subject, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ID, 0, 1)
	ZEND_ARG_INFO(0, SubjectMustMatch)
	ZEND_ARG_INFO(0, IDMustMatch)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11SessionInfo_Close, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11SessionInfo_Login, 0, 0, 2)
	ZEND_ARG_INFO(0, UserType)
	ZEND_ARG_INFO(0, PIN)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11SessionInfo_Logout, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11SessionInfo_ClearObjectInstances, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11SessionInfo_RefreshObjectList, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11SessionInfo_UpdateObjectList, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11SessionInfo_AcquireSession, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11SessionInfo_ReleaseSession, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11SessionInfo_InitPIN, 0, 0, 1)
	ZEND_ARG_INFO(0, Pin)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11SessionInfo_SetPIN, 0, 0, 2)
	ZEND_ARG_INFO(0, OldPin)
	ZEND_ARG_INFO(0, NewPin)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11SessionInfo_get_Consumer, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11SessionInfo_get_Slot, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11SessionInfo_get_Handle, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11SessionInfo_get_CryptoProvider, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11SessionInfo_set_CryptoProvider, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElCustomCryptoProvider, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11SessionInfo_get_ObjectCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11SessionInfo_get_TokenAccessMode, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11SessionInfo_set_TokenAccessMode, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11SessionInfo_get_IsOnDemandSession, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11SessionInfo_get_Objects, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11SessionInfo_get_TokenProps, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11SessionInfo___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElPKCS11SessionInfo_methods[] = {
	PHP_ME(TElPKCS11SessionInfo, AddObject, arginfo_TElPKCS11SessionInfo_AddObject, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11SessionInfo, AddGeneratedObject, arginfo_TElPKCS11SessionInfo_AddGeneratedObject, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11SessionInfo, RemoveObject, arginfo_TElPKCS11SessionInfo_RemoveObject, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11SessionInfo, RemoveObjectByHandle, arginfo_TElPKCS11SessionInfo_RemoveObjectByHandle, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11SessionInfo, ClearObjects, arginfo_TElPKCS11SessionInfo_ClearObjects, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11SessionInfo, CopyObject, arginfo_TElPKCS11SessionInfo_CopyObject, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11SessionInfo, GetObjectByHandle, arginfo_TElPKCS11SessionInfo_GetObjectByHandle, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11SessionInfo, GetObjectBySubjectOrID, arginfo_TElPKCS11SessionInfo_GetObjectBySubjectOrID, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11SessionInfo, Close, arginfo_TElPKCS11SessionInfo_Close, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11SessionInfo, Login, arginfo_TElPKCS11SessionInfo_Login, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11SessionInfo, Logout, arginfo_TElPKCS11SessionInfo_Logout, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11SessionInfo, ClearObjectInstances, arginfo_TElPKCS11SessionInfo_ClearObjectInstances, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11SessionInfo, RefreshObjectList, arginfo_TElPKCS11SessionInfo_RefreshObjectList, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11SessionInfo, UpdateObjectList, arginfo_TElPKCS11SessionInfo_UpdateObjectList, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11SessionInfo, AcquireSession, arginfo_TElPKCS11SessionInfo_AcquireSession, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11SessionInfo, ReleaseSession, arginfo_TElPKCS11SessionInfo_ReleaseSession, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11SessionInfo, InitPIN, arginfo_TElPKCS11SessionInfo_InitPIN, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11SessionInfo, SetPIN, arginfo_TElPKCS11SessionInfo_SetPIN, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11SessionInfo, get_Consumer, arginfo_TElPKCS11SessionInfo_get_Consumer, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11SessionInfo, get_Slot, arginfo_TElPKCS11SessionInfo_get_Slot, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11SessionInfo, get_Handle, arginfo_TElPKCS11SessionInfo_get_Handle, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11SessionInfo, get_CryptoProvider, arginfo_TElPKCS11SessionInfo_get_CryptoProvider, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11SessionInfo, set_CryptoProvider, arginfo_TElPKCS11SessionInfo_set_CryptoProvider, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11SessionInfo, get_ObjectCount, arginfo_TElPKCS11SessionInfo_get_ObjectCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11SessionInfo, get_TokenAccessMode, arginfo_TElPKCS11SessionInfo_get_TokenAccessMode, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11SessionInfo, set_TokenAccessMode, arginfo_TElPKCS11SessionInfo_set_TokenAccessMode, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11SessionInfo, get_IsOnDemandSession, arginfo_TElPKCS11SessionInfo_get_IsOnDemandSession, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11SessionInfo, get_Objects, arginfo_TElPKCS11SessionInfo_get_Objects, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11SessionInfo, get_TokenProps, arginfo_TElPKCS11SessionInfo_get_TokenProps, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11SessionInfo, __construct, arginfo_TElPKCS11SessionInfo___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElPKCS11SessionInfo(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElPKCS11SessionInfo_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElPKCS11SessionInfo", TElPKCS11SessionInfo_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElPKCS11SessionInfo_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElPKCS11Consumer_ce_ptr = NULL;

SB_PHP_METHOD(TElPKCS11Consumer, get_UniqueID)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElPKCS11Consumer_get_UniqueID(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-1535540855, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11Consumer, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPKCS11Consumer_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11Consumer_get_UniqueID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11Consumer___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElPKCS11Consumer_methods[] = {
	PHP_ME(TElPKCS11Consumer, get_UniqueID, arginfo_TElPKCS11Consumer_get_UniqueID, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11Consumer, __construct, arginfo_TElPKCS11Consumer___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElPKCS11Consumer(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElPKCS11Consumer_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElPKCS11Consumer", TElPKCS11Consumer_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElPKCS11Consumer_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElPKCS11AttributeList_ce_ptr = NULL;

SB_PHP_METHOD(TElPKCS11AttributeList, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TElPKCS11AttributeList_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPKCS11AttributeList_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElPKCS11AttributeList)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11AttributeList, Add)
{
#ifdef SB_NOT_CPU64_OR_WINDOWS
	long u4Attribute;
	long u4Value;
#else
	long l8Attribute;
	long l8Value;
#endif
	SBArrayZValInfo aiValue;
	zend_bool bValue;
	zval *zaValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPKCS11AttributeList_Add(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
#ifdef SB_NOT_CPU64_OR_WINDOWS
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lz", &u4Attribute, &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
#else
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lz", &l8Attribute, &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
#endif
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
#ifdef SB_NOT_CPU64_OR_WINDOWS
		SBCheckError(TElPKCS11AttributeList_Add_1(SBGetObjectHandle(getThis() TSRMLS_CC), (uint32_t)u4Attribute, aiValue.data, aiValue.len, &l4OutResultRaw) TSRMLS_CC);
#else
		SBCheckError(TElPKCS11AttributeList_Add_1(SBGetObjectHandle(getThis() TSRMLS_CC), (int64_t)l8Attribute, aiValue.data, aiValue.len, &l4OutResultRaw) TSRMLS_CC);
#endif
		SBFreeArrayZValInfo(&aiValue);
		RETURN_LONG((long)l4OutResultRaw);
	}
#ifdef SB_NOT_CPU64_OR_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &u4Attribute, &u4Value) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &l8Attribute, &l8Value) == SUCCESS)
#endif
	{
		int32_t l4OutResultRaw = 0;
#ifdef SB_NOT_CPU64_OR_WINDOWS
		SBCheckError(TElPKCS11AttributeList_Add_2(SBGetObjectHandle(getThis() TSRMLS_CC), (uint32_t)u4Attribute, (uint32_t)u4Value, &l4OutResultRaw) TSRMLS_CC);
#else
		SBCheckError(TElPKCS11AttributeList_Add_2(SBGetObjectHandle(getThis() TSRMLS_CC), (int64_t)l8Attribute, (int64_t)l8Value, &l4OutResultRaw) TSRMLS_CC);
#endif
		RETURN_LONG((long)l4OutResultRaw);
	}
#ifdef SB_NOT_CPU64_OR_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lb", &u4Attribute, &bValue) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lb", &l8Attribute, &bValue) == SUCCESS)
#endif
	{
		int32_t l4OutResultRaw = 0;
#ifdef SB_NOT_CPU64_OR_WINDOWS
		SBCheckError(TElPKCS11AttributeList_Add_3(SBGetObjectHandle(getThis() TSRMLS_CC), (uint32_t)u4Attribute, (int8_t)bValue, &l4OutResultRaw) TSRMLS_CC);
#else
		SBCheckError(TElPKCS11AttributeList_Add_3(SBGetObjectHandle(getThis() TSRMLS_CC), (int64_t)l8Attribute, (int8_t)bValue, &l4OutResultRaw) TSRMLS_CC);
#endif
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("() or (integer, array of byte|string|NULL) or (integer, integer) or (integer, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11AttributeList, AddByte)
{
#ifndef SB_NOT_CPU64_OR_WINDOWS
	long l8Attribute;
#endif
	long u1Value;
#ifdef SB_NOT_CPU64_OR_WINDOWS
	long u4Attribute;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &u4Attribute, &u1Value) == SUCCESS)
#else
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &l8Attribute, &u1Value) == SUCCESS)
#endif
	{
		int32_t l4OutResultRaw = 0;
#ifdef SB_NOT_CPU64_OR_WINDOWS
		SBCheckError(TElPKCS11AttributeList_AddByte(SBGetObjectHandle(getThis() TSRMLS_CC), (uint32_t)u4Attribute, (uint8_t)u1Value, &l4OutResultRaw) TSRMLS_CC);
#else
		SBCheckError(TElPKCS11AttributeList_AddByte(SBGetObjectHandle(getThis() TSRMLS_CC), (int64_t)l8Attribute, (uint8_t)u1Value, &l4OutResultRaw) TSRMLS_CC);
#endif
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11AttributeList, AddWord)
{
#ifndef SB_NOT_CPU64_OR_WINDOWS
	long l8Attribute;
#endif
	long u2Value;
#ifdef SB_NOT_CPU64_OR_WINDOWS
	long u4Attribute;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &u4Attribute, &u2Value) == SUCCESS)
#else
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &l8Attribute, &u2Value) == SUCCESS)
#endif
	{
		int32_t l4OutResultRaw = 0;
#ifdef SB_NOT_CPU64_OR_WINDOWS
		SBCheckError(TElPKCS11AttributeList_AddWord(SBGetObjectHandle(getThis() TSRMLS_CC), (uint32_t)u4Attribute, (uint16_t)u2Value, &l4OutResultRaw) TSRMLS_CC);
#else
		SBCheckError(TElPKCS11AttributeList_AddWord(SBGetObjectHandle(getThis() TSRMLS_CC), (int64_t)l8Attribute, (uint16_t)u2Value, &l4OutResultRaw) TSRMLS_CC);
#endif
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11AttributeList, AddThreeByteInteger)
{
#ifdef SB_NOT_CPU64_OR_WINDOWS
	long u4Attribute;
	long u4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &u4Attribute, &u4Value) == SUCCESS)
#else
	long l8Attribute;
	long l8Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &l8Attribute, &l8Value) == SUCCESS)
#endif
	{
		int32_t l4OutResultRaw = 0;
#ifdef SB_NOT_CPU64_OR_WINDOWS
		SBCheckError(TElPKCS11AttributeList_AddThreeByteInteger(SBGetObjectHandle(getThis() TSRMLS_CC), (uint32_t)u4Attribute, (uint32_t)u4Value, &l4OutResultRaw) TSRMLS_CC);
#else
		SBCheckError(TElPKCS11AttributeList_AddThreeByteInteger(SBGetObjectHandle(getThis() TSRMLS_CC), (int64_t)l8Attribute, (int64_t)l8Value, &l4OutResultRaw) TSRMLS_CC);
#endif
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11AttributeList, AddIntegerOptEnc)
{
#ifdef SB_NOT_CPU64_OR_WINDOWS
	long u4Attribute;
	long u4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &u4Attribute, &u4Value) == SUCCESS)
#else
	long l8Attribute;
	long l8Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &l8Attribute, &l8Value) == SUCCESS)
#endif
	{
		int32_t l4OutResultRaw = 0;
#ifdef SB_NOT_CPU64_OR_WINDOWS
		SBCheckError(TElPKCS11AttributeList_AddIntegerOptEnc(SBGetObjectHandle(getThis() TSRMLS_CC), (uint32_t)u4Attribute, (uint32_t)u4Value, &l4OutResultRaw) TSRMLS_CC);
#else
		SBCheckError(TElPKCS11AttributeList_AddIntegerOptEnc(SBGetObjectHandle(getThis() TSRMLS_CC), (int64_t)l8Attribute, (int64_t)l8Value, &l4OutResultRaw) TSRMLS_CC);
#endif
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11AttributeList, Insert)
{
	long l4Index;
#ifdef SB_NOT_CPU64_OR_WINDOWS
	long u4Attribute;
	long u4Value;
#else
	long l8Attribute;
	long l8Value;
#endif
	SBArrayZValInfo aiValue;
	zend_bool bValue;
	zval *zaValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		SBCheckError(TElPKCS11AttributeList_Insert(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index) TSRMLS_CC);
	}
#ifdef SB_NOT_CPU64_OR_WINDOWS
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "llz", &l4Index, &u4Attribute, &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
#else
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "llz", &l4Index, &l8Attribute, &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
#endif
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
#ifdef SB_NOT_CPU64_OR_WINDOWS
		SBCheckError(TElPKCS11AttributeList_Insert_1(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, (uint32_t)u4Attribute, aiValue.data, aiValue.len) TSRMLS_CC);
#else
		SBCheckError(TElPKCS11AttributeList_Insert_1(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, (int64_t)l8Attribute, aiValue.data, aiValue.len) TSRMLS_CC);
#endif
		SBFreeArrayZValInfo(&aiValue);
	}
#ifdef SB_NOT_CPU64_OR_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lll", &l4Index, &u4Attribute, &u4Value) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lll", &l4Index, &l8Attribute, &l8Value) == SUCCESS)
#endif
	{
#ifdef SB_NOT_CPU64_OR_WINDOWS
		SBCheckError(TElPKCS11AttributeList_Insert_2(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, (uint32_t)u4Attribute, (uint32_t)u4Value) TSRMLS_CC);
#else
		SBCheckError(TElPKCS11AttributeList_Insert_2(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, (int64_t)l8Attribute, (int64_t)l8Value) TSRMLS_CC);
#endif
	}
#ifdef SB_NOT_CPU64_OR_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "llb", &l4Index, &u4Attribute, &bValue) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "llb", &l4Index, &l8Attribute, &bValue) == SUCCESS)
#endif
	{
#ifdef SB_NOT_CPU64_OR_WINDOWS
		SBCheckError(TElPKCS11AttributeList_Insert_3(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, (uint32_t)u4Attribute, (int8_t)bValue) TSRMLS_CC);
#else
		SBCheckError(TElPKCS11AttributeList_Insert_3(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, (int64_t)l8Attribute, (int8_t)bValue) TSRMLS_CC);
#endif
	}
	else
	{
		SBErrorExpectsArguments("(integer) or (integer, integer, array of byte|string|NULL) or (integer, integer, integer) or (integer, integer, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11AttributeList, Remove)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		SBCheckError(TElPKCS11AttributeList_Remove(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11AttributeList, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElPKCS11AttributeList_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11AttributeList, Serialize)
{
	int32_t l4SizeRaw;
	SBArrayZValInfo piBuffer;
	zval *zl4Size;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zz", &zpBuffer, &zl4Size) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4Size) && (IS_LONG == Z_TYPE_P(zl4Size)))
	{
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		l4SizeRaw = (int32_t)Z_LVAL_P(zl4Size);
		SBCheckError(TElPKCS11AttributeList_Serialize(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, &l4SizeRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
		ZVAL_LONG(zl4Size, (long)l4SizeRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, &integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11AttributeList, ToString)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElPKCS11AttributeList_ToString(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(190975859, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11AttributeList, get_Attributes)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
#ifdef SB_NOT_CPU64_OR_WINDOWS
		uint32_t u4OutResultRaw = 0;
		SBCheckError(TElPKCS11AttributeList_get_Attributes(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &u4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
#else
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElPKCS11AttributeList_get_Attributes(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
#endif
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11AttributeList, set_Attributes)
{
	long l4Index;
#ifdef SB_NOT_CPU64_OR_WINDOWS
	long u4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &l4Index, &u4Value) == SUCCESS)
#else
	long l8Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &l4Index, &l8Value) == SUCCESS)
#endif
	{
#ifdef SB_NOT_CPU64_OR_WINDOWS
		SBCheckError(TElPKCS11AttributeList_set_Attributes(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, (uint32_t)u4Value) TSRMLS_CC);
#else
		SBCheckError(TElPKCS11AttributeList_set_Attributes(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, (int64_t)l8Value) TSRMLS_CC);
#endif
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11AttributeList, get_Values)
{
	long l4Index;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElPKCS11AttributeList_get_Values(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(604640332, 2, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11AttributeList, set_Values)
{
	long l4Index;
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lz", &l4Index, &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPKCS11AttributeList_set_Values(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(integer, array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11AttributeList, get_Count)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPKCS11AttributeList_get_Count(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11AttributeList, set_Count)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElPKCS11AttributeList_set_Count(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11AttributeList, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPKCS11AttributeList_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11AttributeList_Assign, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Source, TElPKCS11AttributeList, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11AttributeList_Add, 0, 0, 0)
	ZEND_ARG_INFO(0, Attribute)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11AttributeList_AddByte, 0, 0, 2)
	ZEND_ARG_INFO(0, Attribute)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11AttributeList_AddWord, 0, 0, 2)
	ZEND_ARG_INFO(0, Attribute)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11AttributeList_AddThreeByteInteger, 0, 0, 2)
	ZEND_ARG_INFO(0, Attribute)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11AttributeList_AddIntegerOptEnc, 0, 0, 2)
	ZEND_ARG_INFO(0, Attribute)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11AttributeList_Insert, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_INFO(0, Attribute)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11AttributeList_Remove, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11AttributeList_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11AttributeList_Serialize, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(1, Size)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11AttributeList_ToString, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11AttributeList_get_Attributes, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11AttributeList_set_Attributes, 0, 0, 2)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11AttributeList_get_Values, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11AttributeList_set_Values, 0, 0, 2)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11AttributeList_get_Count, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11AttributeList_set_Count, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11AttributeList___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElPKCS11AttributeList_methods[] = {
	PHP_ME(TElPKCS11AttributeList, Assign, arginfo_TElPKCS11AttributeList_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11AttributeList, Add, arginfo_TElPKCS11AttributeList_Add, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11AttributeList, AddByte, arginfo_TElPKCS11AttributeList_AddByte, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11AttributeList, AddWord, arginfo_TElPKCS11AttributeList_AddWord, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11AttributeList, AddThreeByteInteger, arginfo_TElPKCS11AttributeList_AddThreeByteInteger, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11AttributeList, AddIntegerOptEnc, arginfo_TElPKCS11AttributeList_AddIntegerOptEnc, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11AttributeList, Insert, arginfo_TElPKCS11AttributeList_Insert, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11AttributeList, Remove, arginfo_TElPKCS11AttributeList_Remove, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11AttributeList, Clear, arginfo_TElPKCS11AttributeList_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11AttributeList, Serialize, arginfo_TElPKCS11AttributeList_Serialize, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11AttributeList, ToString, arginfo_TElPKCS11AttributeList_ToString, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11AttributeList, get_Attributes, arginfo_TElPKCS11AttributeList_get_Attributes, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11AttributeList, set_Attributes, arginfo_TElPKCS11AttributeList_set_Attributes, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11AttributeList, get_Values, arginfo_TElPKCS11AttributeList_get_Values, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11AttributeList, set_Values, arginfo_TElPKCS11AttributeList_set_Values, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11AttributeList, get_Count, arginfo_TElPKCS11AttributeList_get_Count, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11AttributeList, set_Count, arginfo_TElPKCS11AttributeList_set_Count, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11AttributeList, __construct, arginfo_TElPKCS11AttributeList___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElPKCS11AttributeList(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElPKCS11AttributeList_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElPKCS11AttributeList", TElPKCS11AttributeList_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElPKCS11AttributeList_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElPKCS11Object_ce_ptr = NULL;

SB_PHP_METHOD(TElPKCS11Object, SetAttribute)
{
#ifdef SB_NOT_CPU64_OR_WINDOWS
	long u4Attribute;
	long u4Value;
#else
	long l8Attribute;
	long l8Value;
#endif
	SBArrayZValInfo aiValue;
	zend_bool bValue;
	zval *zaValue;
#ifdef SB_NOT_CPU64_OR_WINDOWS
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lz", &u4Attribute, &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
#else
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lz", &l8Attribute, &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
#endif
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
#ifdef SB_NOT_CPU64_OR_WINDOWS
		SBCheckError(TElPKCS11Object_SetAttribute(SBGetObjectHandle(getThis() TSRMLS_CC), (uint32_t)u4Attribute, aiValue.data, aiValue.len) TSRMLS_CC);
#else
		SBCheckError(TElPKCS11Object_SetAttribute(SBGetObjectHandle(getThis() TSRMLS_CC), (int64_t)l8Attribute, aiValue.data, aiValue.len) TSRMLS_CC);
#endif
		SBFreeArrayZValInfo(&aiValue);
	}
#ifdef SB_NOT_CPU64_OR_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &u4Attribute, &u4Value) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &l8Attribute, &l8Value) == SUCCESS)
#endif
	{
#ifdef SB_NOT_CPU64_OR_WINDOWS
		SBCheckError(TElPKCS11Object_SetAttribute_1(SBGetObjectHandle(getThis() TSRMLS_CC), (uint32_t)u4Attribute, (uint32_t)u4Value) TSRMLS_CC);
#else
		SBCheckError(TElPKCS11Object_SetAttribute_1(SBGetObjectHandle(getThis() TSRMLS_CC), (int64_t)l8Attribute, (int64_t)l8Value) TSRMLS_CC);
#endif
	}
#ifdef SB_NOT_CPU64_OR_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lb", &u4Attribute, &bValue) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lb", &l8Attribute, &bValue) == SUCCESS)
#endif
	{
#ifdef SB_NOT_CPU64_OR_WINDOWS
		SBCheckError(TElPKCS11Object_SetAttribute_2(SBGetObjectHandle(getThis() TSRMLS_CC), (uint32_t)u4Attribute, (int8_t)bValue) TSRMLS_CC);
#else
		SBCheckError(TElPKCS11Object_SetAttribute_2(SBGetObjectHandle(getThis() TSRMLS_CC), (int64_t)l8Attribute, (int8_t)bValue) TSRMLS_CC);
#endif
	}
	else
	{
		SBErrorExpectsArguments("(integer, array of byte|string|NULL) or (integer, integer) or (integer, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11Object, SetAttributes)
{
	zval *oAttributes;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAttributes, TElPKCS11AttributeList_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPKCS11Object_SetAttributes(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oAttributes TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElPKCS11AttributeList)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11Object, GetAttribute)
{
#ifdef SB_NOT_CPU64_OR_WINDOWS
	long u4Attribute;
#else
	long l8Attribute;
#endif
	uint32_t _err;
#ifdef SB_NOT_CPU64_OR_WINDOWS
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u4Attribute) == SUCCESS)
#else
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l8Attribute) == SUCCESS)
#endif
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
#ifdef SB_NOT_CPU64_OR_WINDOWS
		_err = TElPKCS11Object_GetAttribute(SBGetObjectHandle(getThis() TSRMLS_CC), (uint32_t)u4Attribute, u8OutResult, &u8OutResult_len);
#else
		_err = TElPKCS11Object_GetAttribute(SBGetObjectHandle(getThis() TSRMLS_CC), (int64_t)l8Attribute, u8OutResult, &u8OutResult_len);
#endif
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
#ifdef SB_NOT_CPU64_OR_WINDOWS
			SBCheckError(SBGetLastReturnBuffer(-1049776617, 2, u8OutResult, &u8OutResult_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnBuffer(1782940032, 2, u8OutResult, &u8OutResult_len) TSRMLS_CC);
#endif
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11Object, ReadProperties)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElPKCS11Object_ReadProperties(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11Object, ClassType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPKCS11Object_ClassType(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TClass_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11Object, get_ObjectType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBPKCS11ObjectTypeRaw fOutResultRaw = 0;
		SBCheckError(TElPKCS11Object_get_ObjectType(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11Object, get_Token)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPKCS11Object_get_Token(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11Object, get_Private)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPKCS11Object_get_Private(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11Object, get_Modifiable)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPKCS11Object_get_Modifiable(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11Object, get_ObjectLabel)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElPKCS11Object_get_ObjectLabel(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1536966772, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11Object, set_ObjectLabel)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElPKCS11Object_set_ObjectLabel(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11Object, get_ObjectSize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPKCS11Object_get_ObjectSize(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11Object, get_Handle)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
#ifdef SB_NOT_CPU64_OR_WINDOWS
		uint32_t u4OutResultRaw = 0;
		SBCheckError(TElPKCS11Object_get_Handle(SBGetObjectHandle(getThis() TSRMLS_CC), &u4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
#else
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElPKCS11Object_get_Handle(SBGetObjectHandle(getThis() TSRMLS_CC), &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
#endif
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11Object, get_Session)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPKCS11Object_get_Session(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElPKCS11SessionInfo_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11Object, get_CryptoProvider)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPKCS11Object_get_CryptoProvider(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomCryptoProvider_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11Object, set_CryptoProvider)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPKCS11Object_set_CryptoProvider(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCryptoProvider)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11Object, __construct)
{
#ifdef SB_NOT_CPU64_OR_WINDOWS
	long u4Handle;
#else
	long l8Handle;
#endif
	zend_bool bCompatibleMode;
	zval *oCryptoProvider;
	zval *oModule;
	zval *oSession;
	zval *oSlot;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPKCS11Object_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
#ifdef SB_NOT_CPU64_OR_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!O!lbO!", &oModule, TElPKCS11Module_ce_ptr, &oSession, TElPKCS11SessionInfo_ce_ptr, &oSlot, TElPKCS11SlotInfo_ce_ptr, &u4Handle, &bCompatibleMode, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!O!lbO!", &oModule, TElPKCS11Module_ce_ptr, &oSession, TElPKCS11SessionInfo_ce_ptr, &oSlot, TElPKCS11SlotInfo_ce_ptr, &l8Handle, &bCompatibleMode, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
#endif
	{
		TElClassHandle hoOutResult = NULL;
#ifdef SB_NOT_CPU64_OR_WINDOWS
		SBCheckError(TElPKCS11Object_Create_1(SBGetObjectHandle(oModule TSRMLS_CC), SBGetObjectHandle(oSession TSRMLS_CC), SBGetObjectHandle(oSlot TSRMLS_CC), (uint32_t)u4Handle, (int8_t)bCompatibleMode, SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
#else
		SBCheckError(TElPKCS11Object_Create_1(SBGetObjectHandle(oModule TSRMLS_CC), SBGetObjectHandle(oSession TSRMLS_CC), SBGetObjectHandle(oSlot TSRMLS_CC), (int64_t)l8Handle, (int8_t)bCompatibleMode, SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
#endif
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("() or (TElPKCS11Module, TElPKCS11SessionInfo, TElPKCS11SlotInfo, integer, bool, TElCustomCryptoProvider)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11Object_SetAttribute, 0, 0, 2)
	ZEND_ARG_INFO(0, Attribute)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11Object_SetAttributes, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Attributes, TElPKCS11AttributeList, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11Object_GetAttribute, 0, 0, 1)
	ZEND_ARG_INFO(0, Attribute)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11Object_ReadProperties, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11Object_ClassType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11Object_get_ObjectType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11Object_get_Token, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11Object_get_Private, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11Object_get_Modifiable, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11Object_get_ObjectLabel, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11Object_set_ObjectLabel, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11Object_get_ObjectSize, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11Object_get_Handle, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11Object_get_Session, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11Object_get_CryptoProvider, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11Object_set_CryptoProvider, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElCustomCryptoProvider, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11Object___construct, 0, 0, 0)
	ZEND_ARG_OBJ_INFO(0, Module, TElPKCS11Module, 1)
	ZEND_ARG_OBJ_INFO(0, Session, TElPKCS11SessionInfo, 1)
	ZEND_ARG_OBJ_INFO(0, Slot, TElPKCS11SlotInfo, 1)
	ZEND_ARG_INFO(0, Handle)
	ZEND_ARG_INFO(0, CompatibleMode)
	ZEND_ARG_OBJ_INFO(0, CryptoProvider, TElCustomCryptoProvider, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElPKCS11Object_methods[] = {
	PHP_ME(TElPKCS11Object, SetAttribute, arginfo_TElPKCS11Object_SetAttribute, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11Object, SetAttributes, arginfo_TElPKCS11Object_SetAttributes, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11Object, GetAttribute, arginfo_TElPKCS11Object_GetAttribute, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11Object, ReadProperties, arginfo_TElPKCS11Object_ReadProperties, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11Object, ClassType, arginfo_TElPKCS11Object_ClassType, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElPKCS11Object, get_ObjectType, arginfo_TElPKCS11Object_get_ObjectType, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11Object, get_Token, arginfo_TElPKCS11Object_get_Token, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11Object, get_Private, arginfo_TElPKCS11Object_get_Private, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11Object, get_Modifiable, arginfo_TElPKCS11Object_get_Modifiable, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11Object, get_ObjectLabel, arginfo_TElPKCS11Object_get_ObjectLabel, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11Object, set_ObjectLabel, arginfo_TElPKCS11Object_set_ObjectLabel, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11Object, get_ObjectSize, arginfo_TElPKCS11Object_get_ObjectSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11Object, get_Handle, arginfo_TElPKCS11Object_get_Handle, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11Object, get_Session, arginfo_TElPKCS11Object_get_Session, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11Object, get_CryptoProvider, arginfo_TElPKCS11Object_get_CryptoProvider, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11Object, set_CryptoProvider, arginfo_TElPKCS11Object_set_CryptoProvider, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11Object, __construct, arginfo_TElPKCS11Object___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElPKCS11Object(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElPKCS11Object_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElPKCS11Object", TElPKCS11Object_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElPKCS11Object_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElPKCS11DataObject_ce_ptr = NULL;

SB_PHP_METHOD(TElPKCS11DataObject, ReadProperties)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElPKCS11DataObject_ReadProperties(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11DataObject, ClassType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPKCS11DataObject_ClassType(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TClass_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11DataObject, get_Application)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElPKCS11DataObject_get_Application(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(144365982, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11DataObject, set_Application)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElPKCS11DataObject_set_Application(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11DataObject, get_ObjectID)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElPKCS11DataObject_get_ObjectID(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(1886009463, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11DataObject, set_ObjectID)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPKCS11DataObject_set_ObjectID(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11DataObject, get_Value)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElPKCS11DataObject_get_Value(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(744443147, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11DataObject, set_Value)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPKCS11DataObject_set_Value(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11DataObject, __construct)
{
#ifdef SB_NOT_CPU64_OR_WINDOWS
	long u4Handle;
#else
	long l8Handle;
#endif
	zend_bool bCompatibleMode;
	zval *oCryptoProvider;
	zval *oModule;
	zval *oSession;
	zval *oSlot;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPKCS11DataObject_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
#ifdef SB_NOT_CPU64_OR_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!O!lbO!", &oModule, TElPKCS11Module_ce_ptr, &oSession, TElPKCS11SessionInfo_ce_ptr, &oSlot, TElPKCS11SlotInfo_ce_ptr, &u4Handle, &bCompatibleMode, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!O!lbO!", &oModule, TElPKCS11Module_ce_ptr, &oSession, TElPKCS11SessionInfo_ce_ptr, &oSlot, TElPKCS11SlotInfo_ce_ptr, &l8Handle, &bCompatibleMode, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
#endif
	{
		TElClassHandle hoOutResult = NULL;
#ifdef SB_NOT_CPU64_OR_WINDOWS
		SBCheckError(TElPKCS11DataObject_Create_1(SBGetObjectHandle(oModule TSRMLS_CC), SBGetObjectHandle(oSession TSRMLS_CC), SBGetObjectHandle(oSlot TSRMLS_CC), (uint32_t)u4Handle, (int8_t)bCompatibleMode, SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
#else
		SBCheckError(TElPKCS11DataObject_Create_1(SBGetObjectHandle(oModule TSRMLS_CC), SBGetObjectHandle(oSession TSRMLS_CC), SBGetObjectHandle(oSlot TSRMLS_CC), (int64_t)l8Handle, (int8_t)bCompatibleMode, SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
#endif
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("() or (TElPKCS11Module, TElPKCS11SessionInfo, TElPKCS11SlotInfo, integer, bool, TElCustomCryptoProvider)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11DataObject_ReadProperties, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11DataObject_ClassType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11DataObject_get_Application, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11DataObject_set_Application, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11DataObject_get_ObjectID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11DataObject_set_ObjectID, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11DataObject_get_Value, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11DataObject_set_Value, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11DataObject___construct, 0, 0, 0)
	ZEND_ARG_OBJ_INFO(0, Module, TElPKCS11Module, 1)
	ZEND_ARG_OBJ_INFO(0, Session, TElPKCS11SessionInfo, 1)
	ZEND_ARG_OBJ_INFO(0, Slot, TElPKCS11SlotInfo, 1)
	ZEND_ARG_INFO(0, Handle)
	ZEND_ARG_INFO(0, CompatibleMode)
	ZEND_ARG_OBJ_INFO(0, CryptoProvider, TElCustomCryptoProvider, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElPKCS11DataObject_methods[] = {
	PHP_ME(TElPKCS11DataObject, ReadProperties, arginfo_TElPKCS11DataObject_ReadProperties, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11DataObject, ClassType, arginfo_TElPKCS11DataObject_ClassType, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElPKCS11DataObject, get_Application, arginfo_TElPKCS11DataObject_get_Application, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11DataObject, set_Application, arginfo_TElPKCS11DataObject_set_Application, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11DataObject, get_ObjectID, arginfo_TElPKCS11DataObject_get_ObjectID, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11DataObject, set_ObjectID, arginfo_TElPKCS11DataObject_set_ObjectID, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11DataObject, get_Value, arginfo_TElPKCS11DataObject_get_Value, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11DataObject, set_Value, arginfo_TElPKCS11DataObject_set_Value, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11DataObject, __construct, arginfo_TElPKCS11DataObject___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElPKCS11DataObject(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElPKCS11DataObject_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElPKCS11DataObject", TElPKCS11DataObject_methods);
	if (NULL == TElPKCS11Object_ce_ptr)
		Register_TElPKCS11Object(TSRMLS_C);
	TElPKCS11DataObject_ce_ptr = zend_register_internal_class_ex(&ce, TElPKCS11Object_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElPKCS11CertificateObject_ce_ptr = NULL;

SB_PHP_METHOD(TElPKCS11CertificateObject, ReadProperties)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElPKCS11CertificateObject_ReadProperties(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CertificateObject, ClassType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPKCS11CertificateObject_ClassType(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TClass_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CertificateObject, get_CertType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPKCS11CertificateObject_get_CertType(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CertificateObject, get_Trusted)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPKCS11CertificateObject_get_Trusted(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CertificateObject, set_Trusted)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElPKCS11CertificateObject_set_Trusted(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CertificateObject, get_CertCategory)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBPKCS11CertCategoryRaw fOutResultRaw = 0;
		SBCheckError(TElPKCS11CertificateObject_get_CertCategory(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CertificateObject, get_Checksum)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElPKCS11CertificateObject_get_Checksum(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-1615621763, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CertificateObject, get_StartDate)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(TElPKCS11CertificateObject_get_StartDate(SBGetObjectHandle(getThis() TSRMLS_CC), &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CertificateObject, set_StartDate)
{
	zval *dtValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &dtValue, php_date_get_date_ce()) == SUCCESS)
	{
		SBCheckError(TElPKCS11CertificateObject_set_StartDate(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetDateTime(dtValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(DateTime)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CertificateObject, get_EndDate)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(TElPKCS11CertificateObject_get_EndDate(SBGetObjectHandle(getThis() TSRMLS_CC), &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CertificateObject, set_EndDate)
{
	zval *dtValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &dtValue, php_date_get_date_ce()) == SUCCESS)
	{
		SBCheckError(TElPKCS11CertificateObject_set_EndDate(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetDateTime(dtValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(DateTime)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CertificateObject, __construct)
{
#ifdef SB_NOT_CPU64_OR_WINDOWS
	long u4Handle;
#else
	long l8Handle;
#endif
	zend_bool bCompatibleMode;
	zval *oCryptoProvider;
	zval *oModule;
	zval *oSession;
	zval *oSlot;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPKCS11CertificateObject_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
#ifdef SB_NOT_CPU64_OR_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!O!lbO!", &oModule, TElPKCS11Module_ce_ptr, &oSession, TElPKCS11SessionInfo_ce_ptr, &oSlot, TElPKCS11SlotInfo_ce_ptr, &u4Handle, &bCompatibleMode, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!O!lbO!", &oModule, TElPKCS11Module_ce_ptr, &oSession, TElPKCS11SessionInfo_ce_ptr, &oSlot, TElPKCS11SlotInfo_ce_ptr, &l8Handle, &bCompatibleMode, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
#endif
	{
		TElClassHandle hoOutResult = NULL;
#ifdef SB_NOT_CPU64_OR_WINDOWS
		SBCheckError(TElPKCS11CertificateObject_Create_1(SBGetObjectHandle(oModule TSRMLS_CC), SBGetObjectHandle(oSession TSRMLS_CC), SBGetObjectHandle(oSlot TSRMLS_CC), (uint32_t)u4Handle, (int8_t)bCompatibleMode, SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
#else
		SBCheckError(TElPKCS11CertificateObject_Create_1(SBGetObjectHandle(oModule TSRMLS_CC), SBGetObjectHandle(oSession TSRMLS_CC), SBGetObjectHandle(oSlot TSRMLS_CC), (int64_t)l8Handle, (int8_t)bCompatibleMode, SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
#endif
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("() or (TElPKCS11Module, TElPKCS11SessionInfo, TElPKCS11SlotInfo, integer, bool, TElCustomCryptoProvider)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CertificateObject_ReadProperties, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CertificateObject_ClassType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CertificateObject_get_CertType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CertificateObject_get_Trusted, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CertificateObject_set_Trusted, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CertificateObject_get_CertCategory, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CertificateObject_get_Checksum, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CertificateObject_get_StartDate, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CertificateObject_set_StartDate, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, DateTime, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CertificateObject_get_EndDate, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CertificateObject_set_EndDate, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, DateTime, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CertificateObject___construct, 0, 0, 0)
	ZEND_ARG_OBJ_INFO(0, Module, TElPKCS11Module, 1)
	ZEND_ARG_OBJ_INFO(0, Session, TElPKCS11SessionInfo, 1)
	ZEND_ARG_OBJ_INFO(0, Slot, TElPKCS11SlotInfo, 1)
	ZEND_ARG_INFO(0, Handle)
	ZEND_ARG_INFO(0, CompatibleMode)
	ZEND_ARG_OBJ_INFO(0, CryptoProvider, TElCustomCryptoProvider, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElPKCS11CertificateObject_methods[] = {
	PHP_ME(TElPKCS11CertificateObject, ReadProperties, arginfo_TElPKCS11CertificateObject_ReadProperties, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CertificateObject, ClassType, arginfo_TElPKCS11CertificateObject_ClassType, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElPKCS11CertificateObject, get_CertType, arginfo_TElPKCS11CertificateObject_get_CertType, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CertificateObject, get_Trusted, arginfo_TElPKCS11CertificateObject_get_Trusted, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CertificateObject, set_Trusted, arginfo_TElPKCS11CertificateObject_set_Trusted, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CertificateObject, get_CertCategory, arginfo_TElPKCS11CertificateObject_get_CertCategory, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CertificateObject, get_Checksum, arginfo_TElPKCS11CertificateObject_get_Checksum, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CertificateObject, get_StartDate, arginfo_TElPKCS11CertificateObject_get_StartDate, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CertificateObject, set_StartDate, arginfo_TElPKCS11CertificateObject_set_StartDate, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CertificateObject, get_EndDate, arginfo_TElPKCS11CertificateObject_get_EndDate, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CertificateObject, set_EndDate, arginfo_TElPKCS11CertificateObject_set_EndDate, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CertificateObject, __construct, arginfo_TElPKCS11CertificateObject___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElPKCS11CertificateObject(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElPKCS11CertificateObject_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElPKCS11CertificateObject", TElPKCS11CertificateObject_methods);
	if (NULL == TElPKCS11Object_ce_ptr)
		Register_TElPKCS11Object(TSRMLS_C);
	TElPKCS11CertificateObject_ce_ptr = zend_register_internal_class_ex(&ce, TElPKCS11Object_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElPKCS11X509CertificateObject_ce_ptr = NULL;

SB_PHP_METHOD(TElPKCS11X509CertificateObject, ReadProperties)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElPKCS11X509CertificateObject_ReadProperties(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11X509CertificateObject, ClassType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPKCS11X509CertificateObject_ClassType(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TClass_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11X509CertificateObject, get_Subject)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElPKCS11X509CertificateObject_get_Subject(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-2141566026, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11X509CertificateObject, get_KeyID)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElPKCS11X509CertificateObject_get_KeyID(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(2067897527, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11X509CertificateObject, set_KeyID)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPKCS11X509CertificateObject_set_KeyID(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11X509CertificateObject, get_Issuer)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElPKCS11X509CertificateObject_get_Issuer(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-2024907271, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11X509CertificateObject, set_Issuer)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPKCS11X509CertificateObject_set_Issuer(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11X509CertificateObject, get_SerialNumber)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElPKCS11X509CertificateObject_get_SerialNumber(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-73342394, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11X509CertificateObject, set_SerialNumber)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPKCS11X509CertificateObject_set_SerialNumber(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11X509CertificateObject, get_Value)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElPKCS11X509CertificateObject_get_Value(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(1227116777, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11X509CertificateObject, get_URL)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElPKCS11X509CertificateObject_get_URL(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1753620660, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11X509CertificateObject, get_SubjectPublicKeyHash)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElPKCS11X509CertificateObject_get_SubjectPublicKeyHash(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(1485716929, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11X509CertificateObject, get_IssuerPublicKeyHash)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElPKCS11X509CertificateObject_get_IssuerPublicKeyHash(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-576348813, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11X509CertificateObject, get_MIDPSecurityDomain)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBPKCS11MIDPSecurityDomainRaw fOutResultRaw = 0;
		SBCheckError(TElPKCS11X509CertificateObject_get_MIDPSecurityDomain(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11X509CertificateObject, __construct)
{
#ifdef SB_NOT_CPU64_OR_WINDOWS
	long u4Handle;
#else
	long l8Handle;
#endif
	zend_bool bCompatibleMode;
	zval *oCryptoProvider;
	zval *oModule;
	zval *oSession;
	zval *oSlot;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPKCS11X509CertificateObject_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
#ifdef SB_NOT_CPU64_OR_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!O!lbO!", &oModule, TElPKCS11Module_ce_ptr, &oSession, TElPKCS11SessionInfo_ce_ptr, &oSlot, TElPKCS11SlotInfo_ce_ptr, &u4Handle, &bCompatibleMode, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!O!lbO!", &oModule, TElPKCS11Module_ce_ptr, &oSession, TElPKCS11SessionInfo_ce_ptr, &oSlot, TElPKCS11SlotInfo_ce_ptr, &l8Handle, &bCompatibleMode, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
#endif
	{
		TElClassHandle hoOutResult = NULL;
#ifdef SB_NOT_CPU64_OR_WINDOWS
		SBCheckError(TElPKCS11X509CertificateObject_Create_1(SBGetObjectHandle(oModule TSRMLS_CC), SBGetObjectHandle(oSession TSRMLS_CC), SBGetObjectHandle(oSlot TSRMLS_CC), (uint32_t)u4Handle, (int8_t)bCompatibleMode, SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
#else
		SBCheckError(TElPKCS11X509CertificateObject_Create_1(SBGetObjectHandle(oModule TSRMLS_CC), SBGetObjectHandle(oSession TSRMLS_CC), SBGetObjectHandle(oSlot TSRMLS_CC), (int64_t)l8Handle, (int8_t)bCompatibleMode, SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
#endif
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("() or (TElPKCS11Module, TElPKCS11SessionInfo, TElPKCS11SlotInfo, integer, bool, TElCustomCryptoProvider)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11X509CertificateObject_ReadProperties, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11X509CertificateObject_ClassType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11X509CertificateObject_get_Subject, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11X509CertificateObject_get_KeyID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11X509CertificateObject_set_KeyID, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11X509CertificateObject_get_Issuer, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11X509CertificateObject_set_Issuer, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11X509CertificateObject_get_SerialNumber, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11X509CertificateObject_set_SerialNumber, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11X509CertificateObject_get_Value, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11X509CertificateObject_get_URL, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11X509CertificateObject_get_SubjectPublicKeyHash, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11X509CertificateObject_get_IssuerPublicKeyHash, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11X509CertificateObject_get_MIDPSecurityDomain, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11X509CertificateObject___construct, 0, 0, 0)
	ZEND_ARG_OBJ_INFO(0, Module, TElPKCS11Module, 1)
	ZEND_ARG_OBJ_INFO(0, Session, TElPKCS11SessionInfo, 1)
	ZEND_ARG_OBJ_INFO(0, Slot, TElPKCS11SlotInfo, 1)
	ZEND_ARG_INFO(0, Handle)
	ZEND_ARG_INFO(0, CompatibleMode)
	ZEND_ARG_OBJ_INFO(0, CryptoProvider, TElCustomCryptoProvider, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElPKCS11X509CertificateObject_methods[] = {
	PHP_ME(TElPKCS11X509CertificateObject, ReadProperties, arginfo_TElPKCS11X509CertificateObject_ReadProperties, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11X509CertificateObject, ClassType, arginfo_TElPKCS11X509CertificateObject_ClassType, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElPKCS11X509CertificateObject, get_Subject, arginfo_TElPKCS11X509CertificateObject_get_Subject, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11X509CertificateObject, get_KeyID, arginfo_TElPKCS11X509CertificateObject_get_KeyID, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11X509CertificateObject, set_KeyID, arginfo_TElPKCS11X509CertificateObject_set_KeyID, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11X509CertificateObject, get_Issuer, arginfo_TElPKCS11X509CertificateObject_get_Issuer, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11X509CertificateObject, set_Issuer, arginfo_TElPKCS11X509CertificateObject_set_Issuer, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11X509CertificateObject, get_SerialNumber, arginfo_TElPKCS11X509CertificateObject_get_SerialNumber, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11X509CertificateObject, set_SerialNumber, arginfo_TElPKCS11X509CertificateObject_set_SerialNumber, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11X509CertificateObject, get_Value, arginfo_TElPKCS11X509CertificateObject_get_Value, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11X509CertificateObject, get_URL, arginfo_TElPKCS11X509CertificateObject_get_URL, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11X509CertificateObject, get_SubjectPublicKeyHash, arginfo_TElPKCS11X509CertificateObject_get_SubjectPublicKeyHash, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11X509CertificateObject, get_IssuerPublicKeyHash, arginfo_TElPKCS11X509CertificateObject_get_IssuerPublicKeyHash, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11X509CertificateObject, get_MIDPSecurityDomain, arginfo_TElPKCS11X509CertificateObject_get_MIDPSecurityDomain, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11X509CertificateObject, __construct, arginfo_TElPKCS11X509CertificateObject___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElPKCS11X509CertificateObject(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElPKCS11X509CertificateObject_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElPKCS11X509CertificateObject", TElPKCS11X509CertificateObject_methods);
	if (NULL == TElPKCS11CertificateObject_ce_ptr)
		Register_TElPKCS11CertificateObject(TSRMLS_C);
	TElPKCS11X509CertificateObject_ce_ptr = zend_register_internal_class_ex(&ce, TElPKCS11CertificateObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElPKCS11WTLSCertificateObject_ce_ptr = NULL;

SB_PHP_METHOD(TElPKCS11WTLSCertificateObject, ReadProperties)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElPKCS11WTLSCertificateObject_ReadProperties(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11WTLSCertificateObject, ClassType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPKCS11WTLSCertificateObject_ClassType(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TClass_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11WTLSCertificateObject, get_Subject)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElPKCS11WTLSCertificateObject_get_Subject(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-1047838391, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11WTLSCertificateObject, get_Issuer)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElPKCS11WTLSCertificateObject_get_Issuer(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(1379844690, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11WTLSCertificateObject, set_Issuer)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPKCS11WTLSCertificateObject_set_Issuer(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11WTLSCertificateObject, get_Value)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElPKCS11WTLSCertificateObject_get_Value(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(1509564363, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11WTLSCertificateObject, get_URL)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElPKCS11WTLSCertificateObject_get_URL(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-2032619726, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11WTLSCertificateObject, get_SubjectPublicKeyHash)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElPKCS11WTLSCertificateObject_get_SubjectPublicKeyHash(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(821953251, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11WTLSCertificateObject, get_IssuerPublicKeyHash)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElPKCS11WTLSCertificateObject_get_IssuerPublicKeyHash(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(1881753505, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11WTLSCertificateObject, __construct)
{
#ifdef SB_NOT_CPU64_OR_WINDOWS
	long u4Handle;
#else
	long l8Handle;
#endif
	zend_bool bCompatibleMode;
	zval *oCryptoProvider;
	zval *oModule;
	zval *oSession;
	zval *oSlot;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPKCS11WTLSCertificateObject_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
#ifdef SB_NOT_CPU64_OR_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!O!lbO!", &oModule, TElPKCS11Module_ce_ptr, &oSession, TElPKCS11SessionInfo_ce_ptr, &oSlot, TElPKCS11SlotInfo_ce_ptr, &u4Handle, &bCompatibleMode, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!O!lbO!", &oModule, TElPKCS11Module_ce_ptr, &oSession, TElPKCS11SessionInfo_ce_ptr, &oSlot, TElPKCS11SlotInfo_ce_ptr, &l8Handle, &bCompatibleMode, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
#endif
	{
		TElClassHandle hoOutResult = NULL;
#ifdef SB_NOT_CPU64_OR_WINDOWS
		SBCheckError(TElPKCS11WTLSCertificateObject_Create_1(SBGetObjectHandle(oModule TSRMLS_CC), SBGetObjectHandle(oSession TSRMLS_CC), SBGetObjectHandle(oSlot TSRMLS_CC), (uint32_t)u4Handle, (int8_t)bCompatibleMode, SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
#else
		SBCheckError(TElPKCS11WTLSCertificateObject_Create_1(SBGetObjectHandle(oModule TSRMLS_CC), SBGetObjectHandle(oSession TSRMLS_CC), SBGetObjectHandle(oSlot TSRMLS_CC), (int64_t)l8Handle, (int8_t)bCompatibleMode, SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
#endif
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("() or (TElPKCS11Module, TElPKCS11SessionInfo, TElPKCS11SlotInfo, integer, bool, TElCustomCryptoProvider)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11WTLSCertificateObject_ReadProperties, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11WTLSCertificateObject_ClassType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11WTLSCertificateObject_get_Subject, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11WTLSCertificateObject_get_Issuer, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11WTLSCertificateObject_set_Issuer, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11WTLSCertificateObject_get_Value, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11WTLSCertificateObject_get_URL, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11WTLSCertificateObject_get_SubjectPublicKeyHash, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11WTLSCertificateObject_get_IssuerPublicKeyHash, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11WTLSCertificateObject___construct, 0, 0, 0)
	ZEND_ARG_OBJ_INFO(0, Module, TElPKCS11Module, 1)
	ZEND_ARG_OBJ_INFO(0, Session, TElPKCS11SessionInfo, 1)
	ZEND_ARG_OBJ_INFO(0, Slot, TElPKCS11SlotInfo, 1)
	ZEND_ARG_INFO(0, Handle)
	ZEND_ARG_INFO(0, CompatibleMode)
	ZEND_ARG_OBJ_INFO(0, CryptoProvider, TElCustomCryptoProvider, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElPKCS11WTLSCertificateObject_methods[] = {
	PHP_ME(TElPKCS11WTLSCertificateObject, ReadProperties, arginfo_TElPKCS11WTLSCertificateObject_ReadProperties, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11WTLSCertificateObject, ClassType, arginfo_TElPKCS11WTLSCertificateObject_ClassType, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElPKCS11WTLSCertificateObject, get_Subject, arginfo_TElPKCS11WTLSCertificateObject_get_Subject, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11WTLSCertificateObject, get_Issuer, arginfo_TElPKCS11WTLSCertificateObject_get_Issuer, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11WTLSCertificateObject, set_Issuer, arginfo_TElPKCS11WTLSCertificateObject_set_Issuer, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11WTLSCertificateObject, get_Value, arginfo_TElPKCS11WTLSCertificateObject_get_Value, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11WTLSCertificateObject, get_URL, arginfo_TElPKCS11WTLSCertificateObject_get_URL, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11WTLSCertificateObject, get_SubjectPublicKeyHash, arginfo_TElPKCS11WTLSCertificateObject_get_SubjectPublicKeyHash, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11WTLSCertificateObject, get_IssuerPublicKeyHash, arginfo_TElPKCS11WTLSCertificateObject_get_IssuerPublicKeyHash, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11WTLSCertificateObject, __construct, arginfo_TElPKCS11WTLSCertificateObject___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElPKCS11WTLSCertificateObject(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElPKCS11WTLSCertificateObject_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElPKCS11WTLSCertificateObject", TElPKCS11WTLSCertificateObject_methods);
	if (NULL == TElPKCS11CertificateObject_ce_ptr)
		Register_TElPKCS11CertificateObject(TSRMLS_C);
	TElPKCS11WTLSCertificateObject_ce_ptr = zend_register_internal_class_ex(&ce, TElPKCS11CertificateObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElPKCS11X509AttributeCertificateObject_ce_ptr = NULL;

SB_PHP_METHOD(TElPKCS11X509AttributeCertificateObject, ReadProperties)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElPKCS11X509AttributeCertificateObject_ReadProperties(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11X509AttributeCertificateObject, ClassType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPKCS11X509AttributeCertificateObject_ClassType(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TClass_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11X509AttributeCertificateObject, get_Owner)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElPKCS11X509AttributeCertificateObject_get_Owner(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-1636051041, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11X509AttributeCertificateObject, get_ACIssuer)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElPKCS11X509AttributeCertificateObject_get_ACIssuer(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(256475852, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11X509AttributeCertificateObject, set_ACIssuer)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPKCS11X509AttributeCertificateObject_set_ACIssuer(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11X509AttributeCertificateObject, get_SerialNumber)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElPKCS11X509AttributeCertificateObject_get_SerialNumber(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(2144635286, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11X509AttributeCertificateObject, set_SerialNumber)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPKCS11X509AttributeCertificateObject_set_SerialNumber(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11X509AttributeCertificateObject, get_AttrTypes)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElPKCS11X509AttributeCertificateObject_get_AttrTypes(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-261618835, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11X509AttributeCertificateObject, set_AttrTypes)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPKCS11X509AttributeCertificateObject_set_AttrTypes(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11X509AttributeCertificateObject, get_Value)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElPKCS11X509AttributeCertificateObject_get_Value(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(1282173399, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11X509AttributeCertificateObject, __construct)
{
#ifdef SB_NOT_CPU64_OR_WINDOWS
	long u4Handle;
#else
	long l8Handle;
#endif
	zend_bool bCompatibleMode;
	zval *oCryptoProvider;
	zval *oModule;
	zval *oSession;
	zval *oSlot;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPKCS11X509AttributeCertificateObject_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
#ifdef SB_NOT_CPU64_OR_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!O!lbO!", &oModule, TElPKCS11Module_ce_ptr, &oSession, TElPKCS11SessionInfo_ce_ptr, &oSlot, TElPKCS11SlotInfo_ce_ptr, &u4Handle, &bCompatibleMode, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!O!lbO!", &oModule, TElPKCS11Module_ce_ptr, &oSession, TElPKCS11SessionInfo_ce_ptr, &oSlot, TElPKCS11SlotInfo_ce_ptr, &l8Handle, &bCompatibleMode, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
#endif
	{
		TElClassHandle hoOutResult = NULL;
#ifdef SB_NOT_CPU64_OR_WINDOWS
		SBCheckError(TElPKCS11X509AttributeCertificateObject_Create_1(SBGetObjectHandle(oModule TSRMLS_CC), SBGetObjectHandle(oSession TSRMLS_CC), SBGetObjectHandle(oSlot TSRMLS_CC), (uint32_t)u4Handle, (int8_t)bCompatibleMode, SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
#else
		SBCheckError(TElPKCS11X509AttributeCertificateObject_Create_1(SBGetObjectHandle(oModule TSRMLS_CC), SBGetObjectHandle(oSession TSRMLS_CC), SBGetObjectHandle(oSlot TSRMLS_CC), (int64_t)l8Handle, (int8_t)bCompatibleMode, SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
#endif
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("() or (TElPKCS11Module, TElPKCS11SessionInfo, TElPKCS11SlotInfo, integer, bool, TElCustomCryptoProvider)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11X509AttributeCertificateObject_ReadProperties, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11X509AttributeCertificateObject_ClassType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11X509AttributeCertificateObject_get_Owner, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11X509AttributeCertificateObject_get_ACIssuer, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11X509AttributeCertificateObject_set_ACIssuer, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11X509AttributeCertificateObject_get_SerialNumber, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11X509AttributeCertificateObject_set_SerialNumber, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11X509AttributeCertificateObject_get_AttrTypes, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11X509AttributeCertificateObject_set_AttrTypes, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11X509AttributeCertificateObject_get_Value, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11X509AttributeCertificateObject___construct, 0, 0, 0)
	ZEND_ARG_OBJ_INFO(0, Module, TElPKCS11Module, 1)
	ZEND_ARG_OBJ_INFO(0, Session, TElPKCS11SessionInfo, 1)
	ZEND_ARG_OBJ_INFO(0, Slot, TElPKCS11SlotInfo, 1)
	ZEND_ARG_INFO(0, Handle)
	ZEND_ARG_INFO(0, CompatibleMode)
	ZEND_ARG_OBJ_INFO(0, CryptoProvider, TElCustomCryptoProvider, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElPKCS11X509AttributeCertificateObject_methods[] = {
	PHP_ME(TElPKCS11X509AttributeCertificateObject, ReadProperties, arginfo_TElPKCS11X509AttributeCertificateObject_ReadProperties, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11X509AttributeCertificateObject, ClassType, arginfo_TElPKCS11X509AttributeCertificateObject_ClassType, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElPKCS11X509AttributeCertificateObject, get_Owner, arginfo_TElPKCS11X509AttributeCertificateObject_get_Owner, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11X509AttributeCertificateObject, get_ACIssuer, arginfo_TElPKCS11X509AttributeCertificateObject_get_ACIssuer, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11X509AttributeCertificateObject, set_ACIssuer, arginfo_TElPKCS11X509AttributeCertificateObject_set_ACIssuer, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11X509AttributeCertificateObject, get_SerialNumber, arginfo_TElPKCS11X509AttributeCertificateObject_get_SerialNumber, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11X509AttributeCertificateObject, set_SerialNumber, arginfo_TElPKCS11X509AttributeCertificateObject_set_SerialNumber, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11X509AttributeCertificateObject, get_AttrTypes, arginfo_TElPKCS11X509AttributeCertificateObject_get_AttrTypes, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11X509AttributeCertificateObject, set_AttrTypes, arginfo_TElPKCS11X509AttributeCertificateObject_set_AttrTypes, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11X509AttributeCertificateObject, get_Value, arginfo_TElPKCS11X509AttributeCertificateObject_get_Value, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11X509AttributeCertificateObject, __construct, arginfo_TElPKCS11X509AttributeCertificateObject___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElPKCS11X509AttributeCertificateObject(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElPKCS11X509AttributeCertificateObject_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElPKCS11X509AttributeCertificateObject", TElPKCS11X509AttributeCertificateObject_methods);
	if (NULL == TElPKCS11CertificateObject_ce_ptr)
		Register_TElPKCS11CertificateObject(TSRMLS_C);
	TElPKCS11X509AttributeCertificateObject_ce_ptr = zend_register_internal_class_ex(&ce, TElPKCS11CertificateObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElPKCS11KeyObject_ce_ptr = NULL;

SB_PHP_METHOD(TElPKCS11KeyObject, ReadProperties)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElPKCS11KeyObject_ReadProperties(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11KeyObject, ClassType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPKCS11KeyObject_ClassType(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TClass_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11KeyObject, get_KeyType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPKCS11KeyObject_get_KeyType(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11KeyObject, get_PKCS11KeyType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
#ifdef SB_NOT_CPU64_OR_WINDOWS
		uint32_t u4OutResultRaw = 0;
		SBCheckError(TElPKCS11KeyObject_get_PKCS11KeyType(SBGetObjectHandle(getThis() TSRMLS_CC), &u4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
#else
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElPKCS11KeyObject_get_PKCS11KeyType(SBGetObjectHandle(getThis() TSRMLS_CC), &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
#endif
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11KeyObject, get_KeyID)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElPKCS11KeyObject_get_KeyID(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(234069721, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11KeyObject, set_KeyID)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPKCS11KeyObject_set_KeyID(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11KeyObject, get_StartDate)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(TElPKCS11KeyObject_get_StartDate(SBGetObjectHandle(getThis() TSRMLS_CC), &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11KeyObject, set_StartDate)
{
	zval *dtValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &dtValue, php_date_get_date_ce()) == SUCCESS)
	{
		SBCheckError(TElPKCS11KeyObject_set_StartDate(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetDateTime(dtValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(DateTime)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11KeyObject, get_EndDate)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(TElPKCS11KeyObject_get_EndDate(SBGetObjectHandle(getThis() TSRMLS_CC), &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11KeyObject, set_EndDate)
{
	zval *dtValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &dtValue, php_date_get_date_ce()) == SUCCESS)
	{
		SBCheckError(TElPKCS11KeyObject_set_EndDate(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetDateTime(dtValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(DateTime)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11KeyObject, get_Derive)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPKCS11KeyObject_get_Derive(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11KeyObject, set_Derive)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElPKCS11KeyObject_set_Derive(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11KeyObject, get_Local)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPKCS11KeyObject_get_Local(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11KeyObject, get_KeyMaterial)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPKCS11KeyObject_get_KeyMaterial(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElKeyMaterial_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11KeyObject, __construct)
{
#ifdef SB_NOT_CPU64_OR_WINDOWS
	long u4Handle;
#else
	long l8Handle;
#endif
	zend_bool bCompatibleMode;
	zval *oCryptoProvider;
	zval *oModule;
	zval *oSession;
	zval *oSlot;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPKCS11KeyObject_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
#ifdef SB_NOT_CPU64_OR_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!O!lbO!", &oModule, TElPKCS11Module_ce_ptr, &oSession, TElPKCS11SessionInfo_ce_ptr, &oSlot, TElPKCS11SlotInfo_ce_ptr, &u4Handle, &bCompatibleMode, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!O!lbO!", &oModule, TElPKCS11Module_ce_ptr, &oSession, TElPKCS11SessionInfo_ce_ptr, &oSlot, TElPKCS11SlotInfo_ce_ptr, &l8Handle, &bCompatibleMode, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
#endif
	{
		TElClassHandle hoOutResult = NULL;
#ifdef SB_NOT_CPU64_OR_WINDOWS
		SBCheckError(TElPKCS11KeyObject_Create_1(SBGetObjectHandle(oModule TSRMLS_CC), SBGetObjectHandle(oSession TSRMLS_CC), SBGetObjectHandle(oSlot TSRMLS_CC), (uint32_t)u4Handle, (int8_t)bCompatibleMode, SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
#else
		SBCheckError(TElPKCS11KeyObject_Create_1(SBGetObjectHandle(oModule TSRMLS_CC), SBGetObjectHandle(oSession TSRMLS_CC), SBGetObjectHandle(oSlot TSRMLS_CC), (int64_t)l8Handle, (int8_t)bCompatibleMode, SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
#endif
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("() or (TElPKCS11Module, TElPKCS11SessionInfo, TElPKCS11SlotInfo, integer, bool, TElCustomCryptoProvider)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11KeyObject_ReadProperties, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11KeyObject_ClassType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11KeyObject_get_KeyType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11KeyObject_get_PKCS11KeyType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11KeyObject_get_KeyID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11KeyObject_set_KeyID, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11KeyObject_get_StartDate, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11KeyObject_set_StartDate, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, DateTime, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11KeyObject_get_EndDate, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11KeyObject_set_EndDate, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, DateTime, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11KeyObject_get_Derive, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11KeyObject_set_Derive, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11KeyObject_get_Local, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11KeyObject_get_KeyMaterial, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11KeyObject___construct, 0, 0, 0)
	ZEND_ARG_OBJ_INFO(0, Module, TElPKCS11Module, 1)
	ZEND_ARG_OBJ_INFO(0, Session, TElPKCS11SessionInfo, 1)
	ZEND_ARG_OBJ_INFO(0, Slot, TElPKCS11SlotInfo, 1)
	ZEND_ARG_INFO(0, Handle)
	ZEND_ARG_INFO(0, CompatibleMode)
	ZEND_ARG_OBJ_INFO(0, CryptoProvider, TElCustomCryptoProvider, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElPKCS11KeyObject_methods[] = {
	PHP_ME(TElPKCS11KeyObject, ReadProperties, arginfo_TElPKCS11KeyObject_ReadProperties, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11KeyObject, ClassType, arginfo_TElPKCS11KeyObject_ClassType, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElPKCS11KeyObject, get_KeyType, arginfo_TElPKCS11KeyObject_get_KeyType, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11KeyObject, get_PKCS11KeyType, arginfo_TElPKCS11KeyObject_get_PKCS11KeyType, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11KeyObject, get_KeyID, arginfo_TElPKCS11KeyObject_get_KeyID, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11KeyObject, set_KeyID, arginfo_TElPKCS11KeyObject_set_KeyID, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11KeyObject, get_StartDate, arginfo_TElPKCS11KeyObject_get_StartDate, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11KeyObject, set_StartDate, arginfo_TElPKCS11KeyObject_set_StartDate, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11KeyObject, get_EndDate, arginfo_TElPKCS11KeyObject_get_EndDate, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11KeyObject, set_EndDate, arginfo_TElPKCS11KeyObject_set_EndDate, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11KeyObject, get_Derive, arginfo_TElPKCS11KeyObject_get_Derive, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11KeyObject, set_Derive, arginfo_TElPKCS11KeyObject_set_Derive, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11KeyObject, get_Local, arginfo_TElPKCS11KeyObject_get_Local, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11KeyObject, get_KeyMaterial, arginfo_TElPKCS11KeyObject_get_KeyMaterial, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11KeyObject, __construct, arginfo_TElPKCS11KeyObject___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElPKCS11KeyObject(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElPKCS11KeyObject_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElPKCS11KeyObject", TElPKCS11KeyObject_methods);
	if (NULL == TElPKCS11Object_ce_ptr)
		Register_TElPKCS11Object(TSRMLS_C);
	TElPKCS11KeyObject_ce_ptr = zend_register_internal_class_ex(&ce, TElPKCS11Object_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElPKCS11PublicKeyObject_ce_ptr = NULL;

SB_PHP_METHOD(TElPKCS11PublicKeyObject, ReadProperties)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElPKCS11PublicKeyObject_ReadProperties(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11PublicKeyObject, ClassType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPKCS11PublicKeyObject_ClassType(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TClass_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11PublicKeyObject, get_Subject)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElPKCS11PublicKeyObject_get_Subject(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(1297364955, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11PublicKeyObject, set_Subject)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPKCS11PublicKeyObject_set_Subject(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11PublicKeyObject, get_CanEncrypt)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPKCS11PublicKeyObject_get_CanEncrypt(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11PublicKeyObject, set_CanEncrypt)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElPKCS11PublicKeyObject_set_CanEncrypt(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11PublicKeyObject, get_CanVerify)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPKCS11PublicKeyObject_get_CanVerify(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11PublicKeyObject, set_CanVerify)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElPKCS11PublicKeyObject_set_CanVerify(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11PublicKeyObject, get_CanVerifyDetached)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPKCS11PublicKeyObject_get_CanVerifyDetached(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11PublicKeyObject, set_CanVerifyDetached)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElPKCS11PublicKeyObject_set_CanVerifyDetached(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11PublicKeyObject, get_CanWrap)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPKCS11PublicKeyObject_get_CanWrap(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11PublicKeyObject, set_CanWrap)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElPKCS11PublicKeyObject_set_CanWrap(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11PublicKeyObject, get_Trusted)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPKCS11PublicKeyObject_get_Trusted(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11PublicKeyObject, set_Trusted)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElPKCS11PublicKeyObject_set_Trusted(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11PublicKeyObject, __construct)
{
#ifdef SB_NOT_CPU64_OR_WINDOWS
	long u4Handle;
#else
	long l8Handle;
#endif
	zend_bool bCompatibleMode;
	zval *oCryptoProvider;
	zval *oModule;
	zval *oSession;
	zval *oSlot;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPKCS11PublicKeyObject_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
#ifdef SB_NOT_CPU64_OR_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!O!lbO!", &oModule, TElPKCS11Module_ce_ptr, &oSession, TElPKCS11SessionInfo_ce_ptr, &oSlot, TElPKCS11SlotInfo_ce_ptr, &u4Handle, &bCompatibleMode, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!O!lbO!", &oModule, TElPKCS11Module_ce_ptr, &oSession, TElPKCS11SessionInfo_ce_ptr, &oSlot, TElPKCS11SlotInfo_ce_ptr, &l8Handle, &bCompatibleMode, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
#endif
	{
		TElClassHandle hoOutResult = NULL;
#ifdef SB_NOT_CPU64_OR_WINDOWS
		SBCheckError(TElPKCS11PublicKeyObject_Create_1(SBGetObjectHandle(oModule TSRMLS_CC), SBGetObjectHandle(oSession TSRMLS_CC), SBGetObjectHandle(oSlot TSRMLS_CC), (uint32_t)u4Handle, (int8_t)bCompatibleMode, SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
#else
		SBCheckError(TElPKCS11PublicKeyObject_Create_1(SBGetObjectHandle(oModule TSRMLS_CC), SBGetObjectHandle(oSession TSRMLS_CC), SBGetObjectHandle(oSlot TSRMLS_CC), (int64_t)l8Handle, (int8_t)bCompatibleMode, SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
#endif
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("() or (TElPKCS11Module, TElPKCS11SessionInfo, TElPKCS11SlotInfo, integer, bool, TElCustomCryptoProvider)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11PublicKeyObject_ReadProperties, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11PublicKeyObject_ClassType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11PublicKeyObject_get_Subject, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11PublicKeyObject_set_Subject, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11PublicKeyObject_get_CanEncrypt, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11PublicKeyObject_set_CanEncrypt, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11PublicKeyObject_get_CanVerify, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11PublicKeyObject_set_CanVerify, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11PublicKeyObject_get_CanVerifyDetached, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11PublicKeyObject_set_CanVerifyDetached, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11PublicKeyObject_get_CanWrap, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11PublicKeyObject_set_CanWrap, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11PublicKeyObject_get_Trusted, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11PublicKeyObject_set_Trusted, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11PublicKeyObject___construct, 0, 0, 0)
	ZEND_ARG_OBJ_INFO(0, Module, TElPKCS11Module, 1)
	ZEND_ARG_OBJ_INFO(0, Session, TElPKCS11SessionInfo, 1)
	ZEND_ARG_OBJ_INFO(0, Slot, TElPKCS11SlotInfo, 1)
	ZEND_ARG_INFO(0, Handle)
	ZEND_ARG_INFO(0, CompatibleMode)
	ZEND_ARG_OBJ_INFO(0, CryptoProvider, TElCustomCryptoProvider, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElPKCS11PublicKeyObject_methods[] = {
	PHP_ME(TElPKCS11PublicKeyObject, ReadProperties, arginfo_TElPKCS11PublicKeyObject_ReadProperties, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11PublicKeyObject, ClassType, arginfo_TElPKCS11PublicKeyObject_ClassType, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElPKCS11PublicKeyObject, get_Subject, arginfo_TElPKCS11PublicKeyObject_get_Subject, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11PublicKeyObject, set_Subject, arginfo_TElPKCS11PublicKeyObject_set_Subject, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11PublicKeyObject, get_CanEncrypt, arginfo_TElPKCS11PublicKeyObject_get_CanEncrypt, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11PublicKeyObject, set_CanEncrypt, arginfo_TElPKCS11PublicKeyObject_set_CanEncrypt, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11PublicKeyObject, get_CanVerify, arginfo_TElPKCS11PublicKeyObject_get_CanVerify, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11PublicKeyObject, set_CanVerify, arginfo_TElPKCS11PublicKeyObject_set_CanVerify, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11PublicKeyObject, get_CanVerifyDetached, arginfo_TElPKCS11PublicKeyObject_get_CanVerifyDetached, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11PublicKeyObject, set_CanVerifyDetached, arginfo_TElPKCS11PublicKeyObject_set_CanVerifyDetached, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11PublicKeyObject, get_CanWrap, arginfo_TElPKCS11PublicKeyObject_get_CanWrap, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11PublicKeyObject, set_CanWrap, arginfo_TElPKCS11PublicKeyObject_set_CanWrap, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11PublicKeyObject, get_Trusted, arginfo_TElPKCS11PublicKeyObject_get_Trusted, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11PublicKeyObject, set_Trusted, arginfo_TElPKCS11PublicKeyObject_set_Trusted, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11PublicKeyObject, __construct, arginfo_TElPKCS11PublicKeyObject___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElPKCS11PublicKeyObject(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElPKCS11PublicKeyObject_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElPKCS11PublicKeyObject", TElPKCS11PublicKeyObject_methods);
	if (NULL == TElPKCS11KeyObject_ce_ptr)
		Register_TElPKCS11KeyObject(TSRMLS_C);
	TElPKCS11PublicKeyObject_ce_ptr = zend_register_internal_class_ex(&ce, TElPKCS11KeyObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElPKCS11PrivateKeyObject_ce_ptr = NULL;

SB_PHP_METHOD(TElPKCS11PrivateKeyObject, ReadProperties)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElPKCS11PrivateKeyObject_ReadProperties(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11PrivateKeyObject, ClassType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPKCS11PrivateKeyObject_ClassType(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TClass_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11PrivateKeyObject, get_Subject)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElPKCS11PrivateKeyObject_get_Subject(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-1948856901, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11PrivateKeyObject, set_Subject)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPKCS11PrivateKeyObject_set_Subject(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11PrivateKeyObject, get_Sensitive)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPKCS11PrivateKeyObject_get_Sensitive(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11PrivateKeyObject, set_Sensitive)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElPKCS11PrivateKeyObject_set_Sensitive(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11PrivateKeyObject, get_CanDecrypt)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPKCS11PrivateKeyObject_get_CanDecrypt(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11PrivateKeyObject, set_CanDecrypt)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElPKCS11PrivateKeyObject_set_CanDecrypt(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11PrivateKeyObject, get_CanSign)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPKCS11PrivateKeyObject_get_CanSign(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11PrivateKeyObject, set_CanSign)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElPKCS11PrivateKeyObject_set_CanSign(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11PrivateKeyObject, get_CanSignDetached)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPKCS11PrivateKeyObject_get_CanSignDetached(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11PrivateKeyObject, set_CanSignDetached)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElPKCS11PrivateKeyObject_set_CanSignDetached(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11PrivateKeyObject, get_CanUnwrap)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPKCS11PrivateKeyObject_get_CanUnwrap(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11PrivateKeyObject, set_CanUnwrap)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElPKCS11PrivateKeyObject_set_CanUnwrap(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11PrivateKeyObject, get_Extractable)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPKCS11PrivateKeyObject_get_Extractable(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11PrivateKeyObject, set_Extractable)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElPKCS11PrivateKeyObject_set_Extractable(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11PrivateKeyObject, get_AlwaysSensitive)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPKCS11PrivateKeyObject_get_AlwaysSensitive(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11PrivateKeyObject, get_NeverExtractable)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPKCS11PrivateKeyObject_get_NeverExtractable(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11PrivateKeyObject, get_WrapWithTrusted)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPKCS11PrivateKeyObject_get_WrapWithTrusted(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11PrivateKeyObject, set_WrapWithTrusted)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElPKCS11PrivateKeyObject_set_WrapWithTrusted(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11PrivateKeyObject, get_AlwaysAuthenticate)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPKCS11PrivateKeyObject_get_AlwaysAuthenticate(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11PrivateKeyObject, set_AlwaysAuthenticate)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElPKCS11PrivateKeyObject_set_AlwaysAuthenticate(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11PrivateKeyObject, __construct)
{
#ifdef SB_NOT_CPU64_OR_WINDOWS
	long u4Handle;
#else
	long l8Handle;
#endif
	zend_bool bCompatibleMode;
	zval *oCryptoProvider;
	zval *oModule;
	zval *oSession;
	zval *oSlot;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPKCS11PrivateKeyObject_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
#ifdef SB_NOT_CPU64_OR_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!O!lbO!", &oModule, TElPKCS11Module_ce_ptr, &oSession, TElPKCS11SessionInfo_ce_ptr, &oSlot, TElPKCS11SlotInfo_ce_ptr, &u4Handle, &bCompatibleMode, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!O!lbO!", &oModule, TElPKCS11Module_ce_ptr, &oSession, TElPKCS11SessionInfo_ce_ptr, &oSlot, TElPKCS11SlotInfo_ce_ptr, &l8Handle, &bCompatibleMode, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
#endif
	{
		TElClassHandle hoOutResult = NULL;
#ifdef SB_NOT_CPU64_OR_WINDOWS
		SBCheckError(TElPKCS11PrivateKeyObject_Create_1(SBGetObjectHandle(oModule TSRMLS_CC), SBGetObjectHandle(oSession TSRMLS_CC), SBGetObjectHandle(oSlot TSRMLS_CC), (uint32_t)u4Handle, (int8_t)bCompatibleMode, SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
#else
		SBCheckError(TElPKCS11PrivateKeyObject_Create_1(SBGetObjectHandle(oModule TSRMLS_CC), SBGetObjectHandle(oSession TSRMLS_CC), SBGetObjectHandle(oSlot TSRMLS_CC), (int64_t)l8Handle, (int8_t)bCompatibleMode, SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
#endif
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("() or (TElPKCS11Module, TElPKCS11SessionInfo, TElPKCS11SlotInfo, integer, bool, TElCustomCryptoProvider)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11PrivateKeyObject_ReadProperties, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11PrivateKeyObject_ClassType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11PrivateKeyObject_get_Subject, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11PrivateKeyObject_set_Subject, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11PrivateKeyObject_get_Sensitive, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11PrivateKeyObject_set_Sensitive, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11PrivateKeyObject_get_CanDecrypt, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11PrivateKeyObject_set_CanDecrypt, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11PrivateKeyObject_get_CanSign, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11PrivateKeyObject_set_CanSign, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11PrivateKeyObject_get_CanSignDetached, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11PrivateKeyObject_set_CanSignDetached, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11PrivateKeyObject_get_CanUnwrap, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11PrivateKeyObject_set_CanUnwrap, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11PrivateKeyObject_get_Extractable, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11PrivateKeyObject_set_Extractable, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11PrivateKeyObject_get_AlwaysSensitive, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11PrivateKeyObject_get_NeverExtractable, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11PrivateKeyObject_get_WrapWithTrusted, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11PrivateKeyObject_set_WrapWithTrusted, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11PrivateKeyObject_get_AlwaysAuthenticate, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11PrivateKeyObject_set_AlwaysAuthenticate, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11PrivateKeyObject___construct, 0, 0, 0)
	ZEND_ARG_OBJ_INFO(0, Module, TElPKCS11Module, 1)
	ZEND_ARG_OBJ_INFO(0, Session, TElPKCS11SessionInfo, 1)
	ZEND_ARG_OBJ_INFO(0, Slot, TElPKCS11SlotInfo, 1)
	ZEND_ARG_INFO(0, Handle)
	ZEND_ARG_INFO(0, CompatibleMode)
	ZEND_ARG_OBJ_INFO(0, CryptoProvider, TElCustomCryptoProvider, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElPKCS11PrivateKeyObject_methods[] = {
	PHP_ME(TElPKCS11PrivateKeyObject, ReadProperties, arginfo_TElPKCS11PrivateKeyObject_ReadProperties, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11PrivateKeyObject, ClassType, arginfo_TElPKCS11PrivateKeyObject_ClassType, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElPKCS11PrivateKeyObject, get_Subject, arginfo_TElPKCS11PrivateKeyObject_get_Subject, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11PrivateKeyObject, set_Subject, arginfo_TElPKCS11PrivateKeyObject_set_Subject, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11PrivateKeyObject, get_Sensitive, arginfo_TElPKCS11PrivateKeyObject_get_Sensitive, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11PrivateKeyObject, set_Sensitive, arginfo_TElPKCS11PrivateKeyObject_set_Sensitive, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11PrivateKeyObject, get_CanDecrypt, arginfo_TElPKCS11PrivateKeyObject_get_CanDecrypt, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11PrivateKeyObject, set_CanDecrypt, arginfo_TElPKCS11PrivateKeyObject_set_CanDecrypt, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11PrivateKeyObject, get_CanSign, arginfo_TElPKCS11PrivateKeyObject_get_CanSign, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11PrivateKeyObject, set_CanSign, arginfo_TElPKCS11PrivateKeyObject_set_CanSign, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11PrivateKeyObject, get_CanSignDetached, arginfo_TElPKCS11PrivateKeyObject_get_CanSignDetached, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11PrivateKeyObject, set_CanSignDetached, arginfo_TElPKCS11PrivateKeyObject_set_CanSignDetached, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11PrivateKeyObject, get_CanUnwrap, arginfo_TElPKCS11PrivateKeyObject_get_CanUnwrap, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11PrivateKeyObject, set_CanUnwrap, arginfo_TElPKCS11PrivateKeyObject_set_CanUnwrap, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11PrivateKeyObject, get_Extractable, arginfo_TElPKCS11PrivateKeyObject_get_Extractable, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11PrivateKeyObject, set_Extractable, arginfo_TElPKCS11PrivateKeyObject_set_Extractable, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11PrivateKeyObject, get_AlwaysSensitive, arginfo_TElPKCS11PrivateKeyObject_get_AlwaysSensitive, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11PrivateKeyObject, get_NeverExtractable, arginfo_TElPKCS11PrivateKeyObject_get_NeverExtractable, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11PrivateKeyObject, get_WrapWithTrusted, arginfo_TElPKCS11PrivateKeyObject_get_WrapWithTrusted, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11PrivateKeyObject, set_WrapWithTrusted, arginfo_TElPKCS11PrivateKeyObject_set_WrapWithTrusted, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11PrivateKeyObject, get_AlwaysAuthenticate, arginfo_TElPKCS11PrivateKeyObject_get_AlwaysAuthenticate, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11PrivateKeyObject, set_AlwaysAuthenticate, arginfo_TElPKCS11PrivateKeyObject_set_AlwaysAuthenticate, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11PrivateKeyObject, __construct, arginfo_TElPKCS11PrivateKeyObject___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElPKCS11PrivateKeyObject(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElPKCS11PrivateKeyObject_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElPKCS11PrivateKeyObject", TElPKCS11PrivateKeyObject_methods);
	if (NULL == TElPKCS11KeyObject_ce_ptr)
		Register_TElPKCS11KeyObject(TSRMLS_C);
	TElPKCS11PrivateKeyObject_ce_ptr = zend_register_internal_class_ex(&ce, TElPKCS11KeyObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElPKCS11SecretKeyObject_ce_ptr = NULL;

SB_PHP_METHOD(TElPKCS11SecretKeyObject, ReadProperties)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElPKCS11SecretKeyObject_ReadProperties(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11SecretKeyObject, ClassType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPKCS11SecretKeyObject_ClassType(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TClass_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11SecretKeyObject, get_Sensitive)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPKCS11SecretKeyObject_get_Sensitive(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11SecretKeyObject, set_Sensitive)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElPKCS11SecretKeyObject_set_Sensitive(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11SecretKeyObject, get_CanEncrypt)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPKCS11SecretKeyObject_get_CanEncrypt(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11SecretKeyObject, set_CanEncrypt)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElPKCS11SecretKeyObject_set_CanEncrypt(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11SecretKeyObject, get_CanDecrypt)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPKCS11SecretKeyObject_get_CanDecrypt(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11SecretKeyObject, set_CanDecrypt)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElPKCS11SecretKeyObject_set_CanDecrypt(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11SecretKeyObject, get_CanSign)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPKCS11SecretKeyObject_get_CanSign(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11SecretKeyObject, set_CanSign)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElPKCS11SecretKeyObject_set_CanSign(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11SecretKeyObject, get_CanVerify)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPKCS11SecretKeyObject_get_CanVerify(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11SecretKeyObject, set_CanVerify)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElPKCS11SecretKeyObject_set_CanVerify(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11SecretKeyObject, get_CanWrap)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPKCS11SecretKeyObject_get_CanWrap(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11SecretKeyObject, set_CanWrap)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElPKCS11SecretKeyObject_set_CanWrap(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11SecretKeyObject, get_CanUnwrap)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPKCS11SecretKeyObject_get_CanUnwrap(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11SecretKeyObject, set_CanUnwrap)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElPKCS11SecretKeyObject_set_CanUnwrap(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11SecretKeyObject, get_Extractable)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPKCS11SecretKeyObject_get_Extractable(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11SecretKeyObject, set_Extractable)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElPKCS11SecretKeyObject_set_Extractable(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11SecretKeyObject, get_AlwaysSensitive)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPKCS11SecretKeyObject_get_AlwaysSensitive(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11SecretKeyObject, get_NeverExtractable)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPKCS11SecretKeyObject_get_NeverExtractable(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11SecretKeyObject, get_Checksum)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElPKCS11SecretKeyObject_get_Checksum(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-977643527, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11SecretKeyObject, get_WrapWithTrusted)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPKCS11SecretKeyObject_get_WrapWithTrusted(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11SecretKeyObject, set_WrapWithTrusted)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElPKCS11SecretKeyObject_set_WrapWithTrusted(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11SecretKeyObject, get_Trusted)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPKCS11SecretKeyObject_get_Trusted(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11SecretKeyObject, set_Trusted)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElPKCS11SecretKeyObject_set_Trusted(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11SecretKeyObject, __construct)
{
#ifdef SB_NOT_CPU64_OR_WINDOWS
	long u4Handle;
#else
	long l8Handle;
#endif
	zend_bool bCompatibleMode;
	zval *oCryptoProvider;
	zval *oModule;
	zval *oSession;
	zval *oSlot;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPKCS11SecretKeyObject_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
#ifdef SB_NOT_CPU64_OR_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!O!lbO!", &oModule, TElPKCS11Module_ce_ptr, &oSession, TElPKCS11SessionInfo_ce_ptr, &oSlot, TElPKCS11SlotInfo_ce_ptr, &u4Handle, &bCompatibleMode, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!O!lbO!", &oModule, TElPKCS11Module_ce_ptr, &oSession, TElPKCS11SessionInfo_ce_ptr, &oSlot, TElPKCS11SlotInfo_ce_ptr, &l8Handle, &bCompatibleMode, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
#endif
	{
		TElClassHandle hoOutResult = NULL;
#ifdef SB_NOT_CPU64_OR_WINDOWS
		SBCheckError(TElPKCS11SecretKeyObject_Create_1(SBGetObjectHandle(oModule TSRMLS_CC), SBGetObjectHandle(oSession TSRMLS_CC), SBGetObjectHandle(oSlot TSRMLS_CC), (uint32_t)u4Handle, (int8_t)bCompatibleMode, SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
#else
		SBCheckError(TElPKCS11SecretKeyObject_Create_1(SBGetObjectHandle(oModule TSRMLS_CC), SBGetObjectHandle(oSession TSRMLS_CC), SBGetObjectHandle(oSlot TSRMLS_CC), (int64_t)l8Handle, (int8_t)bCompatibleMode, SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
#endif
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("() or (TElPKCS11Module, TElPKCS11SessionInfo, TElPKCS11SlotInfo, integer, bool, TElCustomCryptoProvider)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11SecretKeyObject_ReadProperties, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11SecretKeyObject_ClassType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11SecretKeyObject_get_Sensitive, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11SecretKeyObject_set_Sensitive, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11SecretKeyObject_get_CanEncrypt, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11SecretKeyObject_set_CanEncrypt, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11SecretKeyObject_get_CanDecrypt, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11SecretKeyObject_set_CanDecrypt, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11SecretKeyObject_get_CanSign, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11SecretKeyObject_set_CanSign, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11SecretKeyObject_get_CanVerify, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11SecretKeyObject_set_CanVerify, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11SecretKeyObject_get_CanWrap, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11SecretKeyObject_set_CanWrap, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11SecretKeyObject_get_CanUnwrap, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11SecretKeyObject_set_CanUnwrap, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11SecretKeyObject_get_Extractable, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11SecretKeyObject_set_Extractable, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11SecretKeyObject_get_AlwaysSensitive, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11SecretKeyObject_get_NeverExtractable, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11SecretKeyObject_get_Checksum, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11SecretKeyObject_get_WrapWithTrusted, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11SecretKeyObject_set_WrapWithTrusted, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11SecretKeyObject_get_Trusted, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11SecretKeyObject_set_Trusted, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11SecretKeyObject___construct, 0, 0, 0)
	ZEND_ARG_OBJ_INFO(0, Module, TElPKCS11Module, 1)
	ZEND_ARG_OBJ_INFO(0, Session, TElPKCS11SessionInfo, 1)
	ZEND_ARG_OBJ_INFO(0, Slot, TElPKCS11SlotInfo, 1)
	ZEND_ARG_INFO(0, Handle)
	ZEND_ARG_INFO(0, CompatibleMode)
	ZEND_ARG_OBJ_INFO(0, CryptoProvider, TElCustomCryptoProvider, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElPKCS11SecretKeyObject_methods[] = {
	PHP_ME(TElPKCS11SecretKeyObject, ReadProperties, arginfo_TElPKCS11SecretKeyObject_ReadProperties, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11SecretKeyObject, ClassType, arginfo_TElPKCS11SecretKeyObject_ClassType, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElPKCS11SecretKeyObject, get_Sensitive, arginfo_TElPKCS11SecretKeyObject_get_Sensitive, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11SecretKeyObject, set_Sensitive, arginfo_TElPKCS11SecretKeyObject_set_Sensitive, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11SecretKeyObject, get_CanEncrypt, arginfo_TElPKCS11SecretKeyObject_get_CanEncrypt, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11SecretKeyObject, set_CanEncrypt, arginfo_TElPKCS11SecretKeyObject_set_CanEncrypt, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11SecretKeyObject, get_CanDecrypt, arginfo_TElPKCS11SecretKeyObject_get_CanDecrypt, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11SecretKeyObject, set_CanDecrypt, arginfo_TElPKCS11SecretKeyObject_set_CanDecrypt, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11SecretKeyObject, get_CanSign, arginfo_TElPKCS11SecretKeyObject_get_CanSign, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11SecretKeyObject, set_CanSign, arginfo_TElPKCS11SecretKeyObject_set_CanSign, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11SecretKeyObject, get_CanVerify, arginfo_TElPKCS11SecretKeyObject_get_CanVerify, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11SecretKeyObject, set_CanVerify, arginfo_TElPKCS11SecretKeyObject_set_CanVerify, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11SecretKeyObject, get_CanWrap, arginfo_TElPKCS11SecretKeyObject_get_CanWrap, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11SecretKeyObject, set_CanWrap, arginfo_TElPKCS11SecretKeyObject_set_CanWrap, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11SecretKeyObject, get_CanUnwrap, arginfo_TElPKCS11SecretKeyObject_get_CanUnwrap, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11SecretKeyObject, set_CanUnwrap, arginfo_TElPKCS11SecretKeyObject_set_CanUnwrap, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11SecretKeyObject, get_Extractable, arginfo_TElPKCS11SecretKeyObject_get_Extractable, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11SecretKeyObject, set_Extractable, arginfo_TElPKCS11SecretKeyObject_set_Extractable, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11SecretKeyObject, get_AlwaysSensitive, arginfo_TElPKCS11SecretKeyObject_get_AlwaysSensitive, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11SecretKeyObject, get_NeverExtractable, arginfo_TElPKCS11SecretKeyObject_get_NeverExtractable, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11SecretKeyObject, get_Checksum, arginfo_TElPKCS11SecretKeyObject_get_Checksum, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11SecretKeyObject, get_WrapWithTrusted, arginfo_TElPKCS11SecretKeyObject_get_WrapWithTrusted, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11SecretKeyObject, set_WrapWithTrusted, arginfo_TElPKCS11SecretKeyObject_set_WrapWithTrusted, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11SecretKeyObject, get_Trusted, arginfo_TElPKCS11SecretKeyObject_get_Trusted, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11SecretKeyObject, set_Trusted, arginfo_TElPKCS11SecretKeyObject_set_Trusted, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11SecretKeyObject, __construct, arginfo_TElPKCS11SecretKeyObject___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElPKCS11SecretKeyObject(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElPKCS11SecretKeyObject_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElPKCS11SecretKeyObject", TElPKCS11SecretKeyObject_methods);
	if (NULL == TElPKCS11KeyObject_ce_ptr)
		Register_TElPKCS11KeyObject(TSRMLS_C);
	TElPKCS11SecretKeyObject_ce_ptr = zend_register_internal_class_ex(&ce, TElPKCS11KeyObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElPKCS11DomainParametersObject_ce_ptr = NULL;

SB_PHP_METHOD(TElPKCS11DomainParametersObject, ReadProperties)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElPKCS11DomainParametersObject_ReadProperties(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11DomainParametersObject, ClassType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPKCS11DomainParametersObject_ClassType(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TClass_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11DomainParametersObject, get_KeyType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPKCS11DomainParametersObject_get_KeyType(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11DomainParametersObject, get_PKCS11KeyType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
#ifdef SB_NOT_CPU64_OR_WINDOWS
		uint32_t u4OutResultRaw = 0;
		SBCheckError(TElPKCS11DomainParametersObject_get_PKCS11KeyType(SBGetObjectHandle(getThis() TSRMLS_CC), &u4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
#else
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElPKCS11DomainParametersObject_get_PKCS11KeyType(SBGetObjectHandle(getThis() TSRMLS_CC), &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
#endif
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11DomainParametersObject, __construct)
{
#ifdef SB_NOT_CPU64_OR_WINDOWS
	long u4Handle;
#else
	long l8Handle;
#endif
	zend_bool bCompatibleMode;
	zval *oCryptoProvider;
	zval *oModule;
	zval *oSession;
	zval *oSlot;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPKCS11DomainParametersObject_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
#ifdef SB_NOT_CPU64_OR_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!O!lbO!", &oModule, TElPKCS11Module_ce_ptr, &oSession, TElPKCS11SessionInfo_ce_ptr, &oSlot, TElPKCS11SlotInfo_ce_ptr, &u4Handle, &bCompatibleMode, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!O!lbO!", &oModule, TElPKCS11Module_ce_ptr, &oSession, TElPKCS11SessionInfo_ce_ptr, &oSlot, TElPKCS11SlotInfo_ce_ptr, &l8Handle, &bCompatibleMode, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
#endif
	{
		TElClassHandle hoOutResult = NULL;
#ifdef SB_NOT_CPU64_OR_WINDOWS
		SBCheckError(TElPKCS11DomainParametersObject_Create_1(SBGetObjectHandle(oModule TSRMLS_CC), SBGetObjectHandle(oSession TSRMLS_CC), SBGetObjectHandle(oSlot TSRMLS_CC), (uint32_t)u4Handle, (int8_t)bCompatibleMode, SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
#else
		SBCheckError(TElPKCS11DomainParametersObject_Create_1(SBGetObjectHandle(oModule TSRMLS_CC), SBGetObjectHandle(oSession TSRMLS_CC), SBGetObjectHandle(oSlot TSRMLS_CC), (int64_t)l8Handle, (int8_t)bCompatibleMode, SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
#endif
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("() or (TElPKCS11Module, TElPKCS11SessionInfo, TElPKCS11SlotInfo, integer, bool, TElCustomCryptoProvider)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11DomainParametersObject_ReadProperties, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11DomainParametersObject_ClassType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11DomainParametersObject_get_KeyType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11DomainParametersObject_get_PKCS11KeyType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11DomainParametersObject___construct, 0, 0, 0)
	ZEND_ARG_OBJ_INFO(0, Module, TElPKCS11Module, 1)
	ZEND_ARG_OBJ_INFO(0, Session, TElPKCS11SessionInfo, 1)
	ZEND_ARG_OBJ_INFO(0, Slot, TElPKCS11SlotInfo, 1)
	ZEND_ARG_INFO(0, Handle)
	ZEND_ARG_INFO(0, CompatibleMode)
	ZEND_ARG_OBJ_INFO(0, CryptoProvider, TElCustomCryptoProvider, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElPKCS11DomainParametersObject_methods[] = {
	PHP_ME(TElPKCS11DomainParametersObject, ReadProperties, arginfo_TElPKCS11DomainParametersObject_ReadProperties, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11DomainParametersObject, ClassType, arginfo_TElPKCS11DomainParametersObject_ClassType, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElPKCS11DomainParametersObject, get_KeyType, arginfo_TElPKCS11DomainParametersObject_get_KeyType, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11DomainParametersObject, get_PKCS11KeyType, arginfo_TElPKCS11DomainParametersObject_get_PKCS11KeyType, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11DomainParametersObject, __construct, arginfo_TElPKCS11DomainParametersObject___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElPKCS11DomainParametersObject(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElPKCS11DomainParametersObject_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElPKCS11DomainParametersObject", TElPKCS11DomainParametersObject_methods);
	if (NULL == TElPKCS11Object_ce_ptr)
		Register_TElPKCS11Object(TSRMLS_C);
	TElPKCS11DomainParametersObject_ce_ptr = zend_register_internal_class_ex(&ce, TElPKCS11Object_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElPKCS11Utils_ce_ptr = NULL;

SB_PHP_METHOD(TElPKCS11Utils, GetObjectAttribute_Inst)
{
#ifdef SB_NOT_CPU64_OR_WINDOWS
	long u4Attribute;
	long u4hObject;
	long u4hSession;
#else
	long l8Attribute;
	long l8hObject;
	long l8hSession;
#endif
	uint32_t _err;
	zval *oModule;
#ifdef SB_NOT_CPU64_OR_WINDOWS
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!lll", &oModule, TElPKCS11Module_ce_ptr, &u4hSession, &u4hObject, &u4Attribute) == SUCCESS)
#else
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!lll", &oModule, TElPKCS11Module_ce_ptr, &l8hSession, &l8hObject, &l8Attribute) == SUCCESS)
#endif
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
#ifdef SB_NOT_CPU64_OR_WINDOWS
		_err = TElPKCS11Utils_GetObjectAttribute_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oModule TSRMLS_CC), (uint32_t)u4hSession, (uint32_t)u4hObject, (uint32_t)u4Attribute, u8OutResult, &u8OutResult_len);
#else
		_err = TElPKCS11Utils_GetObjectAttribute_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oModule TSRMLS_CC), (int64_t)l8hSession, (int64_t)l8hObject, (int64_t)l8Attribute, u8OutResult, &u8OutResult_len);
#endif
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
#ifdef SB_NOT_CPU64_OR_WINDOWS
			SBCheckError(SBGetLastReturnBuffer(1209326187, 5, u8OutResult, &u8OutResult_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnBuffer(1477817149, 5, u8OutResult, &u8OutResult_len) TSRMLS_CC);
#endif
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(TElPKCS11Module, integer, integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11Utils, GetObjectAttribute)
{
#ifdef SB_NOT_CPU64_OR_WINDOWS
	long u4Attribute;
	long u4hObject;
	long u4hSession;
#else
	long l8Attribute;
	long l8hObject;
	long l8hSession;
#endif
	uint32_t _err;
	zval *oModule;
#ifdef SB_NOT_CPU64_OR_WINDOWS
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!lll", &oModule, TElPKCS11Module_ce_ptr, &u4hSession, &u4hObject, &u4Attribute) == SUCCESS)
#else
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!lll", &oModule, TElPKCS11Module_ce_ptr, &l8hSession, &l8hObject, &l8Attribute) == SUCCESS)
#endif
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
#ifdef SB_NOT_CPU64_OR_WINDOWS
		_err = TElPKCS11Utils_GetObjectAttribute(SBGetObjectHandle(oModule TSRMLS_CC), (uint32_t)u4hSession, (uint32_t)u4hObject, (uint32_t)u4Attribute, u8OutResult, &u8OutResult_len);
#else
		_err = TElPKCS11Utils_GetObjectAttribute(SBGetObjectHandle(oModule TSRMLS_CC), (int64_t)l8hSession, (int64_t)l8hObject, (int64_t)l8Attribute, u8OutResult, &u8OutResult_len);
#endif
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
#ifdef SB_NOT_CPU64_OR_WINDOWS
			SBCheckError(SBGetLastReturnBuffer(1209326187, 4, u8OutResult, &u8OutResult_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnBuffer(1477817149, 4, u8OutResult, &u8OutResult_len) TSRMLS_CC);
#endif
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(TElPKCS11Module, integer, integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11Utils, GetBufferTypeAttribute_Inst)
{
#ifdef SB_NOT_CPU64_OR_WINDOWS
	long u4Attribute;
	long u4hObject;
	long u4hSession;
#else
	long l8Attribute;
	long l8hObject;
	long l8hSession;
#endif
	SBArrayZValInfo aiDef;
	uint32_t _err;
	zval *oModule;
	zval *zaDef;
#ifdef SB_NOT_CPU64_OR_WINDOWS
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!lllz", &oModule, TElPKCS11Module_ce_ptr, &u4hSession, &u4hObject, &u4Attribute, &zaDef) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaDef)) || (IS_ARRAY == Z_TYPE_P(zaDef)) || (IS_NULL == Z_TYPE_P(zaDef))))
#else
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!lllz", &oModule, TElPKCS11Module_ce_ptr, &l8hSession, &l8hObject, &l8Attribute, &zaDef) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaDef)) || (IS_ARRAY == Z_TYPE_P(zaDef)) || (IS_NULL == Z_TYPE_P(zaDef))))
#endif
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		if (!SBGetByteArrayFromZVal(zaDef, &aiDef TSRMLS_CC)) RETURN_FALSE;
#ifdef SB_NOT_CPU64_OR_WINDOWS
		_err = TElPKCS11Utils_GetBufferTypeAttribute_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oModule TSRMLS_CC), (uint32_t)u4hSession, (uint32_t)u4hObject, (uint32_t)u4Attribute, aiDef.data, aiDef.len, u8OutResult, &u8OutResult_len);
#else
		_err = TElPKCS11Utils_GetBufferTypeAttribute_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oModule TSRMLS_CC), (int64_t)l8hSession, (int64_t)l8hObject, (int64_t)l8Attribute, aiDef.data, aiDef.len, u8OutResult, &u8OutResult_len);
#endif
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
#ifdef SB_NOT_CPU64_OR_WINDOWS
			SBCheckError(SBGetLastReturnBuffer(-1119466412, 6, u8OutResult, &u8OutResult_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnBuffer(1306852311, 6, u8OutResult, &u8OutResult_len) TSRMLS_CC);
#endif
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiDef);
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(TElPKCS11Module, integer, integer, integer, array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11Utils, GetBufferTypeAttribute)
{
#ifdef SB_NOT_CPU64_OR_WINDOWS
	long u4Attribute;
	long u4hObject;
	long u4hSession;
#else
	long l8Attribute;
	long l8hObject;
	long l8hSession;
#endif
	SBArrayZValInfo aiDef;
	uint32_t _err;
	zval *oModule;
	zval *zaDef;
#ifdef SB_NOT_CPU64_OR_WINDOWS
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!lllz", &oModule, TElPKCS11Module_ce_ptr, &u4hSession, &u4hObject, &u4Attribute, &zaDef) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaDef)) || (IS_ARRAY == Z_TYPE_P(zaDef)) || (IS_NULL == Z_TYPE_P(zaDef))))
#else
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!lllz", &oModule, TElPKCS11Module_ce_ptr, &l8hSession, &l8hObject, &l8Attribute, &zaDef) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaDef)) || (IS_ARRAY == Z_TYPE_P(zaDef)) || (IS_NULL == Z_TYPE_P(zaDef))))
#endif
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		if (!SBGetByteArrayFromZVal(zaDef, &aiDef TSRMLS_CC)) RETURN_FALSE;
#ifdef SB_NOT_CPU64_OR_WINDOWS
		_err = TElPKCS11Utils_GetBufferTypeAttribute(SBGetObjectHandle(oModule TSRMLS_CC), (uint32_t)u4hSession, (uint32_t)u4hObject, (uint32_t)u4Attribute, aiDef.data, aiDef.len, u8OutResult, &u8OutResult_len);
#else
		_err = TElPKCS11Utils_GetBufferTypeAttribute(SBGetObjectHandle(oModule TSRMLS_CC), (int64_t)l8hSession, (int64_t)l8hObject, (int64_t)l8Attribute, aiDef.data, aiDef.len, u8OutResult, &u8OutResult_len);
#endif
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
#ifdef SB_NOT_CPU64_OR_WINDOWS
			SBCheckError(SBGetLastReturnBuffer(-1119466412, 5, u8OutResult, &u8OutResult_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnBuffer(1306852311, 5, u8OutResult, &u8OutResult_len) TSRMLS_CC);
#endif
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiDef);
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(TElPKCS11Module, integer, integer, integer, array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11Utils, GetBooleanAttribute_Inst)
{
#ifdef SB_NOT_CPU64_OR_WINDOWS
	long u4Attribute;
	long u4hObject;
	long u4hSession;
#else
	long l8Attribute;
	long l8hObject;
	long l8hSession;
#endif
	zend_bool bDef;
	zval *oModule;
#ifdef SB_NOT_CPU64_OR_WINDOWS
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!lllb", &oModule, TElPKCS11Module_ce_ptr, &u4hSession, &u4hObject, &u4Attribute, &bDef) == SUCCESS)
#else
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!lllb", &oModule, TElPKCS11Module_ce_ptr, &l8hSession, &l8hObject, &l8Attribute, &bDef) == SUCCESS)
#endif
	{
		int8_t bOutResultRaw = 0;
#ifdef SB_NOT_CPU64_OR_WINDOWS
		SBCheckError(TElPKCS11Utils_GetBooleanAttribute_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oModule TSRMLS_CC), (uint32_t)u4hSession, (uint32_t)u4hObject, (uint32_t)u4Attribute, (int8_t)bDef, &bOutResultRaw) TSRMLS_CC);
#else
		SBCheckError(TElPKCS11Utils_GetBooleanAttribute_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oModule TSRMLS_CC), (int64_t)l8hSession, (int64_t)l8hObject, (int64_t)l8Attribute, (int8_t)bDef, &bOutResultRaw) TSRMLS_CC);
#endif
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElPKCS11Module, integer, integer, integer, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11Utils, GetBooleanAttribute)
{
#ifdef SB_NOT_CPU64_OR_WINDOWS
	long u4Attribute;
	long u4hObject;
	long u4hSession;
#else
	long l8Attribute;
	long l8hObject;
	long l8hSession;
#endif
	zend_bool bDef;
	zval *oModule;
#ifdef SB_NOT_CPU64_OR_WINDOWS
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!lllb", &oModule, TElPKCS11Module_ce_ptr, &u4hSession, &u4hObject, &u4Attribute, &bDef) == SUCCESS)
#else
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!lllb", &oModule, TElPKCS11Module_ce_ptr, &l8hSession, &l8hObject, &l8Attribute, &bDef) == SUCCESS)
#endif
	{
		int8_t bOutResultRaw = 0;
#ifdef SB_NOT_CPU64_OR_WINDOWS
		SBCheckError(TElPKCS11Utils_GetBooleanAttribute(SBGetObjectHandle(oModule TSRMLS_CC), (uint32_t)u4hSession, (uint32_t)u4hObject, (uint32_t)u4Attribute, (int8_t)bDef, &bOutResultRaw) TSRMLS_CC);
#else
		SBCheckError(TElPKCS11Utils_GetBooleanAttribute(SBGetObjectHandle(oModule TSRMLS_CC), (int64_t)l8hSession, (int64_t)l8hObject, (int64_t)l8Attribute, (int8_t)bDef, &bOutResultRaw) TSRMLS_CC);
#endif
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElPKCS11Module, integer, integer, integer, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11Utils, GetULongAttribute_Inst)
{
#ifdef SB_NOT_CPU64_OR_WINDOWS
	long u4Attribute;
	long u4Def;
	long u4hObject;
	long u4hSession;
#else
	long l8Attribute;
	long l8Def;
	long l8hObject;
	long l8hSession;
#endif
	zval *oModule;
#ifdef SB_NOT_CPU64_OR_WINDOWS
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!llll", &oModule, TElPKCS11Module_ce_ptr, &u4hSession, &u4hObject, &u4Attribute, &u4Def) == SUCCESS)
#else
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!llll", &oModule, TElPKCS11Module_ce_ptr, &l8hSession, &l8hObject, &l8Attribute, &l8Def) == SUCCESS)
#endif
	{
#ifdef SB_NOT_CPU64_OR_WINDOWS
		uint32_t u4OutResultRaw = 0;
		SBCheckError(TElPKCS11Utils_GetULongAttribute_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oModule TSRMLS_CC), (uint32_t)u4hSession, (uint32_t)u4hObject, (uint32_t)u4Attribute, (uint32_t)u4Def, &u4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
#else
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElPKCS11Utils_GetULongAttribute_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oModule TSRMLS_CC), (int64_t)l8hSession, (int64_t)l8hObject, (int64_t)l8Attribute, (int64_t)l8Def, &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
#endif
	}
	else
	{
		SBErrorExpectsArguments("(TElPKCS11Module, integer, integer, integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11Utils, GetULongAttribute)
{
#ifdef SB_NOT_CPU64_OR_WINDOWS
	long u4Attribute;
	long u4Def;
	long u4hObject;
	long u4hSession;
#else
	long l8Attribute;
	long l8Def;
	long l8hObject;
	long l8hSession;
#endif
	zval *oModule;
#ifdef SB_NOT_CPU64_OR_WINDOWS
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!llll", &oModule, TElPKCS11Module_ce_ptr, &u4hSession, &u4hObject, &u4Attribute, &u4Def) == SUCCESS)
#else
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!llll", &oModule, TElPKCS11Module_ce_ptr, &l8hSession, &l8hObject, &l8Attribute, &l8Def) == SUCCESS)
#endif
	{
#ifdef SB_NOT_CPU64_OR_WINDOWS
		uint32_t u4OutResultRaw = 0;
		SBCheckError(TElPKCS11Utils_GetULongAttribute(SBGetObjectHandle(oModule TSRMLS_CC), (uint32_t)u4hSession, (uint32_t)u4hObject, (uint32_t)u4Attribute, (uint32_t)u4Def, &u4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
#else
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElPKCS11Utils_GetULongAttribute(SBGetObjectHandle(oModule TSRMLS_CC), (int64_t)l8hSession, (int64_t)l8hObject, (int64_t)l8Attribute, (int64_t)l8Def, &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
#endif
	}
	else
	{
		SBErrorExpectsArguments("(TElPKCS11Module, integer, integer, integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11Utils, GetDateAttribute_Inst)
{
#ifdef SB_NOT_CPU64_OR_WINDOWS
	long u4Attribute;
	long u4hObject;
	long u4hSession;
#else
	long l8Attribute;
	long l8hObject;
	long l8hSession;
#endif
	zval *dtDef;
	zval *oModule;
#ifdef SB_NOT_CPU64_OR_WINDOWS
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!lllO", &oModule, TElPKCS11Module_ce_ptr, &u4hSession, &u4hObject, &u4Attribute, &dtDef, php_date_get_date_ce()) == SUCCESS)
#else
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!lllO", &oModule, TElPKCS11Module_ce_ptr, &l8hSession, &l8hObject, &l8Attribute, &dtDef, php_date_get_date_ce()) == SUCCESS)
#endif
	{
		int64_t dtOutResultRaw = 0;
#ifdef SB_NOT_CPU64_OR_WINDOWS
		SBCheckError(TElPKCS11Utils_GetDateAttribute_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oModule TSRMLS_CC), (uint32_t)u4hSession, (uint32_t)u4hObject, (uint32_t)u4Attribute, SBGetDateTime(dtDef TSRMLS_CC), &dtOutResultRaw) TSRMLS_CC);
#else
		SBCheckError(TElPKCS11Utils_GetDateAttribute_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oModule TSRMLS_CC), (int64_t)l8hSession, (int64_t)l8hObject, (int64_t)l8Attribute, SBGetDateTime(dtDef TSRMLS_CC), &dtOutResultRaw) TSRMLS_CC);
#endif
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElPKCS11Module, integer, integer, integer, DateTime)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11Utils, GetDateAttribute)
{
#ifdef SB_NOT_CPU64_OR_WINDOWS
	long u4Attribute;
	long u4hObject;
	long u4hSession;
#else
	long l8Attribute;
	long l8hObject;
	long l8hSession;
#endif
	zval *dtDef;
	zval *oModule;
#ifdef SB_NOT_CPU64_OR_WINDOWS
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!lllO", &oModule, TElPKCS11Module_ce_ptr, &u4hSession, &u4hObject, &u4Attribute, &dtDef, php_date_get_date_ce()) == SUCCESS)
#else
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!lllO", &oModule, TElPKCS11Module_ce_ptr, &l8hSession, &l8hObject, &l8Attribute, &dtDef, php_date_get_date_ce()) == SUCCESS)
#endif
	{
		int64_t dtOutResultRaw = 0;
#ifdef SB_NOT_CPU64_OR_WINDOWS
		SBCheckError(TElPKCS11Utils_GetDateAttribute(SBGetObjectHandle(oModule TSRMLS_CC), (uint32_t)u4hSession, (uint32_t)u4hObject, (uint32_t)u4Attribute, SBGetDateTime(dtDef TSRMLS_CC), &dtOutResultRaw) TSRMLS_CC);
#else
		SBCheckError(TElPKCS11Utils_GetDateAttribute(SBGetObjectHandle(oModule TSRMLS_CC), (int64_t)l8hSession, (int64_t)l8hObject, (int64_t)l8Attribute, SBGetDateTime(dtDef TSRMLS_CC), &dtOutResultRaw) TSRMLS_CC);
#endif
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElPKCS11Module, integer, integer, integer, DateTime)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11Utils, SetObjectAttribute_Inst)
{
#ifdef SB_NOT_CPU64_OR_WINDOWS
	long u4Attribute;
	long u4hObject;
	long u4hSession;
#else
	long l8Attribute;
	long l8hObject;
	long l8hSession;
#endif
	SBArrayZValInfo aiValue;
	zval *oModule;
	zval *zaValue;
#ifdef SB_NOT_CPU64_OR_WINDOWS
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!lllz", &oModule, TElPKCS11Module_ce_ptr, &u4hSession, &u4hObject, &u4Attribute, &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
#else
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!lllz", &oModule, TElPKCS11Module_ce_ptr, &l8hSession, &l8hObject, &l8Attribute, &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
#endif
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
#ifdef SB_NOT_CPU64_OR_WINDOWS
		SBCheckError(TElPKCS11Utils_SetObjectAttribute_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oModule TSRMLS_CC), (uint32_t)u4hSession, (uint32_t)u4hObject, (uint32_t)u4Attribute, aiValue.data, aiValue.len) TSRMLS_CC);
#else
		SBCheckError(TElPKCS11Utils_SetObjectAttribute_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oModule TSRMLS_CC), (int64_t)l8hSession, (int64_t)l8hObject, (int64_t)l8Attribute, aiValue.data, aiValue.len) TSRMLS_CC);
#endif
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(TElPKCS11Module, integer, integer, integer, array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11Utils, SetObjectAttribute)
{
#ifdef SB_NOT_CPU64_OR_WINDOWS
	long u4Attribute;
	long u4hObject;
	long u4hSession;
#else
	long l8Attribute;
	long l8hObject;
	long l8hSession;
#endif
	SBArrayZValInfo aiValue;
	zval *oModule;
	zval *zaValue;
#ifdef SB_NOT_CPU64_OR_WINDOWS
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!lllz", &oModule, TElPKCS11Module_ce_ptr, &u4hSession, &u4hObject, &u4Attribute, &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
#else
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!lllz", &oModule, TElPKCS11Module_ce_ptr, &l8hSession, &l8hObject, &l8Attribute, &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
#endif
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
#ifdef SB_NOT_CPU64_OR_WINDOWS
		SBCheckError(TElPKCS11Utils_SetObjectAttribute(SBGetObjectHandle(oModule TSRMLS_CC), (uint32_t)u4hSession, (uint32_t)u4hObject, (uint32_t)u4Attribute, aiValue.data, aiValue.len) TSRMLS_CC);
#else
		SBCheckError(TElPKCS11Utils_SetObjectAttribute(SBGetObjectHandle(oModule TSRMLS_CC), (int64_t)l8hSession, (int64_t)l8hObject, (int64_t)l8Attribute, aiValue.data, aiValue.len) TSRMLS_CC);
#endif
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(TElPKCS11Module, integer, integer, integer, array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11Utils, SetBufferTypeAttribute_Inst)
{
#ifdef SB_NOT_CPU64_OR_WINDOWS
	long u4Attribute;
	long u4hObject;
	long u4hSession;
#else
	long l8Attribute;
	long l8hObject;
	long l8hSession;
#endif
	SBArrayZValInfo aiValue;
	zval *oModule;
	zval *zaValue;
#ifdef SB_NOT_CPU64_OR_WINDOWS
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!lllz", &oModule, TElPKCS11Module_ce_ptr, &u4hSession, &u4hObject, &u4Attribute, &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
#else
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!lllz", &oModule, TElPKCS11Module_ce_ptr, &l8hSession, &l8hObject, &l8Attribute, &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
#endif
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
#ifdef SB_NOT_CPU64_OR_WINDOWS
		SBCheckError(TElPKCS11Utils_SetBufferTypeAttribute_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oModule TSRMLS_CC), (uint32_t)u4hSession, (uint32_t)u4hObject, (uint32_t)u4Attribute, aiValue.data, aiValue.len) TSRMLS_CC);
#else
		SBCheckError(TElPKCS11Utils_SetBufferTypeAttribute_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oModule TSRMLS_CC), (int64_t)l8hSession, (int64_t)l8hObject, (int64_t)l8Attribute, aiValue.data, aiValue.len) TSRMLS_CC);
#endif
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(TElPKCS11Module, integer, integer, integer, array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11Utils, SetBufferTypeAttribute)
{
#ifdef SB_NOT_CPU64_OR_WINDOWS
	long u4Attribute;
	long u4hObject;
	long u4hSession;
#else
	long l8Attribute;
	long l8hObject;
	long l8hSession;
#endif
	SBArrayZValInfo aiValue;
	zval *oModule;
	zval *zaValue;
#ifdef SB_NOT_CPU64_OR_WINDOWS
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!lllz", &oModule, TElPKCS11Module_ce_ptr, &u4hSession, &u4hObject, &u4Attribute, &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
#else
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!lllz", &oModule, TElPKCS11Module_ce_ptr, &l8hSession, &l8hObject, &l8Attribute, &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
#endif
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
#ifdef SB_NOT_CPU64_OR_WINDOWS
		SBCheckError(TElPKCS11Utils_SetBufferTypeAttribute(SBGetObjectHandle(oModule TSRMLS_CC), (uint32_t)u4hSession, (uint32_t)u4hObject, (uint32_t)u4Attribute, aiValue.data, aiValue.len) TSRMLS_CC);
#else
		SBCheckError(TElPKCS11Utils_SetBufferTypeAttribute(SBGetObjectHandle(oModule TSRMLS_CC), (int64_t)l8hSession, (int64_t)l8hObject, (int64_t)l8Attribute, aiValue.data, aiValue.len) TSRMLS_CC);
#endif
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(TElPKCS11Module, integer, integer, integer, array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11Utils, SetBooleanAttribute_Inst)
{
#ifdef SB_NOT_CPU64_OR_WINDOWS
	long u4Attribute;
	long u4hObject;
	long u4hSession;
#else
	long l8Attribute;
	long l8hObject;
	long l8hSession;
#endif
	zend_bool bValue;
	zval *oModule;
#ifdef SB_NOT_CPU64_OR_WINDOWS
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!lllb", &oModule, TElPKCS11Module_ce_ptr, &u4hSession, &u4hObject, &u4Attribute, &bValue) == SUCCESS)
#else
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!lllb", &oModule, TElPKCS11Module_ce_ptr, &l8hSession, &l8hObject, &l8Attribute, &bValue) == SUCCESS)
#endif
	{
#ifdef SB_NOT_CPU64_OR_WINDOWS
		SBCheckError(TElPKCS11Utils_SetBooleanAttribute_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oModule TSRMLS_CC), (uint32_t)u4hSession, (uint32_t)u4hObject, (uint32_t)u4Attribute, (int8_t)bValue) TSRMLS_CC);
#else
		SBCheckError(TElPKCS11Utils_SetBooleanAttribute_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oModule TSRMLS_CC), (int64_t)l8hSession, (int64_t)l8hObject, (int64_t)l8Attribute, (int8_t)bValue) TSRMLS_CC);
#endif
	}
	else
	{
		SBErrorExpectsArguments("(TElPKCS11Module, integer, integer, integer, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11Utils, SetBooleanAttribute)
{
#ifdef SB_NOT_CPU64_OR_WINDOWS
	long u4Attribute;
	long u4hObject;
	long u4hSession;
#else
	long l8Attribute;
	long l8hObject;
	long l8hSession;
#endif
	zend_bool bValue;
	zval *oModule;
#ifdef SB_NOT_CPU64_OR_WINDOWS
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!lllb", &oModule, TElPKCS11Module_ce_ptr, &u4hSession, &u4hObject, &u4Attribute, &bValue) == SUCCESS)
#else
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!lllb", &oModule, TElPKCS11Module_ce_ptr, &l8hSession, &l8hObject, &l8Attribute, &bValue) == SUCCESS)
#endif
	{
#ifdef SB_NOT_CPU64_OR_WINDOWS
		SBCheckError(TElPKCS11Utils_SetBooleanAttribute(SBGetObjectHandle(oModule TSRMLS_CC), (uint32_t)u4hSession, (uint32_t)u4hObject, (uint32_t)u4Attribute, (int8_t)bValue) TSRMLS_CC);
#else
		SBCheckError(TElPKCS11Utils_SetBooleanAttribute(SBGetObjectHandle(oModule TSRMLS_CC), (int64_t)l8hSession, (int64_t)l8hObject, (int64_t)l8Attribute, (int8_t)bValue) TSRMLS_CC);
#endif
	}
	else
	{
		SBErrorExpectsArguments("(TElPKCS11Module, integer, integer, integer, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11Utils, SetULongAttribute_Inst)
{
#ifdef SB_NOT_CPU64_OR_WINDOWS
	long u4Attribute;
	long u4hObject;
	long u4hSession;
	long u4Value;
#else
	long l8Attribute;
	long l8hObject;
	long l8hSession;
	long l8Value;
#endif
	zval *oModule;
#ifdef SB_NOT_CPU64_OR_WINDOWS
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!llll", &oModule, TElPKCS11Module_ce_ptr, &u4hSession, &u4hObject, &u4Attribute, &u4Value) == SUCCESS)
#else
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!llll", &oModule, TElPKCS11Module_ce_ptr, &l8hSession, &l8hObject, &l8Attribute, &l8Value) == SUCCESS)
#endif
	{
#ifdef SB_NOT_CPU64_OR_WINDOWS
		SBCheckError(TElPKCS11Utils_SetULongAttribute_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oModule TSRMLS_CC), (uint32_t)u4hSession, (uint32_t)u4hObject, (uint32_t)u4Attribute, (uint32_t)u4Value) TSRMLS_CC);
#else
		SBCheckError(TElPKCS11Utils_SetULongAttribute_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oModule TSRMLS_CC), (int64_t)l8hSession, (int64_t)l8hObject, (int64_t)l8Attribute, (int64_t)l8Value) TSRMLS_CC);
#endif
	}
	else
	{
		SBErrorExpectsArguments("(TElPKCS11Module, integer, integer, integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11Utils, SetULongAttribute)
{
#ifdef SB_NOT_CPU64_OR_WINDOWS
	long u4Attribute;
	long u4hObject;
	long u4hSession;
	long u4Value;
#else
	long l8Attribute;
	long l8hObject;
	long l8hSession;
	long l8Value;
#endif
	zval *oModule;
#ifdef SB_NOT_CPU64_OR_WINDOWS
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!llll", &oModule, TElPKCS11Module_ce_ptr, &u4hSession, &u4hObject, &u4Attribute, &u4Value) == SUCCESS)
#else
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!llll", &oModule, TElPKCS11Module_ce_ptr, &l8hSession, &l8hObject, &l8Attribute, &l8Value) == SUCCESS)
#endif
	{
#ifdef SB_NOT_CPU64_OR_WINDOWS
		SBCheckError(TElPKCS11Utils_SetULongAttribute(SBGetObjectHandle(oModule TSRMLS_CC), (uint32_t)u4hSession, (uint32_t)u4hObject, (uint32_t)u4Attribute, (uint32_t)u4Value) TSRMLS_CC);
#else
		SBCheckError(TElPKCS11Utils_SetULongAttribute(SBGetObjectHandle(oModule TSRMLS_CC), (int64_t)l8hSession, (int64_t)l8hObject, (int64_t)l8Attribute, (int64_t)l8Value) TSRMLS_CC);
#endif
	}
	else
	{
		SBErrorExpectsArguments("(TElPKCS11Module, integer, integer, integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11Utils, SetDateAttribute_Inst)
{
#ifdef SB_NOT_CPU64_OR_WINDOWS
	long u4Attribute;
	long u4hObject;
	long u4hSession;
#else
	long l8Attribute;
	long l8hObject;
	long l8hSession;
#endif
	zval *dtValue;
	zval *oModule;
#ifdef SB_NOT_CPU64_OR_WINDOWS
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!lllO", &oModule, TElPKCS11Module_ce_ptr, &u4hSession, &u4hObject, &u4Attribute, &dtValue, php_date_get_date_ce()) == SUCCESS)
#else
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!lllO", &oModule, TElPKCS11Module_ce_ptr, &l8hSession, &l8hObject, &l8Attribute, &dtValue, php_date_get_date_ce()) == SUCCESS)
#endif
	{
#ifdef SB_NOT_CPU64_OR_WINDOWS
		SBCheckError(TElPKCS11Utils_SetDateAttribute_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oModule TSRMLS_CC), (uint32_t)u4hSession, (uint32_t)u4hObject, (uint32_t)u4Attribute, SBGetDateTime(dtValue TSRMLS_CC)) TSRMLS_CC);
#else
		SBCheckError(TElPKCS11Utils_SetDateAttribute_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oModule TSRMLS_CC), (int64_t)l8hSession, (int64_t)l8hObject, (int64_t)l8Attribute, SBGetDateTime(dtValue TSRMLS_CC)) TSRMLS_CC);
#endif
	}
	else
	{
		SBErrorExpectsArguments("(TElPKCS11Module, integer, integer, integer, DateTime)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11Utils, SetDateAttribute)
{
#ifdef SB_NOT_CPU64_OR_WINDOWS
	long u4Attribute;
	long u4hObject;
	long u4hSession;
#else
	long l8Attribute;
	long l8hObject;
	long l8hSession;
#endif
	zval *dtValue;
	zval *oModule;
#ifdef SB_NOT_CPU64_OR_WINDOWS
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!lllO", &oModule, TElPKCS11Module_ce_ptr, &u4hSession, &u4hObject, &u4Attribute, &dtValue, php_date_get_date_ce()) == SUCCESS)
#else
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!lllO", &oModule, TElPKCS11Module_ce_ptr, &l8hSession, &l8hObject, &l8Attribute, &dtValue, php_date_get_date_ce()) == SUCCESS)
#endif
	{
#ifdef SB_NOT_CPU64_OR_WINDOWS
		SBCheckError(TElPKCS11Utils_SetDateAttribute(SBGetObjectHandle(oModule TSRMLS_CC), (uint32_t)u4hSession, (uint32_t)u4hObject, (uint32_t)u4Attribute, SBGetDateTime(dtValue TSRMLS_CC)) TSRMLS_CC);
#else
		SBCheckError(TElPKCS11Utils_SetDateAttribute(SBGetObjectHandle(oModule TSRMLS_CC), (int64_t)l8hSession, (int64_t)l8hObject, (int64_t)l8Attribute, SBGetDateTime(dtValue TSRMLS_CC)) TSRMLS_CC);
#endif
	}
	else
	{
		SBErrorExpectsArguments("(TElPKCS11Module, integer, integer, integer, DateTime)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11Utils, ConvertPKCS11KeyTypeToSBBKeyType_Inst)
{
	long l4KeyType;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4KeyType) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPKCS11Utils_ConvertPKCS11KeyTypeToSBBKeyType_1(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4KeyType, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11Utils, ConvertPKCS11KeyTypeToSBBKeyType)
{
	long l4KeyType;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4KeyType) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPKCS11Utils_ConvertPKCS11KeyTypeToSBBKeyType((int32_t)l4KeyType, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11Utils, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPKCS11Utils_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11Utils_GetObjectAttribute_Inst, 0, 0, 4)
	ZEND_ARG_OBJ_INFO(0, Module, TElPKCS11Module, 1)
	ZEND_ARG_INFO(0, hSession)
	ZEND_ARG_INFO(0, hObject)
	ZEND_ARG_INFO(0, Attribute)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11Utils_GetObjectAttribute, 0, 0, 4)
	ZEND_ARG_OBJ_INFO(0, Module, TElPKCS11Module, 1)
	ZEND_ARG_INFO(0, hSession)
	ZEND_ARG_INFO(0, hObject)
	ZEND_ARG_INFO(0, Attribute)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11Utils_GetBufferTypeAttribute_Inst, 0, 0, 5)
	ZEND_ARG_OBJ_INFO(0, Module, TElPKCS11Module, 1)
	ZEND_ARG_INFO(0, hSession)
	ZEND_ARG_INFO(0, hObject)
	ZEND_ARG_INFO(0, Attribute)
	ZEND_ARG_TYPE_INFO(0, Def, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11Utils_GetBufferTypeAttribute, 0, 0, 5)
	ZEND_ARG_OBJ_INFO(0, Module, TElPKCS11Module, 1)
	ZEND_ARG_INFO(0, hSession)
	ZEND_ARG_INFO(0, hObject)
	ZEND_ARG_INFO(0, Attribute)
	ZEND_ARG_TYPE_INFO(0, Def, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11Utils_GetBooleanAttribute_Inst, 0, 0, 5)
	ZEND_ARG_OBJ_INFO(0, Module, TElPKCS11Module, 1)
	ZEND_ARG_INFO(0, hSession)
	ZEND_ARG_INFO(0, hObject)
	ZEND_ARG_INFO(0, Attribute)
	ZEND_ARG_INFO(0, Def)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11Utils_GetBooleanAttribute, 0, 0, 5)
	ZEND_ARG_OBJ_INFO(0, Module, TElPKCS11Module, 1)
	ZEND_ARG_INFO(0, hSession)
	ZEND_ARG_INFO(0, hObject)
	ZEND_ARG_INFO(0, Attribute)
	ZEND_ARG_INFO(0, Def)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11Utils_GetULongAttribute_Inst, 0, 0, 5)
	ZEND_ARG_OBJ_INFO(0, Module, TElPKCS11Module, 1)
	ZEND_ARG_INFO(0, hSession)
	ZEND_ARG_INFO(0, hObject)
	ZEND_ARG_INFO(0, Attribute)
	ZEND_ARG_INFO(0, Def)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11Utils_GetULongAttribute, 0, 0, 5)
	ZEND_ARG_OBJ_INFO(0, Module, TElPKCS11Module, 1)
	ZEND_ARG_INFO(0, hSession)
	ZEND_ARG_INFO(0, hObject)
	ZEND_ARG_INFO(0, Attribute)
	ZEND_ARG_INFO(0, Def)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11Utils_GetDateAttribute_Inst, 0, 0, 5)
	ZEND_ARG_OBJ_INFO(0, Module, TElPKCS11Module, 1)
	ZEND_ARG_INFO(0, hSession)
	ZEND_ARG_INFO(0, hObject)
	ZEND_ARG_INFO(0, Attribute)
	ZEND_ARG_OBJ_INFO(0, Def, DateTime, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11Utils_GetDateAttribute, 0, 0, 5)
	ZEND_ARG_OBJ_INFO(0, Module, TElPKCS11Module, 1)
	ZEND_ARG_INFO(0, hSession)
	ZEND_ARG_INFO(0, hObject)
	ZEND_ARG_INFO(0, Attribute)
	ZEND_ARG_OBJ_INFO(0, Def, DateTime, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11Utils_SetObjectAttribute_Inst, 0, 0, 5)
	ZEND_ARG_OBJ_INFO(0, Module, TElPKCS11Module, 1)
	ZEND_ARG_INFO(0, hSession)
	ZEND_ARG_INFO(0, hObject)
	ZEND_ARG_INFO(0, Attribute)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11Utils_SetObjectAttribute, 0, 0, 5)
	ZEND_ARG_OBJ_INFO(0, Module, TElPKCS11Module, 1)
	ZEND_ARG_INFO(0, hSession)
	ZEND_ARG_INFO(0, hObject)
	ZEND_ARG_INFO(0, Attribute)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11Utils_SetBufferTypeAttribute_Inst, 0, 0, 5)
	ZEND_ARG_OBJ_INFO(0, Module, TElPKCS11Module, 1)
	ZEND_ARG_INFO(0, hSession)
	ZEND_ARG_INFO(0, hObject)
	ZEND_ARG_INFO(0, Attribute)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11Utils_SetBufferTypeAttribute, 0, 0, 5)
	ZEND_ARG_OBJ_INFO(0, Module, TElPKCS11Module, 1)
	ZEND_ARG_INFO(0, hSession)
	ZEND_ARG_INFO(0, hObject)
	ZEND_ARG_INFO(0, Attribute)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11Utils_SetBooleanAttribute_Inst, 0, 0, 5)
	ZEND_ARG_OBJ_INFO(0, Module, TElPKCS11Module, 1)
	ZEND_ARG_INFO(0, hSession)
	ZEND_ARG_INFO(0, hObject)
	ZEND_ARG_INFO(0, Attribute)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11Utils_SetBooleanAttribute, 0, 0, 5)
	ZEND_ARG_OBJ_INFO(0, Module, TElPKCS11Module, 1)
	ZEND_ARG_INFO(0, hSession)
	ZEND_ARG_INFO(0, hObject)
	ZEND_ARG_INFO(0, Attribute)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11Utils_SetULongAttribute_Inst, 0, 0, 5)
	ZEND_ARG_OBJ_INFO(0, Module, TElPKCS11Module, 1)
	ZEND_ARG_INFO(0, hSession)
	ZEND_ARG_INFO(0, hObject)
	ZEND_ARG_INFO(0, Attribute)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11Utils_SetULongAttribute, 0, 0, 5)
	ZEND_ARG_OBJ_INFO(0, Module, TElPKCS11Module, 1)
	ZEND_ARG_INFO(0, hSession)
	ZEND_ARG_INFO(0, hObject)
	ZEND_ARG_INFO(0, Attribute)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11Utils_SetDateAttribute_Inst, 0, 0, 5)
	ZEND_ARG_OBJ_INFO(0, Module, TElPKCS11Module, 1)
	ZEND_ARG_INFO(0, hSession)
	ZEND_ARG_INFO(0, hObject)
	ZEND_ARG_INFO(0, Attribute)
	ZEND_ARG_OBJ_INFO(0, Value, DateTime, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11Utils_SetDateAttribute, 0, 0, 5)
	ZEND_ARG_OBJ_INFO(0, Module, TElPKCS11Module, 1)
	ZEND_ARG_INFO(0, hSession)
	ZEND_ARG_INFO(0, hObject)
	ZEND_ARG_INFO(0, Attribute)
	ZEND_ARG_OBJ_INFO(0, Value, DateTime, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11Utils_ConvertPKCS11KeyTypeToSBBKeyType_Inst, 0, 0, 1)
	ZEND_ARG_INFO(0, KeyType)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11Utils_ConvertPKCS11KeyTypeToSBBKeyType, 0, 0, 1)
	ZEND_ARG_INFO(0, KeyType)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11Utils___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElPKCS11Utils_methods[] = {
	PHP_ME(TElPKCS11Utils, GetObjectAttribute_Inst, arginfo_TElPKCS11Utils_GetObjectAttribute_Inst, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11Utils, GetObjectAttribute, arginfo_TElPKCS11Utils_GetObjectAttribute, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElPKCS11Utils, GetBufferTypeAttribute_Inst, arginfo_TElPKCS11Utils_GetBufferTypeAttribute_Inst, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11Utils, GetBufferTypeAttribute, arginfo_TElPKCS11Utils_GetBufferTypeAttribute, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElPKCS11Utils, GetBooleanAttribute_Inst, arginfo_TElPKCS11Utils_GetBooleanAttribute_Inst, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11Utils, GetBooleanAttribute, arginfo_TElPKCS11Utils_GetBooleanAttribute, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElPKCS11Utils, GetULongAttribute_Inst, arginfo_TElPKCS11Utils_GetULongAttribute_Inst, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11Utils, GetULongAttribute, arginfo_TElPKCS11Utils_GetULongAttribute, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElPKCS11Utils, GetDateAttribute_Inst, arginfo_TElPKCS11Utils_GetDateAttribute_Inst, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11Utils, GetDateAttribute, arginfo_TElPKCS11Utils_GetDateAttribute, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElPKCS11Utils, SetObjectAttribute_Inst, arginfo_TElPKCS11Utils_SetObjectAttribute_Inst, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11Utils, SetObjectAttribute, arginfo_TElPKCS11Utils_SetObjectAttribute, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElPKCS11Utils, SetBufferTypeAttribute_Inst, arginfo_TElPKCS11Utils_SetBufferTypeAttribute_Inst, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11Utils, SetBufferTypeAttribute, arginfo_TElPKCS11Utils_SetBufferTypeAttribute, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElPKCS11Utils, SetBooleanAttribute_Inst, arginfo_TElPKCS11Utils_SetBooleanAttribute_Inst, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11Utils, SetBooleanAttribute, arginfo_TElPKCS11Utils_SetBooleanAttribute, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElPKCS11Utils, SetULongAttribute_Inst, arginfo_TElPKCS11Utils_SetULongAttribute_Inst, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11Utils, SetULongAttribute, arginfo_TElPKCS11Utils_SetULongAttribute, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElPKCS11Utils, SetDateAttribute_Inst, arginfo_TElPKCS11Utils_SetDateAttribute_Inst, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11Utils, SetDateAttribute, arginfo_TElPKCS11Utils_SetDateAttribute, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElPKCS11Utils, ConvertPKCS11KeyTypeToSBBKeyType_Inst, arginfo_TElPKCS11Utils_ConvertPKCS11KeyTypeToSBBKeyType_Inst, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11Utils, ConvertPKCS11KeyTypeToSBBKeyType, arginfo_TElPKCS11Utils_ConvertPKCS11KeyTypeToSBBKeyType, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElPKCS11Utils, __construct, arginfo_TElPKCS11Utils___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElPKCS11Utils(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElPKCS11Utils_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElPKCS11Utils", TElPKCS11Utils_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElPKCS11Utils_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElPKCS11NSSParams_ce_ptr = NULL;

SB_PHP_METHOD(TElPKCS11NSSParams, Load)
{
	SBArrayZValInfo aiData;
	zval *zaData;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaData) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaData)) || (IS_ARRAY == Z_TYPE_P(zaData)) || (IS_NULL == Z_TYPE_P(zaData))))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaData, &aiData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPKCS11NSSParams_Load(SBGetObjectHandle(getThis() TSRMLS_CC), aiData.data, aiData.len, &bOutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiData);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11NSSParams, Save)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElPKCS11NSSParams_Save(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-537035344, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11NSSParams, get_ConfigDir)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElPKCS11NSSParams_get_ConfigDir(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(559108837, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11NSSParams, set_ConfigDir)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElPKCS11NSSParams_set_ConfigDir(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11NSSParams, get_CertPrefix)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElPKCS11NSSParams_get_CertPrefix(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-243952163, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11NSSParams, set_CertPrefix)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElPKCS11NSSParams_set_CertPrefix(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11NSSParams, get_KeyPrefix)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElPKCS11NSSParams_get_KeyPrefix(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(489996109, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11NSSParams, set_KeyPrefix)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElPKCS11NSSParams_set_KeyPrefix(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11NSSParams, get_SecMod)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElPKCS11NSSParams_get_SecMod(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1022661132, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11NSSParams, set_SecMod)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElPKCS11NSSParams_set_SecMod(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11NSSParams, get_Flags)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElPKCS11NSSParams_get_Flags(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1519439409, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11NSSParams, set_Flags)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElPKCS11NSSParams_set_Flags(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11NSSParams, get_UseNSSMode)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPKCS11NSSParams_get_UseNSSMode(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11NSSParams, set_UseNSSMode)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElPKCS11NSSParams_set_UseNSSMode(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11NSSParams, get_RawParamsStr)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElPKCS11NSSParams_get_RawParamsStr(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-245271062, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11NSSParams, set_RawParamsStr)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElPKCS11NSSParams_set_RawParamsStr(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11NSSParams, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPKCS11NSSParams_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11NSSParams_Load, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Data, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11NSSParams_Save, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11NSSParams_get_ConfigDir, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11NSSParams_set_ConfigDir, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11NSSParams_get_CertPrefix, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11NSSParams_set_CertPrefix, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11NSSParams_get_KeyPrefix, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11NSSParams_set_KeyPrefix, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11NSSParams_get_SecMod, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11NSSParams_set_SecMod, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11NSSParams_get_Flags, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11NSSParams_set_Flags, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11NSSParams_get_UseNSSMode, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11NSSParams_set_UseNSSMode, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11NSSParams_get_RawParamsStr, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11NSSParams_set_RawParamsStr, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11NSSParams___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElPKCS11NSSParams_methods[] = {
	PHP_ME(TElPKCS11NSSParams, Load, arginfo_TElPKCS11NSSParams_Load, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11NSSParams, Save, arginfo_TElPKCS11NSSParams_Save, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11NSSParams, get_ConfigDir, arginfo_TElPKCS11NSSParams_get_ConfigDir, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11NSSParams, set_ConfigDir, arginfo_TElPKCS11NSSParams_set_ConfigDir, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11NSSParams, get_CertPrefix, arginfo_TElPKCS11NSSParams_get_CertPrefix, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11NSSParams, set_CertPrefix, arginfo_TElPKCS11NSSParams_set_CertPrefix, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11NSSParams, get_KeyPrefix, arginfo_TElPKCS11NSSParams_get_KeyPrefix, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11NSSParams, set_KeyPrefix, arginfo_TElPKCS11NSSParams_set_KeyPrefix, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11NSSParams, get_SecMod, arginfo_TElPKCS11NSSParams_get_SecMod, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11NSSParams, set_SecMod, arginfo_TElPKCS11NSSParams_set_SecMod, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11NSSParams, get_Flags, arginfo_TElPKCS11NSSParams_get_Flags, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11NSSParams, set_Flags, arginfo_TElPKCS11NSSParams_set_Flags, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11NSSParams, get_UseNSSMode, arginfo_TElPKCS11NSSParams_get_UseNSSMode, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11NSSParams, set_UseNSSMode, arginfo_TElPKCS11NSSParams_set_UseNSSMode, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11NSSParams, get_RawParamsStr, arginfo_TElPKCS11NSSParams_get_RawParamsStr, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11NSSParams, set_RawParamsStr, arginfo_TElPKCS11NSSParams_set_RawParamsStr, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11NSSParams, __construct, arginfo_TElPKCS11NSSParams___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElPKCS11NSSParams(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElPKCS11NSSParams_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElPKCS11NSSParams", TElPKCS11NSSParams_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElPKCS11NSSParams_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElPKCS11ModuleList_ce_ptr = NULL;

SB_PHP_METHOD(TElPKCS11ModuleList, LoadModule)
{
	char *sModuleName;
	int sModuleName_len;
	zend_bool bAutoRefreshSlotInfo;
	zend_bool bNoImplicitSlotInfoUpdates;
	zend_bool bOnDemandMode;
	zend_bool bPreserveSettingsIfExists;
	zend_bool bTrySingleThreadedMode;
	zend_bool bUseSystemProcAddresses;
	zval *oNSSParams;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sbbb", &sModuleName, &sModuleName_len, &bUseSystemProcAddresses, &bTrySingleThreadedMode, &bAutoRefreshSlotInfo) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPKCS11ModuleList_LoadModule(SBGetObjectHandle(getThis() TSRMLS_CC), sModuleName, (int32_t)sModuleName_len, (int8_t)bUseSystemProcAddresses, (int8_t)bTrySingleThreadedMode, (int8_t)bAutoRefreshSlotInfo, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElPKCS11Module_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sbbbb", &sModuleName, &sModuleName_len, &bUseSystemProcAddresses, &bTrySingleThreadedMode, &bAutoRefreshSlotInfo, &bPreserveSettingsIfExists) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPKCS11ModuleList_LoadModule_1(SBGetObjectHandle(getThis() TSRMLS_CC), sModuleName, (int32_t)sModuleName_len, (int8_t)bUseSystemProcAddresses, (int8_t)bTrySingleThreadedMode, (int8_t)bAutoRefreshSlotInfo, (int8_t)bPreserveSettingsIfExists, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElPKCS11Module_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sbbbbb", &sModuleName, &sModuleName_len, &bUseSystemProcAddresses, &bTrySingleThreadedMode, &bAutoRefreshSlotInfo, &bPreserveSettingsIfExists, &bOnDemandMode) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPKCS11ModuleList_LoadModule_2(SBGetObjectHandle(getThis() TSRMLS_CC), sModuleName, (int32_t)sModuleName_len, (int8_t)bUseSystemProcAddresses, (int8_t)bTrySingleThreadedMode, (int8_t)bAutoRefreshSlotInfo, (int8_t)bPreserveSettingsIfExists, (int8_t)bOnDemandMode, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElPKCS11Module_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sbbbbbO!b", &sModuleName, &sModuleName_len, &bUseSystemProcAddresses, &bTrySingleThreadedMode, &bAutoRefreshSlotInfo, &bPreserveSettingsIfExists, &bOnDemandMode, &oNSSParams, TElPKCS11NSSParams_ce_ptr, &bNoImplicitSlotInfoUpdates) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPKCS11ModuleList_LoadModule_3(SBGetObjectHandle(getThis() TSRMLS_CC), sModuleName, (int32_t)sModuleName_len, (int8_t)bUseSystemProcAddresses, (int8_t)bTrySingleThreadedMode, (int8_t)bAutoRefreshSlotInfo, (int8_t)bPreserveSettingsIfExists, (int8_t)bOnDemandMode, SBGetObjectHandle(oNSSParams TSRMLS_CC), (int8_t)bNoImplicitSlotInfoUpdates, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElPKCS11Module_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, bool, bool, bool) or (string, bool, bool, bool, bool) or (string, bool, bool, bool, bool, bool) or (string, bool, bool, bool, bool, bool, TElPKCS11NSSParams, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11ModuleList, UnloadModule)
{
	zval *oaModule;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oaModule, TElPKCS11Module_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPKCS11ModuleList_UnloadModule(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oaModule TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElPKCS11Module)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11ModuleList, get_ModuleCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPKCS11ModuleList_get_ModuleCount(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11ModuleList, get_Modules)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPKCS11ModuleList_get_Modules(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElPKCS11Module_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11ModuleList, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPKCS11ModuleList_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11ModuleList_LoadModule, 0, 0, 4)
	ZEND_ARG_INFO(0, ModuleName)
	ZEND_ARG_INFO(0, UseSystemProcAddresses)
	ZEND_ARG_INFO(0, TrySingleThreadedMode)
	ZEND_ARG_INFO(0, AutoRefreshSlotInfo)
	ZEND_ARG_INFO(0, PreserveSettingsIfExists)
	ZEND_ARG_INFO(0, OnDemandMode)
	ZEND_ARG_OBJ_INFO(0, NSSParams, TElPKCS11NSSParams, 1)
	ZEND_ARG_INFO(0, NoImplicitSlotInfoUpdates)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11ModuleList_UnloadModule, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, aModule, TElPKCS11Module, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11ModuleList_get_ModuleCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11ModuleList_get_Modules, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11ModuleList___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElPKCS11ModuleList_methods[] = {
	PHP_ME(TElPKCS11ModuleList, LoadModule, arginfo_TElPKCS11ModuleList_LoadModule, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11ModuleList, UnloadModule, arginfo_TElPKCS11ModuleList_UnloadModule, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11ModuleList, get_ModuleCount, arginfo_TElPKCS11ModuleList_get_ModuleCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11ModuleList, get_Modules, arginfo_TElPKCS11ModuleList_get_Modules, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11ModuleList, __construct, arginfo_TElPKCS11ModuleList___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElPKCS11ModuleList(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElPKCS11ModuleList_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElPKCS11ModuleList", TElPKCS11ModuleList_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElPKCS11ModuleList_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElPKCS11AlgorithmInfo_ce_ptr = NULL;

SB_PHP_METHOD(TElPKCS11AlgorithmInfo, get_Algorithm)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPKCS11AlgorithmInfo_get_Algorithm(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11AlgorithmInfo, get_Mode)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPKCS11AlgorithmInfo_get_Mode(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11AlgorithmInfo, get_Mechanism)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
#ifdef SB_NOT_CPU64_OR_WINDOWS
		uint32_t u4OutResultRaw = 0;
		SBCheckError(TElPKCS11AlgorithmInfo_get_Mechanism(SBGetObjectHandle(getThis() TSRMLS_CC), &u4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
#else
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElPKCS11AlgorithmInfo_get_Mechanism(SBGetObjectHandle(getThis() TSRMLS_CC), &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
#endif
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11AlgorithmInfo, get_KeyMechanism)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
#ifdef SB_NOT_CPU64_OR_WINDOWS
		uint32_t u4OutResultRaw = 0;
		SBCheckError(TElPKCS11AlgorithmInfo_get_KeyMechanism(SBGetObjectHandle(getThis() TSRMLS_CC), &u4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
#else
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElPKCS11AlgorithmInfo_get_KeyMechanism(SBGetObjectHandle(getThis() TSRMLS_CC), &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
#endif
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11AlgorithmInfo, get_PaddingUsed)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPKCS11AlgorithmInfo_get_PaddingUsed(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11AlgorithmInfo, get_CanGenerate)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPKCS11AlgorithmInfo_get_CanGenerate(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11AlgorithmInfo, get_CanEncrypt)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPKCS11AlgorithmInfo_get_CanEncrypt(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11AlgorithmInfo, get_CanSign)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPKCS11AlgorithmInfo_get_CanSign(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11AlgorithmInfo, get_CanSignRecover)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPKCS11AlgorithmInfo_get_CanSignRecover(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11AlgorithmInfo, get_CanDigest)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPKCS11AlgorithmInfo_get_CanDigest(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11AlgorithmInfo, get_CanWrap)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPKCS11AlgorithmInfo_get_CanWrap(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11AlgorithmInfo, get_CanDerive)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPKCS11AlgorithmInfo_get_CanDerive(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11AlgorithmInfo, get_SignHashAlgorithm)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPKCS11AlgorithmInfo_get_SignHashAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11AlgorithmInfo, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPKCS11AlgorithmInfo_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11AlgorithmInfo_get_Algorithm, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11AlgorithmInfo_get_Mode, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11AlgorithmInfo_get_Mechanism, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11AlgorithmInfo_get_KeyMechanism, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11AlgorithmInfo_get_PaddingUsed, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11AlgorithmInfo_get_CanGenerate, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11AlgorithmInfo_get_CanEncrypt, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11AlgorithmInfo_get_CanSign, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11AlgorithmInfo_get_CanSignRecover, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11AlgorithmInfo_get_CanDigest, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11AlgorithmInfo_get_CanWrap, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11AlgorithmInfo_get_CanDerive, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11AlgorithmInfo_get_SignHashAlgorithm, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11AlgorithmInfo___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElPKCS11AlgorithmInfo_methods[] = {
	PHP_ME(TElPKCS11AlgorithmInfo, get_Algorithm, arginfo_TElPKCS11AlgorithmInfo_get_Algorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11AlgorithmInfo, get_Mode, arginfo_TElPKCS11AlgorithmInfo_get_Mode, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11AlgorithmInfo, get_Mechanism, arginfo_TElPKCS11AlgorithmInfo_get_Mechanism, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11AlgorithmInfo, get_KeyMechanism, arginfo_TElPKCS11AlgorithmInfo_get_KeyMechanism, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11AlgorithmInfo, get_PaddingUsed, arginfo_TElPKCS11AlgorithmInfo_get_PaddingUsed, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11AlgorithmInfo, get_CanGenerate, arginfo_TElPKCS11AlgorithmInfo_get_CanGenerate, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11AlgorithmInfo, get_CanEncrypt, arginfo_TElPKCS11AlgorithmInfo_get_CanEncrypt, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11AlgorithmInfo, get_CanSign, arginfo_TElPKCS11AlgorithmInfo_get_CanSign, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11AlgorithmInfo, get_CanSignRecover, arginfo_TElPKCS11AlgorithmInfo_get_CanSignRecover, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11AlgorithmInfo, get_CanDigest, arginfo_TElPKCS11AlgorithmInfo_get_CanDigest, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11AlgorithmInfo, get_CanWrap, arginfo_TElPKCS11AlgorithmInfo_get_CanWrap, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11AlgorithmInfo, get_CanDerive, arginfo_TElPKCS11AlgorithmInfo_get_CanDerive, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11AlgorithmInfo, get_SignHashAlgorithm, arginfo_TElPKCS11AlgorithmInfo_get_SignHashAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11AlgorithmInfo, __construct, arginfo_TElPKCS11AlgorithmInfo___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElPKCS11AlgorithmInfo(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElPKCS11AlgorithmInfo_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElPKCS11AlgorithmInfo", TElPKCS11AlgorithmInfo_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElPKCS11AlgorithmInfo_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElPKCS11AlgorithmConverter_ce_ptr = NULL;

SB_PHP_METHOD(TElPKCS11AlgorithmConverter, Find)
{
	long l4Algorithm;
	long l4Mode;
	long l4Operation;
	zend_bool bPaddingUsed;
	zval *oInfos;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lllb", &l4Algorithm, &l4Mode, &l4Operation, &bPaddingUsed) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPKCS11AlgorithmConverter_Find(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Algorithm, (int32_t)l4Mode, (int32_t)l4Operation, (int8_t)bPaddingUsed, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "llO!", &l4Algorithm, &l4Mode, &oInfos, TList_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPKCS11AlgorithmConverter_Find_1(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Algorithm, (int32_t)l4Mode, SBGetObjectHandle(oInfos TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer, integer, bool) or (integer, integer, TList)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11AlgorithmConverter, FindSignatureAlgorithmInfo)
{
	long l4Algorithm;
	long l4HashAlgorithm;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &l4Algorithm, &l4HashAlgorithm) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPKCS11AlgorithmConverter_FindSignatureAlgorithmInfo(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Algorithm, (int32_t)l4HashAlgorithm, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11AlgorithmConverter, GetAlgorithmByPKCS11Mechanism)
{
	int32_t l4ModeRaw;
	int8_t bGenRaw;
#ifdef SB_NOT_CPU64_OR_WINDOWS
	long u4Mech;
#else
	long l8Mech;
#endif
	zval *zbGen;
	zval *zl4Mode;
#ifdef SB_NOT_CPU64_OR_WINDOWS
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lzz", &u4Mech, &zl4Mode, &zbGen) == SUCCESS) && PZVAL_IS_REF(zl4Mode) && (IS_LONG == Z_TYPE_P(zl4Mode)) && PZVAL_IS_REF(zbGen) && (IS_BOOL == Z_TYPE_P(zbGen)))
#else
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lzz", &l8Mech, &zl4Mode, &zbGen) == SUCCESS) && PZVAL_IS_REF(zl4Mode) && (IS_LONG == Z_TYPE_P(zl4Mode)) && PZVAL_IS_REF(zbGen) && (IS_BOOL == Z_TYPE_P(zbGen)))
#endif
	{
		int32_t l4OutResultRaw = 0;
		l4ModeRaw = (int32_t)Z_LVAL_P(zl4Mode);
		bGenRaw = (int8_t)Z_BVAL_P(zbGen);
#ifdef SB_NOT_CPU64_OR_WINDOWS
		SBCheckError(TElPKCS11AlgorithmConverter_GetAlgorithmByPKCS11Mechanism(SBGetObjectHandle(getThis() TSRMLS_CC), (uint32_t)u4Mech, &l4ModeRaw, &bGenRaw, &l4OutResultRaw) TSRMLS_CC);
#else
		SBCheckError(TElPKCS11AlgorithmConverter_GetAlgorithmByPKCS11Mechanism(SBGetObjectHandle(getThis() TSRMLS_CC), (int64_t)l8Mech, &l4ModeRaw, &bGenRaw, &l4OutResultRaw) TSRMLS_CC);
#endif
		ZVAL_LONG(zl4Mode, (long)l4ModeRaw);
		ZVAL_BOOL(zbGen, (zend_bool)bGenRaw);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer, &integer, &bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11AlgorithmConverter, GetPKCS11MechanismByAlgorithm)
{
	long l4Algorithm;
	long l4Mode;
	zval *oMech;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "llO", &l4Algorithm, &l4Mode, &oMech, SB_CK_MECHANISM_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oMech))
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPKCS11AlgorithmConverter_GetPKCS11MechanismByAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Algorithm, (int32_t)l4Mode, (SB_CK_MECHANISM *)SBGetStructPointer(oMech TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer, &SB_CK_MECHANISM)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11AlgorithmConverter, get_AlgorithmInfos)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPKCS11AlgorithmConverter_get_AlgorithmInfos(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElPKCS11AlgorithmInfo_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11AlgorithmConverter, get_AlgorithmInfoCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPKCS11AlgorithmConverter_get_AlgorithmInfoCount(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11AlgorithmConverter, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPKCS11AlgorithmConverter_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11AlgorithmConverter_Find, 0, 0, 3)
	ZEND_ARG_INFO(0, Algorithm)
	ZEND_ARG_INFO(0, Mode)
	ZEND_ARG_TYPE_INFO(0, Operation_or_Infos, 0, 1)
	ZEND_ARG_INFO(0, PaddingUsed)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11AlgorithmConverter_FindSignatureAlgorithmInfo, 0, 0, 2)
	ZEND_ARG_INFO(0, Algorithm)
	ZEND_ARG_INFO(0, HashAlgorithm)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11AlgorithmConverter_GetAlgorithmByPKCS11Mechanism, 0, 0, 3)
	ZEND_ARG_INFO(0, Mech)
	ZEND_ARG_INFO(1, Mode)
	ZEND_ARG_INFO(1, Gen)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11AlgorithmConverter_GetPKCS11MechanismByAlgorithm, 0, 0, 3)
	ZEND_ARG_INFO(0, Algorithm)
	ZEND_ARG_INFO(0, Mode)
	ZEND_ARG_OBJ_INFO(1, Mech, SB_CK_MECHANISM, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11AlgorithmConverter_get_AlgorithmInfos, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11AlgorithmConverter_get_AlgorithmInfoCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11AlgorithmConverter___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElPKCS11AlgorithmConverter_methods[] = {
	PHP_ME(TElPKCS11AlgorithmConverter, Find, arginfo_TElPKCS11AlgorithmConverter_Find, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11AlgorithmConverter, FindSignatureAlgorithmInfo, arginfo_TElPKCS11AlgorithmConverter_FindSignatureAlgorithmInfo, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11AlgorithmConverter, GetAlgorithmByPKCS11Mechanism, arginfo_TElPKCS11AlgorithmConverter_GetAlgorithmByPKCS11Mechanism, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11AlgorithmConverter, GetPKCS11MechanismByAlgorithm, arginfo_TElPKCS11AlgorithmConverter_GetPKCS11MechanismByAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11AlgorithmConverter, get_AlgorithmInfos, arginfo_TElPKCS11AlgorithmConverter_get_AlgorithmInfos, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11AlgorithmConverter, get_AlgorithmInfoCount, arginfo_TElPKCS11AlgorithmConverter_get_AlgorithmInfoCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11AlgorithmConverter, __construct, arginfo_TElPKCS11AlgorithmConverter___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElPKCS11AlgorithmConverter(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElPKCS11AlgorithmConverter_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElPKCS11AlgorithmConverter", TElPKCS11AlgorithmConverter_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElPKCS11AlgorithmConverter_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElSlotEventMonitoringThread_ce_ptr = NULL;

SB_PHP_METHOD(TElSlotEventMonitoringThread, get_OnSlotEvent)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElSlotEventMonitoringThreadEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSlotEventMonitoringThread_get_OnSlotEvent(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSlotEventMonitoringThread, set_OnSlotEvent)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSlotEventMonitoringThread_set_OnSlotEvent(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TElSlotEventMonitoringThreadEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSlotEventMonitoringThreadEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSlotEventMonitoringThread, __construct)
{
	long l4Delay;
	zend_bool bSynchronizeGUI;
	zend_bool bUseGetSlotInfo;
	zval *oPKCS11Module;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!bbl", &oPKCS11Module, TElPKCS11Module_ce_ptr, &bSynchronizeGUI, &bUseGetSlotInfo, &l4Delay) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSlotEventMonitoringThread_Create(SBGetObjectHandle(oPKCS11Module TSRMLS_CC), (int8_t)bSynchronizeGUI, (int8_t)bUseGetSlotInfo, (int32_t)l4Delay, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElPKCS11Module, bool, bool, integer)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSlotEventMonitoringThread_get_OnSlotEvent, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSlotEventMonitoringThread_set_OnSlotEvent, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSlotEventMonitoringThread___construct, 0, 0, 4)
	ZEND_ARG_OBJ_INFO(0, PKCS11Module, TElPKCS11Module, 1)
	ZEND_ARG_INFO(0, SynchronizeGUI)
	ZEND_ARG_INFO(0, UseGetSlotInfo)
	ZEND_ARG_INFO(0, Delay)
ZEND_END_ARG_INFO()

static zend_function_entry TElSlotEventMonitoringThread_methods[] = {
	PHP_ME(TElSlotEventMonitoringThread, get_OnSlotEvent, arginfo_TElSlotEventMonitoringThread_get_OnSlotEvent, ZEND_ACC_PUBLIC)
	PHP_ME(TElSlotEventMonitoringThread, set_OnSlotEvent, arginfo_TElSlotEventMonitoringThread_set_OnSlotEvent, ZEND_ACC_PUBLIC)
	PHP_ME(TElSlotEventMonitoringThread, __construct, arginfo_TElSlotEventMonitoringThread___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSlotEventMonitoringThread(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSlotEventMonitoringThread_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSlotEventMonitoringThread", TElSlotEventMonitoringThread_methods);
	if (NULL == TThread_ce_ptr)
		Register_TThread(TSRMLS_C);
	TElSlotEventMonitoringThread_ce_ptr = zend_register_internal_class_ex(&ce, TThread_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_FUNCTION(SBPKCS11Base, PKCS11AlgorithmConverter)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(SBPKCS11Base_PKCS11AlgorithmConverter(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElPKCS11AlgorithmConverter_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBPKCS11Base, CreateMutexCallback)
{
	SBArrayZValInfo piMutexPtr;
	zval *zpMutexPtr;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zpMutexPtr) == SUCCESS) && ((PZVAL_IS_REF(zpMutexPtr) && ((IS_STRING == Z_TYPE_P(zpMutexPtr)) || (IS_ARRAY == Z_TYPE_P(zpMutexPtr)))) || ((IS_OBJECT == Z_TYPE_P(zpMutexPtr)) && (Z_OBJCE_P(zpMutexPtr) == TSBPointer_ce_ptr))))
	{
#ifdef SB_NOT_CPU64_OR_WINDOWS
		uint32_t u4OutResultRaw = 0;
#else
		int64_t l8OutResultRaw = 0;
#endif
		if (!SBGetPointerFromZVal(zpMutexPtr, &piMutexPtr TSRMLS_CC)) RETURN_FALSE;
#ifdef SB_NOT_CPU64_OR_WINDOWS
		SBCheckError(SBPKCS11Base_CreateMutexCallback(&piMutexPtr.data, &u4OutResultRaw) TSRMLS_CC);
#else
		SBCheckError(SBPKCS11Base_CreateMutexCallback(&piMutexPtr.data, &l8OutResultRaw) TSRMLS_CC);
#endif
		SBSetPointerToZVal(&piMutexPtr, zpMutexPtr);
#ifdef SB_NOT_CPU64_OR_WINDOWS
		RETURN_LONG((long)u4OutResultRaw);
#else
		RETURN_LONG((long)l8OutResultRaw);
#endif
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBPKCS11Base, DestroyMutexCallback)
{
	SBArrayZValInfo piMutexPtr;
	zval *zpMutexPtr;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zpMutexPtr) == SUCCESS) && ((Z_TYPE_P(zpMutexPtr) == IS_STRING) || (Z_TYPE_P(zpMutexPtr) == IS_ARRAY) || (Z_TYPE_P(zpMutexPtr) == IS_NULL) || ((Z_TYPE_P(zpMutexPtr) == IS_OBJECT) && (Z_OBJCE_P(zpMutexPtr) == TSBPointer_ce_ptr))))
	{
#ifdef SB_NOT_CPU64_OR_WINDOWS
		uint32_t u4OutResultRaw = 0;
#else
		int64_t l8OutResultRaw = 0;
#endif
		if (!SBGetPointerFromZVal(zpMutexPtr, &piMutexPtr TSRMLS_CC)) RETURN_FALSE;
#ifdef SB_NOT_CPU64_OR_WINDOWS
		SBCheckError(SBPKCS11Base_DestroyMutexCallback(piMutexPtr.data, &u4OutResultRaw) TSRMLS_CC);
#else
		SBCheckError(SBPKCS11Base_DestroyMutexCallback(piMutexPtr.data, &l8OutResultRaw) TSRMLS_CC);
#endif
		SBFreePointerZValInfo(&piMutexPtr);
#ifdef SB_NOT_CPU64_OR_WINDOWS
		RETURN_LONG((long)u4OutResultRaw);
#else
		RETURN_LONG((long)l8OutResultRaw);
#endif
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBPKCS11Base, LockMutexCallback)
{
	SBArrayZValInfo piMutexPtr;
	zval *zpMutexPtr;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zpMutexPtr) == SUCCESS) && ((Z_TYPE_P(zpMutexPtr) == IS_STRING) || (Z_TYPE_P(zpMutexPtr) == IS_ARRAY) || (Z_TYPE_P(zpMutexPtr) == IS_NULL) || ((Z_TYPE_P(zpMutexPtr) == IS_OBJECT) && (Z_OBJCE_P(zpMutexPtr) == TSBPointer_ce_ptr))))
	{
#ifdef SB_NOT_CPU64_OR_WINDOWS
		uint32_t u4OutResultRaw = 0;
#else
		int64_t l8OutResultRaw = 0;
#endif
		if (!SBGetPointerFromZVal(zpMutexPtr, &piMutexPtr TSRMLS_CC)) RETURN_FALSE;
#ifdef SB_NOT_CPU64_OR_WINDOWS
		SBCheckError(SBPKCS11Base_LockMutexCallback(piMutexPtr.data, &u4OutResultRaw) TSRMLS_CC);
#else
		SBCheckError(SBPKCS11Base_LockMutexCallback(piMutexPtr.data, &l8OutResultRaw) TSRMLS_CC);
#endif
		SBFreePointerZValInfo(&piMutexPtr);
#ifdef SB_NOT_CPU64_OR_WINDOWS
		RETURN_LONG((long)u4OutResultRaw);
#else
		RETURN_LONG((long)l8OutResultRaw);
#endif
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBPKCS11Base, UnlockMutexCallback)
{
	SBArrayZValInfo piMutexPtr;
	zval *zpMutexPtr;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zpMutexPtr) == SUCCESS) && ((Z_TYPE_P(zpMutexPtr) == IS_STRING) || (Z_TYPE_P(zpMutexPtr) == IS_ARRAY) || (Z_TYPE_P(zpMutexPtr) == IS_NULL) || ((Z_TYPE_P(zpMutexPtr) == IS_OBJECT) && (Z_OBJCE_P(zpMutexPtr) == TSBPointer_ce_ptr))))
	{
#ifdef SB_NOT_CPU64_OR_WINDOWS
		uint32_t u4OutResultRaw = 0;
#else
		int64_t l8OutResultRaw = 0;
#endif
		if (!SBGetPointerFromZVal(zpMutexPtr, &piMutexPtr TSRMLS_CC)) RETURN_FALSE;
#ifdef SB_NOT_CPU64_OR_WINDOWS
		SBCheckError(SBPKCS11Base_UnlockMutexCallback(piMutexPtr.data, &u4OutResultRaw) TSRMLS_CC);
#else
		SBCheckError(SBPKCS11Base_UnlockMutexCallback(piMutexPtr.data, &l8OutResultRaw) TSRMLS_CC);
#endif
		SBFreePointerZValInfo(&piMutexPtr);
#ifdef SB_NOT_CPU64_OR_WINDOWS
		RETURN_LONG((long)u4OutResultRaw);
#else
		RETURN_LONG((long)l8OutResultRaw);
#endif
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBPKCS11Base, GetPKCS11String)
{
	long l4MaxLength;
	SBArrayZValInfo aiBuffer;
	uint32_t _err;
	zval *zaBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zaBuffer, &l4MaxLength) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaBuffer)) || (IS_ARRAY == Z_TYPE_P(zaBuffer)) || (IS_NULL == Z_TYPE_P(zaBuffer))))
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		if (!SBGetByteArrayFromZVal(zaBuffer, &aiBuffer TSRMLS_CC)) RETURN_FALSE;
		_err = SBPKCS11Base_GetPKCS11String(aiBuffer.data, aiBuffer.len, (int32_t)l4MaxLength, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(757867836, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiBuffer);
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBPKCS11Base, PKCS11CheckError)
{
	long l4FunctionCode;
#ifdef SB_NOT_CPU64_OR_WINDOWS
	long u4ResultCode;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &l4FunctionCode, &u4ResultCode) == SUCCESS)
#else
	long l8ResultCode;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &l4FunctionCode, &l8ResultCode) == SUCCESS)
#endif
	{
#ifdef SB_NOT_CPU64_OR_WINDOWS
		SBCheckError(SBPKCS11Base_PKCS11CheckError((int32_t)l4FunctionCode, (uint32_t)u4ResultCode) TSRMLS_CC);
#else
		SBCheckError(SBPKCS11Base_PKCS11CheckError((int32_t)l4FunctionCode, (int64_t)l8ResultCode) TSRMLS_CC);
#endif
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBPKCS11Base, GetPKCS11ErrorNameByCode)
{
#ifdef SB_NOT_CPU64_OR_WINDOWS
	long u4Code;
#else
	long l8Code;
#endif
	uint32_t _err;
#ifdef SB_NOT_CPU64_OR_WINDOWS
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u4Code) == SUCCESS)
#else
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l8Code) == SUCCESS)
#endif
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
#ifdef SB_NOT_CPU64_OR_WINDOWS
		_err = SBPKCS11Base_GetPKCS11ErrorNameByCode((uint32_t)u4Code, sOutResult, &sOutResult_len);
#else
		_err = SBPKCS11Base_GetPKCS11ErrorNameByCode((int64_t)l8Code, sOutResult, &sOutResult_len);
#endif
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
#ifdef SB_NOT_CPU64_OR_WINDOWS
			SBCheckError(SBGetLastReturnStringA(-857256447, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(-75695820, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
#endif
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBPKCS11Base, EncodeErrorInfo)
{
	char *sErrorClassName;
	char *sErrorStr;
	char *sMethodName;
	int sErrorClassName_len;
	int sErrorStr_len;
	int sMethodName_len;
	int32_t l4SizeRaw;
	SBArrayZValInfo piBuffer;
	zval *zl4Size;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssszz", &sMethodName, &sMethodName_len, &sErrorStr, &sErrorStr_len, &sErrorClassName, &sErrorClassName_len, &zpBuffer, &zl4Size) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4Size) && (IS_LONG == Z_TYPE_P(zl4Size)))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		l4SizeRaw = (int32_t)Z_LVAL_P(zl4Size);
		SBCheckError(SBPKCS11Base_EncodeErrorInfo(sMethodName, (int32_t)sMethodName_len, sErrorStr, (int32_t)sErrorStr_len, sErrorClassName, (int32_t)sErrorClassName_len, piBuffer.data, &l4SizeRaw, &bOutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
		ZVAL_LONG(zl4Size, (long)l4SizeRaw);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string, string, string, TSBPointer|array of byte|string|NULL, &integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBPKCS11Base, GetPKCS11ModuleList)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(SBPKCS11Base_GetPKCS11ModuleList(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElPKCS11ModuleList_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

void Register_SBPKCS11Base_Constants(int module_number TSRMLS_DC)
{
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Base, SB_TOKEN_PROP_FIRST, SB_TOKEN_PROP_FIRST, SB_TOKEN_PROP_FIRST);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Base, SB_TOKEN_PROP_TOKEN_ATTR_UNSUPPORTED, SB_TOKEN_PROP_TOKEN_ATTR_UNSUPPORTED, SB_TOKEN_PROP_TOKEN_ATTR_UNSUPPORTED);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Base, SB_TOKEN_PROP_REQUIRES_KEYS_TO_BE_ADDED_PRIOR_TO_CERTS, SB_TOKEN_PROP_REQUIRES_KEYS_TO_BE_ADDED_PRIOR_TO_CERTS, SB_TOKEN_PROP_REQUIRES_KEYS_TO_BE_ADDED_PRIOR_TO_CERTS);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Base, SB_TOKEN_PROP_REQUIRES_SENSITIVE_FLAG_FOR_PRIVATE_KEY, SB_TOKEN_PROP_REQUIRES_SENSITIVE_FLAG_FOR_PRIVATE_KEY, SB_TOKEN_PROP_REQUIRES_SENSITIVE_FLAG_FOR_PRIVATE_KEY);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Base, SB_TOKEN_PROP_REQUIRES_EXTRACTABLE_FLAG_FOR_PRIVATE_KEY, SB_TOKEN_PROP_REQUIRES_EXTRACTABLE_FLAG_FOR_PRIVATE_KEY, SB_TOKEN_PROP_REQUIRES_EXTRACTABLE_FLAG_FOR_PRIVATE_KEY);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Base, SB_TOKEN_PROP_SUPPORTS_MODIFIABLE_FLAG_FOR_OBJECTS, SB_TOKEN_PROP_SUPPORTS_MODIFIABLE_FLAG_FOR_OBJECTS, SB_TOKEN_PROP_SUPPORTS_MODIFIABLE_FLAG_FOR_OBJECTS);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Base, SB_TOKEN_PROP_LAST, SB_TOKEN_PROP_LAST, SB_TOKEN_PROP_LAST);
	SB_REGISTER_LONG_CONSTANT(SBPKCS11Base, SB_PKCS11_ON_DEMAND_SESSION_HANDLE_START, SB_PKCS11_ON_DEMAND_SESSION_HANDLE_START, SB_PKCS11_ON_DEMAND_SESSION_HANDLE_START);
	SB_REGISTER_STRING_CONSTANT(SBPKCS11Base, SPKCS11ProviderNotOpened, SB_SPKCS11ProviderNotOpened, SB_SPKCS11ProviderNotOpened);
	SB_REGISTER_STRING_CONSTANT(SBPKCS11Base, SNoPKCS11ProviderSpecified, SB_SNoPKCS11ProviderSpecified, SB_SNoPKCS11ProviderSpecified);
	SB_REGISTER_STRING_CONSTANT(SBPKCS11Base, SPKCS11ProviderNoFunctions, SB_SPKCS11ProviderNoFunctions, SB_SPKCS11ProviderNoFunctions);
	SB_REGISTER_STRING_CONSTANT(SBPKCS11Base, SPKCS11ProviderNotFound, SB_SPKCS11ProviderNotFound, SB_SPKCS11ProviderNotFound);
	SB_REGISTER_STRING_CONSTANT(SBPKCS11Base, SPKCS11ProviderError, SB_SPKCS11ProviderError, SB_SPKCS11ProviderError);
	SB_REGISTER_STRING_CONSTANT(SBPKCS11Base, SPKCS11Error, SB_SPKCS11Error, SB_SPKCS11Error);
	SB_REGISTER_STRING_CONSTANT(SBPKCS11Base, SPKCS11FunctionError, SB_SPKCS11FunctionError, SB_SPKCS11FunctionError);
	SB_REGISTER_STRING_CONSTANT(SBPKCS11Base, SPKCS11FunctionErrorStr, SB_SPKCS11FunctionErrorStr, SB_SPKCS11FunctionErrorStr);
	SB_REGISTER_STRING_CONSTANT(SBPKCS11Base, SAlgorithmDoesNotSupportEncryption, SB_SAlgorithmDoesNotSupportEncryption, SB_SAlgorithmDoesNotSupportEncryption);
	SB_REGISTER_STRING_CONSTANT(SBPKCS11Base, SAlgorithmDoesNotSupportSigning, SB_SAlgorithmDoesNotSupportSigning, SB_SAlgorithmDoesNotSupportSigning);
	SB_REGISTER_STRING_CONSTANT(SBPKCS11Base, SNotPKCS11Certificate, SB_SNotPKCS11Certificate, SB_SNotPKCS11Certificate);
	SB_REGISTER_STRING_CONSTANT(SBPKCS11Base, SObjectDoesNotBelongToSession, SB_SObjectDoesNotBelongToSession, SB_SObjectDoesNotBelongToSession);
	SB_REGISTER_STRING_CONSTANT(SBPKCS11Base, SUnsupportedObjectType, SB_SUnsupportedObjectType, SB_SUnsupportedObjectType);
	SB_REGISTER_STRING_CONSTANT(SBPKCS11Base, SObjectNotFound, SB_SObjectNotFound, SB_SObjectNotFound);
	SB_REGISTER_STRING_CONSTANT(SBPKCS11Base, SNumberOfSlotsChanged, SB_SNumberOfSlotsChanged, SB_SNumberOfSlotsChanged);
	SB_REGISTER_STRING_CONSTANT(SBPKCS11Base, SNotInOnDemandMode, SB_SNotInOnDemandMode, SB_SNotInOnDemandMode);
	SB_REGISTER_STRING_CONSTANT(SBPKCS11Base, SOnlyOneSessionAllowedInOnDemandMode, SB_SOnlyOneSessionAllowedInOnDemandMode, SB_SOnlyOneSessionAllowedInOnDemandMode);
	SB_REGISTER_STRING_CONSTANT(SBPKCS11Base, SAlreadyLoggedIn, SB_SAlreadyLoggedIn, SB_SAlreadyLoggedIn);
	SB_REGISTER_STRING_CONSTANT(SBPKCS11Base, SNotLoggedIn, SB_SNotLoggedIn, SB_SNotLoggedIn);
	SB_REGISTER_STRING_CONSTANT(SBPKCS11Base, SReadOnlySessionsOnlyAllowedInOnDemandMode, SB_SReadOnlySessionsOnlyAllowedInOnDemandMode, SB_SReadOnlySessionsOnlyAllowedInOnDemandMode);
	SB_REGISTER_STRING_CONSTANT(SBPKCS11Base, SUpdateFailedObjectsChanged, SB_SUpdateFailedObjectsChanged, SB_SUpdateFailedObjectsChanged);
}

void Register_SBPKCS11Base_Enum_Flags(TSRMLS_D)
{
	zend_class_entry ce;
	INIT_CLASS_ENTRY(ce, "TElPKCS11CertificateType", NULL);
	TElPKCS11CertificateType_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TElPKCS11CertificateType_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TElPKCS11CertificateType_ce_ptr, "pctX509", 0)
	SB_DECLARE_CLASS_LONG_CONST(TElPKCS11CertificateType_ce_ptr, "pctWTLS", 1)
	SB_DECLARE_CLASS_LONG_CONST(TElPKCS11CertificateType_ce_ptr, "pctAttribute", 2)
	SB_DECLARE_CLASS_LONG_CONST(TElPKCS11CertificateType_ce_ptr, "pctVendorDefined", 3)
	
	INIT_CLASS_ENTRY(ce, "TElPKCS11CertificateCategory", NULL);
	TElPKCS11CertificateCategory_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TElPKCS11CertificateCategory_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TElPKCS11CertificateCategory_ce_ptr, "pccUnspecified", 0)
	SB_DECLARE_CLASS_LONG_CONST(TElPKCS11CertificateCategory_ce_ptr, "pccTokenUser", 1)
	SB_DECLARE_CLASS_LONG_CONST(TElPKCS11CertificateCategory_ce_ptr, "pccAuthority", 2)
	SB_DECLARE_CLASS_LONG_CONST(TElPKCS11CertificateCategory_ce_ptr, "pccOtherEntity", 3)
	
	INIT_CLASS_ENTRY(ce, "TElPKCS11NotificationFlag", NULL);
	TElPKCS11NotificationFlag_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TElPKCS11NotificationFlag_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TElPKCS11NotificationFlag_ce_ptr, "nfNone", 0)
	SB_DECLARE_CLASS_LONG_CONST(TElPKCS11NotificationFlag_ce_ptr, "nfSurrender", 1)
	
	INIT_CLASS_ENTRY(ce, "TElPKCS11UserType", NULL);
	TElPKCS11UserType_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TElPKCS11UserType_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TElPKCS11UserType_ce_ptr, "utSecurityOfficer", 0)
	SB_DECLARE_CLASS_LONG_CONST(TElPKCS11UserType_ce_ptr, "utUser", 1)
	
	INIT_CLASS_ENTRY(ce, "TElPKCS11KeyType", NULL);
	TElPKCS11KeyType_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TElPKCS11KeyType_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TElPKCS11KeyType_ce_ptr, "ktRSA", 0)
	SB_DECLARE_CLASS_LONG_CONST(TElPKCS11KeyType_ce_ptr, "ktDSA", 1)
	SB_DECLARE_CLASS_LONG_CONST(TElPKCS11KeyType_ce_ptr, "ktDH", 2)
	SB_DECLARE_CLASS_LONG_CONST(TElPKCS11KeyType_ce_ptr, "ktEC", 3)
	
	INIT_CLASS_ENTRY(ce, "TElPKCS11SessionState", NULL);
	TElPKCS11SessionState_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TElPKCS11SessionState_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TElPKCS11SessionState_ce_ptr, "stROPublicSession", 0)
	SB_DECLARE_CLASS_LONG_CONST(TElPKCS11SessionState_ce_ptr, "stROUserFunctions", 1)
	SB_DECLARE_CLASS_LONG_CONST(TElPKCS11SessionState_ce_ptr, "stRWPublicSession", 2)
	SB_DECLARE_CLASS_LONG_CONST(TElPKCS11SessionState_ce_ptr, "stRWUserFunctions", 3)
	SB_DECLARE_CLASS_LONG_CONST(TElPKCS11SessionState_ce_ptr, "stRWSOFunctions", 4)
	
	INIT_CLASS_ENTRY(ce, "TSBPKCS11StorageOption", NULL);
	TSBPKCS11StorageOption_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBPKCS11StorageOption_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBPKCS11StorageOption_ce_ptr, "pcsoAutoRefreshSlotInfo", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBPKCS11StorageOption_ce_ptr, "pcsoCreatePublicKeyObjects", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBPKCS11StorageOption_ce_ptr, "pcsoOnDemandMode", 2)
	SB_DECLARE_CLASS_LONG_CONST(TSBPKCS11StorageOption_ce_ptr, "pcsoUniqueIDs", 3)
	SB_DECLARE_CLASS_LONG_CONST(TSBPKCS11StorageOption_ce_ptr, "pcsoNoSessionLevelNotifications", 4)
	SB_DECLARE_CLASS_LONG_CONST(TSBPKCS11StorageOption_ce_ptr, "pcsoWeakenedKeySearchCriteria", 5)
	SB_DECLARE_CLASS_LONG_CONST(TSBPKCS11StorageOption_ce_ptr, "pcsoNoImplicitSlotInfoUpdates", 6)
	SB_DECLARE_CLASS_LONG_CONST(TSBPKCS11StorageOption_ce_ptr, "pcsoInitTemplateForFind", 7)
	SB_DECLARE_CLASS_LONG_CONST(TSBPKCS11StorageOption_ce_ptr, "pcsoUseSystemProcAddresses", 8)
	
	INIT_CLASS_ENTRY(ce, "TSBPKCS11StorageOptions", NULL);
	TSBPKCS11StorageOptions_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseFlags_ce_ptr, NULL TSRMLS_CC);
	TSBPKCS11StorageOptions_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBPKCS11StorageOptions_ce_ptr, "pcsoAutoRefreshSlotInfo", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBPKCS11StorageOptions_ce_ptr, "pcsoCreatePublicKeyObjects", 2)
	SB_DECLARE_CLASS_LONG_CONST(TSBPKCS11StorageOptions_ce_ptr, "pcsoOnDemandMode", 4)
	SB_DECLARE_CLASS_LONG_CONST(TSBPKCS11StorageOptions_ce_ptr, "pcsoUniqueIDs", 8)
	SB_DECLARE_CLASS_LONG_CONST(TSBPKCS11StorageOptions_ce_ptr, "pcsoNoSessionLevelNotifications", 16)
	SB_DECLARE_CLASS_LONG_CONST(TSBPKCS11StorageOptions_ce_ptr, "pcsoWeakenedKeySearchCriteria", 32)
	SB_DECLARE_CLASS_LONG_CONST(TSBPKCS11StorageOptions_ce_ptr, "pcsoNoImplicitSlotInfoUpdates", 64)
	SB_DECLARE_CLASS_LONG_CONST(TSBPKCS11StorageOptions_ce_ptr, "pcsoInitTemplateForFind", 128)
	SB_DECLARE_CLASS_LONG_CONST(TSBPKCS11StorageOptions_ce_ptr, "pcsoUseSystemProcAddresses", 256)
	
	INIT_CLASS_ENTRY(ce, "TSBPKCS11SlotEventMonitoringMode", NULL);
	TSBPKCS11SlotEventMonitoringMode_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBPKCS11SlotEventMonitoringMode_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBPKCS11SlotEventMonitoringMode_ce_ptr, "semNoMonitoring", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBPKCS11SlotEventMonitoringMode_ce_ptr, "semStandard", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBPKCS11SlotEventMonitoringMode_ce_ptr, "semSynchronous", 2)
	
	INIT_CLASS_ENTRY(ce, "TSBPKCS11ObjectType", NULL);
	TSBPKCS11ObjectType_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBPKCS11ObjectType_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBPKCS11ObjectType_ce_ptr, "otUnknown", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBPKCS11ObjectType_ce_ptr, "otData", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBPKCS11ObjectType_ce_ptr, "otCertificate", 2)
	SB_DECLARE_CLASS_LONG_CONST(TSBPKCS11ObjectType_ce_ptr, "otX509Certificate", 3)
	SB_DECLARE_CLASS_LONG_CONST(TSBPKCS11ObjectType_ce_ptr, "otWTLSCertificate", 4)
	SB_DECLARE_CLASS_LONG_CONST(TSBPKCS11ObjectType_ce_ptr, "otX509AttributeCertificate", 5)
	SB_DECLARE_CLASS_LONG_CONST(TSBPKCS11ObjectType_ce_ptr, "otPublicKey", 6)
	SB_DECLARE_CLASS_LONG_CONST(TSBPKCS11ObjectType_ce_ptr, "otPrivateKey", 7)
	SB_DECLARE_CLASS_LONG_CONST(TSBPKCS11ObjectType_ce_ptr, "otSecretKey", 8)
	SB_DECLARE_CLASS_LONG_CONST(TSBPKCS11ObjectType_ce_ptr, "otHardwareFeature", 9)
	SB_DECLARE_CLASS_LONG_CONST(TSBPKCS11ObjectType_ce_ptr, "otDomainParameters", 10)
	SB_DECLARE_CLASS_LONG_CONST(TSBPKCS11ObjectType_ce_ptr, "otMechanism", 11)
	SB_DECLARE_CLASS_LONG_CONST(TSBPKCS11ObjectType_ce_ptr, "otVendorDefined", 12)
	
	INIT_CLASS_ENTRY(ce, "TSBPKCS11CertCategory", NULL);
	TSBPKCS11CertCategory_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBPKCS11CertCategory_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBPKCS11CertCategory_ce_ptr, "ccUnspecified", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBPKCS11CertCategory_ce_ptr, "ccTokenUser", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBPKCS11CertCategory_ce_ptr, "ccAuthority", 2)
	SB_DECLARE_CLASS_LONG_CONST(TSBPKCS11CertCategory_ce_ptr, "ccOtherEntity", 3)
	
	INIT_CLASS_ENTRY(ce, "TSBPKCS11CertType", NULL);
	TSBPKCS11CertType_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBPKCS11CertType_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBPKCS11CertType_ce_ptr, "ctX509", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBPKCS11CertType_ce_ptr, "ctWTLS", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBPKCS11CertType_ce_ptr, "ctAttribute", 2)
	
	INIT_CLASS_ENTRY(ce, "TSBPKCS11MIDPSecurityDomain", NULL);
	TSBPKCS11MIDPSecurityDomain_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBPKCS11MIDPSecurityDomain_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBPKCS11MIDPSecurityDomain_ce_ptr, "msdUnspecified", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBPKCS11MIDPSecurityDomain_ce_ptr, "msdManufacturer", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBPKCS11MIDPSecurityDomain_ce_ptr, "msdOperator", 2)
	SB_DECLARE_CLASS_LONG_CONST(TSBPKCS11MIDPSecurityDomain_ce_ptr, "msdThirdParty", 3)
	
	INIT_CLASS_ENTRY(ce, "TSBPKCS11TokenAccessMode", NULL);
	TSBPKCS11TokenAccessMode_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBPKCS11TokenAccessMode_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBPKCS11TokenAccessMode_ce_ptr, "tamCompatible", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBPKCS11TokenAccessMode_ce_ptr, "tamFull", 1)
}

void Register_SBPKCS11Base_Aliases(TSRMLS_D)
{
	if (NULL == TElPKCS11Consumer_ce_ptr)
		Register_TElPKCS11Consumer(TSRMLS_C);
	zend_register_class_alias("ElPKCS11Consumer", TElPKCS11Consumer_ce_ptr);
	if (NULL == TElPKCS11ModuleList_ce_ptr)
		Register_TElPKCS11ModuleList(TSRMLS_C);
	zend_register_class_alias("ElPKCS11ModuleList", TElPKCS11ModuleList_ce_ptr);
	TElPKCS11ObjectClass_ce_ptr = TObject_ce_ptr;
	zend_register_class_alias("TElPKCS11ObjectClass", TElPKCS11ObjectClass_ce_ptr);
}
