#include "sbsftp.h"

zend_class_entry *TElSftpStream_ce_ptr = NULL;

SB_PHP_METHOD(TElSftpStream, Read)
{
	long l4Count;
	SBPointerZValInfo piBuffer;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zpBuffer, &l4Count) == SUCCESS) && ((PZVAL_IS_REF(zpBuffer) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY))) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElSftpStream_Read(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, (int32_t)l4Count, &l4OutResultRaw) TSRMLS_CC);
		SBSetPointerToZVal(&piBuffer, zpBuffer);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpStream, Write)
{
	long l4Count;
	SBPointerZValInfo piBuffer;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zpBuffer, &l4Count) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElSftpStream_Write(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, (int32_t)l4Count, &l4OutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpStream, Seek)
{
	long fOrigin;
	long l4Offset;
	long l8Offset;
	long u2Origin;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &l4Offset, &u2Origin) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSftpStream_Seek(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Offset, (uint16_t)u2Origin, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &l8Offset, &fOrigin) == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElSftpStream_Seek_1(SBGetObjectHandle(getThis() TSRMLS_CC), (int64_t)l8Offset, (TSeekOriginRaw)fOrigin, &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer) or (integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpStream, get_Handle)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElSftpStream_get_Handle(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(1788873458, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpStream, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSftpStream_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpStream_Read, 0, 0, 2)
	ZEND_ARG_INFO(1, Buffer)
	ZEND_ARG_INFO(0, Count)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpStream_Write, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(0, Count)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpStream_Seek, 0, 0, 2)
	ZEND_ARG_INFO(0, Offset)
	ZEND_ARG_INFO(0, Origin)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpStream_get_Handle, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpStream___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElSftpStream_methods[] = {
	PHP_ME(TElSftpStream, Read, arginfo_TElSftpStream_Read, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpStream, Write, arginfo_TElSftpStream_Write, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpStream, Seek, arginfo_TElSftpStream_Seek, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpStream, get_Handle, arginfo_TElSftpStream_get_Handle, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpStream, __construct, arginfo_TElSftpStream___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSftpStream(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSftpStream_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSftpStream", TElSftpStream_methods);
	if (NULL == TStream_ce_ptr)
		Register_TStream(TSRMLS_C);
	TElSftpStream_ce_ptr = zend_register_internal_class_ex(&ce, TStream_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElSftpClient_ce_ptr = NULL;

SB_PHP_METHOD(TElSftpClient, Read)
{
	long l4Size;
	long l8Offset;
	SBArrayZValInfo aiHandle;
	SBArrayZValInfo piBuffer;
	zval *zaHandle;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlzl", &zaHandle, &l8Offset, &zpBuffer, &l4Size) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaHandle)) || (IS_ARRAY == Z_TYPE_P(zaHandle)) || (IS_NULL == Z_TYPE_P(zaHandle))) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaHandle, &aiHandle TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElSftpClient_Read(SBGetObjectHandle(getThis() TSRMLS_CC), aiHandle.data, aiHandle.len, (int64_t)l8Offset, piBuffer.data, (int32_t)l4Size, &l4OutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiHandle);
		SBFreePointerZValInfo(&piBuffer);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zll", &zaHandle, &l8Offset, &l4Size) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaHandle)) || (IS_ARRAY == Z_TYPE_P(zaHandle)) || (IS_NULL == Z_TYPE_P(zaHandle))))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaHandle, &aiHandle TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElSftpClient_Read_1(SBGetObjectHandle(getThis() TSRMLS_CC), aiHandle.data, aiHandle.len, (int64_t)l8Offset, (int32_t)l4Size, &bOutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiHandle);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer) or (array of byte|string|NULL, integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, ReadSync)
{
	long l4Size;
	long l8Offset;
	SBArrayZValInfo aiHandle;
	SBArrayZValInfo piBuffer;
	zval *zaHandle;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlzl", &zaHandle, &l8Offset, &zpBuffer, &l4Size) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaHandle)) || (IS_ARRAY == Z_TYPE_P(zaHandle)) || (IS_NULL == Z_TYPE_P(zaHandle))) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaHandle, &aiHandle TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElSftpClient_ReadSync(SBGetObjectHandle(getThis() TSRMLS_CC), aiHandle.data, aiHandle.len, (int64_t)l8Offset, piBuffer.data, (int32_t)l4Size, &l4OutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiHandle);
		SBFreePointerZValInfo(&piBuffer);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zll", &zaHandle, &l8Offset, &l4Size) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaHandle)) || (IS_ARRAY == Z_TYPE_P(zaHandle)) || (IS_NULL == Z_TYPE_P(zaHandle))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaHandle, &aiHandle TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElSftpClient_ReadSync_1(SBGetObjectHandle(getThis() TSRMLS_CC), aiHandle.data, aiHandle.len, (int64_t)l8Offset, (int32_t)l4Size, &l4OutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiHandle);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer) or (array of byte|string|NULL, integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, OpenStream)
{
	char *sFilename;
	int sFilename_len;
	long fModes;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sl", &sFilename, &sFilename_len, &fModes) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSftpClient_OpenStream(SBGetObjectHandle(getThis() TSRMLS_CC), sFilename, (int32_t)sFilename_len, (TSBSftpFileOpenModesRaw)fModes, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElSftpStream_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, Open)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSftpClient_Open(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, OpenSync)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElSftpClient_OpenSync(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, CreateFile)
{
	char *sFilename;
	int sFilename_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sFilename, &sFilename_len) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSftpClient_CreateFile(SBGetObjectHandle(getThis() TSRMLS_CC), sFilename, (int32_t)sFilename_len, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, CreateFileSync)
{
	char *sFilename;
	int sFilename_len;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sFilename, &sFilename_len) == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElSftpClient_CreateFileSync(SBGetObjectHandle(getThis() TSRMLS_CC), sFilename, (int32_t)sFilename_len, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-818068478, 2, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, OpenFile)
{
	char *sFilename;
	int sFilename_len;
	long fAccess;
	long fModes;
	zval *oAttributes;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "slO!", &sFilename, &sFilename_len, &fModes, &oAttributes, TElSftpFileAttributes_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSftpClient_OpenFile(SBGetObjectHandle(getThis() TSRMLS_CC), sFilename, (int32_t)sFilename_len, (TSBSftpFileOpenModesRaw)fModes, SBGetObjectHandle(oAttributes TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sllO!", &sFilename, &sFilename_len, &fModes, &fAccess, &oAttributes, TElSftpFileAttributes_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSftpClient_OpenFile_1(SBGetObjectHandle(getThis() TSRMLS_CC), sFilename, (int32_t)sFilename_len, (TSBSftpFileOpenModesRaw)fModes, (TSBSftpFileOpenAccessRaw)fAccess, SBGetObjectHandle(oAttributes TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string, integer, TElSftpFileAttributes) or (string, integer, integer, TElSftpFileAttributes)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, OpenFileSync)
{
	char *sFilename;
	int sFilename_len;
	long fAccess;
	long fModes;
	uint32_t _err;
	zval *oAttributes;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "slO!", &sFilename, &sFilename_len, &fModes, &oAttributes, TElSftpFileAttributes_ce_ptr) == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElSftpClient_OpenFileSync(SBGetObjectHandle(getThis() TSRMLS_CC), sFilename, (int32_t)sFilename_len, (TSBSftpFileOpenModesRaw)fModes, SBGetObjectHandle(oAttributes TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-1489180211, 4, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sllO!", &sFilename, &sFilename_len, &fModes, &fAccess, &oAttributes, TElSftpFileAttributes_ce_ptr) == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElSftpClient_OpenFileSync_1(SBGetObjectHandle(getThis() TSRMLS_CC), sFilename, (int32_t)sFilename_len, (TSBSftpFileOpenModesRaw)fModes, (TSBSftpFileOpenAccessRaw)fAccess, SBGetObjectHandle(oAttributes TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(2085937906, 5, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(string, integer, TElSftpFileAttributes) or (string, integer, integer, TElSftpFileAttributes)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, OpenDirectory)
{
	char *sPath;
	int sPath_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sPath, &sPath_len) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSftpClient_OpenDirectory(SBGetObjectHandle(getThis() TSRMLS_CC), sPath, (int32_t)sPath_len, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, OpenDirectorySync)
{
	char *sPath;
	int sPath_len;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sPath, &sPath_len) == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElSftpClient_OpenDirectorySync(SBGetObjectHandle(getThis() TSRMLS_CC), sPath, (int32_t)sPath_len, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(1717049257, 2, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, ReadDirectory)
{
	SBArrayZValInfo aiHandle;
	zval *zaHandle;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaHandle) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaHandle)) || (IS_ARRAY == Z_TYPE_P(zaHandle)) || (IS_NULL == Z_TYPE_P(zaHandle))))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaHandle, &aiHandle TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElSftpClient_ReadDirectory(SBGetObjectHandle(getThis() TSRMLS_CC), aiHandle.data, aiHandle.len, &bOutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiHandle);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, ReadDirectorySync)
{
	SBArrayZValInfo aiHandle;
	zval *zaHandle;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaHandle) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaHandle)) || (IS_ARRAY == Z_TYPE_P(zaHandle)) || (IS_NULL == Z_TYPE_P(zaHandle))))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaHandle, &aiHandle TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElSftpClient_ReadDirectorySync(SBGetObjectHandle(getThis() TSRMLS_CC), aiHandle.data, aiHandle.len, &bOutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiHandle);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, RemoveFile)
{
	char *sFilename;
	int sFilename_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sFilename, &sFilename_len) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSftpClient_RemoveFile(SBGetObjectHandle(getThis() TSRMLS_CC), sFilename, (int32_t)sFilename_len, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, RemoveFileSync)
{
	char *sFilename;
	int sFilename_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sFilename, &sFilename_len) == SUCCESS)
	{
		SBCheckError(TElSftpClient_RemoveFileSync(SBGetObjectHandle(getThis() TSRMLS_CC), sFilename, (int32_t)sFilename_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, RemoveFiles)
{
	zval *oFilenames;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oFilenames, TStrings_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSftpClient_RemoveFiles(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oFilenames TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TStrings)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, RemoveFilesSync)
{
	zval *oFilenames;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oFilenames, TStrings_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSftpClient_RemoveFilesSync(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oFilenames TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStrings)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, RenameFile)
{
	char *sNewPath;
	char *sOldPath;
	int sNewPath_len;
	int sOldPath_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &sOldPath, &sOldPath_len, &sNewPath, &sNewPath_len) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSftpClient_RenameFile(SBGetObjectHandle(getThis() TSRMLS_CC), sOldPath, (int32_t)sOldPath_len, sNewPath, (int32_t)sNewPath_len, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, RenameFileSync)
{
	char *sNewPath;
	char *sOldPath;
	int sNewPath_len;
	int sOldPath_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &sOldPath, &sOldPath_len, &sNewPath, &sNewPath_len) == SUCCESS)
	{
		SBCheckError(TElSftpClient_RenameFileSync(SBGetObjectHandle(getThis() TSRMLS_CC), sOldPath, (int32_t)sOldPath_len, sNewPath, (int32_t)sNewPath_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, MakeDirectory)
{
	char *sPath;
	int sPath_len;
	zval *oAttributes;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &sPath, &sPath_len, &oAttributes, TElSftpFileAttributes_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSftpClient_MakeDirectory(SBGetObjectHandle(getThis() TSRMLS_CC), sPath, (int32_t)sPath_len, SBGetObjectHandle(oAttributes TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string, TElSftpFileAttributes)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, MakeDirectorySync)
{
	char *sPath;
	int sPath_len;
	zval *oAttributes;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &sPath, &sPath_len, &oAttributes, TElSftpFileAttributes_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSftpClient_MakeDirectorySync(SBGetObjectHandle(getThis() TSRMLS_CC), sPath, (int32_t)sPath_len, SBGetObjectHandle(oAttributes TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, TElSftpFileAttributes)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, RemoveDirectory)
{
	char *sPath;
	int sPath_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sPath, &sPath_len) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSftpClient_RemoveDirectory(SBGetObjectHandle(getThis() TSRMLS_CC), sPath, (int32_t)sPath_len, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, RemoveDirectorySync)
{
	char *sPath;
	int sPath_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sPath, &sPath_len) == SUCCESS)
	{
		SBCheckError(TElSftpClient_RemoveDirectorySync(SBGetObjectHandle(getThis() TSRMLS_CC), sPath, (int32_t)sPath_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, RequestAttributes)
{
	char *sPath;
	int sPath_len;
	SBArrayZValInfo aiHandle;
	zend_bool bFollowSymLinks;
	zval *zaHandle;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sb", &sPath, &sPath_len, &bFollowSymLinks) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSftpClient_RequestAttributes(SBGetObjectHandle(getThis() TSRMLS_CC), sPath, (int32_t)sPath_len, (int8_t)bFollowSymLinks, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaHandle) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaHandle)) || (IS_ARRAY == Z_TYPE_P(zaHandle)) || (IS_NULL == Z_TYPE_P(zaHandle))))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaHandle, &aiHandle TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElSftpClient_RequestAttributes_1(SBGetObjectHandle(getThis() TSRMLS_CC), aiHandle.data, aiHandle.len, &bOutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiHandle);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string, bool) or (array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, RequestAttributesSync)
{
	char *sPath;
	int sPath_len;
	SBArrayZValInfo aiHandle;
	zend_bool bFollowSymLinks;
	zval *zaHandle;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sb", &sPath, &sPath_len, &bFollowSymLinks) == SUCCESS)
	{
		SBCheckError(TElSftpClient_RequestAttributesSync(SBGetObjectHandle(getThis() TSRMLS_CC), sPath, (int32_t)sPath_len, (int8_t)bFollowSymLinks) TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaHandle) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaHandle)) || (IS_ARRAY == Z_TYPE_P(zaHandle)) || (IS_NULL == Z_TYPE_P(zaHandle))))
	{
		if (!SBGetByteArrayFromZVal(zaHandle, &aiHandle TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElSftpClient_RequestAttributesSync_1(SBGetObjectHandle(getThis() TSRMLS_CC), aiHandle.data, aiHandle.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiHandle);
	}
	else
	{
		SBErrorExpectsArguments("(string, bool) or (array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, SetAttributes)
{
	char *sPath;
	int sPath_len;
	zval *oAttributes;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &sPath, &sPath_len, &oAttributes, TElSftpFileAttributes_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSftpClient_SetAttributes(SBGetObjectHandle(getThis() TSRMLS_CC), sPath, (int32_t)sPath_len, SBGetObjectHandle(oAttributes TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string, TElSftpFileAttributes)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, SetAttributesSync)
{
	char *sPath;
	int sPath_len;
	zval *oAttributes;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &sPath, &sPath_len, &oAttributes, TElSftpFileAttributes_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSftpClient_SetAttributesSync(SBGetObjectHandle(getThis() TSRMLS_CC), sPath, (int32_t)sPath_len, SBGetObjectHandle(oAttributes TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, TElSftpFileAttributes)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, SetAttributesByHandle)
{
	SBArrayZValInfo aiHandle;
	zval *oAttributes;
	zval *zaHandle;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zO!", &zaHandle, &oAttributes, TElSftpFileAttributes_ce_ptr) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaHandle)) || (IS_ARRAY == Z_TYPE_P(zaHandle)) || (IS_NULL == Z_TYPE_P(zaHandle))))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaHandle, &aiHandle TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElSftpClient_SetAttributesByHandle(SBGetObjectHandle(getThis() TSRMLS_CC), aiHandle.data, aiHandle.len, SBGetObjectHandle(oAttributes TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiHandle);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, TElSftpFileAttributes)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, SetAttributesByHandleSync)
{
	SBArrayZValInfo aiHandle;
	zval *oAttributes;
	zval *zaHandle;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zO!", &zaHandle, &oAttributes, TElSftpFileAttributes_ce_ptr) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaHandle)) || (IS_ARRAY == Z_TYPE_P(zaHandle)) || (IS_NULL == Z_TYPE_P(zaHandle))))
	{
		if (!SBGetByteArrayFromZVal(zaHandle, &aiHandle TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElSftpClient_SetAttributesByHandleSync(SBGetObjectHandle(getThis() TSRMLS_CC), aiHandle.data, aiHandle.len, SBGetObjectHandle(oAttributes TSRMLS_CC)) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiHandle);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, TElSftpFileAttributes)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, ReadSymLink)
{
	char *sPath;
	int sPath_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sPath, &sPath_len) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSftpClient_ReadSymLink(SBGetObjectHandle(getThis() TSRMLS_CC), sPath, (int32_t)sPath_len, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, ReadSymLinkSync)
{
	char *sPath;
	int sPath_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sPath, &sPath_len) == SUCCESS)
	{
		SBCheckError(TElSftpClient_ReadSymLinkSync(SBGetObjectHandle(getThis() TSRMLS_CC), sPath, (int32_t)sPath_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, CreateSymLink)
{
	char *sLinkPath;
	char *sTargetPath;
	int sLinkPath_len;
	int sTargetPath_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &sLinkPath, &sLinkPath_len, &sTargetPath, &sTargetPath_len) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSftpClient_CreateSymLink(SBGetObjectHandle(getThis() TSRMLS_CC), sLinkPath, (int32_t)sLinkPath_len, sTargetPath, (int32_t)sTargetPath_len, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, CreateSymLinkSync)
{
	char *sLinkPath;
	char *sTargetPath;
	int sLinkPath_len;
	int sTargetPath_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &sLinkPath, &sLinkPath_len, &sTargetPath, &sTargetPath_len) == SUCCESS)
	{
		SBCheckError(TElSftpClient_CreateSymLinkSync(SBGetObjectHandle(getThis() TSRMLS_CC), sLinkPath, (int32_t)sLinkPath_len, sTargetPath, (int32_t)sTargetPath_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, CreateHardLink)
{
	char *sLinkPath;
	char *sTargetPath;
	int sLinkPath_len;
	int sTargetPath_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &sLinkPath, &sLinkPath_len, &sTargetPath, &sTargetPath_len) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSftpClient_CreateHardLink(SBGetObjectHandle(getThis() TSRMLS_CC), sLinkPath, (int32_t)sLinkPath_len, sTargetPath, (int32_t)sTargetPath_len, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, CreateHardLinkSync)
{
	char *sLinkPath;
	char *sTargetPath;
	int sLinkPath_len;
	int sTargetPath_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &sLinkPath, &sLinkPath_len, &sTargetPath, &sTargetPath_len) == SUCCESS)
	{
		SBCheckError(TElSftpClient_CreateHardLinkSync(SBGetObjectHandle(getThis() TSRMLS_CC), sLinkPath, (int32_t)sLinkPath_len, sTargetPath, (int32_t)sTargetPath_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, RequestAbsolutePath)
{
	char *sPath;
	int sPath_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sPath, &sPath_len) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSftpClient_RequestAbsolutePath(SBGetObjectHandle(getThis() TSRMLS_CC), sPath, (int32_t)sPath_len, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, RequestAbsolutePathSync)
{
	char *sPath;
	int sPath_len;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sPath, &sPath_len) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSftpClient_RequestAbsolutePathSync(SBGetObjectHandle(getThis() TSRMLS_CC), sPath, (int32_t)sPath_len, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1350141958, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, RequestAbsolutePathEx)
{
	char *sPath;
	int sPath_len;
	long fControl;
	zval *oComposePath;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "slO!", &sPath, &sPath_len, &fControl, &oComposePath, TStringList_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSftpClient_RequestAbsolutePathEx(SBGetObjectHandle(getThis() TSRMLS_CC), sPath, (int32_t)sPath_len, (TSBSftpRealpathControlRaw)fControl, SBGetObjectHandle(oComposePath TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string, integer, TStringList)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, RequestAbsolutePathExSync)
{
	char *sPath;
	int sPath_len;
	long fControl;
	uint32_t _err;
	zval *oComposePath;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "slO!", &sPath, &sPath_len, &fControl, &oComposePath, TStringList_ce_ptr) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSftpClient_RequestAbsolutePathExSync(SBGetObjectHandle(getThis() TSRMLS_CC), sPath, (int32_t)sPath_len, (TSBSftpRealpathControlRaw)fControl, SBGetObjectHandle(oComposePath TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(490311621, 4, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(string, integer, TStringList)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, Block)
{
	long fLockMask;
	long l8Length;
	long l8Offset;
	SBArrayZValInfo aiHandle;
	zval *zaHandle;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlll", &zaHandle, &l8Offset, &l8Length, &fLockMask) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaHandle)) || (IS_ARRAY == Z_TYPE_P(zaHandle)) || (IS_NULL == Z_TYPE_P(zaHandle))))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaHandle, &aiHandle TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElSftpClient_Block(SBGetObjectHandle(getThis() TSRMLS_CC), aiHandle.data, aiHandle.len, (int64_t)l8Offset, (int64_t)l8Length, (TSBSftpFileOpenAccessRaw)fLockMask, &bOutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiHandle);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, integer, integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, BlockSync)
{
	long fLockMask;
	long l8Length;
	long l8Offset;
	SBArrayZValInfo aiHandle;
	zval *zaHandle;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlll", &zaHandle, &l8Offset, &l8Length, &fLockMask) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaHandle)) || (IS_ARRAY == Z_TYPE_P(zaHandle)) || (IS_NULL == Z_TYPE_P(zaHandle))))
	{
		if (!SBGetByteArrayFromZVal(zaHandle, &aiHandle TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElSftpClient_BlockSync(SBGetObjectHandle(getThis() TSRMLS_CC), aiHandle.data, aiHandle.len, (int64_t)l8Offset, (int64_t)l8Length, (TSBSftpFileOpenAccessRaw)fLockMask) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiHandle);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, integer, integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, Unblock)
{
	long l8Length;
	long l8Offset;
	SBArrayZValInfo aiHandle;
	zval *zaHandle;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zll", &zaHandle, &l8Offset, &l8Length) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaHandle)) || (IS_ARRAY == Z_TYPE_P(zaHandle)) || (IS_NULL == Z_TYPE_P(zaHandle))))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaHandle, &aiHandle TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElSftpClient_Unblock(SBGetObjectHandle(getThis() TSRMLS_CC), aiHandle.data, aiHandle.len, (int64_t)l8Offset, (int64_t)l8Length, &bOutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiHandle);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, UnblockSync)
{
	long l8Length;
	long l8Offset;
	SBArrayZValInfo aiHandle;
	zval *zaHandle;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zll", &zaHandle, &l8Offset, &l8Length) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaHandle)) || (IS_ARRAY == Z_TYPE_P(zaHandle)) || (IS_NULL == Z_TYPE_P(zaHandle))))
	{
		if (!SBGetByteArrayFromZVal(zaHandle, &aiHandle TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElSftpClient_UnblockSync(SBGetObjectHandle(getThis() TSRMLS_CC), aiHandle.data, aiHandle.len, (int64_t)l8Offset, (int64_t)l8Length) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiHandle);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, CloseHandle)
{
	SBArrayZValInfo aiHandle;
	zval *zaHandle;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaHandle) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaHandle)) || (IS_ARRAY == Z_TYPE_P(zaHandle)) || (IS_NULL == Z_TYPE_P(zaHandle))))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaHandle, &aiHandle TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElSftpClient_CloseHandle(SBGetObjectHandle(getThis() TSRMLS_CC), aiHandle.data, aiHandle.len, &bOutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiHandle);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, CloseHandleSync)
{
	SBArrayZValInfo aiHandle;
	zval *zaHandle;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaHandle) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaHandle)) || (IS_ARRAY == Z_TYPE_P(zaHandle)) || (IS_NULL == Z_TYPE_P(zaHandle))))
	{
		if (!SBGetByteArrayFromZVal(zaHandle, &aiHandle TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElSftpClient_CloseHandleSync(SBGetObjectHandle(getThis() TSRMLS_CC), aiHandle.data, aiHandle.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiHandle);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, Write)
{
	long l8Offset;
	long u4Size;
	SBArrayZValInfo aiHandle;
	SBArrayZValInfo piBuffer;
	zval *zaHandle;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlzl", &zaHandle, &l8Offset, &zpBuffer, &u4Size) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaHandle)) || (IS_ARRAY == Z_TYPE_P(zaHandle)) || (IS_NULL == Z_TYPE_P(zaHandle))) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaHandle, &aiHandle TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElSftpClient_Write(SBGetObjectHandle(getThis() TSRMLS_CC), aiHandle.data, aiHandle.len, (int64_t)l8Offset, piBuffer.data, (uint32_t)u4Size, &bOutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiHandle);
		SBFreePointerZValInfo(&piBuffer);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, WriteSync)
{
	long l8Offset;
	long u4Size;
	SBArrayZValInfo aiHandle;
	SBArrayZValInfo piBuffer;
	zval *zaHandle;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlzl", &zaHandle, &l8Offset, &zpBuffer, &u4Size) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaHandle)) || (IS_ARRAY == Z_TYPE_P(zaHandle)) || (IS_NULL == Z_TYPE_P(zaHandle))) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		if (!SBGetByteArrayFromZVal(zaHandle, &aiHandle TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElSftpClient_WriteSync(SBGetObjectHandle(getThis() TSRMLS_CC), aiHandle.data, aiHandle.len, (int64_t)l8Offset, piBuffer.data, (uint32_t)u4Size) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiHandle);
		SBFreePointerZValInfo(&piBuffer);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, FinalizeTextWrite)
{
	SBArrayZValInfo aiHandle;
	zval *zaHandle;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaHandle) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaHandle)) || (IS_ARRAY == Z_TYPE_P(zaHandle)) || (IS_NULL == Z_TYPE_P(zaHandle))))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaHandle, &aiHandle TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElSftpClient_FinalizeTextWrite(SBGetObjectHandle(getThis() TSRMLS_CC), aiHandle.data, aiHandle.len, &bOutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiHandle);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, FinalizeTextWriteSync)
{
	SBArrayZValInfo aiHandle;
	zval *zaHandle;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaHandle) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaHandle)) || (IS_ARRAY == Z_TYPE_P(zaHandle)) || (IS_NULL == Z_TYPE_P(zaHandle))))
	{
		if (!SBGetByteArrayFromZVal(zaHandle, &aiHandle TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElSftpClient_FinalizeTextWriteSync(SBGetObjectHandle(getThis() TSRMLS_CC), aiHandle.data, aiHandle.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiHandle);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, ExtensionCmd)
{
	char *sExtension;
	int sExtension_len;
	long l4Size;
	SBArrayZValInfo aiDataBuffer;
	SBArrayZValInfo aiExtension;
	SBArrayZValInfo piDataBuffer;
	zval *zaDataBuffer;
	zval *zaExtension;
	zval *zpDataBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "szl", &sExtension, &sExtension_len, &zpDataBuffer, &l4Size) == SUCCESS) && ((Z_TYPE_P(zpDataBuffer) == IS_STRING) || (Z_TYPE_P(zpDataBuffer) == IS_ARRAY) || (Z_TYPE_P(zpDataBuffer) == IS_NULL) || ((Z_TYPE_P(zpDataBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpDataBuffer) == TSBPointer_ce_ptr))))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpDataBuffer, &piDataBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElSftpClient_ExtensionCmd(SBGetObjectHandle(getThis() TSRMLS_CC), sExtension, (int32_t)sExtension_len, piDataBuffer.data, (int32_t)l4Size, &bOutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piDataBuffer);
		RETURN_BOOL(bOutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sExtension, &sExtension_len) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSftpClient_ExtensionCmd_1(SBGetObjectHandle(getThis() TSRMLS_CC), sExtension, (int32_t)sExtension_len, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sz", &sExtension, &sExtension_len, &zaDataBuffer) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaDataBuffer)) || (IS_ARRAY == Z_TYPE_P(zaDataBuffer)) || (IS_NULL == Z_TYPE_P(zaDataBuffer))))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaDataBuffer, &aiDataBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElSftpClient_ExtensionCmd_2(SBGetObjectHandle(getThis() TSRMLS_CC), sExtension, (int32_t)sExtension_len, aiDataBuffer.data, aiDataBuffer.len, &bOutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiDataBuffer);
		RETURN_BOOL(bOutResultRaw);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaExtension) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaExtension)) || (IS_ARRAY == Z_TYPE_P(zaExtension)) || (IS_NULL == Z_TYPE_P(zaExtension))))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaExtension, &aiExtension TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElSftpClient_ExtensionCmd_3(SBGetObjectHandle(getThis() TSRMLS_CC), aiExtension.data, aiExtension.len, &bOutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiExtension);
		RETURN_BOOL(bOutResultRaw);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zzl", &zaExtension, &zpDataBuffer, &l4Size) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaExtension)) || (IS_ARRAY == Z_TYPE_P(zaExtension)) || (IS_NULL == Z_TYPE_P(zaExtension))) && ((Z_TYPE_P(zpDataBuffer) == IS_STRING) || (Z_TYPE_P(zpDataBuffer) == IS_ARRAY) || (Z_TYPE_P(zpDataBuffer) == IS_NULL) || ((Z_TYPE_P(zpDataBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpDataBuffer) == TSBPointer_ce_ptr))))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaExtension, &aiExtension TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpDataBuffer, &piDataBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElSftpClient_ExtensionCmd_4(SBGetObjectHandle(getThis() TSRMLS_CC), aiExtension.data, aiExtension.len, piDataBuffer.data, (int32_t)l4Size, &bOutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiExtension);
		SBFreePointerZValInfo(&piDataBuffer);
		RETURN_BOOL(bOutResultRaw);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zz", &zaExtension, &zaDataBuffer) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaExtension)) || (IS_ARRAY == Z_TYPE_P(zaExtension)) || (IS_NULL == Z_TYPE_P(zaExtension))) && ((IS_STRING == Z_TYPE_P(zaDataBuffer)) || (IS_ARRAY == Z_TYPE_P(zaDataBuffer)) || (IS_NULL == Z_TYPE_P(zaDataBuffer))))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaExtension, &aiExtension TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaDataBuffer, &aiDataBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElSftpClient_ExtensionCmd_5(SBGetObjectHandle(getThis() TSRMLS_CC), aiExtension.data, aiExtension.len, aiDataBuffer.data, aiDataBuffer.len, &bOutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiExtension);
		SBFreeArrayZValInfo(&aiDataBuffer);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string, TSBPointer|array of byte|string|NULL, integer) or (string) or (string, array of byte|string|NULL) or (array of byte|string|NULL) or (array of byte|string|NULL, TSBPointer|array of byte|string|NULL, integer) or (array of byte|string|NULL, array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, ExtensionCmdSync)
{
	char *sExtension;
	int sExtension_len;
	long l4Size;
	SBArrayZValInfo piDataBuffer;
	zval *zpDataBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "szl", &sExtension, &sExtension_len, &zpDataBuffer, &l4Size) == SUCCESS) && ((Z_TYPE_P(zpDataBuffer) == IS_STRING) || (Z_TYPE_P(zpDataBuffer) == IS_ARRAY) || (Z_TYPE_P(zpDataBuffer) == IS_NULL) || ((Z_TYPE_P(zpDataBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpDataBuffer) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpDataBuffer, &piDataBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElSftpClient_ExtensionCmdSync(SBGetObjectHandle(getThis() TSRMLS_CC), sExtension, (int32_t)sExtension_len, piDataBuffer.data, (int32_t)l4Size) TSRMLS_CC);
		SBFreePointerZValInfo(&piDataBuffer);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sExtension, &sExtension_len) == SUCCESS)
	{
		SBCheckError(TElSftpClient_ExtensionCmdSync_1(SBGetObjectHandle(getThis() TSRMLS_CC), sExtension, (int32_t)sExtension_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, TSBPointer|array of byte|string|NULL, integer) or (string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, TextSeek)
{
	long l8LineNumber;
	SBArrayZValInfo aiHandle;
	zval *zaHandle;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zaHandle, &l8LineNumber) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaHandle)) || (IS_ARRAY == Z_TYPE_P(zaHandle)) || (IS_NULL == Z_TYPE_P(zaHandle))))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaHandle, &aiHandle TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElSftpClient_TextSeek(SBGetObjectHandle(getThis() TSRMLS_CC), aiHandle.data, aiHandle.len, (int64_t)l8LineNumber, &bOutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiHandle);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, TextSeekSync)
{
	long l8LineNumber;
	SBArrayZValInfo aiHandle;
	zval *zaHandle;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zaHandle, &l8LineNumber) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaHandle)) || (IS_ARRAY == Z_TYPE_P(zaHandle)) || (IS_NULL == Z_TYPE_P(zaHandle))))
	{
		if (!SBGetByteArrayFromZVal(zaHandle, &aiHandle TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElSftpClient_TextSeekSync(SBGetObjectHandle(getThis() TSRMLS_CC), aiHandle.data, aiHandle.len, (int64_t)l8LineNumber) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiHandle);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, SendVendorID)
{
	zval *oVendorID;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oVendorID, TElSftpVendorIDExtension_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSftpClient_SendVendorID(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oVendorID TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElSftpVendorIDExtension)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, SendVendorIDSync)
{
	zval *oVendorID;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oVendorID, TElSftpVendorIDExtension_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSftpClient_SendVendorIDSync(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oVendorID TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSftpVendorIDExtension)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, RequestFileHash)
{
	char *sFileName;
	int sFileName_len;
	long l8Length;
	long l8StartOffset;
	long u4BlockSize;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "slll", &sFileName, &sFileName_len, &l8StartOffset, &l8Length, &u4BlockSize) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSftpClient_RequestFileHash(SBGetObjectHandle(getThis() TSRMLS_CC), sFileName, (int32_t)sFileName_len, (int64_t)l8StartOffset, (int64_t)l8Length, (uint32_t)u4BlockSize, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string, integer, integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, RequestFileHashSync)
{
	char *sFileName;
	int sFileName_len;
	long l8Length;
	long l8StartOffset;
	long u4BlockSize;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "slll", &sFileName, &sFileName_len, &l8StartOffset, &l8Length, &u4BlockSize) == SUCCESS)
	{
		SBCheckError(TElSftpClient_RequestFileHashSync(SBGetObjectHandle(getThis() TSRMLS_CC), sFileName, (int32_t)sFileName_len, (int64_t)l8StartOffset, (int64_t)l8Length, (uint32_t)u4BlockSize) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, integer, integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, RequestFileHashByHandle)
{
	long l8Length;
	long l8StartOffset;
	long u4BlockSize;
	SBArrayZValInfo aiHandle;
	zval *zaHandle;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlll", &zaHandle, &l8StartOffset, &l8Length, &u4BlockSize) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaHandle)) || (IS_ARRAY == Z_TYPE_P(zaHandle)) || (IS_NULL == Z_TYPE_P(zaHandle))))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaHandle, &aiHandle TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElSftpClient_RequestFileHashByHandle(SBGetObjectHandle(getThis() TSRMLS_CC), aiHandle.data, aiHandle.len, (int64_t)l8StartOffset, (int64_t)l8Length, (uint32_t)u4BlockSize, &bOutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiHandle);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, integer, integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, RequestFileHashByHandleSync)
{
	long l8Length;
	long l8StartOffset;
	long u4BlockSize;
	SBArrayZValInfo aiHandle;
	zval *zaHandle;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlll", &zaHandle, &l8StartOffset, &l8Length, &u4BlockSize) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaHandle)) || (IS_ARRAY == Z_TYPE_P(zaHandle)) || (IS_NULL == Z_TYPE_P(zaHandle))))
	{
		if (!SBGetByteArrayFromZVal(zaHandle, &aiHandle TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElSftpClient_RequestFileHashByHandleSync(SBGetObjectHandle(getThis() TSRMLS_CC), aiHandle.data, aiHandle.len, (int64_t)l8StartOffset, (int64_t)l8Length, (uint32_t)u4BlockSize) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiHandle);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, integer, integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, QueryAvailableSpace)
{
	char *sPath;
	int sPath_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sPath, &sPath_len) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSftpClient_QueryAvailableSpace(SBGetObjectHandle(getThis() TSRMLS_CC), sPath, (int32_t)sPath_len, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, QueryAvailableSpaceSync)
{
	char *sPath;
	int sPath_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sPath, &sPath_len) == SUCCESS)
	{
		SBCheckError(TElSftpClient_QueryAvailableSpaceSync(SBGetObjectHandle(getThis() TSRMLS_CC), sPath, (int32_t)sPath_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, QueryHomeDirectory)
{
	char *sUsername;
	int sUsername_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sUsername, &sUsername_len) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSftpClient_QueryHomeDirectory(SBGetObjectHandle(getThis() TSRMLS_CC), sUsername, (int32_t)sUsername_len, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, QueryHomeDirectorySync)
{
	char *sUsername;
	int sUsername_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sUsername, &sUsername_len) == SUCCESS)
	{
		SBCheckError(TElSftpClient_QueryHomeDirectorySync(SBGetObjectHandle(getThis() TSRMLS_CC), sUsername, (int32_t)sUsername_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, QueryStatVFS)
{
	char *sPath;
	int sPath_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sPath, &sPath_len) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSftpClient_QueryStatVFS(SBGetObjectHandle(getThis() TSRMLS_CC), sPath, (int32_t)sPath_len, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, QueryStatVFSSync)
{
	char *sPath;
	int sPath_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sPath, &sPath_len) == SUCCESS)
	{
		SBCheckError(TElSftpClient_QueryStatVFSSync(SBGetObjectHandle(getThis() TSRMLS_CC), sPath, (int32_t)sPath_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, CopyRemoteFile)
{
	char *sDestination;
	char *sSource;
	int sDestination_len;
	int sSource_len;
	zend_bool bOverwrite;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssb", &sSource, &sSource_len, &sDestination, &sDestination_len, &bOverwrite) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSftpClient_CopyRemoteFile(SBGetObjectHandle(getThis() TSRMLS_CC), sSource, (int32_t)sSource_len, sDestination, (int32_t)sDestination_len, (int8_t)bOverwrite, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string, string, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, CopyRemoteFileSync)
{
	char *sDestination;
	char *sSource;
	int sDestination_len;
	int sSource_len;
	zend_bool bOverwrite;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssb", &sSource, &sSource_len, &sDestination, &sDestination_len, &bOverwrite) == SUCCESS)
	{
		SBCheckError(TElSftpClient_CopyRemoteFileSync(SBGetObjectHandle(getThis() TSRMLS_CC), sSource, (int32_t)sSource_len, sDestination, (int32_t)sDestination_len, (int8_t)bOverwrite) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, string, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, CopyRemoteData)
{
	long l8DataLength;
	long l8ReadFromOffset;
	long l8WriteToOffset;
	SBArrayZValInfo aiReadFrom;
	SBArrayZValInfo aiWriteTo;
	zval *zaReadFrom;
	zval *zaWriteTo;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlzll", &zaReadFrom, &l8ReadFromOffset, &zaWriteTo, &l8WriteToOffset, &l8DataLength) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaReadFrom)) || (IS_ARRAY == Z_TYPE_P(zaReadFrom)) || (IS_NULL == Z_TYPE_P(zaReadFrom))) && ((IS_STRING == Z_TYPE_P(zaWriteTo)) || (IS_ARRAY == Z_TYPE_P(zaWriteTo)) || (IS_NULL == Z_TYPE_P(zaWriteTo))))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaReadFrom, &aiReadFrom TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaWriteTo, &aiWriteTo TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElSftpClient_CopyRemoteData(SBGetObjectHandle(getThis() TSRMLS_CC), aiReadFrom.data, aiReadFrom.len, (int64_t)l8ReadFromOffset, aiWriteTo.data, aiWriteTo.len, (int64_t)l8WriteToOffset, (int64_t)l8DataLength, &bOutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiReadFrom);
		SBFreeArrayZValInfo(&aiWriteTo);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, integer, array of byte|string|NULL, integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, CopyRemoteDataSync)
{
	long l8DataLength;
	long l8ReadFromOffset;
	long l8WriteToOffset;
	SBArrayZValInfo aiReadFrom;
	SBArrayZValInfo aiWriteTo;
	zval *zaReadFrom;
	zval *zaWriteTo;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlzll", &zaReadFrom, &l8ReadFromOffset, &zaWriteTo, &l8WriteToOffset, &l8DataLength) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaReadFrom)) || (IS_ARRAY == Z_TYPE_P(zaReadFrom)) || (IS_NULL == Z_TYPE_P(zaReadFrom))) && ((IS_STRING == Z_TYPE_P(zaWriteTo)) || (IS_ARRAY == Z_TYPE_P(zaWriteTo)) || (IS_NULL == Z_TYPE_P(zaWriteTo))))
	{
		if (!SBGetByteArrayFromZVal(zaReadFrom, &aiReadFrom TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaWriteTo, &aiWriteTo TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElSftpClient_CopyRemoteDataSync(SBGetObjectHandle(getThis() TSRMLS_CC), aiReadFrom.data, aiReadFrom.len, (int64_t)l8ReadFromOffset, aiWriteTo.data, aiWriteTo.len, (int64_t)l8WriteToOffset, (int64_t)l8DataLength) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiReadFrom);
		SBFreeArrayZValInfo(&aiWriteTo);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, integer, array of byte|string|NULL, integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, RequestTempFolder)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSftpClient_RequestTempFolder(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, RequestTempFolderSync)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElSftpClient_RequestTempFolderSync(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, MakeTempFolder)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSftpClient_MakeTempFolder(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, MakeTempFolderSync)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElSftpClient_MakeTempFolderSync(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, get_Active)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSftpClient_get_Active(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, get_Version)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBSftpVersionRaw fOutResultRaw = 0;
		SBCheckError(TElSftpClient_get_Version(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, get_SFTPExtCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSftpClient_get_SFTPExtCount(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, get_SFTPExt)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSftpClient_get_SFTPExt(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TSBSftpExtendedAttribute_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, get_NewLineConvention)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElSftpClient_get_NewLineConvention(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(1270699329, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, set_NewLineConvention)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElSftpClient_set_NewLineConvention(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, get_LocalNewLineConvention)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElSftpClient_get_LocalNewLineConvention(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-1777531718, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, set_LocalNewLineConvention)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElSftpClient_set_LocalNewLineConvention(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, get_LastSyncComment)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSftpClient_get_LastSyncComment(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1045124271, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, get_LastSyncError)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSftpClient_get_LastSyncError(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, get_LastReadCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSftpClient_get_LastReadCount(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, get_SBB3Compatible)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSftpClient_get_SBB3Compatible(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, set_SBB3Compatible)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSftpClient_set_SBB3Compatible(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, get_SynchronousMode)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSftpClient_get_SynchronousMode(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, set_SynchronousMode)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSftpClient_set_SynchronousMode(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, get_Tunnel)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSftpClient_get_Tunnel(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomSSHTunnel_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, set_Tunnel)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElCustomSSHTunnel_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSftpClient_set_Tunnel(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomSSHTunnel)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, get_SftpBufferSize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSftpClient_get_SftpBufferSize(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, set_SftpBufferSize)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElSftpClient_set_SftpBufferSize(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, get_UseUTF8)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSftpClient_get_UseUTF8(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, set_UseUTF8)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSftpClient_set_UseUTF8(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, get_UseUTF8OnV3)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSftpClient_get_UseUTF8OnV3(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, set_UseUTF8OnV3)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSftpClient_set_UseUTF8OnV3(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, get_RemoteCharset)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSftpClient_get_RemoteCharset(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-2046459092, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, set_RemoteCharset)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSftpClient_set_RemoteCharset(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, get_NoCharacterEncoding)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSftpClient_get_NoCharacterEncoding(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, set_NoCharacterEncoding)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSftpClient_set_NoCharacterEncoding(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, get_LocalCharset)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSftpClient_get_LocalCharset(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1372767036, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, set_LocalCharset)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSftpClient_set_LocalCharset(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, get_Versions)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBSftpVersionsRaw fOutResultRaw = 0;
		SBCheckError(TElSftpClient_get_Versions(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, set_Versions)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElSftpClient_set_Versions(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBSftpVersionsRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, get_ExtendedProperties)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSftpClient_get_ExtendedProperties(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElSftpExtendedProperties_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, set_ExtendedProperties)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElSftpExtendedProperties_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSftpClient_set_ExtendedProperties(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSftpExtendedProperties)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, get_UploadBlockSize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSftpClient_get_UploadBlockSize(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, set_UploadBlockSize)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElSftpClient_set_UploadBlockSize(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, get_DownloadBlockSize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSftpClient_get_DownloadBlockSize(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, set_DownloadBlockSize)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElSftpClient_set_DownloadBlockSize(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, get_PipelineLength)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSftpClient_get_PipelineLength(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, set_PipelineLength)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElSftpClient_set_PipelineLength(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, get_AutoAdjustTransferBlock)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSftpClient_get_AutoAdjustTransferBlock(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, set_AutoAdjustTransferBlock)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSftpClient_set_AutoAdjustTransferBlock(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, get_OperationErrorHandling)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBOperationErrorHandlingRaw fOutResultRaw = 0;
		SBCheckError(TElSftpClient_get_OperationErrorHandling(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, set_OperationErrorHandling)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElSftpClient_set_OperationErrorHandling(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBOperationErrorHandlingRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, get_MessageLoop)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBSftpMessageLoopEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSftpClient_get_MessageLoop(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, set_MessageLoop)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSftpClient_set_MessageLoop(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBSftpMessageLoopEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBSftpMessageLoopEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, get_OnOpenConnection)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TNotifyEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSftpClient_get_OnOpenConnection(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, set_OnOpenConnection)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSftpClient_set_OnOpenConnection(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TNotifyEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TNotifyEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, get_OnCloseConnection)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TNotifyEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSftpClient_get_OnCloseConnection(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, set_OnCloseConnection)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSftpClient_set_OnCloseConnection(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TNotifyEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TNotifyEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, get_OnOpenFile)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBSftpFileOpenEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSftpClient_get_OnOpenFile(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, set_OnOpenFile)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSftpClient_set_OnOpenFile(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBSftpFileOpenEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBSftpFileOpenEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, get_OnError)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBSftpErrorEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSftpClient_get_OnError(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, set_OnError)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSftpClient_set_OnError(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBSftpErrorEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBSftpErrorEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, get_OnSuccess)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBSftpSuccessEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSftpClient_get_OnSuccess(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, set_OnSuccess)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSftpClient_set_OnSuccess(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBSftpSuccessEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBSftpSuccessEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, get_OnDirectoryListing)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBSftpDirectoryListingEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSftpClient_get_OnDirectoryListing(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, set_OnDirectoryListing)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSftpClient_set_OnDirectoryListing(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBSftpDirectoryListingEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBSftpDirectoryListingEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, get_OnFileAttributes)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBSftpFileAttributesEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSftpClient_get_OnFileAttributes(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, set_OnFileAttributes)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSftpClient_set_OnFileAttributes(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBSftpFileAttributesEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBSftpFileAttributesEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, get_OnData)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBSftpDataEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSftpClient_get_OnData(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, set_OnData)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSftpClient_set_OnData(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBSftpDataEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBSftpDataEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, get_OnAbsolutePath)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBSftpAbsolutePathEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSftpClient_get_OnAbsolutePath(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, set_OnAbsolutePath)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSftpClient_set_OnAbsolutePath(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBSftpAbsolutePathEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBSftpAbsolutePathEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, get_OnBlockTransferPrepared)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBSftpBlockTransferPreparedEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSftpClient_get_OnBlockTransferPrepared(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, set_OnBlockTransferPrepared)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSftpClient_set_OnBlockTransferPrepared(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBSftpBlockTransferPreparedEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBSftpBlockTransferPreparedEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, get_OnExtendedReply)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBSftpDataEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSftpClient_get_OnExtendedReply(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, set_OnExtendedReply)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSftpClient_set_OnExtendedReply(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBSftpDataEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBSftpDataEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, get_OnVersionSelect)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBSftpVersionSelectEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSftpClient_get_OnVersionSelect(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, set_OnVersionSelect)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSftpClient_set_OnVersionSelect(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBSftpVersionSelectEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBSftpVersionSelectEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, get_OnFileHash)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBSftpFileHashEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSftpClient_get_OnFileHash(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, set_OnFileHash)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSftpClient_set_OnFileHash(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBSftpFileHashEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBSftpFileHashEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, get_OnAvailableSpace)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBSftpAvailableSpaceEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSftpClient_get_OnAvailableSpace(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, set_OnAvailableSpace)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSftpClient_set_OnAvailableSpace(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBSftpAvailableSpaceEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBSftpAvailableSpaceEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, get_OnName)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBSftpNameEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSftpClient_get_OnName(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, set_OnName)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSftpClient_set_OnName(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBSftpNameEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBSftpNameEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, get_OnTransferCompleted)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBSftpTransferCompletedEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSftpClient_get_OnTransferCompleted(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, set_OnTransferCompleted)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSftpClient_set_OnTransferCompleted(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBSftpTransferCompletedEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBSftpTransferCompletedEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, get_OnProgress)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBProgressEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSftpClient_get_OnProgress(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, set_OnProgress)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSftpClient_set_OnProgress(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBProgressEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBProgressEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, get_OnStatVFS)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBSftpStatvfsEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSftpClient_get_OnStatVFS(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, set_OnStatVFS)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSftpClient_set_OnStatVFS(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBSftpStatvfsEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBSftpStatvfsEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSftpClient, __construct)
{
	zval *oAOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSftpClient_Create(SBGetObjectHandle(oAOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_Read, 0, 0, 3)
	ZEND_ARG_TYPE_INFO(0, Handle, 0, 1)
	ZEND_ARG_INFO(0, Offset)
	ZEND_ARG_TYPE_INFO(0, Buffer_or_Size, 0, 1)
	ZEND_ARG_INFO(0, Size)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_ReadSync, 0, 0, 3)
	ZEND_ARG_TYPE_INFO(0, Handle, 0, 1)
	ZEND_ARG_INFO(0, Offset)
	ZEND_ARG_TYPE_INFO(0, Buffer_or_Size, 0, 1)
	ZEND_ARG_INFO(0, Size)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_OpenStream, 0, 0, 2)
	ZEND_ARG_INFO(0, Filename)
	ZEND_ARG_INFO(0, Modes)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_Open, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_OpenSync, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_CreateFile, 0, 0, 1)
	ZEND_ARG_INFO(0, Filename)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_CreateFileSync, 0, 0, 1)
	ZEND_ARG_INFO(0, Filename)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_OpenFile, 0, 0, 3)
	ZEND_ARG_INFO(0, Filename)
	ZEND_ARG_INFO(0, Modes)
	ZEND_ARG_TYPE_INFO(0, Attributes_or_Access, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Attributes, TElSftpFileAttributes, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_OpenFileSync, 0, 0, 3)
	ZEND_ARG_INFO(0, Filename)
	ZEND_ARG_INFO(0, Modes)
	ZEND_ARG_TYPE_INFO(0, Attributes_or_Access, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Attributes, TElSftpFileAttributes, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_OpenDirectory, 0, 0, 1)
	ZEND_ARG_INFO(0, Path)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_OpenDirectorySync, 0, 0, 1)
	ZEND_ARG_INFO(0, Path)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_ReadDirectory, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Handle, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_ReadDirectorySync, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Handle, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_RemoveFile, 0, 0, 1)
	ZEND_ARG_INFO(0, Filename)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_RemoveFileSync, 0, 0, 1)
	ZEND_ARG_INFO(0, Filename)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_RemoveFiles, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Filenames, TStrings, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_RemoveFilesSync, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Filenames, TStrings, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_RenameFile, 0, 0, 2)
	ZEND_ARG_INFO(0, OldPath)
	ZEND_ARG_INFO(0, NewPath)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_RenameFileSync, 0, 0, 2)
	ZEND_ARG_INFO(0, OldPath)
	ZEND_ARG_INFO(0, NewPath)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_MakeDirectory, 0, 0, 2)
	ZEND_ARG_INFO(0, Path)
	ZEND_ARG_OBJ_INFO(0, Attributes, TElSftpFileAttributes, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_MakeDirectorySync, 0, 0, 2)
	ZEND_ARG_INFO(0, Path)
	ZEND_ARG_OBJ_INFO(0, Attributes, TElSftpFileAttributes, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_RemoveDirectory, 0, 0, 1)
	ZEND_ARG_INFO(0, Path)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_RemoveDirectorySync, 0, 0, 1)
	ZEND_ARG_INFO(0, Path)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_RequestAttributes, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Path_or_Handle, 0, 1)
	ZEND_ARG_INFO(0, FollowSymLinks)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_RequestAttributesSync, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Path_or_Handle, 0, 1)
	ZEND_ARG_INFO(0, FollowSymLinks)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_SetAttributes, 0, 0, 2)
	ZEND_ARG_INFO(0, Path)
	ZEND_ARG_OBJ_INFO(0, Attributes, TElSftpFileAttributes, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_SetAttributesSync, 0, 0, 2)
	ZEND_ARG_INFO(0, Path)
	ZEND_ARG_OBJ_INFO(0, Attributes, TElSftpFileAttributes, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_SetAttributesByHandle, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Handle, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Attributes, TElSftpFileAttributes, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_SetAttributesByHandleSync, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Handle, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Attributes, TElSftpFileAttributes, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_ReadSymLink, 0, 0, 1)
	ZEND_ARG_INFO(0, Path)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_ReadSymLinkSync, 0, 0, 1)
	ZEND_ARG_INFO(0, Path)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_CreateSymLink, 0, 0, 2)
	ZEND_ARG_INFO(0, LinkPath)
	ZEND_ARG_INFO(0, TargetPath)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_CreateSymLinkSync, 0, 0, 2)
	ZEND_ARG_INFO(0, LinkPath)
	ZEND_ARG_INFO(0, TargetPath)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_CreateHardLink, 0, 0, 2)
	ZEND_ARG_INFO(0, LinkPath)
	ZEND_ARG_INFO(0, TargetPath)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_CreateHardLinkSync, 0, 0, 2)
	ZEND_ARG_INFO(0, LinkPath)
	ZEND_ARG_INFO(0, TargetPath)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_RequestAbsolutePath, 0, 0, 1)
	ZEND_ARG_INFO(0, Path)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_RequestAbsolutePathSync, 0, 0, 1)
	ZEND_ARG_INFO(0, Path)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_RequestAbsolutePathEx, 0, 0, 3)
	ZEND_ARG_INFO(0, Path)
	ZEND_ARG_INFO(0, Control)
	ZEND_ARG_OBJ_INFO(0, ComposePath, TStringList, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_RequestAbsolutePathExSync, 0, 0, 3)
	ZEND_ARG_INFO(0, Path)
	ZEND_ARG_INFO(0, Control)
	ZEND_ARG_OBJ_INFO(0, ComposePath, TStringList, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_Block, 0, 0, 4)
	ZEND_ARG_TYPE_INFO(0, Handle, 0, 1)
	ZEND_ARG_INFO(0, Offset)
	ZEND_ARG_INFO(0, Length)
	ZEND_ARG_INFO(0, LockMask)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_BlockSync, 0, 0, 4)
	ZEND_ARG_TYPE_INFO(0, Handle, 0, 1)
	ZEND_ARG_INFO(0, Offset)
	ZEND_ARG_INFO(0, Length)
	ZEND_ARG_INFO(0, LockMask)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_Unblock, 0, 0, 3)
	ZEND_ARG_TYPE_INFO(0, Handle, 0, 1)
	ZEND_ARG_INFO(0, Offset)
	ZEND_ARG_INFO(0, Length)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_UnblockSync, 0, 0, 3)
	ZEND_ARG_TYPE_INFO(0, Handle, 0, 1)
	ZEND_ARG_INFO(0, Offset)
	ZEND_ARG_INFO(0, Length)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_CloseHandle, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Handle, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_CloseHandleSync, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Handle, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_Write, 0, 0, 4)
	ZEND_ARG_TYPE_INFO(0, Handle, 0, 1)
	ZEND_ARG_INFO(0, Offset)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(0, Size)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_WriteSync, 0, 0, 4)
	ZEND_ARG_TYPE_INFO(0, Handle, 0, 1)
	ZEND_ARG_INFO(0, Offset)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(0, Size)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_FinalizeTextWrite, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Handle, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_FinalizeTextWriteSync, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Handle, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_ExtensionCmd, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Extension, 0, 1)
	ZEND_ARG_TYPE_INFO(0, DataBuffer, 0, 1)
	ZEND_ARG_INFO(0, Size)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_ExtensionCmdSync, 0, 0, 1)
	ZEND_ARG_INFO(0, Extension)
	ZEND_ARG_TYPE_INFO(0, DataBuffer, 0, 1)
	ZEND_ARG_INFO(0, Size)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_TextSeek, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Handle, 0, 1)
	ZEND_ARG_INFO(0, LineNumber)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_TextSeekSync, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Handle, 0, 1)
	ZEND_ARG_INFO(0, LineNumber)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_SendVendorID, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, VendorID, TElSftpVendorIDExtension, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_SendVendorIDSync, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, VendorID, TElSftpVendorIDExtension, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_RequestFileHash, 0, 0, 4)
	ZEND_ARG_INFO(0, FileName)
	ZEND_ARG_INFO(0, StartOffset)
	ZEND_ARG_INFO(0, Length)
	ZEND_ARG_INFO(0, BlockSize)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_RequestFileHashSync, 0, 0, 4)
	ZEND_ARG_INFO(0, FileName)
	ZEND_ARG_INFO(0, StartOffset)
	ZEND_ARG_INFO(0, Length)
	ZEND_ARG_INFO(0, BlockSize)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_RequestFileHashByHandle, 0, 0, 4)
	ZEND_ARG_TYPE_INFO(0, Handle, 0, 1)
	ZEND_ARG_INFO(0, StartOffset)
	ZEND_ARG_INFO(0, Length)
	ZEND_ARG_INFO(0, BlockSize)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_RequestFileHashByHandleSync, 0, 0, 4)
	ZEND_ARG_TYPE_INFO(0, Handle, 0, 1)
	ZEND_ARG_INFO(0, StartOffset)
	ZEND_ARG_INFO(0, Length)
	ZEND_ARG_INFO(0, BlockSize)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_QueryAvailableSpace, 0, 0, 1)
	ZEND_ARG_INFO(0, Path)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_QueryAvailableSpaceSync, 0, 0, 1)
	ZEND_ARG_INFO(0, Path)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_QueryHomeDirectory, 0, 0, 1)
	ZEND_ARG_INFO(0, Username)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_QueryHomeDirectorySync, 0, 0, 1)
	ZEND_ARG_INFO(0, Username)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_QueryStatVFS, 0, 0, 1)
	ZEND_ARG_INFO(0, Path)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_QueryStatVFSSync, 0, 0, 1)
	ZEND_ARG_INFO(0, Path)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_CopyRemoteFile, 0, 0, 3)
	ZEND_ARG_INFO(0, Source)
	ZEND_ARG_INFO(0, Destination)
	ZEND_ARG_INFO(0, Overwrite)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_CopyRemoteFileSync, 0, 0, 3)
	ZEND_ARG_INFO(0, Source)
	ZEND_ARG_INFO(0, Destination)
	ZEND_ARG_INFO(0, Overwrite)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_CopyRemoteData, 0, 0, 5)
	ZEND_ARG_TYPE_INFO(0, ReadFrom, 0, 1)
	ZEND_ARG_INFO(0, ReadFromOffset)
	ZEND_ARG_TYPE_INFO(0, WriteTo, 0, 1)
	ZEND_ARG_INFO(0, WriteToOffset)
	ZEND_ARG_INFO(0, DataLength)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_CopyRemoteDataSync, 0, 0, 5)
	ZEND_ARG_TYPE_INFO(0, ReadFrom, 0, 1)
	ZEND_ARG_INFO(0, ReadFromOffset)
	ZEND_ARG_TYPE_INFO(0, WriteTo, 0, 1)
	ZEND_ARG_INFO(0, WriteToOffset)
	ZEND_ARG_INFO(0, DataLength)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_RequestTempFolder, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_RequestTempFolderSync, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_MakeTempFolder, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_MakeTempFolderSync, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_get_Active, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_get_Version, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_get_SFTPExtCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_get_SFTPExt, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_get_NewLineConvention, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_set_NewLineConvention, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_get_LocalNewLineConvention, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_set_LocalNewLineConvention, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_get_LastSyncComment, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_get_LastSyncError, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_get_LastReadCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_get_SBB3Compatible, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_set_SBB3Compatible, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_get_SynchronousMode, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_set_SynchronousMode, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_get_Tunnel, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_set_Tunnel, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElCustomSSHTunnel, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_get_SftpBufferSize, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_set_SftpBufferSize, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_get_UseUTF8, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_set_UseUTF8, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_get_UseUTF8OnV3, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_set_UseUTF8OnV3, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_get_RemoteCharset, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_set_RemoteCharset, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_get_NoCharacterEncoding, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_set_NoCharacterEncoding, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_get_LocalCharset, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_set_LocalCharset, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_get_Versions, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_set_Versions, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_get_ExtendedProperties, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_set_ExtendedProperties, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElSftpExtendedProperties, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_get_UploadBlockSize, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_set_UploadBlockSize, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_get_DownloadBlockSize, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_set_DownloadBlockSize, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_get_PipelineLength, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_set_PipelineLength, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_get_AutoAdjustTransferBlock, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_set_AutoAdjustTransferBlock, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_get_OperationErrorHandling, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_set_OperationErrorHandling, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_get_MessageLoop, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_set_MessageLoop, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_get_OnOpenConnection, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_set_OnOpenConnection, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_get_OnCloseConnection, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_set_OnCloseConnection, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_get_OnOpenFile, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_set_OnOpenFile, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_get_OnError, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_set_OnError, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_get_OnSuccess, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_set_OnSuccess, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_get_OnDirectoryListing, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_set_OnDirectoryListing, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_get_OnFileAttributes, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_set_OnFileAttributes, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_get_OnData, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_set_OnData, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_get_OnAbsolutePath, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_set_OnAbsolutePath, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_get_OnBlockTransferPrepared, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_set_OnBlockTransferPrepared, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_get_OnExtendedReply, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_set_OnExtendedReply, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_get_OnVersionSelect, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_set_OnVersionSelect, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_get_OnFileHash, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_set_OnFileHash, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_get_OnAvailableSpace, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_set_OnAvailableSpace, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_get_OnName, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_set_OnName, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_get_OnTransferCompleted, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_set_OnTransferCompleted, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_get_OnProgress, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_set_OnProgress, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_get_OnStatVFS, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient_set_OnStatVFS, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSftpClient___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AOwner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElSftpClient_methods[] = {
	PHP_ME(TElSftpClient, Read, arginfo_TElSftpClient_Read, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, ReadSync, arginfo_TElSftpClient_ReadSync, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, OpenStream, arginfo_TElSftpClient_OpenStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, Open, arginfo_TElSftpClient_Open, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, OpenSync, arginfo_TElSftpClient_OpenSync, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, CreateFile, arginfo_TElSftpClient_CreateFile, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, CreateFileSync, arginfo_TElSftpClient_CreateFileSync, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, OpenFile, arginfo_TElSftpClient_OpenFile, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, OpenFileSync, arginfo_TElSftpClient_OpenFileSync, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, OpenDirectory, arginfo_TElSftpClient_OpenDirectory, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, OpenDirectorySync, arginfo_TElSftpClient_OpenDirectorySync, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, ReadDirectory, arginfo_TElSftpClient_ReadDirectory, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, ReadDirectorySync, arginfo_TElSftpClient_ReadDirectorySync, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, RemoveFile, arginfo_TElSftpClient_RemoveFile, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, RemoveFileSync, arginfo_TElSftpClient_RemoveFileSync, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, RemoveFiles, arginfo_TElSftpClient_RemoveFiles, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, RemoveFilesSync, arginfo_TElSftpClient_RemoveFilesSync, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, RenameFile, arginfo_TElSftpClient_RenameFile, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, RenameFileSync, arginfo_TElSftpClient_RenameFileSync, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, MakeDirectory, arginfo_TElSftpClient_MakeDirectory, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, MakeDirectorySync, arginfo_TElSftpClient_MakeDirectorySync, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, RemoveDirectory, arginfo_TElSftpClient_RemoveDirectory, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, RemoveDirectorySync, arginfo_TElSftpClient_RemoveDirectorySync, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, RequestAttributes, arginfo_TElSftpClient_RequestAttributes, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, RequestAttributesSync, arginfo_TElSftpClient_RequestAttributesSync, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, SetAttributes, arginfo_TElSftpClient_SetAttributes, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, SetAttributesSync, arginfo_TElSftpClient_SetAttributesSync, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, SetAttributesByHandle, arginfo_TElSftpClient_SetAttributesByHandle, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, SetAttributesByHandleSync, arginfo_TElSftpClient_SetAttributesByHandleSync, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, ReadSymLink, arginfo_TElSftpClient_ReadSymLink, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, ReadSymLinkSync, arginfo_TElSftpClient_ReadSymLinkSync, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, CreateSymLink, arginfo_TElSftpClient_CreateSymLink, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, CreateSymLinkSync, arginfo_TElSftpClient_CreateSymLinkSync, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, CreateHardLink, arginfo_TElSftpClient_CreateHardLink, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, CreateHardLinkSync, arginfo_TElSftpClient_CreateHardLinkSync, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, RequestAbsolutePath, arginfo_TElSftpClient_RequestAbsolutePath, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, RequestAbsolutePathSync, arginfo_TElSftpClient_RequestAbsolutePathSync, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, RequestAbsolutePathEx, arginfo_TElSftpClient_RequestAbsolutePathEx, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, RequestAbsolutePathExSync, arginfo_TElSftpClient_RequestAbsolutePathExSync, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, Block, arginfo_TElSftpClient_Block, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, BlockSync, arginfo_TElSftpClient_BlockSync, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, Unblock, arginfo_TElSftpClient_Unblock, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, UnblockSync, arginfo_TElSftpClient_UnblockSync, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, CloseHandle, arginfo_TElSftpClient_CloseHandle, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, CloseHandleSync, arginfo_TElSftpClient_CloseHandleSync, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, Write, arginfo_TElSftpClient_Write, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, WriteSync, arginfo_TElSftpClient_WriteSync, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, FinalizeTextWrite, arginfo_TElSftpClient_FinalizeTextWrite, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, FinalizeTextWriteSync, arginfo_TElSftpClient_FinalizeTextWriteSync, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, ExtensionCmd, arginfo_TElSftpClient_ExtensionCmd, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, ExtensionCmdSync, arginfo_TElSftpClient_ExtensionCmdSync, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, TextSeek, arginfo_TElSftpClient_TextSeek, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, TextSeekSync, arginfo_TElSftpClient_TextSeekSync, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, SendVendorID, arginfo_TElSftpClient_SendVendorID, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, SendVendorIDSync, arginfo_TElSftpClient_SendVendorIDSync, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, RequestFileHash, arginfo_TElSftpClient_RequestFileHash, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, RequestFileHashSync, arginfo_TElSftpClient_RequestFileHashSync, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, RequestFileHashByHandle, arginfo_TElSftpClient_RequestFileHashByHandle, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, RequestFileHashByHandleSync, arginfo_TElSftpClient_RequestFileHashByHandleSync, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, QueryAvailableSpace, arginfo_TElSftpClient_QueryAvailableSpace, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, QueryAvailableSpaceSync, arginfo_TElSftpClient_QueryAvailableSpaceSync, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, QueryHomeDirectory, arginfo_TElSftpClient_QueryHomeDirectory, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, QueryHomeDirectorySync, arginfo_TElSftpClient_QueryHomeDirectorySync, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, QueryStatVFS, arginfo_TElSftpClient_QueryStatVFS, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, QueryStatVFSSync, arginfo_TElSftpClient_QueryStatVFSSync, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, CopyRemoteFile, arginfo_TElSftpClient_CopyRemoteFile, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, CopyRemoteFileSync, arginfo_TElSftpClient_CopyRemoteFileSync, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, CopyRemoteData, arginfo_TElSftpClient_CopyRemoteData, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, CopyRemoteDataSync, arginfo_TElSftpClient_CopyRemoteDataSync, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, RequestTempFolder, arginfo_TElSftpClient_RequestTempFolder, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, RequestTempFolderSync, arginfo_TElSftpClient_RequestTempFolderSync, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, MakeTempFolder, arginfo_TElSftpClient_MakeTempFolder, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, MakeTempFolderSync, arginfo_TElSftpClient_MakeTempFolderSync, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, get_Active, arginfo_TElSftpClient_get_Active, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, get_Version, arginfo_TElSftpClient_get_Version, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, get_SFTPExtCount, arginfo_TElSftpClient_get_SFTPExtCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, get_SFTPExt, arginfo_TElSftpClient_get_SFTPExt, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, get_NewLineConvention, arginfo_TElSftpClient_get_NewLineConvention, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, set_NewLineConvention, arginfo_TElSftpClient_set_NewLineConvention, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, get_LocalNewLineConvention, arginfo_TElSftpClient_get_LocalNewLineConvention, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, set_LocalNewLineConvention, arginfo_TElSftpClient_set_LocalNewLineConvention, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, get_LastSyncComment, arginfo_TElSftpClient_get_LastSyncComment, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, get_LastSyncError, arginfo_TElSftpClient_get_LastSyncError, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, get_LastReadCount, arginfo_TElSftpClient_get_LastReadCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, get_SBB3Compatible, arginfo_TElSftpClient_get_SBB3Compatible, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, set_SBB3Compatible, arginfo_TElSftpClient_set_SBB3Compatible, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, get_SynchronousMode, arginfo_TElSftpClient_get_SynchronousMode, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, set_SynchronousMode, arginfo_TElSftpClient_set_SynchronousMode, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, get_Tunnel, arginfo_TElSftpClient_get_Tunnel, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, set_Tunnel, arginfo_TElSftpClient_set_Tunnel, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, get_SftpBufferSize, arginfo_TElSftpClient_get_SftpBufferSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, set_SftpBufferSize, arginfo_TElSftpClient_set_SftpBufferSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, get_UseUTF8, arginfo_TElSftpClient_get_UseUTF8, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, set_UseUTF8, arginfo_TElSftpClient_set_UseUTF8, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, get_UseUTF8OnV3, arginfo_TElSftpClient_get_UseUTF8OnV3, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, set_UseUTF8OnV3, arginfo_TElSftpClient_set_UseUTF8OnV3, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, get_RemoteCharset, arginfo_TElSftpClient_get_RemoteCharset, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, set_RemoteCharset, arginfo_TElSftpClient_set_RemoteCharset, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, get_NoCharacterEncoding, arginfo_TElSftpClient_get_NoCharacterEncoding, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, set_NoCharacterEncoding, arginfo_TElSftpClient_set_NoCharacterEncoding, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, get_LocalCharset, arginfo_TElSftpClient_get_LocalCharset, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, set_LocalCharset, arginfo_TElSftpClient_set_LocalCharset, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, get_Versions, arginfo_TElSftpClient_get_Versions, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, set_Versions, arginfo_TElSftpClient_set_Versions, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, get_ExtendedProperties, arginfo_TElSftpClient_get_ExtendedProperties, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, set_ExtendedProperties, arginfo_TElSftpClient_set_ExtendedProperties, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, get_UploadBlockSize, arginfo_TElSftpClient_get_UploadBlockSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, set_UploadBlockSize, arginfo_TElSftpClient_set_UploadBlockSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, get_DownloadBlockSize, arginfo_TElSftpClient_get_DownloadBlockSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, set_DownloadBlockSize, arginfo_TElSftpClient_set_DownloadBlockSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, get_PipelineLength, arginfo_TElSftpClient_get_PipelineLength, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, set_PipelineLength, arginfo_TElSftpClient_set_PipelineLength, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, get_AutoAdjustTransferBlock, arginfo_TElSftpClient_get_AutoAdjustTransferBlock, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, set_AutoAdjustTransferBlock, arginfo_TElSftpClient_set_AutoAdjustTransferBlock, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, get_OperationErrorHandling, arginfo_TElSftpClient_get_OperationErrorHandling, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, set_OperationErrorHandling, arginfo_TElSftpClient_set_OperationErrorHandling, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, get_MessageLoop, arginfo_TElSftpClient_get_MessageLoop, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, set_MessageLoop, arginfo_TElSftpClient_set_MessageLoop, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, get_OnOpenConnection, arginfo_TElSftpClient_get_OnOpenConnection, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, set_OnOpenConnection, arginfo_TElSftpClient_set_OnOpenConnection, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, get_OnCloseConnection, arginfo_TElSftpClient_get_OnCloseConnection, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, set_OnCloseConnection, arginfo_TElSftpClient_set_OnCloseConnection, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, get_OnOpenFile, arginfo_TElSftpClient_get_OnOpenFile, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, set_OnOpenFile, arginfo_TElSftpClient_set_OnOpenFile, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, get_OnError, arginfo_TElSftpClient_get_OnError, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, set_OnError, arginfo_TElSftpClient_set_OnError, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, get_OnSuccess, arginfo_TElSftpClient_get_OnSuccess, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, set_OnSuccess, arginfo_TElSftpClient_set_OnSuccess, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, get_OnDirectoryListing, arginfo_TElSftpClient_get_OnDirectoryListing, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, set_OnDirectoryListing, arginfo_TElSftpClient_set_OnDirectoryListing, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, get_OnFileAttributes, arginfo_TElSftpClient_get_OnFileAttributes, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, set_OnFileAttributes, arginfo_TElSftpClient_set_OnFileAttributes, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, get_OnData, arginfo_TElSftpClient_get_OnData, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, set_OnData, arginfo_TElSftpClient_set_OnData, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, get_OnAbsolutePath, arginfo_TElSftpClient_get_OnAbsolutePath, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, set_OnAbsolutePath, arginfo_TElSftpClient_set_OnAbsolutePath, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, get_OnBlockTransferPrepared, arginfo_TElSftpClient_get_OnBlockTransferPrepared, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, set_OnBlockTransferPrepared, arginfo_TElSftpClient_set_OnBlockTransferPrepared, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, get_OnExtendedReply, arginfo_TElSftpClient_get_OnExtendedReply, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, set_OnExtendedReply, arginfo_TElSftpClient_set_OnExtendedReply, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, get_OnVersionSelect, arginfo_TElSftpClient_get_OnVersionSelect, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, set_OnVersionSelect, arginfo_TElSftpClient_set_OnVersionSelect, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, get_OnFileHash, arginfo_TElSftpClient_get_OnFileHash, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, set_OnFileHash, arginfo_TElSftpClient_set_OnFileHash, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, get_OnAvailableSpace, arginfo_TElSftpClient_get_OnAvailableSpace, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, set_OnAvailableSpace, arginfo_TElSftpClient_set_OnAvailableSpace, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, get_OnName, arginfo_TElSftpClient_get_OnName, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, set_OnName, arginfo_TElSftpClient_set_OnName, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, get_OnTransferCompleted, arginfo_TElSftpClient_get_OnTransferCompleted, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, set_OnTransferCompleted, arginfo_TElSftpClient_set_OnTransferCompleted, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, get_OnProgress, arginfo_TElSftpClient_get_OnProgress, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, set_OnProgress, arginfo_TElSftpClient_set_OnProgress, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, get_OnStatVFS, arginfo_TElSftpClient_get_OnStatVFS, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, set_OnStatVFS, arginfo_TElSftpClient_set_OnStatVFS, ZEND_ACC_PUBLIC)
	PHP_ME(TElSftpClient, __construct, arginfo_TElSftpClient___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSftpClient(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSftpClient_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSftpClient", TElSftpClient_methods);
	if (NULL == TComponent_ce_ptr)
		Register_TComponent(TSRMLS_C);
	TElSftpClient_ce_ptr = zend_register_internal_class_ex(&ce, TComponent_ce_ptr, NULL TSRMLS_CC);
}

void Register_SBSftp_Constants(int module_number TSRMLS_DC)
{
	SB_REGISTER_STRING_CONSTANT(SBSftp, SResizeNotSupported, SB_SResizeNotSupported, SB_SResizeNotSupported);
	SB_REGISTER_LONG_CONSTANT(SBSftp, SFTP_OPTIMAL_UPLOAD_BLOCK_SIZE, SB_SFTP_OPTIMAL_UPLOAD_BLOCK_SIZE, SB_SFTP_OPTIMAL_UPLOAD_BLOCK_SIZE);
	SB_REGISTER_LONG_CONSTANT(SBSftp, SFTP_OPTIMAL_DOWNLOAD_BLOCK_SIZE, SB_SFTP_OPTIMAL_DOWNLOAD_BLOCK_SIZE, SB_SFTP_OPTIMAL_DOWNLOAD_BLOCK_SIZE);
}

void Register_SBSftp_Aliases(TSRMLS_D)
{
	if (NULL == TElSftpStream_ce_ptr)
		Register_TElSftpStream(TSRMLS_C);
	zend_register_class_alias("ElSftpStream", TElSftpStream_ce_ptr);
	if (NULL == TElSftpClient_ce_ptr)
		Register_TElSftpClient(TSRMLS_C);
	zend_register_class_alias("ElSftpClient", TElSftpClient_ce_ptr);
}

