#include "sbsocket.h"

zend_class_entry *TElShutdownDirection_ce_ptr = NULL;

zend_class_entry *TElSocketState_ce_ptr = NULL;

zend_class_entry *TElSocketType_ce_ptr = NULL;

zend_class_entry *TElSocksVersion_ce_ptr = NULL;

zend_class_entry *TElSocksAuthentication_ce_ptr = NULL;

zend_class_entry *TElWebTunnelAuthentication_ce_ptr = NULL;

zend_class_entry *TElBandwidthPolicy_ce_ptr = NULL;

#ifdef SB_WINDOWS
SB_PHP_METHOD(sockaddr_storage, __construct)
#else
SB_PHP_METHOD(hostent, __construct)
#endif
{
#ifdef SB_WINDOWS
	if (ZEND_NUM_ARGS() == 0)
#else
	if (ZEND_NUM_ARGS() == 0)
#endif
	{
#ifdef SB_WINDOWS
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(sockaddr_storage));
		intern->len = sizeof(sockaddr_storage);
		intern->ownData = 1;
#else
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(hostent));
		intern->len = sizeof(hostent);
		intern->ownData = 1;
#endif
	}
	else
#ifdef SB_WINDOWS
		ZEND_WRONG_PARAM_COUNT();
#else
		ZEND_WRONG_PARAM_COUNT();
#endif
}

#ifdef SB_WINDOWS
SB_PHP_METHOD(sockaddr_storage, getSizeOf)
#else
SB_PHP_METHOD(hostent, getSizeOf)
#endif
{
#ifdef SB_WINDOWS
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(sockaddr_storage));
#else
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(hostent));
#endif
}

#ifdef SB_WINDOWS
ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBBaseStruct_GetField, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBBaseStruct_SetField, 0, 0, 1)
	ZEND_ARG_INFO(0, value)
ZEND_END_ARG_INFO()

SB_PHP_METHOD(sockaddr_storage, get_ss_family)
#else
ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBBaseStruct_GetField, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBBaseStruct_SetField, 0, 0, 1)
	ZEND_ARG_INFO(0, value)
ZEND_END_ARG_INFO()

SB_PHP_METHOD(hostent, get_h_addrtype)
#endif
{
#ifdef SB_WINDOWS
	SBStuctGetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
#else
	SBStuctGetFieldInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 8);
#endif
}

#ifdef SB_WINDOWS
SB_PHP_METHOD(sockaddr_storage, set_ss_family)
#else
SB_PHP_METHOD(hostent, set_h_addrtype)
#endif
{
#ifdef SB_WINDOWS
	SBStuctSetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
#else
	SBStuctSetFieldInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 8);
#endif
}

#ifdef SB_WINDOWS
SB_PHP_METHOD(sockaddr_storage, get___ss_align)
#else
SB_PHP_METHOD(hostent, get_h_length)
#endif
{
#ifdef SB_WINDOWS
	SBStuctGetFieldInt64(INTERNAL_FUNCTION_PARAM_PASSTHRU, 8);
#else
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 12);
#endif
}

#ifdef SB_WINDOWS
SB_PHP_METHOD(sockaddr_storage, set___ss_align)
#else
SB_PHP_METHOD(hostent, set_h_length)
#endif
{
#ifdef SB_WINDOWS
	SBStuctSetFieldInt64(INTERNAL_FUNCTION_PARAM_PASSTHRU, 8);
#else
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 12);
#endif
}

#ifdef SB_WINDOWS
zend_class_entry *sockaddr_storage_ce_ptr = NULL;

static zend_function_entry sockaddr_storage_methods[] = {
	PHP_ME(sockaddr_storage, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(sockaddr_storage, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(sockaddr_storage, get_ss_family, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(sockaddr_storage, set_ss_family, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(sockaddr_storage, get___ss_align, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(sockaddr_storage, set___ss_align, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_sockaddr_storage(TSRMLS_D)
{
	zend_class_entry ce;
	if (sockaddr_storage_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "sockaddr_storage", sockaddr_storage_methods);
	sockaddr_storage_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

void SB_CALLBACK TSBSocksAuthMethodChooseEventRaw(void * _ObjectData, TObjectHandle Sender, const TElSocksAuthenticationRaw pAuthMethods[], int32_t szAuthMethods, TElSocksAuthenticationRaw * AuthMethod, int8_t * Cancel)
{
	zval *retval_ptr;
	zval **params[4];
	zval * zSender;
	zval * zAuthMethods;
	zval * zAuthMethod;
	zval * zCancel;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zAuthMethods);
	SBSetByteArrayToZValP((uint8_t *)pAuthMethods, szAuthMethods, zAuthMethods);
	MAKE_STD_ZVAL(zAuthMethod);
	ZVAL_LONG(zAuthMethod, (long)*AuthMethod);
	MAKE_STD_ZVAL(zCancel);
	ZVAL_BOOL(zCancel, (zend_bool)*Cancel);

	params[0] = &zSender;
	params[1] = &zAuthMethods;
	params[2] = &zAuthMethod;
	params[3] = &zCancel;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 4, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zAuthMethods);
	*AuthMethod = (TElSocksAuthenticationRaw)Z_LVAL_P(zAuthMethod);
	zval_ptr_dtor(&zAuthMethod);
	*Cancel = (int8_t)Z_BVAL_P(zCancel);
	zval_ptr_dtor(&zCancel);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBSocksAuthPasswordEventRaw(void * _ObjectData, TObjectHandle Sender, const char * pcUsername, int32_t szUsername, const char * pcPassword, int32_t szPassword, int8_t * Accept)
{
	zval *retval_ptr;
	zval **params[4];
	zval * zSender;
	zval * zUsername;
	zval * zPassword;
	zval * zAccept;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zUsername);
	ZVAL_STRINGL(zUsername, pcUsername, szUsername, 1);
	MAKE_STD_ZVAL(zPassword);
	ZVAL_STRINGL(zPassword, pcPassword, szPassword, 1);
	MAKE_STD_ZVAL(zAccept);
	ZVAL_BOOL(zAccept, (zend_bool)*Accept);

	params[0] = &zSender;
	params[1] = &zUsername;
	params[2] = &zPassword;
	params[3] = &zAccept;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 4, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zUsername);
	zval_ptr_dtor(&zPassword);
	*Accept = (int8_t)Z_BVAL_P(zAccept);
	zval_ptr_dtor(&zAccept);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBSocksConnectEventRaw(void * _ObjectData, TObjectHandle Sender, const char * pcDestHost, int32_t szDestHost, int32_t DestPort, int8_t * Allow)
{
	zval *retval_ptr;
	zval **params[4];
	zval * zSender;
	zval * zDestHost;
	zval * zDestPort;
	zval * zAllow;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zDestHost);
	ZVAL_STRINGL(zDestHost, pcDestHost, szDestHost, 1);
	MAKE_STD_ZVAL(zDestPort);
	ZVAL_LONG(zDestPort, (long)DestPort);
	MAKE_STD_ZVAL(zAllow);
	ZVAL_BOOL(zAllow, (zend_bool)*Allow);

	params[0] = &zSender;
	params[1] = &zDestHost;
	params[2] = &zDestPort;
	params[3] = &zAllow;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 4, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zDestHost);
	zval_ptr_dtor(&zDestPort);
	*Allow = (int8_t)Z_BVAL_P(zAllow);
	zval_ptr_dtor(&zAllow);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TElSocketSecondaryEventRaw(void * _ObjectData, TObjectHandle Sender, TElSocketHandle Socket, int32_t State, int8_t * AbortConnect)
{
	zval *retval_ptr;
	zval **params[4];
	zval * zSender;
	zval * zSocket;
	zval * zState;
	zval * zAbortConnect;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zSocket);
	SBInitObject(zSocket, TElSocket_ce_ptr, Socket TSRMLS_CC);
	MAKE_STD_ZVAL(zState);
	ZVAL_LONG(zState, (long)State);
	MAKE_STD_ZVAL(zAbortConnect);
	ZVAL_BOOL(zAbortConnect, (zend_bool)*AbortConnect);

	params[0] = &zSender;
	params[1] = &zSocket;
	params[2] = &zState;
	params[3] = &zAbortConnect;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 4, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zSocket);
	zval_ptr_dtor(&zState);
	*AbortConnect = (int8_t)Z_BVAL_P(zAbortConnect);
	zval_ptr_dtor(&zAbortConnect);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBDNSResolveEventRaw(void * _ObjectData, TObjectHandle Sender, const char * pcHostName, int32_t szHostName, TElDNSResourceRecordSetHandle Response, int32_t ResolveResult, TSBDNSSecurityStatusRaw SecurityStatus)
{
	zval *retval_ptr;
	zval **params[5];
	zval * zSender;
	zval * zHostName;
	zval * zResponse;
	zval * zResolveResult;
	zval * zSecurityStatus;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zHostName);
	ZVAL_STRINGL(zHostName, pcHostName, szHostName, 1);
	MAKE_STD_ZVAL(zResponse);
	SBInitObject(zResponse, TElDNSResourceRecordSet_ce_ptr, Response TSRMLS_CC);
	MAKE_STD_ZVAL(zResolveResult);
	ZVAL_LONG(zResolveResult, (long)ResolveResult);
	MAKE_STD_ZVAL(zSecurityStatus);
	ZVAL_LONG(zSecurityStatus, (long)SecurityStatus);

	params[0] = &zSender;
	params[1] = &zHostName;
	params[2] = &zResponse;
	params[3] = &zResolveResult;
	params[4] = &zSecurityStatus;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 5, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zHostName);
	zval_ptr_dtor(&zResponse);
	zval_ptr_dtor(&zResolveResult);
	zval_ptr_dtor(&zSecurityStatus);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

zend_class_entry *TElSocket_ce_ptr = NULL;

SB_PHP_METHOD(TElSocket, LoadIPv6Proc_Inst)
{
	char *sProcName;
	int sProcName_len;
	int32_t l4WinsockUsedRaw;
	int32_t l4Wship6UsedRaw;
	SBArrayZValInfo piProc;
	zval *zl4WinsockUsed;
	zval *zl4Wship6Used;
	zval *zpProc;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "szzz", &sProcName, &sProcName_len, &zpProc, &zl4WinsockUsed, &zl4Wship6Used) == SUCCESS) && (Z_TYPE_P(zpProc) == IS_OBJECT) && (Z_OBJCE_P(zpProc) == TSBPointer_ce_ptr) && PZVAL_IS_REF(zl4WinsockUsed) && (IS_LONG == Z_TYPE_P(zl4WinsockUsed)) && PZVAL_IS_REF(zl4Wship6Used) && (IS_LONG == Z_TYPE_P(zl4Wship6Used)))
	{
		int8_t bOutResultRaw = 0;
		SBInitPointerZValInfo(zpProc, &piProc TSRMLS_CC);
		l4WinsockUsedRaw = (int32_t)Z_LVAL_P(zl4WinsockUsed);
		l4Wship6UsedRaw = (int32_t)Z_LVAL_P(zl4Wship6Used);
		SBCheckError(TElSocket_LoadIPv6Proc_1(SBGetObjectHandle(getThis() TSRMLS_CC), sProcName, (int32_t)sProcName_len, &piProc.data, &l4WinsockUsedRaw, &l4Wship6UsedRaw, &bOutResultRaw) TSRMLS_CC);
		SBSetPointerToZVal(&piProc, zpProc);
		ZVAL_LONG(zl4WinsockUsed, (long)l4WinsockUsedRaw);
		ZVAL_LONG(zl4Wship6Used, (long)l4Wship6UsedRaw);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string, TSBPointer, &integer, &integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSocket, LoadIPv6Proc)
{
	char *sProcName;
	int sProcName_len;
	int32_t l4WinsockUsedRaw;
	int32_t l4Wship6UsedRaw;
	SBArrayZValInfo piProc;
	zval *zl4WinsockUsed;
	zval *zl4Wship6Used;
	zval *zpProc;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "szzz", &sProcName, &sProcName_len, &zpProc, &zl4WinsockUsed, &zl4Wship6Used) == SUCCESS) && (Z_TYPE_P(zpProc) == IS_OBJECT) && (Z_OBJCE_P(zpProc) == TSBPointer_ce_ptr) && PZVAL_IS_REF(zl4WinsockUsed) && (IS_LONG == Z_TYPE_P(zl4WinsockUsed)) && PZVAL_IS_REF(zl4Wship6Used) && (IS_LONG == Z_TYPE_P(zl4Wship6Used)))
	{
		int8_t bOutResultRaw = 0;
		SBInitPointerZValInfo(zpProc, &piProc TSRMLS_CC);
		l4WinsockUsedRaw = (int32_t)Z_LVAL_P(zl4WinsockUsed);
		l4Wship6UsedRaw = (int32_t)Z_LVAL_P(zl4Wship6Used);
		SBCheckError(TElSocket_LoadIPv6Proc(sProcName, (int32_t)sProcName_len, &piProc.data, &l4WinsockUsedRaw, &l4Wship6UsedRaw, &bOutResultRaw) TSRMLS_CC);
		SBSetPointerToZVal(&piProc, zpProc);
		ZVAL_LONG(zl4WinsockUsed, (long)l4WinsockUsedRaw);
		ZVAL_LONG(zl4Wship6Used, (long)l4Wship6UsedRaw);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string, TSBPointer, &integer, &integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSocket, InitializeIPv6_Inst)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElSocket_InitializeIPv6_1(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSocket, InitializeIPv6)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElSocket_InitializeIPv6() TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSocket, FinalizeIPv6_Inst)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElSocket_FinalizeIPv6_1(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSocket, FinalizeIPv6)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElSocket_FinalizeIPv6() TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

#else
zend_class_entry *hostent_ce_ptr = NULL;

static zend_function_entry hostent_methods[] = {
	PHP_ME(hostent, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(hostent, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(hostent, get_h_addrtype, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(hostent, set_h_addrtype, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(hostent, get_h_length, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(hostent, set_h_length, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_hostent(TSRMLS_D)
{
	zend_class_entry ce;
	if (hostent_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "hostent", hostent_methods);
	hostent_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(sockaddr_storage, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(sockaddr_storage));
		intern->len = sizeof(sockaddr_storage);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(sockaddr_storage, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(sockaddr_storage));
}

SB_PHP_METHOD(sockaddr_storage, get_ss_family)
{
	SBStuctGetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(sockaddr_storage, set_ss_family)
{
	SBStuctSetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(sockaddr_storage, get___ss_align)
{
	SBStuctGetFieldInt64(INTERNAL_FUNCTION_PARAM_PASSTHRU, 8);
}

SB_PHP_METHOD(sockaddr_storage, set___ss_align)
{
	SBStuctSetFieldInt64(INTERNAL_FUNCTION_PARAM_PASSTHRU, 8);
}

zend_class_entry *sockaddr_storage_ce_ptr = NULL;

static zend_function_entry sockaddr_storage_methods[] = {
	PHP_ME(sockaddr_storage, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(sockaddr_storage, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(sockaddr_storage, get_ss_family, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(sockaddr_storage, set_ss_family, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(sockaddr_storage, get___ss_align, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(sockaddr_storage, set___ss_align, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_sockaddr_storage(TSRMLS_D)
{
	zend_class_entry ce;
	if (sockaddr_storage_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "sockaddr_storage", sockaddr_storage_methods);
	sockaddr_storage_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

void SB_CALLBACK TSBSocksAuthMethodChooseEventRaw(void * _ObjectData, TObjectHandle Sender, const TElSocksAuthenticationRaw pAuthMethods[], int32_t szAuthMethods, TElSocksAuthenticationRaw * AuthMethod, int8_t * Cancel)
{
	zval *retval_ptr;
	zval **params[4];
	zval * zSender;
	zval * zAuthMethods;
	zval * zAuthMethod;
	zval * zCancel;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zAuthMethods);
	SBSetByteArrayToZValP((uint8_t *)pAuthMethods, szAuthMethods, zAuthMethods);
	MAKE_STD_ZVAL(zAuthMethod);
	ZVAL_LONG(zAuthMethod, (long)*AuthMethod);
	MAKE_STD_ZVAL(zCancel);
	ZVAL_BOOL(zCancel, (zend_bool)*Cancel);

	params[0] = &zSender;
	params[1] = &zAuthMethods;
	params[2] = &zAuthMethod;
	params[3] = &zCancel;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 4, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zAuthMethods);
	*AuthMethod = (TElSocksAuthenticationRaw)Z_LVAL_P(zAuthMethod);
	zval_ptr_dtor(&zAuthMethod);
	*Cancel = (int8_t)Z_BVAL_P(zCancel);
	zval_ptr_dtor(&zCancel);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBSocksAuthPasswordEventRaw(void * _ObjectData, TObjectHandle Sender, const char * pcUsername, int32_t szUsername, const char * pcPassword, int32_t szPassword, int8_t * Accept)
{
	zval *retval_ptr;
	zval **params[4];
	zval * zSender;
	zval * zUsername;
	zval * zPassword;
	zval * zAccept;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zUsername);
	ZVAL_STRINGL(zUsername, pcUsername, szUsername, 1);
	MAKE_STD_ZVAL(zPassword);
	ZVAL_STRINGL(zPassword, pcPassword, szPassword, 1);
	MAKE_STD_ZVAL(zAccept);
	ZVAL_BOOL(zAccept, (zend_bool)*Accept);

	params[0] = &zSender;
	params[1] = &zUsername;
	params[2] = &zPassword;
	params[3] = &zAccept;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 4, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zUsername);
	zval_ptr_dtor(&zPassword);
	*Accept = (int8_t)Z_BVAL_P(zAccept);
	zval_ptr_dtor(&zAccept);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBSocksConnectEventRaw(void * _ObjectData, TObjectHandle Sender, const char * pcDestHost, int32_t szDestHost, int32_t DestPort, int8_t * Allow)
{
	zval *retval_ptr;
	zval **params[4];
	zval * zSender;
	zval * zDestHost;
	zval * zDestPort;
	zval * zAllow;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zDestHost);
	ZVAL_STRINGL(zDestHost, pcDestHost, szDestHost, 1);
	MAKE_STD_ZVAL(zDestPort);
	ZVAL_LONG(zDestPort, (long)DestPort);
	MAKE_STD_ZVAL(zAllow);
	ZVAL_BOOL(zAllow, (zend_bool)*Allow);

	params[0] = &zSender;
	params[1] = &zDestHost;
	params[2] = &zDestPort;
	params[3] = &zAllow;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 4, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zDestHost);
	zval_ptr_dtor(&zDestPort);
	*Allow = (int8_t)Z_BVAL_P(zAllow);
	zval_ptr_dtor(&zAllow);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TElSocketSecondaryEventRaw(void * _ObjectData, TObjectHandle Sender, TElSocketHandle Socket, int32_t State, int8_t * AbortConnect)
{
	zval *retval_ptr;
	zval **params[4];
	zval * zSender;
	zval * zSocket;
	zval * zState;
	zval * zAbortConnect;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zSocket);
	SBInitObject(zSocket, TElSocket_ce_ptr, Socket TSRMLS_CC);
	MAKE_STD_ZVAL(zState);
	ZVAL_LONG(zState, (long)State);
	MAKE_STD_ZVAL(zAbortConnect);
	ZVAL_BOOL(zAbortConnect, (zend_bool)*AbortConnect);

	params[0] = &zSender;
	params[1] = &zSocket;
	params[2] = &zState;
	params[3] = &zAbortConnect;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 4, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zSocket);
	zval_ptr_dtor(&zState);
	*AbortConnect = (int8_t)Z_BVAL_P(zAbortConnect);
	zval_ptr_dtor(&zAbortConnect);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

zend_class_entry *TElSocket_ce_ptr = NULL;
#endif

SB_PHP_METHOD(TElSocket, ShutdownSocket)
{
	long fDirection;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElSocket_ShutdownSocket(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fDirection) == SUCCESS)
	{
		SBCheckError(TElSocket_ShutdownSocket_1(SBGetObjectHandle(getThis() TSRMLS_CC), (TElShutdownDirectionRaw)fDirection) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("() or (integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSocket, Close)
{
	long l4Timeout;
	zend_bool bForced;
	zend_bool bGradually;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bForced) == SUCCESS)
	{
		SBCheckError(TElSocket_Close(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bForced) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "bl", &bForced, &l4Timeout) == SUCCESS)
	{
		SBCheckError(TElSocket_Close_1(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bForced, (int32_t)l4Timeout) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "blb", &bForced, &l4Timeout, &bGradually) == SUCCESS)
	{
		SBCheckError(TElSocket_Close_2(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bForced, (int32_t)l4Timeout, (int8_t)bGradually) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool) or (bool, integer) or (bool, integer, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSocket, StartAsyncConnect)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSocket_StartAsyncConnect(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSocket, AsyncConnect)
{
	long l4Timeout;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Timeout) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSocket_AsyncConnect(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Timeout, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSocket, FinalizeWinSock_Inst)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElSocket_FinalizeWinSock_1(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSocket, FinalizeWinSock)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElSocket_FinalizeWinSock() TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSocket, InitializeWinSock_Inst)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElSocket_InitializeWinSock_1(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSocket, InitializeWinSock)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElSocket_InitializeWinSock() TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSocket, LastNetError)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSocket_LastNetError(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSocket, IPFromHost)
{
	char *sHost;
	int sHost_len;
	uint32_t _err;
#ifdef SB_WINDOWS
	zend_bool bUseIPv6;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sb", &sHost, &sHost_len, &bUseIPv6) == SUCCESS)
#else
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sHost, &sHost_len) == SUCCESS)
#endif
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
#ifdef SB_WINDOWS
		_err = TElSocket_IPFromHost(SBGetObjectHandle(getThis() TSRMLS_CC), sHost, (int32_t)sHost_len, (int8_t)bUseIPv6, sOutResult, &sOutResult_len);
#else
		_err = TElSocket_IPFromHost(SBGetObjectHandle(getThis() TSRMLS_CC), sHost, (int32_t)sHost_len, sOutResult, &sOutResult_len);
#endif
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(-315278357, 3, sOutResult, &sOutResult_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(-60845863, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
#endif
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
#ifdef SB_WINDOWS
		SBErrorExpectsArguments("(string, bool)" TSRMLS_CC);
	}
}

#else
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}
#endif

SB_PHP_METHOD(TElSocket, Receive)
{
	int32_t l4ReceivedRaw;
	long l4DataLen;
	SBArrayZValInfo piData;
	zval *zl4Received;
	zval *zpData;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlz", &zpData, &l4DataLen, &zl4Received) == SUCCESS) && ((Z_TYPE_P(zpData) == IS_STRING) || (Z_TYPE_P(zpData) == IS_ARRAY) || (Z_TYPE_P(zpData) == IS_NULL) || ((Z_TYPE_P(zpData) == IS_OBJECT) && (Z_OBJCE_P(zpData) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4Received) && (IS_LONG == Z_TYPE_P(zl4Received)))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpData, &piData TSRMLS_CC)) RETURN_FALSE;
		l4ReceivedRaw = (int32_t)Z_LVAL_P(zl4Received);
		SBCheckError(TElSocket_Receive(SBGetObjectHandle(getThis() TSRMLS_CC), piData.data, (int32_t)l4DataLen, &l4ReceivedRaw, &l4OutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piData);
		ZVAL_LONG(zl4Received, (long)l4ReceivedRaw);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer, &integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSocket, Send)
{
	int32_t l4SentRaw;
	long l4DataLen;
	SBArrayZValInfo piData;
	zval *zl4Sent;
	zval *zpData;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlz", &zpData, &l4DataLen, &zl4Sent) == SUCCESS) && ((Z_TYPE_P(zpData) == IS_STRING) || (Z_TYPE_P(zpData) == IS_ARRAY) || (Z_TYPE_P(zpData) == IS_NULL) || ((Z_TYPE_P(zpData) == IS_OBJECT) && (Z_OBJCE_P(zpData) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4Sent) && (IS_LONG == Z_TYPE_P(zl4Sent)))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpData, &piData TSRMLS_CC)) RETURN_FALSE;
		l4SentRaw = (int32_t)Z_LVAL_P(zl4Sent);
		SBCheckError(TElSocket_Send(SBGetObjectHandle(getThis() TSRMLS_CC), piData.data, (int32_t)l4DataLen, &l4SentRaw, &l4OutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piData);
		ZVAL_LONG(zl4Sent, (long)l4SentRaw);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer, &integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSocket, ReceiveFrom)
{
	char *sRemoteAddress;
	int32_t l4ReceivedRaw;
	int32_t sRemoteAddress_len;
	long l4DataLen;
	SBArrayZValInfo piData;
	uint16_t u2RemotePortRaw;
	uint32_t _err;
	zval *zl4Received;
	zval *zpData;
	zval *zsRemoteAddress;
	zval *zu2RemotePort;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlzzz", &zpData, &l4DataLen, &zl4Received, &zsRemoteAddress, &zu2RemotePort) == SUCCESS) && ((Z_TYPE_P(zpData) == IS_STRING) || (Z_TYPE_P(zpData) == IS_ARRAY) || (Z_TYPE_P(zpData) == IS_NULL) || ((Z_TYPE_P(zpData) == IS_OBJECT) && (Z_OBJCE_P(zpData) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4Received) && (IS_LONG == Z_TYPE_P(zl4Received)) && PZVAL_IS_REF(zsRemoteAddress) && (IS_STRING == Z_TYPE_P(zsRemoteAddress)) && PZVAL_IS_REF(zu2RemotePort) && (IS_LONG == Z_TYPE_P(zu2RemotePort)))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpData, &piData TSRMLS_CC)) RETURN_FALSE;
		l4ReceivedRaw = (int32_t)Z_LVAL_P(zl4Received);
		sRemoteAddress = Z_STRVAL_P(zsRemoteAddress);
		sRemoteAddress_len = (int32_t)Z_STRLEN_P(zsRemoteAddress);
		u2RemotePortRaw = (uint16_t)Z_LVAL_P(zu2RemotePort);
		_err = TElSocket_ReceiveFrom(SBGetObjectHandle(getThis() TSRMLS_CC), piData.data, (int32_t)l4DataLen, &l4ReceivedRaw, sRemoteAddress, &sRemoteAddress_len, &u2RemotePortRaw, &l4OutResultRaw);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sRemoteAddress = emalloc(sRemoteAddress_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1713200769, 4, sRemoteAddress, &sRemoteAddress_len) TSRMLS_CC);
			zval_dtor(zsRemoteAddress);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreePointerZValInfo(&piData);
		ZVAL_LONG(zl4Received, (long)l4ReceivedRaw);
		sRemoteAddress[sRemoteAddress_len] = 0;
		ZVAL_STRINGL(zsRemoteAddress, sRemoteAddress, sRemoteAddress_len, 0);
		ZVAL_LONG(zu2RemotePort, (long)u2RemotePortRaw);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer, &integer, &string, &integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSocket, SendTo)
{
	char *sRemoteAddress;
	int sRemoteAddress_len;
	int32_t l4SentRaw;
	long l4DataLen;
	long u2RemotePort;
	SBArrayZValInfo piData;
	zval *zl4Sent;
	zval *zpData;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlzsl", &zpData, &l4DataLen, &zl4Sent, &sRemoteAddress, &sRemoteAddress_len, &u2RemotePort) == SUCCESS) && ((Z_TYPE_P(zpData) == IS_STRING) || (Z_TYPE_P(zpData) == IS_ARRAY) || (Z_TYPE_P(zpData) == IS_NULL) || ((Z_TYPE_P(zpData) == IS_OBJECT) && (Z_OBJCE_P(zpData) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4Sent) && (IS_LONG == Z_TYPE_P(zl4Sent)))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpData, &piData TSRMLS_CC)) RETURN_FALSE;
		l4SentRaw = (int32_t)Z_LVAL_P(zl4Sent);
		SBCheckError(TElSocket_SendTo(SBGetObjectHandle(getThis() TSRMLS_CC), piData.data, (int32_t)l4DataLen, &l4SentRaw, sRemoteAddress, (int32_t)sRemoteAddress_len, (uint16_t)u2RemotePort, &l4OutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piData);
		ZVAL_LONG(zl4Sent, (long)l4SentRaw);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer, &integer, string, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSocket, ApplySettings)
{
	zval *oSettings;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSettings, TElSocketSettings_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSocket_ApplySettings(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSettings TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSocketSettings)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSocket, Connect)
{
	long l4Timeout;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Timeout) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSocket_Connect(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Timeout, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSocket, CanReceive)
{
	long l4WaitTime;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4WaitTime) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSocket_CanReceive(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4WaitTime, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSocket, CanSend)
{
	long l4WaitTime;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4WaitTime) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSocket_CanSend(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4WaitTime, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSocket, CanAccept)
{
	long l4WaitTime;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4WaitTime) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSocket_CanAccept(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4WaitTime, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSocket, Bind)
{
	zend_bool bOutgoing;
	zend_bool bReuseAddress;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSocket_Bind(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bOutgoing) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSocket_Bind_1(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bOutgoing, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "bb", &bOutgoing, &bReuseAddress) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSocket_Bind_2(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bOutgoing, (int8_t)bReuseAddress, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("() or (bool) or (bool, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSocket, Listen)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSocket_Listen(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSocket, Accept)
{
	long l4Timeout;
	TElClassHandle hoSocket;
	zval *oSocket;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Timeout) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSocket_Accept(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Timeout, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lO", &l4Timeout, &oSocket, TElSocket_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oSocket) && (IS_OBJECT == Z_TYPE_P(oSocket)))
	{
		hoSocket = SBGetObjectHandle(oSocket TSRMLS_CC);
		SBCheckError(TElSocket_Accept_1(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Timeout, &hoSocket) TSRMLS_CC);
		SBUpdateObjectHandle(oSocket, hoSocket TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer) or (integer, &TElSocket)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSocket, AsyncConnectEx)
{
	long l4Timeout;
	void *pzSecEvent;
	zend_bool bSecRecv;
	zend_bool bSecSend;
	zval *oSecondarySocket;
	zval *zSecEvent;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lO!bbz", &l4Timeout, &oSecondarySocket, TElSocket_ce_ptr, &bSecSend, &bSecRecv, &zSecEvent) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zSecEvent)) || (IS_ARRAY == Z_TYPE_P(zSecEvent)) || (IS_CALLABLE == Z_TYPE_P(zSecEvent)) || (IS_NULL == Z_TYPE_P(zSecEvent))))
	{
		int32_t l4OutResultRaw = 0;
		pzSecEvent = SBSetEventData(zSecEvent TSRMLS_CC);
		SBCheckError(TElSocket_AsyncConnectEx(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Timeout, SBGetObjectHandle(oSecondarySocket TSRMLS_CC), (int8_t)bSecSend, (int8_t)bSecRecv, pzSecEvent ? &TElSocketSecondaryEventRaw : NULL, pzSecEvent, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer, TElSocket, bool, bool, TElSocketSecondaryEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSocket, SocksAccept)
{
	long l4Timeout;
	void *pzOnAuthMethodChoose;
	void *pzOnAuthPassword;
	void *pzOnConnect;
	zend_bool bCloseConnectionOnError;
	zend_bool bResolveAddress;
	zval *zOnAuthMethodChoose;
	zval *zOnAuthPassword;
	zval *zOnConnect;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lzzzbb", &l4Timeout, &zOnAuthMethodChoose, &zOnAuthPassword, &zOnConnect, &bCloseConnectionOnError, &bResolveAddress) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zOnAuthMethodChoose)) || (IS_ARRAY == Z_TYPE_P(zOnAuthMethodChoose)) || (IS_CALLABLE == Z_TYPE_P(zOnAuthMethodChoose)) || (IS_NULL == Z_TYPE_P(zOnAuthMethodChoose))) && ((IS_STRING == Z_TYPE_P(zOnAuthPassword)) || (IS_ARRAY == Z_TYPE_P(zOnAuthPassword)) || (IS_CALLABLE == Z_TYPE_P(zOnAuthPassword)) || (IS_NULL == Z_TYPE_P(zOnAuthPassword))) && ((IS_STRING == Z_TYPE_P(zOnConnect)) || (IS_ARRAY == Z_TYPE_P(zOnConnect)) || (IS_CALLABLE == Z_TYPE_P(zOnConnect)) || (IS_NULL == Z_TYPE_P(zOnConnect))))
	{
		pzOnAuthMethodChoose = SBSetEventData(zOnAuthMethodChoose TSRMLS_CC);
		pzOnAuthPassword = SBSetEventData(zOnAuthPassword TSRMLS_CC);
		pzOnConnect = SBSetEventData(zOnConnect TSRMLS_CC);
		SBCheckError(TElSocket_SocksAccept(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Timeout, pzOnAuthMethodChoose ? &TSBSocksAuthMethodChooseEventRaw : NULL, pzOnAuthMethodChoose, pzOnAuthPassword ? &TSBSocksAuthPasswordEventRaw : NULL, pzOnAuthPassword, pzOnConnect ? &TSBSocksConnectEventRaw : NULL, pzOnConnect, (int8_t)bCloseConnectionOnError, (int8_t)bResolveAddress) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, TSBSocksAuthMethodChooseEvent|callable|NULL, TSBSocksAuthPasswordEvent|callable|NULL, TSBSocksConnectEvent|callable|NULL, bool, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSocket, get_LocalHostName)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSocket_get_LocalHostName(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1492429101, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSocket, get_RemoteAddress)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSocket_get_RemoteAddress(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1188633256, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSocket, get_ProxyResult)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSocket_get_ProxyResult(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSocket, get_SocketType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElSocketTypeRaw fOutResultRaw = 0;
		SBCheckError(TElSocket_get_SocketType(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSocket, set_SocketType)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElSocket_set_SocketType(SBGetObjectHandle(getThis() TSRMLS_CC), (TElSocketTypeRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSocket, get_State)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElSocketStateRaw fOutResultRaw = 0;
		SBCheckError(TElSocket_get_State(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

#ifdef SB_WINDOWS
SB_PHP_METHOD(TElSocket, get_UsingIPv6)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSocket_get_UsingIPv6(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}
#endif

SB_PHP_METHOD(TElSocket, get_BoundPort)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSocket_get_BoundPort(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSocket, get_BoundAddress)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSocket_get_BoundAddress(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(498729403, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSocket, get_NativeSocket)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSocket_get_NativeSocket(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSocket, get_Address)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSocket_get_Address(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-185937582, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSocket, set_Address)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSocket_set_Address(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSocket, get_Port)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSocket_get_Port(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSocket, set_Port)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElSocket_set_Port(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSocket, get_ListenPort)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSocket_get_ListenPort(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSocket, set_ListenPort)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElSocket_set_ListenPort(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSocket, get_ListenPortRangeFrom)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSocket_get_ListenPortRangeFrom(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSocket, set_ListenPortRangeFrom)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElSocket_set_ListenPortRangeFrom(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSocket, get_ListenPortRangeTo)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSocket_get_ListenPortRangeTo(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSocket, set_ListenPortRangeTo)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElSocket_set_ListenPortRangeTo(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSocket, get_ListenAddress)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSocket_get_ListenAddress(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-936566027, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSocket, set_ListenAddress)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSocket_set_ListenAddress(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSocket, get_ListenBinding)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSocket_get_ListenBinding(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElClientSocketBinding_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSocket, set_ListenBinding)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElClientSocketBinding_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSocket_set_ListenBinding(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElClientSocketBinding)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSocket, get_OutgoingLocalBinding)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSocket_get_OutgoingLocalBinding(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElClientSocketBinding_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSocket, set_OutgoingLocalBinding)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElClientSocketBinding_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSocket_set_OutgoingLocalBinding(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElClientSocketBinding)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSocket, get_IncomingSpeedLimit)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSocket_get_IncomingSpeedLimit(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSocket, set_IncomingSpeedLimit)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElSocket_set_IncomingSpeedLimit(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSocket, get_OutgoingSpeedLimit)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSocket_get_OutgoingSpeedLimit(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSocket, set_OutgoingSpeedLimit)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElSocket_set_OutgoingSpeedLimit(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSocket, get_SocksAuthentication)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElSocksAuthenticationRaw fOutResultRaw = 0;
		SBCheckError(TElSocket_get_SocksAuthentication(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSocket, set_SocksAuthentication)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElSocket_set_SocksAuthentication(SBGetObjectHandle(getThis() TSRMLS_CC), (TElSocksAuthenticationRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSocket, get_SocksPassword)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSocket_get_SocksPassword(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(545657263, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSocket, set_SocksPassword)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSocket_set_SocksPassword(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSocket, get_SocksPort)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSocket_get_SocksPort(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSocket, set_SocksPort)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElSocket_set_SocksPort(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSocket, get_SocksResolveAddress)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSocket_get_SocksResolveAddress(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSocket, set_SocksResolveAddress)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSocket_set_SocksResolveAddress(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSocket, get_SocksServer)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSocket_get_SocksServer(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(556288414, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSocket, set_SocksServer)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSocket_set_SocksServer(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

#ifdef SB_WINDOWS
SB_PHP_METHOD(TElSocket, get_SocksUseIPv6)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSocket_get_SocksUseIPv6(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSocket, set_SocksUseIPv6)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSocket_set_SocksUseIPv6(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}
#endif

SB_PHP_METHOD(TElSocket, get_SocksUserCode)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSocket_get_SocksUserCode(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1679732909, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSocket, set_SocksUserCode)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSocket_set_SocksUserCode(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSocket, get_SocksVersion)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElSocksVersionRaw fOutResultRaw = 0;
		SBCheckError(TElSocket_get_SocksVersion(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSocket, set_SocksVersion)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElSocket_set_SocksVersion(SBGetObjectHandle(getThis() TSRMLS_CC), (TElSocksVersionRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSocket, get_UseSocks)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSocket_get_UseSocks(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSocket, set_UseSocks)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSocket_set_UseSocks(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

#ifdef SB_WINDOWS
SB_PHP_METHOD(TElSocket, get_UseIPv6)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSocket_get_UseIPv6(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSocket, set_UseIPv6)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSocket_set_UseIPv6(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}
#endif

SB_PHP_METHOD(TElSocket, get_UseNagle)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSocket_get_UseNagle(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSocket, set_UseNagle)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSocket_set_UseNagle(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSocket, get_UseWebTunneling)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSocket_get_UseWebTunneling(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSocket, set_UseWebTunneling)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSocket_set_UseWebTunneling(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSocket, get_WebTunnelAddress)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSocket_get_WebTunnelAddress(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(768702524, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSocket, set_WebTunnelAddress)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSocket_set_WebTunnelAddress(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSocket, get_WebTunnelAuthentication)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElWebTunnelAuthenticationRaw fOutResultRaw = 0;
		SBCheckError(TElSocket_get_WebTunnelAuthentication(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSocket, set_WebTunnelAuthentication)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElSocket_set_WebTunnelAuthentication(SBGetObjectHandle(getThis() TSRMLS_CC), (TElWebTunnelAuthenticationRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSocket, get_WebTunnelPassword)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSocket_get_WebTunnelPassword(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1378941310, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSocket, set_WebTunnelPassword)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSocket_set_WebTunnelPassword(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSocket, get_WebTunnelPort)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSocket_get_WebTunnelPort(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSocket, set_WebTunnelPort)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElSocket_set_WebTunnelPort(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSocket, get_WebTunnelUserId)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSocket_get_WebTunnelUserId(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1689373793, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSocket, set_WebTunnelUserId)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSocket_set_WebTunnelUserId(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSocket, get_WebTunnelRequestHeaders)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSocket_get_WebTunnelRequestHeaders(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
#ifdef SB_WINDOWS
		SBInitObject(return_value, TStringList_ce_ptr, hoOutResult TSRMLS_CC);
#else
		SBInitObject(return_value, TElStringList_ce_ptr, hoOutResult TSRMLS_CC);
#endif
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSocket, set_WebTunnelRequestHeaders)
{
	zval *oValue;
#ifdef SB_WINDOWS
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TStringList_ce_ptr) == SUCCESS)
#else
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElStringList_ce_ptr) == SUCCESS)
#endif
	{
		SBCheckError(TElSocket_set_WebTunnelRequestHeaders(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
#ifdef SB_WINDOWS
		SBErrorExpectsArguments("(TStringList)" TSRMLS_CC);
#else
		SBErrorExpectsArguments("(TElStringList)" TSRMLS_CC);
#endif
	}
}

SB_PHP_METHOD(TElSocket, get_WebTunnelResponseHeaders)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSocket_get_WebTunnelResponseHeaders(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
#ifdef SB_WINDOWS
		SBInitObject(return_value, TStringList_ce_ptr, hoOutResult TSRMLS_CC);
#else
		SBInitObject(return_value, TElStringList_ce_ptr, hoOutResult TSRMLS_CC);
#endif
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSocket, get_WebTunnelResponseBody)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSocket_get_WebTunnelResponseBody(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1418532692, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSocket, get_AutoAdjustBuffersSize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSocket_get_AutoAdjustBuffersSize(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSocket, set_AutoAdjustBuffersSize)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSocket_set_AutoAdjustBuffersSize(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSocket, get_MinBufferSize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSocket_get_MinBufferSize(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSocket, set_MinBufferSize)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElSocket_set_MinBufferSize(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSocket, get_MaxBufferSize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSocket_get_MaxBufferSize(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSocket, set_MaxBufferSize)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElSocket_set_MaxBufferSize(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSocket, get_BuffersAdjustStep)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		double dOutResult = 0.0;
		SBCheckError(TElSocket_get_BuffersAdjustStep(SBGetObjectHandle(getThis() TSRMLS_CC), &dOutResult) TSRMLS_CC);
		RETURN_DOUBLE(dOutResult);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSocket, set_BuffersAdjustStep)
{
	double dValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "d", &dValue) == SUCCESS)
	{
		SBCheckError(TElSocket_set_BuffersAdjustStep(SBGetObjectHandle(getThis() TSRMLS_CC), (double)dValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(double)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSocket, get_SendBufferSize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSocket_get_SendBufferSize(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSocket, set_SendBufferSize)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElSocket_set_SendBufferSize(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSocket, get_RecvBufferSize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSocket_get_RecvBufferSize(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSocket, set_RecvBufferSize)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElSocket_set_RecvBufferSize(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

#ifdef SB_WINDOWS
SB_PHP_METHOD(TElSocket, get_DNS)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSocket_get_DNS(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElDNSSettings_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSocket, set_DNS)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElDNSSettings_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSocket_set_DNS(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElDNSSettings)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSocket, get_OnDNSKeyNeeded)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBDNSKeyNeededEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSocket_get_OnDNSKeyNeeded(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSocket, set_OnDNSKeyNeeded)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSocket_set_OnDNSKeyNeeded(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBDNSKeyNeededEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBDNSKeyNeededEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSocket, get_OnDNSKeyValidate)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBDNSKeyValidateEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSocket_get_OnDNSKeyValidate(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSocket, set_OnDNSKeyValidate)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSocket_set_OnDNSKeyValidate(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBDNSKeyValidateEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBDNSKeyValidateEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSocket, get_OnDNSResolve)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBDNSResolveEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSocket_get_OnDNSResolve(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSocket, set_OnDNSResolve)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSocket_set_OnDNSResolve(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBDNSResolveEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBDNSResolveEvent|callable|NULL)" TSRMLS_CC);
	}
}
#endif

SB_PHP_METHOD(TElSocket, __construct)
{
	zval *oOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSocket_Create(SBGetObjectHandle(oOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSocket_Create_1(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent) or ()" TSRMLS_CC);
	}
}

#ifdef SB_WINDOWS
ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSocket_LoadIPv6Proc_Inst, 0, 0, 4)
	ZEND_ARG_INFO(0, ProcName)
	ZEND_ARG_OBJ_INFO(0, Proc, TSBPointer, 0)
	ZEND_ARG_INFO(1, WinsockUsed)
	ZEND_ARG_INFO(1, Wship6Used)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSocket_LoadIPv6Proc, 0, 0, 4)
	ZEND_ARG_INFO(0, ProcName)
	ZEND_ARG_OBJ_INFO(0, Proc, TSBPointer, 0)
	ZEND_ARG_INFO(1, WinsockUsed)
	ZEND_ARG_INFO(1, Wship6Used)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSocket_InitializeIPv6_Inst, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSocket_InitializeIPv6, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSocket_FinalizeIPv6_Inst, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSocket_FinalizeIPv6, 0, 0, 0)
ZEND_END_ARG_INFO()
#endif

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSocket_ShutdownSocket, 0, 0, 0)
	ZEND_ARG_INFO(0, Direction)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSocket_Close, 0, 0, 1)
	ZEND_ARG_INFO(0, Forced)
	ZEND_ARG_INFO(0, Timeout)
	ZEND_ARG_INFO(0, Gradually)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSocket_StartAsyncConnect, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSocket_AsyncConnect, 0, 0, 1)
	ZEND_ARG_INFO(0, Timeout)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSocket_FinalizeWinSock_Inst, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSocket_FinalizeWinSock, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSocket_InitializeWinSock_Inst, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSocket_InitializeWinSock, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSocket_LastNetError, 0, 0, 0)
ZEND_END_ARG_INFO()

#ifdef SB_WINDOWS
ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSocket_IPFromHost, 0, 0, 2)
#else
ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSocket_IPFromHost, 0, 0, 1)
#endif
	ZEND_ARG_INFO(0, Host)
#ifdef SB_WINDOWS
	ZEND_ARG_INFO(0, UseIPv6)
#endif
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSocket_Receive, 0, 0, 3)
	ZEND_ARG_TYPE_INFO(0, Data, 0, 1)
	ZEND_ARG_INFO(0, DataLen)
	ZEND_ARG_INFO(1, Received)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSocket_Send, 0, 0, 3)
	ZEND_ARG_TYPE_INFO(0, Data, 0, 1)
	ZEND_ARG_INFO(0, DataLen)
	ZEND_ARG_INFO(1, Sent)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSocket_ReceiveFrom, 0, 0, 5)
	ZEND_ARG_TYPE_INFO(0, Data, 0, 1)
	ZEND_ARG_INFO(0, DataLen)
	ZEND_ARG_INFO(1, Received)
	ZEND_ARG_INFO(1, RemoteAddress)
	ZEND_ARG_INFO(1, RemotePort)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSocket_SendTo, 0, 0, 5)
	ZEND_ARG_TYPE_INFO(0, Data, 0, 1)
	ZEND_ARG_INFO(0, DataLen)
	ZEND_ARG_INFO(1, Sent)
	ZEND_ARG_INFO(0, RemoteAddress)
	ZEND_ARG_INFO(0, RemotePort)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSocket_ApplySettings, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Settings, TElSocketSettings, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSocket_Connect, 0, 0, 1)
	ZEND_ARG_INFO(0, Timeout)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSocket_CanReceive, 0, 0, 1)
	ZEND_ARG_INFO(0, WaitTime)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSocket_CanSend, 0, 0, 1)
	ZEND_ARG_INFO(0, WaitTime)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSocket_CanAccept, 0, 0, 1)
	ZEND_ARG_INFO(0, WaitTime)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSocket_Bind, 0, 0, 0)
	ZEND_ARG_INFO(0, Outgoing)
	ZEND_ARG_INFO(0, ReuseAddress)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSocket_Listen, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSocket_Accept, 0, 0, 1)
	ZEND_ARG_INFO(0, Timeout)
	ZEND_ARG_OBJ_INFO(1, Socket, TElSocket, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSocket_AsyncConnectEx, 0, 0, 5)
	ZEND_ARG_INFO(0, Timeout)
	ZEND_ARG_OBJ_INFO(0, SecondarySocket, TElSocket, 1)
	ZEND_ARG_INFO(0, SecSend)
	ZEND_ARG_INFO(0, SecRecv)
	ZEND_ARG_TYPE_INFO(0, SecEvent, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSocket_SocksAccept, 0, 0, 6)
	ZEND_ARG_INFO(0, Timeout)
	ZEND_ARG_TYPE_INFO(0, OnAuthMethodChoose, 0, 1)
	ZEND_ARG_TYPE_INFO(0, OnAuthPassword, 0, 1)
	ZEND_ARG_TYPE_INFO(0, OnConnect, 0, 1)
	ZEND_ARG_INFO(0, CloseConnectionOnError)
	ZEND_ARG_INFO(0, ResolveAddress)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSocket_get_LocalHostName, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSocket_get_RemoteAddress, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSocket_get_ProxyResult, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSocket_get_SocketType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSocket_set_SocketType, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSocket_get_State, 0, 0, 0)
ZEND_END_ARG_INFO()

#ifdef SB_WINDOWS
ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSocket_get_UsingIPv6, 0, 0, 0)
ZEND_END_ARG_INFO()
#endif

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSocket_get_BoundPort, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSocket_get_BoundAddress, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSocket_get_NativeSocket, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSocket_get_Address, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSocket_set_Address, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSocket_get_Port, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSocket_set_Port, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSocket_get_ListenPort, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSocket_set_ListenPort, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSocket_get_ListenPortRangeFrom, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSocket_set_ListenPortRangeFrom, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSocket_get_ListenPortRangeTo, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSocket_set_ListenPortRangeTo, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSocket_get_ListenAddress, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSocket_set_ListenAddress, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSocket_get_ListenBinding, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSocket_set_ListenBinding, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElClientSocketBinding, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSocket_get_OutgoingLocalBinding, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSocket_set_OutgoingLocalBinding, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElClientSocketBinding, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSocket_get_IncomingSpeedLimit, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSocket_set_IncomingSpeedLimit, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSocket_get_OutgoingSpeedLimit, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSocket_set_OutgoingSpeedLimit, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSocket_get_SocksAuthentication, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSocket_set_SocksAuthentication, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSocket_get_SocksPassword, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSocket_set_SocksPassword, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSocket_get_SocksPort, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSocket_set_SocksPort, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSocket_get_SocksResolveAddress, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSocket_set_SocksResolveAddress, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSocket_get_SocksServer, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSocket_set_SocksServer, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

#ifdef SB_WINDOWS
ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSocket_get_SocksUseIPv6, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSocket_set_SocksUseIPv6, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()
#endif

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSocket_get_SocksUserCode, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSocket_set_SocksUserCode, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSocket_get_SocksVersion, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSocket_set_SocksVersion, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSocket_get_UseSocks, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSocket_set_UseSocks, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

#ifdef SB_WINDOWS
ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSocket_get_UseIPv6, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSocket_set_UseIPv6, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()
#endif

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSocket_get_UseNagle, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSocket_set_UseNagle, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSocket_get_UseWebTunneling, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSocket_set_UseWebTunneling, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSocket_get_WebTunnelAddress, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSocket_set_WebTunnelAddress, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSocket_get_WebTunnelAuthentication, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSocket_set_WebTunnelAuthentication, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSocket_get_WebTunnelPassword, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSocket_set_WebTunnelPassword, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSocket_get_WebTunnelPort, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSocket_set_WebTunnelPort, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSocket_get_WebTunnelUserId, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSocket_set_WebTunnelUserId, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSocket_get_WebTunnelRequestHeaders, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSocket_set_WebTunnelRequestHeaders, 0, 0, 1)
#ifdef SB_WINDOWS
	ZEND_ARG_OBJ_INFO(0, Value, TStringList, 1)
#else
	ZEND_ARG_OBJ_INFO(0, Value, TElStringList, 1)
#endif
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSocket_get_WebTunnelResponseHeaders, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSocket_get_WebTunnelResponseBody, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSocket_get_AutoAdjustBuffersSize, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSocket_set_AutoAdjustBuffersSize, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSocket_get_MinBufferSize, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSocket_set_MinBufferSize, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSocket_get_MaxBufferSize, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSocket_set_MaxBufferSize, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSocket_get_BuffersAdjustStep, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSocket_set_BuffersAdjustStep, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSocket_get_SendBufferSize, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSocket_set_SendBufferSize, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSocket_get_RecvBufferSize, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSocket_set_RecvBufferSize, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

#ifdef SB_WINDOWS
ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSocket_get_DNS, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSocket_set_DNS, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElDNSSettings, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSocket_get_OnDNSKeyNeeded, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSocket_set_OnDNSKeyNeeded, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSocket_get_OnDNSKeyValidate, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSocket_set_OnDNSKeyValidate, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSocket_get_OnDNSResolve, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSocket_set_OnDNSResolve, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()
#endif

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSocket___construct, 0, 0, 0)
	ZEND_ARG_OBJ_INFO(0, Owner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElSocket_methods[] = {
#ifdef SB_WINDOWS
	PHP_ME(TElSocket, LoadIPv6Proc_Inst, arginfo_TElSocket_LoadIPv6Proc_Inst, ZEND_ACC_PUBLIC)
	PHP_ME(TElSocket, LoadIPv6Proc, arginfo_TElSocket_LoadIPv6Proc, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElSocket, InitializeIPv6_Inst, arginfo_TElSocket_InitializeIPv6_Inst, ZEND_ACC_PUBLIC)
	PHP_ME(TElSocket, InitializeIPv6, arginfo_TElSocket_InitializeIPv6, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElSocket, FinalizeIPv6_Inst, arginfo_TElSocket_FinalizeIPv6_Inst, ZEND_ACC_PUBLIC)
	PHP_ME(TElSocket, FinalizeIPv6, arginfo_TElSocket_FinalizeIPv6, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
#endif
	PHP_ME(TElSocket, ShutdownSocket, arginfo_TElSocket_ShutdownSocket, ZEND_ACC_PUBLIC)
	PHP_ME(TElSocket, Close, arginfo_TElSocket_Close, ZEND_ACC_PUBLIC)
	PHP_ME(TElSocket, StartAsyncConnect, arginfo_TElSocket_StartAsyncConnect, ZEND_ACC_PUBLIC)
	PHP_ME(TElSocket, AsyncConnect, arginfo_TElSocket_AsyncConnect, ZEND_ACC_PUBLIC)
	PHP_ME(TElSocket, FinalizeWinSock_Inst, arginfo_TElSocket_FinalizeWinSock_Inst, ZEND_ACC_PUBLIC)
	PHP_ME(TElSocket, FinalizeWinSock, arginfo_TElSocket_FinalizeWinSock, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElSocket, InitializeWinSock_Inst, arginfo_TElSocket_InitializeWinSock_Inst, ZEND_ACC_PUBLIC)
	PHP_ME(TElSocket, InitializeWinSock, arginfo_TElSocket_InitializeWinSock, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElSocket, LastNetError, arginfo_TElSocket_LastNetError, ZEND_ACC_PUBLIC)
	PHP_ME(TElSocket, IPFromHost, arginfo_TElSocket_IPFromHost, ZEND_ACC_PUBLIC)
	PHP_ME(TElSocket, Receive, arginfo_TElSocket_Receive, ZEND_ACC_PUBLIC)
	PHP_ME(TElSocket, Send, arginfo_TElSocket_Send, ZEND_ACC_PUBLIC)
	PHP_ME(TElSocket, ReceiveFrom, arginfo_TElSocket_ReceiveFrom, ZEND_ACC_PUBLIC)
	PHP_ME(TElSocket, SendTo, arginfo_TElSocket_SendTo, ZEND_ACC_PUBLIC)
	PHP_ME(TElSocket, ApplySettings, arginfo_TElSocket_ApplySettings, ZEND_ACC_PUBLIC)
	PHP_ME(TElSocket, Connect, arginfo_TElSocket_Connect, ZEND_ACC_PUBLIC)
	PHP_ME(TElSocket, CanReceive, arginfo_TElSocket_CanReceive, ZEND_ACC_PUBLIC)
	PHP_ME(TElSocket, CanSend, arginfo_TElSocket_CanSend, ZEND_ACC_PUBLIC)
	PHP_ME(TElSocket, CanAccept, arginfo_TElSocket_CanAccept, ZEND_ACC_PUBLIC)
	PHP_ME(TElSocket, Bind, arginfo_TElSocket_Bind, ZEND_ACC_PUBLIC)
	PHP_ME(TElSocket, Listen, arginfo_TElSocket_Listen, ZEND_ACC_PUBLIC)
	PHP_ME(TElSocket, Accept, arginfo_TElSocket_Accept, ZEND_ACC_PUBLIC)
	PHP_ME(TElSocket, AsyncConnectEx, arginfo_TElSocket_AsyncConnectEx, ZEND_ACC_PUBLIC)
	PHP_ME(TElSocket, SocksAccept, arginfo_TElSocket_SocksAccept, ZEND_ACC_PUBLIC)
	PHP_ME(TElSocket, get_LocalHostName, arginfo_TElSocket_get_LocalHostName, ZEND_ACC_PUBLIC)
	PHP_ME(TElSocket, get_RemoteAddress, arginfo_TElSocket_get_RemoteAddress, ZEND_ACC_PUBLIC)
	PHP_ME(TElSocket, get_ProxyResult, arginfo_TElSocket_get_ProxyResult, ZEND_ACC_PUBLIC)
	PHP_ME(TElSocket, get_SocketType, arginfo_TElSocket_get_SocketType, ZEND_ACC_PUBLIC)
	PHP_ME(TElSocket, set_SocketType, arginfo_TElSocket_set_SocketType, ZEND_ACC_PUBLIC)
	PHP_ME(TElSocket, get_State, arginfo_TElSocket_get_State, ZEND_ACC_PUBLIC)
#ifdef SB_WINDOWS
	PHP_ME(TElSocket, get_UsingIPv6, arginfo_TElSocket_get_UsingIPv6, ZEND_ACC_PUBLIC)
#endif
	PHP_ME(TElSocket, get_BoundPort, arginfo_TElSocket_get_BoundPort, ZEND_ACC_PUBLIC)
	PHP_ME(TElSocket, get_BoundAddress, arginfo_TElSocket_get_BoundAddress, ZEND_ACC_PUBLIC)
	PHP_ME(TElSocket, get_NativeSocket, arginfo_TElSocket_get_NativeSocket, ZEND_ACC_PUBLIC)
	PHP_ME(TElSocket, get_Address, arginfo_TElSocket_get_Address, ZEND_ACC_PUBLIC)
	PHP_ME(TElSocket, set_Address, arginfo_TElSocket_set_Address, ZEND_ACC_PUBLIC)
	PHP_ME(TElSocket, get_Port, arginfo_TElSocket_get_Port, ZEND_ACC_PUBLIC)
	PHP_ME(TElSocket, set_Port, arginfo_TElSocket_set_Port, ZEND_ACC_PUBLIC)
	PHP_ME(TElSocket, get_ListenPort, arginfo_TElSocket_get_ListenPort, ZEND_ACC_PUBLIC)
	PHP_ME(TElSocket, set_ListenPort, arginfo_TElSocket_set_ListenPort, ZEND_ACC_PUBLIC)
	PHP_ME(TElSocket, get_ListenPortRangeFrom, arginfo_TElSocket_get_ListenPortRangeFrom, ZEND_ACC_PUBLIC)
	PHP_ME(TElSocket, set_ListenPortRangeFrom, arginfo_TElSocket_set_ListenPortRangeFrom, ZEND_ACC_PUBLIC)
	PHP_ME(TElSocket, get_ListenPortRangeTo, arginfo_TElSocket_get_ListenPortRangeTo, ZEND_ACC_PUBLIC)
	PHP_ME(TElSocket, set_ListenPortRangeTo, arginfo_TElSocket_set_ListenPortRangeTo, ZEND_ACC_PUBLIC)
	PHP_ME(TElSocket, get_ListenAddress, arginfo_TElSocket_get_ListenAddress, ZEND_ACC_PUBLIC)
	PHP_ME(TElSocket, set_ListenAddress, arginfo_TElSocket_set_ListenAddress, ZEND_ACC_PUBLIC)
	PHP_ME(TElSocket, get_ListenBinding, arginfo_TElSocket_get_ListenBinding, ZEND_ACC_PUBLIC)
	PHP_ME(TElSocket, set_ListenBinding, arginfo_TElSocket_set_ListenBinding, ZEND_ACC_PUBLIC)
	PHP_ME(TElSocket, get_OutgoingLocalBinding, arginfo_TElSocket_get_OutgoingLocalBinding, ZEND_ACC_PUBLIC)
	PHP_ME(TElSocket, set_OutgoingLocalBinding, arginfo_TElSocket_set_OutgoingLocalBinding, ZEND_ACC_PUBLIC)
	PHP_ME(TElSocket, get_IncomingSpeedLimit, arginfo_TElSocket_get_IncomingSpeedLimit, ZEND_ACC_PUBLIC)
	PHP_ME(TElSocket, set_IncomingSpeedLimit, arginfo_TElSocket_set_IncomingSpeedLimit, ZEND_ACC_PUBLIC)
	PHP_ME(TElSocket, get_OutgoingSpeedLimit, arginfo_TElSocket_get_OutgoingSpeedLimit, ZEND_ACC_PUBLIC)
	PHP_ME(TElSocket, set_OutgoingSpeedLimit, arginfo_TElSocket_set_OutgoingSpeedLimit, ZEND_ACC_PUBLIC)
	PHP_ME(TElSocket, get_SocksAuthentication, arginfo_TElSocket_get_SocksAuthentication, ZEND_ACC_PUBLIC)
	PHP_ME(TElSocket, set_SocksAuthentication, arginfo_TElSocket_set_SocksAuthentication, ZEND_ACC_PUBLIC)
	PHP_ME(TElSocket, get_SocksPassword, arginfo_TElSocket_get_SocksPassword, ZEND_ACC_PUBLIC)
	PHP_ME(TElSocket, set_SocksPassword, arginfo_TElSocket_set_SocksPassword, ZEND_ACC_PUBLIC)
	PHP_ME(TElSocket, get_SocksPort, arginfo_TElSocket_get_SocksPort, ZEND_ACC_PUBLIC)
	PHP_ME(TElSocket, set_SocksPort, arginfo_TElSocket_set_SocksPort, ZEND_ACC_PUBLIC)
	PHP_ME(TElSocket, get_SocksResolveAddress, arginfo_TElSocket_get_SocksResolveAddress, ZEND_ACC_PUBLIC)
	PHP_ME(TElSocket, set_SocksResolveAddress, arginfo_TElSocket_set_SocksResolveAddress, ZEND_ACC_PUBLIC)
	PHP_ME(TElSocket, get_SocksServer, arginfo_TElSocket_get_SocksServer, ZEND_ACC_PUBLIC)
	PHP_ME(TElSocket, set_SocksServer, arginfo_TElSocket_set_SocksServer, ZEND_ACC_PUBLIC)
#ifdef SB_WINDOWS
	PHP_ME(TElSocket, get_SocksUseIPv6, arginfo_TElSocket_get_SocksUseIPv6, ZEND_ACC_PUBLIC)
	PHP_ME(TElSocket, set_SocksUseIPv6, arginfo_TElSocket_set_SocksUseIPv6, ZEND_ACC_PUBLIC)
#endif
	PHP_ME(TElSocket, get_SocksUserCode, arginfo_TElSocket_get_SocksUserCode, ZEND_ACC_PUBLIC)
	PHP_ME(TElSocket, set_SocksUserCode, arginfo_TElSocket_set_SocksUserCode, ZEND_ACC_PUBLIC)
	PHP_ME(TElSocket, get_SocksVersion, arginfo_TElSocket_get_SocksVersion, ZEND_ACC_PUBLIC)
	PHP_ME(TElSocket, set_SocksVersion, arginfo_TElSocket_set_SocksVersion, ZEND_ACC_PUBLIC)
	PHP_ME(TElSocket, get_UseSocks, arginfo_TElSocket_get_UseSocks, ZEND_ACC_PUBLIC)
	PHP_ME(TElSocket, set_UseSocks, arginfo_TElSocket_set_UseSocks, ZEND_ACC_PUBLIC)
#ifdef SB_WINDOWS
	PHP_ME(TElSocket, get_UseIPv6, arginfo_TElSocket_get_UseIPv6, ZEND_ACC_PUBLIC)
	PHP_ME(TElSocket, set_UseIPv6, arginfo_TElSocket_set_UseIPv6, ZEND_ACC_PUBLIC)
#endif
	PHP_ME(TElSocket, get_UseNagle, arginfo_TElSocket_get_UseNagle, ZEND_ACC_PUBLIC)
	PHP_ME(TElSocket, set_UseNagle, arginfo_TElSocket_set_UseNagle, ZEND_ACC_PUBLIC)
	PHP_ME(TElSocket, get_UseWebTunneling, arginfo_TElSocket_get_UseWebTunneling, ZEND_ACC_PUBLIC)
	PHP_ME(TElSocket, set_UseWebTunneling, arginfo_TElSocket_set_UseWebTunneling, ZEND_ACC_PUBLIC)
	PHP_ME(TElSocket, get_WebTunnelAddress, arginfo_TElSocket_get_WebTunnelAddress, ZEND_ACC_PUBLIC)
	PHP_ME(TElSocket, set_WebTunnelAddress, arginfo_TElSocket_set_WebTunnelAddress, ZEND_ACC_PUBLIC)
	PHP_ME(TElSocket, get_WebTunnelAuthentication, arginfo_TElSocket_get_WebTunnelAuthentication, ZEND_ACC_PUBLIC)
	PHP_ME(TElSocket, set_WebTunnelAuthentication, arginfo_TElSocket_set_WebTunnelAuthentication, ZEND_ACC_PUBLIC)
	PHP_ME(TElSocket, get_WebTunnelPassword, arginfo_TElSocket_get_WebTunnelPassword, ZEND_ACC_PUBLIC)
	PHP_ME(TElSocket, set_WebTunnelPassword, arginfo_TElSocket_set_WebTunnelPassword, ZEND_ACC_PUBLIC)
	PHP_ME(TElSocket, get_WebTunnelPort, arginfo_TElSocket_get_WebTunnelPort, ZEND_ACC_PUBLIC)
	PHP_ME(TElSocket, set_WebTunnelPort, arginfo_TElSocket_set_WebTunnelPort, ZEND_ACC_PUBLIC)
	PHP_ME(TElSocket, get_WebTunnelUserId, arginfo_TElSocket_get_WebTunnelUserId, ZEND_ACC_PUBLIC)
	PHP_ME(TElSocket, set_WebTunnelUserId, arginfo_TElSocket_set_WebTunnelUserId, ZEND_ACC_PUBLIC)
	PHP_ME(TElSocket, get_WebTunnelRequestHeaders, arginfo_TElSocket_get_WebTunnelRequestHeaders, ZEND_ACC_PUBLIC)
	PHP_ME(TElSocket, set_WebTunnelRequestHeaders, arginfo_TElSocket_set_WebTunnelRequestHeaders, ZEND_ACC_PUBLIC)
	PHP_ME(TElSocket, get_WebTunnelResponseHeaders, arginfo_TElSocket_get_WebTunnelResponseHeaders, ZEND_ACC_PUBLIC)
	PHP_ME(TElSocket, get_WebTunnelResponseBody, arginfo_TElSocket_get_WebTunnelResponseBody, ZEND_ACC_PUBLIC)
	PHP_ME(TElSocket, get_AutoAdjustBuffersSize, arginfo_TElSocket_get_AutoAdjustBuffersSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElSocket, set_AutoAdjustBuffersSize, arginfo_TElSocket_set_AutoAdjustBuffersSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElSocket, get_MinBufferSize, arginfo_TElSocket_get_MinBufferSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElSocket, set_MinBufferSize, arginfo_TElSocket_set_MinBufferSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElSocket, get_MaxBufferSize, arginfo_TElSocket_get_MaxBufferSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElSocket, set_MaxBufferSize, arginfo_TElSocket_set_MaxBufferSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElSocket, get_BuffersAdjustStep, arginfo_TElSocket_get_BuffersAdjustStep, ZEND_ACC_PUBLIC)
	PHP_ME(TElSocket, set_BuffersAdjustStep, arginfo_TElSocket_set_BuffersAdjustStep, ZEND_ACC_PUBLIC)
	PHP_ME(TElSocket, get_SendBufferSize, arginfo_TElSocket_get_SendBufferSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElSocket, set_SendBufferSize, arginfo_TElSocket_set_SendBufferSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElSocket, get_RecvBufferSize, arginfo_TElSocket_get_RecvBufferSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElSocket, set_RecvBufferSize, arginfo_TElSocket_set_RecvBufferSize, ZEND_ACC_PUBLIC)
#ifdef SB_WINDOWS
	PHP_ME(TElSocket, get_DNS, arginfo_TElSocket_get_DNS, ZEND_ACC_PUBLIC)
	PHP_ME(TElSocket, set_DNS, arginfo_TElSocket_set_DNS, ZEND_ACC_PUBLIC)
	PHP_ME(TElSocket, get_OnDNSKeyNeeded, arginfo_TElSocket_get_OnDNSKeyNeeded, ZEND_ACC_PUBLIC)
	PHP_ME(TElSocket, set_OnDNSKeyNeeded, arginfo_TElSocket_set_OnDNSKeyNeeded, ZEND_ACC_PUBLIC)
	PHP_ME(TElSocket, get_OnDNSKeyValidate, arginfo_TElSocket_get_OnDNSKeyValidate, ZEND_ACC_PUBLIC)
	PHP_ME(TElSocket, set_OnDNSKeyValidate, arginfo_TElSocket_set_OnDNSKeyValidate, ZEND_ACC_PUBLIC)
	PHP_ME(TElSocket, get_OnDNSResolve, arginfo_TElSocket_get_OnDNSResolve, ZEND_ACC_PUBLIC)
	PHP_ME(TElSocket, set_OnDNSResolve, arginfo_TElSocket_set_OnDNSResolve, ZEND_ACC_PUBLIC)
#endif
	PHP_ME(TElSocket, __construct, arginfo_TElSocket___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSocket(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSocket_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSocket", TElSocket_methods);
	if (NULL == TComponent_ce_ptr)
		Register_TComponent(TSRMLS_C);
	TElSocket_ce_ptr = zend_register_internal_class_ex(&ce, TComponent_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElCustomSocketBinding_ce_ptr = NULL;

SB_PHP_METHOD(TElCustomSocketBinding, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TElCustomSocketBinding_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElCustomSocketBinding_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomSocketBinding)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomSocketBinding, get_LocalIntfAddress)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElCustomSocketBinding_get_LocalIntfAddress(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1582509411, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomSocketBinding, set_LocalIntfAddress)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElCustomSocketBinding_set_LocalIntfAddress(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomSocketBinding, get_Port)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElCustomSocketBinding_get_Port(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomSocketBinding, set_Port)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElCustomSocketBinding_set_Port(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomSocketBinding, get_ReuseAddress)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElCustomSocketBinding_get_ReuseAddress(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomSocketBinding, set_ReuseAddress)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElCustomSocketBinding_set_ReuseAddress(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomSocketBinding, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCustomSocketBinding_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomSocketBinding_Assign, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Source, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomSocketBinding_get_LocalIntfAddress, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomSocketBinding_set_LocalIntfAddress, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomSocketBinding_get_Port, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomSocketBinding_set_Port, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomSocketBinding_get_ReuseAddress, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomSocketBinding_set_ReuseAddress, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomSocketBinding___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElCustomSocketBinding_methods[] = {
	PHP_ME(TElCustomSocketBinding, Assign, arginfo_TElCustomSocketBinding_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomSocketBinding, get_LocalIntfAddress, arginfo_TElCustomSocketBinding_get_LocalIntfAddress, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomSocketBinding, set_LocalIntfAddress, arginfo_TElCustomSocketBinding_set_LocalIntfAddress, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomSocketBinding, get_Port, arginfo_TElCustomSocketBinding_get_Port, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomSocketBinding, set_Port, arginfo_TElCustomSocketBinding_set_Port, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomSocketBinding, get_ReuseAddress, arginfo_TElCustomSocketBinding_get_ReuseAddress, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomSocketBinding, set_ReuseAddress, arginfo_TElCustomSocketBinding_set_ReuseAddress, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomSocketBinding, __construct, arginfo_TElCustomSocketBinding___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElCustomSocketBinding(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElCustomSocketBinding_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElCustomSocketBinding", TElCustomSocketBinding_methods);
	if (NULL == TPersistent_ce_ptr)
		Register_TPersistent(TSRMLS_C);
	TElCustomSocketBinding_ce_ptr = zend_register_internal_class_ex(&ce, TPersistent_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElClientSocketBinding_ce_ptr = NULL;

SB_PHP_METHOD(TElClientSocketBinding, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TElCustomSocketBinding_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElClientSocketBinding_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomSocketBinding)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElClientSocketBinding, get_PortRangeFrom)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElClientSocketBinding_get_PortRangeFrom(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElClientSocketBinding, set_PortRangeFrom)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElClientSocketBinding_set_PortRangeFrom(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElClientSocketBinding, get_PortRangeTo)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElClientSocketBinding_get_PortRangeTo(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElClientSocketBinding, set_PortRangeTo)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElClientSocketBinding_set_PortRangeTo(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElClientSocketBinding, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElClientSocketBinding_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElClientSocketBinding_Assign, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Source, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElClientSocketBinding_get_PortRangeFrom, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElClientSocketBinding_set_PortRangeFrom, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElClientSocketBinding_get_PortRangeTo, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElClientSocketBinding_set_PortRangeTo, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElClientSocketBinding___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElClientSocketBinding_methods[] = {
	PHP_ME(TElClientSocketBinding, Assign, arginfo_TElClientSocketBinding_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElClientSocketBinding, get_PortRangeFrom, arginfo_TElClientSocketBinding_get_PortRangeFrom, ZEND_ACC_PUBLIC)
	PHP_ME(TElClientSocketBinding, set_PortRangeFrom, arginfo_TElClientSocketBinding_set_PortRangeFrom, ZEND_ACC_PUBLIC)
	PHP_ME(TElClientSocketBinding, get_PortRangeTo, arginfo_TElClientSocketBinding_get_PortRangeTo, ZEND_ACC_PUBLIC)
	PHP_ME(TElClientSocketBinding, set_PortRangeTo, arginfo_TElClientSocketBinding_set_PortRangeTo, ZEND_ACC_PUBLIC)
	PHP_ME(TElClientSocketBinding, __construct, arginfo_TElClientSocketBinding___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElClientSocketBinding(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElClientSocketBinding_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElClientSocketBinding", TElClientSocketBinding_methods);
	if (NULL == TElCustomSocketBinding_ce_ptr)
		Register_TElCustomSocketBinding(TSRMLS_C);
	TElClientSocketBinding_ce_ptr = zend_register_internal_class_ex(&ce, TElCustomSocketBinding_ce_ptr, NULL TSRMLS_CC);
}

#ifdef SB_WINDOWS
zend_class_entry *TElDNSSettings_ce_ptr = NULL;

SB_PHP_METHOD(TElDNSSettings, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElDNSSettings_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSSettings, ResolveHostName)
{
	char *sHostName;
	int sHostName_len;
	zend_bool bUseIPv6;
	zval *oAddr;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sbO", &sHostName, &sHostName_len, &bUseIPv6, &oAddr, sockaddr_storage_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oAddr))
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElDNSSettings_ResolveHostName(SBGetObjectHandle(getThis() TSRMLS_CC), sHostName, (int32_t)sHostName_len, (int8_t)bUseIPv6, (sockaddr_storage *)SBGetStructPointer(oAddr TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string, bool, &sockaddr_storage)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSSettings, get_AllowStatuses)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBDNSSecurityStatusesRaw fOutResultRaw = 0;
		SBCheckError(TElDNSSettings_get_AllowStatuses(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSSettings, set_AllowStatuses)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElDNSSettings_set_AllowStatuses(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBDNSSecurityStatusesRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSSettings, get_Enabled)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElDNSSettings_get_Enabled(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSSettings, set_Enabled)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElDNSSettings_set_Enabled(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSSettings, get_Port)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint16_t u2OutResultRaw = 0;
		SBCheckError(TElDNSSettings_get_Port(SBGetObjectHandle(getThis() TSRMLS_CC), &u2OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u2OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSSettings, set_Port)
{
	long u2Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u2Value) == SUCCESS)
	{
		SBCheckError(TElDNSSettings_set_Port(SBGetObjectHandle(getThis() TSRMLS_CC), (uint16_t)u2Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSSettings, get_Servers)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDNSSettings_get_Servers(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TStringList_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSSettings, set_Servers)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TStringList_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElDNSSettings_set_Servers(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStringList)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSSettings, get_QueryTimeout)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint16_t u2OutResultRaw = 0;
		SBCheckError(TElDNSSettings_get_QueryTimeout(SBGetObjectHandle(getThis() TSRMLS_CC), &u2OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u2OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSSettings, set_QueryTimeout)
{
	long u2Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u2Value) == SUCCESS)
	{
		SBCheckError(TElDNSSettings_set_QueryTimeout(SBGetObjectHandle(getThis() TSRMLS_CC), (uint16_t)u2Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSSettings, get_TotalTimeout)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint16_t u2OutResultRaw = 0;
		SBCheckError(TElDNSSettings_get_TotalTimeout(SBGetObjectHandle(getThis() TSRMLS_CC), &u2OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u2OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSSettings, set_TotalTimeout)
{
	long u2Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u2Value) == SUCCESS)
	{
		SBCheckError(TElDNSSettings_set_TotalTimeout(SBGetObjectHandle(getThis() TSRMLS_CC), (uint16_t)u2Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSSettings, get_UseIPv6)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElDNSSettings_get_UseIPv6(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSSettings, set_UseIPv6)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElDNSSettings_set_UseIPv6(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSSettings, get_UseSecurity)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElDNSSettings_get_UseSecurity(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSSettings, set_UseSecurity)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElDNSSettings_set_UseSecurity(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSSettings, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDNSSettings_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSSettings_Assign, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Source, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSSettings_ResolveHostName, 0, 0, 3)
	ZEND_ARG_INFO(0, HostName)
	ZEND_ARG_INFO(0, UseIPv6)
	ZEND_ARG_OBJ_INFO(1, Addr, sockaddr_storage, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSSettings_get_AllowStatuses, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSSettings_set_AllowStatuses, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSSettings_get_Enabled, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSSettings_set_Enabled, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSSettings_get_Port, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSSettings_set_Port, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSSettings_get_Servers, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSSettings_set_Servers, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TStringList, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSSettings_get_QueryTimeout, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSSettings_set_QueryTimeout, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSSettings_get_TotalTimeout, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSSettings_set_TotalTimeout, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSSettings_get_UseIPv6, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSSettings_set_UseIPv6, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSSettings_get_UseSecurity, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSSettings_set_UseSecurity, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSSettings___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElDNSSettings_methods[] = {
	PHP_ME(TElDNSSettings, Assign, arginfo_TElDNSSettings_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSSettings, ResolveHostName, arginfo_TElDNSSettings_ResolveHostName, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSSettings, get_AllowStatuses, arginfo_TElDNSSettings_get_AllowStatuses, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSSettings, set_AllowStatuses, arginfo_TElDNSSettings_set_AllowStatuses, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSSettings, get_Enabled, arginfo_TElDNSSettings_get_Enabled, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSSettings, set_Enabled, arginfo_TElDNSSettings_set_Enabled, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSSettings, get_Port, arginfo_TElDNSSettings_get_Port, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSSettings, set_Port, arginfo_TElDNSSettings_set_Port, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSSettings, get_Servers, arginfo_TElDNSSettings_get_Servers, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSSettings, set_Servers, arginfo_TElDNSSettings_set_Servers, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSSettings, get_QueryTimeout, arginfo_TElDNSSettings_get_QueryTimeout, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSSettings, set_QueryTimeout, arginfo_TElDNSSettings_set_QueryTimeout, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSSettings, get_TotalTimeout, arginfo_TElDNSSettings_get_TotalTimeout, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSSettings, set_TotalTimeout, arginfo_TElDNSSettings_set_TotalTimeout, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSSettings, get_UseIPv6, arginfo_TElDNSSettings_get_UseIPv6, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSSettings, set_UseIPv6, arginfo_TElDNSSettings_set_UseIPv6, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSSettings, get_UseSecurity, arginfo_TElDNSSettings_get_UseSecurity, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSSettings, set_UseSecurity, arginfo_TElDNSSettings_set_UseSecurity, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSSettings, __construct, arginfo_TElDNSSettings___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElDNSSettings(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElDNSSettings_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElDNSSettings", TElDNSSettings_methods);
	if (NULL == TPersistent_ce_ptr)
		Register_TPersistent(TSRMLS_C);
	TElDNSSettings_ce_ptr = zend_register_internal_class_ex(&ce, TPersistent_ce_ptr, NULL TSRMLS_CC);
}
#endif

zend_class_entry *TElSocketSettings_ce_ptr = NULL;

SB_PHP_METHOD(TElSocketSettings, get_AutoAdjustBuffersSize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSocketSettings_get_AutoAdjustBuffersSize(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSocketSettings, set_AutoAdjustBuffersSize)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSocketSettings_set_AutoAdjustBuffersSize(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSocketSettings, get_MinBufferSize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSocketSettings_get_MinBufferSize(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSocketSettings, set_MinBufferSize)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElSocketSettings_set_MinBufferSize(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSocketSettings, get_MaxBufferSize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSocketSettings_get_MaxBufferSize(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSocketSettings, set_MaxBufferSize)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElSocketSettings_set_MaxBufferSize(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSocketSettings, get_BuffersAdjustStep)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		double dOutResult = 0.0;
		SBCheckError(TElSocketSettings_get_BuffersAdjustStep(SBGetObjectHandle(getThis() TSRMLS_CC), &dOutResult) TSRMLS_CC);
		RETURN_DOUBLE(dOutResult);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSocketSettings, set_BuffersAdjustStep)
{
	double dValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "d", &dValue) == SUCCESS)
	{
		SBCheckError(TElSocketSettings_set_BuffersAdjustStep(SBGetObjectHandle(getThis() TSRMLS_CC), (double)dValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(double)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSocketSettings, get_SendBufferSize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSocketSettings_get_SendBufferSize(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSocketSettings, set_SendBufferSize)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElSocketSettings_set_SendBufferSize(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSocketSettings, get_RecvBufferSize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSocketSettings_get_RecvBufferSize(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSocketSettings, set_RecvBufferSize)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElSocketSettings_set_RecvBufferSize(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSocketSettings, get_UseNagle)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSocketSettings_get_UseNagle(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSocketSettings, set_UseNagle)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSocketSettings_set_UseNagle(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSocketSettings, __construct)
{
	zval *oSocket;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSocket, TElSocket_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSocketSettings_Create(SBGetObjectHandle(oSocket TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSocket)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSocketSettings_get_AutoAdjustBuffersSize, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSocketSettings_set_AutoAdjustBuffersSize, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSocketSettings_get_MinBufferSize, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSocketSettings_set_MinBufferSize, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSocketSettings_get_MaxBufferSize, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSocketSettings_set_MaxBufferSize, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSocketSettings_get_BuffersAdjustStep, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSocketSettings_set_BuffersAdjustStep, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSocketSettings_get_SendBufferSize, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSocketSettings_set_SendBufferSize, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSocketSettings_get_RecvBufferSize, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSocketSettings_set_RecvBufferSize, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSocketSettings_get_UseNagle, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSocketSettings_set_UseNagle, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSocketSettings___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Socket, TElSocket, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElSocketSettings_methods[] = {
	PHP_ME(TElSocketSettings, get_AutoAdjustBuffersSize, arginfo_TElSocketSettings_get_AutoAdjustBuffersSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElSocketSettings, set_AutoAdjustBuffersSize, arginfo_TElSocketSettings_set_AutoAdjustBuffersSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElSocketSettings, get_MinBufferSize, arginfo_TElSocketSettings_get_MinBufferSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElSocketSettings, set_MinBufferSize, arginfo_TElSocketSettings_set_MinBufferSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElSocketSettings, get_MaxBufferSize, arginfo_TElSocketSettings_get_MaxBufferSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElSocketSettings, set_MaxBufferSize, arginfo_TElSocketSettings_set_MaxBufferSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElSocketSettings, get_BuffersAdjustStep, arginfo_TElSocketSettings_get_BuffersAdjustStep, ZEND_ACC_PUBLIC)
	PHP_ME(TElSocketSettings, set_BuffersAdjustStep, arginfo_TElSocketSettings_set_BuffersAdjustStep, ZEND_ACC_PUBLIC)
	PHP_ME(TElSocketSettings, get_SendBufferSize, arginfo_TElSocketSettings_get_SendBufferSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElSocketSettings, set_SendBufferSize, arginfo_TElSocketSettings_set_SendBufferSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElSocketSettings, get_RecvBufferSize, arginfo_TElSocketSettings_get_RecvBufferSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElSocketSettings, set_RecvBufferSize, arginfo_TElSocketSettings_set_RecvBufferSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElSocketSettings, get_UseNagle, arginfo_TElSocketSettings_get_UseNagle, ZEND_ACC_PUBLIC)
	PHP_ME(TElSocketSettings, set_UseNagle, arginfo_TElSocketSettings_set_UseNagle, ZEND_ACC_PUBLIC)
	PHP_ME(TElSocketSettings, __construct, arginfo_TElSocketSettings___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSocketSettings(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSocketSettings_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSocketSettings", TElSocketSettings_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElSocketSettings_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_FUNCTION(SBSocket, AddressToString)
{
	char *sS = NULL;
	int32_t sS_len = 0;
	uint32_t _err;
	zval *oAddr;
	zval *zsS;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "Oz", &oAddr, sockaddr_storage_ce_ptr, &zsS) == SUCCESS) && PZVAL_IS_REF(zsS) && (IS_STRING == Z_TYPE_P(zsS)))
	{
		int8_t bOutResultRaw = 0;
		_err = SBSocket_AddressToString((sockaddr_storage *)SBGetStructPointer(oAddr TSRMLS_CC), sS, &sS_len, &bOutResultRaw);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sS = emalloc(sS_len + 1);
			SBCheckError(SBGetLastReturnStringA(1620816918, 1, sS, &sS_len) TSRMLS_CC);
			zval_dtor(zsS);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		sS[sS_len] = 0;
		ZVAL_STRINGL(zsS, sS, sS_len, 0);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(sockaddr_storage, &string)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBSocket, StringToAddress)
{
	char *sS;
	int sS_len;
	zval *oAddr;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO", &sS, &sS_len, &oAddr, sockaddr_storage_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oAddr))
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(SBSocket_StringToAddress(sS, (int32_t)sS_len, (sockaddr_storage *)SBGetStructPointer(oAddr TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string, &sockaddr_storage)" TSRMLS_CC);
	}
}

#ifdef SB_WINDOWS
SB_PHP_FUNCTION(SBSocket, IsIPv6Address)
{
	char *sS;
	int sS_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sS, &sS_len) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(SBSocket_IsIPv6Address(sS, (int32_t)sS_len, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}
#endif

void Register_SBSocket_Constants(int module_number TSRMLS_DC)
{
	SB_REGISTER_LONG_CONSTANT(SBSocket, ERROR_FACILITY_SOCKET, SB_ERROR_FACILITY_SOCKET, SB_ERROR_FACILITY_SOCKET);
	SB_REGISTER_LONG_CONSTANT(SBSocket, ERROR_SOCKET_PROTOCOL_ERROR_FLAG, SB_ERROR_SOCKET_PROTOCOL_ERROR_FLAG, SB_ERROR_SOCKET_PROTOCOL_ERROR_FLAG);
	SB_REGISTER_LONG_CONSTANT(SBSocket, SB_SOCKET_ERROR_WINSOCK_INIT_FAILED, SB_SOCKET_ERROR_WINSOCK_INIT_FAILED, SB_SOCKET_ERROR_WINSOCK_INIT_FAILED);
	SB_REGISTER_LONG_CONSTANT(SBSocket, SB_SOCKET_ERROR_WRONG_SOCKET_STATE, SB_SOCKET_ERROR_WRONG_SOCKET_STATE, SB_SOCKET_ERROR_WRONG_SOCKET_STATE);
	SB_REGISTER_LONG_CONSTANT(SBSocket, SB_SOCKET_ERROR_NOT_A_SOCKET, SB_SOCKET_ERROR_NOT_A_SOCKET, SB_SOCKET_ERROR_NOT_A_SOCKET);
	SB_REGISTER_LONG_CONSTANT(SBSocket, SB_SOCKET_ERROR_INVALID_ADDRESS, SB_SOCKET_ERROR_INVALID_ADDRESS, SB_SOCKET_ERROR_INVALID_ADDRESS);
	SB_REGISTER_LONG_CONSTANT(SBSocket, SB_SOCKET_ERROR_ACCEPT_FAILED, SB_SOCKET_ERROR_ACCEPT_FAILED, SB_SOCKET_ERROR_ACCEPT_FAILED);
	SB_REGISTER_LONG_CONSTANT(SBSocket, SB_SOCKET_ERROR_ADDRESS_FAMILY_MISMATCH, SB_SOCKET_ERROR_ADDRESS_FAMILY_MISMATCH, SB_SOCKET_ERROR_ADDRESS_FAMILY_MISMATCH);
	SB_REGISTER_LONG_CONSTANT(SBSocket, SB_SOCKET_ERROR_INVALID_SOCKET_TYPE, SB_SOCKET_ERROR_INVALID_SOCKET_TYPE, SB_SOCKET_ERROR_INVALID_SOCKET_TYPE);
	SB_REGISTER_LONG_CONSTANT(SBSocket, SB_SOCKET_ERROR_SOCKS_NEGOTIATION_FAILED, SB_SOCKET_ERROR_SOCKS_NEGOTIATION_FAILED, SB_SOCKET_ERROR_SOCKS_NEGOTIATION_FAILED);
	SB_REGISTER_LONG_CONSTANT(SBSocket, SB_SOCKET_ERROR_SOCKS_AUTH_FAILED, SB_SOCKET_ERROR_SOCKS_AUTH_FAILED, SB_SOCKET_ERROR_SOCKS_AUTH_FAILED);
	SB_REGISTER_LONG_CONSTANT(SBSocket, SB_SOCKET_ERROR_SOCKS_FAILED_TO_RESOLVE_DESTINATION_ADDRESS, SB_SOCKET_ERROR_SOCKS_FAILED_TO_RESOLVE_DESTINATION_ADDRESS, SB_SOCKET_ERROR_SOCKS_FAILED_TO_RESOLVE_DESTINATION_ADDRESS);
	SB_REGISTER_LONG_CONSTANT(SBSocket, SB_SOCKET_ERROR_DNS_SECURITY_FAILURE, SB_SOCKET_ERROR_DNS_SECURITY_FAILURE, SB_SOCKET_ERROR_DNS_SECURITY_FAILURE);
	SB_REGISTER_LONG_CONSTANT(SBSocket, SB_SOCKET_ERROR_DNS_TIMEOUT, SB_SOCKET_ERROR_DNS_TIMEOUT, SB_SOCKET_ERROR_DNS_TIMEOUT);
	SB_REGISTER_LONG_CONSTANT(SBSocket, SB_SOCKET_ERROR_WEBTUNNEL_NEGOTIATION_FAILED, SB_SOCKET_ERROR_WEBTUNNEL_NEGOTIATION_FAILED, SB_SOCKET_ERROR_WEBTUNNEL_NEGOTIATION_FAILED);
	SB_REGISTER_LONG_CONSTANT(SBSocket, SB_SOCKET_ERROR_TIMEOUT, SB_SOCKET_ERROR_TIMEOUT, SB_SOCKET_ERROR_TIMEOUT);
	SB_REGISTER_LONG_CONSTANT(SBSocket, _SSALIGNSIZE, SB__SSALIGNSIZE, SB__SSALIGNSIZE);
	SB_REGISTER_LONG_CONSTANT(SBSocket, _SSMAXSIZE, SB__SSMAXSIZE, SB__SSMAXSIZE);
	SB_REGISTER_LONG_CONSTANT(SBSocket, _SSPAD1SIZE, SB__SSPAD1SIZE, SB__SSPAD1SIZE);
	SB_REGISTER_LONG_CONSTANT(SBSocket, _SSPAD2SIZE, SB__SSPAD2SIZE, SB__SSPAD2SIZE);
#ifdef SB_WINDOWS
	SB_REGISTER_LONG_CONSTANT(SBSocket, AF_INET6, SB_AF_INET6, SB_AF_INET6);
	SB_REGISTER_LONG_CONSTANT(SBSocket, INVALID_SOCKET, SB_INVALID_SOCKET, SB_INVALID_SOCKET);
#endif
#ifdef LINUX
	SB_REGISTER_LONG_CONSTANT(SBSocket, MSG_NOSIGNAL, SB_MSG_NOSIGNAL, SB_MSG_NOSIGNAL);
#endif
#ifdef MACOS
	SB_REGISTER_LONG_CONSTANT(SBSocket, SO_NOSIGPIPE, SB_SO_NOSIGPIPE, SB_SO_NOSIGPIPE);
#endif
	SB_REGISTER_LONG_CONSTANT(SBSocket, SB_SOCKET_ERROR_CODE_TIMEDOUT, SB_SOCKET_ERROR_CODE_TIMEDOUT, SB_SOCKET_ERROR_CODE_TIMEDOUT);
	SB_REGISTER_LONG_CONSTANT(SBSocket, SB_SOCKET_ERROR_CODE_WOULDBLOCK, SB_SOCKET_ERROR_CODE_WOULDBLOCK, SB_SOCKET_ERROR_CODE_WOULDBLOCK);
	SB_REGISTER_LONG_CONSTANT(SBSocket, SB_SOCKET_ERROR_CODE_CONNRESET, SB_SOCKET_ERROR_CODE_CONNRESET, SB_SOCKET_ERROR_CODE_CONNRESET);
	SB_REGISTER_LONG_CONSTANT(SBSocket, SB_SOCKET_ERROR_CODE_ADDRINUSE, SB_SOCKET_ERROR_CODE_ADDRINUSE, SB_SOCKET_ERROR_CODE_ADDRINUSE);
	SB_REGISTER_LONG_CONSTANT(SBSocket, SB_SOCKET_ERROR_CODE_ISCONN, SB_SOCKET_ERROR_CODE_ISCONN, SB_SOCKET_ERROR_CODE_ISCONN);
	SB_REGISTER_LONG_CONSTANT(SBSocket, SB_SOCKET_ERROR_CODE_INPROGRESS, SB_SOCKET_ERROR_CODE_INPROGRESS, SB_SOCKET_ERROR_CODE_INPROGRESS);
	SB_REGISTER_LONG_CONSTANT(SBSocket, SB_SOCKET_ERROR_CODE_SHUTDOWN, SB_SOCKET_ERROR_CODE_SHUTDOWN, SB_SOCKET_ERROR_CODE_SHUTDOWN);
}

void Register_SBSocket_Enum_Flags(TSRMLS_D)
{
	zend_class_entry ce;
	INIT_CLASS_ENTRY(ce, "TElShutdownDirection", NULL);
	TElShutdownDirection_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TElShutdownDirection_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TElShutdownDirection_ce_ptr, "sdReceive", 0)
	SB_DECLARE_CLASS_LONG_CONST(TElShutdownDirection_ce_ptr, "sdSend", 1)
	SB_DECLARE_CLASS_LONG_CONST(TElShutdownDirection_ce_ptr, "sdSendAndReceive", 2)
	
	INIT_CLASS_ENTRY(ce, "TElSocketState", NULL);
	TElSocketState_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TElSocketState_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TElSocketState_ce_ptr, "issNotASocket", 0)
	SB_DECLARE_CLASS_LONG_CONST(TElSocketState_ce_ptr, "issInitializing", 1)
	SB_DECLARE_CLASS_LONG_CONST(TElSocketState_ce_ptr, "issInitialized", 2)
	SB_DECLARE_CLASS_LONG_CONST(TElSocketState_ce_ptr, "issBound", 3)
	SB_DECLARE_CLASS_LONG_CONST(TElSocketState_ce_ptr, "issConnected", 4)
	SB_DECLARE_CLASS_LONG_CONST(TElSocketState_ce_ptr, "issListening", 5)
	SB_DECLARE_CLASS_LONG_CONST(TElSocketState_ce_ptr, "issConnecting", 6)
	
	INIT_CLASS_ENTRY(ce, "TElSocketType", NULL);
	TElSocketType_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TElSocketType_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TElSocketType_ce_ptr, "istStream", 0)
	SB_DECLARE_CLASS_LONG_CONST(TElSocketType_ce_ptr, "istDatagram", 1)
	
	INIT_CLASS_ENTRY(ce, "TElSocksVersion", NULL);
	TElSocksVersion_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TElSocksVersion_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TElSocksVersion_ce_ptr, "elSocks4", 0)
	SB_DECLARE_CLASS_LONG_CONST(TElSocksVersion_ce_ptr, "elSocks5", 1)
	
	INIT_CLASS_ENTRY(ce, "TElSocksAuthentication", NULL);
	TElSocksAuthentication_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TElSocksAuthentication_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TElSocksAuthentication_ce_ptr, "saNoAuthentication", 0)
	SB_DECLARE_CLASS_LONG_CONST(TElSocksAuthentication_ce_ptr, "saUsercode", 1)
	
	INIT_CLASS_ENTRY(ce, "TElWebTunnelAuthentication", NULL);
	TElWebTunnelAuthentication_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TElWebTunnelAuthentication_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TElWebTunnelAuthentication_ce_ptr, "wtaNoAuthentication", 0)
	SB_DECLARE_CLASS_LONG_CONST(TElWebTunnelAuthentication_ce_ptr, "wtaBasic", 1)
	SB_DECLARE_CLASS_LONG_CONST(TElWebTunnelAuthentication_ce_ptr, "wtaDigest", 2)
	SB_DECLARE_CLASS_LONG_CONST(TElWebTunnelAuthentication_ce_ptr, "wtaNTLM", 3)
	
	INIT_CLASS_ENTRY(ce, "TElBandwidthPolicy", NULL);
	TElBandwidthPolicy_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TElBandwidthPolicy_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TElBandwidthPolicy_ce_ptr, "bpFlexible", 0)
	SB_DECLARE_CLASS_LONG_CONST(TElBandwidthPolicy_ce_ptr, "bpStrict", 1)
}

void Register_SBSocket_Aliases(TSRMLS_D)
{
	if (NULL == TElCustomSocketBinding_ce_ptr)
		Register_TElCustomSocketBinding(TSRMLS_C);
	zend_register_class_alias("ElCustomSocketBinding", TElCustomSocketBinding_ce_ptr);
	if (NULL == TElClientSocketBinding_ce_ptr)
		Register_TElClientSocketBinding(TSRMLS_C);
	zend_register_class_alias("TElSocketBinding", TElClientSocketBinding_ce_ptr);
	if (NULL == TElClientSocketBinding_ce_ptr)
		Register_TElClientSocketBinding(TSRMLS_C);
	zend_register_class_alias("ElClientSocketBinding", TElClientSocketBinding_ce_ptr);
	if (NULL == TElClientSocketBinding_ce_ptr)
		Register_TElClientSocketBinding(TSRMLS_C);
	zend_register_class_alias("ElSocketBinding", TElClientSocketBinding_ce_ptr);
#ifndef SB_WINDOWS
	if (NULL == sockaddr_in_ce_ptr)
		Register_sockaddr_in(TSRMLS_C);
	zend_register_class_alias("TSockAddrIn", sockaddr_in_ce_ptr);
#endif
	if (NULL == sockaddr_storage_ce_ptr)
		Register_sockaddr_storage(TSRMLS_C);
	zend_register_class_alias("TSockAddrStorage", sockaddr_storage_ce_ptr);
}
