#include "sbxmlenc.h"

void SB_CALLBACK TSBXMLDecryptKeyDataEventRaw(void * _ObjectData, TObjectHandle Sender, TElXMLDOMElementHandle EncryptedData, TElXMLDecryptorHandle Decryptor, int32_t PrevResult, TElXMLKeyInfoDataHandle * KeyData, int8_t * OutResult)
{
	zval **params[5];
	zval * zSender;
	zval * zEncryptedData;
	zval * zDecryptor;
	zval * zPrevResult;
	zval * zKeyData;
	zval * pzOutResult = NULL;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zEncryptedData);
	SBInitObject(zEncryptedData, TElXMLDOMElement_ce_ptr, EncryptedData TSRMLS_CC);
	MAKE_STD_ZVAL(zDecryptor);
	SBInitObject(zDecryptor, TElXMLDecryptor_ce_ptr, Decryptor TSRMLS_CC);
	MAKE_STD_ZVAL(zPrevResult);
	ZVAL_LONG(zPrevResult, (long)PrevResult);
	MAKE_STD_ZVAL(zKeyData);
	SBInitObject(zKeyData, TElXMLKeyInfoData_ce_ptr, *KeyData TSRMLS_CC);

	params[0] = &zSender;
	params[1] = &zEncryptedData;
	params[2] = &zDecryptor;
	params[3] = &zPrevResult;
	params[4] = &zKeyData;
	SBCallEvent((zval *)_ObjectData, &pzOutResult, 5, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zEncryptedData);
	zval_ptr_dtor(&zDecryptor);
	zval_ptr_dtor(&zPrevResult);
	*KeyData = SBGetObjectHandleCE(zKeyData, TElXMLKeyInfoData_ce_ptr TSRMLS_CC);
	SBDetachObjectHandleIfUniqueZVal(zKeyData TSRMLS_CC);
	zval_ptr_dtor(&zKeyData);
	if (pzOutResult)
	{
		*OutResult = (int8_t)Z_BVAL_P(pzOutResult);
		zval_ptr_dtor(&pzOutResult);
	}
}

zend_class_entry *TElXMLEncryptedType_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLEncryptedType, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElXMLEncryptedType_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLEncryptedType, IsEmpty)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElXMLEncryptedType_IsEmpty(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLEncryptedType, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLEncryptedType_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLEncryptedType, SaveToXML)
{
	zval *oDocument;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oDocument, TElXMLDOMDocument_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLEncryptedType_SaveToXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDocument, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLEncryptedType_SaveToXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument, TElXMLCustomFormatter) or (TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLEncryptedType, get_EncryptionMethod)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLEncryptedType_get_EncryptionMethod(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLEncryptionMethodType_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLEncryptedType, set_EncryptionMethod)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElXMLEncryptionMethodType_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLEncryptedType_set_EncryptionMethod(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLEncryptionMethodType)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLEncryptedType, get_CipherData)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLEncryptedType_get_CipherData(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLCipherData_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLEncryptedType, set_CipherData)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElXMLCipherData_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLEncryptedType_set_CipherData(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLCipherData)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLEncryptedType, get_KeyInfo)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLEncryptedType_get_KeyInfo(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLKeyInfo_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLEncryptedType, set_KeyInfo)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElXMLKeyInfo_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLEncryptedType_set_KeyInfo(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLKeyInfo)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLEncryptedType, get_EncryptionProperties)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLEncryptedType_get_EncryptionProperties(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLEncryptionProperties_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLEncryptedType, set_EncryptionProperties)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElXMLEncryptionProperties_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLEncryptedType_set_EncryptionProperties(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLEncryptionProperties)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLEncryptedType, get_ID)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLEncryptedType_get_ID(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(324453097, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLEncryptedType, set_ID)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElXMLEncryptedType_set_ID(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLEncryptedType, get_DataType)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLEncryptedType_get_DataType(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1834060141, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLEncryptedType, set_DataType)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElXMLEncryptedType_set_DataType(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLEncryptedType, get_MimeType)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLEncryptedType_get_MimeType(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1868027470, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLEncryptedType, set_MimeType)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElXMLEncryptedType_set_MimeType(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLEncryptedType, get_Encoding)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLEncryptedType_get_Encoding(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(538079354, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLEncryptedType, set_Encoding)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElXMLEncryptedType_set_Encoding(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLEncryptedType, get_CryptoProviderManager)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLEncryptedType_get_CryptoProviderManager(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomCryptoProviderManager_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLEncryptedType, set_CryptoProviderManager)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElCustomCryptoProviderManager_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLEncryptedType_set_CryptoProviderManager(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCryptoProviderManager)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLEncryptedType, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLEncryptedType_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLEncryptedType_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLEncryptedType_IsEmpty, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLEncryptedType_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLEncryptedType_SaveToXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLEncryptedType_get_EncryptionMethod, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLEncryptedType_set_EncryptionMethod, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElXMLEncryptionMethodType, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLEncryptedType_get_CipherData, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLEncryptedType_set_CipherData, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElXMLCipherData, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLEncryptedType_get_KeyInfo, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLEncryptedType_set_KeyInfo, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElXMLKeyInfo, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLEncryptedType_get_EncryptionProperties, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLEncryptedType_set_EncryptionProperties, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElXMLEncryptionProperties, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLEncryptedType_get_ID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLEncryptedType_set_ID, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLEncryptedType_get_DataType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLEncryptedType_set_DataType, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLEncryptedType_get_MimeType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLEncryptedType_set_MimeType, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLEncryptedType_get_Encoding, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLEncryptedType_set_Encoding, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLEncryptedType_get_CryptoProviderManager, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLEncryptedType_set_CryptoProviderManager, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElCustomCryptoProviderManager, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLEncryptedType___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLEncryptedType_methods[] = {
	PHP_ME(TElXMLEncryptedType, Clear, arginfo_TElXMLEncryptedType_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLEncryptedType, IsEmpty, arginfo_TElXMLEncryptedType_IsEmpty, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLEncryptedType, LoadFromXML, arginfo_TElXMLEncryptedType_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLEncryptedType, SaveToXML, arginfo_TElXMLEncryptedType_SaveToXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLEncryptedType, get_EncryptionMethod, arginfo_TElXMLEncryptedType_get_EncryptionMethod, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLEncryptedType, set_EncryptionMethod, arginfo_TElXMLEncryptedType_set_EncryptionMethod, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLEncryptedType, get_CipherData, arginfo_TElXMLEncryptedType_get_CipherData, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLEncryptedType, set_CipherData, arginfo_TElXMLEncryptedType_set_CipherData, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLEncryptedType, get_KeyInfo, arginfo_TElXMLEncryptedType_get_KeyInfo, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLEncryptedType, set_KeyInfo, arginfo_TElXMLEncryptedType_set_KeyInfo, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLEncryptedType, get_EncryptionProperties, arginfo_TElXMLEncryptedType_get_EncryptionProperties, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLEncryptedType, set_EncryptionProperties, arginfo_TElXMLEncryptedType_set_EncryptionProperties, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLEncryptedType, get_ID, arginfo_TElXMLEncryptedType_get_ID, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLEncryptedType, set_ID, arginfo_TElXMLEncryptedType_set_ID, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLEncryptedType, get_DataType, arginfo_TElXMLEncryptedType_get_DataType, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLEncryptedType, set_DataType, arginfo_TElXMLEncryptedType_set_DataType, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLEncryptedType, get_MimeType, arginfo_TElXMLEncryptedType_get_MimeType, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLEncryptedType, set_MimeType, arginfo_TElXMLEncryptedType_set_MimeType, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLEncryptedType, get_Encoding, arginfo_TElXMLEncryptedType_get_Encoding, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLEncryptedType, set_Encoding, arginfo_TElXMLEncryptedType_set_Encoding, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLEncryptedType, get_CryptoProviderManager, arginfo_TElXMLEncryptedType_get_CryptoProviderManager, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLEncryptedType, set_CryptoProviderManager, arginfo_TElXMLEncryptedType_set_CryptoProviderManager, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLEncryptedType, __construct, arginfo_TElXMLEncryptedType___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLEncryptedType(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLEncryptedType_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLEncryptedType", TElXMLEncryptedType_methods);
	if (NULL == TElXMLCustomElement_ce_ptr)
		Register_TElXMLCustomElement(TSRMLS_C);
	TElXMLEncryptedType_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLCustomElement_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLEncProcessor_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLEncProcessor, get_KeyEncryptionKeyData)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLEncProcessor_get_KeyEncryptionKeyData(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLKeyInfoData_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLEncProcessor, set_KeyEncryptionKeyData)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElXMLKeyInfoData_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLEncProcessor_set_KeyEncryptionKeyData(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLKeyInfoData)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLEncProcessor, get_EncryptedData)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLEncProcessor_get_EncryptedData(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLEncryptedData_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLEncProcessor, set_EncryptedData)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElXMLEncryptedData_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLEncProcessor_set_EncryptedData(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLEncryptedData)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLEncProcessor, __construct)
{
	zval *oAOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLEncProcessor_Create(SBGetObjectHandle(oAOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLEncProcessor_get_KeyEncryptionKeyData, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLEncProcessor_set_KeyEncryptionKeyData, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElXMLKeyInfoData, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLEncProcessor_get_EncryptedData, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLEncProcessor_set_EncryptedData, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElXMLEncryptedData, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLEncProcessor___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AOwner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLEncProcessor_methods[] = {
	PHP_ME(TElXMLEncProcessor, get_KeyEncryptionKeyData, arginfo_TElXMLEncProcessor_get_KeyEncryptionKeyData, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLEncProcessor, set_KeyEncryptionKeyData, arginfo_TElXMLEncProcessor_set_KeyEncryptionKeyData, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLEncProcessor, get_EncryptedData, arginfo_TElXMLEncProcessor_get_EncryptedData, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLEncProcessor, set_EncryptedData, arginfo_TElXMLEncProcessor_set_EncryptedData, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLEncProcessor, __construct, arginfo_TElXMLEncProcessor___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLEncProcessor(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLEncProcessor_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLEncProcessor", TElXMLEncProcessor_methods);
	if (NULL == TElXMLProcessor_ce_ptr)
		Register_TElXMLProcessor(TSRMLS_C);
	TElXMLEncProcessor_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLProcessor_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLEncryptor_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLEncryptor, Encrypt)
{
	SBArrayZValInfo aiData;
	zval *oData;
	zval *zaData;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oData, TElXMLDOMNode_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLEncryptor_Encrypt(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oData TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oData, TElXMLDOMNodeList_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLEncryptor_Encrypt_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oData TSRMLS_CC)) TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaData) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaData)) || (IS_ARRAY == Z_TYPE_P(zaData)) || (IS_NULL == Z_TYPE_P(zaData))))
	{
		if (!SBGetByteArrayFromZVal(zaData, &aiData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElXMLEncryptor_Encrypt_2(SBGetObjectHandle(getThis() TSRMLS_CC), aiData.data, aiData.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiData);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMNode) or (TElXMLDOMNodeList) or (array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLEncryptor, Save)
{
	zval *oDocument;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDocument, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLEncryptor_Save(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLEncryptor, SaveToDocument)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLEncryptor_SaveToDocument(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMDocument_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLEncryptor, get_KeyData)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLEncryptor_get_KeyData(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLKeyInfoData_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLEncryptor, set_KeyData)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElXMLKeyInfoData_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLEncryptor_set_KeyData(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLKeyInfoData)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLEncryptor, get_EncryptKey)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElXMLEncryptor_get_EncryptKey(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLEncryptor, set_EncryptKey)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElXMLEncryptor_set_EncryptKey(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLEncryptor, get_KeyName)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLEncryptor_get_KeyName(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1623400077, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLEncryptor, set_KeyName)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElXMLEncryptor_set_KeyName(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLEncryptor, get_EncryptedDataType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElXMLEncryptedDataTypeRaw fOutResultRaw = 0;
		SBCheckError(TElXMLEncryptor_get_EncryptedDataType(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLEncryptor, set_EncryptedDataType)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElXMLEncryptor_set_EncryptedDataType(SBGetObjectHandle(getThis() TSRMLS_CC), (TElXMLEncryptedDataTypeRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLEncryptor, get_EncryptionMethod)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElXMLEncryptionMethodRaw fOutResultRaw = 0;
		SBCheckError(TElXMLEncryptor_get_EncryptionMethod(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLEncryptor, set_EncryptionMethod)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElXMLEncryptor_set_EncryptionMethod(SBGetObjectHandle(getThis() TSRMLS_CC), (TElXMLEncryptionMethodRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLEncryptor, get_KeyEncryptionType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElXMLKeyEncryptionTypeRaw fOutResultRaw = 0;
		SBCheckError(TElXMLEncryptor_get_KeyEncryptionType(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLEncryptor, set_KeyEncryptionType)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElXMLEncryptor_set_KeyEncryptionType(SBGetObjectHandle(getThis() TSRMLS_CC), (TElXMLKeyEncryptionTypeRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLEncryptor, get_KeyTransportMethod)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElXMLKeyTransportMethodRaw fOutResultRaw = 0;
		SBCheckError(TElXMLEncryptor_get_KeyTransportMethod(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLEncryptor, set_KeyTransportMethod)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElXMLEncryptor_set_KeyTransportMethod(SBGetObjectHandle(getThis() TSRMLS_CC), (TElXMLKeyTransportMethodRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLEncryptor, get_KeyWrapMethod)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElXMLKeyWrapMethodRaw fOutResultRaw = 0;
		SBCheckError(TElXMLEncryptor_get_KeyWrapMethod(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLEncryptor, set_KeyWrapMethod)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElXMLEncryptor_set_KeyWrapMethod(SBGetObjectHandle(getThis() TSRMLS_CC), (TElXMLKeyWrapMethodRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLEncryptor, get_IncludeKeyEncryptionKey)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElXMLEncryptor_get_IncludeKeyEncryptionKey(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLEncryptor, set_IncludeKeyEncryptionKey)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElXMLEncryptor_set_IncludeKeyEncryptionKey(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLEncryptor, get_MimeType)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLEncryptor_get_MimeType(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1783066900, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLEncryptor, set_MimeType)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElXMLEncryptor_set_MimeType(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLEncryptor, get_OnFormatElement)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBXMLFormatElementEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElXMLEncryptor_get_OnFormatElement(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLEncryptor, set_OnFormatElement)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElXMLEncryptor_set_OnFormatElement(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBXMLFormatElementEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBXMLFormatElementEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLEncryptor, get_OnFormatText)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBXMLFormatTextEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElXMLEncryptor_get_OnFormatText(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLEncryptor, set_OnFormatText)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElXMLEncryptor_set_OnFormatText(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBXMLFormatTextEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBXMLFormatTextEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLEncryptor, __construct)
{
	zval *oAOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLEncryptor_Create(SBGetObjectHandle(oAOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLEncryptor_Encrypt, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Data, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLEncryptor_Save, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLEncryptor_SaveToDocument, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLEncryptor_get_KeyData, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLEncryptor_set_KeyData, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElXMLKeyInfoData, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLEncryptor_get_EncryptKey, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLEncryptor_set_EncryptKey, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLEncryptor_get_KeyName, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLEncryptor_set_KeyName, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLEncryptor_get_EncryptedDataType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLEncryptor_set_EncryptedDataType, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLEncryptor_get_EncryptionMethod, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLEncryptor_set_EncryptionMethod, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLEncryptor_get_KeyEncryptionType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLEncryptor_set_KeyEncryptionType, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLEncryptor_get_KeyTransportMethod, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLEncryptor_set_KeyTransportMethod, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLEncryptor_get_KeyWrapMethod, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLEncryptor_set_KeyWrapMethod, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLEncryptor_get_IncludeKeyEncryptionKey, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLEncryptor_set_IncludeKeyEncryptionKey, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLEncryptor_get_MimeType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLEncryptor_set_MimeType, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLEncryptor_get_OnFormatElement, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLEncryptor_set_OnFormatElement, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLEncryptor_get_OnFormatText, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLEncryptor_set_OnFormatText, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLEncryptor___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AOwner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLEncryptor_methods[] = {
	PHP_ME(TElXMLEncryptor, Encrypt, arginfo_TElXMLEncryptor_Encrypt, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLEncryptor, Save, arginfo_TElXMLEncryptor_Save, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLEncryptor, SaveToDocument, arginfo_TElXMLEncryptor_SaveToDocument, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLEncryptor, get_KeyData, arginfo_TElXMLEncryptor_get_KeyData, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLEncryptor, set_KeyData, arginfo_TElXMLEncryptor_set_KeyData, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLEncryptor, get_EncryptKey, arginfo_TElXMLEncryptor_get_EncryptKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLEncryptor, set_EncryptKey, arginfo_TElXMLEncryptor_set_EncryptKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLEncryptor, get_KeyName, arginfo_TElXMLEncryptor_get_KeyName, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLEncryptor, set_KeyName, arginfo_TElXMLEncryptor_set_KeyName, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLEncryptor, get_EncryptedDataType, arginfo_TElXMLEncryptor_get_EncryptedDataType, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLEncryptor, set_EncryptedDataType, arginfo_TElXMLEncryptor_set_EncryptedDataType, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLEncryptor, get_EncryptionMethod, arginfo_TElXMLEncryptor_get_EncryptionMethod, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLEncryptor, set_EncryptionMethod, arginfo_TElXMLEncryptor_set_EncryptionMethod, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLEncryptor, get_KeyEncryptionType, arginfo_TElXMLEncryptor_get_KeyEncryptionType, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLEncryptor, set_KeyEncryptionType, arginfo_TElXMLEncryptor_set_KeyEncryptionType, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLEncryptor, get_KeyTransportMethod, arginfo_TElXMLEncryptor_get_KeyTransportMethod, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLEncryptor, set_KeyTransportMethod, arginfo_TElXMLEncryptor_set_KeyTransportMethod, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLEncryptor, get_KeyWrapMethod, arginfo_TElXMLEncryptor_get_KeyWrapMethod, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLEncryptor, set_KeyWrapMethod, arginfo_TElXMLEncryptor_set_KeyWrapMethod, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLEncryptor, get_IncludeKeyEncryptionKey, arginfo_TElXMLEncryptor_get_IncludeKeyEncryptionKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLEncryptor, set_IncludeKeyEncryptionKey, arginfo_TElXMLEncryptor_set_IncludeKeyEncryptionKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLEncryptor, get_MimeType, arginfo_TElXMLEncryptor_get_MimeType, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLEncryptor, set_MimeType, arginfo_TElXMLEncryptor_set_MimeType, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLEncryptor, get_OnFormatElement, arginfo_TElXMLEncryptor_get_OnFormatElement, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLEncryptor, set_OnFormatElement, arginfo_TElXMLEncryptor_set_OnFormatElement, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLEncryptor, get_OnFormatText, arginfo_TElXMLEncryptor_get_OnFormatText, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLEncryptor, set_OnFormatText, arginfo_TElXMLEncryptor_set_OnFormatText, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLEncryptor, __construct, arginfo_TElXMLEncryptor___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLEncryptor(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLEncryptor_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLEncryptor", TElXMLEncryptor_methods);
	if (NULL == TElXMLEncProcessor_ce_ptr)
		Register_TElXMLEncProcessor(TSRMLS_C);
	TElXMLEncryptor_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLEncProcessor_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLDecryptor_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLDecryptor, Decrypt)
{
	zval *oOwnerDocument;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oOwnerDocument, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXMLDecryptor_Decrypt(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oOwnerDocument TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDecryptor, Load)
{
	zval *oDocument;
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLDecryptor_Load(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDocument, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLDecryptor_Load_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement) or (TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDecryptor, get_DecryptedNode)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLDecryptor_get_DecryptedNode(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMNode_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDecryptor, set_DecryptedNode)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElXMLDOMNode_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLDecryptor_set_DecryptedNode(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMNode)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDecryptor, get_DecryptedNodeList)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLDecryptor_get_DecryptedNodeList(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMNodeList_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDecryptor, set_DecryptedNodeList)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElXMLDOMNodeList_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLDecryptor_set_DecryptedNodeList(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMNodeList)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDecryptor, get_DecryptedData)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElXMLDecryptor_get_DecryptedData(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-1463497944, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDecryptor, set_DecryptedData)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElXMLDecryptor_set_DecryptedData(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDecryptor, get_EncryptedDataType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElXMLEncryptedDataTypeRaw fOutResultRaw = 0;
		SBCheckError(TElXMLDecryptor_get_EncryptedDataType(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDecryptor, get_EncryptionMethod)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElXMLEncryptionMethodRaw fOutResultRaw = 0;
		SBCheckError(TElXMLDecryptor_get_EncryptionMethod(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDecryptor, get_EncryptKey)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElXMLDecryptor_get_EncryptKey(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDecryptor, get_KeyName)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLDecryptor_get_KeyName(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-848624021, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDecryptor, get_KeyEncryptionType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElXMLKeyEncryptionTypeRaw fOutResultRaw = 0;
		SBCheckError(TElXMLDecryptor_get_KeyEncryptionType(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDecryptor, get_KeyTransportMethod)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElXMLKeyTransportMethodRaw fOutResultRaw = 0;
		SBCheckError(TElXMLDecryptor_get_KeyTransportMethod(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDecryptor, get_KeyWrapMethod)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElXMLKeyWrapMethodRaw fOutResultRaw = 0;
		SBCheckError(TElXMLDecryptor_get_KeyWrapMethod(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDecryptor, get_MimeType)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLDecryptor_get_MimeType(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(595828289, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDecryptor, get_KeyData)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLDecryptor_get_KeyData(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLKeyInfoData_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDecryptor, set_KeyData)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElXMLKeyInfoData_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLDecryptor_set_KeyData(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLKeyInfoData)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDecryptor, __construct)
{
	zval *oAOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLDecryptor_Create(SBGetObjectHandle(oAOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDecryptor_Decrypt, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, OwnerDocument, TElXMLDOMDocument, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDecryptor_Load, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Element_or_Document, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDecryptor_get_DecryptedNode, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDecryptor_set_DecryptedNode, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElXMLDOMNode, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDecryptor_get_DecryptedNodeList, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDecryptor_set_DecryptedNodeList, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElXMLDOMNodeList, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDecryptor_get_DecryptedData, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDecryptor_set_DecryptedData, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDecryptor_get_EncryptedDataType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDecryptor_get_EncryptionMethod, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDecryptor_get_EncryptKey, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDecryptor_get_KeyName, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDecryptor_get_KeyEncryptionType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDecryptor_get_KeyTransportMethod, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDecryptor_get_KeyWrapMethod, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDecryptor_get_MimeType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDecryptor_get_KeyData, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDecryptor_set_KeyData, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElXMLKeyInfoData, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDecryptor___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AOwner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLDecryptor_methods[] = {
	PHP_ME(TElXMLDecryptor, Decrypt, arginfo_TElXMLDecryptor_Decrypt, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDecryptor, Load, arginfo_TElXMLDecryptor_Load, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDecryptor, get_DecryptedNode, arginfo_TElXMLDecryptor_get_DecryptedNode, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDecryptor, set_DecryptedNode, arginfo_TElXMLDecryptor_set_DecryptedNode, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDecryptor, get_DecryptedNodeList, arginfo_TElXMLDecryptor_get_DecryptedNodeList, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDecryptor, set_DecryptedNodeList, arginfo_TElXMLDecryptor_set_DecryptedNodeList, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDecryptor, get_DecryptedData, arginfo_TElXMLDecryptor_get_DecryptedData, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDecryptor, set_DecryptedData, arginfo_TElXMLDecryptor_set_DecryptedData, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDecryptor, get_EncryptedDataType, arginfo_TElXMLDecryptor_get_EncryptedDataType, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDecryptor, get_EncryptionMethod, arginfo_TElXMLDecryptor_get_EncryptionMethod, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDecryptor, get_EncryptKey, arginfo_TElXMLDecryptor_get_EncryptKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDecryptor, get_KeyName, arginfo_TElXMLDecryptor_get_KeyName, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDecryptor, get_KeyEncryptionType, arginfo_TElXMLDecryptor_get_KeyEncryptionType, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDecryptor, get_KeyTransportMethod, arginfo_TElXMLDecryptor_get_KeyTransportMethod, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDecryptor, get_KeyWrapMethod, arginfo_TElXMLDecryptor_get_KeyWrapMethod, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDecryptor, get_MimeType, arginfo_TElXMLDecryptor_get_MimeType, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDecryptor, get_KeyData, arginfo_TElXMLDecryptor_get_KeyData, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDecryptor, set_KeyData, arginfo_TElXMLDecryptor_set_KeyData, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDecryptor, __construct, arginfo_TElXMLDecryptor___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLDecryptor(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLDecryptor_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLDecryptor", TElXMLDecryptor_methods);
	if (NULL == TElXMLEncProcessor_ce_ptr)
		Register_TElXMLEncProcessor(TSRMLS_C);
	TElXMLDecryptor_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLEncProcessor_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLCipherReference_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLCipherReference, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElXMLCipherReference_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCipherReference, IsEmpty)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElXMLCipherReference_IsEmpty(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCipherReference, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLCipherReference_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCipherReference, SaveToXML)
{
	zval *oDocument;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oDocument, TElXMLDOMDocument_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLCipherReference_SaveToXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDocument, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLCipherReference_SaveToXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument, TElXMLCustomFormatter) or (TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCipherReference, get_CipherValue)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElXMLCipherReference_get_CipherValue(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(1299575299, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCipherReference, set_CipherValue)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElXMLCipherReference_set_CipherValue(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCipherReference, get_TransformChain)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLCipherReference_get_TransformChain(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLTransformChain_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCipherReference, set_TransformChain)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElXMLTransformChain_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLCipherReference_set_TransformChain(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLTransformChain)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCipherReference, get_URI)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLCipherReference_get_URI(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1832365826, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCipherReference, set_URI)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElXMLCipherReference_set_URI(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCipherReference, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLCipherReference_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCipherReference_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCipherReference_IsEmpty, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCipherReference_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCipherReference_SaveToXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCipherReference_get_CipherValue, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCipherReference_set_CipherValue, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCipherReference_get_TransformChain, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCipherReference_set_TransformChain, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElXMLTransformChain, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCipherReference_get_URI, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCipherReference_set_URI, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCipherReference___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLCipherReference_methods[] = {
	PHP_ME(TElXMLCipherReference, Clear, arginfo_TElXMLCipherReference_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCipherReference, IsEmpty, arginfo_TElXMLCipherReference_IsEmpty, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCipherReference, LoadFromXML, arginfo_TElXMLCipherReference_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCipherReference, SaveToXML, arginfo_TElXMLCipherReference_SaveToXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCipherReference, get_CipherValue, arginfo_TElXMLCipherReference_get_CipherValue, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCipherReference, set_CipherValue, arginfo_TElXMLCipherReference_set_CipherValue, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCipherReference, get_TransformChain, arginfo_TElXMLCipherReference_get_TransformChain, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCipherReference, set_TransformChain, arginfo_TElXMLCipherReference_set_TransformChain, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCipherReference, get_URI, arginfo_TElXMLCipherReference_get_URI, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCipherReference, set_URI, arginfo_TElXMLCipherReference_set_URI, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCipherReference, __construct, arginfo_TElXMLCipherReference___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLCipherReference(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLCipherReference_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLCipherReference", TElXMLCipherReference_methods);
	if (NULL == TElXMLCustomElement_ce_ptr)
		Register_TElXMLCustomElement(TSRMLS_C);
	TElXMLCipherReference_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLCustomElement_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLCipherData_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLCipherData, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElXMLCipherData_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCipherData, IsEmpty)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElXMLCipherData_IsEmpty(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCipherData, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLCipherData_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCipherData, SaveToXML)
{
	zval *oDocument;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oDocument, TElXMLDOMDocument_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLCipherData_SaveToXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDocument, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLCipherData_SaveToXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument, TElXMLCustomFormatter) or (TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCipherData, get_CipherValue)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElXMLCipherData_get_CipherValue(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(438862234, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCipherData, set_CipherValue)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElXMLCipherData_set_CipherValue(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCipherData, get_CipherReference)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLCipherData_get_CipherReference(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLCipherReference_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCipherData, set_CipherReference)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElXMLCipherReference_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLCipherData_set_CipherReference(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLCipherReference)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCipherData, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLCipherData_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCipherData_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCipherData_IsEmpty, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCipherData_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCipherData_SaveToXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCipherData_get_CipherValue, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCipherData_set_CipherValue, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCipherData_get_CipherReference, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCipherData_set_CipherReference, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElXMLCipherReference, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCipherData___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLCipherData_methods[] = {
	PHP_ME(TElXMLCipherData, Clear, arginfo_TElXMLCipherData_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCipherData, IsEmpty, arginfo_TElXMLCipherData_IsEmpty, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCipherData, LoadFromXML, arginfo_TElXMLCipherData_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCipherData, SaveToXML, arginfo_TElXMLCipherData_SaveToXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCipherData, get_CipherValue, arginfo_TElXMLCipherData_get_CipherValue, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCipherData, set_CipherValue, arginfo_TElXMLCipherData_set_CipherValue, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCipherData, get_CipherReference, arginfo_TElXMLCipherData_get_CipherReference, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCipherData, set_CipherReference, arginfo_TElXMLCipherData_set_CipherReference, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCipherData, __construct, arginfo_TElXMLCipherData___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLCipherData(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLCipherData_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLCipherData", TElXMLCipherData_methods);
	if (NULL == TElXMLCustomElement_ce_ptr)
		Register_TElXMLCustomElement(TSRMLS_C);
	TElXMLCipherData_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLCustomElement_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLEncryptionMethodType_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLEncryptionMethodType, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElXMLEncryptionMethodType_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLEncryptionMethodType, IsEmpty)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElXMLEncryptionMethodType_IsEmpty(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLEncryptionMethodType, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLEncryptionMethodType_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLEncryptionMethodType, SaveToXML)
{
	zval *oDocument;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oDocument, TElXMLDOMDocument_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLEncryptionMethodType_SaveToXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDocument, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLEncryptionMethodType_SaveToXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument, TElXMLCustomFormatter) or (TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLEncryptionMethodType, get_Algorithm)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLEncryptionMethodType_get_Algorithm(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(390029065, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLEncryptionMethodType, set_Algorithm)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElXMLEncryptionMethodType_set_Algorithm(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLEncryptionMethodType, get_KeySize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXMLEncryptionMethodType_get_KeySize(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLEncryptionMethodType, set_KeySize)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElXMLEncryptionMethodType_set_KeySize(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLEncryptionMethodType, get_OAEPparams)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElXMLEncryptionMethodType_get_OAEPparams(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(1875561523, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLEncryptionMethodType, set_OAEPparams)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElXMLEncryptionMethodType_set_OAEPparams(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLEncryptionMethodType, get_DigestMethod)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLEncryptionMethodType_get_DigestMethod(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(711407890, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLEncryptionMethodType, set_DigestMethod)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElXMLEncryptionMethodType_set_DigestMethod(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLEncryptionMethodType, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLEncryptionMethodType_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLEncryptionMethodType_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLEncryptionMethodType_IsEmpty, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLEncryptionMethodType_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLEncryptionMethodType_SaveToXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLEncryptionMethodType_get_Algorithm, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLEncryptionMethodType_set_Algorithm, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLEncryptionMethodType_get_KeySize, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLEncryptionMethodType_set_KeySize, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLEncryptionMethodType_get_OAEPparams, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLEncryptionMethodType_set_OAEPparams, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLEncryptionMethodType_get_DigestMethod, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLEncryptionMethodType_set_DigestMethod, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLEncryptionMethodType___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLEncryptionMethodType_methods[] = {
	PHP_ME(TElXMLEncryptionMethodType, Clear, arginfo_TElXMLEncryptionMethodType_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLEncryptionMethodType, IsEmpty, arginfo_TElXMLEncryptionMethodType_IsEmpty, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLEncryptionMethodType, LoadFromXML, arginfo_TElXMLEncryptionMethodType_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLEncryptionMethodType, SaveToXML, arginfo_TElXMLEncryptionMethodType_SaveToXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLEncryptionMethodType, get_Algorithm, arginfo_TElXMLEncryptionMethodType_get_Algorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLEncryptionMethodType, set_Algorithm, arginfo_TElXMLEncryptionMethodType_set_Algorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLEncryptionMethodType, get_KeySize, arginfo_TElXMLEncryptionMethodType_get_KeySize, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLEncryptionMethodType, set_KeySize, arginfo_TElXMLEncryptionMethodType_set_KeySize, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLEncryptionMethodType, get_OAEPparams, arginfo_TElXMLEncryptionMethodType_get_OAEPparams, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLEncryptionMethodType, set_OAEPparams, arginfo_TElXMLEncryptionMethodType_set_OAEPparams, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLEncryptionMethodType, get_DigestMethod, arginfo_TElXMLEncryptionMethodType_get_DigestMethod, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLEncryptionMethodType, set_DigestMethod, arginfo_TElXMLEncryptionMethodType_set_DigestMethod, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLEncryptionMethodType, __construct, arginfo_TElXMLEncryptionMethodType___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLEncryptionMethodType(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLEncryptionMethodType_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLEncryptionMethodType", TElXMLEncryptionMethodType_methods);
	if (NULL == TElXMLCustomElement_ce_ptr)
		Register_TElXMLCustomElement(TSRMLS_C);
	TElXMLEncryptionMethodType_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLCustomElement_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLEncryptionProperties_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLEncryptionProperties, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLEncryptionProperties_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLEncryptionProperties___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLEncryptionProperties_methods[] = {
	PHP_ME(TElXMLEncryptionProperties, __construct, arginfo_TElXMLEncryptionProperties___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLEncryptionProperties(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLEncryptionProperties_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLEncryptionProperties", TElXMLEncryptionProperties_methods);
	if (NULL == TElXMLProperties_ce_ptr)
		Register_TElXMLProperties(TSRMLS_C);
	TElXMLEncryptionProperties_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLProperties_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLEncryptedData_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLEncryptedData, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElXMLEncryptedData_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLEncryptedData, IsEmpty)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElXMLEncryptedData_IsEmpty(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLEncryptedData, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLEncryptedData_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLEncryptedData, SaveToXML)
{
	zval *oDocument;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oDocument, TElXMLDOMDocument_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLEncryptedData_SaveToXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDocument, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLEncryptedData_SaveToXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument, TElXMLCustomFormatter) or (TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLEncryptedData, get_EncryptionPrefix)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLEncryptedData_get_EncryptionPrefix(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1281309286, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLEncryptedData, set_EncryptionPrefix)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElXMLEncryptedData_set_EncryptionPrefix(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLEncryptedData, get_SignaturePrefix)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLEncryptedData_get_SignaturePrefix(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-738130000, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLEncryptedData, set_SignaturePrefix)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElXMLEncryptedData_set_SignaturePrefix(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLEncryptedData, get_EncryptedKey)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLEncryptedData_get_EncryptedKey(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLEncryptedKey_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLEncryptedData, set_EncryptedKey)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElXMLEncryptedKey_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLEncryptedData_set_EncryptedKey(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLEncryptedKey)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLEncryptedData, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLEncryptedData_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLEncryptedData_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLEncryptedData_IsEmpty, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLEncryptedData_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLEncryptedData_SaveToXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLEncryptedData_get_EncryptionPrefix, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLEncryptedData_set_EncryptionPrefix, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLEncryptedData_get_SignaturePrefix, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLEncryptedData_set_SignaturePrefix, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLEncryptedData_get_EncryptedKey, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLEncryptedData_set_EncryptedKey, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElXMLEncryptedKey, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLEncryptedData___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLEncryptedData_methods[] = {
	PHP_ME(TElXMLEncryptedData, Clear, arginfo_TElXMLEncryptedData_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLEncryptedData, IsEmpty, arginfo_TElXMLEncryptedData_IsEmpty, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLEncryptedData, LoadFromXML, arginfo_TElXMLEncryptedData_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLEncryptedData, SaveToXML, arginfo_TElXMLEncryptedData_SaveToXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLEncryptedData, get_EncryptionPrefix, arginfo_TElXMLEncryptedData_get_EncryptionPrefix, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLEncryptedData, set_EncryptionPrefix, arginfo_TElXMLEncryptedData_set_EncryptionPrefix, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLEncryptedData, get_SignaturePrefix, arginfo_TElXMLEncryptedData_get_SignaturePrefix, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLEncryptedData, set_SignaturePrefix, arginfo_TElXMLEncryptedData_set_SignaturePrefix, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLEncryptedData, get_EncryptedKey, arginfo_TElXMLEncryptedData_get_EncryptedKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLEncryptedData, set_EncryptedKey, arginfo_TElXMLEncryptedData_set_EncryptedKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLEncryptedData, __construct, arginfo_TElXMLEncryptedData___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLEncryptedData(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLEncryptedData_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLEncryptedData", TElXMLEncryptedData_methods);
	if (NULL == TElXMLEncryptedType_ce_ptr)
		Register_TElXMLEncryptedType(TSRMLS_C);
	TElXMLEncryptedData_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLEncryptedType_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLEncryptedKey_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLEncryptedKey, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElXMLEncryptedKey_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLEncryptedKey, IsEmpty)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElXMLEncryptedKey_IsEmpty(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLEncryptedKey, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLEncryptedKey_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLEncryptedKey, SaveToXML)
{
	zval *oDocument;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oDocument, TElXMLDOMDocument_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLEncryptedKey_SaveToXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDocument, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLEncryptedKey_SaveToXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument, TElXMLCustomFormatter) or (TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLEncryptedKey, get_CarriedKeyName)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLEncryptedKey_get_CarriedKeyName(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-282694000, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLEncryptedKey, set_CarriedKeyName)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElXMLEncryptedKey_set_CarriedKeyName(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLEncryptedKey, get_Recipient)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLEncryptedKey_get_Recipient(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1814385260, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLEncryptedKey, set_Recipient)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElXMLEncryptedKey_set_Recipient(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLEncryptedKey, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLEncryptedKey_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLEncryptedKey_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLEncryptedKey_IsEmpty, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLEncryptedKey_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLEncryptedKey_SaveToXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLEncryptedKey_get_CarriedKeyName, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLEncryptedKey_set_CarriedKeyName, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLEncryptedKey_get_Recipient, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLEncryptedKey_set_Recipient, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLEncryptedKey___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLEncryptedKey_methods[] = {
	PHP_ME(TElXMLEncryptedKey, Clear, arginfo_TElXMLEncryptedKey_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLEncryptedKey, IsEmpty, arginfo_TElXMLEncryptedKey_IsEmpty, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLEncryptedKey, LoadFromXML, arginfo_TElXMLEncryptedKey_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLEncryptedKey, SaveToXML, arginfo_TElXMLEncryptedKey_SaveToXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLEncryptedKey, get_CarriedKeyName, arginfo_TElXMLEncryptedKey_get_CarriedKeyName, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLEncryptedKey, set_CarriedKeyName, arginfo_TElXMLEncryptedKey_set_CarriedKeyName, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLEncryptedKey, get_Recipient, arginfo_TElXMLEncryptedKey_get_Recipient, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLEncryptedKey, set_Recipient, arginfo_TElXMLEncryptedKey_set_Recipient, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLEncryptedKey, __construct, arginfo_TElXMLEncryptedKey___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLEncryptedKey(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLEncryptedKey_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLEncryptedKey", TElXMLEncryptedKey_methods);
	if (NULL == TElXMLEncryptedType_ce_ptr)
		Register_TElXMLEncryptedType(TSRMLS_C);
	TElXMLEncryptedKey_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLEncryptedType_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLDecryptionExcept_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLDecryptionExcept, Clone)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLDecryptionExcept_Clone(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDecryptionExcept_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDecryptionExcept, get_ID)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLDecryptionExcept_get_ID(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(124009306, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDecryptionExcept, set_ID)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElXMLDecryptionExcept_set_ID(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDecryptionExcept, get_URI)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLDecryptionExcept_get_URI(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1927427546, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDecryptionExcept, set_URI)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElXMLDecryptionExcept_set_URI(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDecryptionExcept, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLDecryptionExcept_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDecryptionExcept_Clone, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDecryptionExcept_get_ID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDecryptionExcept_set_ID, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDecryptionExcept_get_URI, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDecryptionExcept_set_URI, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDecryptionExcept___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLDecryptionExcept_methods[] = {
	PHP_ME(TElXMLDecryptionExcept, Clone, arginfo_TElXMLDecryptionExcept_Clone, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDecryptionExcept, get_ID, arginfo_TElXMLDecryptionExcept_get_ID, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDecryptionExcept, set_ID, arginfo_TElXMLDecryptionExcept_set_ID, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDecryptionExcept, get_URI, arginfo_TElXMLDecryptionExcept_get_URI, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDecryptionExcept, set_URI, arginfo_TElXMLDecryptionExcept_set_URI, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDecryptionExcept, __construct, arginfo_TElXMLDecryptionExcept___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLDecryptionExcept(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLDecryptionExcept_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLDecryptionExcept", TElXMLDecryptionExcept_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElXMLDecryptionExcept_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLCustomDecryptionTransform_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLCustomDecryptionTransform, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLCustomDecryptionTransform_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCustomDecryptionTransform, SaveToXML)
{
	zval *oDocument;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oDocument, TElXMLDOMDocument_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLCustomDecryptionTransform_SaveToXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDocument, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLCustomDecryptionTransform_SaveToXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument, TElXMLCustomFormatter) or (TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCustomDecryptionTransform, Add)
{
	char *sExceptID;
	char *sExceptURI;
	int sExceptID_len;
	int sExceptURI_len;
	zval *oAExcept;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAExcept, TElXMLDecryptionExcept_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXMLCustomDecryptionTransform_Add(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oAExcept TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &sExceptID, &sExceptID_len, &sExceptURI, &sExceptURI_len) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXMLCustomDecryptionTransform_Add_1(SBGetObjectHandle(getThis() TSRMLS_CC), sExceptID, (int32_t)sExceptID_len, sExceptURI, (int32_t)sExceptURI_len, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDecryptionExcept) or (string, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCustomDecryptionTransform, Insert)
{
	long l4Index;
	zval *oAExcept;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lO!", &l4Index, &oAExcept, TElXMLDecryptionExcept_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLCustomDecryptionTransform_Insert(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, SBGetObjectHandle(oAExcept TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, TElXMLDecryptionExcept)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCustomDecryptionTransform, Delete)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		SBCheckError(TElXMLCustomDecryptionTransform_Delete(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCustomDecryptionTransform, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElXMLCustomDecryptionTransform_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCustomDecryptionTransform, ClassType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLCustomDecryptionTransform_ClassType(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TClass_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCustomDecryptionTransform, get_Count)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXMLCustomDecryptionTransform_get_Count(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCustomDecryptionTransform, get_Excepts)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLCustomDecryptionTransform_get_Excepts(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDecryptionExcept_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCustomDecryptionTransform, get_KeyData)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLCustomDecryptionTransform_get_KeyData(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLKeyInfoData_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCustomDecryptionTransform, set_KeyData)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElXMLKeyInfoData_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLCustomDecryptionTransform_set_KeyData(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLKeyInfoData)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCustomDecryptionTransform, get_OnKeyData)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBXMLDecryptKeyDataEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElXMLCustomDecryptionTransform_get_OnKeyData(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCustomDecryptionTransform, set_OnKeyData)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElXMLCustomDecryptionTransform_set_OnKeyData(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBXMLDecryptKeyDataEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBXMLDecryptKeyDataEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCustomDecryptionTransform, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLCustomDecryptionTransform_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCustomDecryptionTransform_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCustomDecryptionTransform_SaveToXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCustomDecryptionTransform_Add, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, AExcept_or_ExceptID, 0, 1)
	ZEND_ARG_INFO(0, ExceptURI)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCustomDecryptionTransform_Insert, 0, 0, 2)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_OBJ_INFO(0, AExcept, TElXMLDecryptionExcept, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCustomDecryptionTransform_Delete, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCustomDecryptionTransform_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCustomDecryptionTransform_ClassType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCustomDecryptionTransform_get_Count, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCustomDecryptionTransform_get_Excepts, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCustomDecryptionTransform_get_KeyData, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCustomDecryptionTransform_set_KeyData, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElXMLKeyInfoData, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCustomDecryptionTransform_get_OnKeyData, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCustomDecryptionTransform_set_OnKeyData, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCustomDecryptionTransform___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLCustomDecryptionTransform_methods[] = {
	PHP_ME(TElXMLCustomDecryptionTransform, LoadFromXML, arginfo_TElXMLCustomDecryptionTransform_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCustomDecryptionTransform, SaveToXML, arginfo_TElXMLCustomDecryptionTransform_SaveToXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCustomDecryptionTransform, Add, arginfo_TElXMLCustomDecryptionTransform_Add, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCustomDecryptionTransform, Insert, arginfo_TElXMLCustomDecryptionTransform_Insert, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCustomDecryptionTransform, Delete, arginfo_TElXMLCustomDecryptionTransform_Delete, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCustomDecryptionTransform, Clear, arginfo_TElXMLCustomDecryptionTransform_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCustomDecryptionTransform, ClassType, arginfo_TElXMLCustomDecryptionTransform_ClassType, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElXMLCustomDecryptionTransform, get_Count, arginfo_TElXMLCustomDecryptionTransform_get_Count, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCustomDecryptionTransform, get_Excepts, arginfo_TElXMLCustomDecryptionTransform_get_Excepts, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCustomDecryptionTransform, get_KeyData, arginfo_TElXMLCustomDecryptionTransform_get_KeyData, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCustomDecryptionTransform, set_KeyData, arginfo_TElXMLCustomDecryptionTransform_set_KeyData, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCustomDecryptionTransform, get_OnKeyData, arginfo_TElXMLCustomDecryptionTransform_get_OnKeyData, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCustomDecryptionTransform, set_OnKeyData, arginfo_TElXMLCustomDecryptionTransform_set_OnKeyData, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCustomDecryptionTransform, __construct, arginfo_TElXMLCustomDecryptionTransform___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLCustomDecryptionTransform(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLCustomDecryptionTransform_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLCustomDecryptionTransform", TElXMLCustomDecryptionTransform_methods);
	if (NULL == TElXMLTransform_ce_ptr)
		Register_TElXMLTransform(TSRMLS_C);
	TElXMLCustomDecryptionTransform_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLTransform_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLDecryptionTransform_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLDecryptionTransform, GetDefaultTransformAlgorithmURI_Inst)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLDecryptionTransform_GetDefaultTransformAlgorithmURI_1(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1005829047, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDecryptionTransform, GetDefaultTransformAlgorithmURI)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLDecryptionTransform_GetDefaultTransformAlgorithmURI(sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1005829047, 0, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDecryptionTransform, IsTransformAlgorithmSupported_Inst)
{
	char *sAlgorithm;
	int sAlgorithm_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sAlgorithm, &sAlgorithm_len) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElXMLDecryptionTransform_IsTransformAlgorithmSupported_1(SBGetObjectHandle(getThis() TSRMLS_CC), sAlgorithm, (int32_t)sAlgorithm_len, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDecryptionTransform, IsTransformAlgorithmSupported)
{
	char *sAlgorithm;
	int sAlgorithm_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sAlgorithm, &sAlgorithm_len) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElXMLDecryptionTransform_IsTransformAlgorithmSupported(sAlgorithm, (int32_t)sAlgorithm_len, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDecryptionTransform, TransformData)
{
	SBArrayZValInfo aiData;
	SBArrayZValInfo aiReference;
	zval *oNode;
	zval *oNodes;
	zval *oReference;
	zval *zaData;
	zval *zaReference;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaData) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaData)) || (IS_ARRAY == Z_TYPE_P(zaData)) || (IS_NULL == Z_TYPE_P(zaData))))
	{
		TSBTransformedDataTypeRaw fOutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaData, &aiData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElXMLDecryptionTransform_TransformData(SBGetObjectHandle(getThis() TSRMLS_CC), aiData.data, aiData.len, &fOutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiData);
		RETURN_LONG((long)fOutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oNode, TElXMLDOMNode_ce_ptr, &oReference, TElXMLDOMNode_ce_ptr) == SUCCESS)
	{
		TSBTransformedDataTypeRaw fOutResultRaw = 0;
		SBCheckError(TElXMLDecryptionTransform_TransformData_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oNode TSRMLS_CC), SBGetObjectHandle(oReference TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!z", &oNodes, TElXMLDOMNodeList_ce_ptr, &zaReference, TElXMLDOMNode_ce_ptr) == SUCCESS) && ((IS_ARRAY == Z_TYPE_P(zaReference)) || (IS_NULL == Z_TYPE_P(zaReference))))
	{
		TSBTransformedDataTypeRaw fOutResultRaw = 0;
		if (!SBGetObjectArrayFromZVal(zaReference, TElXMLDOMNode_ce_ptr, &aiReference TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElXMLDecryptionTransform_TransformData_2(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oNodes TSRMLS_CC), aiReference.data, aiReference.len, &fOutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiReference);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL) or (TElXMLDOMNode, TElXMLDOMNode) or (TElXMLDOMNodeList, &array of TElXMLDOMNode|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDecryptionTransform, ClassType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLDecryptionTransform_ClassType(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TClass_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDecryptionTransform, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLDecryptionTransform_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDecryptionTransform_GetDefaultTransformAlgorithmURI_Inst, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDecryptionTransform_GetDefaultTransformAlgorithmURI, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDecryptionTransform_IsTransformAlgorithmSupported_Inst, 0, 0, 1)
	ZEND_ARG_INFO(0, Algorithm)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDecryptionTransform_IsTransformAlgorithmSupported, 0, 0, 1)
	ZEND_ARG_INFO(0, Algorithm)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDecryptionTransform_TransformData, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Data_or_Node_or_Nodes, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Reference, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDecryptionTransform_ClassType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDecryptionTransform___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLDecryptionTransform_methods[] = {
	PHP_ME(TElXMLDecryptionTransform, GetDefaultTransformAlgorithmURI_Inst, arginfo_TElXMLDecryptionTransform_GetDefaultTransformAlgorithmURI_Inst, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDecryptionTransform, GetDefaultTransformAlgorithmURI, arginfo_TElXMLDecryptionTransform_GetDefaultTransformAlgorithmURI, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElXMLDecryptionTransform, IsTransformAlgorithmSupported_Inst, arginfo_TElXMLDecryptionTransform_IsTransformAlgorithmSupported_Inst, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDecryptionTransform, IsTransformAlgorithmSupported, arginfo_TElXMLDecryptionTransform_IsTransformAlgorithmSupported, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElXMLDecryptionTransform, TransformData, arginfo_TElXMLDecryptionTransform_TransformData, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDecryptionTransform, ClassType, arginfo_TElXMLDecryptionTransform_ClassType, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElXMLDecryptionTransform, __construct, arginfo_TElXMLDecryptionTransform___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLDecryptionTransform(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLDecryptionTransform_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLDecryptionTransform", TElXMLDecryptionTransform_methods);
	if (NULL == TElXMLCustomDecryptionTransform_ce_ptr)
		Register_TElXMLCustomDecryptionTransform(TSRMLS_C);
	TElXMLDecryptionTransform_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLCustomDecryptionTransform_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLBinaryDecryptionTransform_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLBinaryDecryptionTransform, GetDefaultTransformAlgorithmURI_Inst)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLBinaryDecryptionTransform_GetDefaultTransformAlgorithmURI_1(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-214616692, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLBinaryDecryptionTransform, GetDefaultTransformAlgorithmURI)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLBinaryDecryptionTransform_GetDefaultTransformAlgorithmURI(sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-214616692, 0, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLBinaryDecryptionTransform, IsTransformAlgorithmSupported_Inst)
{
	char *sAlgorithm;
	int sAlgorithm_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sAlgorithm, &sAlgorithm_len) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElXMLBinaryDecryptionTransform_IsTransformAlgorithmSupported_1(SBGetObjectHandle(getThis() TSRMLS_CC), sAlgorithm, (int32_t)sAlgorithm_len, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLBinaryDecryptionTransform, IsTransformAlgorithmSupported)
{
	char *sAlgorithm;
	int sAlgorithm_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sAlgorithm, &sAlgorithm_len) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElXMLBinaryDecryptionTransform_IsTransformAlgorithmSupported(sAlgorithm, (int32_t)sAlgorithm_len, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLBinaryDecryptionTransform, TransformData)
{
	SBArrayZValInfo aiData;
	SBArrayZValInfo aiReference;
	zval *oNode;
	zval *oNodes;
	zval *oReference;
	zval *zaData;
	zval *zaReference;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaData) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaData)) || (IS_ARRAY == Z_TYPE_P(zaData)) || (IS_NULL == Z_TYPE_P(zaData))))
	{
		TSBTransformedDataTypeRaw fOutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaData, &aiData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElXMLBinaryDecryptionTransform_TransformData(SBGetObjectHandle(getThis() TSRMLS_CC), aiData.data, aiData.len, &fOutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiData);
		RETURN_LONG((long)fOutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oNode, TElXMLDOMNode_ce_ptr, &oReference, TElXMLDOMNode_ce_ptr) == SUCCESS)
	{
		TSBTransformedDataTypeRaw fOutResultRaw = 0;
		SBCheckError(TElXMLBinaryDecryptionTransform_TransformData_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oNode TSRMLS_CC), SBGetObjectHandle(oReference TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!z", &oNodes, TElXMLDOMNodeList_ce_ptr, &zaReference, TElXMLDOMNode_ce_ptr) == SUCCESS) && ((IS_ARRAY == Z_TYPE_P(zaReference)) || (IS_NULL == Z_TYPE_P(zaReference))))
	{
		TSBTransformedDataTypeRaw fOutResultRaw = 0;
		if (!SBGetObjectArrayFromZVal(zaReference, TElXMLDOMNode_ce_ptr, &aiReference TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElXMLBinaryDecryptionTransform_TransformData_2(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oNodes TSRMLS_CC), aiReference.data, aiReference.len, &fOutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiReference);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL) or (TElXMLDOMNode, TElXMLDOMNode) or (TElXMLDOMNodeList, &array of TElXMLDOMNode|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLBinaryDecryptionTransform, ClassType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLBinaryDecryptionTransform_ClassType(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TClass_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLBinaryDecryptionTransform, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLBinaryDecryptionTransform_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLBinaryDecryptionTransform_GetDefaultTransformAlgorithmURI_Inst, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLBinaryDecryptionTransform_GetDefaultTransformAlgorithmURI, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLBinaryDecryptionTransform_IsTransformAlgorithmSupported_Inst, 0, 0, 1)
	ZEND_ARG_INFO(0, Algorithm)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLBinaryDecryptionTransform_IsTransformAlgorithmSupported, 0, 0, 1)
	ZEND_ARG_INFO(0, Algorithm)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLBinaryDecryptionTransform_TransformData, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Data_or_Node_or_Nodes, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Reference, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLBinaryDecryptionTransform_ClassType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLBinaryDecryptionTransform___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLBinaryDecryptionTransform_methods[] = {
	PHP_ME(TElXMLBinaryDecryptionTransform, GetDefaultTransformAlgorithmURI_Inst, arginfo_TElXMLBinaryDecryptionTransform_GetDefaultTransformAlgorithmURI_Inst, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLBinaryDecryptionTransform, GetDefaultTransformAlgorithmURI, arginfo_TElXMLBinaryDecryptionTransform_GetDefaultTransformAlgorithmURI, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElXMLBinaryDecryptionTransform, IsTransformAlgorithmSupported_Inst, arginfo_TElXMLBinaryDecryptionTransform_IsTransformAlgorithmSupported_Inst, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLBinaryDecryptionTransform, IsTransformAlgorithmSupported, arginfo_TElXMLBinaryDecryptionTransform_IsTransformAlgorithmSupported, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElXMLBinaryDecryptionTransform, TransformData, arginfo_TElXMLBinaryDecryptionTransform_TransformData, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLBinaryDecryptionTransform, ClassType, arginfo_TElXMLBinaryDecryptionTransform_ClassType, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElXMLBinaryDecryptionTransform, __construct, arginfo_TElXMLBinaryDecryptionTransform___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLBinaryDecryptionTransform(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLBinaryDecryptionTransform_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLBinaryDecryptionTransform", TElXMLBinaryDecryptionTransform_methods);
	if (NULL == TElXMLCustomDecryptionTransform_ce_ptr)
		Register_TElXMLCustomDecryptionTransform(TSRMLS_C);
	TElXMLBinaryDecryptionTransform_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLCustomDecryptionTransform_ce_ptr, NULL TSRMLS_CC);
}

void Register_SBXMLEnc_Constants(int module_number TSRMLS_DC)
{
	SB_REGISTER_LONG_CONSTANT(SBXMLEnc, SB_XML_ENC_ERROR_OK, SB_XML_ENC_ERROR_OK, SB_XML_ENC_ERROR_OK);
	SB_REGISTER_LONG_CONSTANT(SBXMLEnc, SB_XML_ENC_ERROR_NO_ENCRYPTEDDATA, SB_XML_ENC_ERROR_NO_ENCRYPTEDDATA, SB_XML_ENC_ERROR_NO_ENCRYPTEDDATA);
	SB_REGISTER_LONG_CONSTANT(SBXMLEnc, SB_XML_ENC_ERROR_BAD_DECRYPTED_DATA, SB_XML_ENC_ERROR_BAD_DECRYPTED_DATA, SB_XML_ENC_ERROR_BAD_DECRYPTED_DATA);
	SB_REGISTER_LONG_CONSTANT(SBXMLEnc, SB_XML_ENC_ERROR_UNSUPPORTED_HASH_ALGORITHM, SB_XML_ENC_ERROR_UNSUPPORTED_HASH_ALGORITHM, SB_XML_ENC_ERROR_UNSUPPORTED_HASH_ALGORITHM);
	SB_REGISTER_LONG_CONSTANT(SBXMLEnc, SB_XML_ENC_ERROR_BAD_KEYSIZE, SB_XML_ENC_ERROR_BAD_KEYSIZE, SB_XML_ENC_ERROR_BAD_KEYSIZE);
	SB_REGISTER_LONG_CONSTANT(SBXMLEnc, SB_XML_ENC_ERROR_BAD_KEY_LENGTH, SB_XML_ENC_ERROR_BAD_KEY_LENGTH, SB_XML_ENC_ERROR_BAD_KEY_LENGTH);
	SB_REGISTER_LONG_CONSTANT(SBXMLEnc, SB_XML_ENC_ERROR_NO_DOCUMENT, SB_XML_ENC_ERROR_NO_DOCUMENT, SB_XML_ENC_ERROR_NO_DOCUMENT);
	SB_REGISTER_LONG_CONSTANT(SBXMLEnc, SB_XML_ENC_ERROR_INVALID_KEY, SB_XML_ENC_ERROR_INVALID_KEY, SB_XML_ENC_ERROR_INVALID_KEY);
	SB_REGISTER_LONG_CONSTANT(SBXMLEnc, SB_XML_ENC_ERROR_NO_KEY_DATA, SB_XML_ENC_ERROR_NO_KEY_DATA, SB_XML_ENC_ERROR_NO_KEY_DATA);
	SB_REGISTER_LONG_CONSTANT(SBXMLEnc, SB_XML_ENC_ERROR_INVALID_KEY_DATA, SB_XML_ENC_ERROR_INVALID_KEY_DATA, SB_XML_ENC_ERROR_INVALID_KEY_DATA);
	SB_REGISTER_LONG_CONSTANT(SBXMLEnc, SB_XML_ENC_ERROR_INVALID_KEK, SB_XML_ENC_ERROR_INVALID_KEK, SB_XML_ENC_ERROR_INVALID_KEK);
	SB_REGISTER_LONG_CONSTANT(SBXMLEnc, SB_XML_ENC_ERROR_KEK_NO_KEY_DATA, SB_XML_ENC_ERROR_KEK_NO_KEY_DATA, SB_XML_ENC_ERROR_KEK_NO_KEY_DATA);
	SB_REGISTER_LONG_CONSTANT(SBXMLEnc, SB_XML_ENC_ERROR_KEK_INVALID_KEY_DATA, SB_XML_ENC_ERROR_KEK_INVALID_KEY_DATA, SB_XML_ENC_ERROR_KEK_INVALID_KEY_DATA);
	SB_REGISTER_LONG_CONSTANT(SBXMLEnc, SB_XML_ENC_ERROR_UNKNOWN, SB_XML_ENC_ERROR_UNKNOWN, SB_XML_ENC_ERROR_UNKNOWN);
}

void Register_SBXMLEnc_Aliases(TSRMLS_D)
{
	if (NULL == TElXMLEncryptedData_ce_ptr)
		Register_TElXMLEncryptedData(TSRMLS_C);
	zend_register_class_alias("ElXMLEncryptedData", TElXMLEncryptedData_ce_ptr);
	if (NULL == TElXMLEncProcessor_ce_ptr)
		Register_TElXMLEncProcessor(TSRMLS_C);
	zend_register_class_alias("ElXMLEncProcessor", TElXMLEncProcessor_ce_ptr);
	if (NULL == TElXMLEncryptor_ce_ptr)
		Register_TElXMLEncryptor(TSRMLS_C);
	zend_register_class_alias("ElXMLEncryptor", TElXMLEncryptor_ce_ptr);
	if (NULL == TElXMLDecryptor_ce_ptr)
		Register_TElXMLDecryptor(TSRMLS_C);
	zend_register_class_alias("ElXMLDecryptor", TElXMLDecryptor_ce_ptr);
	if (NULL == TElXMLCipherReference_ce_ptr)
		Register_TElXMLCipherReference(TSRMLS_C);
	zend_register_class_alias("ElXMLCipherReference", TElXMLCipherReference_ce_ptr);
	if (NULL == TElXMLCipherData_ce_ptr)
		Register_TElXMLCipherData(TSRMLS_C);
	zend_register_class_alias("ElXMLCipherData", TElXMLCipherData_ce_ptr);
	if (NULL == TElXMLEncryptionMethodType_ce_ptr)
		Register_TElXMLEncryptionMethodType(TSRMLS_C);
	zend_register_class_alias("ElXMLEncryptionMethodType", TElXMLEncryptionMethodType_ce_ptr);
	if (NULL == TElXMLEncryptionProperties_ce_ptr)
		Register_TElXMLEncryptionProperties(TSRMLS_C);
	zend_register_class_alias("ElXMLEncryptionProperties", TElXMLEncryptionProperties_ce_ptr);
	if (NULL == TElXMLEncryptedType_ce_ptr)
		Register_TElXMLEncryptedType(TSRMLS_C);
	zend_register_class_alias("ElXMLEncryptedType", TElXMLEncryptedType_ce_ptr);
	if (NULL == TElXMLEncryptedKey_ce_ptr)
		Register_TElXMLEncryptedKey(TSRMLS_C);
	zend_register_class_alias("ElXMLEncryptedKey", TElXMLEncryptedKey_ce_ptr);
	if (NULL == TElXMLDecryptionExcept_ce_ptr)
		Register_TElXMLDecryptionExcept(TSRMLS_C);
	zend_register_class_alias("ElXMLDecryptionExcept", TElXMLDecryptionExcept_ce_ptr);
	if (NULL == TElXMLCustomDecryptionTransform_ce_ptr)
		Register_TElXMLCustomDecryptionTransform(TSRMLS_C);
	zend_register_class_alias("ElXMLCustomDecryptionTransform", TElXMLCustomDecryptionTransform_ce_ptr);
	if (NULL == TElXMLDecryptionTransform_ce_ptr)
		Register_TElXMLDecryptionTransform(TSRMLS_C);
	zend_register_class_alias("ElXMLDecryptionTransform", TElXMLDecryptionTransform_ce_ptr);
	if (NULL == TElXMLBinaryDecryptionTransform_ce_ptr)
		Register_TElXMLBinaryDecryptionTransform(TSRMLS_C);
	zend_register_class_alias("ElXMLBinaryDecryptionTransform", TElXMLBinaryDecryptionTransform_ce_ptr);
}

